/* A Bison parser, made by GNU Bison 2.7.1.  */

/* Bison implementation for Yacc-like parsers in C
   
      Copyright (C) 1984, 1989-1990, 2000-2013 Free Software Foundation, Inc.
   
   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.
   
   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "2.7.1"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 1

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1


/* Substitute the variable and function names.  */
#define yyparse         base_yyparse
#define yylex           base_yylex
#define yyerror         base_yyerror
#define yylval          base_yylval
#define yychar          base_yychar
#define yydebug         base_yydebug
#define yynerrs         base_yynerrs
#define yylloc          base_yylloc

/* Copy the first part of user declarations.  */
/* Line 371 of yacc.c  */
#line 1 "gram.y"


/*#define YYDEBUG 1*/
/*-------------------------------------------------------------------------
 *
 * gram.y
 *	  POSTGRESQL BISON rules/actions
 *
 * Portions Copyright (c) 1996-2014, PostgreSQL Global Development Group
 * Portions Copyright (c) 1994, Regents of the University of California
 *
 *
 * IDENTIFICATION
 *	  src/backend/parser/gram.y
 *
 * HISTORY
 *	  AUTHOR			DATE			MAJOR EVENT
 *	  Andrew Yu			Sept, 1994		POSTQUEL to SQL conversion
 *	  Andrew Yu			Oct, 1994		lispy code conversion
 *
 * NOTES
 *	  CAPITALS are used to represent terminal symbols.
 *	  non-capitals are used to represent non-terminals.
 *
 *	  In general, nothing in this file should initiate database accesses
 *	  nor depend on changeable state (such as SET variables).  If you do
 *	  database accesses, your code will fail when we have aborted the
 *	  current transaction and are just parsing commands to find the next
 *	  ROLLBACK or COMMIT.  If you make use of SET variables, then you
 *	  will do the wrong thing in multi-query strings like this:
 *			SET SQL_inheritance TO off; SELECT * FROM foo;
 *	  because the entire string is parsed by gram.y before the SET gets
 *	  executed.  Anything that depends on the database or changeable state
 *	  should be handled during parse analysis so that it happens at the
 *	  right time not the wrong time.  The handling of SQL_inheritance is
 *	  a good example.
 *
 * WARNINGS
 *	  If you use a list, make sure the datum is a node so that the printing
 *	  routines work.
 *
 *	  Sometimes we assign constants to makeStrings. Make sure we don't free
 *	  those.
 *
 *-------------------------------------------------------------------------
 */
#include "postgres.h"

#include <ctype.h>
#include <limits.h>

#include "catalog/index.h"
#include "catalog/namespace.h"
#include "catalog/pg_trigger.h"
#include "commands/defrem.h"
#include "commands/trigger.h"
#include "nodes/makefuncs.h"
#include "nodes/nodeFuncs.h"
#include "parser/gramparse.h"
#include "parser/parser.h"
#include "storage/lmgr.h"
#include "utils/date.h"
#include "utils/datetime.h"
#include "utils/numeric.h"
#include "utils/xml.h"


/*
 * Location tracking support --- simpler than bison's default, since we only
 * want to track the start position not the end position of each nonterminal.
 */
#define YYLLOC_DEFAULT(Current, Rhs, N) \
	do { \
		if ((N) > 0) \
			(Current) = (Rhs)[1]; \
		else \
			(Current) = (-1); \
	} while (0)

/*
 * The above macro assigns -1 (unknown) as the parse location of any
 * nonterminal that was reduced from an empty rule.  This is problematic
 * for nonterminals defined like
 *		OptFooList: / * EMPTY * / { ... } | OptFooList Foo { ... } ;
 * because we'll set -1 as the location during the first reduction and then
 * copy it during each subsequent reduction, leaving us with -1 for the
 * location even when the list is not empty.  To fix that, do this in the
 * action for the nonempty rule(s):
 *		if (@$ < 0) @$ = @2;
 * (Although we have many nonterminals that follow this pattern, we only
 * bother with fixing @$ like this when the nonterminal's parse location
 * is actually referenced in some rule.)
 */

/*
 * Bison doesn't allocate anything that needs to live across parser calls,
 * so we can easily have it use palloc instead of malloc.  This prevents
 * memory leaks if we error out during parsing.  Note this only works with
 * bison >= 2.0.  However, in bison 1.875 the default is to use alloca()
 * if possible, so there's not really much problem anyhow, at least if
 * you're building with gcc.
 */
#define YYMALLOC palloc
#define YYFREE   pfree

/* Private struct for the result of privilege_target production */
typedef struct PrivTarget
{
	GrantTargetType targtype;
	GrantObjectType objtype;
	List	   *objs;
} PrivTarget;

/* ConstraintAttributeSpec yields an integer bitmask of these flags: */
#define CAS_NOT_DEFERRABLE			0x01
#define CAS_DEFERRABLE				0x02
#define CAS_INITIALLY_IMMEDIATE		0x04
#define CAS_INITIALLY_DEFERRED		0x08
#define CAS_NOT_VALID				0x10
#define CAS_NO_INHERIT				0x20


#define parser_yyerror(msg)  scanner_yyerror(msg, yyscanner)
#define parser_errposition(pos)  scanner_errposition(pos, yyscanner)

static void base_yyerror(YYLTYPE *yylloc, core_yyscan_t yyscanner,
						 const char *msg);
static Node *makeColumnRef(char *colname, List *indirection,
						   int location, core_yyscan_t yyscanner);
static Node *makeTypeCast(Node *arg, TypeName *typename, int location);
static Node *makeStringConst(char *str, int location);
static Node *makeStringConstCast(char *str, int location, TypeName *typename);
static Node *makeIntConst(int val, int location);
static Node *makeFloatConst(char *str, int location);
static Node *makeBitStringConst(char *str, int location);
static Node *makeNullAConst(int location);
static Node *makeAConst(Value *v, int location);
static Node *makeBoolAConst(bool state, int location);
static void check_qualified_name(List *names, core_yyscan_t yyscanner);
static List *check_func_name(List *names, core_yyscan_t yyscanner);
static List *check_indirection(List *indirection, core_yyscan_t yyscanner);
static List *extractArgTypes(List *parameters);
static List *extractAggrArgTypes(List *aggrargs);
static List *makeOrderedSetArgs(List *directargs, List *orderedargs,
								core_yyscan_t yyscanner);
static void insertSelectOptions(SelectStmt *stmt,
								List *sortClause, List *lockingClause,
								Node *limitOffset, Node *limitCount,
								WithClause *withClause,
								core_yyscan_t yyscanner);
static Node *makeSetOp(SetOperation op, bool all, Node *larg, Node *rarg);
static Node *doNegate(Node *n, int location);
static void doNegateFloat(Value *v);
static Node *makeAArrayExpr(List *elements, int location);
static Node *makeXmlExpr(XmlExprOp op, char *name, List *named_args,
						 List *args, int location);
static List *mergeTableFuncParameters(List *func_args, List *columns);
static TypeName *TableFuncTypeName(List *columns);
static RangeVar *makeRangeVarFromAnyName(List *names, int position, core_yyscan_t yyscanner);
static void SplitColQualList(List *qualList,
							 List **constraintList, CollateClause **collClause,
							 core_yyscan_t yyscanner);
static void processCASbits(int cas_bits, int location, const char *constrType,
			   bool *deferrable, bool *initdeferred, bool *not_valid,
			   bool *no_inherit, core_yyscan_t yyscanner);
static Node *makeRecursiveViewSelect(char *relname, List *aliases, Node *query);


/* Line 371 of yacc.c  */
#line 245 "gram.c"

# ifndef YY_NULL
#  if defined __cplusplus && 201103L <= __cplusplus
#   define YY_NULL nullptr
#  else
#   define YY_NULL 0
#  endif
# endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* In a future release of Bison, this section will be replaced
   by #include "gram.h".  */
#ifndef YY_BASE_YY_GRAM_H_INCLUDED
# define YY_BASE_YY_GRAM_H_INCLUDED
/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int base_yydebug;
#endif

/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     IDENT = 258,
     FCONST = 259,
     SCONST = 260,
     BCONST = 261,
     XCONST = 262,
     Op = 263,
     ICONST = 264,
     PARAM = 265,
     TYPECAST = 266,
     DOT_DOT = 267,
     COLON_EQUALS = 268,
     ABORT_P = 269,
     ABSOLUTE_P = 270,
     ACCESS = 271,
     ACTION = 272,
     ADD_P = 273,
     ADMIN = 274,
     AFTER = 275,
     AGGREGATE = 276,
     ALL = 277,
     ALSO = 278,
     ALTER = 279,
     ALWAYS = 280,
     ANALYSE = 281,
     ANALYZE = 282,
     AND = 283,
     ANY = 284,
     APPLICATION = 285,
     ARRAY = 286,
     AS = 287,
     ASC = 288,
     ASSERTION = 289,
     ASSIGNMENT = 290,
     ASYMMETRIC = 291,
     AT = 292,
     ATTRIBUTE = 293,
     AUTHORIZATION = 294,
     BACKWARD = 295,
     BEFORE = 296,
     BEGIN_P = 297,
     BETWEEN = 298,
     BIGINT = 299,
     BINARY = 300,
     BIT = 301,
     BOOLEAN_P = 302,
     BOTH = 303,
     BY = 304,
     CACHE = 305,
     CALLED = 306,
     CASCADE = 307,
     CASCADED = 308,
     CASE = 309,
     CAST = 310,
     CATALOG_P = 311,
     CHAIN = 312,
     CHAR_P = 313,
     CHARACTER = 314,
     CHARACTERISTICS = 315,
     CHECK = 316,
     CHECKPOINT = 317,
     CLASS = 318,
     CLOSE = 319,
     CLUSTER = 320,
     COALESCE = 321,
     COLLATE = 322,
     COLLATION = 323,
     COLUMN = 324,
     COMMENT = 325,
     COMMENTS = 326,
     COMMIT = 327,
     COMMITTED = 328,
     CONCURRENTLY = 329,
     CONFIGURATION = 330,
     CONNECTION = 331,
     CONSTRAINT = 332,
     CONSTRAINTS = 333,
     CONTENT_P = 334,
     CONTINUE_P = 335,
     CONVERSION_P = 336,
     COPY = 337,
     COST = 338,
     CREATE = 339,
     CROSS = 340,
     CSV = 341,
     CURRENT_P = 342,
     CURRENT_CATALOG = 343,
     CURRENT_DATE = 344,
     CURRENT_ROLE = 345,
     CURRENT_SCHEMA = 346,
     CURRENT_TIME = 347,
     CURRENT_TIMESTAMP = 348,
     CURRENT_USER = 349,
     CURSOR = 350,
     CYCLE = 351,
     DATA_P = 352,
     DATABASE = 353,
     DAY_P = 354,
     DEALLOCATE = 355,
     DEC = 356,
     DECIMAL_P = 357,
     DECLARE = 358,
     DEFAULT = 359,
     DEFAULTS = 360,
     DEFERRABLE = 361,
     DEFERRED = 362,
     DEFINER = 363,
     DELETE_P = 364,
     DELIMITER = 365,
     DELIMITERS = 366,
     DESC = 367,
     DICTIONARY = 368,
     DISABLE_P = 369,
     DISCARD = 370,
     DISTINCT = 371,
     DO = 372,
     DOCUMENT_P = 373,
     DOMAIN_P = 374,
     DOUBLE_P = 375,
     DROP = 376,
     EACH = 377,
     ELSE = 378,
     ENABLE_P = 379,
     ENCODING = 380,
     ENCRYPTED = 381,
     END_P = 382,
     ENUM_P = 383,
     ESCAPE = 384,
     EVENT = 385,
     EXCEPT = 386,
     EXCLUDE = 387,
     EXCLUDING = 388,
     EXCLUSIVE = 389,
     EXECUTE = 390,
     EXISTS = 391,
     EXPLAIN = 392,
     EXTENSION = 393,
     EXTERNAL = 394,
     EXTRACT = 395,
     FALSE_P = 396,
     FAMILY = 397,
     FETCH = 398,
     FILTER = 399,
     FIRST_P = 400,
     FLOAT_P = 401,
     FOLLOWING = 402,
     FOR = 403,
     FORCE = 404,
     FOREIGN = 405,
     FORWARD = 406,
     FREEZE = 407,
     FROM = 408,
     FULL = 409,
     FUNCTION = 410,
     FUNCTIONS = 411,
     GLOBAL = 412,
     GRANT = 413,
     GRANTED = 414,
     GREATEST = 415,
     GROUP_P = 416,
     HANDLER = 417,
     HAVING = 418,
     HEADER_P = 419,
     HOLD = 420,
     HOUR_P = 421,
     IDENTITY_P = 422,
     IF_P = 423,
     ILIKE = 424,
     IMMEDIATE = 425,
     IMMUTABLE = 426,
     IMPLICIT_P = 427,
     IN_P = 428,
     INCLUDING = 429,
     INCREMENT = 430,
     INDEX = 431,
     INDEXES = 432,
     INHERIT = 433,
     INHERITS = 434,
     INITIALLY = 435,
     INLINE_P = 436,
     INNER_P = 437,
     INOUT = 438,
     INPUT_P = 439,
     INSENSITIVE = 440,
     INSERT = 441,
     INSTEAD = 442,
     INT_P = 443,
     INTEGER = 444,
     INTERSECT = 445,
     INTERVAL = 446,
     INTO = 447,
     INVOKER = 448,
     IS = 449,
     ISNULL = 450,
     ISOLATION = 451,
     JOIN = 452,
     KEY = 453,
     LABEL = 454,
     LANGUAGE = 455,
     LARGE_P = 456,
     LAST_P = 457,
     LATERAL_P = 458,
     LC_COLLATE_P = 459,
     LC_CTYPE_P = 460,
     LEADING = 461,
     LEAKPROOF = 462,
     LEAST = 463,
     LEFT = 464,
     LEVEL = 465,
     LIKE = 466,
     LIMIT = 467,
     LISTEN = 468,
     LOAD = 469,
     LOCAL = 470,
     LOCALTIME = 471,
     LOCALTIMESTAMP = 472,
     LOCATION = 473,
     LOCK_P = 474,
     MAPPING = 475,
     MATCH = 476,
     MATERIALIZED = 477,
     MAXVALUE = 478,
     MINUTE_P = 479,
     MINVALUE = 480,
     MODE = 481,
     MONTH_P = 482,
     MOVE = 483,
     NAME_P = 484,
     NAMES = 485,
     NATIONAL = 486,
     NATURAL = 487,
     NCHAR = 488,
     NEXT = 489,
     NO = 490,
     NONE = 491,
     NOT = 492,
     NOTHING = 493,
     NOTIFY = 494,
     NOTNULL = 495,
     NOWAIT = 496,
     NULL_P = 497,
     NULLIF = 498,
     NULLS_P = 499,
     NUMERIC = 500,
     OBJECT_P = 501,
     OF = 502,
     OFF = 503,
     OFFSET = 504,
     OIDS = 505,
     ON = 506,
     ONLY = 507,
     OPERATOR = 508,
     OPTION = 509,
     OPTIONS = 510,
     OR = 511,
     ORDER = 512,
     ORDINALITY = 513,
     OUT_P = 514,
     OUTER_P = 515,
     OVER = 516,
     OVERLAPS = 517,
     OVERLAY = 518,
     OWNED = 519,
     OWNER = 520,
     PARSER = 521,
     PARTIAL = 522,
     PARTITION = 523,
     PASSING = 524,
     PASSWORD = 525,
     PLACING = 526,
     PLANS = 527,
     POSITION = 528,
     PRECEDING = 529,
     PRECISION = 530,
     PRESERVE = 531,
     PREPARE = 532,
     PREPARED = 533,
     PRIMARY = 534,
     PRIOR = 535,
     PRIVILEGES = 536,
     PROCEDURAL = 537,
     PROCEDURE = 538,
     PROGRAM = 539,
     QUOTE = 540,
     RANGE = 541,
     READ = 542,
     REAL = 543,
     REASSIGN = 544,
     RECHECK = 545,
     RECURSIVE = 546,
     REF = 547,
     REFERENCES = 548,
     REFRESH = 549,
     REINDEX = 550,
     RELATIVE_P = 551,
     RELEASE = 552,
     RENAME = 553,
     REPEATABLE = 554,
     REPLACE = 555,
     REPLICA = 556,
     RESET = 557,
     RESTART = 558,
     RESTRICT = 559,
     RETURNING = 560,
     RETURNS = 561,
     REVOKE = 562,
     RIGHT = 563,
     ROLE = 564,
     ROLLBACK = 565,
     ROW = 566,
     ROWS = 567,
     RULE = 568,
     SAVEPOINT = 569,
     SCHEMA = 570,
     SCROLL = 571,
     SEARCH = 572,
     SECOND_P = 573,
     SECURITY = 574,
     SELECT = 575,
     SEQUENCE = 576,
     SEQUENCES = 577,
     SERIALIZABLE = 578,
     SERVER = 579,
     SESSION = 580,
     SESSION_USER = 581,
     SET = 582,
     SETOF = 583,
     SHARE = 584,
     SHOW = 585,
     SIMILAR = 586,
     SIMPLE = 587,
     SMALLINT = 588,
     SNAPSHOT = 589,
     SOME = 590,
     STABLE = 591,
     STANDALONE_P = 592,
     START = 593,
     STATEMENT = 594,
     STATISTICS = 595,
     STDIN = 596,
     STDOUT = 597,
     STORAGE = 598,
     STRICT_P = 599,
     STRIP_P = 600,
     SUBSTRING = 601,
     SYMMETRIC = 602,
     SYSID = 603,
     SYSTEM_P = 604,
     TABLE = 605,
     TABLES = 606,
     TABLESPACE = 607,
     TEMP = 608,
     TEMPLATE = 609,
     TEMPORARY = 610,
     TEXT_P = 611,
     THEN = 612,
     TIME = 613,
     TIMESTAMP = 614,
     TO = 615,
     TRAILING = 616,
     TRANSACTION = 617,
     TREAT = 618,
     TRIGGER = 619,
     TRIM = 620,
     TRUE_P = 621,
     TRUNCATE = 622,
     TRUSTED = 623,
     TYPE_P = 624,
     TYPES_P = 625,
     UNBOUNDED = 626,
     UNCOMMITTED = 627,
     UNENCRYPTED = 628,
     UNION = 629,
     UNIQUE = 630,
     UNKNOWN = 631,
     UNLISTEN = 632,
     UNLOGGED = 633,
     UNTIL = 634,
     UPDATE = 635,
     USER = 636,
     USING = 637,
     VACUUM = 638,
     VALID = 639,
     VALIDATE = 640,
     VALIDATOR = 641,
     VALUE_P = 642,
     VALUES = 643,
     VARCHAR = 644,
     VARIADIC = 645,
     VARYING = 646,
     VERBOSE = 647,
     VERSION_P = 648,
     VIEW = 649,
     VIEWS = 650,
     VOLATILE = 651,
     WHEN = 652,
     WHERE = 653,
     WHITESPACE_P = 654,
     WINDOW = 655,
     WITH = 656,
     WITHIN = 657,
     WITHOUT = 658,
     WORK = 659,
     WRAPPER = 660,
     WRITE = 661,
     XML_P = 662,
     XMLATTRIBUTES = 663,
     XMLCONCAT = 664,
     XMLELEMENT = 665,
     XMLEXISTS = 666,
     XMLFOREST = 667,
     XMLPARSE = 668,
     XMLPI = 669,
     XMLROOT = 670,
     XMLSERIALIZE = 671,
     YEAR_P = 672,
     YES_P = 673,
     ZONE = 674,
     NULLS_FIRST = 675,
     NULLS_LAST = 676,
     WITH_ORDINALITY = 677,
     WITH_TIME = 678,
     POSTFIXOP = 679,
     UMINUS = 680
   };
#endif


#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
typedef union YYSTYPE
{
/* Line 387 of yacc.c  */
#line 179 "gram.y"

	core_YYSTYPE		core_yystype;
	/* these fields must match core_YYSTYPE: */
	int					ival;
	char				*str;
	const char			*keyword;

	char				chr;
	bool				boolean;
	JoinType			jtype;
	DropBehavior		dbehavior;
	OnCommitAction		oncommit;
	List				*list;
	Node				*node;
	Value				*value;
	ObjectType			objtype;
	TypeName			*typnam;
	FunctionParameter   *fun_param;
	FunctionParameterMode fun_param_mode;
	FuncWithArgs		*funwithargs;
	DefElem				*defelt;
	SortBy				*sortby;
	WindowDef			*windef;
	JoinExpr			*jexpr;
	IndexElem			*ielem;
	Alias				*alias;
	RangeVar			*range;
	IntoClause			*into;
	WithClause			*with;
	A_Indices			*aind;
	ResTarget			*target;
	struct PrivTarget	*privtarget;
	AccessPriv			*accesspriv;
	InsertStmt			*istmt;
	VariableSetStmt		*vsetstmt;


/* Line 387 of yacc.c  */
#line 751 "gram.c"
} YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
#endif

#if ! defined YYLTYPE && ! defined YYLTYPE_IS_DECLARED
typedef struct YYLTYPE
{
  int first_line;
  int first_column;
  int last_line;
  int last_column;
} YYLTYPE;
# define yyltype YYLTYPE /* obsolescent; will be withdrawn */
# define YYLTYPE_IS_DECLARED 1
# define YYLTYPE_IS_TRIVIAL 1
#endif


#ifdef YYPARSE_PARAM
#if defined __STDC__ || defined __cplusplus
int base_yyparse (void *YYPARSE_PARAM);
#else
int base_yyparse ();
#endif
#else /* ! YYPARSE_PARAM */
#if defined __STDC__ || defined __cplusplus
int base_yyparse (core_yyscan_t yyscanner);
#else
int base_yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */

#endif /* !YY_BASE_YY_GRAM_H_INCLUDED  */

/* Copy the second part of user declarations.  */

/* Line 390 of yacc.c  */
#line 791 "gram.c"

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#elif (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
typedef signed char yytype_int8;
#else
typedef short int yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif

#ifndef __attribute__
/* This feature is available in gcc versions 2.5 and later.  */
# if (! defined __GNUC__ || __GNUC__ < 2 \
      || (__GNUC__ == 2 && __GNUC_MINOR__ < 5))
#  define __attribute__(Spec) /* empty */
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif


/* Identity function, used to suppress warnings about constant conditions.  */
#ifndef lint
# define YYID(N) (N)
#else
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static int
YYID (int yyi)
#else
static int
YYID (yyi)
    int yyi;
#endif
{
  return yyi;
}
#endif

#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (YYID (0))
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
	     && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
	 || (defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL \
	     && defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
  YYLTYPE yyls_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE) + sizeof (YYLTYPE)) \
      + 2 * YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)				\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack_alloc, Stack, yysize);			\
	Stack = &yyptr->Stack_alloc;					\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (YYID (0))

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, (Count) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYSIZE_T yyi;                         \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (YYID (0))
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  728
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   79442

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  443
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  576
/* YYNRULES -- Number of rules.  */
#define YYNRULES  2368
/* YYNRULES -- Number of states.  */
#define YYNSTATES  4578

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   680

#define YYTRANSLATE(YYX)						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const yytype_uint16 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,   432,     2,     2,
     437,   438,   430,   428,   441,   429,   439,   431,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,   442,   440,
     425,   424,   426,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,   435,     2,   436,   433,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,   171,   172,   173,   174,
     175,   176,   177,   178,   179,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,   203,   204,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   427,
     434
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const yytype_uint16 yyprhs[] =
{
       0,     0,     3,     5,     9,    11,    13,    15,    17,    19,
      21,    23,    25,    27,    29,    31,    33,    35,    37,    39,
      41,    43,    45,    47,    49,    51,    53,    55,    57,    59,
      61,    63,    65,    67,    69,    71,    73,    75,    77,    79,
      81,    83,    85,    87,    89,    91,    93,    95,    97,    99,
     101,   103,   105,   107,   109,   111,   113,   115,   117,   119,
     121,   123,   125,   127,   129,   131,   133,   135,   137,   139,
     141,   143,   145,   147,   149,   151,   153,   155,   157,   159,
     161,   163,   165,   167,   169,   171,   173,   175,   177,   179,
     181,   183,   185,   187,   189,   191,   193,   195,   197,   199,
     201,   203,   205,   207,   209,   211,   213,   215,   217,   219,
     221,   223,   225,   227,   229,   231,   233,   235,   237,   239,
     241,   243,   244,   250,   252,   253,   256,   257,   260,   261,
     264,   267,   271,   275,   277,   281,   285,   288,   290,   292,
     295,   298,   301,   305,   309,   315,   321,   322,   326,   332,
     338,   344,   349,   353,   359,   363,   369,   375,   382,   384,
     386,   390,   396,   403,   408,   418,   426,   428,   429,   432,
     433,   435,   437,   439,   441,   443,   445,   448,   452,   456,
     459,   465,   467,   471,   475,   479,   483,   485,   489,   493,
     496,   499,   502,   505,   509,   513,   517,   521,   523,   527,
     529,   533,   535,   537,   540,   543,   546,   548,   550,   552,
     554,   556,   558,   560,   564,   571,   573,   575,   577,   579,
     581,   582,   584,   586,   589,   591,   594,   598,   601,   603,
     605,   608,   610,   613,   615,   618,   622,   627,   631,   634,
     639,   641,   643,   645,   647,   649,   652,   655,   658,   661,
     664,   669,   676,   687,   701,   706,   713,   724,   738,   743,
     750,   755,   762,   768,   776,   788,   803,   805,   809,   812,
     816,   821,   828,   835,   842,   848,   854,   861,   868,   873,
     882,   887,   890,   895,   899,   906,   911,   915,   919,   923,
     927,   931,   936,   941,   945,   949,   953,   957,   961,   965,
     970,   975,   979,   982,   986,   989,   992,   996,  1000,  1003,
    1006,  1010,  1012,  1016,  1019,  1021,  1023,  1024,  1027,  1028,
    1031,  1032,  1034,  1036,  1038,  1042,  1046,  1049,  1050,  1052,
    1056,  1060,  1062,  1068,  1072,  1077,  1079,  1083,  1088,  1095,
    1100,  1109,  1112,  1115,  1127,  1135,  1137,  1139,  1141,  1142,
    1144,  1146,  1148,  1150,  1154,  1157,  1158,  1160,  1162,  1164,
    1168,  1172,  1174,  1176,  1180,  1184,  1188,  1192,  1197,  1201,
    1204,  1206,  1207,  1210,  1211,  1215,  1216,  1218,  1219,  1221,
    1225,  1228,  1230,  1232,  1234,  1238,  1239,  1241,  1245,  1247,
    1259,  1274,  1285,  1299,  1301,  1303,  1306,  1309,  1312,  1315,
    1317,  1318,  1320,  1321,  1325,  1326,  1328,  1332,  1334,  1338,
    1340,  1342,  1344,  1346,  1348,  1353,  1358,  1361,  1362,  1366,
    1368,  1370,  1373,  1376,  1378,  1382,  1387,  1393,  1396,  1402,
    1404,  1407,  1410,  1413,  1417,  1421,  1425,  1426,  1428,  1430,
    1432,  1434,  1436,  1438,  1442,  1444,  1450,  1458,  1462,  1471,
    1476,  1486,  1498,  1501,  1502,  1506,  1507,  1509,  1513,  1515,
    1518,  1521,  1524,  1525,  1527,  1531,  1535,  1542,  1547,  1548,
    1550,  1552,  1555,  1558,  1559,  1563,  1567,  1570,  1572,  1574,
    1577,  1580,  1585,  1586,  1589,  1592,  1595,  1596,  1600,  1605,
    1610,  1611,  1614,  1615,  1620,  1621,  1625,  1633,  1639,  1642,
    1646,  1647,  1656,  1661,  1663,  1664,  1671,  1677,  1682,  1689,
    1691,  1692,  1694,  1697,  1700,  1702,  1705,  1709,  1712,  1715,
    1718,  1721,  1725,  1729,  1731,  1735,  1737,  1738,  1740,  1743,
    1745,  1747,  1751,  1758,  1769,  1771,  1772,  1774,  1777,  1780,
    1781,  1784,  1787,  1789,  1790,  1796,  1804,  1806,  1807,  1815,
    1818,  1819,  1823,  1829,  1835,  1844,  1847,  1848,  1851,  1854,
    1857,  1863,  1866,  1867,  1870,  1878,  1889,  1896,  1903,  1910,
    1917,  1925,  1933,  1943,  1953,  1960,  1968,  1975,  1984,  1993,
    2002,  2011,  2018,  2025,  2033,  2041,  2050,  2057,  2064,  2072,
    2075,  2078,  2081,  2084,  2086,  2089,  2091,  2092,  2099,  2108,
    2116,  2123,  2128,  2129,  2131,  2135,  2140,  2142,  2146,  2148,
    2151,  2154,  2157,  2160,  2162,  2164,  2175,  2178,  2179,  2182,
    2185,  2187,  2188,  2193,  2200,  2206,  2211,  2216,  2227,  2241,
    2247,  2255,  2264,  2266,  2268,  2270,  2278,  2288,  2297,  2313,
    2334,  2336,  2338,  2341,  2343,  2347,  2349,  2351,  2353,  2357,
    2359,  2363,  2364,  2366,  2367,  2369,  2371,  2376,  2377,  2379,
    2383,  2384,  2386,  2388,  2390,  2392,  2395,  2396,  2397,  2400,
    2403,  2405,  2408,  2411,  2414,  2417,  2424,  2433,  2445,  2459,
    2461,  2465,  2471,  2473,  2477,  2483,  2485,  2488,  2491,  2493,
    2502,  2507,  2513,  2518,  2523,  2528,  2532,  2540,  2549,  2556,
    2563,  2570,  2577,  2584,  2589,  2595,  2599,  2601,  2605,  2609,
    2611,  2613,  2615,  2617,  2619,  2621,  2625,  2627,  2631,  2635,
    2637,  2638,  2640,  2644,  2652,  2662,  2672,  2676,  2677,  2691,
    2693,  2697,  2703,  2710,  2715,  2723,  2726,  2728,  2729,  2732,
    2733,  2736,  2741,  2742,  2744,  2745,  2752,  2761,  2770,  2772,
    2776,  2782,  2788,  2796,  2806,  2814,  2824,  2830,  2837,  2844,
    2849,  2855,  2863,  2865,  2867,  2869,  2872,  2874,  2877,  2880,
    2882,  2884,  2886,  2888,  2890,  2892,  2896,  2900,  2904,  2908,
    2910,  2914,  2916,  2919,  2922,  2926,  2932,  2935,  2938,  2939,
    2946,  2954,  2962,  2970,  2979,  2988,  2995,  3004,  3014,  3024,
    3032,  3043,  3051,  3053,  3055,  3057,  3059,  3061,  3063,  3065,
    3067,  3069,  3072,  3074,  3076,  3078,  3080,  3082,  3085,  3087,
    3091,  3094,  3098,  3102,  3106,  3110,  3112,  3114,  3123,  3133,
    3143,  3153,  3163,  3166,  3167,  3169,  3171,  3174,  3177,  3179,
    3181,  3183,  3185,  3187,  3189,  3191,  3193,  3196,  3198,  3200,
    3203,  3206,  3208,  3211,  3215,  3219,  3223,  3227,  3232,  3237,
    3241,  3245,  3249,  3254,  3259,  3263,  3268,  3273,  3275,  3277,
    3279,  3280,  3288,  3296,  3307,  3309,  3311,  3314,  3319,  3325,
    3327,  3331,  3334,  3337,  3340,  3343,  3345,  3348,  3351,  3356,
    3360,  3363,  3366,  3369,  3372,  3376,  3379,  3382,  3385,  3391,
    3397,  3403,  3405,  3409,  3411,  3414,  3418,  3419,  3421,  3425,
    3428,  3435,  3442,  3452,  3456,  3457,  3461,  3462,  3468,  3471,
    3472,  3476,  3480,  3484,  3492,  3500,  3511,  3513,  3515,  3517,
    3519,  3534,  3536,  3537,  3539,  3540,  3542,  3543,  3546,  3547,
    3549,  3553,  3559,  3565,  3573,  3576,  3577,  3579,  3582,  3583,
    3585,  3587,  3588,  3590,  3592,  3593,  3603,  3616,  3624,  3627,
    3628,  3632,  3635,  3637,  3641,  3645,  3648,  3650,  3654,  3658,
    3662,  3665,  3668,  3670,  3672,  3674,  3676,  3679,  3681,  3683,
    3685,  3687,  3692,  3698,  3700,  3704,  3708,  3710,  3714,  3718,
    3724,  3731,  3733,  3737,  3739,  3742,  3747,  3753,  3755,  3757,
    3759,  3761,  3765,  3769,  3772,  3775,  3777,  3780,  3783,  3786,
    3788,  3791,  3794,  3796,  3798,  3800,  3804,  3807,  3808,  3811,
    3813,  3817,  3823,  3825,  3828,  3830,  3831,  3837,  3845,  3851,
    3859,  3865,  3873,  3877,  3883,  3889,  3895,  3897,  3901,  3904,
    3906,  3909,  3911,  3914,  3926,  3937,  3948,  3951,  3954,  3955,
    3965,  3968,  3969,  3974,  3979,  3984,  3986,  3988,  3990,  3991,
    3997,  4003,  4011,  4018,  4025,  4032,  4039,  4048,  4057,  4064,
    4071,  4079,  4089,  4099,  4106,  4113,  4120,  4129,  4136,  4145,
    4152,  4161,  4169,  4179,  4186,  4195,  4203,  4213,  4222,  4233,
    4243,  4255,  4264,  4274,  4286,  4295,  4304,  4312,  4319,  4326,
    4333,  4342,  4351,  4360,  4369,  4376,  4386,  4388,  4389,  4392,
    4393,  4401,  4408,  4415,  4422,  4429,  4436,  4444,  4454,  4464,
    4471,  4480,  4489,  4498,  4507,  4516,  4523,  4532,  4539,  4548,
    4556,  4566,  4574,  4584,  4591,  4599,  4606,  4613,  4620,  4627,
    4634,  4642,  4650,  4658,  4668,  4678,  4685,  4692,  4699,  4708,
    4717,  4726,  4733,  4741,  4755,  4757,  4759,  4763,  4767,  4769,
    4771,  4773,  4775,  4777,  4779,  4781,  4782,  4784,  4786,  4788,
    4790,  4792,  4794,  4795,  4802,  4811,  4815,  4818,  4819,  4822,
    4825,  4828,  4831,  4835,  4839,  4842,  4845,  4848,  4851,  4855,
    4858,  4864,  4869,  4873,  4877,  4881,  4883,  4885,  4886,  4890,
    4893,  4896,  4898,  4901,  4903,  4907,  4910,  4912,  4913,  4923,
    4935,  4948,  4963,  4967,  4972,  4977,  4978,  4981,  4987,  4990,
    4991,  4995,  4999,  5003,  5007,  5011,  5015,  5019,  5023,  5027,
    5031,  5035,  5039,  5043,  5048,  5052,  5056,  5058,  5059,  5065,
    5072,  5077,  5080,  5081,  5086,  5090,  5096,  5101,  5106,  5113,
    5118,  5125,  5132,  5138,  5146,  5156,  5163,  5165,  5166,  5173,
    5185,  5197,  5209,  5223,  5233,  5245,  5256,  5261,  5264,  5270,
    5273,  5274,  5279,  5285,  5291,  5296,  5303,  5305,  5309,  5311,
    5313,  5315,  5317,  5320,  5325,  5327,  5329,  5331,  5332,  5334,
    5335,  5337,  5338,  5342,  5343,  5346,  5351,  5355,  5361,  5363,
    5365,  5367,  5369,  5371,  5373,  5375,  5377,  5379,  5381,  5385,
    5388,  5390,  5392,  5394,  5396,  5397,  5403,  5407,  5408,  5410,
    5412,  5414,  5416,  5420,  5430,  5434,  5435,  5438,  5442,  5445,
    5449,  5456,  5458,  5463,  5466,  5468,  5472,  5475,  5478,  5479,
    5487,  5490,  5491,  5497,  5501,  5502,  5505,  5508,  5511,  5514,
    5517,  5521,  5523,  5527,  5529,  5532,  5534,  5535,  5544,  5546,
    5550,  5552,  5554,  5558,  5564,  5567,  5569,  5573,  5581,  5583,
    5584,  5588,  5591,  5594,  5597,  5598,  5601,  5604,  5606,  5608,
    5612,  5616,  5618,  5621,  5626,  5631,  5634,  5638,  5644,  5650,
    5652,  5654,  5664,  5666,  5669,  5674,  5679,  5684,  5687,  5691,
    5693,  5697,  5704,  5706,  5707,  5710,  5711,  5715,  5719,  5724,
    5729,  5734,  5739,  5743,  5746,  5748,  5750,  5751,  5753,  5755,
    5756,  5758,  5764,  5766,  5767,  5769,  5770,  5774,  5776,  5780,
    5785,  5789,  5792,  5795,  5797,  5799,  5801,  5802,  5805,  5810,
    5816,  5819,  5823,  5825,  5827,  5829,  5831,  5835,  5836,  5838,
    5840,  5842,  5844,  5846,  5850,  5851,  5854,  5855,  5857,  5861,
    5863,  5864,  5866,  5869,  5873,  5876,  5881,  5884,  5888,  5891,
    5892,  5895,  5899,  5902,  5903,  5905,  5909,  5912,  5915,  5919,
    5922,  5926,  5928,  5933,  5937,  5942,  5948,  5953,  5959,  5964,
    5970,  5973,  5978,  5980,  5982,  5983,  5985,  5990,  5996,  6001,
    6002,  6005,  6008,  6011,  6013,  6015,  6016,  6021,  6024,  6026,
    6029,  6032,  6037,  6039,  6043,  6045,  6048,  6052,  6055,  6062,
    6065,  6067,  6071,  6076,  6077,  6079,  6080,  6083,  6084,  6087,
    6092,  6093,  6095,  6096,  6098,  6102,  6106,  6109,  6113,  6119,
    6126,  6129,  6133,  6137,  6142,  6143,  6145,  6147,  6149,  6151,
    6153,  6156,  6162,  6164,  6166,  6168,  6170,  6173,  6177,  6181,
    6182,  6184,  6186,  6188,  6190,  6192,  6195,  6198,  6201,  6204,
    6207,  6209,  6213,  6214,  6216,  6218,  6220,  6222,  6228,  6231,
    6233,  6235,  6237,  6239,  6245,  6248,  6251,  6254,  6256,  6260,
    6264,  6267,  6269,  6270,  6274,  6275,  6281,  6284,  6290,  6293,
    6295,  6298,  6302,  6303,  6305,  6307,  6309,  6311,  6313,  6315,
    6319,  6323,  6327,  6331,  6335,  6339,  6343,  6344,  6346,  6351,
    6353,  6357,  6361,  6367,  6370,  6373,  6377,  6381,  6385,  6389,
    6393,  6397,  6401,  6405,  6409,  6413,  6416,  6419,  6423,  6427,
    6430,  6434,  6440,  6445,  6452,  6456,  6462,  6467,  6474,  6479,
    6486,  6492,  6500,  6504,  6507,  6512,  6515,  6519,  6523,  6528,
    6532,  6537,  6541,  6546,  6552,  6559,  6566,  6574,  6581,  6589,
    6596,  6604,  6608,  6613,  6618,  6625,  6628,  6632,  6637,  6639,
    6643,  6646,  6649,  6653,  6657,  6661,  6665,  6669,  6673,  6677,
    6681,  6685,  6689,  6692,  6695,  6701,  6708,  6715,  6723,  6727,
    6732,  6734,  6736,  6739,  6744,  6746,  6748,  6750,  6753,  6756,
    6759,  6762,  6764,  6768,  6774,  6781,  6790,  6797,  6804,  6809,
    6814,  6816,  6818,  6820,  6826,  6828,  6830,  6835,  6837,  6842,
    6844,  6849,  6851,  6856,  6858,  6860,  6862,  6864,  6866,  6868,
    6875,  6880,  6885,  6890,  6895,  6902,  6908,  6914,  6920,  6925,
    6932,  6937,  6942,  6947,  6952,  6958,  6966,  6974,  6984,  6990,
    6995,  7002,  7008,  7016,  7024,  7032,  7035,  7039,  7043,  7047,
    7052,  7053,  7058,  7060,  7064,  7068,  7070,  7072,  7074,  7077,
    7080,  7081,  7084,  7089,  7094,  7101,  7107,  7108,  7114,  7115,
    7118,  7119,  7121,  7125,  7129,  7132,  7135,  7136,  7143,  7145,
    7146,  7150,  7151,  7154,  7157,  7158,  7160,  7165,  7168,  7171,
    7174,  7177,  7180,  7185,  7189,  7195,  7197,  7199,  7201,  7203,
    7205,  7207,  7209,  7211,  7213,  7215,  7217,  7219,  7221,  7223,
    7225,  7230,  7232,  7237,  7239,  7244,  7246,  7249,  7251,  7254,
    7256,  7260,  7262,  7266,  7268,  7272,  7274,  7278,  7282,  7286,
    7289,  7291,  7295,  7299,  7300,  7302,  7304,  7306,  7308,  7310,
    7312,  7314,  7316,  7321,  7325,  7328,  7332,  7333,  7337,  7341,
    7344,  7347,  7349,  7350,  7353,  7356,  7360,  7363,  7365,  7367,
    7371,  7377,  7379,  7382,  7387,  7390,  7391,  7393,  7394,  7396,
    7399,  7402,  7405,  7409,  7415,  7417,  7420,  7421,  7424,  7426,
    7427,  7429,  7431,  7433,  7437,  7441,  7443,  7444,  7446,  7450,
    7454,  7457,  7459,  7461,  7463,  7467,  7469,  7472,  7474,  7478,
    7480,  7482,  7484,  7486,  7488,  7490,  7492,  7495,  7497,  7499,
    7501,  7503,  7505,  7508,  7515,  7518,  7522,  7529,  7531,  7533,
    7535,  7537,  7539,  7541,  7543,  7547,  7549,  7552,  7555,  7557,
    7559,  7561,  7563,  7565,  7567,  7569,  7571,  7573,  7575,  7577,
    7579,  7581,  7583,  7585,  7587,  7589,  7591,  7593,  7595,  7597,
    7599,  7601,  7603,  7605,  7607,  7609,  7611,  7613,  7615,  7617,
    7619,  7621,  7623,  7625,  7627,  7629,  7631,  7633,  7635,  7637,
    7639,  7641,  7643,  7645,  7647,  7649,  7651,  7653,  7655,  7657,
    7659,  7661,  7663,  7665,  7667,  7669,  7671,  7673,  7675,  7677,
    7679,  7681,  7683,  7685,  7687,  7689,  7691,  7693,  7695,  7697,
    7699,  7701,  7703,  7705,  7707,  7709,  7711,  7713,  7715,  7717,
    7719,  7721,  7723,  7725,  7727,  7729,  7731,  7733,  7735,  7737,
    7739,  7741,  7743,  7745,  7747,  7749,  7751,  7753,  7755,  7757,
    7759,  7761,  7763,  7765,  7767,  7769,  7771,  7773,  7775,  7777,
    7779,  7781,  7783,  7785,  7787,  7789,  7791,  7793,  7795,  7797,
    7799,  7801,  7803,  7805,  7807,  7809,  7811,  7813,  7815,  7817,
    7819,  7821,  7823,  7825,  7827,  7829,  7831,  7833,  7835,  7837,
    7839,  7841,  7843,  7845,  7847,  7849,  7851,  7853,  7855,  7857,
    7859,  7861,  7863,  7865,  7867,  7869,  7871,  7873,  7875,  7877,
    7879,  7881,  7883,  7885,  7887,  7889,  7891,  7893,  7895,  7897,
    7899,  7901,  7903,  7905,  7907,  7909,  7911,  7913,  7915,  7917,
    7919,  7921,  7923,  7925,  7927,  7929,  7931,  7933,  7935,  7937,
    7939,  7941,  7943,  7945,  7947,  7949,  7951,  7953,  7955,  7957,
    7959,  7961,  7963,  7965,  7967,  7969,  7971,  7973,  7975,  7977,
    7979,  7981,  7983,  7985,  7987,  7989,  7991,  7993,  7995,  7997,
    7999,  8001,  8003,  8005,  8007,  8009,  8011,  8013,  8015,  8017,
    8019,  8021,  8023,  8025,  8027,  8029,  8031,  8033,  8035,  8037,
    8039,  8041,  8043,  8045,  8047,  8049,  8051,  8053,  8055,  8057,
    8059,  8061,  8063,  8065,  8067,  8069,  8071,  8073,  8075,  8077,
    8079,  8081,  8083,  8085,  8087,  8089,  8091,  8093,  8095,  8097,
    8099,  8101,  8103,  8105,  8107,  8109,  8111,  8113,  8115,  8117,
    8119,  8121,  8123,  8125,  8127,  8129,  8131,  8133,  8135,  8137,
    8139,  8141,  8143,  8145,  8147,  8149,  8151,  8153,  8155,  8157,
    8159,  8161,  8163,  8165,  8167,  8169,  8171,  8173,  8175,  8177,
    8179,  8181,  8183,  8185,  8187,  8189,  8191,  8193,  8195,  8197,
    8199,  8201,  8203,  8205,  8207,  8209,  8211,  8213,  8215,  8217,
    8219,  8221,  8223,  8225,  8227,  8229,  8231,  8233,  8235,  8237,
    8239,  8241,  8243,  8245,  8247,  8249,  8251,  8253,  8255,  8257,
    8259,  8261,  8263,  8265,  8267,  8269,  8271,  8273,  8275,  8277,
    8279,  8281,  8283,  8285,  8287,  8289,  8291,  8293,  8295,  8297,
    8299,  8301,  8303,  8305,  8307,  8309,  8311,  8313,  8315,  8317,
    8319,  8321,  8323,  8325,  8327,  8329,  8331,  8333,  8335,  8337,
    8339,  8341,  8343,  8345,  8347,  8349,  8351,  8353,  8355,  8357,
    8359,  8361,  8363,  8365,  8367,  8369,  8371,  8373,  8375,  8377,
    8379,  8381,  8383,  8385,  8387,  8389,  8391,  8393,  8395
};

/* YYRHS -- A `-1'-separated list of the rules' RHS.  */
static const yytype_int16 yyrhs[] =
{
     444,     0,    -1,   445,    -1,   445,   440,   446,    -1,   446,
      -1,   638,    -1,   788,    -1,   789,    -1,   702,    -1,   795,
      -1,   652,    -1,   590,    -1,   593,    -1,   599,    -1,   613,
      -1,   615,    -1,   740,    -1,   462,    -1,   762,    -1,   763,
      -1,   569,    -1,   793,    -1,   492,    -1,   758,    -1,   504,
      -1,   456,    -1,   454,    -1,   798,    -1,   797,    -1,   619,
      -1,   458,    -1,   457,    -1,   805,    -1,   490,    -1,   507,
      -1,   800,    -1,   676,    -1,   487,    -1,   508,    -1,   561,
      -1,   640,    -1,   751,    -1,   799,    -1,   794,    -1,   587,
      -1,   594,    -1,   608,    -1,   614,    -1,   718,    -1,   461,
      -1,   564,    -1,   654,    -1,   661,    -1,   662,    -1,   576,
      -1,   465,    -1,   568,    -1,   524,    -1,   584,    -1,   620,
      -1,   634,    -1,   447,    -1,   453,    -1,   616,    -1,   784,
      -1,   822,    -1,   841,    -1,   642,    -1,   828,    -1,   491,
      -1,   748,    -1,   641,    -1,   753,    -1,   598,    -1,   612,
      -1,   464,    -1,   665,    -1,   666,    -1,   667,    -1,   582,
      -1,   771,    -1,   669,    -1,   586,    -1,   633,    -1,   459,
      -1,   460,    -1,   618,    -1,   792,    -1,   820,    -1,   811,
      -1,   683,    -1,   687,    -1,   698,    -1,   707,    -1,   823,
      -1,   774,    -1,   567,    -1,   783,    -1,   830,    -1,   772,
      -1,   817,    -1,   668,    -1,   755,    -1,   744,    -1,   743,
      -1,   745,    -1,   759,    -1,   688,    -1,   699,    -1,   764,
      -1,   679,    -1,   845,    -1,   776,    -1,   674,    -1,   775,
      -1,   834,    -1,   802,    -1,   481,    -1,   469,    -1,   486,
      -1,   781,    -1,    -1,    84,   309,  1008,   448,   449,    -1,
     401,    -1,    -1,   449,   452,    -1,    -1,   450,   451,    -1,
      -1,   270,  1007,    -1,   270,   242,    -1,   126,   270,  1007,
      -1,   373,   270,  1007,    -1,   178,    -1,    76,   212,  1010,
      -1,   384,   379,  1007,    -1,   381,  1009,    -1,     3,    -1,
     451,    -1,   348,  1006,    -1,    19,  1009,    -1,   309,  1009,
      -1,   173,   309,  1009,    -1,   173,   161,  1009,    -1,    84,
     381,  1008,   448,   449,    -1,    24,   309,  1008,   448,   450,
      -1,    -1,   173,    98,   999,    -1,    24,   309,  1008,   455,
     484,    -1,    24,   309,    22,   455,   484,    -1,    24,   381,
    1008,   448,   450,    -1,    24,   381,  1008,   484,    -1,   121,
     309,  1009,    -1,   121,   309,   168,   136,  1009,    -1,   121,
     381,  1009,    -1,   121,   381,   168,   136,  1009,    -1,    84,
     161,  1008,   448,   449,    -1,    24,   161,  1008,   463,   381,
    1009,    -1,    18,    -1,   121,    -1,   121,   161,  1009,    -1,
     121,   161,   168,   136,  1009,    -1,    84,   315,   466,    39,
    1008,   467,    -1,    84,   315,  1011,   467,    -1,    84,   315,
     168,   237,   136,   466,    39,  1008,   467,    -1,    84,   315,
     168,   237,   136,  1011,   467,    -1,  1011,    -1,    -1,   467,
     468,    -1,    -1,   524,    -1,   707,    -1,   568,    -1,   620,
      -1,   687,    -1,   781,    -1,   327,   470,    -1,   327,   215,
     470,    -1,   327,   325,   470,    -1,   362,   779,    -1,   325,
      60,    32,   362,   779,    -1,   472,    -1,   473,   360,   474,
      -1,   473,   424,   474,    -1,   473,   360,   104,    -1,   473,
     424,   104,    -1,   471,    -1,   473,   153,    87,    -1,   358,
     419,   478,    -1,    56,  1007,    -1,   315,  1007,    -1,   230,
     479,    -1,   309,   480,    -1,   325,    39,   480,    -1,   325,
      39,   104,    -1,   407,   254,   941,    -1,   362,   334,  1007,
      -1,  1011,    -1,   473,   439,  1011,    -1,   475,    -1,   474,
     441,   475,    -1,   477,    -1,   574,    -1,   287,   372,    -1,
     287,    73,    -1,   299,   287,    -1,   323,    -1,   366,    -1,
     141,    -1,   251,    -1,   480,    -1,  1007,    -1,     3,    -1,
     925,  1007,   927,    -1,   925,   437,  1006,   438,  1007,   927,
      -1,   574,    -1,   104,    -1,   215,    -1,  1007,    -1,   104,
      -1,    -1,  1013,    -1,  1007,    -1,   302,   482,    -1,   483,
      -1,   358,   419,    -1,   362,   196,   210,    -1,   325,    39,
      -1,   473,    -1,    22,    -1,   327,   470,    -1,   481,    -1,
     327,   472,    -1,   481,    -1,   330,   473,    -1,   330,   358,
     419,    -1,   330,   362,   196,   210,    -1,   330,   325,    39,
      -1,   330,    22,    -1,   327,    78,   488,   489,    -1,    22,
      -1,   995,    -1,   107,    -1,   170,    -1,    62,    -1,   115,
      22,    -1,   115,   353,    -1,   115,   355,    -1,   115,   272,
      -1,   115,   322,    -1,    24,   350,   892,   493,    -1,    24,
     350,   168,   136,   892,   493,    -1,    24,   350,    22,   173,
     352,   998,   327,   352,   998,   833,    -1,    24,   350,    22,
     173,   352,   998,   264,    49,  1009,   327,   352,   998,   833,
      -1,    24,   176,   996,   493,    -1,    24,   176,   168,   136,
     996,   493,    -1,    24,   176,    22,   173,   352,   998,   327,
     352,   998,   833,    -1,    24,   176,    22,   173,   352,   998,
     264,    49,  1009,   327,   352,   998,   833,    -1,    24,   321,
     996,   493,    -1,    24,   321,   168,   136,   996,   493,    -1,
      24,   394,   996,   493,    -1,    24,   394,   168,   136,   996,
     493,    -1,    24,   222,   394,   996,   493,    -1,    24,   222,
     394,   168,   136,   996,   493,    -1,    24,   222,   394,    22,
     173,   352,   998,   327,   352,   998,   833,    -1,    24,   222,
     394,    22,   173,   352,   998,   264,    49,  1009,   327,   352,
     998,   833,    -1,   494,    -1,   493,   441,   494,    -1,    18,
     532,    -1,    18,    69,   532,    -1,    24,   760,  1011,   495,
      -1,    24,   760,  1011,   121,   237,   242,    -1,    24,   760,
    1011,   327,   237,   242,    -1,    24,   760,  1011,   327,   340,
    1010,    -1,    24,   760,  1011,   327,   500,    -1,    24,   760,
    1011,   302,   500,    -1,    24,   760,  1011,   327,   343,  1011,
      -1,   121,   760,   168,   136,  1011,   496,    -1,   121,   760,
    1011,   496,    -1,    24,   760,  1011,   761,   369,   905,   497,
     498,    -1,    24,   760,  1011,   602,    -1,    18,   541,    -1,
      24,    77,   998,   631,    -1,   385,    77,   998,    -1,   121,
      77,   168,   136,   998,   496,    -1,   121,    77,   998,   496,
      -1,   327,   401,   250,    -1,   327,   403,   250,    -1,    65,
     251,   998,    -1,   327,   403,    65,    -1,   124,   364,   998,
      -1,   124,    25,   364,   998,    -1,   124,   301,   364,   998,
      -1,   124,   364,    22,    -1,   124,   364,   381,    -1,   114,
     364,   998,    -1,   114,   364,    22,    -1,   114,   364,   381,
      -1,   124,   313,   998,    -1,   124,    25,   313,   998,    -1,
     124,   301,   313,   998,    -1,   114,   313,   998,    -1,   178,
     996,    -1,   235,   178,   996,    -1,   247,   672,    -1,   237,
     247,    -1,   265,   360,  1008,    -1,   327,   352,   998,    -1,
     327,   500,    -1,   302,   500,    -1,   301,   167,   499,    -1,
     602,    -1,   327,   104,   929,    -1,   121,   104,    -1,    52,
      -1,   304,    -1,    -1,    67,   672,    -1,    -1,   382,   929,
      -1,    -1,   238,    -1,   154,    -1,   104,    -1,   382,   176,
     998,    -1,   437,   502,   438,    -1,   401,   500,    -1,    -1,
     503,    -1,   502,   441,   503,    -1,  1014,   424,   646,    -1,
    1014,    -1,  1014,   439,  1014,   424,   646,    -1,  1014,   439,
    1014,    -1,    24,   369,   672,   505,    -1,   506,    -1,   505,
     441,   506,    -1,    18,    38,   904,   496,    -1,   121,    38,
     168,   136,  1011,   496,    -1,   121,    38,  1011,   496,    -1,
      24,    38,  1011,   761,   369,   905,   497,   496,    -1,    64,
     842,    -1,    64,    22,    -1,    82,   515,   996,   544,   516,
     509,   510,   511,   517,   448,   512,    -1,    82,   846,   360,
     510,   511,   448,   512,    -1,   153,    -1,   360,    -1,   284,
      -1,    -1,  1007,    -1,   341,    -1,   342,    -1,   513,    -1,
     437,   519,   438,    -1,   513,   514,    -1,    -1,    45,    -1,
     250,    -1,   152,    -1,   110,   796,  1007,    -1,   242,   796,
    1007,    -1,    86,    -1,   164,    -1,   285,   796,  1007,    -1,
     129,   796,  1007,    -1,   149,   285,   545,    -1,   149,   285,
     430,    -1,   149,   237,   242,   545,    -1,   149,   242,   545,
      -1,   125,  1007,    -1,    45,    -1,    -1,   401,   250,    -1,
      -1,   518,   111,  1007,    -1,    -1,   382,    -1,    -1,   520,
      -1,   519,   441,   520,    -1,  1014,   521,    -1,   477,    -1,
     574,    -1,   430,    -1,   437,   522,   438,    -1,    -1,   523,
      -1,   522,   441,   523,    -1,   477,    -1,    84,   525,   350,
     996,   437,   526,   438,   555,   556,   557,   558,    -1,    84,
     525,   350,   168,   237,   136,   996,   437,   526,   438,   555,
     556,   557,   558,    -1,    84,   525,   350,   996,   247,   672,
     527,   556,   557,   558,    -1,    84,   525,   350,   168,   237,
     136,   996,   247,   672,   527,   556,   557,   558,    -1,   355,
      -1,   353,    -1,   215,   355,    -1,   215,   353,    -1,   157,
     355,    -1,   157,   353,    -1,   378,    -1,    -1,   528,    -1,
      -1,   437,   529,   438,    -1,    -1,   530,    -1,   528,   441,
     530,    -1,   531,    -1,   529,   441,   531,    -1,   532,    -1,
     538,    -1,   541,    -1,   533,    -1,   541,    -1,  1011,   905,
     600,   534,    -1,  1011,   401,   255,   534,    -1,   534,   535,
      -1,    -1,    77,   998,   536,    -1,   536,    -1,   537,    -1,
      67,   672,    -1,   237,   242,    -1,   242,    -1,   375,   737,
     559,    -1,   279,   198,   737,   559,    -1,    61,   437,   929,
     438,   543,    -1,   104,   930,    -1,   293,   996,   544,   547,
     551,    -1,   106,    -1,   237,   106,    -1,   180,   107,    -1,
     180,   170,    -1,   211,   996,   539,    -1,   539,   174,   540,
      -1,   539,   133,   540,    -1,    -1,   105,    -1,    78,    -1,
     177,    -1,   343,    -1,    71,    -1,    22,    -1,    77,   998,
     542,    -1,   542,    -1,    61,   437,   929,   438,   631,    -1,
     375,   437,   545,   438,   737,   559,   631,    -1,   375,   560,
     631,    -1,   279,   198,   437,   545,   438,   737,   559,   631,
      -1,   279,   198,   560,   631,    -1,   132,   711,   437,   548,
     438,   737,   559,   550,   631,    -1,   150,   198,   437,   545,
     438,   293,   996,   544,   547,   551,   631,    -1,   235,   178,
      -1,    -1,   437,   545,   438,    -1,    -1,   546,    -1,   545,
     441,   546,    -1,  1011,    -1,   221,   154,    -1,   221,   267,
      -1,   221,   332,    -1,    -1,   549,    -1,   548,   441,   549,
      -1,   713,   401,   747,    -1,   713,   401,   253,   437,   747,
     438,    -1,   398,   437,   929,   438,    -1,    -1,   552,    -1,
     553,    -1,   552,   553,    -1,   553,   552,    -1,    -1,   251,
     380,   554,    -1,   251,   109,   554,    -1,   235,    17,    -1,
     304,    -1,    52,    -1,   327,   242,    -1,   327,   104,    -1,
     179,   437,   995,   438,    -1,    -1,   401,   500,    -1,   401,
     250,    -1,   403,   250,    -1,    -1,   251,    72,   121,    -1,
     251,    72,   109,   312,    -1,   251,    72,   276,   312,    -1,
      -1,   352,   998,    -1,    -1,   382,   176,   352,   998,    -1,
      -1,   382,   176,  1002,    -1,    84,   525,   350,   562,    32,
     845,   563,    -1,   996,   544,   556,   557,   558,    -1,   401,
      97,    -1,   401,   235,    97,    -1,    -1,    84,   566,   222,
     394,   565,    32,   845,   563,    -1,   996,   544,   501,   558,
      -1,   378,    -1,    -1,   294,   222,   394,   709,   996,   563,
      -1,    84,   525,   321,   996,   570,    -1,    24,   321,   996,
     571,    -1,    24,   321,   168,   136,   996,   571,    -1,   571,
      -1,    -1,   572,    -1,   571,   572,    -1,    50,   574,    -1,
      96,    -1,   235,    96,    -1,   175,   573,   574,    -1,   223,
     574,    -1,   225,   574,    -1,   235,   223,    -1,   235,   225,
      -1,   264,    49,   672,    -1,   338,   448,   574,    -1,   303,
      -1,   303,   448,   574,    -1,    49,    -1,    -1,     4,    -1,
     429,     4,    -1,  1010,    -1,   574,    -1,   575,   441,   574,
      -1,    84,   719,   577,   583,   200,   480,    -1,    84,   719,
     577,   583,   200,   480,   162,   578,   579,   581,    -1,   368,
      -1,    -1,   998,    -1,   998,   673,    -1,   181,   578,    -1,
      -1,   386,   578,    -1,   235,   386,    -1,   580,    -1,    -1,
     121,   583,   200,   480,   496,    -1,   121,   583,   200,   168,
     136,   480,   496,    -1,   282,    -1,    -1,    84,   352,   998,
     585,   218,  1007,   501,    -1,   265,   998,    -1,    -1,   121,
     352,   998,    -1,   121,   352,   168,   136,   998,    -1,    84,
     138,   998,   448,   588,    -1,    84,   138,   168,   237,   136,
     998,   448,   588,    -1,   588,   589,    -1,    -1,   315,   998,
      -1,   393,   480,    -1,   153,   480,    -1,    24,   138,   998,
     380,   591,    -1,   591,   592,    -1,    -1,   360,   480,    -1,
      24,   138,   998,   463,    21,  1004,   731,    -1,    24,   138,
     998,   463,    55,   437,   905,    32,   905,   438,    -1,    24,
     138,   998,   463,    68,   672,    -1,    24,   138,   998,   463,
      81,   672,    -1,    24,   138,   998,   463,   119,   672,    -1,
      24,   138,   998,   463,   155,   697,    -1,    24,   138,   998,
     463,   583,   200,   998,    -1,    24,   138,   998,   463,   253,
     747,   746,    -1,    24,   138,   998,   463,   253,    63,   672,
     382,  1000,    -1,    24,   138,   998,   463,   253,   142,   672,
     382,  1000,    -1,    24,   138,   998,   463,   315,   998,    -1,
      24,   138,   998,   463,   130,   364,   998,    -1,    24,   138,
     998,   463,   350,   672,    -1,    24,   138,   998,   463,   356,
     317,   266,   672,    -1,    24,   138,   998,   463,   356,   317,
     113,   672,    -1,    24,   138,   998,   463,   356,   317,   354,
     672,    -1,    24,   138,   998,   463,   356,   317,    75,   672,
      -1,    24,   138,   998,   463,   321,   672,    -1,    24,   138,
     998,   463,   394,   672,    -1,    24,   138,   998,   463,   222,
     394,   672,    -1,    24,   138,   998,   463,   150,   350,   672,
      -1,    24,   138,   998,   463,   150,    97,   405,   998,    -1,
      24,   138,   998,   463,   324,   998,    -1,    24,   138,   998,
     463,   369,   672,    -1,    84,   150,    97,   405,   998,   597,
     600,    -1,   162,   578,    -1,   235,   162,    -1,   386,   578,
      -1,   235,   386,    -1,   595,    -1,   596,   595,    -1,   596,
      -1,    -1,   121,   150,    97,   405,   998,   496,    -1,   121,
     150,    97,   405,   168,   136,   998,   496,    -1,    24,   150,
      97,   405,   998,   597,   602,    -1,    24,   150,    97,   405,
     998,   596,    -1,   255,   437,   601,   438,    -1,    -1,   605,
      -1,   601,   441,   605,    -1,   255,   437,   603,   438,    -1,
     604,    -1,   603,   441,   604,    -1,   605,    -1,   327,   605,
      -1,    18,   605,    -1,   121,   606,    -1,   606,   607,    -1,
    1014,    -1,  1007,    -1,    84,   324,   998,   609,   611,   150,
      97,   405,   998,   600,    -1,   369,  1007,    -1,    -1,   393,
    1007,    -1,   393,   242,    -1,   610,    -1,    -1,   121,   324,
     998,   496,    -1,   121,   324,   168,   136,   998,   496,    -1,
      24,   324,   998,   610,   602,    -1,    24,   324,   998,   610,
      -1,    24,   324,   998,   602,    -1,    84,   150,   350,   996,
     437,   526,   438,   324,   998,   600,    -1,    84,   150,   350,
     168,   237,   136,   996,   437,   526,   438,   324,   998,   600,
      -1,    24,   150,   350,   892,   493,    -1,    24,   150,   350,
     168,   136,   892,   493,    -1,    84,   381,   220,   148,   617,
     324,   998,   600,    -1,    94,    -1,   381,    -1,  1008,    -1,
     121,   381,   220,   148,   617,   324,   998,    -1,   121,   381,
     220,   168,   136,   148,   617,   324,   998,    -1,    24,   381,
     220,   148,   617,   324,   998,   602,    -1,    84,   364,   998,
     621,   622,   251,   996,   624,   627,   135,   283,  1004,   437,
     628,   438,    -1,    84,    77,   364,   998,    20,   622,   251,
     996,   630,   631,   148,   122,   311,   627,   135,   283,  1004,
     437,   628,   438,    -1,    41,    -1,    20,    -1,   187,   247,
      -1,   623,    -1,   622,   256,   623,    -1,   186,    -1,   109,
      -1,   380,    -1,   380,   247,   545,    -1,   367,    -1,   148,
     625,   626,    -1,    -1,   122,    -1,    -1,   311,    -1,   339,
      -1,   397,   437,   929,   438,    -1,    -1,   629,    -1,   628,
     441,   629,    -1,    -1,  1006,    -1,     4,    -1,  1007,    -1,
    1014,    -1,   153,   996,    -1,    -1,    -1,   631,   632,    -1,
     237,   106,    -1,   106,    -1,   180,   170,    -1,   180,   107,
      -1,   237,   384,    -1,   235,   178,    -1,   121,   364,   998,
     251,   672,   496,    -1,   121,   364,   168,   136,   998,   251,
     672,   496,    -1,    84,   130,   364,   998,   251,  1014,   135,
     283,  1004,   437,   438,    -1,    84,   130,   364,   998,   251,
    1014,   397,   635,   135,   283,  1004,   437,   438,    -1,   636,
      -1,   635,    28,   636,    -1,  1011,   173,   437,   637,   438,
      -1,     5,    -1,   637,   441,     5,    -1,    24,   130,   364,
     998,   639,    -1,   124,    -1,   124,   301,    -1,   124,    25,
      -1,   114,    -1,    84,    34,   998,    61,   437,   929,   438,
     631,    -1,   121,    34,   998,   496,    -1,    84,    21,  1004,
     731,   643,    -1,    84,    21,  1004,   647,    -1,    84,   253,
     747,   643,    -1,    84,   369,   672,   643,    -1,    84,   369,
     672,    -1,    84,   369,   672,    32,   437,   902,   438,    -1,
      84,   369,   672,    32,   128,   437,   650,   438,    -1,    84,
     369,   672,    32,   286,   643,    -1,    84,   356,   317,   266,
     672,   643,    -1,    84,   356,   317,   113,   672,   643,    -1,
      84,   356,   317,   354,   672,   643,    -1,    84,   356,   317,
      75,   672,   643,    -1,    84,    68,   672,   643,    -1,    84,
      68,   672,   153,   672,    -1,   437,   644,   438,    -1,   645,
      -1,   644,   441,   645,    -1,  1014,   424,   646,    -1,  1014,
      -1,   728,    -1,  1018,    -1,   961,    -1,   574,    -1,  1007,
      -1,   437,   648,   438,    -1,   649,    -1,   648,   441,   649,
      -1,     3,   424,   646,    -1,   651,    -1,    -1,  1007,    -1,
     651,   441,  1007,    -1,    24,   369,   672,    18,   387,   653,
    1007,    -1,    24,   369,   672,    18,   387,   653,  1007,    41,
    1007,    -1,    24,   369,   672,    18,   387,   653,  1007,    20,
    1007,    -1,   168,   237,   136,    -1,    -1,    84,   253,    63,
     672,   657,   148,   369,   905,   382,  1000,   658,    32,   655,
      -1,   656,    -1,   655,   441,   656,    -1,   253,  1006,   747,
     659,   660,    -1,   253,  1006,   747,   746,   659,   660,    -1,
     155,  1006,  1004,   720,    -1,   155,  1006,   437,   966,   438,
    1004,   720,    -1,   343,   905,    -1,   104,    -1,    -1,   142,
     672,    -1,    -1,   148,   317,    -1,   148,   257,    49,   672,
      -1,    -1,   290,    -1,    -1,    84,   253,   142,   672,   382,
    1000,    -1,    24,   253,   142,   672,   382,  1000,    18,   655,
      -1,    24,   253,   142,   672,   382,  1000,   121,   663,    -1,
     664,    -1,   663,   441,   664,    -1,   253,  1006,   437,   966,
     438,    -1,   155,  1006,   437,   966,   438,    -1,   121,   253,
      63,   672,   382,  1000,   496,    -1,   121,   253,    63,   168,
     136,   672,   382,  1000,   496,    -1,   121,   253,   142,   672,
     382,  1000,   496,    -1,   121,   253,   142,   168,   136,   672,
     382,  1000,   496,    -1,   121,   264,    49,  1009,   496,    -1,
     289,   264,    49,  1009,   360,   998,    -1,   121,   670,   168,
     136,   671,   496,    -1,   121,   670,   671,   496,    -1,   121,
     176,    74,   671,   496,    -1,   121,   176,    74,   168,   136,
     671,   496,    -1,   350,    -1,   321,    -1,   394,    -1,   222,
     394,    -1,   176,    -1,   150,   350,    -1,   130,   364,    -1,
     369,    -1,   119,    -1,    68,    -1,    81,    -1,   315,    -1,
     138,    -1,   356,   317,   266,    -1,   356,   317,   113,    -1,
     356,   317,   354,    -1,   356,   317,    75,    -1,   672,    -1,
     671,   441,   672,    -1,  1011,    -1,  1011,   673,    -1,   439,
    1001,    -1,   673,   439,  1001,    -1,   367,   856,   893,   675,
     496,    -1,    80,   167,    -1,   303,   167,    -1,    -1,    70,
     251,   677,   672,   194,   678,    -1,    70,   251,    21,  1004,
     731,   194,   678,    -1,    70,   251,   155,  1004,   720,   194,
     678,    -1,    70,   251,   253,   747,   746,   194,   678,    -1,
      70,   251,    77,   998,   251,   672,   194,   678,    -1,    70,
     251,   313,   998,   251,   672,   194,   678,    -1,    70,   251,
     313,   998,   194,   678,    -1,    70,   251,   364,   998,   251,
     672,   194,   678,    -1,    70,   251,   253,    63,   672,   382,
    1000,   194,   678,    -1,    70,   251,   253,   142,   672,   382,
    1000,   194,   678,    -1,    70,   251,   201,   246,   574,   194,
     678,    -1,    70,   251,    55,   437,   905,    32,   905,   438,
     194,   678,    -1,    70,   251,   583,   200,   672,   194,   678,
      -1,    69,    -1,    98,    -1,   315,    -1,   176,    -1,   321,
      -1,   350,    -1,   119,    -1,   369,    -1,   394,    -1,   222,
     394,    -1,    68,    -1,    81,    -1,   352,    -1,   138,    -1,
     309,    -1,   150,   350,    -1,   324,    -1,   150,    97,   405,
      -1,   130,   364,    -1,   356,   317,    75,    -1,   356,   317,
     113,    -1,   356,   317,   266,    -1,   356,   317,   354,    -1,
    1007,    -1,   242,    -1,   319,   199,   680,   251,   681,   672,
     194,   682,    -1,   319,   199,   680,   251,    21,  1004,   731,
     194,   682,    -1,   319,   199,   680,   251,   155,  1004,   720,
     194,   682,    -1,   319,   199,   680,   251,   201,   246,   574,
     194,   682,    -1,   319,   199,   680,   251,   583,   200,   672,
     194,   682,    -1,   148,   480,    -1,    -1,    69,    -1,    98,
      -1,   130,   364,    -1,   150,   350,    -1,   315,    -1,   321,
      -1,   350,    -1,   119,    -1,   309,    -1,   352,    -1,   369,
      -1,   394,    -1,   222,   394,    -1,  1007,    -1,   242,    -1,
     143,   684,    -1,   228,   684,    -1,   842,    -1,   685,   842,
      -1,   234,   686,   842,    -1,   280,   686,   842,    -1,   145,
     686,   842,    -1,   202,   686,   842,    -1,    15,  1010,   686,
     842,    -1,   296,  1010,   686,   842,    -1,  1010,   686,   842,
      -1,    22,   686,   842,    -1,   151,   686,   842,    -1,   151,
    1010,   686,   842,    -1,   151,    22,   686,   842,    -1,    40,
     686,   842,    -1,    40,  1010,   686,   842,    -1,    40,    22,
     686,   842,    -1,   153,    -1,   173,    -1,   685,    -1,    -1,
     158,   689,   251,   692,   360,   693,   695,    -1,   307,   689,
     251,   692,   153,   693,   496,    -1,   307,   158,   254,   148,
     689,   251,   692,   153,   693,   496,    -1,   690,    -1,    22,
      -1,    22,   281,    -1,    22,   437,   545,   438,    -1,    22,
     281,   437,   545,   438,    -1,   691,    -1,   690,   441,   691,
      -1,   320,   544,    -1,   293,   544,    -1,    84,   544,    -1,
    1011,   544,    -1,   995,    -1,   350,   995,    -1,   321,   995,
      -1,   150,    97,   405,   997,    -1,   150,   324,   997,    -1,
     155,   696,    -1,    98,   997,    -1,   119,   671,    -1,   200,
     997,    -1,   201,   246,   575,    -1,   315,   997,    -1,   352,
     997,    -1,   369,   671,    -1,    22,   351,   173,   315,   997,
      -1,    22,   322,   173,   315,   997,    -1,    22,   156,   173,
     315,   997,    -1,   694,    -1,   693,   441,   694,    -1,  1008,
      -1,   161,  1008,    -1,   401,   158,   254,    -1,    -1,   697,
      -1,   696,   441,   697,    -1,  1004,   720,    -1,   158,   690,
     360,  1009,   700,   701,    -1,   307,   690,   153,  1009,   701,
     496,    -1,   307,    19,   254,   148,   690,   153,  1009,   701,
     496,    -1,   401,    19,   254,    -1,    -1,   159,    49,  1008,
      -1,    -1,    24,   104,   281,   703,   705,    -1,   703,   704,
      -1,    -1,   173,   315,   997,    -1,   148,   309,  1009,    -1,
     148,   381,  1009,    -1,   158,   689,   251,   706,   360,   693,
     695,    -1,   307,   689,   251,   706,   153,   693,   496,    -1,
     307,   158,   254,   148,   689,   251,   706,   153,   693,   496,
      -1,   351,    -1,   156,    -1,   322,    -1,   370,    -1,    84,
     708,   176,   709,   710,   251,   996,   711,   437,   712,   438,
     501,   558,   900,    -1,   375,    -1,    -1,    74,    -1,    -1,
    1002,    -1,    -1,   382,  1000,    -1,    -1,   713,    -1,   712,
     441,   713,    -1,  1011,   714,   715,   716,   717,    -1,   934,
     714,   715,   716,   717,    -1,   437,   929,   438,   714,   715,
     716,   717,    -1,    67,   672,    -1,    -1,   672,    -1,   382,
     672,    -1,    -1,    33,    -1,   112,    -1,    -1,   420,    -1,
     421,    -1,    -1,    84,   719,   155,  1004,   722,   306,   727,
     733,   737,    -1,    84,   719,   155,  1004,   722,   306,   350,
     437,   739,   438,   733,   737,    -1,    84,   719,   155,  1004,
     722,   733,   737,    -1,   256,   300,    -1,    -1,   437,   721,
     438,    -1,   437,   438,    -1,   724,    -1,   721,   441,   724,
      -1,   437,   723,   438,    -1,   437,   438,    -1,   729,    -1,
     723,   441,   729,    -1,   725,   726,   728,    -1,   726,   725,
     728,    -1,   726,   728,    -1,   725,   728,    -1,   728,    -1,
     173,    -1,   259,    -1,   183,    -1,   173,   259,    -1,   390,
      -1,  1012,    -1,   728,    -1,   905,    -1,  1012,   673,   432,
     369,    -1,   328,  1012,   673,   432,   369,    -1,   724,    -1,
     724,   104,   929,    -1,   724,   424,   929,    -1,   724,    -1,
     437,   430,   438,    -1,   437,   732,   438,    -1,   437,   257,
      49,   732,   438,    -1,   437,   732,   257,    49,   732,   438,
      -1,   730,    -1,   732,   441,   730,    -1,   735,    -1,   733,
     735,    -1,    51,   251,   242,   184,    -1,   306,   242,   251,
     242,   184,    -1,   344,    -1,   171,    -1,   336,    -1,   396,
      -1,   139,   319,   108,    -1,   139,   319,   193,    -1,   319,
     108,    -1,   319,   193,    -1,   207,    -1,   237,   207,    -1,
      83,   574,    -1,   312,   574,    -1,   485,    -1,    32,   736,
      -1,   200,   480,    -1,   400,    -1,   734,    -1,  1007,    -1,
    1007,   441,  1007,    -1,   401,   643,    -1,    -1,   726,   728,
      -1,   738,    -1,   739,   441,   738,    -1,    24,   155,   697,
     741,   742,    -1,   734,    -1,   741,   734,    -1,   304,    -1,
      -1,   121,   155,  1004,   720,   496,    -1,   121,   155,   168,
     136,  1004,   720,   496,    -1,   121,    21,  1004,   731,   496,
      -1,   121,    21,   168,   136,  1004,   731,   496,    -1,   121,
     253,   747,   746,   496,    -1,   121,   253,   168,   136,   747,
     746,   496,    -1,   437,   905,   438,    -1,   437,   905,   441,
     905,   438,    -1,   437,   236,   441,   905,   438,    -1,   437,
     905,   441,   236,   438,    -1,   958,    -1,  1011,   439,   747,
      -1,   117,   749,    -1,   750,    -1,   749,   750,    -1,  1007,
      -1,   200,   480,    -1,    84,    55,   437,   905,    32,   905,
     438,   401,   155,   697,   752,    -1,    84,    55,   437,   905,
      32,   905,   438,   403,   155,   752,    -1,    84,    55,   437,
     905,    32,   905,   438,   401,   183,   752,    -1,    32,   172,
      -1,    32,    35,    -1,    -1,   121,    55,   754,   437,   905,
      32,   905,   438,   496,    -1,   168,   136,    -1,    -1,   295,
     756,   996,   757,    -1,   295,   349,   998,   757,    -1,   295,
      98,   998,   757,    -1,   176,    -1,   350,    -1,   149,    -1,
      -1,    24,   352,   998,   327,   500,    -1,    24,   352,   998,
     302,   500,    -1,    24,    21,  1004,   731,   298,   360,   998,
      -1,    24,    68,   672,   298,   360,   998,    -1,    24,    81,
     672,   298,   360,   998,    -1,    24,    98,   999,   298,   360,
     999,    -1,    24,   119,   672,   298,   360,   998,    -1,    24,
     119,   672,   298,    77,   998,   360,   998,    -1,    24,   150,
      97,   405,   998,   298,   360,   998,    -1,    24,   155,   697,
     298,   360,   998,    -1,    24,   161,  1008,   298,   360,  1008,
      -1,    24,   583,   200,   998,   298,   360,   998,    -1,    24,
     253,    63,   672,   382,  1000,   298,   360,   998,    -1,    24,
     253,   142,   672,   382,  1000,   298,   360,   998,    -1,    24,
     315,   998,   298,   360,   998,    -1,    24,   324,   998,   298,
     360,   998,    -1,    24,   350,   892,   298,   360,   998,    -1,
      24,   350,   168,   136,   892,   298,   360,   998,    -1,    24,
     321,   996,   298,   360,   998,    -1,    24,   321,   168,   136,
     996,   298,   360,   998,    -1,    24,   394,   996,   298,   360,
     998,    -1,    24,   394,   168,   136,   996,   298,   360,   998,
      -1,    24,   222,   394,   996,   298,   360,   998,    -1,    24,
     222,   394,   168,   136,   996,   298,   360,   998,    -1,    24,
     176,   996,   298,   360,   998,    -1,    24,   176,   168,   136,
     996,   298,   360,   998,    -1,    24,   150,   350,   892,   298,
     360,   998,    -1,    24,   150,   350,   168,   136,   892,   298,
     360,   998,    -1,    24,   350,   892,   298,   760,   998,   360,
     998,    -1,    24,   350,   168,   136,   892,   298,   760,   998,
     360,   998,    -1,    24,   222,   394,   996,   298,   760,   998,
     360,   998,    -1,    24,   222,   394,   168,   136,   996,   298,
     760,   998,   360,   998,    -1,    24,   350,   892,   298,    77,
     998,   360,   998,    -1,    24,   150,   350,   892,   298,   760,
     998,   360,   998,    -1,    24,   150,   350,   168,   136,   892,
     298,   760,   998,   360,   998,    -1,    24,   313,   998,   251,
     996,   298,   360,   998,    -1,    24,   364,   998,   251,   996,
     298,   360,   998,    -1,    24,   130,   364,   998,   298,   360,
     998,    -1,    24,   309,  1008,   298,   360,  1008,    -1,    24,
     381,  1008,   298,   360,  1008,    -1,    24,   352,   998,   298,
     360,   998,    -1,    24,   356,   317,   266,   672,   298,   360,
     998,    -1,    24,   356,   317,   113,   672,   298,   360,   998,
      -1,    24,   356,   317,   354,   672,   298,   360,   998,    -1,
      24,   356,   317,    75,   672,   298,   360,   998,    -1,    24,
     369,   672,   298,   360,   998,    -1,    24,   369,   672,   298,
      38,   998,   360,   998,   496,    -1,    69,    -1,    -1,   327,
      97,    -1,    -1,    24,    21,  1004,   731,   327,   315,   998,
      -1,    24,    68,   672,   327,   315,   998,    -1,    24,    81,
     672,   327,   315,   998,    -1,    24,   119,   672,   327,   315,
     998,    -1,    24,   138,   672,   327,   315,   998,    -1,    24,
     155,   697,   327,   315,   998,    -1,    24,   253,   747,   746,
     327,   315,   998,    -1,    24,   253,    63,   672,   382,  1000,
     327,   315,   998,    -1,    24,   253,   142,   672,   382,  1000,
     327,   315,   998,    -1,    24,   350,   892,   327,   315,   998,
      -1,    24,   350,   168,   136,   892,   327,   315,   998,    -1,
      24,   356,   317,   266,   672,   327,   315,   998,    -1,    24,
     356,   317,   113,   672,   327,   315,   998,    -1,    24,   356,
     317,   354,   672,   327,   315,   998,    -1,    24,   356,   317,
      75,   672,   327,   315,   998,    -1,    24,   321,   996,   327,
     315,   998,    -1,    24,   321,   168,   136,   996,   327,   315,
     998,    -1,    24,   394,   996,   327,   315,   998,    -1,    24,
     394,   168,   136,   996,   327,   315,   998,    -1,    24,   222,
     394,   996,   327,   315,   998,    -1,    24,   222,   394,   168,
     136,   996,   327,   315,   998,    -1,    24,   150,   350,   892,
     327,   315,   998,    -1,    24,   150,   350,   168,   136,   892,
     327,   315,   998,    -1,    24,   369,   672,   327,   315,   998,
      -1,    24,    21,  1004,   731,   265,   360,  1008,    -1,    24,
      68,   672,   265,   360,  1008,    -1,    24,    81,   672,   265,
     360,  1008,    -1,    24,    98,   999,   265,   360,  1008,    -1,
      24,   119,   672,   265,   360,  1008,    -1,    24,   155,   697,
     265,   360,  1008,    -1,    24,   583,   200,   998,   265,   360,
    1008,    -1,    24,   201,   246,   574,   265,   360,  1008,    -1,
      24,   253,   747,   746,   265,   360,  1008,    -1,    24,   253,
      63,   672,   382,  1000,   265,   360,  1008,    -1,    24,   253,
     142,   672,   382,  1000,   265,   360,  1008,    -1,    24,   315,
     998,   265,   360,  1008,    -1,    24,   369,   672,   265,   360,
    1008,    -1,    24,   352,   998,   265,   360,  1008,    -1,    24,
     356,   317,   113,   672,   265,   360,  1008,    -1,    24,   356,
     317,    75,   672,   265,   360,  1008,    -1,    24,   150,    97,
     405,   998,   265,   360,  1008,    -1,    24,   324,   998,   265,
     360,  1008,    -1,    24,   130,   364,   998,   265,   360,  1008,
      -1,    84,   719,   313,   998,    32,   251,   769,   360,   996,
     900,   117,   770,   765,    -1,   238,    -1,   767,    -1,   437,
     766,   438,    -1,   766,   440,   768,    -1,   768,    -1,   845,
      -1,   823,    -1,   834,    -1,   828,    -1,   772,    -1,   767,
      -1,    -1,   320,    -1,   380,    -1,   109,    -1,   186,    -1,
     187,    -1,    23,    -1,    -1,   121,   313,   998,   251,   672,
     496,    -1,   121,   313,   168,   136,   998,   251,   672,   496,
      -1,   239,  1011,   773,    -1,   441,  1007,    -1,    -1,   213,
    1011,    -1,   377,  1011,    -1,   377,   430,    -1,    14,   777,
      -1,    42,   777,   780,    -1,   338,   362,   780,    -1,    72,
     777,    -1,   127,   777,    -1,   310,   777,    -1,   314,  1011,
      -1,   297,   314,  1011,    -1,   297,  1011,    -1,   310,   777,
     360,   314,  1011,    -1,   310,   777,   360,  1011,    -1,   277,
     362,  1007,    -1,    72,   278,  1007,    -1,   310,   278,  1007,
      -1,   404,    -1,   362,    -1,    -1,   196,   210,   476,    -1,
     287,   252,    -1,   287,   406,    -1,   106,    -1,   237,   106,
      -1,   778,    -1,   779,   441,   778,    -1,   779,   778,    -1,
     779,    -1,    -1,    84,   525,   394,   996,   544,   501,    32,
     845,   782,    -1,    84,   256,   300,   525,   394,   996,   544,
     501,    32,   845,   782,    -1,    84,   525,   291,   394,   996,
     437,   545,   438,   501,    32,   845,   782,    -1,    84,   256,
     300,   525,   291,   394,   996,   437,   545,   438,   501,    32,
     845,   782,    -1,   401,    61,   254,    -1,   401,    53,    61,
     254,    -1,   401,   215,    61,   254,    -1,    -1,   214,  1003,
      -1,    84,    98,   999,   448,   785,    -1,   785,   786,    -1,
      -1,   352,   787,   998,    -1,   352,   787,   104,    -1,   218,
     787,  1007,    -1,   218,   787,   104,    -1,   354,   787,   998,
      -1,   354,   787,   104,    -1,   125,   787,  1007,    -1,   125,
     787,  1006,    -1,   125,   787,   104,    -1,   204,   787,  1007,
      -1,   204,   787,   104,    -1,   205,   787,  1007,    -1,   205,
     787,   104,    -1,    76,   212,   787,  1010,    -1,   265,   787,
     998,    -1,   265,   787,   104,    -1,   424,    -1,    -1,    24,
      98,   999,   448,   790,    -1,    24,    98,   999,   327,   352,
     998,    -1,    24,    98,   999,   484,    -1,   790,   791,    -1,
      -1,    76,   212,   787,  1010,    -1,   121,    98,   999,    -1,
     121,    98,   168,   136,   999,    -1,    24,   349,   327,   471,
      -1,    24,   349,   302,   483,    -1,    84,   119,   672,   796,
     905,   534,    -1,    24,   119,   672,   495,    -1,    24,   119,
     672,   121,   237,   242,    -1,    24,   119,   672,   327,   237,
     242,    -1,    24,   119,   672,    18,   541,    -1,    24,   119,
     672,   121,    77,   998,   496,    -1,    24,   119,   672,   121,
      77,   168,   136,   998,   496,    -1,    24,   119,   672,   385,
      77,   998,    -1,    32,    -1,    -1,    24,   356,   317,   113,
     672,   643,    -1,    24,   356,   317,    75,   672,    18,   220,
     148,   997,   401,   671,    -1,    24,   356,   317,    75,   672,
      24,   220,   148,   997,   401,   671,    -1,    24,   356,   317,
      75,   672,    24,   220,   300,   672,   401,   672,    -1,    24,
     356,   317,    75,   672,    24,   220,   148,   997,   300,   672,
     401,   672,    -1,    24,   356,   317,    75,   672,   121,   220,
     148,   997,    -1,    24,   356,   317,    75,   672,   121,   220,
     168,   136,   148,   997,    -1,    84,   657,    81,   672,   148,
    1007,   360,  1007,   153,   672,    -1,    65,   807,   996,   801,
      -1,    65,   807,    -1,    65,   807,  1002,   251,   996,    -1,
     382,  1002,    -1,    -1,   383,   808,   809,   807,    -1,   383,
     808,   809,   807,   996,    -1,   383,   808,   809,   807,   805,
      -1,   383,   437,   803,   438,    -1,   383,   437,   803,   438,
     996,   810,    -1,   804,    -1,   803,   441,   804,    -1,   806,
      -1,   392,    -1,   152,    -1,   154,    -1,   806,   807,    -1,
     806,   807,   996,   810,    -1,    27,    -1,    26,    -1,   392,
      -1,    -1,   154,    -1,    -1,   152,    -1,    -1,   437,   997,
     438,    -1,    -1,   137,   812,    -1,   137,   806,   807,   812,
      -1,   137,   392,   812,    -1,   137,   437,   813,   438,   812,
      -1,   845,    -1,   823,    -1,   834,    -1,   828,    -1,   841,
      -1,   561,    -1,   564,    -1,   567,    -1,   820,    -1,   814,
      -1,   813,   441,   814,    -1,   815,   816,    -1,  1013,    -1,
     806,    -1,   477,    -1,   574,    -1,    -1,   277,   998,   818,
      32,   819,    -1,   437,   966,   438,    -1,    -1,   845,    -1,
     823,    -1,   834,    -1,   828,    -1,   135,   998,   821,    -1,
      84,   525,   350,   562,    32,   135,   998,   821,   563,    -1,
     437,   963,   438,    -1,    -1,   100,   998,    -1,   100,   277,
     998,    -1,   100,    22,    -1,   100,   277,    22,    -1,   853,
     186,   192,   996,   824,   827,    -1,   845,    -1,   437,   825,
     438,   845,    -1,   104,   388,    -1,   826,    -1,   825,   441,
     826,    -1,  1011,   987,    -1,   305,   993,    -1,    -1,   853,
     109,   153,   894,   829,   901,   827,    -1,   382,   883,    -1,
      -1,   219,   856,   893,   831,   833,    -1,   173,   832,   226,
      -1,    -1,    16,   329,    -1,   311,   329,    -1,   311,   134,
      -1,    30,   329,    -1,    30,   134,    -1,   329,   380,   134,
      -1,   329,    -1,   329,   311,   134,    -1,   134,    -1,    16,
     134,    -1,   241,    -1,    -1,   853,   380,   894,   327,   835,
     882,   901,   827,    -1,   836,    -1,   835,   441,   836,    -1,
     837,    -1,   838,    -1,   839,   424,   989,    -1,   437,   840,
     438,   424,   991,    -1,  1011,   987,    -1,   839,    -1,   840,
     441,   839,    -1,   103,   842,   843,    95,   844,   148,   845,
      -1,   998,    -1,    -1,   843,   235,   316,    -1,   843,   316,
      -1,   843,    45,    -1,   843,   185,    -1,    -1,   401,   165,
      -1,   403,   165,    -1,   847,    -1,   846,    -1,   437,   847,
     438,    -1,   437,   846,   438,    -1,   849,    -1,   848,   860,
      -1,   848,   859,   875,   864,    -1,   848,   859,   863,   876,
      -1,   850,   848,    -1,   850,   848,   860,    -1,   850,   848,
     859,   875,   864,    -1,   850,   848,   859,   863,   876,    -1,
     849,    -1,   846,    -1,   320,   858,   992,   854,   882,   900,
     873,   874,   946,    -1,   881,    -1,   350,   892,    -1,   848,
     374,   857,   848,    -1,   848,   190,   857,   848,    -1,   848,
     131,   857,   848,    -1,   401,   851,    -1,   401,   291,   851,
      -1,   852,    -1,   851,   441,   852,    -1,   998,   810,    32,
     437,   819,   438,    -1,   850,    -1,    -1,   192,   855,    -1,
      -1,   355,   856,   996,    -1,   353,   856,   996,    -1,   215,
     355,   856,   996,    -1,   215,   353,   856,   996,    -1,   157,
     355,   856,   996,    -1,   157,   353,   856,   996,    -1,   378,
     856,   996,    -1,   350,   996,    -1,   996,    -1,   350,    -1,
      -1,    22,    -1,   116,    -1,    -1,   116,    -1,   116,   251,
     437,   963,   438,    -1,    22,    -1,    -1,   860,    -1,    -1,
     257,    49,   861,    -1,   862,    -1,   861,   441,   862,    -1,
     929,   382,   961,   717,    -1,   929,   716,   717,    -1,   865,
     866,    -1,   866,   865,    -1,   865,    -1,   866,    -1,   863,
      -1,    -1,   212,   867,    -1,   212,   867,   441,   868,    -1,
     143,   872,   869,   871,   252,    -1,   249,   868,    -1,   249,
     870,   871,    -1,   929,    -1,    22,    -1,   929,    -1,  1010,
      -1,   437,   929,   438,    -1,    -1,   931,    -1,   311,    -1,
     312,    -1,   145,    -1,   234,    -1,   161,    49,   963,    -1,
      -1,   163,   929,    -1,    -1,   877,    -1,   148,   287,   252,
      -1,   875,    -1,    -1,   878,    -1,   877,   878,    -1,   879,
     880,   833,    -1,   148,   380,    -1,   148,   235,   198,   380,
      -1,   148,   329,    -1,   148,   198,   329,    -1,   247,   995,
      -1,    -1,   388,   991,    -1,   881,   441,   991,    -1,   153,
     883,    -1,    -1,   884,    -1,   883,   441,   884,    -1,   892,
     887,    -1,   895,   888,    -1,   203,   895,   888,    -1,   846,
     887,    -1,   203,   846,   887,    -1,   885,    -1,   437,   885,
     438,   886,    -1,   437,   885,   438,    -1,   884,    85,   197,
     884,    -1,   884,   889,   197,   884,   891,    -1,   884,   197,
     884,   891,    -1,   884,   232,   889,   197,   884,    -1,   884,
     232,   197,   884,    -1,    32,  1011,   437,   997,   438,    -1,
      32,  1011,    -1,  1011,   437,   997,   438,    -1,  1011,    -1,
     886,    -1,    -1,   886,    -1,    32,   437,   903,   438,    -1,
      32,  1011,   437,   903,   438,    -1,  1011,   437,   903,   438,
      -1,    -1,   154,   890,    -1,   209,   890,    -1,   308,   890,
      -1,   182,    -1,   260,    -1,    -1,   382,   437,   997,   438,
      -1,   251,   929,    -1,   996,    -1,   996,   430,    -1,   252,
     996,    -1,   252,   437,   996,   438,    -1,   892,    -1,   893,
     441,   892,    -1,   892,    -1,   892,  1011,    -1,   892,    32,
    1011,    -1,   934,   899,    -1,   312,   153,   437,   897,   438,
     899,    -1,   934,   898,    -1,   896,    -1,   897,   441,   896,
      -1,    32,   437,   903,   438,    -1,    -1,   422,    -1,    -1,
     398,   929,    -1,    -1,   398,   929,    -1,   398,    87,   247,
     842,    -1,    -1,   903,    -1,    -1,   904,    -1,   903,   441,
     904,    -1,  1011,   905,   497,    -1,   907,   906,    -1,   328,
     907,   906,    -1,   907,    31,   435,  1006,   436,    -1,   328,
     907,    31,   435,  1006,   436,    -1,   907,    31,    -1,   328,
     907,    31,    -1,   906,   435,   436,    -1,   906,   435,  1006,
     436,    -1,    -1,   909,    -1,   911,    -1,   913,    -1,   917,
      -1,   924,    -1,   925,   927,    -1,   925,   437,  1006,   438,
     927,    -1,   911,    -1,   914,    -1,   918,    -1,   924,    -1,
    1012,   910,    -1,  1012,   673,   910,    -1,   437,   963,   438,
      -1,    -1,   188,    -1,   189,    -1,   333,    -1,    44,    -1,
     288,    -1,   146,   912,    -1,   120,   275,    -1,   102,   910,
      -1,   101,   910,    -1,   245,   910,    -1,    47,    -1,   437,
    1006,   438,    -1,    -1,   915,    -1,   916,    -1,   915,    -1,
     916,    -1,    46,   922,   437,   963,   438,    -1,    46,   922,
      -1,   919,    -1,   920,    -1,   919,    -1,   920,    -1,   921,
     437,  1006,   438,   923,    -1,   921,   923,    -1,    59,   922,
      -1,    58,   922,    -1,   389,    -1,   231,    59,   922,    -1,
     231,    58,   922,    -1,   233,   922,    -1,   391,    -1,    -1,
      59,   327,  1011,    -1,    -1,   359,   437,  1006,   438,   926,
      -1,   359,   926,    -1,   358,   437,  1006,   438,   926,    -1,
     358,   926,    -1,   191,    -1,   423,   419,    -1,   403,   358,
     419,    -1,    -1,   417,    -1,   227,    -1,    99,    -1,   166,
      -1,   224,    -1,   928,    -1,   417,   360,   227,    -1,    99,
     360,   166,    -1,    99,   360,   224,    -1,    99,   360,   928,
      -1,   166,   360,   224,    -1,   166,   360,   928,    -1,   224,
     360,   928,    -1,    -1,   318,    -1,   318,   437,  1006,   438,
      -1,   931,    -1,   929,    11,   905,    -1,   929,    67,   672,
      -1,   929,    37,   358,   419,   929,    -1,   428,   929,    -1,
     429,   929,    -1,   929,   428,   929,    -1,   929,   429,   929,
      -1,   929,   430,   929,    -1,   929,   431,   929,    -1,   929,
     432,   929,    -1,   929,   433,   929,    -1,   929,   425,   929,
      -1,   929,   426,   929,    -1,   929,   424,   929,    -1,   929,
     960,   929,    -1,   960,   929,    -1,   929,   960,    -1,   929,
      28,   929,    -1,   929,   256,   929,    -1,   237,   929,    -1,
     929,   211,   929,    -1,   929,   211,   929,   129,   929,    -1,
     929,   237,   211,   929,    -1,   929,   237,   211,   929,   129,
     929,    -1,   929,   169,   929,    -1,   929,   169,   929,   129,
     929,    -1,   929,   237,   169,   929,    -1,   929,   237,   169,
     929,   129,   929,    -1,   929,   331,   360,   929,    -1,   929,
     331,   360,   929,   129,   929,    -1,   929,   237,   331,   360,
     929,    -1,   929,   237,   331,   360,   929,   129,   929,    -1,
     929,   194,   242,    -1,   929,   195,    -1,   929,   194,   237,
     242,    -1,   929,   240,    -1,   956,   262,   956,    -1,   929,
     194,   366,    -1,   929,   194,   237,   366,    -1,   929,   194,
     141,    -1,   929,   194,   237,   141,    -1,   929,   194,   376,
      -1,   929,   194,   237,   376,    -1,   929,   194,   116,   153,
     929,    -1,   929,   194,   237,   116,   153,   929,    -1,   929,
     194,   247,   437,   966,   438,    -1,   929,   194,   237,   247,
     437,   966,   438,    -1,   929,    43,   988,   930,    28,   930,
      -1,   929,   237,    43,   988,   930,    28,   930,    -1,   929,
      43,   347,   930,    28,   930,    -1,   929,   237,    43,   347,
     930,    28,   930,    -1,   929,   173,   978,    -1,   929,   237,
     173,   978,    -1,   929,   962,   957,   846,    -1,   929,   962,
     957,   437,   929,   438,    -1,   375,   846,    -1,   929,   194,
     118,    -1,   929,   194,   237,   118,    -1,   931,    -1,   930,
      11,   905,    -1,   428,   930,    -1,   429,   930,    -1,   930,
     428,   930,    -1,   930,   429,   930,    -1,   930,   430,   930,
      -1,   930,   431,   930,    -1,   930,   432,   930,    -1,   930,
     433,   930,    -1,   930,   425,   930,    -1,   930,   426,   930,
      -1,   930,   424,   930,    -1,   930,   960,   930,    -1,   960,
     930,    -1,   930,   960,    -1,   930,   194,   116,   153,   930,
      -1,   930,   194,   237,   116,   153,   930,    -1,   930,   194,
     247,   437,   966,   438,    -1,   930,   194,   237,   247,   437,
     966,   438,    -1,   930,   194,   118,    -1,   930,   194,   237,
     118,    -1,   984,    -1,  1005,    -1,    10,   987,    -1,   437,
     929,   438,   987,    -1,   979,    -1,   933,    -1,   846,    -1,
     846,   986,    -1,   136,   846,    -1,    31,   846,    -1,    31,
     967,    -1,   956,    -1,  1004,   437,   438,    -1,  1004,   437,
     964,   859,   438,    -1,  1004,   437,   390,   965,   859,   438,
      -1,  1004,   437,   964,   441,   390,   965,   859,   438,    -1,
    1004,   437,    22,   964,   859,   438,    -1,  1004,   437,   116,
     964,   859,   438,    -1,  1004,   437,   430,   438,    -1,   932,
     944,   945,   949,    -1,   935,    -1,   932,    -1,   935,    -1,
      68,   148,   437,   929,   438,    -1,    89,    -1,    92,    -1,
      92,   437,  1006,   438,    -1,    93,    -1,    93,   437,  1006,
     438,    -1,   216,    -1,   216,   437,  1006,   438,    -1,   217,
      -1,   217,   437,  1006,   438,    -1,    90,    -1,    94,    -1,
     326,    -1,   381,    -1,    88,    -1,    91,    -1,    55,   437,
     929,    32,   905,   438,    -1,   140,   437,   969,   438,    -1,
     263,   437,   971,   438,    -1,   273,   437,   973,   438,    -1,
     346,   437,   974,   438,    -1,   363,   437,   929,    32,   905,
     438,    -1,   365,   437,    48,   977,   438,    -1,   365,   437,
     206,   977,   438,    -1,   365,   437,   361,   977,   438,    -1,
     365,   437,   977,   438,    -1,   243,   437,   929,   441,   929,
     438,    -1,    66,   437,   963,   438,    -1,   160,   437,   963,
     438,    -1,   208,   437,   963,   438,    -1,   409,   437,   963,
     438,    -1,   410,   437,   229,  1014,   438,    -1,   410,   437,
     229,  1014,   441,   938,   438,    -1,   410,   437,   229,  1014,
     441,   963,   438,    -1,   410,   437,   229,  1014,   441,   938,
     441,   963,   438,    -1,   411,   437,   931,   943,   438,    -1,
     412,   437,   939,   438,    -1,   413,   437,   941,   929,   942,
     438,    -1,   414,   437,   229,  1014,   438,    -1,   414,   437,
     229,  1014,   441,   929,   438,    -1,   415,   437,   929,   441,
     936,   937,   438,    -1,   416,   437,   941,   929,    32,   907,
     438,    -1,   393,   929,    -1,   393,   235,   387,    -1,   441,
     337,   418,    -1,   441,   337,   235,    -1,   441,   337,   235,
     387,    -1,    -1,   408,   437,   939,   438,    -1,   940,    -1,
     939,   441,   940,    -1,   929,    32,  1014,    -1,   929,    -1,
     118,    -1,    79,    -1,   276,   399,    -1,   345,   399,    -1,
      -1,   269,   931,    -1,   269,   931,    49,   292,    -1,   269,
      49,   292,   931,    -1,   269,    49,   292,   931,    49,   292,
      -1,   402,   161,   437,   860,   438,    -1,    -1,   144,   437,
     398,   929,   438,    -1,    -1,   400,   947,    -1,    -1,   948,
      -1,   947,   441,   948,    -1,  1011,    32,   950,    -1,   261,
     950,    -1,   261,  1011,    -1,    -1,   437,   951,   952,   859,
     953,   438,    -1,  1011,    -1,    -1,   268,    49,   963,    -1,
      -1,   286,   954,    -1,   312,   954,    -1,    -1,   955,    -1,
      43,   955,    28,   955,    -1,   371,   274,    -1,   371,   147,
      -1,    87,   311,    -1,   929,   274,    -1,   929,   147,    -1,
     311,   437,   963,   438,    -1,   311,   437,   438,    -1,   437,
     963,   441,   929,   438,    -1,    29,    -1,   335,    -1,    22,
      -1,     8,    -1,   959,    -1,   428,    -1,   429,    -1,   430,
      -1,   431,    -1,   432,    -1,   433,    -1,   425,    -1,   426,
      -1,   424,    -1,     8,    -1,   253,   437,   747,   438,    -1,
     958,    -1,   253,   437,   747,   438,    -1,   958,    -1,   253,
     437,   747,   438,    -1,   211,    -1,   237,   211,    -1,   169,
      -1,   237,   169,    -1,   929,    -1,   963,   441,   929,    -1,
     965,    -1,   964,   441,   965,    -1,   929,    -1,   726,    13,
     929,    -1,   905,    -1,   966,   441,   905,    -1,   435,   963,
     436,    -1,   435,   968,   436,    -1,   435,   436,    -1,   967,
      -1,   968,   441,   967,    -1,   970,   153,   929,    -1,    -1,
       3,    -1,   417,    -1,   227,    -1,    99,    -1,   166,    -1,
     224,    -1,   318,    -1,  1007,    -1,   929,   972,   975,   976,
      -1,   929,   972,   975,    -1,   271,   929,    -1,   930,   173,
     930,    -1,    -1,   929,   975,   976,    -1,   929,   976,   975,
      -1,   929,   975,    -1,   929,   976,    -1,   963,    -1,    -1,
     153,   929,    -1,   148,   929,    -1,   929,   153,   963,    -1,
     153,   963,    -1,   963,    -1,   846,    -1,   437,   963,   438,
      -1,    54,   983,   980,   982,   127,    -1,   981,    -1,   980,
     981,    -1,   397,   929,   357,   929,    -1,   123,   929,    -1,
      -1,   929,    -1,    -1,  1011,    -1,  1011,   986,    -1,   439,
    1001,    -1,   439,   430,    -1,   435,   929,   436,    -1,   435,
     929,   442,   929,   436,    -1,   985,    -1,   986,   985,    -1,
      -1,   987,   985,    -1,    36,    -1,    -1,   929,    -1,   104,
      -1,   989,    -1,   990,   441,   989,    -1,   437,   990,   438,
      -1,   993,    -1,    -1,   994,    -1,   993,   441,   994,    -1,
     929,    32,  1014,    -1,   929,     3,    -1,   929,    -1,   430,
      -1,   996,    -1,   995,   441,   996,    -1,  1011,    -1,  1011,
     986,    -1,   998,    -1,   997,   441,   998,    -1,  1011,    -1,
    1011,    -1,  1011,    -1,  1014,    -1,  1011,    -1,  1007,    -1,
    1012,    -1,  1011,   986,    -1,  1006,    -1,     4,    -1,  1007,
      -1,     6,    -1,     7,    -1,  1004,  1007,    -1,  1004,   437,
     964,   859,   438,  1007,    -1,   908,  1007,    -1,   925,  1007,
     927,    -1,   925,   437,  1006,   438,  1007,   927,    -1,   366,
      -1,   141,    -1,   242,    -1,     9,    -1,     5,    -1,  1013,
      -1,  1008,    -1,  1009,   441,  1008,    -1,  1006,    -1,   428,
    1006,    -1,   429,  1006,    -1,     3,    -1,  1015,    -1,  1016,
      -1,     3,    -1,  1015,    -1,  1017,    -1,     3,    -1,  1015,
      -1,  1016,    -1,  1017,    -1,     3,    -1,  1015,    -1,  1016,
      -1,  1017,    -1,  1018,    -1,    14,    -1,    15,    -1,    16,
      -1,    17,    -1,    18,    -1,    19,    -1,    20,    -1,    21,
      -1,    23,    -1,    24,    -1,    25,    -1,    30,    -1,    34,
      -1,    35,    -1,    37,    -1,    38,    -1,    40,    -1,    41,
      -1,    42,    -1,    49,    -1,    50,    -1,    51,    -1,    52,
      -1,    53,    -1,    56,    -1,    57,    -1,    60,    -1,    62,
      -1,    63,    -1,    64,    -1,    65,    -1,    70,    -1,    71,
      -1,    72,    -1,    73,    -1,    75,    -1,    76,    -1,    78,
      -1,    79,    -1,    80,    -1,    81,    -1,    82,    -1,    83,
      -1,    86,    -1,    87,    -1,    95,    -1,    96,    -1,    97,
      -1,    98,    -1,    99,    -1,   100,    -1,   103,    -1,   105,
      -1,   107,    -1,   108,    -1,   109,    -1,   110,    -1,   111,
      -1,   113,    -1,   114,    -1,   115,    -1,   118,    -1,   119,
      -1,   120,    -1,   121,    -1,   122,    -1,   124,    -1,   125,
      -1,   126,    -1,   128,    -1,   129,    -1,   130,    -1,   132,
      -1,   133,    -1,   134,    -1,   135,    -1,   137,    -1,   138,
      -1,   139,    -1,   142,    -1,   144,    -1,   145,    -1,   147,
      -1,   149,    -1,   151,    -1,   155,    -1,   156,    -1,   157,
      -1,   159,    -1,   162,    -1,   164,    -1,   165,    -1,   166,
      -1,   167,    -1,   168,    -1,   170,    -1,   171,    -1,   172,
      -1,   174,    -1,   175,    -1,   176,    -1,   177,    -1,   178,
      -1,   179,    -1,   181,    -1,   184,    -1,   185,    -1,   186,
      -1,   187,    -1,   193,    -1,   196,    -1,   198,    -1,   199,
      -1,   200,    -1,   201,    -1,   202,    -1,   204,    -1,   205,
      -1,   207,    -1,   210,    -1,   213,    -1,   214,    -1,   215,
      -1,   218,    -1,   219,    -1,   220,    -1,   221,    -1,   222,
      -1,   223,    -1,   224,    -1,   225,    -1,   226,    -1,   227,
      -1,   228,    -1,   229,    -1,   230,    -1,   234,    -1,   235,
      -1,   238,    -1,   239,    -1,   241,    -1,   244,    -1,   246,
      -1,   247,    -1,   248,    -1,   250,    -1,   253,    -1,   254,
      -1,   255,    -1,   258,    -1,   261,    -1,   264,    -1,   265,
      -1,   266,    -1,   267,    -1,   268,    -1,   269,    -1,   270,
      -1,   272,    -1,   274,    -1,   277,    -1,   278,    -1,   276,
      -1,   280,    -1,   281,    -1,   282,    -1,   283,    -1,   284,
      -1,   285,    -1,   286,    -1,   287,    -1,   289,    -1,   290,
      -1,   291,    -1,   292,    -1,   294,    -1,   295,    -1,   296,
      -1,   297,    -1,   298,    -1,   299,    -1,   300,    -1,   301,
      -1,   302,    -1,   303,    -1,   304,    -1,   306,    -1,   307,
      -1,   309,    -1,   310,    -1,   312,    -1,   313,    -1,   314,
      -1,   315,    -1,   316,    -1,   317,    -1,   318,    -1,   319,
      -1,   321,    -1,   322,    -1,   323,    -1,   324,    -1,   325,
      -1,   327,    -1,   329,    -1,   330,    -1,   332,    -1,   334,
      -1,   336,    -1,   337,    -1,   338,    -1,   339,    -1,   340,
      -1,   341,    -1,   342,    -1,   343,    -1,   344,    -1,   345,
      -1,   348,    -1,   349,    -1,   351,    -1,   352,    -1,   353,
      -1,   354,    -1,   355,    -1,   356,    -1,   362,    -1,   364,
      -1,   367,    -1,   368,    -1,   369,    -1,   370,    -1,   371,
      -1,   372,    -1,   373,    -1,   376,    -1,   377,    -1,   378,
      -1,   379,    -1,   380,    -1,   383,    -1,   384,    -1,   385,
      -1,   386,    -1,   387,    -1,   391,    -1,   393,    -1,   394,
      -1,   395,    -1,   396,    -1,   399,    -1,   402,    -1,   403,
      -1,   404,    -1,   405,    -1,   406,    -1,   407,    -1,   417,
      -1,   418,    -1,   419,    -1,    43,    -1,    44,    -1,    46,
      -1,    47,    -1,    58,    -1,    59,    -1,    66,    -1,   101,
      -1,   102,    -1,   136,    -1,   140,    -1,   146,    -1,   160,
      -1,   183,    -1,   188,    -1,   189,    -1,   191,    -1,   208,
      -1,   231,    -1,   233,    -1,   236,    -1,   243,    -1,   245,
      -1,   259,    -1,   263,    -1,   273,    -1,   275,    -1,   288,
      -1,   311,    -1,   328,    -1,   333,    -1,   346,    -1,   358,
      -1,   359,    -1,   363,    -1,   365,    -1,   388,    -1,   389,
      -1,   408,    -1,   409,    -1,   410,    -1,   411,    -1,   412,
      -1,   413,    -1,   414,    -1,   415,    -1,   416,    -1,    39,
      -1,    45,    -1,    68,    -1,    74,    -1,    85,    -1,    91,
      -1,   152,    -1,   154,    -1,   169,    -1,   182,    -1,   194,
      -1,   195,    -1,   197,    -1,   209,    -1,   211,    -1,   232,
      -1,   240,    -1,   260,    -1,   262,    -1,   308,    -1,   331,
      -1,   392,    -1,    22,    -1,    26,    -1,    27,    -1,    28,
      -1,    29,    -1,    31,    -1,    32,    -1,    33,    -1,    36,
      -1,    48,    -1,    54,    -1,    55,    -1,    61,    -1,    67,
      -1,    69,    -1,    77,    -1,    84,    -1,    88,    -1,    89,
      -1,    90,    -1,    92,    -1,    93,    -1,    94,    -1,   104,
      -1,   106,    -1,   112,    -1,   116,    -1,   117,    -1,   123,
      -1,   127,    -1,   131,    -1,   141,    -1,   143,    -1,   148,
      -1,   150,    -1,   153,    -1,   158,    -1,   161,    -1,   163,
      -1,   173,    -1,   180,    -1,   190,    -1,   192,    -1,   203,
      -1,   206,    -1,   212,    -1,   216,    -1,   217,    -1,   237,
      -1,   242,    -1,   249,    -1,   251,    -1,   252,    -1,   256,
      -1,   257,    -1,   271,    -1,   279,    -1,   293,    -1,   305,
      -1,   320,    -1,   326,    -1,   335,    -1,   347,    -1,   350,
      -1,   357,    -1,   360,    -1,   361,    -1,   366,    -1,   374,
      -1,   375,    -1,   381,    -1,   382,    -1,   390,    -1,   397,
      -1,   398,    -1,   400,    -1,   401,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   690,   690,   697,   704,   714,   715,   716,   717,   718,
     719,   720,   721,   722,   723,   724,   725,   726,   727,   728,
     729,   730,   731,   732,   733,   734,   735,   736,   737,   738,
     739,   740,   741,   742,   743,   744,   745,   746,   747,   748,
     749,   750,   751,   752,   753,   754,   755,   756,   757,   758,
     759,   760,   761,   762,   763,   764,   765,   766,   767,   768,
     769,   770,   771,   772,   773,   774,   775,   776,   777,   778,
     779,   780,   781,   782,   783,   784,   785,   786,   787,   788,
     789,   790,   791,   792,   793,   794,   795,   796,   797,   798,
     799,   800,   801,   802,   803,   804,   805,   806,   807,   808,
     809,   810,   811,   812,   813,   814,   815,   816,   817,   818,
     819,   820,   821,   822,   823,   824,   825,   826,   827,   828,
     829,   831,   841,   852,   853,   862,   863,   867,   868,   872,
     877,   881,   886,   891,   895,   899,   904,   908,   962,   964,
     968,   972,   976,   980,   994,  1012,  1023,  1024,  1028,  1036,
    1054,  1066,  1087,  1094,  1113,  1120,  1137,  1155,  1166,  1167,
    1179,  1186,  1203,  1216,  1226,  1244,  1262,  1263,  1267,  1274,
    1282,  1283,  1284,  1285,  1286,  1287,  1301,  1307,  1313,  1322,
    1330,  1338,  1342,  1350,  1358,  1365,  1374,  1375,  1383,  1394,
    1402,  1410,  1421,  1429,  1437,  1444,  1453,  1463,  1464,  1468,
    1469,  1472,  1474,  1478,  1479,  1480,  1481,  1485,  1486,  1487,
    1493,  1505,  1509,  1513,  1528,  1551,  1552,  1553,  1557,  1558,
    1559,  1563,  1564,  1568,  1572,  1573,  1580,  1587,  1597,  1604,
    1614,  1615,  1620,  1621,  1626,  1632,  1638,  1644,  1650,  1660,
    1670,  1671,  1675,  1676,  1684,  1699,  1705,  1711,  1717,  1723,
    1742,  1751,  1760,  1771,  1782,  1791,  1800,  1811,  1822,  1831,
    1840,  1849,  1858,  1867,  1876,  1887,  1901,  1902,  1907,  1915,
    1923,  1932,  1940,  1948,  1957,  1966,  1975,  1984,  1994,  2007,
    2022,  2031,  2039,  2054,  2062,  2072,  2082,  2089,  2096,  2104,
    2112,  2120,  2128,  2136,  2143,  2150,  2158,  2165,  2172,  2180,
    2188,  2196,  2204,  2212,  2220,  2230,  2237,  2245,  2253,  2261,
    2269,  2276,  2286,  2287,  2291,  2292,  2293,  2297,  2305,  2309,
    2310,  2314,  2321,  2328,  2335,  2345,  2348,  2349,  2353,  2354,
    2359,  2363,  2367,  2372,  2387,  2400,  2401,  2406,  2415,  2425,
    2435,  2461,  2467,  2497,  2526,  2548,  2549,  2553,  2554,  2563,
    2564,  2565,  2568,  2569,  2574,  2575,  2579,  2583,  2587,  2591,
    2595,  2599,  2603,  2607,  2611,  2615,  2619,  2623,  2627,  2631,
    2640,  2644,  2648,  2652,  2656,  2660,  2664,  2665,  2670,  2674,
    2681,  2688,  2689,  2690,  2691,  2692,  2696,  2700,  2708,  2719,
    2734,  2750,  2766,  2795,  2796,  2797,  2798,  2799,  2806,  2813,
    2814,  2818,  2819,  2823,  2824,  2828,  2832,  2839,  2843,  2850,
    2851,  2852,  2856,  2857,  2860,  2881,  2902,  2903,  2907,  2915,
    2916,  2917,  2948,  2955,  2962,  2973,  2984,  2994,  3003,  3036,
    3043,  3050,  3057,  3068,  3078,  3079,  3080,  3084,  3085,  3086,
    3087,  3088,  3089,  3098,  3106,  3110,  3123,  3138,  3152,  3167,
    3181,  3199,  3220,  3221,  3225,  3226,  3230,  3231,  3234,  3240,
    3244,  3252,  3257,  3263,  3264,  3268,  3273,  3280,  3281,  3291,
    3293,  3295,  3297,  3300,  3303,  3306,  3310,  3311,  3312,  3313,
    3314,  3317,  3318,  3323,  3324,  3325,  3326,  3329,  3330,  3331,
    3332,  3335,  3336,  3339,  3340,  3343,  3358,  3373,  3387,  3388,
    3389,  3401,  3416,  3429,  3430,  3442,  3462,  3474,  3482,  3493,
    3494,  3497,  3498,  3501,  3505,  3509,  3513,  3517,  3521,  3525,
    3529,  3533,  3537,  3541,  3545,  3551,  3552,  3556,  3557,  3562,
    3565,  3566,  3578,  3590,  3605,  3606,  3614,  3615,  3619,  3620,
    3624,  3625,  3629,  3630,  3634,  3645,  3658,  3659,  3669,  3680,
    3681,  3694,  3701,  3718,  3726,  3737,  3740,  3744,  3748,  3752,
    3764,  3774,  3777,  3781,  3794,  3804,  3814,  3823,  3832,  3841,
    3851,  3860,  3870,  3880,  3890,  3899,  3908,  3917,  3926,  3935,
    3944,  3953,  3962,  3971,  3980,  3989,  3998,  4007,  4025,  4036,
    4037,  4038,  4039,  4043,  4044,  4048,  4049,  4059,  4070,  4090,
    4098,  4110,  4111,  4115,  4119,  4127,  4131,  4135,  4142,  4146,
    4151,  4156,  4163,  4170,  4175,  4185,  4199,  4200,  4205,  4206,
    4210,  4211,  4221,  4232,  4252,  4261,  4269,  4286,  4301,  4326,
    4335,  4353,  4365,  4366,  4367,  4377,  4385,  4402,  4421,  4441,
    4466,  4467,  4468,  4472,  4474,  4496,  4498,  4500,  4502,  4504,
    4509,  4514,  4524,  4525,  4529,  4530,  4534,  4535,  4539,  4540,
    4541,  4545,  4551,  4552,  4553,  4557,  4558,  4563,  4564,  4591,
    4592,  4593,  4594,  4595,  4596,  4601,  4612,  4635,  4645,  4659,
    4661,  4666,  4671,  4673,  4678,  4688,  4689,  4690,  4691,  4703,
    4723,  4746,  4756,  4767,  4777,  4787,  4798,  4807,  4814,  4821,
    4830,  4839,  4848,  4857,  4866,  4877,  4880,  4881,  4884,  4888,
    4895,  4896,  4897,  4898,  4899,  4902,  4905,  4906,  4914,  4921,
    4922,  4925,  4927,  4938,  4948,  4958,  4970,  4971,  4987,  5002,
    5003,  5007,  5017,  5028,  5037,  5047,  5056,  5057,  5060,  5061,
    5064,  5065,  5066,  5069,  5083,  5088,  5098,  5107,  5119,  5120,
    5124,  5132,  5144,  5155,  5169,  5180,  5203,  5213,  5231,  5242,
    5253,  5264,  5278,  5279,  5280,  5281,  5282,  5283,  5284,  5285,
    5286,  5287,  5288,  5289,  5290,  5291,  5292,  5293,  5294,  5298,
    5299,  5302,  5303,  5306,  5308,  5321,  5332,  5333,  5334,  5366,
    5375,  5384,  5393,  5402,  5411,  5420,  5430,  5439,  5448,  5457,
    5466,  5475,  5487,  5488,  5489,  5490,  5491,  5492,  5493,  5494,
    5495,  5496,  5497,  5498,  5499,  5500,  5501,  5502,  5503,  5504,
    5505,  5506,  5507,  5508,  5509,  5513,  5514,  5528,  5539,  5550,
    5561,  5572,  5585,  5586,  5590,  5591,  5592,  5593,  5594,  5595,
    5596,  5597,  5598,  5599,  5600,  5601,  5602,  5605,  5606,  5616,
    5622,  5630,  5638,  5646,  5654,  5662,  5670,  5678,  5686,  5694,
    5702,  5710,  5718,  5726,  5734,  5742,  5750,  5760,  5761,  5764,
    5765,  5775,  5791,  5805,  5831,  5833,  5835,  5837,  5844,  5853,
    5854,  5857,  5864,  5871,  5878,  5892,  5900,  5908,  5916,  5924,
    5932,  5940,  5948,  5956,  5964,  5972,  5980,  5988,  5996,  6004,
    6012,  6024,  6025,  6028,  6038,  6052,  6053,  6057,  6058,  6063,
    6079,  6092,  6102,  6114,  6115,  6118,  6119,  6129,  6139,  6140,
    6144,  6148,  6152,  6163,  6176,  6190,  6207,  6208,  6209,  6210,
    6222,  6249,  6250,  6254,  6255,  6259,  6260,  6264,  6265,  6268,
    6269,  6277,  6288,  6299,  6312,  6313,  6316,  6317,  6318,  6321,
    6322,  6323,  6326,  6327,  6328,  6344,  6356,  6369,  6384,  6385,
    6388,  6389,  6393,  6394,  6402,  6403,  6407,  6408,  6423,  6432,
    6441,  6450,  6459,  6471,  6472,  6473,  6474,  6475,  6481,  6485,
    6500,  6501,  6507,  6517,  6521,  6526,  6534,  6575,  6579,  6583,
    6587,  6595,  6596,  6601,  6602,  6609,  6613,  6617,  6621,  6625,
    6629,  6633,  6637,  6641,  6645,  6649,  6653,  6657,  6661,  6665,
    6673,  6677,  6681,  6685,  6691,  6692,  6699,  6700,  6703,  6715,
    6719,  6734,  6745,  6746,  6751,  6752,  6767,  6778,  6792,  6803,
    6817,  6828,  6842,  6850,  6852,  6854,  6859,  6861,  6874,  6883,
    6884,  6888,  6892,  6904,  6915,  6926,  6939,  6940,  6941,  6945,
    6958,  6959,  6973,  6981,  6991,  7004,  7005,  7008,  7009,  7020,
    7029,  7046,  7056,  7065,  7074,  7083,  7092,  7102,  7111,  7121,
    7130,  7139,  7149,  7159,  7168,  7177,  7187,  7197,  7207,  7217,
    7227,  7237,  7247,  7257,  7267,  7277,  7287,  7297,  7308,  7319,
    7330,  7341,  7351,  7362,  7373,  7383,  7393,  7401,  7410,  7419,
    7428,  7437,  7446,  7455,  7464,  7473,  7487,  7488,  7491,  7492,
    7502,  7512,  7521,  7530,  7539,  7548,  7558,  7568,  7578,  7588,
    7597,  7606,  7615,  7624,  7633,  7642,  7651,  7660,  7669,  7678,
    7687,  7696,  7705,  7714,  7731,  7740,  7748,  7756,  7764,  7772,
    7781,  7789,  7797,  7806,  7815,  7824,  7832,  7840,  7848,  7856,
    7864,  7872,  7880,  7897,  7914,  7915,  7916,  7921,  7927,  7936,
    7937,  7938,  7939,  7940,  7944,  7945,  7948,  7949,  7950,  7951,
    7955,  7956,  7957,  7962,  7973,  7995,  8005,  8006,  8009,  8018,
    8024,  8043,  8050,  8057,  8064,  8071,  8078,  8085,  8093,  8101,
    8109,  8117,  8125,  8132,  8139,  8148,  8149,  8150,  8154,  8157,
    8160,  8163,  8166,  8173,  8175,  8177,  8182,  8184,  8196,  8209,
    8222,  8240,  8261,  8262,  8263,  8264,  8274,  8290,  8300,  8301,
    8305,  8309,  8313,  8317,  8321,  8325,  8329,  8333,  8337,  8341,
    8345,  8349,  8353,  8357,  8361,  8365,  8375,  8376,  8387,  8394,
    8405,  8416,  8417,  8421,  8435,  8442,  8460,  8466,  8482,  8495,
    8504,  8512,  8520,  8529,  8540,  8551,  8561,  8562,  8573,  8583,
    8593,  8603,  8613,  8623,  8631,  8652,  8675,  8683,  8692,  8703,
    8704,  8716,  8732,  8748,  8762,  8782,  8807,  8808,  8812,  8813,
    8814,  8815,  8819,  8833,  8850,  8851,  8855,  8856,  8859,  8860,
    8863,  8864,  8868,  8869,  8882,  8889,  8899,  8906,  8916,  8917,
    8918,  8919,  8920,  8921,  8922,  8923,  8924,  8928,  8932,  8939,
    8946,  8947,  8951,  8952,  8953,  8963,  8973,  8974,  8978,  8979,
    8980,  8981,  8991,  8998,  9016,  9017,  9027,  9033,  9039,  9045,
    9061,  9071,  9077,  9083,  9092,  9094,  9099,  9110,  9111,  9122,
    9136,  9137,  9148,  9159,  9160,  9163,  9164,  9165,  9166,  9167,
    9168,  9169,  9170,  9171,  9172,  9175,  9176,  9187,  9205,  9206,
    9210,  9211,  9215,  9223,  9251,  9262,  9263,  9273,  9284,  9287,
    9288,  9289,  9290,  9291,  9294,  9295,  9296,  9344,  9345,  9349,
    9350,  9365,  9366,  9373,  9381,  9389,  9397,  9405,  9413,  9424,
    9425,  9452,  9467,  9468,  9487,  9491,  9495,  9510,  9517,  9527,
    9528,  9531,  9543,  9544,  9548,  9560,  9568,  9573,  9578,  9583,
    9588,  9596,  9604,  9609,  9614,  9621,  9622,  9625,  9626,  9627,
    9634,  9635,  9636,  9637,  9641,  9642,  9646,  9650,  9651,  9654,
    9663,  9676,  9677,  9678,  9679,  9683,  9684,  9688,  9690,  9700,
    9705,  9708,  9713,  9714,  9722,  9732,  9733,  9734,  9742,  9746,
    9747,  9750,  9751,  9756,  9757,  9761,  9762,  9766,  9767,  9771,
    9772,  9776,  9777,  9781,  9792,  9793,  9794,  9795,  9799,  9800,
    9805,  9811,  9829,  9830,  9834,  9835,  9841,  9846,  9853,  9861,
    9896,  9921,  9925,  9951,  9955,  9967,  9980,  9994, 10005, 10020,
   10026, 10031, 10037, 10044, 10045, 10053, 10057, 10061, 10067, 10074,
   10079, 10080, 10081, 10082, 10086, 10087, 10099, 10100, 10105, 10112,
   10119, 10126, 10137, 10138, 10151, 10155, 10162, 10183, 10193, 10205,
   10210, 10211, 10214, 10215, 10218, 10219, 10224, 10225, 10230, 10231,
   10239, 10244, 10245, 10249, 10253, 10259, 10289, 10294, 10301, 10306,
   10312, 10317, 10326, 10328, 10331, 10335, 10336, 10337, 10338, 10339,
   10340, 10345, 10375, 10376, 10377, 10378, 10389, 10395, 10403, 10404,
   10410, 10415, 10420, 10425, 10430, 10435, 10440, 10445, 10451, 10457,
   10463, 10470, 10492, 10501, 10505, 10513, 10517, 10525, 10537, 10558,
   10562, 10568, 10572, 10585, 10596, 10611, 10613, 10615, 10617, 10619,
   10621, 10626, 10627, 10631, 10632, 10639, 10648, 10656, 10665, 10676,
   10684, 10685, 10686, 10690, 10692, 10694, 10696, 10698, 10700, 10702,
   10707, 10712, 10718, 10726, 10731, 10738, 10745, 10749, 10753, 10783,
   10784, 10786, 10794, 10809, 10811, 10813, 10815, 10817, 10819, 10821,
   10823, 10825, 10827, 10829, 10832, 10834, 10836, 10839, 10841, 10843,
   10846, 10848, 10855, 10857, 10864, 10866, 10873, 10875, 10883, 10890,
   10897, 10904, 10921, 10928, 10935, 10942, 10949, 10965, 10972, 10979,
   10986, 10993, 11000, 11007, 11011, 11019, 11023, 11033, 11040, 11047,
   11060, 11073, 11092, 11113, 11123, 11130, 11146, 11151, 11169, 11171,
   11173, 11175, 11177, 11179, 11181, 11183, 11185, 11187, 11189, 11191,
   11193, 11195, 11197, 11199, 11201, 11205, 11210, 11214, 11218, 11223,
   11240, 11241, 11242, 11257, 11269, 11271, 11273, 11283, 11306, 11316,
   11326, 11334, 11345, 11349, 11355, 11362, 11369, 11379, 11386, 11414,
   11449, 11460, 11461, 11468, 11474, 11500, 11510, 11523, 11531, 11544,
   11554, 11567, 11577, 11590, 11594, 11598, 11602, 11606, 11610, 11614,
   11616, 11620, 11629, 11634, 11641, 11656, 11663, 11667, 11671, 11675,
   11679, 11686, 11694, 11702, 11706, 11710, 11714, 11718, 11722, 11728,
   11732, 11741, 11745, 11749, 11754, 11768, 11770, 11774, 11776, 11778,
   11781, 11784, 11787, 11788, 11791, 11799, 11809, 11810, 11813, 11814,
   11815, 11820, 11824, 11828, 11832, 11843, 11844, 11848, 11849, 11857,
   11858, 11862, 11863, 11868, 11876, 11878, 11892, 11895, 11922, 11923,
   11926, 11927, 11938, 11956, 11963, 11972, 11989, 12034, 12042, 12050,
   12058, 12066, 12087, 12088, 12089, 12092, 12093, 12094, 12097, 12098,
   12101, 12102, 12103, 12104, 12105, 12106, 12107, 12108, 12109, 12112,
   12114, 12119, 12121, 12126, 12128, 12130, 12132, 12134, 12136, 12148,
   12152, 12159, 12163, 12169, 12173, 12184, 12185, 12188, 12192, 12196,
   12202, 12203, 12208, 12212, 12219, 12220, 12221, 12222, 12223, 12224,
   12225, 12226, 12236, 12240, 12247, 12254, 12255, 12271, 12275, 12280,
   12284, 12299, 12304, 12308, 12311, 12314, 12315, 12316, 12319, 12326,
   12336, 12350, 12351, 12355, 12366, 12367, 12370, 12371, 12374, 12378,
   12385, 12389, 12393, 12400, 12410, 12411, 12415, 12416, 12419, 12420,
   12431, 12432, 12441, 12442, 12450, 12460, 12461, 12465, 12466, 12469,
   12485, 12493, 12501, 12523, 12524, 12535, 12539, 12566, 12568, 12573,
   12576, 12579, 12581, 12583, 12585, 12595, 12597, 12608, 12612, 12616,
   12620, 12624, 12633, 12640, 12672, 12676, 12682, 12699, 12703, 12707,
   12713, 12714, 12715, 12717, 12719, 12723, 12724, 12725, 12741, 12742,
   12743, 12748, 12749, 12750, 12755, 12756, 12757, 12758, 12764, 12765,
   12766, 12767, 12768, 12788, 12789, 12790, 12791, 12792, 12793, 12794,
   12795, 12796, 12797, 12798, 12799, 12800, 12801, 12802, 12803, 12804,
   12805, 12806, 12807, 12808, 12809, 12810, 12811, 12812, 12813, 12814,
   12815, 12816, 12817, 12818, 12819, 12820, 12821, 12822, 12823, 12824,
   12825, 12826, 12827, 12828, 12829, 12830, 12831, 12832, 12833, 12834,
   12835, 12836, 12837, 12838, 12839, 12840, 12841, 12842, 12843, 12844,
   12845, 12846, 12847, 12848, 12849, 12850, 12851, 12852, 12853, 12854,
   12855, 12856, 12857, 12858, 12859, 12860, 12861, 12862, 12863, 12864,
   12865, 12866, 12867, 12868, 12869, 12870, 12871, 12872, 12873, 12874,
   12875, 12876, 12877, 12878, 12879, 12880, 12881, 12882, 12883, 12884,
   12885, 12886, 12887, 12888, 12889, 12890, 12891, 12892, 12893, 12894,
   12895, 12896, 12897, 12898, 12899, 12900, 12901, 12902, 12903, 12904,
   12905, 12906, 12907, 12908, 12909, 12910, 12911, 12912, 12913, 12914,
   12915, 12916, 12917, 12918, 12919, 12920, 12921, 12922, 12923, 12924,
   12925, 12926, 12927, 12928, 12929, 12930, 12931, 12932, 12933, 12934,
   12935, 12936, 12937, 12938, 12939, 12940, 12941, 12942, 12943, 12944,
   12945, 12946, 12947, 12948, 12949, 12950, 12951, 12952, 12953, 12954,
   12955, 12956, 12957, 12958, 12959, 12960, 12961, 12962, 12963, 12964,
   12965, 12966, 12967, 12968, 12969, 12970, 12971, 12972, 12973, 12974,
   12975, 12976, 12977, 12978, 12979, 12980, 12981, 12982, 12983, 12984,
   12985, 12986, 12987, 12988, 12989, 12990, 12991, 12992, 12993, 12994,
   12995, 12996, 12997, 12998, 12999, 13000, 13001, 13002, 13003, 13004,
   13005, 13006, 13007, 13008, 13009, 13010, 13011, 13012, 13013, 13014,
   13015, 13016, 13017, 13018, 13019, 13020, 13021, 13022, 13023, 13024,
   13025, 13026, 13027, 13028, 13029, 13030, 13031, 13032, 13033, 13034,
   13035, 13036, 13037, 13038, 13039, 13040, 13041, 13042, 13043, 13044,
   13045, 13046, 13047, 13061, 13062, 13063, 13064, 13065, 13066, 13067,
   13068, 13069, 13070, 13071, 13072, 13073, 13074, 13075, 13076, 13077,
   13078, 13079, 13080, 13081, 13082, 13083, 13084, 13085, 13086, 13087,
   13088, 13089, 13090, 13091, 13092, 13093, 13094, 13095, 13096, 13097,
   13098, 13099, 13100, 13101, 13102, 13103, 13104, 13105, 13106, 13107,
   13121, 13122, 13123, 13124, 13125, 13126, 13127, 13128, 13129, 13130,
   13131, 13132, 13133, 13134, 13135, 13136, 13137, 13138, 13139, 13140,
   13141, 13142, 13152, 13153, 13154, 13155, 13156, 13157, 13158, 13159,
   13160, 13161, 13162, 13163, 13164, 13165, 13166, 13167, 13168, 13169,
   13170, 13171, 13172, 13173, 13174, 13175, 13176, 13177, 13178, 13179,
   13180, 13181, 13182, 13183, 13184, 13185, 13186, 13187, 13188, 13189,
   13190, 13191, 13192, 13193, 13194, 13195, 13196, 13197, 13198, 13199,
   13200, 13201, 13202, 13203, 13204, 13205, 13206, 13207, 13208, 13209,
   13210, 13211, 13212, 13213, 13214, 13215, 13216, 13217, 13218, 13219,
   13220, 13221, 13222, 13223, 13224, 13225, 13226, 13227, 13228
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || 0
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "IDENT", "FCONST", "SCONST", "BCONST",
  "XCONST", "Op", "ICONST", "PARAM", "TYPECAST", "DOT_DOT", "COLON_EQUALS",
  "ABORT_P", "ABSOLUTE_P", "ACCESS", "ACTION", "ADD_P", "ADMIN", "AFTER",
  "AGGREGATE", "ALL", "ALSO", "ALTER", "ALWAYS", "ANALYSE", "ANALYZE",
  "AND", "ANY", "APPLICATION", "ARRAY", "AS", "ASC", "ASSERTION",
  "ASSIGNMENT", "ASYMMETRIC", "AT", "ATTRIBUTE", "AUTHORIZATION",
  "BACKWARD", "BEFORE", "BEGIN_P", "BETWEEN", "BIGINT", "BINARY", "BIT",
  "BOOLEAN_P", "BOTH", "BY", "CACHE", "CALLED", "CASCADE", "CASCADED",
  "CASE", "CAST", "CATALOG_P", "CHAIN", "CHAR_P", "CHARACTER",
  "CHARACTERISTICS", "CHECK", "CHECKPOINT", "CLASS", "CLOSE", "CLUSTER",
  "COALESCE", "COLLATE", "COLLATION", "COLUMN", "COMMENT", "COMMENTS",
  "COMMIT", "COMMITTED", "CONCURRENTLY", "CONFIGURATION", "CONNECTION",
  "CONSTRAINT", "CONSTRAINTS", "CONTENT_P", "CONTINUE_P", "CONVERSION_P",
  "COPY", "COST", "CREATE", "CROSS", "CSV", "CURRENT_P", "CURRENT_CATALOG",
  "CURRENT_DATE", "CURRENT_ROLE", "CURRENT_SCHEMA", "CURRENT_TIME",
  "CURRENT_TIMESTAMP", "CURRENT_USER", "CURSOR", "CYCLE", "DATA_P",
  "DATABASE", "DAY_P", "DEALLOCATE", "DEC", "DECIMAL_P", "DECLARE",
  "DEFAULT", "DEFAULTS", "DEFERRABLE", "DEFERRED", "DEFINER", "DELETE_P",
  "DELIMITER", "DELIMITERS", "DESC", "DICTIONARY", "DISABLE_P", "DISCARD",
  "DISTINCT", "DO", "DOCUMENT_P", "DOMAIN_P", "DOUBLE_P", "DROP", "EACH",
  "ELSE", "ENABLE_P", "ENCODING", "ENCRYPTED", "END_P", "ENUM_P", "ESCAPE",
  "EVENT", "EXCEPT", "EXCLUDE", "EXCLUDING", "EXCLUSIVE", "EXECUTE",
  "EXISTS", "EXPLAIN", "EXTENSION", "EXTERNAL", "EXTRACT", "FALSE_P",
  "FAMILY", "FETCH", "FILTER", "FIRST_P", "FLOAT_P", "FOLLOWING", "FOR",
  "FORCE", "FOREIGN", "FORWARD", "FREEZE", "FROM", "FULL", "FUNCTION",
  "FUNCTIONS", "GLOBAL", "GRANT", "GRANTED", "GREATEST", "GROUP_P",
  "HANDLER", "HAVING", "HEADER_P", "HOLD", "HOUR_P", "IDENTITY_P", "IF_P",
  "ILIKE", "IMMEDIATE", "IMMUTABLE", "IMPLICIT_P", "IN_P", "INCLUDING",
  "INCREMENT", "INDEX", "INDEXES", "INHERIT", "INHERITS", "INITIALLY",
  "INLINE_P", "INNER_P", "INOUT", "INPUT_P", "INSENSITIVE", "INSERT",
  "INSTEAD", "INT_P", "INTEGER", "INTERSECT", "INTERVAL", "INTO",
  "INVOKER", "IS", "ISNULL", "ISOLATION", "JOIN", "KEY", "LABEL",
  "LANGUAGE", "LARGE_P", "LAST_P", "LATERAL_P", "LC_COLLATE_P",
  "LC_CTYPE_P", "LEADING", "LEAKPROOF", "LEAST", "LEFT", "LEVEL", "LIKE",
  "LIMIT", "LISTEN", "LOAD", "LOCAL", "LOCALTIME", "LOCALTIMESTAMP",
  "LOCATION", "LOCK_P", "MAPPING", "MATCH", "MATERIALIZED", "MAXVALUE",
  "MINUTE_P", "MINVALUE", "MODE", "MONTH_P", "MOVE", "NAME_P", "NAMES",
  "NATIONAL", "NATURAL", "NCHAR", "NEXT", "NO", "NONE", "NOT", "NOTHING",
  "NOTIFY", "NOTNULL", "NOWAIT", "NULL_P", "NULLIF", "NULLS_P", "NUMERIC",
  "OBJECT_P", "OF", "OFF", "OFFSET", "OIDS", "ON", "ONLY", "OPERATOR",
  "OPTION", "OPTIONS", "OR", "ORDER", "ORDINALITY", "OUT_P", "OUTER_P",
  "OVER", "OVERLAPS", "OVERLAY", "OWNED", "OWNER", "PARSER", "PARTIAL",
  "PARTITION", "PASSING", "PASSWORD", "PLACING", "PLANS", "POSITION",
  "PRECEDING", "PRECISION", "PRESERVE", "PREPARE", "PREPARED", "PRIMARY",
  "PRIOR", "PRIVILEGES", "PROCEDURAL", "PROCEDURE", "PROGRAM", "QUOTE",
  "RANGE", "READ", "REAL", "REASSIGN", "RECHECK", "RECURSIVE", "REF",
  "REFERENCES", "REFRESH", "REINDEX", "RELATIVE_P", "RELEASE", "RENAME",
  "REPEATABLE", "REPLACE", "REPLICA", "RESET", "RESTART", "RESTRICT",
  "RETURNING", "RETURNS", "REVOKE", "RIGHT", "ROLE", "ROLLBACK", "ROW",
  "ROWS", "RULE", "SAVEPOINT", "SCHEMA", "SCROLL", "SEARCH", "SECOND_P",
  "SECURITY", "SELECT", "SEQUENCE", "SEQUENCES", "SERIALIZABLE", "SERVER",
  "SESSION", "SESSION_USER", "SET", "SETOF", "SHARE", "SHOW", "SIMILAR",
  "SIMPLE", "SMALLINT", "SNAPSHOT", "SOME", "STABLE", "STANDALONE_P",
  "START", "STATEMENT", "STATISTICS", "STDIN", "STDOUT", "STORAGE",
  "STRICT_P", "STRIP_P", "SUBSTRING", "SYMMETRIC", "SYSID", "SYSTEM_P",
  "TABLE", "TABLES", "TABLESPACE", "TEMP", "TEMPLATE", "TEMPORARY",
  "TEXT_P", "THEN", "TIME", "TIMESTAMP", "TO", "TRAILING", "TRANSACTION",
  "TREAT", "TRIGGER", "TRIM", "TRUE_P", "TRUNCATE", "TRUSTED", "TYPE_P",
  "TYPES_P", "UNBOUNDED", "UNCOMMITTED", "UNENCRYPTED", "UNION", "UNIQUE",
  "UNKNOWN", "UNLISTEN", "UNLOGGED", "UNTIL", "UPDATE", "USER", "USING",
  "VACUUM", "VALID", "VALIDATE", "VALIDATOR", "VALUE_P", "VALUES",
  "VARCHAR", "VARIADIC", "VARYING", "VERBOSE", "VERSION_P", "VIEW",
  "VIEWS", "VOLATILE", "WHEN", "WHERE", "WHITESPACE_P", "WINDOW", "WITH",
  "WITHIN", "WITHOUT", "WORK", "WRAPPER", "WRITE", "XML_P",
  "XMLATTRIBUTES", "XMLCONCAT", "XMLELEMENT", "XMLEXISTS", "XMLFOREST",
  "XMLPARSE", "XMLPI", "XMLROOT", "XMLSERIALIZE", "YEAR_P", "YES_P",
  "ZONE", "NULLS_FIRST", "NULLS_LAST", "WITH_ORDINALITY", "WITH_TIME",
  "'='", "'<'", "'>'", "POSTFIXOP", "'+'", "'-'", "'*'", "'/'", "'%'",
  "'^'", "UMINUS", "'['", "']'", "'('", "')'", "'.'", "';'", "','", "':'",
  "$accept", "stmtblock", "stmtmulti", "stmt", "CreateRoleStmt",
  "opt_with", "OptRoleList", "AlterOptRoleList", "AlterOptRoleElem",
  "CreateOptRoleElem", "CreateUserStmt", "AlterRoleStmt",
  "opt_in_database", "AlterRoleSetStmt", "AlterUserStmt",
  "AlterUserSetStmt", "DropRoleStmt", "DropUserStmt", "CreateGroupStmt",
  "AlterGroupStmt", "add_drop", "DropGroupStmt", "CreateSchemaStmt",
  "OptSchemaName", "OptSchemaEltList", "schema_stmt", "VariableSetStmt",
  "set_rest", "generic_set", "set_rest_more", "var_name", "var_list",
  "var_value", "iso_level", "opt_boolean_or_string", "zone_value",
  "opt_encoding", "NonReservedWord_or_Sconst", "VariableResetStmt",
  "reset_rest", "generic_reset", "SetResetClause",
  "FunctionSetResetClause", "VariableShowStmt", "ConstraintsSetStmt",
  "constraints_set_list", "constraints_set_mode", "CheckPointStmt",
  "DiscardStmt", "AlterTableStmt", "alter_table_cmds", "alter_table_cmd",
  "alter_column_default", "opt_drop_behavior", "opt_collate_clause",
  "alter_using", "replica_identity", "reloptions", "opt_reloptions",
  "reloption_list", "reloption_elem", "AlterCompositeTypeStmt",
  "alter_type_cmds", "alter_type_cmd", "ClosePortalStmt", "CopyStmt",
  "copy_from", "opt_program", "copy_file_name", "copy_options",
  "copy_opt_list", "copy_opt_item", "opt_binary", "opt_oids",
  "copy_delimiter", "opt_using", "copy_generic_opt_list",
  "copy_generic_opt_elem", "copy_generic_opt_arg",
  "copy_generic_opt_arg_list", "copy_generic_opt_arg_list_item",
  "CreateStmt", "OptTemp", "OptTableElementList",
  "OptTypedTableElementList", "TableElementList", "TypedTableElementList",
  "TableElement", "TypedTableElement", "columnDef", "columnOptions",
  "ColQualList", "ColConstraint", "ColConstraintElem", "ConstraintAttr",
  "TableLikeClause", "TableLikeOptionList", "TableLikeOption",
  "TableConstraint", "ConstraintElem", "opt_no_inherit", "opt_column_list",
  "columnList", "columnElem", "key_match", "ExclusionConstraintList",
  "ExclusionConstraintElem", "ExclusionWhereClause", "key_actions",
  "key_update", "key_delete", "key_action", "OptInherit", "OptWith",
  "OnCommitOption", "OptTableSpace", "OptConsTableSpace", "ExistingIndex",
  "CreateAsStmt", "create_as_target", "opt_with_data", "CreateMatViewStmt",
  "create_mv_target", "OptNoLog", "RefreshMatViewStmt", "CreateSeqStmt",
  "AlterSeqStmt", "OptSeqOptList", "SeqOptList", "SeqOptElem", "opt_by",
  "NumericOnly", "NumericOnly_list", "CreatePLangStmt", "opt_trusted",
  "handler_name", "opt_inline_handler", "validator_clause",
  "opt_validator", "DropPLangStmt", "opt_procedural",
  "CreateTableSpaceStmt", "OptTableSpaceOwner", "DropTableSpaceStmt",
  "CreateExtensionStmt", "create_extension_opt_list",
  "create_extension_opt_item", "AlterExtensionStmt",
  "alter_extension_opt_list", "alter_extension_opt_item",
  "AlterExtensionContentsStmt", "CreateFdwStmt", "fdw_option",
  "fdw_options", "opt_fdw_options", "DropFdwStmt", "AlterFdwStmt",
  "create_generic_options", "generic_option_list", "alter_generic_options",
  "alter_generic_option_list", "alter_generic_option_elem",
  "generic_option_elem", "generic_option_name", "generic_option_arg",
  "CreateForeignServerStmt", "opt_type", "foreign_server_version",
  "opt_foreign_server_version", "DropForeignServerStmt",
  "AlterForeignServerStmt", "CreateForeignTableStmt",
  "AlterForeignTableStmt", "CreateUserMappingStmt", "auth_ident",
  "DropUserMappingStmt", "AlterUserMappingStmt", "CreateTrigStmt",
  "TriggerActionTime", "TriggerEvents", "TriggerOneEvent",
  "TriggerForSpec", "TriggerForOptEach", "TriggerForType", "TriggerWhen",
  "TriggerFuncArgs", "TriggerFuncArg", "OptConstrFromTable",
  "ConstraintAttributeSpec", "ConstraintAttributeElem", "DropTrigStmt",
  "CreateEventTrigStmt", "event_trigger_when_list",
  "event_trigger_when_item", "event_trigger_value_list",
  "AlterEventTrigStmt", "enable_trigger", "CreateAssertStmt",
  "DropAssertStmt", "DefineStmt", "definition", "def_list", "def_elem",
  "def_arg", "old_aggr_definition", "old_aggr_list", "old_aggr_elem",
  "opt_enum_val_list", "enum_val_list", "AlterEnumStmt",
  "opt_if_not_exists", "CreateOpClassStmt", "opclass_item_list",
  "opclass_item", "opt_default", "opt_opfamily", "opclass_purpose",
  "opt_recheck", "CreateOpFamilyStmt", "AlterOpFamilyStmt",
  "opclass_drop_list", "opclass_drop", "DropOpClassStmt",
  "DropOpFamilyStmt", "DropOwnedStmt", "ReassignOwnedStmt", "DropStmt",
  "drop_type", "any_name_list", "any_name", "attrs", "TruncateStmt",
  "opt_restart_seqs", "CommentStmt", "comment_type", "comment_text",
  "SecLabelStmt", "opt_provider", "security_label_type", "security_label",
  "FetchStmt", "fetch_args", "from_in", "opt_from_in", "GrantStmt",
  "RevokeStmt", "privileges", "privilege_list", "privilege",
  "privilege_target", "grantee_list", "grantee", "opt_grant_grant_option",
  "function_with_argtypes_list", "function_with_argtypes", "GrantRoleStmt",
  "RevokeRoleStmt", "opt_grant_admin_option", "opt_granted_by",
  "AlterDefaultPrivilegesStmt", "DefACLOptionList", "DefACLOption",
  "DefACLAction", "defacl_privilege_target", "IndexStmt", "opt_unique",
  "opt_concurrently", "opt_index_name", "access_method_clause",
  "index_params", "index_elem", "opt_collate", "opt_class", "opt_asc_desc",
  "opt_nulls_order", "CreateFunctionStmt", "opt_or_replace", "func_args",
  "func_args_list", "func_args_with_defaults",
  "func_args_with_defaults_list", "func_arg", "arg_class", "param_name",
  "func_return", "func_type", "func_arg_with_default", "aggr_arg",
  "aggr_args", "aggr_args_list", "createfunc_opt_list",
  "common_func_opt_item", "createfunc_opt_item", "func_as",
  "opt_definition", "table_func_column", "table_func_column_list",
  "AlterFunctionStmt", "alterfunc_opt_list", "opt_restrict",
  "RemoveFuncStmt", "RemoveAggrStmt", "RemoveOperStmt", "oper_argtypes",
  "any_operator", "DoStmt", "dostmt_opt_list", "dostmt_opt_item",
  "CreateCastStmt", "cast_context", "DropCastStmt", "opt_if_exists",
  "ReindexStmt", "reindex_type", "opt_force", "AlterTblSpcStmt",
  "RenameStmt", "opt_column", "opt_set_data", "AlterObjectSchemaStmt",
  "AlterOwnerStmt", "RuleStmt", "RuleActionList", "RuleActionMulti",
  "RuleActionStmt", "RuleActionStmtOrEmpty", "event", "opt_instead",
  "DropRuleStmt", "NotifyStmt", "notify_payload", "ListenStmt",
  "UnlistenStmt", "TransactionStmt", "opt_transaction",
  "transaction_mode_item", "transaction_mode_list",
  "transaction_mode_list_or_empty", "ViewStmt", "opt_check_option",
  "LoadStmt", "CreatedbStmt", "createdb_opt_list", "createdb_opt_item",
  "opt_equal", "AlterDatabaseStmt", "AlterDatabaseSetStmt",
  "alterdb_opt_list", "alterdb_opt_item", "DropdbStmt", "AlterSystemStmt",
  "CreateDomainStmt", "AlterDomainStmt", "opt_as", "AlterTSDictionaryStmt",
  "AlterTSConfigurationStmt", "CreateConversionStmt", "ClusterStmt",
  "cluster_index_specification", "VacuumStmt", "vacuum_option_list",
  "vacuum_option_elem", "AnalyzeStmt", "analyze_keyword", "opt_verbose",
  "opt_full", "opt_freeze", "opt_name_list", "ExplainStmt",
  "ExplainableStmt", "explain_option_list", "explain_option_elem",
  "explain_option_name", "explain_option_arg", "PrepareStmt",
  "prep_type_clause", "PreparableStmt", "ExecuteStmt",
  "execute_param_clause", "DeallocateStmt", "InsertStmt", "insert_rest",
  "insert_column_list", "insert_column_item", "returning_clause",
  "DeleteStmt", "using_clause", "LockStmt", "opt_lock", "lock_type",
  "opt_nowait", "UpdateStmt", "set_clause_list", "set_clause",
  "single_set_clause", "multiple_set_clause", "set_target",
  "set_target_list", "DeclareCursorStmt", "cursor_name", "cursor_options",
  "opt_hold", "SelectStmt", "select_with_parens", "select_no_parens",
  "select_clause", "simple_select", "with_clause", "cte_list",
  "common_table_expr", "opt_with_clause", "into_clause",
  "OptTempTableName", "opt_table", "opt_all", "opt_distinct",
  "opt_sort_clause", "sort_clause", "sortby_list", "sortby",
  "select_limit", "opt_select_limit", "limit_clause", "offset_clause",
  "select_limit_value", "select_offset_value",
  "opt_select_fetch_first_value", "select_offset_value2", "row_or_rows",
  "first_or_next", "group_clause", "having_clause", "for_locking_clause",
  "opt_for_locking_clause", "for_locking_items", "for_locking_item",
  "for_locking_strength", "locked_rels_list", "values_clause",
  "from_clause", "from_list", "table_ref", "joined_table", "alias_clause",
  "opt_alias_clause", "func_alias_clause", "join_type", "join_outer",
  "join_qual", "relation_expr", "relation_expr_list",
  "relation_expr_opt_alias", "func_table", "rowsfrom_item",
  "rowsfrom_list", "opt_col_def_list", "opt_ordinality", "where_clause",
  "where_or_current_clause", "OptTableFuncElementList",
  "TableFuncElementList", "TableFuncElement", "Typename",
  "opt_array_bounds", "SimpleTypename", "ConstTypename", "GenericType",
  "opt_type_modifiers", "Numeric", "opt_float", "Bit", "ConstBit",
  "BitWithLength", "BitWithoutLength", "Character", "ConstCharacter",
  "CharacterWithLength", "CharacterWithoutLength", "character",
  "opt_varying", "opt_charset", "ConstDatetime", "ConstInterval",
  "opt_timezone", "opt_interval", "interval_second", "a_expr", "b_expr",
  "c_expr", "func_application", "func_expr", "func_expr_windowless",
  "func_expr_common_subexpr", "xml_root_version",
  "opt_xml_root_standalone", "xml_attributes", "xml_attribute_list",
  "xml_attribute_el", "document_or_content", "xml_whitespace_option",
  "xmlexists_argument", "within_group_clause", "filter_clause",
  "window_clause", "window_definition_list", "window_definition",
  "over_clause", "window_specification", "opt_existing_window_name",
  "opt_partition_clause", "opt_frame_clause", "frame_extent",
  "frame_bound", "row", "sub_type", "all_Op", "MathOp", "qual_Op",
  "qual_all_Op", "subquery_Op", "expr_list", "func_arg_list",
  "func_arg_expr", "type_list", "array_expr", "array_expr_list",
  "extract_list", "extract_arg", "overlay_list", "overlay_placing",
  "position_list", "substr_list", "substr_from", "substr_for", "trim_list",
  "in_expr", "case_expr", "when_clause_list", "when_clause",
  "case_default", "case_arg", "columnref", "indirection_el", "indirection",
  "opt_indirection", "opt_asymmetric", "ctext_expr", "ctext_expr_list",
  "ctext_row", "opt_target_list", "target_list", "target_el",
  "qualified_name_list", "qualified_name", "name_list", "name",
  "database_name", "access_method", "attr_name", "index_name", "file_name",
  "func_name", "AexprConst", "Iconst", "Sconst", "RoleId", "role_list",
  "SignedIconst", "ColId", "type_function_name", "NonReservedWord",
  "ColLabel", "unreserved_keyword", "col_name_keyword",
  "type_func_name_keyword", "reserved_keyword", YY_NULL
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,   600,   601,   602,   603,   604,
     605,   606,   607,   608,   609,   610,   611,   612,   613,   614,
     615,   616,   617,   618,   619,   620,   621,   622,   623,   624,
     625,   626,   627,   628,   629,   630,   631,   632,   633,   634,
     635,   636,   637,   638,   639,   640,   641,   642,   643,   644,
     645,   646,   647,   648,   649,   650,   651,   652,   653,   654,
     655,   656,   657,   658,   659,   660,   661,   662,   663,   664,
     665,   666,   667,   668,   669,   670,   671,   672,   673,   674,
     675,   676,   677,   678,    61,    60,    62,   679,    43,    45,
      42,    47,    37,    94,   680,    91,    93,    40,    41,    46,
      59,    44,    58
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint16 yyr1[] =
{
       0,   443,   444,   445,   445,   446,   446,   446,   446,   446,
     446,   446,   446,   446,   446,   446,   446,   446,   446,   446,
     446,   446,   446,   446,   446,   446,   446,   446,   446,   446,
     446,   446,   446,   446,   446,   446,   446,   446,   446,   446,
     446,   446,   446,   446,   446,   446,   446,   446,   446,   446,
     446,   446,   446,   446,   446,   446,   446,   446,   446,   446,
     446,   446,   446,   446,   446,   446,   446,   446,   446,   446,
     446,   446,   446,   446,   446,   446,   446,   446,   446,   446,
     446,   446,   446,   446,   446,   446,   446,   446,   446,   446,
     446,   446,   446,   446,   446,   446,   446,   446,   446,   446,
     446,   446,   446,   446,   446,   446,   446,   446,   446,   446,
     446,   446,   446,   446,   446,   446,   446,   446,   446,   446,
     446,   446,   447,   448,   448,   449,   449,   450,   450,   451,
     451,   451,   451,   451,   451,   451,   451,   451,   452,   452,
     452,   452,   452,   452,   453,   454,   455,   455,   456,   456,
     457,   458,   459,   459,   460,   460,   461,   462,   463,   463,
     464,   464,   465,   465,   465,   465,   466,   466,   467,   467,
     468,   468,   468,   468,   468,   468,   469,   469,   469,   470,
     470,   470,   471,   471,   471,   471,   472,   472,   472,   472,
     472,   472,   472,   472,   472,   472,   472,   473,   473,   474,
     474,   475,   475,   476,   476,   476,   476,   477,   477,   477,
     477,   478,   478,   478,   478,   478,   478,   478,   479,   479,
     479,   480,   480,   481,   482,   482,   482,   482,   483,   483,
     484,   484,   485,   485,   486,   486,   486,   486,   486,   487,
     488,   488,   489,   489,   490,   491,   491,   491,   491,   491,
     492,   492,   492,   492,   492,   492,   492,   492,   492,   492,
     492,   492,   492,   492,   492,   492,   493,   493,   494,   494,
     494,   494,   494,   494,   494,   494,   494,   494,   494,   494,
     494,   494,   494,   494,   494,   494,   494,   494,   494,   494,
     494,   494,   494,   494,   494,   494,   494,   494,   494,   494,
     494,   494,   494,   494,   494,   494,   494,   494,   494,   494,
     494,   494,   495,   495,   496,   496,   496,   497,   497,   498,
     498,   499,   499,   499,   499,   500,   501,   501,   502,   502,
     503,   503,   503,   503,   504,   505,   505,   506,   506,   506,
     506,   507,   507,   508,   508,   509,   509,   510,   510,   511,
     511,   511,   512,   512,   513,   513,   514,   514,   514,   514,
     514,   514,   514,   514,   514,   514,   514,   514,   514,   514,
     515,   515,   516,   516,   517,   517,   518,   518,   519,   519,
     520,   521,   521,   521,   521,   521,   522,   522,   523,   524,
     524,   524,   524,   525,   525,   525,   525,   525,   525,   525,
     525,   526,   526,   527,   527,   528,   528,   529,   529,   530,
     530,   530,   531,   531,   532,   533,   534,   534,   535,   535,
     535,   535,   536,   536,   536,   536,   536,   536,   536,   537,
     537,   537,   537,   538,   539,   539,   539,   540,   540,   540,
     540,   540,   540,   541,   541,   542,   542,   542,   542,   542,
     542,   542,   543,   543,   544,   544,   545,   545,   546,   547,
     547,   547,   547,   548,   548,   549,   549,   550,   550,   551,
     551,   551,   551,   551,   552,   553,   554,   554,   554,   554,
     554,   555,   555,   556,   556,   556,   556,   557,   557,   557,
     557,   558,   558,   559,   559,   560,   561,   562,   563,   563,
     563,   564,   565,   566,   566,   567,   568,   569,   569,   570,
     570,   571,   571,   572,   572,   572,   572,   572,   572,   572,
     572,   572,   572,   572,   572,   573,   573,   574,   574,   574,
     575,   575,   576,   576,   577,   577,   578,   578,   579,   579,
     580,   580,   581,   581,   582,   582,   583,   583,   584,   585,
     585,   586,   586,   587,   587,   588,   588,   589,   589,   589,
     590,   591,   591,   592,   593,   593,   593,   593,   593,   593,
     593,   593,   593,   593,   593,   593,   593,   593,   593,   593,
     593,   593,   593,   593,   593,   593,   593,   593,   594,   595,
     595,   595,   595,   596,   596,   597,   597,   598,   598,   599,
     599,   600,   600,   601,   601,   602,   603,   603,   604,   604,
     604,   604,   605,   606,   607,   608,   609,   609,   610,   610,
     611,   611,   612,   612,   613,   613,   613,   614,   614,   615,
     615,   616,   617,   617,   617,   618,   618,   619,   620,   620,
     621,   621,   621,   622,   622,   623,   623,   623,   623,   623,
     624,   624,   625,   625,   626,   626,   627,   627,   628,   628,
     628,   629,   629,   629,   629,   630,   630,   631,   631,   632,
     632,   632,   632,   632,   632,   633,   633,   634,   634,   635,
     635,   636,   637,   637,   638,   639,   639,   639,   639,   640,
     641,   642,   642,   642,   642,   642,   642,   642,   642,   642,
     642,   642,   642,   642,   642,   643,   644,   644,   645,   645,
     646,   646,   646,   646,   646,   647,   648,   648,   649,   650,
     650,   651,   651,   652,   652,   652,   653,   653,   654,   655,
     655,   656,   656,   656,   656,   656,   657,   657,   658,   658,
     659,   659,   659,   660,   660,   661,   662,   662,   663,   663,
     664,   664,   665,   665,   666,   666,   667,   668,   669,   669,
     669,   669,   670,   670,   670,   670,   670,   670,   670,   670,
     670,   670,   670,   670,   670,   670,   670,   670,   670,   671,
     671,   672,   672,   673,   673,   674,   675,   675,   675,   676,
     676,   676,   676,   676,   676,   676,   676,   676,   676,   676,
     676,   676,   677,   677,   677,   677,   677,   677,   677,   677,
     677,   677,   677,   677,   677,   677,   677,   677,   677,   677,
     677,   677,   677,   677,   677,   678,   678,   679,   679,   679,
     679,   679,   680,   680,   681,   681,   681,   681,   681,   681,
     681,   681,   681,   681,   681,   681,   681,   682,   682,   683,
     683,   684,   684,   684,   684,   684,   684,   684,   684,   684,
     684,   684,   684,   684,   684,   684,   684,   685,   685,   686,
     686,   687,   688,   688,   689,   689,   689,   689,   689,   690,
     690,   691,   691,   691,   691,   692,   692,   692,   692,   692,
     692,   692,   692,   692,   692,   692,   692,   692,   692,   692,
     692,   693,   693,   694,   694,   695,   695,   696,   696,   697,
     698,   699,   699,   700,   700,   701,   701,   702,   703,   703,
     704,   704,   704,   705,   705,   705,   706,   706,   706,   706,
     707,   708,   708,   709,   709,   710,   710,   711,   711,   712,
     712,   713,   713,   713,   714,   714,   715,   715,   715,   716,
     716,   716,   717,   717,   717,   718,   718,   718,   719,   719,
     720,   720,   721,   721,   722,   722,   723,   723,   724,   724,
     724,   724,   724,   725,   725,   725,   725,   725,   726,   727,
     728,   728,   728,   729,   729,   729,   730,   731,   731,   731,
     731,   732,   732,   733,   733,   734,   734,   734,   734,   734,
     734,   734,   734,   734,   734,   734,   734,   734,   734,   734,
     735,   735,   735,   735,   736,   736,   737,   737,   738,   739,
     739,   740,   741,   741,   742,   742,   743,   743,   744,   744,
     745,   745,   746,   746,   746,   746,   747,   747,   748,   749,
     749,   750,   750,   751,   751,   751,   752,   752,   752,   753,
     754,   754,   755,   755,   755,   756,   756,   757,   757,   758,
     758,   759,   759,   759,   759,   759,   759,   759,   759,   759,
     759,   759,   759,   759,   759,   759,   759,   759,   759,   759,
     759,   759,   759,   759,   759,   759,   759,   759,   759,   759,
     759,   759,   759,   759,   759,   759,   759,   759,   759,   759,
     759,   759,   759,   759,   759,   759,   760,   760,   761,   761,
     762,   762,   762,   762,   762,   762,   762,   762,   762,   762,
     762,   762,   762,   762,   762,   762,   762,   762,   762,   762,
     762,   762,   762,   762,   763,   763,   763,   763,   763,   763,
     763,   763,   763,   763,   763,   763,   763,   763,   763,   763,
     763,   763,   763,   764,   765,   765,   765,   766,   766,   767,
     767,   767,   767,   767,   768,   768,   769,   769,   769,   769,
     770,   770,   770,   771,   771,   772,   773,   773,   774,   775,
     775,   776,   776,   776,   776,   776,   776,   776,   776,   776,
     776,   776,   776,   776,   776,   777,   777,   777,   778,   778,
     778,   778,   778,   779,   779,   779,   780,   780,   781,   781,
     781,   781,   782,   782,   782,   782,   783,   784,   785,   785,
     786,   786,   786,   786,   786,   786,   786,   786,   786,   786,
     786,   786,   786,   786,   786,   786,   787,   787,   788,   788,
     789,   790,   790,   791,   792,   792,   793,   793,   794,   795,
     795,   795,   795,   795,   795,   795,   796,   796,   797,   798,
     798,   798,   798,   798,   798,   799,   800,   800,   800,   801,
     801,   802,   802,   802,   802,   802,   803,   803,   804,   804,
     804,   804,   805,   805,   806,   806,   807,   807,   808,   808,
     809,   809,   810,   810,   811,   811,   811,   811,   812,   812,
     812,   812,   812,   812,   812,   812,   812,   813,   813,   814,
     815,   815,   816,   816,   816,   817,   818,   818,   819,   819,
     819,   819,   820,   820,   821,   821,   822,   822,   822,   822,
     823,   824,   824,   824,   825,   825,   826,   827,   827,   828,
     829,   829,   830,   831,   831,   832,   832,   832,   832,   832,
     832,   832,   832,   832,   832,   833,   833,   834,   835,   835,
     836,   836,   837,   838,   839,   840,   840,   841,   842,   843,
     843,   843,   843,   843,   844,   844,   844,   845,   845,   846,
     846,   847,   847,   847,   847,   847,   847,   847,   847,   848,
     848,   849,   849,   849,   849,   849,   849,   850,   850,   851,
     851,   852,   853,   853,   854,   854,   855,   855,   855,   855,
     855,   855,   855,   855,   855,   856,   856,   857,   857,   857,
     858,   858,   858,   858,   859,   859,   860,   861,   861,   862,
     862,   863,   863,   863,   863,   864,   864,   865,   865,   865,
     866,   866,   867,   867,   868,   869,   869,   869,   870,   871,
     871,   872,   872,   873,   873,   874,   874,   875,   875,   876,
     876,   877,   877,   878,   879,   879,   879,   879,   880,   880,
     881,   881,   882,   882,   883,   883,   884,   884,   884,   884,
     884,   884,   884,   885,   885,   885,   885,   885,   885,   886,
     886,   886,   886,   887,   887,   888,   888,   888,   888,   888,
     889,   889,   889,   889,   890,   890,   891,   891,   892,   892,
     892,   892,   893,   893,   894,   894,   894,   895,   895,   896,
     897,   897,   898,   898,   899,   899,   900,   900,   901,   901,
     901,   902,   902,   903,   903,   904,   905,   905,   905,   905,
     905,   905,   906,   906,   906,   907,   907,   907,   907,   907,
     907,   907,   908,   908,   908,   908,   909,   909,   910,   910,
     911,   911,   911,   911,   911,   911,   911,   911,   911,   911,
     911,   912,   912,   913,   913,   914,   914,   915,   916,   917,
     917,   918,   918,   919,   920,   921,   921,   921,   921,   921,
     921,   922,   922,   923,   923,   924,   924,   924,   924,   925,
     926,   926,   926,   927,   927,   927,   927,   927,   927,   927,
     927,   927,   927,   927,   927,   927,   927,   928,   928,   929,
     929,   929,   929,   929,   929,   929,   929,   929,   929,   929,
     929,   929,   929,   929,   929,   929,   929,   929,   929,   929,
     929,   929,   929,   929,   929,   929,   929,   929,   929,   929,
     929,   929,   929,   929,   929,   929,   929,   929,   929,   929,
     929,   929,   929,   929,   929,   929,   929,   929,   929,   929,
     929,   929,   929,   929,   929,   929,   929,   929,   930,   930,
     930,   930,   930,   930,   930,   930,   930,   930,   930,   930,
     930,   930,   930,   930,   930,   930,   930,   930,   930,   930,
     931,   931,   931,   931,   931,   931,   931,   931,   931,   931,
     931,   931,   932,   932,   932,   932,   932,   932,   932,   933,
     933,   934,   934,   935,   935,   935,   935,   935,   935,   935,
     935,   935,   935,   935,   935,   935,   935,   935,   935,   935,
     935,   935,   935,   935,   935,   935,   935,   935,   935,   935,
     935,   935,   935,   935,   935,   935,   935,   935,   935,   935,
     935,   935,   935,   935,   935,   936,   936,   937,   937,   937,
     937,   938,   939,   939,   940,   940,   941,   941,   942,   942,
     942,   943,   943,   943,   943,   944,   944,   945,   945,   946,
     946,   947,   947,   948,   949,   949,   949,   950,   951,   951,
     952,   952,   953,   953,   953,   954,   954,   955,   955,   955,
     955,   955,   956,   956,   956,   957,   957,   957,   958,   958,
     959,   959,   959,   959,   959,   959,   959,   959,   959,   960,
     960,   961,   961,   962,   962,   962,   962,   962,   962,   963,
     963,   964,   964,   965,   965,   966,   966,   967,   967,   967,
     968,   968,   969,   969,   970,   970,   970,   970,   970,   970,
     970,   970,   971,   971,   972,   973,   973,   974,   974,   974,
     974,   974,   974,   975,   976,   977,   977,   977,   978,   978,
     979,   980,   980,   981,   982,   982,   983,   983,   984,   984,
     985,   985,   985,   985,   986,   986,   987,   987,   988,   988,
     989,   989,   990,   990,   991,   992,   992,   993,   993,   994,
     994,   994,   994,   995,   995,   996,   996,   997,   997,   998,
     999,  1000,  1001,  1002,  1003,  1004,  1004,  1005,  1005,  1005,
    1005,  1005,  1005,  1005,  1005,  1005,  1005,  1005,  1005,  1005,
    1006,  1007,  1008,  1009,  1009,  1010,  1010,  1010,  1011,  1011,
    1011,  1012,  1012,  1012,  1013,  1013,  1013,  1013,  1014,  1014,
    1014,  1014,  1014,  1015,  1015,  1015,  1015,  1015,  1015,  1015,
    1015,  1015,  1015,  1015,  1015,  1015,  1015,  1015,  1015,  1015,
    1015,  1015,  1015,  1015,  1015,  1015,  1015,  1015,  1015,  1015,
    1015,  1015,  1015,  1015,  1015,  1015,  1015,  1015,  1015,  1015,
    1015,  1015,  1015,  1015,  1015,  1015,  1015,  1015,  1015,  1015,
    1015,  1015,  1015,  1015,  1015,  1015,  1015,  1015,  1015,  1015,
    1015,  1015,  1015,  1015,  1015,  1015,  1015,  1015,  1015,  1015,
    1015,  1015,  1015,  1015,  1015,  1015,  1015,  1015,  1015,  1015,
    1015,  1015,  1015,  1015,  1015,  1015,  1015,  1015,  1015,  1015,
    1015,  1015,  1015,  1015,  1015,  1015,  1015,  1015,  1015,  1015,
    1015,  1015,  1015,  1015,  1015,  1015,  1015,  1015,  1015,  1015,
    1015,  1015,  1015,  1015,  1015,  1015,  1015,  1015,  1015,  1015,
    1015,  1015,  1015,  1015,  1015,  1015,  1015,  1015,  1015,  1015,
    1015,  1015,  1015,  1015,  1015,  1015,  1015,  1015,  1015,  1015,
    1015,  1015,  1015,  1015,  1015,  1015,  1015,  1015,  1015,  1015,
    1015,  1015,  1015,  1015,  1015,  1015,  1015,  1015,  1015,  1015,
    1015,  1015,  1015,  1015,  1015,  1015,  1015,  1015,  1015,  1015,
    1015,  1015,  1015,  1015,  1015,  1015,  1015,  1015,  1015,  1015,
    1015,  1015,  1015,  1015,  1015,  1015,  1015,  1015,  1015,  1015,
    1015,  1015,  1015,  1015,  1015,  1015,  1015,  1015,  1015,  1015,
    1015,  1015,  1015,  1015,  1015,  1015,  1015,  1015,  1015,  1015,
    1015,  1015,  1015,  1015,  1015,  1015,  1015,  1015,  1015,  1015,
    1015,  1015,  1015,  1015,  1015,  1015,  1015,  1015,  1015,  1015,
    1015,  1015,  1015,  1015,  1015,  1015,  1015,  1015,  1015,  1015,
    1015,  1015,  1015,  1015,  1015,  1015,  1015,  1015,  1015,  1015,
    1015,  1015,  1015,  1015,  1015,  1015,  1015,  1015,  1015,  1015,
    1015,  1015,  1015,  1016,  1016,  1016,  1016,  1016,  1016,  1016,
    1016,  1016,  1016,  1016,  1016,  1016,  1016,  1016,  1016,  1016,
    1016,  1016,  1016,  1016,  1016,  1016,  1016,  1016,  1016,  1016,
    1016,  1016,  1016,  1016,  1016,  1016,  1016,  1016,  1016,  1016,
    1016,  1016,  1016,  1016,  1016,  1016,  1016,  1016,  1016,  1016,
    1017,  1017,  1017,  1017,  1017,  1017,  1017,  1017,  1017,  1017,
    1017,  1017,  1017,  1017,  1017,  1017,  1017,  1017,  1017,  1017,
    1017,  1017,  1018,  1018,  1018,  1018,  1018,  1018,  1018,  1018,
    1018,  1018,  1018,  1018,  1018,  1018,  1018,  1018,  1018,  1018,
    1018,  1018,  1018,  1018,  1018,  1018,  1018,  1018,  1018,  1018,
    1018,  1018,  1018,  1018,  1018,  1018,  1018,  1018,  1018,  1018,
    1018,  1018,  1018,  1018,  1018,  1018,  1018,  1018,  1018,  1018,
    1018,  1018,  1018,  1018,  1018,  1018,  1018,  1018,  1018,  1018,
    1018,  1018,  1018,  1018,  1018,  1018,  1018,  1018,  1018,  1018,
    1018,  1018,  1018,  1018,  1018,  1018,  1018,  1018,  1018
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     1,     3,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     0,     5,     1,     0,     2,     0,     2,     0,     2,
       2,     3,     3,     1,     3,     3,     2,     1,     1,     2,
       2,     2,     3,     3,     5,     5,     0,     3,     5,     5,
       5,     4,     3,     5,     3,     5,     5,     6,     1,     1,
       3,     5,     6,     4,     9,     7,     1,     0,     2,     0,
       1,     1,     1,     1,     1,     1,     2,     3,     3,     2,
       5,     1,     3,     3,     3,     3,     1,     3,     3,     2,
       2,     2,     2,     3,     3,     3,     3,     1,     3,     1,
       3,     1,     1,     2,     2,     2,     1,     1,     1,     1,
       1,     1,     1,     3,     6,     1,     1,     1,     1,     1,
       0,     1,     1,     2,     1,     2,     3,     2,     1,     1,
       2,     1,     2,     1,     2,     3,     4,     3,     2,     4,
       1,     1,     1,     1,     1,     2,     2,     2,     2,     2,
       4,     6,    10,    13,     4,     6,    10,    13,     4,     6,
       4,     6,     5,     7,    11,    14,     1,     3,     2,     3,
       4,     6,     6,     6,     5,     5,     6,     6,     4,     8,
       4,     2,     4,     3,     6,     4,     3,     3,     3,     3,
       3,     4,     4,     3,     3,     3,     3,     3,     3,     4,
       4,     3,     2,     3,     2,     2,     3,     3,     2,     2,
       3,     1,     3,     2,     1,     1,     0,     2,     0,     2,
       0,     1,     1,     1,     3,     3,     2,     0,     1,     3,
       3,     1,     5,     3,     4,     1,     3,     4,     6,     4,
       8,     2,     2,    11,     7,     1,     1,     1,     0,     1,
       1,     1,     1,     3,     2,     0,     1,     1,     1,     3,
       3,     1,     1,     3,     3,     3,     3,     4,     3,     2,
       1,     0,     2,     0,     3,     0,     1,     0,     1,     3,
       2,     1,     1,     1,     3,     0,     1,     3,     1,    11,
      14,    10,    13,     1,     1,     2,     2,     2,     2,     1,
       0,     1,     0,     3,     0,     1,     3,     1,     3,     1,
       1,     1,     1,     1,     4,     4,     2,     0,     3,     1,
       1,     2,     2,     1,     3,     4,     5,     2,     5,     1,
       2,     2,     2,     3,     3,     3,     0,     1,     1,     1,
       1,     1,     1,     3,     1,     5,     7,     3,     8,     4,
       9,    11,     2,     0,     3,     0,     1,     3,     1,     2,
       2,     2,     0,     1,     3,     3,     6,     4,     0,     1,
       1,     2,     2,     0,     3,     3,     2,     1,     1,     2,
       2,     4,     0,     2,     2,     2,     0,     3,     4,     4,
       0,     2,     0,     4,     0,     3,     7,     5,     2,     3,
       0,     8,     4,     1,     0,     6,     5,     4,     6,     1,
       0,     1,     2,     2,     1,     2,     3,     2,     2,     2,
       2,     3,     3,     1,     3,     1,     0,     1,     2,     1,
       1,     3,     6,    10,     1,     0,     1,     2,     2,     0,
       2,     2,     1,     0,     5,     7,     1,     0,     7,     2,
       0,     3,     5,     5,     8,     2,     0,     2,     2,     2,
       5,     2,     0,     2,     7,    10,     6,     6,     6,     6,
       7,     7,     9,     9,     6,     7,     6,     8,     8,     8,
       8,     6,     6,     7,     7,     8,     6,     6,     7,     2,
       2,     2,     2,     1,     2,     1,     0,     6,     8,     7,
       6,     4,     0,     1,     3,     4,     1,     3,     1,     2,
       2,     2,     2,     1,     1,    10,     2,     0,     2,     2,
       1,     0,     4,     6,     5,     4,     4,    10,    13,     5,
       7,     8,     1,     1,     1,     7,     9,     8,    15,    20,
       1,     1,     2,     1,     3,     1,     1,     1,     3,     1,
       3,     0,     1,     0,     1,     1,     4,     0,     1,     3,
       0,     1,     1,     1,     1,     2,     0,     0,     2,     2,
       1,     2,     2,     2,     2,     6,     8,    11,    13,     1,
       3,     5,     1,     3,     5,     1,     2,     2,     1,     8,
       4,     5,     4,     4,     4,     3,     7,     8,     6,     6,
       6,     6,     6,     4,     5,     3,     1,     3,     3,     1,
       1,     1,     1,     1,     1,     3,     1,     3,     3,     1,
       0,     1,     3,     7,     9,     9,     3,     0,    13,     1,
       3,     5,     6,     4,     7,     2,     1,     0,     2,     0,
       2,     4,     0,     1,     0,     6,     8,     8,     1,     3,
       5,     5,     7,     9,     7,     9,     5,     6,     6,     4,
       5,     7,     1,     1,     1,     2,     1,     2,     2,     1,
       1,     1,     1,     1,     1,     3,     3,     3,     3,     1,
       3,     1,     2,     2,     3,     5,     2,     2,     0,     6,
       7,     7,     7,     8,     8,     6,     8,     9,     9,     7,
      10,     7,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     2,     1,     1,     1,     1,     1,     2,     1,     3,
       2,     3,     3,     3,     3,     1,     1,     8,     9,     9,
       9,     9,     2,     0,     1,     1,     2,     2,     1,     1,
       1,     1,     1,     1,     1,     1,     2,     1,     1,     2,
       2,     1,     2,     3,     3,     3,     3,     4,     4,     3,
       3,     3,     4,     4,     3,     4,     4,     1,     1,     1,
       0,     7,     7,    10,     1,     1,     2,     4,     5,     1,
       3,     2,     2,     2,     2,     1,     2,     2,     4,     3,
       2,     2,     2,     2,     3,     2,     2,     2,     5,     5,
       5,     1,     3,     1,     2,     3,     0,     1,     3,     2,
       6,     6,     9,     3,     0,     3,     0,     5,     2,     0,
       3,     3,     3,     7,     7,    10,     1,     1,     1,     1,
      14,     1,     0,     1,     0,     1,     0,     2,     0,     1,
       3,     5,     5,     7,     2,     0,     1,     2,     0,     1,
       1,     0,     1,     1,     0,     9,    12,     7,     2,     0,
       3,     2,     1,     3,     3,     2,     1,     3,     3,     3,
       2,     2,     1,     1,     1,     1,     2,     1,     1,     1,
       1,     4,     5,     1,     3,     3,     1,     3,     3,     5,
       6,     1,     3,     1,     2,     4,     5,     1,     1,     1,
       1,     3,     3,     2,     2,     1,     2,     2,     2,     1,
       2,     2,     1,     1,     1,     3,     2,     0,     2,     1,
       3,     5,     1,     2,     1,     0,     5,     7,     5,     7,
       5,     7,     3,     5,     5,     5,     1,     3,     2,     1,
       2,     1,     2,    11,    10,    10,     2,     2,     0,     9,
       2,     0,     4,     4,     4,     1,     1,     1,     0,     5,
       5,     7,     6,     6,     6,     6,     8,     8,     6,     6,
       7,     9,     9,     6,     6,     6,     8,     6,     8,     6,
       8,     7,     9,     6,     8,     7,     9,     8,    10,     9,
      11,     8,     9,    11,     8,     8,     7,     6,     6,     6,
       8,     8,     8,     8,     6,     9,     1,     0,     2,     0,
       7,     6,     6,     6,     6,     6,     7,     9,     9,     6,
       8,     8,     8,     8,     8,     6,     8,     6,     8,     7,
       9,     7,     9,     6,     7,     6,     6,     6,     6,     6,
       7,     7,     7,     9,     9,     6,     6,     6,     8,     8,
       8,     6,     7,    13,     1,     1,     3,     3,     1,     1,
       1,     1,     1,     1,     1,     0,     1,     1,     1,     1,
       1,     1,     0,     6,     8,     3,     2,     0,     2,     2,
       2,     2,     3,     3,     2,     2,     2,     2,     3,     2,
       5,     4,     3,     3,     3,     1,     1,     0,     3,     2,
       2,     1,     2,     1,     3,     2,     1,     0,     9,    11,
      12,    14,     3,     4,     4,     0,     2,     5,     2,     0,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     4,     3,     3,     1,     0,     5,     6,
       4,     2,     0,     4,     3,     5,     4,     4,     6,     4,
       6,     6,     5,     7,     9,     6,     1,     0,     6,    11,
      11,    11,    13,     9,    11,    10,     4,     2,     5,     2,
       0,     4,     5,     5,     4,     6,     1,     3,     1,     1,
       1,     1,     2,     4,     1,     1,     1,     0,     1,     0,
       1,     0,     3,     0,     2,     4,     3,     5,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     3,     2,
       1,     1,     1,     1,     0,     5,     3,     0,     1,     1,
       1,     1,     3,     9,     3,     0,     2,     3,     2,     3,
       6,     1,     4,     2,     1,     3,     2,     2,     0,     7,
       2,     0,     5,     3,     0,     2,     2,     2,     2,     2,
       3,     1,     3,     1,     2,     1,     0,     8,     1,     3,
       1,     1,     3,     5,     2,     1,     3,     7,     1,     0,
       3,     2,     2,     2,     0,     2,     2,     1,     1,     3,
       3,     1,     2,     4,     4,     2,     3,     5,     5,     1,
       1,     9,     1,     2,     4,     4,     4,     2,     3,     1,
       3,     6,     1,     0,     2,     0,     3,     3,     4,     4,
       4,     4,     3,     2,     1,     1,     0,     1,     1,     0,
       1,     5,     1,     0,     1,     0,     3,     1,     3,     4,
       3,     2,     2,     1,     1,     1,     0,     2,     4,     5,
       2,     3,     1,     1,     1,     1,     3,     0,     1,     1,
       1,     1,     1,     3,     0,     2,     0,     1,     3,     1,
       0,     1,     2,     3,     2,     4,     2,     3,     2,     0,
       2,     3,     2,     0,     1,     3,     2,     2,     3,     2,
       3,     1,     4,     3,     4,     5,     4,     5,     4,     5,
       2,     4,     1,     1,     0,     1,     4,     5,     4,     0,
       2,     2,     2,     1,     1,     0,     4,     2,     1,     2,
       2,     4,     1,     3,     1,     2,     3,     2,     6,     2,
       1,     3,     4,     0,     1,     0,     2,     0,     2,     4,
       0,     1,     0,     1,     3,     3,     2,     3,     5,     6,
       2,     3,     3,     4,     0,     1,     1,     1,     1,     1,
       2,     5,     1,     1,     1,     1,     2,     3,     3,     0,
       1,     1,     1,     1,     1,     2,     2,     2,     2,     2,
       1,     3,     0,     1,     1,     1,     1,     5,     2,     1,
       1,     1,     1,     5,     2,     2,     2,     1,     3,     3,
       2,     1,     0,     3,     0,     5,     2,     5,     2,     1,
       2,     3,     0,     1,     1,     1,     1,     1,     1,     3,
       3,     3,     3,     3,     3,     3,     0,     1,     4,     1,
       3,     3,     5,     2,     2,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     2,     2,     3,     3,     2,
       3,     5,     4,     6,     3,     5,     4,     6,     4,     6,
       5,     7,     3,     2,     4,     2,     3,     3,     4,     3,
       4,     3,     4,     5,     6,     6,     7,     6,     7,     6,
       7,     3,     4,     4,     6,     2,     3,     4,     1,     3,
       2,     2,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     2,     2,     5,     6,     6,     7,     3,     4,
       1,     1,     2,     4,     1,     1,     1,     2,     2,     2,
       2,     1,     3,     5,     6,     8,     6,     6,     4,     4,
       1,     1,     1,     5,     1,     1,     4,     1,     4,     1,
       4,     1,     4,     1,     1,     1,     1,     1,     1,     6,
       4,     4,     4,     4,     6,     5,     5,     5,     4,     6,
       4,     4,     4,     4,     5,     7,     7,     9,     5,     4,
       6,     5,     7,     7,     7,     2,     3,     3,     3,     4,
       0,     4,     1,     3,     3,     1,     1,     1,     2,     2,
       0,     2,     4,     4,     6,     5,     0,     5,     0,     2,
       0,     1,     3,     3,     2,     2,     0,     6,     1,     0,
       3,     0,     2,     2,     0,     1,     4,     2,     2,     2,
       2,     2,     4,     3,     5,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       4,     1,     4,     1,     4,     1,     2,     1,     2,     1,
       3,     1,     3,     1,     3,     1,     3,     3,     3,     2,
       1,     3,     3,     0,     1,     1,     1,     1,     1,     1,
       1,     1,     4,     3,     2,     3,     0,     3,     3,     2,
       2,     1,     0,     2,     2,     3,     2,     1,     1,     3,
       5,     1,     2,     4,     2,     0,     1,     0,     1,     2,
       2,     2,     3,     5,     1,     2,     0,     2,     1,     0,
       1,     1,     1,     3,     3,     1,     0,     1,     3,     3,
       2,     1,     1,     1,     3,     1,     2,     1,     3,     1,
       1,     1,     1,     1,     1,     1,     2,     1,     1,     1,
       1,     1,     2,     6,     2,     3,     6,     1,     1,     1,
       1,     1,     1,     1,     3,     1,     2,     2,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1
};

/* YYDEFACT[STATE-NAME] -- Default reduction number in state STATE-NUM.
   Performed when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const yytype_uint16 yydefact[] =
{
    1403,  1197,   547,  1285,  1284,  1197,   244,     0,  1287,     0,
    1197,   371,   959,     0,     0,     0,     0,   547,  1197,     0,
    1403,     0,     0,     0,     0,  1416,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1197,     0,     0,  1423,     0,
       0,     0,     0,  1416,     0,  1289,     0,     0,     0,     0,
       2,     4,    61,    62,    26,    25,    31,    30,    84,    85,
      49,    17,    75,    55,   118,   117,   119,    37,    33,    69,
      22,    24,    34,    38,    57,    39,    50,    96,    56,    20,
      54,    79,    58,    82,    44,    11,    12,    45,    73,    13,
      46,    74,    14,    47,    15,    63,    86,    29,    59,    83,
      60,     5,    40,    71,    67,    10,    51,    52,    53,    76,
      77,    78,   101,    81,   113,    36,   110,    90,    91,   107,
      92,   108,     8,    93,    48,    16,   104,   103,   105,    70,
      41,    72,   102,    23,   106,    18,    19,   109,    80,    99,
      95,   114,   112,   120,    97,    64,     6,     7,    87,    21,
      43,     9,    28,    27,    42,    35,   116,    32,  1287,    89,
     100,    88,    65,    94,    68,    98,   115,    66,   111,  1390,
    1377,  1425,  1389,  1402,     0,  1392,  1196,  1195,  1181,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   546,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1207,
    1948,  1963,  1964,  1965,  1966,  1967,  1968,  1969,  1970,   342,
    1971,  1972,  1973,  1974,  1975,  1976,  1977,  1978,  1979,  1980,
    1981,  2223,  2224,  2225,  2226,  1982,  1983,  1984,  1985,  1986,
    1987,  1988,  2227,  2228,  1989,  1990,  1991,  1992,  1993,  2229,
    1994,  1995,  1996,  1997,  1998,  1999,  2000,  2001,  2002,  2003,
    2004,  2005,  2006,  2007,  2008,  2009,  2010,  2011,  2012,  2013,
    2230,  2231,  2014,  2015,  2016,  2017,  2018,  2019,  2020,  2021,
    2022,  2023,  2024,  2025,  2026,  2027,  2028,  2029,  2030,  2031,
    2032,  2033,  2034,  2035,  2036,  2037,  2038,  2232,  2039,  2040,
    2041,  2233,  2042,  2043,  2044,  2234,  2045,  2046,  2047,  2048,
    2049,  2050,  2051,  2235,  2052,  2053,  2054,  2055,  2056,  2057,
    2058,  2059,  2060,  2061,  2062,  2063,  2064,  2065,  2066,  2067,
    2236,  2068,  2069,  2070,  2071,  2237,  2238,  2239,  2072,  2073,
    2074,  2075,  2076,  2077,  2078,  2079,  2080,  2081,  2240,  2082,
    2083,  2084,  2085,  2086,  2087,  2088,  2089,  2090,  2091,  2092,
    2093,  2094,  2095,  2096,  2097,  2098,  2241,  2242,  2099,  2100,
    2243,  2101,  2102,  2103,  2244,  2104,  2245,  2105,  2106,  2107,
    2108,  2109,  2110,  2111,  2112,  2246,  2113,  2247,  2114,  2115,
    2116,  2117,  2118,  2119,  2120,  2121,  2248,  2122,  2249,  2125,
    2123,  2124,  2126,  2127,  2128,  2129,  2130,  2131,  2132,  2133,
    2250,  2134,  2135,  2136,  2137,  2138,  2139,  2140,  2141,  2142,
    2143,  2144,  2145,  2146,  2147,  2148,  2149,  2150,  2151,  2152,
    2251,  2153,  2154,  2155,  2156,  2157,  2158,  2159,  2160,  2161,
    2162,  2163,  2164,  2165,  2166,  2252,  2167,  2168,  2169,  2253,
    2170,  2171,  2172,  2173,  2174,  2175,  2176,  2177,  2178,  2179,
    2180,  2254,  2181,  2182,  2183,  2184,  2185,  2186,  2187,  2188,
    2255,  2256,  2189,  2257,  2190,  2258,  2191,  2192,  2193,  2194,
    2195,  2196,  2197,  2198,  2199,  2200,  2201,  2202,  2203,  2204,
    2205,  2206,  2207,  2259,  2260,  2208,  2209,  2210,  2211,  2212,
    2213,  2214,  2215,  2216,  2217,  2218,  2219,  2261,  2262,  2263,
    2264,  2265,  2266,  2267,  2268,  2269,  2220,  2221,  2222,   341,
    1368,  1919,  1949,  1950,  1286,  1267,   547,     0,  1184,   370,
       0,     0,     0,     0,     0,     0,     0,     0,   736,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   167,
       0,     0,   394,   393,     0,     0,     0,   931,   399,     0,
       0,     0,     0,     0,   535,  1328,  2123,  1326,  1369,   245,
     248,   249,   246,   247,  1941,     0,  1038,  1039,  1041,     0,
       0,  1051,   771,   772,     0,   770,     0,   774,     0,     0,
       0,   766,     0,     0,     0,     0,     0,   773,   763,     0,
     762,     0,     0,     0,   769,     0,   764,     0,     0,  1185,
    1325,   400,  1403,     0,  1303,  1304,  1305,  1287,  1294,  1306,
    1299,  1301,  1300,  1302,  1298,  1940,  1964,   870,   870,   870,
     870,   867,   868,   870,   870,   870,  2140,     0,     0,   849,
       0,   851,  1945,   870,   875,   455,   455,   455,     0,   874,
     879,   455,  1178,  1216,  1924,  1415,     0,   850,  1177,  2189,
    1317,     0,     0,     0,  1055,     0,  1056,     0,  2155,  1189,
     229,  2165,  2255,  2189,   228,   223,   224,   197,  1968,     0,
       0,   874,     0,  1186,  1187,   833,  1422,  1420,  1906,  1987,
    2000,  2085,   220,  2151,  2156,  2165,  2255,  2189,  2219,   176,
     186,   181,     0,   238,  2165,  2255,  2189,   234,  1207,     0,
    1393,  1508,  1915,     0,  1180,  1179,  1288,     0,  1291,     0,
    1470,  2136,  1397,  1399,  1293,  1390,     0,     0,     1,  1403,
    1282,  1419,  1419,     0,  1419,     0,  1382,  1390,  1385,  1389,
       0,     0,     0,     0,  1948,  2270,  2271,  2272,  2273,  2274,
    2275,  2276,  2277,  2278,  2279,  2280,  2281,  2282,  2283,  2284,
    2285,  2286,  2287,  2288,  2289,  2290,  2291,     0,     0,  1925,
    1949,  1953,     0,   781,     0,   124,  1920,   919,     0,     0,
       0,     0,  1919,     0,     0,     0,     0,  1954,     0,  1942,
    1955,  1956,  1957,     0,  2057,     0,     0,     0,  1818,  1991,
    2042,  1828,  1826,  1827,  1820,  1821,  1822,  1823,  1824,  1825,
       0,  1036,  1819,     0,   146,   124,     0,     0,  2057,     0,
       0,     0,     0,     0,  2057,     0,     0,     0,     0,     0,
    2088,   124,  2057,     0,     0,  1201,     0,     0,     0,  1203,
    1206,  1182,  1270,     0,  1915,     0,     0,   812,   802,     0,
     813,   803,   808,     0,   815,     0,     0,   805,     0,     0,
       0,   816,     0,   804,   806,   818,   807,   814,     0,     0,
     809,   810,     0,     0,  1193,   455,   348,     0,     0,     0,
       0,     0,   124,  1257,     0,  2057,   124,     0,     0,   398,
     397,   124,   396,   395,  1991,  2042,     0,   958,   124,  2057,
       0,   169,   617,   550,     0,     0,   695,  2088,   124,     0,
       0,     0,     0,     0,     0,   934,     0,     0,   534,   547,
    1329,  1327,     0,  1042,   222,   221,  1040,  2057,     0,   316,
       0,     0,  2057,  1244,   768,     0,   767,  2057,     0,  2057,
    1943,   160,     0,   765,  1991,  2042,  2057,     0,     0,  2057,
     152,  2057,     0,  2057,   316,  2057,   551,     0,  2057,     0,
    2057,  2088,   154,     0,  2057,   316,   779,     0,  1322,     0,
    1296,  2259,  1311,     0,  1307,  1314,  1310,  1403,   870,   869,
       0,   870,     0,   870,     0,   870,     0,   870,     0,     0,
       0,   870,  1946,  1947,   852,     0,   876,     0,     0,   883,
     882,   881,     0,     0,     0,   884,  1512,  1344,     0,  1175,
    1192,     0,     0,     0,   934,  1058,  1058,  1058,  1188,   227,
     225,     0,     0,     0,     0,     0,     0,  1194,     0,     0,
       0,     0,  1928,  1930,  1931,  1829,  1896,     0,  2224,  2225,
    2226,  1887,     0,  2227,  2228,  2229,  2272,  1737,  1724,  1733,
    1738,  1725,  1727,  1734,  2230,  2231,  2026,  2232,  2233,  1938,
    2234,  2235,  2237,  2238,  2239,  2240,  1729,  1731,  2241,  2242,
       0,  1939,  2244,  2245,  2109,  2247,  2248,  2250,  2251,  1735,
    2253,  2254,  2255,  2256,  2257,  2258,  1937,     0,  1736,  2260,
    2262,  2263,  2264,  2265,  2266,  2267,  2268,  2269,     0,     0,
    1912,     0,  1706,     0,  1552,  1553,  1575,  1576,  1554,  1581,
    1582,  1594,  1555,     0,  1911,  1619,  1786,  1705,  1720,  1711,
       0,  1704,  1700,  1405,  1905,  1907,     0,  1701,  1927,  1929,
    1888,   189,   240,     0,   241,  1913,  2165,   177,   219,   191,
     218,   192,   190,     0,  1989,   178,     0,     0,   179,     0,
       0,     0,     0,   237,   235,     0,  1183,     0,  1510,  1509,
       0,     0,  1894,  1916,   788,  1280,  1281,  1279,     0,  1276,
    1278,  1290,  1287,  1901,  1900,  1902,     0,  1398,     0,     0,
       0,  1380,  1379,     3,  1293,  1417,  1418,     0,     0,     0,
       0,     0,     0,     0,     0,  1460,  1433,  1434,  1436,  1457,
    1461,  1469,     0,  1386,     0,     0,  1514,     0,  1471,     0,
       0,  1926,     0,     0,     0,     0,   782,     0,     0,     0,
       0,     0,     0,   123,  1242,   231,  1240,     0,     0,     0,
       0,     0,     0,     0,  1249,     0,     0,   158,   159,   562,
     547,     0,  2057,     0,     0,     0,     0,   998,  1005,     0,
       0,     0,     0,     0,     0,     0,   999,   997,  1000,   233,
    1009,  1022,  1025,     0,   909,     0,     0,     0,     0,     0,
    1107,     0,     0,  1107,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   254,   266,   311,   527,
       0,     0,   529,     0,  2057,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   128,     0,     0,     0,     0,     0,
       0,   514,   526,     0,     0,     0,     0,     0,   523,     0,
     124,   258,   507,   511,     0,     0,     0,   626,   625,  1247,
    1246,     0,     0,     0,  1107,     0,   250,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   334,   335,     0,     0,     0,   128,   151,     0,
       0,     0,   260,     0,     0,  1202,  1199,  1200,     0,  1205,
       0,  1266,     0,     0,     0,     0,   820,     0,   817,     0,
       0,   811,  1991,  2042,     0,     0,     0,     0,     0,     0,
     373,   347,     0,     0,   692,     0,     0,  1951,  1563,  1592,
    1570,  1592,  1592,  1559,  1559,  1572,  1560,  1561,  1599,     0,
    1592,  1559,  1564,     0,  1562,  1602,  1602,  1587,     0,  1544,
    1545,  1546,  1547,  1573,  1574,  1548,  1579,  1580,  1549,  1616,
    1559,  1952,     0,     0,   703,     0,  1219,  1256,     0,     0,
       0,   556,     0,  2057,     0,   126,   737,     0,   693,   399,
       0,   126,     0,     0,   163,     0,   621,     0,     0,     0,
       0,     0,     0,   641,   640,     0,     0,     0,   694,     0,
     126,     0,   510,  2057,     0,   455,   455,     0,     0,   933,
     936,     0,     0,     0,  1372,  1374,  1373,     0,  1371,     0,
     316,   314,   315,   690,  1050,     0,     0,     0,     0,   316,
       0,     0,  2057,   316,  2057,     0,  2057,     0,     0,   316,
     316,     0,     0,     0,     0,   622,     0,   778,   776,   775,
     777,     0,     0,     0,     0,     0,  2057,   316,     0,     0,
     759,  1839,     0,     0,  1403,     0,   208,   209,   207,  1312,
     210,  1313,  1309,  1295,     0,   860,     0,   864,     0,   855,
       0,   861,     0,   856,   853,   854,     0,   859,     0,     0,
     456,   458,     0,     0,  2011,  2025,     0,  2048,  2076,  2077,
    2156,  2161,     0,  2184,  2193,     0,   885,   914,   880,     0,
       0,  1356,  1176,  1845,     0,  1403,     0,     0,  1057,  1054,
    1053,  1052,   226,   198,     0,     0,     0,   916,  2155,  1191,
     832,   547,     0,  1702,     0,  1709,  1710,  1591,  1578,  1886,
       0,     0,  1586,  1585,     0,     0,     0,     0,     0,  1568,
    1567,  1566,  1708,  1853,     0,  1565,     0,     0,     0,     0,
    1592,  1592,  1590,  1639,     0,  1569,     0,     0,  1866,     0,
    1872,     0,     0,     0,  1598,     0,  1596,     0,     0,  1675,
       0,     0,     0,     0,     0,     0,     0,     0,  1623,  1624,
    1706,  1839,     0,  1707,  1934,     0,     0,  1584,     0,  1616,
    1910,  1829,     0,     0,     0,     0,  1899,     0,  1837,     0,
       0,  1653,  1835,     0,  1655,     0,     0,     0,  1828,  1826,
    1827,  1820,  1821,  1822,  1823,  1824,  1825,  1833,  1636,     0,
       0,  1788,     0,  1635,     0,  1473,     0,     0,  1932,  1889,
     242,   243,   239,     0,     0,   194,   193,     0,   212,   216,
     217,   188,   215,     0,   211,   196,  1777,  1776,   195,   187,
     184,   182,   199,   201,   202,   185,   183,   236,     0,     0,
    1958,  2292,  2293,  2294,  2295,  2296,  2297,  2298,  2299,  2300,
    2301,  2302,  2303,  2304,  2305,  2306,  2307,  2308,  2309,  2310,
    2311,  2312,  2313,  2314,  2315,  2316,  2317,  2318,  2319,  2320,
    2321,  2322,  2323,  2324,  2325,  2326,  2327,  2328,  2329,  2330,
    2331,  2332,  2333,  2334,  2335,  2336,  2337,  2338,  2339,  2340,
    2341,  2342,  2343,  2344,  2345,  2346,  2347,  2348,  2349,  2350,
    2351,  2352,  2353,  2354,  2355,  2356,  2357,  2358,  2359,  2360,
    2361,  2362,  2363,  2364,  2365,  2366,  2367,  2368,  1891,  1890,
    1922,  1959,  1960,  1961,  1962,  1895,     0,     0,   316,  1274,
       0,  1271,  1904,     0,  1400,     0,  1917,     0,  1283,  1396,
    1395,  1426,  1427,   951,  1394,  1451,  1452,  1447,     0,     0,
       0,  1466,  1464,  1443,  1437,  1442,  1440,     0,  1444,  1619,
    1459,  1384,  1431,  1432,  1435,  1383,     0,  1462,     0,  1356,
    1460,  1436,  1341,     0,     0,  1515,     0,   973,   975,     0,
     974,     0,   977,     0,   986,     0,     0,   972,   991,     0,
     980,   978,     0,     0,     0,     0,     0,     0,   783,     0,
       0,     0,     0,     0,     0,  2184,   230,  1238,     0,     0,
       0,     0,   918,   917,     0,     0,   938,     0,     0,     0,
    1252,   444,     0,   313,     0,     0,     0,     0,     0,     0,
       0,     0,   688,   685,     0,     0,   684,     0,   560,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   596,     0,  1107,
       0,   629,     0,  1007,     0,  1006,     0,     0,     0,  1008,
    1003,  1004,  2156,  2165,  2189,   232,  1024,     0,  1023,  1021,
     961,     0,   962,     0,     0,     0,     0,     0,  2035,   268,
     281,     0,  1106,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   302,     0,   305,   304,     0,     0,
       0,     0,     0,   309,     0,     0,     0,   308,     0,     0,
     528,     0,     0,     0,  1107,     0,   262,     0,     0,     0,
       0,     0,     0,  1037,     0,   149,     0,   145,   148,     0,
       0,     0,     0,   513,   525,     0,   517,   518,   515,   519,
     520,     0,     0,     0,     0,     0,     0,   512,     0,     0,
     619,   618,   624,     0,     0,     0,     0,     0,     0,     0,
       0,  1060,  1059,     0,     0,     0,     0,     0,     0,   727,
       0,     0,     0,     0,     0,     0,     0,   632,   633,     0,
     634,     0,   150,     0,     0,     0,     0,     0,     0,     0,
     206,  1198,  1204,  1269,  1923,  1268,     0,     0,     0,   819,
       0,     0,     0,     0,     0,     0,     0,   821,   822,   823,
     824,     0,     0,     0,     0,     0,   350,   351,   124,   349,
    1951,     0,   716,   691,     0,  1544,     0,  1540,  1536,  1605,
    1606,  1607,  1604,  1617,  1603,     0,  1550,  1608,  1559,  1556,
     704,     0,   706,   709,     0,  1217,   417,     0,     0,   553,
     596,     0,   402,   156,     0,     0,     0,     0,   122,   167,
     169,   400,     0,   168,   170,   172,   173,   174,   171,   175,
     616,   620,     0,   549,     0,     0,     0,     0,     0,   642,
     646,   645,   649,   647,     0,   643,     0,     0,  1532,     0,
     144,     0,   506,   509,     0,     0,     0,   402,   486,   327,
       0,   455,     0,     0,   935,     0,     0,     0,     0,     0,
       0,     0,  1370,     0,  1028,     0,  1245,  2057,   316,     0,
    1026,   161,  1944,     0,   760,     0,     0,     0,     0,     0,
    1030,   756,   153,     0,   316,   316,   552,     0,   316,   155,
       0,     0,     0,   544,   316,   780,  1324,     0,   455,  1297,
    1308,   857,   866,   865,   863,   862,   858,     0,   877,     0,
     454,     0,     0,     0,   891,   892,     0,     0,   890,   907,
     893,     0,   895,   887,   886,   896,   897,     0,     0,   916,
       0,     0,  1353,     0,  1351,     0,  1513,  1355,  1342,  1316,
       0,  1315,  1319,  1321,  1320,  1318,     0,   500,     0,     0,
     874,     0,     0,   316,  1190,     0,   834,   835,   841,     0,
       0,     0,     0,     0,   842,   838,   839,   840,   843,   844,
     845,     0,     0,     0,  1897,  1849,     0,  1850,     0,     0,
       0,  1885,  1881,     0,     0,     0,     0,     0,     0,  1854,
    1857,  1858,  1859,  1856,  1860,  1855,     0,     0,  1861,     0,
       0,     0,     0,     0,  1589,  1588,     0,     0,     0,     0,
       0,     0,     0,  1678,  1711,     0,     0,  1813,     0,  1839,
    1871,     0,     0,  1600,     0,     0,     0,     0,     0,     0,
       0,  1839,  1877,     0,     0,     0,     0,  1775,     0,  1772,
       0,     0,     0,     0,  1896,     0,     0,     0,     0,  1935,
    1620,  1637,  1909,     0,  1898,     0,     0,  1621,  1644,     0,
    1878,  1671,     0,  1676,  1659,     0,  1652,     0,  1657,  1661,
    1640,  1899,  1838,     0,  1836,     0,     0,  1638,     0,  1633,
    1631,  1632,  1625,  1626,  1627,  1628,  1629,  1630,  1634,  1817,
    1815,  1816,     0,     0,     0,  1796,     0,     0,  1656,  2050,
    2085,     0,  1416,  1416,  1416,  1404,  1414,     0,  1527,  1908,
       0,     0,     0,     0,  1712,     0,  1843,  1425,  1841,  1925,
    1914,     0,     0,  1616,     0,  1511,  1892,     0,   786,   787,
     785,  1293,  1277,  1273,  1272,  1903,  1292,     0,  1403,     0,
     949,   950,     0,   954,     0,     0,  1445,  1467,     0,  1458,
       0,  1449,  1450,  1441,  1468,  1463,  1388,  1387,     0,  1530,
       0,     0,  1338,  1331,  1516,     0,  1473,  1358,  1360,  1361,
       0,  1896,   976,     0,  1559,   987,     0,   971,     0,   970,
    1559,     0,   988,     0,  1559,     0,     0,     0,  1135,  1062,
    1111,   784,  1136,  1063,  1112,  1137,  1064,  1239,     0,  1241,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   667,  2057,   316,  1250,  1138,     0,
    1065,   312,  1251,  1113,  1255,   687,   686,     0,     0,  1114,
       0,   561,     0,     0,   566,   567,   568,     0,     0,     0,
     569,     0,  1991,  2042,     0,   574,   581,   586,   576,     0,
     587,   582,     0,     0,     0,     0,     0,     0,   593,   600,
       0,     0,     0,     0,     0,     0,  1001,  1002,  1139,  1068,
       0,  1115,   960,     0,  1069,   157,     0,     0,   255,   269,
     602,   667,  1109,   288,   301,   296,   297,   295,  2057,   316,
    2057,   316,     0,     0,     0,     0,   298,   293,   294,   290,
     303,  1967,  2027,  2166,     0,   606,   608,     0,   613,   306,
    1083,   323,   322,   321,     0,   310,     0,   328,   331,   307,
     286,   289,   287,   283,   267,     0,     0,     0,     0,     0,
       0,     0,  1921,     0,     0,  1032,     0,     0,     0,   147,
    1097,   137,     0,     0,   133,     0,     0,     0,     0,   127,
       0,  1145,  1073,     0,     0,   259,   508,   516,   521,  1077,
     524,  1125,   522,  1151,  1074,     0,  1107,     0,   251,     0,
    1075,     0,  1119,  1147,  1099,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1258,     0,     0,     0,     0,     0,
     316,     0,     0,     0,  1109,  2057,   316,  1146,     0,  1104,
    1133,     0,   336,     0,  1098,     0,     0,   261,  1079,  1127,
       0,     0,   204,   203,   205,     0,     0,     0,     0,     0,
       0,     0,     0,   826,   795,   825,     0,     0,     0,   789,
     372,   345,   346,   348,   355,     0,   715,     0,     0,  1541,
    1537,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1557,   705,     0,     0,     0,     0,  1237,  1237,  1237,  1237,
    1237,  1237,  1237,  1218,  1248,     0,   124,     0,     0,     0,
     555,   595,   602,     0,     0,     0,   401,   405,   409,   410,
     411,     0,     0,     0,     0,   138,   125,     0,   745,     0,
     455,     0,   169,   162,     0,     0,     0,   327,   702,   700,
     699,   701,     0,     0,     0,   720,   698,     0,  1531,  1533,
       0,     0,     0,     0,   500,   404,     0,   458,     0,     0,
     490,     0,     0,     0,   327,     0,     0,   965,     0,   983,
     966,     0,     0,     0,  1012,  1017,  1013,   993,     0,   532,
    1375,  1376,     0,   316,     0,     0,   597,   316,   316,     0,
     316,     0,   316,   316,     0,  1173,   623,     0,   675,     0,
       0,   316,   758,  1840,   878,   457,     0,     0,     0,     0,
     889,     0,   530,   894,     0,   906,   901,   903,     0,   910,
    1354,  1345,  1349,  1348,  1347,  1346,     0,     0,  1343,  1846,
     757,     0,   505,     0,     0,   316,     0,   911,     0,   836,
     837,     0,     0,   846,     0,     0,  1421,  1847,  1848,     0,
       0,     0,     0,  1882,     0,     0,  1750,     0,  1726,  1728,
    1558,  1740,     0,  1571,  1751,  1752,  1730,  1732,     0,  1830,
       0,     0,  1741,  1680,  1681,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1693,  1692,
    1742,  1812,     0,     0,  1869,  1870,  1743,  1601,  1602,  1602,
       0,     0,  1876,     0,     0,     0,  1748,  1753,     0,     0,
       0,     0,  1759,     0,  1780,     0,     0,     0,  1703,  1840,
    1593,  1594,     0,     0,     0,     0,     0,     0,     0,     0,
    1677,  1660,  1654,     0,  1658,  1662,     0,     0,     0,     0,
    1646,  1672,  1642,     0,     0,  1648,     0,  1673,     0,     0,
       0,  1719,  1416,  1416,  1416,  1416,  1413,     0,     0,     0,
       0,  2153,     0,  1494,  1472,  1474,  1481,  1494,  1499,  1721,
    1525,  1722,     0,  1915,     0,  1454,  1425,  1425,  1425,  1718,
       0,     0,     0,  1424,   180,     0,   213,   200,     0,  1275,
    1918,     0,  1428,     0,  1831,   954,   952,   953,  1430,     0,
       0,  1465,  1438,  1340,     0,  1338,  1333,     0,  1334,  1896,
       0,  1330,  1365,     0,     0,  1530,     0,  1364,     0,  1559,
     968,   969,     0,   992,     0,  1134,  1061,  1110,  1237,   921,
     922,     0,   920,     0,     0,     0,   443,   937,     0,     0,
       0,   667,     0,     0,   447,     0,  1253,     0,  1152,  1096,
     563,   564,     0,   575,     0,   584,   583,     0,     0,   571,
       0,     0,     0,     0,   570,   589,   536,   590,   592,     0,
       0,   591,   594,   599,  1107,     0,   630,  1085,     0,  1131,
     995,     0,   963,     0,     0,     0,     0,   417,   282,     0,
       0,     0,   270,   280,     0,     0,   285,     0,   278,   299,
     291,   300,   292,   610,   611,   609,   605,     0,   612,   614,
       0,   325,     0,     0,     0,  1141,     0,  1107,     0,   263,
    1081,     0,  1129,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1142,  1116,     0,     0,   130,   129,
       0,   136,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   337,   318,     0,
     723,     0,     0,     0,   339,     0,     0,     0,     0,  1140,
    1070,   790,     0,     0,   791,   799,     0,     0,   792,     0,
       0,   801,     0,     0,   344,   352,  2109,  1820,  1821,   713,
     718,   710,   712,   714,   711,     0,   717,   667,     0,     0,
       0,  1542,     0,  1610,  1611,  1612,  1613,  1614,  1615,     0,
    1609,  1616,   707,   708,     0,  1237,  1236,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   429,     0,
       0,   423,     0,     0,  1017,   416,   419,   420,     0,     0,
     556,   559,   557,   558,   588,     0,   436,     0,     0,   140,
       0,     0,   141,   139,     0,     0,   327,     0,   165,   400,
       0,     0,   548,   648,   651,   644,     0,   719,   721,   696,
       0,   602,     0,     0,  1325,   496,     0,   486,   482,   484,
     483,   485,     0,   492,   326,     0,   500,   492,     0,   938,
     964,     0,     0,     0,  1010,  1014,  1011,     0,     0,   979,
       0,   994,   957,  1168,  1169,  1166,  1167,     0,     0,  1367,
    1029,     0,   316,  1027,   761,     0,   752,     0,   754,  1031,
     316,   316,   635,     0,   545,     0,     0,     0,   888,   908,
       0,   904,     0,     0,   871,   913,  1352,  1350,   498,     0,
     916,     0,   872,   915,     0,     0,     0,     0,     0,  1851,
    1577,     0,  1884,  1880,     0,  1723,  1852,     0,  1864,  1863,
    1679,  1865,     0,  1698,     0,     0,  1690,  1688,  1689,  1682,
    1683,  1684,  1685,  1686,  1687,  1691,  1874,  1873,  1867,  1868,
    1597,  1595,     0,  1745,  1746,  1747,  1875,  1754,     0,  1982,
    1781,  1758,  1774,  1773,     0,     0,     0,  1761,     0,     0,
    1770,     0,  1814,  1583,  1616,  1622,     0,     0,  1645,  1879,
    1663,     0,     0,     0,  1641,     0,     0,     0,     0,  1650,
    1830,     0,     0,     0,     0,  1799,  1794,  1795,     0,     0,
       0,     0,  1407,  1406,  1412,  1494,  1499,     0,  1390,     0,
    1481,     0,  1493,  1479,  1492,     0,     0,  1505,  1503,     0,
    1505,     0,  1505,     0,  1476,     0,  1495,  1477,  1492,  1524,
    1517,     0,  1916,  1526,     0,  1456,     0,     0,     0,     0,
    1844,     0,  1842,  1713,     0,  1893,  1401,     0,  1429,  1446,
    1439,  2007,  1528,  1339,     0,     0,  1336,  1337,     0,     0,
    1359,  1338,  1362,   989,     0,     0,   981,     0,   927,   928,
     926,   929,     0,     0,     0,   667,     0,     0,   463,     0,
     945,   945,     0,     0,   449,   495,  1017,   670,     0,     0,
       0,   668,   316,  1066,     0,   585,     0,     0,   580,   578,
     577,   579,   537,  1150,  1067,     0,     0,     0,     0,   996,
       0,     0,  1084,     0,   414,     0,   275,  1108,     0,     0,
       0,   274,     0,   316,   316,   607,   324,   329,   330,   333,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   746,   729,     0,     0,   747,   748,     0,     0,
       0,  1034,  1035,  1033,   134,   131,   132,   135,  1094,  1078,
    1126,     0,     0,  1076,     0,  1120,  1091,  1087,     0,     0,
       0,     0,     0,  1149,  1103,  1124,  1148,  1101,  1122,  1100,
    1121,  1102,  1123,  1095,     0,  1535,   726,     0,     0,     0,
     316,   316,   637,  1080,  1128,     0,   793,     0,     0,   794,
     796,   375,     0,   378,   385,   356,   361,  1257,     0,  1257,
       0,   358,   362,  1257,   357,  1257,   354,   689,     0,     0,
       0,  1538,  1543,  1618,  1551,   666,     0,  1228,  1227,  1226,
    1230,  1229,  1232,  1231,  1223,  1222,  1235,  1234,  1221,  1220,
    1225,  1224,     0,   421,     0,   427,   431,   432,   430,   422,
    1017,   455,   494,     0,     0,   679,     0,   554,   402,   433,
       0,   406,   143,   142,     0,     0,     0,   169,     0,     0,
     653,   657,   697,     0,  1534,   631,   327,     0,   402,   500,
       0,   407,   412,   413,     0,   490,     0,   486,     0,     0,
     497,  1215,   501,   502,     0,     0,   967,   984,   985,     0,
       0,  1017,  1016,     0,   539,   316,   598,   316,   316,  1174,
     676,     0,   900,   899,   898,   531,     0,   902,   499,   316,
       0,     0,     0,     0,     0,   848,   827,   847,  1883,  1739,
    1749,  1862,     0,     0,  1699,     0,     0,  1744,  2261,     0,
       0,     0,     0,  1778,  1779,  1760,     0,  2100,  1765,     0,
       0,     0,  1936,  1669,  1667,  1664,     0,  1665,     0,     0,
    1647,  1643,     0,  1649,  1674,  1785,     0,  1801,  1798,  1411,
    1410,  1409,  1408,  1480,  1478,     0,  1483,  1490,     0,  1475,
       0,  1504,  1500,     0,  1501,     0,     0,  1502,     0,     0,
    1490,     0,  1425,     0,     0,  1790,  1716,  1717,  1714,  1425,
    1933,  1616,     0,     0,  1332,  1335,     0,  1366,  1357,   982,
     990,  1243,     0,     0,     0,   445,     0,  1017,     0,     0,
       0,   948,   948,     0,  1017,   494,   672,   671,   674,   669,
     673,  1254,     0,   572,   573,  1086,     0,  1132,  1092,     0,
    1356,     0,   603,   271,   272,   273,   276,   318,   284,   277,
       0,     0,     0,  1082,     0,  1130,  1089,  1143,  1071,  1117,
       0,     0,   735,     0,     0,     0,     0,  1144,  1072,  1118,
       0,  1356,     0,     0,     0,     0,  1263,     0,   317,   725,
     724,   318,   338,  1105,     0,   797,   798,   376,   124,     0,
     353,     0,   383,     0,   381,   380,   382,     0,   369,     0,
       0,     0,     0,     0,     0,  1539,     0,  1048,  1048,     0,
     667,  1233,     0,     0,   418,   494,   462,     0,   424,     0,
       0,     0,     0,     0,     0,     0,   602,     0,     0,     0,
     164,   402,   602,   652,     0,     0,     0,   722,     0,   404,
       0,  1323,   403,     0,     0,   492,     0,   490,     0,   487,
       0,   491,     0,  1208,     0,     0,  1015,     0,  1019,     0,
     978,   955,  1527,     0,   543,  1049,   753,   755,   636,   905,
     912,   316,   828,   829,   830,   831,  1694,     0,     0,     0,
       0,  1755,     0,  1756,  1783,  1782,  1762,  1766,     0,  1763,
    1764,  1666,  1670,  1668,  1651,  1787,     0,  1425,  1520,     0,
    1523,  1482,     0,     0,  1484,     0,     0,  1486,  1488,     0,
       0,     0,     0,     0,  1919,     0,  1453,  1455,     0,  1391,
       0,   214,  1832,  1529,  1363,   906,     0,   316,   945,   494,
     464,  2109,   465,   944,     0,   946,   951,   951,     0,   494,
     667,   565,     0,     0,   256,   601,     0,   320,   332,     0,
    1356,     0,     0,     0,   742,   730,     0,     0,   749,     0,
     252,  1088,     0,     0,     0,     0,     0,   316,   800,   355,
       0,   379,   388,     0,   386,   359,   364,     0,   368,   366,
     365,   360,   363,  1048,     0,  1045,  1044,   665,     0,   453,
     425,     0,   473,     0,     0,   680,     0,     0,     0,   442,
     441,   438,   437,   439,   440,   435,   434,   627,   739,   327,
    1215,   615,   654,   655,   650,     0,     0,     0,   486,   482,
     408,   417,   391,     0,   492,   488,   489,     0,     0,     0,
    1265,     0,   939,  1018,     0,     0,     0,   538,     0,     0,
     542,   533,   873,  1695,     0,  1696,     0,     0,     0,  1768,
    1767,     0,  1804,  1525,     0,     0,  1519,     0,  1491,  1507,
       0,  1487,  1485,  1496,     0,  1498,  1713,  1789,  1791,     0,
    1715,   923,     0,   924,   948,   468,     0,   947,   954,   954,
     455,   667,   446,  1093,     0,   604,     0,   279,     0,   264,
    1090,     0,   733,     0,   744,   742,     0,     0,     0,  1259,
       0,  1260,  1261,  1264,   340,   343,   374,   384,     0,   367,
    1043,  1047,  1046,     0,     0,   426,   459,   460,   461,     0,
     428,   469,   470,     0,   677,     0,   682,     0,     0,     0,
       0,     0,  1209,     0,     0,  1215,   490,   486,   415,   481,
     389,     0,  1212,     0,   327,     0,  1017,  1020,  1172,   541,
     540,  1697,  1771,  1757,  1784,  1769,  1800,     0,     0,     0,
    1518,  1521,     0,  1489,     0,  1497,     0,     0,     0,   951,
       0,   667,     0,   942,   941,   462,   448,  1356,   319,     0,
       0,     0,   740,   743,   731,   744,   751,   750,  1356,     0,
     387,     0,   452,     0,     0,     0,   471,     0,   472,   493,
       0,   681,     0,   602,   738,     0,     0,   656,     0,  1210,
     492,   490,  1213,  1214,   492,   940,   956,  1171,  1170,  1403,
    2223,  2007,  2195,     0,  1802,  1805,  1803,  1797,     0,  1506,
    1792,  1793,   316,   954,     0,   450,   466,   473,   257,  1356,
       0,     0,   732,   253,  1262,   657,   478,     0,   477,     0,
     475,   474,   678,   683,   628,   728,  1215,   660,   392,   492,
    1527,  1154,  1403,  1153,  1155,  1163,  1160,  1162,  1161,  1159,
       0,  1809,  1808,  1807,  1811,  1810,  1522,   925,   943,     0,
     667,   265,   734,   741,     0,   476,   480,   479,  1211,   662,
       0,   658,   661,   663,   664,   390,   930,     0,  1164,  1158,
    1390,  1377,     0,   467,   451,     0,   638,     0,  1156,  1403,
    1806,     0,   659,  1157,     0,   660,     0,   639
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,    49,    50,    51,    52,  1224,  2163,  2037,  2845,  2846,
      53,    54,  1302,    55,    56,    57,    58,    59,    60,    61,
    1240,    62,    63,   900,  1454,  2173,    64,  1906,   700,   701,
     702,  1731,  1732,  2101,  1733,  1721,  1139,  1540,  1259,   675,
     676,  1226,  1260,    66,    67,  1133,  1712,    68,    69,    70,
    1286,  1287,  1234,  1493,  3745,  4347,  2675,  2017,  2882,  2676,
    2677,    71,  1352,  1353,    72,    73,  2793,  1392,  2128,  3314,
    3315,  3776,   530,  2125,  4048,  4049,  3762,  3763,  4055,  4233,
    4234,  2174,  1450,  2876,  3407,  2836,  3840,  2837,  3841,  2838,
    3842,  2824,  3365,  3366,  3367,  2839,  3819,  4265,  2840,  1921,
    4375,  2208,  1562,  1560,  4252,  3637,  3638,  4431,  4380,  4381,
    4382,  4510,  3847,  2880,  3413,  3850,  4078,  2574,   614,  1474,
    2952,   615,  2210,   561,   616,  2175,    79,  2202,  1322,  1323,
    2045,  3319,  2933,    80,   919,  3185,  4124,  4300,  4301,    81,
     208,    82,  1458,    83,    84,  2159,  2830,    85,  1938,  2591,
      86,    87,  2618,  2619,  2620,    88,    89,  3207,  4001,  1288,
    2664,  2665,  2666,  2667,  3228,    90,  1456,  1328,  2182,    91,
      92,    93,    94,    95,  2089,    96,    97,  2176,  1466,  2194,
    2195,  3831,  4094,  4274,  4096,  4550,  4551,  4070,  3164,  3651,
      99,   100,  3814,  3815,  4387,   101,  1936,   102,   103,   104,
    1434,  2151,  2152,  3320,  1394,  2131,  2132,  3396,  3397,   105,
    2753,   106,  3702,  3703,   562,  4390,  4354,  4444,   107,   108,
    3706,  3707,   109,   110,   111,   112,   113,   608,   965,   966,
    1216,   114,  1828,   115,   873,  2784,   116,  1030,  2332,  3886,
     117,   639,   979,   980,  2177,   119,   648,  2310,   650,  1575,
    2935,  2936,  3464,  2278,   785,   120,   121,  2289,  2313,   122,
    1227,  1912,  1913,  3632,  2178,   563,  1480,  2213,  2569,  4291,
    3639,  3981,  4196,  2503,  3118,   124,   564,  1264,  1981,  2216,
    2888,  1884,  1885,  1886,  3428,  1887,  2890,  1888,  1210,  1889,
    2895,  2896,  2897,  3424,  3432,  4118,  4119,   125,  1262,  1979,
     126,   127,   128,  1299,   810,   129,   576,   577,   130,  4245,
     131,   931,   132,   667,  1589,   133,   134,  1994,  3214,   135,
     136,   137,  4523,  4557,  4558,  4559,  3437,  4479,   138,  4525,
    1009,   140,   141,   142,   178,   839,   840,   841,  2179,  4113,
     144,   145,  2155,  2823,  3347,   146,   147,  1907,  2559,   148,
     149,   150,   151,  1438,   152,   153,   154,   155,  1371,   156,
    1168,  1169,   157,   158,   525,   718,  1172,  1180,   159,   618,
     973,   974,   975,  1542,   160,  1012,  2301,   619,   968,   162,
     620,  2522,  3127,  3128,  3131,   621,  2519,   165,  1581,  2295,
    2298,   622,  2526,  2527,  2528,  2529,  2530,  3133,   623,   641,
     922,  2221,   624,  1102,   170,   171,   172,   727,   722,   723,
     174,  1705,  2465,   656,  1187,   688,   735,  3103,  1841,  1842,
    1864,  1865,  1196,  1197,  1854,  1856,  2505,  1857,  2513,  1847,
    3595,  3955,  1860,  1861,  1199,  1200,  1201,  1869,   175,  2468,
    3084,  3085,  3086,  3572,  3573,  3587,  3583,  3942,  4167,  3087,
    1007,  1207,  3088,  4158,  4159,  4316,  3590,  3095,  3125,  2867,
    2868,  2869,  1890,  2138,  1419,  1103,  1420,  2149,  1104,  1625,
    1422,  1105,  1106,  1107,  1425,  1108,  1109,  1110,  1111,  1608,
    1667,  1112,  1113,  1644,  2146,  2147,  1531,  2372,  1115,  1116,
    1117,  3090,  1118,  3530,  3910,  3899,  2398,  2399,  1728,  3526,
    3030,  1701,  2455,  4179,  4327,  4328,  3071,  3556,  3927,  4157,
    4419,  4484,  4485,  1119,  2452,  1697,   812,  1120,  3322,  1699,
    2392,  2477,  2478,  1584,  1606,  2338,  2356,  2357,  2369,  2991,
    2376,  2381,  3014,  3015,  2393,  2421,  1121,  2341,  2342,  2974,
    1610,  1122,  1162,  1163,  1603,  2416,  1175,  1176,   720,  1123,
    1124,  1125,  1576,   711,  4163,   520,   775,  2691,  1819,   843,
     653,  1126,  1127,  1128,  1129,   940,   941,  1292,   521,   769,
     789,  2668,   522,   523,   771,  1824
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -4005
static const int yypact[] =
{
    5171,  1256,  9555, -4005, -4005,  1256, -4005, 54497,    -3,   695,
    1016,   165, 11798, 54914, 62837,   731,   288, 11941,  1256, 62837,
    2699, 40319, 51578, 62837,  1118,   813, 40319, 62837, 63254,   964,
    1046,   732, 63671, 55331, 50327,  1247, 62837,  1099,   853, 64088,
   55748,   955, 56165,   813, 37418,   156,   952, 64505,  1780,  1437,
    1008, -4005, -4005, -4005, -4005, -4005, -4005, -4005, -4005, -4005,
   -4005, -4005, -4005, -4005, -4005, -4005, -4005, -4005, -4005, -4005,
   -4005, -4005, -4005, -4005, -4005, -4005, -4005, -4005, -4005, -4005,
   -4005, -4005, -4005, -4005, -4005, -4005, -4005, -4005, -4005, -4005,
   -4005, -4005, -4005, -4005, -4005, -4005, -4005, -4005, -4005, -4005,
   -4005, -4005, -4005, -4005, -4005, -4005, -4005, -4005, -4005, -4005,
   -4005, -4005, -4005, -4005, -4005, -4005, -4005, -4005, -4005, -4005,
   -4005, -4005, -4005, -4005, -4005, -4005, -4005, -4005, -4005, -4005,
   -4005, -4005, -4005, -4005, -4005, -4005, -4005, -4005, -4005, -4005,
   -4005, -4005, -4005, -4005, -4005, -4005, -4005, -4005, -4005, -4005,
   -4005, -4005, -4005, -4005, -4005, -4005, -4005, -4005,    -3, -4005,
   -4005, -4005, -4005, -4005, -4005, -4005, -4005, -4005, -4005,   202,
   -4005,   148,   306,  1382,   654,  1083, -4005, -4005, -4005, 45740,
   62837, 62837, 62837,  1343, 62837,  1294, 62837,   419, 45740, 46157,
   56582,  1418,  1282, 33995, -4005, 44072, 62837, 62837, 64922, 62837,
    1329, 52829, 62837,  1397, 62837, 62837, 46574, 65339,  1543,  1040,
   -4005, -4005, -4005, -4005, -4005, -4005, -4005, -4005, -4005, -4005,
   -4005, -4005, -4005, -4005, -4005, -4005, -4005, -4005, -4005, -4005,
   -4005, -4005, -4005, -4005, -4005, -4005, -4005, -4005, -4005, -4005,
   -4005, -4005, -4005, -4005, -4005, -4005, -4005, -4005, -4005, -4005,
   -4005, -4005, -4005, -4005, -4005, -4005, -4005, -4005, -4005, -4005,
   -4005, -4005, -4005, -4005, -4005, -4005, -4005, -4005, -4005, -4005,
   -4005, -4005, -4005, -4005, -4005, -4005, -4005, -4005, -4005, -4005,
   -4005, -4005, -4005, -4005, -4005, -4005, -4005, -4005, -4005, -4005,
   -4005, -4005, -4005, -4005, -4005, -4005, -4005, -4005, -4005, -4005,
   -4005, -4005, -4005, -4005, -4005, -4005, -4005, -4005, -4005, -4005,
   -4005, -4005, -4005, -4005, -4005, -4005, -4005, -4005, -4005, -4005,
   -4005, -4005, -4005, -4005, -4005, -4005, -4005, -4005, -4005, -4005,
   -4005, -4005, -4005, -4005, -4005, -4005, -4005, -4005, -4005, -4005,
   -4005, -4005, -4005, -4005, -4005, -4005, -4005, -4005, -4005, -4005,
   -4005, -4005, -4005, -4005, -4005, -4005, -4005, -4005, -4005, -4005,
   -4005, -4005, -4005, -4005, -4005, -4005, -4005, -4005, -4005, -4005,
   -4005, -4005, -4005, -4005, -4005, -4005, -4005, -4005, -4005, -4005,
   -4005, -4005, -4005, -4005, -4005, -4005, -4005, -4005, -4005, -4005,
   -4005, -4005, -4005, -4005, -4005, -4005, -4005, -4005, -4005, -4005,
   -4005, -4005, -4005, -4005, -4005, -4005, -4005, -4005, -4005, -4005,
   -4005, -4005, -4005, -4005, -4005, -4005, -4005, -4005, -4005, -4005,
   -4005, -4005, -4005, -4005, -4005, -4005, -4005, -4005, -4005, -4005,
   -4005, -4005, -4005, -4005, -4005, -4005, -4005, -4005, -4005, -4005,
   -4005, -4005, -4005, -4005, -4005, -4005, -4005, -4005, -4005, -4005,
   -4005, -4005, -4005, -4005, -4005, -4005, -4005, -4005, -4005, -4005,
   -4005, -4005, -4005, -4005, -4005, -4005, -4005, -4005, -4005, -4005,
   -4005, -4005, -4005, -4005, -4005, -4005, -4005, -4005, -4005, -4005,
   -4005, -4005, -4005, -4005, -4005, -4005, -4005, -4005, -4005, -4005,
   -4005, -4005, -4005, -4005, -4005, -4005, -4005, -4005, -4005, -4005,
   -4005, -4005, -4005, -4005, -4005, -4005, -4005, -4005, -4005, -4005,
   -4005, -4005, -4005, -4005, -4005, -4005, -4005, -4005, -4005, -4005,
   -4005, -4005, -4005, -4005, -4005, 62837, 12631,  1118, -4005, -4005,
   62837,  1438, 45740, 62837,  1364, 62837,  1443, 62837, -4005, 62837,
    1490, 65756,   702,  1240, 46157,  1653, 34426,  1558, 46157, 66173,
   62837, 62837, -4005, -4005,  1564, 62837, 62837, -4005,  1674, 46991,
    1476,  1685,  1832,  1760,   133, -4005, 56999, -4005, -4005, -4005,
   -4005, -4005, -4005, -4005, -4005, 44489,   288, -4005, -4005, 47408,
   62837,  1776, -4005, -4005, 66590, -4005,  1603, -4005,   721, 47825,
   48242,  1897,  1590, 34857,  1943, 48659, 67007, -4005, -4005, 67424,
   -4005, 67841,  1684, 68258, -4005, 49076, -4005,  1843, 68675, -4005,
    1613,  1738,  2249, 30596, -4005, -4005, -4005,    -3, -4005, -4005,
   -4005, -4005, -4005, -4005, -4005, -4005,   333,   985,   205,   179,
     282, -4005, -4005,   184,   231,   250,   333,  2052,  2052, -4005,
   62837, -4005, -4005,   985,    40,  1645,  1645,  1645,  1850,  1080,
   -4005,  1645, -4005, -4005, -4005, -4005, 56165, -4005,  1676,  1118,
    1688,  2045,  1739, 62837, -4005, 62837, -4005, 62837, 62837, -4005,
   -4005,  2097,  1743,  1948,  1727, -4005, -4005, -4005,  1919,  1930,
    1900,   109,  1118,  1836, -4005,  2064, -4005,  1970, 21120,  1118,
   57416, 69092,   284, 44489,  1118, 57833,  1815,   996,  1993, -4005,
   -4005, -4005,   101, -4005,  2187,  1819,  2059,  1727,  1040, 31868,
   -4005,  1830,   -54, 56165, -4005, -4005, -4005,   381,  2109, 21555,
   -4005, 62837,  1829, -4005,  1838,  1842,  1851,  1382, -4005,  5171,
   62837,  1183,  1183,  2261,  1183,  1399,  1790, -4005,  2096, -4005,
    2135,  2119, 56165,   952,   199, -4005, -4005, -4005, -4005, -4005,
   -4005, -4005, -4005, -4005, -4005, -4005, -4005, -4005, -4005, -4005,
   -4005, -4005, -4005, -4005, -4005, -4005, -4005,  1878,   -54, -4005,
     206, -4005,  1368,  1885,  1501,  1436, -4005, -4005,   480, 62837,
    1998,   226,    19,  1925, 58250,  5749,  1898, -4005,   420, -4005,
   -4005, -4005, -4005,  2161,  2207,  4467,   327, 58667, -4005, 62837,
   62837, -4005, -4005, -4005, -4005, -4005, -4005, -4005, -4005, -4005,
    1907, -4005, -4005,  1910,  2181,  1048,  2123,   683,  2244,  7852,
    1257, 59084, 62837,  2196,  2245,  5186,  1581,   741,  2136,  1103,
    2255,    46,  2280,  5459, 62837, -4005,  2211,  2311,    53, -4005,
     308, -4005,  2048,  2184,    64, 45740,  2003, -4005, -4005, 62837,
   -4005, -4005, -4005,  2087, -4005,   748, 45740, -4005,  2222,  2066,
   35288, -4005, 62837, -4005, -4005, -4005, -4005, -4005,  2155, 62837,
   -4005, -4005,  2277, 62837, -4005,  1645,  2202,  2057,  2421, 77805,
     139, 62837,  2095,  2472, 62837,  2269,  2095,  2107, 69509, -4005,
   -4005,  2095, -4005, -4005, 62837, 62837,  2082,  1401,  2095,  2288,
    2493,  2494,  2165,  2279,   930,   292,   157,  2409,  2095,  2168,
   62837, 69926, 62837,  2174, 62837,  2484, 45740, 62837, -4005,  2295,
   -4005, -4005,  1060, -4005, -4005, -4005, -4005,  2434,  1878,   216,
    2453,  2158,  2457, -4005, -4005,  2204, -4005,  2477,  1898,  2478,
   -4005,  2191, 70343, -4005, 70760, 71177,  2479,  1907, 46157,  2502,
    2191,  2504,  2393,  2518,   216,  2524, -4005,  1015,  2529,  2424,
    2540,  1569,  2191, 44906,  2547,   168, -4005, 23295, -4005,  2337,
   -4005,   952, -4005,  1447, -4005, 39902, -4005,  2249,   985, -4005,
   62837,   985, 62837,   985, 62837,   985, 62837,   985, 62837, 62837,
   62837,   985, -4005, -4005, -4005, 62837,  2253, 62837, 62837, -4005,
   -4005, -4005, 51995, 46157, 52412, -4005, -4005,    88,  1118, -4005,
   -4005, 77805,  2659, 46157,  2484,  2543,  2543,  2543, -4005, -4005,
   -4005,  2483, 62837,  2548,  2550, 51995, 46157, -4005, 71594, 44489,
    2450,  2266, -4005, -4005, -4005, -4005, -4005,  1651,  2700,   201,
    2701, 23295,  2271,   194,   194,  2274,  2565, -4005, -4005, -4005,
     265,  2278,  2281, -4005,   213,   213,  2442,  2282,  2283, -4005,
     268,  2284,  2711,  2717,   272,  2287,  2290,  2293,  1691,   194,
   23295, -4005,  2294,   213,  2296,  2297,  2298,  2727,  2299, -4005,
    2732,  2301,   317,   348,  2302,  2305, -4005,  2282, -4005,   266,
    2307,  2308,  2310,  2312,  2314,  2315,  2316,  2318, 23295, 23295,
   -4005, 20250,   -54,  1118, -4005, -4005, -4005, -4005, -4005, -4005,
   -4005,   154, -4005,   275,  4411, -4005,  2346, -4005, -4005,  2495,
   23295, -4005, -4005,  2566,  2320, -4005,   280, -4005, -4005, -4005,
     -54, -4005, -4005,   247,  2323, -4005,  1659, -4005, -4005, -4005,
   -4005, -4005, -4005, 42821,  2734, -4005,   833,  1118,   308,  1423,
    2672, 39068, 39485, -4005, -4005,  2557, -4005, 62837, -4005, -4005,
   23295, 37001, -4005,   -54,   207, -4005, -4005, -4005,  1485, -4005,
   -4005, -4005,    -3, -4005, 10454, -4005,  1588,  1829, 62837, 62837,
    2738, -4005, -4005, -4005,  1838, -4005, -4005,  1382,  1382, 23295,
    1382,   200,  1345, 21990, 23295,  2623,  2525,  1063,  1410,  2627,
   -4005,  2530,  1399,  1790, 56165, 62837, 72011,  2452, -4005, 37835,
    1524,   -54,  2422,  2426,  2466, 41153,  2345,  2427,  2428,  2474,
    2430,  2432, 72428, -4005, -4005, -4005, -4005,   778,   891,  1290,
    2435,   186,   836,  2719, -4005,  1173,  2482, -4005, -4005, -4005,
    4144, 62837,  2658,  5661,  2553,   327,  2480, -4005, -4005,  2591,
    2446,  2449,  2559,   327,   248, 72845, -4005, -4005, -4005, -4005,
   -4005, -4005,  3800, 19003, -4005,  2455,  2431,  2461, 62837, 49493,
    1664,  2556,  1115,  1725,   610, 62837,  2640,  2574, 62837,  2385,
    2463,  2464,  2662,  2388,  1089,  2749,  2389, -4005, -4005, -4005,
     383,  2568, -4005,  2663,  2695,  6491,  2460,  2462, 76993,  1009,
   35719,  2739,  1408,  2485, -4005,  1408, 62837,  2487,  2488, 62837,
     327, -4005,  2790,   327,   327,  1340,  2794,  2489,   391,  1180,
    2095,  2389,  2039, -4005,  2490,  2497,   264, -4005,  2599, -4005,
   -4005,  1074,  2506, 56165,   178,  1456,  2389,  2499,  2500,  2388,
    2388, 62837, 62837, 62837, 62837, 62837,   191,  2823,  2824,  2503,
     195,  2549,  2425, -4005, 43238,  2505, 69092, -4005, -4005, 62837,
    2507,  1509,  2389,  1254,  1376, -4005, -4005, -4005,  1040, -4005,
   62837, -4005, 62837,  1878, 77805,  2634, -4005,  2469, -4005,  1898,
     327, -4005, 62837, 62837,  1907,   988,  1100,  2635, 62837,  2693,
    2491, -4005,   233, 38243, -4005,  2082,  2451, -4005, -4005,  2498,
   -4005,  2498,  2498,  2454,  2454,  2456, -4005, -4005, -4005,  1691,
    2498,  2454, -4005, 78617, -4005,  1586,  1625, -4005,  2858,  2863,
   -4005, -4005, -4005, -4005, -4005, -4005, -4005, -4005, -4005,   749,
    1583, -4005, 62837, 41153, -4005,  2875, -4005, -4005, 77805,  2645,
    2761, -4005, 62837,  2661,  2467, -4005,  2802,  2527, -4005, -4005,
      58, -4005,  2774, 46157,   825,  1118,  2520, 62837,  2696, 62837,
   62837, 62837, 62837, -4005, -4005,  2664,   777,   147, -4005, 43238,
   -4005, 62837,  2039,  2678,  2884,    54,  1645, 62837,  2769, -4005,
   62837,  2481,  2887,  2720, -4005,  1794, -4005,  2605, -4005, 45740,
     216, -4005, -4005, -4005, -4005, 77805, 62837, 73262, 45740,   216,
   46157, 46157,  2791,   168,  2792,  2552,  2793,  2554, 35719,   216,
     169, 46157, 62837, 62837, 62837, -4005, 62837, -4005, -4005, -4005,
   -4005, 62837, 62837, 46157, 43238,  2795,  2797,   216, 62837, 62837,
   -4005, 10454,  1592, 62837,  2249, 43655, -4005, -4005, -4005, -4005,
   -4005, -4005, -4005, -4005, 62837, -4005, 62837, -4005, 62837, -4005,
   62837, -4005, 62837, -4005, -4005, -4005, 62837, -4005, 62837,  1649,
   -4005, -4005,  1704,   158, 62837, 62837,   709, 45740, 62837,  2684,
   62837, 62837, 62837, 62837, 62837,  2575,  2323,   -30, -4005,   911,
   56165,  2697, -4005, -4005,  1712,  1780,  1096, 62837, -4005, -4005,
   -4005, -4005, -4005, -4005, 52412, 51578,  2786,    89, 62837, -4005,
   -4005,  2441, 23295,   -54, 20685, -4005, -4005, -4005,  2513, 10454,
    2544, 23295, -4005, -4005, 23295,  2516,  2052,  2052, 23295, -4005,
   -4005, -4005, -4005,  1061,  2052, -4005, 23295, 23295,  2052,  2052,
    2498,  2498, -4005,  3138, 23295, -4005, 35719, 23295, 25905, 18151,
   23295,  2582,  2523,  2052, -4005,  2052, -4005, 23295, 19815, -4005,
   23295,  2714, 26769, 23295,  1423,  2715, 23295,  1423,  2944,  2944,
    1637,  4540,  2515,   -54, -4005,  2632,  2052, -4005,  2052,   865,
   -4005,   214, 77805, 23295, 41153,  2604,   204, 62837, 23295,  2526,
    1511, -4005, 23295,   743, -4005,  2531, 23295,  2609, 23295, 23295,
   23295, 23295, 23295, 23295, 23295, 23295, 23295, -4005, 27617,   229,
    2809,  2820,    17,  1636, 59501,  2818, 21120, 17715, -4005,   260,
   -4005, -4005, -4005, 62837,  2734, -4005, -4005,  2611, -4005, -4005,
   -4005, -4005, -4005,   291, -4005, -4005, -4005, -4005, -4005, -4005,
   -4005,  2534, -4005, -4005, -4005, -4005,  2534, -4005,  2541,  2937,
   -4005, -4005, -4005, -4005, -4005, -4005, -4005, -4005, -4005, -4005,
   -4005, -4005, -4005, -4005, -4005, -4005, -4005, -4005, -4005, -4005,
   -4005, -4005, -4005, -4005, -4005, -4005, -4005, -4005, -4005, -4005,
   -4005, -4005, -4005, -4005, -4005, -4005, -4005, -4005, -4005, -4005,
   -4005, -4005, -4005, -4005, -4005, -4005, -4005, -4005, -4005, -4005,
   -4005, -4005, -4005, -4005, -4005, -4005, -4005, -4005, -4005, -4005,
   -4005, -4005, -4005, -4005, -4005, -4005, -4005, -4005, -4005, -4005,
   -4005, -4005, -4005, -4005, -4005, -4005, -4005, -4005, -4005, -4005,
   -4005, -4005, -4005, -4005, -4005, -4005,  2811,  2814,   216, 62837,
     381, 53246, -4005, 21555, -4005,  1734, -4005,  2545, -4005,  2798,
   -4005,  2542, -4005,  8581,  2798, -4005, -4005,   331,  2655,  2787,
    2740, -4005, -4005, -4005,  2555, 10454, -4005,  1521, 10454,  1638,
   -4005, -4005, -4005, -4005, -4005, -4005,  1136, -4005, 62837,  2697,
    2623,  1410,  2612,   131, 62837, -4005, 32292,  2736, -4005,  2950,
   -4005, 78617, -4005,  2563, -4005, 78211, 75764, -4005, -4005,   943,
   -4005,  1167,  2642,  2643,  2690, 46157, 62837, 62837, -4005, 41153,
   46157, 62837, 62837, 46157, 62837, 62837, -4005,  2930,    61, 51578,
    2698, 50744, -4005, -4005,  2573, 62837,  2630,  2817,  2822,  1166,
   -4005, -4005, 73679, -4005,  2776, 46157, 62837, 62837, 23295,  2779,
   62837, 62837, -4005,   340,  2656,  2665, -4005, 62837,  2666, 45740,
    2585, 62837, 62837, 62837,  2660,   780, 45740,  2629, 36150, 62837,
   62837, 62837, 62837,  2712, 62837, 62837,  2831,   782, 56165,   183,
    1519,  2389,  2799, -4005,  1139, -4005, 46157, 62837,  2782, -4005,
   -4005, -4005, 59918,  2995,  2702, -4005, -4005, 74096, -4005, -4005,
   -4005,  1763, -4005, 46157, 46157, 62837,  6893, 62837,  1178, -4005,
   -4005, 77805, -4005, 62837, 62837, 62837, 62837, 53663, 74513, 74930,
    1207,  1248, 62837, 54080, -4005, 62837, -4005, -4005, 41570, 46157,
   62837,   718, 41153, -4005, 62837,  2785,   278, -4005, 62837,  3677,
   -4005,  2677,  2687, 62837,   187,  1695,  2389, 62837, 62837,  2601,
    1782,  2680,  2729, -4005, 62837, -4005, 46157,   788, -4005,  2747,
   46157, 62837,  9950, -4005, -4005,   327, -4005, -4005, -4005, -4005,
   -4005, 62837, 62837,   327, 62837,   327,  1276, -4005, 46157, 62837,
   -4005, -4005, -4005, 62837,  7265, 62837, 62837, 62837, 62837, 46157,
   62837, -4005, -4005,  1108,   764,    85,  1196,  2750, 62837,  2879,
   62837, 75347, 46157, 62837, 62837, 62837,   973, -4005, -4005,  2728,
   -4005, 46157,   788,  7363, 62837, 62837,  2691,  2694,   172,  2766,
   -4005, -4005, -4005, -4005, -4005, -4005,  2861,  3029, 62837, -4005,
    2868,  2869,  2682,  2683,  2873,   269, 62837, -4005, -4005, -4005,
   -4005, 62837,  2874,   269,  2819,   686, -4005, -4005,  2095, -4005,
    2646,  1787, -4005, -4005, 23295,  3041, 77805,  2638,  2639,  2716,
    2718,  2726, -4005,  2651,  2733,  2052, -4005, -4005,  1793, -4005,
   -4005,  1802, -4005,  2668,   777,  1421, -4005, 41153, 62837,   757,
     793,  2939, 49910,  1774,  2931, 62837,  2704, 62837,  1774, 62837,
   -4005,  1858, 51578, -4005, -4005, -4005, -4005, -4005, -4005, -4005,
   -4005, -4005,  2951, -4005,  1118,  2082,  2082,  2082,  2082, -4005,
   -4005, -4005, -4005,  2847,  1585, -4005,  2667,  2082, 62837,  2784,
    1774,  2674, -4005,  2039,  2967,   533, 62837, 49910,  1853,  2708,
    3081,  1645,  1118,  2865, -4005, 19409,  4863,  2867, 44489,  2949,
    2955,  2971, -4005,  1878, -4005,  3089, -4005,  2986,   216,  1898,
   -4005,  2191, -4005, 62837, -4005, 62837, 62837, 62837, 62837,  1907,
   -4005, -4005,  2191,  2872,   216,   216, -4005,  2876,   216,  2191,
    2800,  2977, 44489, -4005,   168, -4005, -4005, 23295,  1645, -4005,
   -4005, -4005, -4005, -4005, -4005, -4005, -4005,  1807, -4005, 62837,
   -4005,  2953,  2956,  2957,  2692,  2706,  2723, 62837,  2709, -4005,
    2692,   327,  2692,  2323,  2323,  2692,  2706, 45323,  3116,  2978,
     192,   666, -4005,   768,  1030,  2912, -4005, -4005, -4005, -4005,
   77805, -4005, -4005, -4005, -4005, -4005, 62837,  2741,   316,  2888,
    2713, 45323,  3091,   216, -4005, 45740, -4005, -4005, -4005,  2781,
    2805, 45740,  2897,  2764, -4005, -4005, -4005, -4005, -4005, -4005,
   -4005,  2959, 62837,  1811, -4005, -4005,  1404, -4005,  1406, 23295,
   23295,   137, -4005,  8965,  1831, 23295,  2722,  2724,  1849, -4005,
   -4005, -4005, -4005, -4005, -4005, -4005,  2725,  3008, -4005,  2730,
    1857,  1866,  2735,  2742, -4005, -4005,  3639,  2744,  9247,  2745,
   25905, 25905,   786, -4005, -4005, 25905,  2746, -4005,  1891,  8614,
    2731,  2748,  2751, -4005,  2753,  2756,  9321, 22425, 23295, 22425,
   22425,  9395,  2731,  2757,  1917, 41153,  2895,  9927,  1921, -4005,
   23295, 41153,  3977, 23295, -4005, 23295, 62837,  2758,  2759, -4005,
   -4005,  3138, -4005,  2752, -4005, 25905, 25905, -4005,  2803, 20250,
   -4005, -4005,  3014, -4005, -4005,  1549, -4005,  2762, -4005, -4005,
    4131,   240, 23295,  2526, 23295,  2816, 35719, 10884, 23295,  3337,
    3923,  3923,   395,   395,   283,   283,   283,  1573,  1636, -4005,
   -4005, -4005,  2763,  2765,  2767,  2917,  2299, 23295, -4005,  1944,
    1995, 62837,  2115,  2551,  2954, -4005, -4005, 28900,  2789, -4005,
   23295, 23295, 23295,  2760, -4005,  3166, 10454,   673, -4005,  3172,
   -4005,  1040,  2052,   865, 39902, -4005, -4005, 23295, -4005, -4005,
   -4005,  1838, -4005, -4005, -4005, -4005, -4005, 62837,  1780, 23295,
   -4005, -4005,   967,  1537, 23295,  1521, -4005, -4005,  2808, -4005,
   23295, -4005, -4005, -4005,  2323, -4005, -4005, -4005, 28900,  2810,
    2801, 31444,  2896, -4005, -4005, 62837,   352, -4005, -4005, -4005,
    2788, -4005, -4005, 75764,  1583, -4005, 78211, -4005, 78211, -4005,
    1583,  3157, -4005, 75764,  1568, 46157, 62837, 62837, -4005, -4005,
   -4005, -4005, -4005, -4005, -4005, -4005, -4005, -4005,  2997, -4005,
   46157, 46157,  2962, 62837,  2960,  2964, 23295,   772, 62837,  2773,
    2780,  1232,  3042, 62837, -4005,  3083,   216, -4005, -4005,  2870,
   -4005, 10454, -4005, -4005, -4005, -4005, -4005, 46157, 62837, -4005,
   44489, -4005,  1878, 77805, -4005, -4005, -4005, 62837,  2832, 62837,
   -4005, 62837, 62837, 62837,  1907, -4005, -4005, -4005, -4005,  1163,
   -4005, -4005, 62837, 62837,   729,  2878,  2880, 62837, -4005,  1208,
    2599,  8064, 62837, 62837, 62837,  3037, -4005, -4005, -4005, -4005,
    2999, -4005, -4005, 75764, -4005,  2191,    95,  2882,  2389, -4005,
    2984, -4005,   188, -4005, -4005, -4005, -4005, -4005,  3107,   216,
    3108,   216, 62837, 62837, 62837, 62837, -4005, -4005, -4005, -4005,
   -4005, 41153, 41153, 41153,  1947, -4005, -4005,  1118, -4005, -4005,
   -4005, -4005, -4005, -4005,  3069, -4005,  1963, -4005,   -42, -4005,
   -4005, -4005, -4005, -4005, -4005, 46157, 62837,  8418, 62837, 62837,
   62837,  1632, -4005,  1125, 77805, -4005, 77399, 46157, 62837, -4005,
   -4005, -4005,  3039,  2979, -4005,   798,  2983, 46157,  2877, -4005,
    2894, -4005, -4005,  2900,  1828,  2389,  2039, -4005, -4005, -4005,
   -4005, -4005, -4005, -4005, -4005,   914,   238,  1834,  2389,  2901,
   -4005,  2902, -4005, -4005, -4005,  3035,  3043,  3044,  2906,  2909,
    2942,  2910,  2911,  2958, -4005,  2914,  2961,  2915,  2963,  2919,
     216, 77805,  3040,  1118,  2945,  3144,   216, -4005,  2922, -4005,
   -4005,  3246, -4005, 62837, -4005,  2925,  2056,  2389, -4005, -4005,
   46157, 62837, -4005, -4005, -4005,   269, 77805,  3092,   269,   269,
   62837, 62837,   269, -4005, -4005, -4005,  3093,  3094,   269, -4005,
   -4005, -4005, -4005,  2202,  2852, 33564, -4005,  3287,  4908,  2856,
    2639,  2854,  2052,   181,   153,   138,  2985,  2052,  3068,  2859,
   -4005, -4005, 41153, 33564,  1658,  3084,  2881,  2881,  2881,  2881,
    2881,  2881,  2881, -4005,  2190,   663,  2095, 44489, 62837, 44489,
   -4005,   793,  2984, 62837, 62837,  2871,  2860, -4005, -4005, -4005,
   -4005, 46157,   745, 46157,  2052, -4005, -4005,  2941, -4005, 62837,
    1645,  3267,  2494,   825,  3012,  1633,  3211,  2708, -4005, -4005,
   -4005, -4005, 62837, 62837,   777,  1118, -4005,  2883,  2885, -4005,
   62837, 62837, 62837, 62837,  2741,  2886,  2891, 77805,    48,  3063,
    3065,  2388,  3282,  1780,  2708,  2965, 62837, -4005,  1964,   130,
   -4005,  1118, 44489, 76170, -4005,  3503, -4005, -4005,   804,  3156,
   -4005, -4005,  1780,   216, 77805, 62837, -4005,   216,   168,  2938,
     216,  2940,   216,   216, 62837, -4005, -4005, 62837, -4005, 62837,
   43238,   216, -4005, 10454, -4005, -4005,  3004,  3009,  3015, 62837,
    2692, 45740, -4005,  2890, 46157,   -21, -4005, -4005,  3080, -4005,
   -4005, -4005, -4005, -4005, -4005, -4005,  3201,  3202, -4005, -4005,
   -4005,   232, -4005, 46157, 51995,   185, 46157, -4005,  1878, -4005,
   -4005,  1898,   327, -4005, 62837,  3147, -4005, -4005, -4005,  2916,
    1968, 10366, 23295, -4005,  3217, 77805, -4005,  5203, -4005, -4005,
   -4005, -4005, 23295, -4005, -4005, -4005, -4005, -4005, 23295, -4005,
   23295,  3193, -4005,  3339,  3339, 77805, 25905,  1459,  2296, 25905,
   25905, 25905, 25905, 25905, 25905, 25905, 25905, 25905, 28052,   680,
   -4005, -4005, 23295, 23295,  3208,  3193, -4005, -4005,  1381,  1381,
   77805,  2920,  2731,  2921,  2926, 23295, -4005, -4005,  1972, 27193,
    2933, 41153, -4005, 23295,  8879,  1973,  2988, 10414,   -54,  5610,
   -4005,  3298,  1118, 23295,  1627,  1965, 23295,  1977, 23295,  3207,
   -4005, -4005, -4005,  2946, -4005, -4005, 77805, 23295, 25905, 25905,
    4619, -4005,  6140, 23295,  2948,  6651, 20250, -4005,  3119,  2989,
   32716, -4005,   813,   813,   813,   813, -4005, 62837, 62837, 62837,
   29324,  3224, 28476, 60335,  2943,  1666, -4005, 60335, 60752, -4005,
    2966, -4005,  2968,   -54, 23295,  3221,   688,   688,  3119, -4005,
   23295, 22860,  2952, -4005,   308,  2969, -4005, -4005,  5939, -4005,
   -4005,  2972, -4005,  2974, -4005,  1537, -4005, -4005, -4005,  5699,
    3143, -4005, -4005,  2943, 23730,  2896, -4005,  1984, -4005, -4005,
   21120, -4005, -4005,  1985, 32292,  2810, 21555,   -54,  1990,  1702,
   -4005, -4005, 75764, -4005,  3027, -4005, -4005, -4005,  2881,  2191,
    2191,   143,  2692,  3249,   143,  6219, -4005, -4005, 29748, 62837,
   62837, -4005, 62837,  2012,  1028, 62837, -4005, 62837, -4005, -4005,
   -4005, -4005,  3366, -4005, 62837, -4005, -4005,  3018,  3019, -4005,
   62837, 62837, 62837, 62837, -4005, -4005,  1885, -4005, -4005, 46157,
   62837, -4005, -4005, -4005,   376,  2060,  2389, -4005,  3046, -4005,
   -4005,  3218, -4005,  3360,  3060, 62837,  2976, -4005,  1028,  1014,
    2388,   135, -4005, -4005,  3045, 62837, -4005, 62837, -4005, -4005,
   -4005, -4005, -4005, -4005, -4005, -4005, -4005, 41570, -4005, -4005,
   62837, -4005, 41153, 33564, 41153, -4005,  1148,   407,  2077,  2389,
   -4005,  3059, -4005,  3062,  3066,  3110,   887,  1007,  3070,  3071,
    3113,  2991,  2994,  2996, -4005, -4005,   333,  1118, -4005, -4005,
    1118,  2191,  1118, 62837, 62837, 62837,  3386,  3086, 62837, 62837,
   62837, 62837, 62837,  3288,   819,  1657, 46157, 62837, 62837, 46157,
   62837, 62837, 62837, 62837, 62837, 62837, 62837, -4005,  3373,  3308,
    1741,  3348,  3078, 62837, -4005, 62837,  2599, 62837, 62837, -4005,
   -4005, -4005,  3010,   269, -4005, -4005,  3256,  3260, -4005,   269,
     269, -4005,   233, 41153, -4005,  1386,  2974,  2052,   383, -4005,
   -4005, -4005, -4005, -4005, -4005,  2646, -4005, -4005,  2052,  1960,
    3020, -4005,  3021, -4005, -4005, -4005, -4005, -4005, -4005,  3022,
   -4005,   865, -4005, -4005, 62837,  2881, -4005,   346,  1031,  1140,
    1189, 61169, 61586, 62003,  3025, 62837, 62837, 25905, -4005,  1360,
     221, -4005,  3268, 62837,  3064, -4005, -4005, -4005,  3187, 62837,
   -4005, -4005, -4005, -4005, -4005,  3034, -4005,  3148, 49910,  2191,
   46157, 46157,  2191, -4005, 77805,  3038,  2708, 46157,   825,  1352,
   69926,  3072, -4005,  3033,  3328, -4005,  3049,  3047, -4005, -4005,
   62837,  2984,  2035,    71,  1613, -4005, 51161,  1853,  3299, -4005,
   -4005, -4005,  3407,  3128, -4005,  1780,  2741,  3128,  1118,  2630,
   -4005, 75764, 23295, 23295, -4005,  3048, -4005,  3053,  5403, -4005,
    2082, -4005, -4005, -4005, -4005, -4005, -4005,  3123, 62837, -4005,
   -4005,  3054,   216, -4005, -4005, 62837, -4005, 62837, -4005, -4005,
     216,   216, -4005,  3160, -4005, 62837, 62837, 62837,  2692, -4005,
     327, -4005,  3335, 45323, -4005, -4005, -4005, -4005, -4005,  3397,
      89,  3342, -4005, -4005,  3302,  3303,  3304,  3305,   808, -4005,
   -4005, 23295, 10454, -4005,  3067, -4005, 10454,  6688, 10454,  3208,
   -4005,  2098,  3347, -4005,   831,  3074,  2098,   824,   824,   437,
     437,   197,   197,   197,  3339,   680, 10454, 10454, -4005, -4005,
   -4005, -4005,  3075, -4005, -4005, -4005,  2731, -4005, 24165,  3209,
    3453, -4005, -4005, -4005,  3104,  3105,  3076, -4005, 23295, 24600,
    3077, 78617, -4005, -4005,   865,   358, 25905, 25905,  1908, -4005,
     429, 23295, 77805,  2046,  1908,  2013,  2447, 23295, 23295,  7460,
     312, 23295,  7031,  3082, 23295, 76576, -4005, -4005, 62837, 62837,
   62837, 62837, -4005, -4005, -4005, 60335, 60752,  3085, 18578,  1666,
    3087, 62837, -4005, -4005,  3090, 28900,  3310,  3248, -4005, 28900,
    3248,  1527,  3248,  3312, -4005, 33140, -4005, -4005,  3096, -4005,
   -4005, 17715,  1542, 10454,  3466,  3356, 23295,  3088,  3098,  3099,
   10454, 23295, -4005,  1118,  1118, -4005, -4005, 35719, -4005, -4005,
   -4005,  3276, 10454, -4005,  1780, 62837,   -54,  2320,  3100, 62837,
   -4005,  2896, -4005, -4005,  3161,  2050, -4005,   333, -4005, -4005,
   -4005, -4005,  3169, 51578,  3387, -4005, 23295,  2070, -4005,  3140,
    3475,   246,  2099,  2100,  1028, -4005,  3064, -4005,  1426,  3365,
     189, -4005,   216, -4005, 77805, -4005, 62837, 62837, -4005, -4005,
   -4005, -4005,  2345, -4005, -4005, 62837, 62837, 62837, 62837, -4005,
   46157, 62837, -4005, 41153,  2190,  3307, -4005, -4005,  3309,   333,
   62837, -4005, 77805,   216,   216, -4005, -4005, -4005, -4005,  3120,
    3496,  3194, 62837, 62837, 62837, 62837, 46157, 62837, 62837,  2052,
    2052, 77805,  3106, -4005,  2052,  2052,  3109, -4005, 46157, 62837,
   62837, -4005, -4005, -4005, -4005, -4005, -4005, -4005, -4005, -4005,
   -4005, 46157, 62837, -4005,  3192, -4005, -4005, -4005, 62837, 62837,
   62837, 62837,  3417, -4005, -4005, -4005, -4005, -4005, -4005, -4005,
   -4005, -4005, -4005, -4005, 62837, -4005, -4005,  1118,  1118, 77805,
     216,   216, -4005, -4005, -4005,  3361, -4005,   269,   269, -4005,
   -4005,   384,  2104, -4005, 30172, -4005, -4005,  2472,  1118,  2472,
    1515, -4005, -4005,  2472, -4005,  2472, -4005,  1028,  3121,  1517,
    3401, -4005, -4005, -4005, -4005,  3405,   333, -4005, -4005, -4005,
   -4005, -4005, -4005, -4005, -4005, -4005, -4005, -4005, -4005, -4005,
   -4005, -4005, 23295, -4005,  1027,  2098, -4005, -4005, -4005, -4005,
    3064,  1645,  3177, 45740,   289, -4005,  3388,   757, 49910,   242,
   62837, -4005,  2191,  2191,  3178, 62837,  3533, -4005,   632, 62837,
    3450,  3176, -4005,  1118, -4005, -4005,  2708, 62837, 49910,  2741,
    2111, -4005, -4005, -4005,  3173,  3065,  3139,  1853,  1182, 62837,
   -4005,  3179, -4005, -4005,  3425,  3145, -4005, 10454, 10454,  1118,
   79023,  3503, -4005, 62837,  3402,   216, -4005,   216,   216, -4005,
   -4005, 62837,  2692,  2692,  2692, -4005,  3330, -4005, -4005,   216,
   45323,   808,   808,   808,   808, -4005, -4005, -4005, 10454, -4005,
   -4005, -4005, 25905,  3432, -4005,  3150, 77805, -4005,  3151,  2118,
    2125, 26769,  3297, -4005, -4005, -4005,  7374,  3204, 10454,  3255,
    3158,  3159, -4005,  1761,  1761,   429,  2126, -4005, 25905, 25905,
    1908,  1908, 23295,  1908, -4005, -4005,  7503,  3327, -4005, -4005,
   -4005, -4005, -4005, -4005, -4005, 41987, 60335,  3165, 62837,  1666,
   28900, -4005, -4005,  1895, -4005, 28900,  3411, -4005, 28900, 62837,
    3167, 62837,   673, 23295, 23295,  3210, -4005, -4005, -4005,  3119,
   -4005,   865,  3175, 62837, -4005, -4005,   952, -4005, -4005, -4005,
   -4005, -4005, 45323,  3367, 45323,  1028,  7714,  3064, 29748, 36581,
   62837, 62420, 62420,  3318,  3064,  3177, -4005, -4005, -4005, -4005,
   -4005, -4005,  3183, -4005, -4005, -4005,  3262, -4005, -4005,     8,
    2697,  2134, -4005, -4005, -4005, -4005, -4005,  3373, -4005, -4005,
   33564, 46157, 62837, -4005,  3263, -4005, -4005, -4005, -4005, -4005,
   31020, 35719, -4005,   887,  3188,  3190,  1007, -4005, -4005, -4005,
     555,  2697, 62837,   531,   907,  3215,  2692,  3480, -4005, -4005,
   -4005,  3373, -4005, -4005,   269, -4005, -4005, -4005,  2095,  3518,
   -4005, 41153, -4005, 42404, -4005, -4005, -4005,  1118, -4005,  1118,
    3389, 62837, 38651,  1118,  1118, -4005, 45740,  3598,  3598, 62837,
   -4005, -4005,  8029,  3394, -4005,  3177,  3416,  3462, -4005,  3203,
   62837,  3358,  3206,  3213,   219,   219,  2984, 62837,  2140,  1780,
     825, 49910,  2984, -4005,  1400,  3212,  3504, -4005,  3612,  2886,
    3216, -4005, -4005, 51161,  3390,  3128, 62837,  3065,  3334, -4005,
    3336, -4005,   255, -4005, 62837, 29748, -4005, 78211, -4005,  2141,
   -4005, -4005,  2789, 62837,   684, -4005, -4005, -4005, -4005, -4005,
   -4005,   185, -4005, -4005, -4005, -4005,   931, 25905, 77805,  2145,
   23295, -4005, 23295, -4005,  3604, -4005, -4005, -4005,    65, -4005,
   -4005, -4005,  1761,  1761,  1908, -4005,  3607,  3119, -4005,  2146,
    3625, -4005, 62837,  2147, -4005, 23295,  3222, -4005, -4005, 28900,
    1895,  2156, 62837,  2162, 77805,  3220,  2731, 10454, 62837, -4005,
    3223, -4005, -4005, -4005, -4005,   -21,   143,   185,  3475,  3177,
   -4005,  3225, -4005, -4005, 62837, -4005,  1304,  1304, 62837,  3177,
   -4005, -4005, 62837,  3311, -4005, -4005, 41153,  3278, -4005,   916,
    2697, 62837, 77805,  1898,    94, -4005, 77805, 77805, -4005,  3313,
   -4005, -4005, 62837, 62837, 62837, 62837, 62837,   216, -4005,  2852,
    1118, -4005, -4005,  2163, -4005, -4005, -4005, 62837,  3033, -4005,
    3033, -4005, -4005,  3598,   820, -4005, -4005, -4005,  1450,  3429,
   -4005,  1175,  3415,  3317,  3232, -4005, 45740,  3667,  3349, -4005,
   -4005, -4005, -4005, -4005, -4005, -4005, -4005, -4005,  3535,  2708,
    3179, -4005, -4005, -4005, -4005, 23295,  3392,  1780,  1853,  3299,
   -4005, -4005, -4005,  2164,  3128, -4005, -4005,  3617,  3426,  3618,
   -4005,  2169, -4005, -4005,  5403, 79023,  3566, -4005,  3300, 62837,
   -4005, -4005, -4005,   931,  2170, -4005,  2193,  2198,  3393,  3301,
   -4005, 23295,    90,  2966, 41987,  3247, -4005,  2210, -4005, 10454,
   62837, -4005, -4005, -4005,  2214, -4005, -4005,  3250, -4005,  3655,
   -4005, -4005,  3536, -4005, 62420,  3292, 35719, -4005,  1537,  1537,
    1645, -4005,  1028, -4005, 62837, -4005, 23295, -4005,  3340, -4005,
   -4005,  2215, -4005,   703,  3403,  3546,  2223,  2231, 62837,  2706,
    3295,  2706, -4005,  2692, -4005, -4005, -4005, -4005, 42404,  3033,
   -4005, -4005, -4005,  3575,  3520, -4005, -4005, -4005, -4005,   409,
   -4005,  3448,  3451, 62837, -4005,  3270, -4005,  2232, 62837, 62837,
    3673,  3679, -4005,  8275, 45740,  3179,  3065,  1853,  2190, -4005,
   -4005,  3455, -4005,  3458,  2708, 29748,  3503, -4005,   300, -4005,
   -4005, -4005, -4005, -4005, -4005, -4005,  2731, 25035, 25035,  3275,
   -4005, -4005, 62837, -4005,  2233, -4005, 62837,  3277, 45323,  1304,
    3279, -4005,  3280, -4005, -4005,  3416,  1028,  2697, 10454, 62837,
   45740,  3666, -4005, -4005, -4005,  3403, -4005, -4005,  2697, 62837,
   -4005,  3406, -4005,   722,   722,  3610, -4005,  3341, -4005, -4005,
    3284, -4005,  3715,  2984, -4005,   887,  1780, -4005,  3286, -4005,
    3128,  3065, -4005, -4005,  3128, -4005, -4005, -4005, -4005,  2309,
   26340,  3420,   758,  8912, -4005, -4005, -4005, -4005,  2239, -4005,
   -4005, -4005,   185,  1537, 23295,  1028, -4005,  3415, -4005,  2697,
    1898, 62837, -4005, -4005, -4005,  3176, -4005,  3709, -4005,   719,
   -4005, -4005, -4005, -4005, -4005,  3106,  3179, 40736, -4005,  3128,
    2789, -4005,  1503, -4005, -4005, -4005, -4005, -4005, -4005, -4005,
    3699, -4005, -4005, -4005, -4005, -4005, -4005, -4005, -4005,  8327,
   -4005, -4005, -4005, -4005,  3593, -4005, -4005, -4005, -4005, -4005,
    2243, -4005, -4005, -4005, -4005, -4005, -4005,  1996, -4005, -4005,
    2016,  1851, 25470, -4005,  1028,  3449, -4005, 40736, -4005,  1503,
   -4005, 45740, -4005, -4005,  3296, 40736,  2247, -4005
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
   -4005, -4005, -4005,  3005, -4005,  -781, -1084,  2378,  -473, -4005,
   -4005, -4005,  2924, -4005, -4005, -4005, -4005, -4005, -4005, -4005,
    2987, -4005, -4005,  1567, -2087, -4005, -4005,   120,  2923, -1099,
     107,  2589,  1259, -4005,  -948, -4005, -4005,  -506,   112, -4005,
    2929,  -616, -4005, -4005, -4005, -4005, -4005, -4005, -4005, -4005,
    -690,  1733,  1102,  -784, -2384, -4005, -4005, -1198, -2761, -4005,
     514, -4005, -4005,  1665, -4005, -4005, -4005,   960,   443,  -470,
   -4005, -4005, -4005, -4005, -4005, -4005, -4005,  -295, -4005, -4005,
    -604,   134,    45, -2074,  -339, -4005, -4005,   393,  -331, -1111,
   -4005, -3079, -4005,   -31, -4005, -4005, -4005,  -309, -1191,  1212,
   -4005,  -591,  -972,  1512,  -655, -4005,  -195, -4005,  -713,  -597,
    -595,  -661,  -484, -3277, -3654, -3271, -3050,  1226,   144, -4005,
   -2743,   151, -4005, -4005,   152,   155, -4005, -4005, -1303, -1216,
   -4005,  -753, -4005, -4005, -4005, -2544, -4005, -4005, -4005, -4005,
     103, -4005, -4005, -4005, -4005,   430, -4005, -4005, -4005, -4005,
   -4005, -4005, -2317,  1639,  1642, -4005, -4005, -2741, -4005,  -776,
   -4005,   576, -2569,  1142, -4005, -4005, -4005,  2351, -4005, -4005,
   -4005, -4005, -4005, -4005, -1376, -4005, -4005,   160, -4005,  1656,
     949, -4005, -4005, -4005,  -691,  -759,  -750, -4005, -2579, -4005,
   -4005, -4005, -4005,  -262, -4005, -4005, -4005, -4005, -4005, -4005,
    -832, -4005,  1012, -2706, -4005, -4005,  1022, -4005, -4005, -4005,
   -4005, -4005,  -644,  -198,  2380, -4005,  -527,  -614, -4005, -4005,
   -4005,  -197, -4005, -4005, -4005, -4005, -4005, -4005,  -907,    44,
   -1343, -4005, -4005, -4005, -4005, -1998, -4005, -4005, -4005, -1599,
   -4005,  3809,  1906,  1335,   161, -4005,   -27,    50,  2833,  -966,
   -2246,   373,  -345, -4005, -1520, -4005, -4005, -4005, -2180, -4005,
   -4005, -4005, -4005, -3038,   163, -4005,  2827, -4005,   423, -4005,
   -3869, -3453, -3765, -3350, -3020, -4005, -4005,  -919, -4005, -4005,
   -4005, -1211,  1957, -1662, -4005, -1786,   424,  1301,  -802, -2366,
   -3283,  -608, -2806, -4005, -3202,  -449, -4005, -4005, -4005, -4005,
   -4005, -4005, -4005,  -916,  -530, -4005, -4005,  3272, -4005, -3757,
   -4005, -4005, -4005, -4005,  1021, -4005, -4005, -1212,  1098, -4005,
   -4005, -4005, -4005, -4005,  -625,  -716, -4005, -4005, -4005,   164,
   -4005, -4005, -4005, -4005,   915,  -787,  -626,  3149,   166, -4004,
   -4005, -4005, -4005, -4005, -2624, -4005, -4005, -4005, -4005, -4005,
   -4005, -4005, -4005, -1590, -4005, -4005, -4005, -4005, -4005, -4005,
   -4005,  2026,  2027,    62,   -20, -4005, -4005, -1087, -4005,  -475,
   -4005,  2324, -4005, -4005, -4005, -4005,  1362,   171,   457, -4005,
       3, -4005, -4005,   249, -2947,     4, -4005, -4005, -4005, -4005,
   -1831,     5, -4005,   733, -4005, -4005, -2410, -4005,   174,    26,
   -4005, -4005,     1,     0,   -36,   -34,   -23,     2,  3142,  2688,
   -4005, -4005, -4005,   -15,  1732, -4005,  -730,  -142, -4005,  1366,
    -550,  1997,  2673,  2679, -4005,  1359, -4005, -4005,  1372, -4005,
   -4005, -4005,  -532,  2008, -4005,  2681, -4005, -4005, -4005,  1356,
    1367, -2910,   802, -2934, -2919,   320,   307, -1090,  -283,    82,
    3180,  2685,   810,  -423, -4005, -4005,  -419, -3930,   761, -4005,
   -3742, -1975,  -215,  1762, -1355, -4005, -4005,  -975,  7236, -4005,
   -4005, -4005, 12275, 12633, -4005, -4005, 13363, 13487, -4005,  -843,
     857, 13500,  5417, -1015, -1633,  -694, 10840, -1190,  -380, -2386,
   -4005, -3047, -2251, -4005, -4005, -4005,  -240,   868,   417, -4005,
   -4005, -4005, -4005, -4005, -4005,  -524, -4005,  -522, -4005, -4005,
   -4005,  -512, -3103, -1519, -4005,  -183, -4005, 12234,  1405, -4005,
    -926, -2357, -2364, -2903, -1518, -4005, -4005, -4005, -4005, -4005,
   -4005, -4005, -1541, -2832,  -269,  1477, -4005, -4005,  1570, -4005,
   -4005, -4005, -1121,  -736, -2228,  1478, -1729, -4005,  -720, -4005,
     783,  2209,  -673,    74, -1155,  6330,  -435, -1979, -1050, -1300,
   -4005,  -158, -4005,    25,   -10,  -180,  -529,    -8,  3419,  4886,
    -536, -1094,  8693, 10833, 10895, -2677
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -2276
static const yytype_int16 yytable[] =
{
     169,   168,   173,   163,   164,   166,   578,   680,  1202,   788,
     811,   531,   726,   643,   654,   815,   896,  1134,   643,  1499,
     169,   767,   173,  1208,  1835,  1559,   831,  1539,   713,   736,
     786,  1509,  1211,   519,  1304,  1503,  2409,  1920,  2515,   925,
     568,  1532,  1825,  1291,  1327,  2475,   642,  2279,   725,  2693,
    1357,   642,  1982,  1369,   999,  1000,  1001,   560,  2135,  1596,
    1005,  1999,  3208,   947,  1448,  2955,   950,  1820,  1646,   923,
    2103,  1148,   649,  3191,  1468,  1395,   962,   976,  1990,  1619,
    1620,  3089,   617,  2853,   681,  2013,  2337,  2148,  2835,  3431,
    1825,  3374,  3223,  2199,  3225,  3608,  3392,  1838,  1635,  2537,
    2539,  1436,   882,  2750,  2495,  1441,  2057,  3343,  3098,  2939,
    1445,  3640,    65,  3096,  3097,  3132,  3634,  1451,  3324,  2374,
     607,  1820,  2067,  3417,   710,  2789,  1490,  1470,  3674,  1321,
    3845,  3405,  3089,  2374,    74,  1336,  3324,   970,   730,   738,
     674,  2071,  2072,  1362,    75,  3861,  3853,   707,  2250,   933,
     739,    76,    77,  3543,  3586,    78,  1975,   925,  1989,   699,
      98,   118,  3812,   123,   139,  1898,   143,  3138,  3584,  2203,
    1515,   161,  3569,   737,   167,  1662,  3038,  1261,  3613, -2044,
    2214,  1530,  3508,  2458, -2078,  1195,  2848,  1141,  3982,  1467,
     625,  4105,  4296,  3348,  3349,  3350,  3351,  3352,  3353, -1592,
    1612,  1613, -1378,  1198, -1951, -1979, -1592,  4171,  2995,  4173,
     529, -1952, -1951,  1665,   625,  1358,  3091,  4197, -1559, -1952,
    1491,  1491,  1541,  2536,   772,   774,  1632,   981,   778,  2078,
     780, -2099,  3677,  2083,  3422,  2520, -1818,  1491,   574,  1928,
    2414,  4259,  4353, -1818,  1237,  2772,  4292,  1992,  2312,   829,
   -2126,  2449,  1992, -1592,  1150,  2065,  1992,  2910,  2450,  2912,
    2972,  1579,  1026,  1926,   795, -1926,  4392,  3091,  1491,   574,
   -2275, -1587,   819, -1572,   574,  2196,  2414, -1599, -2275,   731,
     574,   833, -2047,   825,  1390,   574, -1378,  1826,   916,   574,
    4260,   625,  1432,   574,  1672,  3989,   574,  4261,  3409,  3628,
    4309,  2206,  3192,  3137,   985,  1366, -1381,  1992,  4287,  3209,
     716,  4246,  1463,  3980,  2271, -1923,  4288,  4080,  3837,  3333,
    1675,   996, -1602,  4477,  4262, -1587,  2940,  3808,  2456,  3468,
    1384,  1289,   631,  1464, -1834,  4203,   625,   631,   732,  2153,
     625, -1834,   625,  2681,  1355,  1845,  -781,  1238,    33,  2166,
    1677,   574,   632, -1602,  1710,   625,  1970,   632,   631,  3203,
   -1378,  1369,  3336,   811,   891,  2585,  1663,  2168,   898,  1672,
    2560,  2288,  3678,  1356,   877,  4084,  4417,  3334,   632,   908,
    3462,  1160,  3233,  2745,   631,  1161,  2200,  2020,  1138,   524,
   -1381,  4469,   625,  1722,  1709,  -124,  4263,  3234,  1734,  1734,
    -124,  1646,  4418,   631,   632,   733,  1672,     3,     4,  2274,
     811,  1501,  2746,  2280,   835,  2282,  4085,  1711,  2285,  1510,
    3463,   928,  3204,   632,  4081,  1677,  2600,   925,  1619,  1620,
    4324,   938,  1675,  2197,  1846,   631,  1635, -2098,  1237,   925,
    1672,  1971,  2561,  1279,  3985,  1992,   917,  1223,  2995,  1501,
    3787,    38,  2167,  4284,  2457,   632,  2143,  1527,  1215,  1367,
    2110,  1151,  1677,  3809, -1381,  3629,  1675,  3469,  2114,  2953,
    4289,  2143,  1492,  1492,  1577,  3679,  1992,   997,  3680,  1465,
    2272,    42,  2334,  4310,  1586,  2012,  4370,  4478,   575,  1492,
    3210,  2207,  1963,   925,  3630,  -377,  1677,  1597,  1228,  1160,
    1969,   918,  1543,  1161,   836,  2467,  2060, -1378,  3838,  2273,
    1827,  2783,  4548,  3631,  3192,  3211,   783,   874,  4453,    46,
    1492,  2941,   734,  1600,  3627,  1152,  2135,  3688,  2682,  1580,
    1501,  1298,    47,  1165,  2340,  1166,  4475,  2053,  2066,  2055,
    1022,  1238,  1825,  2622,  2773,   837,  1927,  2688,  2544, -1818,
    1004,  2415,  2062,  1961,  3423,  2084,  3324,  2043,  1612,  1613,
    2046,  2047,  4264,  2133,  2451,   924,   578,  1632,  2521,  4429,
    4107,  2106,  2012,  3990,  2126,  2127,  1433,   726,  2079,   880,
    2412,  2102,  3644,   883,  2198,  1607,  2267,  3058,  1825,  3157,
    4556,  1666,  1607,   717,  1433,   838,  1203,   977,  3268,   842,
     906,  1229,    48, -1378,   875,  2026,  1239,   925,  4075,  1529,
    1501, -1381,   169,   725,   173,   925,   925,  3331,   978, -2044,
     983,  2254,   987, -2276, -2078,  3826,  3463,  2111,   991,   872,
    3007, -1592,  3586,   637,   638,  2000, -1951,  1716, -1592,  3916,
   -1378,  2586, -1378, -1952, -2098, -1979,  3933, -1834,  1580,  1010,
    1618,   642,  1870,   642,  1978,   642,   969,  3891,  2275,  4121,
    3835,   642,   992,   993,  1418,  3939,   994,  2286,  2873,  3943,
    1871, -2099,  1027,  3852,  3968,   972,  2333,   811,  2336,  1131,
    4488,  1160,  1140,   924,  1142,  1161,  2035,  1373,  2344,  2038,
   -2126,  2995,  2348,   738,  3089,  1160,  3089, -1926,  1379,  1161,
    2360,  2361, -2275, -1587,   739,  1624,  2224, -1381, -2098, -1599,
     637,   638,  1668,  2378,  2380,  2230,  1696,  1707,  1265,  2234,
    1641,  3786, -2047, -2098,  2394,  2240,  2241,   737,  2482,   169,
     168,   173,   163,   164,   166,  4334,  3665,  3602,  1006,  2716,
    1642,  1017,  4470,  2253, -1381,  1230, -1381,  2623,  3777,  1368,
    3140,  1641,  3141,   569,  1643,   637,  1290,  1004,  1481,   637,
     638,   637,   638,   740,  1135,  3388,  4047,  3692,  2504,   784,
    2033,  1642,  3089,  1167,  4506,  4189,  3625,  3301,  1231,  1170,
    3304,  3305,  4199,  1158,  3308,  1645,  2431,  2364,  2365,  4454,
    3311,  2701,  1223,  3134,  1035,  1006,  1583,  2995,  3368,   887,
    2942,  3306,  3307,   574,  1184,  1820,  2276,  1232,  2475,  2475,
    2475,  1137,  2689,   574,  1859,  1145,  1341,  4519,   935,  -124,
    -124,   642,  2671,  4546,  1206,  1693,  1694,  1695,  1696,  3091,
     663,  3091,  1035,  1914,  4282,  2995,  1718,  1289,   574,  2791,
     741,    65,   625,  1296,  1297,  1377,  4338,  4339,  2139,  2551,
    3106,  2374,  2374,    38,  1342,  4371,  2374,  1691,  1692,  1693,
    1694,  1695,  1696,    74,  2702,  1233,  1243,  3004,  3005,  3006,
    3007,  1295,  2672,    75,  2997,   686,  2639,  2598,  1975,  2206,
      76,    77,  4219,    42,    78,  2209,  2190,  1225,  4160,    98,
     118,  3187,   123,   139,  3864,   143,  2374,  2374,  2283,  2284,
     161,  3616,  2944,   167,  1916,  4532,  3380,  3091,   664,  2171,
    2827,  2001,  2432,  3433,  2703,  2140,  2433,  1389,  2678,  4298,
     209,    46,  1917,  2002,  1663,   528,  1908,  2290,   674,  1331,
     733,  3640,  4222,   609,    47,  4200,  1909,  1719,  1446,  1447,
    1928,  2291,  2995,  1225,  2613,   733,   526,  3893,  1307,  3894,
     683,  1910,  1914,   924,  2434,  2613,  2673,  4507,  1478,  2996,
    4441,  4547,  1444,  2191,  2139,   924,  2704,  3729,  1915,   687,
      48,  2231,  2497,  2141,  2003,   798,  2142,   169,  2239,   173,
    2997,  1308,  2242,  2172,  1472,  1475,  1476,  2057,  1505,  1507,
    3434,  2761,  4372,  4139,  2249,  2943,  1501,  1347,  1582,   976,
     642,  4396,  4161,   570,  2889,  1459,  1545,  1343,  1547,  3321,
    1549,  4406,  1551,  4400,  1553,  1554,  1555,  2614,  2997,   924,
    4442,  1557,  1483,  1916,  1408,  4250,  4508,  3321,  2614,  2741,
    4164,  2140,  4533,  2277,   742,  4168,   574,  1605,  4170,  2998,
    3258,  1917,  3699,  1460,  2490,  2292,  2792,  2615,  1720,  4509,
    3885,  1918,   888,   571,  3381,  3431,  3975,  1622,  2705,  2259,
    3369,  2226,  2742,  2825,  2349,   726,   574,  2143,  3640,  4091,
    4299,   936,  2828,  1929,  2435,  4098,  1135,  2998,  3895,  4493,
    2616,   665,   666,  2030,   572,  1911,   573,  1649,  3354,  2141,
    1517,  2743,  2142,  1664,  1348,  1344,  4101,  2945,  1378,  1135,
    2674,  1660,   835,  1669,  4002,  1484,  2367,  3429,  3002,  3003,
    3004,  3005,  3006,  3007,  3101,  3188,  1708,   811,  1923,  3730,
    4471,  1346,  2930,   574,  3435, -2276,  2735,  1347,  1518,  3596,
    2599,  3357,  2736,   924,  3647,  3790,  1724,  1725,   631,  4335,
    3700,   924,   924,  3246,  2192,   574,   835,  1919,  4332,  4341,
    2829,  1930,  1831,  1839,  1840,  1485,  1844,  2193,   632,  2107,
    2350,  2706,  3704,   655,   739,   739,  2144,   739,  2617,  2707,
    1918,   642,  2708,  2810,  2090,  2117,   642,   642,  3266,  2617,
    2993,  2994,  2115,  2143,  3436,  3009,  2145,   737,   737,  3089,
     737,  3139,   836,  3089,   574,  2514,  1461,  2544, -1559,  4518,
    2541,  1433,  4398,  4520,  4476,  1185,  1191,  4223,  3648,  3967,
    2999,  3000,  3001,  2118,  3002,  3003,  3004,  3005,  3006,  3007,
    3113,  1301,  2293,  2156,  1348,  3044,  3045,  2351,   661,  2737,
    3701,  1738,  3602,   837,  3952,  4304,   836,  3959,  3180,  2116,
    2294,  3267,  2744,  4348,  3792,  1486,  3247,  2626,  4555, -2276,
   -2276,  3675,  3002,  3003,  3004,  3005,  3006,  3007,  2373,  4321,
    3705,   637,  1290,  3649,  4073,  3650,  1919,  4160,   662,  3361,
     642, -1559,  2396,  2170,  2031,  1193,  3181,   837,   642,  1873,
    2225,  1519,  2144,   838,  1462,  2352,  1206,  1932,  2353,  2090,
    3879,  4108,  2717,  3794,   527,  1487,  2638,  1933,   685,  1186,
    2720,  3028,  2722,  4109,  4208,  3756,  3362,  3035,  4224,  4351,
    2907,  3759,  3760,  4356,  4357,   993,  2061,   708,  4433,  4434,
    3363,  2232,  2007,  2913,  3091,   811,  2908,   838,  3091,  4376,
    1147,  2223,  2627,  3324,  1848,   642,  2032,  2500,   642,   642,
    2229,  2946,  1986,  1956,  2090,  4267,  1303,  2794,  2497,  2004,
    -146,  4271,  2715,  2858,  2859,  2860,  2861,  1501,  3640,  3002,
    3003,  3004,  3005,  3006,  3007,  2866,  2119,  1922,  1349,  1520,
    2613,  1849,  2048,  2738,  2728,  -146,  1488,  4530,   176,  2354,
    2039,  2542,  2129,  2042,  2543,  2073,  2074,  2075,  2076,   719,
    3248,   801,   802,   803,  1923,   804,   805,   806,   807,   808,
     809,  1350,  3364,  2767,  3109,   642,  2739,  3622,  3152,   786,
    2947,  3459,  3690,  2970,  1225,  2064,  2501,  1225,  2604,  2077,
     177,  2903,  3202,  3249, -1559,  3834,  2112,  2113,  1996,  3182,
    1351,  3765,  2122,  2093,  1151,  2740,  2048,   728,  1934,  2475,
    1003,  2014,  4377,  2614,  2906,  2180,  2105,  3321,   729,  1223,
    3489,  3479,  3250,   811,  2120,  2635,  2306,  2410,  4110,  4570,
    2915,  2916,  3022,  -595,  2918,  1851,  3867,  3806,  3868,  2556,
    2922,  1935,  3766,  4538,  3509,  3691,  2150,  2374,  2355,  1997,
    2374,  2374,  2374,  2374,  2374,  2374,  2374,  2374,  2374,  2374,
    2015,  4248,  2016,  3047,  2747,  2054,  3767,  2815,  1152,  2049,
    2057,  2050,  1726,  2185,  2186,  2187,  2188,  4378,  4391,   543,
    2374,  3768,  1279,  1022,  3269,  3769,  1852,  3183,  2005,  2096,
    2652,  1004,  1324,  2748,   743,   682,  2012,  1924,  2932,  2957,
    3807,  1662,  2014,  3986,   169,  3770,   173,  1501,  3771,  2374,
    2374,  1727,  1191,  1848,  3453,  2201,  2816,  1192,  2572,  3089,
    3772,  2211,  2097,  1191,  3089,  1325,  3647,  2244,   543,  3089,
    2568,  2654,  3089,  2049,  2709,  2050,  2248,   545,  2309,  2810,
    2261,  2653,  2262,  2255,  2263,  3492,  2264,  3493,  2265,  4297,
    1849,  2015,  2266,  2016,  1672,   169,  2305,   173,  2302,  2303,
    2304, -1559,  3089,   889,  2617,   890,  3987,   972,  4373,  2699,
    3431,  3163, -1559,  2573,  1618, -1559,  1215,  2258, -1559,   176,
    1675,  1193,  2655,  2358,  2572,  -938,   545,  2012,   176,  2709,
    2884,  4342,  1193,  4207,   777,  2817,  2818,  2422,  3773,  2423,
    3648,   821,  1850,  1212,  4131,  1035,  3774,  4345,  2995,  2819,
    1677,  2346,  2347,  4474,  2308,  1135,  1135,  1672,  1194,  2359,
    1326,   177,  2424,  2362,  2363,  3536,   822,  4227,   779,  1194,
     177,  2307,  2296,  2098,   796,  3049,  1213,  3050,  2384,  3160,
    2385,  3775,  4066,  1675,  1851,  2099,   797,  3993,  3994,  2420,
    3410,  3577,   925,  3414,  3091,  3649,  2820,  3650,  3179,  3091,
    3051,  2407,  -400,  2408,  3091,  1214,  3494,  3091,  1143,  2100,
    4067,  1220,    38,  1677,  2331,   552,  3495,   553,  3784,  3578,
      33,  4272,  2899,  2483,   827,  2548,   925,  1524,  2153,  1714,
    2552,  2417,  4514,  2555,  3945,  1852,  4185,  3091,  4187,  3089,
    1449,  1734,    42,  1992,  1221,  1356,  3580,  1525,    33,  4273,
    4090,  1993,    27,   834,  4083,  2578,  2921,  3102,  2425,  1630,
    1631,  3576,  4060,  2426,   552,  4410,   553,  4061,  2427,  4045,
    4046,  3747,  4436,  1222,  4100,   811,  1217,   909, -1390,  1035,
      46,  2068,  2995,  2821,  3458,  2822,  2640,  2701,  2466,  1449,
   -1390,  2592,  3748,  3089,  1641, -1390,  2628,  2480,   786,  1892,
    3171,  3052,  3166,  2841,  1992,  -400,  3053,   910,   876,  1218,
    4062,   879,  1998,  2634,  1642,  3731,  3491,   881,  2014,  3496,
    3497,  3498,  3499,  3500,  3501,  3502,  3503,  3504,  3505,    48,
    3577,  2997,  1893,    38,  2095,  3732,   911, -1390,  1219,  2669,
    1680,  1681,  2511,  2512,  2624,  3582,  2863,  1223,  2374,  2506,
    2967,  2864,  2968,  3662,  3193,  2257,  1337,  2969,  3578, -1390,
    2702,  1894,  4495,    42,   884,  3104,  2700,  2015,   897,  2016,
    2711,  2014,  3645,  3579,  3091,  3216,  3213,  3218,  3545,  3546,
     912,  2014,   642,   169,  2523,  3580,  1684,  2428,  2723,  1338,
    2998,   904,  2562,  1339,  2565,  1534, -1390,  2429,  1535,  2733,
    3393,    46,  1170,  2012, -1390,   543,  -503,  3243,  3581,  3402,
    2703,  3912,  2757,  2491,    47,  2494,  3064,   913,  1340,  3344,
    2015,  2764,  2016,   914,  2864,  3054,  1671,  2334,  3091,  1672,
    2015,  2801,  2016,  1829,   909,  3055,  1830,   640,  3089,  2475,
    3244,  3196,   640, -1424,  2475,   536,   915,  3522, -1424,  2475,
      48, -1165,  1135, -1165,   930,  1675,  2012,  2842,   925, -1448,
   -1448,  1676,  2704,   545,   910,  2997,  2012,  3116,  3117,  3245,
    -504,  4564,  1142,   982,   984,   986,  3287,   934,   988,   989,
     990,   942,  3294,  1035,  3582,  1677,  2995,  1160,   995, -1926,
    3576,  1161,  3666,  3390,   943,  2594,  2595,  2596,  3471,  1641,
    2373,  2373,   948,  3537,  2606,  2373,  2608,  3239,  2610,  2611,
    3144,   957, -1424,  3510,  3511,  1618,   892,  1899,   893,  1642,
    2690, -1390,  3676,  3681,  2998,   543,  2334,  2374,  2374,  3089,
    1618,  1035,  1215,  1643,  2995,  3693,  1832,   912,  1641,  1833,
    2256,  3149,  3150,  2257,  -932,  2373,  2373,  1590,  1591, -1424,
    2621,  3918,  3475,   963,  2705,  3370,  4228,  2014,  1642,  3577,
     967,  2999,  3000,  3001,   925,  3002,  3003,  3004,  3005,  3006,
    3007,   625,  1645,  3091,  1691,  1692,  1693,  1694,  1695,  1696,
     642,  2400,  1160,   545,  2403,  1181,  1161,  3578,   642,  2660,
     642,  1679,   998,  2843,  3170,  2949,  1604,  2268,    48,  1310,
    2269,   552,  3579,   553,  1013,  2718,  2015,  2687,  2016,  3516,
      38,  1002,  1680,  1681,  3580,  2785,  1035,  2937,  4268,  2995,
    3335,  3337,  3338,  2785,  2854, -2185,   558,  1008,  3021,  3440,
    3023,  3024,  2844,  3443,  3444,  1011,  3446,  3581,  3448,  3449,
      42,  2937,  2012,  1014,  3624,  1311,  1019,  3454,  2678,  1618,
    3689,  1899,  2270,  3265,  1021,  2269,  4165,  2706,  1684,  3270,
    2299,  1025,  2777,  2300,  3091,  2707,  3474,  2958,  2708,  2997,
    2786,  1685,  1020,  2961,  2810,  2787,  1022,  3805,    46,  4204,
    2809,  3472,  2496,  1023,  2857,  2497,  3911,  4057,  3261,  4059,
    2014,    47,  4492,  4063,  1024,  4064,  2014,  3642,  3643,  3002,
    3003,  3004,  3005,  3006,  3007,  2219,  1028,  2220,  4117, -2185,
    4220,  2632,  2885,  3582,  2633,   169,  2874,  2997,   924,  3476,
    2889,   552,  1029,   553,  1312,  3843,  2855,    48,  2998,  3764,
    2695,  1031,   555,  2696,  3321,  2796,  1153,   731,  2797,  2015,
    1618,  2016,  1899,   557,  1146,  2015,  1449,  2016,  1154, -1425,
    2811,  2850,   924,  2812, -1425,  2924, -2185,  1149,  2269,  2966,
    2875,  3354,  2257,   811,  2878,  1155,  2879,  3355, -2185,  3386,
    1159,  1171,  1313, -2185,  1314,  2012,  2998,  3356, -2185,  2976,
    1178,  2012,  2257, -2185,  2056,  1179, -2185,  4166, -2185,  2909,
    1181,  2911,  4132,  4133,  4134,  4135,   732,  2980,  1204,  1182,
    2257,   925,  2997,   925,  3357,  2984,  3358,  3072,  2257,  3073,
    3872,  3873,  3874,  1316,  2985, -2185,   642,  2257, -1425,  3092,
    1189,  1205,  3379,  1544,  3382,  1209,  1546,  1369,  1548,  3114,
    1550,  3371,  1552,  3373,  1215,  1236,  1556, -2185,  4181,  3011,
    1241,  4293,  2257,   611,  1267,  1263,  1691,  1692,  1693,  1694,
    1695,  1696,  1318,  1268,  1298, -1425,  3913,  3914,  3074,  1300,
    3075,  2998,    14,   733,  1301,  3027,   925,  3592,  2257,  3032,
    3092,  3779,  3033,  3780, -2185,  3145,  3597,  3598,  3599,  1332,
    3359,  3298, -2185,  2374,  1306,  3667,  2965,  1320,  3172,  4349,
    1309,  1333,  2374,   726,    19,  3226,  3426,  1345,  3227,  2999,
    3000,  3001,  3694,  3002,  3003,  3004,  3005,  3006,  3007,  2374,
    2374,  3231,  3420,  1354,  3232,  3421,  3480,  3168,  2014,  2257,
    3517,  3527,  2014,  3518,  3528,  3539,  1359,  1365,  2257,  1660,
   -2185,  1364,  3614,  3618,  3470,  3615,  3619,  3360,  3623,  2014,
    1370,  2543,  3361,  2420,  4568,  1372,  4569,  2999,  3000,  3001,
    1374,  3002,  3003,  3004,  3005,  3006,  3007,  3077,  3078,  3079,
    3646,  1376,  3067,  2269,  1181,  1035, -1378,  2015,  2995,  2016,
    1381,  2015,  2315,  2016,  1188,   655,  1190,  3083,  1380,  3362,
     734,  1825,  1386,  3836,   924,  3919,  2269,  1388,  2015,  3251,
    2016,  3253,  1396,  3363,  3917,   726,  1391,  2300,  3970, -2185,
    3944,  2543,  3947,  2012,  1393,  2334,  1223,  2012,   169,  2305,
     173,  2302,  2303,  2304,  1437,  3235,  1440,  3105,  3977,   642,
    2316,  3978,  1442, -2185,  2012, -2185, -2185,  3254,  3083,  1433,
    3752,   725,  2999,  3000,  3001,  1452,  3002,  3003,  3004,  3005,
    3006,  3007,  1453,  -166,  1455,  3076,  3288,  3983,  3984,  2317,
    2269,  2269,  4050,    30,  1457,  4051,  4243,  4521,    27,  4102,
   -2185, -2187,  4103, -2185, -2185, -2185,  4141,  1469,  1479,  4142,
    2318,  3302,  1471,  4143,  4151,  3364,  2257,  2300,  1477,    38,
    1489,  2319,  4205,  4033,  4034,  4206,  4036,   194,  4269,  4294,
     924,  2269,  4295,  4305,  4313,  4318,  2300,  4314,  2497,  1494,
    3299,  2320,  3900,  1496,  4323,  1495,  2321,  3400,  3862,    42,
    4325,  4367,  4399,  3400,  4368,  1713,  4498,  4404,  4411,  1497,
    4405,  2300,  3114,  1498,  1500,  1508,  2373,  4503,  2374,  2373,
    2373,  2373,  2373,  2373,  2373,  2373,  2373,  2373,  2373,    38,
    3114,  4412,  1501,  4117,  3033, -2187,  4413,    46,  1511,  2257,
    1512,  2997,  2322,  3175,  1513,  3176,  3177,  3178,  4423,  3520,
      47,  2497,  4425,  4440,  1514,  3400,  2300,  3229,  3866,    42,
    1516,  4446,  2640,  2323,  2300,  1521,  3869,  3870,  4541,  4447,
    4461,  4489,  2300,  4462,  2497,  1522,  1523,  4536,  2373,  2373,
    3400,  4566, -2187,  1528,  4567,  4577,    48,  1533,  4567,  3441,
    1558,  1585,  1588,  1592, -2187,  3259,  1594,    46,  1595, -2187,
    2998,  1601,  4136,  1602, -2187, -1563, -1570,  3875,  1611, -2187,
      47,  1614, -2187,  1615, -2187,  1616, -1560,  1621,  1617,    48,
    1623,  1626, -1561,   194,  1627,     3,     4,  1628,  4152,  4153,
    1629,  1634, -1564,  1636,  1637,  1638,  1639, -1562,  1640,  1647,
    2090, -2187,  1648,  3290,  1650,  1651,  4522,  1652,  1700,  1653,
    2324,  1654,  1655,  1656,  3461,  1657,  2325,  1702,  1704,  1729,
    3484,  1706,  2326, -2187,  1713,  2785,  1717,  1737,  2785,  2785,
    1837,  1192,  2785,   786,  1194,  1866,  3473,  1868,  2785,  1876,
    3490,  1897,  1895,   611,  1899,  3323,  1896,  1900,  1901,  1902,
    1903,  2327,  1904,  2328,  1958,  1925,  1931,  1937,  1965,  1964,
   -2187,  1968,    14,  3323,  1962,  3512,  1966,  1995, -2187,  1967,
    2329,  1671,  1984,  1985,  1672,  1983,  4054,   924,  2005,   924,
     642,  2006,  2008,  2009,  2010,  2012,  2018,  3330,  3332,  2011,
    2019,  2023,  3339,  2021,    19,  2330,  2022,  2034,   642,  2044,
    1675,  1583,  2027,  2051,  2028,  2036,  1676,  2040,  2041,  2052,
    2058,  3822,  3823,  4088,  1279,  3398, -2187,  2059,  2063,  2069,
    2070,  2080,  2081,  2082,  2085,  2091,  2086,  2094,  3991,  3383,
    1677,  2999,  3000,  3001,  2109,  3002,  3003,  3004,  3005,  3006,
    3007,  3425,   924,   169,  3416,  2108,  2121,  2123,  2134,  1607,
    2136,  1618,  2124,  1624,  2137,  2154,  2157,  2158,  2161,  4008,
    4009,   655,   169,  3439,  2162,  1211,   538,  3375,  3376,  2165,
    2169,  2189,  3843,  1326,  2184,  2204,  2205,  2212,  2215,  2217,
    2218,  2222,  3092,  3385,  3092, -2187,  3553,  2233,  2235,  2237,
    2281,  2251,  3046,  2252,  2236,  2287,  2238,  3394,  2297,  2311,
    2382,  2340,  2383,  2395,  2401,  1671,  3403,  4303,  1672, -2187,
    2339, -2187, -2187,  2345, -2200,  1672,  2405,  3764,  3450,  2406,
    3419,  3451,  2413,  2419,  2454,  1673,  4042,  4043,  2436,  2438,
    2453,  2467, -2276,  2481,  1675,  2484,  1679,  2373,  2488,  2485,
    1676,  2489,  2498,  2499,  2507,  2508, -2187,   642,   732, -2187,
   -2187, -2187,  2509,    30,  2518,  2532,  2510,  1680,  1681,  2533,
    3092,  2535,  2545,  2546,  1677,  2547,  2558,  4317,  3477,  3663,
    2566,  4056,  2568,  2563, -2276,  2570,  2587,  4317,  2577,    38,
    2571,  2582,  2593,  2601,  2597,  2588,  2590,  4176,  1135,  2609,
     726,  2612,  3534,  2630,  1143,  2680,  1147,  2685, -2200,  2686,
    2697,  2625,  2694,  1684,  2698,  2710,   726,  2752,  2749,    42,
    3114,  2770,  2763,  2774,  2771,  2775,  1685,  3558,  3559,  3560,
    3561,  2776,  2778,  2779,  2780,  2781,  1660,  2782,  2788,  2790,
    2795,  4363,  2799,  2802,  2803,  2833,  2804,  3962,  2805,  2847,
    3565,  4125,  3568,  4126,  4127, -2200,  2806,    46,  2807,  4238,
    4240,   612,  2813,  2808,  2862,  4130,  3733, -2200,  2849,  3736,
      47,  2856, -2200,  2872,  2865,  4232,  1678, -2200,  2870,  2881,
    1679,  2871, -2200,  2883,  2900, -2200,  2886, -2200,  2898,  2902,
    2901,  2904,  2905,  2914,  2919,  2920,  2926,  2917,  2929,  2927,
    2928,  1680,  1681,  2497, -2276,  2938,   613,  2312,  2948,  2954,
    2956,  3999,  2951,  2962, -2200,  2959,  1671,  1529,  1682,  1672,
    2931,  3562,  3563,  3564,  1004,  2960,  2373,  2373,  2963,  2964,
    2978,  2982,  2979,  2981,  3029,  4424, -2200,  3048,  2983,  3824,
    3017,  3043,  2257,  2986,  1683,  1675,  3063,  1684,  3070,  3100,
    2987,  1676,  2989,  2992,  3010,  -978,  3016,  3094,  3121,  3126,
    1685,  3018,  4030,  1686,  3019,  3026,  3041,  3042,  3099,  3056,
    3066,  3130,  3068, -2200,  3069,  1677,  3142,  3827,  3124,  3148,
    3158, -2200,  3136,  3151,  3153,  3154,  4307,  3159,  3162,  3165,
    4076,  3200,  4175,  3323,  3658,  3659,  3660,  3661,   925,  4180,
    3167,  1691,  1692,  1693,  1694,  1695,  1696,  3174,  3189,  3206,
    3190,  3201,  3205,  3215,  3217,  3230,  4184,  3715,  3714,  3257,
    3716,  3256,  3717,  3260,  3263,  3273,  3262,  3278,   642, -2200,
    3264,  3271,  3272,  3274,  3275,  4369,  3276,  4229,  1687,  3277,
    3279,  3280,  3291,  3281,  3282,  3284,  3283,  3289,  3285,  3286,
    3293,   642,  3295,  2937,  2078,  3297,  3303,  3309,  3310,  3313,
    3325,  3328,  3329,  2785,  4352,  3340,  3345,  3341,  4355,  2785,
    2785,  3378,  2129,  2143,   655,  3346,  3387,  1678,  3391,  3377,
    3384,  1679,  3389,  3411,  3415,  4359,  3412,  4361,  3438,  3455,
    3445,  3399,  3447,  3406,  3456,  3418,  3400,  1583, -2200,  3408,
    3457,  3460,  1680,  1681,  3465,  3466,  3467,  3789,  3791,  3793,
    3795,  3478,   992,   993,  3483,  1671,  3013,  4302,  1672,  1682,
    2995,  1604, -2200,  3778, -2200, -2200,  3012,  1665,  3513,  3514,
    3541,  1688,  1689,  1690,  3515,  1691,  1692,  1693,  1694,  1695,
    1696,  3521,  3788,  2486,  1675,  1683,   733,  3567,  1684,  2487,
    1676,  3529,  3594,  3542,  3575,  4416,  3550,  3554,  3589, -2200,
    3603,  1685, -2200, -2200, -2200,  3610,  3626,  3633,  3654,  3803,
    3656,  3657,  3669,  4333,  1677,  3591,  3668,  3604,  3854,  3670,
    3606,  3607,  3671,  3673,  3682,   169,  3851,  3092,  3785,  3695,
    4232,  3092,  3696,  4554,   811,  3698,  3697,  4312,  3710,  3711,
    3708,  3709,  3712,  4283,  3713,  3721,  3728,  3811,  3722,  3992,
    3744,   651,   652,  4364,  3746,  3677,   658,  3749,  3755,  4192,
    3757,   669,   677,   651,  3758,   684,  3781,  3782,   677,   677,
    3783,   712,  3802,   715,  3828,  3430,  3810,  4007,  3887,  1687,
    3813,  3818,  3820,  4554,  2269,  3825,  3830,  3829,  3846,  3848,
    3849,  4554,  4209,  3863,  3871,   642,  4022,  3832,  3833,  3859,
    3860,  4214,  3865,  3876,  3878,  3880,  3881,  3882,  3883,  3884,
    3892,  3901,  3902,  3903,  3904,  3889,  1678,  3940,  3941,  3948,
    1679,  3896,  2373,  3897,  3905,  3953,  4017,   925,  3909,  3954,
    3925,  4144,  3935,  3963,  3966,  3936,  3956,  3938,  4027,  3972,
    3969,  1680,  1681,  3951,  4041,  2891,  3957,  3958,  2373,  2373,
    3974,  3979,  3980,  3988,  4010,  4011,  4012,  4023,  1682,  4003,
    4026,  4004,  4032,  4037,  1244,  4044,  4068,  4065,  4069,  4077,
    4087,  4082,  1688,  1689,  1690,  4089,  1691,  1692,  1693,  1694,
    1695,  1696,  4093,  4095,  4104,  3083,  4106,  1684,  4114,  3083,
    4112,  4542,  4115,  4123,  4129,  4137,  1245,  4138,  4140,  4145,
    1685,  4147,  4148,  3960,  3961,  4156,  4149,  4150,   768,   773,
     773,   776,  4162,   773,  4172,   782,  3973,   768,  4169,   712,
    4178,  4198,   813,  4182,   169,  3964,  4225,   712,  4186,  3971,
     712,  4201,  4202,  4211,   773,  4216,   712,  4217,  4226,  4230,
    4244,  4237,  3929,  3930,  3931,  3932,  3809,  4251,  4253,  4276,
    4254,  4256,  1246,  4257,  4277,  4281,  4285,  1671,  4286,  4275,
    1672,  4258,   642,  4308,  4279,  4079,  4311,  4315,  4326,  4320,
    4346,  4330,  4336,  4344,  4374,  4358,  4379,  1673,  1687,  4383,
    4384,  4005,  4386,  4388,  1247,  4394,  1675,  4389,  4401,  4403,
    4402,  1583,  1676,  4408,  4422,  4414,  4409,  4427,  4415,  4428,
    4430,  4426,  4439,  4443,  4353,  1269,  4449,  4451,  4452,  4455,
    2937,  1270,  4457,  2892,   642,  4465,  1677,  4460,  4537,  4472,
    1248,  4466,  4473,  4487,  3555,  4501,  4494,  4505,  4496,  4453,
    4513,  4454,  4512,  4517,  4020,  4021,  4545,  4562,  4565,  4024,
    4025,  4531,  4571,  4575,  1183,  2092,  2851,  4039,  4040,  1305,
    1249,  1736,  1271,  3107,  3212,  1330,  3687,  2785,  2785,  4435,
    1329,  2762,  2684,  3312,   924,  3761,  4231,  2373,  4058,  4365,
    4278,  1688,  1689,  1690,  4450,  1691,  1692,  1693,  1694,  1695,
    1696,  3821,  4280,  4074,  4035,  1266,  4266,  3092,  4071,  3156,
    4497,  2925,  3092,  4190,  4540,  4458,  4456,  3092,  4038,   642,
    3092,  1272,  2937,  4511,  2937,  4397,   811,  3161,  1273,  2831,
    3817,  1274,  2832,  3685,  3224,    33,  4432,  2181,  1678,  1252,
    2814,   642,  1679,  3395,  4544,  1253,  4576,  4572,  4255,  3326,
    3092,  4515,  1254,  4097,  3342,  4215,  2164,  3114,  4445,  4218,
    1977,  4502,   925,  1680,  1681,   657,  3877,  1578,   811,  1256,
    4331,  1587,  3855,  2538,  3143,  3856,  4407,  1257,   926,  4116,
    1682,  1244,  3292,  4573,  4524,  1275,  2492,  1156,  2493,  2260,
    3111,  3839,  4213,  1177,  3965,  3112,  1834,  3620,  2517,  3122,
    1863,  3887,  3887,  3887,  3887,  1862,  1683,  3120,  2516,  1684,
    1867,  4099,  3135,  1245,  3570,  3123,  3934,  4322,  3946,  1872,
    3566,  4421,  1685,  1164,  4420,  1686,  3621,  2800,  3533,  1258,
    4306,  3523,  4490,  2894,  3430,  4491,  4486,  3115,   786,  3059,
    3061,  2973,  1276,  3617,  1277,  2469,     0,     0,     0,     0,
       0,     0,     0,  1583,  1278,     0,     0,     0,     0,     0,
       0,  1671,  1279,     0,  1672,     0,     0,  4122,     0,  1246,
    3083,     0,  1280,     0,   844,  3083,     0,     0,  3083,   712,
       0,   768,     0,     0,   773,     0,   776,  3092,   773,  3288,
    1675,     0,     0,     0,     0,   813,  1676,     0,   901,     0,
    1687,  1247,     0,     0,     0,   773,     0,     0,  1282,  1283,
       0,     0,     0,     0,     0,  1671,     0,     0,  1672,  4183,
    1677,     0,     0,     0,     0,     0,     0,  1583,   768,     0,
    3323,  1583,  1583,   776,  1284,  1673,     0,  1248,   768,     0,
       0,  3092,   813,     0,  1675,     0,     0,     0,     0,     0,
    1676,     0,     0,     0,  4193,  4195,  4195,   773,     0,     0,
       0,     0,     0,     0,  2785,   642,     0,  1249,     0,     0,
       0,     0,     0,   924,  1677,     0,     0,  4235,     0,  4236,
       0,     0,     0,  4241,  4242,     0,     0,     0,     0,     0,
       0,     0,  1285,  1688,  1689,  1690,     0,  1691,  1692,  1693,
    1694,  1695,  1696,     0,     0,   712,     0,     0,     0,     0,
    2988,     0,     0,     0,     0,     0,   712,  1018,     0,   169,
    4270,     0,  1678,     0,     0,     0,  1679,     0,  4385,     0,
       0,     0,    33,     0,  1976,     0,  1252,  1130,     0,   712,
     677,     0,  1253,     0,   677,     0,     0,  1680,  1681,  1254,
       0,     0,     0,     0,     0,     0,     0,  1977,   712,     0,
       0,     0,   712,     0,  1682,     0,  1256,     0,  1130,  1671,
       0,     0,  1672,  4247,  1257,     0,  1678,     0,     0,   712,
    1679,     0,     0,   811,     0,     0,  3092,     0,  4290,     0,
       0,   712,     0,  1684,     0,  1939,     0,     0,  1675,  3083,
       0,  1680,  1681,     0,  1676,     0,  1685,     0,     0,     0,
    1135,     0,     0,     0,     0,     0,     0,     0,  1682,     0,
       0,     0,     0,     0,     0,     0,  1258,     0,  1677,  1940,
       0,     0,     0,   712,     0,     0,     0,     0,     0,     0,
       0,     0,  1941,     0,  1683,     0,   712,  1684,   773,   773,
    4366,     0,     0,     0,     0,  1942,     0,     0,     0,     0,
    1685,     0,     0,  1686,     0,     0,  4468,     0,  4337,     0,
     677,   677,     0,     0,     0,     0,     0,  3092,  2937,     0,
       0,     0,     0,     0,  1687,     0,     0,     0,     0,     0,
    3057,     0,     0,  1943,   768,     0,     0,  4360,     0,  4362,
       0,     0,  4340,     0,  1944,   768,     0,   169,  4395,   813,
       0,     0,  4500,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   773,     0,  1945,     0,     0,     0,     0,  1946,
   -2276,     0,     0,     0,  1679,     0,     0,   712,  1687,     0,
       0,     0,     0,   773,   773,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1680,  1681,     0,     0,   712,
     712,   712,     0,   773,     0,   768,     0,     0,     0,     0,
       0,     0, -2276,     0,     0,     0,     0,     0, -2276, -2276,
       0,  1691,  1692,  1693,  1694,  1695,  1696,     0,   924,     0,
       0,   773,     0,   773,   773,     0,  1947,     0,     0,     0,
       0,  1684,     0,     0,     0,     0,     0,     0,  4195,     0,
       0,     0,     0,     0,  1685,     0,  1130,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1948,     0,     0,
       0,  1688,  1689,  1690,     0,  1691,  1692,  1693,  1694,  1695,
    1696,     0,     0,  4574,  1670,     0,  1561,  1561,  3036,  1671,
       0,   712,  1672,   651,     0,     0,   194,     0,     0,     0,
       0,     0,     0,  4464,     0,     0,     0,     0,     0,  1673,
       0,  1593,     0,  1674,   712,     0,     0,  1599,  1675,     0,
       0,     0,     0,     0,  1676,     0,     0,     0,     0,  1949,
    1130,     0, -2276,     0,     0,  1950,   169,  4516,  1951,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1677,   169,
    4529,   173,  4526,  4527,  4528,  1269,  4561,     0,     0,  1130,
       0,  1270,     0,  4504,  1952,     0,     0,     0,     0,     0,
    1953,     0,     0,     0,     0,     0,     0,  4553,     0,     0,
       0,     0,     0,  1954,     0,     0,     0,  1130,  1130,     0,
    1130,     0,  4560,  4529,   173,  4526,  4527,  4528,     0,     0,
       0,     0,  1271,     0,     0,     0,     0,     0,  1955,  1130,
       0,     0,  4552,     0,     0,  4543,     0,     0,  1671,     0,
       0,  1672,     0,     0,     0,     0,     0,  4553,     0,  1691,
    1692,  1693,  1694,  1695,  1696,  4553,     0,     0,  1673,   169,
    4529,   173,  4526,  4527,  4528,     0,   712,  1675,     0,  1130,
    1678,  1272,     0,  1676,  1679,     0,     0,     0,  1273,     0,
       0,  1274,  4552,     0,     0,     0,     0,     0,     0,     0,
    4552,     0,     0,     0,     0,  1680,  1681,  1677,  1130,     0,
       0,     0,  1130,  1130,     0,     0,     0,     0,     0,     0,
       0,     0,  1682,   712,   712,  1875,     0,  1671,     0,     0,
    1672,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   677,     0,     0,     0,  1275,     0,     0,  1683,     0,
       0,  1684,     0,     0,     0,     0,  1675,     0,     0,     0,
       0,     0,  1676,     0,  1685,     0,     0,  1686,     0,     0,
       0,     0,     0,     0,   677,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1677,   712,  1991,     0,
       0,     0,     0,     0,   712,     0,     0,   773,     0,     0,
       0,     0,  1276,     0,  1277,     0,     0,     0,     0,  1678,
       0,     0,     0,  1679,  1278,     0,     0,     0,     0,   813,
       0,     0,  1279,     0,     0,   712,     0,     0,   712,     0,
       0,     0,  1280,     0,  1680,  1681,     0,     0,     0,     0,
       0,     0,  1687,     0,     0,     0,     0,     0,  3547,     0,
       0,  1682,   712,     0,     0,     0,     0,     0,     0,     0,
     773,   773,   773,   773,   712,  1281,     0,     0,  1282,  1283,
       0,     0,     0,     0,     0,   677,     0,  1683,   712,     0,
    1684,     0,     0,     0,     0,     0,     0,     0, -2276,  2104,
       0,   712,  1679,  1685,  1284,     0,  1686,     0,     0,     0,
       0,   773,   773,     0,     0,     0,     0,   773,     0,     0,
       0,     0,     0,  1680,  1681,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
   -2276,     0,     0,     0,     0,  1688,  1689,  1690,     0,  1691,
    1692,  1693,  1694,  1695,  1696,     0,     0,     0,     0,     0,
       0,   773,  1285,     0,     0,     0,     0,     0,     0,  1684,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1687,  1685,     0,     0,     0,     0,     0,   773,   773,
     773,   773,     0,     0,     0,     0,     0,     0,     0,     0,
     712,     0,     0,     0,     0,  2891,   712,     0,     0,  2104,
       0,     0,     0,     0,     0,     0,     0,     0,   768,     0,
       0,     0,     0,     0,  1244,   776,  1671,   768,     0,  1672,
       0,     0,     0,     0,     0,     0,     0,   813,     0,     0,
       0,     0,   773,     0,     0,     0,  1673,     0,     0,     0,
       0,   773,     0,     0,     0,  1675,  1245,   773,   773,     0,
   -2276,  1676,   712,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1688,  1689,  1690,     0,  1691,  1692,
    1693,  1694,  1695,  1696,     0,  1677,     0,  1561,  2404,     0,
       0,     0,     0,     0,   773,     0,   768,     0,     0,     0,
     712,   712,     0,   773,     0,     0,     0,     0,     0,   712,
       0,     0,  1246,     0,     0,     0,   712,     0,     0,     0,
       0,     0,     0,   651,   651,     0,     0,  2314,     0,     0,
       0,  1130,     0,  1130,     0,     0,     0,     0,     0,     0,
    1130,     0,     0,  1130,  1247,     0,     0,  1130,     0,     0,
       0,     0,     0,     0,     0,  1130,  1130,  1691,  1692,  1693,
    1694,  1695,  1696,  1130,     0,   813,  1130,  1130,  1130,  1130,
       0,     0,     0,  2892,     0,     0,  1130,  1130,     0,  1130,
    1248,  1130,  1130,     0,     0,  1130,     0,  1678,     0,     0,
       0,  1679,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1130,     0,     0,     0,   773,  1130,     0,     0,
    1249,  1130,  1680,  1681,     0,  1130,     0,  1130,  1130,  1130,
    1130,  1130,  1130,  1130,  1130,  1130,     0,  1130,     0,  1682,
       0,     0,     0,   712,     0,  1130,  1130,     0,     0,     0,
       0,     0,   712,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1683,     0,     0,  1684,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1685,     0,     0,  1686,    33,     0,     0,     0,  2893,
       0,  -121,     0,     0,     0,  1253,     0,     0,     0,     0,
       0,     0,  1254,     0,     0,     1,     0,     0,     0,     0,
    1977,     0,     0,     0,     0,     2,     0,     3,     4,  1256,
       0,     0,     0,     0,  1269,     0,     0,  1257,     0,     0,
    1270,  1671,     0,     5,  1672,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1673,     0,     6,     0,     7,     8,     0,     0,  1687,
    1675,     9,     0,    10,     0,     0,  1676,     0,   712,     0,
     712,  1271,  1130,    11,     0,    12,     0,     0,     0,  1258,
       0,     0,     0,  2894,     0,     0,     0,     0,     0,     0,
    1677,    13,     0,     0,    14,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    15,   712,    16,     0,
       0,     0,    17,  2524,     0,  2531,     0,     0,    18,     0,
    1272,     0,     0,     0,     0,     0,    19,  1273,    20,     0,
    1274,     0,     0,     0,    21,     0,     0,     0,     0,     0,
       0,     0,     0,   776,     0,     0,     0,     0,   651,    22,
     651,     0,  1688,  1689,  1690,     0,  1691,  1692,  1693,  1694,
    1695,  1696,     0,     0,     0,     0,  3327,  1130,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   768,     0,
     773,   773,   773,     0,  1275,   768,     0,   813,     0,   773,
       0,   773,  1678,   773,   773,     0,  1679,   712,     0,     0,
       0,     0,     0,     0,    23,    24,     0,     0,     0,     0,
      25,     0,     0,     0,     0,     0,   677,  1680,  1681,    26,
       0,     0,     0,     0,     0,     0,  1991,     0,     0,     0,
      27,     0,     0,  2642,  1682,     0,     0,     0,  2651,     0,
       0,  1276,     0,  1277,   712,     0,     0,     0,     0,     0,
       0,     0,     0,  1278,     0,  2891,     0,     0,     0,     0,
    1683,  1279,   712,  1684,     0,     0,  2692,  2692,    28,     0,
       0,  1280,     0,   776,  1244,     0,  1685,     0,     0,  1686,
      29,     0,     0,     0,     0,    30,    31,     0,    32,     0,
     773,     0,     0,    33,     0,     0,     0,  1269,    34,     0,
       0,    35,     0,  1270,  1334,    36,  1245,  1282,  1283,     0,
      37,    38,     0,     0,     0,     0,     0,  2751,    39,  2754,
    2756,    40,     0,     0,     0,     0,     0,     0,     0,    41,
       0,     0,     0,  1335,     0,     0,     0,     0,     0,     0,
       0,    42,     0,     0,  1271,     0,     0,   773,     0,     0,
       0,     0,     0,     0,  1687,   773,     0,     0,    43,     0,
     773,     0,  1246,     0,     0,     0,     0,     0,    44,     0,
       0,     0,     0,  1130,    45,     0,     0,     0,     0,    46,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1285,    47,  1272,  1247,     0,     0,     0,     0,     0,
    1273,  1991,     0,  1274,  2692,     0,   712,     0,  2852,     0,
       0,   651,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2892,     0,     0,     0,     0,    48,     0,
    1248,  -121,     0,     0,     0,     0,     0,  2751,  1671,     0,
       0,  1672,     0,     0,     0,   773,  2877,  1688,  1689,  1690,
       0,  1691,  1692,  1693,  1694,  1695,  1696,  1275,  1673,     0,
    1249,  3485,     0,     0,     0,     0,     0,  1675,     0,     0,
       0,     0,   773,  1676,   773,  2692,   773,  2692,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1130,  1677,     0,  1269,
       0,     0,     0,     0,     0,  1270,     0,     0,  1561,     0,
       0,     0,     0,     0,  1276,     0,  1277,     0,     0,     0,
       0,     0,     0,     0,     0,    33,  1278,  1671,     0,  1252,
    1672,     0,     0,     0,  1279,  1253,     0,     0,     0,     0,
       0,     0,  1254,     0,  1280,     0,  1271,  1673,     0,     0,
    1977,     0,     0,     0,   768,     0,  1675,     0,     0,  1256,
     768,     0,  1676,     0,     0,     0,     0,  1257,     0,     0,
       0,   773,     0,     0,     0,     0,     0,  1360,  1130,  1130,
    1282,  1283,     0,     0,  1130,  1430,  1677,     0,     0,     0,
       0,     0,     0,     0,     0,  1272,     0,     0,     0,  1678,
       0,     0,  1273,  1679,     0,  1274,  1361,     0,     0,  1130,
    1130,     0,     0,     0,  1130,     0,     0,     0,     0,  1258,
    1244,     0,     0,  2894,  1680,  1681,  1130,  1130,  1130,  1130,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1130,
       0,  1682,  1130,     0,  1130,  3040,     0,     0,     0,     0,
       0,     0,  1245,     0,  1130,  1130,     0,     0,  1130,  1275,
       0,     0,     0,     0,  1285,     0,     0,  1683,     0,     0,
    1684,  1130,     0,  1130,     0,   813,     0,  1130,     0,     0,
       0,     0,     0,  1685,     0,     0,  1686,     0,  1678,     0,
       0,     0,  1679,     0,     0,     0,  1130,     0,     0,     0,
     712,     0,     0,     0,     0,     0,  3093,     0,  1246,  1130,
    1130,  1130,     0,  1680,  1681,     0,  1276,  1430,  1277,     0,
       0,     0,     0,     0,     0,     0,  1130,     0,  1278,     0,
    1682,     0,     0,     0,     0,     0,  1279,     0,  1130,     0,
    1247,     0,     0,  1130,     0,     0,  1280,     0,     0,  1130,
       0,     0,     0,     0,     0,     0,  1683,  3093,     0,  1684,
    3129,  1687,     0,     0,  2531,     0,     0,  1671,     0,     0,
    1672,     0,  1685,     0,     0,  1686,  1248,     0,     0,  1959,
       0,     0,  1282,  1283,     0,     0,     0,  1673,     0,     0,
       0,     0,     0,     0,     0,     0,  1675,     0,     0,     0,
       0,     0,  1676,     0,     0,  1130,  1249,  2692,  1960,     0,
       0,     0,  1561,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1677,     0,     0,     0,
       0,     0,     0,     0,  1250,     0,     0,     0,   773,     0,
     773,   773,   773,     0,     0,     0,     0,     0,     0,     0,
    1687,     0,     0,     0,  1688,  1689,  1690,     0,  1691,  1692,
    1693,  1694,  1695,  1696,     0,     0,  1285,  1251,  3532,     0,
       0,    33,     0,     0,     0,  1252,     0,     0,     0,     0,
       0,  1253,     0,     0,     0,     0,     0,     0,  1254,     0,
       0,     0,     0,     0,     0,     0,  1255,     0,     0,     0,
       0,     0,     0,     0,     0,  1256,     0,     0,     0,     0,
       0,     0,     0,  1257,     0,  1891,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1678,     0,
       0,     0,  1679,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1688,  1689,  1690,     0,  1691,  1692,  1693,
    1694,  1695,  1696,  1680,  1681,     0,     0,  3609,     0,     0,
       0,     0,     0,     0,     0,  1258,     0,     0,  1671,  1891,
    1682,  1672,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1683,  1675,     0,  1684,
       0,     0,     0,  1676,  1430,     0,     0,     0,     0,     0,
       0,     0,  1685,     0,     0,  1686,     0,     0,     0,  2692,
    2692,     0,     0,     0,     0,     0,     0,  1677,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1671,     0,     0,
    1672,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1673,     0,     0,
       0,     0,   712,   712,     0,     0,  1675,     0,     0,     0,
    1430,     0,  1676,     0,     0,     0,     0,     0,   712,  3548,
    1687,     0,     0,     0,     0,     0,     0,     0,     0,  1891,
       0,  1561,   712,     0,     0,     0,  1677,     0,     0,     0,
    1561,   712,     0,     0,     0,     0,  1429,     0,     0,  1430,
       0,     0,     0,     0,     0,   712,     0,     0,     0, -2276,
       0,     0,     0,  1679,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1430,     0,     0,     0,     0,     0,
       0,     0,     0,   773,  1680,  1681,   773,     0,     0,     0,
       0,     0,     0,   567,     0,     0,     0,     0,     0,   610,
     768, -2276,     0,     0,     0,     0,     0,     0,   660,     0,
       0,     0,     0,  1688,  1689,  1690,     0,  1691,  1692,  1693,
    1694,  1695,  1696,   712,     0,  3605,     0,   724,     0,     0,
    1684,  1430,     0,   773,     0,     0,     0,     0,  1678,     0,
       0,  1130,  1679,  1685,     0,     0,     0,     0,     0,     0,
       0,  1130,     0,     0,     0,     0,     0,  1130,     0,  1130,
       0,     0,     0,  1680,  1681,  1130,     0,     0,  1130,  1130,
    1130,  1130,  1130,  1130,  1130,  1130,  1130,  1130,  1429,     0,
    1682,  1130,  1130,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1130,     0,     0,     0,  1130,     0,
       0,     0,  1130,     0,     0,     0,  1683,     0,     0,  1684,
       0,     0,  1130,     0,     0,  1130,     0,  1130,     0,     0,
       0, -2276,  1685,     0,     0,  1686,  1130,  1130,  1130,     0,
       0,     0,  1130,     0,     0,  1130,     0,     0,     0,  3557,
       0,     0,     0,     0,     0,     0,   712,   712,   712,   768,
       0,  3093,  3574,     0,     0,     0,  3574,  3588,     0,  1269,
       0,     0,     0,  1130,     0,  1270,   781,     0,     0,  1130,
    1130,     0,     0,     0,     0,     0,   816,   817,     0,   820,
       0,     0,   826,     0,   828,     0,     0,     0,     0,     0,
       0,     0,     0,  1130,     0,     0,     0,     0,     0,  1130,
    1687,     0,     0,  2531,     0,  1130,  1271,     0,  1430,     0,
       0,     0,     0,  1723,     0,     0,     0,     0,  1691,  1692,
    1693,  1694,  1695,  1696,     0,     0,     0,  3641,  1561,  1561,
       0,  2104,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2479,     0,     0,     0,     0,     0,   773,
     773,   773,   773,     0,     0,  1272,     0,     0,     0,     0,
       0,     0,  1273,     0,     0,  1274,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1429,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  3684,     0,     0,     0,
       0,     0,     0,  1688,  1689,  1690,     0,  1691,  1692,  1693,
    1694,  1695,  1696,     0,     0,     0,     0,  3635,     0,  1671,
       0,     0,  1672,     0,     0,     0,     0,     0,     0,  1275,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1429,     0,     0,     0,     0,     0,     0,     0,  1675,     0,
       0,     0,     0,     0,  1676,     0,  1671,     0,     0,  1672,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  3750,     0,     0,  1429,  1673,     0,  1677,     0,
       0,     0,     0,     0,     0,  1675,  1276,     0,  1277,     0,
       0,  1676,     0,     0,     0,     0,     0,     0,  1278,     0,
       0,     0,     0,     0,     0,     0,  1279,     0,     0,     0,
       0,     0,     0,     0,     0,  1677,  1280,     0,     0,     0,
       0,     0,     0,   712,     0,     0,     0,  2534,     0,     0,
       0,  1891,  2540,     0,   773,     0,  1130,     0,     0,     0,
    3551,     0,   712,     0,     0,     0,     0,     0,  3816,  2024,
       0,  1429,  1282,  1283,     0,     0,     0,  1991,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   712,
    1429,     0,     0,     0,     0,     0,     0,     0,  2025,  2751,
   -2276,     0,     0,     0,  1679,  3844,     0,     0,     0,     0,
    1429,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1130,  1130,     0,     0,  1680,  1681,     0,     0,     0,
       0,     0,     0,     0,     0,  1429,     0,  1678,     0,     0,
       0,  1679, -2276,   878,  2692,     0,  2692,     0,     0,     0,
       0,   886,     0,     0,     0,     0,  1285,  1430,     0,     0,
     902,   903,  1680,  1681,     0,   905,     0,     0,     0,     0,
       0,  1684,     0,     0,     0,     0,   921,     0,     0,  1682,
    1130,     0,     0,     0,  1685,     0,     0,     0,     0,     0,
     929,  1269,  1429,     0,     0,     0,     0,  1270,     0,     0,
       0,     0,     0,     0,     0,  1683,   952,     0,  1684,   954,
       0,   956,     0,   959,     0,     0,     0,  1130,     0,     0,
       0,  1685,     0,     0,  1686,     0,     0,  1130,  1130,     0,
       0,     0,     0,     0,     0,  1130,  1130,     0,  1271,     0,
    1130,     0,     0,     0,     0,     0,  1130,  1130,     0,     0,
    1130,     0,     0,  1130,  3928,     0,     0,   712,   712,   712,
     712,     0, -2276,     0,  3574,  3588,     0,  3574,     0,     0,
    3937,     0,     0,  1015,  3093,  1016,     0,     0,  3093,     0,
       0,     0,     0,     0,  3950,     0,     0,  1272,     0,     0,
    1130,     0,     0,     0,  1273,  1130,     0,  1274,     0,  1687,
    1130,     0,  1430,     0,     0,     0,   813,     0,     0,     0,
       0,     0,     0,     0,  3129,     0,     0,     0,  2531,  1671,
       0,     0,  1672,     0,     0,     0,     0,     0,     0,     0,
       0,   724,   651,     0,     0,  1130,     0,     0,     0,  1673,
       0,     0,     0,     0,     0,     0,     0,     0,  1675,     0,
       0,  1275,     0,     0,  1676,  2692,  2692,     0,     0,  1691,
    1692,  1693,  1694,  1695,  1696,     0,     0,     0,     0,  1429,
       0,     0,     0,     0,     0,     0,     0,     0,  1677,  4006,
       0,  1891,     0,     0,     0,     0,     0,     0,     0,  1235,
       0,     0,  1688,  1689,  1690,     0,  1691,  1692,  1693,  1694,
    1695,  1696,     0,     0,     0,     0,  3890,     0,  1276,     0,
    1277,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1278,     0,     0,     0,     0,     0,     0,     0,  1279,   773,
       0,     0,     0,     0,     0,     0,     0,     0,  1280,     0,
       0,     0,     0,   773,  1363,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1375,
       0,     0,     0,     0,     0,     0,  1430,     0,     0,     0,
       0,  2637,  1385,     0,  1282,  1283,     0,     0,     0,  1387,
    1678,     0,     0,     0,  1679,     0,     0,     0,     0,     0,
       0,  1435,     0,     0,  1439,     0,     0,     0,     0,     0,
    1284,  1130,     0,     0,     0,  1680,  1681,     0,     0,     0,
       0,     0,   768,     0,     0,     0,     0,  1991,     0,     0,
       0,     0,  1682,     0,  1561,     0,     0,  1482,     0,     0,
       0,     0,     0,     0,     0,     0,   773,  1991,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1683,     0,
       0,  1684,     0,     0,     0,     0,     0,     0,  1285,     0,
       0,     0,   712,  1269,  1685,     0,     0,  1686,     0,  1270,
       0,     0,     0,     0,     0,     0,     0,     0,  1429,     0,
       0,     0,  1429,  1429,     0,     0,     0,     0,     0,     0,
       0,  1130,     0,     0,     0,     0,     0,     0,     0,     0,
    1130,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1271,     0,     0,     0,     0,     0,     0,  1130,  1130,     0,
       0,  1130,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   768,  3574,  2479,  2479,  2479,  3093,
       0,     0,  1687,     0,  3093,     0,     0,  3093,  2751,     0,
    4174,     0,  1130,  1130,     0,     0,     0,     0,     0,  1272,
       0,  1269,  1671,     0,     0,  1672,  1273,  1270,     0,  1274,
       0,     0,     0,     0,     0,     0,     0,  3641,   813,   773,
     773,   773,  1673,     0,     0,     0,     0,     0,  1429,     0,
       0,  1675,     0,     0,     0,     0,     0,  1676,     0,  1891,
       0,     0,  2540,     0,  2540,     0,     0,     0,  1271,  1891,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   768,
     813,  1677,     0,  1275,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1688,  1689,  1690,     0,  1691,
    1692,  1693,  1694,  1695,  1696,     0,     0,     0,  1671,  3924,
       0,  1672,     0,     0,     0,     0,     0,  1272,     0,  1430,
    1561,  1561,     0,     0,  1273,   768,     0,  1274,   712,     0,
       0,     0,     0,     0,     0,     0,     0,  1675,     0,  3816,
    1276,     0,  1277,  1676,     0,     0,  2692,     0,   724,  1836,
    1991,  1671,  1278,     0,  1672,     0,     0,     0,     0,  1891,
    1279,     0,  3844,     0,     0,   712,     0,  1677,     0,     0,
    1280,  1673,     0,   773,  3641,     0,     0,     0,     0,     0,
    1675,  1275,     0,  1678,     0,     0,  1676,  1679,     0,     0,
       0,     0,     0,  1429,     0,     0,  1130,     0,     0,  1130,
       0,  1130,     0,  2726,     0,     0,  1282,  1283,  1680,  1681,
    1677,  1957,     0,     0,     0,     0,     0,     0,     0,     0,
    1430,     0,  1430,     0,  1130,  1682,     0,     0,  3093,  3922,
       0,  4174,  2727,     0,     0,     0,     0,  4329,  1276,     0,
    1277,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1278,  1683,     0,   773,  1684,     0,     0,   712,  1279,     0,
       0,     0,     0,     0,     0,     0,     0,  1685,  1280, -2276,
    1686,     0,  1429,  1679,     0,     0,     0,  1430,     0,     0,
       0,   773,   773,   773,   773,     0,     0,     0,     0,     0,
    1285,     0,     0,     0,  1680,  1681,  1561,     0,     0,     0,
       0,  2765,  1430,     0,  1282,  1283,     0,     0,     0,     0,
       0, -2276,  1678,     0,     0,   768,  1679,     0,     0,     0,
       0,  2540,     0,     0,     0,     0,     0,     0,     0,     0,
    2766,     0,     0,     0,  1130,     0,     0,  1680,  1681,  2540,
    1684,     0,     0,     0,     0,  1687,     0,     0,     0,     0,
       0,     0,     0,  1685,  1682,     0,     0,  1429,     0,     0,
       0,     0,  1671,     0,     0,  1672,     0,     0,     0,     0,
    1130,     0,     0,   768,     0,     0,     0,     0,     0,     0,
    1683,     0,  1673,  1684,     0,     0,     0,     0,  1285,     0,
       0,  1675,     0,   773,     0,   813,  1685,  1676,     0,  1686,
       0,     0,     0,  1430,     0,  1130,     0,     0,     0,     0,
       0,     0,  2160,     0,     0,     0,     0,     0,     0,  2540,
       0,  1677,     0,     0,     0,     0,     0,  2183,     0,     0,
    1430, -2276,     0,     0,     0,     0,     0,     0,  1688,  1689,
    1690,     0,  1691,  1692,  1693,  1694,  1695,  1696,   773,     0,
       0,     0,  4146,   768,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  3641,     0,     0,  2228,     0,     0,
       0,     0,     0,     0,  1687,     0,  1130,  1130,     0,     0,
       0,  2751,  2243,     0,  2245,  4329,  2246,     0,     0,     0,
       0,  2247,     0,     0,     0,     0,     0,     0,     0,   768,
       0,  1430,     0,     0,     0,     0,     0,     0,   773,     0,
    1269,     0,     0,     0,     0,     0,  1270,     0,     0,     0,
       0,  1430,     0,  1678,     0,     0,     0,  1679,  1691,  1692,
    1693,  1694,  1695,  1696,  1836,     0,     0,     0,  1836,  1130,
    1836,     0,  1310,  1836,     0,     0,  1430,     0,  1680,  1681,
       0,     0,     0,  1130,     0,     0,     0,  1271,     0,     0,
     773,     0,     0,     0,     0,  1682,     0,  1688,  1689,  1690,
       0,  1691,  1692,  1693,  1694,  1695,  1696,     0,     0,     0,
       0,  4155,  1430,     0,     0,     0,     0,     0,  1311,     0,
    1429,  1683,     0,  1429,  1684,  1429,     0,     0,     0,     0,
    1429,     0,     0,     0,     0,     0,  1272,  1685,     0,     0,
    1686,     0,     0,  1273,     0,     0,  1274,     0,     0,     0,
       0,  1130,     0,     0,     0,     0,     0,  2479,     0,     0,
     768,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1429,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1312,  1891,     0,
    1275,     0,     0,     0,     0,     0,     0,  1671,     0,     0,
    1672,     0,     0,     0,     0,  1687,     0,     0,     0,     0,
    1429,     0,     0,     0,     0,     0,     0,  1673,     0,     0,
       0,     0,     0,     0,     0,     0,  1675,     0,     0,     0,
       0,     0,  1676,     0,     0,  1313,     0,  1314,     0,     0,
       0,     0,  1269,     0,     0,     0,     0,  1315,  1270,  1277,
       0,     0,     0,     0,     0,     0,  1677,     0,     0,  1278,
       0,     0,     0,     0,     0,     0,     0,  1279,     0,     0,
       0,  1429,     0,  1429,     0,  1421,  1316,  1280,     0,  2540,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1271,
       0,     0,     0,     0,     0,     0,     0,     0,  1688,  1689,
    1690,     0,  1691,  1692,  1693,  1694,  1695,  1696,     0,     0,
    1317,     0,  4188,  1282,  1283,  1318,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1429,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1272,  1319,
       0,     0,     0,     0,     0,  1273,     0,     0,  1274,     0,
    1320,     0,     0,  1429,     0,     0,     0,     0,  1678,     0,
       0,     0,  1679,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1429,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1680,  1681,     0,  2549,  2550,     0,     0,
    1429,  2553,  2554,     0,     0,  2557,     0,  1285,     0,     0,
    1682,     0,  1275,     0,     0,  2567,     0,  1421,     0,     0,
       0,     0,  2576,     0,     0,     0,  2579,  2580,     0,     0,
    2583,  2584,     0,     0,     0,     0,  1683,  2589,     0,  1684,
    1430,     0,     0,     0,     0,     0,     0,     0,     0,  2605,
       0,  2607,  1685,  1671,     0,  1686,  1672,     0,     0,     0,
       0,     0,     0,     0,  1429,     0,     0,  2629,     0,  1276,
       0,  1277,  2631,  1673,     0,     0,     0,  1891,     0,     0,
    1429,  1278,  1675,     0,     0,  2636,     0,     0,  1676,  1279,
       0,  1429,     0,  2641,     0,  2643,  2644,  2647,  2649,  1280,
       0,     0,  2656,  2659,     0,  1671,     0,     0,  1672,     0,
    2670,     0,  1677,     0,  2679,     0,     0,     0,  2683,     0,
       0,     0,     0,     0,     0,  1673,     0,     0,     0,     0,
    1687,     0,  3194,     0,  1675,  1282,  1283,     0,     0,     0,
    1676,  2712,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2719,     0,  2721,     0,     0,     0,     0,  2724,
       0,  3195,  1429,  2725,  1677,  2729,  2730,  2731,  2732,     0,
    2734,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1429,  2758,  2759,  2760,     0,  1430,     0,     0,
       0,     0,     0,     0,  2768,  2769,     0,     0,  1430,     0,
       0,     0,     0,     0,     0,     0,  1269,  1429,     0,     0,
       0,     0,  1270,     0,  1678,  1421,     0,     0,  1679,  1285,
       0,     0,     0,  1688,  1689,  1690,     0,  1691,  1692,  1693,
    1694,  1695,  1696,     0,     0,     0,     0,  4249,     0,  1680,
    1681,     0,     0,  1429,     0,     0,     0,  2479,     0,     0,
       0,     0,  2479,  1271,     0,     0,  1682,  2479,  2826,     0,
       0,     0,     0,     0,     0,     0,  1678,     0,     0,  1421,
    1679,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1683,     0,     0,  1684,     0,     0,     0,     0,
       0,  1680,  1681,     0,     0,     0,     0,     0,  1685,     0,
       0,  1686,  1272,     0,  1421,     0,     0,     0,  1682,  1273,
    1430,     0,  1274,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1429,
       0,     0,     0,     0,  1683,     0,     0,  1684,  1430,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1685,     0,     0,  1686,     0,     0,     0,  1430,     0,  1671,
       0,     0,  1672,     0,     0,     0,  1275,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1687,  1836,     0,  1673,
    1421,     0,     0,     0,  2500,     0,     0,     0,  1675,     0,
       0,     0,  1671,     0,  1676,  1672,     0,     0,     0,  1421,
       0,     0,     0,     0,     0,  1430,  2950,     0,     0,     0,
       0,     0,  1673,     0,     0,     0,     0,     0,  1677,  1421,
    1429,  1675,     0,  1276,     0,  1277,     0,  1676,  1687,     0,
       0,     0,     0,     0,     0,  1278,     0,     0,     0,     0,
       0,     0,     0,  1279,  1421,     0,     0,     0,     0,     0,
       0,  1677,     0,  1280,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2501,     0,     0,     0,     0,     0,  1688,
    1689,  1690,     0,  1691,  1692,  1693,  1694,  1695,  1696,     0,
       0,     0,     0,  4467,     0,     0,  3237,     0,     0,  1282,
    1283,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1421,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  3238,  4120,     0,     0,     0,
    1678,  1688,  1689,  1690,  1679,  1691,  1692,  1693,  1694,  1695,
    1696,     0,  3012,     0,     0,  4563,     0,  3013,     0,     0,
       0,     0,     0,     0,     0,  1680,  1681,     0,     0,     0,
       0,     0,  1430,  1678,     0,     0,     0,  1679,     0,     0,
       0,     0,  1682,     0,     0,     0,     0,     0,     0,     0,
       0,  1429,     0,  1285,     0,     0,     0,     0,  1680,  1681,
       0,     0,     0,     0,     0,     0,     0,     0,  1683,     0,
       0,  1684,     0,     0,     0,  1682,     0,  3110,     0,     0,
       0,     0,     0,     0,  1685,     0,     0,  1686,  1429,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1683,     0,     0,  1684,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1685,     0,     0,
    1686,     0,   770,     0,     0,     0,  3146,  3147,     0,     0,
       0,   770,   790,     0,     0,     0,     0,  1671,   790,     0,
    1672,     0,     0,  1836,     0,     0,  2540,     0,     0,   790,
       0,     0,     0,     0,     0,     0,     0,  1673,  1421,     0,
       0,     0,  1687,     0,     0,     0,  1675,     0,  3169,     0,
    1671,     0,  1676,  1672,     0,     0,     0,  3173,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1673,     0,  3184,  3186,     0,  1687,  1677,  3186,  1429,  1675,
       0,     0,  3197,  3198,  3199,  1676,     0,     0,     0,  1429,
       0,     0,     0,  2502,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1671,     0,     0,  1672,     0,     0,  1677,
       0,     0,  3219,  3220,  3221,  3222,     0,     0,     0,     0,
       0,     0,     0,  1673,     0,     0,     0,  2975,     0,     0,
       0,     0,  1675,  2540,     0,  1688,  1689,  1690,  1676,  1691,
    1692,  1693,  1694,  1695,  1696,     0,  3236,     0,  3240,  3241,
    3242,     0,     0,     0,  1430,     0,     0,     0,  3255,     0,
       0,     0,  1677,     0,     0,     0,     0,     0,  1688,  1689,
    1690,     0,  1691,  1692,  1693,  1694,  1695,  1696,  1678,     0,
       0,     0,  1679,     0,     0,     0,     0,     0,     0,  4534,
    1430,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1429,     0,  1680,  1681,     0,     0,     0,     0,     0,
       0,  1678,     0,     0,     0,  1679,     0,     0,     0,     0,
    1682,     0,     0,  3296,     0,     0,     0,     0,  1430,  1429,
       0,  3300,  1430,  1430,     0,     0,  1680,  1681,     0,     0,
       0,     0,     0,     0,     0,     0,  1683,  1421,  1429,  1684,
       0,  1421,  1421,  1682,     0,     0,     0,     0,     0,     0,
       0,     0,  1685,     0,  1678,  1686,     0,     0,  1679,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1683,
       0,     0,  1684,     0,     0,  3524,     0,     0,  3372,  1680,
    1681,     0,     0,     0,     0,  1685,  1429,     0,  1686,     0,
       0,     0,     0,     0,     0,     0,  1682,     0,     0,     0,
       0,  4120,     0,     0,     0,     0,  4535,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    3401,     0,  1683,  3404,     0,  1684,     0,     0,     0,     0,
    1687,     0,     0,     0,     0,     0,     0,     0,  1685,     0,
       0,  1686,     0,     0,  3525,   770,     0,  1421,     0,     0,
       0,     0,     0,     0,     0,  3442,     0,   790,     0,     0,
       0,   790,     0,  1687,     0,     0,     0,     0,     0,  3452,
       0,     0,   790,     0,     0,  1671,     0,     0,  1672,  1836,
       0,     0,     0,     0,     0,     0,     0,     0,   790,     0,
       0,     0,   770,     0,     0,  1673,     0,     0,     0,     0,
       0,     0,   770,   790,  1675,     0,     0,     0,   790,     0,
    1676,     0,     0,     0,     0,     0,  1687,     0,   790,     0,
       0,     0,     0,  1688,  1689,  1690,   790,  1691,  1692,  1693,
    1694,  1695,  1696,  1429,  1677,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1671,
       0,     0,  1672,     0,     0,     0,  1688,  1689,  1690,     0,
    1691,  1692,  1693,  1694,  1695,  1696,     0,     0,     0,  1673,
       0,     0,     0,  3020,     0,     0,     0,     0,  1675,     0,
       0,     0,     0,     0,  1676,     0,     0,     0,     0,     0,
       0,     0,  1421,     0,     0,     0,     0,     0,     0,     0,
       0,   770,     0,     0,     0,     0,   790,     0,  1677,  1688,
    1689,  1690,     0,  1691,  1692,  1693,  1694,  1695,  1696,     0,
       0,     0,     0,  1671,     0,     0,  1672,     0,     0,     0,
       0,     0,   770,     0,     0,     0,  1678,     0,     0,     0,
    1679,     0,     0,  1673,     0,     0,     0,  1429,     0,     0,
       0,     0,  1675,     0,     0,     0,     0,     0,  1676,     0,
       0,  1680,  1681,     0,     0,     0,     0,     0,     0,     0,
       0,  1421,     0,     0,     0,     0,     0,     0,  1682,     0,
       0,     0,  1677,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1683,     0,     0,  1684,     0,     0,
    1678,     0,     0,     0,  1679,  3652,     0,  3653,     0,     0,
    1685,     0,     0,  1686,  3655,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1680,  1681,     0,  2990,     0,
    3664,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1682,     0,  1429,  3672,  1421,     0,   770,     0,
       0,     0,     0,     0,     0,  3683,     0,     0,  3025,   770,
       0,     0,     0,     0,     0,  1429,     0,     0,  1683,     0,
    3686,  1684,     0,     0,  1678,     0,     0,     0,  1679,     0,
       0,     0,  1431,     0,  1685,     0,   179,  1686,  1687,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1680,
    1681,  1429,     0,  3718,  3719,  3720,     0,     0,  3723,  3724,
    3725,  3726,  3727,     0,     0,     0,  1682,  3734,  3735,   770,
    3737,  3738,  3739,  3740,  3741,  3742,  3743,     0,     0,     0,
       0,     0,     0,   180,     0,  3751,     0,  3753,  3754,  1429,
       0,     0,  1683,  1429,  1429,  1684,   181,     0,     0,     0,
       0,   790,     0,     0,     0,     0,     0,     0,  1685,     0,
       0,  1686,  1687,   182,     0,     0,   790,     0,     0,   183,
     770,     0,     0,     0,     0,     0,     0,     0,   790,     0,
       0,  1688,  1689,  1690,   184,  1691,  1692,  1693,  1694,  1695,
    1696,  3797,  3799,  3801,     0,   185,  3804,     0,     0,     0,
       0,     0,     0,   186,     0,     0,   790,     0,     0,     0,
       0,     0,     0,     0,  1431,   187,   790,     0,     0,     0,
     188,     0,     0,     0,     0,     0,   189,     0,     0,   790,
       0,     0,   790,     0,     0,     0,  1687,     0,     0,     0,
       0,   190,     0,     0,   770,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1688,  1689,  1690,     0,  1691,
    1692,  1693,  1694,  1695,  1696,     0,   191,     0,     0,     0,
       0,     0,     0,   770,     0,     0,     0,     0,  3186,  1421,
       0,     0,  1421,     0,  1421,     0,     0,   192,     0,  1421,
       0,     0,     0,     0,     0,  1836,  1836,  1836,     0,     0,
       0,   770,   770,     0,   770,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   193,     0,
       0,     0,     0,   770,     0,     0,     0,     0,     0,  1688,
    1689,  1690,     0,  1691,  1692,  1693,  1694,  1695,  1696,  1421,
       0,     0,     0,     0,     0,     0,   790,   194,     0,     0,
       0,     0,     0,     0,   790,   790,     0,     0,     0,     0,
       0,     0,     0,   770,  1821,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   195,     0,     0,     0,   196,  1421,
     197,     0,     0,     0,     0,     0,   198,     0,     0,   199,
       0,     0,   770,     0,     0,     0,   770,   770,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1431,     0,   200,   201,     0,   202,  1821,     0,
       0,   203,     0,     0,     0,     0,     0,     0,     0,   204,
       0,     0,     0,     0,   205,     0,     0,     0,     0,     0,
    1421,     0,  1421,     0,     0,  1671,   206,     0,  1672,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   207,
       0,     0,     0,     0,     0,  1673,  1431,     0,     0,  3031,
       0,     0,     0,     0,  1675,     0,     0,     0,  1269,     0,
    1676,     0,     0,     0,  1270,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1421,     0,     0,
       0,  1431,     0,     0,  1677,  3995,  3996,  3997,  3998,     0,
    1310,  4000,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1421,     0,     0,  1271,     0,     0,     0,     0,
       0,     0,  4013,  4014,  4015,  4016,     0,  4018,  4019,     0,
       0,  1421,     0,     0,     0,     0,     0,     0,     0,  4028,
    4029,     0,     0,     0,     0,     0,  1311,   790,     0,  1421,
       0,     0,  4031,     0,     0,     0,     0,     0,  1836,  1836,
       0,  1836,     0,     0,  1272,     0,     0,  1431,     0,     0,
       0,  1273,     0,     0,  1274,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1431,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1678,     0,     0,     0,
    1679,     0,     0,     0,     0,     0,  1431,     0,     0,     0,
       0,     0,     0,  1421,     0,     0,     0,     0,     0,     0,
       0,  1680,  1681,     0,     0,  1312,  1821,     0,  1275,  1421,
       0,  1431,     0,     0,     0,     0,     0,     0,  1682,     0,
    1421,     0,     0,     0,     0,     0,   790,     0,     0,     0,
    4086,     0,     0,     0,     0,     0,     0,     0,     0,  4092,
       0,     0,   790,     0,  1683,     0,     0,  1684,     0,     0,
       0,     0,     0,  1313,     0,  1314,     0,     0,     0,  4111,
    1685,     0,   770,  1686,     0,  1315,     0,  1277,  1431,     0,
       0,   770,     0,   790,   790,     0,     0,  1278,     0,     0,
       0,  4128,     0,     0,   790,  1279,     0,     0,     0,     0,
       0,  1421,     0,     0,  1316,  1280,   790,   790,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   790,     0,
       0,  1421,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2713,     0,
       0,  1282,  1283,  1318,     0,     0,  1421,     0,  1687,     0,
     770,     0,     0,     0,     0,     0,     0,     0,  1836,     0,
       0,     0,     0,     0,     0,     0,     0,  2714,     0,     0,
       0,  1836,     0,     0,     0,     0,     0,     0,  1320,     0,
       0,     0,  1421,     0,     0,   770,     0,   770,     0,     0,
       0,     0,     0,     0,   770,     0,     0,   770,     0,     0,
       0,   770,     0,     0,     0,     0,     0,     0,     0,   770,
     770,     0,     0,     0,     0,     0,     0,   770,     0,     0,
     770,   770,   770,   770,     0,  1285,     0,     0,     0,     0,
     770,   770,  4210,   770,     0,   770,   770,     0,     0,   770,
       0,  1688,  1689,  1690,     0,  1691,  1692,  1693,  1694,  1695,
    1696,     0,  4221,     0,     0,  1431,   770,  1821,     0,     0,
       0,   770,     0,     0,  1671,   770,     0,  1672,  1421,   770,
       0,   770,   770,   770,   770,   770,   770,   770,   770,   770,
       0,   770,     0,     0,  1673,     0,     0,     0,     0,   770,
     770,     0,     0,  1675,     0,     0,     0,     0,     0,  1676,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1671,     0,     0,  1672,     0,     0,     0,     0,
       0,     0,     0,  1677,     0,     0,     0,     0,     0,     0,
       0,     0,  1673,     0,     0,     0,  3531,     0,     0,     0,
       0,  1675,     0,  3186,     0,     0,     0,  1676,     0,     0,
       0,     0,  1671,     0,     0,  1672,     0,     0,     0,  1421,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1677,  1673,     0,     0,     0,     0,     0,     0,     0,
       0,  1675,  1836,     0,     0,     0,     0,  1676,     0,     0,
       0,     0,  1836,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1677,     0,     0,     0,     0,   770,     0,     0,     0,
       0,     0,  4343,     0,     0,  1678,     0,     0,     0,  1679,
       0,  4350,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1836,     0,     0,     0,
    1680,  1681,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1431,     0,     0,  1682,  1431,  1431,
       0,     0,     0,  1678,     0,     0,     0,  1679,   790,     0,
       0,     0,  1821,   790,     0,     0,   790,     0,     0,     0,
       0,     0,     0,  1683,     0,     0,  1684,     0,  1680,  1681,
       0,     0,     0,     0,     0,     0,     0,     0,   790,  1685,
    1421,   770,  1686,  1678,     0,  1682,     0,  1679,     0,  3186,
       0,     0,   770,     0,     0,     0,     0,     0,     0,   770,
       0,     0,     0,     0,     0,     0,     0,     0,  1680,  1681,
    1836,  1683,     0,     0,  1684,     0,     0,  1421,     0,   790,
       0,     0,     0,     0,     0,  1682,     0,  1685,     0,     0,
    1686,     0,     0,     0,  4437,     0,   790,   790,     0,     0,
       0,     0,     0,     0,  1431,     0,     0,     0,  4448,     0,
       0,  1683,     0,     0,  1684,     0,     0,  1687,     0,     0,
       0,  1821,   790,     0,     0,  1821,     0,  1685,     0,     0,
    1686,     0,     0,  4459,     0,     0,     0,     0,  4463,     0,
       0,     0,     0,  3481,     0,     0,     0,     0,     0,   790,
       0,     0,     0,   790,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1687,     0,     0,     0,     0,
       0,   790,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   790,     0,     0,     0,     0,  1421,     0,  4499,
       0,     0,     0,     0,     0,   790,     0,     0,  1421,     0,
       0,     0,     0,     0,   790,  1687,     0,     0,     0,     0,
    1688,  1689,  1690,     0,  1691,  1692,  1693,  1694,  1695,  1696,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   770,     0,  1431,
       0,     0,     0,     0,     0,     0,     0,     0,  1688,  1689,
    1690,     0,  1691,  1692,  1693,  1694,  1695,  1696,     0,     0,
    1821,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1688,  1689,
    1690,     0,  1691,  1692,  1693,  1694,  1695,  1696,     0,     0,
    1421,     0,  1671,     0,     0,  1672,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1431,     0,
       0,   790,  1673,     0,     0,     0,     0,     0,  1421,     0,
       0,  1675,     0,     0,     0,     0,     0,  1676,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1421,     0,     0,
       0,     0,     0,     0,     0,   790,     0,     0,     0,     0,
     770,  1677,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     790,     0,     0,     0,     0,  1421,     0,     0,     0,     0,
       0,     0,     0,  1431,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   790,     0,     0,     0,   770,     0,
       0,     0,     0,     0,   770,     0,     0,     0,     0,     0,
       0,     0,   791,     0,     0,     0,     0,     0,   791,     0,
       0,     0,   770,   770,     0,     0,     0,     0,   770,   791,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1678,     0,     0,     0,  1679,     0,     0,
       0,     0,     0,   770,   770,     0,     0,     0,   770,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1680,  1681,
     770,   770,   770,   770,   792,     0,     0,     0,  1821,     0,
     792,     0,     0,   770,  1821,  1682,   770,     0,   770,     0,
       0,   792,     0,     0,     0,     0,     0,     0,   770,   770,
       0,     0,   770,     0,     0,     0,     0,     0,     0,     0,
       0,  1683,     0,     0,  1684,   770,     0,   770,     0,     0,
       0,   770,  1421,     0,     0,     0,     0,  1685,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     770,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     770,     0,     0,   770,   770,   770,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   790,     0,     0,
     770,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   770,     0,     0,     0,     0,   770,     0,     0,
       0,     0,     0,   770,     0,     0,     0,     0,     0,     0,
       0,   770,     0,     0,     0,  1687,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1431,     0,     0,  1431,
       0,  1431,     0,     0,     0,     0,  1431,     0,   790,     0,
       0,     0,     0,     0,     0,     0,  1421,     0,     0,     0,
       0,     0,     0,   790,   790,     0,     0,     0,     0,   770,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     790,     0,     0,   790,     0,     0,  1431,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1688,  1689,
    1690,     0,  1691,  1692,  1693,  1694,  1695,  1696,     0,     0,
       0,     0,     0,     0,     0,     0,  1431,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1421,  1821,  1821,  1821,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1421,     0,     0,   791,   790,     0,
       0,   791,     0,     0,     0,     0,     0,  1431,     0,  1431,
     790,     0,   791,     0,     0,     0,     0,     0,     0,     0,
     790,     0,     0,     0,     0,     0,     0,     0,   791,     0,
    1421,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   791,     0,     0,     0,     0,   791,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   791,   792,
       0,     0,     0,   792,  1431,     0,   791,     0,  1421,     0,
       0,     0,  1421,  1421,   792,     0,     0,     0,     0,     0,
       0,     0,     0,   790,     0,     0,     0,     0,     0,  1431,
     792,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   792,     0,     0,  1431,     0,
     792,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     792,     0,     0,     0,     0,  1821,  1431,     0,   792,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     790,     0,   790,     0,     0,     0,   791,     0,  1114,     0,
       0,     0,     0,     0,   790,     0,   790,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1174,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1431,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   790,  1431,     0,   792,     0,
       0,     0,     0,     0,     0,     0,     0,  1431,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   790,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   770,     0,     0,   790,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   790,     0,     0,   790,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   770,     0,     0,  1431,     0,
       0,     0,     0,     0,     0,   770,     0,     0,     0,     0,
       0,   770,     0,   770,     0,     0,     0,     0,  1431,   770,
       0,     0,   770,   770,   770,   770,   770,   770,   770,   770,
     770,   770,     0,     0,     0,   770,   770,     0,     0,     0,
       0,     0,     0,  1431,     0,     0,     0,     0,   770,     0,
       0,     0,   770,     0,  1821,     0,   770,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   770,     0,     0,   770,
       0,   770,     0,     0,     0,     0,     0,     0,     0,  1431,
     770,   770,   770,     0,     0,     0,   770,     0,     0,   770,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   770,     0,   770,     0,     0,     0,     0,
       0,   791,     0,     0,     0,     0,     0,   770,     0,     0,
       0,     0,     0,   770,   770,     0,   791,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   791,     0,
       0,     0,     0,     0,     0,     0,     0,   770,     0,   532,
       0,     0,     0,   770,     0,     0,     0,     0,     0,   770,
       0,     0,   533,     0,     0,  1431,   791,     0,     0,     0,
       0,     0,     0,   792,     0,     0,   791,     0,     0,     0,
       0,   770,     0,   534,     0,     0,     0,     0,   792,   791,
       0,     0,   791,     0,     0,     0,   535,     0,     0,     0,
     792,     0,     0,     0,     0,   536,     0,     0,     0,  -737,
       0,  1609,   790,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   537,     0,   792,     0,
       0,     0,   538,     0,     0,     0,     0,     0,   792,     0,
    1633,     0,     0,     0,     0,     0,     0,   539,     0,     0,
    1821,   792,     0,     0,   792,  1821,  1431,  1821,   540,     0,
       0,     0,     0,     0,     0,     0,   541,     0,  1658,  1659,
       0,  1661,     0,     0,     0,     0,     0,     0,   542,     0,
       0,     0,     0,     0,     0,   543,     0,     0,     0,   544,
    1703,     0,   579,     0,     0,     0,     0,     0,     0,   790,
       0,     0,   790,     0,  -932,   580,   791,     0,     0,     0,
       0,     0,     0,     0,   791,   791,     0,     0,     0,     0,
       0,     0,     0,     0,  1822,     0,   581,     0,     0,     0,
    1739,     0,     0,     0,     0,     0,  1821,     0,     0,   582,
       0,     0,     0,   545,     0,     0,     0,     0,     0,     0,
    -504,     0,   583,     0,     0,     0,     0,     0,     0,  1843,
       0,     0,     0,  1855,  1858,     0,     0,     0,   792,   584,
       0,     0,     0,     0,     0,     0,   792,   792,  1822,     0,
     770,   546,     0,     0,   547,     0,  1823,     0,     0,     0,
     585,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   586,     0,   790,   790,     0,     0,  1431,     0,   587,
     790,     0,     0,     0,     0,     0,     0,     0,     0,  -400,
       0,   588,     0,     0,     0,     0,   589,     0,     0,     0,
       0,     0,   590,     0,     0,     0,     0,   548,     0,     0,
    1823,     0,     0,   549,  1431,   770,   770,   591,     0,  -400,
       0,     0,   550,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  -400,     0,
     551,   552,     0,   553,   554,     0,   790,     0,     0,     0,
       0,     0,   555,   592,     0,     0,     0,   556,     0,     0,
       0,     0,     0,   557,   770,     0,   558,     0,     0,   559,
       0,     0,     0,     0,     0,     0,     0,   791,     0,     0,
       0,     0,  -400,     0,   593,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   594,     0,     0,     0,     0,
       0,   770,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   770,   770,   194,  1431,     0,     0,     0,     0,   770,
     770,     0,     0,     0,   770,  1431,     0,     0,     0,     0,
     770,   770,     0,     0,   770,     0,     0,   770,     0,   792,
     595,     0,     0,     0,   596,     0,   597,     0,     0,     0,
       0,     0,   598,     0,     0,   599,  1822,     0,   770,     0,
       0,     0,   770,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   770,     0,   791,     0,     0,   770,
       0,   600,     0,   601,   770,     0,     0,   602,     0,     0,
       0,     0,   791,     0,     0,   603,     0,     0,     0,     0,
     604,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   605,     0,     0,     0,     0,     0,  1823,   770,
       0,     0,     0,   791,   791,   606,     0,     0,     0,     0,
       0,     0,     0,     0,   791,     0,     0,  1431,   792,     0,
       0,     0,     0,     0,     0,     0,   791,   791,     0,     0,
       0,     0,     0,   790,   792,     0,  1821,     0,   791,     0,
       0,     0,     0,     0,     0,  1431,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   790,
       0,     0,     0,     0,  1431,   792,   792,     0,     0,     0,
       0,   790,     0,     0,     0,     0,   792,     0,     0,     0,
       0,     0,     0,     0,   790,     0,     0,     0,   792,   792,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     792,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1431,     0,     0,     0,     0,     0,     0,     0,
       0,  2343,     0,     0,     0,     0,     0,   790,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2366,     0,     0,  2368,     0,     0,
    2379,     0,     0,     0,     0,     0,     0,  2386,  2391,     0,
       0,     0,     0,  2397,     0,   770,  2402,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   770,  1822,     0,     0,
       0,     0,     0,  2411,     0,     0,     0,     0,  2418,     0,
       0,     0,  2430,     0,     0,     0,  2437,     0,  2439,  2440,
    2441,  2442,  2443,  2444,  2445,  2446,  2447,     0,  2448,     0,
       0,     0,     0,     0,     0,     0,  1114,  2476,     0,     0,
       0,     0,     0,  1431,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1823,
       0,     0,     0,   790,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   770,     0,     0,     0,  1431,
       0,     0,     0,     0,   770,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   770,   770,     0,     0,   770,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   770,     0,
       0,     0,     0,   770,     0,     0,     0,     0,   770,     0,
       0,   770,     0,     0,     0,     0,   770,   770,     0,     0,
       0,     0,   845,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   790,     0,   790,     0,     0,
       0,   770,     0,  1174,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   846,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   847,
     848,     0,     0,  1431,   790,     0,     0,     0,   849,     0,
       0,     0,   850,   770,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   791,   851,
       0,     0,  1822,   791,     0,     0,   791,     0,     0,     0,
       0,     0,     0,     0,  1821,     0,   790,     0,     0,     0,
     852,     0,     0,     0,     0,     0,     0,     0,   791,   770,
       0,   853,     0,     0,     0,     0,     0,     0,  2581,   854,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   855,     0,     0,     0,     0,   856,     0,     0,     0,
     792,     0,     0,     0,  1823,   792,     0,     0,   792,   791,
       0,     0,     0,     0,     0,     0,     0,   857,   770,     0,
    1431,     0,     0,     0,     0,     0,   791,   791,     0,     0,
     792,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     770,  1431,   858,   770,     0,   770,     0,     0,     0,     0,
       0,  1822,   791,     0,     0,  1822,     0,     0,     0,     0,
       0,     0,     0,   859,     0,     0,     0,     0,   770,     0,
       0,   792,   770,     0,     0,     0,     0,  1431,     0,   791,
       0,     0,     0,   791,     0,     0,     0,     0,   792,   792,
       0,     0,     0,     0,   860,     0,     0,     0,     0,     0,
       0,   791,     0,     0,     0,     0,     0,     0,     0,  1821,
       0,     0,   791,  1823,   792,  1431,     0,  1823,     0,  1431,
    1431,     0,     0,   194,     0,   791,     0,     0,     0,     0,
       0,     0,     0,     0,   791,     0,     0,     0,     0,     0,
       0,   792,     0,     0,     0,   792,     0,     0,     0,     0,
     861,     0,     0,     0,   862,     0,   863,     0,     0,   770,
       0,     0,   864,   792,     0,   865,     0,     0,     0,     0,
       0,     0,     0,     0,   792,     0,     0,     0,   770,     0,
       0,     0,     0,     0,  2798,     0,     0,   792,     0,     0,
       0,   866,     0,   867,     0,     0,   792,   868,  1431,     0,
    1822,     0,     0,     0,     0,   869,     0,     0,     0,     0,
     870,     0,     0,     0,   770,     0,     0,   770,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   871,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   770,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   791,  1823,     0,     0,     0,     0,     0,     0,     0,
       0,   790,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   791,     0,   770,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2923,   770,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     770,   770,     0,   792,     0,     0,     0,     0,     0,     0,
     791,   790,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   770,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   791,     0,     0,   792,     0,     0,
       0,     0,     0,     0,  1423,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   770,     0,     0,     0,     0,     0,     0,
    2971,     0,   792,     0,     0,  2977,     0,   770,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   792,     0,     0,     0,
    1821,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2391,  1822,  2391,
    2391,     0,     0,     0,  1822,     0,     0,     0,     0,     0,
    3034,     0,     0,  3037,     0,  3039,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   770,     0,     0,     0,     0,
    1821,     0,     0,     0,   770,     0,     0,     0,  1821,     0,
       0,     0,  3060,     0,  3062,     0,     0,     0,  3065,     0,
       0,     0,     0,     0,     0,     0,  1423,     0,     0,     0,
    1823,     0,     0,     0,     0,     0,  1823,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2476,  2476,  2476,     0,     0,     0,     0,   791,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  3108,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1843,
       0,     0,     0,     0,  3119,     0,     0,     0,  1698,     0,
    1858,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   791,   792,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   791,   791,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  3155,     0,  1698,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     791,     0,     0,   791,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     792,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   792,   792,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   792,     0,  1423,   792,     0,     0,     0,     0,
       0,     0,     0,     0,  1822,  1822,  1822,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1424,     0,     0,     0,     0,     0,   791,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     791,     0,     0,     0,     0,     0,     0,     0,  1423,     0,
     791,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1823,  1823,  1823,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1423,     0,     0,     0,     0,     0,     0,
     792,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   792,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   792,   791,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1424,  1822,     0,     0,     0,  1423,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     791,     0,   791,     0,     0,   792,     0,     0,  1423,     0,
       0,     0,     0,     0,   791,     0,   791,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1423,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1823,     0,     0,
       0,     0,     0,  1423,     0,     0,     0,     0,     0,     0,
       0,     0,   792,     0,   792,   791,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   792,     0,   792,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   791,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1698,     0,   791,     0,     0,
    1423,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   791,   792,     0,   791,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  3482,     0,     0,   792,     0,     0,     0,     0,
       0,     0,  3486,     0,     0,     0,     0,     0,  3487,   792,
    3488,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1424,  1698,     0,     0,     0,     0,   792,     0,
       0,   792,  3506,  3507,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1822,     0,     0,  1698,     0,     0,
       0,     0,  2375,  2397,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  3535,     0,     0,  3538,     0,  3540,     0,
       0,     0,  1698,  1698,     0,  1698,  1424,  3544,     0,     0,
       0,     0,     0,  3549,     0,     0,  3552,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1823,     0,     0,     0,
       0,  1424,     0,     0,  3593,     0,     0,  1698,     0,     0,
    3600,  2476,     0,     0,     0,     0,     0,  1423,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  3612,     0,     0,     0,     0,     0,
    1114,     0,     0,  1698,     0,     0,  1174,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1424,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   791,     0,     0,     0,  1424,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1424,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1822,     0,     0,     0,     0,  1822,     0,  1822,     0,     0,
       0,  1424,     0,     0,     0,     0,     0,  1698,     0,     0,
       0,     0,     0,     0,   792,     0,     0,     0,     0,  1698,
       0,     0,  1698,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   791,
       0,     0,   791,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1823,     0,     0,     0,     0,  1823,  1424,  1823,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1822,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1423,     0,     0,     0,
    1423,  1423,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   792,     0,     0,   792,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1823,     0,
       0,     0,     0,   791,   791,     0,     0,     0,     0,     0,
     791,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1426,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  3857,  3858,     0,     0,  1423,     0,     0,     0,
       0,     0,     0,     0,     0,   792,   792,     0,     0,     0,
       0,     0,   792,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   791,     0,     0,     0,
       0,     0,     0,     0,     0,  1424,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  3888,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   792,     0,
       0,     0,     0,     0,     0,     0,  1427,     0,  3906,  3908,
       0,     0,     0,     0,  1426,     0,     0,     0,     0,  1428,
       0,  3915,     0,     0,     0,     0,     0,  3920,  3921,     0,
       0,  3923,     0,     0,  3926,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1423,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2476,     0,     0,     0,     0,  2476,     0,     0,     0,
       0,  2476,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  3976,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1423,     0,     0,     0,     0,     0,     0,     0,  1427,     0,
       0,     0,     0,   791,     0,     0,  1822,     0,     0,     0,
       0,  1428,     0,     0,  1424,     0,     0,     0,  1424,  1424,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   791,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   791,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   791,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   792,     0,     0,  1823,     0,
       0,     0,  1426,     0,     0,  1423,     0,  1698,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   792,     0,     0,     0,     0,     0,   791,     0,     0,
    1698,     0,  1698,   792,  2375,  2375,  3008,     0,     0,  2375,
       0,     0,     0,  1698,     0,     0,   792,     0,     0,     0,
    1698,     0,     0,     0,  1424,  1698,  1426,     0,     0,     0,
       0,  1698,     0,     0,     0,     0,  1698,     0,     0,     0,
       0,     0,  4072,     0,     0,  1698,     0,     0,     0,  2375,
    2375,     0,  1698,     0,     0,     0,     0,     0,     0,   792,
       0,  1426,     0,     0,  1698,     0,     0,     0,     0,     0,
       0,  1698,     0,  1698,  1698,  1698,  1698,  1698,  1698,  1698,
    1698,  1698,  1698,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1427,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1428,
    1698,     0,     0,   791,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1426,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1427,     0,     0,     0,     0,     0,  1426,     0,     0,     0,
       0,     0,  4154,  1428,     0,     0,     0,     0,     0,  1424,
       0,     0,     0,     0,     0,   792,  1426,     0,     0,     0,
       0,     0,     0,     0,     0,  1427,     0,     0,     0,     0,
       0,     0,     0,     0,  4177,     0,     0,     0,  1428,     0,
       0,  1426,     0,     0,     0,   791,     0,   791,  1423,     0,
       0,  1423,     0,  1423,     0,  1698,     0,     0,  1423,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   791,     0,     0,     0,  1424,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1426,     0,
       0,  1427,     0,     0,     0,     0,     0,   792,  1423,   792,
       0,     0,     0,     0,  1428,     0,     0,     0,     0,     0,
    1427,     0,     0,     0,  1822,     0,   791,     0,     0,     0,
       0,     0,     0,  1428,     0,     0,     0,     0,     0,     0,
    1427,     0,     0,     0,     0,     0,   792,     0,  1423,     0,
       0,     0,     0,  1428,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1427,     0,     0,     0,     0,
       0,     0,     0,  1424,     0,     0,     0,     0,  1428,     0,
       0,     0,     0,     0,     0,     0,  1823,     0,   792,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1423,
       0,  1423,     0,     0,     0,     0,     0,     0,     0,     0,
    2397,     0,  1427,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1428,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  4319,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1423,     0,     0,     0,
       0,     0,  1698,     0,     0,  1426,     0,     0,     0,  1822,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1423,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1423,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1423,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1823,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  4393,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1423,     0,     0,     0,     0,  1698,     0,  1427,
       0,     0,     0,     0,     0,     0,  1424,     0,  1423,  1424,
       0,  1424,  1428,     0,     0,     0,  1424,     0,     0,  1423,
       0,     0,     0,     0,     0,     0,  4438,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   791,     0,     0,     0,  1698,     0,     0,     0,     0,
       0,  1698,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1424,  3008,  3008,     0,
    2375,     0,     0,  2375,  2375,  2375,  2375,  2375,  2375,  2375,
    2375,  2375,  2375,  3008,  1426,     0,     0,     0,  1426,  1426,
    1423,     0,     0,     0,     0,     0,     0,  4483,  4483,     0,
       0,   791,     0,   792,     0,     0,  1424,     0,  1698,     0,
    1423,  1698,     0,  1698,     0,     0,     0,     0,  3008,  3008,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2375,  2375,  1698,  1423,  1698,     0,     0,  1698,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    4483,     0,     0,   792,     0,     0,     0,  1424,     0,  1424,
       0,  1423,     0,     0,  4539,     0,     0,     0,     0,     0,
       0,     0,  1698,     0,     0,     0,     0,     0,     0,     0,
    1822,     0,     0,  1698,  1426,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1427,     0,
       0,     0,  1427,  1427,     0,     0,     0,     0,     0,     0,
       0,  1428,     0,     0,  1424,  1428,  1428,     0,     0,  1698,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1822,     0,  4483,     0,     0,     0,     0,     0,  1822,  1424,
       0,     0,  1823,     0,     0,     0,     0,  1423,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1424,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1424,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1823,     0,     0,     0,     0,     0,     0,     0,
    1823,     0,     0,     0,     0,     0,     0,     0,  1427,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1428,     0,     0,     0,     0,     0,     0,     0,  1426,
       0,     0,     0,     0,     0,     0,     0,     0,  1423,     0,
    1424,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1424,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1424,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1426,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2375,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1424,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1427,     0,     0,     0,     0,  1424,     0,
       0,     0,     0,     0,     0,     0,  1428,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1424,     0,     0,     0,     0,     0,  1423,
       0,     0,     0,  1426,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1424,
       0,     0,     0,     0,     0,     0,  1423,     0,     0,     0,
       0,     0,  1427,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1428,  1698,     0,     0,     0,
    1698,  1698,  1698,     0,     0,  3008,     0,     0,     0,     0,
    3008,  3008,  3008,  3008,  3008,  3008,  3008,  3008,  3008,  3008,
    1698,  1698,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1698,
    2375,  2375,  1698,     0,  1698,  1424,     0,     0,  1698,  3008,
    3008,     0,     0,  1698,     0,     0,  1698,  1427,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1428,     0,     0,     0,     0,     0,  1423,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1423,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1698,     0,     0,
       0,     0,     0,     0,  1698,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1698,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1424,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1426,     0,     0,  1426,
       0,  1426,     0,     0,     0,     0,  1426,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1423,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1426,  1423,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1423,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1426,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1424,     0,     0,
    1427,     0,     0,  1427,  1423,  1427,     0,     0,     0,     0,
    1427,     0,     0,  1428,     0,     0,  1428,     0,  1428,  3008,
       0,     0,     0,  1428,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1424,     0,     0,  1426,     0,  1426,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1427,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1698,  1698,  1428,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1426,     0,     0,     0,     0,     0,
    1427,     0,  1698,     0,     0,     0,  2375,     0,     0,     0,
       0,     0,     0,  1428,     0,     0,     0,     0,     0,  1426,
    1698,     0,  1698,     0,     0,     0,     0,  3008,  3008,  1698,
       0,     0,  2375,  2375,  1698,  1698,     0,  1698,  1426,     0,
    1698,     0,     0,     0,  1424,     0,     0,     0,     0,     0,
       0,  1423,     0,     0,     0,  1424,  1426,     0,     0,     0,
       0,  1427,     0,  1427,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1428,     0,  1428,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1698,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1427,     0,
    1426,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1428,     0,     0,     0,     0,  1426,     0,     0,     0,
       0,     0,     0,  1427,     0,     0,     0,  1426,     0,     0,
       0,     0,     0,     0,     0,     0,  1428,     0,     0,     0,
       0,     0,  1427,     0,     0,  1423,     0,  1424,     0,     0,
       0,     0,     0,     0,     0,  1428,     0,     0,     0,     0,
    1427,     0,     0,     0,     0,     0,  1698,     0,     0,     0,
       0,     0,     0,  1428,     0,  1424,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1424,     0,     0,     0,  1426,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1426,     0,
       0,     0,     0,     0,  1427,     0,     0,     0,     0,     0,
    3008,  2375,     0,     0,     0,     0,     0,  1428,     0,     0,
    1427,     0,  1424,  1426,     0,     0,  3008,  3008,  1698,     0,
       0,  1427,  1423,  1428,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1428,     0,     0,     0,     0,     0,
       0,  1698,     0,  1423,     0,     0,     0,     0,     0,  1426,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1423,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1427,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1428,     0,     0,     0,     0,
       0,     0,  1427,     0,     0,     0,     0,  1423,     0,     0,
       0,  1423,  1423,     0,     0,  1428,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1426,     0,  1427,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1428,     0,     0,     0,     0,     0,     0,     0,     0,  1424,
       0,     0,     0,     0,     0,     0,     0,  3008,     0,     0,
       0,     0,     0,  1427,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1698,     0,     0,  1428,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1426,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1698,     0,  1427,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1428,  1424,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1698,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1698,     0,     0,
    1427,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1428,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1426,     0,     0,
    1424,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1424,     0,  1698,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1426,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1424,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1424,     0,     0,     0,  1424,
    1424,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1427,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1428,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1426,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1426,     0,     0,  1427,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1428,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1426,  1427,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1427,
       0,  1428,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1428,     0,     0,  1426,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1426,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1426,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1427,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1428,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1427,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1428,     0,     0,     0,     0,     0,  1427,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1428,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1427,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1428,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1426,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1426,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1427,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1428,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1426,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1427,     0,     0,
       0,  1426,     0,     0,     0,     0,     0,     0,     0,     0,
    1428,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1426,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1426,     0,     0,     0,  1426,
    1426,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1427,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1428,     0,     0,
       0,     0,     0,     0,     0,  1427,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1428,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1427,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1428,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1427,
       0,     0,     0,  1427,  1427,     0,     0,     0,     0,     0,
       0,     0,  1428,     0,     0,     0,  1428,  1428,   744,  1032,
     574,  1033,  1034,  1035,   625,  1036,     0,     0,     0,   211,
     212,   213,   214,   215,   216,   217,   218,  2470,   220,   221,
     222,     0,     0,     0,     0,   223,  1037,     0,     0,   224,
     225,     0,   226,   227,   745,   228,   229,   230,   231,  1038,
     746,  1039,  1040,     0,   235,   236,   237,   238,   239,  1041,
    1042,   240,   241,  1043,  1044,   244,     0,   245,   246,   247,
     248,  1045,     0,  1046,     0,   250,   251,   252,   253,   748,
     254,   255,     0,   256,   257,   258,   259,   260,   261,     0,
     749,   262,   263,  1047,  1048,  1049,  1050,  1051,  1052,  1053,
     264,   265,   266,   267,   268,   269,  1054,  1055,   272,     0,
     273,     0,   274,   275,   276,   277,   278,     0,   279,   280,
     281,  2471,     0,   282,   283,  1056,   285,   286,     0,   287,
     288,   289,     0,   290,   291,   292,     0,   293,   294,   295,
     296,  1057,   298,   299,   300,  1058,  1059,   302,     0,   303,
     304,  1060,   306,     0,   307,     0,   308,   751,     0,   752,
     309,   310,   311,     0,   312,  1061,     0,   314,     0,   315,
     316,   317,   318,   319,   753,   320,   321,   322,     0,   323,
     324,   325,   326,   327,   328,     0,   329,   754,   330,   331,
     332,   333,   334,  1062,  1063,     0,  1064,     0,   338,   755,
     756,   339,   757,   340,   341,   342,   343,   344,     0,   345,
     346,     0,   347,  1065,   758,   349,   759,     0,   350,   351,
     352,  1066,  1067,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,  1068,   760,  1069,   368,
     369,   370,  1070,   371,   372,   761,   373,  1071,  1072,   375,
    1073,   377,   378,   379,     0,   380,     0,     0,  1074,   382,
     383,     0,     0,   384,   385,   762,   386,   763,  1075,   388,
     389,   390,   391,   392,   393,   394,     0,   395,  1076,   397,
     398,   399,   400,   401,     0,   402,   403,   404,   405,   406,
     407,   408,   409,  1077,   411,   412,   413,   414,     0,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
       0,   426,   427,   764,   428,   429,  1078,   431,   432,   433,
     434,   435,   436,   437,   438,     0,   439,   440,   441,   442,
     443,  1079,   444,   445,   446,   447,   765,   448,  1080,   450,
       0,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,  1081,     0,   462,   463,     0,   464,   465,   466,   467,
     468,   469,     0,  1082,  1083,     0,     0,   472,  1084,   474,
    1085,  1086,   476,   477,   478,   479,   480,   481,   482,     0,
    1087,   483,   484,   485,   486,   487,  1088,     0,   488,   489,
     490,   491,   492,   493,  1089,  2472,   495,   766,   496,   497,
     498,   499,     0,     0,   500,     0,     0,   501,   502,   503,
     504,   505,   506,   507,  1090,  1091,  1092,  1093,  1094,  1095,
    1096,  1097,   516,   517,   518,     0,     0,     0,     0,     0,
       0,     0,     0,  1098,  1099,  2473,     0,     0,     0,     0,
       0,     0,  1101,  2474,   744,  1032,   574,  1033,  1034,  1035,
     625,  1036,     0,     0,     0,   211,   212,   213,   214,   215,
     216,   217,   218,     0,   220,   221,   222,     0,     0,     0,
       0,   223,  1037,     0,     0,   224,   225,     0,   226,   227,
     745,   228,   229,   230,   231,  1038,   746,  1039,  1040,     0,
     235,   236,   237,   238,   239,  1041,  1042,   240,   241,  1043,
    1044,   244,     0,   245,   246,   247,   248,  1045,     0,  1046,
       0,   250,   251,   252,   253,   748,   254,   255,     0,   256,
     257,   258,   259,   260,   261,     0,   749,   262,   263,  1047,
    1048,  1049,  1050,  1051,  1052,  1053,   264,   265,   266,   267,
     268,   269,  1054,  1055,   272,     0,   273,     0,   274,   275,
     276,   277,   278,     0,   279,   280,   281,     0,     0,   282,
     283,  1056,   285,   286,     0,   287,   288,   289,     0,   290,
     291,   292,     0,   293,   294,   295,   296,  1057,   298,   299,
     300,  1058,  1059,   302,     0,   303,   304,  1060,   306,     0,
     307,     0,   308,   751,     0,   752,   309,   310,   311,     0,
     312,  1061,     0,   314,     0,   315,   316,   317,   318,   319,
     753,   320,   321,   322,     0,   323,   324,   325,   326,   327,
     328,     0,   329,   754,   330,   331,   332,   333,   334,  1062,
    1063,     0,  1064,     0,   338,   755,   756,   339,   757,   340,
     341,   342,   343,   344,     0,   345,   346,     0,   347,  1065,
     758,   349,   759,     0,   350,   351,   352,  1066,  1067,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,  1068,   760,  1069,   368,   369,   370,  1070,   371,
     372,   761,   373,  1071,  1072,   375,  1073,   377,   378,   379,
       0,   380,     0,     0,  1074,   382,   383,     0,     0,   384,
     385,   762,   386,   763,  1075,   388,   389,   390,   391,   392,
     393,   394,     0,   395,  1076,   397,   398,   399,   400,   401,
       0,   402,   403,   404,   405,   406,   407,   408,   409,  1077,
     411,   412,   413,   414,     0,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,     0,   426,   427,   764,
     428,   429,  1078,   431,   432,   433,   434,   435,   436,   437,
     438,     0,   439,   440,   441,   442,   443,  1079,   444,   445,
     446,   447,   765,   448,  1080,   450,     0,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,  1081,     0,   462,
     463,     0,   464,   465,   466,   467,   468,   469,     0,  1082,
    1083,     0,     0,   472,  1084,   474,  1085,  1086,   476,   477,
     478,   479,   480,   481,   482,     0,  1087,   483,   484,   485,
     486,   487,  1088,     0,   488,   489,   490,   491,   492,   493,
    1089,     0,   495,   766,   496,   497,   498,   499,     0,     0,
     500,     0,     0,   501,   502,   503,   504,   505,   506,   507,
    1090,  1091,  1092,  1093,  1094,  1095,  1096,  1097,   516,   517,
     518,     0,     0,     0,     0,     0,     0,     0,     0,  1098,
    1099,   210,     0,     0,     0,     0,     0,     0,  1101,  2377,
       0,     0,   211,   212,   213,   214,   215,   216,   217,   218,
       0,   220,   221,   222,     0,     0,     0,     0,   223,     0,
    3571,     0,   224,   225,     0,   226,   227,     0,   228,   229,
     230,   231,   232,     0,   233,   234,     0,   235,   236,   237,
     238,   239,     0,     0,   240,   241,   242,   243,   244,     0,
     245,   246,   247,   248,   249,     0,     0,     0,   250,   251,
     252,   253,     0,   254,   255,     0,   256,   257,   258,   259,
     260,   261,     0, -1494,   262,   263,     0,     0,     0,     0,
       0,     0,     0,   264,   265,   266,   267,   268,   269,   270,
     271,   272,     0,   273,     0,   274,   275,   276,   277,   278,
       0,   279,   280,   281,     0,     0,   282,   283,   284,   285,
     286,     0,   287,   288,   289,     0,   290,   291,   292,     0,
     293,   294,   295,   296,   297,   298,   299,   300,   301,     0,
     302,     0,   303,   304,   305,   306,     0,   307,     0,   308,
       0,     0, -1494,   309,   310,   311,     0,   312,   313,     0,
     314,     0,   315,   316,   317,   318,   319,     0,   320,   321,
     322,     0,   323,   324,   325,   326,   327,   328,     0,   329,
   -1494,   330,   331,   332,   333,   334,   335,   336,     0,   337,
       0,   338,     0,     0,   339, -1494,   340,   341,   342,   343,
     344,     0,   345,   346,     0,   347,   348, -1494,   349,     0,
       0,   350,   351,   352,     0,     0,   353,   354,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,   366,
   -1494,   367,   368,   369,   370,     0,   371,   372,     0,   373,
       0,   374,   375,   376,   377,   378,   379,     0,   380,     0,
       0,   381,   382,   383,     0,     0,   384,   385,     0,   386,
       0,   387,   388,   389,   390,   391,   392,   393,   394,     0,
     395,   396,   397,   398,   399,   400,   401,     0,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,     0,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,     0,   426,   427, -1494,   428,   429,   430,
     431,   432,   433,   434,   435,   436,   437,   438,     0,   439,
     440,   441,   442,   443,     0,   444,   445,   446,   447,     0,
     448,   449,   450,     0,   451,   452,   453,   454,   455,   456,
     457,   458,   459,   460,   461,     0,   462,   463,     0,   464,
     465,   466,   467,   468,   469,     0,   470,   471,     0,     0,
     472,   473,   474,   475,     0,   476,   477,   478,   479,   480,
     481,   482,     0,     0,   483,   484,   485,   486,   487,     0,
       0,   488,   489,   490,   491,   492,   493,   494,     0,   495,
       0,   496,   497,   498,   499,     0,     0,   500,     0,     0,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,   513,   514,   515,   516,   517,   518,     0,     0,
       0,     0,     0,     0,     0,     0,  1397,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1181,   211,   212,   213,
     214,   215,   216,   217,   218,     0,   220,   221,   222,     0,
       0,     0,     0,   223,     0,     0,     0,   224,   225,     0,
     226,   227,   745,   228,   229,   230,     0,  1398,   746,  1399,
    1400,     0,   235,   236,   237,   238,   239,     0,     0,   240,
     241,  1401,  1402,   244,     0,   245,   246,   247,   248,     0,
       0,   747,     0,   250,   251,   252,   253,   748,   254,   255,
       0,   256,   257,   258,   259,   260,   261,     0,   749,   262,
     263,     0,     0,     0,   750,     0,     0,     0,   264,   265,
     266,   267,   268,   269,  1403,  1404,   272,     0,   273,     0,
     274,   275,   276,   277,   278,     0,   279,   280,   281,     0,
       0,   282,   283,  1056,   285,   286,     0,   287,   288,   289,
       0,   290,   291,   292,     0,   293,   294,   295,   296,     0,
     298,   299,   300,     0,     0,   302,     0,   303,   304,  1405,
     306,     0,   307,     0,   308,   751,     0,   752,   309,   310,
     311,     0,   312,     0,     0,   314,     0,   315,   316,   317,
     318,   319,   753,   320,   321,   322,  1877,   323,   324,   325,
     326,   327,   328,     0,   329,   754,  1878,   331,   332,   333,
     334,  1406,  1407,     0,  1408,     0,   338,   755,   756,   339,
     757,   340,   341,   342,   343,   344,     0,   345,   346,     0,
     347,     0,   758,   349,   759,     0,   350,   351,   352,     0,
       0,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,  1409,   760,  1410,   368,   369,     0,
       0,   371,   372,   761,   373,     0,     0,   375,  1411,   377,
     378,   379,     0,   380,     0,     0,   381,   382,   383,     0,
       0,   384,  1880,   762,   386,   763,     0,   388,   389,   390,
     391,   392,   393,   394,     0,   395,     0,   397,     0,   399,
     400,   401,     0,   402,   403,   404,   405,   406,   407,   408,
     409,  1412,   411,   412,   413,   414,     0,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,     0,   426,
     427,   764,   428,   429,     0,   431,   432,   433,   434,   435,
     436,   437,   438,     0,   439,   440,   441,   442,   443,     0,
     444,  1881,   446,   447,   765,   448,  1414,   450,     0,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,     0,
       0,   462,   463,     0,   464,   465,   466,   467,   468,   469,
       0,  1415,  1416,     0,     0,   472,     0,   474,     0,     0,
     476,   477,   478,   479,   480,   481,   482,     0,     0,   483,
     484,   485,   486,   487,     0,     0,   488,   489,   490,   491,
     492,     0,  1417,  1882,   495,   766,   496,   497,   498,   499,
       0,     0,   500,     0,     0,   501,   502,   503,   504,   505,
     506,     0,  1397,     0,     0,     0,     0,     0,     0,     0,
     516,   517,   518,   211,   212,   213,   214,   215,   216,   217,
     218,     0,   220,   221,   222,     0,     0,     0,     0,   223,
       0,  1980,     0,   224,   225,     0,   226,   227,   745,   228,
     229,   230,     0,  1398,   746,  1399,  1400,     0,   235,   236,
     237,   238,   239,     0,     0,   240,   241,  1401,  1402,   244,
       0,   245,   246,   247,   248,     0,     0,   747,     0,   250,
     251,   252,   253,   748,   254,   255,     0,   256,   257,   258,
     259,   260,   261,     0,   749,   262,   263,     0,     0,     0,
     750,     0,     0,     0,   264,   265,   266,   267,   268,   269,
    1403,  1404,   272,     0,   273,     0,   274,   275,   276,   277,
     278,     0,   279,   280,   281,     0,     0,   282,   283,  1056,
     285,   286,     0,   287,   288,   289,     0,   290,   291,   292,
       0,   293,   294,   295,   296,     0,   298,   299,   300,     0,
       0,   302,     0,   303,   304,  1405,   306,     0,   307,     0,
     308,   751,     0,   752,   309,   310,   311,     0,   312,     0,
       0,   314,     0,   315,   316,   317,   318,   319,   753,   320,
     321,   322,  1877,   323,   324,   325,   326,   327,   328,     0,
     329,   754,  1878,   331,   332,   333,   334,  1406,  1407,     0,
    1408,     0,   338,   755,   756,   339,   757,   340,   341,   342,
     343,   344,     0,   345,   346,     0,   347,     0,   758,   349,
     759,     0,   350,   351,   352,     0,     0,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
    1409,   760,  1410,   368,   369,     0,     0,   371,   372,   761,
     373,     0,     0,   375,  1411,   377,   378,   379,     0,   380,
       0,     0,   381,   382,   383,     0,     0,   384,  1880,   762,
     386,   763,     0,   388,   389,   390,   391,   392,   393,   394,
       0,   395,     0,   397,     0,   399,   400,   401,     0,   402,
     403,   404,   405,   406,   407,   408,   409,  1412,   411,   412,
     413,   414,     0,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,     0,   426,   427,   764,   428,   429,
       0,   431,   432,   433,   434,   435,   436,   437,   438,     0,
     439,   440,   441,   442,   443,     0,   444,  1881,   446,   447,
     765,   448,  1414,   450,     0,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,     0,     0,   462,   463,     0,
     464,   465,   466,   467,   468,   469,     0,  1415,  1416,     0,
       0,   472,     0,   474,     0,     0,   476,   477,   478,   479,
     480,   481,   482,     0,     0,   483,   484,   485,   486,   487,
       0,     0,   488,   489,   490,   491,   492,     0,  1417,  1882,
     495,   766,   496,   497,   498,   499,     0,     0,   500,     0,
       0,   501,   502,   503,   504,   505,   506,     0,   744,  1032,
     574,  1033,  1034,  1035,   625,  1036,   516,   517,   518,   211,
     212,   213,   214,   215,   216,   217,   218,     0,   220,   221,
     222,     0,     0,     0,     0,   223,  1037,  2887,     0,   224,
     225,     0,   226,   227,   745,   228,   229,   230,   231,  1038,
     746,  1039,  1040,  2387,   235,   236,   237,   238,   239,  1041,
    1042,   240,   241,  1043,  1044,   244,     0,   245,   246,   247,
     248,  1045,     0,  1046,     0,   250,   251,   252,   253,   748,
     254,   255,     0,   256,   257,   258,   259,   260,   261,     0,
     749,   262,   263,  1047,  1048,  1049,  1050,  1051,  1052,  1053,
     264,   265,   266,   267,   268,   269,  1054,  1055,   272,     0,
     273,     0,   274,   275,   276,   277,   278,     0,   279,   280,
     281,     0,     0,   282,   283,  1056,   285,   286,     0,   287,
     288,   289,     0,   290,   291,   292,     0,   293,   294,   295,
     296,  1057,   298,   299,   300,  1058,  1059,   302,     0,   303,
     304,  1060,   306,     0,   307,     0,   308,   751,  2388,   752,
     309,   310,   311,     0,   312,  1061,     0,   314,     0,   315,
     316,   317,   318,   319,   753,   320,   321,   322,     0,   323,
     324,   325,   326,   327,   328,     0,   329,   754,   330,   331,
     332,   333,   334,  1062,  1063,     0,  1064,     0,   338,   755,
     756,   339,   757,   340,   341,   342,   343,   344,     0,   345,
     346,  2389,   347,  1065,   758,   349,   759,     0,   350,   351,
     352,  1066,  1067,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,  1068,   760,  1069,   368,
     369,   370,  1070,   371,   372,   761,   373,  1071,  1072,   375,
    1073,   377,   378,   379,     0,   380,     0,     0,  1074,   382,
     383,     0,     0,   384,   385,   762,   386,   763,  1075,   388,
     389,   390,   391,   392,   393,   394,     0,   395,  1076,   397,
     398,   399,   400,   401,     0,   402,   403,   404,   405,   406,
     407,   408,   409,  1077,   411,   412,   413,   414,     0,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
       0,   426,   427,   764,   428,   429,  1078,   431,   432,   433,
     434,   435,   436,   437,   438,     0,   439,   440,   441,   442,
     443,  1079,   444,   445,   446,   447,   765,   448,  1080,   450,
       0,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,  1081,     0,   462,   463,     0,   464,   465,   466,   467,
     468,   469,     0,  1082,  1083,     0,  2390,   472,  1084,   474,
    1085,  1086,   476,   477,   478,   479,   480,   481,   482,     0,
    1087,   483,   484,   485,   486,   487,  1088,     0,   488,   489,
     490,   491,   492,   493,  1089,     0,   495,   766,   496,   497,
     498,   499,     0,     0,   500,     0,     0,   501,   502,   503,
     504,   505,   506,   507,  1090,  1091,  1092,  1093,  1094,  1095,
    1096,  1097,   516,   517,   518,     0,     0,     0,     0,     0,
       0,     0,     0,  1098,  1099,     0,     0,     0,     0,     0,
       0,     0,  1101,   744,  1032,   574,  1033,  1034,  1035,   625,
    1036,     0,     0,     0,   211,   212,   213,   214,   215,   216,
     217,   218,     0,   220,   221,   222,     0,     0,     0,     0,
     223,  1037,     0,     0,   224,   225,     0,   226,   227,   745,
     228,   229,   230,   231,  1038,   746,  1039,  1040,     0,   235,
     236,   237,   238,   239,  1041,  1042,   240,   241,  1043,  1044,
     244,     0,   245,   246,   247,   248,  1045,     0,  1046,     0,
     250,   251,   252,   253,   748,   254,   255,     0,   256,   257,
     258,   259,   260,   261,     0,   749,   262,   263,  1047,  1048,
    1049,  1050,  1051,  1052,  1053,   264,   265,   266,   267,   268,
     269,  1054,  1055,   272,     0,   273,     0,   274,   275,   276,
     277,   278,     0,   279,   280,   281,     0,     0,   282,   283,
    1056,   285,   286,     0,   287,   288,   289,     0,   290,   291,
     292,     0,   293,   294,   295,   296,  1057,   298,   299,   300,
    1058,  1059,   302,     0,   303,   304,  1060,   306,     0,   307,
       0,   308,   751,     0,   752,   309,   310,   311,     0,   312,
    1061,     0,   314,     0,   315,   316,   317,   318,   319,   753,
     320,   321,   322,     0,   323,   324,   325,   326,   327,   328,
       0,   329,   754,   330,   331,   332,   333,   334,  1062,  1063,
       0,  1064,     0,   338,   755,   756,   339,   757,   340,   341,
     342,   343,   344,     0,   345,   346,     0,   347,  1065,   758,
     349,   759,     0,   350,   351,   352,  1066,  1067,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,  1068,   760,  1069,   368,   369,   370,  1070,   371,   372,
     761,   373,  1071,  1072,   375,  1073,   377,   378,   379,     0,
     380,     0,     0,  1074,   382,   383,     0,     0,   384,   385,
     762,   386,   763,  1075,   388,   389,   390,   391,   392,   393,
     394,     0,   395,  1076,   397,   398,   399,   400,   401,     0,
     402,   403,   404,   405,   406,   407,   408,   409,  1077,   411,
     412,   413,   414,     0,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,     0,   426,   427,   764,   428,
     429,  1078,   431,   432,   433,   434,   435,   436,   437,   438,
      38,   439,   440,   441,   442,   443,  1079,   444,   445,   446,
     447,   765,   448,  1080,   450,     0,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,  1081,     0,   462,   463,
      42,   464,   465,   466,   467,   468,   469,     0,  1082,  1083,
       0,     0,   472,  1084,   474,  1085,  1086,   476,   477,   478,
     479,   480,   481,   482,     0,  1087,   483,   484,   485,   486,
     487,  1088,     0,   488,   489,   490,   491,   492,   971,  1089,
       0,   495,   766,   496,   497,   498,   499,     0,     0,   500,
       0,    47,   501,   502,   503,   504,   505,   506,   507,  1090,
    1091,  1092,  1093,  1094,  1095,  1096,  1097,   516,   517,   518,
       0,     0,     0,     0,     0,     0,     0,     0,  1098,  1099,
       0,     0,     0,     0,     0,     0,     0,  1101,   744,  1032,
     574,  1033,  1034,  1035,   625,  1036,     0,     0,     0,   211,
     212,   213,   214,   215,   216,   217,   218,     0,   220,   221,
     222,     0,     0,     0,     0,   223,  1037,     0,     0,   224,
     225,     0,   226,   227,   745,   228,   229,   230,   231,  1038,
     746,  1039,  1040,     0,   235,   236,   237,   238,   239,  1041,
    1042,   240,   241,  1043,  1044,   244,     0,   245,   246,   247,
     248,  1045,     0,  1046,     0,   250,   251,   252,   253,   748,
     254,   255,     0,   256,   257,   258,   259,   260,   261,     0,
     749,   262,   263,  1047,  1048,  1049,  1050,  1051,  1052,  1053,
     264,   265,   266,   267,   268,   269,  1054,  1055,   272,     0,
     273,     0,   274,   275,   276,   277,   278,     0,   279,   280,
     281,     0,     0,   282,   283,  1056,   285,   286,     0,   287,
     288,   289,     0,   290,   291,   292,     0,   293,   294,   295,
     296,  1057,   298,   299,   300,  1058,  1059,   302,     0,   303,
     304,  1060,   306,     0,   307,     0,   308,   751,     0,   752,
     309,   310,   311,     0,   312,  1061,     0,   314,     0,   315,
     316,   317,   318,   319,   753,   320,   321,   322,     0,   323,
     324,   325,   326,   327,   328,     0,   329,   754,   330,   331,
     332,   333,   334,  1062,  1063,     0,  1064,     0,   338,   755,
     756,   339,   757,   340,   341,   342,   343,   344,     0,   345,
     346,     0,   347,  1065,   758,   349,   759,     0,   350,   351,
     352,  1066,  1067,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,  1068,   760,  1069,   368,
     369,   370,  1070,   371,   372,   761,   373,  1071,  1072,   375,
    1073,   377,   378,   379,     0,   380,     0,     0,  1074,   382,
     383,     0,     0,   384,   385,   762,   386,   763,  1075,   388,
     389,   390,   391,   392,   393,   394,     0,   395,  1076,   397,
     398,   399,   400,   401,     0,   402,   403,   404,   405,   406,
     407,   408,   409,  1077,   411,   412,   413,   414,     0,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
       0,   426,   427,   764,   428,   429,  1078,   431,   432,   433,
     434,   435,   436,   437,   438,     0,   439,   440,   441,   442,
     443,  1079,   444,   445,   446,   447,   765,   448,  1080,   450,
       0,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,  1081,     0,   462,   463,     0,   464,   465,   466,   467,
     468,   469,     0,  1082,  1083,     0,     0,   472,  1084,   474,
    1085,  1086,   476,   477,   478,   479,   480,   481,   482,     0,
    1087,   483,   484,   485,   486,   487,  1088,     0,   488,   489,
     490,   491,   492,   493,  1089,     0,   495,   766,   496,   497,
     498,   499,     0,     0,   500,     0,     0,   501,   502,   503,
     504,   505,   506,   507,  1090,  1091,  1092,  1093,  1094,  1095,
    1096,  1097,   516,   517,   518,     0,     0,     0,     0,     0,
       0,     0,     0,  1098,  1099,     0,     0,     0,     0,     0,
    1604,  2335,  1101,   744,  1032,   574,  1033,  1034,  1035,   625,
    1036,     0,     0,     0,   211,   212,   213,   214,   215,   216,
     217,   218,     0,   220,   221,   222,     0,     0,     0,     0,
     223,  1037,     0,     0,   224,   225,     0,   226,   227,   745,
     228,   229,   230,   231,  1038,   746,  1039,  1040,     0,   235,
     236,   237,   238,   239,  1041,  1042,   240,   241,  1043,  1044,
     244,     0,   245,   246,   247,   248,  1045,     0,  1046,     0,
     250,   251,   252,   253,   748,   254,   255,     0,   256,   257,
     258,   259,   260,   261,     0,   749,   262,   263,  1047,  1048,
    1049,  1050,  1051,  1052,  1053,   264,   265,   266,   267,   268,
     269,  1054,  1055,   272,     0,   273,     0,   274,   275,   276,
     277,   278,     0,   279,   280,   281,     0,     0,   282,   283,
    1056,   285,   286,     0,   287,   288,   289,     0,   290,   291,
     292,     0,   293,   294,   295,   296,  1057,   298,   299,   300,
    1058,  1059,   302,     0,   303,   304,  1060,   306,     0,   307,
       0,   308,   751,     0,   752,   309,   310,   311,     0,   312,
    1061,     0,   314,     0,   315,   316,   317,   318,   319,   753,
     320,   321,   322,     0,   323,   324,   325,   326,   327,   328,
       0,   329,   754,   330,   331,   332,   333,   334,  1062,  1063,
       0,  1064,     0,   338,   755,   756,   339,   757,   340,   341,
     342,   343,   344,     0,   345,   346,     0,   347,  1065,   758,
     349,   759,     0,   350,   351,   352,  1066,  1067,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,  1068,   760,  1069,   368,   369,   370,  1070,   371,   372,
     761,   373,  1071,  1072,   375,  1073,   377,   378,   379,     0,
     380,     0,     0,  1074,   382,   383,     0,     0,   384,   385,
     762,   386,   763,  1075,   388,   389,   390,   391,   392,   393,
     394,     0,   395,  1076,   397,   398,   399,   400,   401,     0,
     402,   403,   404,   405,   406,   407,   408,   409,  1077,   411,
     412,   413,   414,     0,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,     0,   426,   427,   764,   428,
     429,  1078,   431,   432,   433,   434,   435,   436,   437,   438,
       0,   439,   440,   441,   442,   443,  1079,   444,   445,   446,
     447,   765,   448,  1080,   450,     0,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,  1081,     0,   462,   463,
       0,   464,   465,   466,   467,   468,   469,     0,  1082,  1083,
       0,     0,   472,  1084,   474,  1085,  1086,   476,   477,   478,
     479,   480,   481,   482,     0,  1087,   483,   484,   485,   486,
     487,  1088,     0,   488,   489,   490,   491,   492,   493,  1089,
       0,   495,   766,   496,   497,   498,   499,     0,     0,   500,
       0,     0,   501,   502,   503,   504,   505,   506,   507,  1090,
    1091,  1092,  1093,  1094,  1095,  1096,  1097,   516,   517,   518,
       0,     0,     0,     0,     0,     0,     0,     0,  1098,  1099,
    1100,     0,     0,     0,     0,     0,     0,  1101,   744,  1032,
     574,  1033,  1034,  1035,   625,  1036,     0,     0,     0,   211,
     212,   213,   214,   215,   216,   217,   218,     0,   220,   221,
     222,     0,     0,     0,     0,   223,  1037,     0,     0,   224,
     225,     0,   226,   227,   745,   228,   229,   230,   231,  1038,
     746,  1039,  1040,     0,   235,   236,   237,   238,   239,  1041,
    1042,   240,   241,  1043,  1044,   244,     0,   245,   246,   247,
     248,  1045,     0,  1046,     0,   250,   251,   252,   253,   748,
     254,   255,     0,   256,   257,   258,   259,   260,   261,     0,
     749,   262,   263,  1047,  1048,  1049,  1050,  1051,  1052,  1053,
     264,   265,   266,   267,   268,   269,  1054,  1055,   272,  1173,
     273,     0,   274,   275,   276,   277,   278,     0,   279,   280,
     281,     0,     0,   282,   283,  1056,   285,   286,     0,   287,
     288,   289,     0,   290,   291,   292,     0,   293,   294,   295,
     296,  1057,   298,   299,   300,  1058,  1059,   302,     0,   303,
     304,  1060,   306,     0,   307,     0,   308,   751,     0,   752,
     309,   310,   311,     0,   312,  1061,     0,   314,     0,   315,
     316,   317,   318,   319,   753,   320,   321,   322,     0,   323,
     324,   325,   326,   327,   328,     0,   329,   754,   330,   331,
     332,   333,   334,  1062,  1063,     0,  1064,     0,   338,   755,
     756,   339,   757,   340,   341,   342,   343,   344,     0,   345,
     346,     0,   347,  1065,   758,   349,   759,     0,   350,   351,
     352,  1066,  1067,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,  1068,   760,  1069,   368,
     369,   370,  1070,   371,   372,   761,   373,  1071,  1072,   375,
    1073,   377,   378,   379,     0,   380,     0,     0,  1074,   382,
     383,     0,     0,   384,   385,   762,   386,   763,  1075,   388,
     389,   390,   391,   392,   393,   394,     0,   395,  1076,   397,
     398,   399,   400,   401,     0,   402,   403,   404,   405,   406,
     407,   408,   409,  1077,   411,   412,   413,   414,     0,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
       0,   426,   427,   764,   428,   429,  1078,   431,   432,   433,
     434,   435,   436,   437,   438,     0,   439,   440,   441,   442,
     443,  1079,   444,   445,   446,   447,   765,   448,  1080,   450,
       0,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,  1081,     0,   462,   463,     0,   464,   465,   466,   467,
     468,   469,     0,  1082,  1083,     0,     0,   472,  1084,   474,
    1085,  1086,   476,   477,   478,   479,   480,   481,   482,     0,
    1087,   483,   484,   485,   486,   487,  1088,     0,   488,   489,
     490,   491,   492,   493,  1089,     0,   495,   766,   496,   497,
     498,   499,     0,     0,   500,     0,     0,   501,   502,   503,
     504,   505,   506,   507,  1090,  1091,  1092,  1093,  1094,  1095,
    1096,  1097,   516,   517,   518,     0,     0,     0,     0,     0,
       0,     0,     0,  1098,  1099,     0,     0,     0,     0,     0,
       0,     0,  1101,   744,  1032,   574,  1033,  1034,  1035,   625,
    1036,     0,     0,     0,   211,   212,   213,   214,   215,   216,
     217,   218,  1853,   220,   221,   222,     0,     0,     0,     0,
     223,  1037,     0,     0,   224,   225,     0,   226,   227,   745,
     228,   229,   230,   231,  1038,   746,  1039,  1040,     0,   235,
     236,   237,   238,   239,  1041,  1042,   240,   241,  1043,  1044,
     244,     0,   245,   246,   247,   248,  1045,     0,  1046,     0,
     250,   251,   252,   253,   748,   254,   255,     0,   256,   257,
     258,   259,   260,   261,     0,   749,   262,   263,  1047,  1048,
    1049,  1050,  1051,  1052,  1053,   264,   265,   266,   267,   268,
     269,  1054,  1055,   272,     0,   273,     0,   274,   275,   276,
     277,   278,     0,   279,   280,   281,     0,     0,   282,   283,
    1056,   285,   286,     0,   287,   288,   289,     0,   290,   291,
     292,     0,   293,   294,   295,   296,  1057,   298,   299,   300,
    1058,  1059,   302,     0,   303,   304,  1060,   306,     0,   307,
       0,   308,   751,     0,   752,   309,   310,   311,     0,   312,
    1061,     0,   314,     0,   315,   316,   317,   318,   319,   753,
     320,   321,   322,     0,   323,   324,   325,   326,   327,   328,
       0,   329,   754,   330,   331,   332,   333,   334,  1062,  1063,
       0,  1064,     0,   338,   755,   756,   339,   757,   340,   341,
     342,   343,   344,     0,   345,   346,     0,   347,  1065,   758,
     349,   759,     0,   350,   351,   352,  1066,  1067,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,  1068,   760,  1069,   368,   369,   370,  1070,   371,   372,
     761,   373,  1071,  1072,   375,  1073,   377,   378,   379,     0,
     380,     0,     0,  1074,   382,   383,     0,     0,   384,   385,
     762,   386,   763,  1075,   388,   389,   390,   391,   392,   393,
     394,     0,   395,  1076,   397,   398,   399,   400,   401,     0,
     402,   403,   404,   405,   406,   407,   408,   409,  1077,   411,
     412,   413,   414,     0,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,     0,   426,   427,   764,   428,
     429,  1078,   431,   432,   433,   434,   435,   436,   437,   438,
       0,   439,   440,   441,   442,   443,  1079,   444,   445,   446,
     447,   765,   448,  1080,   450,     0,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,  1081,     0,   462,   463,
       0,   464,   465,   466,   467,   468,   469,     0,  1082,  1083,
       0,     0,   472,  1084,   474,  1085,  1086,   476,   477,   478,
     479,   480,   481,   482,     0,  1087,   483,   484,   485,   486,
     487,  1088,     0,   488,   489,   490,   491,   492,   493,  1089,
       0,   495,   766,   496,   497,   498,   499,     0,     0,   500,
       0,     0,   501,   502,   503,   504,   505,   506,   507,  1090,
    1091,  1092,  1093,  1094,  1095,  1096,  1097,   516,   517,   518,
       0,     0,     0,     0,     0,     0,     0,     0,  1098,  1099,
       0,     0,     0,     0,     0,     0,     0,  1101,   744,  1032,
     574,  1033,  1034,  1035,   625,  1036,     0,     0,     0,   211,
     212,   213,   214,   215,   216,   217,   218,     0,   220,   221,
     222,     0,     0,     0,     0,   223,  1037,     0,     0,   224,
     225,     0,   226,   227,   745,   228,   229,   230,   231,  1038,
     746,  1039,  1040,     0,   235,   236,   237,   238,   239,  1041,
    1042,   240,   241,  1043,  1044,   244,     0,   245,   246,   247,
     248,  1045,     0,  1046,     0,   250,   251,   252,   253,   748,
     254,   255,     0,   256,   257,   258,   259,   260,   261,     0,
     749,   262,   263,  1047,  1048,  1049,  1050,  1051,  1052,  1053,
     264,   265,   266,   267,   268,   269,  1054,  1055,   272,     0,
     273,     0,   274,   275,   276,   277,   278,     0,   279,   280,
     281,     0,     0,   282,   283,  1056,   285,   286,     0,   287,
     288,   289,     0,   290,   291,   292,     0,   293,   294,   295,
     296,  1057,   298,   299,   300,  1058,  1059,   302,     0,   303,
     304,  1060,   306,     0,   307,     0,   308,   751,  2388,   752,
     309,   310,   311,     0,   312,  1061,     0,   314,     0,   315,
     316,   317,   318,   319,   753,   320,   321,   322,     0,   323,
     324,   325,   326,   327,   328,     0,   329,   754,   330,   331,
     332,   333,   334,  1062,  1063,     0,  1064,     0,   338,   755,
     756,   339,   757,   340,   341,   342,   343,   344,     0,   345,
     346,     0,   347,  1065,   758,   349,   759,     0,   350,   351,
     352,  1066,  1067,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,  1068,   760,  1069,   368,
     369,   370,  1070,   371,   372,   761,   373,  1071,  1072,   375,
    1073,   377,   378,   379,     0,   380,     0,     0,  1074,   382,
     383,     0,     0,   384,   385,   762,   386,   763,  1075,   388,
     389,   390,   391,   392,   393,   394,     0,   395,  1076,   397,
     398,   399,   400,   401,     0,   402,   403,   404,   405,   406,
     407,   408,   409,  1077,   411,   412,   413,   414,     0,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
       0,   426,   427,   764,   428,   429,  1078,   431,   432,   433,
     434,   435,   436,   437,   438,     0,   439,   440,   441,   442,
     443,  1079,   444,   445,   446,   447,   765,   448,  1080,   450,
       0,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,  1081,     0,   462,   463,     0,   464,   465,   466,   467,
     468,   469,     0,  1082,  1083,     0,     0,   472,  1084,   474,
    1085,  1086,   476,   477,   478,   479,   480,   481,   482,     0,
    1087,   483,   484,   485,   486,   487,  1088,     0,   488,   489,
     490,   491,   492,   493,  1089,     0,   495,   766,   496,   497,
     498,   499,     0,     0,   500,     0,     0,   501,   502,   503,
     504,   505,   506,   507,  1090,  1091,  1092,  1093,  1094,  1095,
    1096,  1097,   516,   517,   518,     0,     0,     0,     0,     0,
       0,     0,     0,  1098,  1099,     0,     0,     0,     0,     0,
       0,     0,  1101,   744,  1032,   574,  1033,  1034,  1035,   625,
    1036,     0,     0,     0,   211,   212,   213,   214,   215,   216,
     217,   218,     0,   220,   221,   222,     0,     0,     0,     0,
     223,  1037,     0,     0,   224,   225,     0,   226,   227,   745,
     228,   229,   230,   231,  1038,   746,  1039,  1040,     0,   235,
     236,   237,   238,   239,  1041,  1042,   240,   241,  1043,  1044,
     244,     0,   245,   246,   247,   248,  1045,     0,  1046,     0,
     250,   251,   252,   253,   748,   254,   255,     0,   256,   257,
     258,   259,   260,   261,     0,   749,   262,   263,  1047,  1048,
    1049,  1050,  1051,  1052,  1053,   264,   265,   266,   267,   268,
     269,  1054,  1055,   272,     0,   273,     0,   274,   275,   276,
     277,   278,     0,   279,   280,   281,     0,     0,   282,   283,
    1056,   285,   286,     0,   287,   288,   289,     0,   290,   291,
     292,     0,   293,   294,   295,   296,  1057,   298,   299,   300,
    1058,  1059,   302,     0,   303,   304,  1060,   306,     0,   307,
       0,   308,   751,     0,   752,   309,   310,   311,     0,   312,
    1061,     0,   314,     0,   315,   316,   317,   318,   319,   753,
     320,   321,   322,     0,   323,   324,   325,   326,   327,   328,
       0,   329,   754,   330,   331,   332,   333,   334,  1062,  1063,
       0,  1064,     0,   338,   755,   756,   339,   757,   340,   341,
     342,   343,   344,     0,   345,   346,     0,   347,  1065,   758,
     349,   759,     0,   350,   351,   352,  1066,  1067,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,  1068,   760,  1069,   368,   369,   370,  1070,   371,   372,
     761,   373,  1071,  1072,   375,  1073,   377,   378,   379,     0,
     380,     0,     0,  1074,   382,   383,     0,     0,   384,   385,
     762,   386,   763,  1075,   388,   389,   390,   391,   392,   393,
     394,     0,   395,  1076,   397,   398,   399,   400,   401,     0,
     402,   403,   404,   405,   406,   407,   408,   409,  1077,   411,
     412,   413,   414,     0,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,     0,   426,   427,   764,   428,
     429,  1078,   431,   432,   433,   434,   435,   436,   437,   438,
       0,   439,   440,   441,   442,   443,  1079,   444,   445,   446,
     447,   765,   448,  1080,   450,     0,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,  1081,     0,   462,   463,
       0,   464,   465,   466,   467,   468,   469,     0,  1082,  1083,
       0,     0,   472,  1084,   474,  1085,  1086,   476,   477,   478,
     479,   480,   481,   482,     0,  1087,   483,   484,   485,   486,
     487,  1088,     0,   488,   489,   490,   491,   492,   493,  1089,
    3601,   495,   766,   496,   497,   498,   499,     0,     0,   500,
       0,     0,   501,   502,   503,   504,   505,   506,   507,  1090,
    1091,  1092,  1093,  1094,  1095,  1096,  1097,   516,   517,   518,
       0,     0,     0,     0,     0,     0,     0,     0,  1098,  1099,
       0,     0,     0,     0,     0,     0,     0,  1101,   744,  1032,
     574,  1033,  1034,  1035,   625,  1036,     0,     0,     0,   211,
     212,   213,   214,   215,   216,   217,   218,     0,   220,   221,
     222,     0,     0,     0,     0,   223,  1037,     0,     0,   224,
     225,     0,   226,   227,   745,   228,   229,   230,   231,  1038,
     746,  1039,  1040,     0,   235,   236,   237,   238,   239,  1041,
    1042,   240,   241,  1043,  1044,   244,     0,   245,   246,   247,
     248,  1045,     0,  1046,     0,   250,   251,   252,   253,   748,
     254,   255,     0,   256,   257,   258,   259,   260,   261,     0,
     749,   262,   263,  1047,  1048,  1049,  1050,  1051,  1052,  1053,
     264,   265,   266,   267,   268,   269,  1054,  1055,   272,     0,
     273,     0,   274,   275,   276,   277,   278,     0,   279,   280,
     281,     0,     0,   282,   283,  1056,   285,   286,     0,   287,
     288,   289,     0,   290,   291,   292,     0,   293,   294,   295,
     296,  1057,   298,   299,   300,  1058,  1059,   302,     0,   303,
     304,  1060,   306,     0,   307,     0,   308,   751,     0,   752,
     309,   310,   311,     0,   312,  1061,     0,   314,     0,   315,
     316,   317,   318,   319,   753,   320,   321,   322,     0,   323,
     324,   325,   326,   327,   328,     0,   329,   754,   330,   331,
     332,   333,   334,  1062,  1063,     0,  1064,     0,   338,   755,
     756,   339,   757,   340,   341,   342,   343,   344,     0,   345,
     346,     0,   347,  1065,   758,   349,   759,     0,   350,   351,
     352,  1066,  1067,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,  1068,   760,  1069,   368,
     369,   370,  1070,   371,   372,   761,   373,  1071,  1072,   375,
    1073,   377,   378,   379,     0,   380,     0,     0,  1074,   382,
     383,     0,     0,   384,   385,   762,   386,   763,  1075,   388,
     389,   390,   391,   392,   393,   394,     0,   395,  1076,   397,
     398,   399,   400,   401,     0,   402,   403,   404,   405,   406,
     407,   408,   409,  1077,   411,   412,   413,   414,     0,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
       0,   426,   427,   764,   428,   429,  1078,   431,   432,   433,
     434,   435,   436,   437,   438,     0,   439,   440,   441,   442,
     443,  1079,   444,   445,   446,   447,   765,   448,  1080,   450,
       0,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,  1081,     0,   462,   463,     0,   464,   465,   466,   467,
     468,   469,     0,  1082,  1083,     0,     0,   472,  1084,   474,
    1085,  1086,   476,   477,   478,   479,   480,   481,   482,     0,
    1087,   483,   484,   485,   486,   487,  1088,     0,   488,   489,
     490,   491,   492,   493,  1089,     0,   495,   766,   496,   497,
     498,   499,     0,     0,   500,     0,     0,   501,   502,   503,
     504,   505,   506,   507,  1090,  1091,  1092,  1093,  1094,  1095,
    1096,  1097,   516,   517,   518,     0,     0,     0,     0,     0,
       0,     0,     0,  1098,  1099,     0,     0,     0,     0,     0,
       0,     0,  1101,   744,  1032,   574,  1033,  1034,  1035,   625,
    1036,     0,     0,     0,   211,   212,   213,   214,   215,   216,
     217,   218,     0,   220,   221,   222,     0,     0,     0,     0,
     223,  1037,     0,     0,   224,   225,     0,   226,   227,   745,
     228,   229,   230,   231,  1038,   746,  1039,  1040,     0,   235,
     236,   237,   238,   239,  1041,  1042,   240,   241,  1043,  1044,
     244,     0,   245,   246,   247,   248,  1045,     0,  1046,     0,
     250,   251,   252,   253,   748,   254,   255,     0,   256,   257,
     258,   259,   260,   261,     0,   749,   262,  3611,  1047,  1048,
    1049,  1050,  1051,  1052,  1053,   264,   265,   266,   267,   268,
     269,  1054,  1055,   272,     0,   273,     0,   274,   275,   276,
     277,   278,     0,   279,   280,   281,     0,     0,   282,   283,
    1056,   285,   286,     0,   287,   288,   289,     0,   290,   291,
     292,     0,   293,   294,   295,   296,  1057,   298,   299,   300,
    1058,  1059,   302,     0,   303,   304,  1060,   306,     0,   307,
       0,   308,   751,     0,   752,   309,   310,   311,     0,   312,
    1061,     0,   314,     0,   315,   316,   317,   318,   319,   753,
     320,   321,   322,     0,   323,   324,   325,   326,   327,   328,
       0,   329,   754,   330,   331,   332,   333,   334,  1062,  1063,
       0,  1064,     0,   338,   755,   756,   339,   757,   340,   341,
     342,   343,   344,     0,   345,   346,     0,   347,  1065,   758,
     349,   759,     0,   350,   351,   352,  1066,  1067,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,  1068,   760,  1069,   368,   369,   370,  1070,   371,   372,
     761,   373,  1071,  1072,   375,  1073,   377,   378,   379,     0,
     380,     0,     0,  1074,   382,   383,     0,     0,   384,   385,
     762,   386,   763,  1075,   388,   389,   390,   391,   392,   393,
     394,     0,   395,  1076,   397,   398,   399,   400,   401,     0,
     402,   403,   404,   405,   406,   407,   408,   409,  1077,   411,
     412,   413,   414,     0,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,     0,   426,   427,   764,   428,
     429,  1078,   431,   432,   433,   434,   435,   436,   437,   438,
       0,   439,   440,   441,   442,   443,  1079,   444,   445,   446,
     447,   765,   448,  1080,   450,     0,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,  1081,     0,   462,   463,
       0,   464,   465,   466,   467,   468,   469,     0,  1082,  1083,
       0,     0,   472,  1084,   474,  1085,  1086,   476,   477,   478,
     479,   480,   481,   482,     0,  1087,   483,   484,   485,   486,
     487,  1088,     0,   488,   489,   490,   491,   492,   493,  1089,
       0,   495,   766,   496,   497,   498,   499,     0,     0,   500,
       0,     0,   501,   502,   503,   504,   505,   506,   507,  1090,
    1091,  1092,  1093,  1094,  1095,  1096,  1097,   516,   517,   518,
       0,     0,     0,     0,     0,     0,     0,     0,  1098,  1099,
       0,     0,     0,     0,     0,     0,     0,  1101,   744,  1032,
     574,  1033,  1034,  1035,   625,  1036,     0,     0,     0,   211,
     212,   213,   214,   215,   216,   217,   218,     0,   220,   221,
     222,     0,     0,     0,     0,   223,  1037,     0,     0,   224,
     225,     0,   226,   227,   745,   228,   229,   230,   231,  1038,
     746,  1039,  1040,     0,   235,   236,   237,   238,   239,  1041,
    1042,   240,   241,  1043,  1044,   244,     0,   245,   246,   247,
     248,  1045,     0,  1046,     0,   250,   251,   252,   253,   748,
     254,   255,     0,   256,   257,   258,   259,   260,   261,     0,
     749,   262,   263,  1047,  1048,  1049,  1050,  1051,  1052,  1053,
     264,   265,   266,   267,   268,   269,  1054,  1055,   272,     0,
     273,     0,   274,   275,   276,   277,   278,     0,   279,   280,
     281,     0,     0,   282,   283,  1056,   285,   286,     0,   287,
     288,   289,     0,   290,   291,   292,     0,   293,   294,   295,
     296,  1057,   298,   299,   300,  1058,  1059,   302,     0,   303,
     304,  1060,   306,     0,   307,     0,   308,   751,     0,   752,
     309,   310,   311,     0,   312,  1061,     0,   314,     0,   315,
     316,   317,   318,   319,   753,   320,   321,   322,     0,   323,
     324,   325,   326,   327,   328,     0,   329,   754,   330,   331,
     332,   333,   334,  1062,  1063,     0,  1064,     0,   338,   755,
     756,   339,   757,   340,   341,   342,   343,   344,     0,   345,
     346,     0,   347,  1065,   758,   349,   759,     0,   350,   351,
     352,  1066,  1067,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,  1068,   760,  1069,   368,
     369,   370,  1070,   371,   372,   761,   373,  1071,  1072,   375,
    1073,   377,   378,   379,     0,   380,     0,     0,  1074,   382,
     383,     0,     0,   384,   385,   762,   386,   763,  1075,   388,
     389,   390,   391,   392,   393,   394,     0,   395,  1076,   397,
     398,   399,   400,   401,     0,   402,   403,   404,   405,   406,
     407,   408,   409,  1077,   411,   412,   413,   414,     0,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
       0,   426,   427,   764,   428,   429,  1078,   431,   432,   433,
     434,   435,   436,   437,   438,     0,   439,   440,   441,   442,
     443,  1079,   444,   445,   446,   447,   765,   448,  1080,   450,
       0,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,  1081,     0,   462,   463,     0,   464,   465,   466,   467,
     468,   469,     0,  1082,  1083,     0,     0,   472,  1084,   474,
    1085,  1086,   476,   477,   478,   479,   480,   481,   482,     0,
    1087,   483,   484,   485,   486,   487,  1088,     0,   488,   489,
     490,   491,   492,   493,  1089,     0,   495,   766,   496,   497,
     498,   499,     0,     0,   500,     0,     0,   501,   502,   503,
     504,   505,   506,  3898,  1090,  1091,  1092,  1093,  1094,  1095,
    1096,  1097,   516,   517,   518,     0,     0,     0,     0,     0,
       0,     0,     0,  1098,  1099,     0,     0,     0,     0,     0,
       0,     0,  1101,   744,  1032,   574,  1033,  1034,  1035,   625,
    1036,     0,     0,     0,   211,   212,   213,   214,   215,   216,
     217,   218,     0,   220,   221,   222,     0,     0,     0,     0,
     223,  1037,     0,     0,   224,   225,     0,   226,   227,   745,
     228,   229,   230,   231,  1038,   746,  1039,  1040,     0,   235,
     236,   237,   238,   239,  1041,  1042,   240,   241,  1043,  1044,
     244,     0,   245,   246,   247,   248,  1045,     0,  1046,     0,
     250,   251,   252,   253,   748,   254,   255,     0,   256,   257,
     258,   259,   260,   261,     0,   749,   262,   263,  1047,  1048,
    1049,  1050,  1051,  1052,  1053,   264,   265,   266,   267,   268,
     269,  1054,  1055,   272,     0,   273,     0,   274,   275,   276,
     277,   278,     0,   279,   280,   281,     0,     0,   282,   283,
    1056,   285,   286,     0,   287,   288,   289,     0,   290,   291,
     292,     0,   293,   294,   295,   296,  1057,   298,   299,   300,
    1058,  1059,   302,     0,   303,   304,  1060,   306,     0,   307,
       0,   308,   751,     0,   752,   309,   310,   311,     0,   312,
    1061,     0,   314,     0,   315,   316,   317,   318,   319,   753,
     320,   321,   322,     0,   323,   324,   325,   326,   327,   328,
       0,   329,   754,   330,   331,   332,   333,   334,  1062,  1063,
       0,  1064,     0,   338,   755,   756,   339,   757,   340,   341,
     342,   343,   344,     0,   345,   346,     0,   347,  1065,   758,
     349,   759,     0,   350,   351,   352,  1066,  1067,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,  1068,   760,  1069,   368,  3907,   370,  1070,   371,   372,
     761,   373,  1071,  1072,   375,  1073,   377,   378,   379,     0,
     380,     0,     0,  1074,   382,   383,     0,     0,   384,   385,
     762,   386,   763,  1075,   388,   389,   390,   391,   392,   393,
     394,     0,   395,  1076,   397,   398,   399,   400,   401,     0,
     402,   403,   404,   405,   406,   407,   408,   409,  1077,   411,
     412,   413,   414,     0,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,     0,   426,   427,   764,   428,
     429,  1078,   431,   432,   433,   434,   435,   436,   437,   438,
       0,   439,   440,   441,   442,   443,  1079,   444,   445,   446,
     447,   765,   448,  1080,   450,     0,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,  1081,     0,   462,   463,
       0,   464,   465,   466,   467,   468,   469,     0,  1082,  1083,
       0,     0,   472,  1084,   474,  1085,  1086,   476,   477,   478,
     479,   480,   481,   482,     0,  1087,   483,   484,   485,   486,
     487,  1088,     0,   488,   489,   490,   491,   492,   493,  1089,
       0,   495,   766,   496,   497,   498,   499,     0,     0,   500,
       0,     0,   501,   502,   503,   504,   505,   506,   507,  1090,
    1091,  1092,  1093,  1094,  1095,  1096,  1097,   516,   517,   518,
       0,     0,     0,     0,     0,     0,     0,     0,  1098,  1099,
       0,     0,     0,     0,     0,     0,     0,  1101,   744,  1032,
     574,  1033,  1034,  1035,   625,  1036,     0,     0,     0,   211,
     212,   213,   214,   215,   216,   217,   218,     0,   220,   221,
     222,     0,     0,     0,     0,   223,  1037,     0,     0,   224,
     225,     0,   226,   227,   745,   228,   229,   230,  4480,  1038,
     746,  1039,  1040,     0,   235,   236,   237,   238,   239,  1041,
    1042,   240,   241,  1043,  1044,   244,     0,   245,   246,   247,
     248,  1045,     0,  1046,     0,   250,   251,   252,   253,   748,
     254,   255,     0,   256,   257,   258,   259,   260,   261,     0,
     749,   262,  4481,  1047,  1048,  1049,  1050,  1051,  1052,  1053,
     264,   265,   266,   267,   268,   269,  1054,  1055,   272,     0,
     273,     0,   274,   275,   276,   277,   278,     0,   279,   280,
     281,     0,     0,   282,   283,  1056,   285,   286,     0,   287,
     288,   289,     0,   290,   291,   292,     0,   293,   294,   295,
     296,  1057,   298,   299,   300,  1058,  1059,   302,     0,   303,
     304,  1060,   306,     0,   307,     0,   308,   751,     0,   752,
     309,   310,   311,     0,   312,  1061,     0,   314,     0,   315,
     316,   317,   318,   319,   753,   320,   321,   322,     0,   323,
     324,   325,   326,   327,   328,     0,   329,   754,   330,   331,
     332,   333,   334,  1062,  1063,     0,  1064,     0,   338,   755,
     756,   339,   757,   340,   341,   342,   343,   344,     0,   345,
     346,     0,   347,  1065,   758,   349,   759,     0,   350,   351,
     352,  1066,  1067,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,  1068,   760,  1069,   368,
     369,   370,  1070,   371,   372,   761,   373,  1071,  1072,   375,
    1073,   377,   378,   379,     0,   380,     0,     0,  1074,   382,
     383,     0,     0,   384,   385,   762,   386,   763,  1075,   388,
     389,   390,   391,   392,   393,   394,     0,   395,  1076,   397,
     398,   399,   400,   401,     0,   402,   403,   404,   405,   406,
     407,   408,   409,  1077,   411,   412,   413,   414,     0,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
       0,   426,   427,   764,   428,   429,  1078,   431,   432,   433,
     434,   435,   436,   437,   438,     0,   439,   440,   441,   442,
     443,  1079,   444,   445,   446,   447,   765,   448,  1080,   450,
       0,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,  1081,     0,   462,   463,     0,   464,   465,   466,   467,
     468,   469,     0,  1082,  1083,     0,     0,   472,  1084,   474,
    1085,  1086,   476,   477,   478,   479,  4482,   481,   482,     0,
    1087,   483,   484,   485,   486,   487,  1088,     0,   488,   489,
     490,   491,   492,   493,  1089,     0,   495,   766,   496,   497,
     498,   499,     0,     0,   500,     0,     0,   501,   502,   503,
     504,   505,   506,   507,  1090,  1091,  1092,  1093,  1094,  1095,
    1096,  1097,   516,   517,   518,     0,     0,     0,     0,     0,
       0,     0,     0,  1098,  1099,     0,     0,     0,     0,     0,
       0,     0,  1101,   744,  1032,   574,  1033,  1034,  1035,   625,
    1036,     0,     0,     0,   211,   212,   213,   214,   215,   216,
     217,   218,     0,   220,   221,   222,     0,     0,     0,     0,
     223,  1037,     0,     0,   224,   225,     0,   226,   227,   745,
     228,   229,   230,   231,  1038,   746,  1039,  1040,     0,   235,
     236,   237,   238,   239,  1041,  1042,   240,   241,  1043,  1044,
     244,     0,   245,   246,   247,   248,  1045,     0,  1046,     0,
     250,   251,   252,   253,   748,   254,   255,     0,   256,   257,
     258,   259,   260,   261,     0,   749,   262,  4481,  1047,  1048,
    1049,  1050,  1051,  1052,  1053,   264,   265,   266,   267,   268,
     269,  1054,  1055,   272,     0,   273,     0,   274,   275,   276,
     277,   278,     0,   279,   280,   281,     0,     0,   282,   283,
    1056,   285,   286,     0,   287,   288,   289,     0,   290,   291,
     292,     0,   293,   294,   295,   296,  1057,   298,   299,   300,
    1058,  1059,   302,     0,   303,   304,  1060,   306,     0,   307,
       0,   308,   751,     0,   752,   309,   310,   311,     0,   312,
    1061,     0,   314,     0,   315,   316,   317,   318,   319,   753,
     320,   321,   322,     0,   323,   324,   325,   326,   327,   328,
       0,   329,   754,   330,   331,   332,   333,   334,  1062,  1063,
       0,  1064,     0,   338,   755,   756,   339,   757,   340,   341,
     342,   343,   344,     0,   345,   346,     0,   347,  1065,   758,
     349,   759,     0,   350,   351,   352,  1066,  1067,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,  1068,   760,  1069,   368,   369,   370,  1070,   371,   372,
     761,   373,  1071,  1072,   375,  1073,   377,   378,   379,     0,
     380,     0,     0,  1074,   382,   383,     0,     0,   384,   385,
     762,   386,   763,  1075,   388,   389,   390,   391,   392,   393,
     394,     0,   395,  1076,   397,   398,   399,   400,   401,     0,
     402,   403,   404,   405,   406,   407,   408,   409,  1077,   411,
     412,   413,   414,     0,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,     0,   426,   427,   764,   428,
     429,  1078,   431,   432,   433,   434,   435,   436,   437,   438,
       0,   439,   440,   441,   442,   443,  1079,   444,   445,   446,
     447,   765,   448,  1080,   450,     0,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,  1081,     0,   462,   463,
       0,   464,   465,   466,   467,   468,   469,     0,  1082,  1083,
       0,     0,   472,  1084,   474,  1085,  1086,   476,   477,   478,
     479,  4482,   481,   482,     0,  1087,   483,   484,   485,   486,
     487,  1088,     0,   488,   489,   490,   491,   492,   493,  1089,
       0,   495,   766,   496,   497,   498,   499,     0,     0,   500,
       0,     0,   501,   502,   503,   504,   505,   506,   507,  1090,
    1091,  1092,  1093,  1094,  1095,  1096,  1097,   516,   517,   518,
       0,     0,     0,     0,     0,     0,     0,     0,  1098,  1099,
       0,     0,     0,     0,     0,     0,     0,  1101,   744,  1032,
     574,  1033,  1034,  1035,   625,  1036,     0,     0,     0,   211,
     212,   213,   214,   215,   216,   217,   218,     0,   220,   221,
     222,     0,     0,     0,     0,   223,  1037,     0,     0,   224,
     225,     0,   226,   227,   745,   228,   229,   230,   231,  1038,
     746,  1039,  1040,     0,   235,   236,   237,   238,   239,  1041,
    1042,   240,   241,  1043,  1044,   244,     0,   245,   246,   247,
     248,  1045,     0,  1046,     0,   250,   251,   252,   253,   748,
     254,   255,     0,   256,   257,   258,   259,   260,   261,     0,
     749,   262,   263,  1047,  1048,  1049,  1050,  1051,  1052,  1053,
     264,   265,   266,   267,   268,   269,  1054,  1055,   272,     0,
     273,     0,   274,   275,   276,   277,   278,     0,   279,   280,
     281,     0,     0,   282,   283,  1056,   285,   286,     0,   287,
     288,   289,     0,   290,   291,   292,     0,   293,   294,   295,
     296,  1057,   298,   299,   300,  1058,  1059,   302,     0,   303,
     304,  1060,   306,     0,   307,     0,   308,   751,     0,   752,
     309,   310,   311,     0,   312,  1061,     0,   314,     0,   315,
     316,   317,   318,   319,   753,   320,   321,   322,     0,   323,
     324,   325,   326,   327,   328,     0,   329,   754,   330,   331,
     332,   333,   334,  1062,  1063,     0,  1064,     0,   338,   755,
     756,   339,   757,   340,   341,   342,   343,   344,     0,   345,
     346,     0,   347,  1065,   758,   349,   759,     0,   350,   351,
     352,  1066,  1067,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,  1068,   760,  1069,   368,
     369,   370,     0,   371,   372,   761,   373,  1071,  1072,   375,
    1073,   377,   378,   379,     0,   380,     0,     0,  1074,   382,
     383,     0,     0,   384,   385,   762,   386,   763,  1075,   388,
     389,   390,   391,   392,   393,   394,     0,   395,  1076,   397,
     398,   399,   400,   401,     0,   402,   403,   404,   405,   406,
     407,   408,   409,  1077,   411,   412,   413,   414,     0,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
       0,   426,   427,   764,   428,   429,  1078,   431,   432,   433,
     434,   435,   436,   437,   438,     0,   439,   440,   441,   442,
     443,  1079,   444,   445,   446,   447,   765,   448,  1080,   450,
       0,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,  1081,     0,   462,   463,     0,   464,   465,   466,   467,
     468,   469,     0,  1082,  1083,     0,     0,   472,  1084,   474,
    1085,  1086,   476,   477,   478,   479,   480,   481,   482,     0,
       0,   483,   484,   485,   486,   487,  1088,     0,   488,   489,
     490,   491,   492,   493,  1089,     0,   495,   766,   496,   497,
     498,   499,     0,     0,   500,     0,     0,   501,   502,   503,
     504,   505,   506,   507,  1090,  1091,  1092,  1093,  1094,  1095,
    1096,  1097,   516,   517,   518,     0,     0,     0,     0,     0,
       0,     0,     0,  2370,  2371,     0,     0,     0,     0,     0,
       0,     0,  1101,   744,  1032,   574,  1033,  1034,  1035,   625,
    1036,     0,     0,     0,   211,   212,   213,   214,   215,   216,
     217,   218,     0,   220,   221,   222,     0,     0,     0,     0,
     223,  1037,     0,     0,   224,   225,     0,   226,   227,   745,
     228,   229,   230, -2276,  1038,   746,  1039,  1040,     0,   235,
     236,   237,   238,   239,  1041,  1042,   240,   241,  1043,  1044,
     244,     0,   245,   246,   247,   248,  1045,     0,  1046,     0,
     250,   251,   252,   253,   748,   254,   255,     0,   256,   257,
     258,   259,   260,   261,     0,   749,   262,  4481,  1047,  1048,
    1049,  1050,  1051,  1052,  1053,   264,   265,   266,   267,   268,
     269,  1054,  1055,   272,     0,   273,     0,   274,   275,   276,
     277,   278,     0,   279,   280,   281,     0,     0,   282,   283,
    1056,   285,   286,     0,   287,   288,   289,     0,   290,   291,
     292,     0,   293,   294,   295,   296,  1057,   298,   299,   300,
    1058,  1059,   302,     0,   303,   304,  1060,   306,     0,   307,
       0,   308,   751,     0,   752,   309,   310,   311,     0,   312,
    1061,     0,   314,     0,   315,   316,   317,   318,   319,     0,
     320,   321,   322,     0,   323,   324,   325,   326,   327,   328,
       0,   329,   754,   330,   331,   332,   333,   334,  1062,  1063,
       0,  1064,     0,   338,   755,   756,   339,   757,   340,   341,
     342,   343,   344,     0,   345,   346,     0,   347,  1065,   758,
     349,     0,     0,   350,   351,   352,  1066,  1067,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,  1068,   760,  1069,   368,   369,   370,     0,   371,   372,
     761,   373,  1071,  1072,   375,  1073,   377,   378,   379,     0,
     380,     0,     0,  1074,   382,   383,     0,     0,   384,   385,
     762,   386,   763,  1075,   388,   389,   390,   391,   392,   393,
     394,     0,   395,  1076,   397,   398,   399,   400,   401,     0,
     402,   403,   404,   405,   406,   407,   408,   409,  1077,   411,
     412,   413,   414,     0,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,     0,   426,   427,   764,   428,
     429,  1078,   431,   432,   433,   434,   435,   436,   437,   438,
       0,   439,   440,   441,   442,   443,  1079,   444,   445,   446,
     447,     0,   448,  1080,   450,     0,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,  1081,     0,   462,   463,
       0,   464,   465,   466,   467,   468,   469,     0,  1082,  1083,
       0,     0,   472,  1084,   474,  1085,  1086,   476,   477,   478,
     479,  4482,   481,   482,     0,  1087,   483,   484,   485,   486,
     487,  1088,     0,   488,   489,   490,   491,   492,   493,  1089,
       0,   495,   766,   496,   497,   498,   499,     0,     0,   500,
       0,     0,   501,   502,   503,   504,   505,   506,   507,  1090,
    1091,  1092,  1093,  1094,  1095,  1096,  1097,   516,   517,   518,
       0,     0,     0,     0,     0,     0,     0,     0,  1098,  1099,
       0,     0,   744,  1032,   574,  1033,  1034,  1101,   625,  1036,
       0,     0,     0,   211,   212,   213,   214,   215,   216,   217,
     218,     0,   220,   221,   222,     0,     0,     0,     0,   223,
    1037,     0,     0,   224,   225,     0,   226,   227,   745,   228,
     229,   230,   231,  1038,   746,  1039,  1040,     0,   235,   236,
     237,   238,   239,  1041,  1042,   240,   241,  1043,  1044,   244,
       0,   245,   246,   247,   248,  1045,     0,  1046,     0,   250,
     251,   252,   253,   748,   254,   255,     0,   256,   257,   258,
     259,   260,   261,     0,   749,   262,   263,  1047,  1048,  1049,
    1050,  1051,  1052,  1053,   264,   265,   266,   267,   268,   269,
    1054,  1055,   272,     0,   273,     0,   274,   275,   276,   277,
     278,     0,   279,   280,   281,     0,     0,   282,   283,  1056,
     285,   286,     0,   287,   288,   289,     0,   290,   291,   292,
       0,   293,   294,   295,   296,  1057,   298,   299,   300,  1058,
    1059,   302,     0,   303,   304,  1060,   306,     0,   307,     0,
     308,   751,     0,   752,   309,   310,   311,     0,   312,  1061,
       0,   314,     0,   315,   316,   317,   318,   319,   753,   320,
     321,   322,     0,   323,   324,   325,   326,   327,   328,     0,
     329,   754,   330,   331,   332,   333,   334,  1062,  1063,     0,
    1064,     0,   338,   755,   756,   339,   757,   340,   341,   342,
     343,   344,     0,   345,   346,     0,   347,  1065,   758,   349,
     759,     0,   350,   351,   352,  1066,  1067,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
    1068,   760,  1069,   368,   369,   370,     0,   371,   372,   761,
     373,  1071,  1072,   375,  1073,   377,   378,   379,     0,   380,
       0,     0,   381,   382,   383,     0,     0,   384,   385,   762,
     386,   763,  1075,   388,   389,   390,   391,   392,   393,   394,
       0,   395,  1076,   397,   398,   399,   400,   401,     0,   402,
     403,   404,   405,   406,   407,   408,   409,  1077,   411,   412,
     413,   414,     0,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,     0,   426,   427,   764,   428,   429,
    1078,   431,   432,   433,   434,   435,   436,   437,   438,     0,
     439,   440,   441,   442,   443,  1079,   444,   445,   446,   447,
     765,   448,  1080,   450,     0,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,  1081,     0,   462,   463,     0,
     464,   465,   466,   467,   468,   469,     0,  1082,  1083,     0,
       0,   472,  1084,   474,  1085,  1086,   476,   477,   478,   479,
     480,   481,   482,     0,     0,   483,   484,   485,   486,   487,
    1088,     0,   488,   489,   490,   491,   492,   493,  1089,     0,
     495,   766,   496,   497,   498,   499,     0,     0,   500,     0,
       0,   501,   502,   503,   504,   505,   506,   507,  1090,  1091,
    1092,  1093,  1094,  1095,  1096,  1097,   516,   517,   518,     0,
       0,     0,     0,     0,     0,     0,   744,  1032,   574,  1033,
    1034,     0,   625,  1036,     0,     0,  1101,   211,   212,   213,
     214,   215,   216,   217,   218,     0,   220,   221,   222,     0,
       0,     0,     0,   223,  1037,     0,     0,   224,   225,     0,
     226,   227,   745,   228,   229,   230,   231,  1038,   746,  1039,
    1040,     0,  3519,   236,   237,   238,   239,  1041,  1042,   240,
     241,  1043,  1044,   244,     0,   245,   246,   247,   248,  1045,
       0,  1046,     0,   250,   251,   252,   253,   748,   254,   255,
       0,   256,   257,   258,   259,   260,   261,     0,   749,   262,
     263,  1047,  1048,  1049,  1050,  1051,  1052,  1053,   264,   265,
     266,   267,   268,   269,  1054,  1055,   272,     0,   273,     0,
     274,   275,   276,   277,   278,     0,   279,   280,   281,     0,
       0,   282,   283,  1056,   285,   286,     0,   287,   288,   289,
       0,   290,   291,   292,     0,   293,   294,   295,   296,  1057,
     298,   299,   300,  1058,  1059,   302,     0,   303,   304,  1060,
     306,     0,   307,     0,   308,   751,     0,   752,   309,   310,
     311,     0,   312,  1061,     0,   314,     0,   315,   316,   317,
     318,   319,   753,   320,   321,   322,     0,   323,   324,   325,
     326,   327,   328,     0,   329,   754,   330,   331,   332,   333,
     334,  1062,  1063,     0,  1064,     0,   338,   755,   756,   339,
     757,   340,   341,   342,   343,   344,     0,   345,   346,     0,
     347,  1065,   758,   349,   759,     0,   350,   351,   352,  1066,
    1067,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,  1068,   760,  1069,   368,   369,   370,
       0,   371,   372,   761,   373,  1071,  1072,   375,  1073,   377,
     378,   379,     0,   380,     0,     0,   381,   382,   383,     0,
       0,   384,   385,   762,   386,   763,  1075,   388,   389,   390,
     391,   392,   393,   394,     0,   395,  1076,   397,   398,   399,
     400,   401,     0,   402,   403,   404,   405,   406,   407,   408,
     409,  1077,   411,   412,   413,   414,     0,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,     0,   426,
     427,   764,   428,   429,  1078,   431,   432,   433,   434,   435,
     436,   437,   438,     0,   439,   440,   441,   442,   443,  1079,
     444,   445,   446,   447,   765,   448,  1080,   450,     0,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,  1081,
       0,   462,   463,     0,   464,   465,   466,   467,   468,   469,
       0,  1082,  1083,     0,     0,   472,  1084,   474,  1085,  1086,
     476,   477,   478,   479,   480,   481,   482,     0,     0,   483,
     484,   485,   486,   487,  1088,     0,   488,   489,   490,   491,
     492,   493,  1089,     0,   495,   766,   496,   497,   498,   499,
       0,     0,   500,     0,     0,   501,   502,   503,   504,   505,
     506,   507,  1090,  1091,  1092,  1093,  1094,  1095,  1096,  1097,
     516,   517,   518,     0,     0,     0,     0,     0,     0,     0,
     744,  1032,   574,  1033,  1034,  1035,   625,  1036,     0,     0,
    1101,   211,   212,   213,   214,   215,   216,   217,   218,     0,
     220,   221,   222,     0,     0,     0,     0,   223,  1037,     0,
       0,   224,   225,     0,   226,   227,   745,   228,   229,   230,
       0,  1038,   746,  1039,  1040,     0,   235,   236,   237,   238,
     239,  1041,  1042,   240,   241,  1043,  1044,   244,     0,   245,
     246,   247,   248,  1045,     0,  1046,     0,   250,   251,   252,
     253,   748,   254,   255,     0,   256,   257,   258,   259,   260,
     261,     0,   749,   262,   263,  1047,  1048,  1049,  1050,  1051,
    1052,  1053,   264,   265,   266,   267,   268,   269,  1054,  1055,
     272,     0,   273,     0,   274,   275,   276,   277,   278,     0,
     279,   280,   281,     0,     0,   282,   283,  1056,   285,   286,
       0,   287,   288,   289,     0,   290,     0,   292,     0,   293,
     294,   295,   296,  1057,   298,   299,   300,  1058,  1059,   302,
       0,   303,   304,  1060,   306,     0,   307,     0,   308,   751,
       0,   752,   309,   310,   311,     0,   312,  1061,     0,   314,
       0,   315,   316,   317,   318,   319,     0,   320,   321,   322,
       0,   323,   324,   325,   326,   327,   328,     0,   329,   754,
     330,   331,   332,   333,   334,  1062,  1063,     0,  1064,     0,
     338,   755,   756,   339,   757,   340,   341,   342,   343,   344,
       0,   345,   346,     0,   347,  1065,   758,   349,     0,     0,
     350,   351,   352,  1066,  1067,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,  1068,   760,
    1069,   368,   369,   370,     0,   371,   372,   761,   373,  1071,
    1072,   375,  1073,   377,   378,   379,     0,   380,     0,     0,
    1074,   382,   383,     0,     0,   384,   385,   762,   386,   763,
    1075,   388,   389,   390,   391,   392,   393,   394,     0,   395,
    1076,   397,   398,   399,   400,   401,     0,   402,   403,   404,
     405,   406,   407,   408,   409,  1077,   411,   412,   413,   414,
       0,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,     0,   426,   427,   764,   428,   429,  1078,   431,
     432,   433,   434,   435,   436,   437,   438,     0,   439,   440,
     441,   442,   443,  1079,   444,   445,   446,   447,     0,   448,
    1080,   450,     0,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,  1081,     0,   462,   463,     0,   464,   465,
     466,   467,   468,   469,     0,  1082,  1083,     0,     0,   472,
    1084,   474,  1085,  1086,   476,   477,   478,   479,   480,   481,
     482,     0,  1087,   483,   484,   485,   486,   487,  1088,     0,
     488,   489,   490,   491,   492,   493,  1089,     0,   495,   766,
     496,   497,   498,   499,     0,     0,   500,     0,     0,   501,
     502,   503,   504,   505,   506,   507,  1090,  1091,  1092,  1093,
    1094,  1095,  1096,  1097,   516,   517,   518,     0,     0,     0,
       0,     0,     0,     0,     0,  1098,  1099,     0,     0,     0,
       0,     0,     0,     0,  1101,   744,  1032,   574,  1033,  1034,
    1035,   625,  1036,     0,     0,     0,   211,   212,   213,   214,
     215,   216,   217,   218,     0,   220,   221,   222,     0,     0,
       0,     0,   223,  1037,     0,     0,   224,   225,     0,   226,
     227,   745,   228,   229,   230,     0,  1038,   746,  1039,  1040,
       0,   235,   236,   237,   238,   239,  1041,  1042,   240,   241,
    1043,  1044,   244,     0,   245,   246,   247,   248,  1045,     0,
    1046,     0,   250,   251,   252,   253,   748,   254,   255,     0,
     256,   257,   258,   259,   260,   261,     0,   749,   262,   263,
    1047,  1048,  1049,  1050,  1051,  1052,  1053,   264,   265,   266,
     267,   268,   269,  1054,  1055,   272,     0,   273,     0,   274,
     275,   276,   277,   278,     0,   279,   280,   281,     0,     0,
     282,   283,  1056,   285,   286,     0,   287,   288,   289,     0,
     290,     0,   292,     0,   293,   294,   295,   296,  1057,   298,
     299,   300,  1058,  1059,   302,     0,   303,   304,  1060,   306,
       0,   307,     0,   308,   751,     0,   752,   309,   310,   311,
       0,   312,  1061,     0,   314,     0,   315,   316,   317,   318,
     319,     0,   320,   321,   322,     0,   323,   324,   325,   326,
     327,   328,     0,   329,   754,   330,   331,   332,   333,   334,
    1062,  1063,     0,  1064,     0,   338,   755,   756,   339,   757,
     340,   341,   342,   343,   344,     0,   345,   346,     0,   347,
    1065,   758,   349,     0,     0,   350,   351,   352,  1066,  1067,
     353,   354,   355,   356,   357,   358,   359,   360,   361,   362,
     363,   364,   365,  1068,   760,  1069,   368,   369,   370,     0,
     371,   372,   761,   373,  1071,  1072,   375,  1073,   377,   378,
     379,     0,   380,     0,     0,  1074,   382,   383,     0,     0,
     384,   385,   762,   386,   763,  1075,   388,   389,   390,   391,
     392,   393,   394,     0,   395,  1076,   397,   398,   399,   400,
     401,     0,   402,   403,   404,   405,   406,   407,   408,   409,
    1077,   411,   412,   413,   414,     0,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,     0,   426,   427,
     764,   428,   429,  1078,   431,   432,   433,   434,   435,   436,
     437,   438,     0,   439,   440,   441,   442,   443,  1079,   444,
     445,   446,   447,     0,   448,  1080,   450,     0,   451,   452,
     453,   454,   455,   456,   457,   458,   459,   460,  1081,     0,
     462,   463,     0,   464,   465,   466,   467,   468,   469,     0,
    1082,  1083,     0,     0,   472,  1084,   474,  1085,  1086,   476,
     477,   478,   479,   480,   481,   482,     0,     0,   483,   484,
     485,   486,   487,  1088,     0,   488,   489,   490,   491,   492,
     493,  1089,     0,   495,   766,   496,   497,   498,   499,     0,
       0,   500,     0,     0,   501,   502,   503,   504,   505,   506,
     507,  1090,  1091,  1092,  1093,  1094,  1095,  1096,  1097,   516,
     517,   518,     0,     0,     0,     0,     0,     0,     0,   744,
    2370,  2371,     0,     0,     0,     0,     0,     0,     0,  1101,
     211,   212,   213,   214,   215,   216,   217,   218,     0,   220,
     221,   222,     0,     0,     0,     0,   223,     0,     0,     0,
     224,   225,     0,   226,   227,   745,   228,   229,   230,   231,
     232,   746,   233,   234,     0,   235,   236,   237,   238,   239,
       0,  1042,   240,   241,   242,   243,   244,     0,   245,   246,
     247,   248,  1045,     0,  1046,     0,   250,   251,   252,   253,
     748,   254,   255,     0,   256,   257,   258,   259,   260,   261,
       0,   749,   262,   263,  1047,  1048,  1049,  1050,  1051,  1052,
    1053,   264,   265,   266,   267,   268,   269,   270,   271,   272,
       0,   273,     0,   274,   275,   276,   277,   278,     0,   279,
     280,   281,     0,     0,   282,   283,   284,   285,   286,     0,
     287,   288,   289,     0,   290,   291,   292,     0,   293,   294,
     295,   296,   297,   298,   299,   300,  1058,     0,   302,     0,
     303,   304,   305,   306,     0,   307,     0,   308,   751,     0,
     752,   309,   310,   311,     0,   312,  1061,     0,   314,     0,
     315,   316,   317,   318,   319,   753,   320,   321,   322,     0,
     323,   324,   325,   326,   327,   328,     0,   329,   754,   330,
     331,   332,   333,   334,   335,   336,     0,   337,     0,   338,
     755,   756,   339,   757,   340,   341,   342,   343,   344,  3080,
     345,   346,     0,   347,  1065,   758,   349,   759,     0,   350,
     351,   352,  1066,  1067,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,   365,   366,   760,   367,
     368,   369,   370,     0,   371,   372,   761,   373,     0,  1072,
     375,   376,   377,   378,   379,     0,   380,     0,   709,   381,
     382,   383,     0,     0,   384,   385,   762,   386,   763,  1075,
     388,   389,   390,   391,   392,   393,   394,     0,   395,  1076,
     397,   398,   399,   400,   401,     0,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,     0,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,     0,   426,   427,   764,   428,   429,   430,  3081,   432,
     433,   434,   435,   436,   437,   438,    38,   439,   440,   441,
     442,   443,  1079,   444,   445,   446,   447,   765,   448,   449,
     450,     0,   451,   452,   453,   454,   455,   456,   457,   458,
     459,   460,  1081,     0,   462,   463,    42,   464,   465,   466,
     467,   468,   469,     0,   470,   471,     0,     0,   472,  1084,
     474,  1085,     0,   476,   477,   478,   479,   480,   481,   482,
       0,     0,   483,   484,   485,   486,   487,  1088,     0,   488,
     489,   490,   491,   492,   971,   494,     0,   495,   766,   496,
     497,   498,   499,     0,     0,   500,     0,    47,   501,   502,
     503,   504,   505,   506,   507,  1090,  1091,  1092,  1093,  1094,
    1095,  1096,  1097,   516,   517,   518,     0,     0,     0,     0,
       0,     0,     0,   744,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  3082,   211,   212,   213,   214,   215,   216,
     217,   218,     0,   220,   221,   222,     0,     0,     0,     0,
     223,     0,     0,     0,   224,   225,     0,   226,   227,   745,
     228,   229,   230,   231,   232,   746,   233,   234,     0,   235,
     236,   237,   238,   239,     0,  1042,   240,   241,   242,   243,
     244,     0,   245,   246,   247,   248,  1045,     0,  1046,     0,
     250,   251,   252,   253,   748,   254,   255,     0,   256,   257,
     258,   259,   260,   261,     0,   749,   262,   263,  1047,  1048,
    1049,  1050,  1051,  1052,  1053,   264,   265,   266,   267,   268,
     269,   270,   271,   272,     0,   273,     0,   274,   275,   276,
     277,   278,     0,   279,   280,   281,     0,     0,   282,   283,
     284,   285,   286,     0,   287,   288,   289,     0,   290,   291,
     292,     0,   293,   294,   295,   296,   297,   298,   299,   300,
    1058,     0,   302,     0,   303,   304,   305,   306,     0,   307,
       0,   308,   751,     0,   752,   309,   310,   311,     0,   312,
    1061,     0,   314,     0,   315,   316,   317,   318,   319,   753,
     320,   321,   322,     0,   323,   324,   325,   326,   327,   328,
       0,   329,   754,   330,   331,   332,   333,   334,   335,   336,
       0,   337,     0,   338,   755,   756,   339,   757,   340,   341,
     342,   343,   344,  3080,   345,   346,     0,   347,  1065,   758,
     349,   759,     0,   350,   351,   352,  1066,  1067,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   760,   367,   368,   369,   370,     0,   371,   372,
     761,   373,     0,  1072,   375,   376,   377,   378,   379,     0,
     380,     0,   709,   381,   382,   383,     0,     0,   384,   385,
     762,   386,   763,  1075,   388,   389,   390,   391,   392,   393,
     394,     0,   395,  1076,   397,   398,   399,   400,   401,     0,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,     0,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,     0,   426,   427,   764,   428,
     429,   430,  3081,   432,   433,   434,   435,   436,   437,   438,
       0,   439,   440,   441,   442,   443,  1079,   444,   445,   446,
     447,   765,   448,   449,   450,     0,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,  1081,     0,   462,   463,
       0,   464,   465,   466,   467,   468,   469,     0,   470,   471,
       0,     0,   472,  1084,   474,  1085,     0,   476,   477,   478,
     479,   480,   481,   482,     0,     0,   483,   484,   485,   486,
     487,  1088,     0,   488,   489,   490,   491,   492,   493,   494,
       0,   495,   766,   496,   497,   498,   499,     0,     0,   500,
       0,     0,   501,   502,   503,   504,   505,   506,   507,  1090,
    1091,  1092,  1093,  1094,  1095,  1096,  1097,   516,   517,   518,
       0,     0,     0,     0,     0,     0,     0,   744,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  3082,   211,   212,
     213,   214,   215,   216,   217,   218,     0,   220,   221,   222,
       0,     0,     0,     0,   223,     0,     0,     0,   224,   225,
       0,   226,   227,   745,   228,   229,   230,   231,   232,   746,
     233,   234,     0,   235,   236,   237,   238,   239,     0,  1042,
     240,   241,   242,   243,   244,     0,   245,   246,   247,   248,
    1045,     0,  1046,     0,   250,   251,   252,   253,   748,   254,
     255,     0,   256,   257,   258,   259,   260,   261,     0,   749,
     262,   263,  1047,  1048,  1049,  1050,  1051,  1052,  1053,   264,
     265,   266,   267,   268,   269,   270,   271,   272,     0,   273,
       0,   274,   275,   276,   277,   278,     0,   279,   280,   281,
       0,     0,   282,   283,   284,   285,   286,     0,   287,   288,
     289,     0,   290,   291,   292,     0,   293,   294,   295,   296,
     297,   298,   299,   300,  1058,     0,   302,     0,   303,   304,
     305,   306,     0,   307,     0,   308,   751,     0,   752,   309,
     310,   311,     0,   312,  1061,     0,   314,     0,   315,   316,
     317,   318,   319,   753,   320,   321,   322,     0,   323,   324,
     325,   326,   327,   328,     0,   329,   754,   330,   331,   332,
     333,   334,   335,   336,     0,   337,     0,   338,   755,   756,
     339,   757,   340,   341,   342,   343,   344,     0,   345,   346,
       0,   347,  1065,   758,   349,   759,     0,   350,   351,   352,
    1066,  1067,   353,   354,   355,   356,   357,   358,   359,   360,
     361,   362,   363,   364,   365,   366,   760,   367,   368,   369,
     370,     0,   371,   372,   761,   373,     0,  1072,   375,   376,
     377,   378,   379,     0,   380,     0,     0,   381,   382,   383,
       0,     0,   384,   385,   762,   386,   763,  1075,   388,   389,
     390,   391,   392,   393,   394,     0,   395,  1076,   397,   398,
     399,   400,   401,     0,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,     0,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,     0,
     426,   427,   764,   428,   429,   430,  3081,   432,   433,   434,
     435,   436,   437,   438,     0,   439,   440,   441,   442,   443,
    1079,   444,   445,   446,   447,   765,   448,   449,   450,     0,
     451,   452,   453,   454,   455,   456,   457,   458,   459,   460,
    1081,     0,   462,   463,     0,   464,   465,   466,   467,   468,
     469,     0,   470,   471,     0,     0,   472,  1084,   474,  1085,
       0,   476,   477,   478,   479,   480,   481,   482,     0,     0,
     483,   484,   485,   486,   487,  1088,     0,   488,   489,   490,
     491,   492,   493,   494,     0,   495,   766,   496,   497,   498,
     499,     0,     0,   500,     0,     0,   501,   502,   503,   504,
     505,   506,   507,  1090,  1091,  1092,  1093,  1094,  1095,  1096,
    1097,   516,   517,   518,     0,     0,     0,     0,     0,     0,
       0,   744,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    48,   211,   212,   213,   214,   215,   216,   217,   218,
       0,   220,   221,   222,     0,     0,     0,     0,   223,     0,
       0,     0,   224,   225,     0,   226,   227,   745,   228,   229,
     230,   231,   232,   746,   233,   234,     0,   235,   236,   237,
     238,   239,     0,  1042,   240,   241,   242,   243,   244,     0,
     245,   246,   247,   248,  1045,     0,  1046,     0,   250,   251,
     252,   253,   748,   254,   255,     0,   256,   257,   258,   259,
     260,   261,     0,   749,   262,   263,  1047,  1048,  1049,  1050,
    1051,  1052,  1053,   264,   265,   266,   267,   268,   269,   270,
     271,   272,     0,   273,     0,   274,   275,   276,   277,   278,
       0,   279,   280,   281,     0,     0,   282,   283,   284,   285,
     286,     0,   287,   288,   289,     0,   290,   291,   292,     0,
     293,   294,   295,   296,   297,   298,   299,   300,  1058,     0,
     302,     0,   303,   304,   305,   306,     0,   307,     0,   308,
     751,     0,   752,   309,   310,   311,     0,   312,  1061,     0,
     314,     0,   315,   316,   317,   318,   319,   753,   320,   321,
     322,     0,   323,   324,   325,   326,   327,   328,     0,   329,
     754,   330,   331,   332,   333,   334,   335,   336,     0,   337,
       0,   338,   755,   756,   339,   757,   340,   341,   342,   343,
     344,     0,   345,   346,     0,   347,  1065,   758,   349,   759,
       0,   350,   351,   352,  1066,  1067,   353,   354,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,   366,
     760,   367,   368,   369,   370,     0,   371,   372,   761,   373,
       0,  1072,   375,   376,   377,   378,   379,     0,   380,     0,
       0,   381,   382,   383,     0,     0,   384,   385,   762,   386,
     763,  1075,   388,   389,   390,   391,   392,   393,   394,     0,
     395,  1076,   397,   398,   399,   400,   401,     0,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,     0,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,     0,   426,   427,   764,   428,   429,   430,
     431,   432,   433,   434,   435,   436,   437,   438,     0,   439,
     440,   441,   442,   443,  1079,   444,   445,   446,   447,   765,
     448,   449,   450,     0,   451,   452,   453,   454,   455,   456,
     457,   458,   459,   460,  1081,     0,   462,   463,     0,   464,
     465,   466,   467,   468,   469,     0,   470,   471,     0,     0,
     472,  1084,   474,  1085,     0,   476,   477,   478,   479,   480,
     481,   482,     0,     0,   483,   484,   485,   486,   487,  1088,
       0,   488,   489,   490,   491,   492,   493,   494,     0,   495,
     766,   496,   497,   498,   499,     0,     0,   500,     0,     0,
     501,   502,   503,   504,   505,   506,   507,  1090,  1091,  1092,
    1093,  1094,  1095,  1096,  1097,   516,   517,   518,     0,     0,
       0,     0,     0,     0,     0,   787,  1289,   574,     0,     0,
       0,   625,     0,     0,     0,  3636,   211,   212,   213,   214,
     215,   216,   217,   218,     0,   220,   221,   222,     0,     0,
       0,     0,   223,     0,     0,     0,   224,   225,     0,   226,
     227,   745,   228,   229,   230,   231,   232,   746,   233,   234,
       0,   235,   236,   237,   238,   239,     0,     0,   240,   241,
     242,   243,   244,     0,   245,   246,   247,   248,   249,     0,
     747,     0,   250,   251,   252,   253,   748,   254,   255,     0,
     256,   257,   258,   259,   260,   261,     0,   749,   262,   263,
       0,     0,     0,   750,     0,     0,     0,   264,   265,   266,
     267,   268,   269,   270,   271,   272,     0,   273,     0,   274,
     275,   276,   277,   278,     0,   279,   280,   281,     0,     0,
     282,   283,   284,   285,   286,     0,   287,   288,   289,     0,
     290,   291,   292,     0,   293,   294,   295,   296,   297,   298,
     299,   300,   301,  1536,   302,     0,   303,   304,   305,   306,
       0,   307,     0,   308,   751,     0,   752,   309,   310,   311,
       0,   312,   313,     0,   314,     0,   315,   316,   317,   318,
     319,   753,   320,   321,   322,     0,   323,   324,   325,   326,
     327,   328,     0,   329,   754,   330,   331,   332,   333,   334,
     335,   336,     0,   337,     0,   338,   755,   756,   339,   757,
     340,   341,   342,   343,   344,     0,   345,   346,     0,   347,
     348,   758,   349,   759,     0,   350,   351,   352,     0,     0,
     353,   354,   355,   356,   357,   358,   359,   360,   361,   362,
     363,   364,   365,   366,   760,   367,   368,   369,   370,     0,
     371,   372,   761,   373,     0,   374,   375,   376,   377,   378,
     379,     0,   380,  1537,     0,   381,   382,   383,     0,     0,
     384,   385,   762,   386,   763,   387,   388,   389,   390,   391,
     392,   393,   394,     0,   395,   396,   397,   398,   399,   400,
     401,     0,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,     0,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,     0,   426,   427,
     764,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,     0,   439,   440,   441,   442,   443,     0,   444,
     445,   446,   447,   765,   448,   449,   450,     0,   451,   452,
     453,   454,   455,   456,   457,   458,   459,   460,   461,     0,
     462,   463,     0,   464,   465,   466,   467,   468,   469,     0,
     470,   471,     0,     0,   472,   473,   474,   475,  1538,   476,
     477,   478,   479,   480,   481,   482,     0,     0,   483,   484,
     485,   486,   487,     0,     0,   488,   489,   490,   491,   492,
     493,   494,     0,   495,   766,   496,   497,   498,   499,     0,
       0,   500,     0,     0,   501,   502,   503,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
     517,   518,     0,     0,     0,     0,     0,     0,     0,   787,
     637,  1290,  4052,     0,     0,     0,     0,     0,     0,  4053,
     211,   212,   213,   214,   215,   216,   217,   218,     0,   220,
     221,   222,     3,     4,     0,     0,   223,     0,     0,     0,
     224,   225,     0,   226,   227,   745,   228,   229,   230,   231,
     232,   746,   233,   234,     0,   235,   236,   237,   238,   239,
       0,     0,   240,   241,   242,   243,   244,     0,   245,   246,
     247,   248,   249,     0,   747,     0,   250,   251,   252,   253,
     748,   254,   255,     0,   256,   257,   258,   259,   260,   261,
       0,   749,   262,   263,     0,     0,     0,   750,     0,     0,
       0,   264,   265,   266,   267,   268,   269,   270,   271,   272,
       0,   273,     0,   274,   275,   276,   277,   278,     0,   279,
     280,   281,     0,     0,   282,   283,   284,   285,   286,     0,
     287,   288,   289,     0,   290,   291,   292,     0,   293,   294,
     295,   296,   297,   298,   299,   300,   301,     0,   302,     0,
     303,   304,   305,   306,     0,   307,     0,   308,   751,     0,
     752,   309,   310,   311,     0,   312,   313,     0,   314,     0,
     315,   316,   317,   318,   319,   753,   320,   321,   322,     0,
     323,   324,   325,   326,   327,   328,     0,   329,   754,   330,
     331,   332,   333,   334,   335,   336,     0,   337,     0,   338,
     755,   756,   339,   757,   340,   341,   342,   343,   344,     0,
     345,   346,     0,   347,   348,   758,   349,   759,     0,   350,
     351,   352,     0,     0,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,   365,   366,   760,   367,
     368,   369,   370,     0,   371,   372,   761,   373,     0,   374,
     375,   376,   377,   378,   379,     0,   380,     0,     0,   381,
     382,   383,     0,     0,   384,   385,   762,   386,   763,   387,
     388,   389,   390,   391,   392,   393,   394,     0,   395,   396,
     397,   398,   399,   400,   401,     0,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,     0,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,     0,   426,   427,   764,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,   438,    38,   439,   440,   441,
     442,   443,     0,   444,   445,   446,   447,   765,   448,   449,
     450,     0,   451,   452,   453,   454,   455,   456,   457,   458,
     459,   460,   461,     0,   462,   463,    42,   464,   465,   466,
     467,   468,   469,     0,   470,   471,     0,     0,   472,   473,
     474,   475,     0,   476,   477,   478,   479,   480,   481,   482,
       0,     0,   483,   484,   485,   486,   487,     0,     0,   488,
     489,   490,   491,   492,   971,   494,     0,   495,   766,   496,
     497,   498,   499,     0,     0,   500,     0,    47,   501,   502,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
     513,   514,   515,   516,   517,   518,     0,     0,     0,     0,
       0,     0,     0,   744,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    48,   211,   212,   213,   214,   215,   216,
     217,   218,     0,   220,   221,   222,     0,     0,     0,     0,
     223,     0,     0,     0,   224,   225,     0,   226,   227,   745,
     228,   229,   230,   231,   232,   746,   233,   234,     0,   235,
     236,   237,   238,   239,     0,     0,   240,   241,   242,   243,
     244,     0,   245,   246,   247,   248,   249,     0,   747,     0,
     250,   251,   252,   253,   748,   254,   255,     0,   256,   257,
     258,   259,   260,   261,     0,   749,   262,   263,     0,     0,
       0,   750,     0,     0,     0,   264,   265,   266,   267,   268,
     269,   270,   271,   272,     0,   273,     0,   274,   275,   276,
     277,   278,     0,   279,   280,   281,     0,     0,   282,   283,
     284,   285,   286,     0,   287,   288,   289,     0,   290,   291,
     292,     0,   293,   294,   295,   296,   297,   298,   299,   300,
     301,     0,   302,     0,   303,   304,   305,   306,     0,   307,
       0,   308,   751,     0,   752,   309,   310,   311,     0,   312,
     313,     0,   314,     0,   315,   316,   317,   318,   319,   753,
     320,   321,   322,     0,   323,   324,   325,   326,   327,   328,
       0,   329,   754,   330,   331,   332,   333,   334,   335,   336,
       0,   337,     0,   338,   755,   756,   339,   757,   340,   341,
     342,   343,   344,     0,   345,   346,     0,   347,   348,   758,
     349,   759,     0,   350,   351,   352,     0,     0,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   760,   367,   368,   369,   370,     0,   371,   372,
     761,   373,     0,   374,   375,   376,   377,   378,   379,     0,
     380,     0,     0,   381,   382,   383,     0,     0,   384,   385,
     762,   386,   763,   387,   388,   389,   390,   391,   392,   393,
     394,     0,   395,   396,   397,   398,   399,   400,   401,     0,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,     0,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,     0,   426,   427,   764,   428,
     429,   430,   431,   432,   433,   434,   435,   436,   437,   438,
       0,   439,   440,   441,   442,   443,     0,   444,   445,   446,
     447,   765,   448,   449,   450,     0,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,     0,   462,   463,
       0,   464,   465,   466,   467,   468,   469,     0,   470,   471,
       0,     0,   472,   473,   474,   475,     0,   476,   477,   478,
     479,   480,   481,   482,     0,     0,   483,   484,   485,   486,
     487,     0,     0,   488,   489,   490,   491,   492,   493,   494,
       0,   495,   766,   496,   497,   498,   499,     0,     0,   500,
       0,     0,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
       0,     0,     0,     0,     0,     0,     0,   210,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  4212,   211,   212,
     213,   214,   215,   216,   217,   218,     0,   220,   221,   222,
       0,     0,     0,     0,   223,     0,     0,     0,   224,   225,
       0,   226,   227,     0,   228,   229,   230,   231,   232,     0,
     233,   234,     0,   235,   236,   237,   238,   239,     0,     0,
     240,   241,   242,   243,   244,     0,   245,   246,   247,   248,
     249,     0,     0,     0,   250,   251,   252,   253,     0,   254,
     255,     0,   256,   257,   258,   259,   260,   261,     0,     0,
     262,   263,     0,     0,     0,     0,     0,     0,     0,   264,
     265,   266,   267,   268,   269,   270,   271,   272,     0,   273,
       0,   274,   275,   276,   277,   278,     0,   279,   280,   281,
       0,     0,   282,   283,   284,   285,   286,     0,   287,   288,
     289,     0,   290,   291,   292,     0,   293,   294,   295,   296,
     297,   298,   299,   300,   301,     0,   302,     0,   303,   304,
     305,   306,     0,   307,     0,   308,     0,     0,     0,   309,
     310,   311,     0,   312,   313,     0,   314,     0,   315,   316,
     317,   318,   319,     0,   320,   321,   322,     0,   323,   324,
     325,   326,   327,   328,     0,   329,     0,   330,   331,   332,
     333,   334,   335,   336,     0,   337,     0,   338,     0,     0,
     339,     0,   340,   341,   342,   343,   344,     0,   345,   346,
       0,   347,   348,     0,   349,     0,     0,   350,   351,   352,
       0,     0,   353,   354,   355,   356,   357,   358,   359,   360,
     361,   362,   363,   364,   365,   366,     0,   367,   368,   369,
     370,     0,   371,   372,     0,   373,     0,   374,   375,   376,
     377,   378,   379,     0,   380,     0,     0,   381,   382,   383,
       0,     0,   384,   385,     0,   386,     0,   387,   388,   389,
     390,   391,   392,   393,   394,     0,   395,   396,   397,   398,
     399,   400,   401,     0,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,     0,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,     0,
     426,   427,     0,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,    38,   439,   440,   441,   442,   443,
       0,   444,   445,   446,   447,     0,   448,   449,   450,     0,
     451,   452,   453,   454,   455,   456,   457,   458,   459,   460,
     461,     0,   462,   463,    42,   464,   465,   466,   467,   468,
     469,     0,   470,   471,     0,     0,   472,   473,   474,   475,
       0,   476,   477,   478,   479,   480,   481,   482,     0,     0,
     483,   484,   485,   486,   487,     0,     0,   488,   489,   490,
     491,   492,   971,   494,     0,   495,     0,   496,   497,   498,
     499,     0,     0,   500,     0,    47,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,     0,     0,     0,     0,     0,     0,
       0,   210,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    48,   211,   212,   213,   214,   215,   216,   217,   218,
       0,   220,   221,   222,     0,     0,     0,     0,   223,     0,
       0,     0,   224,   225,     0,   226,   227,     0,   228,   229,
     230,   231,   232,     0,   233,   234,     0,   235,   236,   237,
     238,   239,     0,     0,   240,   241,   242,   243,   244,     0,
     245,   246,   247,   248,   249,     0,     0,     0,   250,   251,
     252,   253,     0,   254,   255,     0,   256,   257,   258,   259,
     260,   261,     0,     0,   262,   263,     0,     0,     0,     0,
       0,     0,     0,   264,   265,   266,   267,   268,   269,   270,
     271,   272,     0,   273,     0,   274,   275,   276,   277,   278,
       0,   279,   280,   281,     0,     0,   282,   283,   284,   285,
     286,     0,   287,   288,   289,     0,   290,   291,   292,     0,
     293,   294,   295,   296,   297,   298,   299,   300,   301,     0,
     302,     0,   303,   304,   305,   306,     0,   307,     0,   308,
       0,     0,     0,   309,   310,   311,     0,   312,   313,     0,
     314,     0,   315,   316,   317,   318,   319,     0,   320,   321,
     322,     0,   323,   324,   325,   326,   327,   328,     0,   329,
       0,   330,   331,   332,   333,   334,   335,   336,     0,   337,
       0,   338,     0,     0,   339,     0,   340,   341,   342,   343,
     344,     0,   345,   346,     0,   347,   348,     0,   349,     0,
       0,   350,   351,   352,     0,     0,   353,   354,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,   366,
       0,   367,   368,   369,   370,     0,   371,   372,     0,   373,
       0,   374,   375,   376,   377,   378,   379,     0,   380,     0,
       0,   381,   382,   383,     0,     0,   384,   385,     0,   386,
       0,   387,   388,   389,   390,   391,   392,   393,   394,     0,
     395,   396,   397,   398,   399,   400,   401,     0,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,     0,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,     0,   426,   427,     0,   428,   429,   430,
     431,   432,   433,   434,   435,   436,   437,   438,     0,   439,
     440,   441,   442,   443,     0,   444,   445,   446,   447,     0,
     448,   449,   450,     0,   451,   452,   453,   454,   455,   456,
     457,   458,   459,   460,   461,     0,   462,   463,     0,   464,
     465,   466,   467,   468,   469,     0,   470,   471,     0,     0,
     472,   473,   474,   475,     0,   476,   477,   478,   479,   480,
     481,   482,     0,     0,   483,   484,   485,   486,   487,     0,
       0,   488,   489,   490,   491,   492,   493,   494,     0,   495,
       0,   496,   497,   498,   499,     0,     0,   500,     0,     0,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,   513,   514,   515,   516,   517,   518,     0,     0,
       0,     0,     0,     0,     0,   210,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1157,   211,   212,   213,   214,
     215,   216,   217,   218,     0,   220,   221,   222,     0,     0,
       0,     0,   223,     0,     0,     0,   224,   225,     0,   226,
     227,     0,   228,   229,   230,   231,   232,     0,   233,   234,
       0,   235,   236,   237,   238,   239,     0,     0,   240,   241,
     242,   243,   244,     0,   245,   246,   247,   248,   249,     0,
       0,     0,   250,   251,   252,   253,     0,   254,   255,     0,
     256,   257,   258,   259,   260,   261,     0,     0,   262,   263,
       0,     0,     0,     0,     0,     0,     0,   264,   265,   266,
     267,   268,   269,   270,   271,   272,     0,   273,     0,   274,
     275,   276,   277,   278,     0,   279,   280,   281,     0,     0,
     282,   283,   284,   285,   286,     0,   287,   288,   289,     0,
     290,   291,   292,     0,   293,   294,   295,   296,   297,   298,
     299,   300,   301,     0,   302,     0,   303,   304,   305,   306,
       0,   307,     0,   308,     0,     0,     0,   309,   310,   311,
       0,   312,   313,     0,   314,     0,   315,   316,   317,   318,
     319,     0,   320,   321,   322,     0,   323,   324,   325,   326,
     327,   328,     0,   329,     0,   330,   331,   332,   333,   334,
     335,   336,     0,   337,     0,   338,     0,     0,   339,     0,
     340,   341,   342,   343,   344,     0,   345,   346,     0,   347,
     348,     0,   349,     0,     0,   350,   351,   352,     0,     0,
     353,   354,   355,   356,   357,   358,   359,   360,   361,   362,
     363,   364,   365,   366,     0,   367,   368,   369,   370,     0,
     371,   372,     0,   373,     0,   374,   375,   376,   377,   378,
     379,     0,   380,     0,     0,   381,   382,   383,     0,     0,
     384,   385,     0,   386,     0,   387,   388,   389,   390,   391,
     392,   393,   394,     0,   395,   396,   397,   398,   399,   400,
     401,     0,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,     0,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,     0,   426,   427,
       0,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,     0,   439,   440,   441,   442,   443,     0,   444,
     445,   446,   447,     0,   448,   449,   450,     0,   451,   452,
     453,   454,   455,   456,   457,   458,   459,   460,   461,     0,
     462,   463,     0,   464,   465,   466,   467,   468,   469,     0,
     470,   471,     0,     0,   472,   473,   474,   475,     0,   476,
     477,   478,   479,   480,   481,   482,     0,     0,   483,   484,
     485,   486,   487,     0,     0,   488,   489,   490,   491,   492,
     493,   494,     0,   495,     0,   496,   497,   498,   499,     0,
       0,   500,     0,     0,   501,   502,   503,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
     517,   518,     0,     0,     0,     0,     0,     0,     0,   210,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2525,
     211,   212,   213,   214,   215,   216,   217,   218,     0,   220,
     221,   222,     0,     0,     0,     0,   223,     0,     0,     0,
     224,   225,     0,   226,   227,     0,   228,   229,   230,   231,
     232,     0,   233,   234,     0,   235,   236,   237,   238,   239,
       0,     0,   240,   241,   242,   243,   244,     0,   245,   246,
     247,   248,   249,     0,     0,     0,   250,   251,   252,   253,
       0,   254,   255,     0,   256,   257,   258,   259,   260,   261,
       0,     0,   262,   263,     0,     0,     0,     0,     0,     0,
       0,   264,   265,   266,   267,   268,   269,   270,   271,   272,
       0,   273,     0,   274,   275,   276,   277,   278,     0,   279,
     280,   281,     0,     0,   282,   283,   284,   285,   286,     0,
     287,   288,   289,     0,   290,   291,   292,     0,   293,   294,
     295,   296,   297,   298,   299,   300,   301,     0,   302,     0,
     303,   304,   305,   306,     0,   307,     0,   308,     0,     0,
       0,   309,   310,   311,     0,   312,   313,     0,   314,     0,
     315,   316,   317,   318,   319,     0,   320,   321,   322,     0,
     323,   324,   325,   326,   327,   328,     0,   329,     0,   330,
     331,   332,   333,   334,   335,   336,     0,   337,     0,   338,
       0,     0,   339,     0,   340,   341,   342,   343,   344,     0,
     345,   346,     0,   347,   348,     0,   349,     0,     0,   350,
     351,   352,     0,     0,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,   365,   366,     0,   367,
     368,   369,   370,     0,   371,   372,     0,   373,     0,   374,
     375,   376,   377,   378,   379,     0,   380,     0,     0,   381,
     382,   383,     0,     0,   384,   385,     0,   386,     0,   387,
     388,   389,   390,   391,   392,   393,   394,     0,   395,   396,
     397,   398,   399,   400,   401,     0,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,     0,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,     0,   426,   427,     0,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,   438,     0,   439,   440,   441,
     442,   443,     0,   444,   445,   446,   447,     0,   448,   449,
     450,     0,   451,   452,   453,   454,   455,   456,   457,   458,
     459,   460,   461,     0,   462,   463,     0,   464,   465,   466,
     467,   468,   469,     0,   470,   471,     0,     0,   472,   473,
     474,   475,     0,   476,   477,   478,   479,   480,   481,   482,
       0,     0,   483,   484,   485,   486,   487,     0,     0,   488,
     489,   490,   491,   492,   493,   494,     0,   495,     0,   496,
     497,   498,   499,     0,     0,   500,     0,     0,   501,   502,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
     513,   514,   515,   516,   517,   518,     0,     0,     0,     0,
       0,     0,     0,   210,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  3555,   211,   212,   213,   214,   215,   216,
     217,   218,     0,   220,   221,   222,     0,     0,     0,     0,
     223,     0,     0,     0,   224,   225,     0,   226,   227,     0,
     228,   229,   230,   231,   232,     0,   233,   234,     0,   235,
     236,   237,   238,   239,     0,     0,   240,   241,   242,   243,
     244,     0,   245,   246,   247,   248,   249,     0,     0,     0,
     250,   251,   252,   253,     0,   254,   255,     0,   256,   257,
     258,   259,   260,   261,     0,     0,   262,   263,     0,     0,
       0,     0,     0,     0,     0,   264,   265,   266,   267,   268,
     269,   270,   271,   272,     0,   273,     0,   274,   275,   276,
     277,   278,     0,   279,   280,   281,     0,     0,   282,   283,
     284,   285,   286,     0,   287,   288,   289,     0,   290,   291,
     292,     0,   293,   294,   295,   296,   297,   298,   299,   300,
     301,     0,   302,     0,   303,   304,   305,   306,     0,   307,
       0,   308,     0,     0,     0,   309,   310,   311,     0,   312,
     313,     0,   314,     0,   315,   316,   317,   318,   319,     0,
     320,   321,   322,     0,   323,   324,   325,   326,   327,   328,
       0,   329,     0,   330,   331,   332,   333,   334,   335,   336,
       0,   337,     0,   338,     0,     0,   339,     0,   340,   341,
     342,   343,   344,     0,   345,   346,     0,   347,   348,     0,
     349,     0,     0,   350,   351,   352,     0,     0,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,     0,   367,   368,   369,   370,     0,   371,   372,
       0,   373,     0,   374,   375,   376,   377,   378,   379,     0,
     380,     0,     0,   381,   382,   383,     0,     0,   384,   385,
       0,   386,     0,   387,   388,   389,   390,   391,   392,   393,
     394,     0,   395,   396,   397,   398,   399,   400,   401,     0,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,     0,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,     0,   426,   427,     0,   428,
     429,   430,   431,   432,   433,   434,   435,   436,   437,   438,
       0,   439,   440,   441,   442,   443,     0,   444,   445,   446,
     447,     0,   448,   449,   450,     0,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,     0,   462,   463,
       0,   464,   465,   466,   467,   468,   469,     0,   470,   471,
       0,     0,   472,   473,   474,   475,     0,   476,   477,   478,
     479,   480,   481,   482,     0,     0,   483,   484,   485,   486,
     487,     0,     0,   488,   489,   490,   491,   492,   493,   494,
       0,   495,     0,   496,   497,   498,   499,     0,     0,   500,
       0,     0,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
       0,     0,     0,     0,     0,     0,     0,  1397,  1289,   574,
       0,     0,   798,   625,     0,     0,     0,  3949,   211,   212,
     213,   214,   215,   216,   217,   218,  1741,   220,   221,   222,
    1742,  1743,  1744,  1745,   223,  1746,  1747,  1748,   224,   225,
    1749,   226,   227,   745,   228,   229,   230,     0,  1398,   746,
    1399,  1400,  1750,   235,   236,   237,   238,   239,  1751,  1752,
     240,   241,  1401,  1402,   244,  1753,   245,   246,   247,   248,
       0,  1754,   747,  1755,   250,   251,   252,   253,   748,   254,
     255,  1756,   256,   257,   258,   259,   260,   261,  1757,   749,
     262,   263,  1758,  1759,  1760,   750,  1761,  1762,  1763,   264,
     265,   266,   267,   268,   269,  1403,  1404,   272,  1764,   273,
    1765,   274,   275,   276,   277,   278,  1766,   279,   280,   281,
    1767,  1768,   282,   283,  1056,   285,   286,  1769,   287,   288,
     289,  1770,   290,   291,   292,  1771,   293,   294,   295,   296,
       0,   298,   299,   300,     0,  1772,   302,  1773,   303,   304,
    1405,   306,  1774,   307,  1775,   308,   751,  1776,   752,   309,
     310,   311,  1777,   312,     0,  1778,   314,  1779,   315,   316,
     317,   318,   319,   753,   320,   321,   322,  1780,   323,   324,
     325,   326,   327,   328,  1781,   329,   754,     0,   331,   332,
     333,   334,  1406,  1407,  1782,  1408,  1783,   338,   755,   756,
     339,   757,   340,   341,   342,   343,   344,  1784,   345,   346,
    1785,   347,     0,   758,   349,   759,  1786,   350,   351,   352,
    1787,  1788,   353,   354,   355,   356,   357,   358,   359,   360,
     361,   362,   363,   364,   365,  1409,   760,  1410,   368,   369,
       0,  1789,   371,   372,   761,   373,  1790,     0,   375,  1411,
     377,   378,   379,  1791,   380,  1792,  1793,  3316,   382,   383,
    1794,  1795,   384,     0,   762,   386,   763,     0,   388,   389,
     390,   391,   392,   393,   394,  1796,   395,     0,   397,     0,
     399,   400,   401,  1797,   402,   403,   404,   405,   406,   407,
     408,   409,  1412,   411,   412,   413,   414,  1798,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,  1799,
     426,   427,   764,   428,   429,     0,   431,   432,   433,   434,
     435,   436,   437,   438,  1800,   439,   440,   441,   442,   443,
    1801,   444,  1881,   446,   447,   765,   448,  1414,   450,  1802,
     451,   452,   453,   454,   455,   456,   457,   458,   459,   460,
       0,  1803,   462,   463,  1804,   464,   465,   466,   467,   468,
     469,  1805,  1415,  1416,  1806,  1807,   472,     0,   474,     0,
    1808,   476,   477,   478,   479,   480,   481,   482,  1809,  1810,
     483,   484,   485,   486,   487,  1811,  1812,   488,   489,   490,
     491,   492,     0,  1417,  1813,   495,   766,   496,   497,   498,
     499,  1814,  1815,   500,  1816,  1817,   501,   502,   503,   504,
     505,   506,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   516,   517,   518,     0,     0,     0,     0,   801,   802,
     803,     0,  3317,  3318,   806,   807,   808,   809,   210,     0,
       0,     0,     0,   798,     0,     0,     0,     0,     0,   211,
     212,   213,   214,   215,   216,   217,   218,     0,   220,   221,
     222,     0,     0,     0,     0,   223,     0,     0,     0,   224,
     225,     0,   226,   227,     0,   228,   229,   230,   231,   232,
       0,   233,   234,     0,   235,   236,   237,   238,   239,     0,
       0,   240,   241,   242,   243,   244,     0,   245,   799,   247,
     248,   249,     0,     0,     0,   250,   251,   252,   253,     0,
     254,   255,     0,   256,   257,   258,   259,   260,   261,     0,
       0,   262,   263,     0,     0,     0,     0,     0,     0,     0,
     264,   265,   266,   267,   268,   269,   270,   271,   272,     0,
     273,     0,   274,   275,   276,   277,   278,     0,   279,   280,
     281,     0,     0,   282,   283,   284,   285,   286,     0,   287,
     288,   289,     0,   290,   291,   292,     0,   293,   294,   295,
     296,   297,   298,   299,   300,   301,     0,   800,     0,   303,
     304,   305,   306,     0,   307,     0,   308,     0,     0,     0,
     309,   310,   311,     0,   312,   313,     0,   314,     0,   315,
     316,   317,   318,   319,     0,   320,   321,   322,     0,   323,
     324,   325,   326,   327,   328,     0,   329,     0,   330,   331,
     332,   333,   334,   335,   336,     0,   337,     0,   338,     0,
       0,   339,     0,   340,   341,   342,   343,   344,     0,   345,
     346,     0,   347,   348,     0,   349,     0,     0,   350,   351,
     352,     0,     0,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,     0,   367,   368,
     369,   370,     0,   371,   372,     0,   373,     0,   374,   375,
     376,   377,   378,   379,     0,   380,     0,     0,   381,   382,
     383,     0,     0,   384,   385,     0,   386,     0,   387,   388,
     389,   390,   391,   392,   393,   394,     0,   395,   396,   397,
     398,   399,   400,   401,     0,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,     0,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
       0,   426,   427,     0,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,     0,   439,   440,   441,   442,
     443,     0,   444,   445,   446,   447,     0,   448,   449,   450,
       0,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,     0,   462,   463,     0,   464,   465,   466,   467,
     468,   469,     0,   470,   471,     0,     0,   472,   473,   474,
     475,     0,   476,   477,   478,   479,   480,   481,   482,     0,
       0,   483,   484,   485,   486,   487,     0,     0,   488,   489,
     490,   491,   492,   493,   494,     0,   495,     0,   496,   497,
     498,   499,     0,     0,   500,     0,     0,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,     0,     0,     0,     0,   801,
     802,   803,     0,   804,   805,   806,   807,   808,   809,   210,
       0,     0,     0,     0,   798,     0,     0,     0,     0,     0,
     211,   212,   213,   214,   215,   216,   217,   218,     0,   220,
     221,   222,     0,     0,     0,     0,   223,     0,     0,     0,
     224,   225,     0,   226,   227,     0,   228,   229,   230,   231,
     232,     0,   233,   234,     0,   235,   236,   237,   238,   239,
       0,     0,   240,   241,   242,   243,   244,     0,   245,   894,
     247,   248,   249,     0,     0,     0,   250,   251,   252,   253,
       0,   254,   255,     0,   256,   257,   258,   259,   260,   261,
       0,     0,   262,   263,     0,     0,     0,     0,     0,     0,
       0,   264,   265,   266,   267,   268,   269,   270,   271,   272,
       0,   273,     0,   274,   275,   276,   277,   278,     0,   279,
     280,   281,     0,     0,   282,   283,   284,   285,   286,     0,
     287,   288,   289,     0,   290,   291,   292,     0,   293,   294,
     295,   296,   297,   298,   299,   300,   301,     0,   895,     0,
     303,   304,   305,   306,     0,   307,     0,   308,     0,     0,
       0,   309,   310,   311,     0,   312,   313,     0,   314,     0,
     315,   316,   317,   318,   319,     0,   320,   321,   322,     0,
     323,   324,   325,   326,   327,   328,     0,   329,     0,   330,
     331,   332,   333,   334,   335,   336,     0,   337,     0,   338,
       0,     0,   339,     0,   340,   341,   342,   343,   344,     0,
     345,   346,     0,   347,   348,     0,   349,     0,     0,   350,
     351,   352,     0,     0,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,   365,   366,     0,   367,
     368,   369,   370,     0,   371,   372,     0,   373,     0,   374,
     375,   376,   377,   378,   379,     0,   380,     0,     0,   381,
     382,   383,     0,     0,   384,   385,     0,   386,     0,   387,
     388,   389,   390,   391,   392,   393,   394,     0,   395,   396,
     397,   398,   399,   400,   401,     0,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,     0,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,     0,   426,   427,     0,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,   438,     0,   439,   440,   441,
     442,   443,     0,   444,   445,   446,   447,     0,   448,   449,
     450,     0,   451,   452,   453,   454,   455,   456,   457,   458,
     459,   460,   461,     0,   462,   463,     0,   464,   465,   466,
     467,   468,   469,     0,   470,   471,     0,     0,   472,   473,
     474,   475,     0,   476,   477,   478,   479,   480,   481,   482,
       0,     0,   483,   484,   485,   486,   487,     0,     0,   488,
     489,   490,   491,   492,   493,   494,     0,   495,     0,   496,
     497,   498,   499,     0,     0,   500,     0,     0,   501,   502,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
     513,   514,   515,   516,   517,   518,     0,     0,     0,     0,
     801,   802,   803,     0,   804,   805,   806,   807,   808,   809,
     210,     0,     0,     0,     0,   798,     0,     0,     0,     0,
       0,   211,   212,   213,   214,   215,   216,   217,   218,     0,
     220,   221,   222,     0,     0,     0,     0,   223,     0,     0,
       0,   224,   225,     0,   226,   227,     0,   228,   229,   230,
     231,   232,     0,   233,   234,     0,   235,   236,   237,   238,
     239,     0,     0,   240,   241,   242,   243,   244,     0,   245,
     944,   247,   248,   249,     0,     0,     0,   250,   251,   252,
     253,     0,   254,   255,     0,   256,   257,   258,   259,   260,
     261,     0,     0,   262,   263,     0,     0,     0,     0,     0,
       0,     0,   264,   265,   266,   267,   268,   269,   270,   271,
     272,     0,   273,     0,   274,   275,   276,   277,   278,     0,
     279,   280,   281,     0,     0,   282,   283,   284,   285,   286,
       0,   287,   288,   289,     0,   290,   291,   292,     0,   293,
     294,   295,   296,   297,   298,   299,   300,   301,     0,   945,
       0,   303,   304,   305,   306,     0,   307,     0,   308,     0,
       0,     0,   309,   310,   311,     0,   312,   313,     0,   314,
       0,   315,   316,   317,   318,   946,     0,   320,   321,   322,
       0,   323,   324,   325,   326,   327,   328,     0,   329,     0,
     330,   331,   332,   333,   334,   335,   336,     0,   337,     0,
     338,     0,     0,   339,     0,   340,   341,   342,   343,   344,
       0,   345,   346,     0,   347,   348,     0,   349,     0,     0,
     350,   351,   352,     0,     0,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   366,     0,
     367,   368,   369,   370,     0,   371,   372,     0,   373,     0,
     374,   375,   376,   377,   378,   379,     0,   380,     0,     0,
     381,   382,   383,     0,     0,   384,   385,     0,   386,     0,
     387,   388,   389,   390,   391,   392,   393,   394,     0,   395,
     396,   397,   398,   399,   400,   401,     0,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
       0,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,     0,   426,   427,     0,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,     0,   439,   440,
     441,   442,   443,     0,   444,   445,   446,   447,     0,   448,
     449,   450,     0,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,   461,     0,   462,   463,     0,   464,   465,
     466,   467,   468,   469,     0,   470,   471,     0,     0,   472,
     473,   474,   475,     0,   476,   477,   478,   479,   480,   481,
     482,     0,     0,   483,   484,   485,   486,   487,     0,     0,
     488,   489,   490,   491,   492,   493,   494,     0,   495,     0,
     496,   497,   498,   499,     0,     0,   500,     0,     0,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,   516,   517,   518,     0,     0,     0,
       0,   801,   802,   803,     0,   804,   805,   806,   807,   808,
     809,   210,     0,     0,     0,     0,   798,     0,     0,     0,
       0,     0,   211,   212,   213,   214,   215,   216,   217,   218,
       0,   220,   221,   222,     0,     0,     0,     0,   223,     0,
       0,     0,   224,   225,     0,   226,   227,     0,   228,   229,
     230,   231,   232,     0,   233,   234,     0,   235,   236,   237,
     238,   239,     0,     0,   240,   241,   242,   243,   244,     0,
     245,  1382,   247,   248,   249,     0,     0,     0,   250,   251,
     252,   253,     0,   254,   255,     0,   256,   257,   258,   259,
     260,   261,     0,     0,   262,   263,     0,     0,     0,     0,
       0,     0,     0,   264,   265,   266,   267,   268,   269,   270,
     271,   272,     0,   273,     0,   274,   275,   276,   277,   278,
       0,   279,   280,   281,     0,     0,   282,   283,   284,   285,
     286,     0,   287,   288,   289,     0,   290,   291,   292,     0,
     293,   294,   295,   296,   297,   298,   299,   300,   301,     0,
    1383,     0,   303,   304,   305,   306,     0,   307,     0,   308,
       0,     0,     0,   309,   310,   311,     0,   312,   313,     0,
     314,     0,   315,   316,   317,   318,   319,     0,   320,   321,
     322,     0,   323,   324,   325,   326,   327,   328,     0,   329,
       0,   330,   331,   332,   333,   334,   335,   336,     0,   337,
       0,   338,     0,     0,   339,     0,   340,   341,   342,   343,
     344,     0,   345,   346,     0,   347,   348,     0,   349,     0,
       0,   350,   351,   352,     0,     0,   353,   354,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,   366,
       0,   367,   368,   369,   370,     0,   371,   372,     0,   373,
       0,   374,   375,   376,   377,   378,   379,     0,   380,     0,
       0,   381,   382,   383,     0,     0,   384,   385,     0,   386,
       0,   387,   388,   389,   390,   391,   392,   393,   394,     0,
     395,   396,   397,   398,   399,   400,   401,     0,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,     0,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,     0,   426,   427,     0,   428,   429,   430,
     431,   432,   433,   434,   435,   436,   437,   438,     0,   439,
     440,   441,   442,   443,     0,   444,   445,   446,   447,     0,
     448,   449,   450,     0,   451,   452,   453,   454,   455,   456,
     457,   458,   459,   460,   461,     0,   462,   463,     0,   464,
     465,   466,   467,   468,   469,     0,   470,   471,     0,     0,
     472,   473,   474,   475,     0,   476,   477,   478,   479,   480,
     481,   482,     0,     0,   483,   484,   485,   486,   487,     0,
       0,   488,   489,   490,   491,   492,   493,   494,     0,   495,
       0,   496,   497,   498,   499,     0,     0,   500,     0,     0,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,   513,   514,   515,   516,   517,   518,     0,     0,
       0,     0,   801,   802,   803,     0,   804,   805,   806,   807,
     808,   809,   210,     0,     0,     0,     0,   798,     0,     0,
       0,     0,     0,   211,   212,   213,   214,   215,   216,   217,
     218,     0,   220,   221,   222,     0,     0,     0,     0,   223,
       0,     0,     0,   224,   225,     0,   226,   227,     0,   228,
     229,   230,   231,   232,     0,   233,   234,     0,   235,   236,
     237,   238,   239,     0,     0,   240,   241,   242,   243,   244,
       0,   245,   246,   247,   248,   249,     0,     0,     0,   250,
     251,   252,   253,     0,   254,   255,     0,   256,   257,   258,
     259,   260,   261,     0,     0,   262,   263,     0,     0,     0,
       0,     0,     0,     0,   264,   265,   266,   267,   268,   269,
     270,   271,   272,     0,   273,     0,   274,   275,   276,   277,
     278,     0,   279,   280,   281,     0,     0,   282,   283,   284,
     285,   286,     0,   287,   288,   289,     0,   290,   291,   292,
       0,   293,   294,   295,   296,   297,   298,   299,   300,   301,
       0,   302,     0,   303,   304,   305,   306,     0,   307,     0,
     308,     0,     0,     0,   309,   310,   311,     0,   312,   313,
       0,   314,     0,   315,   316,   317,   318,   319,     0,   320,
     321,   322,     0,   323,   324,   325,   326,   327,   328,     0,
     329,     0,   330,   331,   332,   333,   334,   335,   336,     0,
     337,     0,   338,     0,     0,   339,     0,   340,   341,   342,
     343,   344,     0,   345,   346,     0,   347,   348,     0,   349,
       0,     0,   350,   351,   352,     0,     0,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,     0,   367,   368,   369,   370,     0,   371,   372,     0,
     373,     0,   374,   375,   376,   377,   378,   379,     0,   380,
       0,     0,   381,   382,   383,     0,     0,   384,   385,     0,
     386,     0,   387,   388,   389,   390,   391,   392,   393,   394,
       0,   395,   396,   397,   398,   399,   400,   401,     0,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,     0,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,     0,   426,   427,     0,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,     0,
     439,   440,   441,   442,   443,     0,   444,   445,   446,   447,
       0,   448,   449,   450,     0,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,     0,   462,   463,     0,
     464,   465,   466,   467,   468,   469,     0,   470,   471,     0,
       0,   472,   473,   474,   475,     0,   476,   477,   478,   479,
     480,   481,   482,     0,     0,   483,   484,   485,   486,   487,
       0,     0,   488,   489,   490,   491,   492,   493,   494,     0,
     495,     0,   496,   497,   498,   499,     0,     0,   500,     0,
       0,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,     0,
       0,     0,     0,   801,   802,   803,     0,   804,   805,   806,
     807,   808,   809,   210,     0,     0,     0,     0,   798,     0,
       0,     0,     0,     0,   211,   212,   213,   214,   215,   216,
     217,   218,     0,   220,   221,   222,     0,     0,     0,     0,
     223,     0,     0,     0,   224,   225,     0,   226,   227,     0,
     228,   229,   230,   231,   232,     0,   233,   234,     0,   235,
     236,   237,   238,   239,     0,     0,   240,   241,   242,   243,
     244,     0,   245,  2602,   247,   248,   249,     0,     0,     0,
     250,   251,   252,   253,     0,   254,   255,     0,   256,   257,
     258,   259,   260,   261,     0,     0,   262,   263,     0,     0,
       0,     0,     0,     0,     0,   264,   265,   266,   267,   268,
     269,   270,   271,   272,     0,   273,     0,   274,   275,   276,
     277,   278,     0,   279,   280,   281,     0,     0,   282,   283,
     284,   285,   286,     0,   287,   288,   289,     0,   290,   291,
     292,     0,   293,   294,   295,   296,   297,   298,   299,   300,
     301,     0,  2603,     0,   303,   304,   305,   306,     0,   307,
       0,   308,     0,     0,     0,   309,   310,   311,     0,   312,
     313,     0,   314,     0,   315,   316,   317,   318,   319,     0,
     320,   321,   322,     0,   323,   324,   325,   326,   327,   328,
       0,   329,     0,   330,   331,   332,   333,   334,   335,   336,
       0,   337,     0,   338,     0,     0,   339,     0,   340,   341,
     342,   343,   344,     0,   345,   346,     0,   347,   348,     0,
     349,     0,     0,   350,   351,   352,     0,     0,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,     0,   367,   368,   369,   370,     0,   371,   372,
       0,   373,     0,   374,   375,   376,   377,   378,   379,     0,
     380,     0,     0,   381,   382,   383,     0,     0,   384,   385,
       0,   386,     0,   387,   388,   389,   390,   391,   392,   393,
     394,     0,   395,   396,   397,   398,   399,   400,   401,     0,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,     0,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,     0,   426,   427,     0,   428,
     429,   430,   431,   432,   433,   434,   435,   436,   437,   438,
       0,   439,   440,   441,   442,   443,     0,   444,   445,   446,
     447,     0,   448,   449,   450,     0,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,     0,   462,   463,
       0,   464,   465,   466,   467,   468,   469,     0,   470,   471,
       0,     0,   472,   473,   474,   475,     0,   476,   477,   478,
     479,   480,   481,   482,     0,     0,   483,   484,   485,   486,
     487,     0,     0,   488,   489,   490,   491,   492,   493,   494,
       0,   495,     0,   496,   497,   498,   499,     0,     0,   500,
       0,     0,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
       0,     0,     0,     0,   801,   802,   803,     0,   804,   805,
     806,   807,   808,   809,   210,     0,     0,     0,     0,   798,
       0,     0,     0,     0,     0,   211,   212,   213,   214,   215,
     216,   217,   218,     0,   220,   221,   222,     0,     0,     0,
       0,   223,     0,     0,     0,   224,   225,     0,   226,   227,
       0,   228,   229,   230,   231,   232,     0,   233,   234,     0,
     235,   236,   237,   238,   239,     0,     0,   240,   241,   242,
     243,   244,     0,   245,   246,   247,   248,   249,     0,     0,
       0,   250,   251,   252,   253,     0,   254,   255,     0,   256,
     257,   258,   259,   260,   261,     0,     0,   262,   263,     0,
       0,     0,     0,     0,     0,     0,   264,   265,   266,   267,
     268,   269,   270,   271,   272,     0,   273,     0,   274,   275,
     276,   277,   278,     0,   279,   280,   281,     0,     0,   282,
     283,   284,   285,   286,     0,   287,   288,   289,     0,   290,
     291,   292,     0,   293,   294,   295,   296,   297,   298,   299,
     300,   301,     0,   302,     0,   303,   304,   305,   306,     0,
     307,     0,   308,     0,     0,     0,   309,   310,   311,     0,
     312,   313,     0,   314,     0,   315,   316,   317,   318,   319,
       0,   320,   321,   322,     0,   323,   324,   325,   326,   327,
     328,     0,   329,     0,   330,   331,   332,   333,   334,   335,
     336,     0,   337,     0,   338,     0,     0,   339,     0,   340,
     341,   342,   343,   344,     0,   345,   346,     0,   347,   348,
       0,   349,     0,     0,   350,   351,   352,     0,     0,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,     0,   367,   368,   369,   370,     0,   371,
     372,     0,   373,     0,   374,   375,   376,   377,   378,   379,
       0,   380,     0,     0,  4191,   382,   383,     0,     0,   384,
     385,     0,   386,     0,   387,   388,   389,   390,   391,   392,
     393,   394,     0,   395,   396,   397,   398,   399,   400,   401,
       0,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,     0,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,     0,   426,   427,     0,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,     0,   439,   440,   441,   442,   443,     0,   444,   445,
     446,   447,     0,   448,   449,   450,     0,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,     0,   462,
     463,     0,   464,   465,   466,   467,   468,   469,     0,   470,
     471,     0,     0,   472,   473,   474,   475,     0,   476,   477,
     478,   479,   480,   481,   482,     0,     0,   483,   484,   485,
     486,   487,     0,     0,   488,   489,   490,   491,   492,   493,
     494,     0,   495,     0,   496,   497,   498,   499,     0,     0,
     500,     0,     0,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,   516,   517,
     518,     0,     0,     0,  1740,   801,   802,   803,     0,   804,
     805,   806,   807,   808,   809,   211,   212,   213,   214,   215,
     216,   217,   218,  1741,   220,   221,   222,  1742,  1743,  1744,
    1745,   223,  1746,  1747,  1748,   224,   225,  1749,   226,   227,
     745,   228,   229,   230,   231,   232,   746,   233,   234,  1750,
     235,   236,   237,   238,   239,  1751,  1752,   240,   241,   242,
     243,   244,  1753,   245,   246,   247,   248,   249,  1754,   747,
    1755,   250,   251,   252,   253,   748,   254,   255,  1756,   256,
     257,   258,   259,   260,   261,  1757,   749,   262,   263,  1758,
    1759,  1760,   750,  1761,  1762,  1763,   264,   265,   266,   267,
     268,   269,   270,   271,   272,  1764,   273,  1765,   274,   275,
     276,   277,   278,  1766,   279,   280,   281,  1767,  1768,   282,
     283,   284,   285,   286,  1769,   287,   288,   289,  1770,   290,
     291,   292,  1771,   293,   294,   295,   296,   297,   298,   299,
     300,   301,  1772,   302,  1773,   303,   304,   305,   306,  1774,
     307,  1775,   308,   751,  1776,   752,   309,   310,   311,  1777,
     312,   313,  1778,   314,  1779,   315,   316,   317,   318,   319,
     753,   320,   321,   322,  1780,   323,   324,   325,   326,   327,
     328,  1781,   329,   754,   330,   331,   332,   333,   334,   335,
     336,  1782,   337,  1783,   338,   755,   756,   339,   757,   340,
     341,   342,   343,   344,  1784,   345,   346,  1785,   347,   348,
     758,   349,   759,  1786,   350,   351,   352,  1787,  1788,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   760,   367,   368,   369,   370,  1789,   371,
     372,   761,   373,  1790,   374,   375,   376,   377,   378,   379,
    1791,   380,  1792,  1793,   381,   382,   383,  1794,  1795,   384,
     385,   762,   386,   763,   387,   388,   389,   390,   391,   392,
     393,   394,  1796,   395,   396,   397,   398,   399,   400,   401,
    1797,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,  1798,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,  1799,   426,   427,   764,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,  1800,   439,   440,   441,   442,   443,  1801,   444,   445,
     446,   447,   765,   448,   449,   450,  1802,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,  1803,   462,
     463,  1804,   464,   465,   466,   467,   468,   469,  1805,   470,
     471,  1806,  1807,   472,   473,   474,   475,  1808,   476,   477,
     478,   479,   480,   481,   482,  1809,  1810,   483,   484,   485,
     486,   487,  1811,  1812,   488,   489,   490,   491,   492,   493,
     494,  1813,   495,   766,   496,   497,   498,   499,  1814,  1815,
     500,  1816,  1817,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,   516,   517,
     518,   210,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1818,   211,   212,   213,   214,   215,   216,   217,   218,
       0,   220,   221,   222,     0,     0,     0,     0,   223,     0,
       0,     0,   224,   225,     0,   226,   227,     0,   228,   229,
     230,   231,   232,     0,   233,   234,     0,   235,   236,   237,
     238,   239,     0,     0,   240,   241,   242,   243,   244,     0,
     245,   246,   247,   248,   249,     0,     0,     0,   250,   251,
     252,   253,     0,   254,   255,     0,   256,   257,   258,   259,
     260,   261,     0,     0,   262,   263,     0,     0,     0,     0,
       0,     0,     0,   264,   265,   266,   267,   268,   269,   270,
     271,   272,     0,   273,     0,   274,   275,   276,   277,   278,
       0,   279,   280,   281,     0,     0,   282,   283,   284,   285,
     286,     0,   287,   288,   289,     0,   290,   291,   292,     0,
     293,   294,   295,   296,   297,   298,   299,   300,   301,     0,
     302,     0,   303,   304,   305,   306,     0,   307,     0,   308,
       0,     0,     0,   309,   310,   311,     0,   312,   313,     0,
     314,     0,   315,   316,   317,   318,   319,     0,   320,   321,
     322,     0,   323,   324,   325,   326,   327,   328,     0,   329,
       0,   330,   331,   332,   333,   334,   335,   336,     0,   337,
       0,   338,     0,     0,   339,     0,   340,   341,   342,   343,
     344,     0,   345,   346,     0,   347,   348,     0,   349,     0,
       0,   350,   351,   352,     0,     0,   353,   354,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,   366,
       0,   367,   368,   369,   370,     0,   371,   372,     0,   373,
       0,   374,   375,   376,   377,   378,   379,     0,   380,     0,
       0,   381,   382,   383,     0,     0,   384,   385,     0,   386,
       0,   387,   388,   389,   390,   391,   392,   393,   394,     0,
     395,   396,   397,   398,   399,   400,   401,     0,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,     0,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,     0,   426,   427,     0,   428,   429,   430,
     431,   432,   433,   434,   435,   436,   437,   438,     0,   439,
     440,   441,   442,   443,     0,   444,   445,   446,   447,     0,
     448,   449,   450,     0,   451,   452,   453,   454,   455,   456,
     457,   458,   459,   460,   461,     0,   462,   463,     0,   464,
     465,   466,   467,   468,   469,     0,   470,   471,     0,     0,
     472,   473,   474,   475,     0,   476,   477,   478,   479,   480,
     481,   482,     0,     0,   483,   484,   485,   486,   487,     0,
       0,   488,   489,   490,   491,   492,   493,   494,     0,   495,
       0,   496,   497,   498,   499,     0,     0,   500,     0,     0,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,   513,   514,   515,   516,   517,   518,  1397,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   714,   211,
     212,   213,   214,   215,   216,   217,   218,     0,   220,   221,
     222,     0,     0,     0,     0,   223,     0,     0,     0,   224,
     225,     0,   226,   227,   745,   228,   229,   230,     0,  1398,
     746,  1399,  1400,     0,   235,   236,   237,   238,   239,     0,
       0,   240,   241,  1401,  1402,   244,     0,   245,   246,   247,
     248,     0,     0,   747,     0,   250,   251,   252,   253,   748,
     254,   255,     0,   256,   257,   258,   259,   260,   261,     0,
     749,   262,   263,     0,     0,     0,   750,     0,     0,     0,
     264,   265,   266,   267,   268,   269,  1403,  1404,   272,     0,
     273,     0,   274,   275,   276,   277,   278,     0,   279,   280,
     281,     0,     0,   282,   283,  1056,   285,   286,     0,   287,
     288,   289,     0,   290,   291,   292,     0,   293,   294,   295,
     296,     0,   298,   299,   300,     0,     0,   302,     0,   303,
     304,  1405,   306,     0,   307,     0,   308,   751,     0,   752,
     309,   310,   311,     0,   312,     0,     0,   314,     0,   315,
     316,   317,   318,   319,   753,   320,   321,   322,  1877,   323,
     324,   325,   326,   327,   328,     0,   329,   754,  1878,   331,
     332,   333,   334,  1406,  1407,     0,  1408,     0,   338,   755,
     756,   339,   757,   340,   341,   342,   343,   344,     0,   345,
     346,     0,   347,     0,   758,   349,   759,     0,   350,   351,
     352,     0,     0,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,  1409,   760,  1410,   368,
     369,     0,     0,   371,   372,   761,   373,     0,     0,   375,
    1411,   377,   378,   379,     0,   380,     0,     0,   381,   382,
     383,     0,  1879,   384,  1880,   762,   386,   763,     0,   388,
     389,   390,   391,   392,   393,   394,     0,   395,     0,   397,
       0,   399,   400,   401,     0,   402,   403,   404,   405,   406,
     407,   408,   409,  1412,   411,   412,   413,   414,     0,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
       0,   426,   427,   764,   428,   429,     0,   431,   432,   433,
     434,   435,   436,   437,   438,     0,   439,   440,   441,   442,
     443,     0,   444,  1881,   446,   447,   765,   448,  1414,   450,
       0,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,     0,     0,   462,   463,     0,   464,   465,   466,   467,
     468,   469,     0,  1415,  1416,     0,     0,   472,     0,   474,
       0,     0,   476,   477,   478,   479,   480,   481,   482,     0,
       0,   483,   484,   485,   486,   487,     0,     0,   488,   489,
     490,   491,   492,     0,  1417,  1882,   495,   766,   496,   497,
     498,   499,     0,     0,   500,     0,     0,   501,   502,   503,
     504,   505,   506,     0,     0,     0,  2130,     0,     0,     0,
       0,     0,   516,   517,   518,     0,     0,   211,   212,   213,
     214,   215,   216,   217,   218,  1883,   220,   221,   222,     0,
       0,     0,     0,   223,     0,     0,     0,   224,   225,     0,
     226,   227,   745,   228,   229,   230,     0,  1398,   746,  1399,
    1400,     0,   235,   236,   237,   238,   239,     0,     0,   240,
     241,  1401,  1402,   244,     0,   245,   246,   247,   248,     0,
       0,   747,     0,   250,   251,   252,   253,   748,   254,   255,
       0,   256,   257,   258,   259,   260,   261,     0,   749,   262,
     263,     0,     0,     0,   750,     0,     0,     0,   264,   265,
     266,   267,   268,   269,  1403,  1404,   272,     0,   273,     0,
     274,   275,   276,   277,   278,     0,   279,   280,   281,     0,
       0,   282,   283,  1056,   285,   286,     0,   287,   288,   289,
       0,   290,   291,   292,     0,   293,   294,   295,   296,     0,
     298,   299,   300,     0,     0,   302,     0,   303,   304,  1405,
     306,     0,   307,     0,   308,   751,     0,   752,   309,   310,
     311,     0,   312,     0,     0,   314,     0,   315,   316,   317,
     318,   319,   753,   320,   321,   322,  1877,   323,   324,   325,
     326,   327,   328,     0,   329,   754,  1878,   331,   332,   333,
     334,  1406,  1407,     0,  1408,     0,   338,   755,   756,   339,
     757,   340,   341,   342,   343,   344,     0,   345,   346,     0,
     347,     0,   758,   349,   759,     0,   350,   351,   352,     0,
       0,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,  1409,   760,  1410,   368,   369,     0,
       0,   371,   372,   761,   373,     0,     0,   375,  1411,   377,
     378,   379,     0,   380,     0,     0,   381,   382,   383,     0,
    1879,   384,  1880,   762,   386,   763,     0,   388,   389,   390,
     391,   392,   393,   394,     0,   395,     0,   397,     0,   399,
     400,   401,     0,   402,   403,   404,   405,   406,   407,   408,
     409,  1412,   411,   412,   413,   414,     0,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,     0,   426,
     427,   764,   428,   429,     0,   431,   432,   433,   434,   435,
     436,   437,   438,     0,   439,   440,   441,   442,   443,     0,
     444,  1881,   446,   447,   765,   448,  1414,   450,     0,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,     0,
       0,   462,   463,     0,   464,   465,   466,   467,   468,   469,
       0,  1415,  1416,     0,     0,   472,     0,   474,     0,     0,
     476,   477,   478,   479,   480,   481,   482,     0,     0,   483,
     484,   485,   486,   487,     0,     0,   488,   489,   490,   491,
     492,     0,  1417,  1882,   495,   766,   496,   497,   498,   499,
       0,     0,   500,     0,     0,   501,   502,   503,   504,   505,
     506,     0,     0,     0,   210,     0,     0,     0,     0,     0,
     516,   517,   518,     0,     0,   211,   212,   213,   214,   215,
     216,   217,   218,  1883,   220,   221,   222,     0,     0,     0,
       0,   223,     0,     0,     0,   224,   225,     0,   226,   227,
       0,   228,   229,   230,   231,   232,     0,   233,   234,     0,
     235,   236,   237,   238,   239,     0,     0,   240,   241,   242,
     243,   244,     0,   245,   246,   247,   248,   249,     0,     0,
       0,   250,   251,   252,   253,     0,   254,   255,     0,   256,
     257,   258,   259,   260,   261,     0,     0,   262,   263,     0,
       0,     0,     0,     0,     0,     0,   264,   265,   266,   267,
     268,   269,   270,   271,   272,     0,   273,     0,   274,   275,
     276,   277,   278,     0,   279,   280,   281,     0,     0,   282,
     283,   284,   285,   286,     0,   287,   288,   289,     0,   290,
     291,   292,     0,   293,   294,   295,   296,   297,   298,   299,
     300,   301,     0,   302,     0,   303,   304,   305,   306,     0,
     307,     0,   308,     0,     0,     0,   309,   310,   311,     0,
     312,   313,     0,   314,     0,   315,   316,   317,   318,   319,
       0,   320,   321,   322,     0,   323,   324,   325,   326,   327,
     328,     0,   329,     0,   330,   331,   332,   333,   334,   335,
     336,     0,   337,     0,   338,     0,     0,   339,     0,   340,
     341,   342,   343,   344,     0,   345,   346,     0,   347,   348,
       0,   349,     0,     0,   350,   351,   352,     0,     0,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,     0,   367,   368,   369,   370,     0,   371,
     372,     0,   373,     0,   374,   375,   376,   377,   378,   379,
       0,   380,     0,     0,   381,   382,   383,     0,     0,   384,
     385,     0,   386,     0,   387,   388,   389,   390,   391,   392,
     393,   394,     0,   395,   396,   397,   398,   399,   400,   401,
       0,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,     0,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,     0,   426,   427,     0,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,     0,   439,   440,   441,   442,   443,     0,   444,   445,
     446,   447,     0,   448,   449,   450,     0,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,     0,   462,
     463,     0,   464,   465,   466,   467,   468,   469,     0,   470,
     471,     0,     0,   472,   473,   474,   475,     0,   476,   477,
     478,   479,   480,   481,   482,     0,     0,   483,   484,   485,
     486,   487,     0,     0,   488,   489,   490,   491,   492,   493,
     494,     0,   495,     0,   496,   497,   498,   499,     0,     0,
     500,     0,     0,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,   516,   517,
     518,   787,  1289,   574,     0,     0,     0,   625,     0,     0,
       0,  4239,   211,   212,   213,   214,   215,   216,   217,   218,
       0,   220,   221,   222,     0,     0,     0,     0,   223,     0,
       0,     0,   224,   225,     0,   226,   227,   745,   228,   229,
     230,   231,   232,   746,   233,   234,     0,   235,   236,   237,
     238,   239,     0,     0,   240,   241,   242,   243,   244,     0,
     245,   246,   247,   248,   249,     0,   747,     0,   250,   251,
     252,   253,   748,   254,   255,     0,   256,   257,   258,   259,
     260,   261,     0,   749,   262,   263,     0,     0,     0,   750,
       0,     0,     0,   264,   265,   266,   267,   268,   269,   270,
     271,   272,  1730,   273,     0,   274,   275,   276,   277,   278,
       0,   279,   280,   281,     0,     0,   282,   283,   284,   285,
     286,     0,   287,   288,   289,     0,   290,   291,   292,     0,
     293,   294,   295,   296,   297,   298,   299,   300,   301,  1536,
     302,     0,   303,   304,   305,   306,     0,   307,     0,   308,
     751,     0,   752,   309,   310,   311,     0,   312,   313,     0,
     314,     0,   315,   316,   317,   318,   319,   753,   320,   321,
     322,     0,   323,   324,   325,   326,   327,   328,     0,   329,
     754,   330,   331,   332,   333,   334,   335,   336,     0,   337,
       0,   338,   755,   756,   339,   757,   340,   341,   342,   343,
     344,     0,   345,   346,     0,   347,   348,   758,   349,   759,
       0,   350,   351,   352,     0,     0,   353,   354,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,   366,
     760,   367,   368,   369,   370,     0,   371,   372,   761,   373,
       0,   374,   375,   376,   377,   378,   379,     0,   380,  1537,
       0,   381,   382,   383,     0,     0,   384,   385,   762,   386,
     763,   387,   388,   389,   390,   391,   392,   393,   394,     0,
     395,   396,   397,   398,   399,   400,   401,     0,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,     0,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,     0,   426,   427,   764,   428,   429,   430,
     431,   432,   433,   434,   435,   436,   437,   438,     0,   439,
     440,   441,   442,   443,     0,   444,   445,   446,   447,   765,
     448,   449,   450,     0,   451,   452,   453,   454,   455,   456,
     457,   458,   459,   460,   461,     0,   462,   463,     0,   464,
     465,   466,   467,   468,   469,     0,   470,   471,     0,     0,
     472,   473,   474,   475,  1538,   476,   477,   478,   479,   480,
     481,   482,     0,     0,   483,   484,   485,   486,   487,     0,
       0,   488,   489,   490,   491,   492,   493,   494,     0,   495,
     766,   496,   497,   498,   499,     0,     0,   500,     0,     0,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,   513,   514,   515,   516,   517,   518,   787,  1289,
     574,     0,     0,     0,   625,     0,   637,  1290,     0,   211,
     212,   213,   214,   215,   216,   217,   218,     0,   220,   221,
     222,     0,     0,     0,     0,   223,     0,     0,     0,   224,
     225,     0,   226,   227,   745,   228,   229,   230,   231,   232,
     746,   233,   234,     0,   235,   236,   237,   238,   239,     0,
       0,   240,   241,   242,   243,   244,     0,   245,   246,   247,
     248,   249,     0,   747,     0,   250,   251,   252,   253,   748,
     254,   255,     0,   256,   257,   258,   259,   260,   261,     0,
     749,   262,   263,     0,     0,     0,   750,     0,     0,     0,
     264,   265,   266,   267,   268,   269,   270,   271,   272,  1735,
     273,     0,   274,   275,   276,   277,   278,     0,   279,   280,
     281,     0,     0,   282,   283,   284,   285,   286,     0,   287,
     288,   289,     0,   290,   291,   292,     0,   293,   294,   295,
     296,   297,   298,   299,   300,   301,  1536,   302,     0,   303,
     304,   305,   306,     0,   307,     0,   308,   751,     0,   752,
     309,   310,   311,     0,   312,   313,     0,   314,     0,   315,
     316,   317,   318,   319,   753,   320,   321,   322,     0,   323,
     324,   325,   326,   327,   328,     0,   329,   754,   330,   331,
     332,   333,   334,   335,   336,     0,   337,     0,   338,   755,
     756,   339,   757,   340,   341,   342,   343,   344,     0,   345,
     346,     0,   347,   348,   758,   349,   759,     0,   350,   351,
     352,     0,     0,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   760,   367,   368,
     369,   370,     0,   371,   372,   761,   373,     0,   374,   375,
     376,   377,   378,   379,     0,   380,  1537,     0,   381,   382,
     383,     0,     0,   384,   385,   762,   386,   763,   387,   388,
     389,   390,   391,   392,   393,   394,     0,   395,   396,   397,
     398,   399,   400,   401,     0,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,     0,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
       0,   426,   427,   764,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,     0,   439,   440,   441,   442,
     443,     0,   444,   445,   446,   447,   765,   448,   449,   450,
       0,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,     0,   462,   463,     0,   464,   465,   466,   467,
     468,   469,     0,   470,   471,     0,     0,   472,   473,   474,
     475,  1538,   476,   477,   478,   479,   480,   481,   482,     0,
       0,   483,   484,   485,   486,   487,     0,     0,   488,   489,
     490,   491,   492,   493,   494,     0,   495,   766,   496,   497,
     498,   499,     0,     0,   500,     0,     0,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   787,  1289,   574,     0,     0,
       0,   625,     0,   637,  1290,     0,   211,   212,   213,   214,
     215,   216,   217,   218,     0,   220,   221,   222,     0,     0,
       0,     0,   223,     0,     0,     0,   224,   225,     0,   226,
     227,   745,   228,   229,   230,   231,   232,   746,   233,   234,
       0,   235,   236,   237,   238,   239,     0,     0,   240,   241,
     242,   243,   244,     0,   245,   246,   247,   248,   249,     0,
     747,     0,   250,   251,   252,   253,   748,   254,   255,     0,
     256,   257,   258,   259,   260,   261,     0,   749,   262,   263,
       0,     0,     0,   750,     0,     0,     0,   264,   265,   266,
     267,   268,   269,   270,   271,   272,     0,   273,     0,   274,
     275,   276,   277,   278,     0,   279,   280,   281,     0,     0,
     282,   283,   284,   285,   286,     0,   287,   288,   289,     0,
     290,   291,   292,     0,   293,   294,   295,   296,   297,   298,
     299,   300,   301,  1536,   302,     0,   303,   304,   305,   306,
       0,   307,     0,   308,   751,     0,   752,   309,   310,   311,
       0,   312,   313,     0,   314,     0,   315,   316,   317,   318,
     319,   753,   320,   321,   322,     0,   323,   324,   325,   326,
     327,   328,     0,   329,   754,   330,   331,   332,   333,   334,
     335,   336,     0,   337,     0,   338,   755,   756,   339,   757,
     340,   341,   342,   343,   344,     0,   345,   346,     0,   347,
     348,   758,   349,   759,     0,   350,   351,   352,     0,     0,
     353,   354,   355,   356,   357,   358,   359,   360,   361,   362,
     363,   364,   365,   366,   760,   367,   368,   369,   370,     0,
     371,   372,   761,   373,     0,   374,   375,   376,   377,   378,
     379,     0,   380,  1537,     0,   381,   382,   383,     0,     0,
     384,   385,   762,   386,   763,   387,   388,   389,   390,   391,
     392,   393,   394,     0,   395,   396,   397,   398,   399,   400,
     401,     0,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,     0,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,     0,   426,   427,
     764,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,     0,   439,   440,   441,   442,   443,     0,   444,
     445,   446,   447,   765,   448,   449,   450,     0,   451,   452,
     453,   454,   455,   456,   457,   458,   459,   460,   461,     0,
     462,   463,     0,   464,   465,   466,   467,   468,   469,     0,
     470,   471,     0,     0,   472,   473,   474,   475,  1538,   476,
     477,   478,   479,   480,   481,   482,     0,     0,   483,   484,
     485,   486,   487,     0,     0,   488,   489,   490,   491,   492,
     493,   494,     0,   495,   766,   496,   497,   498,   499,     0,
       0,   500,     0,     0,   501,   502,   503,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
     517,   518,   210,     0,     0,     0,     0,     0,   625,     0,
     637,  1290,     0,   211,   626,   213,   214,   215,   216,   217,
     218,   627,   220,   221,   222,     0,     0,     0,     0,   223,
       0,     0,     0,   224,   225,     0,   226,   227,     0,   628,
     229,   230,   231,   232,     0,   233,   234,     0,   235,   236,
     237,   238,   239,     0,     0,   240,   241,   242,   243,   244,
       0,   245,   246,   247,   248,   249,     0,     0,     0,   250,
     251,   252,   253,     0,   254,   255,     0,   256,   257,   258,
     259,   260,   261,     0,     0,   262,   263,     0,     0,     0,
       0,     0,     0,     0,   264,   265,   266,   267,   268,   269,
     270,   271,   272,     0,   273,     0,   274,   275,   276,   277,
     278,     0,   279,   280,   281,     0,     0,   282,   283,   284,
     285,   286,     0,   287,   288,   289,     0,   290,   291,   292,
       0,   293,   294,   295,   296,   297,   298,   299,   300,   301,
       0,   302,     0,   303,   629,   305,   306,     0,   307,     0,
     630,     0,   631,     0,   309,   310,   311,     0,   312,   313,
       0,   314,     0,   315,   316,   317,   318,   319,     0,   320,
     321,   322,   632,   323,   324,   325,   326,   327,   328,     0,
     329,     0,   330,   331,   332,   333,   334,   335,   336,     0,
     337,     0,   338,     0,     0,   339,     0,   340,   341,   342,
     343,   633,     0,   345,   346,     0,   347,   348,     0,   349,
       0,     0,   350,   351,   352,     0,     0,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,     0,   367,   634,   369,   370,     0,   371,   372,     0,
     373,     0,   374,   375,   376,   377,   378,   379,     0,   380,
       0,     0,   381,   382,   383,     0,     0,   384,   385,     0,
     386,     0,   387,   388,   389,   390,   391,   392,   393,   394,
       0,   395,   396,   397,   398,   399,   400,   401,     0,   635,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,     0,   415,   416,   636,   418,   419,   420,   421,
     422,   423,   424,   425,     0,   426,   427,     0,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,     0,
     439,   440,   441,   442,   443,     0,   444,   445,   446,   447,
       0,   448,   449,   450,     0,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,     0,   462,   463,     0,
     464,   465,   466,   467,   468,   469,     0,   470,   471,     0,
       0,   472,   473,   474,   475,     0,   476,   477,   478,   479,
     480,   481,   482,     0,     0,   483,   484,   485,   486,   487,
       0,     0,   488,   489,   490,   491,   492,   493,   494,     0,
     495,     0,   496,   497,   498,   499,     0,     0,   500,     0,
       0,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,  1740,
    4549,   574,     0,     0,     0,   625,     0,   637,   638,     0,
     211,   212,   213,   214,   215,   216,   217,   218,  1741,   220,
     221,   222,  1742,  1743,  1744,  1745,   223,  1746,  1747,  1748,
     224,   225,  1749,   226,   227,   745,   228,   229,   230,   231,
     232,   746,   233,   234,  1750,   235,   236,   237,   238,   239,
    1751,  1752,   240,   241,   242,   243,   244,  1753,   245,   246,
     247,   248,   249,  1754,   747,  1755,   250,   251,   252,   253,
     748,   254,   255,  1756,   256,   257,   258,   259,   260,   261,
    1757,   749,   262,   263,  1758,  1759,  1760,   750,  1761,  1762,
    1763,   264,   265,   266,   267,   268,   269,   270,   271,   272,
    1764,   273,  1765,   274,   275,   276,   277,   278,  1766,   279,
     280,   281,  1767,  1768,   282,   283,   284,   285,   286,  1769,
     287,   288,   289,  1770,   290,   291,   292,  1771,   293,   294,
     295,   296,   297,   298,   299,   300,   301,  1772,   302,  1773,
     303,   304,   305,   306,  1774,   307,  1775,   308,   751,  1776,
     752,   309,   310,   311,  1777,   312,   313,  1778,   314,  1779,
     315,   316,   317,   318,   319,   753,   320,   321,   322,  1780,
     323,   324,   325,   326,   327,   328,  1781,   329,   754,   330,
     331,   332,   333,   334,   335,   336,  1782,   337,  1783,   338,
     755,   756,   339,   757,   340,   341,   342,   343,   344,  1784,
     345,   346,  1785,   347,   348,   758,   349,   759,  1786,   350,
     351,   352,  1787,  1788,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,   365,   366,   760,   367,
     368,   369,   370,  1789,   371,   372,   761,   373,  1790,   374,
     375,   376,   377,   378,   379,  1791,   380,  1792,  1793,   381,
     382,   383,  1794,  1795,   384,   385,   762,   386,   763,   387,
     388,   389,   390,   391,   392,   393,   394,  1796,   395,   396,
     397,   398,   399,   400,   401,  1797,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,  1798,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,  1799,   426,   427,   764,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,   438,  1800,   439,   440,   441,
     442,   443,  1801,   444,   445,   446,   447,   765,   448,   449,
     450,  1802,   451,   452,   453,   454,   455,   456,   457,   458,
     459,   460,   461,  1803,   462,   463,  1804,   464,   465,   466,
     467,   468,   469,  1805,   470,   471,  1806,  1807,   472,   473,
     474,   475,  1808,   476,   477,   478,   479,   480,   481,   482,
    1809,  1810,   483,   484,   485,   486,   487,  1811,  1812,   488,
     489,   490,   491,   492,   493,   494,  1813,   495,   766,   496,
     497,   498,   499,  1814,  1815,   500,  1816,  1817,   501,   502,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
     513,   514,   515,   516,   517,   518,  1740,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   211,   212,   213,
     214,   215,   216,   217,   218,  1741,   220,   221,   222,  1742,
    1743,  1744,  1745,   223,  1746,  1747,  1748,   224,   225,  1749,
     226,   227,   745,   228,   229,   230,   231,   232,   746,   233,
     234,  1750,   235,   236,   237,   238,   239,  1751,  1752,   240,
     241,   242,   243,   244,  1753,   245,   246,   247,   248,   249,
    1754,   747,  1755,   250,   251,   252,   253,   748,   254,   255,
    1756,   256,   257,   258,   259,   260,   261,  1757,   749,   262,
     263,  1758,  1759,  1760,   750,  1761,  1762,  1763,   264,   265,
     266,   267,   268,   269,   270,   271,   272,  1764,   273,  1765,
     274,   275,   276,   277,   278,  1766,   279,   280,   281,  1767,
    1768,   282,   283,   284,   285,   286,  1769,   287,   288,   289,
    1770,   290,   291,   292,  1771,   293,   294,   295,   296,   297,
     298,   299,   300,   301,  1772,   302,  1773,   303,   304,   305,
     306,  1774,   307,  1775,   308,   751,  1776,   752,   309,   310,
     311,  1777,   312,   313,  1778,   314,  1779,   315,   316,   317,
     318,   319,   753,   320,   321,   322,  1780,   323,   324,   325,
     326,   327,   328,  1781,   329,   754,   330,   331,   332,   333,
     334,   335,   336,  1782,   337,  1783,   338,   755,   756,   339,
     757,   340,   341,   342,   343,   344,  1784,   345,   346,  1785,
     347,   348,   758,   349,   759,  1786,   350,   351,   352,  1787,
    1788,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   366,   760,   367,   368,   369,   370,
    1789,   371,   372,   761,   373,  1790,   374,   375,   376,   377,
     378,   379,  1791,   380,  1792,  1793,   381,   382,   383,  1794,
    1795,   384,   385,   762,   386,   763,   387,   388,   389,   390,
     391,   392,   393,   394,  1796,   395,   396,   397,   398,   399,
     400,   401,  1797,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,  1798,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,  1799,   426,
     427,   764,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,  1800,   439,   440,   441,   442,   443,  1801,
     444,   445,   446,   447,   765,   448,   449,   450,  1802,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,   461,
    1803,   462,   463,  1804,   464,   465,   466,   467,   468,   469,
    1805,   470,   471,  1806,  1807,   472,   473,   474,   475,  1808,
     476,   477,   478,   479,   480,   481,   482,  1809,  1810,   483,
     484,   485,   486,   487,  1811,  1812,   488,   489,   490,   491,
     492,   493,   494,  1813,   495,   766,   496,   497,   498,   499,
    1814,  1815,   500,  1816,  1817,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,  1740,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   211,   212,   213,   214,  2661,   216,
     217,   218,  1741,   220,   221,   222,  1742,  1743,  1744,  1745,
     223,  1746,  1747,  1748,   224,   225,  1749,   226,   227,   745,
     228,   229,   230,   231,   232,   746,   233,   234,  1750,   235,
     236,   237,   238,   239,  1751,  1752,   240,   241,   242,   243,
     244,  1753,   245,   246,   247,   248,   249,  1754,   747,  1755,
     250,   251,   252,   253,   748,   254,   255,  1756,   256,   257,
     258,   259,   260,   261,  1757,   749,   262,   263,  1758,  1759,
    1760,   750,  1761,  1762,  1763,   264,   265,   266,   267,   268,
     269,   270,   271,   272,  1764,   273,  1765,   274,   275,   276,
     277,   278,  1766,   279,   280,   281,  1767,  1768,   282,   283,
     284,  2662,   286,  1769,   287,   288,   289,  1770,   290,   291,
     292,  1771,   293,   294,   295,   296,   297,   298,   299,   300,
     301,  1772,   302,  1773,   303,   304,   305,   306,  1774,   307,
    1775,   308,   751,  1776,   752,   309,   310,   311,  1777,   312,
     313,  1778,   314,  1779,   315,   316,   317,   318,   319,   753,
     320,   321,   322,  1780,   323,   324,   325,   326,   327,   328,
    1781,   329,   754,   330,   331,   332,   333,   334,   335,   336,
    1782,   337,  1783,   338,   755,   756,   339,   757,   340,   341,
     342,   343,   344,  1784,   345,   346,  1785,   347,   348,   758,
     349,   759,  1786,   350,   351,   352,  1787,  1788,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   760,   367,   368,   369,   370,  1789,   371,   372,
     761,   373,  1790,   374,   375,   376,   377,   378,   379,  1791,
     380,  1792,  1793,   381,   382,   383,  1794,  1795,   384,   385,
     762,   386,   763,   387,   388,   389,   390,   391,   392,   393,
     394,  1796,   395,   396,   397,   398,   399,   400,   401,  1797,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,  1798,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,  1799,   426,   427,   764,   428,
     429,   430,   431,   432,   433,   434,   435,   436,   437,   438,
    1800,   439,   440,   441,   442,   443,  1801,  2663,   445,   446,
     447,   765,   448,   449,   450,  1802,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,  1803,   462,   463,
    1804,   464,   465,   466,   467,   468,   469,  1805,   470,   471,
    1806,  1807,   472,   473,   474,   475,  1808,   476,   477,   478,
     479,   480,   481,   482,  1809,  1810,   483,   484,   485,   486,
     487,  1811,  1812,   488,   489,   490,   491,   492,   493,   494,
    1813,   495,   766,   496,   497,   498,   499,  1814,  1815,   500,
    1816,  1817,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
     744,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   211,   212,   213,   214,   215,   216,   217,   218,     0,
     220,   221,   222,     0,     0,     0,     0,   223,     0,     0,
       0,   224,   225,     0,   226,   227,   745,   228,   229,   230,
     231,   232,   746,   233,   234,     0,   235,   236,   237,   238,
     239,     0,  1042,   240,   241,   242,   243,   244,     0,   245,
     246,   247,   248,  1045,     0,  1046,     0,   250,   251,   252,
     253,   748,   254,   255,     0,   256,   257,   258,   259,   260,
     261,     0,   749,   262,   263,  1047,  1048,  1049,  1050,  1051,
    1052,  1053,   264,   265,   266,   267,   268,   269,   270,   271,
     272,     0,   273,     0,   274,   275,   276,   277,   278,     0,
     279,   280,   281,     0,     0,   282,   283,   284,   285,   286,
       0,   287,   288,   289,     0,   290,   291,   292,     0,   293,
     294,   295,   296,   297,   298,   299,   300,  1058,     0,   302,
       0,   303,   304,   305,   306,     0,   307,     0,   308,   751,
       0,   752,   309,   310,   311,     0,   312,  1061,     0,   314,
       0,   315,   316,   317,   318,   319,   753,   320,   321,   322,
       0,   323,   324,   325,   326,   327,   328,     0,   329,   754,
     330,   331,   332,   333,   334,   335,   336,     0,   337,     0,
     338,   755,   756,   339,   757,   340,   341,   342,   343,   344,
       0,   345,   346,     0,   347,  1065,   758,   349,   759,     0,
     350,   351,   352,  1066,  1067,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   366,   760,
     367,   368,   369,   370,     0,   371,   372,   761,   373,     0,
    1072,   375,   376,   377,   378,   379,     0,   380,     0,     0,
     381,   382,   383,     0,     0,   384,   385,   762,   386,   763,
    1075,   388,   389,   390,   391,   392,   393,   394,     0,   395,
    1076,   397,   398,   399,   400,   401,     0,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
       0,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,     0,   426,   427,   764,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,     0,   439,   440,
     441,   442,   443,  1079,   444,   445,   446,   447,   765,   448,
     449,   450,     0,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,  1081,     0,   462,   463,     0,   464,   465,
     466,   467,   468,   469,     0,   470,   471,     0,     0,   472,
    1084,   474,  1085,     0,   476,   477,   478,   479,   480,   481,
     482,     0,     0,   483,   484,   485,   486,   487,  1088,     0,
     488,   489,   490,   491,   492,   493,   494,     0,   495,   766,
     496,   497,   498,   499,     0,     0,   500,     0,     0,   501,
     502,   503,   504,   505,   506,   507,  1090,  1091,  1092,  1093,
    1094,  1095,  1096,  1097,   516,   517,   518,   787,     0,   574,
       0,     0,     0,     0,     0,     0,     0,     0,   211,   212,
     213,   214,   215,   216,   217,   218,     0,   220,   221,   222,
       0,     0,     0,     0,   223,     0,     0,     0,   224,   225,
       0,   226,   227,   745,   228,   229,   230,   231,   232,   746,
     233,   234,     0,   235,   236,   237,   238,   239,     0,     0,
     240,   241,   242,   243,   244,     0,   245,   246,   247,   248,
     249,     0,   747,     0,   250,   251,   252,   253,   748,   254,
     255,     0,   256,   257,   258,   259,   260,   261,     0,   749,
     262,   263,     0,     0,     0,   750,     0,     0,     0,   264,
     265,   266,   267,   268,   269,   270,   271,   272,     0,   273,
       0,   274,   275,   276,   277,   278,     0,   279,   280,   281,
       0,     0,   282,   283,   284,   285,   286,     0,   287,   288,
     289,     0,   290,   291,   292,     0,   293,   294,   295,   296,
     297,   298,   299,   300,   301,  1536,   302,     0,   303,   304,
     305,   306,     0,   307,     0,   308,   751,     0,   752,   309,
     310,   311,     0,   312,   313,     0,   314,     0,   315,   316,
     317,   318,   319,   753,   320,   321,   322,     0,   323,   324,
     325,   326,   327,   328,     0,   329,   754,   330,   331,   332,
     333,   334,   335,   336,     0,   337,     0,   338,   755,   756,
     339,   757,   340,   341,   342,   343,   344,     0,   345,   346,
       0,   347,   348,   758,   349,   759,     0,   350,   351,   352,
       0,     0,   353,   354,   355,   356,   357,   358,   359,   360,
     361,   362,   363,   364,   365,   366,   760,   367,   368,   369,
     370,     0,   371,   372,   761,   373,     0,   374,   375,   376,
     377,   378,   379,     0,   380,  1537,     0,   381,   382,   383,
       0,     0,   384,   385,   762,   386,   763,   387,   388,   389,
     390,   391,   392,   393,   394,     0,   395,   396,   397,   398,
     399,   400,   401,     0,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,     0,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,     0,
     426,   427,   764,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,     0,   439,   440,   441,   442,   443,
       0,   444,   445,   446,   447,   765,   448,   449,   450,     0,
     451,   452,   453,   454,   455,   456,   457,   458,   459,   460,
     461,     0,   462,   463,     0,   464,   465,   466,   467,   468,
     469,     0,   470,   471,     0,     0,   472,   473,   474,   475,
    1538,   476,   477,   478,   479,   480,   481,   482,     0,     0,
     483,   484,   485,   486,   487,     0,     0,   488,   489,   490,
     491,   492,   493,   494,     0,   495,   766,   496,   497,   498,
     499,     0,     0,   500,     0,     0,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   787,     0,   574,     0,     0,     0,
       0,     0,     0,     0,     0,   211,   212,   213,   214,   215,
     216,   217,   218,     0,   220,   221,   222,     0,     0,     0,
       0,   223,     0,     0,     0,   224,   225,     0,   226,   227,
     745,   228,   229,   230,   231,   232,   746,   233,   234,     0,
     235,   236,   237,   238,   239,     0,     0,   240,   241,   242,
     243,   244,     0,   245,   246,   247,   248,   249,     0,   747,
       0,   250,   251,   252,   253,   748,   254,   255,     0,   256,
     257,   258,   259,   260,   261,     0,   749,   262,   263,     0,
       0,     0,   750,     0,     0,     0,   264,   265,   266,   267,
     268,   269,   270,   271,   272,  1715,   273,     0,   274,   275,
     276,   277,   278,     0,   279,   280,   281,     0,     0,   282,
     283,   284,   285,   286,     0,   287,   288,   289,     0,   290,
     291,   292,     0,   293,   294,   295,   296,   297,   298,   299,
     300,   301,     0,   302,     0,   303,   304,   305,   306,     0,
     307,     0,   308,   751,     0,   752,   309,   310,   311,     0,
     312,   313,     0,   314,     0,   315,   316,   317,   318,   319,
     753,   320,   321,   322,     0,   323,   324,   325,   326,   327,
     328,     0,   329,   754,   330,   331,   332,   333,   334,   335,
     336,     0,   337,     0,   338,   755,   756,   339,   757,   340,
     341,   342,   343,   344,     0,   345,   346,     0,   347,   348,
     758,   349,   759,     0,   350,   351,   352,     0,     0,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   760,   367,   368,   369,   370,     0,   371,
     372,   761,   373,     0,   374,   375,   376,   377,   378,   379,
       0,   380,     0,     0,   381,   382,   383,     0,     0,   384,
     385,   762,   386,   763,   387,   388,   389,   390,   391,   392,
     393,   394,     0,   395,   396,   397,   398,   399,   400,   401,
       0,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,     0,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,     0,   426,   427,   764,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,     0,   439,   440,   441,   442,   443,     0,   444,   445,
     446,   447,   765,   448,   449,   450,     0,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,     0,   462,
     463,     0,   464,   465,   466,   467,   468,   469,     0,   470,
     471,     0,     0,   472,   473,   474,   475,     0,   476,   477,
     478,   479,   480,   481,   482,     0,     0,   483,   484,   485,
     486,   487,     0,     0,   488,   489,   490,   491,   492,   493,
     494,     0,   495,   766,   496,   497,   498,   499,     0,     0,
     500,     0,     0,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,   516,   517,
     518,   787,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   211,   212,   213,   214,   215,   216,   217,   218,
       0,   220,   221,   222,     0,     0,     0,     0,   223,     0,
       0,     0,   224,   225,     0,   226,   227,   745,   228,   229,
     230,   231,   232,   746,   233,   234,     0,   235,   236,   237,
     238,   239,     0,     0,   240,   241,   242,   243,   244,     0,
     245,   246,   247,   248,   249,     0,   747,     0,   250,   251,
     252,   253,   748,   254,   255,     0,   256,   257,   258,   259,
     260,   261,     0,   749,   262,   263,     0,     0,     0,   750,
       0,     0,  2087,   264,   265,   266,   267,   268,   269,   270,
     271,   272,     0,   273,     0,   274,   275,   276,   277,   278,
       0,   279,   280,   281,     0,     0,   282,   283,   284,   285,
     286,     0,   287,   288,   289,     0,   290,   291,   292,     0,
     293,   294,   295,   296,   297,   298,   299,   300,   301,     0,
     302,     0,   303,   304,   305,   306,     0,   307,     0,   308,
     751,     0,   752,   309,   310,   311,     0,   312,   313,     0,
     314,     0,   315,   316,   317,   318,   319,   753,   320,   321,
     322,     0,   323,   324,   325,   326,   327,   328,     0,   329,
     754,   330,   331,   332,   333,   334,   335,   336,     0,   337,
       0,   338,   755,   756,   339,   757,   340,   341,   342,   343,
     344,     0,   345,   346,     0,   347,   348,   758,   349,   759,
       0,   350,   351,   352,     0,     0,   353,   354,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,   366,
     760,   367,   368,   369,   370,     0,   371,   372,   761,   373,
       0,   374,   375,   376,   377,   378,   379,     0,   380,     0,
       0,   381,   382,   383,     0,     0,   384,   385,   762,   386,
     763,   387,   388,   389,   390,   391,   392,   393,   394,     0,
     395,   396,   397,   398,   399,   400,   401,     0,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,     0,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,     0,   426,   427,   764,   428,   429,   430,
     431,   432,   433,   434,   435,   436,   437,   438,     0,   439,
     440,   441,   442,   443,     0,   444,   445,   446,   447,   765,
     448,   449,   450,     0,   451,   452,   453,   454,   455,   456,
     457,   458,   459,   460,   461,     0,   462,   463,     0,   464,
     465,   466,   467,   468,   469,     0,   470,   471,     0,     0,
     472,   473,   474,   475,     0,   476,   477,   478,   479,   480,
     481,   482,     0,     0,   483,   484,   485,   486,   487,  2088,
       0,   488,   489,   490,   491,   492,   493,   494,     0,   495,
     766,   496,   497,   498,   499,     0,     0,   500,     0,     0,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,   513,   514,   515,   516,   517,   518,   787,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   211,
     212,   213,   214,   215,   216,   217,   218,     0,   220,   221,
     222,     3,     4,     0,     0,   223,     0,     0,     0,   224,
     225,     0,   226,   227,   745,   228,   229,   230,   231,   232,
     746,   233,   234,     0,   235,   236,   237,   238,   239,     0,
       0,   240,   241,   242,   243,   244,     0,   245,   246,   247,
     248,   249,     0,   747,     0,   250,   251,   252,   253,   748,
     254,   255,     0,   256,   257,   258,   259,   260,   261,     0,
     749,   262,   263,     0,     0,     0,   750,     0,     0,     0,
     264,   265,   266,   267,   268,   269,   270,   271,   272,     0,
     273,     0,   274,   275,   276,   277,   278,     0,   279,   280,
     281,     0,     0,   282,   283,   284,   285,   286,     0,   287,
     288,   289,     0,   290,   291,   292,     0,   293,   294,   295,
     296,   297,   298,   299,   300,   301,     0,   302,     0,   303,
     304,   305,   306,     0,   307,     0,   308,   751,     0,   752,
     309,   310,   311,     0,   312,   313,     0,   314,     0,   315,
     316,   317,   318,   319,   753,   320,   321,   322,     0,   323,
     324,   325,   326,   327,   328,     0,   329,   754,   330,   331,
     332,   333,   334,   335,   336,     0,   337,     0,   338,   755,
     756,   339,   757,   340,   341,   342,   343,   344,     0,   345,
     346,     0,   347,   348,   758,   349,   759,     0,   350,   351,
     352,     0,     0,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   760,   367,   368,
     369,   370,     0,   371,   372,   761,   373,     0,   374,   375,
     376,   377,   378,   379,     0,   380,     0,     0,   381,   382,
     383,     0,     0,   384,   385,   762,   386,   763,   387,   388,
     389,   390,   391,   392,   393,   394,     0,   395,   396,   397,
     398,   399,   400,   401,     0,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,     0,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
       0,   426,   427,   764,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,     0,   439,   440,   441,   442,
     443,     0,   444,   445,   446,   447,   765,   448,   449,   450,
       0,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,     0,   462,   463,     0,   464,   465,   466,   467,
     468,   469,     0,   470,   471,     0,     0,   472,   473,   474,
     475,     0,   476,   477,   478,   479,   480,   481,   482,     0,
       0,   483,   484,   485,   486,   487,     0,     0,   488,   489,
     490,   491,   492,   493,   494,     0,   495,   766,   496,   497,
     498,   499,     0,     0,   500,     0,     0,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   787,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   211,   212,   213,   214,
     215,   216,   217,   218,   814,   220,   221,   222,     0,     0,
       0,     0,   223,     0,     0,     0,   224,   225,     0,   226,
     227,   745,   228,   229,   230,   231,   232,   746,   233,   234,
       0,   235,   236,   237,   238,   239,     0,     0,   240,   241,
     242,   243,   244,     0,   245,   246,   247,   248,   249,     0,
     747,     0,   250,   251,   252,   253,   748,   254,   255,     0,
     256,   257,   258,   259,   260,   261,     0,   749,   262,   263,
       0,     0,     0,   750,     0,     0,     0,   264,   265,   266,
     267,   268,   269,   270,   271,   272,     0,   273,     0,   274,
     275,   276,   277,   278,     0,   279,   280,   281,     0,     0,
     282,   283,   284,   285,   286,     0,   287,   288,   289,     0,
     290,   291,   292,     0,   293,   294,   295,   296,   297,   298,
     299,   300,   301,     0,   302,     0,   303,   304,   305,   306,
       0,   307,     0,   308,   751,     0,   752,   309,   310,   311,
       0,   312,   313,     0,   314,     0,   315,   316,   317,   318,
     319,   753,   320,   321,   322,     0,   323,   324,   325,   326,
     327,   328,     0,   329,   754,   330,   331,   332,   333,   334,
     335,   336,     0,   337,     0,   338,   755,   756,   339,   757,
     340,   341,   342,   343,   344,     0,   345,   346,     0,   347,
     348,   758,   349,   759,     0,   350,   351,   352,     0,     0,
     353,   354,   355,   356,   357,   358,   359,   360,   361,   362,
     363,   364,   365,   366,   760,   367,   368,   369,   370,     0,
     371,   372,   761,   373,     0,   374,   375,   376,   377,   378,
     379,     0,   380,     0,     0,   381,   382,   383,     0,     0,
     384,   385,   762,   386,   763,   387,   388,   389,   390,   391,
     392,   393,   394,     0,   395,   396,   397,   398,   399,   400,
     401,     0,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,     0,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,     0,   426,   427,
     764,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,     0,   439,   440,   441,   442,   443,     0,   444,
     445,   446,   447,   765,   448,   449,   450,     0,   451,   452,
     453,   454,   455,   456,   457,   458,   459,   460,   461,     0,
     462,   463,     0,   464,   465,   466,   467,   468,   469,     0,
     470,   471,     0,     0,   472,   473,   474,   475,     0,   476,
     477,   478,   479,   480,   481,   482,     0,     0,   483,   484,
     485,   486,   487,     0,     0,   488,   489,   490,   491,   492,
     493,   494,     0,   495,   766,   496,   497,   498,   499,     0,
       0,   500,     0,     0,   501,   502,   503,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
     517,   518,   787,     0,   574,     0,     0,     0,     0,     0,
       0,     0,     0,   211,   212,   213,   214,   215,   216,   217,
     218,     0,   220,   221,   222,     0,     0,     0,     0,   223,
       0,     0,     0,   224,   225,     0,   226,   227,   745,   228,
     229,   230,   231,   232,   746,   233,   234,     0,   235,   236,
     237,   238,   239,     0,     0,   240,   241,   242,   243,   244,
       0,   245,   246,   247,   248,   249,     0,   747,     0,   250,
     251,   252,   253,   748,   254,   255,     0,   256,   257,   258,
     259,   260,   261,     0,   749,   262,   263,     0,     0,     0,
     750,     0,     0,     0,   264,   265,   266,   267,   268,   269,
     270,   271,   272,     0,   273,     0,   274,   275,   276,   277,
     278,     0,   279,   280,   281,     0,     0,   282,   283,   284,
     285,   286,     0,   287,   288,   289,     0,   290,   291,   292,
       0,   293,   294,   295,   296,   297,   298,   299,   300,   301,
       0,   302,     0,   303,   304,   305,   306,     0,   307,     0,
     308,   751,     0,   752,   309,   310,   311,     0,   312,   313,
       0,   314,     0,   315,   316,   317,   318,   319,   753,   320,
     321,   322,     0,   323,   324,   325,   326,   327,   328,     0,
     329,   754,   330,   331,   332,   333,   334,   335,   336,     0,
     337,     0,   338,   755,   756,   339,   757,   340,   341,   342,
     343,   344,     0,   345,   346,     0,   347,   348,   758,   349,
     759,     0,   350,   351,   352,     0,     0,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   760,   367,   368,   369,   370,     0,   371,   372,   761,
     373,     0,   374,   375,   376,   377,   378,   379,     0,   380,
       0,     0,   381,   382,   383,     0,     0,   384,   385,   762,
     386,   763,   387,   388,   389,   390,   391,   392,   393,   394,
       0,   395,   396,   397,   398,   399,   400,   401,     0,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,     0,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,     0,   426,   427,   764,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,     0,
     439,   440,   441,   442,   443,     0,   444,   445,   446,   447,
     765,   448,   449,   450,     0,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,     0,   462,   463,     0,
     464,   465,   466,   467,   468,   469,     0,   470,   471,     0,
       0,   472,   473,   474,   475,     0,   476,   477,   478,   479,
     480,   481,   482,     0,     0,   483,   484,   485,   486,   487,
       0,     0,   488,   489,   490,   491,   492,   493,   494,     0,
     495,   766,   496,   497,   498,   499,     0,     0,   500,     0,
       0,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   787,
       0,   574,     0,     0,     0,     0,     0,     0,     0,     0,
     211,   212,   213,   214,   215,   216,   217,   218,     0,   220,
     221,   222,     0,     0,     0,     0,   223,     0,     0,     0,
     224,   225,     0,   226,   227,   745,   228,   229,   230,   231,
     232,   746,   233,   234,     0,   235,   236,   237,   238,   239,
       0,     0,   240,   241,   242,   243,   244,     0,   245,   246,
     247,   248,   249,     0,   747,     0,   250,   251,   252,   253,
     748,   254,   255,     0,   256,   257,   258,   259,   260,   261,
       0,   749,   262,   263,     0,     0,     0,   750,     0,     0,
       0,   264,   265,   266,   267,   268,   269,   270,   271,   272,
       0,   273,     0,   274,   275,   276,   277,   278,     0,   279,
     280,   281,     0,     0,   282,   283,   284,   285,   286,     0,
     287,   288,   289,     0,   290,   291,   292,     0,   293,   294,
     295,   296,   297,   298,   299,   300,   301,     0,   302,     0,
     303,   304,   305,   306,     0,   307,     0,   308,   751,     0,
     752,   309,   310,   311,     0,   312,   313,     0,   314,     0,
     315,   316,   317,   318,  1526,   753,   320,   321,   322,     0,
     323,   324,   325,   326,   327,   328,     0,   329,   754,   330,
     331,   332,   333,   334,   335,   336,     0,   337,     0,   338,
     755,   756,   339,   757,   340,   341,   342,   343,   344,     0,
     345,   346,     0,   347,   348,   758,   349,   759,     0,   350,
     351,   352,     0,     0,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,   365,   366,   760,   367,
     368,   369,   370,     0,   371,   372,   761,   373,     0,   374,
     375,   376,   377,   378,   379,     0,   380,     0,     0,   381,
     382,   383,     0,     0,   384,   385,   762,   386,   763,   387,
     388,   389,   390,   391,   392,   393,   394,     0,   395,   396,
     397,   398,   399,   400,   401,     0,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,     0,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,     0,   426,   427,   764,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,   438,     0,   439,   440,   441,
     442,   443,     0,   444,   445,   446,   447,   765,   448,   449,
     450,     0,   451,   452,   453,   454,   455,   456,   457,   458,
     459,   460,   461,     0,   462,   463,     0,   464,   465,   466,
     467,   468,   469,     0,   470,   471,     0,     0,   472,   473,
     474,   475,     0,   476,   477,   478,   479,   480,   481,   482,
       0,     0,   483,   484,   485,   486,   487,     0,     0,   488,
     489,   490,   491,   492,   493,   494,     0,   495,   766,   496,
     497,   498,   499,     0,     0,   500,     0,     0,   501,   502,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
     513,   514,   515,   516,   517,   518,   787,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   211,   212,   213,
     214,   215,   216,   217,   218,     0,   220,   221,   222,     0,
       0,     0,     0,   223,     0,     0,     0,   224,   225,     0,
     226,   227,   745,   228,   229,   230,   231,   232,   746,   233,
     234,     0,   235,   236,   237,   238,   239,     0,     0,   240,
     241,   242,   243,   244,     0,   245,   246,   247,   248,   249,
       0,   747,     0,   250,   251,   252,   253,   748,   254,   255,
       0,   256,   257,   258,   259,   260,   261,     0,   749,   262,
     263,     0,     0,     0,   750,     0,     0,     0,   264,   265,
     266,   267,   268,   269,   270,   271,   272,     0,   273,     0,
     274,   275,   276,   277,   278,     0,   279,   280,   281,     0,
       0,   282,   283,   284,   285,   286,     0,   287,   288,   289,
       0,   290,   291,   292,     0,   293,   294,   295,   296,   297,
     298,   299,   300,   301,     0,   302,     0,   303,   304,   305,
     306,     0,   307,     0,   308,   751,     0,   752,   309,   310,
     311,     0,   312,   313,  2934,   314,     0,   315,   316,   317,
     318,   319,   753,   320,   321,   322,     0,   323,   324,   325,
     326,   327,   328,     0,   329,   754,   330,   331,   332,   333,
     334,   335,   336,     0,   337,     0,   338,   755,   756,   339,
     757,   340,   341,   342,   343,   344,     0,   345,   346,     0,
     347,   348,   758,   349,   759,     0,   350,   351,   352,     0,
       0,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   366,   760,   367,   368,   369,   370,
       0,   371,   372,   761,   373,     0,   374,   375,   376,   377,
     378,   379,     0,   380,     0,     0,   381,   382,   383,     0,
       0,   384,   385,   762,   386,   763,   387,   388,   389,   390,
     391,   392,   393,   394,     0,   395,   396,   397,   398,   399,
     400,   401,     0,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,     0,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,     0,   426,
     427,   764,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,     0,   439,   440,   441,   442,   443,     0,
     444,   445,   446,   447,   765,   448,   449,   450,     0,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,   461,
       0,   462,   463,     0,   464,   465,   466,   467,   468,   469,
       0,   470,   471,     0,     0,   472,   473,   474,   475,     0,
     476,   477,   478,   479,   480,   481,   482,     0,     0,   483,
     484,   485,   486,   487,     0,     0,   488,   489,   490,   491,
     492,   493,   494,     0,   495,   766,   496,   497,   498,   499,
       0,     0,   500,     0,     0,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   744,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   211,   212,   213,   214,   215,   216,
     217,   218,     0,   220,   221,   222,     0,     0,     0,     0,
     223,     0,     0,     0,   224,   225,     0,   226,   227,   745,
     228,   229,   230,   231,   232,   746,   233,   234,     0,   235,
     236,   237,   238,   239,     0,     0,   240,   241,   242,   243,
     244,     0,   245,   246,   247,   248,   249,     0,   747,     0,
     250,   251,   252,   253,   748,   254,   255,     0,   256,   257,
     258,   259,   260,   261,     0,   749,   262,   263,     0,     0,
       0,   750,     0,     0,     0,   264,   265,   266,   267,   268,
     269,   270,   271,   272,     0,   273,     0,   274,   275,   276,
     277,   278,     0,   279,   280,   281,     0,     0,   282,   283,
     284,   285,   286,     0,   287,   288,   289,     0,   290,   291,
     292,     0,   293,   294,   295,   296,   297,   298,   299,   300,
     301,     0,   302,     0,   303,   304,   305,   306,     0,   307,
       0,   308,   751,     0,   752,   309,   310,   311,     0,   312,
     313,     0,   314,     0,   315,   316,   317,   318,   319,   753,
     320,   321,   322,     0,   323,   324,   325,   326,   327,   328,
       0,   329,   754,   330,   331,   332,   333,   334,   335,   336,
       0,   337,     0,   338,   755,   756,   339,   757,   340,   341,
     342,   343,   344,     0,   345,   346,     0,   347,   348,   758,
     349,   759,     0,   350,   351,   352,     0,     0,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   760,   367,   368,   369,   370,     0,   371,   372,
     761,   373,     0,   374,   375,   376,   377,   378,   379,     0,
     380,     0,     0,   381,   382,   383,     0,     0,   384,   385,
     762,   386,   763,   387,   388,   389,   390,   391,   392,   393,
     394,     0,   395,   396,   397,   398,   399,   400,   401,     0,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,     0,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,     0,   426,   427,   764,   428,
     429,   430,   431,   432,   433,   434,   435,   436,   437,   438,
       0,   439,   440,   441,   442,   443,     0,   444,   445,   446,
     447,   765,   448,   449,   450,     0,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,     0,   462,   463,
       0,   464,   465,   466,   467,   468,   469,     0,   470,   471,
       0,     0,   472,   473,   474,   475,     0,   476,   477,   478,
     479,   480,   481,   482,     0,     0,   483,   484,   485,   486,
     487,     0,     0,   488,   489,   490,   491,   492,   493,   494,
       0,   495,   766,   496,   497,   498,   499,     0,     0,   500,
       0,     0,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
     787,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   211,   212,   213,   214,   215,   216,   217,   218,     0,
     220,   221,   222,     0,     0,     0,     0,   223,     0,     0,
       0,   224,   225,     0,   226,   227,   745,   228,   229,   230,
     231,   232,   746,   233,   234,     0,   235,   236,   237,   238,
     239,     0,     0,   240,   241,   242,   243,   244,     0,   245,
     246,   247,   248,   249,     0,   747,     0,   250,   251,   252,
     253,   748,   254,   255,     0,   256,   257,   258,   259,   260,
     261,     0,   749,   262,   263,     0,     0,     0,   750,     0,
       0,     0,   264,   265,   266,   267,   268,   269,   270,   271,
     272,     0,   273,     0,   274,   275,   276,   277,   278,     0,
     279,   280,   281,     0,     0,   282,   283,   284,   285,   286,
       0,   287,   288,   289,     0,   290,   291,   292,     0,   293,
     294,   295,   296,   297,   298,   299,   300,   301,     0,   302,
       0,   303,   304,   305,   306,     0,   307,     0,   308,   751,
       0,   752,   309,   310,   311,     0,   312,   313,     0,   314,
       0,   315,   316,   317,   318,   319,   753,   320,   321,   322,
       0,   323,   324,   325,   326,   327,   328,     0,   329,   754,
     330,   331,   332,   333,   334,   335,   336,     0,   337,     0,
     338,   755,   756,   339,   757,   340,   341,   342,   343,   344,
       0,   345,   346,     0,   347,   348,   758,   349,   759,     0,
     350,   351,   352,     0,     0,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   366,   760,
     367,   368,   369,   370,     0,   371,   372,   761,   373,     0,
     374,   375,   376,   377,   378,   379,     0,   380,     0,     0,
     381,   382,   383,     0,     0,   384,   385,   762,   386,   763,
     387,   388,   389,   390,   391,   392,   393,   394,     0,   395,
     396,   397,   398,   399,   400,   401,     0,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
       0,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,     0,   426,   427,   764,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,     0,   439,   440,
     441,   442,   443,     0,   444,   445,   446,   447,   765,   448,
     449,   450,     0,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,   461,     0,   462,   463,     0,   464,   465,
     466,   467,   468,   469,     0,   470,   471,     0,     0,   472,
     473,   474,   475,     0,   476,   477,   478,   479,   480,   481,
     482,     0,     0,   483,   484,   485,   486,   487,     0,     0,
     488,   489,   490,   491,   492,   493,   494,     0,   495,   766,
     496,   497,   498,   499,     0,     0,   500,     0,     0,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,   516,   517,   518,   787,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   211,   212,
     213,   214,   215,   216,   217,   218,     0,   220,   221,   222,
       0,     0,     0,     0,   223,     0,     0,     0,   224,   225,
       0,   226,   227,   745,   228,   229,   230,   231,   232,   746,
     233,   234,     0,   235,   236,   237,   238,   239,     0,     0,
     240,   241,   242,   243,   244,     0,   245,   246,   247,   248,
     249,     0,   747,     0,   250,   251,   252,   253,   748,   254,
     255,     0,   256,   257,   258,   259,   260,   261,     0,   749,
     262,   263,     0,     0,     0,   750,     0,     0,     0,   264,
     265,   266,   267,   268,   269,   270,   271,   272,     0,   273,
       0,   274,   275,   276,   277,   278,     0,   279,   280,   281,
       0,     0,   282,   283,   284,   285,   286,     0,   287,   288,
     289,     0,   290,   291,   292,     0,   293,   294,   295,   296,
     297,   298,   299,   300,   301,     0,   302,     0,   303,   304,
     305,   306,     0,   307,     0,   308,   751,     0,   752,   309,
     310,   311,     0,   312,   313,     0,   314,     0,   315,   316,
     317,   318,   319,   753,   320,   321,   322,     0,   323,   324,
     325,   326,   327,   328,     0,   329,   754,   330,   331,   332,
     333,   334,   335,   336,     0,   337,     0,   338,   755,   756,
     339,   757,   340,   341,   342,   343,   344,     0,   345,   346,
       0,   347,   348,   758,   349,   759,     0,   350,   351,   352,
       0,     0,   353,   354,   830,   356,   357,   358,   359,   360,
     361,   362,   363,   364,   365,   366,   760,   367,   368,   369,
     370,     0,   371,   372,   761,   373,     0,   374,   375,   376,
     377,   378,   379,     0,   380,     0,     0,   381,   382,   383,
       0,     0,   384,   385,   762,   386,   763,   387,   388,   389,
     390,   391,   392,   393,   394,     0,   395,   396,   397,   398,
     399,   400,   401,     0,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,     0,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,     0,
     426,   427,   764,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,     0,   439,   440,   441,   442,   443,
       0,   444,   445,   446,   447,   765,   448,   449,   450,     0,
     451,   452,   453,   454,   455,   456,   457,   458,   459,   460,
     461,     0,   462,   463,     0,   464,   465,   466,   467,   468,
     469,     0,   470,   471,     0,     0,   472,   473,   474,   475,
       0,   476,   477,   478,   479,   480,   481,   482,     0,     0,
     483,   484,   485,   486,   487,     0,     0,   488,   489,   490,
     491,   492,   493,   494,     0,   495,   766,   496,   497,   498,
     499,     0,     0,   500,     0,     0,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   787,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   211,   212,   213,   214,   215,
     216,   217,   218,     0,   220,   221,   222,     0,     0,     0,
       0,   223,     0,     0,     0,   224,   225,     0,   226,   227,
     745,   228,   229,   230,   231,   232,   746,   233,   234,     0,
     235,   236,   237,   238,   239,     0,     0,   240,   241,   242,
     243,   244,     0,   245,   246,   247,   248,   249,     0,   747,
       0,   250,   251,   252,   253,   748,   254,   255,     0,   256,
     257,   258,   259,   260,   261,     0,   749,   262,   263,     0,
       0,     0,   750,     0,     0,     0,   264,   265,   266,   267,
     268,   269,   270,   271,   272,     0,   273,     0,   274,   275,
     276,   277,   278,     0,   279,   280,   281,     0,     0,   282,
     283,   284,   285,   286,     0,   287,   288,   289,     0,   290,
     291,   292,     0,   293,   294,   295,   296,   297,   298,   299,
     300,   301,     0,   302,     0,   303,   304,   305,   306,     0,
     307,     0,   308,   751,     0,   752,   309,   310,   311,     0,
     312,   313,     0,   314,     0,   315,   316,   317,   318,   319,
     753,   320,   321,   322,     0,   323,   324,   325,   326,   327,
     328,     0,   329,   754,   330,   331,   332,   333,   334,   335,
     336,     0,   337,     0,   338,   755,   756,   339,   757,   340,
     341,   342,   343,   344,     0,   345,   346,     0,   347,   348,
     758,   349,   759,     0,   350,   351,   352,     0,     0,   353,
     354,   907,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   760,   367,   368,   369,   370,     0,   371,
     372,   761,   373,     0,   374,   375,   376,   377,   378,   379,
       0,   380,     0,     0,   381,   382,   383,     0,     0,   384,
     385,   762,   386,   763,   387,   388,   389,   390,   391,   392,
     393,   394,     0,   395,   396,   397,   398,   399,   400,   401,
       0,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,     0,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,     0,   426,   427,   764,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,     0,   439,   440,   441,   442,   443,     0,   444,   445,
     446,   447,   765,   448,   449,   450,     0,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,     0,   462,
     463,     0,   464,   465,   466,   467,   468,   469,     0,   470,
     471,     0,     0,   472,   473,   474,   475,     0,   476,   477,
     478,   479,   480,   481,   482,     0,     0,   483,   484,   485,
     486,   487,     0,     0,   488,   489,   490,   491,   492,   493,
     494,     0,   495,   766,   496,   497,   498,   499,     0,     0,
     500,     0,     0,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,   516,   517,
     518,   744,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   211,   212,   213,   214,   215,   216,   217,   218,
       0,   220,   221,   222,     0,     0,     0,     0,   223,     0,
       0,     0,   224,   225,     0,   226,   227,   745,   228,   229,
     230,   231,   232,   746,   233,   234,     0,   235,   236,   237,
     238,   239,     0,     0,   240,   241,   242,   243,   244,     0,
     245,   246,   247,   248,   249,     0,   747,     0,   250,   251,
     252,   253,   748,   254,   255,     0,   256,   257,   258,   259,
     260,   261,     0,   749,   262,   263,     0,     0,     0,   750,
       0,     0,     0,   264,   265,   266,   267,   268,   269,   270,
     271,   272,     0,   273,     0,   274,   275,   276,   277,   278,
       0,   279,   280,   281,     0,     0,   282,   283,   284,   285,
     286,     0,   287,   288,   289,     0,   290,   291,   292,     0,
     293,   294,   295,   296,   297,   298,   299,   300,   301,     0,
     302,     0,   303,   304,   305,   306,     0,   307,     0,   308,
     751,     0,   752,   309,   310,   311,     0,   312,   313,     0,
     314,     0,   315,   316,   317,   318,   927,   753,   320,   321,
     322,     0,   323,   324,   325,   326,   327,   328,     0,   329,
     754,   330,   331,   332,   333,   334,   335,   336,     0,   337,
       0,   338,   755,   756,   339,   757,   340,   341,   342,   343,
     344,     0,   345,   346,     0,   347,   348,   758,   349,   759,
       0,   350,   351,   352,     0,     0,   353,   354,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,   366,
     760,   367,   368,   369,   370,     0,   371,   372,   761,   373,
       0,   374,   375,   376,   377,   378,   379,     0,   380,     0,
       0,   381,   382,   383,     0,     0,   384,   385,   762,   386,
     763,   387,   388,   389,   390,   391,   392,   393,   394,     0,
     395,   396,   397,   398,   399,   400,   401,     0,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,     0,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,     0,   426,   427,   764,   428,   429,   430,
     431,   432,   433,   434,   435,   436,   437,   438,     0,   439,
     440,   441,   442,   443,     0,   444,   445,   446,   447,   765,
     448,   449,   450,     0,   451,   452,   453,   454,   455,   456,
     457,   458,   459,   460,   461,     0,   462,   463,     0,   464,
     465,   466,   467,   468,   469,     0,   470,   471,     0,     0,
     472,   473,   474,   475,     0,   476,   477,   478,   479,   480,
     481,   482,     0,     0,   483,   484,   485,   486,   487,     0,
       0,   488,   489,   490,   491,   492,   493,   494,     0,   495,
     766,   496,   497,   498,   499,     0,     0,   500,     0,     0,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,   513,   514,   515,   516,   517,   518,   744,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   211,
     212,   213,   214,   215,   216,   217,   218,     0,   220,   221,
     222,     0,     0,     0,     0,   223,     0,     0,     0,   224,
     225,     0,   226,   227,   745,   228,   229,   230,   231,   232,
     746,   233,   234,     0,   235,   236,   237,   238,   239,     0,
       0,   240,   241,   242,   243,   244,     0,   245,   246,   247,
     248,   249,     0,   747,     0,   250,   251,   252,   253,   748,
     254,   255,     0,   256,   257,   258,   259,   260,   261,     0,
     749,   262,   263,     0,     0,     0,   750,     0,     0,     0,
     264,   265,   266,   267,   268,   269,   270,   271,   272,     0,
     273,     0,   274,   275,   276,   277,   278,     0,   279,   280,
     281,     0,     0,   282,   283,   284,   285,   286,     0,   287,
     288,   289,     0,   290,   291,   292,     0,   293,   294,   295,
     296,   297,   298,   299,   300,   301,     0,   302,     0,   303,
     304,   305,   306,     0,   307,     0,   308,   751,     0,   752,
     309,   310,   311,     0,   312,   313,     0,   314,     0,   315,
     316,   317,   318,   937,   753,   320,   321,   322,     0,   323,
     324,   325,   326,   327,   328,     0,   329,   754,   330,   331,
     332,   333,   334,   335,   336,     0,   337,     0,   338,   755,
     756,   339,   757,   340,   341,   342,   343,   344,     0,   345,
     346,     0,   347,   348,   758,   349,   759,     0,   350,   351,
     352,     0,     0,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   760,   367,   368,
     369,   370,     0,   371,   372,   761,   373,     0,   374,   375,
     376,   377,   378,   379,     0,   380,     0,     0,   381,   382,
     383,     0,     0,   384,   385,   762,   386,   763,   387,   388,
     389,   390,   391,   392,   393,   394,     0,   395,   396,   397,
     398,   399,   400,   401,     0,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,     0,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
       0,   426,   427,   764,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,     0,   439,   440,   441,   442,
     443,     0,   444,   445,   446,   447,   765,   448,   449,   450,
       0,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,     0,   462,   463,     0,   464,   465,   466,   467,
     468,   469,     0,   470,   471,     0,     0,   472,   473,   474,
     475,     0,   476,   477,   478,   479,   480,   481,   482,     0,
       0,   483,   484,   485,   486,   487,     0,     0,   488,   489,
     490,   491,   492,   493,   494,     0,   495,   766,   496,   497,
     498,   499,     0,     0,   500,     0,     0,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   787,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   211,   212,   213,   214,
     215,   216,   217,   218,     0,   220,   221,   222,     0,     0,
       0,     0,   223,     0,     0,     0,   224,   225,     0,   226,
     227,   745,   228,   229,   230,   231,   232,   746,   233,   234,
       0,   235,   236,   237,   238,   239,     0,     0,   240,   241,
     242,   243,   244,     0,   245,   246,   247,   248,   249,     0,
     747,     0,   250,   251,   252,   253,   748,   254,   255,     0,
     256,   257,   258,   259,   260,   261,     0,   749,   262,   263,
       0,     0,     0,   750,     0,     0,     0,   264,   265,   266,
     267,   268,   269,   270,   271,   272,     0,   273,     0,   274,
     275,   276,   277,   278,     0,   279,   280,   281,     0,     0,
     282,   283,   284,   285,   286,     0,   287,   288,   289,     0,
     290,   291,   292,     0,   293,   294,   295,   296,   297,   298,
     299,   300,   301,     0,   302,     0,   303,   304,   305,   306,
       0,   307,     0,   308,   751,     0,   752,   309,   310,   311,
       0,   312,   313,     0,   314,     0,   315,   316,   317,   318,
     939,   753,   320,   321,   322,     0,   323,   324,   325,   326,
     327,   328,     0,   329,   754,   330,   331,   332,   333,   334,
     335,   336,     0,   337,     0,   338,   755,   756,   339,   757,
     340,   341,   342,   343,   344,     0,   345,   346,     0,   347,
     348,   758,   349,   759,     0,   350,   351,   352,     0,     0,
     353,   354,   355,   356,   357,   358,   359,   360,   361,   362,
     363,   364,   365,   366,   760,   367,   368,   369,   370,     0,
     371,   372,   761,   373,     0,   374,   375,   376,   377,   378,
     379,     0,   380,     0,     0,   381,   382,   383,     0,     0,
     384,   385,   762,   386,   763,   387,   388,   389,   390,   391,
     392,   393,   394,     0,   395,   396,   397,   398,   399,   400,
     401,     0,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,     0,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,     0,   426,   427,
     764,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,     0,   439,   440,   441,   442,   443,     0,   444,
     445,   446,   447,   765,   448,   449,   450,     0,   451,   452,
     453,   454,   455,   456,   457,   458,   459,   460,   461,     0,
     462,   463,     0,   464,   465,   466,   467,   468,   469,     0,
     470,   471,     0,     0,   472,   473,   474,   475,     0,   476,
     477,   478,   479,   480,   481,   482,     0,     0,   483,   484,
     485,   486,   487,     0,     0,   488,   489,   490,   491,   492,
     493,   494,     0,   495,   766,   496,   497,   498,   499,     0,
       0,   500,     0,     0,   501,   502,   503,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
     517,   518,   787,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   211,   212,   213,   214,   215,   216,   217,
     218,     0,   220,   221,   222,     0,     0,     0,     0,   223,
       0,     0,     0,   224,   225,     0,   226,   227,   745,   228,
     229,   230,   231,   232,   746,   233,   234,     0,   235,   236,
     237,   238,   239,     0,     0,   240,   241,   242,   243,   244,
       0,   245,   246,   247,   248,   249,     0,   747,     0,   250,
     251,   252,   253,   748,   254,   255,     0,   256,   257,   258,
     259,   260,   261,     0,   749,   262,   263,     0,     0,     0,
     750,     0,     0,     0,   264,   265,   266,   267,   268,   269,
     270,   271,   272,     0,   273,     0,   274,   275,   276,   277,
     278,     0,   279,   280,   281,     0,     0,   282,   283,   284,
     285,   286,     0,   287,   288,   289,     0,   290,   291,   292,
       0,   293,   294,   295,   296,   297,   298,   299,   300,   301,
       0,   302,     0,   303,   304,   305,   306,     0,   307,     0,
     308,   751,     0,   752,   309,   310,   311,     0,   312,   313,
       0,   314,     0,   315,   316,   317,   318,   949,   753,   320,
     321,   322,     0,   323,   324,   325,   326,   327,   328,     0,
     329,   754,   330,   331,   332,   333,   334,   335,   336,     0,
     337,     0,   338,   755,   756,   339,   757,   340,   341,   342,
     343,   344,     0,   345,   346,     0,   347,   348,   758,   349,
     759,     0,   350,   351,   352,     0,     0,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   760,   367,   368,   369,   370,     0,   371,   372,   761,
     373,     0,   374,   375,   376,   377,   378,   379,     0,   380,
       0,     0,   381,   382,   383,     0,     0,   384,   385,   762,
     386,   763,   387,   388,   389,   390,   391,   392,   393,   394,
       0,   395,   396,   397,   398,   399,   400,   401,     0,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,     0,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,     0,   426,   427,   764,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,     0,
     439,   440,   441,   442,   443,     0,   444,   445,   446,   447,
     765,   448,   449,   450,     0,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,     0,   462,   463,     0,
     464,   465,   466,   467,   468,   469,     0,   470,   471,     0,
       0,   472,   473,   474,   475,     0,   476,   477,   478,   479,
     480,   481,   482,     0,     0,   483,   484,   485,   486,   487,
       0,     0,   488,   489,   490,   491,   492,   493,   494,     0,
     495,   766,   496,   497,   498,   499,     0,     0,   500,     0,
       0,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   787,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     211,   212,   213,   214,   215,   216,   217,   218,     0,   220,
     221,   222,     0,     0,     0,     0,   223,     0,     0,     0,
     224,   225,     0,   226,   227,   745,   228,   229,   230,   231,
     232,   746,   233,   234,     0,   235,   236,   237,   238,   239,
       0,     0,   240,   241,   242,   243,   244,     0,   245,   246,
     247,   248,   249,     0,   747,     0,   250,   251,   252,   253,
     748,   254,   255,     0,   256,   257,   258,   259,   260,   261,
       0,   749,   262,   263,     0,     0,     0,   750,     0,     0,
       0,   264,   265,   266,   267,   268,   269,   270,   271,   272,
       0,   273,     0,   274,   275,   276,   277,   278,     0,   279,
     280,   281,     0,     0,   282,   283,   284,   285,   286,     0,
     287,   288,   289,     0,   290,   291,   292,     0,   293,   294,
     295,   296,   297,   298,   299,   300,   301,     0,   302,     0,
     303,   304,   305,   306,     0,   307,     0,   308,   751,     0,
     752,   309,   310,   311,     0,   312,   313,     0,   314,     0,
     315,   316,   317,   318,   960,   753,   320,   321,   322,     0,
     323,   324,   325,   326,   327,   328,     0,   329,   754,   330,
     331,   332,   333,   334,   335,   336,     0,   337,     0,   338,
     755,   756,   339,   757,   340,   341,   342,   343,   344,     0,
     345,   346,     0,   347,   348,   758,   349,   759,     0,   350,
     351,   352,     0,     0,   353,   354,   961,   356,   357,   358,
     359,   360,   361,   362,   363,   364,   365,   366,   760,   367,
     368,   369,   370,     0,   371,   372,   761,   373,     0,   374,
     375,   376,   377,   378,   379,     0,   380,     0,     0,   381,
     382,   383,     0,     0,   384,   385,   762,   386,   763,   387,
     388,   389,   390,   391,   392,   393,   394,     0,   395,   396,
     397,   398,   399,   400,   401,     0,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,     0,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,     0,   426,   427,   764,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,   438,     0,   439,   440,   441,
     442,   443,     0,   444,   445,   446,   447,   765,   448,   449,
     450,     0,   451,   452,   453,   454,   455,   456,   457,   458,
     459,   460,   461,     0,   462,   463,     0,   464,   465,   466,
     467,   468,   469,     0,   470,   471,     0,     0,   472,   473,
     474,   475,     0,   476,   477,   478,   479,   480,   481,   482,
       0,     0,   483,   484,   485,   486,   487,     0,     0,   488,
     489,   490,   491,   492,   493,   494,     0,   495,   766,   496,
     497,   498,   499,     0,     0,   500,     0,     0,   501,   502,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
     513,   514,   515,   516,   517,   518,   210,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   211,   212,   213,
     214,   215,   216,   217,   218,     0,   220,   221,   222,     0,
       0,     0,     0,   223,     0,     0,     0,   224,   225,     0,
     226,   227,     0,   228,   229,   230,   231,   232,     0,   233,
     234,     0,   235,   236,   237,   238,   239,     0,     0,   240,
     241,   242,   243,   244,  1914,   245,   246,   247,   248,   249,
       0,     0,  1987,   250,   251,   252,   253,     0,   254,   255,
    1915,   256,   257,   258,   259,   260,   261,     0,     0,   262,
     263,     0,     0,     0,     0,     0,     0,     0,   264,   265,
     266,   267,   268,   269,   270,   271,   272,     0,   273,     0,
     274,   275,   276,   277,   278,     0,   279,   280,   281,     0,
       0,   282,   283,   284,   285,   286,     0,   287,   288,   289,
       0,   290,   291,   292,     0,  1988,   294,   295,   296,   297,
     298,   299,   300,   301,     0,   302,     0,   303,   304,   305,
     306,     0,   307,  1917,   308,     0,     0,     0,   309,   310,
     311,     0,   312,   313,     0,   314,     0,   315,   316,   317,
     318,   319,     0,   320,   321,   322,     0,   323,   324,   325,
     326,   327,   328,     0,   329,     0,   330,   331,   332,   333,
     334,   335,   336,     0,   337,     0,   338,     0,     0,   339,
       0,   340,   341,   342,   343,   344,     0,   345,   346,     0,
     347,   348,     0,   349,     0,     0,   350,   351,   352,     0,
       0,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   366,     0,   367,   368,   369,   370,
       0,   371,   372,     0,   373,     0,   374,   375,   376,   377,
     378,   379,     0,   380,     0,     0,   381,   382,   383,     0,
       0,   384,   385,     0,   386,     0,   387,   388,   389,   390,
     391,   392,   393,   394,     0,   395,   396,   397,   398,   399,
     400,   401,  1918,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,     0,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,     0,   426,
     427,     0,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,     0,   439,   440,   441,   442,   443,     0,
     444,   445,   446,   447,     0,   448,   449,   450,     0,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,   461,
       0,   462,   463,     0,   464,   465,   466,   467,   468,   469,
       0,   470,   471,     0,     0,   472,   473,   474,   475,     0,
     476,   477,   478,   479,   480,   481,   482,     0,  1919,   483,
     484,   485,   486,   487,     0,     0,   488,   489,   490,   491,
     492,   493,   494,     0,   495,     0,   496,   497,   498,   499,
       0,     0,   500,     0,     0,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   210,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   211,   212,   213,   214,   215,   216,
     217,   218,     0,   220,   221,   222,     0,     0,     0,     0,
     223,     0,     0,     0,   224,   225,     0,   226,   227,     0,
     228,   229,   230,   231,   232,     0,   233,   234,     0,   235,
     236,   237,   238,   239,     0,     0,   240,   241,   242,   243,
     244,  1914,   245,   246,   247,   248,   249,     0,     0,     0,
     250,   251,   252,   253,     0,   254,   255,  1915,   256,   257,
     258,   259,   260,   261,     0,     0,   262,   263,     0,     0,
       0,     0,     0,     0,     0,   264,   265,   266,   267,   268,
     269,   270,   271,   272,     0,   273,     0,   274,   275,   276,
     277,   278,     0,   279,   280,   281,     0,     0,   282,   283,
     284,   285,   286,     0,   287,   288,   289,     0,   290,   291,
     292,     0,  1988,   294,   295,   296,   297,   298,   299,   300,
     301,     0,   302,     0,   303,   304,   305,   306,     0,   307,
    1917,   308,     0,     0,     0,   309,   310,   311,     0,   312,
     313,     0,   314,     0,   315,   316,   317,   318,   319,     0,
     320,   321,   322,     0,   323,   324,   325,   326,   327,   328,
       0,   329,     0,   330,   331,   332,   333,   334,   335,   336,
       0,   337,     0,   338,     0,     0,   339,     0,   340,   341,
     342,   343,   344,     0,   345,   346,     0,   347,   348,     0,
     349,  2834,     0,   350,   351,   352,     0,     0,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,     0,   367,   368,   369,   370,     0,   371,   372,
       0,   373,     0,   374,   375,   376,   377,   378,   379,     0,
     380,     0,     0,   381,   382,   383,     0,     0,   384,   385,
       0,   386,     0,   387,   388,   389,   390,   391,   392,   393,
     394,     0,   395,   396,   397,   398,   399,   400,   401,  1918,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,     0,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,     0,   426,   427,     0,   428,
     429,   430,   431,   432,   433,   434,   435,   436,   437,   438,
       0,   439,   440,   441,   442,   443,     0,   444,   445,   446,
     447,     0,   448,   449,   450,     0,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,     0,   462,   463,
       0,   464,   465,   466,   467,   468,   469,     0,   470,   471,
       0,     0,   472,   473,   474,   475,     0,   476,   477,   478,
     479,   480,   481,   482,     0,  1919,   483,   484,   485,   486,
     487,     0,     0,   488,   489,   490,   491,   492,   493,   494,
       0,   495,     0,   496,   497,   498,   499,     0,     0,   500,
       0,     0,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
     210,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   211,   212,   213,   214,   215,   678,   217,   218,   644,
     220,   221,   222,     0,     0,     0,     0,   223,     0,     0,
       0,   224,   225,     0,   226,   227,     0,   228,   229,   230,
     231,   232,     0,   233,   234,     0,   235,   236,   237,   238,
     239,     0,     0,   240,   241,   242,   243,   244,     0,   245,
     246,   247,   248,   249,     0,     0,     0,   250,   251,   252,
     253,     0,   254,   255,     0,   256,   257,   258,   259,   260,
     261,   645,     0,   262,   263,     0,     0,     0,     0,     0,
       0,     0,   264,   265,   266,   267,   268,   269,   270,   271,
     272,     0,   273,     0,   274,   275,   276,   277,   278,     0,
     279,   280,   281,     0,     0,   282,   283,   284,   285,   286,
       0,   287,   288,   289,     0,   290,   291,   292,     0,   293,
     294,   295,   296,   297,   298,   299,   300,   301,     0,   302,
       0,   303,   304,   305,   306,     0,   307,     0,   308,     0,
       0,     0,   309,   310,   311,   679,   312,   313,     0,   314,
       0,   315,   316,   317,   318,   319,     0,   320,   321,   322,
       0,   323,   324,   325,   326,   327,   328,     0,   329,     0,
     330,   331,   332,   333,   334,   335,   336,     0,   337,     0,
     338,     0,     0,   339,     0,   340,   341,   342,   343,   344,
       0,   345,   346,     0,   347,   348,     0,   349,     0,     0,
     350,   351,   352,     0,     0,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   366,     0,
     367,   368,   369,   370,     0,   371,   372,     0,   373,     0,
     374,   375,   376,   377,   378,   379,     0,   380,     0,     0,
     381,   382,   383,     0,     0,   384,   385,     0,   386,     0,
     387,   388,   389,   390,   391,   392,   393,   394,     0,   395,
     396,   397,   398,   399,   400,   401,     0,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     646,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,     0,   426,   427,     0,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,   647,   439,   440,
     441,   442,   443,     0,   444,   445,   446,   447,     0,   448,
     449,   450,     0,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,   461,     0,   462,   463,     0,   464,   465,
     466,   467,   468,   469,     0,   470,   471,     0,     0,   472,
     473,   474,   475,     0,   476,   477,   478,   479,   480,   481,
     482,     0,     0,   483,   484,   485,   486,   487,     0,     0,
     488,   489,   490,   491,   492,   493,   494,     0,   495,     0,
     496,   497,   498,   499,     0,     0,   500,     0,     0,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,   516,   517,   518,   210,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   211,   212,
     213,   214,   215,   216,   217,   218,   644,   220,   221,   222,
       0,     0,     0,     0,   223,     0,     0,     0,   224,   225,
       0,   226,   227,     0,   228,   229,   230,   231,   232,     0,
     233,   234,     0,   235,   236,   237,   238,   239,     0,     0,
     240,   241,   242,   243,   244,     0,   245,   246,   247,   248,
     249,     0,     0,     0,   250,   251,   252,   253,     0,   254,
     255,     0,   256,   257,   258,   259,   260,   261,   645,     0,
     262,   263,     0,     0,     0,     0,     0,     0,     0,   264,
     265,   266,   267,   268,   269,   270,   271,   272,     0,   273,
       0,   274,   275,   276,   277,   278,     0,   279,   280,   281,
       0,     0,   282,   283,   284,   285,   286,     0,   287,   288,
     289,     0,   290,   291,   292,     0,   293,   294,   295,   296,
     297,   298,   299,   300,   301,     0,   302,     0,   303,   304,
     305,   306,     0,   307,     0,   308,     0,     0,     0,   309,
     310,   311,  2564,   312,   313,     0,   314,     0,   315,   316,
     317,   318,   319,     0,   320,   321,   322,     0,   323,   324,
     325,   326,   327,   328,     0,   329,     0,   330,   331,   332,
     333,   334,   335,   336,     0,   337,     0,   338,     0,     0,
     339,     0,   340,   341,   342,   343,   344,     0,   345,   346,
       0,   347,   348,     0,   349,     0,     0,   350,   351,   352,
       0,     0,   353,   354,   355,   356,   357,   358,   359,   360,
     361,   362,   363,   364,   365,   366,     0,   367,   368,   369,
     370,     0,   371,   372,     0,   373,     0,   374,   375,   376,
     377,   378,   379,     0,   380,     0,     0,   381,   382,   383,
       0,     0,   384,   385,     0,   386,     0,   387,   388,   389,
     390,   391,   392,   393,   394,     0,   395,   396,   397,   398,
     399,   400,   401,     0,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   646,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,     0,
     426,   427,     0,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   647,   439,   440,   441,   442,   443,
       0,   444,   445,   446,   447,     0,   448,   449,   450,     0,
     451,   452,   453,   454,   455,   456,   457,   458,   459,   460,
     461,     0,   462,   463,     0,   464,   465,   466,   467,   468,
     469,     0,   470,   471,     0,     0,   472,   473,   474,   475,
       0,   476,   477,   478,   479,   480,   481,   482,     0,     0,
     483,   484,   485,   486,   487,     0,     0,   488,   489,   490,
     491,   492,   493,   494,     0,   495,     0,   496,   497,   498,
     499,     0,     0,   500,     0,     0,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   210,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   211,   212,   213,   214,   215,
     216,   217,   218,     0,   220,   221,   222,     0,     0,     0,
       0,   223,     0,     0,     0,   224,   225,     0,   226,   227,
       0,   228,   229,   230,   231,   232,     0,   233,   234,     0,
     235,   236,   237,   238,   239,     0,     0,   240,   241,   242,
     243,   244,  1914,   245,   246,   247,   248,   249,     0,     0,
       0,   250,   251,   252,   253,     0,   254,   255,  1915,   256,
     257,   258,   259,   260,   261,     0,     0,   262,   263,     0,
       0,     0,     0,     0,     0,     0,   264,   265,   266,   267,
     268,   269,   270,   271,   272,     0,   273,     0,   274,   275,
     276,   277,   278,     0,   279,   280,   281,     0,     0,   282,
     283,   284,   285,   286,     0,   287,   288,   289,     0,   290,
     291,   292,     0,  1988,   294,   295,   296,   297,   298,   299,
     300,   301,     0,   302,     0,   303,   304,   305,   306,     0,
     307,  1917,   308,     0,     0,     0,   309,   310,   311,     0,
     312,   313,     0,   314,     0,   315,   316,   317,   318,   319,
       0,   320,   321,   322,     0,   323,   324,   325,   326,   327,
     328,     0,   329,     0,   330,   331,   332,   333,   334,   335,
     336,     0,   337,     0,   338,     0,     0,   339,     0,   340,
     341,   342,   343,   344,     0,   345,   346,     0,   347,   348,
       0,   349,     0,     0,   350,   351,   352,     0,     0,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,     0,   367,   368,   369,   370,     0,   371,
     372,     0,   373,     0,   374,   375,   376,   377,   378,   379,
       0,   380,     0,     0,   381,   382,   383,     0,     0,   384,
     385,     0,   386,     0,   387,   388,   389,   390,   391,   392,
     393,   394,     0,   395,   396,   397,   398,   399,   400,   401,
    1918,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,     0,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,     0,   426,   427,     0,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,     0,   439,   440,   441,   442,   443,     0,   444,   445,
     446,   447,     0,   448,   449,   450,     0,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,     0,   462,
     463,     0,   464,   465,   466,   467,   468,   469,     0,   470,
     471,     0,     0,   472,   473,   474,   475,     0,   476,   477,
     478,   479,   480,   481,   482,     0,  1919,   483,   484,   485,
     486,   487,     0,     0,   488,   489,   490,   491,   492,   493,
     494,     0,   495,     0,   496,   497,   498,   499,     0,     0,
     500,     0,     0,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,   516,   517,
     518,   210,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   211,   212,   213,   214,   215,   216,   217,   218,
     644,   220,   221,   222,     0,     0,     0,     0,   223,     0,
       0,     0,   224,   225,     0,   226,   227,     0,   228,   229,
     230,   231,   232,     0,   233,   234,     0,   235,   236,   237,
     238,   239,     0,     0,   240,   241,   242,   243,   244,     0,
     245,   246,   247,   248,   249,     0,     0,     0,   250,   251,
     252,   253,     0,   254,   255,     0,   256,   257,   258,   259,
     260,   261,   645,     0,   262,   263,     0,     0,     0,     0,
       0,     0,     0,   264,   265,   266,   267,   268,   269,   270,
     271,   272,     0,   273,     0,   274,   275,   276,   277,   278,
       0,   279,   280,   281,     0,     0,   282,   283,   284,   285,
     286,     0,   287,   288,   289,     0,   290,   291,   292,     0,
     293,   294,   295,   296,   297,   298,   299,   300,   301,     0,
     302,     0,   303,   304,   305,   306,     0,   307,     0,   308,
       0,     0,     0,   309,   310,   311,     0,   312,   313,     0,
     314,     0,   315,   316,   317,   318,   319,     0,   320,   321,
     322,     0,   323,   324,   325,   326,   327,   328,     0,   329,
       0,   330,   331,   332,   333,   334,   335,   336,     0,   337,
       0,   338,     0,     0,   339,     0,   340,   341,   342,   343,
     344,     0,   345,   346,     0,   347,   348,     0,   349,     0,
       0,   350,   351,   352,     0,     0,   353,   354,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,   366,
       0,   367,   368,   369,   370,     0,   371,   372,     0,   373,
       0,   374,   375,   376,   377,   378,   379,     0,   380,     0,
       0,   381,   382,   383,     0,     0,   384,   385,     0,   386,
       0,   387,   388,   389,   390,   391,   392,   393,   394,     0,
     395,   396,   397,   398,   399,   400,   401,     0,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   646,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,     0,   426,   427,     0,   428,   429,   430,
     431,   432,   433,   434,   435,   436,   437,   438,   647,   439,
     440,   441,   442,   443,     0,   444,   445,   446,   447,     0,
     448,   449,   450,     0,   451,   452,   453,   454,   455,   456,
     457,   458,   459,   460,   461,     0,   462,   463,     0,   464,
     465,   466,   467,   468,   469,     0,   470,   471,     0,     0,
     472,   473,   474,   475,     0,   476,   477,   478,   479,   480,
     481,   482,     0,     0,   483,   484,   485,   486,   487,     0,
       0,   488,   489,   490,   491,   492,   493,   494,     0,   495,
       0,   496,   497,   498,   499,     0,     0,   500,     0,     0,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,   513,   514,   515,   516,   517,   518,   210,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   211,
     212,   213,   214,   215,   216,   217,   218,  1563,   220,   221,
     222,     0,     0,     0,     0,   223,     0,     0,     0,   224,
     225,     0,   226,   227,     0,   228,   229,   230,   231,   232,
       0,   233,   234,     0,   235,   236,   237,   238,   239,     0,
       0,   240,   241,   242,   243,   244,     0,   245,   246,   247,
     248,   249,     0,     0,     0,   250,   251,   252,   253,     0,
     254,   255,     0,   256,   257,   258,   259,   260,   261,     0,
       0,   262,   263,     0,     0,     0,     0,     0,     0,     0,
     264,   265,   266,  1564,   268,   269,   270,   271,   272,     0,
     273,     0,   274,   275,   276,   277,   278,     0,   279,   280,
     281,     0,     0,   282,  1565,   284,   285,   286,     0,   287,
     288,   289,     0,   290,   291,   292,     0,   293,   294,   295,
     296,   297,   298,   299,   300,   301,     0,   302,     0,   303,
     304,   305,   306,     0,   307,  1566,   308,     0,     0,     0,
    1567,   310,   311,     0,   312,   313,     0,   314,     0,   315,
     316,   317,   318,   319,     0,   320,   321,   322,     0,   323,
     324,   325,   326,   327,   328,     0,   329,     0,   330,   331,
     332,   333,   334,   335,   336,     0,   337,     0,   338,     0,
       0,   339,     0,   340,   341,  1568,  1569,   344,     0,   345,
     346,     0,   347,   348,     0,   349,     0,     0,   350,   351,
     352,     0,     0,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,     0,   367,   368,
     369,   370,     0,   371,   372,     0,   373,     0,   374,   375,
     376,   377,   378,   379,     0,   380,     0,     0,   381,   382,
     383,     0,     0,   384,   385,     0,   386,     0,   387,   388,
     389,   390,   391,   392,   393,   394,     0,   395,   396,   397,
     398,   399,   400,   401,     0,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,     0,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
       0,   426,   427,     0,   428,   429,   430,   431,   432,   433,
    1570,   435,   436,   437,   438,     0,  1571,   440,   441,   442,
     443,     0,   444,   445,   446,   447,     0,   448,   449,   450,
       0,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,     0,   462,   463,  1572,   464,  1573,   466,   467,
     468,   469,     0,   470,   471,     0,     0,   472,   473,   474,
     475,     0,   476,   477,  1574,   479,   480,   481,   482,     0,
       0,   483,   484,   485,   486,   487,     0,     0,   488,   489,
     490,   491,   492,   493,   494,     0,   495,     0,   496,   497,
     498,   499,     0,     0,   500,     0,     0,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   210,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   211,   212,   213,   214,
     215,   216,   217,   218,     0,   220,   221,   222,     0,     0,
       0,     0,   223,     0,     0,     0,   224,   225,     0,   226,
     227,     0,   228,   229,   230,   231,   232,     0,   233,   234,
       0,   235,   236,   237,   238,   239,     0,     0,   240,   241,
     242,   243,   244,     0,   245,   246,   247,   248,   249,     0,
       0,     0,   250,   251,   252,   253,     0,   254,   255,     0,
     256,   257,   258,   259,   260,   261,   645,     0,   262,   263,
       0,     0,     0,     0,     0,     0,     0,   264,   265,   266,
     267,   268,   269,   270,   271,   272,     0,   273,     0,   274,
     275,   276,   277,   278,     0,   279,   280,   281,     0,     0,
     282,   283,   284,   285,   286,     0,   287,   288,   289,     0,
     290,   291,   292,     0,   293,   294,   295,   296,   297,   298,
     299,   300,   301,     0,   302,     0,   303,   304,   305,   306,
       0,   307,     0,   308,     0,     0,     0,   309,   310,   311,
       0,   312,   313,     0,   314,     0,   315,   316,   317,   318,
     319,     0,   320,   321,   322,     0,   323,   324,   325,   326,
     327,   328,     0,   329,     0,   330,   331,   332,   333,   334,
     335,   336,     0,   337,     0,   338,     0,     0,   339,     0,
     340,   341,   342,   343,   344,     0,   345,   346,     0,   347,
     348,     0,   349,     0,     0,   350,   351,   352,     0,     0,
     353,   354,   355,   356,   357,   358,   359,   360,   361,   362,
     363,   364,   365,   366,     0,   367,   368,   369,   370,     0,
     371,   372,     0,   373,     0,   374,   375,   376,   377,   378,
     379,     0,   380,     0,     0,   381,   382,   383,     0,     0,
     384,   385,     0,   386,     0,   387,   388,   389,   390,   391,
     392,   393,   394,     0,   395,   396,   397,   398,   399,   400,
     401,     0,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   646,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,     0,   426,   427,
       0,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,   647,   439,   440,   441,   442,   443,     0,   444,
     445,   446,   447,     0,   448,   449,   450,     0,   451,   452,
     453,   454,   455,   456,   457,   458,   459,   460,   461,     0,
     462,   463,     0,   464,   465,   466,   467,   468,   469,     0,
     470,   471,     0,     0,   472,   473,   474,   475,     0,   476,
     477,   478,   479,   480,   481,   482,     0,     0,   483,   484,
     485,   486,   487,     0,     0,   488,   489,   490,   491,   492,
     493,   494,     0,   495,     0,   496,   497,   498,   499,     0,
       0,   500,     0,     0,   501,   502,   503,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
     517,   518,   210,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   211,   212,   213,   214,   215,   216,   217,
     218,   823,   220,   221,   222,     0,     0,     0,     0,   223,
       0,     0,     0,   224,   225,     0,   226,   227,     0,   228,
     229,   230,   231,   232,     0,   233,   234,     0,   235,   236,
     237,   238,   239,     0,     0,   240,   241,   242,   243,   244,
       0,   245,   246,   247,   248,   249,     0,     0,     0,   250,
     251,   252,   253,     0,   254,   255,     0,   256,   257,   258,
     259,   260,   261,     0,     0,   262,   263,     0,     0,     0,
       0,     0,     0,     0,   264,   265,   266,   267,   268,   269,
     270,   271,   272,     0,   273,     0,   274,   275,   276,   277,
     278,     0,   279,   280,   281,     0,     0,   282,   283,   284,
     285,   286,     0,   287,   288,   289,     0,   290,   291,   292,
       0,   293,   294,   295,   296,   297,   298,   299,   300,   301,
       0,   302,     0,   303,   304,   305,   306,     0,   307,     0,
     308,     0,     0,     0,   309,   310,   311,     0,   312,   313,
       0,   314,     0,   315,   316,   317,   318,   824,     0,   320,
     321,   322,     0,   323,   324,   325,   326,   327,   328,     0,
     329,     0,   330,   331,   332,   333,   334,   335,   336,     0,
     337,     0,   338,     0,     0,   339,     0,   340,   341,   342,
     343,   344,     0,   345,   346,     0,   347,   348,     0,   349,
       0,     0,   350,   351,   352,     0,     0,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,     0,   367,   368,   369,   370,     0,   371,   372,     0,
     373,     0,   374,   375,   376,   377,   378,   379,     0,   380,
       0,   709,   381,   382,   383,     0,     0,   384,   385,     0,
     386,     0,   387,   388,   389,   390,   391,   392,   393,   394,
       0,   395,   396,   397,   398,   399,   400,   401,     0,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,     0,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,     0,   426,   427,     0,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,     0,
     439,   440,   441,   442,   443,     0,   444,   445,   446,   447,
       0,   448,   449,   450,     0,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,     0,   462,   463,     0,
     464,   465,   466,   467,   468,   469,     0,   470,   471,     0,
       0,   472,   473,   474,   475,     0,   476,   477,   478,   479,
     480,   481,   482,     0,     0,   483,   484,   485,   486,   487,
       0,     0,   488,   489,   490,   491,   492,   493,   494,     0,
     495,     0,   496,   497,   498,   499,     0,     0,   500,     0,
       0,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   210,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     211,   212,   213,   214,   215,   216,   217,   218,     0,   220,
     221,   222,     3,     4,     0,     0,   223,     0,     0,     0,
     224,   225,     0,   226,   227,     0,   228,   229,   230,   231,
     232,     0,   233,   234,     0,   235,   236,   237,   238,   239,
       0,     0,   240,   241,   242,   243,   244,     0,   245,   246,
     247,   248,   249,     0,     0,     0,   250,   251,   252,   253,
       0,   254,   255,     0,   256,   257,   258,   259,   260,   261,
       0,     0,   262,   263,     0,     0,     0,     0,     0,     0,
       0,   264,   265,   266,   267,   268,   269,   270,   271,   272,
       0,   273,     0,   274,   275,   276,   277,   278,     0,   279,
     280,   281,     0,     0,   282,   283,   284,   285,   286,     0,
     287,   288,   289,     0,   290,   291,   292,     0,   293,   294,
     295,   296,   297,   298,   299,   300,   301,     0,   302,     0,
     303,   304,   305,   306,     0,   307,     0,   308,     0,     0,
       0,   309,   310,   311,     0,   312,   313,     0,   314,     0,
     315,   316,   317,   318,   319,     0,   320,   321,   322,     0,
     323,   324,   325,   326,   327,   328,     0,   329,     0,   330,
     331,   332,   333,   334,   335,   336,     0,   337,     0,   338,
       0,     0,   339,     0,   340,   341,   342,   343,   344,     0,
     345,   346,     0,   347,   348,     0,   349,     0,     0,   350,
     351,   352,     0,     0,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,   365,   366,     0,   367,
     368,   369,   370,     0,   371,   372,     0,   373,     0,   374,
     375,   376,   377,   378,   379,     0,   380,     0,     0,   381,
     382,   383,     0,     0,   384,   385,     0,   386,     0,   387,
     388,   389,   390,   391,   392,   393,   394,     0,   395,   396,
     397,   398,   399,   400,   401,     0,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,     0,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,     0,   426,   427,     0,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,   438,     0,   439,   440,   441,
     442,   443,     0,   444,   445,   446,   447,     0,   448,   449,
     450,     0,   451,   452,   453,   454,   455,   456,   457,   458,
     459,   460,   461,     0,   462,   463,     0,   464,   465,   466,
     467,   468,   469,     0,   470,   471,     0,     0,   472,   473,
     474,   475,     0,   476,   477,   478,   479,   480,   481,   482,
       0,     0,   483,   484,   485,   486,   487,     0,     0,   488,
     489,   490,   491,   492,   493,   494,     0,   495,     0,   496,
     497,   498,   499,     0,     0,   500,     0,     0,   501,   502,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
     513,   514,   515,   516,   517,   518,   210,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   211,   212,   213,
     214,   215,   216,   217,   218,  2645,   220,   221,   222,     0,
       0,     0,     0,   223,     0,     0,     0,   224,   225,     0,
     226,   227,     0,   228,   229,   230,   231,   232,     0,   233,
     234,     0,   235,   236,   237,   238,   239,     0,     0,   240,
     241,   242,   243,   244,     0,   245,   246,   247,   248,   249,
       0,     0,     0,   250,   251,   252,   253,     0,   254,   255,
       0,   256,   257,   258,   259,   260,   261,     0,     0,   262,
     263,     0,     0,     0,     0,     0,     0,     0,   264,   265,
     266,   267,   268,   269,   270,   271,   272,     0,   273,     0,
     274,   275,   276,   277,   278,     0,   279,   280,   281,     0,
       0,   282,   283,   284,   285,   286,     0,   287,   288,   289,
       0,   290,   291,   292,     0,   293,   294,   295,   296,   297,
     298,   299,   300,   301,     0,   302,     0,   303,   304,   305,
     306,     0,   307,     0,   308,     0,     0,     0,   309,   310,
     311,     0,   312,   313,     0,   314,     0,   315,   316,   317,
     318,   319,     0,   320,   321,   322,     0,   323,   324,   325,
     326,   327,   328,     0,   329,     0,   330,   331,   332,   333,
     334,   335,   336,     0,   337,     0,   338,     0,     0,   339,
       0,   340,   341,   342,   343,   344,     0,   345,   346,     0,
     347,   348,     0,   349,     0,     0,   350,   351,   352,     0,
       0,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   366,     0,   367,   368,   369,   370,
       0,   371,   372,     0,   373,     0,   374,   375,   376,   377,
     378,   379,     0,   380,     0,     0,   381,   382,   383,     0,
       0,   384,   385,     0,   386,     0,   387,   388,   389,   390,
     391,   392,   393,   394,     0,   395,   396,   397,   398,   399,
     400,   401,     0,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,     0,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,     0,   426,
     427,     0,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,     0,   439,   440,   441,   442,   443,     0,
     444,   445,   446,   447,     0,   448,   449,   450,     0,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,   461,
       0,   462,   463,     0,   464,   465,   466,   467,   468,   469,
       0,   470,   471,     0,     0,   472,   473,   474,   475,     0,
     476,   477,   478,   479,   480,   481,   482,     0,     0,   483,
     484,   485,   486,   487,  2646,     0,   488,   489,   490,   491,
     492,   493,   494,     0,   495,     0,   496,   497,   498,   499,
       0,     0,   500,     0,     0,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   210,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   211,   212,   213,   214,   215,   216,
     217,   218,  2657,   220,   221,   222,     0,     0,     0,     0,
     223,     0,     0,     0,   224,   225,     0,   226,   227,     0,
     228,   229,   230,   231,   232,     0,   233,   234,     0,   235,
     236,   237,   238,   239,     0,     0,   240,   241,   242,   243,
     244,     0,   245,   246,   247,   248,   249,     0,     0,     0,
     250,   251,   252,   253,     0,   254,   255,     0,   256,   257,
     258,   259,   260,   261,     0,     0,   262,   263,     0,     0,
       0,     0,     0,     0,     0,   264,   265,   266,   267,   268,
     269,   270,   271,   272,     0,   273,     0,   274,   275,   276,
     277,   278,     0,   279,   280,   281,     0,     0,   282,   283,
     284,   285,   286,     0,   287,   288,   289,     0,   290,   291,
     292,     0,   293,   294,   295,   296,   297,   298,   299,   300,
     301,     0,   302,     0,   303,   304,   305,   306,     0,   307,
       0,   308,     0,     0,     0,   309,   310,   311,     0,   312,
     313,     0,   314,     0,   315,   316,   317,   318,   319,     0,
     320,   321,   322,     0,   323,   324,   325,   326,   327,   328,
       0,   329,     0,   330,   331,   332,   333,   334,   335,   336,
       0,   337,     0,   338,     0,     0,   339,     0,   340,   341,
     342,   343,   344,     0,   345,   346,     0,   347,   348,     0,
     349,     0,     0,   350,   351,   352,     0,     0,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,     0,   367,   368,   369,   370,     0,   371,   372,
       0,   373,     0,   374,   375,   376,   377,   378,   379,     0,
     380,     0,     0,   381,   382,   383,     0,     0,   384,   385,
       0,   386,     0,   387,   388,   389,   390,   391,   392,   393,
     394,     0,   395,   396,   397,   398,   399,   400,   401,     0,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,     0,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,     0,   426,   427,     0,   428,
     429,   430,   431,   432,   433,   434,   435,   436,   437,   438,
       0,   439,   440,   441,   442,   443,     0,   444,   445,   446,
     447,     0,   448,   449,   450,     0,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,     0,   462,   463,
       0,   464,   465,   466,   467,   468,   469,     0,   470,   471,
       0,     0,   472,   473,   474,   475,     0,   476,   477,   478,
     479,   480,   481,   482,     0,     0,   483,   484,   485,   486,
     487,  2658,     0,   488,   489,   490,   491,   492,   493,   494,
       0,   495,     0,   496,   497,   498,   499,     0,     0,   500,
       0,     0,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
     210,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   211,   212,   213,   214,   215,   216,   217,   218,   219,
     220,   221,   222,     0,     0,     0,     0,   223,     0,     0,
       0,   224,   225,     0,   226,   227,     0,   228,   229,   230,
     231,   232,     0,   233,   234,     0,   235,   236,   237,   238,
     239,     0,     0,   240,   241,   242,   243,   244,     0,   245,
     246,   247,   248,   249,     0,     0,     0,   250,   251,   252,
     253,     0,   254,   255,     0,   256,   257,   258,   259,   260,
     261,     0,     0,   262,   263,     0,     0,     0,     0,     0,
       0,     0,   264,   265,   266,   267,   268,   269,   270,   271,
     272,     0,   273,     0,   274,   275,   276,   277,   278,     0,
     279,   280,   281,     0,     0,   282,   283,   284,   285,   286,
       0,   287,   288,   289,     0,   290,   291,   292,     0,   293,
     294,   295,   296,   297,   298,   299,   300,   301,     0,   302,
       0,   303,   304,   305,   306,     0,   307,     0,   308,     0,
       0,     0,   309,   310,   311,     0,   312,   313,     0,   314,
       0,   315,   316,   317,   318,   319,     0,   320,   321,   322,
       0,   323,   324,   325,   326,   327,   328,     0,   329,     0,
     330,   331,   332,   333,   334,   335,   336,     0,   337,     0,
     338,     0,     0,   339,     0,   340,   341,   342,   343,   344,
       0,   345,   346,     0,   347,   348,     0,   349,     0,     0,
     350,   351,   352,     0,     0,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   366,     0,
     367,   368,   369,   370,     0,   371,   372,     0,   373,     0,
     374,   375,   376,   377,   378,   379,     0,   380,     0,     0,
     381,   382,   383,     0,     0,   384,   385,     0,   386,     0,
     387,   388,   389,   390,   391,   392,   393,   394,     0,   395,
     396,   397,   398,   399,   400,   401,     0,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
       0,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,     0,   426,   427,     0,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,     0,   439,   440,
     441,   442,   443,     0,   444,   445,   446,   447,     0,   448,
     449,   450,     0,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,   461,     0,   462,   463,     0,   464,   465,
     466,   467,   468,   469,     0,   470,   471,     0,     0,   472,
     473,   474,   475,     0,   476,   477,   478,   479,   480,   481,
     482,     0,     0,   483,   484,   485,   486,   487,     0,     0,
     488,   489,   490,   491,   492,   493,   494,     0,   495,     0,
     496,   497,   498,   499,     0,     0,   500,     0,     0,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,   516,   517,   518,   210,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   211,   212,
     213,   214,   215,   216,   217,   218,   565,   220,   221,   222,
       0,     0,     0,     0,   223,     0,     0,     0,   224,   225,
       0,   226,   227,     0,   228,   229,   230,   231,   232,     0,
     233,   234,     0,   235,   236,   237,   238,   239,     0,     0,
     240,   241,   242,   243,   244,     0,   245,   246,   247,   248,
     249,     0,     0,     0,   250,   251,   252,   253,     0,   254,
     255,     0,   256,   257,   258,   259,   260,   261,     0,     0,
     262,   263,     0,     0,     0,     0,     0,     0,     0,   264,
     265,   266,   267,   268,   269,   270,   271,   272,     0,   273,
       0,   274,   275,   276,   277,   278,     0,   279,   280,   281,
       0,     0,   282,   283,   284,   285,   286,     0,   287,   288,
     289,     0,   290,   291,   292,     0,   293,   294,   295,   296,
     297,   298,   299,   300,   301,     0,   302,     0,   303,   304,
     305,   306,     0,   307,     0,   308,     0,     0,     0,   309,
     310,   311,     0,   312,   313,     0,   314,     0,   315,   316,
     317,   318,   319,     0,   320,   321,   322,     0,   323,   324,
     325,   326,   327,   328,     0,   329,     0,   330,   331,   332,
     333,   334,   335,   336,     0,   337,     0,   338,     0,     0,
     339,     0,   340,   341,   342,   343,   344,     0,   345,   346,
       0,   347,   348,     0,   349,     0,     0,   350,   351,   352,
       0,     0,   353,   354,   355,   356,   357,   358,   359,   360,
     361,   362,   363,   364,   365,   366,     0,   367,   368,   369,
     370,     0,   371,   372,     0,   373,     0,   374,   375,   376,
     377,   378,   379,     0,   380,     0,     0,   381,   382,   383,
       0,     0,   384,   385,     0,   386,     0,   387,   388,   389,
     390,   391,   392,   393,   394,     0,   395,   396,   397,   398,
     399,   566,   401,     0,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,     0,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,     0,
     426,   427,     0,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,     0,   439,   440,   441,   442,   443,
       0,   444,   445,   446,   447,     0,   448,   449,   450,     0,
     451,   452,   453,   454,   455,   456,   457,   458,   459,   460,
     461,     0,   462,   463,     0,   464,   465,   466,   467,   468,
     469,     0,   470,   471,     0,     0,   472,   473,   474,   475,
       0,   476,   477,   478,   479,   480,   481,   482,     0,     0,
     483,   484,   485,   486,   487,     0,     0,   488,   489,   490,
     491,   492,   493,   494,     0,   495,     0,   496,   497,   498,
     499,     0,     0,   500,     0,     0,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   210,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   211,   212,   213,   214,   215,
     216,   217,   218,   670,   220,   221,   222,     0,     0,     0,
       0,   223,     0,     0,     0,   224,   225,     0,   226,   227,
       0,   228,   229,   230,   231,   232,     0,   233,   234,     0,
     235,   236,   237,   238,   239,     0,     0,   240,   241,   242,
     243,   244,     0,   245,   246,   247,   248,   249,     0,     0,
       0,   250,   251,   252,   253,     0,   254,   255,     0,   256,
     257,   258,   259,   260,   261,     0,     0,   262,   263,     0,
       0,     0,     0,     0,     0,     0,   264,   265,   266,   267,
     268,   269,   270,   271,   272,     0,   273,     0,   274,   275,
     276,   277,   278,     0,   279,   280,   281,     0,     0,   282,
     283,   284,   285,   286,     0,   287,   288,   289,     0,   290,
     291,   292,     0,   293,   294,   295,   296,   297,   298,   299,
     300,   301,     0,   302,     0,   303,   304,   305,   306,     0,
     307,     0,   308,     0,     0,     0,   309,   310,   311,     0,
     312,   313,     0,   314,     0,   315,   316,   317,   318,   319,
       0,   320,   321,   322,     0,   323,   324,   325,   326,   327,
     328,     0,   329,     0,   330,   331,   332,   333,   334,   335,
     336,     0,   337,     0,   338,     0,     0,   339,     0,   340,
     341,   342,   343,   344,     0,   345,   346,     0,   347,   348,
       0,   349,     0,     0,   350,   351,   352,     0,     0,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,     0,   367,   368,   369,   370,     0,   371,
     372,     0,   373,     0,   374,   375,   376,   377,   378,   379,
       0,   380,     0,     0,   381,   382,   383,     0,     0,   384,
     385,     0,   386,     0,   387,   388,   389,   390,   391,   392,
     393,   394,     0,   395,   396,   397,   398,   399,   400,   401,
       0,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,     0,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,     0,   426,   427,     0,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,     0,   439,   440,   441,   442,   671,     0,   444,   445,
     446,   447,     0,   448,   449,   450,     0,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,     0,   462,
     463,     0,   464,   465,   466,   467,   468,   469,     0,   672,
     471,     0,     0,   673,   473,   474,   475,     0,   476,   477,
     478,   479,   480,   481,   482,     0,     0,   483,   484,   485,
     486,   487,     0,     0,   488,   489,   490,   491,   492,   493,
     494,     0,   495,     0,   496,   497,   498,   499,     0,     0,
     500,     0,     0,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,   516,   517,
     518,   210,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   211,   212,   213,   214,   215,   216,   217,   218,
     703,   220,   221,   222,     0,     0,     0,     0,   223,     0,
       0,     0,   224,   225,     0,   226,   227,     0,   228,   229,
     230,   231,   232,     0,   233,   234,     0,   235,   236,   237,
     238,   239,     0,     0,   240,   241,   242,   243,   244,     0,
     245,   246,   247,   248,   249,     0,     0,     0,   250,   251,
     252,   253,     0,   254,   255,     0,   256,   257,   258,   259,
     260,   261,     0,     0,   262,   263,     0,     0,     0,     0,
       0,     0,     0,   264,   265,   266,   267,   268,   269,   270,
     271,   272,     0,   273,     0,   274,   275,   276,   277,   278,
       0,   279,   280,   281,     0,     0,   282,   283,   284,   285,
     286,     0,   287,   288,   289,     0,   290,   291,   292,     0,
     293,   294,   295,   296,   297,   298,   299,   300,   301,     0,
     302,     0,   303,   304,   305,   306,     0,   307,     0,   308,
       0,     0,     0,   309,   310,   311,     0,   312,   313,     0,
     314,     0,   315,   316,   317,   318,   319,     0,   320,   321,
     322,     0,   323,   324,   325,   326,   327,   328,     0,   329,
       0,   330,   331,   332,   333,   334,   335,   336,     0,   337,
       0,   338,     0,     0,   339,     0,   340,   341,   342,   343,
     344,     0,   345,   346,     0,   347,   348,     0,   349,     0,
       0,   350,   351,   352,     0,     0,   353,   354,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,   366,
       0,   367,   368,   369,   370,     0,   371,   372,     0,   373,
       0,   374,   375,   376,   377,   378,   379,     0,   380,     0,
       0,   381,   382,   383,     0,     0,   384,   385,     0,   386,
       0,   387,   388,   389,   390,   391,   392,   393,   394,     0,
     395,   396,   397,   398,   399,   400,   401,     0,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,     0,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,     0,   426,   427,     0,   428,   429,   430,
     431,   432,   433,   434,   435,   436,   437,   438,     0,   439,
     440,   441,   442,   704,     0,   444,   445,   446,   447,     0,
     448,   449,   450,     0,   451,   452,   453,   454,   455,   456,
     457,   458,   459,   460,   461,     0,   462,   463,     0,   464,
     465,   466,   467,   468,   469,     0,   705,   471,     0,     0,
     706,   473,   474,   475,     0,   476,   477,   478,   479,   480,
     481,   482,     0,     0,   483,   484,   485,   486,   487,     0,
       0,   488,   489,   490,   491,   492,   493,   494,     0,   495,
       0,   496,   497,   498,   499,     0,     0,   500,     0,     0,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,   513,   514,   515,   516,   517,   518,   210,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   211,
     212,   213,   214,   215,   216,   217,   218,     0,   220,   221,
     222,     0,     0,     0,     0,   223,     0,     0,     0,   224,
     225,     0,   226,   227,     0,   228,   229,   230,   231,   232,
       0,   233,   234,     0,   235,   236,   237,   238,   239,     0,
       0,   240,   241,   242,   243,   244,     0,   245,   246,   247,
     248,   249,     0,     0,     0,   250,   251,   252,   253,     0,
     254,   255,     0,   256,   257,   258,   259,   260,   261,     0,
       0,   262,   263,     0,     0,     0,     0,     0,     0,     0,
     264,   265,   266,   267,   268,   269,   270,   271,   272,     0,
     273,     0,   274,   275,   276,   277,   278,     0,   279,   280,
     281,     0,     0,   282,   283,   284,   285,   286,     0,   287,
     288,   289,     0,   290,   291,   292,     0,   293,   294,   295,
     296,   297,   298,   299,   300,   301,     0,   302,     0,   303,
     304,   305,   306,     0,   307,     0,   308,     0,     0,     0,
     309,   310,   311,     0,   312,   313,     0,   314,     0,   315,
     316,   317,   318,   319,     0,   320,   321,   322,     0,   323,
     324,   325,   326,   327,   328,     0,   329,     0,   330,   331,
     332,   333,   334,   335,   336,     0,   337,     0,   338,     0,
       0,   339,     0,   340,   341,   342,   343,   344,     0,   345,
     346,     0,   347,   348,     0,   349,     0,     0,   350,   351,
     352,     0,     0,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,     0,   367,   368,
     369,   370,     0,   371,   372,     0,   373,     0,   374,   375,
     376,   377,   378,   379,     0,   380,     0,   709,   381,   382,
     383,     0,     0,   384,   385,     0,   386,     0,   387,   388,
     389,   390,   391,   392,   393,   394,     0,   395,   396,   397,
     398,   399,   400,   401,     0,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,     0,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
       0,   426,   427,     0,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,     0,   439,   440,   441,   442,
     443,     0,   444,   445,   446,   447,     0,   448,   449,   450,
       0,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,     0,   462,   463,     0,   464,   465,   466,   467,
     468,   469,     0,   470,   471,     0,     0,   472,   473,   474,
     475,     0,   476,   477,   478,   479,   480,   481,   482,     0,
       0,   483,   484,   485,   486,   487,     0,     0,   488,   489,
     490,   491,   492,   493,   494,     0,   495,     0,   496,   497,
     498,   499,     0,     0,   500,     0,     0,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   210,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   211,   212,   213,   214,
     215,   216,   217,   218,   793,   220,   221,   222,     0,     0,
       0,     0,   223,     0,     0,     0,   224,   225,     0,   226,
     227,     0,   228,   229,   230,   231,   232,     0,   233,   234,
       0,   235,   236,   237,   238,   239,     0,     0,   240,   241,
     242,   243,   244,     0,   245,   246,   247,   248,   249,     0,
       0,     0,   250,   251,   252,   253,     0,   254,   255,     0,
     256,   257,   258,   259,   260,   261,     0,     0,   262,   263,
       0,     0,     0,     0,     0,     0,     0,   264,   265,   266,
     267,   268,   269,   270,   271,   272,     0,   273,     0,   274,
     275,   276,   277,   278,     0,   279,   280,   281,     0,     0,
     282,   283,   284,   285,   286,     0,   287,   288,   289,     0,
     290,   291,   292,     0,   293,   294,   295,   296,   297,   298,
     299,   300,   301,     0,   302,     0,   303,   304,   305,   306,
       0,   307,     0,   308,     0,     0,     0,   309,   310,   311,
       0,   312,   313,     0,   314,     0,   315,   316,   317,   318,
     794,     0,   320,   321,   322,     0,   323,   324,   325,   326,
     327,   328,     0,   329,     0,   330,   331,   332,   333,   334,
     335,   336,     0,   337,     0,   338,     0,     0,   339,     0,
     340,   341,   342,   343,   344,     0,   345,   346,     0,   347,
     348,     0,   349,     0,     0,   350,   351,   352,     0,     0,
     353,   354,   355,   356,   357,   358,   359,   360,   361,   362,
     363,   364,   365,   366,     0,   367,   368,   369,   370,     0,
     371,   372,     0,   373,     0,   374,   375,   376,   377,   378,
     379,     0,   380,     0,     0,   381,   382,   383,     0,     0,
     384,   385,     0,   386,     0,   387,   388,   389,   390,   391,
     392,   393,   394,     0,   395,   396,   397,   398,   399,   400,
     401,     0,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,     0,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,     0,   426,   427,
       0,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,     0,   439,   440,   441,   442,   443,     0,   444,
     445,   446,   447,     0,   448,   449,   450,     0,   451,   452,
     453,   454,   455,   456,   457,   458,   459,   460,   461,     0,
     462,   463,     0,   464,   465,   466,   467,   468,   469,     0,
     470,   471,     0,     0,   472,   473,   474,   475,     0,   476,
     477,   478,   479,   480,   481,   482,     0,     0,   483,   484,
     485,   486,   487,     0,     0,   488,   489,   490,   491,   492,
     493,   494,     0,   495,     0,   496,   497,   498,   499,     0,
       0,   500,     0,     0,   501,   502,   503,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
     517,   518,   210,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   211,   212,   213,   214,   215,   216,   217,
     218,   920,   220,   221,   222,     0,     0,     0,     0,   223,
       0,     0,     0,   224,   225,     0,   226,   227,     0,   228,
     229,   230,   231,   232,     0,   233,   234,     0,   235,   236,
     237,   238,   239,     0,     0,   240,   241,   242,   243,   244,
       0,   245,   246,   247,   248,   249,     0,     0,     0,   250,
     251,   252,   253,     0,   254,   255,     0,   256,   257,   258,
     259,   260,   261,     0,     0,   262,   263,     0,     0,     0,
       0,     0,     0,     0,   264,   265,   266,   267,   268,   269,
     270,   271,   272,     0,   273,     0,   274,   275,   276,   277,
     278,     0,   279,   280,   281,     0,     0,   282,   283,   284,
     285,   286,     0,   287,   288,   289,     0,   290,   291,   292,
       0,   293,   294,   295,   296,   297,   298,   299,   300,   301,
       0,   302,     0,   303,   304,   305,   306,     0,   307,     0,
     308,     0,     0,     0,   309,   310,   311,     0,   312,   313,
       0,   314,     0,   315,   316,   317,   318,   319,     0,   320,
     321,   322,     0,   323,   324,   325,   326,   327,   328,     0,
     329,     0,   330,   331,   332,   333,   334,   335,   336,     0,
     337,     0,   338,     0,     0,   339,     0,   340,   341,   342,
     343,   344,     0,   345,   346,     0,   347,   348,     0,   349,
       0,     0,   350,   351,   352,     0,     0,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,     0,   367,   368,   369,   370,     0,   371,   372,     0,
     373,     0,   374,   375,   376,   377,   378,   379,     0,   380,
       0,     0,   381,   382,   383,     0,     0,   384,   385,     0,
     386,     0,   387,   388,   389,   390,   391,   392,   393,   394,
       0,   395,   396,   397,   398,   399,   400,   401,     0,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,     0,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,     0,   426,   427,     0,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,     0,
     439,   440,   441,   442,   443,     0,   444,   445,   446,   447,
       0,   448,   449,   450,     0,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,     0,   462,   463,     0,
     464,   465,   466,   467,   468,   469,     0,   470,   471,     0,
       0,   472,   473,   474,   475,     0,   476,   477,   478,   479,
     480,   481,   482,     0,     0,   483,   484,   485,   486,   487,
       0,     0,   488,   489,   490,   491,   492,   493,   494,     0,
     495,     0,   496,   497,   498,   499,     0,     0,   500,     0,
       0,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   210,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     211,   212,   213,   214,   215,   216,   217,   218,  1132,   220,
     221,   222,     0,     0,     0,     0,   223,     0,     0,     0,
     224,   225,     0,   226,   227,     0,   228,   229,   230,   231,
     232,     0,   233,   234,     0,   235,   236,   237,   238,   239,
       0,     0,   240,   241,   242,   243,   244,     0,   245,   246,
     247,   248,   249,     0,     0,     0,   250,   251,   252,   253,
       0,   254,   255,     0,   256,   257,   258,   259,   260,   261,
       0,     0,   262,   263,     0,     0,     0,     0,     0,     0,
       0,   264,   265,   266,   267,   268,   269,   270,   271,   272,
       0,   273,     0,   274,   275,   276,   277,   278,     0,   279,
     280,   281,     0,     0,   282,   283,   284,   285,   286,     0,
     287,   288,   289,     0,   290,   291,   292,     0,   293,   294,
     295,   296,   297,   298,   299,   300,   301,     0,   302,     0,
     303,   304,   305,   306,     0,   307,     0,   308,     0,     0,
       0,   309,   310,   311,     0,   312,   313,     0,   314,     0,
     315,   316,   317,   318,   319,     0,   320,   321,   322,     0,
     323,   324,   325,   326,   327,   328,     0,   329,     0,   330,
     331,   332,   333,   334,   335,   336,     0,   337,     0,   338,
       0,     0,   339,     0,   340,   341,   342,   343,   344,     0,
     345,   346,     0,   347,   348,     0,   349,     0,     0,   350,
     351,   352,     0,     0,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,   365,   366,     0,   367,
     368,   369,   370,     0,   371,   372,     0,   373,     0,   374,
     375,   376,   377,   378,   379,     0,   380,     0,     0,   381,
     382,   383,     0,     0,   384,   385,     0,   386,     0,   387,
     388,   389,   390,   391,   392,   393,   394,     0,   395,   396,
     397,   398,   399,   400,   401,     0,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,     0,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,     0,   426,   427,     0,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,   438,     0,   439,   440,   441,
     442,   443,     0,   444,   445,   446,   447,     0,   448,   449,
     450,     0,   451,   452,   453,   454,   455,   456,   457,   458,
     459,   460,   461,     0,   462,   463,     0,   464,   465,   466,
     467,   468,   469,     0,   470,   471,     0,     0,   472,   473,
     474,   475,     0,   476,   477,   478,   479,   480,   481,   482,
       0,     0,   483,   484,   485,   486,   487,     0,     0,   488,
     489,   490,   491,   492,   493,   494,     0,   495,     0,   496,
     497,   498,   499,     0,     0,   500,     0,     0,   501,   502,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
     513,   514,   515,   516,   517,   518,   210,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   211,   212,   213,
     214,   215,   216,   217,   218,     0,   220,   221,   222,     0,
       0,     0,     0,   223,     0,     0,     0,   224,   225,     0,
     226,   227,  1143,   228,   229,   230,   231,   232,     0,   233,
     234,     0,   235,   236,   237,   238,   239,     0,     0,   689,
     241,   242,   243,  1144,     0,   245,   246,   247,   248,   249,
       0,     0,     0,   250,   251,   252,   253,     0,   254,   255,
       0,   256,   257,   258,   259,   260,   261,     0,     0,   262,
     263,     0,     0,     0,     0,     0,     0,     0,   264,   265,
     266,   267,   268,   269,   270,   271,   272,     0,   273,     0,
     274,   275,   276,   277,   278,     0,   279,   280,   281,     0,
       0,   282,   283,   284,   285,   286,     0,   287,   288,   289,
       0,   290,   291,   292,     0,   293,   294,   295,   296,   297,
     298,   299,   300,   301,     0,   302,     0,   303,   304,   305,
     306,     0,   307,     0,   308,     0,     0,     0,   309,   310,
     311,     0,   312,   313,     0,   314,     0,   315,   316,   317,
     318,   319,     0,   320,   321,   322,     0,   323,   324,   325,
     326,   327,   328,     0,   329,     0,   330,   331,   332,   333,
     334,   335,   336,     0,   337,     0,   338,     0,     0,   339,
       0,   340,   341,   342,   343,   344,     0,   345,   346,     0,
     347,   348,     0,   349,     0,     0,   350,   351,   352,     0,
       0,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   692,   366,     0,   367,   368,   369,   370,
       0,   371,   372,     0,   373,     0,   374,   375,   376,   377,
     378,   379,     0,   380,     0,     0,   381,   382,   383,     0,
       0,   384,   385,     0,   386,     0,   387,   388,   389,   390,
     391,   392,   393,   394,     0,   395,   396,   397,   398,   399,
     400,   401,     0,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,     0,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,     0,   426,
     427,     0,   693,   429,   430,   431,   432,   433,   694,   435,
     436,   437,   438,     0,   439,   440,   441,   442,  1136,     0,
     444,   445,   446,   447,     0,   448,   449,   450,     0,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,   461,
       0,   462,   463,     0,   464,   465,   466,   467,   468,   469,
       0,   696,   471,     0,     0,   697,   473,   474,   475,     0,
     476,   477,   478,   479,   480,   481,   482,     0,     0,   483,
     484,   485,   486,   487,     0,     0,   488,   489,   490,   491,
     492,   493,   494,     0,   495,     0,   496,   497,   498,   499,
       0,     0,   500,     0,     0,   501,   502,   503,   504,   505,
     698,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   210,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   211,   212,   213,   214,   215,   216,
     217,   218,     0,   220,   221,   222,     0,     0,     0,     0,
     223,     0,     0,     0,   224,   225,     0,   226,   227,     0,
     228,   229,   230,   231,   232,     0,   233,   234,     0,   235,
     236,   237,   238,   239,     0,     0,   240,   241,   242,   243,
     244,     0,   245,   246,   247,   248,   249,     0,     0,     0,
     250,   251,   252,   253,     0,   254,   255,     0,   256,   257,
     258,   259,   260,   261,     0,     0,   262,   263,     0,     0,
       0,     0,     0,     0,     0,   264,   265,   266,   267,   268,
     269,   270,   271,   272,     0,   273,     0,   274,   275,   276,
     277,   278,     0,   279,   280,   281,     0,     0,   282,   283,
     284,   285,   286,     0,   287,   288,   289,     0,   290,   291,
     292,     0,   293,   294,   295,   296,   297,   298,   299,   300,
     301,     0,   302,     0,   303,   304,   305,   306,     0,   307,
       0,   308,     0,     0,     0,   309,   310,   311,     0,   312,
     313,     0,   314,     0,   315,   316,   317,   318,  1242,     0,
     320,   321,   322,     0,   323,   324,   325,   326,   327,   328,
       0,   329,     0,   330,   331,   332,   333,   334,   335,   336,
       0,   337,     0,   338,     0,     0,   339,     0,   340,   341,
     342,   343,   344,     0,   345,   346,     0,   347,   348,     0,
     349,     0,     0,   350,   351,   352,     0,     0,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,     0,   367,   368,   369,   370,     0,   371,   372,
       0,   373,     0,   374,   375,   376,   377,   378,   379,     0,
     380,     0,   709,   381,   382,   383,     0,     0,   384,   385,
       0,   386,     0,   387,   388,   389,   390,   391,   392,   393,
     394,     0,   395,   396,   397,   398,   399,   400,   401,     0,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,     0,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,     0,   426,   427,     0,   428,
     429,   430,   431,   432,   433,   434,   435,   436,   437,   438,
       0,   439,   440,   441,   442,   443,     0,   444,   445,   446,
     447,     0,   448,   449,   450,     0,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,     0,   462,   463,
       0,   464,   465,   466,   467,   468,   469,     0,   470,   471,
       0,     0,   472,   473,   474,   475,     0,   476,   477,   478,
     479,   480,   481,   482,     0,     0,   483,   484,   485,   486,
     487,     0,     0,   488,   489,   490,   491,   492,   493,   494,
       0,   495,     0,   496,   497,   498,   499,     0,     0,   500,
       0,     0,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
     210,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   211,   212,   213,   214,   215,   216,   217,   218,  1293,
     220,   221,   222,     0,     0,     0,     0,   223,     0,     0,
       0,   224,   225,     0,   226,   227,     0,   228,   229,   230,
     231,   232,     0,   233,   234,     0,   235,   236,   237,   238,
     239,     0,     0,   240,   241,   242,   243,   244,     0,   245,
     246,   247,   248,   249,     0,     0,     0,   250,   251,   252,
     253,     0,   254,   255,     0,   256,   257,   258,   259,   260,
     261,     0,     0,   262,   263,     0,     0,     0,     0,     0,
       0,     0,   264,   265,   266,   267,   268,   269,   270,   271,
     272,     0,   273,     0,   274,   275,   276,   277,   278,     0,
     279,   280,   281,     0,     0,   282,   283,   284,   285,   286,
       0,   287,   288,   289,     0,   290,   291,   292,     0,   293,
     294,   295,   296,   297,   298,   299,   300,   301,     0,   302,
       0,   303,   304,   305,   306,     0,   307,     0,   308,     0,
       0,     0,   309,   310,   311,     0,   312,   313,     0,   314,
       0,   315,   316,   317,   318,  1294,     0,   320,   321,   322,
       0,   323,   324,   325,   326,   327,   328,     0,   329,     0,
     330,   331,   332,   333,   334,   335,   336,     0,   337,     0,
     338,     0,     0,   339,     0,   340,   341,   342,   343,   344,
       0,   345,   346,     0,   347,   348,     0,   349,     0,     0,
     350,   351,   352,     0,     0,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   366,     0,
     367,   368,   369,   370,     0,   371,   372,     0,   373,     0,
     374,   375,   376,   377,   378,   379,     0,   380,     0,     0,
     381,   382,   383,     0,     0,   384,   385,     0,   386,     0,
     387,   388,   389,   390,   391,   392,   393,   394,     0,   395,
     396,   397,   398,   399,   400,   401,     0,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
       0,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,     0,   426,   427,     0,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,     0,   439,   440,
     441,   442,   443,     0,   444,   445,   446,   447,     0,   448,
     449,   450,     0,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,   461,     0,   462,   463,     0,   464,   465,
     466,   467,   468,   469,     0,   470,   471,     0,     0,   472,
     473,   474,   475,     0,   476,   477,   478,   479,   480,   481,
     482,     0,     0,   483,   484,   485,   486,   487,     0,     0,
     488,   489,   490,   491,   492,   493,   494,     0,   495,     0,
     496,   497,   498,   499,     0,     0,   500,     0,     0,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,   516,   517,   518,   210,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   211,   212,
     213,   214,   215,   216,   217,   218,   670,   220,   221,   222,
       0,     0,     0,     0,   223,     0,     0,     0,   224,   225,
       0,   226,   227,     0,   228,   229,   230,   231,   232,     0,
     233,   234,     0,   235,   236,   237,   238,   239,     0,     0,
     240,   241,   242,   243,   244,     0,   245,   246,   247,   248,
     249,     0,     0,     0,   250,   251,   252,   253,     0,   254,
     255,     0,   256,   257,   258,   259,   260,   261,     0,     0,
     262,   263,     0,     0,     0,     0,     0,     0,     0,   264,
     265,   266,   267,   268,   269,   270,   271,   272,     0,   273,
       0,   274,   275,   276,   277,   278,     0,   279,   280,   281,
       0,     0,   282,   283,   284,   285,   286,     0,   287,   288,
     289,     0,   290,   291,   292,     0,   293,   294,   295,   296,
     297,   298,   299,   300,   301,     0,   302,     0,   303,   304,
     305,   306,     0,   307,     0,   308,     0,     0,     0,   309,
     310,   311,     0,   312,   313,     0,   314,     0,   315,   316,
     317,   318,   319,     0,   320,   321,   322,     0,   323,   324,
     325,   326,   327,   328,     0,   329,     0,   330,   331,   332,
     333,   334,   335,   336,     0,   337,     0,   338,     0,     0,
     339,     0,   340,   341,   342,   343,   344,     0,   345,   346,
       0,   347,   348,     0,   349,     0,     0,   350,   351,   352,
       0,     0,   353,   354,   355,   356,   357,   358,   359,   360,
     361,   362,   363,   364,   365,   366,     0,   367,   368,   369,
     370,     0,   371,   372,     0,   373,     0,   374,   375,   376,
     377,   378,   379,     0,   380,     0,     0,   381,   382,   383,
       0,     0,   384,   385,     0,   386,     0,   387,   388,   389,
     390,   391,   392,   393,   394,     0,   395,   396,   397,   398,
     399,   400,   401,     0,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,     0,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,     0,
     426,   427,     0,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,     0,   439,   440,   441,   442,   443,
       0,   444,   445,   446,   447,     0,   448,   449,   450,     0,
     451,   452,   453,   454,   455,   456,   457,   458,   459,   460,
     461,     0,   462,   463,     0,   464,   465,   466,   467,   468,
     469,     0,   470,   471,     0,     0,   472,   473,   474,   475,
       0,   476,   477,   478,   479,   480,   481,   482,     0,     0,
     483,   484,   485,   486,   487,     0,     0,   488,   489,   490,
     491,   492,   493,   494,     0,   495,     0,   496,   497,   498,
     499,     0,     0,   500,     0,     0,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   210,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   211,   212,   213,   214,   215,
     216,   217,   218,     0,   220,   221,   222,     0,     0,     0,
       0,   223,     0,     0,     0,   224,   225,     0,   226,   227,
       0,   228,   229,   230,   231,   232,     0,   233,   234,     0,
     235,   236,   237,   238,   239,     0,     0,   240,   241,   242,
     243,   244,     0,   245,   246,   247,   248,   249,     0,     0,
       0,   250,   251,   252,   253,     0,   254,   255,     0,   256,
     257,   258,   259,   260,   261,     0,     0,   262,   263,     0,
       0,     0,     0,     0,     0,     0,   264,   265,   266,   267,
     268,   269,   270,   271,   272,     0,   273,     0,   274,   275,
     276,   277,   278,     0,   279,   280,   281,     0,     0,   282,
     283,   284,   285,   286,     0,   287,   288,   289,     0,   290,
     291,   292,     0,   293,   294,   295,   296,   297,   298,   299,
     300,   301,     0,   302,     0,   303,   304,   305,   306,     0,
     307,     0,   308,     0,     0,     0,   309,   310,  2459,     0,
     312,   313,     0,   314,     0,   315,   316,   317,   318,   319,
       0,   320,   321,   322,     0,   323,   324,   325,   326,   327,
     328,     0,   329,     0,   330,   331,   332,   333,   334,   335,
     336,     0,   337,     0,   338,     0,     0,   339,     0,   340,
     341,   342,   343,   344,     0,   345,   346,     0,   347,   348,
       0,   349,     0,     0,   350,   351,  2460,     0,     0,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,     0,   367,   368,   369,   370,     0,   371,
     372,     0,   373,     0,   374,   375,   376,   377,   378,   379,
       0,   380,     0,     0,   381,   382,   383,     0,     0,   384,
     385,     0,   386,     0,   387,   388,   389,   390,   391,   392,
     393,   394,     0,   395,   396,   397,   398,   399,   400,   401,
       0,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,     0,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,     0,   426,   427,     0,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,     0,   439,   440,   441,   442,   443,     0,   444,   445,
     446,   447,     0,   448,   449,   450,     0,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,     0,   462,
     463,  2461,   464,   465,  2462,   467,  2463,   469,     0,   470,
     471,     0,     0,   472,   473,   474,   475,     0,   476,   477,
     478,   479,   480,   481,   482,     0,     0,   483,   484,  2464,
     486,   487,     0,     0,   488,   489,   490,   491,   492,   493,
     494,     0,   495,     0,   496,   497,   498,   499,     0,     0,
     500,     0,     0,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,   516,   517,
     518,   210,     0,   574,     0,     0,     0,     0,     0,     0,
       0,     0,   211,   212,   213,   214,   215,   216,   217,   218,
       0,   220,   221,   222,     0,     0,     0,     0,   223,     0,
       0,     0,   224,   225,     0,   226,   227,     0,   228,   229,
     230,   231,   232,     0,   233,   234,     0,   235,   236,   237,
     238,   239,     0,     0,   240,   241,   242,   243,   244,     0,
     245,   246,   247,   248,   249,     0,     0,     0,   250,   251,
     252,   253,     0,   254,   255,     0,   256,   257,   258,   259,
     260,   261,     0,     0,   262,   263,     0,     0,     0,     0,
       0,     0,     0,   264,   265,   266,   267,   268,   269,   270,
     271,   272,     0,   273,     0,   274,   275,   276,   277,   278,
       0,   279,   280,   281,     0,     0,   282,   283,   284,   285,
     286,     0,   287,   288,   289,     0,   290,   291,   292,     0,
     293,   294,   295,   296,   297,   298,   299,   300,   301,     0,
     302,     0,   303,   304,   305,   306,     0,   307,     0,   308,
       0,     0,     0,   309,   310,   311,     0,   312,   313,     0,
     314,     0,   315,   316,   317,   318,   319,     0,   320,   321,
     322,     0,   323,   324,   325,   326,   327,   328,     0,   329,
       0,   330,   331,   332,   333,   334,   335,   336,     0,   337,
       0,   338,     0,     0,   339,     0,   340,   341,   342,   343,
     344,     0,   345,   346,     0,   347,   348,     0,   349,     0,
       0,   350,   351,   352,     0,     0,   353,   354,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,   366,
       0,   367,   368,   369,   370,     0,   371,   372,     0,   373,
       0,   374,   375,   376,   377,   378,   379,     0,   380,     0,
       0,   381,   382,   383,     0,     0,   384,   385,     0,   386,
       0,   387,   388,   389,   390,   391,   392,   393,   394,     0,
     395,   396,   397,   398,   399,   400,   401,     0,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,     0,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,     0,   426,   427,     0,   428,   429,   430,
     431,   432,   433,   434,   435,   436,   437,   438,     0,   439,
     440,   441,   442,   443,     0,   444,   445,   446,   447,     0,
     448,   449,   450,     0,   451,   452,   453,   454,   455,   456,
     457,   458,   459,   460,   461,     0,   462,   463,     0,   464,
     465,   466,   467,   468,   469,     0,   470,   471,     0,     0,
     472,   473,   474,   475,     0,   476,   477,   478,   479,   480,
     481,   482,     0,     0,   483,   484,   485,   486,   487,     0,
       0,   488,   489,   490,   491,   492,   493,   494,     0,   495,
       0,   496,   497,   498,   499,     0,     0,   500,     0,     0,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,   513,   514,   515,   516,   517,   518,   210,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   211,
     212,   213,   214,   215,   216,   217,   218,     0,   220,   221,
     222,     0,     0,     0,     0,   223,     0,  3571,     0,   224,
     225,     0,   226,   227,     0,   228,   229,   230,   231,   232,
       0,   233,   234,     0,   235,   236,   237,   238,   239,     0,
       0,   240,   241,   242,   243,   244,     0,   245,   246,   247,
     248,   249,     0,     0,     0,   250,   251,   252,   253,     0,
     254,   255,     0,   256,   257,   258,   259,   260,   261,     0,
       0,   262,   263,     0,     0,     0,     0,     0,     0,     0,
     264,   265,   266,   267,   268,   269,   270,   271,   272,     0,
     273,     0,   274,   275,   276,   277,   278,     0,   279,   280,
     281,     0,     0,   282,   283,   284,   285,   286,     0,   287,
     288,   289,     0,   290,   291,   292,     0,   293,   294,   295,
     296,   297,   298,   299,   300,   301,     0,   302,     0,   303,
     304,   305,   306,     0,   307,     0,   308,     0,     0,     0,
     309,   310,   311,     0,   312,   313,     0,   314,     0,   315,
     316,   317,   318,   319,     0,   320,   321,   322,     0,   323,
     324,   325,   326,   327,   328,     0,   329,     0,   330,   331,
     332,   333,   334,   335,   336,     0,   337,     0,   338,     0,
       0,   339,     0,   340,   341,   342,   343,   344,     0,   345,
     346,     0,   347,   348,     0,   349,     0,     0,   350,   351,
     352,     0,     0,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,     0,   367,   368,
     369,   370,     0,   371,   372,     0,   373,     0,   374,   375,
     376,   377,   378,   379,     0,   380,     0,     0,   381,   382,
     383,     0,     0,   384,   385,     0,   386,     0,   387,   388,
     389,   390,   391,   392,   393,   394,     0,   395,   396,   397,
     398,   399,   400,   401,     0,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,     0,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
       0,   426,   427,     0,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,     0,   439,   440,   441,   442,
     443,     0,   444,   445,   446,   447,     0,   448,   449,   450,
       0,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,     0,   462,   463,     0,   464,   465,   466,   467,
     468,   469,     0,   470,   471,     0,     0,   472,   473,   474,
     475,     0,   476,   477,   478,   479,   480,   481,   482,     0,
       0,   483,   484,   485,   486,   487,     0,     0,   488,   489,
     490,   491,   492,   493,   494,     0,   495,     0,   496,   497,
     498,   499,     0,     0,   500,     0,     0,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   210,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   211,   212,   213,   214,
     215,   216,   217,   218,     0,   220,   221,   222,     0,     0,
       0,     0,   223,     0,  3585,     0,   224,   225,     0,   226,
     227,     0,   228,   229,   230,   231,   232,     0,   233,   234,
       0,   235,   236,   237,   238,   239,     0,     0,   240,   241,
     242,   243,   244,     0,   245,   246,   247,   248,   249,     0,
       0,     0,   250,   251,   252,   253,     0,   254,   255,     0,
     256,   257,   258,   259,   260,   261,     0,     0,   262,   263,
       0,     0,     0,     0,     0,     0,     0,   264,   265,   266,
     267,   268,   269,   270,   271,   272,     0,   273,     0,   274,
     275,   276,   277,   278,     0,   279,   280,   281,     0,     0,
     282,   283,   284,   285,   286,     0,   287,   288,   289,     0,
     290,   291,   292,     0,   293,   294,   295,   296,   297,   298,
     299,   300,   301,     0,   302,     0,   303,   304,   305,   306,
       0,   307,     0,   308,     0,     0,     0,   309,   310,   311,
       0,   312,   313,     0,   314,     0,   315,   316,   317,   318,
     319,     0,   320,   321,   322,     0,   323,   324,   325,   326,
     327,   328,     0,   329,     0,   330,   331,   332,   333,   334,
     335,   336,     0,   337,     0,   338,     0,     0,   339,     0,
     340,   341,   342,   343,   344,     0,   345,   346,     0,   347,
     348,     0,   349,     0,     0,   350,   351,   352,     0,     0,
     353,   354,   355,   356,   357,   358,   359,   360,   361,   362,
     363,   364,   365,   366,     0,   367,   368,   369,   370,     0,
     371,   372,     0,   373,     0,   374,   375,   376,   377,   378,
     379,     0,   380,     0,     0,   381,   382,   383,     0,     0,
     384,   385,     0,   386,     0,   387,   388,   389,   390,   391,
     392,   393,   394,     0,   395,   396,   397,   398,   399,   400,
     401,     0,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,     0,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,     0,   426,   427,
       0,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,     0,   439,   440,   441,   442,   443,     0,   444,
     445,   446,   447,     0,   448,   449,   450,     0,   451,   452,
     453,   454,   455,   456,   457,   458,   459,   460,   461,     0,
     462,   463,     0,   464,   465,   466,   467,   468,   469,     0,
     470,   471,     0,     0,   472,   473,   474,   475,     0,   476,
     477,   478,   479,   480,   481,   482,     0,     0,   483,   484,
     485,   486,   487,     0,     0,   488,   489,   490,   491,   492,
     493,   494,     0,   495,     0,   496,   497,   498,   499,     0,
       0,   500,     0,     0,   501,   502,   503,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
     517,   518,   210,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   211,   212,   213,   214,   215,   216,   217,
     218,     0,   220,   221,   222,     0,     0,     0,     0,   223,
       0,     0,     0,   224,   225,     0,   226,   227,     0,   228,
     229,   230,   231,   232,     0,   233,   234,     0,   235,   236,
     237,   238,   239,     0,     0,   240,   241,   242,   243,   244,
       0,   245,   246,   247,   248,   249,     0,     0,     0,   250,
     251,   252,   253,     0,   254,   255,     0,   256,   257,   258,
     259,   260,   261,     0,     0,   262,   263,     0,     0,     0,
       0,     0,     0,     0,   264,   265,   266,   267,   268,   269,
     270,   271,   272,  3796,   273,     0,   274,   275,   276,   277,
     278,     0,   279,   280,   281,     0,     0,   282,   283,   284,
     285,   286,     0,   287,   288,   289,     0,   290,   291,   292,
       0,   293,   294,   295,   296,   297,   298,   299,   300,   301,
       0,   302,     0,   303,   304,   305,   306,     0,   307,     0,
     308,     0,     0,     0,   309,   310,   311,     0,   312,   313,
       0,   314,     0,   315,   316,   317,   318,   319,     0,   320,
     321,   322,     0,   323,   324,   325,   326,   327,   328,     0,
     329,     0,   330,   331,   332,   333,   334,   335,   336,     0,
     337,     0,   338,     0,     0,   339,     0,   340,   341,   342,
     343,   344,     0,   345,   346,     0,   347,   348,     0,   349,
       0,     0,   350,   351,   352,     0,     0,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,     0,   367,   368,   369,   370,     0,   371,   372,     0,
     373,     0,   374,   375,   376,   377,   378,   379,     0,   380,
       0,     0,   381,   382,   383,     0,     0,   384,   385,     0,
     386,     0,   387,   388,   389,   390,   391,   392,   393,   394,
       0,   395,   396,   397,   398,   399,   400,   401,     0,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,     0,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,     0,   426,   427,     0,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,     0,
     439,   440,   441,   442,   443,     0,   444,   445,   446,   447,
       0,   448,   449,   450,     0,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,     0,   462,   463,     0,
     464,   465,   466,   467,   468,   469,     0,   470,   471,     0,
       0,   472,   473,   474,   475,     0,   476,   477,   478,   479,
     480,   481,   482,     0,     0,   483,   484,   485,   486,   487,
       0,     0,   488,   489,   490,   491,   492,   493,   494,     0,
     495,     0,   496,   497,   498,   499,     0,     0,   500,     0,
       0,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   210,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     211,   212,   213,   214,   215,   216,   217,   218,     0,   220,
     221,   222,     0,     0,     0,     0,   223,     0,     0,     0,
     224,   225,     0,   226,   227,     0,   228,   229,   230,   231,
     232,     0,   233,   234,     0,   235,   236,   237,   238,   239,
       0,     0,   240,   241,   242,   243,   244,     0,   245,   246,
     247,   248,   249,     0,     0,     0,   250,   251,   252,   253,
       0,   254,   255,     0,   256,   257,   258,   259,   260,   261,
       0,     0,   262,   263,     0,     0,     0,     0,     0,     0,
       0,   264,   265,   266,   267,   268,   269,   270,   271,   272,
    3798,   273,     0,   274,   275,   276,   277,   278,     0,   279,
     280,   281,     0,     0,   282,   283,   284,   285,   286,     0,
     287,   288,   289,     0,   290,   291,   292,     0,   293,   294,
     295,   296,   297,   298,   299,   300,   301,     0,   302,     0,
     303,   304,   305,   306,     0,   307,     0,   308,     0,     0,
       0,   309,   310,   311,     0,   312,   313,     0,   314,     0,
     315,   316,   317,   318,   319,     0,   320,   321,   322,     0,
     323,   324,   325,   326,   327,   328,     0,   329,     0,   330,
     331,   332,   333,   334,   335,   336,     0,   337,     0,   338,
       0,     0,   339,     0,   340,   341,   342,   343,   344,     0,
     345,   346,     0,   347,   348,     0,   349,     0,     0,   350,
     351,   352,     0,     0,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,   365,   366,     0,   367,
     368,   369,   370,     0,   371,   372,     0,   373,     0,   374,
     375,   376,   377,   378,   379,     0,   380,     0,     0,   381,
     382,   383,     0,     0,   384,   385,     0,   386,     0,   387,
     388,   389,   390,   391,   392,   393,   394,     0,   395,   396,
     397,   398,   399,   400,   401,     0,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,     0,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,     0,   426,   427,     0,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,   438,     0,   439,   440,   441,
     442,   443,     0,   444,   445,   446,   447,     0,   448,   449,
     450,     0,   451,   452,   453,   454,   455,   456,   457,   458,
     459,   460,   461,     0,   462,   463,     0,   464,   465,   466,
     467,   468,   469,     0,   470,   471,     0,     0,   472,   473,
     474,   475,     0,   476,   477,   478,   479,   480,   481,   482,
       0,     0,   483,   484,   485,   486,   487,     0,     0,   488,
     489,   490,   491,   492,   493,   494,     0,   495,     0,   496,
     497,   498,   499,     0,     0,   500,     0,     0,   501,   502,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
     513,   514,   515,   516,   517,   518,   210,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   211,   212,   213,
     214,   215,   216,   217,   218,     0,   220,   221,   222,     0,
       0,     0,     0,   223,     0,     0,     0,   224,   225,     0,
     226,   227,     0,   228,   229,   230,   231,   232,     0,   233,
     234,     0,   235,   236,   237,   238,   239,     0,     0,   240,
     241,   242,   243,   244,     0,   245,   246,   247,   248,   249,
       0,     0,     0,   250,   251,   252,   253,     0,   254,   255,
       0,   256,   257,   258,   259,   260,   261,     0,     0,   262,
     263,     0,     0,     0,     0,     0,     0,     0,   264,   265,
     266,   267,   268,   269,   270,   271,   272,  3800,   273,     0,
     274,   275,   276,   277,   278,     0,   279,   280,   281,     0,
       0,   282,   283,   284,   285,   286,     0,   287,   288,   289,
       0,   290,   291,   292,     0,   293,   294,   295,   296,   297,
     298,   299,   300,   301,     0,   302,     0,   303,   304,   305,
     306,     0,   307,     0,   308,     0,     0,     0,   309,   310,
     311,     0,   312,   313,     0,   314,     0,   315,   316,   317,
     318,   319,     0,   320,   321,   322,     0,   323,   324,   325,
     326,   327,   328,     0,   329,     0,   330,   331,   332,   333,
     334,   335,   336,     0,   337,     0,   338,     0,     0,   339,
       0,   340,   341,   342,   343,   344,     0,   345,   346,     0,
     347,   348,     0,   349,     0,     0,   350,   351,   352,     0,
       0,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   366,     0,   367,   368,   369,   370,
       0,   371,   372,     0,   373,     0,   374,   375,   376,   377,
     378,   379,     0,   380,     0,     0,   381,   382,   383,     0,
       0,   384,   385,     0,   386,     0,   387,   388,   389,   390,
     391,   392,   393,   394,     0,   395,   396,   397,   398,   399,
     400,   401,     0,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,     0,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,     0,   426,
     427,     0,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,     0,   439,   440,   441,   442,   443,     0,
     444,   445,   446,   447,     0,   448,   449,   450,     0,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,   461,
       0,   462,   463,     0,   464,   465,   466,   467,   468,   469,
       0,   470,   471,     0,     0,   472,   473,   474,   475,     0,
     476,   477,   478,   479,   480,   481,   482,     0,     0,   483,
     484,   485,   486,   487,     0,     0,   488,   489,   490,   491,
     492,   493,   494,     0,   495,     0,   496,   497,   498,   499,
       0,     0,   500,     0,     0,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   210,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   211,   212,   213,   214,   215,   216,
     217,   218,     0,   220,   221,   222,     0,     0,     0,     0,
     223,     0,     0,     0,   224,   225,     0,   226,   227,     0,
     228,   229,   230,   231,   232,     0,   233,   234,     0,   235,
     236,   237,   238,   239,     0,     0,   240,   241,   242,   243,
     244,     0,   245,   246,   247,   248,   249,     0,     0,     0,
     250,   251,   252,   253,     0,   254,   255,     0,   256,   257,
     258,   259,   260,   261,     0,     0,   262,   263,     0,     0,
       0,     0,     0,     0,     0,   264,   265,   266,   267,   268,
     269,   270,   271,   272,     0,   273,     0,   274,   275,   276,
     277,   278,     0,   279,   280,   281,     0,     0,   282,   283,
     284,   285,   286,     0,   287,   288,   289,     0,   290,   291,
     292,     0,   293,   294,   295,   296,   297,   298,   299,   300,
     301,     0,   302,     0,   303,   304,   305,   306,     0,   307,
       0,   308,     0,     0,     0,   309,   310,   311,     0,   312,
     313,     0,   314,     0,   315,   316,   317,   318,   319,     0,
     320,   321,   322,     0,   323,   324,   325,   326,   327,   328,
       0,   329,     0,   330,   331,   332,   333,   334,   335,   336,
       0,   337,     0,   338,     0,     0,   339,     0,   340,   341,
     342,   343,   344,     0,   345,   346,     0,   347,   348,     0,
     349,     0,     0,   350,   351,   352,     0,     0,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,     0,   367,   368,   369,   370,     0,   371,   372,
       0,   373,     0,   374,   375,   376,   377,   378,   379,     0,
     380,     0,     0,   381,   382,   383,     0,     0,   384,   385,
       0,   386,     0,   387,   388,   389,   390,   391,   392,   393,
     394,     0,   395,   396,   397,   398,   399,   400,   401,     0,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,     0,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,     0,   426,   427,     0,   428,
     429,   430,   431,   432,   433,   434,   435,   436,   437,   438,
       0,   439,   440,   441,   442,   443,     0,   444,   445,   446,
     447,     0,   448,   449,   450,     0,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,     0,   462,   463,
       0,   464,   465,   466,   467,   468,   469,     0,   470,   471,
       0,     0,   472,   473,   474,   475,     0,   476,   477,   478,
     479,   480,   481,   482,     0,     0,   483,   484,   485,   486,
     487,     0,  4194,   488,   489,   490,   491,   492,   493,   494,
       0,   495,     0,   496,   497,   498,   499,     0,     0,   500,
       0,     0,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
     210,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   211,   212,   213,   214,   215,   216,   217,   218,     0,
     220,   221,   222,     0,     0,     0,     0,   223,     0,     0,
       0,   224,   225,     0,   226,   227,     0,   228,   229,   230,
     231,   232,     0,   233,   234,     0,   235,   236,   237,   238,
     239,     0,     0,   240,   241,   242,   243,   244,     0,   245,
     246,   247,   248,   249,     0,     0,     0,   250,   251,   252,
     253,     0,   254,   255,     0,   256,   257,   258,   259,   260,
     261,     0,     0,   262,   263,     0,     0,     0,     0,     0,
       0,     0,   264,   265,   266,   267,   268,   269,   270,   271,
     272,     0,   273,     0,   274,   275,   276,   277,   278,     0,
     279,   280,   281,     0,     0,   282,   283,   284,   285,   286,
       0,   287,   288,   289,     0,   290,   291,   292,     0,   293,
     294,   295,   296,   297,   298,   299,   300,   301,     0,   302,
       0,   303,   304,   305,   306,     0,   307,     0,   308,     0,
       0,     0,   309,   310,   311,     0,   312,   313,     0,   314,
       0,   315,   316,   317,   318,   319,     0,   320,   321,   322,
       0,   323,   324,   325,   326,   327,   328,     0,   329,     0,
     330,   331,   332,   333,   334,   335,   336,     0,   337,     0,
     338,     0,     0,   339,     0,   340,   341,   342,   343,   344,
       0,   345,   346,     0,   347,   348,     0,   349,     0,     0,
     350,   351,   352,     0,     0,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   366,     0,
     367,   368,   369,   370,     0,   371,   372,     0,   373,     0,
     374,   375,   376,   377,   378,   379,     0,   380,     0,     0,
     381,   382,   383,     0,     0,   384,   385,     0,   386,     0,
     387,   388,   389,   390,   391,   392,   393,   394,     0,   395,
     396,   397,   398,   399,   400,   401,     0,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
       0,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,     0,   426,   427,     0,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,     0,   439,   440,
     441,   442,   443,     0,   444,   445,   446,   447,     0,   448,
     449,   450,     0,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,   461,     0,   462,   463,     0,   464,   465,
     466,   467,   468,   469,     0,   470,   471,     0,     0,   472,
     473,   474,   475,     0,   476,   477,   478,   479,   480,   481,
     482,     0,     0,   483,   484,   485,   486,   487,     0,     0,
     488,   489,   490,   491,   492,   493,   494,     0,   495,     0,
     496,   497,   498,   499,     0,     0,   500,     0,     0,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,   516,   517,   518,   210,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   211,   212,
     213,   214,   215,   216,   217,   218,     0,   220,   221,   222,
       0,     0,     0,     0,   223,     0,     0,     0,   224,   225,
       0,   226,   227,     0,   228,   229,   230,   231,   232,     0,
     233,   234,     0,   235,   236,   237,   238,   239,     0,     0,
     240,   241,   242,   243,   244,     0,   245,   246,   247,   248,
     249,     0,     0,     0,   250,   251,   252,   253,     0,   254,
     255,     0,   256,   257,   258,   259,   260,   261,     0,     0,
     262,   263,     0,     0,     0,     0,     0,     0,     0,   264,
     265,   266,   267,   268,   269,   270,   271,   272,     0,   273,
       0,   274,   275,   276,   277,   278,     0,   279,   280,   281,
       0,     0,   282,   283,   284,   285,   286,     0,   287,   288,
     289,     0,   290,   291,   292,     0,   293,   294,   295,   296,
     297,   298,   299,   300,   301,     0,   302,     0,   303,   304,
     305,   306,     0,   307,     0,   308,     0,     0,     0,   309,
     310,   311,     0,   312,   313,     0,   314,     0,   315,   316,
     317,   318,   319,     0,   320,   321,   322,     0,   323,   324,
     325,   326,   327,   328,     0,   329,     0,   330,   331,   332,
     333,   334,   335,   336,     0,   337,     0,   338,     0,     0,
     339,     0,   340,   341,   342,   343,   344,     0,   345,   346,
       0,   347,   348,     0,   349,     0,     0,   350,   351,   352,
       0,     0,   353,   354,   355,   356,   357,   358,   359,   360,
     361,   362,   363,   364,   365,   366,     0,   367,   368,   369,
     370,     0,   371,   372,     0,   373,     0,   374,   375,   376,
     377,   378,   379,     0,   380,     0,     0,   381,   382,   383,
       0,     0,   384,   385,     0,   386,     0,   387,   388,   389,
     390,   391,   392,   393,   394,     0,   395,   396,   397,   398,
     399,   400,   401,     0,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,     0,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,     0,
     426,   427,     0,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,     0,   439,   440,   441,   442,   443,
       0,   444,   445,   446,   447,     0,   448,   449,   450,     0,
     451,   452,   453,   454,   455,   456,   457,   458,   459,   460,
     461,     0,   462,   463,     0,   464,   465,   466,   467,   468,
     469,     0,   470,   471,     0,     0,   659,   473,   474,   475,
       0,   476,   477,   478,   479,   480,   481,   482,     0,     0,
     483,   484,   485,   486,   487,     0,     0,   488,   489,   490,
     491,   492,   493,   494,     0,   495,     0,   496,   497,   498,
     499,     0,     0,   500,     0,     0,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   210,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   211,   212,   213,   214,   215,
     216,   217,   218,     0,   220,   221,   222,     0,     0,     0,
       0,   223,     0,     0,     0,   224,   225,     0,   226,   227,
       0,   228,   229,   230,   231,   232,     0,   233,   234,     0,
     235,   236,   237,   238,   239,     0,     0,   240,   241,   242,
     243,   244,     0,   245,   246,   247,   248,   249,     0,     0,
       0,   250,   251,   252,   253,     0,   254,   255,     0,   256,
     257,   258,   259,   260,   261,     0,     0,   262,   263,     0,
       0,     0,     0,     0,     0,     0,   264,   265,   266,   267,
     268,   269,   270,   271,   272,     0,   273,     0,   274,   275,
     276,   277,   278,     0,   279,   280,   281,     0,     0,   282,
     283,   284,   285,   286,     0,   287,   288,   289,     0,   290,
     291,   292,     0,   293,   294,   295,   296,   297,   298,   299,
     300,   301,     0,   302,     0,   303,   304,   305,   306,     0,
     307,     0,   308,     0,     0,     0,   309,   310,   311,     0,
     312,   313,     0,   314,     0,   315,   316,   317,   318,   319,
       0,   320,   321,   322,     0,   323,   324,   325,   326,   327,
     328,     0,   329,     0,   330,   331,   332,   333,   334,   335,
     336,     0,   337,     0,   338,     0,     0,   339,     0,   340,
     341,   342,   343,   344,     0,   345,   346,     0,   347,   348,
       0,   349,     0,     0,   350,   351,   352,     0,     0,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,     0,   367,   368,   369,   370,     0,   371,
     372,     0,   373,     0,   374,   375,   376,   377,   378,   379,
       0,   380,     0,     0,   381,   382,   383,     0,     0,   384,
     385,     0,   386,     0,   387,   388,   389,   390,   391,   392,
     393,   394,     0,   395,   396,   397,   398,   399,   400,   401,
       0,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,     0,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,     0,   426,   427,     0,
     428,   429,   430,   431,   432,   668,   434,   435,   436,   437,
     438,     0,   439,   440,   441,   442,   443,     0,   444,   445,
     446,   447,     0,   448,   449,   450,     0,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,     0,   462,
     463,     0,   464,   465,   466,   467,   468,   469,     0,   470,
     471,     0,     0,   472,   473,   474,   475,     0,   476,   477,
     478,   479,   480,   481,   482,     0,     0,   483,   484,   485,
     486,   487,     0,     0,   488,   489,   490,   491,   492,   493,
     494,     0,   495,     0,   496,   497,   498,   499,     0,     0,
     500,     0,     0,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,   516,   517,
     518,   210,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   211,   212,   213,   214,   215,   216,   217,   218,
       0,   220,   221,   222,     0,     0,     0,     0,   223,     0,
       0,     0,   224,   225,     0,   226,   227,     0,   228,   229,
     230,   231,   232,     0,   233,   234,     0,   235,   236,   237,
     238,   239,     0,     0,   689,   241,   242,   243,   244,     0,
     245,   246,   247,   248,   249,     0,     0,     0,   250,   251,
     252,   253,     0,   254,   255,     0,   690,   257,   258,   259,
     260,   261,     0,     0,   262,   263,     0,     0,     0,     0,
       0,     0,     0,   264,   265,   266,   267,   268,   269,   270,
     271,   272,     0,   273,     0,   274,   275,   276,   277,   278,
       0,   279,   280,   281,     0,     0,   282,   283,   284,   285,
     286,     0,   287,   288,   289,     0,   290,   291,   292,     0,
     293,   294,   295,   296,   297,   298,   299,   300,   301,     0,
     302,     0,   303,   304,   305,   306,     0,   307,     0,   308,
       0,     0,     0,   309,   310,   311,     0,   312,   313,     0,
     314,     0,   315,   316,   317,   318,   319,     0,   320,   321,
     322,     0,   323,   324,   325,   326,   327,   328,     0,   329,
       0,   330,   331,   332,   333,   334,   335,   336,     0,   337,
       0,   338,     0,     0,   339,     0,   340,   341,   342,   343,
     344,     0,   345,   346,     0,   347,   348,     0,   349,     0,
       0,   350,   351,   691,     0,     0,   353,   354,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   692,   366,
       0,   367,   368,   369,   370,     0,   371,   372,     0,   373,
       0,   374,   375,   376,   377,   378,   379,     0,   380,     0,
       0,   381,   382,   383,     0,     0,   384,   385,     0,   386,
       0,   387,   388,   389,   390,   391,   392,   393,   394,     0,
     395,   396,   397,   398,   399,   400,   401,     0,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,     0,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,     0,   426,   427,     0,   693,   429,   430,
     431,   432,   433,   694,   435,   436,   437,   438,     0,   439,
     440,   441,   442,   695,     0,   444,   445,   446,   447,     0,
     448,   449,   450,     0,   451,   452,   453,   454,   455,   456,
     457,   458,   459,   460,   461,     0,   462,   463,     0,   464,
     465,   466,   467,   468,   469,     0,   696,   471,     0,     0,
     697,   473,   474,   475,     0,   476,   477,   478,   479,   480,
     481,   482,     0,     0,   483,   484,   485,   486,   487,     0,
       0,   488,   489,   490,   491,   492,   493,   494,     0,   495,
       0,   496,   497,   498,   499,     0,     0,   500,     0,     0,
     501,   502,   503,   504,   505,   698,   507,   508,   509,   510,
     511,   512,   513,   514,   515,   516,   517,   518,   210,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   211,
     212,   213,   214,   215,   216,   217,   218,     0,   220,   221,
     222,     0,     0,     0,     0,   223,     0,     0,     0,   224,
     225,     0,   226,   227,     0,   228,   229,   230,   231,   232,
       0,   233,   234,     0,   235,   236,   237,   238,   239,     0,
       0,   240,   241,   242,   243,   244,     0,   245,   246,   247,
     248,   249,     0,     0,     0,   250,   251,   252,   253,     0,
     254,   255,     0,   256,   257,   258,   259,   260,   261,     0,
       0,   262,   263,     0,     0,     0,     0,     0,     0,     0,
     264,   265,   266,   267,   268,   269,   270,   271,   272,     0,
     273,     0,   274,   275,   276,   277,   278,     0,   279,   280,
     281,     0,     0,   282,   283,   284,   285,   286,     0,   287,
     288,   289,     0,   290,   291,   292,     0,   293,   294,   295,
     296,   297,   298,   299,   300,   301,     0,   302,     0,   303,
     304,   305,   306,     0,   307,     0,   308,     0,     0,     0,
     309,   310,   311,     0,   312,   313,     0,   314,     0,   315,
     316,   317,   318,   319,     0,   320,   321,   322,     0,   323,
     324,   325,   326,   327,   328,     0,   329,     0,   330,   331,
     332,   333,   334,   335,   336,     0,   337,     0,   338,     0,
       0,   339,     0,   340,   341,   342,   343,   344,     0,   345,
     346,     0,   347,   348,     0,   349,     0,     0,   350,   351,
     352,     0,     0,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,     0,   367,   368,
     369,   370,     0,   371,   372,     0,   373,     0,   374,   375,
     376,   377,   378,   379,     0,   380,     0,     0,   381,   382,
     383,     0,     0,   384,   385,     0,   386,     0,   387,   388,
     389,   390,   391,   392,   393,   394,     0,   395,   396,   397,
     398,   399,   400,   401,     0,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   721,   414,     0,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
       0,   426,   427,     0,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,     0,   439,   440,   441,   442,
     443,     0,   444,   445,   446,   447,     0,   448,   449,   450,
       0,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,     0,   462,   463,     0,   464,   465,   466,   467,
     468,   469,     0,   470,   471,     0,     0,   472,   473,   474,
     475,     0,   476,   477,   478,   479,   480,   481,   482,     0,
       0,   483,   484,   485,   486,   487,     0,     0,   488,   489,
     490,   491,   492,   493,   494,     0,   495,     0,   496,   497,
     498,   499,     0,     0,   500,     0,     0,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   210,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   211,   212,   213,   214,
     215,   216,   217,   218,     0,   220,   221,   222,     0,     0,
       0,     0,   223,     0,     0,     0,   224,   225,     0,   226,
     227,     0,   228,   229,   230,   231,   232,     0,   233,   234,
       0,   235,   236,   237,   238,   239,     0,     0,   240,   241,
     242,   243,   244,     0,   245,   246,   247,   248,   249,     0,
       0,     0,   250,   251,   252,   253,     0,   254,   255,     0,
     256,   257,   258,   259,   260,   261,     0,     0,   262,   263,
       0,     0,     0,     0,     0,     0,     0,   264,   265,   266,
     267,   268,   269,   270,   271,   272,     0,   273,     0,   274,
     275,   276,   277,   278,     0,   279,   280,   281,     0,     0,
     282,   283,   284,   285,   286,     0,   287,   288,   289,     0,
     290,   291,   292,     0,   293,   294,   295,   296,   297,   298,
     299,   300,   301,     0,   302,     0,   303,   304,   305,   306,
       0,   307,     0,   308,     0,     0,     0,   309,   310,   311,
       0,   312,   313,     0,   314,     0,   315,   316,   317,   318,
     818,     0,   320,   321,   322,     0,   323,   324,   325,   326,
     327,   328,     0,   329,     0,   330,   331,   332,   333,   334,
     335,   336,     0,   337,     0,   338,     0,     0,   339,     0,
     340,   341,   342,   343,   344,     0,   345,   346,     0,   347,
     348,     0,   349,     0,     0,   350,   351,   352,     0,     0,
     353,   354,   355,   356,   357,   358,   359,   360,   361,   362,
     363,   364,   365,   366,     0,   367,   368,   369,   370,     0,
     371,   372,     0,   373,     0,   374,   375,   376,   377,   378,
     379,     0,   380,     0,     0,   381,   382,   383,     0,     0,
     384,   385,     0,   386,     0,   387,   388,   389,   390,   391,
     392,   393,   394,     0,   395,   396,   397,   398,   399,   400,
     401,     0,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,     0,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,     0,   426,   427,
       0,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,     0,   439,   440,   441,   442,   443,     0,   444,
     445,   446,   447,     0,   448,   449,   450,     0,   451,   452,
     453,   454,   455,   456,   457,   458,   459,   460,   461,     0,
     462,   463,     0,   464,   465,   466,   467,   468,   469,     0,
     470,   471,     0,     0,   472,   473,   474,   475,     0,   476,
     477,   478,   479,   480,   481,   482,     0,     0,   483,   484,
     485,   486,   487,     0,     0,   488,   489,   490,   491,   492,
     493,   494,     0,   495,     0,   496,   497,   498,   499,     0,
       0,   500,     0,     0,   501,   502,   503,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
     517,   518,   210,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   211,   212,   213,   214,   215,   216,   217,
     218,     0,   220,   221,   222,     0,     0,     0,     0,   223,
       0,     0,     0,   224,   225,     0,   226,   227,     0,   228,
     229,   230,   231,   232,     0,   233,   234,     0,   235,   236,
     237,   238,   239,     0,     0,   240,   241,   242,   243,   244,
       0,   245,   246,   247,   248,   249,     0,     0,     0,   250,
     251,   252,   253,     0,   254,   255,     0,   256,   257,   258,
     259,   260,   261,     0,     0,   262,   263,     0,     0,     0,
       0,     0,     0,     0,   264,   265,   266,   267,   268,   269,
     270,   271,   272,     0,   273,     0,   274,   275,   276,   277,
     278,     0,   279,   280,   281,     0,     0,   282,   283,   284,
     285,   286,     0,   287,   288,   289,     0,   290,   291,   292,
       0,   293,   294,   295,   296,   297,   298,   299,   300,   301,
       0,   302,     0,   303,   304,   305,   306,     0,   307,     0,
     308,     0,     0,     0,   309,   310,   311,     0,   312,   313,
       0,   314,     0,   315,   316,   317,   318,   832,     0,   320,
     321,   322,     0,   323,   324,   325,   326,   327,   328,     0,
     329,     0,   330,   331,   332,   333,   334,   335,   336,     0,
     337,     0,   338,     0,     0,   339,     0,   340,   341,   342,
     343,   344,     0,   345,   346,     0,   347,   348,     0,   349,
       0,     0,   350,   351,   352,     0,     0,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,     0,   367,   368,   369,   370,     0,   371,   372,     0,
     373,     0,   374,   375,   376,   377,   378,   379,     0,   380,
       0,     0,   381,   382,   383,     0,     0,   384,   385,     0,
     386,     0,   387,   388,   389,   390,   391,   392,   393,   394,
       0,   395,   396,   397,   398,   399,   400,   401,     0,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,     0,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,     0,   426,   427,     0,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,     0,
     439,   440,   441,   442,   443,     0,   444,   445,   446,   447,
       0,   448,   449,   450,     0,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,     0,   462,   463,     0,
     464,   465,   466,   467,   468,   469,     0,   470,   471,     0,
       0,   472,   473,   474,   475,     0,   476,   477,   478,   479,
     480,   481,   482,     0,     0,   483,   484,   485,   486,   487,
       0,     0,   488,   489,   490,   491,   492,   493,   494,     0,
     495,     0,   496,   497,   498,   499,     0,     0,   500,     0,
       0,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   210,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     211,   212,   213,   214,   215,   216,   217,   218,     0,   220,
     221,   222,     0,     0,     0,     0,   223,     0,     0,     0,
     224,   225,     0,   226,   227,     0,   228,   229,   230,   231,
     232,     0,   233,   234,     0,   235,   236,   237,   238,   239,
       0,     0,   240,   241,   242,   243,   244,     0,   245,   246,
     247,   248,   249,     0,     0,     0,   250,   251,   252,   253,
       0,   254,   255,     0,   256,   257,   258,   259,   260,   261,
       0,     0,   262,   263,     0,     0,     0,     0,     0,     0,
       0,   264,   265,   266,   267,   268,   269,   270,   271,   272,
       0,   273,     0,   274,   275,   276,   277,   278,     0,   279,
     280,   281,     0,     0,   282,   283,   284,   285,   286,     0,
     287,   288,   289,     0,   290,   291,   292,     0,   293,   294,
     295,   296,   297,   298,   299,   300,   301,     0,   302,     0,
     303,   304,   305,   306,     0,   307,     0,   308,     0,     0,
       0,   309,   310,   311,     0,   312,   313,     0,   314,     0,
     315,   316,   317,   318,   885,     0,   320,   321,   322,     0,
     323,   324,   325,   326,   327,   328,     0,   329,     0,   330,
     331,   332,   333,   334,   335,   336,     0,   337,     0,   338,
       0,     0,   339,     0,   340,   341,   342,   343,   344,     0,
     345,   346,     0,   347,   348,     0,   349,     0,     0,   350,
     351,   352,     0,     0,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,   365,   366,     0,   367,
     368,   369,   370,     0,   371,   372,     0,   373,     0,   374,
     375,   376,   377,   378,   379,     0,   380,     0,     0,   381,
     382,   383,     0,     0,   384,   385,     0,   386,     0,   387,
     388,   389,   390,   391,   392,   393,   394,     0,   395,   396,
     397,   398,   399,   400,   401,     0,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,     0,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,     0,   426,   427,     0,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,   438,     0,   439,   440,   441,
     442,   443,     0,   444,   445,   446,   447,     0,   448,   449,
     450,     0,   451,   452,   453,   454,   455,   456,   457,   458,
     459,   460,   461,     0,   462,   463,     0,   464,   465,   466,
     467,   468,   469,     0,   470,   471,     0,     0,   472,   473,
     474,   475,     0,   476,   477,   478,   479,   480,   481,   482,
       0,     0,   483,   484,   485,   486,   487,     0,     0,   488,
     489,   490,   491,   492,   493,   494,     0,   495,     0,   496,
     497,   498,   499,     0,     0,   500,     0,     0,   501,   502,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
     513,   514,   515,   516,   517,   518,   210,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   211,   212,   213,
     214,   215,   216,   217,   218,     0,   220,   221,   222,     0,
       0,     0,     0,   223,     0,     0,     0,   224,   225,     0,
     226,   227,     0,   228,   229,   230,   231,   232,     0,   233,
     234,     0,   235,   236,   237,   238,   239,     0,     0,   240,
     241,   242,   243,   244,     0,   245,   246,   247,   248,   249,
       0,     0,     0,   250,   251,   252,   253,     0,   254,   255,
       0,   256,   257,   258,   259,   260,   261,     0,     0,   262,
     263,     0,     0,     0,     0,     0,     0,     0,   264,   265,
     266,   267,   268,   269,   270,   271,   272,     0,   273,     0,
     274,   275,   276,   277,   278,     0,   279,   280,   281,     0,
       0,   282,   283,   284,   285,   286,     0,   287,   288,   289,
       0,   290,   291,   292,     0,   293,   294,   295,   296,   297,
     298,   299,   300,   301,     0,   302,     0,   303,   304,   305,
     306,     0,   307,     0,   308,     0,     0,     0,   309,   310,
     311,     0,   312,   313,     0,   314,     0,   315,   316,   317,
     318,   899,     0,   320,   321,   322,     0,   323,   324,   325,
     326,   327,   328,     0,   329,     0,   330,   331,   332,   333,
     334,   335,   336,     0,   337,     0,   338,     0,     0,   339,
       0,   340,   341,   342,   343,   344,     0,   345,   346,     0,
     347,   348,     0,   349,     0,     0,   350,   351,   352,     0,
       0,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   366,     0,   367,   368,   369,   370,
       0,   371,   372,     0,   373,     0,   374,   375,   376,   377,
     378,   379,     0,   380,     0,     0,   381,   382,   383,     0,
       0,   384,   385,     0,   386,     0,   387,   388,   389,   390,
     391,   392,   393,   394,     0,   395,   396,   397,   398,   399,
     400,   401,     0,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,     0,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,     0,   426,
     427,     0,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,     0,   439,   440,   441,   442,   443,     0,
     444,   445,   446,   447,     0,   448,   449,   450,     0,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,   461,
       0,   462,   463,     0,   464,   465,   466,   467,   468,   469,
       0,   470,   471,     0,     0,   472,   473,   474,   475,     0,
     476,   477,   478,   479,   480,   481,   482,     0,     0,   483,
     484,   485,   486,   487,     0,     0,   488,   489,   490,   491,
     492,   493,   494,     0,   495,     0,   496,   497,   498,   499,
       0,     0,   500,     0,     0,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   210,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   211,   212,   213,   214,   215,   216,
     217,   218,     0,   220,   221,   222,     0,     0,     0,     0,
     223,     0,     0,     0,   224,   225,     0,   226,   227,     0,
     228,   229,   230,   231,   232,     0,   233,   234,     0,   235,
     236,   237,   238,   239,     0,     0,   240,   241,   242,   243,
     244,     0,   245,   246,   247,   248,   249,     0,     0,     0,
     250,   251,   252,   253,     0,   254,   255,     0,   256,   257,
     258,   259,   260,   261,     0,     0,   262,   263,     0,     0,
       0,     0,     0,     0,     0,   264,   265,   266,   267,   268,
     269,   270,   271,   272,     0,   273,     0,   274,   275,   276,
     277,   278,     0,   279,   280,   281,     0,     0,   282,   283,
     284,   285,   286,     0,   287,   288,   289,     0,   290,   291,
     292,     0,   293,   294,   295,   296,   297,   298,   299,   300,
     301,     0,   302,     0,   303,   304,   305,   306,     0,   307,
       0,   308,     0,     0,     0,   309,   310,   311,     0,   312,
     313,     0,   314,     0,   315,   316,   317,   318,   932,     0,
     320,   321,   322,     0,   323,   324,   325,   326,   327,   328,
       0,   329,     0,   330,   331,   332,   333,   334,   335,   336,
       0,   337,     0,   338,     0,     0,   339,     0,   340,   341,
     342,   343,   344,     0,   345,   346,     0,   347,   348,     0,
     349,     0,     0,   350,   351,   352,     0,     0,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,     0,   367,   368,   369,   370,     0,   371,   372,
       0,   373,     0,   374,   375,   376,   377,   378,   379,     0,
     380,     0,     0,   381,   382,   383,     0,     0,   384,   385,
       0,   386,     0,   387,   388,   389,   390,   391,   392,   393,
     394,     0,   395,   396,   397,   398,   399,   400,   401,     0,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,     0,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,     0,   426,   427,     0,   428,
     429,   430,   431,   432,   433,   434,   435,   436,   437,   438,
       0,   439,   440,   441,   442,   443,     0,   444,   445,   446,
     447,     0,   448,   449,   450,     0,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,     0,   462,   463,
       0,   464,   465,   466,   467,   468,   469,     0,   470,   471,
       0,     0,   472,   473,   474,   475,     0,   476,   477,   478,
     479,   480,   481,   482,     0,     0,   483,   484,   485,   486,
     487,     0,     0,   488,   489,   490,   491,   492,   493,   494,
       0,   495,     0,   496,   497,   498,   499,     0,     0,   500,
       0,     0,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
     210,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   211,   212,   213,   214,   215,   216,   217,   218,     0,
     220,   221,   222,     0,     0,     0,     0,   223,     0,     0,
       0,   224,   225,     0,   226,   227,     0,   228,   229,   230,
     231,   232,     0,   233,   234,     0,   235,   236,   237,   238,
     239,     0,     0,   240,   241,   242,   243,   244,     0,   245,
     246,   247,   248,   249,     0,     0,     0,   250,   251,   252,
     253,     0,   254,   255,     0,   256,   257,   258,   259,   260,
     261,     0,     0,   262,   263,     0,     0,     0,     0,     0,
       0,     0,   264,   265,   266,   267,   268,   269,   270,   271,
     272,     0,   273,     0,   274,   275,   276,   277,   278,     0,
     279,   280,   281,     0,     0,   282,   283,   284,   285,   286,
       0,   287,   288,   289,     0,   290,   291,   292,     0,   293,
     294,   295,   296,   297,   298,   299,   300,   301,     0,   302,
       0,   303,   304,   305,   306,     0,   307,     0,   308,     0,
       0,     0,   309,   310,   311,     0,   312,   313,     0,   314,
       0,   315,   316,   317,   318,   951,     0,   320,   321,   322,
       0,   323,   324,   325,   326,   327,   328,     0,   329,     0,
     330,   331,   332,   333,   334,   335,   336,     0,   337,     0,
     338,     0,     0,   339,     0,   340,   341,   342,   343,   344,
       0,   345,   346,     0,   347,   348,     0,   349,     0,     0,
     350,   351,   352,     0,     0,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   366,     0,
     367,   368,   369,   370,     0,   371,   372,     0,   373,     0,
     374,   375,   376,   377,   378,   379,     0,   380,     0,     0,
     381,   382,   383,     0,     0,   384,   385,     0,   386,     0,
     387,   388,   389,   390,   391,   392,   393,   394,     0,   395,
     396,   397,   398,   399,   400,   401,     0,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
       0,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,     0,   426,   427,     0,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,     0,   439,   440,
     441,   442,   443,     0,   444,   445,   446,   447,     0,   448,
     449,   450,     0,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,   461,     0,   462,   463,     0,   464,   465,
     466,   467,   468,   469,     0,   470,   471,     0,     0,   472,
     473,   474,   475,     0,   476,   477,   478,   479,   480,   481,
     482,     0,     0,   483,   484,   485,   486,   487,     0,     0,
     488,   489,   490,   491,   492,   493,   494,     0,   495,     0,
     496,   497,   498,   499,     0,     0,   500,     0,     0,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,   516,   517,   518,   210,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   211,   212,
     213,   214,   215,   216,   217,   218,     0,   220,   221,   222,
       0,     0,     0,     0,   223,     0,     0,     0,   224,   225,
       0,   226,   227,     0,   228,   229,   230,   231,   232,     0,
     233,   234,     0,   235,   236,   237,   238,   239,     0,     0,
     240,   241,   242,   243,   244,     0,   245,   246,   247,   248,
     249,     0,     0,     0,   250,   251,   252,   253,     0,   254,
     255,     0,   256,   257,   258,   259,   260,   261,     0,     0,
     262,   263,     0,     0,     0,     0,     0,     0,     0,   264,
     265,   266,   267,   268,   269,   270,   271,   272,     0,   273,
       0,   274,   275,   276,   277,   278,     0,   279,   280,   281,
       0,     0,   282,   283,   284,   285,   286,     0,   287,   288,
     289,     0,   290,   291,   292,     0,   293,   294,   295,   296,
     297,   298,   299,   300,   301,     0,   302,     0,   303,   304,
     305,   306,     0,   307,     0,   308,     0,     0,     0,   309,
     310,   311,     0,   312,   313,     0,   314,     0,   315,   316,
     317,   318,   953,     0,   320,   321,   322,     0,   323,   324,
     325,   326,   327,   328,     0,   329,     0,   330,   331,   332,
     333,   334,   335,   336,     0,   337,     0,   338,     0,     0,
     339,     0,   340,   341,   342,   343,   344,     0,   345,   346,
       0,   347,   348,     0,   349,     0,     0,   350,   351,   352,
       0,     0,   353,   354,   355,   356,   357,   358,   359,   360,
     361,   362,   363,   364,   365,   366,     0,   367,   368,   369,
     370,     0,   371,   372,     0,   373,     0,   374,   375,   376,
     377,   378,   379,     0,   380,     0,     0,   381,   382,   383,
       0,     0,   384,   385,     0,   386,     0,   387,   388,   389,
     390,   391,   392,   393,   394,     0,   395,   396,   397,   398,
     399,   400,   401,     0,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,     0,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,     0,
     426,   427,     0,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,     0,   439,   440,   441,   442,   443,
       0,   444,   445,   446,   447,     0,   448,   449,   450,     0,
     451,   452,   453,   454,   455,   456,   457,   458,   459,   460,
     461,     0,   462,   463,     0,   464,   465,   466,   467,   468,
     469,     0,   470,   471,     0,     0,   472,   473,   474,   475,
       0,   476,   477,   478,   479,   480,   481,   482,     0,     0,
     483,   484,   485,   486,   487,     0,     0,   488,   489,   490,
     491,   492,   493,   494,     0,   495,     0,   496,   497,   498,
     499,     0,     0,   500,     0,     0,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   210,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   211,   212,   213,   214,   215,
     216,   217,   218,     0,   220,   221,   222,     0,     0,     0,
       0,   223,     0,     0,     0,   224,   225,     0,   226,   227,
       0,   228,   229,   230,   231,   232,     0,   233,   234,     0,
     235,   236,   237,   238,   239,     0,     0,   240,   241,   242,
     243,   244,     0,   245,   246,   247,   248,   249,     0,     0,
       0,   250,   251,   252,   253,     0,   254,   255,     0,   256,
     257,   258,   259,   260,   261,     0,     0,   262,   263,     0,
       0,     0,     0,     0,     0,     0,   264,   265,   266,   267,
     268,   269,   270,   271,   272,     0,   273,     0,   274,   275,
     276,   277,   278,     0,   279,   280,   281,     0,     0,   282,
     283,   284,   285,   286,     0,   287,   288,   289,     0,   290,
     291,   292,     0,   293,   294,   295,   296,   297,   298,   299,
     300,   301,     0,   302,     0,   303,   304,   305,   306,     0,
     307,     0,   308,     0,     0,     0,   309,   310,   311,     0,
     312,   313,     0,   314,     0,   315,   316,   317,   318,   955,
       0,   320,   321,   322,     0,   323,   324,   325,   326,   327,
     328,     0,   329,     0,   330,   331,   332,   333,   334,   335,
     336,     0,   337,     0,   338,     0,     0,   339,     0,   340,
     341,   342,   343,   344,     0,   345,   346,     0,   347,   348,
       0,   349,     0,     0,   350,   351,   352,     0,     0,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,     0,   367,   368,   369,   370,     0,   371,
     372,     0,   373,     0,   374,   375,   376,   377,   378,   379,
       0,   380,     0,     0,   381,   382,   383,     0,     0,   384,
     385,     0,   386,     0,   387,   388,   389,   390,   391,   392,
     393,   394,     0,   395,   396,   397,   398,   399,   400,   401,
       0,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,     0,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,     0,   426,   427,     0,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,     0,   439,   440,   441,   442,   443,     0,   444,   445,
     446,   447,     0,   448,   449,   450,     0,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,     0,   462,
     463,     0,   464,   465,   466,   467,   468,   469,     0,   470,
     471,     0,     0,   472,   473,   474,   475,     0,   476,   477,
     478,   479,   480,   481,   482,     0,     0,   483,   484,   485,
     486,   487,     0,     0,   488,   489,   490,   491,   492,   493,
     494,     0,   495,     0,   496,   497,   498,   499,     0,     0,
     500,     0,     0,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,   516,   517,
     518,   210,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   211,   212,   213,   214,   215,   216,   217,   218,
       0,   220,   221,   222,     0,     0,     0,     0,   223,     0,
       0,     0,   224,   225,     0,   226,   227,     0,   228,   229,
     230,   231,   232,     0,   233,   234,     0,   235,   236,   237,
     238,   239,     0,     0,   240,   241,   242,   243,   244,     0,
     245,   246,   247,   248,   249,     0,     0,     0,   250,   251,
     252,   253,     0,   254,   255,     0,   256,   257,   258,   259,
     260,   261,     0,     0,   262,   263,     0,     0,     0,     0,
       0,     0,     0,   264,   265,   266,   267,   268,   269,   270,
     271,   272,     0,   273,     0,   274,   275,   276,   277,   278,
       0,   279,   280,   281,     0,     0,   282,   283,   284,   285,
     286,     0,   287,   288,   289,     0,   290,   291,   292,     0,
     293,   294,   295,   296,   297,   298,   299,   300,   301,     0,
     302,     0,   303,   304,   305,   306,     0,   307,     0,   308,
       0,     0,     0,   309,   310,   311,     0,   312,   313,     0,
     314,     0,   315,   316,   317,   318,   958,     0,   320,   321,
     322,     0,   323,   324,   325,   326,   327,   328,     0,   329,
       0,   330,   331,   332,   333,   334,   335,   336,     0,   337,
       0,   338,     0,     0,   339,     0,   340,   341,   342,   343,
     344,     0,   345,   346,     0,   347,   348,     0,   349,     0,
       0,   350,   351,   352,     0,     0,   353,   354,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,   366,
       0,   367,   368,   369,   370,     0,   371,   372,     0,   373,
       0,   374,   375,   376,   377,   378,   379,     0,   380,     0,
       0,   381,   382,   383,     0,     0,   384,   385,     0,   386,
       0,   387,   388,   389,   390,   391,   392,   393,   394,     0,
     395,   396,   397,   398,   399,   400,   401,     0,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,     0,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,     0,   426,   427,     0,   428,   429,   430,
     431,   432,   433,   434,   435,   436,   437,   438,     0,   439,
     440,   441,   442,   443,     0,   444,   445,   446,   447,     0,
     448,   449,   450,     0,   451,   452,   453,   454,   455,   456,
     457,   458,   459,   460,   461,     0,   462,   463,     0,   464,
     465,   466,   467,   468,   469,     0,   470,   471,     0,     0,
     472,   473,   474,   475,     0,   476,   477,   478,   479,   480,
     481,   482,     0,     0,   483,   484,   485,   486,   487,     0,
       0,   488,   489,   490,   491,   492,   493,   494,     0,   495,
       0,   496,   497,   498,   499,     0,     0,   500,     0,     0,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,   513,   514,   515,   516,   517,   518,   210,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   211,
     212,   213,   214,   215,   216,   217,   218,     0,   220,   221,
     222,     0,     0,     0,     0,   223,     0,     0,     0,   224,
     225,     0,   226,   227,     0,   228,   229,   230,   231,   232,
       0,   233,   234,     0,   235,   236,   237,   238,   239,     0,
       0,   240,   241,   242,   243,   244,     0,   245,   246,   247,
     248,   249,     0,     0,     0,   250,   251,   252,   253,     0,
     254,   255,     0,   256,   257,   258,   259,   260,   261,     0,
       0,   262,   263,     0,     0,     0,     0,     0,     0,     0,
     264,   265,   266,   267,   268,   269,   270,   271,   272,     0,
     273,     0,   274,   275,   276,   277,   278,     0,   279,   280,
     281,     0,     0,   282,   283,   284,   285,   286,     0,   287,
     288,   289,     0,   290,   291,   292,     0,   293,   294,   295,
     296,   297,   298,   299,   300,   301,     0,   302,     0,   303,
     304,   305,   306,     0,   307,     0,   308,     0,     0,     0,
     309,   310,   311,     0,   312,   313,     0,   314,     0,   315,
     316,   317,   318,   964,     0,   320,   321,   322,     0,   323,
     324,   325,   326,   327,   328,     0,   329,     0,   330,   331,
     332,   333,   334,   335,   336,     0,   337,     0,   338,     0,
       0,   339,     0,   340,   341,   342,   343,   344,     0,   345,
     346,     0,   347,   348,     0,   349,     0,     0,   350,   351,
     352,     0,     0,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,     0,   367,   368,
     369,   370,     0,   371,   372,     0,   373,     0,   374,   375,
     376,   377,   378,   379,     0,   380,     0,     0,   381,   382,
     383,     0,     0,   384,   385,     0,   386,     0,   387,   388,
     389,   390,   391,   392,   393,   394,     0,   395,   396,   397,
     398,   399,   400,   401,     0,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,     0,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
       0,   426,   427,     0,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,     0,   439,   440,   441,   442,
     443,     0,   444,   445,   446,   447,     0,   448,   449,   450,
       0,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,     0,   462,   463,     0,   464,   465,   466,   467,
     468,   469,     0,   470,   471,     0,     0,   472,   473,   474,
     475,     0,   476,   477,   478,   479,   480,   481,   482,     0,
       0,   483,   484,   485,   486,   487,     0,     0,   488,   489,
     490,   491,   492,   493,   494,     0,   495,     0,   496,   497,
     498,   499,     0,     0,   500,     0,     0,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   210,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   211,   212,   213,   214,
     215,   216,   217,   218,     0,   220,   221,   222,     0,     0,
       0,     0,   223,     0,     0,     0,   224,   225,     0,   226,
     227,     0,   228,   229,   230,   231,   232,     0,   233,   234,
       0,   235,   236,   237,   238,   239,     0,     0,   689,   241,
     242,   243,   244,     0,   245,   246,   247,   248,   249,     0,
       0,     0,   250,   251,   252,   253,     0,   254,   255,     0,
     256,   257,   258,   259,   260,   261,     0,     0,   262,   263,
       0,     0,     0,     0,     0,     0,     0,   264,   265,   266,
     267,   268,   269,   270,   271,   272,     0,   273,     0,   274,
     275,   276,   277,   278,     0,   279,   280,   281,     0,     0,
     282,   283,   284,   285,   286,     0,   287,   288,   289,     0,
     290,   291,   292,     0,   293,   294,   295,   296,   297,   298,
     299,   300,   301,     0,   302,     0,   303,   304,   305,   306,
       0,   307,     0,   308,     0,     0,     0,   309,   310,   311,
       0,   312,   313,     0,   314,     0,   315,   316,   317,   318,
     319,     0,   320,   321,   322,     0,   323,   324,   325,   326,
     327,   328,     0,   329,     0,   330,   331,   332,   333,   334,
     335,   336,     0,   337,     0,   338,     0,     0,   339,     0,
     340,   341,   342,   343,   344,     0,   345,   346,     0,   347,
     348,     0,   349,     0,     0,   350,   351,   352,     0,     0,
     353,   354,   355,   356,   357,   358,   359,   360,   361,   362,
     363,   364,   692,   366,     0,   367,   368,   369,   370,     0,
     371,   372,     0,   373,     0,   374,   375,   376,   377,   378,
     379,     0,   380,     0,     0,   381,   382,   383,     0,     0,
     384,   385,     0,   386,     0,   387,   388,   389,   390,   391,
     392,   393,   394,     0,   395,   396,   397,   398,   399,   400,
     401,     0,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,     0,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,     0,   426,   427,
       0,   693,   429,   430,   431,   432,   433,   694,   435,   436,
     437,   438,     0,   439,   440,   441,   442,  1136,     0,   444,
     445,   446,   447,     0,   448,   449,   450,     0,   451,   452,
     453,   454,   455,   456,   457,   458,   459,   460,   461,     0,
     462,   463,     0,   464,   465,   466,   467,   468,   469,     0,
     696,   471,     0,     0,   697,   473,   474,   475,     0,   476,
     477,   478,   479,   480,   481,   482,     0,     0,   483,   484,
     485,   486,   487,     0,     0,   488,   489,   490,   491,   492,
     493,   494,     0,   495,     0,   496,   497,   498,   499,     0,
       0,   500,     0,     0,   501,   502,   503,   504,   505,   698,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
     517,   518,   210,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   211,   212,   213,   214,   215,   216,   217,
     218,     0,   220,   221,   222,     0,     0,     0,     0,   223,
       0,     0,     0,   224,   225,     0,   226,   227,     0,   228,
     229,   230,   231,   232,     0,   233,   234,     0,   235,   236,
     237,   238,   239,     0,     0,   240,   241,   242,   243,   244,
       0,   245,   246,   247,   248,   249,     0,     0,     0,   250,
     251,   252,   253,     0,   254,   255,     0,   256,   257,   258,
     259,   260,   261,     0,     0,   262,   263,     0,     0,     0,
       0,     0,     0,     0,   264,   265,   266,   267,   268,   269,
     270,   271,   272,     0,   273,     0,   274,   275,   276,   277,
     278,     0,   279,   280,   281,     0,     0,   282,   283,   284,
     285,   286,     0,   287,   288,   289,     0,   290,   291,   292,
       0,   293,   294,   295,   296,   297,   298,   299,   300,   301,
       0,   302,     0,   303,   304,   305,   306,     0,   307,     0,
     308,     0,     0,     0,   309,   310,   311,     0,   312,   313,
       0,   314,     0,   315,   316,   317,   318,  1443,     0,   320,
     321,   322,     0,   323,   324,   325,   326,   327,   328,     0,
     329,     0,   330,   331,   332,   333,   334,   335,   336,     0,
     337,     0,   338,     0,     0,   339,     0,   340,   341,   342,
     343,   344,     0,   345,   346,     0,   347,   348,     0,   349,
       0,     0,   350,   351,   352,     0,     0,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,     0,   367,   368,   369,   370,     0,   371,   372,     0,
     373,     0,   374,   375,   376,   377,   378,   379,     0,   380,
       0,     0,   381,   382,   383,     0,     0,   384,   385,     0,
     386,     0,   387,   388,   389,   390,   391,   392,   393,   394,
       0,   395,   396,   397,   398,   399,   400,   401,     0,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,     0,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,     0,   426,   427,     0,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,     0,
     439,   440,   441,   442,   443,     0,   444,   445,   446,   447,
       0,   448,   449,   450,     0,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,     0,   462,   463,     0,
     464,   465,   466,   467,   468,   469,     0,   470,   471,     0,
       0,   472,   473,   474,   475,     0,   476,   477,   478,   479,
     480,   481,   482,     0,     0,   483,   484,   485,   486,   487,
       0,     0,   488,   489,   490,   491,   492,   493,   494,     0,
     495,     0,   496,   497,   498,   499,     0,     0,   500,     0,
       0,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   210,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     211,   212,   213,   214,   215,   216,   217,   218,     0,   220,
     221,   222,     0,     0,     0,     0,   223,     0,     0,     0,
     224,   225,     0,   226,   227,     0,   228,   229,   230,   231,
     232,     0,   233,   234,     0,   235,   236,   237,   238,   239,
       0,     0,   240,   241,   242,   243,   244,     0,   245,   246,
     247,   248,   249,     0,     0,     0,   250,   251,   252,   253,
       0,   254,   255,     0,   256,   257,   258,   259,   260,   261,
       0,     0,   262,   263,     0,     0,     0,     0,     0,     0,
       0,   264,   265,   266,   267,   268,   269,   270,   271,   272,
       0,   273,     0,   274,   275,   276,   277,   278,     0,   279,
     280,   281,     0,     0,   282,   283,   284,   285,   286,     0,
     287,   288,   289,     0,   290,   291,   292,     0,   293,   294,
     295,   296,   297,   298,   299,   300,   301,     0,   302,     0,
     303,   304,   305,   306,     0,   307,     0,   308,     0,     0,
       0,   309,   310,   311,     0,   312,   313,     0,   314,     0,
     315,   316,   317,   318,  1473,     0,   320,   321,   322,     0,
     323,   324,   325,   326,   327,   328,     0,   329,     0,   330,
     331,   332,   333,   334,   335,   336,     0,   337,     0,   338,
       0,     0,   339,     0,   340,   341,   342,   343,   344,     0,
     345,   346,     0,   347,   348,     0,   349,     0,     0,   350,
     351,   352,     0,     0,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,   365,   366,     0,   367,
     368,   369,   370,     0,   371,   372,     0,   373,     0,   374,
     375,   376,   377,   378,   379,     0,   380,     0,     0,   381,
     382,   383,     0,     0,   384,   385,     0,   386,     0,   387,
     388,   389,   390,   391,   392,   393,   394,     0,   395,   396,
     397,   398,   399,   400,   401,     0,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,     0,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,     0,   426,   427,     0,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,   438,     0,   439,   440,   441,
     442,   443,     0,   444,   445,   446,   447,     0,   448,   449,
     450,     0,   451,   452,   453,   454,   455,   456,   457,   458,
     459,   460,   461,     0,   462,   463,     0,   464,   465,   466,
     467,   468,   469,     0,   470,   471,     0,     0,   472,   473,
     474,   475,     0,   476,   477,   478,   479,   480,   481,   482,
       0,     0,   483,   484,   485,   486,   487,     0,     0,   488,
     489,   490,   491,   492,   493,   494,     0,   495,     0,   496,
     497,   498,   499,     0,     0,   500,     0,     0,   501,   502,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
     513,   514,   515,   516,   517,   518,   210,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   211,   212,   213,
     214,   215,   216,   217,   218,     0,   220,   221,   222,     0,
       0,     0,     0,   223,     0,     0,     0,   224,   225,     0,
     226,   227,     0,   228,   229,   230,   231,   232,     0,   233,
     234,     0,   235,   236,   237,   238,   239,     0,     0,   240,
     241,   242,   243,   244,     0,   245,   246,   247,   248,   249,
       0,     0,     0,   250,   251,   252,   253,     0,   254,   255,
       0,   256,   257,   258,   259,   260,   261,     0,     0,   262,
     263,     0,     0,     0,     0,     0,     0,     0,   264,   265,
     266,   267,   268,   269,   270,   271,   272,     0,   273,     0,
     274,   275,   276,   277,   278,     0,   279,   280,   281,     0,
       0,   282,   283,   284,   285,   286,     0,   287,   288,   289,
       0,   290,   291,   292,     0,   293,   294,   295,   296,   297,
     298,   299,   300,   301,     0,   302,     0,   303,   304,   305,
     306,     0,   307,     0,   308,     0,     0,     0,   309,   310,
     311,     0,   312,   313,     0,   314,     0,   315,   316,   317,
     318,  1502,     0,   320,   321,   322,     0,   323,   324,   325,
     326,   327,   328,     0,   329,     0,   330,   331,   332,   333,
     334,   335,   336,     0,   337,     0,   338,     0,     0,   339,
       0,   340,   341,   342,   343,   344,     0,   345,   346,     0,
     347,   348,     0,   349,     0,     0,   350,   351,   352,     0,
       0,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   366,     0,   367,   368,   369,   370,
       0,   371,   372,     0,   373,     0,   374,   375,   376,   377,
     378,   379,     0,   380,     0,     0,   381,   382,   383,     0,
       0,   384,   385,     0,   386,     0,   387,   388,   389,   390,
     391,   392,   393,   394,     0,   395,   396,   397,   398,   399,
     400,   401,     0,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,     0,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,     0,   426,
     427,     0,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,     0,   439,   440,   441,   442,   443,     0,
     444,   445,   446,   447,     0,   448,   449,   450,     0,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,   461,
       0,   462,   463,     0,   464,   465,   466,   467,   468,   469,
       0,   470,   471,     0,     0,   472,   473,   474,   475,     0,
     476,   477,   478,   479,   480,   481,   482,     0,     0,   483,
     484,   485,   486,   487,     0,     0,   488,   489,   490,   491,
     492,   493,   494,     0,   495,     0,   496,   497,   498,   499,
       0,     0,   500,     0,     0,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   210,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   211,   212,   213,   214,   215,   216,
     217,   218,     0,   220,   221,   222,     0,     0,     0,     0,
     223,     0,     0,     0,   224,   225,     0,   226,   227,     0,
     228,   229,   230,   231,   232,     0,   233,   234,     0,   235,
     236,   237,   238,   239,     0,     0,   240,   241,   242,   243,
     244,     0,   245,   246,   247,   248,   249,     0,     0,     0,
     250,   251,   252,   253,     0,   254,   255,     0,   256,   257,
     258,   259,   260,   261,     0,     0,   262,   263,     0,     0,
       0,     0,     0,     0,     0,   264,   265,   266,   267,   268,
     269,   270,   271,   272,     0,   273,     0,   274,   275,   276,
     277,   278,     0,   279,   280,   281,     0,     0,   282,   283,
     284,   285,   286,     0,   287,   288,   289,     0,   290,   291,
     292,     0,   293,   294,   295,   296,   297,   298,   299,   300,
     301,     0,   302,     0,   303,   304,   305,   306,     0,   307,
       0,   308,     0,     0,     0,   309,   310,   311,     0,   312,
     313,     0,   314,     0,   315,   316,   317,   318,  1504,     0,
     320,   321,   322,     0,   323,   324,   325,   326,   327,   328,
       0,   329,     0,   330,   331,   332,   333,   334,   335,   336,
       0,   337,     0,   338,     0,     0,   339,     0,   340,   341,
     342,   343,   344,     0,   345,   346,     0,   347,   348,     0,
     349,     0,     0,   350,   351,   352,     0,     0,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,     0,   367,   368,   369,   370,     0,   371,   372,
       0,   373,     0,   374,   375,   376,   377,   378,   379,     0,
     380,     0,     0,   381,   382,   383,     0,     0,   384,   385,
       0,   386,     0,   387,   388,   389,   390,   391,   392,   393,
     394,     0,   395,   396,   397,   398,   399,   400,   401,     0,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,     0,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,     0,   426,   427,     0,   428,
     429,   430,   431,   432,   433,   434,   435,   436,   437,   438,
       0,   439,   440,   441,   442,   443,     0,   444,   445,   446,
     447,     0,   448,   449,   450,     0,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,     0,   462,   463,
       0,   464,   465,   466,   467,   468,   469,     0,   470,   471,
       0,     0,   472,   473,   474,   475,     0,   476,   477,   478,
     479,   480,   481,   482,     0,     0,   483,   484,   485,   486,
     487,     0,     0,   488,   489,   490,   491,   492,   493,   494,
       0,   495,     0,   496,   497,   498,   499,     0,     0,   500,
       0,     0,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
     210,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   211,   212,   213,   214,   215,   216,   217,   218,     0,
     220,   221,   222,     0,     0,     0,     0,   223,     0,     0,
       0,   224,   225,     0,   226,   227,     0,   228,   229,   230,
     231,   232,     0,   233,   234,     0,   235,   236,   237,   238,
     239,     0,     0,   240,   241,   242,   243,   244,     0,   245,
     246,   247,   248,   249,     0,     0,     0,   250,   251,   252,
     253,     0,   254,   255,     0,   256,   257,   258,   259,   260,
     261,     0,     0,   262,   263,     0,     0,     0,     0,     0,
       0,     0,   264,   265,   266,   267,   268,   269,   270,   271,
     272,     0,   273,     0,   274,   275,   276,   277,   278,     0,
     279,   280,   281,     0,     0,   282,   283,   284,   285,   286,
       0,   287,   288,   289,     0,   290,   291,   292,     0,   293,
     294,   295,   296,   297,   298,   299,   300,   301,     0,   302,
       0,   303,   304,   305,   306,     0,   307,     0,   308,     0,
       0,     0,   309,   310,   311,     0,   312,   313,     0,   314,
       0,   315,   316,   317,   318,  1506,     0,   320,   321,   322,
       0,   323,   324,   325,   326,   327,   328,     0,   329,     0,
     330,   331,   332,   333,   334,   335,   336,     0,   337,     0,
     338,     0,     0,   339,     0,   340,   341,   342,   343,   344,
       0,   345,   346,     0,   347,   348,     0,   349,     0,     0,
     350,   351,   352,     0,     0,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   366,     0,
     367,   368,   369,   370,     0,   371,   372,     0,   373,     0,
     374,   375,   376,   377,   378,   379,     0,   380,     0,     0,
     381,   382,   383,     0,     0,   384,   385,     0,   386,     0,
     387,   388,   389,   390,   391,   392,   393,   394,     0,   395,
     396,   397,   398,   399,   400,   401,     0,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
       0,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,     0,   426,   427,     0,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,     0,   439,   440,
     441,   442,   443,     0,   444,   445,   446,   447,     0,   448,
     449,   450,     0,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,   461,     0,   462,   463,     0,   464,   465,
     466,   467,   468,   469,     0,   470,   471,     0,     0,   472,
     473,   474,   475,     0,   476,   477,   478,   479,   480,   481,
     482,     0,     0,   483,   484,   485,   486,   487,     0,     0,
     488,   489,   490,   491,   492,   493,   494,     0,   495,     0,
     496,   497,   498,   499,     0,     0,   500,     0,     0,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,   516,   517,   518,   210,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   211,   212,
     213,   214,   215,   216,   217,   218,     0,   220,   221,   222,
       0,     0,     0,     0,   223,     0,     0,     0,   224,   225,
       0,   226,   227,     0,   228,   229,   230,   231,   232,     0,
     233,   234,     0,   235,   236,   237,   238,   239,     0,     0,
     240,   241,   242,   243,   244,     0,   245,   246,   247,   248,
     249,     0,     0,     0,   250,   251,   252,   253,     0,   254,
     255,     0,   256,   257,   258,   259,   260,   261,     0,     0,
     262,   263,     0,     0,     0,     0,     0,     0,     0,   264,
     265,   266,   267,   268,   269,   270,   271,   272,     0,   273,
       0,   274,   275,   276,   277,   278,     0,   279,   280,   281,
       0,     0,   282,   283,   284,   285,   286,     0,   287,   288,
     289,     0,   290,   291,   292,     0,   293,   294,   295,   296,
     297,   298,   299,   300,   301,     0,   302,     0,   303,   304,
     305,   306,     0,   307,     0,   308,     0,     0,     0,   309,
     310,   311,     0,   312,   313,     0,   314,     0,   315,   316,
     317,   318,   319,     0,   320,   321,   322,     0,   323,   324,
     325,   326,   327,   328,     0,   329,     0,   330,   331,   332,
     333,   334,   335,   336,     0,   337,     0,   338,     0,     0,
     339,     0,   340,   341,   342,   343,   344,     0,   345,   346,
       0,   347,   348,     0,   349,     0,     0,   350,   351,   352,
       0,     0,   353,   354,   355,   356,   357,   358,   359,   360,
     361,   362,   363,   364,   365,   366,     0,   367,   368,   369,
     370,     0,   371,   372,     0,   373,     0,   374,   375,   376,
     377,   378,   379,     0,   380,     0,     0,   381,   382,   383,
       0,     0,   384,   385,     0,   386,     0,   387,   388,   389,
     390,   391,   392,   393,   394,     0,   395,   396,   397,   398,
     399,   400,   401,     0,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,     0,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,     0,
     426,   427,     0,   428,   429,   430,   431,   432,  1598,   434,
     435,   436,   437,   438,     0,   439,   440,   441,   442,   443,
       0,   444,   445,   446,   447,     0,   448,   449,   450,     0,
     451,   452,   453,   454,   455,   456,   457,   458,   459,   460,
     461,     0,   462,   463,     0,   464,   465,   466,   467,   468,
     469,     0,   470,   471,     0,     0,   472,   473,   474,   475,
       0,   476,   477,   478,   479,   480,   481,   482,     0,     0,
     483,   484,   485,   486,   487,     0,     0,   488,   489,   490,
     491,   492,   493,   494,     0,   495,     0,   496,   497,   498,
     499,     0,     0,   500,     0,     0,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   210,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   211,   212,   213,   214,   215,
     216,   217,   218,     0,   220,   221,   222,     0,     0,     0,
       0,   223,     0,  1874,     0,   224,   225,     0,   226,   227,
       0,   228,   229,   230,   231,   232,     0,   233,   234,     0,
     235,   236,   237,   238,   239,     0,     0,   240,   241,   242,
     243,   244,     0,   245,   246,   247,   248,   249,     0,     0,
       0,   250,   251,   252,   253,     0,   254,   255,     0,   256,
     257,   258,   259,   260,   261,     0,     0,   262,   263,     0,
       0,     0,     0,     0,     0,     0,   264,   265,   266,   267,
     268,   269,   270,   271,   272,     0,   273,     0,   274,   275,
     276,   277,   278,     0,   279,   280,   281,     0,     0,   282,
     283,   284,   285,   286,     0,   287,   288,   289,     0,   290,
     291,   292,     0,   293,   294,   295,   296,   297,   298,   299,
     300,   301,     0,   302,     0,   303,   304,   305,   306,     0,
     307,     0,   308,     0,     0,     0,   309,   310,   311,     0,
     312,   313,     0,   314,     0,   315,   316,   317,   318,   319,
       0,   320,   321,   322,     0,   323,   324,   325,   326,   327,
     328,     0,   329,     0,   330,   331,   332,   333,   334,   335,
     336,     0,   337,     0,   338,     0,     0,   339,     0,   340,
     341,   342,   343,   344,     0,   345,   346,     0,   347,   348,
       0,   349,     0,     0,   350,   351,   352,     0,     0,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,     0,   367,   368,   369,   370,     0,   371,
     372,     0,   373,     0,   374,   375,   376,   377,   378,   379,
       0,   380,     0,     0,   381,   382,   383,     0,     0,   384,
     385,     0,   386,     0,   387,   388,   389,   390,   391,   392,
     393,   394,     0,   395,   396,   397,   398,   399,   400,   401,
       0,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,     0,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,     0,   426,   427,     0,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,     0,   439,   440,   441,   442,   443,     0,     0,   445,
     446,   447,     0,   448,   449,   450,     0,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,     0,   462,
     463,     0,   464,   465,   466,   467,   468,   469,     0,   470,
     471,     0,     0,   472,   473,   474,   475,     0,   476,   477,
     478,   479,   480,   481,   482,     0,     0,   483,   484,   485,
     486,   487,     0,     0,   488,   489,   490,   491,   492,   493,
     494,     0,   495,     0,   496,   497,   498,   499,     0,     0,
     500,     0,     0,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,   516,   517,
     518,   210,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   211,   212,   213,   214,   215,   216,   217,   218,
       0,   220,   221,   222,     0,     0,     0,     0,   223,     0,
       0,     0,   224,   225,     0,   226,   227,     0,   228,   229,
     230,   231,   232,     0,   233,   234,     0,   235,   236,   237,
     238,   239,     0,     0,   689,   241,   242,   243,   244,     0,
     245,   246,   247,   248,   249,     0,     0,     0,   250,   251,
     252,   253,     0,   254,   255,     0,   256,   257,   258,   259,
     260,   261,     0,     0,   262,   263,     0,     0,     0,     0,
       0,     0,     0,   264,   265,   266,   267,   268,   269,   270,
     271,   272,     0,   273,     0,   274,   275,   276,   277,   278,
       0,   279,   280,   281,     0,     0,   282,   283,   284,   285,
     286,     0,   287,   288,   289,     0,   290,   291,   292,     0,
     293,   294,   295,   296,   297,   298,   299,   300,   301,     0,
     302,     0,   303,   304,   305,   306,     0,   307,     0,   308,
       0,     0,     0,   309,   310,   311,     0,   312,   313,     0,
     314,     0,   315,   316,   317,   318,   319,     0,   320,   321,
     322,     0,   323,   324,   325,   326,   327,   328,     0,   329,
       0,   330,   331,   332,   333,   334,   335,   336,     0,   337,
       0,   338,     0,     0,   339,     0,   340,   341,   342,   343,
     344,     0,   345,   346,     0,   347,   348,     0,   349,     0,
       0,   350,   351,   352,     0,     0,   353,   354,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   692,   366,
       0,   367,   368,   369,   370,     0,   371,   372,     0,   373,
       0,   374,   375,   376,   377,   378,   379,     0,   380,     0,
       0,   381,   382,   383,     0,     0,   384,   385,     0,   386,
       0,   387,   388,   389,   390,   391,   392,   393,   394,     0,
     395,   396,   397,   398,   399,   400,   401,     0,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,     0,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,     0,   426,   427,     0,   693,   429,   430,
     431,   432,   433,   694,   435,   436,   437,   438,     0,   439,
     440,   441,   442,  1136,     0,   444,   445,   446,   447,     0,
     448,   449,   450,     0,   451,   452,   453,   454,   455,   456,
     457,   458,   459,   460,   461,     0,   462,   463,     0,   464,
    1905,   466,   467,   468,   469,     0,   696,   471,     0,     0,
     697,   473,   474,   475,     0,   476,   477,   478,   479,   480,
     481,   482,     0,     0,   483,   484,   485,   486,   487,     0,
       0,   488,   489,   490,   491,   492,   493,   494,     0,   495,
       0,   496,   497,   498,   499,     0,     0,   500,     0,     0,
     501,   502,   503,   504,   505,   698,   507,   508,   509,   510,
     511,   512,   513,   514,   515,   516,   517,   518,   210,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   211,
     212,   213,   214,   215,   216,   217,   218,     0,   220,   221,
     222,     0,     0,     0,     0,   223,     0,     0,     0,   224,
     225,     0,   226,   227,     0,   228,   229,   230,   231,   232,
       0,   233,   234,     0,   235,   236,   237,   238,   239,     0,
       0,   689,   241,   242,   243,   244,     0,   245,   246,   247,
     248,   249,     0,     0,     0,   250,   251,   252,   253,     0,
     254,   255,     0,   256,   257,   258,   259,   260,   261,     0,
       0,   262,   263,     0,     0,     0,     0,     0,     0,     0,
     264,   265,   266,   267,   268,   269,   270,   271,   272,     0,
     273,     0,   274,   275,   276,   277,   278,     0,   279,   280,
     281,     0,     0,   282,   283,   284,   285,   286,     0,   287,
     288,   289,     0,   290,   291,   292,     0,   293,   294,   295,
     296,   297,   298,   299,   300,   301,     0,   302,     0,   303,
     304,   305,   306,     0,   307,     0,   308,     0,     0,     0,
     309,   310,   311,     0,   312,   313,     0,   314,     0,   315,
     316,   317,   318,   319,     0,   320,   321,   322,     0,   323,
     324,   325,   326,   327,   328,     0,   329,     0,   330,   331,
     332,   333,   334,   335,   336,     0,   337,     0,   338,     0,
       0,   339,     0,   340,   341,   342,   343,   344,     0,   345,
     346,     0,   347,   348,     0,   349,     0,     0,   350,   351,
     352,     0,     0,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   692,   366,     0,   367,   368,
     369,   370,     0,   371,   372,     0,   373,     0,   374,   375,
     376,   377,   378,   379,     0,   380,     0,     0,   381,   382,
     383,     0,     0,   384,   385,     0,   386,     0,   387,   388,
     389,   390,   391,   392,   393,   394,     0,   395,   396,   397,
     398,   399,   400,   401,     0,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,     0,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
       0,   426,   427,     0,   693,   429,   430,   431,   432,   433,
    1972,   435,   436,   437,   438,     0,   439,   440,   441,   442,
    1973,     0,   444,   445,   446,   447,     0,   448,   449,   450,
       0,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,     0,   462,   463,     0,   464,   465,   466,   467,
     468,   469,     0,   696,   471,     0,     0,  1974,   473,   474,
     475,     0,   476,   477,   478,   479,   480,   481,   482,     0,
       0,   483,   484,   485,   486,   487,     0,     0,   488,   489,
     490,   491,   492,   493,   494,     0,   495,     0,   496,   497,
     498,   499,     0,     0,   500,     0,     0,   501,   502,   503,
     504,   505,   698,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   210,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   211,   212,   213,   214,
     215,   216,   217,   218,     0,   220,   221,   222,     0,     0,
       0,     0,   223,     0,     0,     0,   224,   225,     0,   226,
     227,     0,   228,   229,   230,   231,   232,     0,   233,   234,
       0,   235,   236,   237,   238,   239,     0,     0,   240,   241,
     242,   243,   244,     0,   245,   246,   247,   248,   249,     0,
       0,     0,   250,   251,   252,   253,     0,   254,   255,     0,
     256,   257,   258,   259,   260,   261,     0,     0,   262,   263,
       0,     0,     0,     0,     0,     0,     0,   264,   265,   266,
     267,   268,   269,   270,   271,   272,     0,   273,     0,   274,
     275,   276,   277,   278,     0,   279,   280,   281,     0,     0,
     282,   283,   284,   285,   286,     0,   287,   288,   289,     0,
     290,   291,   292,     0,   293,   294,   295,   296,   297,   298,
     299,   300,   301,     0,   302,     0,   303,   304,   305,   306,
       0,   307,     0,   308,     0,     0,     0,   309,   310,   311,
       0,   312,   313,     0,   314,     0,   315,   316,   317,   318,
    2227,     0,   320,   321,   322,     0,   323,   324,   325,   326,
     327,   328,     0,   329,     0,   330,   331,   332,   333,   334,
     335,   336,     0,   337,     0,   338,     0,     0,   339,     0,
     340,   341,   342,   343,   344,     0,   345,   346,     0,   347,
     348,     0,   349,     0,     0,   350,   351,   352,     0,     0,
     353,   354,   355,   356,   357,   358,   359,   360,   361,   362,
     363,   364,   365,   366,     0,   367,   368,   369,   370,     0,
     371,   372,     0,   373,     0,   374,   375,   376,   377,   378,
     379,     0,   380,     0,     0,   381,   382,   383,     0,     0,
     384,   385,     0,   386,     0,   387,   388,   389,   390,   391,
     392,   393,   394,     0,   395,   396,   397,   398,   399,   400,
     401,     0,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,     0,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,     0,   426,   427,
       0,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,     0,   439,   440,   441,   442,   443,     0,   444,
     445,   446,   447,     0,   448,   449,   450,     0,   451,   452,
     453,   454,   455,   456,   457,   458,   459,   460,   461,     0,
     462,   463,     0,   464,   465,   466,   467,   468,   469,     0,
     470,   471,     0,     0,   472,   473,   474,   475,     0,   476,
     477,   478,   479,   480,   481,   482,     0,     0,   483,   484,
     485,   486,   487,     0,     0,   488,   489,   490,   491,   492,
     493,   494,     0,   495,     0,   496,   497,   498,   499,     0,
       0,   500,     0,     0,   501,   502,   503,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
     517,   518,   210,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   211,   212,   213,   214,   215,   216,   217,
     218,     0,   220,   221,   222,     0,     0,     0,     0,   223,
       0,     0,     0,   224,   225,     0,   226,   227,     0,   228,
     229,   230,   231,   232,     0,   233,   234,     0,   235,   236,
     237,   238,   239,     0,     0,   240,   241,   242,   243,   244,
       0,   245,   246,   247,   248,   249,     0,     0,     0,   250,
     251,   252,   253,     0,   254,   255,     0,   256,   257,   258,
     259,   260,   261,     0,     0,   262,   263,     0,     0,     0,
       0,     0,     0,     0,   264,   265,   266,   267,   268,   269,
     270,   271,   272,     0,   273,     0,   274,   275,   276,   277,
     278,     0,   279,   280,   281,     0,     0,   282,   283,   284,
     285,   286,     0,   287,   288,   289,     0,   290,   291,   292,
       0,   293,   294,   295,   296,   297,   298,   299,   300,   301,
       0,   302,     0,   303,   304,   305,   306,     0,   307,     0,
     308,     0,     0,     0,   309,   310,   311,     0,   312,   313,
       0,   314,     0,   315,   316,   317,   318,  2575,     0,   320,
     321,   322,     0,   323,   324,   325,   326,   327,   328,     0,
     329,     0,   330,   331,   332,   333,   334,   335,   336,     0,
     337,     0,   338,     0,     0,   339,     0,   340,   341,   342,
     343,   344,     0,   345,   346,     0,   347,   348,     0,   349,
       0,     0,   350,   351,   352,     0,     0,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,     0,   367,   368,   369,   370,     0,   371,   372,     0,
     373,     0,   374,   375,   376,   377,   378,   379,     0,   380,
       0,     0,   381,   382,   383,     0,     0,   384,   385,     0,
     386,     0,   387,   388,   389,   390,   391,   392,   393,   394,
       0,   395,   396,   397,   398,   399,   400,   401,     0,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,     0,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,     0,   426,   427,     0,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,     0,
     439,   440,   441,   442,   443,     0,   444,   445,   446,   447,
       0,   448,   449,   450,     0,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,     0,   462,   463,     0,
     464,   465,   466,   467,   468,   469,     0,   470,   471,     0,
       0,   472,   473,   474,   475,     0,   476,   477,   478,   479,
     480,   481,   482,     0,     0,   483,   484,   485,   486,   487,
       0,     0,   488,   489,   490,   491,   492,   493,   494,     0,
     495,     0,   496,   497,   498,   499,     0,     0,   500,     0,
       0,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   210,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     211,   212,   213,   214,   215,   216,   217,   218,     0,   220,
     221,   222,     0,     0,     0,     0,   223,     0,     0,     0,
     224,   225,     0,   226,   227,     0,   228,   229,   230,   231,
     232,     0,   233,   234,     0,   235,   236,   237,   238,   239,
       0,     0,   689,   241,   242,   243,   244,     0,   245,   246,
     247,   248,   249,     0,     0,     0,   250,   251,   252,   253,
       0,   254,   255,     0,   256,   257,   258,   259,   260,   261,
       0,     0,   262,   263,     0,     0,     0,     0,     0,     0,
       0,   264,   265,   266,   267,   268,   269,   270,   271,   272,
       0,   273,     0,   274,   275,   276,   277,   278,     0,   279,
     280,   281,     0,     0,   282,   283,   284,   285,   286,     0,
     287,   288,   289,     0,   290,   291,   292,     0,   293,   294,
     295,   296,   297,   298,   299,   300,   301,     0,   302,     0,
     303,   304,   305,   306,     0,   307,     0,   308,     0,     0,
       0,   309,   310,   311,     0,   312,   313,     0,   314,     0,
     315,   316,   317,   318,   319,     0,   320,   321,   322,     0,
     323,   324,   325,   326,   327,   328,     0,   329,     0,   330,
     331,   332,   333,   334,   335,   336,     0,   337,     0,   338,
       0,     0,   339,     0,   340,   341,   342,   343,   344,     0,
     345,   346,     0,   347,   348,     0,   349,     0,     0,   350,
     351,   352,     0,     0,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,   692,   366,     0,   367,
     368,   369,   370,     0,   371,   372,     0,   373,     0,   374,
     375,   376,   377,   378,   379,     0,   380,     0,     0,   381,
     382,   383,     0,     0,   384,   385,     0,   386,     0,   387,
     388,   389,   390,   391,   392,   393,   394,     0,   395,   396,
     397,   398,   399,   400,   401,     0,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,     0,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,     0,   426,   427,     0,   693,   429,   430,   431,   432,
     433,   694,   435,   436,   437,   438,     0,   439,   440,   441,
     442,  1973,     0,   444,   445,   446,   447,     0,   448,   449,
     450,     0,   451,   452,   453,   454,   455,   456,   457,   458,
     459,   460,   461,     0,   462,   463,     0,   464,   465,   466,
     467,   468,   469,     0,   696,   471,     0,     0,  1974,   473,
     474,   475,     0,   476,   477,   478,   479,   480,   481,   482,
       0,     0,   483,   484,   485,   486,   487,     0,     0,   488,
     489,   490,   491,   492,   493,   494,     0,   495,     0,   496,
     497,   498,   499,     0,     0,   500,     0,     0,   501,   502,
     503,   504,   505,   698,   507,   508,   509,   510,   511,   512,
     513,   514,   515,   516,   517,   518,   210,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   211,   212,   213,
     214,   215,   216,   217,   218,     0,   220,   221,   222,     0,
       0,     0,     0,   223,     0,     0,     0,   224,   225,     0,
     226,   227,     0,   228,   229,   230,   231,   232,     0,   233,
     234,     0,   235,   236,   237,   238,   239,     0,     0,   240,
     241,   242,   243,   244,     0,   245,   246,   247,   248,   249,
       0,     0,     0,   250,   251,   252,   253,     0,   254,   255,
       0,   256,   257,   258,   259,   260,   261,     0,     0,   262,
     263,     0,     0,     0,     0,     0,     0,     0,   264,   265,
     266,   267,   268,   269,   270,   271,   272,     0,   273,     0,
     274,   275,   276,   277,   278,     0,   279,   280,   281,     0,
       0,   282,   283,   284,   285,   286,     0,   287,   288,   289,
       0,   290,   291,   292,     0,   293,   294,   295,   296,   297,
     298,   299,   300,   301,     0,   302,     0,   303,   304,   305,
     306,     0,   307,     0,   308,     0,     0,     0,   309,   310,
     311,     0,   312,   313,     0,   314,     0,   315,   316,   317,
     318,  2648,     0,   320,   321,   322,     0,   323,   324,   325,
     326,   327,   328,     0,   329,     0,   330,   331,   332,   333,
     334,   335,   336,     0,   337,     0,   338,     0,     0,   339,
       0,   340,   341,   342,   343,   344,     0,   345,   346,     0,
     347,   348,     0,   349,     0,     0,   350,   351,   352,     0,
       0,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   366,     0,   367,   368,   369,   370,
       0,   371,   372,     0,   373,     0,   374,   375,   376,   377,
     378,   379,     0,   380,     0,     0,   381,   382,   383,     0,
       0,   384,   385,     0,   386,     0,   387,   388,   389,   390,
     391,   392,   393,   394,     0,   395,   396,   397,   398,   399,
     400,   401,     0,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,     0,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,     0,   426,
     427,     0,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,     0,   439,   440,   441,   442,   443,     0,
     444,   445,   446,   447,     0,   448,   449,   450,     0,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,   461,
       0,   462,   463,     0,   464,   465,   466,   467,   468,   469,
       0,   470,   471,     0,     0,   472,   473,   474,   475,     0,
     476,   477,   478,   479,   480,   481,   482,     0,     0,   483,
     484,   485,   486,   487,     0,     0,   488,   489,   490,   491,
     492,   493,   494,     0,   495,     0,   496,   497,   498,   499,
       0,     0,   500,     0,     0,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   210,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   211,   212,   213,   214,   215,   216,
     217,   218,     0,   220,   221,   222,     0,     0,     0,     0,
     223,     0,     0,     0,   224,   225,     0,   226,   227,     0,
     228,   229,   230,   231,   232,     0,   233,   234,     0,   235,
     236,   237,   238,   239,     0,     0,   240,   241,   242,   243,
     244,     0,   245,   246,   247,   248,   249,     0,     0,     0,
     250,   251,   252,   253,     0,   254,   255,     0,   256,   257,
     258,   259,   260,   261,     0,     0,   262,   263,     0,     0,
       0,     0,     0,     0,     0,   264,   265,   266,   267,   268,
     269,   270,   271,   272,     0,   273,     0,   274,   275,   276,
     277,   278,     0,   279,   280,   281,     0,     0,   282,   283,
     284,   285,   286,     0,   287,   288,   289,     0,   290,   291,
     292,     0,   293,   294,   295,   296,   297,   298,   299,   300,
     301,     0,   302,     0,   303,   304,   305,   306,     0,   307,
       0,   308,     0,     0,     0,   309,   310,   311,     0,   312,
     313,     0,   314,     0,   315,   316,   317,   318,  2650,     0,
     320,   321,   322,     0,   323,   324,   325,   326,   327,   328,
       0,   329,     0,   330,   331,   332,   333,   334,   335,   336,
       0,   337,     0,   338,     0,     0,   339,     0,   340,   341,
     342,   343,   344,     0,   345,   346,     0,   347,   348,     0,
     349,     0,     0,   350,   351,   352,     0,     0,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,     0,   367,   368,   369,   370,     0,   371,   372,
       0,   373,     0,   374,   375,   376,   377,   378,   379,     0,
     380,     0,     0,   381,   382,   383,     0,     0,   384,   385,
       0,   386,     0,   387,   388,   389,   390,   391,   392,   393,
     394,     0,   395,   396,   397,   398,   399,   400,   401,     0,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,     0,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,     0,   426,   427,     0,   428,
     429,   430,   431,   432,   433,   434,   435,   436,   437,   438,
       0,   439,   440,   441,   442,   443,     0,   444,   445,   446,
     447,     0,   448,   449,   450,     0,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,     0,   462,   463,
       0,   464,   465,   466,   467,   468,   469,     0,   470,   471,
       0,     0,   472,   473,   474,   475,     0,   476,   477,   478,
     479,   480,   481,   482,     0,     0,   483,   484,   485,   486,
     487,     0,     0,   488,   489,   490,   491,   492,   493,   494,
       0,   495,     0,   496,   497,   498,   499,     0,     0,   500,
       0,     0,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
     210,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   211,   212,   213,   214,   215,   216,   217,   218,     0,
     220,   221,   222,     0,     0,     0,     0,   223,     0,     0,
       0,   224,   225,     0,   226,   227,     0,   228,   229,   230,
     231,   232,     0,   233,   234,     0,   235,   236,   237,   238,
     239,     0,     0,   240,   241,   242,   243,   244,     0,   245,
     246,   247,   248,   249,     0,     0,     0,   250,   251,   252,
     253,     0,   254,   255,     0,   256,   257,   258,   259,   260,
     261,     0,     0,   262,   263,     0,     0,     0,     0,     0,
       0,     0,   264,   265,   266,   267,   268,   269,   270,   271,
     272,     0,   273,     0,   274,   275,   276,   277,   278,     0,
     279,   280,   281,     0,     0,   282,   283,   284,   285,   286,
       0,   287,   288,   289,     0,   290,   291,   292,     0,   293,
     294,   295,   296,   297,   298,   299,   300,   301,     0,   302,
       0,   303,   304,   305,   306,     0,   307,     0,   308,     0,
       0,     0,   309,   310,   311,     0,   312,   313,     0,   314,
       0,   315,   316,   317,   318,  2755,     0,   320,   321,   322,
       0,   323,   324,   325,   326,   327,   328,     0,   329,     0,
     330,   331,   332,   333,   334,   335,   336,     0,   337,     0,
     338,     0,     0,   339,     0,   340,   341,   342,   343,   344,
       0,   345,   346,     0,   347,   348,     0,   349,     0,     0,
     350,   351,   352,     0,     0,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   366,     0,
     367,   368,   369,   370,     0,   371,   372,     0,   373,     0,
     374,   375,   376,   377,   378,   379,     0,   380,     0,     0,
     381,   382,   383,     0,     0,   384,   385,     0,   386,     0,
     387,   388,   389,   390,   391,   392,   393,   394,     0,   395,
     396,   397,   398,   399,   400,   401,     0,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
       0,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,     0,   426,   427,     0,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,     0,   439,   440,
     441,   442,   443,     0,   444,   445,   446,   447,     0,   448,
     449,   450,     0,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,   461,     0,   462,   463,     0,   464,   465,
     466,   467,   468,   469,     0,   470,   471,     0,     0,   472,
     473,   474,   475,     0,   476,   477,   478,   479,   480,   481,
     482,     0,     0,   483,   484,   485,   486,   487,     0,     0,
     488,   489,   490,   491,   492,   493,   494,     0,   495,     0,
     496,   497,   498,   499,     0,     0,   500,     0,     0,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,   516,   517,   518,  1397,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   211,   212,
     213,   214,   215,   216,   217,   218,     0,   220,   221,   222,
       0,     0,     0,     0,   223,     0,     0,     0,   224,   225,
       0,   226,   227,   745,   228,   229,   230,     0,  1398,   746,
    1399,  1400,     0,   235,   236,   237,   238,   239,     0,     0,
     240,   241,  1401,  1402,   244,     0,   245,   246,   247,   248,
       0,     0,   747,     0,   250,   251,   252,   253,   748,   254,
     255,     0,   256,   257,   258,   259,   260,   261,     0,   749,
     262,   263,     0,     0,     0,   750,     0,     0,     0,   264,
     265,   266,   267,   268,   269,  1403,  1404,   272,     0,   273,
       0,   274,   275,   276,   277,   278,     0,   279,   280,   281,
       0,     0,   282,   283,  1056,   285,   286,     0,   287,   288,
     289,     0,   290,   291,   292,     0,   293,   294,   295,   296,
       0,   298,   299,   300,     0,     0,   302,     0,   303,   304,
    1405,   306,     0,   307,     0,   308,   751,     0,   752,   309,
     310,   311,     0,   312,     0,     0,   314,     0,   315,   316,
     317,   318,   319,   753,   320,   321,   322,  1877,   323,   324,
     325,   326,   327,   328,     0,   329,   754,  1878,   331,   332,
     333,   334,  1406,  1407,     0,  1408,     0,   338,   755,   756,
     339,   757,   340,   341,   342,   343,   344,     0,   345,   346,
       0,   347,     0,   758,   349,   759,     0,   350,   351,   352,
       0,     0,   353,   354,   355,   356,   357,   358,   359,   360,
     361,   362,   363,   364,   365,  1409,   760,  1410,   368,   369,
       0,     0,   371,   372,   761,   373,     0,     0,   375,  1411,
     377,   378,   379,     0,   380,     0,     0,   381,   382,   383,
       0,     0,   384,  1880,   762,   386,   763,     0,   388,   389,
     390,   391,   392,   393,   394,     0,   395,     0,   397,     0,
     399,   400,   401,     0,   402,   403,   404,   405,   406,   407,
     408,   409,  1412,   411,   412,   413,   414,     0,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,     0,
     426,   427,   764,   428,   429,     0,   431,   432,   433,   434,
     435,   436,   437,   438,     0,   439,   440,   441,   442,   443,
       0,   444,  1881,   446,   447,   765,   448,  1414,   450,     0,
     451,   452,   453,   454,   455,   456,   457,   458,   459,   460,
       0,     0,   462,   463,     0,   464,   465,   466,   467,   468,
     469,     0,  1415,  1416,     0,     0,   472,     0,   474,     0,
       0,   476,   477,   478,   479,   480,   481,   482,     0,     0,
     483,   484,   485,   486,   487,     0,     0,   488,   489,   490,
     491,   492,     0,  1417,  1882,   495,   766,   496,   497,   498,
     499,     0,     0,   500,     0,     0,   501,   502,   503,   504,
     505,   506,     0,  1397,     0,     0,     0,     0,     0,     0,
       0,   516,   517,   518,   211,   212,   213,   214,   215,   216,
     217,   218,     0,   220,   221,   222,     0,     0,     0,     0,
     223,     0,     0,     0,   224,   225,     0,   226,   227,   745,
     228,   229,   230,     0,  1398,   746,  1399,  1400,     0,   235,
     236,   237,   238,   239,     0,     0,   240,   241,  1401,  1402,
     244,     0,   245,   246,   247,   248,     0,     0,   747,     0,
     250,   251,   252,   253,   748,   254,   255,     0,   256,   257,
     258,   259,   260,   261,     0,   749,   262,   263,     0,     0,
       0,   750,     0,     0,     0,   264,   265,   266,   267,   268,
     269,  1403,  1404,   272,     0,   273,     0,   274,   275,   276,
     277,   278,     0,   279,   280,   281,     0,     0,   282,   283,
    1056,   285,   286,     0,   287,   288,   289,     0,   290,   291,
     292,     0,   293,   294,   295,   296,     0,   298,   299,   300,
       0,     0,   302,     0,   303,   304,  1405,   306,     0,   307,
       0,   308,   751,     0,   752,   309,   310,   311,     0,   312,
       0,     0,   314,     0,   315,   316,   317,   318,   319,   753,
     320,   321,   322,     0,   323,   324,   325,   326,   327,   328,
       0,   329,   754,     0,   331,   332,   333,   334,  1406,  1407,
       0,  1408,     0,   338,   755,   756,   339,   757,   340,   341,
     342,   343,   344,     0,   345,   346,     0,   347,     0,   758,
     349,   759,     0,   350,   351,   352,     0,     0,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,  1409,   760,  1410,   368,   369,     0,     0,   371,   372,
     761,   373,  1968,     0,   375,  1411,   377,   378,   379,     0,
     380,     0,     0,   381,   382,   383,     0,     0,   384,     0,
     762,   386,   763,     0,   388,   389,   390,   391,   392,   393,
     394,     0,   395,     0,   397,     0,   399,   400,   401,     0,
     402,   403,   404,   405,   406,   407,   408,   409,  1412,   411,
     412,   413,   414,     0,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,     0,   426,   427,   764,   428,
     429,     0,   431,   432,   433,   434,   435,   436,   437,   438,
       0,   439,   440,   441,   442,   443,     0,   444,  1881,   446,
     447,   765,   448,  1414,   450,     0,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,     0,     0,   462,   463,
    3427,   464,   465,   466,   467,   468,   469,     0,  1415,  1416,
       0,     0,   472,     0,   474,     0,     0,   476,   477,   478,
     479,   480,   481,   482,     0,     0,   483,   484,   485,   486,
     487,     0,     0,   488,   489,   490,   491,   492,     0,  1417,
       0,   495,   766,   496,   497,   498,   499,     0,     0,   500,
       0,     0,   501,   502,   503,   504,   505,   506,     0,   210,
       0,     0,     0,     0,     0,     0,     0,   516,   517,   518,
     211,   212,   213,   214,   215,   216,   217,   218,     0,   220,
     221,   222,     0,     0,     0,     0,   223,     0,     0,     0,
     224,   225,     0,   226,   227,     0,   228,   229,   230,   231,
     232,     0,   233,   234,     0,   235,   236,   237,   238,   239,
       0,     0,   240,   241,   242,   243,   244,     0,   245,   246,
     247,   248,   249,     0,     0,     0,   250,   251,   252,   253,
       0,   254,   255,     0,   256,   257,   258,   259,   260,   261,
       0,     0,   262,   263,     0,     0,     0,     0,     0,     0,
       0,   264,   265,   266,   267,   268,   269,   270,   271,   272,
       0,   273,     0,   274,   275,   276,   277,   278,     0,   279,
     280,   281,     0,     0,   282,   283,   284,   285,   286,     0,
     287,   288,   289,     0,   290,   291,   292,     0,   293,   294,
     295,   296,   297,   298,   299,   300,   301,     0,   302,     0,
     303,   304,   305,   306,     0,   307,     0,   308,     0,     0,
       0,   309,   310,   311,     0,   312,   313,     0,   314,     0,
     315,   316,   317,   318,   319,     0,   320,   321,   322,     0,
     323,   324,   325,   326,   327,   328,     0,   329,     0,   330,
     331,   332,   333,   334,   335,   336,     0,   337,     0,   338,
       0,     0,   339,     0,   340,   341,   342,   343,   344,     0,
     345,   346,     0,   347,   348,     0,   349,     0,     0,   350,
     351,   352,     0,     0,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,   365,   366,     0,   367,
     368,   369,   370,     0,   371,   372,     0,   373,     0,   374,
     375,   376,   377,   378,   379,     0,   380,     0,     0,   381,
     382,   383,     0,     0,   384,   385,     0,   386,     0,   387,
     388,   389,   390,   391,     0,   393,   394,     0,   395,   396,
     397,   398,   399,   400,   401,     0,   402,   403,   404,   405,
     406,   407,     0,   409,   410,   411,   412,   413,   414,     0,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,     0,   426,   427,     0,   428,   429,   430,     0,   432,
     433,   434,   435,   436,   437,   438,     0,   439,   440,   441,
     442,   443,     0,   444,   445,   446,   447,     0,   448,   449,
     450,     0,   451,   452,   453,   454,   455,   456,   457,   458,
     459,   460,   461,     0,   462,   463,     0,   464,   465,   466,
     467,   468,   469,     0,   470,   471,     0,     0,   472,   473,
     474,   475,     0,   476,   477,   478,   479,   480,   481,   482,
       0,     0,   483,   484,   485,   486,   487,     0,     0,   488,
     489,   490,   491,   492,   493,   494,     0,   495,     0,   496,
     497,   498,   499,     0,     0,   500,     0,     0,   501,   502,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
     513,   514,   515,   516,   517,   518,  1397,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   211,   212,   213,
     214,   215,   216,   217,   218,     0,   220,   221,   222,     0,
       0,     0,     0,   223,     0,     0,     0,   224,   225,     0,
     226,   227,   745,   228,   229,   230,     0,  1398,   746,  1399,
    1400,     0,   235,   236,   237,   238,   239,     0,     0,   240,
     241,  1401,  1402,   244,     0,   245,   246,   247,   248,     0,
       0,   747,     0,   250,   251,   252,   253,   748,   254,   255,
       0,   256,   257,   258,   259,   260,   261,     0,   749,   262,
     263,     0,     0,     0,   750,     0,     0,     0,   264,   265,
     266,   267,   268,   269,  1403,  1404,   272,     0,   273,     0,
     274,   275,   276,   277,   278,     0,   279,   280,   281,     0,
       0,   282,   283,  1056,   285,   286,     0,   287,   288,   289,
       0,   290,   291,   292,     0,   293,   294,   295,   296,     0,
     298,   299,   300,     0,     0,   302,     0,   303,   304,  1405,
     306,     0,   307,     0,   308,   751,     0,   752,   309,   310,
     311,     0,   312,     0,     0,   314,     0,   315,   316,   317,
     318,   319,   753,   320,   321,   322,     0,   323,   324,   325,
     326,   327,   328,     0,   329,   754,     0,   331,   332,   333,
     334,  1406,  1407,     0,  1408,     0,   338,   755,   756,   339,
     757,   340,   341,   342,   343,   344,     0,   345,   346,     0,
     347,     0,   758,   349,   759,     0,   350,   351,   352,     0,
       0,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,  1409,   760,  1410,   368,   369,  2029,
       0,   371,   372,   761,   373,     0,     0,   375,  1411,   377,
     378,   379,     0,   380,     0,     0,   381,   382,   383,     0,
       0,   384,     0,   762,   386,   763,     0,   388,   389,   390,
     391,   392,   393,   394,     0,   395,     0,   397,     0,   399,
     400,   401,     0,   402,   403,   404,   405,   406,   407,   408,
     409,  1412,   411,   412,   413,   414,     0,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,     0,   426,
     427,   764,   428,   429,     0,   431,   432,   433,   434,   435,
     436,   437,   438,     0,   439,   440,   441,   442,   443,     0,
     444,  1413,   446,   447,   765,   448,  1414,   450,     0,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,     0,
       0,   462,   463,     0,   464,   465,   466,   467,   468,   469,
       0,  1415,  1416,     0,     0,   472,     0,   474,     0,     0,
     476,   477,   478,   479,   480,   481,   482,     0,     0,   483,
     484,   485,   486,   487,     0,     0,   488,   489,   490,   491,
     492,     0,  1417,     0,   495,   766,   496,   497,   498,   499,
       0,     0,   500,     0,     0,   501,   502,   503,   504,   505,
     506,     0,  1397,     0,     0,     0,     0,     0,     0,     0,
     516,   517,   518,   211,   212,   213,   214,   215,   216,   217,
     218,     0,   220,   221,   222,     0,     0,     0,     0,   223,
       0,     0,     0,   224,   225,     0,   226,   227,   745,   228,
     229,   230,     0,  1398,   746,  1399,  1400,     0,   235,   236,
     237,   238,   239,     0,     0,   240,   241,  1401,  1402,   244,
       0,   245,   246,   247,   248,     0,     0,   747,     0,   250,
     251,   252,   253,   748,   254,   255,     0,   256,   257,   258,
     259,   260,   261,     0,   749,   262,   263,     0,     0,     0,
     750,     0,     0,     0,   264,   265,   266,   267,   268,   269,
    1403,  1404,   272,     0,   273,     0,   274,   275,   276,   277,
     278,     0,   279,   280,   281,     0,     0,   282,   283,  1056,
     285,   286,     0,   287,   288,   289,     0,   290,   291,   292,
       0,   293,   294,   295,   296,     0,   298,   299,   300,     0,
       0,   302,     0,   303,   304,  1405,   306,     0,   307,     0,
     308,   751,     0,   752,   309,   310,   311,     0,   312,     0,
       0,   314,     0,   315,   316,   317,   318,   319,   753,   320,
     321,   322,     0,   323,   324,   325,   326,   327,   328,     0,
     329,   754,     0,   331,   332,   333,   334,  1406,  1407,     0,
    1408,     0,   338,   755,   756,   339,   757,   340,   341,   342,
     343,   344,     0,   345,   346,     0,   347,     0,   758,   349,
     759,     0,   350,   351,   352,     0,     0,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
    1409,   760,  1410,   368,   369,  3252,     0,   371,   372,   761,
     373,     0,     0,   375,  1411,   377,   378,   379,     0,   380,
       0,     0,   381,   382,   383,     0,     0,   384,     0,   762,
     386,   763,     0,   388,   389,   390,   391,   392,   393,   394,
       0,   395,     0,   397,     0,   399,   400,   401,     0,   402,
     403,   404,   405,   406,   407,   408,   409,  1412,   411,   412,
     413,   414,     0,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,     0,   426,   427,   764,   428,   429,
       0,   431,   432,   433,   434,   435,   436,   437,   438,     0,
     439,   440,   441,   442,   443,     0,   444,  1413,   446,   447,
     765,   448,  1414,   450,     0,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,     0,     0,   462,   463,     0,
     464,   465,   466,   467,   468,   469,     0,  1415,  1416,     0,
       0,   472,     0,   474,     0,     0,   476,   477,   478,   479,
     480,   481,   482,     0,     0,   483,   484,   485,   486,   487,
       0,     0,   488,   489,   490,   491,   492,     0,  1417,     0,
     495,   766,   496,   497,   498,   499,     0,     0,   500,     0,
       0,   501,   502,   503,   504,   505,   506,     0,  1397,     0,
       0,     0,     0,     0,     0,     0,   516,   517,   518,   211,
     212,   213,   214,   215,   216,   217,   218,     0,   220,   221,
     222,     0,     0,     0,     0,   223,     0,     0,     0,   224,
     225,     0,   226,   227,   745,   228,   229,   230,     0,  1398,
     746,  1399,  1400,     0,   235,   236,   237,   238,   239,     0,
       0,   240,   241,  1401,  1402,   244,     0,   245,   246,   247,
     248,     0,     0,   747,     0,   250,   251,   252,   253,   748,
     254,   255,     0,   256,   257,   258,   259,   260,   261,     0,
     749,   262,   263,     0,     0,     0,   750,     0,     0,     0,
     264,   265,   266,   267,   268,   269,  1403,  1404,   272,     0,
     273,     0,   274,   275,   276,   277,   278,     0,   279,   280,
     281,     0,     0,   282,   283,  1056,   285,   286,     0,   287,
     288,   289,     0,   290,   291,   292,     0,   293,   294,   295,
     296,     0,   298,   299,   300,     0,     0,   302,     0,   303,
     304,  1405,   306,     0,   307,     0,   308,   751,     0,   752,
     309,   310,   311,     0,   312,     0,     0,   314,     0,   315,
     316,   317,   318,   319,   753,   320,   321,   322,     0,   323,
     324,   325,   326,   327,   328,     0,   329,   754,     0,   331,
     332,   333,   334,  1406,  1407,     0,  1408,     0,   338,   755,
     756,   339,   757,   340,   341,   342,   343,   344,     0,   345,
     346,     0,   347,     0,   758,   349,   759,     0,   350,   351,
     352,     0,     0,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,  1409,   760,  1410,   368,
     369,     0,     0,   371,   372,   761,   373,     0,     0,   375,
    1411,   377,   378,   379,     0,   380,     0,     0,   381,   382,
     383,     0,     0,   384,     0,   762,   386,   763,     0,   388,
     389,   390,   391,   392,   393,   394,     0,   395,     0,   397,
       0,   399,   400,   401,     0,   402,   403,   404,   405,   406,
     407,   408,   409,  1412,   411,   412,   413,   414,     0,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
       0,   426,   427,   764,   428,   429,     0,   431,   432,   433,
     434,   435,   436,   437,   438,     0,   439,   440,   441,   442,
     443,     0,   444,  1413,   446,   447,   765,   448,  1414,   450,
       0,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,     0,     0,   462,   463,     0,   464,   465,   466,   467,
     468,   469,     0,  1415,  1416,     0,     0,   472,     0,   474,
       0,     0,   476,   477,   478,   479,   480,   481,   482,     0,
       0,   483,   484,   485,   486,   487,     0,     0,   488,   489,
     490,   491,   492,     0,  1417,     0,   495,   766,   496,   497,
     498,   499,     0,     0,   500,     0,     0,   501,   502,   503,
     504,   505,   506,     0,  1397,     0,     0,     0,     0,     0,
       0,     0,   516,   517,   518,   211,   212,   213,   214,   215,
     216,   217,   218,     0,   220,   221,   222,     0,     0,     0,
       0,   223,     0,     0,     0,   224,   225,     0,   226,   227,
     745,   228,   229,   230,     0,  1398,   746,  1399,  1400,     0,
     235,   236,   237,   238,   239,     0,     0,   240,   241,  1401,
    1402,   244,     0,   245,   246,   247,   248,     0,     0,   747,
       0,   250,   251,   252,   253,   748,   254,   255,     0,   256,
     257,   258,   259,   260,   261,     0,   749,   262,   263,     0,
       0,     0,   750,     0,     0,     0,   264,   265,   266,   267,
     268,   269,  1403,  1404,   272,     0,   273,     0,   274,   275,
     276,   277,   278,     0,   279,   280,   281,     0,     0,   282,
     283,  1056,   285,   286,     0,   287,   288,   289,     0,   290,
     291,   292,     0,   293,   294,   295,   296,     0,   298,   299,
     300,     0,     0,   302,     0,   303,   304,  1405,   306,     0,
     307,     0,   308,   751,     0,   752,   309,   310,   311,     0,
     312,     0,     0,   314,     0,   315,   316,   317,   318,   319,
     753,   320,   321,   322,     0,   323,   324,   325,   326,   327,
     328,     0,   329,   754,     0,   331,   332,   333,   334,  1406,
    1407,     0,  1408,     0,   338,   755,   756,   339,   757,   340,
     341,   342,   343,   344,     0,   345,   346,     0,   347,     0,
     758,   349,   759,     0,   350,   351,   352,     0,     0,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,  1409,   760,  1410,   368,   369,     0,     0,   371,
     372,   761,   373,     0,     0,   375,  1411,   377,   378,   379,
       0,   380,     0,     0,   381,   382,   383,     0,     0,   384,
       0,   762,   386,   763,     0,   388,   389,   390,   391,   392,
     393,   394,     0,   395,     0,   397,     0,   399,   400,   401,
       0,   402,   403,   404,   405,   406,   407,   408,   409,  1412,
     411,   412,   413,   414,     0,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,     0,   426,   427,   764,
     428,   429,     0,   431,   432,   433,   434,   435,   436,   437,
     438,     0,   439,   440,   441,   442,   443,     0,   444,  1881,
     446,   447,   765,   448,  1414,   450,     0,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,     0,     0,   462,
     463,     0,   464,   465,   466,   467,   468,   469,     0,  1415,
    1416,     0,     0,   472,     0,   474,     0,     0,   476,   477,
     478,   479,   480,   481,   482,     0,     0,   483,   484,   485,
     486,   487,     0,     0,   488,   489,   490,   491,   492,     0,
    1417,     0,   495,   766,   496,   497,   498,   499,     0,     0,
     500,     0,     0,   501,   502,   503,   504,   505,   506,     0,
    1397,     0,     0,     0,     0,     0,     0,     0,   516,   517,
     518,   211,   212,   213,   214,   215,   216,   217,   218,     0,
     220,   221,   222,     0,     0,     0,     0,   223,     0,     0,
       0,   224,   225,     0,   226,   227,   745,   228,   229,   230,
       0,  1398,   746,  1399,  1400,     0,   235,   236,   237,   238,
     239,     0,     0,   240,   241,  1401,  1402,   244,     0,   245,
     246,   247,   248,     0,     0,   747,     0,   250,   251,   252,
     253,   748,   254,   255,     0,   256,   257,   258,   259,   260,
     261,     0,   749,   262,   263,     0,     0,     0,   750,     0,
       0,     0,   264,   265,   266,   267,   268,   269,  1403,  1404,
     272,     0,   273,     0,   274,   275,   276,   277,   278,     0,
     279,   280,   281,     0,     0,   282,   283,  1056,   285,   286,
       0,   287,   288,   289,     0,   290,   291,   292,     0,   293,
     294,   295,   296,     0,   298,   299,   300,     0,     0,   302,
       0,   303,   304,  1405,   306,     0,   307,     0,   308,   751,
       0,   752,   309,   310,   311,     0,   312,     0,     0,   314,
       0,   315,   316,   317,   318,   319,   753,   320,   321,   322,
       0,   323,   324,   325,   326,   327,   328,     0,   329,   754,
       0,   331,   332,   333,   334,  1406,  1407,     0,  1408,     0,
     338,   755,   756,   339,   757,   340,   341,   342,   343,   344,
       0,   345,   346,     0,   347,     0,   758,   349,   759,     0,
     350,   351,   352,     0,     0,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,  1409,   760,
    1410,   368,   369,     0,     0,   371,   372,   761,   373,     0,
       0,   375,  1411,   377,   378,   379,     0,   380,     0,     0,
     381,   382,   383,     0,     0,   384,     0,   762,   386,   763,
       0,   388,   389,   390,   391,   392,   393,   394,     0,   395,
       0,   397,     0,   399,   400,   401,     0,   402,   403,   404,
     405,   406,   407,   408,   409,  1412,   411,   412,   413,   414,
       0,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,     0,   426,   427,   764,   428,   429,     0,   431,
     432,   433,   434,   435,   436,   437,   438,     0,   439,   440,
     441,   442,   443,     0,   444,     0,   446,   447,   765,   448,
    1414,   450,     0,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,     0,     0,   462,   463,     0,   464,   465,
     466,   467,   468,   469,     0,  1415,  1416,     0,     0,   472,
       0,   474,     0,     0,   476,   477,   478,   479,   480,   481,
     482,     0,     0,   483,   484,   485,   486,   487,     0,     0,
     488,   489,   490,   491,   492,     0,  1417,     0,   495,   766,
     496,   497,   498,   499,     0,     0,   500,     0,     0,   501,
     502,   503,   504,   505,   506,     0,  1397,     0,     0,     0,
       0,     0,     0,     0,   516,   517,   518,   211,   212,   213,
     214,   215,   216,   217,   218,     0,   220,   221,   222,     0,
       0,     0,     0,   223,     0,     0,     0,   224,   225,     0,
     226,   227,   745,   228,   229,   230,     0,     0,   746,     0,
       0,     0,   235,   236,   237,   238,   239,     0,     0,   240,
     241,     0,     0,   244,     0,   245,   246,   247,   248,     0,
       0,   747,     0,   250,   251,   252,   253,   748,   254,   255,
       0,   256,   257,   258,   259,   260,   261,     0,   749,   262,
     263,     0,     0,     0,   750,     0,     0,     0,   264,   265,
     266,   267,   268,   269,     0,     0,   272,     0,   273,     0,
     274,   275,   276,   277,   278,     0,   279,   280,   281,     0,
       0,   282,   283,   284,   285,   286,     0,   287,   288,   289,
       0,   290,   291,   292,     0,   293,   294,   295,   296,     0,
     298,   299,   300,     0,     0,   302,     0,   303,   304,     0,
     306,     0,   307,     0,   308,   751,     0,   752,   309,   310,
     311,     0,   312,     0,     0,   314,     0,   315,   316,   317,
     318,   319,   753,   320,   321,   322,     0,   323,   324,   325,
     326,   327,   328,     0,   329,   754,     0,   331,   332,   333,
     334,     0,     0,     0,     0,     0,   338,   755,   756,   339,
     757,   340,   341,   342,   343,   344,     0,   345,   346,     0,
     347,     0,   758,   349,   759,     0,   350,   351,   352,     0,
       0,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,     0,   760,     0,   368,   369,     0,
       0,   371,   372,   761,   373,     0,     0,   375,     0,   377,
     378,   379,     0,   380,     0,     0,   381,   382,   383,     0,
       0,   384,     0,   762,   386,   763,     0,   388,   389,   390,
     391,   392,   393,   394,     0,   395,     0,   397,     0,   399,
     400,   401,     0,   402,   403,   404,   405,   406,   407,   408,
     409,     0,   411,   412,   413,   414,     0,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,     0,   426,
     427,   764,   428,   429,     0,   431,   432,   433,   434,   435,
     436,   437,   438,     0,   439,   440,   441,   442,   443,     0,
     444,     0,   446,   447,   765,   448,     0,   450,     0,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,     0,
       0,   462,   463,     0,   464,   465,   466,   467,   468,   469,
       0,     0,     0,     0,     0,   472,     0,   474,     0,     0,
     476,   477,   478,   479,   480,   481,   482,     0,     0,   483,
     484,   485,   486,   487,     0,     0,   488,   489,   490,   491,
     492,     0,     0,     0,   495,   766,   496,   497,   498,   499,
       0,     0,   500,     0,     0,   501,   502,   503,   504,   505,
     506,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     516,   517,   518
};

#define yypact_value_is_default(Yystate) \
  (!!((Yystate) == (-4005)))

#define yytable_value_is_error(Yytable_value) \
  (!!((Yytable_value) == (-2276)))

static const yytype_int16 yycheck[] =
{
       0,     0,     0,     0,     0,     0,    16,    34,   738,   189,
     193,    11,    48,    21,    24,   195,   546,   690,    26,   938,
      20,   179,    20,   743,  1179,   997,   206,   975,    43,   171,
     188,   947,   768,     7,   815,   942,  1669,  1228,  1869,   575,
      14,   967,  1163,   796,   820,  1707,    21,  1567,    48,  2028,
     831,    26,  1263,   840,   645,   646,   647,    12,  1413,  1025,
     651,  1273,  2641,   593,   896,  2311,   595,  1161,  1083,   575,
    1370,   697,    22,  2617,   906,   877,   605,   613,  1269,  1054,
    1055,  2467,    20,  2170,    34,  1283,  1604,  1430,  2162,  2895,
    1211,  2832,  2661,  1469,  2663,  3115,  2857,  1184,  1073,  1885,
    1886,   882,   537,  2078,  1833,   886,  1322,  2813,  2472,  2289,
     891,  3158,     0,  2470,  2471,  2525,  3154,   898,  2795,  1638,
      17,  1215,  1334,  2884,    42,  2123,   928,   908,  3207,   819,
    3407,  2874,  2518,  1652,     0,   825,  2813,   612,   158,   173,
      33,  1339,  1340,   833,     0,  3428,  3417,    40,  1524,   584,
     173,     0,     0,  3056,  3088,     0,  1255,   693,  1269,    39,
       0,     0,  3364,     0,     0,  1215,     0,  2533,  3087,  1472,
     954,     0,  3082,   173,     0,  1101,  2404,   785,  3125,     0,
    1480,   965,  3014,  1702,     0,   735,  2165,   693,  3641,    32,
       9,  3845,  4122,  2817,  2818,  2819,  2820,  2821,  2822,     5,
    1043,  1044,     0,   735,     5,     0,     5,  3949,    11,  3951,
      45,     5,    13,    59,     9,   831,  2467,  3982,     5,    13,
      52,    52,   975,  1885,   180,   181,  1069,    22,   184,    38,
     186,     0,    97,    38,   104,   104,    22,    52,     5,   104,
      36,    22,   148,    29,    18,    73,  4115,    69,   159,   205,
       0,    22,    69,    59,   153,    77,    69,  2236,    29,  2238,
     123,   173,   153,    77,   190,     5,  4270,  2518,    52,     5,
       5,     5,   198,     5,     5,   128,    36,     5,    13,   131,
       5,   207,     0,   201,   875,     5,    84,    80,   155,     5,
      71,     9,   153,     5,    11,   106,     5,    78,   250,   156,
     235,   247,  2619,  2531,    22,   252,     0,    69,    53,   121,
     154,  4068,    20,    67,   156,   251,    61,    28,   247,   166,
      37,   281,     5,    23,   105,    59,   134,   106,   311,    97,
     860,     4,   153,    41,    22,   327,     9,   153,   190,  1433,
       9,    29,     9,    65,   298,   145,   327,   121,   302,   291,
      67,     5,   173,     5,   107,     9,   108,   173,   153,   264,
     158,  1148,   224,   546,   544,    25,  1102,  1451,   548,    11,
     309,   401,   237,   327,   532,   133,   286,   224,   173,   559,
     401,   435,   424,   298,   153,   439,  1470,     4,   104,   392,
      84,  4395,     9,  1146,  1130,     4,   177,   439,  1151,  1152,
       9,  1416,   312,   153,   173,   257,    11,    26,    27,  1564,
     593,   441,   327,  1568,   106,  1570,   174,   170,  1573,   948,
     441,   579,   327,   173,   135,    67,  1946,   963,  1403,  1404,
    4172,   589,    37,   286,   234,   153,  1411,   153,    18,   975,
      11,   193,   381,   255,  3646,    69,   313,   401,    11,   441,
     104,   320,   394,  4107,   437,   173,   318,   963,   439,   406,
    1379,   360,    67,   242,   158,   322,    37,   235,  1384,   153,
     215,   318,   304,   304,  1003,   340,    69,   437,   343,   187,
     322,   350,  1603,   418,  1013,   437,  4243,   187,   200,   304,
     302,   437,  1245,  1029,   351,   111,    67,  1026,    18,   435,
    1253,   368,   977,   439,   196,   153,   242,   305,   437,   351,
     303,   242,  4516,   370,  2831,   327,    97,   527,   109,   388,
     304,   329,   374,  1029,  3148,   424,  1881,  3233,   250,   441,
     441,   437,   401,   152,   397,   154,  4405,  1318,   360,  1320,
     439,   121,  1663,   360,   372,   237,   360,   360,  1891,   335,
     441,   347,  1328,  1243,   424,   360,  3233,  1310,  1401,  1402,
    1313,  1314,   343,  1395,   335,   575,   576,  1410,   437,  4334,
    3847,  1373,   437,   384,   341,   342,   437,   613,   387,   535,
    1674,  1368,  3161,   539,   437,   391,  1558,   347,  1709,  2568,
    4520,   437,   391,   437,   437,   287,   738,   617,   360,   525,
     556,   121,   437,   401,   530,  1295,   380,  1143,  3810,   441,
     441,   305,   612,   613,   612,  1151,  1152,   436,   626,   440,
     628,  1528,   630,   194,   440,  3386,   441,  1380,   636,   526,
     433,   437,  3566,   428,   429,    25,   437,  1143,   437,  3542,
     438,   301,   440,   437,   360,   440,  3565,   335,   441,   659,
     437,   626,  1202,   628,  1262,   630,   611,  3489,  1565,  3861,
    3401,   636,   637,   638,   879,  3575,   640,  1574,   135,  3579,
    1202,   440,   682,  3416,  3621,   613,  1602,   860,  1604,   689,
    4422,   435,   692,   693,   694,   439,  1302,   845,  1614,  1305,
     440,    11,  1618,   727,  3080,   435,  3082,   437,   856,   439,
    1626,  1627,   437,   437,   727,   437,  1490,   401,   424,   437,
     428,   429,   437,  1639,  1640,  1499,   433,   437,   298,  1503,
     403,  3345,   440,   439,  1650,  1509,  1510,   727,   437,   729,
     729,   729,   729,   729,   729,  4188,   360,  3101,   656,  2042,
     423,   667,  4396,  1527,   438,   265,   440,  1959,  3327,   441,
    2536,   403,  2538,    22,   437,   428,   429,   441,   916,   428,
     429,   428,   429,   109,   690,  2852,   382,   360,   437,   350,
    1300,   423,  3158,   392,    52,  3977,  3142,  2775,   298,   717,
    2778,  2779,  3984,   709,  2782,   437,    43,  1630,  1631,   380,
    2788,     3,   401,   441,     8,   713,  1011,    11,   135,    97,
     134,  2780,  2781,     5,   730,  1899,    97,   327,  2470,  2471,
    2472,   691,  2024,     5,  1194,   695,    75,  4471,    97,   428,
     429,   796,   104,   104,   742,   430,   431,   432,   433,  3080,
      98,  3082,     8,    61,  4105,    11,     3,     4,     5,   153,
     186,   729,     9,   799,   800,    97,  4196,  4197,    99,  1899,
    2483,  2370,  2371,   320,   113,    35,  2375,   428,   429,   430,
     431,   432,   433,   729,    76,   385,   784,   430,   431,   432,
     433,   797,   154,   729,   194,    22,  1987,    97,  1977,   247,
     729,   729,   327,   350,   729,  1476,   109,   775,  3935,   729,
     729,   162,   729,   729,  3438,   729,  2415,  2416,  1571,  1572,
     729,  3129,   134,   729,   132,   147,   161,  3158,   176,    84,
     153,   301,   169,   109,   126,   166,   173,   873,  2012,   235,
       5,   388,   150,   313,  1660,    10,   148,    16,   821,   822,
     257,  3978,   401,    18,   401,  3985,   158,   104,   894,   895,
     104,    30,    11,   831,   162,   257,   251,   116,   265,   118,
      35,   173,    61,   963,   211,   162,   238,   235,   914,   173,
     257,   242,   888,   186,    99,   975,   178,   148,    77,   116,
     437,  1500,   441,   224,   364,     8,   227,   977,  1508,   977,
     194,   298,  1511,   158,   910,   911,   912,  2203,   944,   945,
     186,    18,   172,  3896,  1523,   329,   441,    24,  1008,  1535,
     975,  4278,  3936,   272,  2215,    75,   980,   266,   982,  2795,
     984,  4294,   986,  4284,   988,   989,   990,   235,   194,  1029,
     317,   995,   919,   132,   191,  4075,   304,  2813,   235,   265,
    3940,   166,   274,   324,   380,  3945,     5,  1037,  3948,   253,
     242,   150,   155,   113,  1828,   134,   360,   265,   215,   327,
     242,   279,   350,   322,   309,  3861,  3635,  1057,   270,  1534,
     397,  1496,   298,  2157,     3,  1101,     5,   318,  4115,   437,
     386,   350,   315,   237,   331,  3836,  1002,   253,   247,  4429,
     298,   349,   350,  1298,   353,   307,   355,  1087,    61,   224,
      75,   327,   227,  1103,   121,   354,  3839,   329,   350,  1025,
     382,  1101,   106,  1113,  3673,    45,  1636,  2893,   428,   429,
     430,   431,   432,   433,   441,   386,  1126,  1300,   104,   300,
    4397,    18,  2277,     5,   320,   194,    18,    24,   113,   441,
     350,   104,    24,  1143,   106,   104,  1146,  1147,   153,  4189,
     253,  1151,  1152,    18,   367,     5,   106,   375,  4186,  4199,
     393,   315,  1172,  1187,  1188,    95,  1190,   380,   173,  1374,
      99,   373,   155,   350,  1187,  1188,   417,  1190,   386,   381,
     279,  1146,   384,  2148,  1354,    75,  1151,  1152,   264,   386,
    2370,  2371,   194,   318,   380,  2375,   437,  1187,  1188,  3575,
    1190,  2534,   196,  3579,     5,  1868,   266,  2540,    31,  4470,
     257,   437,  4281,  4474,  4406,    22,   143,   300,   180,  3619,
     424,   425,   426,   113,   428,   429,   430,   431,   432,   433,
     253,   173,   311,  1438,   121,  2415,  2416,   166,   264,   121,
     343,  1157,  3596,   237,  3591,  4138,   196,  3601,    75,   251,
     329,   327,  2074,   327,   104,   185,   121,   108,  4519,   425,
     426,   237,   428,   429,   430,   431,   432,   433,  1638,  4169,
     253,   428,   429,   235,   237,   237,   375,  4314,   222,   242,
    1245,   104,  1652,  1453,   265,   212,   113,   237,  1253,  1205,
    1495,   266,   417,   287,   354,   224,  1204,   114,   227,  1469,
    3470,   109,  2045,   104,   278,   235,  1986,   124,   199,   116,
    2053,  2395,  2055,   121,  4010,  3303,   279,  2401,   401,  4212,
    2229,  3309,  3310,  4216,  4217,  1290,  1326,   362,  4338,  4339,
     293,  1501,  1278,  2239,  3575,  1508,  2233,   287,  3579,   154,
     334,  1489,   193,  4010,   198,  1310,   327,    33,  1313,  1314,
    1498,   311,  1268,  1240,  1524,  4086,   298,  2128,   441,  1275,
     302,  4092,  2042,  2185,  2186,  2187,  2188,   441,  4405,   428,
     429,   430,   431,   432,   433,  2197,   266,    77,   265,   354,
     162,   235,    96,   265,  2064,   327,   316,  4480,   362,   318,
    1306,   438,  1392,  1309,   441,  1341,  1342,  1343,  1344,   437,
     265,   424,   425,   426,   104,   428,   429,   430,   431,   432,
     433,   298,   375,  2093,  2491,  1380,   298,  3136,  2563,  1567,
     380,  2931,   264,  2339,  1302,  1333,   112,  1305,  1948,  1345,
     404,  2223,  2633,   298,   257,  3400,  1382,  1383,   313,   266,
     327,    45,  1388,  1359,   360,   327,    96,     0,   265,  3101,
     360,   352,   267,   235,  2228,  1455,  1372,  3233,   440,   401,
    2991,  2969,   327,  1636,   354,  1984,   360,  1672,   276,  4562,
    2244,  2245,  2388,   255,  2248,   329,  3445,   107,  3447,  1904,
    2254,   298,    86,  4493,  3015,   327,  1432,  2996,   417,   364,
    2999,  3000,  3001,  3002,  3003,  3004,  3005,  3006,  3007,  3008,
     401,  4070,   403,  2419,   298,   315,   110,    76,   424,   223,
    2716,   225,    79,  1459,  1460,  1461,  1462,   332,  4269,   157,
    3029,   125,   255,   439,  2726,   129,   380,   354,   178,   265,
     313,   441,   265,   327,   441,   278,   437,   237,  2281,  2313,
     170,  2457,   352,   107,  1534,   149,  1534,   441,   152,  3058,
    3059,   118,   143,   198,  2920,  1471,   125,   148,   382,  3935,
     164,  1477,   298,   143,  3940,   298,   106,  1513,   157,  3945,
     382,   313,  3948,   223,  2037,   225,  1522,   215,  1595,  2544,
    1544,   364,  1546,  1529,  1548,   116,  1550,   118,  1552,  4123,
     235,   401,  1556,   403,    11,  1585,  1585,  1585,  1585,  1585,
    1585,   424,  3978,   353,   386,   355,   170,  1535,   148,  2034,
    4406,  2573,   435,   437,   437,   438,   439,  1533,   441,   362,
      37,   212,   364,  1623,   382,   437,   215,   437,   362,  2092,
    2211,  4200,   212,  4007,   281,   204,   205,   116,   242,   118,
     180,   302,   287,   265,  3880,     8,   250,  4206,    11,   218,
      67,  1616,  1617,  4404,  1594,  1571,  1572,    11,   249,  1624,
     393,   404,   141,  1628,  1629,    28,   327,  4041,   364,   249,
     404,  1587,  1580,   287,   246,   116,   298,   118,  1643,   437,
    1645,   285,   155,    37,   329,   299,   394,  3656,  3657,  1679,
    2878,   154,  2218,  2881,  3935,   235,   265,   237,  2604,  3940,
     141,  1666,   291,  1668,  3945,   327,   237,  3948,    39,   323,
     183,   265,   320,    67,  1601,   353,   247,   355,  3341,   182,
     302,   311,  2218,  1723,   317,  1895,  2252,   148,  2812,    60,
    1900,  1677,  4463,  1903,   197,   380,  3972,  3978,  3974,  4115,
     378,  2484,   350,    69,   298,   327,   209,   168,   302,   339,
    3827,    77,   239,   200,  3818,  1925,  2252,  2477,   237,    58,
      59,    85,   237,   242,   353,  4299,   355,   242,   247,  3757,
    3758,    20,  4341,   327,  3838,  1948,   265,   291,   131,     8,
     388,   315,    11,   352,  2929,   354,  1991,     3,  1704,   378,
     143,  1939,    41,  4169,   403,   148,  1966,  1713,  1946,   265,
    2592,   242,  2576,    19,    69,   394,   247,   321,   360,   298,
     285,   437,    77,  1983,   423,   148,  2996,   364,   352,  2999,
    3000,  3001,  3002,  3003,  3004,  3005,  3006,  3007,  3008,   437,
     154,   194,   298,   320,   315,   168,   350,   190,   327,  2009,
     194,   195,   311,   312,   315,   308,   251,   401,  3357,  1847,
     436,   256,   436,  3186,  2620,   441,   265,   441,   182,   212,
      76,   327,  4431,   350,   364,  2481,  2036,   401,   300,   403,
    2040,   352,  3162,   197,  4115,  2649,  2642,  2651,  3058,  3059,
     394,   352,  1847,  1873,  1873,   209,   240,   366,  2058,   298,
     253,   317,  1909,   302,  1911,   438,   249,   376,   441,  2069,
    2862,   388,  1830,   437,   257,   157,   222,   265,   232,  2871,
     126,  3534,  2082,  1829,   401,  1831,  2436,   222,   327,   251,
     401,  2091,   403,    81,   256,   366,     8,  3038,  4169,    11,
     401,  2136,   403,   438,   291,   376,   441,    21,  4314,  3591,
     298,  2621,    26,   143,  3596,    77,   176,  3031,   148,  3601,
     437,   438,  1868,   440,   168,    37,   437,   173,  2484,   311,
     312,    43,   178,   215,   321,   194,   437,   420,   421,   327,
     222,  4540,  1972,   628,   629,   630,  2750,   364,   633,   634,
     635,    74,  2756,     8,   308,    67,    11,   435,   643,   437,
      85,   439,  3194,   350,   394,  1941,  1942,  1943,  2954,   403,
    2370,  2371,    49,    28,  1950,  2375,  1952,  2687,  1954,  1955,
     432,   317,   212,  3018,  3019,   437,   353,   439,   355,   423,
     315,   374,  3210,  3211,   253,   157,  3137,  3536,  3537,  4405,
     437,     8,   439,   437,    11,  3237,   438,   394,   403,   441,
     438,  2560,  2561,   441,   176,  2415,  2416,  1016,  1017,   249,
    1958,    28,  2961,   200,   270,  2826,  4044,   352,   423,   154,
     437,   424,   425,   426,  2590,   428,   429,   430,   431,   432,
     433,     9,   437,  4314,   428,   429,   430,   431,   432,   433,
    2045,  1654,   435,   215,  1657,   438,   439,   182,  2053,  2005,
    2055,   173,   437,   309,  2590,  2300,   435,   438,   437,    50,
     441,   353,   197,   355,    49,  2051,   401,  2023,   403,  3025,
     320,   251,   194,   195,   209,  2115,     8,  2287,  4087,    11,
    2804,  2805,  2806,  2123,   256,     0,   378,   441,  2387,  2903,
    2389,  2390,   348,  2907,  2908,   437,  2910,   232,  2912,  2913,
     350,  2311,   437,   394,   432,    96,    39,  2921,  3232,   437,
    3234,   439,   438,   315,   196,   441,   251,   373,   240,   315,
     438,   251,  2108,   441,  4405,   381,  2958,  2315,   384,   194,
    2116,   253,   419,  2321,  3139,  2121,   439,  3357,   388,  4000,
    2145,  2955,   438,   254,  2184,   441,  3531,  3767,  2707,  3769,
     352,   401,  4428,  3773,   254,  3775,   352,  3159,  3160,   428,
     429,   430,   431,   432,   433,   401,   360,   403,  3860,    84,
    4031,   438,  2212,   308,   441,  2205,  2205,   194,  2218,  2962,
    3421,   353,   148,   355,   175,  3406,  2171,   437,   253,  3313,
     438,   251,   364,   441,  4010,   438,    39,   131,   441,   401,
     437,   403,   439,   375,   419,   401,   378,   403,   419,   143,
     438,  2167,  2252,   441,   148,   438,   131,   254,   441,   438,
    2206,    61,   441,  2436,   401,   196,   403,    67,   143,  2850,
     430,   152,   223,   148,   225,   437,   253,    77,   153,   438,
     441,   437,   441,   158,   235,   437,   161,   382,   163,  2235,
     438,  2237,  3881,  3882,  3883,  3884,   190,   438,   153,   438,
     441,  2827,   194,  2829,   104,   438,   106,   353,   441,   355,
    3455,  3456,  3457,   264,   438,   190,  2281,   441,   212,  2467,
      49,   192,  2841,   978,  2843,   437,   981,  3104,   983,  2502,
     985,  2827,   987,  2829,   439,   327,   991,   212,  3961,   438,
     405,  4117,   441,    84,   173,   437,   428,   429,   430,   431,
     432,   433,   303,   136,   437,   249,  3536,  3537,   353,   439,
     355,   253,   103,   257,   173,   438,  2892,  3093,   441,   438,
    2518,   401,   441,   403,   249,  2545,  3096,  3097,  3098,   173,
     180,   315,   257,  3892,   251,   315,  2332,   338,  2593,  4210,
     136,   136,  3901,  2419,   135,   438,  2892,   251,   441,   424,
     425,   426,   315,   428,   429,   430,   431,   432,   433,  3918,
    3919,   438,   438,   148,   441,   441,   438,  2587,   352,   441,
     438,   438,   352,   441,   441,   438,   136,   106,   441,  2419,
     305,   210,   438,   438,  2953,   441,   441,   237,   438,   352,
     382,   441,   242,  2433,   438,   251,   440,   424,   425,   426,
     437,   428,   429,   430,   431,   432,   433,  2462,  2463,  2464,
     438,   364,  2452,   441,   438,     8,   440,   401,    11,   403,
     394,   401,    21,   403,   732,   350,   734,  2467,   246,   279,
     374,  3592,   317,   438,  2484,    28,   441,   200,   401,  2694,
     403,  2696,    61,   293,   438,  2521,   284,   441,   438,   374,
    3580,   441,  3582,   437,   437,  3616,   401,   437,  2498,  2498,
    2498,  2498,  2498,  2498,    32,  2685,   237,  2482,   438,  2484,
      69,   441,   405,   398,   437,   400,   401,  2697,  2518,   437,
    3296,  2521,   424,   425,   426,   237,   428,   429,   430,   431,
     432,   433,    39,    39,   369,  2461,  2751,   438,   438,    98,
     441,   441,   438,   294,   265,   441,  4066,   238,   239,   438,
     435,     0,   441,   438,   439,   440,   438,   148,    74,   441,
     119,  2776,   394,   438,   438,   375,   441,   441,   394,   320,
     136,   130,   438,  3728,  3729,   441,  3731,   282,   438,   438,
    2590,   441,   441,   438,   438,   438,   441,   441,   441,   136,
    2770,   150,  3518,   136,   438,   437,   155,   441,  3430,   350,
     438,   438,   438,   441,   441,   441,  4437,   438,   438,   405,
     441,   441,  2795,   136,   136,   136,  2996,  4448,  4137,  2999,
    3000,  3001,  3002,  3003,  3004,  3005,  3006,  3007,  3008,   320,
    2813,   438,   441,  4295,   441,    84,   438,   388,   136,   441,
     136,   194,   201,  2599,   251,  2601,  2602,  2603,   438,  3029,
     401,   441,   438,   438,   136,   441,   441,  2667,  3442,   350,
     136,   438,  2877,   222,   441,   136,  3450,  3451,  4499,   438,
     438,   438,   441,   441,   441,   251,   136,   438,  3058,  3059,
     441,   438,   131,   136,   441,   438,   437,   350,   441,  2904,
     437,    32,   149,   210,   143,  2705,   148,   388,   148,   148,
     253,   251,  3892,   437,   153,     5,     5,  3460,   437,   158,
     401,   437,   161,   148,   163,   437,     5,   275,   437,   437,
     437,   437,     5,   282,   437,    26,    27,   437,  3918,  3919,
     437,   437,     5,   437,   437,   437,   437,     5,   437,   437,
    2920,   190,   437,  2753,   437,   437,   437,   437,   402,   437,
     309,   437,   437,   437,  2934,   437,   315,   262,   192,    87,
    2975,   441,   321,   212,   441,  2775,    32,   210,  2778,  2779,
      32,   148,  2782,  2931,   249,   148,  2956,   247,  2788,   327,
    2995,   315,   360,    84,   439,  2795,   360,   360,   360,   315,
     360,   350,   360,   352,   136,   360,    77,   315,   207,   319,
     249,   242,   103,  2813,   251,  3020,   360,   251,   257,   360,
     369,     8,   381,   352,    11,   360,  3764,  2827,   178,  2829,
    2795,   247,   437,   360,   360,   437,    77,  2802,  2803,   167,
     441,   136,  2807,   265,   135,   394,   173,    98,  2813,    49,
      37,  3056,   382,    49,   382,   360,    43,   360,   360,   360,
     360,  3380,  3381,  3825,   255,  2865,   305,   360,   352,   360,
     360,    38,    38,   360,   315,   360,   441,   360,  3652,  2844,
      67,   424,   425,   426,   405,   428,   429,   430,   431,   432,
     433,  2891,  2892,  2883,  2883,   251,   251,   194,   437,   391,
      32,   437,   401,   437,    31,    20,   251,   136,   237,  3683,
    3684,   350,  2902,  2902,   437,  3641,   104,  2833,  2834,   382,
     136,   247,  4103,   393,   218,   237,    32,   148,   437,    32,
     200,   316,  3080,  2849,  3082,   374,  3068,   136,   136,   136,
     246,   136,   129,   136,   382,   360,   382,  2863,   241,   153,
     358,   397,   419,   229,   229,     8,  2872,  4137,    11,   398,
     437,   400,   401,   437,     0,    11,   441,  4051,  2914,   327,
    2886,  2917,   358,   437,   144,    28,  3750,  3751,   437,   360,
     161,   153,   169,   362,    37,   441,   173,  3357,   167,   438,
      43,   167,   437,   441,   329,   198,   435,  2962,   190,   438,
     439,   440,   252,   294,   382,   259,   441,   194,   195,    49,
    3158,   438,   360,   360,    67,   315,    76,  4162,  2964,  3189,
     437,  3764,   382,   315,   211,   198,   360,  4172,   242,   320,
     198,   242,   437,   394,   364,   360,   360,  3953,  2954,   317,
    3066,   200,  3042,   251,    39,   250,   334,   360,    84,   352,
     360,   242,   441,   240,   315,   298,  3082,   168,   298,   350,
    3233,   360,   324,   287,   360,   194,   253,  3072,  3073,  3074,
    3075,    32,   194,   194,   382,   382,  3066,   194,   194,   250,
     424,  4226,    31,   435,   435,   136,   360,  3607,   360,   148,
    3080,  3865,  3082,  3867,  3868,   131,   360,   388,   437,  4061,
    4062,   392,   424,   360,   247,  3879,  3276,   143,   394,  3279,
     401,   150,   148,   136,   437,  4053,   169,   153,   324,   401,
     173,   437,   158,    32,   165,   161,   251,   163,   251,   148,
     165,    32,   136,   251,   324,   148,   173,   251,   405,   173,
     173,   194,   195,   441,   331,    19,   437,   159,   226,   251,
      49,  3670,   401,   246,   190,   364,     8,   441,   211,    11,
     441,  3077,  3078,  3079,   441,   350,  3536,  3537,   394,   200,
     438,   153,   438,   438,   269,  4320,   212,   153,   438,  3384,
     419,   419,   441,   438,   237,    37,   360,   240,   261,    13,
     438,    43,   438,   438,   438,    13,   438,   398,   380,   388,
     253,   438,  3721,   256,   438,   438,   438,   438,   438,   437,
     437,   305,   437,   249,   437,    67,    49,  3387,   398,   212,
     437,   257,   424,   251,   254,   251,  4142,   437,   176,   136,
    3811,   184,  3952,  3233,  3180,  3181,  3182,  3183,  3764,  3959,
     360,   428,   429,   430,   431,   432,   433,   405,   360,   255,
     360,   242,   360,   136,   136,   176,  3966,  3257,  3256,   270,
    3260,   212,  3262,   270,   360,   220,   379,   315,  3233,   305,
     360,   360,   360,   220,   220,  4237,   360,  4048,   331,   360,
     360,   360,   327,   315,   360,   360,   315,   237,   315,   360,
     136,  3256,   360,  3463,    38,   360,   194,   194,   194,   437,
       3,   435,   438,  3303,  4213,   227,   212,   438,  4214,  3309,
    3310,   441,  3312,   318,   350,   424,    39,   169,    97,   438,
     369,   173,   300,   250,    32,  4222,   251,  4224,   162,   315,
     382,   438,   382,   437,   315,   360,   441,  3542,   374,   438,
     315,   441,   194,   195,   254,   134,   134,  3347,  3348,  3349,
    3350,   194,  3317,  3318,   127,     8,   153,  4131,    11,   211,
      11,   435,   398,  3328,   400,   401,   148,    59,   438,   438,
     153,   424,   425,   426,   438,   428,   429,   430,   431,   432,
     433,   438,  3347,   436,    37,   237,   257,   153,   240,   442,
      43,   393,   161,   437,   441,  4311,   438,   398,   422,   435,
     438,   253,   438,   439,   440,   252,   369,   148,    32,  3355,
     382,   382,   184,  4187,    67,   437,   360,   438,  3418,    49,
     438,   437,   352,   437,   369,  3415,  3415,  3575,  3344,   360,
    4368,  3579,   360,  4517,  3607,   315,   360,  4157,   315,   438,
     360,   360,   438,  4106,   438,    49,   148,  3363,   352,  3654,
      67,    22,    23,  4227,   136,    97,    27,   369,   438,  3979,
     194,    32,    33,    34,   194,    36,   436,   436,    39,    40,
     438,    42,   437,    44,  3390,   401,   198,  3682,  3478,   331,
     283,   437,   324,  4567,   441,   437,   148,   405,   179,    72,
     352,  4575,  4011,   360,   324,  3460,  3701,   438,   441,   441,
     437,  4021,   438,   158,    97,   153,   194,   194,   194,   194,
     153,   292,    49,   399,   399,   438,   169,   197,   260,   197,
     173,   437,  3892,   438,   438,    49,  3696,  4053,   441,   163,
     438,  3901,   437,   247,   424,   438,   438,   437,  3708,   360,
     369,   194,   195,   437,  3749,    32,   438,   438,  3918,  3919,
     153,   401,    67,   178,   424,    49,   352,   441,   211,   242,
     441,   242,   360,   136,    51,   194,   155,   436,   153,   382,
     382,   173,   424,   425,   426,    32,   428,   429,   430,   431,
     432,   433,   122,   397,   401,  3575,   437,   240,   153,  3579,
     401,  4500,   437,   181,   254,   153,    83,   437,   437,   292,
     253,   387,   337,  3603,  3604,   268,   438,   438,   179,   180,
     181,   182,   437,   184,   437,   186,  3633,   188,   197,   190,
     400,   293,   193,   438,  3614,  3614,   401,   198,   251,  3627,
     201,   438,   360,   360,   205,   437,   207,   437,   148,   111,
      32,   242,  3558,  3559,  3560,  3561,   242,   221,   176,   135,
     437,   283,   139,   437,    32,   255,   312,     8,   312,   437,
      11,   438,  3627,    49,   438,  3813,    49,    32,   438,   437,
     382,   438,   437,   352,   235,   352,   251,    28,   331,   352,
     438,  3679,     5,   324,   171,   283,    37,   142,    61,    61,
     254,  3896,    43,   117,   437,   292,   386,    32,   387,   153,
     398,   441,   352,   290,   148,    18,   401,   122,   178,   251,
    3880,    24,   251,   200,  3679,    32,    67,   437,  4492,   254,
     207,    32,   254,   438,   437,    49,   437,   311,   438,   109,
       5,   380,   438,   437,  3699,  3700,    17,    28,   135,  3704,
    3705,   311,   283,   437,   729,  1357,  2169,  3747,  3748,   815,
     237,  1152,    65,  2484,  2642,   822,  3232,  3757,  3758,  4340,
     821,  2086,  2019,  2793,  3764,  3312,  4051,  4137,  3768,  4229,
    4099,   424,   425,   426,  4368,   428,   429,   430,   431,   432,
     433,  3378,  4103,  3804,  3730,   788,  4085,  3935,  3786,  2567,
    4435,  2269,  3940,  3978,  4497,  4382,  4381,  3945,  3744,  3764,
    3948,   114,  3972,  4454,  3974,  4279,  3979,  2571,   121,  2160,
    3370,   124,  2160,  3227,  2662,   302,  4336,  1456,   169,   306,
    2154,  3786,   173,  2864,  4505,   312,  4575,  4567,  4080,  2797,
    3978,  4465,   319,  3833,  2812,  4023,  1446,  4010,  4355,  4026,
     327,  4445,  4368,   194,   195,    26,  3463,  1004,  4021,   336,
    4185,  1014,  3419,  1886,  2543,  3421,  4295,   344,   576,  3859,
     211,    51,  2754,  4569,  4479,   178,  1830,   708,  1831,  1535,
    2498,  3404,  4020,   721,  3615,  2499,  1178,  3134,  1871,  2510,
    1197,  3881,  3882,  3883,  3884,  1196,   237,  2505,  1870,   240,
    1199,  3837,  2526,    83,  3082,  2518,  3566,  4170,  3581,  1204,
    3080,  4314,   253,   713,  4313,   256,  3135,  2135,  3041,   396,
    4140,  3033,  4426,   400,   401,  4427,  4418,  2502,  4066,  2431,
    2433,  2341,   235,  3130,   237,  1706,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4138,   247,    -1,    -1,    -1,    -1,    -1,
      -1,     8,   255,    -1,    11,    -1,    -1,  3863,    -1,   139,
    3940,    -1,   265,    -1,   525,  3945,    -1,    -1,  3948,   530,
      -1,   532,    -1,    -1,   535,    -1,   537,  4115,   539,  4174,
      37,    -1,    -1,    -1,    -1,   546,    43,    -1,   549,    -1,
     331,   171,    -1,    -1,    -1,   556,    -1,    -1,   301,   302,
      -1,    -1,    -1,    -1,    -1,     8,    -1,    -1,    11,  3963,
      67,    -1,    -1,    -1,    -1,    -1,    -1,  4212,   579,    -1,
    4010,  4216,  4217,   584,   327,    28,    -1,   207,   589,    -1,
      -1,  4169,   593,    -1,    37,    -1,    -1,    -1,    -1,    -1,
      43,    -1,    -1,    -1,  3980,  3981,  3982,   608,    -1,    -1,
      -1,    -1,    -1,    -1,  4044,  4010,    -1,   237,    -1,    -1,
      -1,    -1,    -1,  4053,    67,    -1,    -1,  4057,    -1,  4059,
      -1,    -1,    -1,  4063,  4064,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   385,   424,   425,   426,    -1,   428,   429,   430,
     431,   432,   433,    -1,    -1,   656,    -1,    -1,    -1,    -1,
     441,    -1,    -1,    -1,    -1,    -1,   667,   668,    -1,  4089,
    4089,    -1,   169,    -1,    -1,    -1,   173,    -1,  4256,    -1,
      -1,    -1,   302,    -1,   304,    -1,   306,   688,    -1,   690,
     691,    -1,   312,    -1,   695,    -1,    -1,   194,   195,   319,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   327,   709,    -1,
      -1,    -1,   713,    -1,   211,    -1,   336,    -1,   719,     8,
      -1,    -1,    11,  4069,   344,    -1,   169,    -1,    -1,   730,
     173,    -1,    -1,  4336,    -1,    -1,  4314,    -1,  4114,    -1,
      -1,   742,    -1,   240,    -1,    21,    -1,    -1,    37,  4169,
      -1,   194,   195,    -1,    43,    -1,   253,    -1,    -1,    -1,
    4106,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   211,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   396,    -1,    67,    55,
      -1,    -1,    -1,   784,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    68,    -1,   237,    -1,   797,   240,   799,   800,
    4230,    -1,    -1,    -1,    -1,    81,    -1,    -1,    -1,    -1,
     253,    -1,    -1,   256,    -1,    -1,  4394,    -1,  4194,    -1,
     821,   822,    -1,    -1,    -1,    -1,    -1,  4405,  4428,    -1,
      -1,    -1,    -1,    -1,   331,    -1,    -1,    -1,    -1,    -1,
     129,    -1,    -1,   119,   845,    -1,    -1,  4223,    -1,  4225,
      -1,    -1,  4198,    -1,   130,   856,    -1,  4277,  4277,   860,
      -1,    -1,  4440,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   873,    -1,   150,    -1,    -1,    -1,    -1,   155,
     169,    -1,    -1,    -1,   173,    -1,    -1,   888,   331,    -1,
      -1,    -1,    -1,   894,   895,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   194,   195,    -1,    -1,   910,
     911,   912,    -1,   914,    -1,   916,    -1,    -1,    -1,    -1,
      -1,    -1,   211,    -1,    -1,    -1,    -1,    -1,   425,   426,
      -1,   428,   429,   430,   431,   432,   433,    -1,  4368,    -1,
      -1,   942,    -1,   944,   945,    -1,   222,    -1,    -1,    -1,
      -1,   240,    -1,    -1,    -1,    -1,    -1,    -1,  4334,    -1,
      -1,    -1,    -1,    -1,   253,    -1,   967,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   253,    -1,    -1,
      -1,   424,   425,   426,    -1,   428,   429,   430,   431,   432,
     433,    -1,    -1,  4571,     3,    -1,   997,   998,   441,     8,
      -1,  1002,    11,  1004,    -1,    -1,   282,    -1,    -1,    -1,
      -1,    -1,    -1,  4389,    -1,    -1,    -1,    -1,    -1,    28,
      -1,  1022,    -1,    32,  1025,    -1,    -1,  1028,    37,    -1,
      -1,    -1,    -1,    -1,    43,    -1,    -1,    -1,    -1,   315,
    1041,    -1,   331,    -1,    -1,   321,  4466,  4466,   324,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    67,  4479,
    4479,  4479,  4479,  4479,  4479,    18,  4522,    -1,    -1,  1070,
      -1,    24,    -1,  4449,   350,    -1,    -1,    -1,    -1,    -1,
     356,    -1,    -1,    -1,    -1,    -1,    -1,  4517,    -1,    -1,
      -1,    -1,    -1,   369,    -1,    -1,    -1,  1098,  1099,    -1,
    1101,    -1,  4522,  4522,  4522,  4522,  4522,  4522,    -1,    -1,
      -1,    -1,    65,    -1,    -1,    -1,    -1,    -1,   394,  1120,
      -1,    -1,  4517,    -1,    -1,  4501,    -1,    -1,     8,    -1,
      -1,    11,    -1,    -1,    -1,    -1,    -1,  4567,    -1,   428,
     429,   430,   431,   432,   433,  4575,    -1,    -1,    28,  4569,
    4569,  4569,  4569,  4569,  4569,    -1,  1157,    37,    -1,  1160,
     169,   114,    -1,    43,   173,    -1,    -1,    -1,   121,    -1,
      -1,   124,  4567,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4575,    -1,    -1,    -1,    -1,   194,   195,    67,  1189,    -1,
      -1,    -1,  1193,  1194,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   211,  1204,  1205,  1206,    -1,     8,    -1,    -1,
      11,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1222,    -1,    -1,    -1,   178,    -1,    -1,   237,    -1,
      -1,   240,    -1,    -1,    -1,    -1,    37,    -1,    -1,    -1,
      -1,    -1,    43,    -1,   253,    -1,    -1,   256,    -1,    -1,
      -1,    -1,    -1,    -1,  1255,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    67,  1268,  1269,    -1,
      -1,    -1,    -1,    -1,  1275,    -1,    -1,  1278,    -1,    -1,
      -1,    -1,   235,    -1,   237,    -1,    -1,    -1,    -1,   169,
      -1,    -1,    -1,   173,   247,    -1,    -1,    -1,    -1,  1300,
      -1,    -1,   255,    -1,    -1,  1306,    -1,    -1,  1309,    -1,
      -1,    -1,   265,    -1,   194,   195,    -1,    -1,    -1,    -1,
      -1,    -1,   331,    -1,    -1,    -1,    -1,    -1,   129,    -1,
      -1,   211,  1333,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1341,  1342,  1343,  1344,  1345,   298,    -1,    -1,   301,   302,
      -1,    -1,    -1,    -1,    -1,  1356,    -1,   237,  1359,    -1,
     240,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   169,  1370,
      -1,  1372,   173,   253,   327,    -1,   256,    -1,    -1,    -1,
      -1,  1382,  1383,    -1,    -1,    -1,    -1,  1388,    -1,    -1,
      -1,    -1,    -1,   194,   195,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     211,    -1,    -1,    -1,    -1,   424,   425,   426,    -1,   428,
     429,   430,   431,   432,   433,    -1,    -1,    -1,    -1,    -1,
      -1,  1432,   385,    -1,    -1,    -1,    -1,    -1,    -1,   240,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   331,   253,    -1,    -1,    -1,    -1,    -1,  1459,  1460,
    1461,  1462,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1471,    -1,    -1,    -1,    -1,    32,  1477,    -1,    -1,  1480,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1489,    -1,
      -1,    -1,    -1,    -1,    51,  1496,     8,  1498,    -1,    11,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1508,    -1,    -1,
      -1,    -1,  1513,    -1,    -1,    -1,    28,    -1,    -1,    -1,
      -1,  1522,    -1,    -1,    -1,    37,    83,  1528,  1529,    -1,
     331,    43,  1533,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   424,   425,   426,    -1,   428,   429,
     430,   431,   432,   433,    -1,    67,    -1,  1558,   438,    -1,
      -1,    -1,    -1,    -1,  1565,    -1,  1567,    -1,    -1,    -1,
    1571,  1572,    -1,  1574,    -1,    -1,    -1,    -1,    -1,  1580,
      -1,    -1,   139,    -1,    -1,    -1,  1587,    -1,    -1,    -1,
      -1,    -1,    -1,  1594,  1595,    -1,    -1,  1598,    -1,    -1,
      -1,  1602,    -1,  1604,    -1,    -1,    -1,    -1,    -1,    -1,
    1611,    -1,    -1,  1614,   171,    -1,    -1,  1618,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1626,  1627,   428,   429,   430,
     431,   432,   433,  1634,    -1,  1636,  1637,  1638,  1639,  1640,
      -1,    -1,    -1,   200,    -1,    -1,  1647,  1648,    -1,  1650,
     207,  1652,  1653,    -1,    -1,  1656,    -1,   169,    -1,    -1,
      -1,   173,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1673,    -1,    -1,    -1,  1677,  1678,    -1,    -1,
     237,  1682,   194,   195,    -1,  1686,    -1,  1688,  1689,  1690,
    1691,  1692,  1693,  1694,  1695,  1696,    -1,  1698,    -1,   211,
      -1,    -1,    -1,  1704,    -1,  1706,  1707,    -1,    -1,    -1,
      -1,    -1,  1713,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   237,    -1,    -1,   240,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   253,    -1,    -1,   256,   302,    -1,    -1,    -1,   306,
      -1,     0,    -1,    -1,    -1,   312,    -1,    -1,    -1,    -1,
      -1,    -1,   319,    -1,    -1,    14,    -1,    -1,    -1,    -1,
     327,    -1,    -1,    -1,    -1,    24,    -1,    26,    27,   336,
      -1,    -1,    -1,    -1,    18,    -1,    -1,   344,    -1,    -1,
      24,     8,    -1,    42,    11,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    28,    -1,    62,    -1,    64,    65,    -1,    -1,   331,
      37,    70,    -1,    72,    -1,    -1,    43,    -1,  1829,    -1,
    1831,    65,  1833,    82,    -1,    84,    -1,    -1,    -1,   396,
      -1,    -1,    -1,   400,    -1,    -1,    -1,    -1,    -1,    -1,
      67,   100,    -1,    -1,   103,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   115,  1868,   117,    -1,
      -1,    -1,   121,  1874,    -1,  1876,    -1,    -1,   127,    -1,
     114,    -1,    -1,    -1,    -1,    -1,   135,   121,   137,    -1,
     124,    -1,    -1,    -1,   143,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1904,    -1,    -1,    -1,    -1,  1909,   158,
    1911,    -1,   424,   425,   426,    -1,   428,   429,   430,   431,
     432,   433,    -1,    -1,    -1,    -1,   438,  1928,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1939,    -1,
    1941,  1942,  1943,    -1,   178,  1946,    -1,  1948,    -1,  1950,
      -1,  1952,   169,  1954,  1955,    -1,   173,  1958,    -1,    -1,
      -1,    -1,    -1,    -1,   213,   214,    -1,    -1,    -1,    -1,
     219,    -1,    -1,    -1,    -1,    -1,  1977,   194,   195,   228,
      -1,    -1,    -1,    -1,    -1,    -1,  1987,    -1,    -1,    -1,
     239,    -1,    -1,  1994,   211,    -1,    -1,    -1,  1999,    -1,
      -1,   235,    -1,   237,  2005,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   247,    -1,    32,    -1,    -1,    -1,    -1,
     237,   255,  2023,   240,    -1,    -1,  2027,  2028,   277,    -1,
      -1,   265,    -1,  2034,    51,    -1,   253,    -1,    -1,   256,
     289,    -1,    -1,    -1,    -1,   294,   295,    -1,   297,    -1,
    2051,    -1,    -1,   302,    -1,    -1,    -1,    18,   307,    -1,
      -1,   310,    -1,    24,   298,   314,    83,   301,   302,    -1,
     319,   320,    -1,    -1,    -1,    -1,    -1,  2078,   327,  2080,
    2081,   330,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   338,
      -1,    -1,    -1,   327,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   350,    -1,    -1,    65,    -1,    -1,  2108,    -1,    -1,
      -1,    -1,    -1,    -1,   331,  2116,    -1,    -1,   367,    -1,
    2121,    -1,   139,    -1,    -1,    -1,    -1,    -1,   377,    -1,
      -1,    -1,    -1,  2134,   383,    -1,    -1,    -1,    -1,   388,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   385,   401,   114,   171,    -1,    -1,    -1,    -1,    -1,
     121,  2162,    -1,   124,  2165,    -1,  2167,    -1,  2169,    -1,
      -1,  2172,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   200,    -1,    -1,    -1,    -1,   437,    -1,
     207,   440,    -1,    -1,    -1,    -1,    -1,  2198,     8,    -1,
      -1,    11,    -1,    -1,    -1,  2206,  2207,   424,   425,   426,
      -1,   428,   429,   430,   431,   432,   433,   178,    28,    -1,
     237,   438,    -1,    -1,    -1,    -1,    -1,    37,    -1,    -1,
      -1,    -1,  2233,    43,  2235,  2236,  2237,  2238,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2257,    67,    -1,    18,
      -1,    -1,    -1,    -1,    -1,    24,    -1,    -1,  2269,    -1,
      -1,    -1,    -1,    -1,   235,    -1,   237,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   302,   247,     8,    -1,   306,
      11,    -1,    -1,    -1,   255,   312,    -1,    -1,    -1,    -1,
      -1,    -1,   319,    -1,   265,    -1,    65,    28,    -1,    -1,
     327,    -1,    -1,    -1,  2315,    -1,    37,    -1,    -1,   336,
    2321,    -1,    43,    -1,    -1,    -1,    -1,   344,    -1,    -1,
      -1,  2332,    -1,    -1,    -1,    -1,    -1,   298,  2339,  2340,
     301,   302,    -1,    -1,  2345,   879,    67,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   114,    -1,    -1,    -1,   169,
      -1,    -1,   121,   173,    -1,   124,   327,    -1,    -1,  2370,
    2371,    -1,    -1,    -1,  2375,    -1,    -1,    -1,    -1,   396,
      51,    -1,    -1,   400,   194,   195,  2387,  2388,  2389,  2390,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2400,
      -1,   211,  2403,    -1,  2405,  2406,    -1,    -1,    -1,    -1,
      -1,    -1,    83,    -1,  2415,  2416,    -1,    -1,  2419,   178,
      -1,    -1,    -1,    -1,   385,    -1,    -1,   237,    -1,    -1,
     240,  2432,    -1,  2434,    -1,  2436,    -1,  2438,    -1,    -1,
      -1,    -1,    -1,   253,    -1,    -1,   256,    -1,   169,    -1,
      -1,    -1,   173,    -1,    -1,    -1,  2457,    -1,    -1,    -1,
    2461,    -1,    -1,    -1,    -1,    -1,  2467,    -1,   139,  2470,
    2471,  2472,    -1,   194,   195,    -1,   235,  1011,   237,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2487,    -1,   247,    -1,
     211,    -1,    -1,    -1,    -1,    -1,   255,    -1,  2499,    -1,
     171,    -1,    -1,  2504,    -1,    -1,   265,    -1,    -1,  2510,
      -1,    -1,    -1,    -1,    -1,    -1,   237,  2518,    -1,   240,
    2521,   331,    -1,    -1,  2525,    -1,    -1,     8,    -1,    -1,
      11,    -1,   253,    -1,    -1,   256,   207,    -1,    -1,   298,
      -1,    -1,   301,   302,    -1,    -1,    -1,    28,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    37,    -1,    -1,    -1,
      -1,    -1,    43,    -1,    -1,  2566,   237,  2568,   327,    -1,
      -1,    -1,  2573,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    67,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   265,    -1,    -1,    -1,  2599,    -1,
    2601,  2602,  2603,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     331,    -1,    -1,    -1,   424,   425,   426,    -1,   428,   429,
     430,   431,   432,   433,    -1,    -1,   385,   298,   438,    -1,
      -1,   302,    -1,    -1,    -1,   306,    -1,    -1,    -1,    -1,
      -1,   312,    -1,    -1,    -1,    -1,    -1,    -1,   319,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   327,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   336,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   344,    -1,  1209,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   169,    -1,
      -1,    -1,   173,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   424,   425,   426,    -1,   428,   429,   430,
     431,   432,   433,   194,   195,    -1,    -1,   438,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   396,    -1,    -1,     8,  1263,
     211,    11,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   237,    37,    -1,   240,
      -1,    -1,    -1,    43,  1298,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   253,    -1,    -1,   256,    -1,    -1,    -1,  2780,
    2781,    -1,    -1,    -1,    -1,    -1,    -1,    67,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,     8,    -1,    -1,
      11,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    28,    -1,    -1,
      -1,    -1,  2833,  2834,    -1,    -1,    37,    -1,    -1,    -1,
    1374,    -1,    43,    -1,    -1,    -1,    -1,    -1,  2849,   129,
     331,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1393,
      -1,  2862,  2863,    -1,    -1,    -1,    67,    -1,    -1,    -1,
    2871,  2872,    -1,    -1,    -1,    -1,   879,    -1,    -1,  1413,
      -1,    -1,    -1,    -1,    -1,  2886,    -1,    -1,    -1,   169,
      -1,    -1,    -1,   173,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1438,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2914,   194,   195,  2917,    -1,    -1,    -1,
      -1,    -1,    -1,    13,    -1,    -1,    -1,    -1,    -1,    19,
    2931,   211,    -1,    -1,    -1,    -1,    -1,    -1,    28,    -1,
      -1,    -1,    -1,   424,   425,   426,    -1,   428,   429,   430,
     431,   432,   433,  2954,    -1,   436,    -1,    47,    -1,    -1,
     240,  1495,    -1,  2964,    -1,    -1,    -1,    -1,   169,    -1,
      -1,  2972,   173,   253,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2982,    -1,    -1,    -1,    -1,    -1,  2988,    -1,  2990,
      -1,    -1,    -1,   194,   195,  2996,    -1,    -1,  2999,  3000,
    3001,  3002,  3003,  3004,  3005,  3006,  3007,  3008,  1011,    -1,
     211,  3012,  3013,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3025,    -1,    -1,    -1,  3029,    -1,
      -1,    -1,  3033,    -1,    -1,    -1,   237,    -1,    -1,   240,
      -1,    -1,  3043,    -1,    -1,  3046,    -1,  3048,    -1,    -1,
      -1,   331,   253,    -1,    -1,   256,  3057,  3058,  3059,    -1,
      -1,    -1,  3063,    -1,    -1,  3066,    -1,    -1,    -1,  3070,
      -1,    -1,    -1,    -1,    -1,    -1,  3077,  3078,  3079,  3080,
      -1,  3082,  3083,    -1,    -1,    -1,  3087,  3088,    -1,    18,
      -1,    -1,    -1,  3094,    -1,    24,   186,    -1,    -1,  3100,
    3101,    -1,    -1,    -1,    -1,    -1,   196,   197,    -1,   199,
      -1,    -1,   202,    -1,   204,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3124,    -1,    -1,    -1,    -1,    -1,  3130,
     331,    -1,    -1,  3134,    -1,  3136,    65,    -1,  1672,    -1,
      -1,    -1,    -1,  1146,    -1,    -1,    -1,    -1,   428,   429,
     430,   431,   432,   433,    -1,    -1,    -1,  3158,  3159,  3160,
      -1,  3162,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1707,    -1,    -1,    -1,    -1,    -1,  3180,
    3181,  3182,  3183,    -1,    -1,   114,    -1,    -1,    -1,    -1,
      -1,    -1,   121,    -1,    -1,   124,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1209,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3217,    -1,    -1,    -1,
      -1,    -1,    -1,   424,   425,   426,    -1,   428,   429,   430,
     431,   432,   433,    -1,    -1,    -1,    -1,   438,    -1,     8,
      -1,    -1,    11,    -1,    -1,    -1,    -1,    -1,    -1,   178,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1263,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,    -1,
      -1,    -1,    -1,    -1,    43,    -1,     8,    -1,    -1,    11,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3293,    -1,    -1,  1298,    28,    -1,    67,    -1,
      -1,    -1,    -1,    -1,    -1,    37,   235,    -1,   237,    -1,
      -1,    43,    -1,    -1,    -1,    -1,    -1,    -1,   247,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   255,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    67,   265,    -1,    -1,    -1,
      -1,    -1,    -1,  3344,    -1,    -1,    -1,  1881,    -1,    -1,
      -1,  1885,  1886,    -1,  3355,    -1,  3357,    -1,    -1,    -1,
     129,    -1,  3363,    -1,    -1,    -1,    -1,    -1,  3369,   298,
      -1,  1374,   301,   302,    -1,    -1,    -1,  3378,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3390,
    1393,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   327,  3400,
     169,    -1,    -1,    -1,   173,  3406,    -1,    -1,    -1,    -1,
    1413,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3422,  3423,    -1,    -1,   194,   195,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1438,    -1,   169,    -1,    -1,
      -1,   173,   211,   533,  3445,    -1,  3447,    -1,    -1,    -1,
      -1,   541,    -1,    -1,    -1,    -1,   385,  1991,    -1,    -1,
     550,   551,   194,   195,    -1,   555,    -1,    -1,    -1,    -1,
      -1,   240,    -1,    -1,    -1,    -1,   566,    -1,    -1,   211,
    3481,    -1,    -1,    -1,   253,    -1,    -1,    -1,    -1,    -1,
     580,    18,  1495,    -1,    -1,    -1,    -1,    24,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   237,   596,    -1,   240,   599,
      -1,   601,    -1,   603,    -1,    -1,    -1,  3518,    -1,    -1,
      -1,   253,    -1,    -1,   256,    -1,    -1,  3528,  3529,    -1,
      -1,    -1,    -1,    -1,    -1,  3536,  3537,    -1,    65,    -1,
    3541,    -1,    -1,    -1,    -1,    -1,  3547,  3548,    -1,    -1,
    3551,    -1,    -1,  3554,  3555,    -1,    -1,  3558,  3559,  3560,
    3561,    -1,   331,    -1,  3565,  3566,    -1,  3568,    -1,    -1,
    3571,    -1,    -1,   663,  3575,   665,    -1,    -1,  3579,    -1,
      -1,    -1,    -1,    -1,  3585,    -1,    -1,   114,    -1,    -1,
    3591,    -1,    -1,    -1,   121,  3596,    -1,   124,    -1,   331,
    3601,    -1,  2136,    -1,    -1,    -1,  3607,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3615,    -1,    -1,    -1,  3619,     8,
      -1,    -1,    11,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   721,  3633,    -1,    -1,  3636,    -1,    -1,    -1,    28,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,    -1,
      -1,   178,    -1,    -1,    43,  3656,  3657,    -1,    -1,   428,
     429,   430,   431,   432,   433,    -1,    -1,    -1,    -1,  1672,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    67,  3680,
      -1,  2215,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   779,
      -1,    -1,   424,   425,   426,    -1,   428,   429,   430,   431,
     432,   433,    -1,    -1,    -1,    -1,   438,    -1,   235,    -1,
     237,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     247,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   255,  3730,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   265,    -1,
      -1,    -1,    -1,  3744,   834,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   849,
      -1,    -1,    -1,    -1,    -1,    -1,  2300,    -1,    -1,    -1,
      -1,   298,   862,    -1,   301,   302,    -1,    -1,    -1,   869,
     169,    -1,    -1,    -1,   173,    -1,    -1,    -1,    -1,    -1,
      -1,   881,    -1,    -1,   884,    -1,    -1,    -1,    -1,    -1,
     327,  3802,    -1,    -1,    -1,   194,   195,    -1,    -1,    -1,
      -1,    -1,  3813,    -1,    -1,    -1,    -1,  3818,    -1,    -1,
      -1,    -1,   211,    -1,  3825,    -1,    -1,   917,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3837,  3838,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   237,    -1,
      -1,   240,    -1,    -1,    -1,    -1,    -1,    -1,   385,    -1,
      -1,    -1,  3863,    18,   253,    -1,    -1,   256,    -1,    24,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1881,    -1,
      -1,    -1,  1885,  1886,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3892,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3901,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      65,    -1,    -1,    -1,    -1,    -1,    -1,  3918,  3919,    -1,
      -1,  3922,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3935,  3936,  2470,  2471,  2472,  3940,
      -1,    -1,   331,    -1,  3945,    -1,    -1,  3948,  3949,    -1,
    3951,    -1,  3953,  3954,    -1,    -1,    -1,    -1,    -1,   114,
      -1,    18,     8,    -1,    -1,    11,   121,    24,    -1,   124,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3978,  3979,  3980,
    3981,  3982,    28,    -1,    -1,    -1,    -1,    -1,  1991,    -1,
      -1,    37,    -1,    -1,    -1,    -1,    -1,    43,    -1,  2533,
      -1,    -1,  2536,    -1,  2538,    -1,    -1,    -1,    65,  2543,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4020,
    4021,    67,    -1,   178,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   424,   425,   426,    -1,   428,
     429,   430,   431,   432,   433,    -1,    -1,    -1,     8,   438,
      -1,    11,    -1,    -1,    -1,    -1,    -1,   114,    -1,  2593,
    4061,  4062,    -1,    -1,   121,  4066,    -1,   124,  4069,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,    -1,  4080,
     235,    -1,   237,    43,    -1,    -1,  4087,    -1,  1178,  1179,
    4091,     8,   247,    -1,    11,    -1,    -1,    -1,    -1,  2633,
     255,    -1,  4103,    -1,    -1,  4106,    -1,    67,    -1,    -1,
     265,    28,    -1,  4114,  4115,    -1,    -1,    -1,    -1,    -1,
      37,   178,    -1,   169,    -1,    -1,    43,   173,    -1,    -1,
      -1,    -1,    -1,  2136,    -1,    -1,  4137,    -1,    -1,  4140,
      -1,  4142,    -1,   298,    -1,    -1,   301,   302,   194,   195,
      67,  1241,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2694,    -1,  2696,    -1,  4165,   211,    -1,    -1,  4169,   129,
      -1,  4172,   327,    -1,    -1,    -1,    -1,  4178,   235,    -1,
     237,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     247,   237,    -1,  4194,   240,    -1,    -1,  4198,   255,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   253,   265,   169,
     256,    -1,  2215,   173,    -1,    -1,    -1,  2751,    -1,    -1,
      -1,  4222,  4223,  4224,  4225,    -1,    -1,    -1,    -1,    -1,
     385,    -1,    -1,    -1,   194,   195,  4237,    -1,    -1,    -1,
      -1,   298,  2776,    -1,   301,   302,    -1,    -1,    -1,    -1,
      -1,   211,   169,    -1,    -1,  4256,   173,    -1,    -1,    -1,
      -1,  2795,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     327,    -1,    -1,    -1,  4275,    -1,    -1,   194,   195,  2813,
     240,    -1,    -1,    -1,    -1,   331,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   253,   211,    -1,    -1,  2300,    -1,    -1,
      -1,    -1,     8,    -1,    -1,    11,    -1,    -1,    -1,    -1,
    4311,    -1,    -1,  4314,    -1,    -1,    -1,    -1,    -1,    -1,
     237,    -1,    28,   240,    -1,    -1,    -1,    -1,   385,    -1,
      -1,    37,    -1,  4334,    -1,  4336,   253,    43,    -1,   256,
      -1,    -1,    -1,  2877,    -1,  4346,    -1,    -1,    -1,    -1,
      -1,    -1,  1442,    -1,    -1,    -1,    -1,    -1,    -1,  2893,
      -1,    67,    -1,    -1,    -1,    -1,    -1,  1457,    -1,    -1,
    2904,   331,    -1,    -1,    -1,    -1,    -1,    -1,   424,   425,
     426,    -1,   428,   429,   430,   431,   432,   433,  4389,    -1,
      -1,    -1,   438,  4394,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4405,    -1,    -1,  1497,    -1,    -1,
      -1,    -1,    -1,    -1,   331,    -1,  4417,  4418,    -1,    -1,
      -1,  4422,  1512,    -1,  1514,  4426,  1516,    -1,    -1,    -1,
      -1,  1521,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4440,
      -1,  2975,    -1,    -1,    -1,    -1,    -1,    -1,  4449,    -1,
      18,    -1,    -1,    -1,    -1,    -1,    24,    -1,    -1,    -1,
      -1,  2995,    -1,   169,    -1,    -1,    -1,   173,   428,   429,
     430,   431,   432,   433,  1564,    -1,    -1,    -1,  1568,  4480,
    1570,    -1,    50,  1573,    -1,    -1,  3020,    -1,   194,   195,
      -1,    -1,    -1,  4494,    -1,    -1,    -1,    65,    -1,    -1,
    4501,    -1,    -1,    -1,    -1,   211,    -1,   424,   425,   426,
      -1,   428,   429,   430,   431,   432,   433,    -1,    -1,    -1,
      -1,   438,  3056,    -1,    -1,    -1,    -1,    -1,    96,    -1,
    2533,   237,    -1,  2536,   240,  2538,    -1,    -1,    -1,    -1,
    2543,    -1,    -1,    -1,    -1,    -1,   114,   253,    -1,    -1,
     256,    -1,    -1,   121,    -1,    -1,   124,    -1,    -1,    -1,
      -1,  4562,    -1,    -1,    -1,    -1,    -1,  3101,    -1,    -1,
    4571,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2593,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   175,  3142,    -1,
     178,    -1,    -1,    -1,    -1,    -1,    -1,     8,    -1,    -1,
      11,    -1,    -1,    -1,    -1,   331,    -1,    -1,    -1,    -1,
    2633,    -1,    -1,    -1,    -1,    -1,    -1,    28,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    37,    -1,    -1,    -1,
      -1,    -1,    43,    -1,    -1,   223,    -1,   225,    -1,    -1,
      -1,    -1,    18,    -1,    -1,    -1,    -1,   235,    24,   237,
      -1,    -1,    -1,    -1,    -1,    -1,    67,    -1,    -1,   247,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   255,    -1,    -1,
      -1,  2694,    -1,  2696,    -1,   879,   264,   265,    -1,  3233,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    65,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   424,   425,
     426,    -1,   428,   429,   430,   431,   432,   433,    -1,    -1,
     298,    -1,   438,   301,   302,   303,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2751,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   114,   327,
      -1,    -1,    -1,    -1,    -1,   121,    -1,    -1,   124,    -1,
     338,    -1,    -1,  2776,    -1,    -1,    -1,    -1,   169,    -1,
      -1,    -1,   173,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2795,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   194,   195,    -1,  1896,  1897,    -1,    -1,
    2813,  1901,  1902,    -1,    -1,  1905,    -1,   385,    -1,    -1,
     211,    -1,   178,    -1,    -1,  1915,    -1,  1011,    -1,    -1,
      -1,    -1,  1922,    -1,    -1,    -1,  1926,  1927,    -1,    -1,
    1930,  1931,    -1,    -1,    -1,    -1,   237,  1937,    -1,   240,
    3384,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1949,
      -1,  1951,   253,     8,    -1,   256,    11,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2877,    -1,    -1,  1967,    -1,   235,
      -1,   237,  1972,    28,    -1,    -1,    -1,  3421,    -1,    -1,
    2893,   247,    37,    -1,    -1,  1985,    -1,    -1,    43,   255,
      -1,  2904,    -1,  1993,    -1,  1995,  1996,  1997,  1998,   265,
      -1,    -1,  2002,  2003,    -1,     8,    -1,    -1,    11,    -1,
    2010,    -1,    67,    -1,  2014,    -1,    -1,    -1,  2018,    -1,
      -1,    -1,    -1,    -1,    -1,    28,    -1,    -1,    -1,    -1,
     331,    -1,   298,    -1,    37,   301,   302,    -1,    -1,    -1,
      43,  2041,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2052,    -1,  2054,    -1,    -1,    -1,    -1,  2059,
      -1,   327,  2975,  2063,    67,  2065,  2066,  2067,  2068,    -1,
    2070,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2995,  2083,  2084,  2085,    -1,  3531,    -1,    -1,
      -1,    -1,    -1,    -1,  2094,  2095,    -1,    -1,  3542,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    18,  3020,    -1,    -1,
      -1,    -1,    24,    -1,   169,  1209,    -1,    -1,   173,   385,
      -1,    -1,    -1,   424,   425,   426,    -1,   428,   429,   430,
     431,   432,   433,    -1,    -1,    -1,    -1,   438,    -1,   194,
     195,    -1,    -1,  3056,    -1,    -1,    -1,  3591,    -1,    -1,
      -1,    -1,  3596,    65,    -1,    -1,   211,  3601,  2158,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   169,    -1,    -1,  1263,
     173,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   237,    -1,    -1,   240,    -1,    -1,    -1,    -1,
      -1,   194,   195,    -1,    -1,    -1,    -1,    -1,   253,    -1,
      -1,   256,   114,    -1,  1298,    -1,    -1,    -1,   211,   121,
    3654,    -1,   124,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3142,
      -1,    -1,    -1,    -1,   237,    -1,    -1,   240,  3682,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     253,    -1,    -1,   256,    -1,    -1,    -1,  3701,    -1,     8,
      -1,    -1,    11,    -1,    -1,    -1,   178,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   331,  2277,    -1,    28,
    1374,    -1,    -1,    -1,    33,    -1,    -1,    -1,    37,    -1,
      -1,    -1,     8,    -1,    43,    11,    -1,    -1,    -1,  1393,
      -1,    -1,    -1,    -1,    -1,  3749,  2306,    -1,    -1,    -1,
      -1,    -1,    28,    -1,    -1,    -1,    -1,    -1,    67,  1413,
    3233,    37,    -1,   235,    -1,   237,    -1,    43,   331,    -1,
      -1,    -1,    -1,    -1,    -1,   247,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   255,  1438,    -1,    -1,    -1,    -1,    -1,
      -1,    67,    -1,   265,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   112,    -1,    -1,    -1,    -1,    -1,   424,
     425,   426,    -1,   428,   429,   430,   431,   432,   433,    -1,
      -1,    -1,    -1,   438,    -1,    -1,   298,    -1,    -1,   301,
     302,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1495,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   327,  3860,    -1,    -1,    -1,
     169,   424,   425,   426,   173,   428,   429,   430,   431,   432,
     433,    -1,   148,    -1,    -1,   438,    -1,   153,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   194,   195,    -1,    -1,    -1,
      -1,    -1,  3896,   169,    -1,    -1,    -1,   173,    -1,    -1,
      -1,    -1,   211,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3384,    -1,   385,    -1,    -1,    -1,    -1,   194,   195,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   237,    -1,
      -1,   240,    -1,    -1,    -1,   211,    -1,  2497,    -1,    -1,
      -1,    -1,    -1,    -1,   253,    -1,    -1,   256,  3421,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   237,    -1,    -1,   240,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   253,    -1,    -1,
     256,    -1,   179,    -1,    -1,    -1,  2546,  2547,    -1,    -1,
      -1,   188,   189,    -1,    -1,    -1,    -1,     8,   195,    -1,
      11,    -1,    -1,  2563,    -1,    -1,  4010,    -1,    -1,   206,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    28,  1672,    -1,
      -1,    -1,   331,    -1,    -1,    -1,    37,    -1,  2588,    -1,
       8,    -1,    43,    11,    -1,    -1,    -1,  2597,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      28,    -1,  2612,  2613,    -1,   331,    67,  2617,  3531,    37,
      -1,    -1,  2622,  2623,  2624,    43,    -1,    -1,    -1,  3542,
      -1,    -1,    -1,   382,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,     8,    -1,    -1,    11,    -1,    -1,    67,
      -1,    -1,  2652,  2653,  2654,  2655,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    28,    -1,    -1,    -1,    32,    -1,    -1,
      -1,    -1,    37,  4117,    -1,   424,   425,   426,    43,   428,
     429,   430,   431,   432,   433,    -1,  2686,    -1,  2688,  2689,
    2690,    -1,    -1,    -1,  4138,    -1,    -1,    -1,  2698,    -1,
      -1,    -1,    67,    -1,    -1,    -1,    -1,    -1,   424,   425,
     426,    -1,   428,   429,   430,   431,   432,   433,   169,    -1,
      -1,    -1,   173,    -1,    -1,    -1,    -1,    -1,    -1,   147,
    4174,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3654,    -1,   194,   195,    -1,    -1,    -1,    -1,    -1,
      -1,   169,    -1,    -1,    -1,   173,    -1,    -1,    -1,    -1,
     211,    -1,    -1,  2763,    -1,    -1,    -1,    -1,  4212,  3682,
      -1,  2771,  4216,  4217,    -1,    -1,   194,   195,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   237,  1881,  3701,   240,
      -1,  1885,  1886,   211,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   253,    -1,   169,   256,    -1,    -1,   173,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   237,
      -1,    -1,   240,    -1,    -1,   276,    -1,    -1,  2828,   194,
     195,    -1,    -1,    -1,    -1,   253,  3749,    -1,   256,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   211,    -1,    -1,    -1,
      -1,  4295,    -1,    -1,    -1,    -1,   274,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2870,    -1,   237,  2873,    -1,   240,    -1,    -1,    -1,    -1,
     331,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   253,    -1,
      -1,   256,    -1,    -1,   345,   532,    -1,  1991,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2905,    -1,   544,    -1,    -1,
      -1,   548,    -1,   331,    -1,    -1,    -1,    -1,    -1,  2919,
      -1,    -1,   559,    -1,    -1,     8,    -1,    -1,    11,  2929,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   575,    -1,
      -1,    -1,   579,    -1,    -1,    28,    -1,    -1,    -1,    -1,
      -1,    -1,   589,   590,    37,    -1,    -1,    -1,   595,    -1,
      43,    -1,    -1,    -1,    -1,    -1,   331,    -1,   605,    -1,
      -1,    -1,    -1,   424,   425,   426,   613,   428,   429,   430,
     431,   432,   433,  3896,    67,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,     8,
      -1,    -1,    11,    -1,    -1,    -1,   424,   425,   426,    -1,
     428,   429,   430,   431,   432,   433,    -1,    -1,    -1,    28,
      -1,    -1,    -1,    32,    -1,    -1,    -1,    -1,    37,    -1,
      -1,    -1,    -1,    -1,    43,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2136,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   688,    -1,    -1,    -1,    -1,   693,    -1,    67,   424,
     425,   426,    -1,   428,   429,   430,   431,   432,   433,    -1,
      -1,    -1,    -1,     8,    -1,    -1,    11,    -1,    -1,    -1,
      -1,    -1,   719,    -1,    -1,    -1,   169,    -1,    -1,    -1,
     173,    -1,    -1,    28,    -1,    -1,    -1,  4010,    -1,    -1,
      -1,    -1,    37,    -1,    -1,    -1,    -1,    -1,    43,    -1,
      -1,   194,   195,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2215,    -1,    -1,    -1,    -1,    -1,    -1,   211,    -1,
      -1,    -1,    67,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   237,    -1,    -1,   240,    -1,    -1,
     169,    -1,    -1,    -1,   173,  3165,    -1,  3167,    -1,    -1,
     253,    -1,    -1,   256,  3174,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   194,   195,    -1,   271,    -1,
    3190,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   211,    -1,  4117,  3205,  2300,    -1,   845,    -1,
      -1,    -1,    -1,    -1,    -1,  3215,    -1,    -1,   153,   856,
      -1,    -1,    -1,    -1,    -1,  4138,    -1,    -1,   237,    -1,
    3230,   240,    -1,    -1,   169,    -1,    -1,    -1,   173,    -1,
      -1,    -1,   879,    -1,   253,    -1,    21,   256,   331,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   194,
     195,  4174,    -1,  3263,  3264,  3265,    -1,    -1,  3268,  3269,
    3270,  3271,  3272,    -1,    -1,    -1,   211,  3277,  3278,   916,
    3280,  3281,  3282,  3283,  3284,  3285,  3286,    -1,    -1,    -1,
      -1,    -1,    -1,    68,    -1,  3295,    -1,  3297,  3298,  4212,
      -1,    -1,   237,  4216,  4217,   240,    81,    -1,    -1,    -1,
      -1,   948,    -1,    -1,    -1,    -1,    -1,    -1,   253,    -1,
      -1,   256,   331,    98,    -1,    -1,   963,    -1,    -1,   104,
     967,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   975,    -1,
      -1,   424,   425,   426,   119,   428,   429,   430,   431,   432,
     433,  3351,  3352,  3353,    -1,   130,  3356,    -1,    -1,    -1,
      -1,    -1,    -1,   138,    -1,    -1,  1003,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1011,   150,  1013,    -1,    -1,    -1,
     155,    -1,    -1,    -1,    -1,    -1,   161,    -1,    -1,  1026,
      -1,    -1,  1029,    -1,    -1,    -1,   331,    -1,    -1,    -1,
      -1,   176,    -1,    -1,  1041,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   424,   425,   426,    -1,   428,
     429,   430,   431,   432,   433,    -1,   201,    -1,    -1,    -1,
      -1,    -1,    -1,  1070,    -1,    -1,    -1,    -1,  3438,  2533,
      -1,    -1,  2536,    -1,  2538,    -1,    -1,   222,    -1,  2543,
      -1,    -1,    -1,    -1,    -1,  3455,  3456,  3457,    -1,    -1,
      -1,  1098,  1099,    -1,  1101,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   253,    -1,
      -1,    -1,    -1,  1120,    -1,    -1,    -1,    -1,    -1,   424,
     425,   426,    -1,   428,   429,   430,   431,   432,   433,  2593,
      -1,    -1,    -1,    -1,    -1,    -1,  1143,   282,    -1,    -1,
      -1,    -1,    -1,    -1,  1151,  1152,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1160,  1161,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   309,    -1,    -1,    -1,   313,  2633,
     315,    -1,    -1,    -1,    -1,    -1,   321,    -1,    -1,   324,
      -1,    -1,  1189,    -1,    -1,    -1,  1193,  1194,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1209,    -1,   349,   350,    -1,   352,  1215,    -1,
      -1,   356,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   364,
      -1,    -1,    -1,    -1,   369,    -1,    -1,    -1,    -1,    -1,
    2694,    -1,  2696,    -1,    -1,     8,   381,    -1,    11,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   394,
      -1,    -1,    -1,    -1,    -1,    28,  1263,    -1,    -1,    32,
      -1,    -1,    -1,    -1,    37,    -1,    -1,    -1,    18,    -1,
      43,    -1,    -1,    -1,    24,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2751,    -1,    -1,
      -1,  1298,    -1,    -1,    67,  3665,  3666,  3667,  3668,    -1,
      50,  3671,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2776,    -1,    -1,    65,    -1,    -1,    -1,    -1,
      -1,    -1,  3692,  3693,  3694,  3695,    -1,  3697,  3698,    -1,
      -1,  2795,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3709,
    3710,    -1,    -1,    -1,    -1,    -1,    96,  1354,    -1,  2813,
      -1,    -1,  3722,    -1,    -1,    -1,    -1,    -1,  3728,  3729,
      -1,  3731,    -1,    -1,   114,    -1,    -1,  1374,    -1,    -1,
      -1,   121,    -1,    -1,   124,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1393,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   169,    -1,    -1,    -1,
     173,    -1,    -1,    -1,    -1,    -1,  1413,    -1,    -1,    -1,
      -1,    -1,    -1,  2877,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   194,   195,    -1,    -1,   175,  1433,    -1,   178,  2893,
      -1,  1438,    -1,    -1,    -1,    -1,    -1,    -1,   211,    -1,
    2904,    -1,    -1,    -1,    -1,    -1,  1453,    -1,    -1,    -1,
    3820,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3829,
      -1,    -1,  1469,    -1,   237,    -1,    -1,   240,    -1,    -1,
      -1,    -1,    -1,   223,    -1,   225,    -1,    -1,    -1,  3849,
     253,    -1,  1489,   256,    -1,   235,    -1,   237,  1495,    -1,
      -1,  1498,    -1,  1500,  1501,    -1,    -1,   247,    -1,    -1,
      -1,  3871,    -1,    -1,  1511,   255,    -1,    -1,    -1,    -1,
      -1,  2975,    -1,    -1,   264,   265,  1523,  1524,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1535,    -1,
      -1,  2995,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   298,    -1,
      -1,   301,   302,   303,    -1,    -1,  3020,    -1,   331,    -1,
    1567,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3938,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   327,    -1,    -1,
      -1,  3951,    -1,    -1,    -1,    -1,    -1,    -1,   338,    -1,
      -1,    -1,  3056,    -1,    -1,  1602,    -1,  1604,    -1,    -1,
      -1,    -1,    -1,    -1,  1611,    -1,    -1,  1614,    -1,    -1,
      -1,  1618,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1626,
    1627,    -1,    -1,    -1,    -1,    -1,    -1,  1634,    -1,    -1,
    1637,  1638,  1639,  1640,    -1,   385,    -1,    -1,    -1,    -1,
    1647,  1648,  4012,  1650,    -1,  1652,  1653,    -1,    -1,  1656,
      -1,   424,   425,   426,    -1,   428,   429,   430,   431,   432,
     433,    -1,  4032,    -1,    -1,  1672,  1673,  1674,    -1,    -1,
      -1,  1678,    -1,    -1,     8,  1682,    -1,    11,  3142,  1686,
      -1,  1688,  1689,  1690,  1691,  1692,  1693,  1694,  1695,  1696,
      -1,  1698,    -1,    -1,    28,    -1,    -1,    -1,    -1,  1706,
    1707,    -1,    -1,    37,    -1,    -1,    -1,    -1,    -1,    43,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,     8,    -1,    -1,    11,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    67,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    28,    -1,    -1,    -1,    32,    -1,    -1,    -1,
      -1,    37,    -1,  4123,    -1,    -1,    -1,    43,    -1,    -1,
      -1,    -1,     8,    -1,    -1,    11,    -1,    -1,    -1,  3233,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    67,    28,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    37,  4162,    -1,    -1,    -1,    -1,    43,    -1,    -1,
      -1,    -1,  4172,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    67,    -1,    -1,    -1,    -1,  1833,    -1,    -1,    -1,
      -1,    -1,  4202,    -1,    -1,   169,    -1,    -1,    -1,   173,
      -1,  4211,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4226,    -1,    -1,    -1,
     194,   195,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1881,    -1,    -1,   211,  1885,  1886,
      -1,    -1,    -1,   169,    -1,    -1,    -1,   173,  1895,    -1,
      -1,    -1,  1899,  1900,    -1,    -1,  1903,    -1,    -1,    -1,
      -1,    -1,    -1,   237,    -1,    -1,   240,    -1,   194,   195,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1925,   253,
    3384,  1928,   256,   169,    -1,   211,    -1,   173,    -1,  4299,
      -1,    -1,  1939,    -1,    -1,    -1,    -1,    -1,    -1,  1946,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   194,   195,
    4320,   237,    -1,    -1,   240,    -1,    -1,  3421,    -1,  1966,
      -1,    -1,    -1,    -1,    -1,   211,    -1,   253,    -1,    -1,
     256,    -1,    -1,    -1,  4344,    -1,  1983,  1984,    -1,    -1,
      -1,    -1,    -1,    -1,  1991,    -1,    -1,    -1,  4358,    -1,
      -1,   237,    -1,    -1,   240,    -1,    -1,   331,    -1,    -1,
      -1,  2008,  2009,    -1,    -1,  2012,    -1,   253,    -1,    -1,
     256,    -1,    -1,  4383,    -1,    -1,    -1,    -1,  4388,    -1,
      -1,    -1,    -1,   357,    -1,    -1,    -1,    -1,    -1,  2036,
      -1,    -1,    -1,  2040,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   331,    -1,    -1,    -1,    -1,
      -1,  2058,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2069,    -1,    -1,    -1,    -1,  3531,    -1,  4439,
      -1,    -1,    -1,    -1,    -1,  2082,    -1,    -1,  3542,    -1,
      -1,    -1,    -1,    -1,  2091,   331,    -1,    -1,    -1,    -1,
     424,   425,   426,    -1,   428,   429,   430,   431,   432,   433,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2134,    -1,  2136,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   424,   425,
     426,    -1,   428,   429,   430,   431,   432,   433,    -1,    -1,
    2157,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   424,   425,
     426,    -1,   428,   429,   430,   431,   432,   433,    -1,    -1,
    3654,    -1,     8,    -1,    -1,    11,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2215,    -1,
      -1,  2218,    28,    -1,    -1,    -1,    -1,    -1,  3682,    -1,
      -1,    37,    -1,    -1,    -1,    -1,    -1,    43,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3701,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2252,    -1,    -1,    -1,    -1,
    2257,    67,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2287,    -1,    -1,    -1,    -1,  3749,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2300,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2311,    -1,    -1,    -1,  2315,    -1,
      -1,    -1,    -1,    -1,  2321,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   189,    -1,    -1,    -1,    -1,    -1,   195,    -1,
      -1,    -1,  2339,  2340,    -1,    -1,    -1,    -1,  2345,   206,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   169,    -1,    -1,    -1,   173,    -1,    -1,
      -1,    -1,    -1,  2370,  2371,    -1,    -1,    -1,  2375,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   194,   195,
    2387,  2388,  2389,  2390,   189,    -1,    -1,    -1,  2395,    -1,
     195,    -1,    -1,  2400,  2401,   211,  2403,    -1,  2405,    -1,
      -1,   206,    -1,    -1,    -1,    -1,    -1,    -1,  2415,  2416,
      -1,    -1,  2419,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   237,    -1,    -1,   240,  2432,    -1,  2434,    -1,    -1,
      -1,  2438,  3896,    -1,    -1,    -1,    -1,   253,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2457,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2467,    -1,    -1,  2470,  2471,  2472,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2484,    -1,    -1,
    2487,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2499,    -1,    -1,    -1,    -1,  2504,    -1,    -1,
      -1,    -1,    -1,  2510,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2518,    -1,    -1,    -1,   331,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2533,    -1,    -1,  2536,
      -1,  2538,    -1,    -1,    -1,    -1,  2543,    -1,  2545,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4010,    -1,    -1,    -1,
      -1,    -1,    -1,  2560,  2561,    -1,    -1,    -1,    -1,  2566,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2587,    -1,    -1,  2590,    -1,    -1,  2593,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   424,   425,
     426,    -1,   428,   429,   430,   431,   432,   433,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2633,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4117,  2661,  2662,  2663,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4138,    -1,    -1,   544,  2685,    -1,
      -1,   548,    -1,    -1,    -1,    -1,    -1,  2694,    -1,  2696,
    2697,    -1,   559,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2707,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   575,    -1,
    4174,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   590,    -1,    -1,    -1,    -1,   595,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   605,   544,
      -1,    -1,    -1,   548,  2751,    -1,   613,    -1,  4212,    -1,
      -1,    -1,  4216,  4217,   559,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2770,    -1,    -1,    -1,    -1,    -1,  2776,
     575,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   590,    -1,    -1,  2795,    -1,
     595,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     605,    -1,    -1,    -1,    -1,  2812,  2813,    -1,   613,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2827,    -1,  2829,    -1,    -1,    -1,   693,    -1,   688,    -1,
      -1,    -1,    -1,    -1,  2841,    -1,  2843,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   719,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2877,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2892,  2893,    -1,   693,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2904,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2920,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2931,    -1,    -1,  2934,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2953,    -1,    -1,  2956,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2972,    -1,    -1,  2975,    -1,
      -1,    -1,    -1,    -1,    -1,  2982,    -1,    -1,    -1,    -1,
      -1,  2988,    -1,  2990,    -1,    -1,    -1,    -1,  2995,  2996,
      -1,    -1,  2999,  3000,  3001,  3002,  3003,  3004,  3005,  3006,
    3007,  3008,    -1,    -1,    -1,  3012,  3013,    -1,    -1,    -1,
      -1,    -1,    -1,  3020,    -1,    -1,    -1,    -1,  3025,    -1,
      -1,    -1,  3029,    -1,  3031,    -1,  3033,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3043,    -1,    -1,  3046,
      -1,  3048,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3056,
    3057,  3058,  3059,    -1,    -1,    -1,  3063,    -1,    -1,  3066,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3080,    -1,  3082,    -1,    -1,    -1,    -1,
      -1,   948,    -1,    -1,    -1,    -1,    -1,  3094,    -1,    -1,
      -1,    -1,    -1,  3100,  3101,    -1,   963,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   975,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3124,    -1,    21,
      -1,    -1,    -1,  3130,    -1,    -1,    -1,    -1,    -1,  3136,
      -1,    -1,    34,    -1,    -1,  3142,  1003,    -1,    -1,    -1,
      -1,    -1,    -1,   948,    -1,    -1,  1013,    -1,    -1,    -1,
      -1,  3158,    -1,    55,    -1,    -1,    -1,    -1,   963,  1026,
      -1,    -1,  1029,    -1,    -1,    -1,    68,    -1,    -1,    -1,
     975,    -1,    -1,    -1,    -1,    77,    -1,    -1,    -1,    81,
      -1,  1041,  3189,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    98,    -1,  1003,    -1,
      -1,    -1,   104,    -1,    -1,    -1,    -1,    -1,  1013,    -1,
    1070,    -1,    -1,    -1,    -1,    -1,    -1,   119,    -1,    -1,
    3227,  1026,    -1,    -1,  1029,  3232,  3233,  3234,   130,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   138,    -1,  1098,  1099,
      -1,  1101,    -1,    -1,    -1,    -1,    -1,    -1,   150,    -1,
      -1,    -1,    -1,    -1,    -1,   157,    -1,    -1,    -1,   161,
    1120,    -1,    21,    -1,    -1,    -1,    -1,    -1,    -1,  3276,
      -1,    -1,  3279,    -1,   176,    34,  1143,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1151,  1152,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1161,    -1,    55,    -1,    -1,    -1,
    1160,    -1,    -1,    -1,    -1,    -1,  3313,    -1,    -1,    68,
      -1,    -1,    -1,   215,    -1,    -1,    -1,    -1,    -1,    -1,
     222,    -1,    81,    -1,    -1,    -1,    -1,    -1,    -1,  1189,
      -1,    -1,    -1,  1193,  1194,    -1,    -1,    -1,  1143,    98,
      -1,    -1,    -1,    -1,    -1,    -1,  1151,  1152,  1215,    -1,
    3357,   253,    -1,    -1,   256,    -1,  1161,    -1,    -1,    -1,
     119,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   130,    -1,  3380,  3381,    -1,    -1,  3384,    -1,   138,
    3387,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   291,
      -1,   150,    -1,    -1,    -1,    -1,   155,    -1,    -1,    -1,
      -1,    -1,   161,    -1,    -1,    -1,    -1,   309,    -1,    -1,
    1215,    -1,    -1,   315,  3421,  3422,  3423,   176,    -1,   321,
      -1,    -1,   324,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   350,    -1,
     352,   353,    -1,   355,   356,    -1,  3463,    -1,    -1,    -1,
      -1,    -1,   364,   222,    -1,    -1,    -1,   369,    -1,    -1,
      -1,    -1,    -1,   375,  3481,    -1,   378,    -1,    -1,   381,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1354,    -1,    -1,
      -1,    -1,   394,    -1,   253,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   264,    -1,    -1,    -1,    -1,
      -1,  3518,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3528,  3529,   282,  3531,    -1,    -1,    -1,    -1,  3536,
    3537,    -1,    -1,    -1,  3541,  3542,    -1,    -1,    -1,    -1,
    3547,  3548,    -1,    -1,  3551,    -1,    -1,  3554,    -1,  1354,
     309,    -1,    -1,    -1,   313,    -1,   315,    -1,    -1,    -1,
      -1,    -1,   321,    -1,    -1,   324,  1433,    -1,  3575,    -1,
      -1,    -1,  3579,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3591,    -1,  1453,    -1,    -1,  3596,
      -1,   350,    -1,   352,  3601,    -1,    -1,   356,    -1,    -1,
      -1,    -1,  1469,    -1,    -1,   364,    -1,    -1,    -1,    -1,
     369,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   381,    -1,    -1,    -1,    -1,    -1,  1433,  3636,
      -1,    -1,    -1,  1500,  1501,   394,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1511,    -1,    -1,  3654,  1453,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1523,  1524,    -1,    -1,
      -1,    -1,    -1,  3670,  1469,    -1,  3673,    -1,  1535,    -1,
      -1,    -1,    -1,    -1,    -1,  3682,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3696,
      -1,    -1,    -1,    -1,  3701,  1500,  1501,    -1,    -1,    -1,
      -1,  3708,    -1,    -1,    -1,    -1,  1511,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3721,    -1,    -1,    -1,  1523,  1524,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1535,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3749,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1611,    -1,    -1,    -1,    -1,    -1,  3764,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1634,    -1,    -1,  1637,    -1,    -1,
    1640,    -1,    -1,    -1,    -1,    -1,    -1,  1647,  1648,    -1,
      -1,    -1,    -1,  1653,    -1,  3802,  1656,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3813,  1674,    -1,    -1,
      -1,    -1,    -1,  1673,    -1,    -1,    -1,    -1,  1678,    -1,
      -1,    -1,  1682,    -1,    -1,    -1,  1686,    -1,  1688,  1689,
    1690,  1691,  1692,  1693,  1694,  1695,  1696,    -1,  1698,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1706,  1707,    -1,    -1,
      -1,    -1,    -1,  3860,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1674,
      -1,    -1,    -1,  3880,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3892,    -1,    -1,    -1,  3896,
      -1,    -1,    -1,    -1,  3901,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3918,  3919,    -1,    -1,  3922,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3935,    -1,
      -1,    -1,    -1,  3940,    -1,    -1,    -1,    -1,  3945,    -1,
      -1,  3948,    -1,    -1,    -1,    -1,  3953,  3954,    -1,    -1,
      -1,    -1,    21,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3972,    -1,  3974,    -1,    -1,
      -1,  3978,    -1,  1833,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    55,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    68,
      69,    -1,    -1,  4010,  4011,    -1,    -1,    -1,    77,    -1,
      -1,    -1,    81,  4020,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1895,    98,
      -1,    -1,  1899,  1900,    -1,    -1,  1903,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4051,    -1,  4053,    -1,    -1,    -1,
     119,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1925,  4066,
      -1,   130,    -1,    -1,    -1,    -1,    -1,    -1,  1928,   138,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   150,    -1,    -1,    -1,    -1,   155,    -1,    -1,    -1,
    1895,    -1,    -1,    -1,  1899,  1900,    -1,    -1,  1903,  1966,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   176,  4115,    -1,
    4117,    -1,    -1,    -1,    -1,    -1,  1983,  1984,    -1,    -1,
    1925,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4137,  4138,   201,  4140,    -1,  4142,    -1,    -1,    -1,    -1,
      -1,  2008,  2009,    -1,    -1,  2012,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   222,    -1,    -1,    -1,    -1,  4165,    -1,
      -1,  1966,  4169,    -1,    -1,    -1,    -1,  4174,    -1,  2036,
      -1,    -1,    -1,  2040,    -1,    -1,    -1,    -1,  1983,  1984,
      -1,    -1,    -1,    -1,   253,    -1,    -1,    -1,    -1,    -1,
      -1,  2058,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4206,
      -1,    -1,  2069,  2008,  2009,  4212,    -1,  2012,    -1,  4216,
    4217,    -1,    -1,   282,    -1,  2082,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2091,    -1,    -1,    -1,    -1,    -1,
      -1,  2036,    -1,    -1,    -1,  2040,    -1,    -1,    -1,    -1,
     309,    -1,    -1,    -1,   313,    -1,   315,    -1,    -1,  4256,
      -1,    -1,   321,  2058,    -1,   324,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2069,    -1,    -1,    -1,  4275,    -1,
      -1,    -1,    -1,    -1,  2134,    -1,    -1,  2082,    -1,    -1,
      -1,   350,    -1,   352,    -1,    -1,  2091,   356,  4295,    -1,
    2157,    -1,    -1,    -1,    -1,   364,    -1,    -1,    -1,    -1,
     369,    -1,    -1,    -1,  4311,    -1,    -1,  4314,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   394,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4346,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2218,  2157,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4368,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2252,    -1,  4394,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2257,  4405,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4417,  4418,    -1,  2218,    -1,    -1,    -1,    -1,    -1,    -1,
    2287,  4428,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4440,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2311,    -1,    -1,  2252,    -1,    -1,
      -1,    -1,    -1,    -1,   879,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4480,    -1,    -1,    -1,    -1,    -1,    -1,
    2340,    -1,  2287,    -1,    -1,  2345,    -1,  4494,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2311,    -1,    -1,    -1,
    4517,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2387,  2395,  2389,
    2390,    -1,    -1,    -1,  2401,    -1,    -1,    -1,    -1,    -1,
    2400,    -1,    -1,  2403,    -1,  2405,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4562,    -1,    -1,    -1,    -1,
    4567,    -1,    -1,    -1,  4571,    -1,    -1,    -1,  4575,    -1,
      -1,    -1,  2432,    -1,  2434,    -1,    -1,    -1,  2438,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1011,    -1,    -1,    -1,
    2395,    -1,    -1,    -1,    -1,    -1,  2401,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2470,  2471,  2472,    -1,    -1,    -1,    -1,  2484,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2487,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2499,
      -1,    -1,    -1,    -1,  2504,    -1,    -1,    -1,  1114,    -1,
    2510,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2545,  2484,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2560,  2561,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2566,    -1,  1174,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2587,    -1,    -1,  2590,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2545,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2560,  2561,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2587,    -1,  1209,  2590,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2661,  2662,  2663,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   879,    -1,    -1,    -1,    -1,    -1,  2685,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2697,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1263,    -1,
    2707,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2661,  2662,  2663,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1298,    -1,    -1,    -1,    -1,    -1,    -1,
    2685,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2697,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2707,  2770,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1011,  2812,    -1,    -1,    -1,  1374,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2827,    -1,  2829,    -1,    -1,  2770,    -1,    -1,  1393,    -1,
      -1,    -1,    -1,    -1,  2841,    -1,  2843,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1413,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2812,    -1,    -1,
      -1,    -1,    -1,  1438,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2827,    -1,  2829,  2892,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2841,    -1,  2843,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2920,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1531,    -1,  2934,    -1,    -1,
    1495,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2953,  2892,    -1,  2956,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2972,    -1,    -1,  2920,    -1,    -1,    -1,    -1,
      -1,    -1,  2982,    -1,    -1,    -1,    -1,    -1,  2988,  2934,
    2990,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1209,  1609,    -1,    -1,    -1,    -1,  2953,    -1,
      -1,  2956,  3012,  3013,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3031,    -1,    -1,  1633,    -1,    -1,
      -1,    -1,  1638,  3033,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3043,    -1,    -1,  3046,    -1,  3048,    -1,
      -1,    -1,  1658,  1659,    -1,  1661,  1263,  3057,    -1,    -1,
      -1,    -1,    -1,  3063,    -1,    -1,  3066,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3031,    -1,    -1,    -1,
      -1,  1298,    -1,    -1,  3094,    -1,    -1,  1703,    -1,    -1,
    3100,  3101,    -1,    -1,    -1,    -1,    -1,  1672,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3124,    -1,    -1,    -1,    -1,    -1,
    3130,    -1,    -1,  1739,    -1,    -1,  3136,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1374,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3189,    -1,    -1,    -1,  1393,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1413,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3227,    -1,    -1,    -1,    -1,  3232,    -1,  3234,    -1,    -1,
      -1,  1438,    -1,    -1,    -1,    -1,    -1,  1843,    -1,    -1,
      -1,    -1,    -1,    -1,  3189,    -1,    -1,    -1,    -1,  1855,
      -1,    -1,  1858,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3276,
      -1,    -1,  3279,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3227,    -1,    -1,    -1,    -1,  3232,  1495,  3234,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3313,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1881,    -1,    -1,    -1,
    1885,  1886,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3276,    -1,    -1,  3279,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3313,    -1,
      -1,    -1,    -1,  3380,  3381,    -1,    -1,    -1,    -1,    -1,
    3387,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   879,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3422,  3423,    -1,    -1,  1991,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3380,  3381,    -1,    -1,    -1,
      -1,    -1,  3387,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3463,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1672,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3481,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3463,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   879,    -1,  3528,  3529,
      -1,    -1,    -1,    -1,  1011,    -1,    -1,    -1,    -1,   879,
      -1,  3541,    -1,    -1,    -1,    -1,    -1,  3547,  3548,    -1,
      -1,  3551,    -1,    -1,  3554,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2136,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3591,    -1,    -1,    -1,    -1,  3596,    -1,    -1,    -1,
      -1,  3601,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3636,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2215,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1011,    -1,
      -1,    -1,    -1,  3670,    -1,    -1,  3673,    -1,    -1,    -1,
      -1,  1011,    -1,    -1,  1881,    -1,    -1,    -1,  1885,  1886,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3696,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3708,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3721,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3670,    -1,    -1,  3673,    -1,
      -1,    -1,  1209,    -1,    -1,  2300,    -1,  2343,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3696,    -1,    -1,    -1,    -1,    -1,  3764,    -1,    -1,
    2366,    -1,  2368,  3708,  2370,  2371,  2372,    -1,    -1,  2375,
      -1,    -1,    -1,  2379,    -1,    -1,  3721,    -1,    -1,    -1,
    2386,    -1,    -1,    -1,  1991,  2391,  1263,    -1,    -1,    -1,
      -1,  2397,    -1,    -1,    -1,    -1,  2402,    -1,    -1,    -1,
      -1,    -1,  3802,    -1,    -1,  2411,    -1,    -1,    -1,  2415,
    2416,    -1,  2418,    -1,    -1,    -1,    -1,    -1,    -1,  3764,
      -1,  1298,    -1,    -1,  2430,    -1,    -1,    -1,    -1,    -1,
      -1,  2437,    -1,  2439,  2440,  2441,  2442,  2443,  2444,  2445,
    2446,  2447,  2448,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1209,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1209,
    2476,    -1,    -1,  3880,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1374,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1263,    -1,    -1,    -1,    -1,    -1,  1393,    -1,    -1,    -1,
      -1,    -1,  3922,  1263,    -1,    -1,    -1,    -1,    -1,  2136,
      -1,    -1,    -1,    -1,    -1,  3880,  1413,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1298,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3954,    -1,    -1,    -1,  1298,    -1,
      -1,  1438,    -1,    -1,    -1,  3972,    -1,  3974,  2533,    -1,
      -1,  2536,    -1,  2538,    -1,  2581,    -1,    -1,  2543,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4011,    -1,    -1,    -1,  2215,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1495,    -1,
      -1,  1374,    -1,    -1,    -1,    -1,    -1,  3972,  2593,  3974,
      -1,    -1,    -1,    -1,  1374,    -1,    -1,    -1,    -1,    -1,
    1393,    -1,    -1,    -1,  4051,    -1,  4053,    -1,    -1,    -1,
      -1,    -1,    -1,  1393,    -1,    -1,    -1,    -1,    -1,    -1,
    1413,    -1,    -1,    -1,    -1,    -1,  4011,    -1,  2633,    -1,
      -1,    -1,    -1,  1413,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1438,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2300,    -1,    -1,    -1,    -1,  1438,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4051,    -1,  4053,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2694,
      -1,  2696,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4140,    -1,  1495,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1495,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4165,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2751,    -1,    -1,    -1,
      -1,    -1,  2798,    -1,    -1,  1672,    -1,    -1,    -1,  4206,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2776,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2795,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2813,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4206,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4275,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2877,    -1,    -1,    -1,    -1,  2923,    -1,  1672,
      -1,    -1,    -1,    -1,    -1,    -1,  2533,    -1,  2893,  2536,
      -1,  2538,  1672,    -1,    -1,    -1,  2543,    -1,    -1,  2904,
      -1,    -1,    -1,    -1,    -1,    -1,  4346,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4368,    -1,    -1,    -1,  2971,    -1,    -1,    -1,    -1,
      -1,  2977,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2593,  2993,  2994,    -1,
    2996,    -1,    -1,  2999,  3000,  3001,  3002,  3003,  3004,  3005,
    3006,  3007,  3008,  3009,  1881,    -1,    -1,    -1,  1885,  1886,
    2975,    -1,    -1,    -1,    -1,    -1,    -1,  4417,  4418,    -1,
      -1,  4428,    -1,  4368,    -1,    -1,  2633,    -1,  3034,    -1,
    2995,  3037,    -1,  3039,    -1,    -1,    -1,    -1,  3044,  3045,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3058,  3059,  3060,  3020,  3062,    -1,    -1,  3065,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4480,    -1,    -1,  4428,    -1,    -1,    -1,  2694,    -1,  2696,
      -1,  3056,    -1,    -1,  4494,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3108,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4517,    -1,    -1,  3119,  1991,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1881,    -1,
      -1,    -1,  1885,  1886,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1881,    -1,    -1,  2751,  1885,  1886,    -1,    -1,  3155,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4567,    -1,  4562,    -1,    -1,    -1,    -1,    -1,  4575,  2776,
      -1,    -1,  4517,    -1,    -1,    -1,    -1,  3142,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2795,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2813,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4567,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4575,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1991,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1991,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2136,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3233,    -1,
    2877,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2893,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2904,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2215,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3357,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2975,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2136,    -1,    -1,    -1,    -1,  2995,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2136,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3020,    -1,    -1,    -1,    -1,    -1,  3384,
      -1,    -1,    -1,  2300,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3056,
      -1,    -1,    -1,    -1,    -1,    -1,  3421,    -1,    -1,    -1,
      -1,    -1,  2215,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2215,  3482,    -1,    -1,    -1,
    3486,  3487,  3488,    -1,    -1,  3491,    -1,    -1,    -1,    -1,
    3496,  3497,  3498,  3499,  3500,  3501,  3502,  3503,  3504,  3505,
    3506,  3507,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3535,
    3536,  3537,  3538,    -1,  3540,  3142,    -1,    -1,  3544,  3545,
    3546,    -1,    -1,  3549,    -1,    -1,  3552,  2300,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2300,    -1,    -1,    -1,    -1,    -1,  3531,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3542,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3593,    -1,    -1,
      -1,    -1,    -1,    -1,  3600,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3612,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3233,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2533,    -1,    -1,  2536,
      -1,  2538,    -1,    -1,    -1,    -1,  2543,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3654,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2593,  3682,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3701,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2633,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3384,    -1,    -1,
    2533,    -1,    -1,  2536,  3749,  2538,    -1,    -1,    -1,    -1,
    2543,    -1,    -1,  2533,    -1,    -1,  2536,    -1,  2538,  3805,
      -1,    -1,    -1,  2543,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3421,    -1,    -1,  2694,    -1,  2696,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2593,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3857,  3858,  2593,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2751,    -1,    -1,    -1,    -1,    -1,
    2633,    -1,  3888,    -1,    -1,    -1,  3892,    -1,    -1,    -1,
      -1,    -1,    -1,  2633,    -1,    -1,    -1,    -1,    -1,  2776,
    3906,    -1,  3908,    -1,    -1,    -1,    -1,  3913,  3914,  3915,
      -1,    -1,  3918,  3919,  3920,  3921,    -1,  3923,  2795,    -1,
    3926,    -1,    -1,    -1,  3531,    -1,    -1,    -1,    -1,    -1,
      -1,  3896,    -1,    -1,    -1,  3542,  2813,    -1,    -1,    -1,
      -1,  2694,    -1,  2696,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2694,    -1,  2696,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3976,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2751,    -1,
    2877,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2751,    -1,    -1,    -1,    -1,  2893,    -1,    -1,    -1,
      -1,    -1,    -1,  2776,    -1,    -1,    -1,  2904,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2776,    -1,    -1,    -1,
      -1,    -1,  2795,    -1,    -1,  4010,    -1,  3654,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2795,    -1,    -1,    -1,    -1,
    2813,    -1,    -1,    -1,    -1,    -1,  4072,    -1,    -1,    -1,
      -1,    -1,    -1,  2813,    -1,  3682,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3701,    -1,    -1,    -1,  2975,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2995,    -1,
      -1,    -1,    -1,    -1,  2877,    -1,    -1,    -1,    -1,    -1,
    4136,  4137,    -1,    -1,    -1,    -1,    -1,  2877,    -1,    -1,
    2893,    -1,  3749,  3020,    -1,    -1,  4152,  4153,  4154,    -1,
      -1,  2904,  4117,  2893,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2904,    -1,    -1,    -1,    -1,    -1,
      -1,  4177,    -1,  4138,    -1,    -1,    -1,    -1,    -1,  3056,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4174,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2975,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2975,    -1,    -1,    -1,    -1,
      -1,    -1,  2995,    -1,    -1,    -1,    -1,  4212,    -1,    -1,
      -1,  4216,  4217,    -1,    -1,  2995,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3142,    -1,  3020,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3020,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3896,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4303,    -1,    -1,
      -1,    -1,    -1,  3056,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4319,    -1,    -1,  3056,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3233,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4393,    -1,  3142,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3142,  4010,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4438,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4483,    -1,    -1,
    3233,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3233,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3384,    -1,    -1,
    4117,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4138,    -1,  4539,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3421,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4174,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4212,    -1,    -1,    -1,  4216,
    4217,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3384,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3384,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3531,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3542,    -1,    -1,  3421,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3421,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3654,  3531,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3542,
      -1,  3531,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3542,    -1,    -1,  3682,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3701,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3749,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3654,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3654,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3682,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3682,    -1,    -1,    -1,    -1,    -1,  3701,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3701,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3749,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3749,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3896,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4010,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3896,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3896,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4117,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4010,    -1,    -1,
      -1,  4138,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4010,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4174,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4212,    -1,    -1,    -1,  4216,
    4217,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4117,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4117,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4138,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4138,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4174,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4174,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4212,
      -1,    -1,    -1,  4216,  4217,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4212,    -1,    -1,    -1,  4216,  4217,     3,     4,
       5,     6,     7,     8,     9,    10,    -1,    -1,    -1,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    -1,    -1,    -1,    -1,    30,    31,    -1,    -1,    34,
      35,    -1,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    -1,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    -1,    62,    63,    64,
      65,    66,    -1,    68,    -1,    70,    71,    72,    73,    74,
      75,    76,    -1,    78,    79,    80,    81,    82,    83,    -1,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,    -1,
     105,    -1,   107,   108,   109,   110,   111,    -1,   113,   114,
     115,   116,    -1,   118,   119,   120,   121,   122,    -1,   124,
     125,   126,    -1,   128,   129,   130,    -1,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,    -1,   144,
     145,   146,   147,    -1,   149,    -1,   151,   152,    -1,   154,
     155,   156,   157,    -1,   159,   160,    -1,   162,    -1,   164,
     165,   166,   167,   168,   169,   170,   171,   172,    -1,   174,
     175,   176,   177,   178,   179,    -1,   181,   182,   183,   184,
     185,   186,   187,   188,   189,    -1,   191,    -1,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,    -1,   204,
     205,    -1,   207,   208,   209,   210,   211,    -1,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,    -1,   250,    -1,    -1,   253,   254,
     255,    -1,    -1,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,    -1,   272,   273,   274,
     275,   276,   277,   278,    -1,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,    -1,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
      -1,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,    -1,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
      -1,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,    -1,   348,   349,    -1,   351,   352,   353,   354,
     355,   356,    -1,   358,   359,    -1,    -1,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,    -1,
     375,   376,   377,   378,   379,   380,   381,    -1,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,    -1,    -1,   399,    -1,    -1,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   428,   429,   430,    -1,    -1,    -1,    -1,
      -1,    -1,   437,   438,     3,     4,     5,     6,     7,     8,
       9,    10,    -1,    -1,    -1,    14,    15,    16,    17,    18,
      19,    20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,
      -1,    30,    31,    -1,    -1,    34,    35,    -1,    37,    38,
      39,    40,    41,    42,    43,    44,    45,    46,    47,    -1,
      49,    50,    51,    52,    53,    54,    55,    56,    57,    58,
      59,    60,    -1,    62,    63,    64,    65,    66,    -1,    68,
      -1,    70,    71,    72,    73,    74,    75,    76,    -1,    78,
      79,    80,    81,    82,    83,    -1,    85,    86,    87,    88,
      89,    90,    91,    92,    93,    94,    95,    96,    97,    98,
      99,   100,   101,   102,   103,    -1,   105,    -1,   107,   108,
     109,   110,   111,    -1,   113,   114,   115,    -1,    -1,   118,
     119,   120,   121,   122,    -1,   124,   125,   126,    -1,   128,
     129,   130,    -1,   132,   133,   134,   135,   136,   137,   138,
     139,   140,   141,   142,    -1,   144,   145,   146,   147,    -1,
     149,    -1,   151,   152,    -1,   154,   155,   156,   157,    -1,
     159,   160,    -1,   162,    -1,   164,   165,   166,   167,   168,
     169,   170,   171,   172,    -1,   174,   175,   176,   177,   178,
     179,    -1,   181,   182,   183,   184,   185,   186,   187,   188,
     189,    -1,   191,    -1,   193,   194,   195,   196,   197,   198,
     199,   200,   201,   202,    -1,   204,   205,    -1,   207,   208,
     209,   210,   211,    -1,   213,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,   247,   248,
      -1,   250,    -1,    -1,   253,   254,   255,    -1,    -1,   258,
     259,   260,   261,   262,   263,   264,   265,   266,   267,   268,
     269,   270,    -1,   272,   273,   274,   275,   276,   277,   278,
      -1,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,   292,    -1,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,   304,    -1,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   316,   317,   318,
     319,    -1,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,    -1,   336,   337,   338,
     339,   340,   341,   342,   343,   344,   345,   346,    -1,   348,
     349,    -1,   351,   352,   353,   354,   355,   356,    -1,   358,
     359,    -1,    -1,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,   373,    -1,   375,   376,   377,   378,
     379,   380,   381,    -1,   383,   384,   385,   386,   387,   388,
     389,    -1,   391,   392,   393,   394,   395,   396,    -1,    -1,
     399,    -1,    -1,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   428,
     429,     3,    -1,    -1,    -1,    -1,    -1,    -1,   437,   438,
      -1,    -1,    14,    15,    16,    17,    18,    19,    20,    21,
      -1,    23,    24,    25,    -1,    -1,    -1,    -1,    30,    -1,
      32,    -1,    34,    35,    -1,    37,    38,    -1,    40,    41,
      42,    43,    44,    -1,    46,    47,    -1,    49,    50,    51,
      52,    53,    -1,    -1,    56,    57,    58,    59,    60,    -1,
      62,    63,    64,    65,    66,    -1,    -1,    -1,    70,    71,
      72,    73,    -1,    75,    76,    -1,    78,    79,    80,    81,
      82,    83,    -1,    85,    86,    87,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    95,    96,    97,    98,    99,   100,   101,
     102,   103,    -1,   105,    -1,   107,   108,   109,   110,   111,
      -1,   113,   114,   115,    -1,    -1,   118,   119,   120,   121,
     122,    -1,   124,   125,   126,    -1,   128,   129,   130,    -1,
     132,   133,   134,   135,   136,   137,   138,   139,   140,    -1,
     142,    -1,   144,   145,   146,   147,    -1,   149,    -1,   151,
      -1,    -1,   154,   155,   156,   157,    -1,   159,   160,    -1,
     162,    -1,   164,   165,   166,   167,   168,    -1,   170,   171,
     172,    -1,   174,   175,   176,   177,   178,   179,    -1,   181,
     182,   183,   184,   185,   186,   187,   188,   189,    -1,   191,
      -1,   193,    -1,    -1,   196,   197,   198,   199,   200,   201,
     202,    -1,   204,   205,    -1,   207,   208,   209,   210,    -1,
      -1,   213,   214,   215,    -1,    -1,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,    -1,   238,   239,    -1,   241,
      -1,   243,   244,   245,   246,   247,   248,    -1,   250,    -1,
      -1,   253,   254,   255,    -1,    -1,   258,   259,    -1,   261,
      -1,   263,   264,   265,   266,   267,   268,   269,   270,    -1,
     272,   273,   274,   275,   276,   277,   278,    -1,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
     292,    -1,   294,   295,   296,   297,   298,   299,   300,   301,
     302,   303,   304,    -1,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,   316,   317,   318,   319,    -1,   321,
     322,   323,   324,   325,    -1,   327,   328,   329,   330,    -1,
     332,   333,   334,    -1,   336,   337,   338,   339,   340,   341,
     342,   343,   344,   345,   346,    -1,   348,   349,    -1,   351,
     352,   353,   354,   355,   356,    -1,   358,   359,    -1,    -1,
     362,   363,   364,   365,    -1,   367,   368,   369,   370,   371,
     372,   373,    -1,    -1,   376,   377,   378,   379,   380,    -1,
      -1,   383,   384,   385,   386,   387,   388,   389,    -1,   391,
      -1,   393,   394,   395,   396,    -1,    -1,   399,    -1,    -1,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   438,    14,    15,    16,
      17,    18,    19,    20,    21,    -1,    23,    24,    25,    -1,
      -1,    -1,    -1,    30,    -1,    -1,    -1,    34,    35,    -1,
      37,    38,    39,    40,    41,    42,    -1,    44,    45,    46,
      47,    -1,    49,    50,    51,    52,    53,    -1,    -1,    56,
      57,    58,    59,    60,    -1,    62,    63,    64,    65,    -1,
      -1,    68,    -1,    70,    71,    72,    73,    74,    75,    76,
      -1,    78,    79,    80,    81,    82,    83,    -1,    85,    86,
      87,    -1,    -1,    -1,    91,    -1,    -1,    -1,    95,    96,
      97,    98,    99,   100,   101,   102,   103,    -1,   105,    -1,
     107,   108,   109,   110,   111,    -1,   113,   114,   115,    -1,
      -1,   118,   119,   120,   121,   122,    -1,   124,   125,   126,
      -1,   128,   129,   130,    -1,   132,   133,   134,   135,    -1,
     137,   138,   139,    -1,    -1,   142,    -1,   144,   145,   146,
     147,    -1,   149,    -1,   151,   152,    -1,   154,   155,   156,
     157,    -1,   159,    -1,    -1,   162,    -1,   164,   165,   166,
     167,   168,   169,   170,   171,   172,   173,   174,   175,   176,
     177,   178,   179,    -1,   181,   182,   183,   184,   185,   186,
     187,   188,   189,    -1,   191,    -1,   193,   194,   195,   196,
     197,   198,   199,   200,   201,   202,    -1,   204,   205,    -1,
     207,    -1,   209,   210,   211,    -1,   213,   214,   215,    -1,
      -1,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,    -1,
      -1,   238,   239,   240,   241,    -1,    -1,   244,   245,   246,
     247,   248,    -1,   250,    -1,    -1,   253,   254,   255,    -1,
      -1,   258,   259,   260,   261,   262,    -1,   264,   265,   266,
     267,   268,   269,   270,    -1,   272,    -1,   274,    -1,   276,
     277,   278,    -1,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,   292,    -1,   294,   295,   296,
     297,   298,   299,   300,   301,   302,   303,   304,    -1,   306,
     307,   308,   309,   310,    -1,   312,   313,   314,   315,   316,
     317,   318,   319,    -1,   321,   322,   323,   324,   325,    -1,
     327,   328,   329,   330,   331,   332,   333,   334,    -1,   336,
     337,   338,   339,   340,   341,   342,   343,   344,   345,    -1,
      -1,   348,   349,    -1,   351,   352,   353,   354,   355,   356,
      -1,   358,   359,    -1,    -1,   362,    -1,   364,    -1,    -1,
     367,   368,   369,   370,   371,   372,   373,    -1,    -1,   376,
     377,   378,   379,   380,    -1,    -1,   383,   384,   385,   386,
     387,    -1,   389,   390,   391,   392,   393,   394,   395,   396,
      -1,    -1,   399,    -1,    -1,   402,   403,   404,   405,   406,
     407,    -1,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     417,   418,   419,    14,    15,    16,    17,    18,    19,    20,
      21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,    30,
      -1,   438,    -1,    34,    35,    -1,    37,    38,    39,    40,
      41,    42,    -1,    44,    45,    46,    47,    -1,    49,    50,
      51,    52,    53,    -1,    -1,    56,    57,    58,    59,    60,
      -1,    62,    63,    64,    65,    -1,    -1,    68,    -1,    70,
      71,    72,    73,    74,    75,    76,    -1,    78,    79,    80,
      81,    82,    83,    -1,    85,    86,    87,    -1,    -1,    -1,
      91,    -1,    -1,    -1,    95,    96,    97,    98,    99,   100,
     101,   102,   103,    -1,   105,    -1,   107,   108,   109,   110,
     111,    -1,   113,   114,   115,    -1,    -1,   118,   119,   120,
     121,   122,    -1,   124,   125,   126,    -1,   128,   129,   130,
      -1,   132,   133,   134,   135,    -1,   137,   138,   139,    -1,
      -1,   142,    -1,   144,   145,   146,   147,    -1,   149,    -1,
     151,   152,    -1,   154,   155,   156,   157,    -1,   159,    -1,
      -1,   162,    -1,   164,   165,   166,   167,   168,   169,   170,
     171,   172,   173,   174,   175,   176,   177,   178,   179,    -1,
     181,   182,   183,   184,   185,   186,   187,   188,   189,    -1,
     191,    -1,   193,   194,   195,   196,   197,   198,   199,   200,
     201,   202,    -1,   204,   205,    -1,   207,    -1,   209,   210,
     211,    -1,   213,   214,   215,    -1,    -1,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,    -1,    -1,   238,   239,   240,
     241,    -1,    -1,   244,   245,   246,   247,   248,    -1,   250,
      -1,    -1,   253,   254,   255,    -1,    -1,   258,   259,   260,
     261,   262,    -1,   264,   265,   266,   267,   268,   269,   270,
      -1,   272,    -1,   274,    -1,   276,   277,   278,    -1,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,   292,    -1,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,   304,    -1,   306,   307,   308,   309,   310,
      -1,   312,   313,   314,   315,   316,   317,   318,   319,    -1,
     321,   322,   323,   324,   325,    -1,   327,   328,   329,   330,
     331,   332,   333,   334,    -1,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,    -1,    -1,   348,   349,    -1,
     351,   352,   353,   354,   355,   356,    -1,   358,   359,    -1,
      -1,   362,    -1,   364,    -1,    -1,   367,   368,   369,   370,
     371,   372,   373,    -1,    -1,   376,   377,   378,   379,   380,
      -1,    -1,   383,   384,   385,   386,   387,    -1,   389,   390,
     391,   392,   393,   394,   395,   396,    -1,    -1,   399,    -1,
      -1,   402,   403,   404,   405,   406,   407,    -1,     3,     4,
       5,     6,     7,     8,     9,    10,   417,   418,   419,    14,
      15,    16,    17,    18,    19,    20,    21,    -1,    23,    24,
      25,    -1,    -1,    -1,    -1,    30,    31,   438,    -1,    34,
      35,    -1,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    -1,    62,    63,    64,
      65,    66,    -1,    68,    -1,    70,    71,    72,    73,    74,
      75,    76,    -1,    78,    79,    80,    81,    82,    83,    -1,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,    -1,
     105,    -1,   107,   108,   109,   110,   111,    -1,   113,   114,
     115,    -1,    -1,   118,   119,   120,   121,   122,    -1,   124,
     125,   126,    -1,   128,   129,   130,    -1,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,    -1,   144,
     145,   146,   147,    -1,   149,    -1,   151,   152,   153,   154,
     155,   156,   157,    -1,   159,   160,    -1,   162,    -1,   164,
     165,   166,   167,   168,   169,   170,   171,   172,    -1,   174,
     175,   176,   177,   178,   179,    -1,   181,   182,   183,   184,
     185,   186,   187,   188,   189,    -1,   191,    -1,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,    -1,   204,
     205,   206,   207,   208,   209,   210,   211,    -1,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,    -1,   250,    -1,    -1,   253,   254,
     255,    -1,    -1,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,    -1,   272,   273,   274,
     275,   276,   277,   278,    -1,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,    -1,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
      -1,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,    -1,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
      -1,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,    -1,   348,   349,    -1,   351,   352,   353,   354,
     355,   356,    -1,   358,   359,    -1,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,    -1,
     375,   376,   377,   378,   379,   380,   381,    -1,   383,   384,
     385,   386,   387,   388,   389,    -1,   391,   392,   393,   394,
     395,   396,    -1,    -1,   399,    -1,    -1,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   428,   429,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   437,     3,     4,     5,     6,     7,     8,     9,
      10,    -1,    -1,    -1,    14,    15,    16,    17,    18,    19,
      20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,
      30,    31,    -1,    -1,    34,    35,    -1,    37,    38,    39,
      40,    41,    42,    43,    44,    45,    46,    47,    -1,    49,
      50,    51,    52,    53,    54,    55,    56,    57,    58,    59,
      60,    -1,    62,    63,    64,    65,    66,    -1,    68,    -1,
      70,    71,    72,    73,    74,    75,    76,    -1,    78,    79,
      80,    81,    82,    83,    -1,    85,    86,    87,    88,    89,
      90,    91,    92,    93,    94,    95,    96,    97,    98,    99,
     100,   101,   102,   103,    -1,   105,    -1,   107,   108,   109,
     110,   111,    -1,   113,   114,   115,    -1,    -1,   118,   119,
     120,   121,   122,    -1,   124,   125,   126,    -1,   128,   129,
     130,    -1,   132,   133,   134,   135,   136,   137,   138,   139,
     140,   141,   142,    -1,   144,   145,   146,   147,    -1,   149,
      -1,   151,   152,    -1,   154,   155,   156,   157,    -1,   159,
     160,    -1,   162,    -1,   164,   165,   166,   167,   168,   169,
     170,   171,   172,    -1,   174,   175,   176,   177,   178,   179,
      -1,   181,   182,   183,   184,   185,   186,   187,   188,   189,
      -1,   191,    -1,   193,   194,   195,   196,   197,   198,   199,
     200,   201,   202,    -1,   204,   205,    -1,   207,   208,   209,
     210,   211,    -1,   213,   214,   215,   216,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,   246,   247,   248,    -1,
     250,    -1,    -1,   253,   254,   255,    -1,    -1,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,    -1,   272,   273,   274,   275,   276,   277,   278,    -1,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,   292,    -1,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,   304,    -1,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,    -1,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,    -1,   348,   349,
     350,   351,   352,   353,   354,   355,   356,    -1,   358,   359,
      -1,    -1,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,    -1,   375,   376,   377,   378,   379,
     380,   381,    -1,   383,   384,   385,   386,   387,   388,   389,
      -1,   391,   392,   393,   394,   395,   396,    -1,    -1,   399,
      -1,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   428,   429,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   437,     3,     4,
       5,     6,     7,     8,     9,    10,    -1,    -1,    -1,    14,
      15,    16,    17,    18,    19,    20,    21,    -1,    23,    24,
      25,    -1,    -1,    -1,    -1,    30,    31,    -1,    -1,    34,
      35,    -1,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    -1,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    -1,    62,    63,    64,
      65,    66,    -1,    68,    -1,    70,    71,    72,    73,    74,
      75,    76,    -1,    78,    79,    80,    81,    82,    83,    -1,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,    -1,
     105,    -1,   107,   108,   109,   110,   111,    -1,   113,   114,
     115,    -1,    -1,   118,   119,   120,   121,   122,    -1,   124,
     125,   126,    -1,   128,   129,   130,    -1,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,    -1,   144,
     145,   146,   147,    -1,   149,    -1,   151,   152,    -1,   154,
     155,   156,   157,    -1,   159,   160,    -1,   162,    -1,   164,
     165,   166,   167,   168,   169,   170,   171,   172,    -1,   174,
     175,   176,   177,   178,   179,    -1,   181,   182,   183,   184,
     185,   186,   187,   188,   189,    -1,   191,    -1,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,    -1,   204,
     205,    -1,   207,   208,   209,   210,   211,    -1,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,    -1,   250,    -1,    -1,   253,   254,
     255,    -1,    -1,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,    -1,   272,   273,   274,
     275,   276,   277,   278,    -1,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,    -1,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
      -1,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,    -1,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
      -1,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,    -1,   348,   349,    -1,   351,   352,   353,   354,
     355,   356,    -1,   358,   359,    -1,    -1,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,    -1,
     375,   376,   377,   378,   379,   380,   381,    -1,   383,   384,
     385,   386,   387,   388,   389,    -1,   391,   392,   393,   394,
     395,   396,    -1,    -1,   399,    -1,    -1,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   428,   429,    -1,    -1,    -1,    -1,    -1,
     435,   436,   437,     3,     4,     5,     6,     7,     8,     9,
      10,    -1,    -1,    -1,    14,    15,    16,    17,    18,    19,
      20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,
      30,    31,    -1,    -1,    34,    35,    -1,    37,    38,    39,
      40,    41,    42,    43,    44,    45,    46,    47,    -1,    49,
      50,    51,    52,    53,    54,    55,    56,    57,    58,    59,
      60,    -1,    62,    63,    64,    65,    66,    -1,    68,    -1,
      70,    71,    72,    73,    74,    75,    76,    -1,    78,    79,
      80,    81,    82,    83,    -1,    85,    86,    87,    88,    89,
      90,    91,    92,    93,    94,    95,    96,    97,    98,    99,
     100,   101,   102,   103,    -1,   105,    -1,   107,   108,   109,
     110,   111,    -1,   113,   114,   115,    -1,    -1,   118,   119,
     120,   121,   122,    -1,   124,   125,   126,    -1,   128,   129,
     130,    -1,   132,   133,   134,   135,   136,   137,   138,   139,
     140,   141,   142,    -1,   144,   145,   146,   147,    -1,   149,
      -1,   151,   152,    -1,   154,   155,   156,   157,    -1,   159,
     160,    -1,   162,    -1,   164,   165,   166,   167,   168,   169,
     170,   171,   172,    -1,   174,   175,   176,   177,   178,   179,
      -1,   181,   182,   183,   184,   185,   186,   187,   188,   189,
      -1,   191,    -1,   193,   194,   195,   196,   197,   198,   199,
     200,   201,   202,    -1,   204,   205,    -1,   207,   208,   209,
     210,   211,    -1,   213,   214,   215,   216,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,   246,   247,   248,    -1,
     250,    -1,    -1,   253,   254,   255,    -1,    -1,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,    -1,   272,   273,   274,   275,   276,   277,   278,    -1,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,   292,    -1,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,   304,    -1,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
      -1,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,    -1,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,    -1,   348,   349,
      -1,   351,   352,   353,   354,   355,   356,    -1,   358,   359,
      -1,    -1,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,    -1,   375,   376,   377,   378,   379,
     380,   381,    -1,   383,   384,   385,   386,   387,   388,   389,
      -1,   391,   392,   393,   394,   395,   396,    -1,    -1,   399,
      -1,    -1,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   428,   429,
     430,    -1,    -1,    -1,    -1,    -1,    -1,   437,     3,     4,
       5,     6,     7,     8,     9,    10,    -1,    -1,    -1,    14,
      15,    16,    17,    18,    19,    20,    21,    -1,    23,    24,
      25,    -1,    -1,    -1,    -1,    30,    31,    -1,    -1,    34,
      35,    -1,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    -1,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    -1,    62,    63,    64,
      65,    66,    -1,    68,    -1,    70,    71,    72,    73,    74,
      75,    76,    -1,    78,    79,    80,    81,    82,    83,    -1,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,    -1,   107,   108,   109,   110,   111,    -1,   113,   114,
     115,    -1,    -1,   118,   119,   120,   121,   122,    -1,   124,
     125,   126,    -1,   128,   129,   130,    -1,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,    -1,   144,
     145,   146,   147,    -1,   149,    -1,   151,   152,    -1,   154,
     155,   156,   157,    -1,   159,   160,    -1,   162,    -1,   164,
     165,   166,   167,   168,   169,   170,   171,   172,    -1,   174,
     175,   176,   177,   178,   179,    -1,   181,   182,   183,   184,
     185,   186,   187,   188,   189,    -1,   191,    -1,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,    -1,   204,
     205,    -1,   207,   208,   209,   210,   211,    -1,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,    -1,   250,    -1,    -1,   253,   254,
     255,    -1,    -1,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,    -1,   272,   273,   274,
     275,   276,   277,   278,    -1,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,    -1,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
      -1,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,    -1,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
      -1,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,    -1,   348,   349,    -1,   351,   352,   353,   354,
     355,   356,    -1,   358,   359,    -1,    -1,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,    -1,
     375,   376,   377,   378,   379,   380,   381,    -1,   383,   384,
     385,   386,   387,   388,   389,    -1,   391,   392,   393,   394,
     395,   396,    -1,    -1,   399,    -1,    -1,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   428,   429,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   437,     3,     4,     5,     6,     7,     8,     9,
      10,    -1,    -1,    -1,    14,    15,    16,    17,    18,    19,
      20,    21,    22,    23,    24,    25,    -1,    -1,    -1,    -1,
      30,    31,    -1,    -1,    34,    35,    -1,    37,    38,    39,
      40,    41,    42,    43,    44,    45,    46,    47,    -1,    49,
      50,    51,    52,    53,    54,    55,    56,    57,    58,    59,
      60,    -1,    62,    63,    64,    65,    66,    -1,    68,    -1,
      70,    71,    72,    73,    74,    75,    76,    -1,    78,    79,
      80,    81,    82,    83,    -1,    85,    86,    87,    88,    89,
      90,    91,    92,    93,    94,    95,    96,    97,    98,    99,
     100,   101,   102,   103,    -1,   105,    -1,   107,   108,   109,
     110,   111,    -1,   113,   114,   115,    -1,    -1,   118,   119,
     120,   121,   122,    -1,   124,   125,   126,    -1,   128,   129,
     130,    -1,   132,   133,   134,   135,   136,   137,   138,   139,
     140,   141,   142,    -1,   144,   145,   146,   147,    -1,   149,
      -1,   151,   152,    -1,   154,   155,   156,   157,    -1,   159,
     160,    -1,   162,    -1,   164,   165,   166,   167,   168,   169,
     170,   171,   172,    -1,   174,   175,   176,   177,   178,   179,
      -1,   181,   182,   183,   184,   185,   186,   187,   188,   189,
      -1,   191,    -1,   193,   194,   195,   196,   197,   198,   199,
     200,   201,   202,    -1,   204,   205,    -1,   207,   208,   209,
     210,   211,    -1,   213,   214,   215,   216,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,   246,   247,   248,    -1,
     250,    -1,    -1,   253,   254,   255,    -1,    -1,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,    -1,   272,   273,   274,   275,   276,   277,   278,    -1,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,   292,    -1,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,   304,    -1,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
      -1,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,    -1,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,    -1,   348,   349,
      -1,   351,   352,   353,   354,   355,   356,    -1,   358,   359,
      -1,    -1,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,    -1,   375,   376,   377,   378,   379,
     380,   381,    -1,   383,   384,   385,   386,   387,   388,   389,
      -1,   391,   392,   393,   394,   395,   396,    -1,    -1,   399,
      -1,    -1,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   428,   429,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   437,     3,     4,
       5,     6,     7,     8,     9,    10,    -1,    -1,    -1,    14,
      15,    16,    17,    18,    19,    20,    21,    -1,    23,    24,
      25,    -1,    -1,    -1,    -1,    30,    31,    -1,    -1,    34,
      35,    -1,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    -1,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    -1,    62,    63,    64,
      65,    66,    -1,    68,    -1,    70,    71,    72,    73,    74,
      75,    76,    -1,    78,    79,    80,    81,    82,    83,    -1,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,    -1,
     105,    -1,   107,   108,   109,   110,   111,    -1,   113,   114,
     115,    -1,    -1,   118,   119,   120,   121,   122,    -1,   124,
     125,   126,    -1,   128,   129,   130,    -1,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,    -1,   144,
     145,   146,   147,    -1,   149,    -1,   151,   152,   153,   154,
     155,   156,   157,    -1,   159,   160,    -1,   162,    -1,   164,
     165,   166,   167,   168,   169,   170,   171,   172,    -1,   174,
     175,   176,   177,   178,   179,    -1,   181,   182,   183,   184,
     185,   186,   187,   188,   189,    -1,   191,    -1,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,    -1,   204,
     205,    -1,   207,   208,   209,   210,   211,    -1,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,    -1,   250,    -1,    -1,   253,   254,
     255,    -1,    -1,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,    -1,   272,   273,   274,
     275,   276,   277,   278,    -1,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,    -1,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
      -1,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,    -1,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
      -1,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,    -1,   348,   349,    -1,   351,   352,   353,   354,
     355,   356,    -1,   358,   359,    -1,    -1,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,    -1,
     375,   376,   377,   378,   379,   380,   381,    -1,   383,   384,
     385,   386,   387,   388,   389,    -1,   391,   392,   393,   394,
     395,   396,    -1,    -1,   399,    -1,    -1,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   428,   429,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   437,     3,     4,     5,     6,     7,     8,     9,
      10,    -1,    -1,    -1,    14,    15,    16,    17,    18,    19,
      20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,
      30,    31,    -1,    -1,    34,    35,    -1,    37,    38,    39,
      40,    41,    42,    43,    44,    45,    46,    47,    -1,    49,
      50,    51,    52,    53,    54,    55,    56,    57,    58,    59,
      60,    -1,    62,    63,    64,    65,    66,    -1,    68,    -1,
      70,    71,    72,    73,    74,    75,    76,    -1,    78,    79,
      80,    81,    82,    83,    -1,    85,    86,    87,    88,    89,
      90,    91,    92,    93,    94,    95,    96,    97,    98,    99,
     100,   101,   102,   103,    -1,   105,    -1,   107,   108,   109,
     110,   111,    -1,   113,   114,   115,    -1,    -1,   118,   119,
     120,   121,   122,    -1,   124,   125,   126,    -1,   128,   129,
     130,    -1,   132,   133,   134,   135,   136,   137,   138,   139,
     140,   141,   142,    -1,   144,   145,   146,   147,    -1,   149,
      -1,   151,   152,    -1,   154,   155,   156,   157,    -1,   159,
     160,    -1,   162,    -1,   164,   165,   166,   167,   168,   169,
     170,   171,   172,    -1,   174,   175,   176,   177,   178,   179,
      -1,   181,   182,   183,   184,   185,   186,   187,   188,   189,
      -1,   191,    -1,   193,   194,   195,   196,   197,   198,   199,
     200,   201,   202,    -1,   204,   205,    -1,   207,   208,   209,
     210,   211,    -1,   213,   214,   215,   216,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,   246,   247,   248,    -1,
     250,    -1,    -1,   253,   254,   255,    -1,    -1,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,    -1,   272,   273,   274,   275,   276,   277,   278,    -1,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,   292,    -1,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,   304,    -1,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
      -1,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,    -1,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,    -1,   348,   349,
      -1,   351,   352,   353,   354,   355,   356,    -1,   358,   359,
      -1,    -1,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,    -1,   375,   376,   377,   378,   379,
     380,   381,    -1,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,    -1,    -1,   399,
      -1,    -1,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   428,   429,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   437,     3,     4,
       5,     6,     7,     8,     9,    10,    -1,    -1,    -1,    14,
      15,    16,    17,    18,    19,    20,    21,    -1,    23,    24,
      25,    -1,    -1,    -1,    -1,    30,    31,    -1,    -1,    34,
      35,    -1,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    -1,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    -1,    62,    63,    64,
      65,    66,    -1,    68,    -1,    70,    71,    72,    73,    74,
      75,    76,    -1,    78,    79,    80,    81,    82,    83,    -1,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,    -1,
     105,    -1,   107,   108,   109,   110,   111,    -1,   113,   114,
     115,    -1,    -1,   118,   119,   120,   121,   122,    -1,   124,
     125,   126,    -1,   128,   129,   130,    -1,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,    -1,   144,
     145,   146,   147,    -1,   149,    -1,   151,   152,    -1,   154,
     155,   156,   157,    -1,   159,   160,    -1,   162,    -1,   164,
     165,   166,   167,   168,   169,   170,   171,   172,    -1,   174,
     175,   176,   177,   178,   179,    -1,   181,   182,   183,   184,
     185,   186,   187,   188,   189,    -1,   191,    -1,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,    -1,   204,
     205,    -1,   207,   208,   209,   210,   211,    -1,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,    -1,   250,    -1,    -1,   253,   254,
     255,    -1,    -1,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,    -1,   272,   273,   274,
     275,   276,   277,   278,    -1,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,    -1,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
      -1,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,    -1,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
      -1,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,    -1,   348,   349,    -1,   351,   352,   353,   354,
     355,   356,    -1,   358,   359,    -1,    -1,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,    -1,
     375,   376,   377,   378,   379,   380,   381,    -1,   383,   384,
     385,   386,   387,   388,   389,    -1,   391,   392,   393,   394,
     395,   396,    -1,    -1,   399,    -1,    -1,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   428,   429,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   437,     3,     4,     5,     6,     7,     8,     9,
      10,    -1,    -1,    -1,    14,    15,    16,    17,    18,    19,
      20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,
      30,    31,    -1,    -1,    34,    35,    -1,    37,    38,    39,
      40,    41,    42,    43,    44,    45,    46,    47,    -1,    49,
      50,    51,    52,    53,    54,    55,    56,    57,    58,    59,
      60,    -1,    62,    63,    64,    65,    66,    -1,    68,    -1,
      70,    71,    72,    73,    74,    75,    76,    -1,    78,    79,
      80,    81,    82,    83,    -1,    85,    86,    87,    88,    89,
      90,    91,    92,    93,    94,    95,    96,    97,    98,    99,
     100,   101,   102,   103,    -1,   105,    -1,   107,   108,   109,
     110,   111,    -1,   113,   114,   115,    -1,    -1,   118,   119,
     120,   121,   122,    -1,   124,   125,   126,    -1,   128,   129,
     130,    -1,   132,   133,   134,   135,   136,   137,   138,   139,
     140,   141,   142,    -1,   144,   145,   146,   147,    -1,   149,
      -1,   151,   152,    -1,   154,   155,   156,   157,    -1,   159,
     160,    -1,   162,    -1,   164,   165,   166,   167,   168,   169,
     170,   171,   172,    -1,   174,   175,   176,   177,   178,   179,
      -1,   181,   182,   183,   184,   185,   186,   187,   188,   189,
      -1,   191,    -1,   193,   194,   195,   196,   197,   198,   199,
     200,   201,   202,    -1,   204,   205,    -1,   207,   208,   209,
     210,   211,    -1,   213,   214,   215,   216,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,   246,   247,   248,    -1,
     250,    -1,    -1,   253,   254,   255,    -1,    -1,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,    -1,   272,   273,   274,   275,   276,   277,   278,    -1,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,   292,    -1,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,   304,    -1,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
      -1,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,    -1,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,    -1,   348,   349,
      -1,   351,   352,   353,   354,   355,   356,    -1,   358,   359,
      -1,    -1,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,    -1,   375,   376,   377,   378,   379,
     380,   381,    -1,   383,   384,   385,   386,   387,   388,   389,
      -1,   391,   392,   393,   394,   395,   396,    -1,    -1,   399,
      -1,    -1,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   428,   429,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   437,     3,     4,
       5,     6,     7,     8,     9,    10,    -1,    -1,    -1,    14,
      15,    16,    17,    18,    19,    20,    21,    -1,    23,    24,
      25,    -1,    -1,    -1,    -1,    30,    31,    -1,    -1,    34,
      35,    -1,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    -1,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    -1,    62,    63,    64,
      65,    66,    -1,    68,    -1,    70,    71,    72,    73,    74,
      75,    76,    -1,    78,    79,    80,    81,    82,    83,    -1,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,    -1,
     105,    -1,   107,   108,   109,   110,   111,    -1,   113,   114,
     115,    -1,    -1,   118,   119,   120,   121,   122,    -1,   124,
     125,   126,    -1,   128,   129,   130,    -1,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,    -1,   144,
     145,   146,   147,    -1,   149,    -1,   151,   152,    -1,   154,
     155,   156,   157,    -1,   159,   160,    -1,   162,    -1,   164,
     165,   166,   167,   168,   169,   170,   171,   172,    -1,   174,
     175,   176,   177,   178,   179,    -1,   181,   182,   183,   184,
     185,   186,   187,   188,   189,    -1,   191,    -1,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,    -1,   204,
     205,    -1,   207,   208,   209,   210,   211,    -1,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,    -1,   250,    -1,    -1,   253,   254,
     255,    -1,    -1,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,    -1,   272,   273,   274,
     275,   276,   277,   278,    -1,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,    -1,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
      -1,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,    -1,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
      -1,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,    -1,   348,   349,    -1,   351,   352,   353,   354,
     355,   356,    -1,   358,   359,    -1,    -1,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,    -1,
     375,   376,   377,   378,   379,   380,   381,    -1,   383,   384,
     385,   386,   387,   388,   389,    -1,   391,   392,   393,   394,
     395,   396,    -1,    -1,   399,    -1,    -1,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   428,   429,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   437,     3,     4,     5,     6,     7,     8,     9,
      10,    -1,    -1,    -1,    14,    15,    16,    17,    18,    19,
      20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,
      30,    31,    -1,    -1,    34,    35,    -1,    37,    38,    39,
      40,    41,    42,    43,    44,    45,    46,    47,    -1,    49,
      50,    51,    52,    53,    54,    55,    56,    57,    58,    59,
      60,    -1,    62,    63,    64,    65,    66,    -1,    68,    -1,
      70,    71,    72,    73,    74,    75,    76,    -1,    78,    79,
      80,    81,    82,    83,    -1,    85,    86,    87,    88,    89,
      90,    91,    92,    93,    94,    95,    96,    97,    98,    99,
     100,   101,   102,   103,    -1,   105,    -1,   107,   108,   109,
     110,   111,    -1,   113,   114,   115,    -1,    -1,   118,   119,
     120,   121,   122,    -1,   124,   125,   126,    -1,   128,   129,
     130,    -1,   132,   133,   134,   135,   136,   137,   138,   139,
     140,   141,   142,    -1,   144,   145,   146,   147,    -1,   149,
      -1,   151,   152,    -1,   154,   155,   156,   157,    -1,   159,
     160,    -1,   162,    -1,   164,   165,   166,   167,   168,   169,
     170,   171,   172,    -1,   174,   175,   176,   177,   178,   179,
      -1,   181,   182,   183,   184,   185,   186,   187,   188,   189,
      -1,   191,    -1,   193,   194,   195,   196,   197,   198,   199,
     200,   201,   202,    -1,   204,   205,    -1,   207,   208,   209,
     210,   211,    -1,   213,   214,   215,   216,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,   246,   247,   248,    -1,
     250,    -1,    -1,   253,   254,   255,    -1,    -1,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,    -1,   272,   273,   274,   275,   276,   277,   278,    -1,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,   292,    -1,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,   304,    -1,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
      -1,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,    -1,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,    -1,   348,   349,
      -1,   351,   352,   353,   354,   355,   356,    -1,   358,   359,
      -1,    -1,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,    -1,   375,   376,   377,   378,   379,
     380,   381,    -1,   383,   384,   385,   386,   387,   388,   389,
      -1,   391,   392,   393,   394,   395,   396,    -1,    -1,   399,
      -1,    -1,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   428,   429,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   437,     3,     4,
       5,     6,     7,     8,     9,    10,    -1,    -1,    -1,    14,
      15,    16,    17,    18,    19,    20,    21,    -1,    23,    24,
      25,    -1,    -1,    -1,    -1,    30,    31,    -1,    -1,    34,
      35,    -1,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    -1,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    -1,    62,    63,    64,
      65,    66,    -1,    68,    -1,    70,    71,    72,    73,    74,
      75,    76,    -1,    78,    79,    80,    81,    82,    83,    -1,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,    -1,
     105,    -1,   107,   108,   109,   110,   111,    -1,   113,   114,
     115,    -1,    -1,   118,   119,   120,   121,   122,    -1,   124,
     125,   126,    -1,   128,   129,   130,    -1,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,    -1,   144,
     145,   146,   147,    -1,   149,    -1,   151,   152,    -1,   154,
     155,   156,   157,    -1,   159,   160,    -1,   162,    -1,   164,
     165,   166,   167,   168,   169,   170,   171,   172,    -1,   174,
     175,   176,   177,   178,   179,    -1,   181,   182,   183,   184,
     185,   186,   187,   188,   189,    -1,   191,    -1,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,    -1,   204,
     205,    -1,   207,   208,   209,   210,   211,    -1,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,    -1,   250,    -1,    -1,   253,   254,
     255,    -1,    -1,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,    -1,   272,   273,   274,
     275,   276,   277,   278,    -1,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,    -1,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
      -1,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,    -1,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
      -1,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,    -1,   348,   349,    -1,   351,   352,   353,   354,
     355,   356,    -1,   358,   359,    -1,    -1,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,    -1,
     375,   376,   377,   378,   379,   380,   381,    -1,   383,   384,
     385,   386,   387,   388,   389,    -1,   391,   392,   393,   394,
     395,   396,    -1,    -1,   399,    -1,    -1,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   428,   429,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   437,     3,     4,     5,     6,     7,     8,     9,
      10,    -1,    -1,    -1,    14,    15,    16,    17,    18,    19,
      20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,
      30,    31,    -1,    -1,    34,    35,    -1,    37,    38,    39,
      40,    41,    42,    43,    44,    45,    46,    47,    -1,    49,
      50,    51,    52,    53,    54,    55,    56,    57,    58,    59,
      60,    -1,    62,    63,    64,    65,    66,    -1,    68,    -1,
      70,    71,    72,    73,    74,    75,    76,    -1,    78,    79,
      80,    81,    82,    83,    -1,    85,    86,    87,    88,    89,
      90,    91,    92,    93,    94,    95,    96,    97,    98,    99,
     100,   101,   102,   103,    -1,   105,    -1,   107,   108,   109,
     110,   111,    -1,   113,   114,   115,    -1,    -1,   118,   119,
     120,   121,   122,    -1,   124,   125,   126,    -1,   128,   129,
     130,    -1,   132,   133,   134,   135,   136,   137,   138,   139,
     140,   141,   142,    -1,   144,   145,   146,   147,    -1,   149,
      -1,   151,   152,    -1,   154,   155,   156,   157,    -1,   159,
     160,    -1,   162,    -1,   164,   165,   166,   167,   168,   169,
     170,   171,   172,    -1,   174,   175,   176,   177,   178,   179,
      -1,   181,   182,   183,   184,   185,   186,   187,   188,   189,
      -1,   191,    -1,   193,   194,   195,   196,   197,   198,   199,
     200,   201,   202,    -1,   204,   205,    -1,   207,   208,   209,
     210,   211,    -1,   213,   214,   215,   216,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,   246,   247,   248,    -1,
     250,    -1,    -1,   253,   254,   255,    -1,    -1,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,    -1,   272,   273,   274,   275,   276,   277,   278,    -1,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,   292,    -1,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,   304,    -1,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
      -1,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,    -1,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,    -1,   348,   349,
      -1,   351,   352,   353,   354,   355,   356,    -1,   358,   359,
      -1,    -1,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,    -1,   375,   376,   377,   378,   379,
     380,   381,    -1,   383,   384,   385,   386,   387,   388,   389,
      -1,   391,   392,   393,   394,   395,   396,    -1,    -1,   399,
      -1,    -1,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   428,   429,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   437,     3,     4,
       5,     6,     7,     8,     9,    10,    -1,    -1,    -1,    14,
      15,    16,    17,    18,    19,    20,    21,    -1,    23,    24,
      25,    -1,    -1,    -1,    -1,    30,    31,    -1,    -1,    34,
      35,    -1,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    -1,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    -1,    62,    63,    64,
      65,    66,    -1,    68,    -1,    70,    71,    72,    73,    74,
      75,    76,    -1,    78,    79,    80,    81,    82,    83,    -1,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,    -1,
     105,    -1,   107,   108,   109,   110,   111,    -1,   113,   114,
     115,    -1,    -1,   118,   119,   120,   121,   122,    -1,   124,
     125,   126,    -1,   128,   129,   130,    -1,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,    -1,   144,
     145,   146,   147,    -1,   149,    -1,   151,   152,    -1,   154,
     155,   156,   157,    -1,   159,   160,    -1,   162,    -1,   164,
     165,   166,   167,   168,   169,   170,   171,   172,    -1,   174,
     175,   176,   177,   178,   179,    -1,   181,   182,   183,   184,
     185,   186,   187,   188,   189,    -1,   191,    -1,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,    -1,   204,
     205,    -1,   207,   208,   209,   210,   211,    -1,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,    -1,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,    -1,   250,    -1,    -1,   253,   254,
     255,    -1,    -1,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,    -1,   272,   273,   274,
     275,   276,   277,   278,    -1,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,    -1,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
      -1,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,    -1,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
      -1,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,    -1,   348,   349,    -1,   351,   352,   353,   354,
     355,   356,    -1,   358,   359,    -1,    -1,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,    -1,
      -1,   376,   377,   378,   379,   380,   381,    -1,   383,   384,
     385,   386,   387,   388,   389,    -1,   391,   392,   393,   394,
     395,   396,    -1,    -1,   399,    -1,    -1,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   428,   429,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   437,     3,     4,     5,     6,     7,     8,     9,
      10,    -1,    -1,    -1,    14,    15,    16,    17,    18,    19,
      20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,
      30,    31,    -1,    -1,    34,    35,    -1,    37,    38,    39,
      40,    41,    42,    43,    44,    45,    46,    47,    -1,    49,
      50,    51,    52,    53,    54,    55,    56,    57,    58,    59,
      60,    -1,    62,    63,    64,    65,    66,    -1,    68,    -1,
      70,    71,    72,    73,    74,    75,    76,    -1,    78,    79,
      80,    81,    82,    83,    -1,    85,    86,    87,    88,    89,
      90,    91,    92,    93,    94,    95,    96,    97,    98,    99,
     100,   101,   102,   103,    -1,   105,    -1,   107,   108,   109,
     110,   111,    -1,   113,   114,   115,    -1,    -1,   118,   119,
     120,   121,   122,    -1,   124,   125,   126,    -1,   128,   129,
     130,    -1,   132,   133,   134,   135,   136,   137,   138,   139,
     140,   141,   142,    -1,   144,   145,   146,   147,    -1,   149,
      -1,   151,   152,    -1,   154,   155,   156,   157,    -1,   159,
     160,    -1,   162,    -1,   164,   165,   166,   167,   168,    -1,
     170,   171,   172,    -1,   174,   175,   176,   177,   178,   179,
      -1,   181,   182,   183,   184,   185,   186,   187,   188,   189,
      -1,   191,    -1,   193,   194,   195,   196,   197,   198,   199,
     200,   201,   202,    -1,   204,   205,    -1,   207,   208,   209,
     210,    -1,    -1,   213,   214,   215,   216,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,    -1,   238,   239,
     240,   241,   242,   243,   244,   245,   246,   247,   248,    -1,
     250,    -1,    -1,   253,   254,   255,    -1,    -1,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,    -1,   272,   273,   274,   275,   276,   277,   278,    -1,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,   292,    -1,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,   304,    -1,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
      -1,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,    -1,   332,   333,   334,    -1,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,    -1,   348,   349,
      -1,   351,   352,   353,   354,   355,   356,    -1,   358,   359,
      -1,    -1,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,    -1,   375,   376,   377,   378,   379,
     380,   381,    -1,   383,   384,   385,   386,   387,   388,   389,
      -1,   391,   392,   393,   394,   395,   396,    -1,    -1,   399,
      -1,    -1,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   428,   429,
      -1,    -1,     3,     4,     5,     6,     7,   437,     9,    10,
      -1,    -1,    -1,    14,    15,    16,    17,    18,    19,    20,
      21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,    30,
      31,    -1,    -1,    34,    35,    -1,    37,    38,    39,    40,
      41,    42,    43,    44,    45,    46,    47,    -1,    49,    50,
      51,    52,    53,    54,    55,    56,    57,    58,    59,    60,
      -1,    62,    63,    64,    65,    66,    -1,    68,    -1,    70,
      71,    72,    73,    74,    75,    76,    -1,    78,    79,    80,
      81,    82,    83,    -1,    85,    86,    87,    88,    89,    90,
      91,    92,    93,    94,    95,    96,    97,    98,    99,   100,
     101,   102,   103,    -1,   105,    -1,   107,   108,   109,   110,
     111,    -1,   113,   114,   115,    -1,    -1,   118,   119,   120,
     121,   122,    -1,   124,   125,   126,    -1,   128,   129,   130,
      -1,   132,   133,   134,   135,   136,   137,   138,   139,   140,
     141,   142,    -1,   144,   145,   146,   147,    -1,   149,    -1,
     151,   152,    -1,   154,   155,   156,   157,    -1,   159,   160,
      -1,   162,    -1,   164,   165,   166,   167,   168,   169,   170,
     171,   172,    -1,   174,   175,   176,   177,   178,   179,    -1,
     181,   182,   183,   184,   185,   186,   187,   188,   189,    -1,
     191,    -1,   193,   194,   195,   196,   197,   198,   199,   200,
     201,   202,    -1,   204,   205,    -1,   207,   208,   209,   210,
     211,    -1,   213,   214,   215,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,    -1,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,    -1,   250,
      -1,    -1,   253,   254,   255,    -1,    -1,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
      -1,   272,   273,   274,   275,   276,   277,   278,    -1,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,   292,    -1,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,   304,    -1,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,   319,    -1,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,   334,    -1,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,   346,    -1,   348,   349,    -1,
     351,   352,   353,   354,   355,   356,    -1,   358,   359,    -1,
      -1,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,    -1,    -1,   376,   377,   378,   379,   380,
     381,    -1,   383,   384,   385,   386,   387,   388,   389,    -1,
     391,   392,   393,   394,   395,   396,    -1,    -1,   399,    -1,
      -1,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,   419,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,     3,     4,     5,     6,
       7,    -1,     9,    10,    -1,    -1,   437,    14,    15,    16,
      17,    18,    19,    20,    21,    -1,    23,    24,    25,    -1,
      -1,    -1,    -1,    30,    31,    -1,    -1,    34,    35,    -1,
      37,    38,    39,    40,    41,    42,    43,    44,    45,    46,
      47,    -1,    49,    50,    51,    52,    53,    54,    55,    56,
      57,    58,    59,    60,    -1,    62,    63,    64,    65,    66,
      -1,    68,    -1,    70,    71,    72,    73,    74,    75,    76,
      -1,    78,    79,    80,    81,    82,    83,    -1,    85,    86,
      87,    88,    89,    90,    91,    92,    93,    94,    95,    96,
      97,    98,    99,   100,   101,   102,   103,    -1,   105,    -1,
     107,   108,   109,   110,   111,    -1,   113,   114,   115,    -1,
      -1,   118,   119,   120,   121,   122,    -1,   124,   125,   126,
      -1,   128,   129,   130,    -1,   132,   133,   134,   135,   136,
     137,   138,   139,   140,   141,   142,    -1,   144,   145,   146,
     147,    -1,   149,    -1,   151,   152,    -1,   154,   155,   156,
     157,    -1,   159,   160,    -1,   162,    -1,   164,   165,   166,
     167,   168,   169,   170,   171,   172,    -1,   174,   175,   176,
     177,   178,   179,    -1,   181,   182,   183,   184,   185,   186,
     187,   188,   189,    -1,   191,    -1,   193,   194,   195,   196,
     197,   198,   199,   200,   201,   202,    -1,   204,   205,    -1,
     207,   208,   209,   210,   211,    -1,   213,   214,   215,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
      -1,   238,   239,   240,   241,   242,   243,   244,   245,   246,
     247,   248,    -1,   250,    -1,    -1,   253,   254,   255,    -1,
      -1,   258,   259,   260,   261,   262,   263,   264,   265,   266,
     267,   268,   269,   270,    -1,   272,   273,   274,   275,   276,
     277,   278,    -1,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,   292,    -1,   294,   295,   296,
     297,   298,   299,   300,   301,   302,   303,   304,    -1,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,    -1,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,   333,   334,    -1,   336,
     337,   338,   339,   340,   341,   342,   343,   344,   345,   346,
      -1,   348,   349,    -1,   351,   352,   353,   354,   355,   356,
      -1,   358,   359,    -1,    -1,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,   373,    -1,    -1,   376,
     377,   378,   379,   380,   381,    -1,   383,   384,   385,   386,
     387,   388,   389,    -1,   391,   392,   393,   394,   395,   396,
      -1,    -1,   399,    -1,    -1,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
       3,     4,     5,     6,     7,     8,     9,    10,    -1,    -1,
     437,    14,    15,    16,    17,    18,    19,    20,    21,    -1,
      23,    24,    25,    -1,    -1,    -1,    -1,    30,    31,    -1,
      -1,    34,    35,    -1,    37,    38,    39,    40,    41,    42,
      -1,    44,    45,    46,    47,    -1,    49,    50,    51,    52,
      53,    54,    55,    56,    57,    58,    59,    60,    -1,    62,
      63,    64,    65,    66,    -1,    68,    -1,    70,    71,    72,
      73,    74,    75,    76,    -1,    78,    79,    80,    81,    82,
      83,    -1,    85,    86,    87,    88,    89,    90,    91,    92,
      93,    94,    95,    96,    97,    98,    99,   100,   101,   102,
     103,    -1,   105,    -1,   107,   108,   109,   110,   111,    -1,
     113,   114,   115,    -1,    -1,   118,   119,   120,   121,   122,
      -1,   124,   125,   126,    -1,   128,    -1,   130,    -1,   132,
     133,   134,   135,   136,   137,   138,   139,   140,   141,   142,
      -1,   144,   145,   146,   147,    -1,   149,    -1,   151,   152,
      -1,   154,   155,   156,   157,    -1,   159,   160,    -1,   162,
      -1,   164,   165,   166,   167,   168,    -1,   170,   171,   172,
      -1,   174,   175,   176,   177,   178,   179,    -1,   181,   182,
     183,   184,   185,   186,   187,   188,   189,    -1,   191,    -1,
     193,   194,   195,   196,   197,   198,   199,   200,   201,   202,
      -1,   204,   205,    -1,   207,   208,   209,   210,    -1,    -1,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,    -1,   238,   239,   240,   241,   242,
     243,   244,   245,   246,   247,   248,    -1,   250,    -1,    -1,
     253,   254,   255,    -1,    -1,   258,   259,   260,   261,   262,
     263,   264,   265,   266,   267,   268,   269,   270,    -1,   272,
     273,   274,   275,   276,   277,   278,    -1,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,   292,
      -1,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,   304,    -1,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,   317,   318,   319,    -1,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,    -1,   332,
     333,   334,    -1,   336,   337,   338,   339,   340,   341,   342,
     343,   344,   345,   346,    -1,   348,   349,    -1,   351,   352,
     353,   354,   355,   356,    -1,   358,   359,    -1,    -1,   362,
     363,   364,   365,   366,   367,   368,   369,   370,   371,   372,
     373,    -1,   375,   376,   377,   378,   379,   380,   381,    -1,
     383,   384,   385,   386,   387,   388,   389,    -1,   391,   392,
     393,   394,   395,   396,    -1,    -1,   399,    -1,    -1,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   428,   429,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   437,     3,     4,     5,     6,     7,
       8,     9,    10,    -1,    -1,    -1,    14,    15,    16,    17,
      18,    19,    20,    21,    -1,    23,    24,    25,    -1,    -1,
      -1,    -1,    30,    31,    -1,    -1,    34,    35,    -1,    37,
      38,    39,    40,    41,    42,    -1,    44,    45,    46,    47,
      -1,    49,    50,    51,    52,    53,    54,    55,    56,    57,
      58,    59,    60,    -1,    62,    63,    64,    65,    66,    -1,
      68,    -1,    70,    71,    72,    73,    74,    75,    76,    -1,
      78,    79,    80,    81,    82,    83,    -1,    85,    86,    87,
      88,    89,    90,    91,    92,    93,    94,    95,    96,    97,
      98,    99,   100,   101,   102,   103,    -1,   105,    -1,   107,
     108,   109,   110,   111,    -1,   113,   114,   115,    -1,    -1,
     118,   119,   120,   121,   122,    -1,   124,   125,   126,    -1,
     128,    -1,   130,    -1,   132,   133,   134,   135,   136,   137,
     138,   139,   140,   141,   142,    -1,   144,   145,   146,   147,
      -1,   149,    -1,   151,   152,    -1,   154,   155,   156,   157,
      -1,   159,   160,    -1,   162,    -1,   164,   165,   166,   167,
     168,    -1,   170,   171,   172,    -1,   174,   175,   176,   177,
     178,   179,    -1,   181,   182,   183,   184,   185,   186,   187,
     188,   189,    -1,   191,    -1,   193,   194,   195,   196,   197,
     198,   199,   200,   201,   202,    -1,   204,   205,    -1,   207,
     208,   209,   210,    -1,    -1,   213,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,    -1,
     238,   239,   240,   241,   242,   243,   244,   245,   246,   247,
     248,    -1,   250,    -1,    -1,   253,   254,   255,    -1,    -1,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,    -1,   272,   273,   274,   275,   276,   277,
     278,    -1,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,   290,   291,   292,    -1,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,    -1,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,   316,   317,
     318,   319,    -1,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,    -1,   332,   333,   334,    -1,   336,   337,
     338,   339,   340,   341,   342,   343,   344,   345,   346,    -1,
     348,   349,    -1,   351,   352,   353,   354,   355,   356,    -1,
     358,   359,    -1,    -1,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,    -1,    -1,   376,   377,
     378,   379,   380,   381,    -1,   383,   384,   385,   386,   387,
     388,   389,    -1,   391,   392,   393,   394,   395,   396,    -1,
      -1,   399,    -1,    -1,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,    -1,    -1,    -1,    -1,    -1,    -1,    -1,     3,
     428,   429,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   437,
      14,    15,    16,    17,    18,    19,    20,    21,    -1,    23,
      24,    25,    -1,    -1,    -1,    -1,    30,    -1,    -1,    -1,
      34,    35,    -1,    37,    38,    39,    40,    41,    42,    43,
      44,    45,    46,    47,    -1,    49,    50,    51,    52,    53,
      -1,    55,    56,    57,    58,    59,    60,    -1,    62,    63,
      64,    65,    66,    -1,    68,    -1,    70,    71,    72,    73,
      74,    75,    76,    -1,    78,    79,    80,    81,    82,    83,
      -1,    85,    86,    87,    88,    89,    90,    91,    92,    93,
      94,    95,    96,    97,    98,    99,   100,   101,   102,   103,
      -1,   105,    -1,   107,   108,   109,   110,   111,    -1,   113,
     114,   115,    -1,    -1,   118,   119,   120,   121,   122,    -1,
     124,   125,   126,    -1,   128,   129,   130,    -1,   132,   133,
     134,   135,   136,   137,   138,   139,   140,    -1,   142,    -1,
     144,   145,   146,   147,    -1,   149,    -1,   151,   152,    -1,
     154,   155,   156,   157,    -1,   159,   160,    -1,   162,    -1,
     164,   165,   166,   167,   168,   169,   170,   171,   172,    -1,
     174,   175,   176,   177,   178,   179,    -1,   181,   182,   183,
     184,   185,   186,   187,   188,   189,    -1,   191,    -1,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
     204,   205,    -1,   207,   208,   209,   210,   211,    -1,   213,
     214,   215,   216,   217,   218,   219,   220,   221,   222,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,    -1,   238,   239,   240,   241,    -1,   243,
     244,   245,   246,   247,   248,    -1,   250,    -1,   252,   253,
     254,   255,    -1,    -1,   258,   259,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,    -1,   272,   273,
     274,   275,   276,   277,   278,    -1,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,   292,    -1,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
     304,    -1,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,    -1,   336,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,    -1,   348,   349,   350,   351,   352,   353,
     354,   355,   356,    -1,   358,   359,    -1,    -1,   362,   363,
     364,   365,    -1,   367,   368,   369,   370,   371,   372,   373,
      -1,    -1,   376,   377,   378,   379,   380,   381,    -1,   383,
     384,   385,   386,   387,   388,   389,    -1,   391,   392,   393,
     394,   395,   396,    -1,    -1,   399,    -1,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   437,    14,    15,    16,    17,    18,    19,
      20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,
      30,    -1,    -1,    -1,    34,    35,    -1,    37,    38,    39,
      40,    41,    42,    43,    44,    45,    46,    47,    -1,    49,
      50,    51,    52,    53,    -1,    55,    56,    57,    58,    59,
      60,    -1,    62,    63,    64,    65,    66,    -1,    68,    -1,
      70,    71,    72,    73,    74,    75,    76,    -1,    78,    79,
      80,    81,    82,    83,    -1,    85,    86,    87,    88,    89,
      90,    91,    92,    93,    94,    95,    96,    97,    98,    99,
     100,   101,   102,   103,    -1,   105,    -1,   107,   108,   109,
     110,   111,    -1,   113,   114,   115,    -1,    -1,   118,   119,
     120,   121,   122,    -1,   124,   125,   126,    -1,   128,   129,
     130,    -1,   132,   133,   134,   135,   136,   137,   138,   139,
     140,    -1,   142,    -1,   144,   145,   146,   147,    -1,   149,
      -1,   151,   152,    -1,   154,   155,   156,   157,    -1,   159,
     160,    -1,   162,    -1,   164,   165,   166,   167,   168,   169,
     170,   171,   172,    -1,   174,   175,   176,   177,   178,   179,
      -1,   181,   182,   183,   184,   185,   186,   187,   188,   189,
      -1,   191,    -1,   193,   194,   195,   196,   197,   198,   199,
     200,   201,   202,   203,   204,   205,    -1,   207,   208,   209,
     210,   211,    -1,   213,   214,   215,   216,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,    -1,   238,   239,
     240,   241,    -1,   243,   244,   245,   246,   247,   248,    -1,
     250,    -1,   252,   253,   254,   255,    -1,    -1,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,    -1,   272,   273,   274,   275,   276,   277,   278,    -1,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,   292,    -1,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,   304,    -1,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
      -1,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,    -1,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,    -1,   348,   349,
      -1,   351,   352,   353,   354,   355,   356,    -1,   358,   359,
      -1,    -1,   362,   363,   364,   365,    -1,   367,   368,   369,
     370,   371,   372,   373,    -1,    -1,   376,   377,   378,   379,
     380,   381,    -1,   383,   384,   385,   386,   387,   388,   389,
      -1,   391,   392,   393,   394,   395,   396,    -1,    -1,   399,
      -1,    -1,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   437,    14,    15,
      16,    17,    18,    19,    20,    21,    -1,    23,    24,    25,
      -1,    -1,    -1,    -1,    30,    -1,    -1,    -1,    34,    35,
      -1,    37,    38,    39,    40,    41,    42,    43,    44,    45,
      46,    47,    -1,    49,    50,    51,    52,    53,    -1,    55,
      56,    57,    58,    59,    60,    -1,    62,    63,    64,    65,
      66,    -1,    68,    -1,    70,    71,    72,    73,    74,    75,
      76,    -1,    78,    79,    80,    81,    82,    83,    -1,    85,
      86,    87,    88,    89,    90,    91,    92,    93,    94,    95,
      96,    97,    98,    99,   100,   101,   102,   103,    -1,   105,
      -1,   107,   108,   109,   110,   111,    -1,   113,   114,   115,
      -1,    -1,   118,   119,   120,   121,   122,    -1,   124,   125,
     126,    -1,   128,   129,   130,    -1,   132,   133,   134,   135,
     136,   137,   138,   139,   140,    -1,   142,    -1,   144,   145,
     146,   147,    -1,   149,    -1,   151,   152,    -1,   154,   155,
     156,   157,    -1,   159,   160,    -1,   162,    -1,   164,   165,
     166,   167,   168,   169,   170,   171,   172,    -1,   174,   175,
     176,   177,   178,   179,    -1,   181,   182,   183,   184,   185,
     186,   187,   188,   189,    -1,   191,    -1,   193,   194,   195,
     196,   197,   198,   199,   200,   201,   202,    -1,   204,   205,
      -1,   207,   208,   209,   210,   211,    -1,   213,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,    -1,   238,   239,   240,   241,    -1,   243,   244,   245,
     246,   247,   248,    -1,   250,    -1,    -1,   253,   254,   255,
      -1,    -1,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,    -1,   272,   273,   274,   275,
     276,   277,   278,    -1,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,   292,    -1,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,    -1,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,   319,    -1,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,    -1,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,    -1,   348,   349,    -1,   351,   352,   353,   354,   355,
     356,    -1,   358,   359,    -1,    -1,   362,   363,   364,   365,
      -1,   367,   368,   369,   370,   371,   372,   373,    -1,    -1,
     376,   377,   378,   379,   380,   381,    -1,   383,   384,   385,
     386,   387,   388,   389,    -1,   391,   392,   393,   394,   395,
     396,    -1,    -1,   399,    -1,    -1,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   437,    14,    15,    16,    17,    18,    19,    20,    21,
      -1,    23,    24,    25,    -1,    -1,    -1,    -1,    30,    -1,
      -1,    -1,    34,    35,    -1,    37,    38,    39,    40,    41,
      42,    43,    44,    45,    46,    47,    -1,    49,    50,    51,
      52,    53,    -1,    55,    56,    57,    58,    59,    60,    -1,
      62,    63,    64,    65,    66,    -1,    68,    -1,    70,    71,
      72,    73,    74,    75,    76,    -1,    78,    79,    80,    81,
      82,    83,    -1,    85,    86,    87,    88,    89,    90,    91,
      92,    93,    94,    95,    96,    97,    98,    99,   100,   101,
     102,   103,    -1,   105,    -1,   107,   108,   109,   110,   111,
      -1,   113,   114,   115,    -1,    -1,   118,   119,   120,   121,
     122,    -1,   124,   125,   126,    -1,   128,   129,   130,    -1,
     132,   133,   134,   135,   136,   137,   138,   139,   140,    -1,
     142,    -1,   144,   145,   146,   147,    -1,   149,    -1,   151,
     152,    -1,   154,   155,   156,   157,    -1,   159,   160,    -1,
     162,    -1,   164,   165,   166,   167,   168,   169,   170,   171,
     172,    -1,   174,   175,   176,   177,   178,   179,    -1,   181,
     182,   183,   184,   185,   186,   187,   188,   189,    -1,   191,
      -1,   193,   194,   195,   196,   197,   198,   199,   200,   201,
     202,    -1,   204,   205,    -1,   207,   208,   209,   210,   211,
      -1,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,    -1,   238,   239,   240,   241,
      -1,   243,   244,   245,   246,   247,   248,    -1,   250,    -1,
      -1,   253,   254,   255,    -1,    -1,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,    -1,
     272,   273,   274,   275,   276,   277,   278,    -1,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
     292,    -1,   294,   295,   296,   297,   298,   299,   300,   301,
     302,   303,   304,    -1,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,   316,   317,   318,   319,    -1,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,    -1,   336,   337,   338,   339,   340,   341,
     342,   343,   344,   345,   346,    -1,   348,   349,    -1,   351,
     352,   353,   354,   355,   356,    -1,   358,   359,    -1,    -1,
     362,   363,   364,   365,    -1,   367,   368,   369,   370,   371,
     372,   373,    -1,    -1,   376,   377,   378,   379,   380,   381,
      -1,   383,   384,   385,   386,   387,   388,   389,    -1,   391,
     392,   393,   394,   395,   396,    -1,    -1,   399,    -1,    -1,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,     3,     4,     5,    -1,    -1,
      -1,     9,    -1,    -1,    -1,   437,    14,    15,    16,    17,
      18,    19,    20,    21,    -1,    23,    24,    25,    -1,    -1,
      -1,    -1,    30,    -1,    -1,    -1,    34,    35,    -1,    37,
      38,    39,    40,    41,    42,    43,    44,    45,    46,    47,
      -1,    49,    50,    51,    52,    53,    -1,    -1,    56,    57,
      58,    59,    60,    -1,    62,    63,    64,    65,    66,    -1,
      68,    -1,    70,    71,    72,    73,    74,    75,    76,    -1,
      78,    79,    80,    81,    82,    83,    -1,    85,    86,    87,
      -1,    -1,    -1,    91,    -1,    -1,    -1,    95,    96,    97,
      98,    99,   100,   101,   102,   103,    -1,   105,    -1,   107,
     108,   109,   110,   111,    -1,   113,   114,   115,    -1,    -1,
     118,   119,   120,   121,   122,    -1,   124,   125,   126,    -1,
     128,   129,   130,    -1,   132,   133,   134,   135,   136,   137,
     138,   139,   140,   141,   142,    -1,   144,   145,   146,   147,
      -1,   149,    -1,   151,   152,    -1,   154,   155,   156,   157,
      -1,   159,   160,    -1,   162,    -1,   164,   165,   166,   167,
     168,   169,   170,   171,   172,    -1,   174,   175,   176,   177,
     178,   179,    -1,   181,   182,   183,   184,   185,   186,   187,
     188,   189,    -1,   191,    -1,   193,   194,   195,   196,   197,
     198,   199,   200,   201,   202,    -1,   204,   205,    -1,   207,
     208,   209,   210,   211,    -1,   213,   214,   215,    -1,    -1,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,    -1,
     238,   239,   240,   241,    -1,   243,   244,   245,   246,   247,
     248,    -1,   250,   251,    -1,   253,   254,   255,    -1,    -1,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,    -1,   272,   273,   274,   275,   276,   277,
     278,    -1,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,   290,   291,   292,    -1,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,    -1,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,   316,   317,
     318,   319,    -1,   321,   322,   323,   324,   325,    -1,   327,
     328,   329,   330,   331,   332,   333,   334,    -1,   336,   337,
     338,   339,   340,   341,   342,   343,   344,   345,   346,    -1,
     348,   349,    -1,   351,   352,   353,   354,   355,   356,    -1,
     358,   359,    -1,    -1,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,    -1,    -1,   376,   377,
     378,   379,   380,    -1,    -1,   383,   384,   385,   386,   387,
     388,   389,    -1,   391,   392,   393,   394,   395,   396,    -1,
      -1,   399,    -1,    -1,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,    -1,    -1,    -1,    -1,    -1,    -1,    -1,     3,
     428,   429,   430,    -1,    -1,    -1,    -1,    -1,    -1,   437,
      14,    15,    16,    17,    18,    19,    20,    21,    -1,    23,
      24,    25,    26,    27,    -1,    -1,    30,    -1,    -1,    -1,
      34,    35,    -1,    37,    38,    39,    40,    41,    42,    43,
      44,    45,    46,    47,    -1,    49,    50,    51,    52,    53,
      -1,    -1,    56,    57,    58,    59,    60,    -1,    62,    63,
      64,    65,    66,    -1,    68,    -1,    70,    71,    72,    73,
      74,    75,    76,    -1,    78,    79,    80,    81,    82,    83,
      -1,    85,    86,    87,    -1,    -1,    -1,    91,    -1,    -1,
      -1,    95,    96,    97,    98,    99,   100,   101,   102,   103,
      -1,   105,    -1,   107,   108,   109,   110,   111,    -1,   113,
     114,   115,    -1,    -1,   118,   119,   120,   121,   122,    -1,
     124,   125,   126,    -1,   128,   129,   130,    -1,   132,   133,
     134,   135,   136,   137,   138,   139,   140,    -1,   142,    -1,
     144,   145,   146,   147,    -1,   149,    -1,   151,   152,    -1,
     154,   155,   156,   157,    -1,   159,   160,    -1,   162,    -1,
     164,   165,   166,   167,   168,   169,   170,   171,   172,    -1,
     174,   175,   176,   177,   178,   179,    -1,   181,   182,   183,
     184,   185,   186,   187,   188,   189,    -1,   191,    -1,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,    -1,
     204,   205,    -1,   207,   208,   209,   210,   211,    -1,   213,
     214,   215,    -1,    -1,   218,   219,   220,   221,   222,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,    -1,   238,   239,   240,   241,    -1,   243,
     244,   245,   246,   247,   248,    -1,   250,    -1,    -1,   253,
     254,   255,    -1,    -1,   258,   259,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,    -1,   272,   273,
     274,   275,   276,   277,   278,    -1,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,   292,    -1,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
     304,    -1,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,   319,   320,   321,   322,   323,
     324,   325,    -1,   327,   328,   329,   330,   331,   332,   333,
     334,    -1,   336,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,    -1,   348,   349,   350,   351,   352,   353,
     354,   355,   356,    -1,   358,   359,    -1,    -1,   362,   363,
     364,   365,    -1,   367,   368,   369,   370,   371,   372,   373,
      -1,    -1,   376,   377,   378,   379,   380,    -1,    -1,   383,
     384,   385,   386,   387,   388,   389,    -1,   391,   392,   393,
     394,   395,   396,    -1,    -1,   399,    -1,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   437,    14,    15,    16,    17,    18,    19,
      20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,
      30,    -1,    -1,    -1,    34,    35,    -1,    37,    38,    39,
      40,    41,    42,    43,    44,    45,    46,    47,    -1,    49,
      50,    51,    52,    53,    -1,    -1,    56,    57,    58,    59,
      60,    -1,    62,    63,    64,    65,    66,    -1,    68,    -1,
      70,    71,    72,    73,    74,    75,    76,    -1,    78,    79,
      80,    81,    82,    83,    -1,    85,    86,    87,    -1,    -1,
      -1,    91,    -1,    -1,    -1,    95,    96,    97,    98,    99,
     100,   101,   102,   103,    -1,   105,    -1,   107,   108,   109,
     110,   111,    -1,   113,   114,   115,    -1,    -1,   118,   119,
     120,   121,   122,    -1,   124,   125,   126,    -1,   128,   129,
     130,    -1,   132,   133,   134,   135,   136,   137,   138,   139,
     140,    -1,   142,    -1,   144,   145,   146,   147,    -1,   149,
      -1,   151,   152,    -1,   154,   155,   156,   157,    -1,   159,
     160,    -1,   162,    -1,   164,   165,   166,   167,   168,   169,
     170,   171,   172,    -1,   174,   175,   176,   177,   178,   179,
      -1,   181,   182,   183,   184,   185,   186,   187,   188,   189,
      -1,   191,    -1,   193,   194,   195,   196,   197,   198,   199,
     200,   201,   202,    -1,   204,   205,    -1,   207,   208,   209,
     210,   211,    -1,   213,   214,   215,    -1,    -1,   218,   219,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,    -1,   238,   239,
     240,   241,    -1,   243,   244,   245,   246,   247,   248,    -1,
     250,    -1,    -1,   253,   254,   255,    -1,    -1,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,    -1,   272,   273,   274,   275,   276,   277,   278,    -1,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,   292,    -1,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,   304,    -1,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
      -1,   321,   322,   323,   324,   325,    -1,   327,   328,   329,
     330,   331,   332,   333,   334,    -1,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,    -1,   348,   349,
      -1,   351,   352,   353,   354,   355,   356,    -1,   358,   359,
      -1,    -1,   362,   363,   364,   365,    -1,   367,   368,   369,
     370,   371,   372,   373,    -1,    -1,   376,   377,   378,   379,
     380,    -1,    -1,   383,   384,   385,   386,   387,   388,   389,
      -1,   391,   392,   393,   394,   395,   396,    -1,    -1,   399,
      -1,    -1,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   437,    14,    15,
      16,    17,    18,    19,    20,    21,    -1,    23,    24,    25,
      -1,    -1,    -1,    -1,    30,    -1,    -1,    -1,    34,    35,
      -1,    37,    38,    -1,    40,    41,    42,    43,    44,    -1,
      46,    47,    -1,    49,    50,    51,    52,    53,    -1,    -1,
      56,    57,    58,    59,    60,    -1,    62,    63,    64,    65,
      66,    -1,    -1,    -1,    70,    71,    72,    73,    -1,    75,
      76,    -1,    78,    79,    80,    81,    82,    83,    -1,    -1,
      86,    87,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    95,
      96,    97,    98,    99,   100,   101,   102,   103,    -1,   105,
      -1,   107,   108,   109,   110,   111,    -1,   113,   114,   115,
      -1,    -1,   118,   119,   120,   121,   122,    -1,   124,   125,
     126,    -1,   128,   129,   130,    -1,   132,   133,   134,   135,
     136,   137,   138,   139,   140,    -1,   142,    -1,   144,   145,
     146,   147,    -1,   149,    -1,   151,    -1,    -1,    -1,   155,
     156,   157,    -1,   159,   160,    -1,   162,    -1,   164,   165,
     166,   167,   168,    -1,   170,   171,   172,    -1,   174,   175,
     176,   177,   178,   179,    -1,   181,    -1,   183,   184,   185,
     186,   187,   188,   189,    -1,   191,    -1,   193,    -1,    -1,
     196,    -1,   198,   199,   200,   201,   202,    -1,   204,   205,
      -1,   207,   208,    -1,   210,    -1,    -1,   213,   214,   215,
      -1,    -1,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,    -1,   233,   234,   235,
     236,    -1,   238,   239,    -1,   241,    -1,   243,   244,   245,
     246,   247,   248,    -1,   250,    -1,    -1,   253,   254,   255,
      -1,    -1,   258,   259,    -1,   261,    -1,   263,   264,   265,
     266,   267,   268,   269,   270,    -1,   272,   273,   274,   275,
     276,   277,   278,    -1,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,   292,    -1,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,    -1,
     306,   307,    -1,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,   319,   320,   321,   322,   323,   324,   325,
      -1,   327,   328,   329,   330,    -1,   332,   333,   334,    -1,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,    -1,   348,   349,   350,   351,   352,   353,   354,   355,
     356,    -1,   358,   359,    -1,    -1,   362,   363,   364,   365,
      -1,   367,   368,   369,   370,   371,   372,   373,    -1,    -1,
     376,   377,   378,   379,   380,    -1,    -1,   383,   384,   385,
     386,   387,   388,   389,    -1,   391,    -1,   393,   394,   395,
     396,    -1,    -1,   399,    -1,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   437,    14,    15,    16,    17,    18,    19,    20,    21,
      -1,    23,    24,    25,    -1,    -1,    -1,    -1,    30,    -1,
      -1,    -1,    34,    35,    -1,    37,    38,    -1,    40,    41,
      42,    43,    44,    -1,    46,    47,    -1,    49,    50,    51,
      52,    53,    -1,    -1,    56,    57,    58,    59,    60,    -1,
      62,    63,    64,    65,    66,    -1,    -1,    -1,    70,    71,
      72,    73,    -1,    75,    76,    -1,    78,    79,    80,    81,
      82,    83,    -1,    -1,    86,    87,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    95,    96,    97,    98,    99,   100,   101,
     102,   103,    -1,   105,    -1,   107,   108,   109,   110,   111,
      -1,   113,   114,   115,    -1,    -1,   118,   119,   120,   121,
     122,    -1,   124,   125,   126,    -1,   128,   129,   130,    -1,
     132,   133,   134,   135,   136,   137,   138,   139,   140,    -1,
     142,    -1,   144,   145,   146,   147,    -1,   149,    -1,   151,
      -1,    -1,    -1,   155,   156,   157,    -1,   159,   160,    -1,
     162,    -1,   164,   165,   166,   167,   168,    -1,   170,   171,
     172,    -1,   174,   175,   176,   177,   178,   179,    -1,   181,
      -1,   183,   184,   185,   186,   187,   188,   189,    -1,   191,
      -1,   193,    -1,    -1,   196,    -1,   198,   199,   200,   201,
     202,    -1,   204,   205,    -1,   207,   208,    -1,   210,    -1,
      -1,   213,   214,   215,    -1,    -1,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
      -1,   233,   234,   235,   236,    -1,   238,   239,    -1,   241,
      -1,   243,   244,   245,   246,   247,   248,    -1,   250,    -1,
      -1,   253,   254,   255,    -1,    -1,   258,   259,    -1,   261,
      -1,   263,   264,   265,   266,   267,   268,   269,   270,    -1,
     272,   273,   274,   275,   276,   277,   278,    -1,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
     292,    -1,   294,   295,   296,   297,   298,   299,   300,   301,
     302,   303,   304,    -1,   306,   307,    -1,   309,   310,   311,
     312,   313,   314,   315,   316,   317,   318,   319,    -1,   321,
     322,   323,   324,   325,    -1,   327,   328,   329,   330,    -1,
     332,   333,   334,    -1,   336,   337,   338,   339,   340,   341,
     342,   343,   344,   345,   346,    -1,   348,   349,    -1,   351,
     352,   353,   354,   355,   356,    -1,   358,   359,    -1,    -1,
     362,   363,   364,   365,    -1,   367,   368,   369,   370,   371,
     372,   373,    -1,    -1,   376,   377,   378,   379,   380,    -1,
      -1,   383,   384,   385,   386,   387,   388,   389,    -1,   391,
      -1,   393,   394,   395,   396,    -1,    -1,   399,    -1,    -1,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   437,    14,    15,    16,    17,
      18,    19,    20,    21,    -1,    23,    24,    25,    -1,    -1,
      -1,    -1,    30,    -1,    -1,    -1,    34,    35,    -1,    37,
      38,    -1,    40,    41,    42,    43,    44,    -1,    46,    47,
      -1,    49,    50,    51,    52,    53,    -1,    -1,    56,    57,
      58,    59,    60,    -1,    62,    63,    64,    65,    66,    -1,
      -1,    -1,    70,    71,    72,    73,    -1,    75,    76,    -1,
      78,    79,    80,    81,    82,    83,    -1,    -1,    86,    87,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    95,    96,    97,
      98,    99,   100,   101,   102,   103,    -1,   105,    -1,   107,
     108,   109,   110,   111,    -1,   113,   114,   115,    -1,    -1,
     118,   119,   120,   121,   122,    -1,   124,   125,   126,    -1,
     128,   129,   130,    -1,   132,   133,   134,   135,   136,   137,
     138,   139,   140,    -1,   142,    -1,   144,   145,   146,   147,
      -1,   149,    -1,   151,    -1,    -1,    -1,   155,   156,   157,
      -1,   159,   160,    -1,   162,    -1,   164,   165,   166,   167,
     168,    -1,   170,   171,   172,    -1,   174,   175,   176,   177,
     178,   179,    -1,   181,    -1,   183,   184,   185,   186,   187,
     188,   189,    -1,   191,    -1,   193,    -1,    -1,   196,    -1,
     198,   199,   200,   201,   202,    -1,   204,   205,    -1,   207,
     208,    -1,   210,    -1,    -1,   213,   214,   215,    -1,    -1,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,    -1,   233,   234,   235,   236,    -1,
     238,   239,    -1,   241,    -1,   243,   244,   245,   246,   247,
     248,    -1,   250,    -1,    -1,   253,   254,   255,    -1,    -1,
     258,   259,    -1,   261,    -1,   263,   264,   265,   266,   267,
     268,   269,   270,    -1,   272,   273,   274,   275,   276,   277,
     278,    -1,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,   290,   291,   292,    -1,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,    -1,   306,   307,
      -1,   309,   310,   311,   312,   313,   314,   315,   316,   317,
     318,   319,    -1,   321,   322,   323,   324,   325,    -1,   327,
     328,   329,   330,    -1,   332,   333,   334,    -1,   336,   337,
     338,   339,   340,   341,   342,   343,   344,   345,   346,    -1,
     348,   349,    -1,   351,   352,   353,   354,   355,   356,    -1,
     358,   359,    -1,    -1,   362,   363,   364,   365,    -1,   367,
     368,   369,   370,   371,   372,   373,    -1,    -1,   376,   377,
     378,   379,   380,    -1,    -1,   383,   384,   385,   386,   387,
     388,   389,    -1,   391,    -1,   393,   394,   395,   396,    -1,
      -1,   399,    -1,    -1,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,    -1,    -1,    -1,    -1,    -1,    -1,    -1,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   437,
      14,    15,    16,    17,    18,    19,    20,    21,    -1,    23,
      24,    25,    -1,    -1,    -1,    -1,    30,    -1,    -1,    -1,
      34,    35,    -1,    37,    38,    -1,    40,    41,    42,    43,
      44,    -1,    46,    47,    -1,    49,    50,    51,    52,    53,
      -1,    -1,    56,    57,    58,    59,    60,    -1,    62,    63,
      64,    65,    66,    -1,    -1,    -1,    70,    71,    72,    73,
      -1,    75,    76,    -1,    78,    79,    80,    81,    82,    83,
      -1,    -1,    86,    87,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    95,    96,    97,    98,    99,   100,   101,   102,   103,
      -1,   105,    -1,   107,   108,   109,   110,   111,    -1,   113,
     114,   115,    -1,    -1,   118,   119,   120,   121,   122,    -1,
     124,   125,   126,    -1,   128,   129,   130,    -1,   132,   133,
     134,   135,   136,   137,   138,   139,   140,    -1,   142,    -1,
     144,   145,   146,   147,    -1,   149,    -1,   151,    -1,    -1,
      -1,   155,   156,   157,    -1,   159,   160,    -1,   162,    -1,
     164,   165,   166,   167,   168,    -1,   170,   171,   172,    -1,
     174,   175,   176,   177,   178,   179,    -1,   181,    -1,   183,
     184,   185,   186,   187,   188,   189,    -1,   191,    -1,   193,
      -1,    -1,   196,    -1,   198,   199,   200,   201,   202,    -1,
     204,   205,    -1,   207,   208,    -1,   210,    -1,    -1,   213,
     214,   215,    -1,    -1,   218,   219,   220,   221,   222,   223,
     224,   225,   226,   227,   228,   229,   230,   231,    -1,   233,
     234,   235,   236,    -1,   238,   239,    -1,   241,    -1,   243,
     244,   245,   246,   247,   248,    -1,   250,    -1,    -1,   253,
     254,   255,    -1,    -1,   258,   259,    -1,   261,    -1,   263,
     264,   265,   266,   267,   268,   269,   270,    -1,   272,   273,
     274,   275,   276,   277,   278,    -1,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,   292,    -1,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
     304,    -1,   306,   307,    -1,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,   319,    -1,   321,   322,   323,
     324,   325,    -1,   327,   328,   329,   330,    -1,   332,   333,
     334,    -1,   336,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,    -1,   348,   349,    -1,   351,   352,   353,
     354,   355,   356,    -1,   358,   359,    -1,    -1,   362,   363,
     364,   365,    -1,   367,   368,   369,   370,   371,   372,   373,
      -1,    -1,   376,   377,   378,   379,   380,    -1,    -1,   383,
     384,   385,   386,   387,   388,   389,    -1,   391,    -1,   393,
     394,   395,   396,    -1,    -1,   399,    -1,    -1,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   437,    14,    15,    16,    17,    18,    19,
      20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,
      30,    -1,    -1,    -1,    34,    35,    -1,    37,    38,    -1,
      40,    41,    42,    43,    44,    -1,    46,    47,    -1,    49,
      50,    51,    52,    53,    -1,    -1,    56,    57,    58,    59,
      60,    -1,    62,    63,    64,    65,    66,    -1,    -1,    -1,
      70,    71,    72,    73,    -1,    75,    76,    -1,    78,    79,
      80,    81,    82,    83,    -1,    -1,    86,    87,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    95,    96,    97,    98,    99,
     100,   101,   102,   103,    -1,   105,    -1,   107,   108,   109,
     110,   111,    -1,   113,   114,   115,    -1,    -1,   118,   119,
     120,   121,   122,    -1,   124,   125,   126,    -1,   128,   129,
     130,    -1,   132,   133,   134,   135,   136,   137,   138,   139,
     140,    -1,   142,    -1,   144,   145,   146,   147,    -1,   149,
      -1,   151,    -1,    -1,    -1,   155,   156,   157,    -1,   159,
     160,    -1,   162,    -1,   164,   165,   166,   167,   168,    -1,
     170,   171,   172,    -1,   174,   175,   176,   177,   178,   179,
      -1,   181,    -1,   183,   184,   185,   186,   187,   188,   189,
      -1,   191,    -1,   193,    -1,    -1,   196,    -1,   198,   199,
     200,   201,   202,    -1,   204,   205,    -1,   207,   208,    -1,
     210,    -1,    -1,   213,   214,   215,    -1,    -1,   218,   219,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,    -1,   233,   234,   235,   236,    -1,   238,   239,
      -1,   241,    -1,   243,   244,   245,   246,   247,   248,    -1,
     250,    -1,    -1,   253,   254,   255,    -1,    -1,   258,   259,
      -1,   261,    -1,   263,   264,   265,   266,   267,   268,   269,
     270,    -1,   272,   273,   274,   275,   276,   277,   278,    -1,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,   292,    -1,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,   304,    -1,   306,   307,    -1,   309,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
      -1,   321,   322,   323,   324,   325,    -1,   327,   328,   329,
     330,    -1,   332,   333,   334,    -1,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,    -1,   348,   349,
      -1,   351,   352,   353,   354,   355,   356,    -1,   358,   359,
      -1,    -1,   362,   363,   364,   365,    -1,   367,   368,   369,
     370,   371,   372,   373,    -1,    -1,   376,   377,   378,   379,
     380,    -1,    -1,   383,   384,   385,   386,   387,   388,   389,
      -1,   391,    -1,   393,   394,   395,   396,    -1,    -1,   399,
      -1,    -1,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,     3,     4,     5,
      -1,    -1,     8,     9,    -1,    -1,    -1,   437,    14,    15,
      16,    17,    18,    19,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    31,    32,    33,    34,    35,
      36,    37,    38,    39,    40,    41,    42,    -1,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    57,    58,    59,    60,    61,    62,    63,    64,    65,
      -1,    67,    68,    69,    70,    71,    72,    73,    74,    75,
      76,    77,    78,    79,    80,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    90,    91,    92,    93,    94,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   118,   119,   120,   121,   122,   123,   124,   125,
     126,   127,   128,   129,   130,   131,   132,   133,   134,   135,
      -1,   137,   138,   139,    -1,   141,   142,   143,   144,   145,
     146,   147,   148,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,   159,    -1,   161,   162,   163,   164,   165,
     166,   167,   168,   169,   170,   171,   172,   173,   174,   175,
     176,   177,   178,   179,   180,   181,   182,    -1,   184,   185,
     186,   187,   188,   189,   190,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,   201,   202,   203,   204,   205,
     206,   207,    -1,   209,   210,   211,   212,   213,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
      -1,   237,   238,   239,   240,   241,   242,    -1,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,    -1,   260,   261,   262,    -1,   264,   265,
     266,   267,   268,   269,   270,   271,   272,    -1,   274,    -1,
     276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,    -1,   312,   313,   314,   315,
     316,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
      -1,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,    -1,   364,    -1,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,    -1,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   417,   418,   419,    -1,    -1,    -1,    -1,   424,   425,
     426,    -1,   428,   429,   430,   431,   432,   433,     3,    -1,
      -1,    -1,    -1,     8,    -1,    -1,    -1,    -1,    -1,    14,
      15,    16,    17,    18,    19,    20,    21,    -1,    23,    24,
      25,    -1,    -1,    -1,    -1,    30,    -1,    -1,    -1,    34,
      35,    -1,    37,    38,    -1,    40,    41,    42,    43,    44,
      -1,    46,    47,    -1,    49,    50,    51,    52,    53,    -1,
      -1,    56,    57,    58,    59,    60,    -1,    62,    63,    64,
      65,    66,    -1,    -1,    -1,    70,    71,    72,    73,    -1,
      75,    76,    -1,    78,    79,    80,    81,    82,    83,    -1,
      -1,    86,    87,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      95,    96,    97,    98,    99,   100,   101,   102,   103,    -1,
     105,    -1,   107,   108,   109,   110,   111,    -1,   113,   114,
     115,    -1,    -1,   118,   119,   120,   121,   122,    -1,   124,
     125,   126,    -1,   128,   129,   130,    -1,   132,   133,   134,
     135,   136,   137,   138,   139,   140,    -1,   142,    -1,   144,
     145,   146,   147,    -1,   149,    -1,   151,    -1,    -1,    -1,
     155,   156,   157,    -1,   159,   160,    -1,   162,    -1,   164,
     165,   166,   167,   168,    -1,   170,   171,   172,    -1,   174,
     175,   176,   177,   178,   179,    -1,   181,    -1,   183,   184,
     185,   186,   187,   188,   189,    -1,   191,    -1,   193,    -1,
      -1,   196,    -1,   198,   199,   200,   201,   202,    -1,   204,
     205,    -1,   207,   208,    -1,   210,    -1,    -1,   213,   214,
     215,    -1,    -1,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,    -1,   233,   234,
     235,   236,    -1,   238,   239,    -1,   241,    -1,   243,   244,
     245,   246,   247,   248,    -1,   250,    -1,    -1,   253,   254,
     255,    -1,    -1,   258,   259,    -1,   261,    -1,   263,   264,
     265,   266,   267,   268,   269,   270,    -1,   272,   273,   274,
     275,   276,   277,   278,    -1,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,    -1,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
      -1,   306,   307,    -1,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,    -1,   321,   322,   323,   324,
     325,    -1,   327,   328,   329,   330,    -1,   332,   333,   334,
      -1,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,    -1,   348,   349,    -1,   351,   352,   353,   354,
     355,   356,    -1,   358,   359,    -1,    -1,   362,   363,   364,
     365,    -1,   367,   368,   369,   370,   371,   372,   373,    -1,
      -1,   376,   377,   378,   379,   380,    -1,    -1,   383,   384,
     385,   386,   387,   388,   389,    -1,   391,    -1,   393,   394,
     395,   396,    -1,    -1,   399,    -1,    -1,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,    -1,    -1,    -1,    -1,   424,
     425,   426,    -1,   428,   429,   430,   431,   432,   433,     3,
      -1,    -1,    -1,    -1,     8,    -1,    -1,    -1,    -1,    -1,
      14,    15,    16,    17,    18,    19,    20,    21,    -1,    23,
      24,    25,    -1,    -1,    -1,    -1,    30,    -1,    -1,    -1,
      34,    35,    -1,    37,    38,    -1,    40,    41,    42,    43,
      44,    -1,    46,    47,    -1,    49,    50,    51,    52,    53,
      -1,    -1,    56,    57,    58,    59,    60,    -1,    62,    63,
      64,    65,    66,    -1,    -1,    -1,    70,    71,    72,    73,
      -1,    75,    76,    -1,    78,    79,    80,    81,    82,    83,
      -1,    -1,    86,    87,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    95,    96,    97,    98,    99,   100,   101,   102,   103,
      -1,   105,    -1,   107,   108,   109,   110,   111,    -1,   113,
     114,   115,    -1,    -1,   118,   119,   120,   121,   122,    -1,
     124,   125,   126,    -1,   128,   129,   130,    -1,   132,   133,
     134,   135,   136,   137,   138,   139,   140,    -1,   142,    -1,
     144,   145,   146,   147,    -1,   149,    -1,   151,    -1,    -1,
      -1,   155,   156,   157,    -1,   159,   160,    -1,   162,    -1,
     164,   165,   166,   167,   168,    -1,   170,   171,   172,    -1,
     174,   175,   176,   177,   178,   179,    -1,   181,    -1,   183,
     184,   185,   186,   187,   188,   189,    -1,   191,    -1,   193,
      -1,    -1,   196,    -1,   198,   199,   200,   201,   202,    -1,
     204,   205,    -1,   207,   208,    -1,   210,    -1,    -1,   213,
     214,   215,    -1,    -1,   218,   219,   220,   221,   222,   223,
     224,   225,   226,   227,   228,   229,   230,   231,    -1,   233,
     234,   235,   236,    -1,   238,   239,    -1,   241,    -1,   243,
     244,   245,   246,   247,   248,    -1,   250,    -1,    -1,   253,
     254,   255,    -1,    -1,   258,   259,    -1,   261,    -1,   263,
     264,   265,   266,   267,   268,   269,   270,    -1,   272,   273,
     274,   275,   276,   277,   278,    -1,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,   292,    -1,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
     304,    -1,   306,   307,    -1,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,   319,    -1,   321,   322,   323,
     324,   325,    -1,   327,   328,   329,   330,    -1,   332,   333,
     334,    -1,   336,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,    -1,   348,   349,    -1,   351,   352,   353,
     354,   355,   356,    -1,   358,   359,    -1,    -1,   362,   363,
     364,   365,    -1,   367,   368,   369,   370,   371,   372,   373,
      -1,    -1,   376,   377,   378,   379,   380,    -1,    -1,   383,
     384,   385,   386,   387,   388,   389,    -1,   391,    -1,   393,
     394,   395,   396,    -1,    -1,   399,    -1,    -1,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,    -1,    -1,    -1,    -1,
     424,   425,   426,    -1,   428,   429,   430,   431,   432,   433,
       3,    -1,    -1,    -1,    -1,     8,    -1,    -1,    -1,    -1,
      -1,    14,    15,    16,    17,    18,    19,    20,    21,    -1,
      23,    24,    25,    -1,    -1,    -1,    -1,    30,    -1,    -1,
      -1,    34,    35,    -1,    37,    38,    -1,    40,    41,    42,
      43,    44,    -1,    46,    47,    -1,    49,    50,    51,    52,
      53,    -1,    -1,    56,    57,    58,    59,    60,    -1,    62,
      63,    64,    65,    66,    -1,    -1,    -1,    70,    71,    72,
      73,    -1,    75,    76,    -1,    78,    79,    80,    81,    82,
      83,    -1,    -1,    86,    87,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    95,    96,    97,    98,    99,   100,   101,   102,
     103,    -1,   105,    -1,   107,   108,   109,   110,   111,    -1,
     113,   114,   115,    -1,    -1,   118,   119,   120,   121,   122,
      -1,   124,   125,   126,    -1,   128,   129,   130,    -1,   132,
     133,   134,   135,   136,   137,   138,   139,   140,    -1,   142,
      -1,   144,   145,   146,   147,    -1,   149,    -1,   151,    -1,
      -1,    -1,   155,   156,   157,    -1,   159,   160,    -1,   162,
      -1,   164,   165,   166,   167,   168,    -1,   170,   171,   172,
      -1,   174,   175,   176,   177,   178,   179,    -1,   181,    -1,
     183,   184,   185,   186,   187,   188,   189,    -1,   191,    -1,
     193,    -1,    -1,   196,    -1,   198,   199,   200,   201,   202,
      -1,   204,   205,    -1,   207,   208,    -1,   210,    -1,    -1,
     213,   214,   215,    -1,    -1,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,    -1,
     233,   234,   235,   236,    -1,   238,   239,    -1,   241,    -1,
     243,   244,   245,   246,   247,   248,    -1,   250,    -1,    -1,
     253,   254,   255,    -1,    -1,   258,   259,    -1,   261,    -1,
     263,   264,   265,   266,   267,   268,   269,   270,    -1,   272,
     273,   274,   275,   276,   277,   278,    -1,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,   292,
      -1,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,   304,    -1,   306,   307,    -1,   309,   310,   311,   312,
     313,   314,   315,   316,   317,   318,   319,    -1,   321,   322,
     323,   324,   325,    -1,   327,   328,   329,   330,    -1,   332,
     333,   334,    -1,   336,   337,   338,   339,   340,   341,   342,
     343,   344,   345,   346,    -1,   348,   349,    -1,   351,   352,
     353,   354,   355,   356,    -1,   358,   359,    -1,    -1,   362,
     363,   364,   365,    -1,   367,   368,   369,   370,   371,   372,
     373,    -1,    -1,   376,   377,   378,   379,   380,    -1,    -1,
     383,   384,   385,   386,   387,   388,   389,    -1,   391,    -1,
     393,   394,   395,   396,    -1,    -1,   399,    -1,    -1,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,    -1,    -1,    -1,
      -1,   424,   425,   426,    -1,   428,   429,   430,   431,   432,
     433,     3,    -1,    -1,    -1,    -1,     8,    -1,    -1,    -1,
      -1,    -1,    14,    15,    16,    17,    18,    19,    20,    21,
      -1,    23,    24,    25,    -1,    -1,    -1,    -1,    30,    -1,
      -1,    -1,    34,    35,    -1,    37,    38,    -1,    40,    41,
      42,    43,    44,    -1,    46,    47,    -1,    49,    50,    51,
      52,    53,    -1,    -1,    56,    57,    58,    59,    60,    -1,
      62,    63,    64,    65,    66,    -1,    -1,    -1,    70,    71,
      72,    73,    -1,    75,    76,    -1,    78,    79,    80,    81,
      82,    83,    -1,    -1,    86,    87,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    95,    96,    97,    98,    99,   100,   101,
     102,   103,    -1,   105,    -1,   107,   108,   109,   110,   111,
      -1,   113,   114,   115,    -1,    -1,   118,   119,   120,   121,
     122,    -1,   124,   125,   126,    -1,   128,   129,   130,    -1,
     132,   133,   134,   135,   136,   137,   138,   139,   140,    -1,
     142,    -1,   144,   145,   146,   147,    -1,   149,    -1,   151,
      -1,    -1,    -1,   155,   156,   157,    -1,   159,   160,    -1,
     162,    -1,   164,   165,   166,   167,   168,    -1,   170,   171,
     172,    -1,   174,   175,   176,   177,   178,   179,    -1,   181,
      -1,   183,   184,   185,   186,   187,   188,   189,    -1,   191,
      -1,   193,    -1,    -1,   196,    -1,   198,   199,   200,   201,
     202,    -1,   204,   205,    -1,   207,   208,    -1,   210,    -1,
      -1,   213,   214,   215,    -1,    -1,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
      -1,   233,   234,   235,   236,    -1,   238,   239,    -1,   241,
      -1,   243,   244,   245,   246,   247,   248,    -1,   250,    -1,
      -1,   253,   254,   255,    -1,    -1,   258,   259,    -1,   261,
      -1,   263,   264,   265,   266,   267,   268,   269,   270,    -1,
     272,   273,   274,   275,   276,   277,   278,    -1,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
     292,    -1,   294,   295,   296,   297,   298,   299,   300,   301,
     302,   303,   304,    -1,   306,   307,    -1,   309,   310,   311,
     312,   313,   314,   315,   316,   317,   318,   319,    -1,   321,
     322,   323,   324,   325,    -1,   327,   328,   329,   330,    -1,
     332,   333,   334,    -1,   336,   337,   338,   339,   340,   341,
     342,   343,   344,   345,   346,    -1,   348,   349,    -1,   351,
     352,   353,   354,   355,   356,    -1,   358,   359,    -1,    -1,
     362,   363,   364,   365,    -1,   367,   368,   369,   370,   371,
     372,   373,    -1,    -1,   376,   377,   378,   379,   380,    -1,
      -1,   383,   384,   385,   386,   387,   388,   389,    -1,   391,
      -1,   393,   394,   395,   396,    -1,    -1,   399,    -1,    -1,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,    -1,    -1,
      -1,    -1,   424,   425,   426,    -1,   428,   429,   430,   431,
     432,   433,     3,    -1,    -1,    -1,    -1,     8,    -1,    -1,
      -1,    -1,    -1,    14,    15,    16,    17,    18,    19,    20,
      21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,    30,
      -1,    -1,    -1,    34,    35,    -1,    37,    38,    -1,    40,
      41,    42,    43,    44,    -1,    46,    47,    -1,    49,    50,
      51,    52,    53,    -1,    -1,    56,    57,    58,    59,    60,
      -1,    62,    63,    64,    65,    66,    -1,    -1,    -1,    70,
      71,    72,    73,    -1,    75,    76,    -1,    78,    79,    80,
      81,    82,    83,    -1,    -1,    86,    87,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    95,    96,    97,    98,    99,   100,
     101,   102,   103,    -1,   105,    -1,   107,   108,   109,   110,
     111,    -1,   113,   114,   115,    -1,    -1,   118,   119,   120,
     121,   122,    -1,   124,   125,   126,    -1,   128,   129,   130,
      -1,   132,   133,   134,   135,   136,   137,   138,   139,   140,
      -1,   142,    -1,   144,   145,   146,   147,    -1,   149,    -1,
     151,    -1,    -1,    -1,   155,   156,   157,    -1,   159,   160,
      -1,   162,    -1,   164,   165,   166,   167,   168,    -1,   170,
     171,   172,    -1,   174,   175,   176,   177,   178,   179,    -1,
     181,    -1,   183,   184,   185,   186,   187,   188,   189,    -1,
     191,    -1,   193,    -1,    -1,   196,    -1,   198,   199,   200,
     201,   202,    -1,   204,   205,    -1,   207,   208,    -1,   210,
      -1,    -1,   213,   214,   215,    -1,    -1,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,    -1,   233,   234,   235,   236,    -1,   238,   239,    -1,
     241,    -1,   243,   244,   245,   246,   247,   248,    -1,   250,
      -1,    -1,   253,   254,   255,    -1,    -1,   258,   259,    -1,
     261,    -1,   263,   264,   265,   266,   267,   268,   269,   270,
      -1,   272,   273,   274,   275,   276,   277,   278,    -1,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,   292,    -1,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,   304,    -1,   306,   307,    -1,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,   319,    -1,
     321,   322,   323,   324,   325,    -1,   327,   328,   329,   330,
      -1,   332,   333,   334,    -1,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,   346,    -1,   348,   349,    -1,
     351,   352,   353,   354,   355,   356,    -1,   358,   359,    -1,
      -1,   362,   363,   364,   365,    -1,   367,   368,   369,   370,
     371,   372,   373,    -1,    -1,   376,   377,   378,   379,   380,
      -1,    -1,   383,   384,   385,   386,   387,   388,   389,    -1,
     391,    -1,   393,   394,   395,   396,    -1,    -1,   399,    -1,
      -1,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,   419,    -1,
      -1,    -1,    -1,   424,   425,   426,    -1,   428,   429,   430,
     431,   432,   433,     3,    -1,    -1,    -1,    -1,     8,    -1,
      -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,    19,
      20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,
      30,    -1,    -1,    -1,    34,    35,    -1,    37,    38,    -1,
      40,    41,    42,    43,    44,    -1,    46,    47,    -1,    49,
      50,    51,    52,    53,    -1,    -1,    56,    57,    58,    59,
      60,    -1,    62,    63,    64,    65,    66,    -1,    -1,    -1,
      70,    71,    72,    73,    -1,    75,    76,    -1,    78,    79,
      80,    81,    82,    83,    -1,    -1,    86,    87,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    95,    96,    97,    98,    99,
     100,   101,   102,   103,    -1,   105,    -1,   107,   108,   109,
     110,   111,    -1,   113,   114,   115,    -1,    -1,   118,   119,
     120,   121,   122,    -1,   124,   125,   126,    -1,   128,   129,
     130,    -1,   132,   133,   134,   135,   136,   137,   138,   139,
     140,    -1,   142,    -1,   144,   145,   146,   147,    -1,   149,
      -1,   151,    -1,    -1,    -1,   155,   156,   157,    -1,   159,
     160,    -1,   162,    -1,   164,   165,   166,   167,   168,    -1,
     170,   171,   172,    -1,   174,   175,   176,   177,   178,   179,
      -1,   181,    -1,   183,   184,   185,   186,   187,   188,   189,
      -1,   191,    -1,   193,    -1,    -1,   196,    -1,   198,   199,
     200,   201,   202,    -1,   204,   205,    -1,   207,   208,    -1,
     210,    -1,    -1,   213,   214,   215,    -1,    -1,   218,   219,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,    -1,   233,   234,   235,   236,    -1,   238,   239,
      -1,   241,    -1,   243,   244,   245,   246,   247,   248,    -1,
     250,    -1,    -1,   253,   254,   255,    -1,    -1,   258,   259,
      -1,   261,    -1,   263,   264,   265,   266,   267,   268,   269,
     270,    -1,   272,   273,   274,   275,   276,   277,   278,    -1,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,   292,    -1,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,   304,    -1,   306,   307,    -1,   309,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
      -1,   321,   322,   323,   324,   325,    -1,   327,   328,   329,
     330,    -1,   332,   333,   334,    -1,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,    -1,   348,   349,
      -1,   351,   352,   353,   354,   355,   356,    -1,   358,   359,
      -1,    -1,   362,   363,   364,   365,    -1,   367,   368,   369,
     370,   371,   372,   373,    -1,    -1,   376,   377,   378,   379,
     380,    -1,    -1,   383,   384,   385,   386,   387,   388,   389,
      -1,   391,    -1,   393,   394,   395,   396,    -1,    -1,   399,
      -1,    -1,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
      -1,    -1,    -1,    -1,   424,   425,   426,    -1,   428,   429,
     430,   431,   432,   433,     3,    -1,    -1,    -1,    -1,     8,
      -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,
      19,    20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,
      -1,    30,    -1,    -1,    -1,    34,    35,    -1,    37,    38,
      -1,    40,    41,    42,    43,    44,    -1,    46,    47,    -1,
      49,    50,    51,    52,    53,    -1,    -1,    56,    57,    58,
      59,    60,    -1,    62,    63,    64,    65,    66,    -1,    -1,
      -1,    70,    71,    72,    73,    -1,    75,    76,    -1,    78,
      79,    80,    81,    82,    83,    -1,    -1,    86,    87,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    95,    96,    97,    98,
      99,   100,   101,   102,   103,    -1,   105,    -1,   107,   108,
     109,   110,   111,    -1,   113,   114,   115,    -1,    -1,   118,
     119,   120,   121,   122,    -1,   124,   125,   126,    -1,   128,
     129,   130,    -1,   132,   133,   134,   135,   136,   137,   138,
     139,   140,    -1,   142,    -1,   144,   145,   146,   147,    -1,
     149,    -1,   151,    -1,    -1,    -1,   155,   156,   157,    -1,
     159,   160,    -1,   162,    -1,   164,   165,   166,   167,   168,
      -1,   170,   171,   172,    -1,   174,   175,   176,   177,   178,
     179,    -1,   181,    -1,   183,   184,   185,   186,   187,   188,
     189,    -1,   191,    -1,   193,    -1,    -1,   196,    -1,   198,
     199,   200,   201,   202,    -1,   204,   205,    -1,   207,   208,
      -1,   210,    -1,    -1,   213,   214,   215,    -1,    -1,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,    -1,   233,   234,   235,   236,    -1,   238,
     239,    -1,   241,    -1,   243,   244,   245,   246,   247,   248,
      -1,   250,    -1,    -1,   253,   254,   255,    -1,    -1,   258,
     259,    -1,   261,    -1,   263,   264,   265,   266,   267,   268,
     269,   270,    -1,   272,   273,   274,   275,   276,   277,   278,
      -1,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,   292,    -1,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,   304,    -1,   306,   307,    -1,
     309,   310,   311,   312,   313,   314,   315,   316,   317,   318,
     319,    -1,   321,   322,   323,   324,   325,    -1,   327,   328,
     329,   330,    -1,   332,   333,   334,    -1,   336,   337,   338,
     339,   340,   341,   342,   343,   344,   345,   346,    -1,   348,
     349,    -1,   351,   352,   353,   354,   355,   356,    -1,   358,
     359,    -1,    -1,   362,   363,   364,   365,    -1,   367,   368,
     369,   370,   371,   372,   373,    -1,    -1,   376,   377,   378,
     379,   380,    -1,    -1,   383,   384,   385,   386,   387,   388,
     389,    -1,   391,    -1,   393,   394,   395,   396,    -1,    -1,
     399,    -1,    -1,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,    -1,    -1,    -1,     3,   424,   425,   426,    -1,   428,
     429,   430,   431,   432,   433,    14,    15,    16,    17,    18,
      19,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      29,    30,    31,    32,    33,    34,    35,    36,    37,    38,
      39,    40,    41,    42,    43,    44,    45,    46,    47,    48,
      49,    50,    51,    52,    53,    54,    55,    56,    57,    58,
      59,    60,    61,    62,    63,    64,    65,    66,    67,    68,
      69,    70,    71,    72,    73,    74,    75,    76,    77,    78,
      79,    80,    81,    82,    83,    84,    85,    86,    87,    88,
      89,    90,    91,    92,    93,    94,    95,    96,    97,    98,
      99,   100,   101,   102,   103,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   113,   114,   115,   116,   117,   118,
     119,   120,   121,   122,   123,   124,   125,   126,   127,   128,
     129,   130,   131,   132,   133,   134,   135,   136,   137,   138,
     139,   140,   141,   142,   143,   144,   145,   146,   147,   148,
     149,   150,   151,   152,   153,   154,   155,   156,   157,   158,
     159,   160,   161,   162,   163,   164,   165,   166,   167,   168,
     169,   170,   171,   172,   173,   174,   175,   176,   177,   178,
     179,   180,   181,   182,   183,   184,   185,   186,   187,   188,
     189,   190,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,   202,   203,   204,   205,   206,   207,   208,
     209,   210,   211,   212,   213,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,   247,   248,
     249,   250,   251,   252,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,   263,   264,   265,   266,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,   304,   305,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   316,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   344,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   430,    14,    15,    16,    17,    18,    19,    20,    21,
      -1,    23,    24,    25,    -1,    -1,    -1,    -1,    30,    -1,
      -1,    -1,    34,    35,    -1,    37,    38,    -1,    40,    41,
      42,    43,    44,    -1,    46,    47,    -1,    49,    50,    51,
      52,    53,    -1,    -1,    56,    57,    58,    59,    60,    -1,
      62,    63,    64,    65,    66,    -1,    -1,    -1,    70,    71,
      72,    73,    -1,    75,    76,    -1,    78,    79,    80,    81,
      82,    83,    -1,    -1,    86,    87,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    95,    96,    97,    98,    99,   100,   101,
     102,   103,    -1,   105,    -1,   107,   108,   109,   110,   111,
      -1,   113,   114,   115,    -1,    -1,   118,   119,   120,   121,
     122,    -1,   124,   125,   126,    -1,   128,   129,   130,    -1,
     132,   133,   134,   135,   136,   137,   138,   139,   140,    -1,
     142,    -1,   144,   145,   146,   147,    -1,   149,    -1,   151,
      -1,    -1,    -1,   155,   156,   157,    -1,   159,   160,    -1,
     162,    -1,   164,   165,   166,   167,   168,    -1,   170,   171,
     172,    -1,   174,   175,   176,   177,   178,   179,    -1,   181,
      -1,   183,   184,   185,   186,   187,   188,   189,    -1,   191,
      -1,   193,    -1,    -1,   196,    -1,   198,   199,   200,   201,
     202,    -1,   204,   205,    -1,   207,   208,    -1,   210,    -1,
      -1,   213,   214,   215,    -1,    -1,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
      -1,   233,   234,   235,   236,    -1,   238,   239,    -1,   241,
      -1,   243,   244,   245,   246,   247,   248,    -1,   250,    -1,
      -1,   253,   254,   255,    -1,    -1,   258,   259,    -1,   261,
      -1,   263,   264,   265,   266,   267,   268,   269,   270,    -1,
     272,   273,   274,   275,   276,   277,   278,    -1,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
     292,    -1,   294,   295,   296,   297,   298,   299,   300,   301,
     302,   303,   304,    -1,   306,   307,    -1,   309,   310,   311,
     312,   313,   314,   315,   316,   317,   318,   319,    -1,   321,
     322,   323,   324,   325,    -1,   327,   328,   329,   330,    -1,
     332,   333,   334,    -1,   336,   337,   338,   339,   340,   341,
     342,   343,   344,   345,   346,    -1,   348,   349,    -1,   351,
     352,   353,   354,   355,   356,    -1,   358,   359,    -1,    -1,
     362,   363,   364,   365,    -1,   367,   368,   369,   370,   371,
     372,   373,    -1,    -1,   376,   377,   378,   379,   380,    -1,
      -1,   383,   384,   385,   386,   387,   388,   389,    -1,   391,
      -1,   393,   394,   395,   396,    -1,    -1,   399,    -1,    -1,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   430,    14,
      15,    16,    17,    18,    19,    20,    21,    -1,    23,    24,
      25,    -1,    -1,    -1,    -1,    30,    -1,    -1,    -1,    34,
      35,    -1,    37,    38,    39,    40,    41,    42,    -1,    44,
      45,    46,    47,    -1,    49,    50,    51,    52,    53,    -1,
      -1,    56,    57,    58,    59,    60,    -1,    62,    63,    64,
      65,    -1,    -1,    68,    -1,    70,    71,    72,    73,    74,
      75,    76,    -1,    78,    79,    80,    81,    82,    83,    -1,
      85,    86,    87,    -1,    -1,    -1,    91,    -1,    -1,    -1,
      95,    96,    97,    98,    99,   100,   101,   102,   103,    -1,
     105,    -1,   107,   108,   109,   110,   111,    -1,   113,   114,
     115,    -1,    -1,   118,   119,   120,   121,   122,    -1,   124,
     125,   126,    -1,   128,   129,   130,    -1,   132,   133,   134,
     135,    -1,   137,   138,   139,    -1,    -1,   142,    -1,   144,
     145,   146,   147,    -1,   149,    -1,   151,   152,    -1,   154,
     155,   156,   157,    -1,   159,    -1,    -1,   162,    -1,   164,
     165,   166,   167,   168,   169,   170,   171,   172,   173,   174,
     175,   176,   177,   178,   179,    -1,   181,   182,   183,   184,
     185,   186,   187,   188,   189,    -1,   191,    -1,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,    -1,   204,
     205,    -1,   207,    -1,   209,   210,   211,    -1,   213,   214,
     215,    -1,    -1,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,    -1,    -1,   238,   239,   240,   241,    -1,    -1,   244,
     245,   246,   247,   248,    -1,   250,    -1,    -1,   253,   254,
     255,    -1,   257,   258,   259,   260,   261,   262,    -1,   264,
     265,   266,   267,   268,   269,   270,    -1,   272,    -1,   274,
      -1,   276,   277,   278,    -1,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,    -1,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
      -1,   306,   307,   308,   309,   310,    -1,   312,   313,   314,
     315,   316,   317,   318,   319,    -1,   321,   322,   323,   324,
     325,    -1,   327,   328,   329,   330,   331,   332,   333,   334,
      -1,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,    -1,    -1,   348,   349,    -1,   351,   352,   353,   354,
     355,   356,    -1,   358,   359,    -1,    -1,   362,    -1,   364,
      -1,    -1,   367,   368,   369,   370,   371,   372,   373,    -1,
      -1,   376,   377,   378,   379,   380,    -1,    -1,   383,   384,
     385,   386,   387,    -1,   389,   390,   391,   392,   393,   394,
     395,   396,    -1,    -1,   399,    -1,    -1,   402,   403,   404,
     405,   406,   407,    -1,    -1,    -1,     3,    -1,    -1,    -1,
      -1,    -1,   417,   418,   419,    -1,    -1,    14,    15,    16,
      17,    18,    19,    20,    21,   430,    23,    24,    25,    -1,
      -1,    -1,    -1,    30,    -1,    -1,    -1,    34,    35,    -1,
      37,    38,    39,    40,    41,    42,    -1,    44,    45,    46,
      47,    -1,    49,    50,    51,    52,    53,    -1,    -1,    56,
      57,    58,    59,    60,    -1,    62,    63,    64,    65,    -1,
      -1,    68,    -1,    70,    71,    72,    73,    74,    75,    76,
      -1,    78,    79,    80,    81,    82,    83,    -1,    85,    86,
      87,    -1,    -1,    -1,    91,    -1,    -1,    -1,    95,    96,
      97,    98,    99,   100,   101,   102,   103,    -1,   105,    -1,
     107,   108,   109,   110,   111,    -1,   113,   114,   115,    -1,
      -1,   118,   119,   120,   121,   122,    -1,   124,   125,   126,
      -1,   128,   129,   130,    -1,   132,   133,   134,   135,    -1,
     137,   138,   139,    -1,    -1,   142,    -1,   144,   145,   146,
     147,    -1,   149,    -1,   151,   152,    -1,   154,   155,   156,
     157,    -1,   159,    -1,    -1,   162,    -1,   164,   165,   166,
     167,   168,   169,   170,   171,   172,   173,   174,   175,   176,
     177,   178,   179,    -1,   181,   182,   183,   184,   185,   186,
     187,   188,   189,    -1,   191,    -1,   193,   194,   195,   196,
     197,   198,   199,   200,   201,   202,    -1,   204,   205,    -1,
     207,    -1,   209,   210,   211,    -1,   213,   214,   215,    -1,
      -1,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,    -1,
      -1,   238,   239,   240,   241,    -1,    -1,   244,   245,   246,
     247,   248,    -1,   250,    -1,    -1,   253,   254,   255,    -1,
     257,   258,   259,   260,   261,   262,    -1,   264,   265,   266,
     267,   268,   269,   270,    -1,   272,    -1,   274,    -1,   276,
     277,   278,    -1,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,   292,    -1,   294,   295,   296,
     297,   298,   299,   300,   301,   302,   303,   304,    -1,   306,
     307,   308,   309,   310,    -1,   312,   313,   314,   315,   316,
     317,   318,   319,    -1,   321,   322,   323,   324,   325,    -1,
     327,   328,   329,   330,   331,   332,   333,   334,    -1,   336,
     337,   338,   339,   340,   341,   342,   343,   344,   345,    -1,
      -1,   348,   349,    -1,   351,   352,   353,   354,   355,   356,
      -1,   358,   359,    -1,    -1,   362,    -1,   364,    -1,    -1,
     367,   368,   369,   370,   371,   372,   373,    -1,    -1,   376,
     377,   378,   379,   380,    -1,    -1,   383,   384,   385,   386,
     387,    -1,   389,   390,   391,   392,   393,   394,   395,   396,
      -1,    -1,   399,    -1,    -1,   402,   403,   404,   405,   406,
     407,    -1,    -1,    -1,     3,    -1,    -1,    -1,    -1,    -1,
     417,   418,   419,    -1,    -1,    14,    15,    16,    17,    18,
      19,    20,    21,   430,    23,    24,    25,    -1,    -1,    -1,
      -1,    30,    -1,    -1,    -1,    34,    35,    -1,    37,    38,
      -1,    40,    41,    42,    43,    44,    -1,    46,    47,    -1,
      49,    50,    51,    52,    53,    -1,    -1,    56,    57,    58,
      59,    60,    -1,    62,    63,    64,    65,    66,    -1,    -1,
      -1,    70,    71,    72,    73,    -1,    75,    76,    -1,    78,
      79,    80,    81,    82,    83,    -1,    -1,    86,    87,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    95,    96,    97,    98,
      99,   100,   101,   102,   103,    -1,   105,    -1,   107,   108,
     109,   110,   111,    -1,   113,   114,   115,    -1,    -1,   118,
     119,   120,   121,   122,    -1,   124,   125,   126,    -1,   128,
     129,   130,    -1,   132,   133,   134,   135,   136,   137,   138,
     139,   140,    -1,   142,    -1,   144,   145,   146,   147,    -1,
     149,    -1,   151,    -1,    -1,    -1,   155,   156,   157,    -1,
     159,   160,    -1,   162,    -1,   164,   165,   166,   167,   168,
      -1,   170,   171,   172,    -1,   174,   175,   176,   177,   178,
     179,    -1,   181,    -1,   183,   184,   185,   186,   187,   188,
     189,    -1,   191,    -1,   193,    -1,    -1,   196,    -1,   198,
     199,   200,   201,   202,    -1,   204,   205,    -1,   207,   208,
      -1,   210,    -1,    -1,   213,   214,   215,    -1,    -1,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,    -1,   233,   234,   235,   236,    -1,   238,
     239,    -1,   241,    -1,   243,   244,   245,   246,   247,   248,
      -1,   250,    -1,    -1,   253,   254,   255,    -1,    -1,   258,
     259,    -1,   261,    -1,   263,   264,   265,   266,   267,   268,
     269,   270,    -1,   272,   273,   274,   275,   276,   277,   278,
      -1,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,   292,    -1,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,   304,    -1,   306,   307,    -1,
     309,   310,   311,   312,   313,   314,   315,   316,   317,   318,
     319,    -1,   321,   322,   323,   324,   325,    -1,   327,   328,
     329,   330,    -1,   332,   333,   334,    -1,   336,   337,   338,
     339,   340,   341,   342,   343,   344,   345,   346,    -1,   348,
     349,    -1,   351,   352,   353,   354,   355,   356,    -1,   358,
     359,    -1,    -1,   362,   363,   364,   365,    -1,   367,   368,
     369,   370,   371,   372,   373,    -1,    -1,   376,   377,   378,
     379,   380,    -1,    -1,   383,   384,   385,   386,   387,   388,
     389,    -1,   391,    -1,   393,   394,   395,   396,    -1,    -1,
     399,    -1,    -1,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,     3,     4,     5,    -1,    -1,    -1,     9,    -1,    -1,
      -1,   430,    14,    15,    16,    17,    18,    19,    20,    21,
      -1,    23,    24,    25,    -1,    -1,    -1,    -1,    30,    -1,
      -1,    -1,    34,    35,    -1,    37,    38,    39,    40,    41,
      42,    43,    44,    45,    46,    47,    -1,    49,    50,    51,
      52,    53,    -1,    -1,    56,    57,    58,    59,    60,    -1,
      62,    63,    64,    65,    66,    -1,    68,    -1,    70,    71,
      72,    73,    74,    75,    76,    -1,    78,    79,    80,    81,
      82,    83,    -1,    85,    86,    87,    -1,    -1,    -1,    91,
      -1,    -1,    -1,    95,    96,    97,    98,    99,   100,   101,
     102,   103,   104,   105,    -1,   107,   108,   109,   110,   111,
      -1,   113,   114,   115,    -1,    -1,   118,   119,   120,   121,
     122,    -1,   124,   125,   126,    -1,   128,   129,   130,    -1,
     132,   133,   134,   135,   136,   137,   138,   139,   140,   141,
     142,    -1,   144,   145,   146,   147,    -1,   149,    -1,   151,
     152,    -1,   154,   155,   156,   157,    -1,   159,   160,    -1,
     162,    -1,   164,   165,   166,   167,   168,   169,   170,   171,
     172,    -1,   174,   175,   176,   177,   178,   179,    -1,   181,
     182,   183,   184,   185,   186,   187,   188,   189,    -1,   191,
      -1,   193,   194,   195,   196,   197,   198,   199,   200,   201,
     202,    -1,   204,   205,    -1,   207,   208,   209,   210,   211,
      -1,   213,   214,   215,    -1,    -1,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,    -1,   238,   239,   240,   241,
      -1,   243,   244,   245,   246,   247,   248,    -1,   250,   251,
      -1,   253,   254,   255,    -1,    -1,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,    -1,
     272,   273,   274,   275,   276,   277,   278,    -1,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
     292,    -1,   294,   295,   296,   297,   298,   299,   300,   301,
     302,   303,   304,    -1,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,   316,   317,   318,   319,    -1,   321,
     322,   323,   324,   325,    -1,   327,   328,   329,   330,   331,
     332,   333,   334,    -1,   336,   337,   338,   339,   340,   341,
     342,   343,   344,   345,   346,    -1,   348,   349,    -1,   351,
     352,   353,   354,   355,   356,    -1,   358,   359,    -1,    -1,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,    -1,    -1,   376,   377,   378,   379,   380,    -1,
      -1,   383,   384,   385,   386,   387,   388,   389,    -1,   391,
     392,   393,   394,   395,   396,    -1,    -1,   399,    -1,    -1,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,     3,     4,
       5,    -1,    -1,    -1,     9,    -1,   428,   429,    -1,    14,
      15,    16,    17,    18,    19,    20,    21,    -1,    23,    24,
      25,    -1,    -1,    -1,    -1,    30,    -1,    -1,    -1,    34,
      35,    -1,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    -1,    49,    50,    51,    52,    53,    -1,
      -1,    56,    57,    58,    59,    60,    -1,    62,    63,    64,
      65,    66,    -1,    68,    -1,    70,    71,    72,    73,    74,
      75,    76,    -1,    78,    79,    80,    81,    82,    83,    -1,
      85,    86,    87,    -1,    -1,    -1,    91,    -1,    -1,    -1,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,    -1,   107,   108,   109,   110,   111,    -1,   113,   114,
     115,    -1,    -1,   118,   119,   120,   121,   122,    -1,   124,
     125,   126,    -1,   128,   129,   130,    -1,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,    -1,   144,
     145,   146,   147,    -1,   149,    -1,   151,   152,    -1,   154,
     155,   156,   157,    -1,   159,   160,    -1,   162,    -1,   164,
     165,   166,   167,   168,   169,   170,   171,   172,    -1,   174,
     175,   176,   177,   178,   179,    -1,   181,   182,   183,   184,
     185,   186,   187,   188,   189,    -1,   191,    -1,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,    -1,   204,
     205,    -1,   207,   208,   209,   210,   211,    -1,   213,   214,
     215,    -1,    -1,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,    -1,   238,   239,   240,   241,    -1,   243,   244,
     245,   246,   247,   248,    -1,   250,   251,    -1,   253,   254,
     255,    -1,    -1,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,    -1,   272,   273,   274,
     275,   276,   277,   278,    -1,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,    -1,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
      -1,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,    -1,   321,   322,   323,   324,
     325,    -1,   327,   328,   329,   330,   331,   332,   333,   334,
      -1,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,    -1,   348,   349,    -1,   351,   352,   353,   354,
     355,   356,    -1,   358,   359,    -1,    -1,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,    -1,
      -1,   376,   377,   378,   379,   380,    -1,    -1,   383,   384,
     385,   386,   387,   388,   389,    -1,   391,   392,   393,   394,
     395,   396,    -1,    -1,   399,    -1,    -1,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,     3,     4,     5,    -1,    -1,
      -1,     9,    -1,   428,   429,    -1,    14,    15,    16,    17,
      18,    19,    20,    21,    -1,    23,    24,    25,    -1,    -1,
      -1,    -1,    30,    -1,    -1,    -1,    34,    35,    -1,    37,
      38,    39,    40,    41,    42,    43,    44,    45,    46,    47,
      -1,    49,    50,    51,    52,    53,    -1,    -1,    56,    57,
      58,    59,    60,    -1,    62,    63,    64,    65,    66,    -1,
      68,    -1,    70,    71,    72,    73,    74,    75,    76,    -1,
      78,    79,    80,    81,    82,    83,    -1,    85,    86,    87,
      -1,    -1,    -1,    91,    -1,    -1,    -1,    95,    96,    97,
      98,    99,   100,   101,   102,   103,    -1,   105,    -1,   107,
     108,   109,   110,   111,    -1,   113,   114,   115,    -1,    -1,
     118,   119,   120,   121,   122,    -1,   124,   125,   126,    -1,
     128,   129,   130,    -1,   132,   133,   134,   135,   136,   137,
     138,   139,   140,   141,   142,    -1,   144,   145,   146,   147,
      -1,   149,    -1,   151,   152,    -1,   154,   155,   156,   157,
      -1,   159,   160,    -1,   162,    -1,   164,   165,   166,   167,
     168,   169,   170,   171,   172,    -1,   174,   175,   176,   177,
     178,   179,    -1,   181,   182,   183,   184,   185,   186,   187,
     188,   189,    -1,   191,    -1,   193,   194,   195,   196,   197,
     198,   199,   200,   201,   202,    -1,   204,   205,    -1,   207,
     208,   209,   210,   211,    -1,   213,   214,   215,    -1,    -1,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,    -1,
     238,   239,   240,   241,    -1,   243,   244,   245,   246,   247,
     248,    -1,   250,   251,    -1,   253,   254,   255,    -1,    -1,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,    -1,   272,   273,   274,   275,   276,   277,
     278,    -1,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,   290,   291,   292,    -1,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,    -1,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,   316,   317,
     318,   319,    -1,   321,   322,   323,   324,   325,    -1,   327,
     328,   329,   330,   331,   332,   333,   334,    -1,   336,   337,
     338,   339,   340,   341,   342,   343,   344,   345,   346,    -1,
     348,   349,    -1,   351,   352,   353,   354,   355,   356,    -1,
     358,   359,    -1,    -1,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,    -1,    -1,   376,   377,
     378,   379,   380,    -1,    -1,   383,   384,   385,   386,   387,
     388,   389,    -1,   391,   392,   393,   394,   395,   396,    -1,
      -1,   399,    -1,    -1,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,     3,    -1,    -1,    -1,    -1,    -1,     9,    -1,
     428,   429,    -1,    14,    15,    16,    17,    18,    19,    20,
      21,    22,    23,    24,    25,    -1,    -1,    -1,    -1,    30,
      -1,    -1,    -1,    34,    35,    -1,    37,    38,    -1,    40,
      41,    42,    43,    44,    -1,    46,    47,    -1,    49,    50,
      51,    52,    53,    -1,    -1,    56,    57,    58,    59,    60,
      -1,    62,    63,    64,    65,    66,    -1,    -1,    -1,    70,
      71,    72,    73,    -1,    75,    76,    -1,    78,    79,    80,
      81,    82,    83,    -1,    -1,    86,    87,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    95,    96,    97,    98,    99,   100,
     101,   102,   103,    -1,   105,    -1,   107,   108,   109,   110,
     111,    -1,   113,   114,   115,    -1,    -1,   118,   119,   120,
     121,   122,    -1,   124,   125,   126,    -1,   128,   129,   130,
      -1,   132,   133,   134,   135,   136,   137,   138,   139,   140,
      -1,   142,    -1,   144,   145,   146,   147,    -1,   149,    -1,
     151,    -1,   153,    -1,   155,   156,   157,    -1,   159,   160,
      -1,   162,    -1,   164,   165,   166,   167,   168,    -1,   170,
     171,   172,   173,   174,   175,   176,   177,   178,   179,    -1,
     181,    -1,   183,   184,   185,   186,   187,   188,   189,    -1,
     191,    -1,   193,    -1,    -1,   196,    -1,   198,   199,   200,
     201,   202,    -1,   204,   205,    -1,   207,   208,    -1,   210,
      -1,    -1,   213,   214,   215,    -1,    -1,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,    -1,   233,   234,   235,   236,    -1,   238,   239,    -1,
     241,    -1,   243,   244,   245,   246,   247,   248,    -1,   250,
      -1,    -1,   253,   254,   255,    -1,    -1,   258,   259,    -1,
     261,    -1,   263,   264,   265,   266,   267,   268,   269,   270,
      -1,   272,   273,   274,   275,   276,   277,   278,    -1,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,   292,    -1,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,   304,    -1,   306,   307,    -1,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,   319,    -1,
     321,   322,   323,   324,   325,    -1,   327,   328,   329,   330,
      -1,   332,   333,   334,    -1,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,   346,    -1,   348,   349,    -1,
     351,   352,   353,   354,   355,   356,    -1,   358,   359,    -1,
      -1,   362,   363,   364,   365,    -1,   367,   368,   369,   370,
     371,   372,   373,    -1,    -1,   376,   377,   378,   379,   380,
      -1,    -1,   383,   384,   385,   386,   387,   388,   389,    -1,
     391,    -1,   393,   394,   395,   396,    -1,    -1,   399,    -1,
      -1,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,   419,     3,
       4,     5,    -1,    -1,    -1,     9,    -1,   428,   429,    -1,
      14,    15,    16,    17,    18,    19,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    29,    30,    31,    32,    33,
      34,    35,    36,    37,    38,    39,    40,    41,    42,    43,
      44,    45,    46,    47,    48,    49,    50,    51,    52,    53,
      54,    55,    56,    57,    58,    59,    60,    61,    62,    63,
      64,    65,    66,    67,    68,    69,    70,    71,    72,    73,
      74,    75,    76,    77,    78,    79,    80,    81,    82,    83,
      84,    85,    86,    87,    88,    89,    90,    91,    92,    93,
      94,    95,    96,    97,    98,    99,   100,   101,   102,   103,
     104,   105,   106,   107,   108,   109,   110,   111,   112,   113,
     114,   115,   116,   117,   118,   119,   120,   121,   122,   123,
     124,   125,   126,   127,   128,   129,   130,   131,   132,   133,
     134,   135,   136,   137,   138,   139,   140,   141,   142,   143,
     144,   145,   146,   147,   148,   149,   150,   151,   152,   153,
     154,   155,   156,   157,   158,   159,   160,   161,   162,   163,
     164,   165,   166,   167,   168,   169,   170,   171,   172,   173,
     174,   175,   176,   177,   178,   179,   180,   181,   182,   183,
     184,   185,   186,   187,   188,   189,   190,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
     204,   205,   206,   207,   208,   209,   210,   211,   212,   213,
     214,   215,   216,   217,   218,   219,   220,   221,   222,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,   246,   247,   248,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,   277,   278,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,    15,    16,
      17,    18,    19,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    29,    30,    31,    32,    33,    34,    35,    36,
      37,    38,    39,    40,    41,    42,    43,    44,    45,    46,
      47,    48,    49,    50,    51,    52,    53,    54,    55,    56,
      57,    58,    59,    60,    61,    62,    63,    64,    65,    66,
      67,    68,    69,    70,    71,    72,    73,    74,    75,    76,
      77,    78,    79,    80,    81,    82,    83,    84,    85,    86,
      87,    88,    89,    90,    91,    92,    93,    94,    95,    96,
      97,    98,    99,   100,   101,   102,   103,   104,   105,   106,
     107,   108,   109,   110,   111,   112,   113,   114,   115,   116,
     117,   118,   119,   120,   121,   122,   123,   124,   125,   126,
     127,   128,   129,   130,   131,   132,   133,   134,   135,   136,
     137,   138,   139,   140,   141,   142,   143,   144,   145,   146,
     147,   148,   149,   150,   151,   152,   153,   154,   155,   156,
     157,   158,   159,   160,   161,   162,   163,   164,   165,   166,
     167,   168,   169,   170,   171,   172,   173,   174,   175,   176,
     177,   178,   179,   180,   181,   182,   183,   184,   185,   186,
     187,   188,   189,   190,   191,   192,   193,   194,   195,   196,
     197,   198,   199,   200,   201,   202,   203,   204,   205,   206,
     207,   208,   209,   210,   211,   212,   213,   214,   215,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   246,
     247,   248,   249,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,   263,   264,   265,   266,
     267,   268,   269,   270,   271,   272,   273,   274,   275,   276,
     277,   278,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,   303,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,   320,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,   333,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   343,   344,   345,   346,
     347,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,   395,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,    19,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    31,    32,    33,    34,    35,    36,    37,    38,    39,
      40,    41,    42,    43,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    56,    57,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    71,    72,    73,    74,    75,    76,    77,    78,    79,
      80,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      90,    91,    92,    93,    94,    95,    96,    97,    98,    99,
     100,   101,   102,   103,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,   116,   117,   118,   119,
     120,   121,   122,   123,   124,   125,   126,   127,   128,   129,
     130,   131,   132,   133,   134,   135,   136,   137,   138,   139,
     140,   141,   142,   143,   144,   145,   146,   147,   148,   149,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
     160,   161,   162,   163,   164,   165,   166,   167,   168,   169,
     170,   171,   172,   173,   174,   175,   176,   177,   178,   179,
     180,   181,   182,   183,   184,   185,   186,   187,   188,   189,
     190,   191,   192,   193,   194,   195,   196,   197,   198,   199,
     200,   201,   202,   203,   204,   205,   206,   207,   208,   209,
     210,   211,   212,   213,   214,   215,   216,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    14,    15,    16,    17,    18,    19,    20,    21,    -1,
      23,    24,    25,    -1,    -1,    -1,    -1,    30,    -1,    -1,
      -1,    34,    35,    -1,    37,    38,    39,    40,    41,    42,
      43,    44,    45,    46,    47,    -1,    49,    50,    51,    52,
      53,    -1,    55,    56,    57,    58,    59,    60,    -1,    62,
      63,    64,    65,    66,    -1,    68,    -1,    70,    71,    72,
      73,    74,    75,    76,    -1,    78,    79,    80,    81,    82,
      83,    -1,    85,    86,    87,    88,    89,    90,    91,    92,
      93,    94,    95,    96,    97,    98,    99,   100,   101,   102,
     103,    -1,   105,    -1,   107,   108,   109,   110,   111,    -1,
     113,   114,   115,    -1,    -1,   118,   119,   120,   121,   122,
      -1,   124,   125,   126,    -1,   128,   129,   130,    -1,   132,
     133,   134,   135,   136,   137,   138,   139,   140,    -1,   142,
      -1,   144,   145,   146,   147,    -1,   149,    -1,   151,   152,
      -1,   154,   155,   156,   157,    -1,   159,   160,    -1,   162,
      -1,   164,   165,   166,   167,   168,   169,   170,   171,   172,
      -1,   174,   175,   176,   177,   178,   179,    -1,   181,   182,
     183,   184,   185,   186,   187,   188,   189,    -1,   191,    -1,
     193,   194,   195,   196,   197,   198,   199,   200,   201,   202,
      -1,   204,   205,    -1,   207,   208,   209,   210,   211,    -1,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,    -1,   238,   239,   240,   241,    -1,
     243,   244,   245,   246,   247,   248,    -1,   250,    -1,    -1,
     253,   254,   255,    -1,    -1,   258,   259,   260,   261,   262,
     263,   264,   265,   266,   267,   268,   269,   270,    -1,   272,
     273,   274,   275,   276,   277,   278,    -1,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,   292,
      -1,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,   304,    -1,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,   317,   318,   319,    -1,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
     333,   334,    -1,   336,   337,   338,   339,   340,   341,   342,
     343,   344,   345,   346,    -1,   348,   349,    -1,   351,   352,
     353,   354,   355,   356,    -1,   358,   359,    -1,    -1,   362,
     363,   364,   365,    -1,   367,   368,   369,   370,   371,   372,
     373,    -1,    -1,   376,   377,   378,   379,   380,   381,    -1,
     383,   384,   385,   386,   387,   388,   389,    -1,   391,   392,
     393,   394,   395,   396,    -1,    -1,   399,    -1,    -1,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,     3,    -1,     5,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,    15,
      16,    17,    18,    19,    20,    21,    -1,    23,    24,    25,
      -1,    -1,    -1,    -1,    30,    -1,    -1,    -1,    34,    35,
      -1,    37,    38,    39,    40,    41,    42,    43,    44,    45,
      46,    47,    -1,    49,    50,    51,    52,    53,    -1,    -1,
      56,    57,    58,    59,    60,    -1,    62,    63,    64,    65,
      66,    -1,    68,    -1,    70,    71,    72,    73,    74,    75,
      76,    -1,    78,    79,    80,    81,    82,    83,    -1,    85,
      86,    87,    -1,    -1,    -1,    91,    -1,    -1,    -1,    95,
      96,    97,    98,    99,   100,   101,   102,   103,    -1,   105,
      -1,   107,   108,   109,   110,   111,    -1,   113,   114,   115,
      -1,    -1,   118,   119,   120,   121,   122,    -1,   124,   125,
     126,    -1,   128,   129,   130,    -1,   132,   133,   134,   135,
     136,   137,   138,   139,   140,   141,   142,    -1,   144,   145,
     146,   147,    -1,   149,    -1,   151,   152,    -1,   154,   155,
     156,   157,    -1,   159,   160,    -1,   162,    -1,   164,   165,
     166,   167,   168,   169,   170,   171,   172,    -1,   174,   175,
     176,   177,   178,   179,    -1,   181,   182,   183,   184,   185,
     186,   187,   188,   189,    -1,   191,    -1,   193,   194,   195,
     196,   197,   198,   199,   200,   201,   202,    -1,   204,   205,
      -1,   207,   208,   209,   210,   211,    -1,   213,   214,   215,
      -1,    -1,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,    -1,   238,   239,   240,   241,    -1,   243,   244,   245,
     246,   247,   248,    -1,   250,   251,    -1,   253,   254,   255,
      -1,    -1,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,    -1,   272,   273,   274,   275,
     276,   277,   278,    -1,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,   292,    -1,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,    -1,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,   319,    -1,   321,   322,   323,   324,   325,
      -1,   327,   328,   329,   330,   331,   332,   333,   334,    -1,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,    -1,   348,   349,    -1,   351,   352,   353,   354,   355,
     356,    -1,   358,   359,    -1,    -1,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,    -1,    -1,
     376,   377,   378,   379,   380,    -1,    -1,   383,   384,   385,
     386,   387,   388,   389,    -1,   391,   392,   393,   394,   395,
     396,    -1,    -1,   399,    -1,    -1,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,     3,    -1,     5,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,
      19,    20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,
      -1,    30,    -1,    -1,    -1,    34,    35,    -1,    37,    38,
      39,    40,    41,    42,    43,    44,    45,    46,    47,    -1,
      49,    50,    51,    52,    53,    -1,    -1,    56,    57,    58,
      59,    60,    -1,    62,    63,    64,    65,    66,    -1,    68,
      -1,    70,    71,    72,    73,    74,    75,    76,    -1,    78,
      79,    80,    81,    82,    83,    -1,    85,    86,    87,    -1,
      -1,    -1,    91,    -1,    -1,    -1,    95,    96,    97,    98,
      99,   100,   101,   102,   103,   104,   105,    -1,   107,   108,
     109,   110,   111,    -1,   113,   114,   115,    -1,    -1,   118,
     119,   120,   121,   122,    -1,   124,   125,   126,    -1,   128,
     129,   130,    -1,   132,   133,   134,   135,   136,   137,   138,
     139,   140,    -1,   142,    -1,   144,   145,   146,   147,    -1,
     149,    -1,   151,   152,    -1,   154,   155,   156,   157,    -1,
     159,   160,    -1,   162,    -1,   164,   165,   166,   167,   168,
     169,   170,   171,   172,    -1,   174,   175,   176,   177,   178,
     179,    -1,   181,   182,   183,   184,   185,   186,   187,   188,
     189,    -1,   191,    -1,   193,   194,   195,   196,   197,   198,
     199,   200,   201,   202,    -1,   204,   205,    -1,   207,   208,
     209,   210,   211,    -1,   213,   214,   215,    -1,    -1,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,    -1,   238,
     239,   240,   241,    -1,   243,   244,   245,   246,   247,   248,
      -1,   250,    -1,    -1,   253,   254,   255,    -1,    -1,   258,
     259,   260,   261,   262,   263,   264,   265,   266,   267,   268,
     269,   270,    -1,   272,   273,   274,   275,   276,   277,   278,
      -1,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,   292,    -1,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,   304,    -1,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   316,   317,   318,
     319,    -1,   321,   322,   323,   324,   325,    -1,   327,   328,
     329,   330,   331,   332,   333,   334,    -1,   336,   337,   338,
     339,   340,   341,   342,   343,   344,   345,   346,    -1,   348,
     349,    -1,   351,   352,   353,   354,   355,   356,    -1,   358,
     359,    -1,    -1,   362,   363,   364,   365,    -1,   367,   368,
     369,   370,   371,   372,   373,    -1,    -1,   376,   377,   378,
     379,   380,    -1,    -1,   383,   384,   385,   386,   387,   388,
     389,    -1,   391,   392,   393,   394,   395,   396,    -1,    -1,
     399,    -1,    -1,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    14,    15,    16,    17,    18,    19,    20,    21,
      -1,    23,    24,    25,    -1,    -1,    -1,    -1,    30,    -1,
      -1,    -1,    34,    35,    -1,    37,    38,    39,    40,    41,
      42,    43,    44,    45,    46,    47,    -1,    49,    50,    51,
      52,    53,    -1,    -1,    56,    57,    58,    59,    60,    -1,
      62,    63,    64,    65,    66,    -1,    68,    -1,    70,    71,
      72,    73,    74,    75,    76,    -1,    78,    79,    80,    81,
      82,    83,    -1,    85,    86,    87,    -1,    -1,    -1,    91,
      -1,    -1,    94,    95,    96,    97,    98,    99,   100,   101,
     102,   103,    -1,   105,    -1,   107,   108,   109,   110,   111,
      -1,   113,   114,   115,    -1,    -1,   118,   119,   120,   121,
     122,    -1,   124,   125,   126,    -1,   128,   129,   130,    -1,
     132,   133,   134,   135,   136,   137,   138,   139,   140,    -1,
     142,    -1,   144,   145,   146,   147,    -1,   149,    -1,   151,
     152,    -1,   154,   155,   156,   157,    -1,   159,   160,    -1,
     162,    -1,   164,   165,   166,   167,   168,   169,   170,   171,
     172,    -1,   174,   175,   176,   177,   178,   179,    -1,   181,
     182,   183,   184,   185,   186,   187,   188,   189,    -1,   191,
      -1,   193,   194,   195,   196,   197,   198,   199,   200,   201,
     202,    -1,   204,   205,    -1,   207,   208,   209,   210,   211,
      -1,   213,   214,   215,    -1,    -1,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,    -1,   238,   239,   240,   241,
      -1,   243,   244,   245,   246,   247,   248,    -1,   250,    -1,
      -1,   253,   254,   255,    -1,    -1,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,    -1,
     272,   273,   274,   275,   276,   277,   278,    -1,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
     292,    -1,   294,   295,   296,   297,   298,   299,   300,   301,
     302,   303,   304,    -1,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,   316,   317,   318,   319,    -1,   321,
     322,   323,   324,   325,    -1,   327,   328,   329,   330,   331,
     332,   333,   334,    -1,   336,   337,   338,   339,   340,   341,
     342,   343,   344,   345,   346,    -1,   348,   349,    -1,   351,
     352,   353,   354,   355,   356,    -1,   358,   359,    -1,    -1,
     362,   363,   364,   365,    -1,   367,   368,   369,   370,   371,
     372,   373,    -1,    -1,   376,   377,   378,   379,   380,   381,
      -1,   383,   384,   385,   386,   387,   388,   389,    -1,   391,
     392,   393,   394,   395,   396,    -1,    -1,   399,    -1,    -1,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,
      15,    16,    17,    18,    19,    20,    21,    -1,    23,    24,
      25,    26,    27,    -1,    -1,    30,    -1,    -1,    -1,    34,
      35,    -1,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    -1,    49,    50,    51,    52,    53,    -1,
      -1,    56,    57,    58,    59,    60,    -1,    62,    63,    64,
      65,    66,    -1,    68,    -1,    70,    71,    72,    73,    74,
      75,    76,    -1,    78,    79,    80,    81,    82,    83,    -1,
      85,    86,    87,    -1,    -1,    -1,    91,    -1,    -1,    -1,
      95,    96,    97,    98,    99,   100,   101,   102,   103,    -1,
     105,    -1,   107,   108,   109,   110,   111,    -1,   113,   114,
     115,    -1,    -1,   118,   119,   120,   121,   122,    -1,   124,
     125,   126,    -1,   128,   129,   130,    -1,   132,   133,   134,
     135,   136,   137,   138,   139,   140,    -1,   142,    -1,   144,
     145,   146,   147,    -1,   149,    -1,   151,   152,    -1,   154,
     155,   156,   157,    -1,   159,   160,    -1,   162,    -1,   164,
     165,   166,   167,   168,   169,   170,   171,   172,    -1,   174,
     175,   176,   177,   178,   179,    -1,   181,   182,   183,   184,
     185,   186,   187,   188,   189,    -1,   191,    -1,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,    -1,   204,
     205,    -1,   207,   208,   209,   210,   211,    -1,   213,   214,
     215,    -1,    -1,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,    -1,   238,   239,   240,   241,    -1,   243,   244,
     245,   246,   247,   248,    -1,   250,    -1,    -1,   253,   254,
     255,    -1,    -1,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,    -1,   272,   273,   274,
     275,   276,   277,   278,    -1,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,    -1,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
      -1,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,    -1,   321,   322,   323,   324,
     325,    -1,   327,   328,   329,   330,   331,   332,   333,   334,
      -1,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,    -1,   348,   349,    -1,   351,   352,   353,   354,
     355,   356,    -1,   358,   359,    -1,    -1,   362,   363,   364,
     365,    -1,   367,   368,   369,   370,   371,   372,   373,    -1,
      -1,   376,   377,   378,   379,   380,    -1,    -1,   383,   384,
     385,   386,   387,   388,   389,    -1,   391,   392,   393,   394,
     395,   396,    -1,    -1,   399,    -1,    -1,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,
      18,    19,    20,    21,    22,    23,    24,    25,    -1,    -1,
      -1,    -1,    30,    -1,    -1,    -1,    34,    35,    -1,    37,
      38,    39,    40,    41,    42,    43,    44,    45,    46,    47,
      -1,    49,    50,    51,    52,    53,    -1,    -1,    56,    57,
      58,    59,    60,    -1,    62,    63,    64,    65,    66,    -1,
      68,    -1,    70,    71,    72,    73,    74,    75,    76,    -1,
      78,    79,    80,    81,    82,    83,    -1,    85,    86,    87,
      -1,    -1,    -1,    91,    -1,    -1,    -1,    95,    96,    97,
      98,    99,   100,   101,   102,   103,    -1,   105,    -1,   107,
     108,   109,   110,   111,    -1,   113,   114,   115,    -1,    -1,
     118,   119,   120,   121,   122,    -1,   124,   125,   126,    -1,
     128,   129,   130,    -1,   132,   133,   134,   135,   136,   137,
     138,   139,   140,    -1,   142,    -1,   144,   145,   146,   147,
      -1,   149,    -1,   151,   152,    -1,   154,   155,   156,   157,
      -1,   159,   160,    -1,   162,    -1,   164,   165,   166,   167,
     168,   169,   170,   171,   172,    -1,   174,   175,   176,   177,
     178,   179,    -1,   181,   182,   183,   184,   185,   186,   187,
     188,   189,    -1,   191,    -1,   193,   194,   195,   196,   197,
     198,   199,   200,   201,   202,    -1,   204,   205,    -1,   207,
     208,   209,   210,   211,    -1,   213,   214,   215,    -1,    -1,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,    -1,
     238,   239,   240,   241,    -1,   243,   244,   245,   246,   247,
     248,    -1,   250,    -1,    -1,   253,   254,   255,    -1,    -1,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,    -1,   272,   273,   274,   275,   276,   277,
     278,    -1,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,   290,   291,   292,    -1,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,    -1,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,   316,   317,
     318,   319,    -1,   321,   322,   323,   324,   325,    -1,   327,
     328,   329,   330,   331,   332,   333,   334,    -1,   336,   337,
     338,   339,   340,   341,   342,   343,   344,   345,   346,    -1,
     348,   349,    -1,   351,   352,   353,   354,   355,   356,    -1,
     358,   359,    -1,    -1,   362,   363,   364,   365,    -1,   367,
     368,   369,   370,   371,   372,   373,    -1,    -1,   376,   377,
     378,   379,   380,    -1,    -1,   383,   384,   385,   386,   387,
     388,   389,    -1,   391,   392,   393,   394,   395,   396,    -1,
      -1,   399,    -1,    -1,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,     3,    -1,     5,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    14,    15,    16,    17,    18,    19,    20,
      21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,    30,
      -1,    -1,    -1,    34,    35,    -1,    37,    38,    39,    40,
      41,    42,    43,    44,    45,    46,    47,    -1,    49,    50,
      51,    52,    53,    -1,    -1,    56,    57,    58,    59,    60,
      -1,    62,    63,    64,    65,    66,    -1,    68,    -1,    70,
      71,    72,    73,    74,    75,    76,    -1,    78,    79,    80,
      81,    82,    83,    -1,    85,    86,    87,    -1,    -1,    -1,
      91,    -1,    -1,    -1,    95,    96,    97,    98,    99,   100,
     101,   102,   103,    -1,   105,    -1,   107,   108,   109,   110,
     111,    -1,   113,   114,   115,    -1,    -1,   118,   119,   120,
     121,   122,    -1,   124,   125,   126,    -1,   128,   129,   130,
      -1,   132,   133,   134,   135,   136,   137,   138,   139,   140,
      -1,   142,    -1,   144,   145,   146,   147,    -1,   149,    -1,
     151,   152,    -1,   154,   155,   156,   157,    -1,   159,   160,
      -1,   162,    -1,   164,   165,   166,   167,   168,   169,   170,
     171,   172,    -1,   174,   175,   176,   177,   178,   179,    -1,
     181,   182,   183,   184,   185,   186,   187,   188,   189,    -1,
     191,    -1,   193,   194,   195,   196,   197,   198,   199,   200,
     201,   202,    -1,   204,   205,    -1,   207,   208,   209,   210,
     211,    -1,   213,   214,   215,    -1,    -1,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,    -1,   238,   239,   240,
     241,    -1,   243,   244,   245,   246,   247,   248,    -1,   250,
      -1,    -1,   253,   254,   255,    -1,    -1,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
      -1,   272,   273,   274,   275,   276,   277,   278,    -1,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,   292,    -1,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,   304,    -1,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,   319,    -1,
     321,   322,   323,   324,   325,    -1,   327,   328,   329,   330,
     331,   332,   333,   334,    -1,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,   346,    -1,   348,   349,    -1,
     351,   352,   353,   354,   355,   356,    -1,   358,   359,    -1,
      -1,   362,   363,   364,   365,    -1,   367,   368,   369,   370,
     371,   372,   373,    -1,    -1,   376,   377,   378,   379,   380,
      -1,    -1,   383,   384,   385,   386,   387,   388,   389,    -1,
     391,   392,   393,   394,   395,   396,    -1,    -1,   399,    -1,
      -1,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,   419,     3,
      -1,     5,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      14,    15,    16,    17,    18,    19,    20,    21,    -1,    23,
      24,    25,    -1,    -1,    -1,    -1,    30,    -1,    -1,    -1,
      34,    35,    -1,    37,    38,    39,    40,    41,    42,    43,
      44,    45,    46,    47,    -1,    49,    50,    51,    52,    53,
      -1,    -1,    56,    57,    58,    59,    60,    -1,    62,    63,
      64,    65,    66,    -1,    68,    -1,    70,    71,    72,    73,
      74,    75,    76,    -1,    78,    79,    80,    81,    82,    83,
      -1,    85,    86,    87,    -1,    -1,    -1,    91,    -1,    -1,
      -1,    95,    96,    97,    98,    99,   100,   101,   102,   103,
      -1,   105,    -1,   107,   108,   109,   110,   111,    -1,   113,
     114,   115,    -1,    -1,   118,   119,   120,   121,   122,    -1,
     124,   125,   126,    -1,   128,   129,   130,    -1,   132,   133,
     134,   135,   136,   137,   138,   139,   140,    -1,   142,    -1,
     144,   145,   146,   147,    -1,   149,    -1,   151,   152,    -1,
     154,   155,   156,   157,    -1,   159,   160,    -1,   162,    -1,
     164,   165,   166,   167,   168,   169,   170,   171,   172,    -1,
     174,   175,   176,   177,   178,   179,    -1,   181,   182,   183,
     184,   185,   186,   187,   188,   189,    -1,   191,    -1,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,    -1,
     204,   205,    -1,   207,   208,   209,   210,   211,    -1,   213,
     214,   215,    -1,    -1,   218,   219,   220,   221,   222,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,    -1,   238,   239,   240,   241,    -1,   243,
     244,   245,   246,   247,   248,    -1,   250,    -1,    -1,   253,
     254,   255,    -1,    -1,   258,   259,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,    -1,   272,   273,
     274,   275,   276,   277,   278,    -1,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,   292,    -1,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
     304,    -1,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,   319,    -1,   321,   322,   323,
     324,   325,    -1,   327,   328,   329,   330,   331,   332,   333,
     334,    -1,   336,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,    -1,   348,   349,    -1,   351,   352,   353,
     354,   355,   356,    -1,   358,   359,    -1,    -1,   362,   363,
     364,   365,    -1,   367,   368,   369,   370,   371,   372,   373,
      -1,    -1,   376,   377,   378,   379,   380,    -1,    -1,   383,
     384,   385,   386,   387,   388,   389,    -1,   391,   392,   393,
     394,   395,   396,    -1,    -1,   399,    -1,    -1,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,    15,    16,
      17,    18,    19,    20,    21,    -1,    23,    24,    25,    -1,
      -1,    -1,    -1,    30,    -1,    -1,    -1,    34,    35,    -1,
      37,    38,    39,    40,    41,    42,    43,    44,    45,    46,
      47,    -1,    49,    50,    51,    52,    53,    -1,    -1,    56,
      57,    58,    59,    60,    -1,    62,    63,    64,    65,    66,
      -1,    68,    -1,    70,    71,    72,    73,    74,    75,    76,
      -1,    78,    79,    80,    81,    82,    83,    -1,    85,    86,
      87,    -1,    -1,    -1,    91,    -1,    -1,    -1,    95,    96,
      97,    98,    99,   100,   101,   102,   103,    -1,   105,    -1,
     107,   108,   109,   110,   111,    -1,   113,   114,   115,    -1,
      -1,   118,   119,   120,   121,   122,    -1,   124,   125,   126,
      -1,   128,   129,   130,    -1,   132,   133,   134,   135,   136,
     137,   138,   139,   140,    -1,   142,    -1,   144,   145,   146,
     147,    -1,   149,    -1,   151,   152,    -1,   154,   155,   156,
     157,    -1,   159,   160,   161,   162,    -1,   164,   165,   166,
     167,   168,   169,   170,   171,   172,    -1,   174,   175,   176,
     177,   178,   179,    -1,   181,   182,   183,   184,   185,   186,
     187,   188,   189,    -1,   191,    -1,   193,   194,   195,   196,
     197,   198,   199,   200,   201,   202,    -1,   204,   205,    -1,
     207,   208,   209,   210,   211,    -1,   213,   214,   215,    -1,
      -1,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
      -1,   238,   239,   240,   241,    -1,   243,   244,   245,   246,
     247,   248,    -1,   250,    -1,    -1,   253,   254,   255,    -1,
      -1,   258,   259,   260,   261,   262,   263,   264,   265,   266,
     267,   268,   269,   270,    -1,   272,   273,   274,   275,   276,
     277,   278,    -1,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,   292,    -1,   294,   295,   296,
     297,   298,   299,   300,   301,   302,   303,   304,    -1,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,    -1,   321,   322,   323,   324,   325,    -1,
     327,   328,   329,   330,   331,   332,   333,   334,    -1,   336,
     337,   338,   339,   340,   341,   342,   343,   344,   345,   346,
      -1,   348,   349,    -1,   351,   352,   353,   354,   355,   356,
      -1,   358,   359,    -1,    -1,   362,   363,   364,   365,    -1,
     367,   368,   369,   370,   371,   372,   373,    -1,    -1,   376,
     377,   378,   379,   380,    -1,    -1,   383,   384,   385,   386,
     387,   388,   389,    -1,   391,   392,   393,   394,   395,   396,
      -1,    -1,   399,    -1,    -1,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,    19,
      20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,
      30,    -1,    -1,    -1,    34,    35,    -1,    37,    38,    39,
      40,    41,    42,    43,    44,    45,    46,    47,    -1,    49,
      50,    51,    52,    53,    -1,    -1,    56,    57,    58,    59,
      60,    -1,    62,    63,    64,    65,    66,    -1,    68,    -1,
      70,    71,    72,    73,    74,    75,    76,    -1,    78,    79,
      80,    81,    82,    83,    -1,    85,    86,    87,    -1,    -1,
      -1,    91,    -1,    -1,    -1,    95,    96,    97,    98,    99,
     100,   101,   102,   103,    -1,   105,    -1,   107,   108,   109,
     110,   111,    -1,   113,   114,   115,    -1,    -1,   118,   119,
     120,   121,   122,    -1,   124,   125,   126,    -1,   128,   129,
     130,    -1,   132,   133,   134,   135,   136,   137,   138,   139,
     140,    -1,   142,    -1,   144,   145,   146,   147,    -1,   149,
      -1,   151,   152,    -1,   154,   155,   156,   157,    -1,   159,
     160,    -1,   162,    -1,   164,   165,   166,   167,   168,   169,
     170,   171,   172,    -1,   174,   175,   176,   177,   178,   179,
      -1,   181,   182,   183,   184,   185,   186,   187,   188,   189,
      -1,   191,    -1,   193,   194,   195,   196,   197,   198,   199,
     200,   201,   202,    -1,   204,   205,    -1,   207,   208,   209,
     210,   211,    -1,   213,   214,   215,    -1,    -1,   218,   219,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,    -1,   238,   239,
     240,   241,    -1,   243,   244,   245,   246,   247,   248,    -1,
     250,    -1,    -1,   253,   254,   255,    -1,    -1,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,    -1,   272,   273,   274,   275,   276,   277,   278,    -1,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,   292,    -1,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,   304,    -1,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
      -1,   321,   322,   323,   324,   325,    -1,   327,   328,   329,
     330,   331,   332,   333,   334,    -1,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,    -1,   348,   349,
      -1,   351,   352,   353,   354,   355,   356,    -1,   358,   359,
      -1,    -1,   362,   363,   364,   365,    -1,   367,   368,   369,
     370,   371,   372,   373,    -1,    -1,   376,   377,   378,   379,
     380,    -1,    -1,   383,   384,   385,   386,   387,   388,   389,
      -1,   391,   392,   393,   394,   395,   396,    -1,    -1,   399,
      -1,    -1,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    14,    15,    16,    17,    18,    19,    20,    21,    -1,
      23,    24,    25,    -1,    -1,    -1,    -1,    30,    -1,    -1,
      -1,    34,    35,    -1,    37,    38,    39,    40,    41,    42,
      43,    44,    45,    46,    47,    -1,    49,    50,    51,    52,
      53,    -1,    -1,    56,    57,    58,    59,    60,    -1,    62,
      63,    64,    65,    66,    -1,    68,    -1,    70,    71,    72,
      73,    74,    75,    76,    -1,    78,    79,    80,    81,    82,
      83,    -1,    85,    86,    87,    -1,    -1,    -1,    91,    -1,
      -1,    -1,    95,    96,    97,    98,    99,   100,   101,   102,
     103,    -1,   105,    -1,   107,   108,   109,   110,   111,    -1,
     113,   114,   115,    -1,    -1,   118,   119,   120,   121,   122,
      -1,   124,   125,   126,    -1,   128,   129,   130,    -1,   132,
     133,   134,   135,   136,   137,   138,   139,   140,    -1,   142,
      -1,   144,   145,   146,   147,    -1,   149,    -1,   151,   152,
      -1,   154,   155,   156,   157,    -1,   159,   160,    -1,   162,
      -1,   164,   165,   166,   167,   168,   169,   170,   171,   172,
      -1,   174,   175,   176,   177,   178,   179,    -1,   181,   182,
     183,   184,   185,   186,   187,   188,   189,    -1,   191,    -1,
     193,   194,   195,   196,   197,   198,   199,   200,   201,   202,
      -1,   204,   205,    -1,   207,   208,   209,   210,   211,    -1,
     213,   214,   215,    -1,    -1,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,    -1,   238,   239,   240,   241,    -1,
     243,   244,   245,   246,   247,   248,    -1,   250,    -1,    -1,
     253,   254,   255,    -1,    -1,   258,   259,   260,   261,   262,
     263,   264,   265,   266,   267,   268,   269,   270,    -1,   272,
     273,   274,   275,   276,   277,   278,    -1,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,   292,
      -1,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,   304,    -1,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,   317,   318,   319,    -1,   321,   322,
     323,   324,   325,    -1,   327,   328,   329,   330,   331,   332,
     333,   334,    -1,   336,   337,   338,   339,   340,   341,   342,
     343,   344,   345,   346,    -1,   348,   349,    -1,   351,   352,
     353,   354,   355,   356,    -1,   358,   359,    -1,    -1,   362,
     363,   364,   365,    -1,   367,   368,   369,   370,   371,   372,
     373,    -1,    -1,   376,   377,   378,   379,   380,    -1,    -1,
     383,   384,   385,   386,   387,   388,   389,    -1,   391,   392,
     393,   394,   395,   396,    -1,    -1,   399,    -1,    -1,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,    15,
      16,    17,    18,    19,    20,    21,    -1,    23,    24,    25,
      -1,    -1,    -1,    -1,    30,    -1,    -1,    -1,    34,    35,
      -1,    37,    38,    39,    40,    41,    42,    43,    44,    45,
      46,    47,    -1,    49,    50,    51,    52,    53,    -1,    -1,
      56,    57,    58,    59,    60,    -1,    62,    63,    64,    65,
      66,    -1,    68,    -1,    70,    71,    72,    73,    74,    75,
      76,    -1,    78,    79,    80,    81,    82,    83,    -1,    85,
      86,    87,    -1,    -1,    -1,    91,    -1,    -1,    -1,    95,
      96,    97,    98,    99,   100,   101,   102,   103,    -1,   105,
      -1,   107,   108,   109,   110,   111,    -1,   113,   114,   115,
      -1,    -1,   118,   119,   120,   121,   122,    -1,   124,   125,
     126,    -1,   128,   129,   130,    -1,   132,   133,   134,   135,
     136,   137,   138,   139,   140,    -1,   142,    -1,   144,   145,
     146,   147,    -1,   149,    -1,   151,   152,    -1,   154,   155,
     156,   157,    -1,   159,   160,    -1,   162,    -1,   164,   165,
     166,   167,   168,   169,   170,   171,   172,    -1,   174,   175,
     176,   177,   178,   179,    -1,   181,   182,   183,   184,   185,
     186,   187,   188,   189,    -1,   191,    -1,   193,   194,   195,
     196,   197,   198,   199,   200,   201,   202,    -1,   204,   205,
      -1,   207,   208,   209,   210,   211,    -1,   213,   214,   215,
      -1,    -1,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,    -1,   238,   239,   240,   241,    -1,   243,   244,   245,
     246,   247,   248,    -1,   250,    -1,    -1,   253,   254,   255,
      -1,    -1,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,    -1,   272,   273,   274,   275,
     276,   277,   278,    -1,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,   292,    -1,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,    -1,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,   319,    -1,   321,   322,   323,   324,   325,
      -1,   327,   328,   329,   330,   331,   332,   333,   334,    -1,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,    -1,   348,   349,    -1,   351,   352,   353,   354,   355,
     356,    -1,   358,   359,    -1,    -1,   362,   363,   364,   365,
      -1,   367,   368,   369,   370,   371,   372,   373,    -1,    -1,
     376,   377,   378,   379,   380,    -1,    -1,   383,   384,   385,
     386,   387,   388,   389,    -1,   391,   392,   393,   394,   395,
     396,    -1,    -1,   399,    -1,    -1,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,
      19,    20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,
      -1,    30,    -1,    -1,    -1,    34,    35,    -1,    37,    38,
      39,    40,    41,    42,    43,    44,    45,    46,    47,    -1,
      49,    50,    51,    52,    53,    -1,    -1,    56,    57,    58,
      59,    60,    -1,    62,    63,    64,    65,    66,    -1,    68,
      -1,    70,    71,    72,    73,    74,    75,    76,    -1,    78,
      79,    80,    81,    82,    83,    -1,    85,    86,    87,    -1,
      -1,    -1,    91,    -1,    -1,    -1,    95,    96,    97,    98,
      99,   100,   101,   102,   103,    -1,   105,    -1,   107,   108,
     109,   110,   111,    -1,   113,   114,   115,    -1,    -1,   118,
     119,   120,   121,   122,    -1,   124,   125,   126,    -1,   128,
     129,   130,    -1,   132,   133,   134,   135,   136,   137,   138,
     139,   140,    -1,   142,    -1,   144,   145,   146,   147,    -1,
     149,    -1,   151,   152,    -1,   154,   155,   156,   157,    -1,
     159,   160,    -1,   162,    -1,   164,   165,   166,   167,   168,
     169,   170,   171,   172,    -1,   174,   175,   176,   177,   178,
     179,    -1,   181,   182,   183,   184,   185,   186,   187,   188,
     189,    -1,   191,    -1,   193,   194,   195,   196,   197,   198,
     199,   200,   201,   202,    -1,   204,   205,    -1,   207,   208,
     209,   210,   211,    -1,   213,   214,   215,    -1,    -1,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,    -1,   238,
     239,   240,   241,    -1,   243,   244,   245,   246,   247,   248,
      -1,   250,    -1,    -1,   253,   254,   255,    -1,    -1,   258,
     259,   260,   261,   262,   263,   264,   265,   266,   267,   268,
     269,   270,    -1,   272,   273,   274,   275,   276,   277,   278,
      -1,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,   292,    -1,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,   304,    -1,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   316,   317,   318,
     319,    -1,   321,   322,   323,   324,   325,    -1,   327,   328,
     329,   330,   331,   332,   333,   334,    -1,   336,   337,   338,
     339,   340,   341,   342,   343,   344,   345,   346,    -1,   348,
     349,    -1,   351,   352,   353,   354,   355,   356,    -1,   358,
     359,    -1,    -1,   362,   363,   364,   365,    -1,   367,   368,
     369,   370,   371,   372,   373,    -1,    -1,   376,   377,   378,
     379,   380,    -1,    -1,   383,   384,   385,   386,   387,   388,
     389,    -1,   391,   392,   393,   394,   395,   396,    -1,    -1,
     399,    -1,    -1,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    14,    15,    16,    17,    18,    19,    20,    21,
      -1,    23,    24,    25,    -1,    -1,    -1,    -1,    30,    -1,
      -1,    -1,    34,    35,    -1,    37,    38,    39,    40,    41,
      42,    43,    44,    45,    46,    47,    -1,    49,    50,    51,
      52,    53,    -1,    -1,    56,    57,    58,    59,    60,    -1,
      62,    63,    64,    65,    66,    -1,    68,    -1,    70,    71,
      72,    73,    74,    75,    76,    -1,    78,    79,    80,    81,
      82,    83,    -1,    85,    86,    87,    -1,    -1,    -1,    91,
      -1,    -1,    -1,    95,    96,    97,    98,    99,   100,   101,
     102,   103,    -1,   105,    -1,   107,   108,   109,   110,   111,
      -1,   113,   114,   115,    -1,    -1,   118,   119,   120,   121,
     122,    -1,   124,   125,   126,    -1,   128,   129,   130,    -1,
     132,   133,   134,   135,   136,   137,   138,   139,   140,    -1,
     142,    -1,   144,   145,   146,   147,    -1,   149,    -1,   151,
     152,    -1,   154,   155,   156,   157,    -1,   159,   160,    -1,
     162,    -1,   164,   165,   166,   167,   168,   169,   170,   171,
     172,    -1,   174,   175,   176,   177,   178,   179,    -1,   181,
     182,   183,   184,   185,   186,   187,   188,   189,    -1,   191,
      -1,   193,   194,   195,   196,   197,   198,   199,   200,   201,
     202,    -1,   204,   205,    -1,   207,   208,   209,   210,   211,
      -1,   213,   214,   215,    -1,    -1,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,    -1,   238,   239,   240,   241,
      -1,   243,   244,   245,   246,   247,   248,    -1,   250,    -1,
      -1,   253,   254,   255,    -1,    -1,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,    -1,
     272,   273,   274,   275,   276,   277,   278,    -1,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
     292,    -1,   294,   295,   296,   297,   298,   299,   300,   301,
     302,   303,   304,    -1,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,   316,   317,   318,   319,    -1,   321,
     322,   323,   324,   325,    -1,   327,   328,   329,   330,   331,
     332,   333,   334,    -1,   336,   337,   338,   339,   340,   341,
     342,   343,   344,   345,   346,    -1,   348,   349,    -1,   351,
     352,   353,   354,   355,   356,    -1,   358,   359,    -1,    -1,
     362,   363,   364,   365,    -1,   367,   368,   369,   370,   371,
     372,   373,    -1,    -1,   376,   377,   378,   379,   380,    -1,
      -1,   383,   384,   385,   386,   387,   388,   389,    -1,   391,
     392,   393,   394,   395,   396,    -1,    -1,   399,    -1,    -1,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,
      15,    16,    17,    18,    19,    20,    21,    -1,    23,    24,
      25,    -1,    -1,    -1,    -1,    30,    -1,    -1,    -1,    34,
      35,    -1,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    -1,    49,    50,    51,    52,    53,    -1,
      -1,    56,    57,    58,    59,    60,    -1,    62,    63,    64,
      65,    66,    -1,    68,    -1,    70,    71,    72,    73,    74,
      75,    76,    -1,    78,    79,    80,    81,    82,    83,    -1,
      85,    86,    87,    -1,    -1,    -1,    91,    -1,    -1,    -1,
      95,    96,    97,    98,    99,   100,   101,   102,   103,    -1,
     105,    -1,   107,   108,   109,   110,   111,    -1,   113,   114,
     115,    -1,    -1,   118,   119,   120,   121,   122,    -1,   124,
     125,   126,    -1,   128,   129,   130,    -1,   132,   133,   134,
     135,   136,   137,   138,   139,   140,    -1,   142,    -1,   144,
     145,   146,   147,    -1,   149,    -1,   151,   152,    -1,   154,
     155,   156,   157,    -1,   159,   160,    -1,   162,    -1,   164,
     165,   166,   167,   168,   169,   170,   171,   172,    -1,   174,
     175,   176,   177,   178,   179,    -1,   181,   182,   183,   184,
     185,   186,   187,   188,   189,    -1,   191,    -1,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,    -1,   204,
     205,    -1,   207,   208,   209,   210,   211,    -1,   213,   214,
     215,    -1,    -1,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,    -1,   238,   239,   240,   241,    -1,   243,   244,
     245,   246,   247,   248,    -1,   250,    -1,    -1,   253,   254,
     255,    -1,    -1,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,    -1,   272,   273,   274,
     275,   276,   277,   278,    -1,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,    -1,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
      -1,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,    -1,   321,   322,   323,   324,
     325,    -1,   327,   328,   329,   330,   331,   332,   333,   334,
      -1,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,    -1,   348,   349,    -1,   351,   352,   353,   354,
     355,   356,    -1,   358,   359,    -1,    -1,   362,   363,   364,
     365,    -1,   367,   368,   369,   370,   371,   372,   373,    -1,
      -1,   376,   377,   378,   379,   380,    -1,    -1,   383,   384,
     385,   386,   387,   388,   389,    -1,   391,   392,   393,   394,
     395,   396,    -1,    -1,   399,    -1,    -1,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,
      18,    19,    20,    21,    -1,    23,    24,    25,    -1,    -1,
      -1,    -1,    30,    -1,    -1,    -1,    34,    35,    -1,    37,
      38,    39,    40,    41,    42,    43,    44,    45,    46,    47,
      -1,    49,    50,    51,    52,    53,    -1,    -1,    56,    57,
      58,    59,    60,    -1,    62,    63,    64,    65,    66,    -1,
      68,    -1,    70,    71,    72,    73,    74,    75,    76,    -1,
      78,    79,    80,    81,    82,    83,    -1,    85,    86,    87,
      -1,    -1,    -1,    91,    -1,    -1,    -1,    95,    96,    97,
      98,    99,   100,   101,   102,   103,    -1,   105,    -1,   107,
     108,   109,   110,   111,    -1,   113,   114,   115,    -1,    -1,
     118,   119,   120,   121,   122,    -1,   124,   125,   126,    -1,
     128,   129,   130,    -1,   132,   133,   134,   135,   136,   137,
     138,   139,   140,    -1,   142,    -1,   144,   145,   146,   147,
      -1,   149,    -1,   151,   152,    -1,   154,   155,   156,   157,
      -1,   159,   160,    -1,   162,    -1,   164,   165,   166,   167,
     168,   169,   170,   171,   172,    -1,   174,   175,   176,   177,
     178,   179,    -1,   181,   182,   183,   184,   185,   186,   187,
     188,   189,    -1,   191,    -1,   193,   194,   195,   196,   197,
     198,   199,   200,   201,   202,    -1,   204,   205,    -1,   207,
     208,   209,   210,   211,    -1,   213,   214,   215,    -1,    -1,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,    -1,
     238,   239,   240,   241,    -1,   243,   244,   245,   246,   247,
     248,    -1,   250,    -1,    -1,   253,   254,   255,    -1,    -1,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,    -1,   272,   273,   274,   275,   276,   277,
     278,    -1,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,   290,   291,   292,    -1,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,    -1,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,   316,   317,
     318,   319,    -1,   321,   322,   323,   324,   325,    -1,   327,
     328,   329,   330,   331,   332,   333,   334,    -1,   336,   337,
     338,   339,   340,   341,   342,   343,   344,   345,   346,    -1,
     348,   349,    -1,   351,   352,   353,   354,   355,   356,    -1,
     358,   359,    -1,    -1,   362,   363,   364,   365,    -1,   367,
     368,   369,   370,   371,   372,   373,    -1,    -1,   376,   377,
     378,   379,   380,    -1,    -1,   383,   384,   385,   386,   387,
     388,   389,    -1,   391,   392,   393,   394,   395,   396,    -1,
      -1,   399,    -1,    -1,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    14,    15,    16,    17,    18,    19,    20,
      21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,    30,
      -1,    -1,    -1,    34,    35,    -1,    37,    38,    39,    40,
      41,    42,    43,    44,    45,    46,    47,    -1,    49,    50,
      51,    52,    53,    -1,    -1,    56,    57,    58,    59,    60,
      -1,    62,    63,    64,    65,    66,    -1,    68,    -1,    70,
      71,    72,    73,    74,    75,    76,    -1,    78,    79,    80,
      81,    82,    83,    -1,    85,    86,    87,    -1,    -1,    -1,
      91,    -1,    -1,    -1,    95,    96,    97,    98,    99,   100,
     101,   102,   103,    -1,   105,    -1,   107,   108,   109,   110,
     111,    -1,   113,   114,   115,    -1,    -1,   118,   119,   120,
     121,   122,    -1,   124,   125,   126,    -1,   128,   129,   130,
      -1,   132,   133,   134,   135,   136,   137,   138,   139,   140,
      -1,   142,    -1,   144,   145,   146,   147,    -1,   149,    -1,
     151,   152,    -1,   154,   155,   156,   157,    -1,   159,   160,
      -1,   162,    -1,   164,   165,   166,   167,   168,   169,   170,
     171,   172,    -1,   174,   175,   176,   177,   178,   179,    -1,
     181,   182,   183,   184,   185,   186,   187,   188,   189,    -1,
     191,    -1,   193,   194,   195,   196,   197,   198,   199,   200,
     201,   202,    -1,   204,   205,    -1,   207,   208,   209,   210,
     211,    -1,   213,   214,   215,    -1,    -1,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,    -1,   238,   239,   240,
     241,    -1,   243,   244,   245,   246,   247,   248,    -1,   250,
      -1,    -1,   253,   254,   255,    -1,    -1,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
      -1,   272,   273,   274,   275,   276,   277,   278,    -1,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,   292,    -1,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,   304,    -1,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,   319,    -1,
     321,   322,   323,   324,   325,    -1,   327,   328,   329,   330,
     331,   332,   333,   334,    -1,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,   346,    -1,   348,   349,    -1,
     351,   352,   353,   354,   355,   356,    -1,   358,   359,    -1,
      -1,   362,   363,   364,   365,    -1,   367,   368,   369,   370,
     371,   372,   373,    -1,    -1,   376,   377,   378,   379,   380,
      -1,    -1,   383,   384,   385,   386,   387,   388,   389,    -1,
     391,   392,   393,   394,   395,   396,    -1,    -1,   399,    -1,
      -1,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,   419,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      14,    15,    16,    17,    18,    19,    20,    21,    -1,    23,
      24,    25,    -1,    -1,    -1,    -1,    30,    -1,    -1,    -1,
      34,    35,    -1,    37,    38,    39,    40,    41,    42,    43,
      44,    45,    46,    47,    -1,    49,    50,    51,    52,    53,
      -1,    -1,    56,    57,    58,    59,    60,    -1,    62,    63,
      64,    65,    66,    -1,    68,    -1,    70,    71,    72,    73,
      74,    75,    76,    -1,    78,    79,    80,    81,    82,    83,
      -1,    85,    86,    87,    -1,    -1,    -1,    91,    -1,    -1,
      -1,    95,    96,    97,    98,    99,   100,   101,   102,   103,
      -1,   105,    -1,   107,   108,   109,   110,   111,    -1,   113,
     114,   115,    -1,    -1,   118,   119,   120,   121,   122,    -1,
     124,   125,   126,    -1,   128,   129,   130,    -1,   132,   133,
     134,   135,   136,   137,   138,   139,   140,    -1,   142,    -1,
     144,   145,   146,   147,    -1,   149,    -1,   151,   152,    -1,
     154,   155,   156,   157,    -1,   159,   160,    -1,   162,    -1,
     164,   165,   166,   167,   168,   169,   170,   171,   172,    -1,
     174,   175,   176,   177,   178,   179,    -1,   181,   182,   183,
     184,   185,   186,   187,   188,   189,    -1,   191,    -1,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,    -1,
     204,   205,    -1,   207,   208,   209,   210,   211,    -1,   213,
     214,   215,    -1,    -1,   218,   219,   220,   221,   222,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,    -1,   238,   239,   240,   241,    -1,   243,
     244,   245,   246,   247,   248,    -1,   250,    -1,    -1,   253,
     254,   255,    -1,    -1,   258,   259,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,    -1,   272,   273,
     274,   275,   276,   277,   278,    -1,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,   292,    -1,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
     304,    -1,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,   319,    -1,   321,   322,   323,
     324,   325,    -1,   327,   328,   329,   330,   331,   332,   333,
     334,    -1,   336,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,    -1,   348,   349,    -1,   351,   352,   353,
     354,   355,   356,    -1,   358,   359,    -1,    -1,   362,   363,
     364,   365,    -1,   367,   368,   369,   370,   371,   372,   373,
      -1,    -1,   376,   377,   378,   379,   380,    -1,    -1,   383,
     384,   385,   386,   387,   388,   389,    -1,   391,   392,   393,
     394,   395,   396,    -1,    -1,   399,    -1,    -1,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,    15,    16,
      17,    18,    19,    20,    21,    -1,    23,    24,    25,    -1,
      -1,    -1,    -1,    30,    -1,    -1,    -1,    34,    35,    -1,
      37,    38,    -1,    40,    41,    42,    43,    44,    -1,    46,
      47,    -1,    49,    50,    51,    52,    53,    -1,    -1,    56,
      57,    58,    59,    60,    61,    62,    63,    64,    65,    66,
      -1,    -1,    69,    70,    71,    72,    73,    -1,    75,    76,
      77,    78,    79,    80,    81,    82,    83,    -1,    -1,    86,
      87,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    95,    96,
      97,    98,    99,   100,   101,   102,   103,    -1,   105,    -1,
     107,   108,   109,   110,   111,    -1,   113,   114,   115,    -1,
      -1,   118,   119,   120,   121,   122,    -1,   124,   125,   126,
      -1,   128,   129,   130,    -1,   132,   133,   134,   135,   136,
     137,   138,   139,   140,    -1,   142,    -1,   144,   145,   146,
     147,    -1,   149,   150,   151,    -1,    -1,    -1,   155,   156,
     157,    -1,   159,   160,    -1,   162,    -1,   164,   165,   166,
     167,   168,    -1,   170,   171,   172,    -1,   174,   175,   176,
     177,   178,   179,    -1,   181,    -1,   183,   184,   185,   186,
     187,   188,   189,    -1,   191,    -1,   193,    -1,    -1,   196,
      -1,   198,   199,   200,   201,   202,    -1,   204,   205,    -1,
     207,   208,    -1,   210,    -1,    -1,   213,   214,   215,    -1,
      -1,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,    -1,   233,   234,   235,   236,
      -1,   238,   239,    -1,   241,    -1,   243,   244,   245,   246,
     247,   248,    -1,   250,    -1,    -1,   253,   254,   255,    -1,
      -1,   258,   259,    -1,   261,    -1,   263,   264,   265,   266,
     267,   268,   269,   270,    -1,   272,   273,   274,   275,   276,
     277,   278,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,   292,    -1,   294,   295,   296,
     297,   298,   299,   300,   301,   302,   303,   304,    -1,   306,
     307,    -1,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,    -1,   321,   322,   323,   324,   325,    -1,
     327,   328,   329,   330,    -1,   332,   333,   334,    -1,   336,
     337,   338,   339,   340,   341,   342,   343,   344,   345,   346,
      -1,   348,   349,    -1,   351,   352,   353,   354,   355,   356,
      -1,   358,   359,    -1,    -1,   362,   363,   364,   365,    -1,
     367,   368,   369,   370,   371,   372,   373,    -1,   375,   376,
     377,   378,   379,   380,    -1,    -1,   383,   384,   385,   386,
     387,   388,   389,    -1,   391,    -1,   393,   394,   395,   396,
      -1,    -1,   399,    -1,    -1,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,    19,
      20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,
      30,    -1,    -1,    -1,    34,    35,    -1,    37,    38,    -1,
      40,    41,    42,    43,    44,    -1,    46,    47,    -1,    49,
      50,    51,    52,    53,    -1,    -1,    56,    57,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    -1,    -1,    -1,
      70,    71,    72,    73,    -1,    75,    76,    77,    78,    79,
      80,    81,    82,    83,    -1,    -1,    86,    87,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    95,    96,    97,    98,    99,
     100,   101,   102,   103,    -1,   105,    -1,   107,   108,   109,
     110,   111,    -1,   113,   114,   115,    -1,    -1,   118,   119,
     120,   121,   122,    -1,   124,   125,   126,    -1,   128,   129,
     130,    -1,   132,   133,   134,   135,   136,   137,   138,   139,
     140,    -1,   142,    -1,   144,   145,   146,   147,    -1,   149,
     150,   151,    -1,    -1,    -1,   155,   156,   157,    -1,   159,
     160,    -1,   162,    -1,   164,   165,   166,   167,   168,    -1,
     170,   171,   172,    -1,   174,   175,   176,   177,   178,   179,
      -1,   181,    -1,   183,   184,   185,   186,   187,   188,   189,
      -1,   191,    -1,   193,    -1,    -1,   196,    -1,   198,   199,
     200,   201,   202,    -1,   204,   205,    -1,   207,   208,    -1,
     210,   211,    -1,   213,   214,   215,    -1,    -1,   218,   219,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,    -1,   233,   234,   235,   236,    -1,   238,   239,
      -1,   241,    -1,   243,   244,   245,   246,   247,   248,    -1,
     250,    -1,    -1,   253,   254,   255,    -1,    -1,   258,   259,
      -1,   261,    -1,   263,   264,   265,   266,   267,   268,   269,
     270,    -1,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,   292,    -1,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,   304,    -1,   306,   307,    -1,   309,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
      -1,   321,   322,   323,   324,   325,    -1,   327,   328,   329,
     330,    -1,   332,   333,   334,    -1,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,    -1,   348,   349,
      -1,   351,   352,   353,   354,   355,   356,    -1,   358,   359,
      -1,    -1,   362,   363,   364,   365,    -1,   367,   368,   369,
     370,   371,   372,   373,    -1,   375,   376,   377,   378,   379,
     380,    -1,    -1,   383,   384,   385,   386,   387,   388,   389,
      -1,   391,    -1,   393,   394,   395,   396,    -1,    -1,   399,
      -1,    -1,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    14,    15,    16,    17,    18,    19,    20,    21,    22,
      23,    24,    25,    -1,    -1,    -1,    -1,    30,    -1,    -1,
      -1,    34,    35,    -1,    37,    38,    -1,    40,    41,    42,
      43,    44,    -1,    46,    47,    -1,    49,    50,    51,    52,
      53,    -1,    -1,    56,    57,    58,    59,    60,    -1,    62,
      63,    64,    65,    66,    -1,    -1,    -1,    70,    71,    72,
      73,    -1,    75,    76,    -1,    78,    79,    80,    81,    82,
      83,    84,    -1,    86,    87,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    95,    96,    97,    98,    99,   100,   101,   102,
     103,    -1,   105,    -1,   107,   108,   109,   110,   111,    -1,
     113,   114,   115,    -1,    -1,   118,   119,   120,   121,   122,
      -1,   124,   125,   126,    -1,   128,   129,   130,    -1,   132,
     133,   134,   135,   136,   137,   138,   139,   140,    -1,   142,
      -1,   144,   145,   146,   147,    -1,   149,    -1,   151,    -1,
      -1,    -1,   155,   156,   157,   158,   159,   160,    -1,   162,
      -1,   164,   165,   166,   167,   168,    -1,   170,   171,   172,
      -1,   174,   175,   176,   177,   178,   179,    -1,   181,    -1,
     183,   184,   185,   186,   187,   188,   189,    -1,   191,    -1,
     193,    -1,    -1,   196,    -1,   198,   199,   200,   201,   202,
      -1,   204,   205,    -1,   207,   208,    -1,   210,    -1,    -1,
     213,   214,   215,    -1,    -1,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,    -1,
     233,   234,   235,   236,    -1,   238,   239,    -1,   241,    -1,
     243,   244,   245,   246,   247,   248,    -1,   250,    -1,    -1,
     253,   254,   255,    -1,    -1,   258,   259,    -1,   261,    -1,
     263,   264,   265,   266,   267,   268,   269,   270,    -1,   272,
     273,   274,   275,   276,   277,   278,    -1,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,   304,    -1,   306,   307,    -1,   309,   310,   311,   312,
     313,   314,   315,   316,   317,   318,   319,   320,   321,   322,
     323,   324,   325,    -1,   327,   328,   329,   330,    -1,   332,
     333,   334,    -1,   336,   337,   338,   339,   340,   341,   342,
     343,   344,   345,   346,    -1,   348,   349,    -1,   351,   352,
     353,   354,   355,   356,    -1,   358,   359,    -1,    -1,   362,
     363,   364,   365,    -1,   367,   368,   369,   370,   371,   372,
     373,    -1,    -1,   376,   377,   378,   379,   380,    -1,    -1,
     383,   384,   385,   386,   387,   388,   389,    -1,   391,    -1,
     393,   394,   395,   396,    -1,    -1,   399,    -1,    -1,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,    15,
      16,    17,    18,    19,    20,    21,    22,    23,    24,    25,
      -1,    -1,    -1,    -1,    30,    -1,    -1,    -1,    34,    35,
      -1,    37,    38,    -1,    40,    41,    42,    43,    44,    -1,
      46,    47,    -1,    49,    50,    51,    52,    53,    -1,    -1,
      56,    57,    58,    59,    60,    -1,    62,    63,    64,    65,
      66,    -1,    -1,    -1,    70,    71,    72,    73,    -1,    75,
      76,    -1,    78,    79,    80,    81,    82,    83,    84,    -1,
      86,    87,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    95,
      96,    97,    98,    99,   100,   101,   102,   103,    -1,   105,
      -1,   107,   108,   109,   110,   111,    -1,   113,   114,   115,
      -1,    -1,   118,   119,   120,   121,   122,    -1,   124,   125,
     126,    -1,   128,   129,   130,    -1,   132,   133,   134,   135,
     136,   137,   138,   139,   140,    -1,   142,    -1,   144,   145,
     146,   147,    -1,   149,    -1,   151,    -1,    -1,    -1,   155,
     156,   157,   158,   159,   160,    -1,   162,    -1,   164,   165,
     166,   167,   168,    -1,   170,   171,   172,    -1,   174,   175,
     176,   177,   178,   179,    -1,   181,    -1,   183,   184,   185,
     186,   187,   188,   189,    -1,   191,    -1,   193,    -1,    -1,
     196,    -1,   198,   199,   200,   201,   202,    -1,   204,   205,
      -1,   207,   208,    -1,   210,    -1,    -1,   213,   214,   215,
      -1,    -1,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,    -1,   233,   234,   235,
     236,    -1,   238,   239,    -1,   241,    -1,   243,   244,   245,
     246,   247,   248,    -1,   250,    -1,    -1,   253,   254,   255,
      -1,    -1,   258,   259,    -1,   261,    -1,   263,   264,   265,
     266,   267,   268,   269,   270,    -1,   272,   273,   274,   275,
     276,   277,   278,    -1,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,    -1,
     306,   307,    -1,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,   319,   320,   321,   322,   323,   324,   325,
      -1,   327,   328,   329,   330,    -1,   332,   333,   334,    -1,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,    -1,   348,   349,    -1,   351,   352,   353,   354,   355,
     356,    -1,   358,   359,    -1,    -1,   362,   363,   364,   365,
      -1,   367,   368,   369,   370,   371,   372,   373,    -1,    -1,
     376,   377,   378,   379,   380,    -1,    -1,   383,   384,   385,
     386,   387,   388,   389,    -1,   391,    -1,   393,   394,   395,
     396,    -1,    -1,   399,    -1,    -1,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,
      19,    20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,
      -1,    30,    -1,    -1,    -1,    34,    35,    -1,    37,    38,
      -1,    40,    41,    42,    43,    44,    -1,    46,    47,    -1,
      49,    50,    51,    52,    53,    -1,    -1,    56,    57,    58,
      59,    60,    61,    62,    63,    64,    65,    66,    -1,    -1,
      -1,    70,    71,    72,    73,    -1,    75,    76,    77,    78,
      79,    80,    81,    82,    83,    -1,    -1,    86,    87,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    95,    96,    97,    98,
      99,   100,   101,   102,   103,    -1,   105,    -1,   107,   108,
     109,   110,   111,    -1,   113,   114,   115,    -1,    -1,   118,
     119,   120,   121,   122,    -1,   124,   125,   126,    -1,   128,
     129,   130,    -1,   132,   133,   134,   135,   136,   137,   138,
     139,   140,    -1,   142,    -1,   144,   145,   146,   147,    -1,
     149,   150,   151,    -1,    -1,    -1,   155,   156,   157,    -1,
     159,   160,    -1,   162,    -1,   164,   165,   166,   167,   168,
      -1,   170,   171,   172,    -1,   174,   175,   176,   177,   178,
     179,    -1,   181,    -1,   183,   184,   185,   186,   187,   188,
     189,    -1,   191,    -1,   193,    -1,    -1,   196,    -1,   198,
     199,   200,   201,   202,    -1,   204,   205,    -1,   207,   208,
      -1,   210,    -1,    -1,   213,   214,   215,    -1,    -1,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,    -1,   233,   234,   235,   236,    -1,   238,
     239,    -1,   241,    -1,   243,   244,   245,   246,   247,   248,
      -1,   250,    -1,    -1,   253,   254,   255,    -1,    -1,   258,
     259,    -1,   261,    -1,   263,   264,   265,   266,   267,   268,
     269,   270,    -1,   272,   273,   274,   275,   276,   277,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,   292,    -1,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,   304,    -1,   306,   307,    -1,
     309,   310,   311,   312,   313,   314,   315,   316,   317,   318,
     319,    -1,   321,   322,   323,   324,   325,    -1,   327,   328,
     329,   330,    -1,   332,   333,   334,    -1,   336,   337,   338,
     339,   340,   341,   342,   343,   344,   345,   346,    -1,   348,
     349,    -1,   351,   352,   353,   354,   355,   356,    -1,   358,
     359,    -1,    -1,   362,   363,   364,   365,    -1,   367,   368,
     369,   370,   371,   372,   373,    -1,   375,   376,   377,   378,
     379,   380,    -1,    -1,   383,   384,   385,   386,   387,   388,
     389,    -1,   391,    -1,   393,   394,   395,   396,    -1,    -1,
     399,    -1,    -1,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    14,    15,    16,    17,    18,    19,    20,    21,
      22,    23,    24,    25,    -1,    -1,    -1,    -1,    30,    -1,
      -1,    -1,    34,    35,    -1,    37,    38,    -1,    40,    41,
      42,    43,    44,    -1,    46,    47,    -1,    49,    50,    51,
      52,    53,    -1,    -1,    56,    57,    58,    59,    60,    -1,
      62,    63,    64,    65,    66,    -1,    -1,    -1,    70,    71,
      72,    73,    -1,    75,    76,    -1,    78,    79,    80,    81,
      82,    83,    84,    -1,    86,    87,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    95,    96,    97,    98,    99,   100,   101,
     102,   103,    -1,   105,    -1,   107,   108,   109,   110,   111,
      -1,   113,   114,   115,    -1,    -1,   118,   119,   120,   121,
     122,    -1,   124,   125,   126,    -1,   128,   129,   130,    -1,
     132,   133,   134,   135,   136,   137,   138,   139,   140,    -1,
     142,    -1,   144,   145,   146,   147,    -1,   149,    -1,   151,
      -1,    -1,    -1,   155,   156,   157,    -1,   159,   160,    -1,
     162,    -1,   164,   165,   166,   167,   168,    -1,   170,   171,
     172,    -1,   174,   175,   176,   177,   178,   179,    -1,   181,
      -1,   183,   184,   185,   186,   187,   188,   189,    -1,   191,
      -1,   193,    -1,    -1,   196,    -1,   198,   199,   200,   201,
     202,    -1,   204,   205,    -1,   207,   208,    -1,   210,    -1,
      -1,   213,   214,   215,    -1,    -1,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
      -1,   233,   234,   235,   236,    -1,   238,   239,    -1,   241,
      -1,   243,   244,   245,   246,   247,   248,    -1,   250,    -1,
      -1,   253,   254,   255,    -1,    -1,   258,   259,    -1,   261,
      -1,   263,   264,   265,   266,   267,   268,   269,   270,    -1,
     272,   273,   274,   275,   276,   277,   278,    -1,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
     292,   293,   294,   295,   296,   297,   298,   299,   300,   301,
     302,   303,   304,    -1,   306,   307,    -1,   309,   310,   311,
     312,   313,   314,   315,   316,   317,   318,   319,   320,   321,
     322,   323,   324,   325,    -1,   327,   328,   329,   330,    -1,
     332,   333,   334,    -1,   336,   337,   338,   339,   340,   341,
     342,   343,   344,   345,   346,    -1,   348,   349,    -1,   351,
     352,   353,   354,   355,   356,    -1,   358,   359,    -1,    -1,
     362,   363,   364,   365,    -1,   367,   368,   369,   370,   371,
     372,   373,    -1,    -1,   376,   377,   378,   379,   380,    -1,
      -1,   383,   384,   385,   386,   387,   388,   389,    -1,   391,
      -1,   393,   394,   395,   396,    -1,    -1,   399,    -1,    -1,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    -1,    -1,    -1,    -1,    30,    -1,    -1,    -1,    34,
      35,    -1,    37,    38,    -1,    40,    41,    42,    43,    44,
      -1,    46,    47,    -1,    49,    50,    51,    52,    53,    -1,
      -1,    56,    57,    58,    59,    60,    -1,    62,    63,    64,
      65,    66,    -1,    -1,    -1,    70,    71,    72,    73,    -1,
      75,    76,    -1,    78,    79,    80,    81,    82,    83,    -1,
      -1,    86,    87,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      95,    96,    97,    98,    99,   100,   101,   102,   103,    -1,
     105,    -1,   107,   108,   109,   110,   111,    -1,   113,   114,
     115,    -1,    -1,   118,   119,   120,   121,   122,    -1,   124,
     125,   126,    -1,   128,   129,   130,    -1,   132,   133,   134,
     135,   136,   137,   138,   139,   140,    -1,   142,    -1,   144,
     145,   146,   147,    -1,   149,   150,   151,    -1,    -1,    -1,
     155,   156,   157,    -1,   159,   160,    -1,   162,    -1,   164,
     165,   166,   167,   168,    -1,   170,   171,   172,    -1,   174,
     175,   176,   177,   178,   179,    -1,   181,    -1,   183,   184,
     185,   186,   187,   188,   189,    -1,   191,    -1,   193,    -1,
      -1,   196,    -1,   198,   199,   200,   201,   202,    -1,   204,
     205,    -1,   207,   208,    -1,   210,    -1,    -1,   213,   214,
     215,    -1,    -1,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,    -1,   233,   234,
     235,   236,    -1,   238,   239,    -1,   241,    -1,   243,   244,
     245,   246,   247,   248,    -1,   250,    -1,    -1,   253,   254,
     255,    -1,    -1,   258,   259,    -1,   261,    -1,   263,   264,
     265,   266,   267,   268,   269,   270,    -1,   272,   273,   274,
     275,   276,   277,   278,    -1,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,    -1,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
      -1,   306,   307,    -1,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,    -1,   321,   322,   323,   324,
     325,    -1,   327,   328,   329,   330,    -1,   332,   333,   334,
      -1,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,    -1,   348,   349,   350,   351,   352,   353,   354,
     355,   356,    -1,   358,   359,    -1,    -1,   362,   363,   364,
     365,    -1,   367,   368,   369,   370,   371,   372,   373,    -1,
      -1,   376,   377,   378,   379,   380,    -1,    -1,   383,   384,
     385,   386,   387,   388,   389,    -1,   391,    -1,   393,   394,
     395,   396,    -1,    -1,   399,    -1,    -1,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,
      18,    19,    20,    21,    -1,    23,    24,    25,    -1,    -1,
      -1,    -1,    30,    -1,    -1,    -1,    34,    35,    -1,    37,
      38,    -1,    40,    41,    42,    43,    44,    -1,    46,    47,
      -1,    49,    50,    51,    52,    53,    -1,    -1,    56,    57,
      58,    59,    60,    -1,    62,    63,    64,    65,    66,    -1,
      -1,    -1,    70,    71,    72,    73,    -1,    75,    76,    -1,
      78,    79,    80,    81,    82,    83,    84,    -1,    86,    87,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    95,    96,    97,
      98,    99,   100,   101,   102,   103,    -1,   105,    -1,   107,
     108,   109,   110,   111,    -1,   113,   114,   115,    -1,    -1,
     118,   119,   120,   121,   122,    -1,   124,   125,   126,    -1,
     128,   129,   130,    -1,   132,   133,   134,   135,   136,   137,
     138,   139,   140,    -1,   142,    -1,   144,   145,   146,   147,
      -1,   149,    -1,   151,    -1,    -1,    -1,   155,   156,   157,
      -1,   159,   160,    -1,   162,    -1,   164,   165,   166,   167,
     168,    -1,   170,   171,   172,    -1,   174,   175,   176,   177,
     178,   179,    -1,   181,    -1,   183,   184,   185,   186,   187,
     188,   189,    -1,   191,    -1,   193,    -1,    -1,   196,    -1,
     198,   199,   200,   201,   202,    -1,   204,   205,    -1,   207,
     208,    -1,   210,    -1,    -1,   213,   214,   215,    -1,    -1,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,    -1,   233,   234,   235,   236,    -1,
     238,   239,    -1,   241,    -1,   243,   244,   245,   246,   247,
     248,    -1,   250,    -1,    -1,   253,   254,   255,    -1,    -1,
     258,   259,    -1,   261,    -1,   263,   264,   265,   266,   267,
     268,   269,   270,    -1,   272,   273,   274,   275,   276,   277,
     278,    -1,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,   290,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,    -1,   306,   307,
      -1,   309,   310,   311,   312,   313,   314,   315,   316,   317,
     318,   319,   320,   321,   322,   323,   324,   325,    -1,   327,
     328,   329,   330,    -1,   332,   333,   334,    -1,   336,   337,
     338,   339,   340,   341,   342,   343,   344,   345,   346,    -1,
     348,   349,    -1,   351,   352,   353,   354,   355,   356,    -1,
     358,   359,    -1,    -1,   362,   363,   364,   365,    -1,   367,
     368,   369,   370,   371,   372,   373,    -1,    -1,   376,   377,
     378,   379,   380,    -1,    -1,   383,   384,   385,   386,   387,
     388,   389,    -1,   391,    -1,   393,   394,   395,   396,    -1,
      -1,   399,    -1,    -1,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    14,    15,    16,    17,    18,    19,    20,
      21,    22,    23,    24,    25,    -1,    -1,    -1,    -1,    30,
      -1,    -1,    -1,    34,    35,    -1,    37,    38,    -1,    40,
      41,    42,    43,    44,    -1,    46,    47,    -1,    49,    50,
      51,    52,    53,    -1,    -1,    56,    57,    58,    59,    60,
      -1,    62,    63,    64,    65,    66,    -1,    -1,    -1,    70,
      71,    72,    73,    -1,    75,    76,    -1,    78,    79,    80,
      81,    82,    83,    -1,    -1,    86,    87,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    95,    96,    97,    98,    99,   100,
     101,   102,   103,    -1,   105,    -1,   107,   108,   109,   110,
     111,    -1,   113,   114,   115,    -1,    -1,   118,   119,   120,
     121,   122,    -1,   124,   125,   126,    -1,   128,   129,   130,
      -1,   132,   133,   134,   135,   136,   137,   138,   139,   140,
      -1,   142,    -1,   144,   145,   146,   147,    -1,   149,    -1,
     151,    -1,    -1,    -1,   155,   156,   157,    -1,   159,   160,
      -1,   162,    -1,   164,   165,   166,   167,   168,    -1,   170,
     171,   172,    -1,   174,   175,   176,   177,   178,   179,    -1,
     181,    -1,   183,   184,   185,   186,   187,   188,   189,    -1,
     191,    -1,   193,    -1,    -1,   196,    -1,   198,   199,   200,
     201,   202,    -1,   204,   205,    -1,   207,   208,    -1,   210,
      -1,    -1,   213,   214,   215,    -1,    -1,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,    -1,   233,   234,   235,   236,    -1,   238,   239,    -1,
     241,    -1,   243,   244,   245,   246,   247,   248,    -1,   250,
      -1,   252,   253,   254,   255,    -1,    -1,   258,   259,    -1,
     261,    -1,   263,   264,   265,   266,   267,   268,   269,   270,
      -1,   272,   273,   274,   275,   276,   277,   278,    -1,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,   292,    -1,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,   304,    -1,   306,   307,    -1,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,   319,    -1,
     321,   322,   323,   324,   325,    -1,   327,   328,   329,   330,
      -1,   332,   333,   334,    -1,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,   346,    -1,   348,   349,    -1,
     351,   352,   353,   354,   355,   356,    -1,   358,   359,    -1,
      -1,   362,   363,   364,   365,    -1,   367,   368,   369,   370,
     371,   372,   373,    -1,    -1,   376,   377,   378,   379,   380,
      -1,    -1,   383,   384,   385,   386,   387,   388,   389,    -1,
     391,    -1,   393,   394,   395,   396,    -1,    -1,   399,    -1,
      -1,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,   419,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      14,    15,    16,    17,    18,    19,    20,    21,    -1,    23,
      24,    25,    26,    27,    -1,    -1,    30,    -1,    -1,    -1,
      34,    35,    -1,    37,    38,    -1,    40,    41,    42,    43,
      44,    -1,    46,    47,    -1,    49,    50,    51,    52,    53,
      -1,    -1,    56,    57,    58,    59,    60,    -1,    62,    63,
      64,    65,    66,    -1,    -1,    -1,    70,    71,    72,    73,
      -1,    75,    76,    -1,    78,    79,    80,    81,    82,    83,
      -1,    -1,    86,    87,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    95,    96,    97,    98,    99,   100,   101,   102,   103,
      -1,   105,    -1,   107,   108,   109,   110,   111,    -1,   113,
     114,   115,    -1,    -1,   118,   119,   120,   121,   122,    -1,
     124,   125,   126,    -1,   128,   129,   130,    -1,   132,   133,
     134,   135,   136,   137,   138,   139,   140,    -1,   142,    -1,
     144,   145,   146,   147,    -1,   149,    -1,   151,    -1,    -1,
      -1,   155,   156,   157,    -1,   159,   160,    -1,   162,    -1,
     164,   165,   166,   167,   168,    -1,   170,   171,   172,    -1,
     174,   175,   176,   177,   178,   179,    -1,   181,    -1,   183,
     184,   185,   186,   187,   188,   189,    -1,   191,    -1,   193,
      -1,    -1,   196,    -1,   198,   199,   200,   201,   202,    -1,
     204,   205,    -1,   207,   208,    -1,   210,    -1,    -1,   213,
     214,   215,    -1,    -1,   218,   219,   220,   221,   222,   223,
     224,   225,   226,   227,   228,   229,   230,   231,    -1,   233,
     234,   235,   236,    -1,   238,   239,    -1,   241,    -1,   243,
     244,   245,   246,   247,   248,    -1,   250,    -1,    -1,   253,
     254,   255,    -1,    -1,   258,   259,    -1,   261,    -1,   263,
     264,   265,   266,   267,   268,   269,   270,    -1,   272,   273,
     274,   275,   276,   277,   278,    -1,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,   292,    -1,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
     304,    -1,   306,   307,    -1,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,   319,    -1,   321,   322,   323,
     324,   325,    -1,   327,   328,   329,   330,    -1,   332,   333,
     334,    -1,   336,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,    -1,   348,   349,    -1,   351,   352,   353,
     354,   355,   356,    -1,   358,   359,    -1,    -1,   362,   363,
     364,   365,    -1,   367,   368,   369,   370,   371,   372,   373,
      -1,    -1,   376,   377,   378,   379,   380,    -1,    -1,   383,
     384,   385,   386,   387,   388,   389,    -1,   391,    -1,   393,
     394,   395,   396,    -1,    -1,   399,    -1,    -1,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,    15,    16,
      17,    18,    19,    20,    21,    22,    23,    24,    25,    -1,
      -1,    -1,    -1,    30,    -1,    -1,    -1,    34,    35,    -1,
      37,    38,    -1,    40,    41,    42,    43,    44,    -1,    46,
      47,    -1,    49,    50,    51,    52,    53,    -1,    -1,    56,
      57,    58,    59,    60,    -1,    62,    63,    64,    65,    66,
      -1,    -1,    -1,    70,    71,    72,    73,    -1,    75,    76,
      -1,    78,    79,    80,    81,    82,    83,    -1,    -1,    86,
      87,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    95,    96,
      97,    98,    99,   100,   101,   102,   103,    -1,   105,    -1,
     107,   108,   109,   110,   111,    -1,   113,   114,   115,    -1,
      -1,   118,   119,   120,   121,   122,    -1,   124,   125,   126,
      -1,   128,   129,   130,    -1,   132,   133,   134,   135,   136,
     137,   138,   139,   140,    -1,   142,    -1,   144,   145,   146,
     147,    -1,   149,    -1,   151,    -1,    -1,    -1,   155,   156,
     157,    -1,   159,   160,    -1,   162,    -1,   164,   165,   166,
     167,   168,    -1,   170,   171,   172,    -1,   174,   175,   176,
     177,   178,   179,    -1,   181,    -1,   183,   184,   185,   186,
     187,   188,   189,    -1,   191,    -1,   193,    -1,    -1,   196,
      -1,   198,   199,   200,   201,   202,    -1,   204,   205,    -1,
     207,   208,    -1,   210,    -1,    -1,   213,   214,   215,    -1,
      -1,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,    -1,   233,   234,   235,   236,
      -1,   238,   239,    -1,   241,    -1,   243,   244,   245,   246,
     247,   248,    -1,   250,    -1,    -1,   253,   254,   255,    -1,
      -1,   258,   259,    -1,   261,    -1,   263,   264,   265,   266,
     267,   268,   269,   270,    -1,   272,   273,   274,   275,   276,
     277,   278,    -1,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,   292,    -1,   294,   295,   296,
     297,   298,   299,   300,   301,   302,   303,   304,    -1,   306,
     307,    -1,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,    -1,   321,   322,   323,   324,   325,    -1,
     327,   328,   329,   330,    -1,   332,   333,   334,    -1,   336,
     337,   338,   339,   340,   341,   342,   343,   344,   345,   346,
      -1,   348,   349,    -1,   351,   352,   353,   354,   355,   356,
      -1,   358,   359,    -1,    -1,   362,   363,   364,   365,    -1,
     367,   368,   369,   370,   371,   372,   373,    -1,    -1,   376,
     377,   378,   379,   380,   381,    -1,   383,   384,   385,   386,
     387,   388,   389,    -1,   391,    -1,   393,   394,   395,   396,
      -1,    -1,   399,    -1,    -1,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,    19,
      20,    21,    22,    23,    24,    25,    -1,    -1,    -1,    -1,
      30,    -1,    -1,    -1,    34,    35,    -1,    37,    38,    -1,
      40,    41,    42,    43,    44,    -1,    46,    47,    -1,    49,
      50,    51,    52,    53,    -1,    -1,    56,    57,    58,    59,
      60,    -1,    62,    63,    64,    65,    66,    -1,    -1,    -1,
      70,    71,    72,    73,    -1,    75,    76,    -1,    78,    79,
      80,    81,    82,    83,    -1,    -1,    86,    87,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    95,    96,    97,    98,    99,
     100,   101,   102,   103,    -1,   105,    -1,   107,   108,   109,
     110,   111,    -1,   113,   114,   115,    -1,    -1,   118,   119,
     120,   121,   122,    -1,   124,   125,   126,    -1,   128,   129,
     130,    -1,   132,   133,   134,   135,   136,   137,   138,   139,
     140,    -1,   142,    -1,   144,   145,   146,   147,    -1,   149,
      -1,   151,    -1,    -1,    -1,   155,   156,   157,    -1,   159,
     160,    -1,   162,    -1,   164,   165,   166,   167,   168,    -1,
     170,   171,   172,    -1,   174,   175,   176,   177,   178,   179,
      -1,   181,    -1,   183,   184,   185,   186,   187,   188,   189,
      -1,   191,    -1,   193,    -1,    -1,   196,    -1,   198,   199,
     200,   201,   202,    -1,   204,   205,    -1,   207,   208,    -1,
     210,    -1,    -1,   213,   214,   215,    -1,    -1,   218,   219,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,    -1,   233,   234,   235,   236,    -1,   238,   239,
      -1,   241,    -1,   243,   244,   245,   246,   247,   248,    -1,
     250,    -1,    -1,   253,   254,   255,    -1,    -1,   258,   259,
      -1,   261,    -1,   263,   264,   265,   266,   267,   268,   269,
     270,    -1,   272,   273,   274,   275,   276,   277,   278,    -1,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,   292,    -1,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,   304,    -1,   306,   307,    -1,   309,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
      -1,   321,   322,   323,   324,   325,    -1,   327,   328,   329,
     330,    -1,   332,   333,   334,    -1,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,    -1,   348,   349,
      -1,   351,   352,   353,   354,   355,   356,    -1,   358,   359,
      -1,    -1,   362,   363,   364,   365,    -1,   367,   368,   369,
     370,   371,   372,   373,    -1,    -1,   376,   377,   378,   379,
     380,   381,    -1,   383,   384,   385,   386,   387,   388,   389,
      -1,   391,    -1,   393,   394,   395,   396,    -1,    -1,   399,
      -1,    -1,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    14,    15,    16,    17,    18,    19,    20,    21,    22,
      23,    24,    25,    -1,    -1,    -1,    -1,    30,    -1,    -1,
      -1,    34,    35,    -1,    37,    38,    -1,    40,    41,    42,
      43,    44,    -1,    46,    47,    -1,    49,    50,    51,    52,
      53,    -1,    -1,    56,    57,    58,    59,    60,    -1,    62,
      63,    64,    65,    66,    -1,    -1,    -1,    70,    71,    72,
      73,    -1,    75,    76,    -1,    78,    79,    80,    81,    82,
      83,    -1,    -1,    86,    87,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    95,    96,    97,    98,    99,   100,   101,   102,
     103,    -1,   105,    -1,   107,   108,   109,   110,   111,    -1,
     113,   114,   115,    -1,    -1,   118,   119,   120,   121,   122,
      -1,   124,   125,   126,    -1,   128,   129,   130,    -1,   132,
     133,   134,   135,   136,   137,   138,   139,   140,    -1,   142,
      -1,   144,   145,   146,   147,    -1,   149,    -1,   151,    -1,
      -1,    -1,   155,   156,   157,    -1,   159,   160,    -1,   162,
      -1,   164,   165,   166,   167,   168,    -1,   170,   171,   172,
      -1,   174,   175,   176,   177,   178,   179,    -1,   181,    -1,
     183,   184,   185,   186,   187,   188,   189,    -1,   191,    -1,
     193,    -1,    -1,   196,    -1,   198,   199,   200,   201,   202,
      -1,   204,   205,    -1,   207,   208,    -1,   210,    -1,    -1,
     213,   214,   215,    -1,    -1,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,    -1,
     233,   234,   235,   236,    -1,   238,   239,    -1,   241,    -1,
     243,   244,   245,   246,   247,   248,    -1,   250,    -1,    -1,
     253,   254,   255,    -1,    -1,   258,   259,    -1,   261,    -1,
     263,   264,   265,   266,   267,   268,   269,   270,    -1,   272,
     273,   274,   275,   276,   277,   278,    -1,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,   292,
      -1,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,   304,    -1,   306,   307,    -1,   309,   310,   311,   312,
     313,   314,   315,   316,   317,   318,   319,    -1,   321,   322,
     323,   324,   325,    -1,   327,   328,   329,   330,    -1,   332,
     333,   334,    -1,   336,   337,   338,   339,   340,   341,   342,
     343,   344,   345,   346,    -1,   348,   349,    -1,   351,   352,
     353,   354,   355,   356,    -1,   358,   359,    -1,    -1,   362,
     363,   364,   365,    -1,   367,   368,   369,   370,   371,   372,
     373,    -1,    -1,   376,   377,   378,   379,   380,    -1,    -1,
     383,   384,   385,   386,   387,   388,   389,    -1,   391,    -1,
     393,   394,   395,   396,    -1,    -1,   399,    -1,    -1,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,    15,
      16,    17,    18,    19,    20,    21,    22,    23,    24,    25,
      -1,    -1,    -1,    -1,    30,    -1,    -1,    -1,    34,    35,
      -1,    37,    38,    -1,    40,    41,    42,    43,    44,    -1,
      46,    47,    -1,    49,    50,    51,    52,    53,    -1,    -1,
      56,    57,    58,    59,    60,    -1,    62,    63,    64,    65,
      66,    -1,    -1,    -1,    70,    71,    72,    73,    -1,    75,
      76,    -1,    78,    79,    80,    81,    82,    83,    -1,    -1,
      86,    87,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    95,
      96,    97,    98,    99,   100,   101,   102,   103,    -1,   105,
      -1,   107,   108,   109,   110,   111,    -1,   113,   114,   115,
      -1,    -1,   118,   119,   120,   121,   122,    -1,   124,   125,
     126,    -1,   128,   129,   130,    -1,   132,   133,   134,   135,
     136,   137,   138,   139,   140,    -1,   142,    -1,   144,   145,
     146,   147,    -1,   149,    -1,   151,    -1,    -1,    -1,   155,
     156,   157,    -1,   159,   160,    -1,   162,    -1,   164,   165,
     166,   167,   168,    -1,   170,   171,   172,    -1,   174,   175,
     176,   177,   178,   179,    -1,   181,    -1,   183,   184,   185,
     186,   187,   188,   189,    -1,   191,    -1,   193,    -1,    -1,
     196,    -1,   198,   199,   200,   201,   202,    -1,   204,   205,
      -1,   207,   208,    -1,   210,    -1,    -1,   213,   214,   215,
      -1,    -1,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,    -1,   233,   234,   235,
     236,    -1,   238,   239,    -1,   241,    -1,   243,   244,   245,
     246,   247,   248,    -1,   250,    -1,    -1,   253,   254,   255,
      -1,    -1,   258,   259,    -1,   261,    -1,   263,   264,   265,
     266,   267,   268,   269,   270,    -1,   272,   273,   274,   275,
     276,   277,   278,    -1,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,   292,    -1,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,    -1,
     306,   307,    -1,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,   319,    -1,   321,   322,   323,   324,   325,
      -1,   327,   328,   329,   330,    -1,   332,   333,   334,    -1,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,    -1,   348,   349,    -1,   351,   352,   353,   354,   355,
     356,    -1,   358,   359,    -1,    -1,   362,   363,   364,   365,
      -1,   367,   368,   369,   370,   371,   372,   373,    -1,    -1,
     376,   377,   378,   379,   380,    -1,    -1,   383,   384,   385,
     386,   387,   388,   389,    -1,   391,    -1,   393,   394,   395,
     396,    -1,    -1,   399,    -1,    -1,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,
      19,    20,    21,    22,    23,    24,    25,    -1,    -1,    -1,
      -1,    30,    -1,    -1,    -1,    34,    35,    -1,    37,    38,
      -1,    40,    41,    42,    43,    44,    -1,    46,    47,    -1,
      49,    50,    51,    52,    53,    -1,    -1,    56,    57,    58,
      59,    60,    -1,    62,    63,    64,    65,    66,    -1,    -1,
      -1,    70,    71,    72,    73,    -1,    75,    76,    -1,    78,
      79,    80,    81,    82,    83,    -1,    -1,    86,    87,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    95,    96,    97,    98,
      99,   100,   101,   102,   103,    -1,   105,    -1,   107,   108,
     109,   110,   111,    -1,   113,   114,   115,    -1,    -1,   118,
     119,   120,   121,   122,    -1,   124,   125,   126,    -1,   128,
     129,   130,    -1,   132,   133,   134,   135,   136,   137,   138,
     139,   140,    -1,   142,    -1,   144,   145,   146,   147,    -1,
     149,    -1,   151,    -1,    -1,    -1,   155,   156,   157,    -1,
     159,   160,    -1,   162,    -1,   164,   165,   166,   167,   168,
      -1,   170,   171,   172,    -1,   174,   175,   176,   177,   178,
     179,    -1,   181,    -1,   183,   184,   185,   186,   187,   188,
     189,    -1,   191,    -1,   193,    -1,    -1,   196,    -1,   198,
     199,   200,   201,   202,    -1,   204,   205,    -1,   207,   208,
      -1,   210,    -1,    -1,   213,   214,   215,    -1,    -1,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,    -1,   233,   234,   235,   236,    -1,   238,
     239,    -1,   241,    -1,   243,   244,   245,   246,   247,   248,
      -1,   250,    -1,    -1,   253,   254,   255,    -1,    -1,   258,
     259,    -1,   261,    -1,   263,   264,   265,   266,   267,   268,
     269,   270,    -1,   272,   273,   274,   275,   276,   277,   278,
      -1,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,   292,    -1,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,   304,    -1,   306,   307,    -1,
     309,   310,   311,   312,   313,   314,   315,   316,   317,   318,
     319,    -1,   321,   322,   323,   324,   325,    -1,   327,   328,
     329,   330,    -1,   332,   333,   334,    -1,   336,   337,   338,
     339,   340,   341,   342,   343,   344,   345,   346,    -1,   348,
     349,    -1,   351,   352,   353,   354,   355,   356,    -1,   358,
     359,    -1,    -1,   362,   363,   364,   365,    -1,   367,   368,
     369,   370,   371,   372,   373,    -1,    -1,   376,   377,   378,
     379,   380,    -1,    -1,   383,   384,   385,   386,   387,   388,
     389,    -1,   391,    -1,   393,   394,   395,   396,    -1,    -1,
     399,    -1,    -1,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    14,    15,    16,    17,    18,    19,    20,    21,
      22,    23,    24,    25,    -1,    -1,    -1,    -1,    30,    -1,
      -1,    -1,    34,    35,    -1,    37,    38,    -1,    40,    41,
      42,    43,    44,    -1,    46,    47,    -1,    49,    50,    51,
      52,    53,    -1,    -1,    56,    57,    58,    59,    60,    -1,
      62,    63,    64,    65,    66,    -1,    -1,    -1,    70,    71,
      72,    73,    -1,    75,    76,    -1,    78,    79,    80,    81,
      82,    83,    -1,    -1,    86,    87,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    95,    96,    97,    98,    99,   100,   101,
     102,   103,    -1,   105,    -1,   107,   108,   109,   110,   111,
      -1,   113,   114,   115,    -1,    -1,   118,   119,   120,   121,
     122,    -1,   124,   125,   126,    -1,   128,   129,   130,    -1,
     132,   133,   134,   135,   136,   137,   138,   139,   140,    -1,
     142,    -1,   144,   145,   146,   147,    -1,   149,    -1,   151,
      -1,    -1,    -1,   155,   156,   157,    -1,   159,   160,    -1,
     162,    -1,   164,   165,   166,   167,   168,    -1,   170,   171,
     172,    -1,   174,   175,   176,   177,   178,   179,    -1,   181,
      -1,   183,   184,   185,   186,   187,   188,   189,    -1,   191,
      -1,   193,    -1,    -1,   196,    -1,   198,   199,   200,   201,
     202,    -1,   204,   205,    -1,   207,   208,    -1,   210,    -1,
      -1,   213,   214,   215,    -1,    -1,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
      -1,   233,   234,   235,   236,    -1,   238,   239,    -1,   241,
      -1,   243,   244,   245,   246,   247,   248,    -1,   250,    -1,
      -1,   253,   254,   255,    -1,    -1,   258,   259,    -1,   261,
      -1,   263,   264,   265,   266,   267,   268,   269,   270,    -1,
     272,   273,   274,   275,   276,   277,   278,    -1,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
     292,    -1,   294,   295,   296,   297,   298,   299,   300,   301,
     302,   303,   304,    -1,   306,   307,    -1,   309,   310,   311,
     312,   313,   314,   315,   316,   317,   318,   319,    -1,   321,
     322,   323,   324,   325,    -1,   327,   328,   329,   330,    -1,
     332,   333,   334,    -1,   336,   337,   338,   339,   340,   341,
     342,   343,   344,   345,   346,    -1,   348,   349,    -1,   351,
     352,   353,   354,   355,   356,    -1,   358,   359,    -1,    -1,
     362,   363,   364,   365,    -1,   367,   368,   369,   370,   371,
     372,   373,    -1,    -1,   376,   377,   378,   379,   380,    -1,
      -1,   383,   384,   385,   386,   387,   388,   389,    -1,   391,
      -1,   393,   394,   395,   396,    -1,    -1,   399,    -1,    -1,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,
      15,    16,    17,    18,    19,    20,    21,    -1,    23,    24,
      25,    -1,    -1,    -1,    -1,    30,    -1,    -1,    -1,    34,
      35,    -1,    37,    38,    -1,    40,    41,    42,    43,    44,
      -1,    46,    47,    -1,    49,    50,    51,    52,    53,    -1,
      -1,    56,    57,    58,    59,    60,    -1,    62,    63,    64,
      65,    66,    -1,    -1,    -1,    70,    71,    72,    73,    -1,
      75,    76,    -1,    78,    79,    80,    81,    82,    83,    -1,
      -1,    86,    87,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      95,    96,    97,    98,    99,   100,   101,   102,   103,    -1,
     105,    -1,   107,   108,   109,   110,   111,    -1,   113,   114,
     115,    -1,    -1,   118,   119,   120,   121,   122,    -1,   124,
     125,   126,    -1,   128,   129,   130,    -1,   132,   133,   134,
     135,   136,   137,   138,   139,   140,    -1,   142,    -1,   144,
     145,   146,   147,    -1,   149,    -1,   151,    -1,    -1,    -1,
     155,   156,   157,    -1,   159,   160,    -1,   162,    -1,   164,
     165,   166,   167,   168,    -1,   170,   171,   172,    -1,   174,
     175,   176,   177,   178,   179,    -1,   181,    -1,   183,   184,
     185,   186,   187,   188,   189,    -1,   191,    -1,   193,    -1,
      -1,   196,    -1,   198,   199,   200,   201,   202,    -1,   204,
     205,    -1,   207,   208,    -1,   210,    -1,    -1,   213,   214,
     215,    -1,    -1,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,    -1,   233,   234,
     235,   236,    -1,   238,   239,    -1,   241,    -1,   243,   244,
     245,   246,   247,   248,    -1,   250,    -1,   252,   253,   254,
     255,    -1,    -1,   258,   259,    -1,   261,    -1,   263,   264,
     265,   266,   267,   268,   269,   270,    -1,   272,   273,   274,
     275,   276,   277,   278,    -1,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,    -1,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
      -1,   306,   307,    -1,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,    -1,   321,   322,   323,   324,
     325,    -1,   327,   328,   329,   330,    -1,   332,   333,   334,
      -1,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,    -1,   348,   349,    -1,   351,   352,   353,   354,
     355,   356,    -1,   358,   359,    -1,    -1,   362,   363,   364,
     365,    -1,   367,   368,   369,   370,   371,   372,   373,    -1,
      -1,   376,   377,   378,   379,   380,    -1,    -1,   383,   384,
     385,   386,   387,   388,   389,    -1,   391,    -1,   393,   394,
     395,   396,    -1,    -1,   399,    -1,    -1,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,
      18,    19,    20,    21,    22,    23,    24,    25,    -1,    -1,
      -1,    -1,    30,    -1,    -1,    -1,    34,    35,    -1,    37,
      38,    -1,    40,    41,    42,    43,    44,    -1,    46,    47,
      -1,    49,    50,    51,    52,    53,    -1,    -1,    56,    57,
      58,    59,    60,    -1,    62,    63,    64,    65,    66,    -1,
      -1,    -1,    70,    71,    72,    73,    -1,    75,    76,    -1,
      78,    79,    80,    81,    82,    83,    -1,    -1,    86,    87,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    95,    96,    97,
      98,    99,   100,   101,   102,   103,    -1,   105,    -1,   107,
     108,   109,   110,   111,    -1,   113,   114,   115,    -1,    -1,
     118,   119,   120,   121,   122,    -1,   124,   125,   126,    -1,
     128,   129,   130,    -1,   132,   133,   134,   135,   136,   137,
     138,   139,   140,    -1,   142,    -1,   144,   145,   146,   147,
      -1,   149,    -1,   151,    -1,    -1,    -1,   155,   156,   157,
      -1,   159,   160,    -1,   162,    -1,   164,   165,   166,   167,
     168,    -1,   170,   171,   172,    -1,   174,   175,   176,   177,
     178,   179,    -1,   181,    -1,   183,   184,   185,   186,   187,
     188,   189,    -1,   191,    -1,   193,    -1,    -1,   196,    -1,
     198,   199,   200,   201,   202,    -1,   204,   205,    -1,   207,
     208,    -1,   210,    -1,    -1,   213,   214,   215,    -1,    -1,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,    -1,   233,   234,   235,   236,    -1,
     238,   239,    -1,   241,    -1,   243,   244,   245,   246,   247,
     248,    -1,   250,    -1,    -1,   253,   254,   255,    -1,    -1,
     258,   259,    -1,   261,    -1,   263,   264,   265,   266,   267,
     268,   269,   270,    -1,   272,   273,   274,   275,   276,   277,
     278,    -1,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,   290,   291,   292,    -1,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,    -1,   306,   307,
      -1,   309,   310,   311,   312,   313,   314,   315,   316,   317,
     318,   319,    -1,   321,   322,   323,   324,   325,    -1,   327,
     328,   329,   330,    -1,   332,   333,   334,    -1,   336,   337,
     338,   339,   340,   341,   342,   343,   344,   345,   346,    -1,
     348,   349,    -1,   351,   352,   353,   354,   355,   356,    -1,
     358,   359,    -1,    -1,   362,   363,   364,   365,    -1,   367,
     368,   369,   370,   371,   372,   373,    -1,    -1,   376,   377,
     378,   379,   380,    -1,    -1,   383,   384,   385,   386,   387,
     388,   389,    -1,   391,    -1,   393,   394,   395,   396,    -1,
      -1,   399,    -1,    -1,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    14,    15,    16,    17,    18,    19,    20,
      21,    22,    23,    24,    25,    -1,    -1,    -1,    -1,    30,
      -1,    -1,    -1,    34,    35,    -1,    37,    38,    -1,    40,
      41,    42,    43,    44,    -1,    46,    47,    -1,    49,    50,
      51,    52,    53,    -1,    -1,    56,    57,    58,    59,    60,
      -1,    62,    63,    64,    65,    66,    -1,    -1,    -1,    70,
      71,    72,    73,    -1,    75,    76,    -1,    78,    79,    80,
      81,    82,    83,    -1,    -1,    86,    87,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    95,    96,    97,    98,    99,   100,
     101,   102,   103,    -1,   105,    -1,   107,   108,   109,   110,
     111,    -1,   113,   114,   115,    -1,    -1,   118,   119,   120,
     121,   122,    -1,   124,   125,   126,    -1,   128,   129,   130,
      -1,   132,   133,   134,   135,   136,   137,   138,   139,   140,
      -1,   142,    -1,   144,   145,   146,   147,    -1,   149,    -1,
     151,    -1,    -1,    -1,   155,   156,   157,    -1,   159,   160,
      -1,   162,    -1,   164,   165,   166,   167,   168,    -1,   170,
     171,   172,    -1,   174,   175,   176,   177,   178,   179,    -1,
     181,    -1,   183,   184,   185,   186,   187,   188,   189,    -1,
     191,    -1,   193,    -1,    -1,   196,    -1,   198,   199,   200,
     201,   202,    -1,   204,   205,    -1,   207,   208,    -1,   210,
      -1,    -1,   213,   214,   215,    -1,    -1,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,    -1,   233,   234,   235,   236,    -1,   238,   239,    -1,
     241,    -1,   243,   244,   245,   246,   247,   248,    -1,   250,
      -1,    -1,   253,   254,   255,    -1,    -1,   258,   259,    -1,
     261,    -1,   263,   264,   265,   266,   267,   268,   269,   270,
      -1,   272,   273,   274,   275,   276,   277,   278,    -1,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,   292,    -1,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,   304,    -1,   306,   307,    -1,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,   319,    -1,
     321,   322,   323,   324,   325,    -1,   327,   328,   329,   330,
      -1,   332,   333,   334,    -1,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,   346,    -1,   348,   349,    -1,
     351,   352,   353,   354,   355,   356,    -1,   358,   359,    -1,
      -1,   362,   363,   364,   365,    -1,   367,   368,   369,   370,
     371,   372,   373,    -1,    -1,   376,   377,   378,   379,   380,
      -1,    -1,   383,   384,   385,   386,   387,   388,   389,    -1,
     391,    -1,   393,   394,   395,   396,    -1,    -1,   399,    -1,
      -1,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,   419,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      14,    15,    16,    17,    18,    19,    20,    21,    22,    23,
      24,    25,    -1,    -1,    -1,    -1,    30,    -1,    -1,    -1,
      34,    35,    -1,    37,    38,    -1,    40,    41,    42,    43,
      44,    -1,    46,    47,    -1,    49,    50,    51,    52,    53,
      -1,    -1,    56,    57,    58,    59,    60,    -1,    62,    63,
      64,    65,    66,    -1,    -1,    -1,    70,    71,    72,    73,
      -1,    75,    76,    -1,    78,    79,    80,    81,    82,    83,
      -1,    -1,    86,    87,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    95,    96,    97,    98,    99,   100,   101,   102,   103,
      -1,   105,    -1,   107,   108,   109,   110,   111,    -1,   113,
     114,   115,    -1,    -1,   118,   119,   120,   121,   122,    -1,
     124,   125,   126,    -1,   128,   129,   130,    -1,   132,   133,
     134,   135,   136,   137,   138,   139,   140,    -1,   142,    -1,
     144,   145,   146,   147,    -1,   149,    -1,   151,    -1,    -1,
      -1,   155,   156,   157,    -1,   159,   160,    -1,   162,    -1,
     164,   165,   166,   167,   168,    -1,   170,   171,   172,    -1,
     174,   175,   176,   177,   178,   179,    -1,   181,    -1,   183,
     184,   185,   186,   187,   188,   189,    -1,   191,    -1,   193,
      -1,    -1,   196,    -1,   198,   199,   200,   201,   202,    -1,
     204,   205,    -1,   207,   208,    -1,   210,    -1,    -1,   213,
     214,   215,    -1,    -1,   218,   219,   220,   221,   222,   223,
     224,   225,   226,   227,   228,   229,   230,   231,    -1,   233,
     234,   235,   236,    -1,   238,   239,    -1,   241,    -1,   243,
     244,   245,   246,   247,   248,    -1,   250,    -1,    -1,   253,
     254,   255,    -1,    -1,   258,   259,    -1,   261,    -1,   263,
     264,   265,   266,   267,   268,   269,   270,    -1,   272,   273,
     274,   275,   276,   277,   278,    -1,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,   292,    -1,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
     304,    -1,   306,   307,    -1,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,   319,    -1,   321,   322,   323,
     324,   325,    -1,   327,   328,   329,   330,    -1,   332,   333,
     334,    -1,   336,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,    -1,   348,   349,    -1,   351,   352,   353,
     354,   355,   356,    -1,   358,   359,    -1,    -1,   362,   363,
     364,   365,    -1,   367,   368,   369,   370,   371,   372,   373,
      -1,    -1,   376,   377,   378,   379,   380,    -1,    -1,   383,
     384,   385,   386,   387,   388,   389,    -1,   391,    -1,   393,
     394,   395,   396,    -1,    -1,   399,    -1,    -1,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,    15,    16,
      17,    18,    19,    20,    21,    -1,    23,    24,    25,    -1,
      -1,    -1,    -1,    30,    -1,    -1,    -1,    34,    35,    -1,
      37,    38,    39,    40,    41,    42,    43,    44,    -1,    46,
      47,    -1,    49,    50,    51,    52,    53,    -1,    -1,    56,
      57,    58,    59,    60,    -1,    62,    63,    64,    65,    66,
      -1,    -1,    -1,    70,    71,    72,    73,    -1,    75,    76,
      -1,    78,    79,    80,    81,    82,    83,    -1,    -1,    86,
      87,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    95,    96,
      97,    98,    99,   100,   101,   102,   103,    -1,   105,    -1,
     107,   108,   109,   110,   111,    -1,   113,   114,   115,    -1,
      -1,   118,   119,   120,   121,   122,    -1,   124,   125,   126,
      -1,   128,   129,   130,    -1,   132,   133,   134,   135,   136,
     137,   138,   139,   140,    -1,   142,    -1,   144,   145,   146,
     147,    -1,   149,    -1,   151,    -1,    -1,    -1,   155,   156,
     157,    -1,   159,   160,    -1,   162,    -1,   164,   165,   166,
     167,   168,    -1,   170,   171,   172,    -1,   174,   175,   176,
     177,   178,   179,    -1,   181,    -1,   183,   184,   185,   186,
     187,   188,   189,    -1,   191,    -1,   193,    -1,    -1,   196,
      -1,   198,   199,   200,   201,   202,    -1,   204,   205,    -1,
     207,   208,    -1,   210,    -1,    -1,   213,   214,   215,    -1,
      -1,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,    -1,   233,   234,   235,   236,
      -1,   238,   239,    -1,   241,    -1,   243,   244,   245,   246,
     247,   248,    -1,   250,    -1,    -1,   253,   254,   255,    -1,
      -1,   258,   259,    -1,   261,    -1,   263,   264,   265,   266,
     267,   268,   269,   270,    -1,   272,   273,   274,   275,   276,
     277,   278,    -1,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,   292,    -1,   294,   295,   296,
     297,   298,   299,   300,   301,   302,   303,   304,    -1,   306,
     307,    -1,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,    -1,   321,   322,   323,   324,   325,    -1,
     327,   328,   329,   330,    -1,   332,   333,   334,    -1,   336,
     337,   338,   339,   340,   341,   342,   343,   344,   345,   346,
      -1,   348,   349,    -1,   351,   352,   353,   354,   355,   356,
      -1,   358,   359,    -1,    -1,   362,   363,   364,   365,    -1,
     367,   368,   369,   370,   371,   372,   373,    -1,    -1,   376,
     377,   378,   379,   380,    -1,    -1,   383,   384,   385,   386,
     387,   388,   389,    -1,   391,    -1,   393,   394,   395,   396,
      -1,    -1,   399,    -1,    -1,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,    19,
      20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,
      30,    -1,    -1,    -1,    34,    35,    -1,    37,    38,    -1,
      40,    41,    42,    43,    44,    -1,    46,    47,    -1,    49,
      50,    51,    52,    53,    -1,    -1,    56,    57,    58,    59,
      60,    -1,    62,    63,    64,    65,    66,    -1,    -1,    -1,
      70,    71,    72,    73,    -1,    75,    76,    -1,    78,    79,
      80,    81,    82,    83,    -1,    -1,    86,    87,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    95,    96,    97,    98,    99,
     100,   101,   102,   103,    -1,   105,    -1,   107,   108,   109,
     110,   111,    -1,   113,   114,   115,    -1,    -1,   118,   119,
     120,   121,   122,    -1,   124,   125,   126,    -1,   128,   129,
     130,    -1,   132,   133,   134,   135,   136,   137,   138,   139,
     140,    -1,   142,    -1,   144,   145,   146,   147,    -1,   149,
      -1,   151,    -1,    -1,    -1,   155,   156,   157,    -1,   159,
     160,    -1,   162,    -1,   164,   165,   166,   167,   168,    -1,
     170,   171,   172,    -1,   174,   175,   176,   177,   178,   179,
      -1,   181,    -1,   183,   184,   185,   186,   187,   188,   189,
      -1,   191,    -1,   193,    -1,    -1,   196,    -1,   198,   199,
     200,   201,   202,    -1,   204,   205,    -1,   207,   208,    -1,
     210,    -1,    -1,   213,   214,   215,    -1,    -1,   218,   219,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,    -1,   233,   234,   235,   236,    -1,   238,   239,
      -1,   241,    -1,   243,   244,   245,   246,   247,   248,    -1,
     250,    -1,   252,   253,   254,   255,    -1,    -1,   258,   259,
      -1,   261,    -1,   263,   264,   265,   266,   267,   268,   269,
     270,    -1,   272,   273,   274,   275,   276,   277,   278,    -1,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,   292,    -1,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,   304,    -1,   306,   307,    -1,   309,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
      -1,   321,   322,   323,   324,   325,    -1,   327,   328,   329,
     330,    -1,   332,   333,   334,    -1,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,    -1,   348,   349,
      -1,   351,   352,   353,   354,   355,   356,    -1,   358,   359,
      -1,    -1,   362,   363,   364,   365,    -1,   367,   368,   369,
     370,   371,   372,   373,    -1,    -1,   376,   377,   378,   379,
     380,    -1,    -1,   383,   384,   385,   386,   387,   388,   389,
      -1,   391,    -1,   393,   394,   395,   396,    -1,    -1,   399,
      -1,    -1,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    14,    15,    16,    17,    18,    19,    20,    21,    22,
      23,    24,    25,    -1,    -1,    -1,    -1,    30,    -1,    -1,
      -1,    34,    35,    -1,    37,    38,    -1,    40,    41,    42,
      43,    44,    -1,    46,    47,    -1,    49,    50,    51,    52,
      53,    -1,    -1,    56,    57,    58,    59,    60,    -1,    62,
      63,    64,    65,    66,    -1,    -1,    -1,    70,    71,    72,
      73,    -1,    75,    76,    -1,    78,    79,    80,    81,    82,
      83,    -1,    -1,    86,    87,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    95,    96,    97,    98,    99,   100,   101,   102,
     103,    -1,   105,    -1,   107,   108,   109,   110,   111,    -1,
     113,   114,   115,    -1,    -1,   118,   119,   120,   121,   122,
      -1,   124,   125,   126,    -1,   128,   129,   130,    -1,   132,
     133,   134,   135,   136,   137,   138,   139,   140,    -1,   142,
      -1,   144,   145,   146,   147,    -1,   149,    -1,   151,    -1,
      -1,    -1,   155,   156,   157,    -1,   159,   160,    -1,   162,
      -1,   164,   165,   166,   167,   168,    -1,   170,   171,   172,
      -1,   174,   175,   176,   177,   178,   179,    -1,   181,    -1,
     183,   184,   185,   186,   187,   188,   189,    -1,   191,    -1,
     193,    -1,    -1,   196,    -1,   198,   199,   200,   201,   202,
      -1,   204,   205,    -1,   207,   208,    -1,   210,    -1,    -1,
     213,   214,   215,    -1,    -1,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,    -1,
     233,   234,   235,   236,    -1,   238,   239,    -1,   241,    -1,
     243,   244,   245,   246,   247,   248,    -1,   250,    -1,    -1,
     253,   254,   255,    -1,    -1,   258,   259,    -1,   261,    -1,
     263,   264,   265,   266,   267,   268,   269,   270,    -1,   272,
     273,   274,   275,   276,   277,   278,    -1,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,   292,
      -1,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,   304,    -1,   306,   307,    -1,   309,   310,   311,   312,
     313,   314,   315,   316,   317,   318,   319,    -1,   321,   322,
     323,   324,   325,    -1,   327,   328,   329,   330,    -1,   332,
     333,   334,    -1,   336,   337,   338,   339,   340,   341,   342,
     343,   344,   345,   346,    -1,   348,   349,    -1,   351,   352,
     353,   354,   355,   356,    -1,   358,   359,    -1,    -1,   362,
     363,   364,   365,    -1,   367,   368,   369,   370,   371,   372,
     373,    -1,    -1,   376,   377,   378,   379,   380,    -1,    -1,
     383,   384,   385,   386,   387,   388,   389,    -1,   391,    -1,
     393,   394,   395,   396,    -1,    -1,   399,    -1,    -1,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,    15,
      16,    17,    18,    19,    20,    21,    22,    23,    24,    25,
      -1,    -1,    -1,    -1,    30,    -1,    -1,    -1,    34,    35,
      -1,    37,    38,    -1,    40,    41,    42,    43,    44,    -1,
      46,    47,    -1,    49,    50,    51,    52,    53,    -1,    -1,
      56,    57,    58,    59,    60,    -1,    62,    63,    64,    65,
      66,    -1,    -1,    -1,    70,    71,    72,    73,    -1,    75,
      76,    -1,    78,    79,    80,    81,    82,    83,    -1,    -1,
      86,    87,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    95,
      96,    97,    98,    99,   100,   101,   102,   103,    -1,   105,
      -1,   107,   108,   109,   110,   111,    -1,   113,   114,   115,
      -1,    -1,   118,   119,   120,   121,   122,    -1,   124,   125,
     126,    -1,   128,   129,   130,    -1,   132,   133,   134,   135,
     136,   137,   138,   139,   140,    -1,   142,    -1,   144,   145,
     146,   147,    -1,   149,    -1,   151,    -1,    -1,    -1,   155,
     156,   157,    -1,   159,   160,    -1,   162,    -1,   164,   165,
     166,   167,   168,    -1,   170,   171,   172,    -1,   174,   175,
     176,   177,   178,   179,    -1,   181,    -1,   183,   184,   185,
     186,   187,   188,   189,    -1,   191,    -1,   193,    -1,    -1,
     196,    -1,   198,   199,   200,   201,   202,    -1,   204,   205,
      -1,   207,   208,    -1,   210,    -1,    -1,   213,   214,   215,
      -1,    -1,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,    -1,   233,   234,   235,
     236,    -1,   238,   239,    -1,   241,    -1,   243,   244,   245,
     246,   247,   248,    -1,   250,    -1,    -1,   253,   254,   255,
      -1,    -1,   258,   259,    -1,   261,    -1,   263,   264,   265,
     266,   267,   268,   269,   270,    -1,   272,   273,   274,   275,
     276,   277,   278,    -1,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,   292,    -1,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,    -1,
     306,   307,    -1,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,   319,    -1,   321,   322,   323,   324,   325,
      -1,   327,   328,   329,   330,    -1,   332,   333,   334,    -1,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,    -1,   348,   349,    -1,   351,   352,   353,   354,   355,
     356,    -1,   358,   359,    -1,    -1,   362,   363,   364,   365,
      -1,   367,   368,   369,   370,   371,   372,   373,    -1,    -1,
     376,   377,   378,   379,   380,    -1,    -1,   383,   384,   385,
     386,   387,   388,   389,    -1,   391,    -1,   393,   394,   395,
     396,    -1,    -1,   399,    -1,    -1,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,
      19,    20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,
      -1,    30,    -1,    -1,    -1,    34,    35,    -1,    37,    38,
      -1,    40,    41,    42,    43,    44,    -1,    46,    47,    -1,
      49,    50,    51,    52,    53,    -1,    -1,    56,    57,    58,
      59,    60,    -1,    62,    63,    64,    65,    66,    -1,    -1,
      -1,    70,    71,    72,    73,    -1,    75,    76,    -1,    78,
      79,    80,    81,    82,    83,    -1,    -1,    86,    87,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    95,    96,    97,    98,
      99,   100,   101,   102,   103,    -1,   105,    -1,   107,   108,
     109,   110,   111,    -1,   113,   114,   115,    -1,    -1,   118,
     119,   120,   121,   122,    -1,   124,   125,   126,    -1,   128,
     129,   130,    -1,   132,   133,   134,   135,   136,   137,   138,
     139,   140,    -1,   142,    -1,   144,   145,   146,   147,    -1,
     149,    -1,   151,    -1,    -1,    -1,   155,   156,   157,    -1,
     159,   160,    -1,   162,    -1,   164,   165,   166,   167,   168,
      -1,   170,   171,   172,    -1,   174,   175,   176,   177,   178,
     179,    -1,   181,    -1,   183,   184,   185,   186,   187,   188,
     189,    -1,   191,    -1,   193,    -1,    -1,   196,    -1,   198,
     199,   200,   201,   202,    -1,   204,   205,    -1,   207,   208,
      -1,   210,    -1,    -1,   213,   214,   215,    -1,    -1,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,    -1,   233,   234,   235,   236,    -1,   238,
     239,    -1,   241,    -1,   243,   244,   245,   246,   247,   248,
      -1,   250,    -1,    -1,   253,   254,   255,    -1,    -1,   258,
     259,    -1,   261,    -1,   263,   264,   265,   266,   267,   268,
     269,   270,    -1,   272,   273,   274,   275,   276,   277,   278,
      -1,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,   292,    -1,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,   304,    -1,   306,   307,    -1,
     309,   310,   311,   312,   313,   314,   315,   316,   317,   318,
     319,    -1,   321,   322,   323,   324,   325,    -1,   327,   328,
     329,   330,    -1,   332,   333,   334,    -1,   336,   337,   338,
     339,   340,   341,   342,   343,   344,   345,   346,    -1,   348,
     349,   350,   351,   352,   353,   354,   355,   356,    -1,   358,
     359,    -1,    -1,   362,   363,   364,   365,    -1,   367,   368,
     369,   370,   371,   372,   373,    -1,    -1,   376,   377,   378,
     379,   380,    -1,    -1,   383,   384,   385,   386,   387,   388,
     389,    -1,   391,    -1,   393,   394,   395,   396,    -1,    -1,
     399,    -1,    -1,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,     3,    -1,     5,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    14,    15,    16,    17,    18,    19,    20,    21,
      -1,    23,    24,    25,    -1,    -1,    -1,    -1,    30,    -1,
      -1,    -1,    34,    35,    -1,    37,    38,    -1,    40,    41,
      42,    43,    44,    -1,    46,    47,    -1,    49,    50,    51,
      52,    53,    -1,    -1,    56,    57,    58,    59,    60,    -1,
      62,    63,    64,    65,    66,    -1,    -1,    -1,    70,    71,
      72,    73,    -1,    75,    76,    -1,    78,    79,    80,    81,
      82,    83,    -1,    -1,    86,    87,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    95,    96,    97,    98,    99,   100,   101,
     102,   103,    -1,   105,    -1,   107,   108,   109,   110,   111,
      -1,   113,   114,   115,    -1,    -1,   118,   119,   120,   121,
     122,    -1,   124,   125,   126,    -1,   128,   129,   130,    -1,
     132,   133,   134,   135,   136,   137,   138,   139,   140,    -1,
     142,    -1,   144,   145,   146,   147,    -1,   149,    -1,   151,
      -1,    -1,    -1,   155,   156,   157,    -1,   159,   160,    -1,
     162,    -1,   164,   165,   166,   167,   168,    -1,   170,   171,
     172,    -1,   174,   175,   176,   177,   178,   179,    -1,   181,
      -1,   183,   184,   185,   186,   187,   188,   189,    -1,   191,
      -1,   193,    -1,    -1,   196,    -1,   198,   199,   200,   201,
     202,    -1,   204,   205,    -1,   207,   208,    -1,   210,    -1,
      -1,   213,   214,   215,    -1,    -1,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
      -1,   233,   234,   235,   236,    -1,   238,   239,    -1,   241,
      -1,   243,   244,   245,   246,   247,   248,    -1,   250,    -1,
      -1,   253,   254,   255,    -1,    -1,   258,   259,    -1,   261,
      -1,   263,   264,   265,   266,   267,   268,   269,   270,    -1,
     272,   273,   274,   275,   276,   277,   278,    -1,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
     292,    -1,   294,   295,   296,   297,   298,   299,   300,   301,
     302,   303,   304,    -1,   306,   307,    -1,   309,   310,   311,
     312,   313,   314,   315,   316,   317,   318,   319,    -1,   321,
     322,   323,   324,   325,    -1,   327,   328,   329,   330,    -1,
     332,   333,   334,    -1,   336,   337,   338,   339,   340,   341,
     342,   343,   344,   345,   346,    -1,   348,   349,    -1,   351,
     352,   353,   354,   355,   356,    -1,   358,   359,    -1,    -1,
     362,   363,   364,   365,    -1,   367,   368,   369,   370,   371,
     372,   373,    -1,    -1,   376,   377,   378,   379,   380,    -1,
      -1,   383,   384,   385,   386,   387,   388,   389,    -1,   391,
      -1,   393,   394,   395,   396,    -1,    -1,   399,    -1,    -1,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,
      15,    16,    17,    18,    19,    20,    21,    -1,    23,    24,
      25,    -1,    -1,    -1,    -1,    30,    -1,    32,    -1,    34,
      35,    -1,    37,    38,    -1,    40,    41,    42,    43,    44,
      -1,    46,    47,    -1,    49,    50,    51,    52,    53,    -1,
      -1,    56,    57,    58,    59,    60,    -1,    62,    63,    64,
      65,    66,    -1,    -1,    -1,    70,    71,    72,    73,    -1,
      75,    76,    -1,    78,    79,    80,    81,    82,    83,    -1,
      -1,    86,    87,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      95,    96,    97,    98,    99,   100,   101,   102,   103,    -1,
     105,    -1,   107,   108,   109,   110,   111,    -1,   113,   114,
     115,    -1,    -1,   118,   119,   120,   121,   122,    -1,   124,
     125,   126,    -1,   128,   129,   130,    -1,   132,   133,   134,
     135,   136,   137,   138,   139,   140,    -1,   142,    -1,   144,
     145,   146,   147,    -1,   149,    -1,   151,    -1,    -1,    -1,
     155,   156,   157,    -1,   159,   160,    -1,   162,    -1,   164,
     165,   166,   167,   168,    -1,   170,   171,   172,    -1,   174,
     175,   176,   177,   178,   179,    -1,   181,    -1,   183,   184,
     185,   186,   187,   188,   189,    -1,   191,    -1,   193,    -1,
      -1,   196,    -1,   198,   199,   200,   201,   202,    -1,   204,
     205,    -1,   207,   208,    -1,   210,    -1,    -1,   213,   214,
     215,    -1,    -1,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,    -1,   233,   234,
     235,   236,    -1,   238,   239,    -1,   241,    -1,   243,   244,
     245,   246,   247,   248,    -1,   250,    -1,    -1,   253,   254,
     255,    -1,    -1,   258,   259,    -1,   261,    -1,   263,   264,
     265,   266,   267,   268,   269,   270,    -1,   272,   273,   274,
     275,   276,   277,   278,    -1,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,    -1,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
      -1,   306,   307,    -1,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,    -1,   321,   322,   323,   324,
     325,    -1,   327,   328,   329,   330,    -1,   332,   333,   334,
      -1,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,    -1,   348,   349,    -1,   351,   352,   353,   354,
     355,   356,    -1,   358,   359,    -1,    -1,   362,   363,   364,
     365,    -1,   367,   368,   369,   370,   371,   372,   373,    -1,
      -1,   376,   377,   378,   379,   380,    -1,    -1,   383,   384,
     385,   386,   387,   388,   389,    -1,   391,    -1,   393,   394,
     395,   396,    -1,    -1,   399,    -1,    -1,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,
      18,    19,    20,    21,    -1,    23,    24,    25,    -1,    -1,
      -1,    -1,    30,    -1,    32,    -1,    34,    35,    -1,    37,
      38,    -1,    40,    41,    42,    43,    44,    -1,    46,    47,
      -1,    49,    50,    51,    52,    53,    -1,    -1,    56,    57,
      58,    59,    60,    -1,    62,    63,    64,    65,    66,    -1,
      -1,    -1,    70,    71,    72,    73,    -1,    75,    76,    -1,
      78,    79,    80,    81,    82,    83,    -1,    -1,    86,    87,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    95,    96,    97,
      98,    99,   100,   101,   102,   103,    -1,   105,    -1,   107,
     108,   109,   110,   111,    -1,   113,   114,   115,    -1,    -1,
     118,   119,   120,   121,   122,    -1,   124,   125,   126,    -1,
     128,   129,   130,    -1,   132,   133,   134,   135,   136,   137,
     138,   139,   140,    -1,   142,    -1,   144,   145,   146,   147,
      -1,   149,    -1,   151,    -1,    -1,    -1,   155,   156,   157,
      -1,   159,   160,    -1,   162,    -1,   164,   165,   166,   167,
     168,    -1,   170,   171,   172,    -1,   174,   175,   176,   177,
     178,   179,    -1,   181,    -1,   183,   184,   185,   186,   187,
     188,   189,    -1,   191,    -1,   193,    -1,    -1,   196,    -1,
     198,   199,   200,   201,   202,    -1,   204,   205,    -1,   207,
     208,    -1,   210,    -1,    -1,   213,   214,   215,    -1,    -1,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,    -1,   233,   234,   235,   236,    -1,
     238,   239,    -1,   241,    -1,   243,   244,   245,   246,   247,
     248,    -1,   250,    -1,    -1,   253,   254,   255,    -1,    -1,
     258,   259,    -1,   261,    -1,   263,   264,   265,   266,   267,
     268,   269,   270,    -1,   272,   273,   274,   275,   276,   277,
     278,    -1,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,   290,   291,   292,    -1,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,    -1,   306,   307,
      -1,   309,   310,   311,   312,   313,   314,   315,   316,   317,
     318,   319,    -1,   321,   322,   323,   324,   325,    -1,   327,
     328,   329,   330,    -1,   332,   333,   334,    -1,   336,   337,
     338,   339,   340,   341,   342,   343,   344,   345,   346,    -1,
     348,   349,    -1,   351,   352,   353,   354,   355,   356,    -1,
     358,   359,    -1,    -1,   362,   363,   364,   365,    -1,   367,
     368,   369,   370,   371,   372,   373,    -1,    -1,   376,   377,
     378,   379,   380,    -1,    -1,   383,   384,   385,   386,   387,
     388,   389,    -1,   391,    -1,   393,   394,   395,   396,    -1,
      -1,   399,    -1,    -1,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    14,    15,    16,    17,    18,    19,    20,
      21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,    30,
      -1,    -1,    -1,    34,    35,    -1,    37,    38,    -1,    40,
      41,    42,    43,    44,    -1,    46,    47,    -1,    49,    50,
      51,    52,    53,    -1,    -1,    56,    57,    58,    59,    60,
      -1,    62,    63,    64,    65,    66,    -1,    -1,    -1,    70,
      71,    72,    73,    -1,    75,    76,    -1,    78,    79,    80,
      81,    82,    83,    -1,    -1,    86,    87,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    95,    96,    97,    98,    99,   100,
     101,   102,   103,   104,   105,    -1,   107,   108,   109,   110,
     111,    -1,   113,   114,   115,    -1,    -1,   118,   119,   120,
     121,   122,    -1,   124,   125,   126,    -1,   128,   129,   130,
      -1,   132,   133,   134,   135,   136,   137,   138,   139,   140,
      -1,   142,    -1,   144,   145,   146,   147,    -1,   149,    -1,
     151,    -1,    -1,    -1,   155,   156,   157,    -1,   159,   160,
      -1,   162,    -1,   164,   165,   166,   167,   168,    -1,   170,
     171,   172,    -1,   174,   175,   176,   177,   178,   179,    -1,
     181,    -1,   183,   184,   185,   186,   187,   188,   189,    -1,
     191,    -1,   193,    -1,    -1,   196,    -1,   198,   199,   200,
     201,   202,    -1,   204,   205,    -1,   207,   208,    -1,   210,
      -1,    -1,   213,   214,   215,    -1,    -1,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,    -1,   233,   234,   235,   236,    -1,   238,   239,    -1,
     241,    -1,   243,   244,   245,   246,   247,   248,    -1,   250,
      -1,    -1,   253,   254,   255,    -1,    -1,   258,   259,    -1,
     261,    -1,   263,   264,   265,   266,   267,   268,   269,   270,
      -1,   272,   273,   274,   275,   276,   277,   278,    -1,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,   292,    -1,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,   304,    -1,   306,   307,    -1,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,   319,    -1,
     321,   322,   323,   324,   325,    -1,   327,   328,   329,   330,
      -1,   332,   333,   334,    -1,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,   346,    -1,   348,   349,    -1,
     351,   352,   353,   354,   355,   356,    -1,   358,   359,    -1,
      -1,   362,   363,   364,   365,    -1,   367,   368,   369,   370,
     371,   372,   373,    -1,    -1,   376,   377,   378,   379,   380,
      -1,    -1,   383,   384,   385,   386,   387,   388,   389,    -1,
     391,    -1,   393,   394,   395,   396,    -1,    -1,   399,    -1,
      -1,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,   419,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      14,    15,    16,    17,    18,    19,    20,    21,    -1,    23,
      24,    25,    -1,    -1,    -1,    -1,    30,    -1,    -1,    -1,
      34,    35,    -1,    37,    38,    -1,    40,    41,    42,    43,
      44,    -1,    46,    47,    -1,    49,    50,    51,    52,    53,
      -1,    -1,    56,    57,    58,    59,    60,    -1,    62,    63,
      64,    65,    66,    -1,    -1,    -1,    70,    71,    72,    73,
      -1,    75,    76,    -1,    78,    79,    80,    81,    82,    83,
      -1,    -1,    86,    87,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    95,    96,    97,    98,    99,   100,   101,   102,   103,
     104,   105,    -1,   107,   108,   109,   110,   111,    -1,   113,
     114,   115,    -1,    -1,   118,   119,   120,   121,   122,    -1,
     124,   125,   126,    -1,   128,   129,   130,    -1,   132,   133,
     134,   135,   136,   137,   138,   139,   140,    -1,   142,    -1,
     144,   145,   146,   147,    -1,   149,    -1,   151,    -1,    -1,
      -1,   155,   156,   157,    -1,   159,   160,    -1,   162,    -1,
     164,   165,   166,   167,   168,    -1,   170,   171,   172,    -1,
     174,   175,   176,   177,   178,   179,    -1,   181,    -1,   183,
     184,   185,   186,   187,   188,   189,    -1,   191,    -1,   193,
      -1,    -1,   196,    -1,   198,   199,   200,   201,   202,    -1,
     204,   205,    -1,   207,   208,    -1,   210,    -1,    -1,   213,
     214,   215,    -1,    -1,   218,   219,   220,   221,   222,   223,
     224,   225,   226,   227,   228,   229,   230,   231,    -1,   233,
     234,   235,   236,    -1,   238,   239,    -1,   241,    -1,   243,
     244,   245,   246,   247,   248,    -1,   250,    -1,    -1,   253,
     254,   255,    -1,    -1,   258,   259,    -1,   261,    -1,   263,
     264,   265,   266,   267,   268,   269,   270,    -1,   272,   273,
     274,   275,   276,   277,   278,    -1,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,   292,    -1,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
     304,    -1,   306,   307,    -1,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,   319,    -1,   321,   322,   323,
     324,   325,    -1,   327,   328,   329,   330,    -1,   332,   333,
     334,    -1,   336,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,    -1,   348,   349,    -1,   351,   352,   353,
     354,   355,   356,    -1,   358,   359,    -1,    -1,   362,   363,
     364,   365,    -1,   367,   368,   369,   370,   371,   372,   373,
      -1,    -1,   376,   377,   378,   379,   380,    -1,    -1,   383,
     384,   385,   386,   387,   388,   389,    -1,   391,    -1,   393,
     394,   395,   396,    -1,    -1,   399,    -1,    -1,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,    15,    16,
      17,    18,    19,    20,    21,    -1,    23,    24,    25,    -1,
      -1,    -1,    -1,    30,    -1,    -1,    -1,    34,    35,    -1,
      37,    38,    -1,    40,    41,    42,    43,    44,    -1,    46,
      47,    -1,    49,    50,    51,    52,    53,    -1,    -1,    56,
      57,    58,    59,    60,    -1,    62,    63,    64,    65,    66,
      -1,    -1,    -1,    70,    71,    72,    73,    -1,    75,    76,
      -1,    78,    79,    80,    81,    82,    83,    -1,    -1,    86,
      87,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    95,    96,
      97,    98,    99,   100,   101,   102,   103,   104,   105,    -1,
     107,   108,   109,   110,   111,    -1,   113,   114,   115,    -1,
      -1,   118,   119,   120,   121,   122,    -1,   124,   125,   126,
      -1,   128,   129,   130,    -1,   132,   133,   134,   135,   136,
     137,   138,   139,   140,    -1,   142,    -1,   144,   145,   146,
     147,    -1,   149,    -1,   151,    -1,    -1,    -1,   155,   156,
     157,    -1,   159,   160,    -1,   162,    -1,   164,   165,   166,
     167,   168,    -1,   170,   171,   172,    -1,   174,   175,   176,
     177,   178,   179,    -1,   181,    -1,   183,   184,   185,   186,
     187,   188,   189,    -1,   191,    -1,   193,    -1,    -1,   196,
      -1,   198,   199,   200,   201,   202,    -1,   204,   205,    -1,
     207,   208,    -1,   210,    -1,    -1,   213,   214,   215,    -1,
      -1,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,    -1,   233,   234,   235,   236,
      -1,   238,   239,    -1,   241,    -1,   243,   244,   245,   246,
     247,   248,    -1,   250,    -1,    -1,   253,   254,   255,    -1,
      -1,   258,   259,    -1,   261,    -1,   263,   264,   265,   266,
     267,   268,   269,   270,    -1,   272,   273,   274,   275,   276,
     277,   278,    -1,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,   292,    -1,   294,   295,   296,
     297,   298,   299,   300,   301,   302,   303,   304,    -1,   306,
     307,    -1,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,    -1,   321,   322,   323,   324,   325,    -1,
     327,   328,   329,   330,    -1,   332,   333,   334,    -1,   336,
     337,   338,   339,   340,   341,   342,   343,   344,   345,   346,
      -1,   348,   349,    -1,   351,   352,   353,   354,   355,   356,
      -1,   358,   359,    -1,    -1,   362,   363,   364,   365,    -1,
     367,   368,   369,   370,   371,   372,   373,    -1,    -1,   376,
     377,   378,   379,   380,    -1,    -1,   383,   384,   385,   386,
     387,   388,   389,    -1,   391,    -1,   393,   394,   395,   396,
      -1,    -1,   399,    -1,    -1,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,    19,
      20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,
      30,    -1,    -1,    -1,    34,    35,    -1,    37,    38,    -1,
      40,    41,    42,    43,    44,    -1,    46,    47,    -1,    49,
      50,    51,    52,    53,    -1,    -1,    56,    57,    58,    59,
      60,    -1,    62,    63,    64,    65,    66,    -1,    -1,    -1,
      70,    71,    72,    73,    -1,    75,    76,    -1,    78,    79,
      80,    81,    82,    83,    -1,    -1,    86,    87,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    95,    96,    97,    98,    99,
     100,   101,   102,   103,    -1,   105,    -1,   107,   108,   109,
     110,   111,    -1,   113,   114,   115,    -1,    -1,   118,   119,
     120,   121,   122,    -1,   124,   125,   126,    -1,   128,   129,
     130,    -1,   132,   133,   134,   135,   136,   137,   138,   139,
     140,    -1,   142,    -1,   144,   145,   146,   147,    -1,   149,
      -1,   151,    -1,    -1,    -1,   155,   156,   157,    -1,   159,
     160,    -1,   162,    -1,   164,   165,   166,   167,   168,    -1,
     170,   171,   172,    -1,   174,   175,   176,   177,   178,   179,
      -1,   181,    -1,   183,   184,   185,   186,   187,   188,   189,
      -1,   191,    -1,   193,    -1,    -1,   196,    -1,   198,   199,
     200,   201,   202,    -1,   204,   205,    -1,   207,   208,    -1,
     210,    -1,    -1,   213,   214,   215,    -1,    -1,   218,   219,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,    -1,   233,   234,   235,   236,    -1,   238,   239,
      -1,   241,    -1,   243,   244,   245,   246,   247,   248,    -1,
     250,    -1,    -1,   253,   254,   255,    -1,    -1,   258,   259,
      -1,   261,    -1,   263,   264,   265,   266,   267,   268,   269,
     270,    -1,   272,   273,   274,   275,   276,   277,   278,    -1,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,   292,    -1,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,   304,    -1,   306,   307,    -1,   309,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
      -1,   321,   322,   323,   324,   325,    -1,   327,   328,   329,
     330,    -1,   332,   333,   334,    -1,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,    -1,   348,   349,
      -1,   351,   352,   353,   354,   355,   356,    -1,   358,   359,
      -1,    -1,   362,   363,   364,   365,    -1,   367,   368,   369,
     370,   371,   372,   373,    -1,    -1,   376,   377,   378,   379,
     380,    -1,   382,   383,   384,   385,   386,   387,   388,   389,
      -1,   391,    -1,   393,   394,   395,   396,    -1,    -1,   399,
      -1,    -1,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    14,    15,    16,    17,    18,    19,    20,    21,    -1,
      23,    24,    25,    -1,    -1,    -1,    -1,    30,    -1,    -1,
      -1,    34,    35,    -1,    37,    38,    -1,    40,    41,    42,
      43,    44,    -1,    46,    47,    -1,    49,    50,    51,    52,
      53,    -1,    -1,    56,    57,    58,    59,    60,    -1,    62,
      63,    64,    65,    66,    -1,    -1,    -1,    70,    71,    72,
      73,    -1,    75,    76,    -1,    78,    79,    80,    81,    82,
      83,    -1,    -1,    86,    87,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    95,    96,    97,    98,    99,   100,   101,   102,
     103,    -1,   105,    -1,   107,   108,   109,   110,   111,    -1,
     113,   114,   115,    -1,    -1,   118,   119,   120,   121,   122,
      -1,   124,   125,   126,    -1,   128,   129,   130,    -1,   132,
     133,   134,   135,   136,   137,   138,   139,   140,    -1,   142,
      -1,   144,   145,   146,   147,    -1,   149,    -1,   151,    -1,
      -1,    -1,   155,   156,   157,    -1,   159,   160,    -1,   162,
      -1,   164,   165,   166,   167,   168,    -1,   170,   171,   172,
      -1,   174,   175,   176,   177,   178,   179,    -1,   181,    -1,
     183,   184,   185,   186,   187,   188,   189,    -1,   191,    -1,
     193,    -1,    -1,   196,    -1,   198,   199,   200,   201,   202,
      -1,   204,   205,    -1,   207,   208,    -1,   210,    -1,    -1,
     213,   214,   215,    -1,    -1,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,    -1,
     233,   234,   235,   236,    -1,   238,   239,    -1,   241,    -1,
     243,   244,   245,   246,   247,   248,    -1,   250,    -1,    -1,
     253,   254,   255,    -1,    -1,   258,   259,    -1,   261,    -1,
     263,   264,   265,   266,   267,   268,   269,   270,    -1,   272,
     273,   274,   275,   276,   277,   278,    -1,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,   292,
      -1,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,   304,    -1,   306,   307,    -1,   309,   310,   311,   312,
     313,   314,   315,   316,   317,   318,   319,    -1,   321,   322,
     323,   324,   325,    -1,   327,   328,   329,   330,    -1,   332,
     333,   334,    -1,   336,   337,   338,   339,   340,   341,   342,
     343,   344,   345,   346,    -1,   348,   349,    -1,   351,   352,
     353,   354,   355,   356,    -1,   358,   359,    -1,    -1,   362,
     363,   364,   365,    -1,   367,   368,   369,   370,   371,   372,
     373,    -1,    -1,   376,   377,   378,   379,   380,    -1,    -1,
     383,   384,   385,   386,   387,   388,   389,    -1,   391,    -1,
     393,   394,   395,   396,    -1,    -1,   399,    -1,    -1,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,    15,
      16,    17,    18,    19,    20,    21,    -1,    23,    24,    25,
      -1,    -1,    -1,    -1,    30,    -1,    -1,    -1,    34,    35,
      -1,    37,    38,    -1,    40,    41,    42,    43,    44,    -1,
      46,    47,    -1,    49,    50,    51,    52,    53,    -1,    -1,
      56,    57,    58,    59,    60,    -1,    62,    63,    64,    65,
      66,    -1,    -1,    -1,    70,    71,    72,    73,    -1,    75,
      76,    -1,    78,    79,    80,    81,    82,    83,    -1,    -1,
      86,    87,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    95,
      96,    97,    98,    99,   100,   101,   102,   103,    -1,   105,
      -1,   107,   108,   109,   110,   111,    -1,   113,   114,   115,
      -1,    -1,   118,   119,   120,   121,   122,    -1,   124,   125,
     126,    -1,   128,   129,   130,    -1,   132,   133,   134,   135,
     136,   137,   138,   139,   140,    -1,   142,    -1,   144,   145,
     146,   147,    -1,   149,    -1,   151,    -1,    -1,    -1,   155,
     156,   157,    -1,   159,   160,    -1,   162,    -1,   164,   165,
     166,   167,   168,    -1,   170,   171,   172,    -1,   174,   175,
     176,   177,   178,   179,    -1,   181,    -1,   183,   184,   185,
     186,   187,   188,   189,    -1,   191,    -1,   193,    -1,    -1,
     196,    -1,   198,   199,   200,   201,   202,    -1,   204,   205,
      -1,   207,   208,    -1,   210,    -1,    -1,   213,   214,   215,
      -1,    -1,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,    -1,   233,   234,   235,
     236,    -1,   238,   239,    -1,   241,    -1,   243,   244,   245,
     246,   247,   248,    -1,   250,    -1,    -1,   253,   254,   255,
      -1,    -1,   258,   259,    -1,   261,    -1,   263,   264,   265,
     266,   267,   268,   269,   270,    -1,   272,   273,   274,   275,
     276,   277,   278,    -1,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,   292,    -1,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,    -1,
     306,   307,    -1,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,   319,    -1,   321,   322,   323,   324,   325,
      -1,   327,   328,   329,   330,    -1,   332,   333,   334,    -1,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,    -1,   348,   349,    -1,   351,   352,   353,   354,   355,
     356,    -1,   358,   359,    -1,    -1,   362,   363,   364,   365,
      -1,   367,   368,   369,   370,   371,   372,   373,    -1,    -1,
     376,   377,   378,   379,   380,    -1,    -1,   383,   384,   385,
     386,   387,   388,   389,    -1,   391,    -1,   393,   394,   395,
     396,    -1,    -1,   399,    -1,    -1,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,
      19,    20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,
      -1,    30,    -1,    -1,    -1,    34,    35,    -1,    37,    38,
      -1,    40,    41,    42,    43,    44,    -1,    46,    47,    -1,
      49,    50,    51,    52,    53,    -1,    -1,    56,    57,    58,
      59,    60,    -1,    62,    63,    64,    65,    66,    -1,    -1,
      -1,    70,    71,    72,    73,    -1,    75,    76,    -1,    78,
      79,    80,    81,    82,    83,    -1,    -1,    86,    87,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    95,    96,    97,    98,
      99,   100,   101,   102,   103,    -1,   105,    -1,   107,   108,
     109,   110,   111,    -1,   113,   114,   115,    -1,    -1,   118,
     119,   120,   121,   122,    -1,   124,   125,   126,    -1,   128,
     129,   130,    -1,   132,   133,   134,   135,   136,   137,   138,
     139,   140,    -1,   142,    -1,   144,   145,   146,   147,    -1,
     149,    -1,   151,    -1,    -1,    -1,   155,   156,   157,    -1,
     159,   160,    -1,   162,    -1,   164,   165,   166,   167,   168,
      -1,   170,   171,   172,    -1,   174,   175,   176,   177,   178,
     179,    -1,   181,    -1,   183,   184,   185,   186,   187,   188,
     189,    -1,   191,    -1,   193,    -1,    -1,   196,    -1,   198,
     199,   200,   201,   202,    -1,   204,   205,    -1,   207,   208,
      -1,   210,    -1,    -1,   213,   214,   215,    -1,    -1,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,    -1,   233,   234,   235,   236,    -1,   238,
     239,    -1,   241,    -1,   243,   244,   245,   246,   247,   248,
      -1,   250,    -1,    -1,   253,   254,   255,    -1,    -1,   258,
     259,    -1,   261,    -1,   263,   264,   265,   266,   267,   268,
     269,   270,    -1,   272,   273,   274,   275,   276,   277,   278,
      -1,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,   292,    -1,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,   304,    -1,   306,   307,    -1,
     309,   310,   311,   312,   313,   314,   315,   316,   317,   318,
     319,    -1,   321,   322,   323,   324,   325,    -1,   327,   328,
     329,   330,    -1,   332,   333,   334,    -1,   336,   337,   338,
     339,   340,   341,   342,   343,   344,   345,   346,    -1,   348,
     349,    -1,   351,   352,   353,   354,   355,   356,    -1,   358,
     359,    -1,    -1,   362,   363,   364,   365,    -1,   367,   368,
     369,   370,   371,   372,   373,    -1,    -1,   376,   377,   378,
     379,   380,    -1,    -1,   383,   384,   385,   386,   387,   388,
     389,    -1,   391,    -1,   393,   394,   395,   396,    -1,    -1,
     399,    -1,    -1,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    14,    15,    16,    17,    18,    19,    20,    21,
      -1,    23,    24,    25,    -1,    -1,    -1,    -1,    30,    -1,
      -1,    -1,    34,    35,    -1,    37,    38,    -1,    40,    41,
      42,    43,    44,    -1,    46,    47,    -1,    49,    50,    51,
      52,    53,    -1,    -1,    56,    57,    58,    59,    60,    -1,
      62,    63,    64,    65,    66,    -1,    -1,    -1,    70,    71,
      72,    73,    -1,    75,    76,    -1,    78,    79,    80,    81,
      82,    83,    -1,    -1,    86,    87,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    95,    96,    97,    98,    99,   100,   101,
     102,   103,    -1,   105,    -1,   107,   108,   109,   110,   111,
      -1,   113,   114,   115,    -1,    -1,   118,   119,   120,   121,
     122,    -1,   124,   125,   126,    -1,   128,   129,   130,    -1,
     132,   133,   134,   135,   136,   137,   138,   139,   140,    -1,
     142,    -1,   144,   145,   146,   147,    -1,   149,    -1,   151,
      -1,    -1,    -1,   155,   156,   157,    -1,   159,   160,    -1,
     162,    -1,   164,   165,   166,   167,   168,    -1,   170,   171,
     172,    -1,   174,   175,   176,   177,   178,   179,    -1,   181,
      -1,   183,   184,   185,   186,   187,   188,   189,    -1,   191,
      -1,   193,    -1,    -1,   196,    -1,   198,   199,   200,   201,
     202,    -1,   204,   205,    -1,   207,   208,    -1,   210,    -1,
      -1,   213,   214,   215,    -1,    -1,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
      -1,   233,   234,   235,   236,    -1,   238,   239,    -1,   241,
      -1,   243,   244,   245,   246,   247,   248,    -1,   250,    -1,
      -1,   253,   254,   255,    -1,    -1,   258,   259,    -1,   261,
      -1,   263,   264,   265,   266,   267,   268,   269,   270,    -1,
     272,   273,   274,   275,   276,   277,   278,    -1,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
     292,    -1,   294,   295,   296,   297,   298,   299,   300,   301,
     302,   303,   304,    -1,   306,   307,    -1,   309,   310,   311,
     312,   313,   314,   315,   316,   317,   318,   319,    -1,   321,
     322,   323,   324,   325,    -1,   327,   328,   329,   330,    -1,
     332,   333,   334,    -1,   336,   337,   338,   339,   340,   341,
     342,   343,   344,   345,   346,    -1,   348,   349,    -1,   351,
     352,   353,   354,   355,   356,    -1,   358,   359,    -1,    -1,
     362,   363,   364,   365,    -1,   367,   368,   369,   370,   371,
     372,   373,    -1,    -1,   376,   377,   378,   379,   380,    -1,
      -1,   383,   384,   385,   386,   387,   388,   389,    -1,   391,
      -1,   393,   394,   395,   396,    -1,    -1,   399,    -1,    -1,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,
      15,    16,    17,    18,    19,    20,    21,    -1,    23,    24,
      25,    -1,    -1,    -1,    -1,    30,    -1,    -1,    -1,    34,
      35,    -1,    37,    38,    -1,    40,    41,    42,    43,    44,
      -1,    46,    47,    -1,    49,    50,    51,    52,    53,    -1,
      -1,    56,    57,    58,    59,    60,    -1,    62,    63,    64,
      65,    66,    -1,    -1,    -1,    70,    71,    72,    73,    -1,
      75,    76,    -1,    78,    79,    80,    81,    82,    83,    -1,
      -1,    86,    87,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      95,    96,    97,    98,    99,   100,   101,   102,   103,    -1,
     105,    -1,   107,   108,   109,   110,   111,    -1,   113,   114,
     115,    -1,    -1,   118,   119,   120,   121,   122,    -1,   124,
     125,   126,    -1,   128,   129,   130,    -1,   132,   133,   134,
     135,   136,   137,   138,   139,   140,    -1,   142,    -1,   144,
     145,   146,   147,    -1,   149,    -1,   151,    -1,    -1,    -1,
     155,   156,   157,    -1,   159,   160,    -1,   162,    -1,   164,
     165,   166,   167,   168,    -1,   170,   171,   172,    -1,   174,
     175,   176,   177,   178,   179,    -1,   181,    -1,   183,   184,
     185,   186,   187,   188,   189,    -1,   191,    -1,   193,    -1,
      -1,   196,    -1,   198,   199,   200,   201,   202,    -1,   204,
     205,    -1,   207,   208,    -1,   210,    -1,    -1,   213,   214,
     215,    -1,    -1,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,    -1,   233,   234,
     235,   236,    -1,   238,   239,    -1,   241,    -1,   243,   244,
     245,   246,   247,   248,    -1,   250,    -1,    -1,   253,   254,
     255,    -1,    -1,   258,   259,    -1,   261,    -1,   263,   264,
     265,   266,   267,   268,   269,   270,    -1,   272,   273,   274,
     275,   276,   277,   278,    -1,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,    -1,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
      -1,   306,   307,    -1,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,    -1,   321,   322,   323,   324,
     325,    -1,   327,   328,   329,   330,    -1,   332,   333,   334,
      -1,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,    -1,   348,   349,    -1,   351,   352,   353,   354,
     355,   356,    -1,   358,   359,    -1,    -1,   362,   363,   364,
     365,    -1,   367,   368,   369,   370,   371,   372,   373,    -1,
      -1,   376,   377,   378,   379,   380,    -1,    -1,   383,   384,
     385,   386,   387,   388,   389,    -1,   391,    -1,   393,   394,
     395,   396,    -1,    -1,   399,    -1,    -1,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,
      18,    19,    20,    21,    -1,    23,    24,    25,    -1,    -1,
      -1,    -1,    30,    -1,    -1,    -1,    34,    35,    -1,    37,
      38,    -1,    40,    41,    42,    43,    44,    -1,    46,    47,
      -1,    49,    50,    51,    52,    53,    -1,    -1,    56,    57,
      58,    59,    60,    -1,    62,    63,    64,    65,    66,    -1,
      -1,    -1,    70,    71,    72,    73,    -1,    75,    76,    -1,
      78,    79,    80,    81,    82,    83,    -1,    -1,    86,    87,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    95,    96,    97,
      98,    99,   100,   101,   102,   103,    -1,   105,    -1,   107,
     108,   109,   110,   111,    -1,   113,   114,   115,    -1,    -1,
     118,   119,   120,   121,   122,    -1,   124,   125,   126,    -1,
     128,   129,   130,    -1,   132,   133,   134,   135,   136,   137,
     138,   139,   140,    -1,   142,    -1,   144,   145,   146,   147,
      -1,   149,    -1,   151,    -1,    -1,    -1,   155,   156,   157,
      -1,   159,   160,    -1,   162,    -1,   164,   165,   166,   167,
     168,    -1,   170,   171,   172,    -1,   174,   175,   176,   177,
     178,   179,    -1,   181,    -1,   183,   184,   185,   186,   187,
     188,   189,    -1,   191,    -1,   193,    -1,    -1,   196,    -1,
     198,   199,   200,   201,   202,    -1,   204,   205,    -1,   207,
     208,    -1,   210,    -1,    -1,   213,   214,   215,    -1,    -1,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,    -1,   233,   234,   235,   236,    -1,
     238,   239,    -1,   241,    -1,   243,   244,   245,   246,   247,
     248,    -1,   250,    -1,    -1,   253,   254,   255,    -1,    -1,
     258,   259,    -1,   261,    -1,   263,   264,   265,   266,   267,
     268,   269,   270,    -1,   272,   273,   274,   275,   276,   277,
     278,    -1,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,   290,   291,   292,    -1,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,    -1,   306,   307,
      -1,   309,   310,   311,   312,   313,   314,   315,   316,   317,
     318,   319,    -1,   321,   322,   323,   324,   325,    -1,   327,
     328,   329,   330,    -1,   332,   333,   334,    -1,   336,   337,
     338,   339,   340,   341,   342,   343,   344,   345,   346,    -1,
     348,   349,    -1,   351,   352,   353,   354,   355,   356,    -1,
     358,   359,    -1,    -1,   362,   363,   364,   365,    -1,   367,
     368,   369,   370,   371,   372,   373,    -1,    -1,   376,   377,
     378,   379,   380,    -1,    -1,   383,   384,   385,   386,   387,
     388,   389,    -1,   391,    -1,   393,   394,   395,   396,    -1,
      -1,   399,    -1,    -1,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    14,    15,    16,    17,    18,    19,    20,
      21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,    30,
      -1,    -1,    -1,    34,    35,    -1,    37,    38,    -1,    40,
      41,    42,    43,    44,    -1,    46,    47,    -1,    49,    50,
      51,    52,    53,    -1,    -1,    56,    57,    58,    59,    60,
      -1,    62,    63,    64,    65,    66,    -1,    -1,    -1,    70,
      71,    72,    73,    -1,    75,    76,    -1,    78,    79,    80,
      81,    82,    83,    -1,    -1,    86,    87,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    95,    96,    97,    98,    99,   100,
     101,   102,   103,    -1,   105,    -1,   107,   108,   109,   110,
     111,    -1,   113,   114,   115,    -1,    -1,   118,   119,   120,
     121,   122,    -1,   124,   125,   126,    -1,   128,   129,   130,
      -1,   132,   133,   134,   135,   136,   137,   138,   139,   140,
      -1,   142,    -1,   144,   145,   146,   147,    -1,   149,    -1,
     151,    -1,    -1,    -1,   155,   156,   157,    -1,   159,   160,
      -1,   162,    -1,   164,   165,   166,   167,   168,    -1,   170,
     171,   172,    -1,   174,   175,   176,   177,   178,   179,    -1,
     181,    -1,   183,   184,   185,   186,   187,   188,   189,    -1,
     191,    -1,   193,    -1,    -1,   196,    -1,   198,   199,   200,
     201,   202,    -1,   204,   205,    -1,   207,   208,    -1,   210,
      -1,    -1,   213,   214,   215,    -1,    -1,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,    -1,   233,   234,   235,   236,    -1,   238,   239,    -1,
     241,    -1,   243,   244,   245,   246,   247,   248,    -1,   250,
      -1,    -1,   253,   254,   255,    -1,    -1,   258,   259,    -1,
     261,    -1,   263,   264,   265,   266,   267,   268,   269,   270,
      -1,   272,   273,   274,   275,   276,   277,   278,    -1,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,   292,    -1,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,   304,    -1,   306,   307,    -1,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,   319,    -1,
     321,   322,   323,   324,   325,    -1,   327,   328,   329,   330,
      -1,   332,   333,   334,    -1,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,   346,    -1,   348,   349,    -1,
     351,   352,   353,   354,   355,   356,    -1,   358,   359,    -1,
      -1,   362,   363,   364,   365,    -1,   367,   368,   369,   370,
     371,   372,   373,    -1,    -1,   376,   377,   378,   379,   380,
      -1,    -1,   383,   384,   385,   386,   387,   388,   389,    -1,
     391,    -1,   393,   394,   395,   396,    -1,    -1,   399,    -1,
      -1,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,   419,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      14,    15,    16,    17,    18,    19,    20,    21,    -1,    23,
      24,    25,    -1,    -1,    -1,    -1,    30,    -1,    -1,    -1,
      34,    35,    -1,    37,    38,    -1,    40,    41,    42,    43,
      44,    -1,    46,    47,    -1,    49,    50,    51,    52,    53,
      -1,    -1,    56,    57,    58,    59,    60,    -1,    62,    63,
      64,    65,    66,    -1,    -1,    -1,    70,    71,    72,    73,
      -1,    75,    76,    -1,    78,    79,    80,    81,    82,    83,
      -1,    -1,    86,    87,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    95,    96,    97,    98,    99,   100,   101,   102,   103,
      -1,   105,    -1,   107,   108,   109,   110,   111,    -1,   113,
     114,   115,    -1,    -1,   118,   119,   120,   121,   122,    -1,
     124,   125,   126,    -1,   128,   129,   130,    -1,   132,   133,
     134,   135,   136,   137,   138,   139,   140,    -1,   142,    -1,
     144,   145,   146,   147,    -1,   149,    -1,   151,    -1,    -1,
      -1,   155,   156,   157,    -1,   159,   160,    -1,   162,    -1,
     164,   165,   166,   167,   168,    -1,   170,   171,   172,    -1,
     174,   175,   176,   177,   178,   179,    -1,   181,    -1,   183,
     184,   185,   186,   187,   188,   189,    -1,   191,    -1,   193,
      -1,    -1,   196,    -1,   198,   199,   200,   201,   202,    -1,
     204,   205,    -1,   207,   208,    -1,   210,    -1,    -1,   213,
     214,   215,    -1,    -1,   218,   219,   220,   221,   222,   223,
     224,   225,   226,   227,   228,   229,   230,   231,    -1,   233,
     234,   235,   236,    -1,   238,   239,    -1,   241,    -1,   243,
     244,   245,   246,   247,   248,    -1,   250,    -1,    -1,   253,
     254,   255,    -1,    -1,   258,   259,    -1,   261,    -1,   263,
     264,   265,   266,   267,   268,   269,   270,    -1,   272,   273,
     274,   275,   276,   277,   278,    -1,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,   292,    -1,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
     304,    -1,   306,   307,    -1,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,   319,    -1,   321,   322,   323,
     324,   325,    -1,   327,   328,   329,   330,    -1,   332,   333,
     334,    -1,   336,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,    -1,   348,   349,    -1,   351,   352,   353,
     354,   355,   356,    -1,   358,   359,    -1,    -1,   362,   363,
     364,   365,    -1,   367,   368,   369,   370,   371,   372,   373,
      -1,    -1,   376,   377,   378,   379,   380,    -1,    -1,   383,
     384,   385,   386,   387,   388,   389,    -1,   391,    -1,   393,
     394,   395,   396,    -1,    -1,   399,    -1,    -1,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,    15,    16,
      17,    18,    19,    20,    21,    -1,    23,    24,    25,    -1,
      -1,    -1,    -1,    30,    -1,    -1,    -1,    34,    35,    -1,
      37,    38,    -1,    40,    41,    42,    43,    44,    -1,    46,
      47,    -1,    49,    50,    51,    52,    53,    -1,    -1,    56,
      57,    58,    59,    60,    -1,    62,    63,    64,    65,    66,
      -1,    -1,    -1,    70,    71,    72,    73,    -1,    75,    76,
      -1,    78,    79,    80,    81,    82,    83,    -1,    -1,    86,
      87,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    95,    96,
      97,    98,    99,   100,   101,   102,   103,    -1,   105,    -1,
     107,   108,   109,   110,   111,    -1,   113,   114,   115,    -1,
      -1,   118,   119,   120,   121,   122,    -1,   124,   125,   126,
      -1,   128,   129,   130,    -1,   132,   133,   134,   135,   136,
     137,   138,   139,   140,    -1,   142,    -1,   144,   145,   146,
     147,    -1,   149,    -1,   151,    -1,    -1,    -1,   155,   156,
     157,    -1,   159,   160,    -1,   162,    -1,   164,   165,   166,
     167,   168,    -1,   170,   171,   172,    -1,   174,   175,   176,
     177,   178,   179,    -1,   181,    -1,   183,   184,   185,   186,
     187,   188,   189,    -1,   191,    -1,   193,    -1,    -1,   196,
      -1,   198,   199,   200,   201,   202,    -1,   204,   205,    -1,
     207,   208,    -1,   210,    -1,    -1,   213,   214,   215,    -1,
      -1,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,    -1,   233,   234,   235,   236,
      -1,   238,   239,    -1,   241,    -1,   243,   244,   245,   246,
     247,   248,    -1,   250,    -1,    -1,   253,   254,   255,    -1,
      -1,   258,   259,    -1,   261,    -1,   263,   264,   265,   266,
     267,   268,   269,   270,    -1,   272,   273,   274,   275,   276,
     277,   278,    -1,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,   292,    -1,   294,   295,   296,
     297,   298,   299,   300,   301,   302,   303,   304,    -1,   306,
     307,    -1,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,    -1,   321,   322,   323,   324,   325,    -1,
     327,   328,   329,   330,    -1,   332,   333,   334,    -1,   336,
     337,   338,   339,   340,   341,   342,   343,   344,   345,   346,
      -1,   348,   349,    -1,   351,   352,   353,   354,   355,   356,
      -1,   358,   359,    -1,    -1,   362,   363,   364,   365,    -1,
     367,   368,   369,   370,   371,   372,   373,    -1,    -1,   376,
     377,   378,   379,   380,    -1,    -1,   383,   384,   385,   386,
     387,   388,   389,    -1,   391,    -1,   393,   394,   395,   396,
      -1,    -1,   399,    -1,    -1,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,    19,
      20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,
      30,    -1,    -1,    -1,    34,    35,    -1,    37,    38,    -1,
      40,    41,    42,    43,    44,    -1,    46,    47,    -1,    49,
      50,    51,    52,    53,    -1,    -1,    56,    57,    58,    59,
      60,    -1,    62,    63,    64,    65,    66,    -1,    -1,    -1,
      70,    71,    72,    73,    -1,    75,    76,    -1,    78,    79,
      80,    81,    82,    83,    -1,    -1,    86,    87,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    95,    96,    97,    98,    99,
     100,   101,   102,   103,    -1,   105,    -1,   107,   108,   109,
     110,   111,    -1,   113,   114,   115,    -1,    -1,   118,   119,
     120,   121,   122,    -1,   124,   125,   126,    -1,   128,   129,
     130,    -1,   132,   133,   134,   135,   136,   137,   138,   139,
     140,    -1,   142,    -1,   144,   145,   146,   147,    -1,   149,
      -1,   151,    -1,    -1,    -1,   155,   156,   157,    -1,   159,
     160,    -1,   162,    -1,   164,   165,   166,   167,   168,    -1,
     170,   171,   172,    -1,   174,   175,   176,   177,   178,   179,
      -1,   181,    -1,   183,   184,   185,   186,   187,   188,   189,
      -1,   191,    -1,   193,    -1,    -1,   196,    -1,   198,   199,
     200,   201,   202,    -1,   204,   205,    -1,   207,   208,    -1,
     210,    -1,    -1,   213,   214,   215,    -1,    -1,   218,   219,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,    -1,   233,   234,   235,   236,    -1,   238,   239,
      -1,   241,    -1,   243,   244,   245,   246,   247,   248,    -1,
     250,    -1,    -1,   253,   254,   255,    -1,    -1,   258,   259,
      -1,   261,    -1,   263,   264,   265,   266,   267,   268,   269,
     270,    -1,   272,   273,   274,   275,   276,   277,   278,    -1,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,   292,    -1,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,   304,    -1,   306,   307,    -1,   309,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
      -1,   321,   322,   323,   324,   325,    -1,   327,   328,   329,
     330,    -1,   332,   333,   334,    -1,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,    -1,   348,   349,
      -1,   351,   352,   353,   354,   355,   356,    -1,   358,   359,
      -1,    -1,   362,   363,   364,   365,    -1,   367,   368,   369,
     370,   371,   372,   373,    -1,    -1,   376,   377,   378,   379,
     380,    -1,    -1,   383,   384,   385,   386,   387,   388,   389,
      -1,   391,    -1,   393,   394,   395,   396,    -1,    -1,   399,
      -1,    -1,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    14,    15,    16,    17,    18,    19,    20,    21,    -1,
      23,    24,    25,    -1,    -1,    -1,    -1,    30,    -1,    -1,
      -1,    34,    35,    -1,    37,    38,    -1,    40,    41,    42,
      43,    44,    -1,    46,    47,    -1,    49,    50,    51,    52,
      53,    -1,    -1,    56,    57,    58,    59,    60,    -1,    62,
      63,    64,    65,    66,    -1,    -1,    -1,    70,    71,    72,
      73,    -1,    75,    76,    -1,    78,    79,    80,    81,    82,
      83,    -1,    -1,    86,    87,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    95,    96,    97,    98,    99,   100,   101,   102,
     103,    -1,   105,    -1,   107,   108,   109,   110,   111,    -1,
     113,   114,   115,    -1,    -1,   118,   119,   120,   121,   122,
      -1,   124,   125,   126,    -1,   128,   129,   130,    -1,   132,
     133,   134,   135,   136,   137,   138,   139,   140,    -1,   142,
      -1,   144,   145,   146,   147,    -1,   149,    -1,   151,    -1,
      -1,    -1,   155,   156,   157,    -1,   159,   160,    -1,   162,
      -1,   164,   165,   166,   167,   168,    -1,   170,   171,   172,
      -1,   174,   175,   176,   177,   178,   179,    -1,   181,    -1,
     183,   184,   185,   186,   187,   188,   189,    -1,   191,    -1,
     193,    -1,    -1,   196,    -1,   198,   199,   200,   201,   202,
      -1,   204,   205,    -1,   207,   208,    -1,   210,    -1,    -1,
     213,   214,   215,    -1,    -1,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,    -1,
     233,   234,   235,   236,    -1,   238,   239,    -1,   241,    -1,
     243,   244,   245,   246,   247,   248,    -1,   250,    -1,    -1,
     253,   254,   255,    -1,    -1,   258,   259,    -1,   261,    -1,
     263,   264,   265,   266,   267,   268,   269,   270,    -1,   272,
     273,   274,   275,   276,   277,   278,    -1,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,   292,
      -1,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,   304,    -1,   306,   307,    -1,   309,   310,   311,   312,
     313,   314,   315,   316,   317,   318,   319,    -1,   321,   322,
     323,   324,   325,    -1,   327,   328,   329,   330,    -1,   332,
     333,   334,    -1,   336,   337,   338,   339,   340,   341,   342,
     343,   344,   345,   346,    -1,   348,   349,    -1,   351,   352,
     353,   354,   355,   356,    -1,   358,   359,    -1,    -1,   362,
     363,   364,   365,    -1,   367,   368,   369,   370,   371,   372,
     373,    -1,    -1,   376,   377,   378,   379,   380,    -1,    -1,
     383,   384,   385,   386,   387,   388,   389,    -1,   391,    -1,
     393,   394,   395,   396,    -1,    -1,   399,    -1,    -1,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,    15,
      16,    17,    18,    19,    20,    21,    -1,    23,    24,    25,
      -1,    -1,    -1,    -1,    30,    -1,    -1,    -1,    34,    35,
      -1,    37,    38,    -1,    40,    41,    42,    43,    44,    -1,
      46,    47,    -1,    49,    50,    51,    52,    53,    -1,    -1,
      56,    57,    58,    59,    60,    -1,    62,    63,    64,    65,
      66,    -1,    -1,    -1,    70,    71,    72,    73,    -1,    75,
      76,    -1,    78,    79,    80,    81,    82,    83,    -1,    -1,
      86,    87,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    95,
      96,    97,    98,    99,   100,   101,   102,   103,    -1,   105,
      -1,   107,   108,   109,   110,   111,    -1,   113,   114,   115,
      -1,    -1,   118,   119,   120,   121,   122,    -1,   124,   125,
     126,    -1,   128,   129,   130,    -1,   132,   133,   134,   135,
     136,   137,   138,   139,   140,    -1,   142,    -1,   144,   145,
     146,   147,    -1,   149,    -1,   151,    -1,    -1,    -1,   155,
     156,   157,    -1,   159,   160,    -1,   162,    -1,   164,   165,
     166,   167,   168,    -1,   170,   171,   172,    -1,   174,   175,
     176,   177,   178,   179,    -1,   181,    -1,   183,   184,   185,
     186,   187,   188,   189,    -1,   191,    -1,   193,    -1,    -1,
     196,    -1,   198,   199,   200,   201,   202,    -1,   204,   205,
      -1,   207,   208,    -1,   210,    -1,    -1,   213,   214,   215,
      -1,    -1,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,    -1,   233,   234,   235,
     236,    -1,   238,   239,    -1,   241,    -1,   243,   244,   245,
     246,   247,   248,    -1,   250,    -1,    -1,   253,   254,   255,
      -1,    -1,   258,   259,    -1,   261,    -1,   263,   264,   265,
     266,   267,   268,   269,   270,    -1,   272,   273,   274,   275,
     276,   277,   278,    -1,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,   292,    -1,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,    -1,
     306,   307,    -1,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,   319,    -1,   321,   322,   323,   324,   325,
      -1,   327,   328,   329,   330,    -1,   332,   333,   334,    -1,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,    -1,   348,   349,    -1,   351,   352,   353,   354,   355,
     356,    -1,   358,   359,    -1,    -1,   362,   363,   364,   365,
      -1,   367,   368,   369,   370,   371,   372,   373,    -1,    -1,
     376,   377,   378,   379,   380,    -1,    -1,   383,   384,   385,
     386,   387,   388,   389,    -1,   391,    -1,   393,   394,   395,
     396,    -1,    -1,   399,    -1,    -1,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,
      19,    20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,
      -1,    30,    -1,    -1,    -1,    34,    35,    -1,    37,    38,
      -1,    40,    41,    42,    43,    44,    -1,    46,    47,    -1,
      49,    50,    51,    52,    53,    -1,    -1,    56,    57,    58,
      59,    60,    -1,    62,    63,    64,    65,    66,    -1,    -1,
      -1,    70,    71,    72,    73,    -1,    75,    76,    -1,    78,
      79,    80,    81,    82,    83,    -1,    -1,    86,    87,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    95,    96,    97,    98,
      99,   100,   101,   102,   103,    -1,   105,    -1,   107,   108,
     109,   110,   111,    -1,   113,   114,   115,    -1,    -1,   118,
     119,   120,   121,   122,    -1,   124,   125,   126,    -1,   128,
     129,   130,    -1,   132,   133,   134,   135,   136,   137,   138,
     139,   140,    -1,   142,    -1,   144,   145,   146,   147,    -1,
     149,    -1,   151,    -1,    -1,    -1,   155,   156,   157,    -1,
     159,   160,    -1,   162,    -1,   164,   165,   166,   167,   168,
      -1,   170,   171,   172,    -1,   174,   175,   176,   177,   178,
     179,    -1,   181,    -1,   183,   184,   185,   186,   187,   188,
     189,    -1,   191,    -1,   193,    -1,    -1,   196,    -1,   198,
     199,   200,   201,   202,    -1,   204,   205,    -1,   207,   208,
      -1,   210,    -1,    -1,   213,   214,   215,    -1,    -1,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,    -1,   233,   234,   235,   236,    -1,   238,
     239,    -1,   241,    -1,   243,   244,   245,   246,   247,   248,
      -1,   250,    -1,    -1,   253,   254,   255,    -1,    -1,   258,
     259,    -1,   261,    -1,   263,   264,   265,   266,   267,   268,
     269,   270,    -1,   272,   273,   274,   275,   276,   277,   278,
      -1,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,   292,    -1,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,   304,    -1,   306,   307,    -1,
     309,   310,   311,   312,   313,   314,   315,   316,   317,   318,
     319,    -1,   321,   322,   323,   324,   325,    -1,   327,   328,
     329,   330,    -1,   332,   333,   334,    -1,   336,   337,   338,
     339,   340,   341,   342,   343,   344,   345,   346,    -1,   348,
     349,    -1,   351,   352,   353,   354,   355,   356,    -1,   358,
     359,    -1,    -1,   362,   363,   364,   365,    -1,   367,   368,
     369,   370,   371,   372,   373,    -1,    -1,   376,   377,   378,
     379,   380,    -1,    -1,   383,   384,   385,   386,   387,   388,
     389,    -1,   391,    -1,   393,   394,   395,   396,    -1,    -1,
     399,    -1,    -1,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    14,    15,    16,    17,    18,    19,    20,    21,
      -1,    23,    24,    25,    -1,    -1,    -1,    -1,    30,    -1,
      -1,    -1,    34,    35,    -1,    37,    38,    -1,    40,    41,
      42,    43,    44,    -1,    46,    47,    -1,    49,    50,    51,
      52,    53,    -1,    -1,    56,    57,    58,    59,    60,    -1,
      62,    63,    64,    65,    66,    -1,    -1,    -1,    70,    71,
      72,    73,    -1,    75,    76,    -1,    78,    79,    80,    81,
      82,    83,    -1,    -1,    86,    87,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    95,    96,    97,    98,    99,   100,   101,
     102,   103,    -1,   105,    -1,   107,   108,   109,   110,   111,
      -1,   113,   114,   115,    -1,    -1,   118,   119,   120,   121,
     122,    -1,   124,   125,   126,    -1,   128,   129,   130,    -1,
     132,   133,   134,   135,   136,   137,   138,   139,   140,    -1,
     142,    -1,   144,   145,   146,   147,    -1,   149,    -1,   151,
      -1,    -1,    -1,   155,   156,   157,    -1,   159,   160,    -1,
     162,    -1,   164,   165,   166,   167,   168,    -1,   170,   171,
     172,    -1,   174,   175,   176,   177,   178,   179,    -1,   181,
      -1,   183,   184,   185,   186,   187,   188,   189,    -1,   191,
      -1,   193,    -1,    -1,   196,    -1,   198,   199,   200,   201,
     202,    -1,   204,   205,    -1,   207,   208,    -1,   210,    -1,
      -1,   213,   214,   215,    -1,    -1,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
      -1,   233,   234,   235,   236,    -1,   238,   239,    -1,   241,
      -1,   243,   244,   245,   246,   247,   248,    -1,   250,    -1,
      -1,   253,   254,   255,    -1,    -1,   258,   259,    -1,   261,
      -1,   263,   264,   265,   266,   267,   268,   269,   270,    -1,
     272,   273,   274,   275,   276,   277,   278,    -1,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
     292,    -1,   294,   295,   296,   297,   298,   299,   300,   301,
     302,   303,   304,    -1,   306,   307,    -1,   309,   310,   311,
     312,   313,   314,   315,   316,   317,   318,   319,    -1,   321,
     322,   323,   324,   325,    -1,   327,   328,   329,   330,    -1,
     332,   333,   334,    -1,   336,   337,   338,   339,   340,   341,
     342,   343,   344,   345,   346,    -1,   348,   349,    -1,   351,
     352,   353,   354,   355,   356,    -1,   358,   359,    -1,    -1,
     362,   363,   364,   365,    -1,   367,   368,   369,   370,   371,
     372,   373,    -1,    -1,   376,   377,   378,   379,   380,    -1,
      -1,   383,   384,   385,   386,   387,   388,   389,    -1,   391,
      -1,   393,   394,   395,   396,    -1,    -1,   399,    -1,    -1,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,
      15,    16,    17,    18,    19,    20,    21,    -1,    23,    24,
      25,    -1,    -1,    -1,    -1,    30,    -1,    -1,    -1,    34,
      35,    -1,    37,    38,    -1,    40,    41,    42,    43,    44,
      -1,    46,    47,    -1,    49,    50,    51,    52,    53,    -1,
      -1,    56,    57,    58,    59,    60,    -1,    62,    63,    64,
      65,    66,    -1,    -1,    -1,    70,    71,    72,    73,    -1,
      75,    76,    -1,    78,    79,    80,    81,    82,    83,    -1,
      -1,    86,    87,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      95,    96,    97,    98,    99,   100,   101,   102,   103,    -1,
     105,    -1,   107,   108,   109,   110,   111,    -1,   113,   114,
     115,    -1,    -1,   118,   119,   120,   121,   122,    -1,   124,
     125,   126,    -1,   128,   129,   130,    -1,   132,   133,   134,
     135,   136,   137,   138,   139,   140,    -1,   142,    -1,   144,
     145,   146,   147,    -1,   149,    -1,   151,    -1,    -1,    -1,
     155,   156,   157,    -1,   159,   160,    -1,   162,    -1,   164,
     165,   166,   167,   168,    -1,   170,   171,   172,    -1,   174,
     175,   176,   177,   178,   179,    -1,   181,    -1,   183,   184,
     185,   186,   187,   188,   189,    -1,   191,    -1,   193,    -1,
      -1,   196,    -1,   198,   199,   200,   201,   202,    -1,   204,
     205,    -1,   207,   208,    -1,   210,    -1,    -1,   213,   214,
     215,    -1,    -1,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,    -1,   233,   234,
     235,   236,    -1,   238,   239,    -1,   241,    -1,   243,   244,
     245,   246,   247,   248,    -1,   250,    -1,    -1,   253,   254,
     255,    -1,    -1,   258,   259,    -1,   261,    -1,   263,   264,
     265,   266,   267,   268,   269,   270,    -1,   272,   273,   274,
     275,   276,   277,   278,    -1,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,    -1,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
      -1,   306,   307,    -1,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,    -1,   321,   322,   323,   324,
     325,    -1,   327,   328,   329,   330,    -1,   332,   333,   334,
      -1,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,    -1,   348,   349,    -1,   351,   352,   353,   354,
     355,   356,    -1,   358,   359,    -1,    -1,   362,   363,   364,
     365,    -1,   367,   368,   369,   370,   371,   372,   373,    -1,
      -1,   376,   377,   378,   379,   380,    -1,    -1,   383,   384,
     385,   386,   387,   388,   389,    -1,   391,    -1,   393,   394,
     395,   396,    -1,    -1,   399,    -1,    -1,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,
      18,    19,    20,    21,    -1,    23,    24,    25,    -1,    -1,
      -1,    -1,    30,    -1,    -1,    -1,    34,    35,    -1,    37,
      38,    -1,    40,    41,    42,    43,    44,    -1,    46,    47,
      -1,    49,    50,    51,    52,    53,    -1,    -1,    56,    57,
      58,    59,    60,    -1,    62,    63,    64,    65,    66,    -1,
      -1,    -1,    70,    71,    72,    73,    -1,    75,    76,    -1,
      78,    79,    80,    81,    82,    83,    -1,    -1,    86,    87,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    95,    96,    97,
      98,    99,   100,   101,   102,   103,    -1,   105,    -1,   107,
     108,   109,   110,   111,    -1,   113,   114,   115,    -1,    -1,
     118,   119,   120,   121,   122,    -1,   124,   125,   126,    -1,
     128,   129,   130,    -1,   132,   133,   134,   135,   136,   137,
     138,   139,   140,    -1,   142,    -1,   144,   145,   146,   147,
      -1,   149,    -1,   151,    -1,    -1,    -1,   155,   156,   157,
      -1,   159,   160,    -1,   162,    -1,   164,   165,   166,   167,
     168,    -1,   170,   171,   172,    -1,   174,   175,   176,   177,
     178,   179,    -1,   181,    -1,   183,   184,   185,   186,   187,
     188,   189,    -1,   191,    -1,   193,    -1,    -1,   196,    -1,
     198,   199,   200,   201,   202,    -1,   204,   205,    -1,   207,
     208,    -1,   210,    -1,    -1,   213,   214,   215,    -1,    -1,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,    -1,   233,   234,   235,   236,    -1,
     238,   239,    -1,   241,    -1,   243,   244,   245,   246,   247,
     248,    -1,   250,    -1,    -1,   253,   254,   255,    -1,    -1,
     258,   259,    -1,   261,    -1,   263,   264,   265,   266,   267,
     268,   269,   270,    -1,   272,   273,   274,   275,   276,   277,
     278,    -1,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,   290,   291,   292,    -1,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,    -1,   306,   307,
      -1,   309,   310,   311,   312,   313,   314,   315,   316,   317,
     318,   319,    -1,   321,   322,   323,   324,   325,    -1,   327,
     328,   329,   330,    -1,   332,   333,   334,    -1,   336,   337,
     338,   339,   340,   341,   342,   343,   344,   345,   346,    -1,
     348,   349,    -1,   351,   352,   353,   354,   355,   356,    -1,
     358,   359,    -1,    -1,   362,   363,   364,   365,    -1,   367,
     368,   369,   370,   371,   372,   373,    -1,    -1,   376,   377,
     378,   379,   380,    -1,    -1,   383,   384,   385,   386,   387,
     388,   389,    -1,   391,    -1,   393,   394,   395,   396,    -1,
      -1,   399,    -1,    -1,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    14,    15,    16,    17,    18,    19,    20,
      21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,    30,
      -1,    -1,    -1,    34,    35,    -1,    37,    38,    -1,    40,
      41,    42,    43,    44,    -1,    46,    47,    -1,    49,    50,
      51,    52,    53,    -1,    -1,    56,    57,    58,    59,    60,
      -1,    62,    63,    64,    65,    66,    -1,    -1,    -1,    70,
      71,    72,    73,    -1,    75,    76,    -1,    78,    79,    80,
      81,    82,    83,    -1,    -1,    86,    87,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    95,    96,    97,    98,    99,   100,
     101,   102,   103,    -1,   105,    -1,   107,   108,   109,   110,
     111,    -1,   113,   114,   115,    -1,    -1,   118,   119,   120,
     121,   122,    -1,   124,   125,   126,    -1,   128,   129,   130,
      -1,   132,   133,   134,   135,   136,   137,   138,   139,   140,
      -1,   142,    -1,   144,   145,   146,   147,    -1,   149,    -1,
     151,    -1,    -1,    -1,   155,   156,   157,    -1,   159,   160,
      -1,   162,    -1,   164,   165,   166,   167,   168,    -1,   170,
     171,   172,    -1,   174,   175,   176,   177,   178,   179,    -1,
     181,    -1,   183,   184,   185,   186,   187,   188,   189,    -1,
     191,    -1,   193,    -1,    -1,   196,    -1,   198,   199,   200,
     201,   202,    -1,   204,   205,    -1,   207,   208,    -1,   210,
      -1,    -1,   213,   214,   215,    -1,    -1,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,    -1,   233,   234,   235,   236,    -1,   238,   239,    -1,
     241,    -1,   243,   244,   245,   246,   247,   248,    -1,   250,
      -1,    -1,   253,   254,   255,    -1,    -1,   258,   259,    -1,
     261,    -1,   263,   264,   265,   266,   267,   268,   269,   270,
      -1,   272,   273,   274,   275,   276,   277,   278,    -1,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,   292,    -1,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,   304,    -1,   306,   307,    -1,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,   319,    -1,
     321,   322,   323,   324,   325,    -1,   327,   328,   329,   330,
      -1,   332,   333,   334,    -1,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,   346,    -1,   348,   349,    -1,
     351,   352,   353,   354,   355,   356,    -1,   358,   359,    -1,
      -1,   362,   363,   364,   365,    -1,   367,   368,   369,   370,
     371,   372,   373,    -1,    -1,   376,   377,   378,   379,   380,
      -1,    -1,   383,   384,   385,   386,   387,   388,   389,    -1,
     391,    -1,   393,   394,   395,   396,    -1,    -1,   399,    -1,
      -1,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,   419,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      14,    15,    16,    17,    18,    19,    20,    21,    -1,    23,
      24,    25,    -1,    -1,    -1,    -1,    30,    -1,    -1,    -1,
      34,    35,    -1,    37,    38,    -1,    40,    41,    42,    43,
      44,    -1,    46,    47,    -1,    49,    50,    51,    52,    53,
      -1,    -1,    56,    57,    58,    59,    60,    -1,    62,    63,
      64,    65,    66,    -1,    -1,    -1,    70,    71,    72,    73,
      -1,    75,    76,    -1,    78,    79,    80,    81,    82,    83,
      -1,    -1,    86,    87,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    95,    96,    97,    98,    99,   100,   101,   102,   103,
      -1,   105,    -1,   107,   108,   109,   110,   111,    -1,   113,
     114,   115,    -1,    -1,   118,   119,   120,   121,   122,    -1,
     124,   125,   126,    -1,   128,   129,   130,    -1,   132,   133,
     134,   135,   136,   137,   138,   139,   140,    -1,   142,    -1,
     144,   145,   146,   147,    -1,   149,    -1,   151,    -1,    -1,
      -1,   155,   156,   157,    -1,   159,   160,    -1,   162,    -1,
     164,   165,   166,   167,   168,    -1,   170,   171,   172,    -1,
     174,   175,   176,   177,   178,   179,    -1,   181,    -1,   183,
     184,   185,   186,   187,   188,   189,    -1,   191,    -1,   193,
      -1,    -1,   196,    -1,   198,   199,   200,   201,   202,    -1,
     204,   205,    -1,   207,   208,    -1,   210,    -1,    -1,   213,
     214,   215,    -1,    -1,   218,   219,   220,   221,   222,   223,
     224,   225,   226,   227,   228,   229,   230,   231,    -1,   233,
     234,   235,   236,    -1,   238,   239,    -1,   241,    -1,   243,
     244,   245,   246,   247,   248,    -1,   250,    -1,    -1,   253,
     254,   255,    -1,    -1,   258,   259,    -1,   261,    -1,   263,
     264,   265,   266,   267,   268,   269,   270,    -1,   272,   273,
     274,   275,   276,   277,   278,    -1,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,   292,    -1,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
     304,    -1,   306,   307,    -1,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,   319,    -1,   321,   322,   323,
     324,   325,    -1,   327,   328,   329,   330,    -1,   332,   333,
     334,    -1,   336,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,    -1,   348,   349,    -1,   351,   352,   353,
     354,   355,   356,    -1,   358,   359,    -1,    -1,   362,   363,
     364,   365,    -1,   367,   368,   369,   370,   371,   372,   373,
      -1,    -1,   376,   377,   378,   379,   380,    -1,    -1,   383,
     384,   385,   386,   387,   388,   389,    -1,   391,    -1,   393,
     394,   395,   396,    -1,    -1,   399,    -1,    -1,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,    15,    16,
      17,    18,    19,    20,    21,    -1,    23,    24,    25,    -1,
      -1,    -1,    -1,    30,    -1,    -1,    -1,    34,    35,    -1,
      37,    38,    -1,    40,    41,    42,    43,    44,    -1,    46,
      47,    -1,    49,    50,    51,    52,    53,    -1,    -1,    56,
      57,    58,    59,    60,    -1,    62,    63,    64,    65,    66,
      -1,    -1,    -1,    70,    71,    72,    73,    -1,    75,    76,
      -1,    78,    79,    80,    81,    82,    83,    -1,    -1,    86,
      87,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    95,    96,
      97,    98,    99,   100,   101,   102,   103,    -1,   105,    -1,
     107,   108,   109,   110,   111,    -1,   113,   114,   115,    -1,
      -1,   118,   119,   120,   121,   122,    -1,   124,   125,   126,
      -1,   128,   129,   130,    -1,   132,   133,   134,   135,   136,
     137,   138,   139,   140,    -1,   142,    -1,   144,   145,   146,
     147,    -1,   149,    -1,   151,    -1,    -1,    -1,   155,   156,
     157,    -1,   159,   160,    -1,   162,    -1,   164,   165,   166,
     167,   168,    -1,   170,   171,   172,    -1,   174,   175,   176,
     177,   178,   179,    -1,   181,    -1,   183,   184,   185,   186,
     187,   188,   189,    -1,   191,    -1,   193,    -1,    -1,   196,
      -1,   198,   199,   200,   201,   202,    -1,   204,   205,    -1,
     207,   208,    -1,   210,    -1,    -1,   213,   214,   215,    -1,
      -1,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,    -1,   233,   234,   235,   236,
      -1,   238,   239,    -1,   241,    -1,   243,   244,   245,   246,
     247,   248,    -1,   250,    -1,    -1,   253,   254,   255,    -1,
      -1,   258,   259,    -1,   261,    -1,   263,   264,   265,   266,
     267,   268,   269,   270,    -1,   272,   273,   274,   275,   276,
     277,   278,    -1,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,   292,    -1,   294,   295,   296,
     297,   298,   299,   300,   301,   302,   303,   304,    -1,   306,
     307,    -1,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,    -1,   321,   322,   323,   324,   325,    -1,
     327,   328,   329,   330,    -1,   332,   333,   334,    -1,   336,
     337,   338,   339,   340,   341,   342,   343,   344,   345,   346,
      -1,   348,   349,    -1,   351,   352,   353,   354,   355,   356,
      -1,   358,   359,    -1,    -1,   362,   363,   364,   365,    -1,
     367,   368,   369,   370,   371,   372,   373,    -1,    -1,   376,
     377,   378,   379,   380,    -1,    -1,   383,   384,   385,   386,
     387,   388,   389,    -1,   391,    -1,   393,   394,   395,   396,
      -1,    -1,   399,    -1,    -1,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,    19,
      20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,
      30,    -1,    -1,    -1,    34,    35,    -1,    37,    38,    -1,
      40,    41,    42,    43,    44,    -1,    46,    47,    -1,    49,
      50,    51,    52,    53,    -1,    -1,    56,    57,    58,    59,
      60,    -1,    62,    63,    64,    65,    66,    -1,    -1,    -1,
      70,    71,    72,    73,    -1,    75,    76,    -1,    78,    79,
      80,    81,    82,    83,    -1,    -1,    86,    87,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    95,    96,    97,    98,    99,
     100,   101,   102,   103,    -1,   105,    -1,   107,   108,   109,
     110,   111,    -1,   113,   114,   115,    -1,    -1,   118,   119,
     120,   121,   122,    -1,   124,   125,   126,    -1,   128,   129,
     130,    -1,   132,   133,   134,   135,   136,   137,   138,   139,
     140,    -1,   142,    -1,   144,   145,   146,   147,    -1,   149,
      -1,   151,    -1,    -1,    -1,   155,   156,   157,    -1,   159,
     160,    -1,   162,    -1,   164,   165,   166,   167,   168,    -1,
     170,   171,   172,    -1,   174,   175,   176,   177,   178,   179,
      -1,   181,    -1,   183,   184,   185,   186,   187,   188,   189,
      -1,   191,    -1,   193,    -1,    -1,   196,    -1,   198,   199,
     200,   201,   202,    -1,   204,   205,    -1,   207,   208,    -1,
     210,    -1,    -1,   213,   214,   215,    -1,    -1,   218,   219,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,    -1,   233,   234,   235,   236,    -1,   238,   239,
      -1,   241,    -1,   243,   244,   245,   246,   247,   248,    -1,
     250,    -1,    -1,   253,   254,   255,    -1,    -1,   258,   259,
      -1,   261,    -1,   263,   264,   265,   266,   267,   268,   269,
     270,    -1,   272,   273,   274,   275,   276,   277,   278,    -1,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,   292,    -1,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,   304,    -1,   306,   307,    -1,   309,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
      -1,   321,   322,   323,   324,   325,    -1,   327,   328,   329,
     330,    -1,   332,   333,   334,    -1,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,    -1,   348,   349,
      -1,   351,   352,   353,   354,   355,   356,    -1,   358,   359,
      -1,    -1,   362,   363,   364,   365,    -1,   367,   368,   369,
     370,   371,   372,   373,    -1,    -1,   376,   377,   378,   379,
     380,    -1,    -1,   383,   384,   385,   386,   387,   388,   389,
      -1,   391,    -1,   393,   394,   395,   396,    -1,    -1,   399,
      -1,    -1,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    14,    15,    16,    17,    18,    19,    20,    21,    -1,
      23,    24,    25,    -1,    -1,    -1,    -1,    30,    -1,    -1,
      -1,    34,    35,    -1,    37,    38,    -1,    40,    41,    42,
      43,    44,    -1,    46,    47,    -1,    49,    50,    51,    52,
      53,    -1,    -1,    56,    57,    58,    59,    60,    -1,    62,
      63,    64,    65,    66,    -1,    -1,    -1,    70,    71,    72,
      73,    -1,    75,    76,    -1,    78,    79,    80,    81,    82,
      83,    -1,    -1,    86,    87,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    95,    96,    97,    98,    99,   100,   101,   102,
     103,    -1,   105,    -1,   107,   108,   109,   110,   111,    -1,
     113,   114,   115,    -1,    -1,   118,   119,   120,   121,   122,
      -1,   124,   125,   126,    -1,   128,   129,   130,    -1,   132,
     133,   134,   135,   136,   137,   138,   139,   140,    -1,   142,
      -1,   144,   145,   146,   147,    -1,   149,    -1,   151,    -1,
      -1,    -1,   155,   156,   157,    -1,   159,   160,    -1,   162,
      -1,   164,   165,   166,   167,   168,    -1,   170,   171,   172,
      -1,   174,   175,   176,   177,   178,   179,    -1,   181,    -1,
     183,   184,   185,   186,   187,   188,   189,    -1,   191,    -1,
     193,    -1,    -1,   196,    -1,   198,   199,   200,   201,   202,
      -1,   204,   205,    -1,   207,   208,    -1,   210,    -1,    -1,
     213,   214,   215,    -1,    -1,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,    -1,
     233,   234,   235,   236,    -1,   238,   239,    -1,   241,    -1,
     243,   244,   245,   246,   247,   248,    -1,   250,    -1,    -1,
     253,   254,   255,    -1,    -1,   258,   259,    -1,   261,    -1,
     263,   264,   265,   266,   267,   268,   269,   270,    -1,   272,
     273,   274,   275,   276,   277,   278,    -1,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,   292,
      -1,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,   304,    -1,   306,   307,    -1,   309,   310,   311,   312,
     313,   314,   315,   316,   317,   318,   319,    -1,   321,   322,
     323,   324,   325,    -1,   327,   328,   329,   330,    -1,   332,
     333,   334,    -1,   336,   337,   338,   339,   340,   341,   342,
     343,   344,   345,   346,    -1,   348,   349,    -1,   351,   352,
     353,   354,   355,   356,    -1,   358,   359,    -1,    -1,   362,
     363,   364,   365,    -1,   367,   368,   369,   370,   371,   372,
     373,    -1,    -1,   376,   377,   378,   379,   380,    -1,    -1,
     383,   384,   385,   386,   387,   388,   389,    -1,   391,    -1,
     393,   394,   395,   396,    -1,    -1,   399,    -1,    -1,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,    15,
      16,    17,    18,    19,    20,    21,    -1,    23,    24,    25,
      -1,    -1,    -1,    -1,    30,    -1,    -1,    -1,    34,    35,
      -1,    37,    38,    -1,    40,    41,    42,    43,    44,    -1,
      46,    47,    -1,    49,    50,    51,    52,    53,    -1,    -1,
      56,    57,    58,    59,    60,    -1,    62,    63,    64,    65,
      66,    -1,    -1,    -1,    70,    71,    72,    73,    -1,    75,
      76,    -1,    78,    79,    80,    81,    82,    83,    -1,    -1,
      86,    87,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    95,
      96,    97,    98,    99,   100,   101,   102,   103,    -1,   105,
      -1,   107,   108,   109,   110,   111,    -1,   113,   114,   115,
      -1,    -1,   118,   119,   120,   121,   122,    -1,   124,   125,
     126,    -1,   128,   129,   130,    -1,   132,   133,   134,   135,
     136,   137,   138,   139,   140,    -1,   142,    -1,   144,   145,
     146,   147,    -1,   149,    -1,   151,    -1,    -1,    -1,   155,
     156,   157,    -1,   159,   160,    -1,   162,    -1,   164,   165,
     166,   167,   168,    -1,   170,   171,   172,    -1,   174,   175,
     176,   177,   178,   179,    -1,   181,    -1,   183,   184,   185,
     186,   187,   188,   189,    -1,   191,    -1,   193,    -1,    -1,
     196,    -1,   198,   199,   200,   201,   202,    -1,   204,   205,
      -1,   207,   208,    -1,   210,    -1,    -1,   213,   214,   215,
      -1,    -1,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,    -1,   233,   234,   235,
     236,    -1,   238,   239,    -1,   241,    -1,   243,   244,   245,
     246,   247,   248,    -1,   250,    -1,    -1,   253,   254,   255,
      -1,    -1,   258,   259,    -1,   261,    -1,   263,   264,   265,
     266,   267,   268,   269,   270,    -1,   272,   273,   274,   275,
     276,   277,   278,    -1,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,   292,    -1,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,    -1,
     306,   307,    -1,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,   319,    -1,   321,   322,   323,   324,   325,
      -1,   327,   328,   329,   330,    -1,   332,   333,   334,    -1,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,    -1,   348,   349,    -1,   351,   352,   353,   354,   355,
     356,    -1,   358,   359,    -1,    -1,   362,   363,   364,   365,
      -1,   367,   368,   369,   370,   371,   372,   373,    -1,    -1,
     376,   377,   378,   379,   380,    -1,    -1,   383,   384,   385,
     386,   387,   388,   389,    -1,   391,    -1,   393,   394,   395,
     396,    -1,    -1,   399,    -1,    -1,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,
      19,    20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,
      -1,    30,    -1,    32,    -1,    34,    35,    -1,    37,    38,
      -1,    40,    41,    42,    43,    44,    -1,    46,    47,    -1,
      49,    50,    51,    52,    53,    -1,    -1,    56,    57,    58,
      59,    60,    -1,    62,    63,    64,    65,    66,    -1,    -1,
      -1,    70,    71,    72,    73,    -1,    75,    76,    -1,    78,
      79,    80,    81,    82,    83,    -1,    -1,    86,    87,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    95,    96,    97,    98,
      99,   100,   101,   102,   103,    -1,   105,    -1,   107,   108,
     109,   110,   111,    -1,   113,   114,   115,    -1,    -1,   118,
     119,   120,   121,   122,    -1,   124,   125,   126,    -1,   128,
     129,   130,    -1,   132,   133,   134,   135,   136,   137,   138,
     139,   140,    -1,   142,    -1,   144,   145,   146,   147,    -1,
     149,    -1,   151,    -1,    -1,    -1,   155,   156,   157,    -1,
     159,   160,    -1,   162,    -1,   164,   165,   166,   167,   168,
      -1,   170,   171,   172,    -1,   174,   175,   176,   177,   178,
     179,    -1,   181,    -1,   183,   184,   185,   186,   187,   188,
     189,    -1,   191,    -1,   193,    -1,    -1,   196,    -1,   198,
     199,   200,   201,   202,    -1,   204,   205,    -1,   207,   208,
      -1,   210,    -1,    -1,   213,   214,   215,    -1,    -1,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,    -1,   233,   234,   235,   236,    -1,   238,
     239,    -1,   241,    -1,   243,   244,   245,   246,   247,   248,
      -1,   250,    -1,    -1,   253,   254,   255,    -1,    -1,   258,
     259,    -1,   261,    -1,   263,   264,   265,   266,   267,   268,
     269,   270,    -1,   272,   273,   274,   275,   276,   277,   278,
      -1,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,   292,    -1,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,   304,    -1,   306,   307,    -1,
     309,   310,   311,   312,   313,   314,   315,   316,   317,   318,
     319,    -1,   321,   322,   323,   324,   325,    -1,    -1,   328,
     329,   330,    -1,   332,   333,   334,    -1,   336,   337,   338,
     339,   340,   341,   342,   343,   344,   345,   346,    -1,   348,
     349,    -1,   351,   352,   353,   354,   355,   356,    -1,   358,
     359,    -1,    -1,   362,   363,   364,   365,    -1,   367,   368,
     369,   370,   371,   372,   373,    -1,    -1,   376,   377,   378,
     379,   380,    -1,    -1,   383,   384,   385,   386,   387,   388,
     389,    -1,   391,    -1,   393,   394,   395,   396,    -1,    -1,
     399,    -1,    -1,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    14,    15,    16,    17,    18,    19,    20,    21,
      -1,    23,    24,    25,    -1,    -1,    -1,    -1,    30,    -1,
      -1,    -1,    34,    35,    -1,    37,    38,    -1,    40,    41,
      42,    43,    44,    -1,    46,    47,    -1,    49,    50,    51,
      52,    53,    -1,    -1,    56,    57,    58,    59,    60,    -1,
      62,    63,    64,    65,    66,    -1,    -1,    -1,    70,    71,
      72,    73,    -1,    75,    76,    -1,    78,    79,    80,    81,
      82,    83,    -1,    -1,    86,    87,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    95,    96,    97,    98,    99,   100,   101,
     102,   103,    -1,   105,    -1,   107,   108,   109,   110,   111,
      -1,   113,   114,   115,    -1,    -1,   118,   119,   120,   121,
     122,    -1,   124,   125,   126,    -1,   128,   129,   130,    -1,
     132,   133,   134,   135,   136,   137,   138,   139,   140,    -1,
     142,    -1,   144,   145,   146,   147,    -1,   149,    -1,   151,
      -1,    -1,    -1,   155,   156,   157,    -1,   159,   160,    -1,
     162,    -1,   164,   165,   166,   167,   168,    -1,   170,   171,
     172,    -1,   174,   175,   176,   177,   178,   179,    -1,   181,
      -1,   183,   184,   185,   186,   187,   188,   189,    -1,   191,
      -1,   193,    -1,    -1,   196,    -1,   198,   199,   200,   201,
     202,    -1,   204,   205,    -1,   207,   208,    -1,   210,    -1,
      -1,   213,   214,   215,    -1,    -1,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
      -1,   233,   234,   235,   236,    -1,   238,   239,    -1,   241,
      -1,   243,   244,   245,   246,   247,   248,    -1,   250,    -1,
      -1,   253,   254,   255,    -1,    -1,   258,   259,    -1,   261,
      -1,   263,   264,   265,   266,   267,   268,   269,   270,    -1,
     272,   273,   274,   275,   276,   277,   278,    -1,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
     292,    -1,   294,   295,   296,   297,   298,   299,   300,   301,
     302,   303,   304,    -1,   306,   307,    -1,   309,   310,   311,
     312,   313,   314,   315,   316,   317,   318,   319,    -1,   321,
     322,   323,   324,   325,    -1,   327,   328,   329,   330,    -1,
     332,   333,   334,    -1,   336,   337,   338,   339,   340,   341,
     342,   343,   344,   345,   346,    -1,   348,   349,    -1,   351,
     352,   353,   354,   355,   356,    -1,   358,   359,    -1,    -1,
     362,   363,   364,   365,    -1,   367,   368,   369,   370,   371,
     372,   373,    -1,    -1,   376,   377,   378,   379,   380,    -1,
      -1,   383,   384,   385,   386,   387,   388,   389,    -1,   391,
      -1,   393,   394,   395,   396,    -1,    -1,   399,    -1,    -1,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,
      15,    16,    17,    18,    19,    20,    21,    -1,    23,    24,
      25,    -1,    -1,    -1,    -1,    30,    -1,    -1,    -1,    34,
      35,    -1,    37,    38,    -1,    40,    41,    42,    43,    44,
      -1,    46,    47,    -1,    49,    50,    51,    52,    53,    -1,
      -1,    56,    57,    58,    59,    60,    -1,    62,    63,    64,
      65,    66,    -1,    -1,    -1,    70,    71,    72,    73,    -1,
      75,    76,    -1,    78,    79,    80,    81,    82,    83,    -1,
      -1,    86,    87,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      95,    96,    97,    98,    99,   100,   101,   102,   103,    -1,
     105,    -1,   107,   108,   109,   110,   111,    -1,   113,   114,
     115,    -1,    -1,   118,   119,   120,   121,   122,    -1,   124,
     125,   126,    -1,   128,   129,   130,    -1,   132,   133,   134,
     135,   136,   137,   138,   139,   140,    -1,   142,    -1,   144,
     145,   146,   147,    -1,   149,    -1,   151,    -1,    -1,    -1,
     155,   156,   157,    -1,   159,   160,    -1,   162,    -1,   164,
     165,   166,   167,   168,    -1,   170,   171,   172,    -1,   174,
     175,   176,   177,   178,   179,    -1,   181,    -1,   183,   184,
     185,   186,   187,   188,   189,    -1,   191,    -1,   193,    -1,
      -1,   196,    -1,   198,   199,   200,   201,   202,    -1,   204,
     205,    -1,   207,   208,    -1,   210,    -1,    -1,   213,   214,
     215,    -1,    -1,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,    -1,   233,   234,
     235,   236,    -1,   238,   239,    -1,   241,    -1,   243,   244,
     245,   246,   247,   248,    -1,   250,    -1,    -1,   253,   254,
     255,    -1,    -1,   258,   259,    -1,   261,    -1,   263,   264,
     265,   266,   267,   268,   269,   270,    -1,   272,   273,   274,
     275,   276,   277,   278,    -1,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,    -1,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
      -1,   306,   307,    -1,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,    -1,   321,   322,   323,   324,
     325,    -1,   327,   328,   329,   330,    -1,   332,   333,   334,
      -1,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,    -1,   348,   349,    -1,   351,   352,   353,   354,
     355,   356,    -1,   358,   359,    -1,    -1,   362,   363,   364,
     365,    -1,   367,   368,   369,   370,   371,   372,   373,    -1,
      -1,   376,   377,   378,   379,   380,    -1,    -1,   383,   384,
     385,   386,   387,   388,   389,    -1,   391,    -1,   393,   394,
     395,   396,    -1,    -1,   399,    -1,    -1,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,
      18,    19,    20,    21,    -1,    23,    24,    25,    -1,    -1,
      -1,    -1,    30,    -1,    -1,    -1,    34,    35,    -1,    37,
      38,    -1,    40,    41,    42,    43,    44,    -1,    46,    47,
      -1,    49,    50,    51,    52,    53,    -1,    -1,    56,    57,
      58,    59,    60,    -1,    62,    63,    64,    65,    66,    -1,
      -1,    -1,    70,    71,    72,    73,    -1,    75,    76,    -1,
      78,    79,    80,    81,    82,    83,    -1,    -1,    86,    87,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    95,    96,    97,
      98,    99,   100,   101,   102,   103,    -1,   105,    -1,   107,
     108,   109,   110,   111,    -1,   113,   114,   115,    -1,    -1,
     118,   119,   120,   121,   122,    -1,   124,   125,   126,    -1,
     128,   129,   130,    -1,   132,   133,   134,   135,   136,   137,
     138,   139,   140,    -1,   142,    -1,   144,   145,   146,   147,
      -1,   149,    -1,   151,    -1,    -1,    -1,   155,   156,   157,
      -1,   159,   160,    -1,   162,    -1,   164,   165,   166,   167,
     168,    -1,   170,   171,   172,    -1,   174,   175,   176,   177,
     178,   179,    -1,   181,    -1,   183,   184,   185,   186,   187,
     188,   189,    -1,   191,    -1,   193,    -1,    -1,   196,    -1,
     198,   199,   200,   201,   202,    -1,   204,   205,    -1,   207,
     208,    -1,   210,    -1,    -1,   213,   214,   215,    -1,    -1,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,    -1,   233,   234,   235,   236,    -1,
     238,   239,    -1,   241,    -1,   243,   244,   245,   246,   247,
     248,    -1,   250,    -1,    -1,   253,   254,   255,    -1,    -1,
     258,   259,    -1,   261,    -1,   263,   264,   265,   266,   267,
     268,   269,   270,    -1,   272,   273,   274,   275,   276,   277,
     278,    -1,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,   290,   291,   292,    -1,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,    -1,   306,   307,
      -1,   309,   310,   311,   312,   313,   314,   315,   316,   317,
     318,   319,    -1,   321,   322,   323,   324,   325,    -1,   327,
     328,   329,   330,    -1,   332,   333,   334,    -1,   336,   337,
     338,   339,   340,   341,   342,   343,   344,   345,   346,    -1,
     348,   349,    -1,   351,   352,   353,   354,   355,   356,    -1,
     358,   359,    -1,    -1,   362,   363,   364,   365,    -1,   367,
     368,   369,   370,   371,   372,   373,    -1,    -1,   376,   377,
     378,   379,   380,    -1,    -1,   383,   384,   385,   386,   387,
     388,   389,    -1,   391,    -1,   393,   394,   395,   396,    -1,
      -1,   399,    -1,    -1,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    14,    15,    16,    17,    18,    19,    20,
      21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,    30,
      -1,    -1,    -1,    34,    35,    -1,    37,    38,    -1,    40,
      41,    42,    43,    44,    -1,    46,    47,    -1,    49,    50,
      51,    52,    53,    -1,    -1,    56,    57,    58,    59,    60,
      -1,    62,    63,    64,    65,    66,    -1,    -1,    -1,    70,
      71,    72,    73,    -1,    75,    76,    -1,    78,    79,    80,
      81,    82,    83,    -1,    -1,    86,    87,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    95,    96,    97,    98,    99,   100,
     101,   102,   103,    -1,   105,    -1,   107,   108,   109,   110,
     111,    -1,   113,   114,   115,    -1,    -1,   118,   119,   120,
     121,   122,    -1,   124,   125,   126,    -1,   128,   129,   130,
      -1,   132,   133,   134,   135,   136,   137,   138,   139,   140,
      -1,   142,    -1,   144,   145,   146,   147,    -1,   149,    -1,
     151,    -1,    -1,    -1,   155,   156,   157,    -1,   159,   160,
      -1,   162,    -1,   164,   165,   166,   167,   168,    -1,   170,
     171,   172,    -1,   174,   175,   176,   177,   178,   179,    -1,
     181,    -1,   183,   184,   185,   186,   187,   188,   189,    -1,
     191,    -1,   193,    -1,    -1,   196,    -1,   198,   199,   200,
     201,   202,    -1,   204,   205,    -1,   207,   208,    -1,   210,
      -1,    -1,   213,   214,   215,    -1,    -1,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,    -1,   233,   234,   235,   236,    -1,   238,   239,    -1,
     241,    -1,   243,   244,   245,   246,   247,   248,    -1,   250,
      -1,    -1,   253,   254,   255,    -1,    -1,   258,   259,    -1,
     261,    -1,   263,   264,   265,   266,   267,   268,   269,   270,
      -1,   272,   273,   274,   275,   276,   277,   278,    -1,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,   292,    -1,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,   304,    -1,   306,   307,    -1,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,   319,    -1,
     321,   322,   323,   324,   325,    -1,   327,   328,   329,   330,
      -1,   332,   333,   334,    -1,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,   346,    -1,   348,   349,    -1,
     351,   352,   353,   354,   355,   356,    -1,   358,   359,    -1,
      -1,   362,   363,   364,   365,    -1,   367,   368,   369,   370,
     371,   372,   373,    -1,    -1,   376,   377,   378,   379,   380,
      -1,    -1,   383,   384,   385,   386,   387,   388,   389,    -1,
     391,    -1,   393,   394,   395,   396,    -1,    -1,   399,    -1,
      -1,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,   419,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      14,    15,    16,    17,    18,    19,    20,    21,    -1,    23,
      24,    25,    -1,    -1,    -1,    -1,    30,    -1,    -1,    -1,
      34,    35,    -1,    37,    38,    -1,    40,    41,    42,    43,
      44,    -1,    46,    47,    -1,    49,    50,    51,    52,    53,
      -1,    -1,    56,    57,    58,    59,    60,    -1,    62,    63,
      64,    65,    66,    -1,    -1,    -1,    70,    71,    72,    73,
      -1,    75,    76,    -1,    78,    79,    80,    81,    82,    83,
      -1,    -1,    86,    87,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    95,    96,    97,    98,    99,   100,   101,   102,   103,
      -1,   105,    -1,   107,   108,   109,   110,   111,    -1,   113,
     114,   115,    -1,    -1,   118,   119,   120,   121,   122,    -1,
     124,   125,   126,    -1,   128,   129,   130,    -1,   132,   133,
     134,   135,   136,   137,   138,   139,   140,    -1,   142,    -1,
     144,   145,   146,   147,    -1,   149,    -1,   151,    -1,    -1,
      -1,   155,   156,   157,    -1,   159,   160,    -1,   162,    -1,
     164,   165,   166,   167,   168,    -1,   170,   171,   172,    -1,
     174,   175,   176,   177,   178,   179,    -1,   181,    -1,   183,
     184,   185,   186,   187,   188,   189,    -1,   191,    -1,   193,
      -1,    -1,   196,    -1,   198,   199,   200,   201,   202,    -1,
     204,   205,    -1,   207,   208,    -1,   210,    -1,    -1,   213,
     214,   215,    -1,    -1,   218,   219,   220,   221,   222,   223,
     224,   225,   226,   227,   228,   229,   230,   231,    -1,   233,
     234,   235,   236,    -1,   238,   239,    -1,   241,    -1,   243,
     244,   245,   246,   247,   248,    -1,   250,    -1,    -1,   253,
     254,   255,    -1,    -1,   258,   259,    -1,   261,    -1,   263,
     264,   265,   266,   267,   268,   269,   270,    -1,   272,   273,
     274,   275,   276,   277,   278,    -1,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,   292,    -1,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
     304,    -1,   306,   307,    -1,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,   319,    -1,   321,   322,   323,
     324,   325,    -1,   327,   328,   329,   330,    -1,   332,   333,
     334,    -1,   336,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,    -1,   348,   349,    -1,   351,   352,   353,
     354,   355,   356,    -1,   358,   359,    -1,    -1,   362,   363,
     364,   365,    -1,   367,   368,   369,   370,   371,   372,   373,
      -1,    -1,   376,   377,   378,   379,   380,    -1,    -1,   383,
     384,   385,   386,   387,   388,   389,    -1,   391,    -1,   393,
     394,   395,   396,    -1,    -1,   399,    -1,    -1,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,    15,    16,
      17,    18,    19,    20,    21,    -1,    23,    24,    25,    -1,
      -1,    -1,    -1,    30,    -1,    -1,    -1,    34,    35,    -1,
      37,    38,    -1,    40,    41,    42,    43,    44,    -1,    46,
      47,    -1,    49,    50,    51,    52,    53,    -1,    -1,    56,
      57,    58,    59,    60,    -1,    62,    63,    64,    65,    66,
      -1,    -1,    -1,    70,    71,    72,    73,    -1,    75,    76,
      -1,    78,    79,    80,    81,    82,    83,    -1,    -1,    86,
      87,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    95,    96,
      97,    98,    99,   100,   101,   102,   103,    -1,   105,    -1,
     107,   108,   109,   110,   111,    -1,   113,   114,   115,    -1,
      -1,   118,   119,   120,   121,   122,    -1,   124,   125,   126,
      -1,   128,   129,   130,    -1,   132,   133,   134,   135,   136,
     137,   138,   139,   140,    -1,   142,    -1,   144,   145,   146,
     147,    -1,   149,    -1,   151,    -1,    -1,    -1,   155,   156,
     157,    -1,   159,   160,    -1,   162,    -1,   164,   165,   166,
     167,   168,    -1,   170,   171,   172,    -1,   174,   175,   176,
     177,   178,   179,    -1,   181,    -1,   183,   184,   185,   186,
     187,   188,   189,    -1,   191,    -1,   193,    -1,    -1,   196,
      -1,   198,   199,   200,   201,   202,    -1,   204,   205,    -1,
     207,   208,    -1,   210,    -1,    -1,   213,   214,   215,    -1,
      -1,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,    -1,   233,   234,   235,   236,
      -1,   238,   239,    -1,   241,    -1,   243,   244,   245,   246,
     247,   248,    -1,   250,    -1,    -1,   253,   254,   255,    -1,
      -1,   258,   259,    -1,   261,    -1,   263,   264,   265,   266,
     267,   268,   269,   270,    -1,   272,   273,   274,   275,   276,
     277,   278,    -1,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,   292,    -1,   294,   295,   296,
     297,   298,   299,   300,   301,   302,   303,   304,    -1,   306,
     307,    -1,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,    -1,   321,   322,   323,   324,   325,    -1,
     327,   328,   329,   330,    -1,   332,   333,   334,    -1,   336,
     337,   338,   339,   340,   341,   342,   343,   344,   345,   346,
      -1,   348,   349,    -1,   351,   352,   353,   354,   355,   356,
      -1,   358,   359,    -1,    -1,   362,   363,   364,   365,    -1,
     367,   368,   369,   370,   371,   372,   373,    -1,    -1,   376,
     377,   378,   379,   380,    -1,    -1,   383,   384,   385,   386,
     387,   388,   389,    -1,   391,    -1,   393,   394,   395,   396,
      -1,    -1,   399,    -1,    -1,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,    19,
      20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,
      30,    -1,    -1,    -1,    34,    35,    -1,    37,    38,    -1,
      40,    41,    42,    43,    44,    -1,    46,    47,    -1,    49,
      50,    51,    52,    53,    -1,    -1,    56,    57,    58,    59,
      60,    -1,    62,    63,    64,    65,    66,    -1,    -1,    -1,
      70,    71,    72,    73,    -1,    75,    76,    -1,    78,    79,
      80,    81,    82,    83,    -1,    -1,    86,    87,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    95,    96,    97,    98,    99,
     100,   101,   102,   103,    -1,   105,    -1,   107,   108,   109,
     110,   111,    -1,   113,   114,   115,    -1,    -1,   118,   119,
     120,   121,   122,    -1,   124,   125,   126,    -1,   128,   129,
     130,    -1,   132,   133,   134,   135,   136,   137,   138,   139,
     140,    -1,   142,    -1,   144,   145,   146,   147,    -1,   149,
      -1,   151,    -1,    -1,    -1,   155,   156,   157,    -1,   159,
     160,    -1,   162,    -1,   164,   165,   166,   167,   168,    -1,
     170,   171,   172,    -1,   174,   175,   176,   177,   178,   179,
      -1,   181,    -1,   183,   184,   185,   186,   187,   188,   189,
      -1,   191,    -1,   193,    -1,    -1,   196,    -1,   198,   199,
     200,   201,   202,    -1,   204,   205,    -1,   207,   208,    -1,
     210,    -1,    -1,   213,   214,   215,    -1,    -1,   218,   219,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,    -1,   233,   234,   235,   236,    -1,   238,   239,
      -1,   241,    -1,   243,   244,   245,   246,   247,   248,    -1,
     250,    -1,    -1,   253,   254,   255,    -1,    -1,   258,   259,
      -1,   261,    -1,   263,   264,   265,   266,   267,   268,   269,
     270,    -1,   272,   273,   274,   275,   276,   277,   278,    -1,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,   292,    -1,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,   304,    -1,   306,   307,    -1,   309,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
      -1,   321,   322,   323,   324,   325,    -1,   327,   328,   329,
     330,    -1,   332,   333,   334,    -1,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,    -1,   348,   349,
      -1,   351,   352,   353,   354,   355,   356,    -1,   358,   359,
      -1,    -1,   362,   363,   364,   365,    -1,   367,   368,   369,
     370,   371,   372,   373,    -1,    -1,   376,   377,   378,   379,
     380,    -1,    -1,   383,   384,   385,   386,   387,   388,   389,
      -1,   391,    -1,   393,   394,   395,   396,    -1,    -1,   399,
      -1,    -1,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    14,    15,    16,    17,    18,    19,    20,    21,    -1,
      23,    24,    25,    -1,    -1,    -1,    -1,    30,    -1,    -1,
      -1,    34,    35,    -1,    37,    38,    -1,    40,    41,    42,
      43,    44,    -1,    46,    47,    -1,    49,    50,    51,    52,
      53,    -1,    -1,    56,    57,    58,    59,    60,    -1,    62,
      63,    64,    65,    66,    -1,    -1,    -1,    70,    71,    72,
      73,    -1,    75,    76,    -1,    78,    79,    80,    81,    82,
      83,    -1,    -1,    86,    87,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    95,    96,    97,    98,    99,   100,   101,   102,
     103,    -1,   105,    -1,   107,   108,   109,   110,   111,    -1,
     113,   114,   115,    -1,    -1,   118,   119,   120,   121,   122,
      -1,   124,   125,   126,    -1,   128,   129,   130,    -1,   132,
     133,   134,   135,   136,   137,   138,   139,   140,    -1,   142,
      -1,   144,   145,   146,   147,    -1,   149,    -1,   151,    -1,
      -1,    -1,   155,   156,   157,    -1,   159,   160,    -1,   162,
      -1,   164,   165,   166,   167,   168,    -1,   170,   171,   172,
      -1,   174,   175,   176,   177,   178,   179,    -1,   181,    -1,
     183,   184,   185,   186,   187,   188,   189,    -1,   191,    -1,
     193,    -1,    -1,   196,    -1,   198,   199,   200,   201,   202,
      -1,   204,   205,    -1,   207,   208,    -1,   210,    -1,    -1,
     213,   214,   215,    -1,    -1,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,    -1,
     233,   234,   235,   236,    -1,   238,   239,    -1,   241,    -1,
     243,   244,   245,   246,   247,   248,    -1,   250,    -1,    -1,
     253,   254,   255,    -1,    -1,   258,   259,    -1,   261,    -1,
     263,   264,   265,   266,   267,   268,   269,   270,    -1,   272,
     273,   274,   275,   276,   277,   278,    -1,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,   292,
      -1,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,   304,    -1,   306,   307,    -1,   309,   310,   311,   312,
     313,   314,   315,   316,   317,   318,   319,    -1,   321,   322,
     323,   324,   325,    -1,   327,   328,   329,   330,    -1,   332,
     333,   334,    -1,   336,   337,   338,   339,   340,   341,   342,
     343,   344,   345,   346,    -1,   348,   349,    -1,   351,   352,
     353,   354,   355,   356,    -1,   358,   359,    -1,    -1,   362,
     363,   364,   365,    -1,   367,   368,   369,   370,   371,   372,
     373,    -1,    -1,   376,   377,   378,   379,   380,    -1,    -1,
     383,   384,   385,   386,   387,   388,   389,    -1,   391,    -1,
     393,   394,   395,   396,    -1,    -1,   399,    -1,    -1,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,    15,
      16,    17,    18,    19,    20,    21,    -1,    23,    24,    25,
      -1,    -1,    -1,    -1,    30,    -1,    -1,    -1,    34,    35,
      -1,    37,    38,    39,    40,    41,    42,    -1,    44,    45,
      46,    47,    -1,    49,    50,    51,    52,    53,    -1,    -1,
      56,    57,    58,    59,    60,    -1,    62,    63,    64,    65,
      -1,    -1,    68,    -1,    70,    71,    72,    73,    74,    75,
      76,    -1,    78,    79,    80,    81,    82,    83,    -1,    85,
      86,    87,    -1,    -1,    -1,    91,    -1,    -1,    -1,    95,
      96,    97,    98,    99,   100,   101,   102,   103,    -1,   105,
      -1,   107,   108,   109,   110,   111,    -1,   113,   114,   115,
      -1,    -1,   118,   119,   120,   121,   122,    -1,   124,   125,
     126,    -1,   128,   129,   130,    -1,   132,   133,   134,   135,
      -1,   137,   138,   139,    -1,    -1,   142,    -1,   144,   145,
     146,   147,    -1,   149,    -1,   151,   152,    -1,   154,   155,
     156,   157,    -1,   159,    -1,    -1,   162,    -1,   164,   165,
     166,   167,   168,   169,   170,   171,   172,   173,   174,   175,
     176,   177,   178,   179,    -1,   181,   182,   183,   184,   185,
     186,   187,   188,   189,    -1,   191,    -1,   193,   194,   195,
     196,   197,   198,   199,   200,   201,   202,    -1,   204,   205,
      -1,   207,    -1,   209,   210,   211,    -1,   213,   214,   215,
      -1,    -1,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
      -1,    -1,   238,   239,   240,   241,    -1,    -1,   244,   245,
     246,   247,   248,    -1,   250,    -1,    -1,   253,   254,   255,
      -1,    -1,   258,   259,   260,   261,   262,    -1,   264,   265,
     266,   267,   268,   269,   270,    -1,   272,    -1,   274,    -1,
     276,   277,   278,    -1,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,   292,    -1,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,    -1,
     306,   307,   308,   309,   310,    -1,   312,   313,   314,   315,
     316,   317,   318,   319,    -1,   321,   322,   323,   324,   325,
      -1,   327,   328,   329,   330,   331,   332,   333,   334,    -1,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
      -1,    -1,   348,   349,    -1,   351,   352,   353,   354,   355,
     356,    -1,   358,   359,    -1,    -1,   362,    -1,   364,    -1,
      -1,   367,   368,   369,   370,   371,   372,   373,    -1,    -1,
     376,   377,   378,   379,   380,    -1,    -1,   383,   384,   385,
     386,   387,    -1,   389,   390,   391,   392,   393,   394,   395,
     396,    -1,    -1,   399,    -1,    -1,   402,   403,   404,   405,
     406,   407,    -1,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   417,   418,   419,    14,    15,    16,    17,    18,    19,
      20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,
      30,    -1,    -1,    -1,    34,    35,    -1,    37,    38,    39,
      40,    41,    42,    -1,    44,    45,    46,    47,    -1,    49,
      50,    51,    52,    53,    -1,    -1,    56,    57,    58,    59,
      60,    -1,    62,    63,    64,    65,    -1,    -1,    68,    -1,
      70,    71,    72,    73,    74,    75,    76,    -1,    78,    79,
      80,    81,    82,    83,    -1,    85,    86,    87,    -1,    -1,
      -1,    91,    -1,    -1,    -1,    95,    96,    97,    98,    99,
     100,   101,   102,   103,    -1,   105,    -1,   107,   108,   109,
     110,   111,    -1,   113,   114,   115,    -1,    -1,   118,   119,
     120,   121,   122,    -1,   124,   125,   126,    -1,   128,   129,
     130,    -1,   132,   133,   134,   135,    -1,   137,   138,   139,
      -1,    -1,   142,    -1,   144,   145,   146,   147,    -1,   149,
      -1,   151,   152,    -1,   154,   155,   156,   157,    -1,   159,
      -1,    -1,   162,    -1,   164,   165,   166,   167,   168,   169,
     170,   171,   172,    -1,   174,   175,   176,   177,   178,   179,
      -1,   181,   182,    -1,   184,   185,   186,   187,   188,   189,
      -1,   191,    -1,   193,   194,   195,   196,   197,   198,   199,
     200,   201,   202,    -1,   204,   205,    -1,   207,    -1,   209,
     210,   211,    -1,   213,   214,   215,    -1,    -1,   218,   219,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,    -1,    -1,   238,   239,
     240,   241,   242,    -1,   244,   245,   246,   247,   248,    -1,
     250,    -1,    -1,   253,   254,   255,    -1,    -1,   258,    -1,
     260,   261,   262,    -1,   264,   265,   266,   267,   268,   269,
     270,    -1,   272,    -1,   274,    -1,   276,   277,   278,    -1,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,   292,    -1,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,   304,    -1,   306,   307,   308,   309,
     310,    -1,   312,   313,   314,   315,   316,   317,   318,   319,
      -1,   321,   322,   323,   324,   325,    -1,   327,   328,   329,
     330,   331,   332,   333,   334,    -1,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,    -1,    -1,   348,   349,
     350,   351,   352,   353,   354,   355,   356,    -1,   358,   359,
      -1,    -1,   362,    -1,   364,    -1,    -1,   367,   368,   369,
     370,   371,   372,   373,    -1,    -1,   376,   377,   378,   379,
     380,    -1,    -1,   383,   384,   385,   386,   387,    -1,   389,
      -1,   391,   392,   393,   394,   395,   396,    -1,    -1,   399,
      -1,    -1,   402,   403,   404,   405,   406,   407,    -1,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   417,   418,   419,
      14,    15,    16,    17,    18,    19,    20,    21,    -1,    23,
      24,    25,    -1,    -1,    -1,    -1,    30,    -1,    -1,    -1,
      34,    35,    -1,    37,    38,    -1,    40,    41,    42,    43,
      44,    -1,    46,    47,    -1,    49,    50,    51,    52,    53,
      -1,    -1,    56,    57,    58,    59,    60,    -1,    62,    63,
      64,    65,    66,    -1,    -1,    -1,    70,    71,    72,    73,
      -1,    75,    76,    -1,    78,    79,    80,    81,    82,    83,
      -1,    -1,    86,    87,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    95,    96,    97,    98,    99,   100,   101,   102,   103,
      -1,   105,    -1,   107,   108,   109,   110,   111,    -1,   113,
     114,   115,    -1,    -1,   118,   119,   120,   121,   122,    -1,
     124,   125,   126,    -1,   128,   129,   130,    -1,   132,   133,
     134,   135,   136,   137,   138,   139,   140,    -1,   142,    -1,
     144,   145,   146,   147,    -1,   149,    -1,   151,    -1,    -1,
      -1,   155,   156,   157,    -1,   159,   160,    -1,   162,    -1,
     164,   165,   166,   167,   168,    -1,   170,   171,   172,    -1,
     174,   175,   176,   177,   178,   179,    -1,   181,    -1,   183,
     184,   185,   186,   187,   188,   189,    -1,   191,    -1,   193,
      -1,    -1,   196,    -1,   198,   199,   200,   201,   202,    -1,
     204,   205,    -1,   207,   208,    -1,   210,    -1,    -1,   213,
     214,   215,    -1,    -1,   218,   219,   220,   221,   222,   223,
     224,   225,   226,   227,   228,   229,   230,   231,    -1,   233,
     234,   235,   236,    -1,   238,   239,    -1,   241,    -1,   243,
     244,   245,   246,   247,   248,    -1,   250,    -1,    -1,   253,
     254,   255,    -1,    -1,   258,   259,    -1,   261,    -1,   263,
     264,   265,   266,   267,    -1,   269,   270,    -1,   272,   273,
     274,   275,   276,   277,   278,    -1,   280,   281,   282,   283,
     284,   285,    -1,   287,   288,   289,   290,   291,   292,    -1,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
     304,    -1,   306,   307,    -1,   309,   310,   311,    -1,   313,
     314,   315,   316,   317,   318,   319,    -1,   321,   322,   323,
     324,   325,    -1,   327,   328,   329,   330,    -1,   332,   333,
     334,    -1,   336,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,    -1,   348,   349,    -1,   351,   352,   353,
     354,   355,   356,    -1,   358,   359,    -1,    -1,   362,   363,
     364,   365,    -1,   367,   368,   369,   370,   371,   372,   373,
      -1,    -1,   376,   377,   378,   379,   380,    -1,    -1,   383,
     384,   385,   386,   387,   388,   389,    -1,   391,    -1,   393,
     394,   395,   396,    -1,    -1,   399,    -1,    -1,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,    15,    16,
      17,    18,    19,    20,    21,    -1,    23,    24,    25,    -1,
      -1,    -1,    -1,    30,    -1,    -1,    -1,    34,    35,    -1,
      37,    38,    39,    40,    41,    42,    -1,    44,    45,    46,
      47,    -1,    49,    50,    51,    52,    53,    -1,    -1,    56,
      57,    58,    59,    60,    -1,    62,    63,    64,    65,    -1,
      -1,    68,    -1,    70,    71,    72,    73,    74,    75,    76,
      -1,    78,    79,    80,    81,    82,    83,    -1,    85,    86,
      87,    -1,    -1,    -1,    91,    -1,    -1,    -1,    95,    96,
      97,    98,    99,   100,   101,   102,   103,    -1,   105,    -1,
     107,   108,   109,   110,   111,    -1,   113,   114,   115,    -1,
      -1,   118,   119,   120,   121,   122,    -1,   124,   125,   126,
      -1,   128,   129,   130,    -1,   132,   133,   134,   135,    -1,
     137,   138,   139,    -1,    -1,   142,    -1,   144,   145,   146,
     147,    -1,   149,    -1,   151,   152,    -1,   154,   155,   156,
     157,    -1,   159,    -1,    -1,   162,    -1,   164,   165,   166,
     167,   168,   169,   170,   171,   172,    -1,   174,   175,   176,
     177,   178,   179,    -1,   181,   182,    -1,   184,   185,   186,
     187,   188,   189,    -1,   191,    -1,   193,   194,   195,   196,
     197,   198,   199,   200,   201,   202,    -1,   204,   205,    -1,
     207,    -1,   209,   210,   211,    -1,   213,   214,   215,    -1,
      -1,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
      -1,   238,   239,   240,   241,    -1,    -1,   244,   245,   246,
     247,   248,    -1,   250,    -1,    -1,   253,   254,   255,    -1,
      -1,   258,    -1,   260,   261,   262,    -1,   264,   265,   266,
     267,   268,   269,   270,    -1,   272,    -1,   274,    -1,   276,
     277,   278,    -1,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,   292,    -1,   294,   295,   296,
     297,   298,   299,   300,   301,   302,   303,   304,    -1,   306,
     307,   308,   309,   310,    -1,   312,   313,   314,   315,   316,
     317,   318,   319,    -1,   321,   322,   323,   324,   325,    -1,
     327,   328,   329,   330,   331,   332,   333,   334,    -1,   336,
     337,   338,   339,   340,   341,   342,   343,   344,   345,    -1,
      -1,   348,   349,    -1,   351,   352,   353,   354,   355,   356,
      -1,   358,   359,    -1,    -1,   362,    -1,   364,    -1,    -1,
     367,   368,   369,   370,   371,   372,   373,    -1,    -1,   376,
     377,   378,   379,   380,    -1,    -1,   383,   384,   385,   386,
     387,    -1,   389,    -1,   391,   392,   393,   394,   395,   396,
      -1,    -1,   399,    -1,    -1,   402,   403,   404,   405,   406,
     407,    -1,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     417,   418,   419,    14,    15,    16,    17,    18,    19,    20,
      21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,    30,
      -1,    -1,    -1,    34,    35,    -1,    37,    38,    39,    40,
      41,    42,    -1,    44,    45,    46,    47,    -1,    49,    50,
      51,    52,    53,    -1,    -1,    56,    57,    58,    59,    60,
      -1,    62,    63,    64,    65,    -1,    -1,    68,    -1,    70,
      71,    72,    73,    74,    75,    76,    -1,    78,    79,    80,
      81,    82,    83,    -1,    85,    86,    87,    -1,    -1,    -1,
      91,    -1,    -1,    -1,    95,    96,    97,    98,    99,   100,
     101,   102,   103,    -1,   105,    -1,   107,   108,   109,   110,
     111,    -1,   113,   114,   115,    -1,    -1,   118,   119,   120,
     121,   122,    -1,   124,   125,   126,    -1,   128,   129,   130,
      -1,   132,   133,   134,   135,    -1,   137,   138,   139,    -1,
      -1,   142,    -1,   144,   145,   146,   147,    -1,   149,    -1,
     151,   152,    -1,   154,   155,   156,   157,    -1,   159,    -1,
      -1,   162,    -1,   164,   165,   166,   167,   168,   169,   170,
     171,   172,    -1,   174,   175,   176,   177,   178,   179,    -1,
     181,   182,    -1,   184,   185,   186,   187,   188,   189,    -1,
     191,    -1,   193,   194,   195,   196,   197,   198,   199,   200,
     201,   202,    -1,   204,   205,    -1,   207,    -1,   209,   210,
     211,    -1,   213,   214,   215,    -1,    -1,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,    -1,   238,   239,   240,
     241,    -1,    -1,   244,   245,   246,   247,   248,    -1,   250,
      -1,    -1,   253,   254,   255,    -1,    -1,   258,    -1,   260,
     261,   262,    -1,   264,   265,   266,   267,   268,   269,   270,
      -1,   272,    -1,   274,    -1,   276,   277,   278,    -1,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,   292,    -1,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,   304,    -1,   306,   307,   308,   309,   310,
      -1,   312,   313,   314,   315,   316,   317,   318,   319,    -1,
     321,   322,   323,   324,   325,    -1,   327,   328,   329,   330,
     331,   332,   333,   334,    -1,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,    -1,    -1,   348,   349,    -1,
     351,   352,   353,   354,   355,   356,    -1,   358,   359,    -1,
      -1,   362,    -1,   364,    -1,    -1,   367,   368,   369,   370,
     371,   372,   373,    -1,    -1,   376,   377,   378,   379,   380,
      -1,    -1,   383,   384,   385,   386,   387,    -1,   389,    -1,
     391,   392,   393,   394,   395,   396,    -1,    -1,   399,    -1,
      -1,   402,   403,   404,   405,   406,   407,    -1,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   417,   418,   419,    14,
      15,    16,    17,    18,    19,    20,    21,    -1,    23,    24,
      25,    -1,    -1,    -1,    -1,    30,    -1,    -1,    -1,    34,
      35,    -1,    37,    38,    39,    40,    41,    42,    -1,    44,
      45,    46,    47,    -1,    49,    50,    51,    52,    53,    -1,
      -1,    56,    57,    58,    59,    60,    -1,    62,    63,    64,
      65,    -1,    -1,    68,    -1,    70,    71,    72,    73,    74,
      75,    76,    -1,    78,    79,    80,    81,    82,    83,    -1,
      85,    86,    87,    -1,    -1,    -1,    91,    -1,    -1,    -1,
      95,    96,    97,    98,    99,   100,   101,   102,   103,    -1,
     105,    -1,   107,   108,   109,   110,   111,    -1,   113,   114,
     115,    -1,    -1,   118,   119,   120,   121,   122,    -1,   124,
     125,   126,    -1,   128,   129,   130,    -1,   132,   133,   134,
     135,    -1,   137,   138,   139,    -1,    -1,   142,    -1,   144,
     145,   146,   147,    -1,   149,    -1,   151,   152,    -1,   154,
     155,   156,   157,    -1,   159,    -1,    -1,   162,    -1,   164,
     165,   166,   167,   168,   169,   170,   171,   172,    -1,   174,
     175,   176,   177,   178,   179,    -1,   181,   182,    -1,   184,
     185,   186,   187,   188,   189,    -1,   191,    -1,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,    -1,   204,
     205,    -1,   207,    -1,   209,   210,   211,    -1,   213,   214,
     215,    -1,    -1,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,    -1,    -1,   238,   239,   240,   241,    -1,    -1,   244,
     245,   246,   247,   248,    -1,   250,    -1,    -1,   253,   254,
     255,    -1,    -1,   258,    -1,   260,   261,   262,    -1,   264,
     265,   266,   267,   268,   269,   270,    -1,   272,    -1,   274,
      -1,   276,   277,   278,    -1,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,    -1,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
      -1,   306,   307,   308,   309,   310,    -1,   312,   313,   314,
     315,   316,   317,   318,   319,    -1,   321,   322,   323,   324,
     325,    -1,   327,   328,   329,   330,   331,   332,   333,   334,
      -1,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,    -1,    -1,   348,   349,    -1,   351,   352,   353,   354,
     355,   356,    -1,   358,   359,    -1,    -1,   362,    -1,   364,
      -1,    -1,   367,   368,   369,   370,   371,   372,   373,    -1,
      -1,   376,   377,   378,   379,   380,    -1,    -1,   383,   384,
     385,   386,   387,    -1,   389,    -1,   391,   392,   393,   394,
     395,   396,    -1,    -1,   399,    -1,    -1,   402,   403,   404,
     405,   406,   407,    -1,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   417,   418,   419,    14,    15,    16,    17,    18,
      19,    20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,
      -1,    30,    -1,    -1,    -1,    34,    35,    -1,    37,    38,
      39,    40,    41,    42,    -1,    44,    45,    46,    47,    -1,
      49,    50,    51,    52,    53,    -1,    -1,    56,    57,    58,
      59,    60,    -1,    62,    63,    64,    65,    -1,    -1,    68,
      -1,    70,    71,    72,    73,    74,    75,    76,    -1,    78,
      79,    80,    81,    82,    83,    -1,    85,    86,    87,    -1,
      -1,    -1,    91,    -1,    -1,    -1,    95,    96,    97,    98,
      99,   100,   101,   102,   103,    -1,   105,    -1,   107,   108,
     109,   110,   111,    -1,   113,   114,   115,    -1,    -1,   118,
     119,   120,   121,   122,    -1,   124,   125,   126,    -1,   128,
     129,   130,    -1,   132,   133,   134,   135,    -1,   137,   138,
     139,    -1,    -1,   142,    -1,   144,   145,   146,   147,    -1,
     149,    -1,   151,   152,    -1,   154,   155,   156,   157,    -1,
     159,    -1,    -1,   162,    -1,   164,   165,   166,   167,   168,
     169,   170,   171,   172,    -1,   174,   175,   176,   177,   178,
     179,    -1,   181,   182,    -1,   184,   185,   186,   187,   188,
     189,    -1,   191,    -1,   193,   194,   195,   196,   197,   198,
     199,   200,   201,   202,    -1,   204,   205,    -1,   207,    -1,
     209,   210,   211,    -1,   213,   214,   215,    -1,    -1,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,    -1,    -1,   238,
     239,   240,   241,    -1,    -1,   244,   245,   246,   247,   248,
      -1,   250,    -1,    -1,   253,   254,   255,    -1,    -1,   258,
      -1,   260,   261,   262,    -1,   264,   265,   266,   267,   268,
     269,   270,    -1,   272,    -1,   274,    -1,   276,   277,   278,
      -1,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,   292,    -1,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,   304,    -1,   306,   307,   308,
     309,   310,    -1,   312,   313,   314,   315,   316,   317,   318,
     319,    -1,   321,   322,   323,   324,   325,    -1,   327,   328,
     329,   330,   331,   332,   333,   334,    -1,   336,   337,   338,
     339,   340,   341,   342,   343,   344,   345,    -1,    -1,   348,
     349,    -1,   351,   352,   353,   354,   355,   356,    -1,   358,
     359,    -1,    -1,   362,    -1,   364,    -1,    -1,   367,   368,
     369,   370,   371,   372,   373,    -1,    -1,   376,   377,   378,
     379,   380,    -1,    -1,   383,   384,   385,   386,   387,    -1,
     389,    -1,   391,   392,   393,   394,   395,   396,    -1,    -1,
     399,    -1,    -1,   402,   403,   404,   405,   406,   407,    -1,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   417,   418,
     419,    14,    15,    16,    17,    18,    19,    20,    21,    -1,
      23,    24,    25,    -1,    -1,    -1,    -1,    30,    -1,    -1,
      -1,    34,    35,    -1,    37,    38,    39,    40,    41,    42,
      -1,    44,    45,    46,    47,    -1,    49,    50,    51,    52,
      53,    -1,    -1,    56,    57,    58,    59,    60,    -1,    62,
      63,    64,    65,    -1,    -1,    68,    -1,    70,    71,    72,
      73,    74,    75,    76,    -1,    78,    79,    80,    81,    82,
      83,    -1,    85,    86,    87,    -1,    -1,    -1,    91,    -1,
      -1,    -1,    95,    96,    97,    98,    99,   100,   101,   102,
     103,    -1,   105,    -1,   107,   108,   109,   110,   111,    -1,
     113,   114,   115,    -1,    -1,   118,   119,   120,   121,   122,
      -1,   124,   125,   126,    -1,   128,   129,   130,    -1,   132,
     133,   134,   135,    -1,   137,   138,   139,    -1,    -1,   142,
      -1,   144,   145,   146,   147,    -1,   149,    -1,   151,   152,
      -1,   154,   155,   156,   157,    -1,   159,    -1,    -1,   162,
      -1,   164,   165,   166,   167,   168,   169,   170,   171,   172,
      -1,   174,   175,   176,   177,   178,   179,    -1,   181,   182,
      -1,   184,   185,   186,   187,   188,   189,    -1,   191,    -1,
     193,   194,   195,   196,   197,   198,   199,   200,   201,   202,
      -1,   204,   205,    -1,   207,    -1,   209,   210,   211,    -1,
     213,   214,   215,    -1,    -1,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,    -1,    -1,   238,   239,   240,   241,    -1,
      -1,   244,   245,   246,   247,   248,    -1,   250,    -1,    -1,
     253,   254,   255,    -1,    -1,   258,    -1,   260,   261,   262,
      -1,   264,   265,   266,   267,   268,   269,   270,    -1,   272,
      -1,   274,    -1,   276,   277,   278,    -1,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,   292,
      -1,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,   304,    -1,   306,   307,   308,   309,   310,    -1,   312,
     313,   314,   315,   316,   317,   318,   319,    -1,   321,   322,
     323,   324,   325,    -1,   327,    -1,   329,   330,   331,   332,
     333,   334,    -1,   336,   337,   338,   339,   340,   341,   342,
     343,   344,   345,    -1,    -1,   348,   349,    -1,   351,   352,
     353,   354,   355,   356,    -1,   358,   359,    -1,    -1,   362,
      -1,   364,    -1,    -1,   367,   368,   369,   370,   371,   372,
     373,    -1,    -1,   376,   377,   378,   379,   380,    -1,    -1,
     383,   384,   385,   386,   387,    -1,   389,    -1,   391,   392,
     393,   394,   395,   396,    -1,    -1,   399,    -1,    -1,   402,
     403,   404,   405,   406,   407,    -1,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   417,   418,   419,    14,    15,    16,
      17,    18,    19,    20,    21,    -1,    23,    24,    25,    -1,
      -1,    -1,    -1,    30,    -1,    -1,    -1,    34,    35,    -1,
      37,    38,    39,    40,    41,    42,    -1,    -1,    45,    -1,
      -1,    -1,    49,    50,    51,    52,    53,    -1,    -1,    56,
      57,    -1,    -1,    60,    -1,    62,    63,    64,    65,    -1,
      -1,    68,    -1,    70,    71,    72,    73,    74,    75,    76,
      -1,    78,    79,    80,    81,    82,    83,    -1,    85,    86,
      87,    -1,    -1,    -1,    91,    -1,    -1,    -1,    95,    96,
      97,    98,    99,   100,    -1,    -1,   103,    -1,   105,    -1,
     107,   108,   109,   110,   111,    -1,   113,   114,   115,    -1,
      -1,   118,   119,   120,   121,   122,    -1,   124,   125,   126,
      -1,   128,   129,   130,    -1,   132,   133,   134,   135,    -1,
     137,   138,   139,    -1,    -1,   142,    -1,   144,   145,    -1,
     147,    -1,   149,    -1,   151,   152,    -1,   154,   155,   156,
     157,    -1,   159,    -1,    -1,   162,    -1,   164,   165,   166,
     167,   168,   169,   170,   171,   172,    -1,   174,   175,   176,
     177,   178,   179,    -1,   181,   182,    -1,   184,   185,   186,
     187,    -1,    -1,    -1,    -1,    -1,   193,   194,   195,   196,
     197,   198,   199,   200,   201,   202,    -1,   204,   205,    -1,
     207,    -1,   209,   210,   211,    -1,   213,   214,   215,    -1,
      -1,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,    -1,   232,    -1,   234,   235,    -1,
      -1,   238,   239,   240,   241,    -1,    -1,   244,    -1,   246,
     247,   248,    -1,   250,    -1,    -1,   253,   254,   255,    -1,
      -1,   258,    -1,   260,   261,   262,    -1,   264,   265,   266,
     267,   268,   269,   270,    -1,   272,    -1,   274,    -1,   276,
     277,   278,    -1,   280,   281,   282,   283,   284,   285,   286,
     287,    -1,   289,   290,   291,   292,    -1,   294,   295,   296,
     297,   298,   299,   300,   301,   302,   303,   304,    -1,   306,
     307,   308,   309,   310,    -1,   312,   313,   314,   315,   316,
     317,   318,   319,    -1,   321,   322,   323,   324,   325,    -1,
     327,    -1,   329,   330,   331,   332,    -1,   334,    -1,   336,
     337,   338,   339,   340,   341,   342,   343,   344,   345,    -1,
      -1,   348,   349,    -1,   351,   352,   353,   354,   355,   356,
      -1,    -1,    -1,    -1,    -1,   362,    -1,   364,    -1,    -1,
     367,   368,   369,   370,   371,   372,   373,    -1,    -1,   376,
     377,   378,   379,   380,    -1,    -1,   383,   384,   385,   386,
     387,    -1,    -1,    -1,   391,   392,   393,   394,   395,   396,
      -1,    -1,   399,    -1,    -1,   402,   403,   404,   405,   406,
     407,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     417,   418,   419
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const yytype_uint16 yystos[] =
{
       0,    14,    24,    26,    27,    42,    62,    64,    65,    70,
      72,    82,    84,   100,   103,   115,   117,   121,   127,   135,
     137,   143,   158,   213,   214,   219,   228,   239,   277,   289,
     294,   295,   297,   302,   307,   310,   314,   319,   320,   327,
     330,   338,   350,   367,   377,   383,   388,   401,   437,   444,
     445,   446,   447,   453,   454,   456,   457,   458,   459,   460,
     461,   462,   464,   465,   469,   481,   486,   487,   490,   491,
     492,   504,   507,   508,   524,   561,   564,   567,   568,   569,
     576,   582,   584,   586,   587,   590,   593,   594,   598,   599,
     608,   612,   613,   614,   615,   616,   618,   619,   620,   633,
     634,   638,   640,   641,   642,   652,   654,   661,   662,   665,
     666,   667,   668,   669,   674,   676,   679,   683,   687,   688,
     698,   699,   702,   707,   718,   740,   743,   744,   745,   748,
     751,   753,   755,   758,   759,   762,   763,   764,   771,   772,
     774,   775,   776,   781,   783,   784,   788,   789,   792,   793,
     794,   795,   797,   798,   799,   800,   802,   805,   806,   811,
     817,   820,   822,   823,   828,   830,   834,   841,   845,   846,
     847,   848,   849,   850,   853,   881,   362,   404,   777,    21,
      68,    81,    98,   104,   119,   130,   138,   150,   155,   161,
     176,   201,   222,   253,   282,   309,   313,   315,   321,   324,
     349,   350,   352,   356,   364,   369,   381,   394,   583,   777,
       3,    14,    15,    16,    17,    18,    19,    20,    21,    22,
      23,    24,    25,    30,    34,    35,    37,    38,    40,    41,
      42,    43,    44,    46,    47,    49,    50,    51,    52,    53,
      56,    57,    58,    59,    60,    62,    63,    64,    65,    66,
      70,    71,    72,    73,    75,    76,    78,    79,    80,    81,
      82,    83,    86,    87,    95,    96,    97,    98,    99,   100,
     101,   102,   103,   105,   107,   108,   109,   110,   111,   113,
     114,   115,   118,   119,   120,   121,   122,   124,   125,   126,
     128,   129,   130,   132,   133,   134,   135,   136,   137,   138,
     139,   140,   142,   144,   145,   146,   147,   149,   151,   155,
     156,   157,   159,   160,   162,   164,   165,   166,   167,   168,
     170,   171,   172,   174,   175,   176,   177,   178,   179,   181,
     183,   184,   185,   186,   187,   188,   189,   191,   193,   196,
     198,   199,   200,   201,   202,   204,   205,   207,   208,   210,
     213,   214,   215,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   233,   234,   235,
     236,   238,   239,   241,   243,   244,   245,   246,   247,   248,
     250,   253,   254,   255,   258,   259,   261,   263,   264,   265,
     266,   267,   268,   269,   270,   272,   273,   274,   275,   276,
     277,   278,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,   290,   291,   292,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,   304,   306,   307,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,   319,   321,
     322,   323,   324,   325,   327,   328,   329,   330,   332,   333,
     334,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   348,   349,   351,   352,   353,   354,   355,   356,
     358,   359,   362,   363,   364,   365,   367,   368,   369,   370,
     371,   372,   373,   376,   377,   378,   379,   380,   383,   384,
     385,   386,   387,   388,   389,   391,   393,   394,   395,   396,
     399,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,   419,   842,
     998,  1011,  1015,  1016,   392,   807,   251,   278,   777,    45,
     515,   846,    21,    34,    55,    68,    77,    98,   104,   119,
     130,   138,   150,   157,   161,   215,   253,   256,   309,   315,
     324,   352,   353,   355,   356,   364,   369,   375,   378,   381,
     525,   566,   657,   708,   719,    22,   277,   998,   842,    22,
     272,   322,   353,   355,     5,   200,   749,   750,  1007,    21,
      34,    55,    68,    81,    98,   119,   130,   138,   150,   155,
     161,   176,   222,   253,   264,   309,   313,   315,   321,   324,
     350,   352,   356,   364,   369,   381,   394,   583,   670,   777,
     998,    84,   392,   437,   561,   564,   567,   806,   812,   820,
     823,   828,   834,   841,   845,     9,    15,    22,    40,   145,
     151,   153,   173,   202,   234,   280,   296,   428,   429,   684,
     685,   842,  1006,  1010,    22,    84,   293,   320,   689,   690,
     691,  1011,  1011,  1003,  1007,   350,   856,   684,  1011,   362,
     998,   264,   222,    98,   176,   349,   350,   756,   314,  1011,
      22,   325,   358,   362,   473,   482,   483,  1011,    19,   158,
     689,   690,   278,   777,  1011,   199,    22,   116,   858,    56,
      78,   215,   230,   309,   315,   325,   358,   362,   407,   470,
     471,   472,   473,    22,   325,   358,   362,   473,   362,   252,
     892,   996,  1011,   856,   430,  1011,   154,   437,   808,   437,
     991,   291,   851,   852,   998,   846,   847,   850,     0,   440,
     807,   131,   190,   257,   374,   859,   860,   846,   848,   849,
     109,   186,   380,   441,     3,    39,    45,    68,    74,    85,
      91,   152,   154,   169,   182,   194,   195,   197,   209,   211,
     232,   240,   260,   262,   308,   331,   392,  1004,  1011,  1012,
    1015,  1017,   672,  1011,   672,   999,  1011,   281,   672,   364,
     672,   998,  1011,    97,   350,   697,  1004,     3,  1008,  1013,
    1015,  1016,  1017,    22,   168,   996,   246,   394,     8,    63,
     142,   424,   425,   426,   428,   429,   430,   431,   432,   433,
     747,   958,   959,  1011,    22,  1008,   998,   998,   168,   996,
     998,   302,   327,    22,   168,   892,   998,   317,   998,   672,
     220,  1008,   168,   996,   200,   106,   196,   237,   287,   778,
     779,   780,   996,  1002,  1011,    21,    55,    68,    69,    77,
      81,    98,   119,   130,   138,   150,   155,   176,   201,   222,
     253,   309,   313,   315,   321,   324,   350,   352,   356,   364,
     369,   394,   583,   677,  1007,   996,   360,  1004,   998,   437,
     672,   364,   999,   672,   364,   168,   998,    97,   350,   353,
     355,  1008,   353,   355,    63,   142,   747,   300,  1008,   168,
     466,  1011,   998,   998,   317,   998,   672,   220,  1008,   291,
     321,   350,   394,   222,    81,   176,   155,   313,   368,   577,
      22,   998,   843,   480,  1007,  1013,   750,   168,  1004,   998,
     168,   754,   168,   999,   364,    97,   350,   168,  1004,   168,
    1008,  1009,    74,   394,    63,   142,   168,   747,    49,   168,
    1009,   168,   998,   168,   998,   168,   998,   317,   168,   998,
     168,   220,  1009,   200,   168,   671,   672,   437,   821,   525,
     812,   388,   806,   813,   814,   815,  1013,   807,  1010,   685,
     686,    22,   686,  1010,   686,    22,   686,  1010,   686,   686,
     686,  1010,  1006,  1006,   842,   686,   281,   437,   437,   544,
     544,   544,   251,   360,   441,   544,   892,   893,   441,   773,
    1007,   437,   818,    49,   394,   998,   998,   996,  1011,    39,
     419,   196,   439,   254,   254,   251,   153,  1007,   360,   148,
     680,   251,     4,     6,     7,     8,    10,    31,    44,    46,
      47,    54,    55,    58,    59,    66,    68,    88,    89,    90,
      91,    92,    93,    94,   101,   102,   120,   136,   140,   141,
     146,   160,   188,   189,   191,   208,   216,   217,   231,   233,
     237,   242,   243,   245,   253,   263,   273,   288,   311,   326,
     333,   346,   358,   359,   363,   365,   366,   375,   381,   389,
     409,   410,   411,   412,   413,   414,   415,   416,   428,   429,
     430,   437,   846,   908,   911,   914,   915,   916,   918,   919,
     920,   921,   924,   925,   929,   931,   932,   933,   935,   956,
     960,   979,   984,   992,   993,   994,  1004,  1005,  1006,  1007,
    1011,  1007,    22,   488,   995,   996,   325,   470,   104,   479,
    1007,   480,  1007,    39,    60,   470,   419,   334,   779,   254,
     153,   360,   424,    39,   419,   196,   780,   437,   996,   430,
     435,   439,   985,   986,   893,   152,   154,   392,   803,   804,
     806,   152,   809,   104,   929,   989,   990,   851,   441,   437,
     810,   438,   438,   446,   996,    22,   116,   857,   857,    49,
     857,   143,   148,   212,   249,   863,   865,   866,   875,   877,
     878,   879,   859,   860,   153,   192,   892,   894,   991,   437,
     731,   986,   265,   298,   327,   439,   673,   265,   298,   327,
     265,   298,   327,   401,   448,   481,   484,   703,    18,   121,
     265,   298,   327,   385,   495,   998,   327,    18,   121,   380,
     463,   405,   168,   892,    51,    83,   139,   171,   207,   237,
     265,   298,   306,   312,   319,   327,   336,   344,   396,   481,
     485,   734,   741,   437,   720,   298,   463,   173,   136,    18,
      24,    65,   114,   121,   124,   178,   235,   237,   247,   255,
     265,   298,   301,   302,   327,   385,   493,   494,   602,     4,
     429,   574,  1010,    22,   168,   996,   672,   672,   437,   746,
     439,   173,   455,   298,   448,   455,   251,   265,   298,   136,
      50,    96,   175,   223,   225,   235,   264,   298,   303,   327,
     338,   493,   571,   572,   265,   298,   393,   602,   610,   483,
     471,   473,   173,   136,   298,   327,   493,   265,   298,   302,
     327,    75,   113,   266,   354,   251,    18,    24,   121,   265,
     298,   327,   505,   506,   148,   298,   327,   448,   484,   136,
     298,   327,   493,   998,   210,   106,   252,   406,   441,   778,
     382,   801,   251,  1004,   437,   998,   364,    97,   350,  1004,
     246,   394,    63,   142,   747,   998,   317,   998,   200,   672,
     544,   284,   510,   437,   647,   731,    61,     3,    44,    46,
      47,    58,    59,   101,   102,   146,   188,   189,   191,   231,
     233,   245,   288,   328,   333,   358,   359,   389,   905,   907,
     909,   911,   913,   915,   916,   917,   919,   920,   924,   925,
    1012,  1015,   153,   437,   643,   998,   448,    32,   796,   998,
     237,   448,   405,   168,   996,   448,   672,   672,   643,   378,
     525,   448,   237,    39,   467,   369,   609,   265,   585,    75,
     113,   266,   354,    20,    41,   187,   621,    32,   643,   148,
     448,   394,   996,   168,   562,   996,   996,   394,   672,    74,
     709,  1004,   998,   583,    45,    95,   185,   235,   316,   136,
     731,    52,   304,   496,   136,   437,   136,   405,   136,   720,
     136,   441,   168,   671,   168,   672,   168,   672,   136,   746,
    1009,   136,   136,   251,   136,   496,   136,    75,   113,   266,
     354,   136,   251,   136,   148,   168,   168,   480,   136,   441,
     496,   929,   963,   350,   438,   441,   141,   251,   366,   477,
     480,   574,   816,   812,   686,   842,   686,   842,   686,   842,
     686,   842,   686,   842,   842,   842,   686,   842,   437,   545,
     546,  1011,   545,    22,    98,   119,   150,   155,   200,   201,
     315,   321,   350,   352,   369,   692,   995,  1009,   691,   173,
     441,   831,  1007,   905,   966,    32,  1009,   709,   149,   757,
     757,   757,   210,  1011,   148,   148,   692,  1009,   314,  1011,
     480,   251,   437,   987,   435,   846,   967,   391,   922,   929,
     983,   437,   922,   922,   437,   148,   437,   437,   437,   910,
     910,   275,   846,   437,   437,   912,   437,   437,   437,   437,
      58,    59,   922,   929,   437,   910,   437,   437,   437,   437,
     437,   403,   423,   437,   926,   437,   926,   437,   437,   846,
     437,   437,   437,   437,   437,   437,   437,   437,   929,   929,
     846,   929,   963,   986,  1007,    59,   437,   923,   437,  1007,
       3,     8,    11,    28,    32,    37,    43,    67,   169,   173,
     194,   195,   211,   237,   240,   253,   256,   331,   424,   425,
     426,   428,   429,   430,   431,   432,   433,   958,   960,   962,
     402,   944,   262,   929,   192,   854,   441,   437,  1007,   986,
     107,   170,   489,   441,    60,   104,   480,    32,     3,   104,
     215,   478,   574,   925,  1007,  1007,    79,   118,   941,    87,
     104,   474,   475,   477,   574,   104,   474,   210,   996,   929,
       3,    22,    26,    27,    28,    29,    31,    32,    33,    36,
      48,    54,    55,    61,    67,    69,    77,    84,    88,    89,
      90,    92,    93,    94,   104,   106,   112,   116,   117,   123,
     127,   131,   141,   143,   148,   150,   153,   158,   161,   163,
     173,   180,   190,   192,   203,   206,   212,   216,   217,   237,
     242,   249,   251,   252,   256,   257,   271,   279,   293,   305,
     320,   326,   335,   347,   350,   357,   360,   361,   366,   374,
     375,   381,   382,   390,   397,   398,   400,   401,   430,  1001,
    1014,  1015,  1016,  1017,  1018,   985,    80,   303,   675,   438,
     441,   807,   438,   441,   852,   997,   998,    32,   810,   848,
     848,   861,   862,   929,   848,   145,   234,   872,   198,   235,
     287,   329,   380,    22,   867,   929,   868,   870,   929,   931,
     875,   876,   866,   865,   863,   864,   148,   878,   247,   880,
     863,   875,   894,   996,    32,  1011,   327,   173,   183,   257,
     259,   328,   390,   430,   724,   725,   726,   728,   730,   732,
     905,  1012,   265,   298,   327,   360,   360,   315,  1001,   439,
     360,   360,   315,   360,   360,   352,   470,   790,   148,   158,
     173,   307,   704,   705,    61,    77,   132,   150,   279,   375,
     541,   542,    77,   104,   237,   360,    77,   360,   104,   237,
     315,    77,   114,   124,   265,   298,   639,   315,   591,    21,
      55,    68,    81,   119,   130,   150,   155,   222,   253,   315,
     321,   324,   350,   356,   369,   394,   583,   998,   136,   298,
     327,   493,   251,   574,   319,   207,   360,   360,   242,   574,
     108,   193,   315,   325,   362,   472,   304,   327,   734,   742,
     438,   721,   724,   360,   381,   352,   996,    69,   132,   532,
     541,  1011,    69,    77,   760,   251,   313,   364,    77,   760,
      25,   301,   313,   364,   996,   178,   247,   672,   437,   360,
     360,   167,   437,   500,   352,   401,   403,   500,    77,   441,
       4,   265,   173,   136,   298,   327,   493,   382,   382,   236,
     905,   265,   327,   747,    98,   484,   360,   450,   484,   996,
     360,   360,   996,   574,    49,   573,   574,   574,    96,   223,
     225,    49,   360,   448,   315,   448,   235,   572,   360,   360,
     242,  1007,   602,   352,   892,    77,   360,   760,   315,   360,
     360,   500,   500,   672,   672,   672,   672,   996,    38,   387,
      38,    38,   360,    38,   360,   315,   441,    94,   381,   617,
    1008,   360,   450,   996,   360,   315,   265,   298,   287,   299,
     323,   476,   778,  1002,  1011,   996,   731,   905,   251,   405,
     720,   574,   672,   672,   746,   194,   251,    75,   113,   266,
     354,   251,   672,   194,   401,   516,   341,   342,   511,  1007,
       3,   648,   649,   643,   437,   907,    32,    31,   906,    99,
     166,   224,   227,   318,   417,   437,   927,   928,   673,   910,
     672,   644,   645,  1014,    20,   785,   905,   251,   136,   588,
     998,   237,   437,   449,   657,   382,   291,   394,   449,   136,
    1008,    84,   158,   468,   524,   568,   620,   687,   707,   781,
    1007,   610,   611,   998,   218,   672,   672,   672,   672,   247,
     109,   186,   367,   380,   622,   623,   128,   286,   437,   617,
     449,   996,   570,   571,   237,    32,   247,   437,   544,   544,
     565,   996,   148,   710,  1002,   437,   722,    32,   200,   401,
     403,   844,   316,  1004,   496,   905,   999,   168,   998,  1004,
     496,  1009,  1008,   136,   496,   136,   382,   136,   382,   747,
     496,   496,  1009,   998,   672,   998,   998,   998,   672,  1009,
     617,   136,   136,   496,   671,   672,   438,   441,   996,   812,
     814,   842,   842,   842,   842,   842,   842,   545,   438,   441,
     438,   156,   322,   351,   997,   671,    97,   324,   696,   697,
     997,   246,   997,   995,   995,   997,   671,   360,   401,   700,
      16,    30,   134,   311,   329,   832,   892,   241,   833,   438,
     441,   819,   823,   828,   834,   845,   360,   996,   690,   689,
     690,   153,   159,   701,  1011,    21,    69,    98,   119,   130,
     150,   155,   201,   222,   309,   315,   321,   350,   352,   369,
     394,   583,   681,   963,   985,   436,   963,   967,   968,   437,
     397,   980,   981,   929,   963,   437,  1006,  1006,   963,     3,
      99,   166,   224,   227,   318,   417,   969,   970,  1007,  1006,
     963,   963,  1006,  1006,   922,   922,   929,   747,   929,   971,
     428,   429,   930,   931,   956,   960,   973,   438,   963,   929,
     963,   974,   358,   419,  1006,  1006,   929,    48,   153,   206,
     361,   929,   963,   977,   963,   229,   931,   929,   939,   940,
     941,   229,   929,   941,   438,   441,   327,  1006,  1006,   927,
     905,   929,  1014,   358,    36,   347,   988,   672,   929,   437,
     846,   978,   116,   118,   141,   237,   242,   247,   366,   376,
     929,    43,   169,   173,   211,   331,   437,   929,   360,   929,
     929,   929,   929,   929,   929,   929,   929,   929,   929,    22,
      29,   335,   957,   161,   144,   945,   311,   437,   956,   157,
     215,   350,   353,   355,   378,   855,   996,   153,   882,   994,
      22,   116,   390,   430,   438,   726,   929,   964,   965,  1012,
     996,   362,   437,  1007,   441,   438,   436,   442,   167,   167,
     496,   996,   804,   805,   996,   989,   438,   441,   437,   441,
      33,   112,   382,   716,   437,   869,  1010,   329,   198,   252,
     441,   311,   312,   871,   995,   833,   876,   864,   382,   829,
     104,   437,   824,   845,  1011,   437,   835,   836,   837,   838,
     839,  1011,   259,    49,  1012,   438,   726,   728,   725,   728,
    1012,   257,   438,   441,   673,   360,   360,   315,  1008,   998,
     998,  1001,  1008,   998,   998,  1008,   999,   998,    76,   791,
     309,   381,   689,   315,   158,   689,   437,   998,   382,   711,
     198,   198,   382,   437,   560,   168,   998,   242,  1008,   998,
     998,   929,   242,   998,   998,    25,   301,   360,   360,   998,
     360,   592,  1004,   437,   672,   672,   672,   364,    97,   350,
     697,   394,    63,   142,   747,   998,   672,   998,   672,   317,
     672,   672,   200,   162,   235,   265,   298,   386,   595,   596,
     597,   892,   360,   760,   315,   242,   108,   193,  1008,   998,
     251,   998,   438,   441,  1008,  1009,   998,   298,   493,   532,
     905,   998,  1011,   998,   998,    22,   381,   998,   168,   998,
     168,  1011,   313,   364,   313,   364,   998,    22,   381,   998,
     996,    18,   121,   327,   603,   604,   605,   606,  1014,  1008,
     998,   104,   154,   238,   382,   499,   502,   503,  1014,   998,
     250,    65,   250,   998,   494,   360,   352,   996,   360,   760,
     315,  1000,  1011,  1000,   441,   438,   441,   360,   315,   999,
    1008,     3,    76,   126,   178,   270,   373,   381,   384,   451,
     298,  1008,   998,   298,   327,   493,   571,   574,   672,   998,
     574,   998,   574,  1008,   998,   998,   298,   327,   493,   998,
     998,   998,   998,  1008,   998,    18,    24,   121,   265,   298,
     327,   265,   298,   327,   643,   298,   327,   298,   327,   298,
     904,  1011,   168,   653,  1011,   168,  1011,  1008,   998,   998,
     998,    18,   506,   324,  1008,   298,   327,   493,   998,   998,
     360,   360,    73,   372,   287,   194,    32,   672,   194,   194,
     382,   382,   194,   242,   678,  1007,   672,   672,   194,   678,
     250,   153,   360,   509,   448,   424,   438,   441,   929,    31,
     906,   905,   435,   435,   360,   360,   360,   437,   360,  1006,
     910,   438,   441,   424,   622,    76,   125,   204,   205,   218,
     265,   352,   354,   786,   534,  1014,   998,   153,   315,   393,
     589,   596,   597,   136,   211,   526,   528,   530,   532,   538,
     541,    19,   173,   309,   348,   451,   452,   148,  1000,   394,
     996,   466,  1011,   467,   256,   525,   150,  1007,   643,   643,
     643,   643,   247,   251,   256,   437,   643,   902,   903,   904,
     324,   437,   136,   135,   845,   672,   526,  1011,   401,   403,
     556,   401,   501,    32,   544,  1007,   251,   438,   723,   724,
     729,    32,   200,   306,   400,   733,   734,   735,   251,   480,
     165,   165,   148,   731,    32,   136,   496,   720,   671,   672,
    1000,   672,  1000,   746,   251,   496,   496,   251,   496,   324,
     148,   480,   496,   929,   438,   546,   173,   173,   173,   405,
     997,   441,   574,   575,   161,   693,   694,  1008,    19,   701,
     134,   329,   134,   329,   134,   329,   311,   380,   226,   905,
     998,   401,   563,   153,   251,   693,    49,   496,  1004,   364,
     350,  1004,   246,   394,   200,   672,   438,   436,   436,   441,
     963,   929,   123,   981,   982,    32,   438,   929,   438,   438,
     438,   438,   153,   438,   438,   438,   438,   438,   441,   438,
     271,   972,   438,   930,   930,    11,   173,   194,   253,   424,
     425,   426,   428,   429,   430,   431,   432,   433,   960,   930,
     438,   438,   148,   153,   975,   976,   438,   419,   438,   438,
      32,   977,   963,   977,   977,   153,   438,   438,  1014,   269,
     943,    32,   438,   441,   929,  1014,   441,   929,   987,   929,
    1011,   438,   438,   419,   930,   930,   129,   963,   153,   116,
     118,   141,   242,   247,   366,   376,   437,   129,   347,   988,
     929,   978,   929,   360,   747,   929,   437,   846,   437,   437,
     261,   949,   353,   355,   353,   355,   996,   856,   856,   856,
     203,   312,   437,   846,   883,   884,   885,   892,   895,   932,
     934,   935,  1004,  1011,   398,   900,   964,   964,   965,   438,
      13,   441,   859,   860,   779,  1006,   927,   475,   929,   810,
     998,   819,   862,   253,   958,   961,   420,   421,   717,   929,
     871,   380,   868,   883,   398,   901,   388,   825,   826,  1011,
     305,   827,   839,   840,   441,   882,   424,   987,   732,   673,
     728,   728,    49,   730,   432,  1008,   998,   998,   212,  1009,
    1009,   251,   997,   254,   251,   929,   542,  1000,   437,   437,
     437,   560,   176,   545,   631,   136,   496,   360,  1008,   998,
     480,   731,   905,   998,   405,   672,   672,   672,   672,   746,
      75,   113,   266,   354,   998,   578,   998,   162,   386,   360,
     360,   578,   595,   602,   298,   327,   493,   998,   998,   998,
     184,   242,   724,   264,   327,   360,   255,   600,   631,   121,
     302,   327,   495,   602,   761,   136,   496,   136,   496,   998,
     998,   998,   998,   605,   606,   605,   438,   441,   607,  1007,
     176,   438,   441,   424,   439,  1008,   998,   298,   327,   493,
     998,   998,   998,   265,   298,   327,    18,   121,   265,   298,
     327,   905,   236,   905,  1008,   998,   212,   270,   242,  1007,
     270,  1009,   379,   360,   360,   315,   264,   327,   360,   760,
     315,   360,   360,   220,   220,   220,   360,   360,   315,   360,
     360,   315,   360,   315,   360,   315,   360,   496,   905,   237,
    1007,   327,   761,   136,   496,   360,   998,   360,   315,  1008,
     998,   678,   905,   194,   678,   678,  1000,  1000,   678,   194,
     194,   678,   510,   437,   512,   513,   253,   428,   429,   574,
     646,   728,   961,  1007,  1018,     3,   649,   438,   435,   438,
    1006,   436,  1006,   166,   224,   928,   224,   928,   928,  1006,
     227,   438,   645,   646,   251,   212,   424,   787,   787,   787,
     787,   787,   787,   787,    61,    67,    77,   104,   106,   180,
     237,   242,   279,   293,   375,   535,   536,   537,   135,   397,
     448,   480,   998,   480,   600,   996,   996,   438,   441,  1009,
     161,   309,  1009,  1006,   369,   996,   544,    39,   467,   300,
     350,    97,   501,   545,   996,   623,   650,   651,  1007,   438,
     441,   998,   545,   996,   998,   563,   437,   527,   438,   250,
     500,   250,   251,   557,   500,    32,   845,   501,   360,   996,
     438,   441,   104,   424,   736,  1007,   480,   350,   727,   728,
     401,   735,   737,   109,   186,   320,   380,   769,   162,   845,
     496,   905,   998,   496,   496,   382,   496,   382,   496,   496,
     672,   672,   998,   617,   496,   315,   315,   315,   997,   697,
     441,  1008,   401,   441,   695,   254,   134,   134,    97,   235,
    1009,   692,   496,  1008,   731,   720,   574,   672,   194,   967,
     438,   357,   929,   127,   905,   438,   929,   929,   929,   975,
     905,   930,   116,   118,   237,   247,   930,   930,   930,   930,
     930,   930,   930,   930,   930,   930,   929,   929,   976,   975,
     926,   926,   905,   438,   438,   438,   963,   438,   441,    49,
     931,   438,  1014,   940,   276,   345,   942,   438,   441,   393,
     936,    32,   438,   923,  1007,   929,    28,    28,   929,   438,
     929,   153,   437,   966,   929,   930,   930,   129,   129,   929,
     438,   129,   929,   860,   398,   437,   950,  1011,   856,   856,
     856,   856,   996,   996,   996,   846,   895,   153,   846,   884,
     885,    32,   886,   887,  1011,   441,    85,   154,   182,   197,
     209,   232,   308,   889,   887,    32,   886,   888,  1011,   422,
     899,   437,   986,   929,   161,   873,   441,   859,   859,   859,
     929,   390,   965,   438,   438,   436,   438,   437,   717,   438,
     252,    87,   929,   827,   438,   441,   987,   993,   438,   441,
     836,   901,   989,   438,   432,   732,   369,   787,   156,   322,
     351,   370,   706,   148,   706,   438,   437,   548,   549,   713,
     934,  1011,   545,   545,   631,  1002,   438,   106,   180,   235,
     237,   632,   998,   998,    32,   998,   382,   382,   672,   672,
     672,   672,   673,  1008,   998,   360,   760,   315,   360,   184,
      49,   352,   998,   437,   534,   237,   500,    97,   237,   340,
     343,   500,   369,   998,  1011,   604,   998,   503,   646,  1014,
     264,   327,   360,   760,   315,   360,   360,   360,   315,   155,
     253,   343,   655,   656,   155,   253,   663,   664,   360,   360,
     315,   438,   438,   438,  1010,  1007,  1007,  1007,   998,   998,
     998,    49,   352,   998,   998,   998,   998,   998,   148,   148,
     300,   148,   168,  1008,   998,   998,  1008,   998,   998,   998,
     998,   998,   998,   998,    67,   497,   136,    20,    41,   369,
    1011,   998,   602,   998,   998,   438,   678,   194,   194,   678,
     678,   511,   519,   520,  1014,    45,    86,   110,   125,   129,
     149,   152,   164,   242,   250,   285,   514,   631,  1006,   401,
     403,   436,   436,   438,   927,   996,   787,   104,  1006,  1007,
     104,  1007,   104,  1007,   104,  1007,   104,   998,   104,   998,
     104,   998,   437,   672,   998,   930,   107,   170,   106,   242,
     198,   996,   737,   283,   635,   636,  1011,   588,   437,   539,
     324,   530,  1009,  1009,   905,   437,   501,  1008,   996,   405,
     148,   624,   438,   441,   904,   600,   438,   247,   437,   821,
     529,   531,   533,   541,  1011,   556,   179,   555,    72,   352,
     558,   845,   563,   558,  1007,   711,   729,   929,   929,   441,
     437,   733,   643,   360,   578,   438,   496,  1000,  1000,   496,
     496,   324,   997,   997,   997,   574,   158,   694,    97,   701,
     153,   194,   194,   194,   194,   242,   682,  1007,   929,   438,
     438,   976,   153,   116,   118,   247,   437,   438,   408,   938,
     963,   292,    49,   399,   399,   438,   929,   235,   929,   441,
     937,   907,   927,   930,   930,   929,   966,   438,    28,    28,
     929,   929,   129,   929,   438,   438,   929,   951,  1011,   996,
     996,   996,   996,   887,   888,   437,   438,  1011,   437,   884,
     197,   260,   890,   884,   890,   197,   889,   890,   197,   437,
    1011,   437,   964,    49,   163,   874,   438,   438,   438,   965,
    1007,  1007,   747,   247,   845,   826,   424,   839,   827,   369,
     438,  1010,   360,   689,   153,   631,   929,   438,   441,   401,
      67,   714,   714,   438,   438,   737,   107,   170,   178,   106,
     384,   496,   905,  1000,  1000,   998,   998,   998,   998,  1009,
     998,   601,   605,   242,   242,  1010,  1011,   905,   496,   496,
     424,    49,   352,   998,   998,   998,   998,  1008,   998,   998,
    1006,  1006,   905,   441,  1006,  1006,   441,  1008,   998,   998,
    1009,   998,   360,   997,   997,   672,   997,   136,   672,  1007,
    1007,   905,   496,   496,   194,   678,   678,   382,   517,   518,
     438,   441,   430,   437,   477,   521,   574,   796,  1007,   796,
     237,   242,   285,   796,   796,   436,   155,   183,   155,   153,
     630,  1010,   929,   237,   536,   737,   544,   382,   559,  1004,
      28,   135,   173,   526,   133,   174,   998,   382,   545,    32,
     467,   437,   998,   122,   625,   397,   627,  1007,   501,   672,
     526,   563,   438,   441,   401,   557,   437,   556,   109,   121,
     276,   998,   401,   782,   153,   437,  1007,   726,   738,   739,
    1012,   737,   996,   181,   579,   496,   496,   496,   998,   254,
     496,   693,   682,   682,   682,   682,   930,   153,   437,   966,
     437,   438,   441,   438,   931,   292,   438,   387,   337,   438,
     438,   438,   930,   930,   929,   438,   268,   952,   896,   897,
     934,   886,   437,   997,   884,   251,   382,   891,   884,   197,
     884,   903,   437,   903,  1011,   859,   963,   929,   400,   946,
     859,   927,   438,   842,   991,   693,   251,   693,   438,   737,
     549,   253,   747,   672,   382,   672,   715,   715,   293,   737,
     559,   438,   360,   327,   833,   438,   441,   497,   646,  1009,
     998,   360,   437,  1004,   747,   656,   437,   437,   664,   327,
     833,   998,   401,   300,   401,   401,   148,   497,   678,   448,
     111,   520,   477,   522,   523,  1007,  1007,   242,   545,   430,
     545,  1007,  1007,   697,    32,   752,   752,   996,   631,   438,
     559,   221,   547,   176,   437,   636,   283,   437,   438,    22,
      71,    78,   105,   177,   343,   540,   540,   600,  1000,   438,
     845,   600,   311,   339,   626,   437,   135,    32,   527,   438,
     531,   255,   558,   995,   557,   312,   312,    53,    61,   215,
     672,   712,   713,   728,   438,   441,   900,   578,   235,   386,
     580,   581,   496,   930,   966,   438,   939,   963,    49,   235,
     418,    49,   859,   438,   441,    32,   898,   997,   438,   929,
     437,   884,   891,   438,   903,   438,   438,   947,   948,  1011,
     438,   695,   706,   496,   714,   559,   437,   672,   716,   716,
     996,   559,   631,   998,   352,   605,   382,   498,   327,   833,
     998,   966,   720,   148,   659,   746,   966,   966,   352,   671,
     672,   671,   672,   997,   496,   512,  1007,   438,   441,   545,
     752,    35,   172,   148,   235,   543,   154,   267,   332,   251,
     551,   552,   553,   352,   438,  1004,     5,   637,   324,   142,
     658,   501,   782,   929,   283,   845,   556,   555,   534,   438,
     558,    61,   254,    61,   438,   441,   733,   738,   117,   386,
     578,   438,   438,   438,   292,   387,   963,   286,   312,   953,
     899,   896,   437,   438,   997,   438,   441,    32,   153,   715,
     398,   550,   747,   717,   717,   544,   631,   998,   929,   352,
     438,   257,   317,   290,   660,   659,   438,   438,   998,   401,
     523,   122,   178,   109,   380,   251,   553,   251,   552,   998,
     437,   438,   441,   998,   672,    32,    32,   438,  1004,   782,
     557,   556,   254,   254,   501,   713,   737,    23,   187,   770,
      43,    87,   371,   929,   954,   955,   954,   438,   903,   438,
     948,   950,   693,   716,   437,   631,   438,   547,   833,   998,
    1004,    49,   660,   833,   672,   311,    52,   235,   304,   327,
     554,   554,   438,     5,   600,   655,   845,   437,   558,   557,
     558,   238,   437,   765,   767,   772,   823,   828,   834,   845,
     955,   311,   147,   274,   147,   274,   438,   496,   717,   929,
     551,   833,   720,   672,   627,    17,   104,   242,   782,     4,
     628,   629,  1006,  1007,  1014,   558,   900,   766,   767,   768,
     846,   847,    28,   438,   631,   135,   438,   441,   438,   440,
     955,   283,   629,   768,  1004,   437,   628,   438
};

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  However,
   YYFAIL appears to be in use.  Nevertheless, it is formally deprecated
   in Bison 2.4.2's NEWS entry, where a plan to phase it out is
   discussed.  */

#define YYFAIL		goto yyerrlab
#if defined YYFAIL
  /* This is here to suppress warnings from the GCC cpp's
     -Wunused-macros.  Normally we don't worry about that warning, but
     some users do, and we want to make it easy for users to remove
     YYFAIL uses, which will produce warnings from Bison 2.5.  */
#endif

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                  \
do                                                              \
  if (yychar == YYEMPTY)                                        \
    {                                                           \
      yychar = (Token);                                         \
      yylval = (Value);                                         \
      YYPOPSTACK (yylen);                                       \
      yystate = *yyssp;                                         \
      goto yybackup;                                            \
    }                                                           \
  else                                                          \
    {                                                           \
      yyerror (&yylloc, yyscanner, YY_("syntax error: cannot back up")); \
      YYERROR;							\
    }								\
while (YYID (0))

/* Error token number */
#define YYTERROR	1
#define YYERRCODE	256


/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)                                \
    do                                                                  \
      if (YYID (N))                                                     \
        {                                                               \
          (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;        \
          (Current).first_column = YYRHSLOC (Rhs, 1).first_column;      \
          (Current).last_line    = YYRHSLOC (Rhs, N).last_line;         \
          (Current).last_column  = YYRHSLOC (Rhs, N).last_column;       \
        }                                                               \
      else                                                              \
        {                                                               \
          (Current).first_line   = (Current).last_line   =              \
            YYRHSLOC (Rhs, 0).last_line;                                \
          (Current).first_column = (Current).last_column =              \
            YYRHSLOC (Rhs, 0).last_column;                              \
        }                                                               \
    while (YYID (0))
#endif

#define YYRHSLOC(Rhs, K) ((Rhs)[K])


/* YY_LOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

#ifndef YY_LOCATION_PRINT
# if defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL

/* Print *YYLOCP on YYO.  Private, do not rely on its existence. */

__attribute__((__unused__))
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static unsigned
yy_location_print_ (FILE *yyo, YYLTYPE const * const yylocp)
#else
static unsigned
yy_location_print_ (yyo, yylocp)
    FILE *yyo;
    YYLTYPE const * const yylocp;
#endif
{
  unsigned res = 0;
  int end_col = 0 != yylocp->last_column ? yylocp->last_column - 1 : 0;
  if (0 <= yylocp->first_line)
    {
      res += fprintf (yyo, "%d", yylocp->first_line);
      if (0 <= yylocp->first_column)
        res += fprintf (yyo, ".%d", yylocp->first_column);
    }
  if (0 <= yylocp->last_line)
    {
      if (yylocp->first_line < yylocp->last_line)
        {
          res += fprintf (yyo, "-%d", yylocp->last_line);
          if (0 <= end_col)
            res += fprintf (yyo, ".%d", end_col);
        }
      else if (0 <= end_col && yylocp->first_column < end_col)
        res += fprintf (yyo, "-%d", end_col);
    }
  return res;
 }

#  define YY_LOCATION_PRINT(File, Loc)          \
  yy_location_print_ (File, &(Loc))

# else
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */
#ifdef YYLEX_PARAM
# define YYLEX yylex (&yylval, &yylloc, YYLEX_PARAM)
#else
# define YYLEX yylex (&yylval, &yylloc, yyscanner)
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (YYID (0))

# define YY_SYMBOL_PRINT(Title, Type, Value, Location)			  \
do {									  \
  if (yydebug)								  \
    {									  \
      YYFPRINTF (stderr, "%s ", Title);					  \
      yy_symbol_print (stderr,						  \
		  Type, Value, Location, yyscanner); \
      YYFPRINTF (stderr, "\n");						  \
    }									  \
} while (YYID (0))


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp, core_yyscan_t yyscanner)
#else
static void
yy_symbol_value_print (yyoutput, yytype, yyvaluep, yylocationp, yyscanner)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
    YYLTYPE const * const yylocationp;
    core_yyscan_t yyscanner;
#endif
{
  FILE *yyo = yyoutput;
  YYUSE (yyo);
  if (!yyvaluep)
    return;
  YYUSE (yylocationp);
  YYUSE (yyscanner);
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# else
  YYUSE (yyoutput);
# endif
  YYUSE (yytype);
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp, core_yyscan_t yyscanner)
#else
static void
yy_symbol_print (yyoutput, yytype, yyvaluep, yylocationp, yyscanner)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
    YYLTYPE const * const yylocationp;
    core_yyscan_t yyscanner;
#endif
{
  if (yytype < YYNTOKENS)
    YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  YY_LOCATION_PRINT (yyoutput, *yylocationp);
  YYFPRINTF (yyoutput, ": ");
  yy_symbol_value_print (yyoutput, yytype, yyvaluep, yylocationp, yyscanner);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
#else
static void
yy_stack_print (yybottom, yytop)
    yytype_int16 *yybottom;
    yytype_int16 *yytop;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (YYID (0))


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_reduce_print (YYSTYPE *yyvsp, YYLTYPE *yylsp, int yyrule, core_yyscan_t yyscanner)
#else
static void
yy_reduce_print (yyvsp, yylsp, yyrule, yyscanner)
    YYSTYPE *yyvsp;
    YYLTYPE *yylsp;
    int yyrule;
    core_yyscan_t yyscanner;
#endif
{
  int yynrhs = yyr2[yyrule];
  int yyi;
  unsigned long int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
	     yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr, yyrhs[yyprhs[yyrule] + yyi],
		       &(yyvsp[(yyi + 1) - (yynrhs)])
		       , &(yylsp[(yyi + 1) - (yynrhs)])		       , yyscanner);
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (yyvsp, yylsp, Rule, yyscanner); \
} while (YYID (0))

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static YYSIZE_T
yystrlen (const char *yystr)
#else
static YYSIZE_T
yystrlen (yystr)
    const char *yystr;
#endif
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static char *
yystpcpy (char *yydest, const char *yysrc)
#else
static char *
yystpcpy (yydest, yysrc)
    char *yydest;
    const char *yysrc;
#endif
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
	switch (*++yyp)
	  {
	  case '\'':
	  case ',':
	    goto do_not_strip_quotes;

	  case '\\':
	    if (*++yyp != '\\')
	      goto do_not_strip_quotes;
	    /* Fall through.  */
	  default:
	    if (yyres)
	      yyres[yyn] = *yyp;
	    yyn++;
	    break;

	  case '"':
	    if (yyres)
	      yyres[yyn] = '\0';
	    return yyn;
	  }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (YY_NULL, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULL;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - Assume YYFAIL is not used.  It's too flawed to consider.  See
       <http://lists.gnu.org/archive/html/bison-patches/2009-12/msg00024.html>
       for details.  YYERROR is fine as it does not invoke this
       function.
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                {
                  YYSIZE_T yysize1 = yysize + yytnamerr (YY_NULL, yytname[yyx]);
                  if (! (yysize <= yysize1
                         && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
                    return 2;
                  yysize = yysize1;
                }
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  {
    YYSIZE_T yysize1 = yysize + yystrlen (yyformat);
    if (! (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
      return 2;
    yysize = yysize1;
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep, YYLTYPE *yylocationp, core_yyscan_t yyscanner)
#else
static void
yydestruct (yymsg, yytype, yyvaluep, yylocationp, yyscanner)
    const char *yymsg;
    int yytype;
    YYSTYPE *yyvaluep;
    YYLTYPE *yylocationp;
    core_yyscan_t yyscanner;
#endif
{
  YYUSE (yyvaluep);
  YYUSE (yylocationp);
  YYUSE (yyscanner);

  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  YYUSE (yytype);
}




/*----------.
| yyparse.  |
`----------*/

#ifdef YYPARSE_PARAM
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void *YYPARSE_PARAM)
#else
int
yyparse (YYPARSE_PARAM)
    void *YYPARSE_PARAM;
#endif
#else /* ! YYPARSE_PARAM */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (core_yyscan_t yyscanner)
#else
int
yyparse (yyscanner)
    core_yyscan_t yyscanner;
#endif
#endif
{
/* The lookahead symbol.  */
int yychar;


#if defined __GNUC__ && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN \
    _Pragma ("GCC diagnostic push") \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")\
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END \
    _Pragma ("GCC diagnostic pop")
#else
/* Default value used for initialization, for pacifying older GCCs
   or non-GCC compilers.  */
static YYSTYPE yyval_default;
# define YY_INITIAL_VALUE(Value) = Value
#endif
static YYLTYPE yyloc_default
# if defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL
  = { 1, 1, 1, 1 }
# endif
;
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval YY_INITIAL_VALUE(yyval_default);

/* Location data for the lookahead symbol.  */
YYLTYPE yylloc = yyloc_default;


    /* Number of syntax errors so far.  */
    int yynerrs;

    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       `yyss': related to states.
       `yyvs': related to semantic values.
       `yyls': related to locations.

       Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    /* The location stack.  */
    YYLTYPE yylsa[YYINITDEPTH];
    YYLTYPE *yyls;
    YYLTYPE *yylsp;

    /* The locations where the error started and ended.  */
    YYLTYPE yyerror_range[3];

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;
  YYLTYPE yyloc;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N), yylsp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yyssp = yyss = yyssa;
  yyvsp = yyvs = yyvsa;
  yylsp = yyls = yylsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */
  yylsp[0] = yylloc;
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack.  Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	yytype_int16 *yyss1 = yyss;
	YYLTYPE *yyls1 = yyls;

	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow (YY_("memory exhausted"),
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yyls1, yysize * sizeof (*yylsp),
		    &yystacksize);

	yyls = yyls1;
	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	yytype_int16 *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyexhaustedlab;
	YYSTACK_RELOCATE (yyss_alloc, yyss);
	YYSTACK_RELOCATE (yyvs_alloc, yyvs);
	YYSTACK_RELOCATE (yyls_alloc, yyls);
#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;
      yylsp = yyls + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END
  *++yylsp = yylloc;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];

  /* Default location.  */
  YYLLOC_DEFAULT (yyloc, (yylsp - yylen), yylen);
  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:
/* Line 1787 of yacc.c  */
#line 691 "gram.y"
    {
				pg_yyget_extra(yyscanner)->parsetree = (yyvsp[(1) - (1)].list);
			}
    break;

  case 3:
/* Line 1787 of yacc.c  */
#line 698 "gram.y"
    {
					if ((yyvsp[(3) - (3)].node) != NULL)
						(yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node));
					else
						(yyval.list) = (yyvsp[(1) - (3)].list);
				}
    break;

  case 4:
/* Line 1787 of yacc.c  */
#line 705 "gram.y"
    {
					if ((yyvsp[(1) - (1)].node) != NULL)
						(yyval.list) = list_make1((yyvsp[(1) - (1)].node));
					else
						(yyval.list) = NIL;
				}
    break;

  case 121:
/* Line 1787 of yacc.c  */
#line 831 "gram.y"
    { (yyval.node) = NULL; }
    break;

  case 122:
/* Line 1787 of yacc.c  */
#line 842 "gram.y"
    {
					CreateRoleStmt *n = makeNode(CreateRoleStmt);
					n->stmt_type = ROLESTMT_ROLE;
					n->role = (yyvsp[(3) - (5)].str);
					n->options = (yyvsp[(5) - (5)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 123:
/* Line 1787 of yacc.c  */
#line 852 "gram.y"
    {}
    break;

  case 124:
/* Line 1787 of yacc.c  */
#line 853 "gram.y"
    {}
    break;

  case 125:
/* Line 1787 of yacc.c  */
#line 862 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].defelt)); }
    break;

  case 126:
/* Line 1787 of yacc.c  */
#line 863 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 127:
/* Line 1787 of yacc.c  */
#line 867 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].defelt)); }
    break;

  case 128:
/* Line 1787 of yacc.c  */
#line 868 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 129:
/* Line 1787 of yacc.c  */
#line 873 "gram.y"
    {
					(yyval.defelt) = makeDefElem("password",
									 (Node *)makeString((yyvsp[(2) - (2)].str)));
				}
    break;

  case 130:
/* Line 1787 of yacc.c  */
#line 878 "gram.y"
    {
					(yyval.defelt) = makeDefElem("password", NULL);
				}
    break;

  case 131:
/* Line 1787 of yacc.c  */
#line 882 "gram.y"
    {
					(yyval.defelt) = makeDefElem("encryptedPassword",
									 (Node *)makeString((yyvsp[(3) - (3)].str)));
				}
    break;

  case 132:
/* Line 1787 of yacc.c  */
#line 887 "gram.y"
    {
					(yyval.defelt) = makeDefElem("unencryptedPassword",
									 (Node *)makeString((yyvsp[(3) - (3)].str)));
				}
    break;

  case 133:
/* Line 1787 of yacc.c  */
#line 892 "gram.y"
    {
					(yyval.defelt) = makeDefElem("inherit", (Node *)makeInteger(TRUE));
				}
    break;

  case 134:
/* Line 1787 of yacc.c  */
#line 896 "gram.y"
    {
					(yyval.defelt) = makeDefElem("connectionlimit", (Node *)makeInteger((yyvsp[(3) - (3)].ival)));
				}
    break;

  case 135:
/* Line 1787 of yacc.c  */
#line 900 "gram.y"
    {
					(yyval.defelt) = makeDefElem("validUntil", (Node *)makeString((yyvsp[(3) - (3)].str)));
				}
    break;

  case 136:
/* Line 1787 of yacc.c  */
#line 905 "gram.y"
    {
					(yyval.defelt) = makeDefElem("rolemembers", (Node *)(yyvsp[(2) - (2)].list));
				}
    break;

  case 137:
/* Line 1787 of yacc.c  */
#line 909 "gram.y"
    {
					/*
					 * We handle identifiers that aren't parser keywords with
					 * the following special-case codes, to avoid bloating the
					 * size of the main parser.
					 */
					if (strcmp((yyvsp[(1) - (1)].str), "superuser") == 0)
						(yyval.defelt) = makeDefElem("superuser", (Node *)makeInteger(TRUE));
					else if (strcmp((yyvsp[(1) - (1)].str), "nosuperuser") == 0)
						(yyval.defelt) = makeDefElem("superuser", (Node *)makeInteger(FALSE));
					else if (strcmp((yyvsp[(1) - (1)].str), "createuser") == 0)
					{
						/* For backwards compatibility, synonym for SUPERUSER */
						(yyval.defelt) = makeDefElem("superuser", (Node *)makeInteger(TRUE));
					}
					else if (strcmp((yyvsp[(1) - (1)].str), "nocreateuser") == 0)
					{
						/* For backwards compatibility, synonym for SUPERUSER */
						(yyval.defelt) = makeDefElem("superuser", (Node *)makeInteger(FALSE));
					}
					else if (strcmp((yyvsp[(1) - (1)].str), "createrole") == 0)
						(yyval.defelt) = makeDefElem("createrole", (Node *)makeInteger(TRUE));
					else if (strcmp((yyvsp[(1) - (1)].str), "nocreaterole") == 0)
						(yyval.defelt) = makeDefElem("createrole", (Node *)makeInteger(FALSE));
					else if (strcmp((yyvsp[(1) - (1)].str), "replication") == 0)
						(yyval.defelt) = makeDefElem("isreplication", (Node *)makeInteger(TRUE));
					else if (strcmp((yyvsp[(1) - (1)].str), "noreplication") == 0)
						(yyval.defelt) = makeDefElem("isreplication", (Node *)makeInteger(FALSE));
					else if (strcmp((yyvsp[(1) - (1)].str), "createdb") == 0)
						(yyval.defelt) = makeDefElem("createdb", (Node *)makeInteger(TRUE));
					else if (strcmp((yyvsp[(1) - (1)].str), "nocreatedb") == 0)
						(yyval.defelt) = makeDefElem("createdb", (Node *)makeInteger(FALSE));
					else if (strcmp((yyvsp[(1) - (1)].str), "login") == 0)
						(yyval.defelt) = makeDefElem("canlogin", (Node *)makeInteger(TRUE));
					else if (strcmp((yyvsp[(1) - (1)].str), "nologin") == 0)
						(yyval.defelt) = makeDefElem("canlogin", (Node *)makeInteger(FALSE));
					else if (strcmp((yyvsp[(1) - (1)].str), "noinherit") == 0)
					{
						/*
						 * Note that INHERIT is a keyword, so it's handled by main parser, but
						 * NOINHERIT is handled here.
						 */
						(yyval.defelt) = makeDefElem("inherit", (Node *)makeInteger(FALSE));
					}
					else
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("unrecognized role option \"%s\"", (yyvsp[(1) - (1)].str)),
									 parser_errposition((yylsp[(1) - (1)]))));
				}
    break;

  case 138:
/* Line 1787 of yacc.c  */
#line 962 "gram.y"
    { (yyval.defelt) = (yyvsp[(1) - (1)].defelt); }
    break;

  case 139:
/* Line 1787 of yacc.c  */
#line 965 "gram.y"
    {
					(yyval.defelt) = makeDefElem("sysid", (Node *)makeInteger((yyvsp[(2) - (2)].ival)));
				}
    break;

  case 140:
/* Line 1787 of yacc.c  */
#line 969 "gram.y"
    {
					(yyval.defelt) = makeDefElem("adminmembers", (Node *)(yyvsp[(2) - (2)].list));
				}
    break;

  case 141:
/* Line 1787 of yacc.c  */
#line 973 "gram.y"
    {
					(yyval.defelt) = makeDefElem("rolemembers", (Node *)(yyvsp[(2) - (2)].list));
				}
    break;

  case 142:
/* Line 1787 of yacc.c  */
#line 977 "gram.y"
    {
					(yyval.defelt) = makeDefElem("addroleto", (Node *)(yyvsp[(3) - (3)].list));
				}
    break;

  case 143:
/* Line 1787 of yacc.c  */
#line 981 "gram.y"
    {
					(yyval.defelt) = makeDefElem("addroleto", (Node *)(yyvsp[(3) - (3)].list));
				}
    break;

  case 144:
/* Line 1787 of yacc.c  */
#line 995 "gram.y"
    {
					CreateRoleStmt *n = makeNode(CreateRoleStmt);
					n->stmt_type = ROLESTMT_USER;
					n->role = (yyvsp[(3) - (5)].str);
					n->options = (yyvsp[(5) - (5)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 145:
/* Line 1787 of yacc.c  */
#line 1013 "gram.y"
    {
					AlterRoleStmt *n = makeNode(AlterRoleStmt);
					n->role = (yyvsp[(3) - (5)].str);
					n->action = +1;	/* add, if there are members */
					n->options = (yyvsp[(5) - (5)].list);
					(yyval.node) = (Node *)n;
				 }
    break;

  case 146:
/* Line 1787 of yacc.c  */
#line 1023 "gram.y"
    { (yyval.str) = NULL; }
    break;

  case 147:
/* Line 1787 of yacc.c  */
#line 1024 "gram.y"
    { (yyval.str) = (yyvsp[(3) - (3)].str); }
    break;

  case 148:
/* Line 1787 of yacc.c  */
#line 1029 "gram.y"
    {
					AlterRoleSetStmt *n = makeNode(AlterRoleSetStmt);
					n->role = (yyvsp[(3) - (5)].str);
					n->database = (yyvsp[(4) - (5)].str);
					n->setstmt = (yyvsp[(5) - (5)].vsetstmt);
					(yyval.node) = (Node *)n;
				}
    break;

  case 149:
/* Line 1787 of yacc.c  */
#line 1037 "gram.y"
    {
					AlterRoleSetStmt *n = makeNode(AlterRoleSetStmt);
					n->role = NULL;
					n->database = (yyvsp[(4) - (5)].str);
					n->setstmt = (yyvsp[(5) - (5)].vsetstmt);
					(yyval.node) = (Node *)n;
				}
    break;

  case 150:
/* Line 1787 of yacc.c  */
#line 1055 "gram.y"
    {
					AlterRoleStmt *n = makeNode(AlterRoleStmt);
					n->role = (yyvsp[(3) - (5)].str);
					n->action = +1;	/* add, if there are members */
					n->options = (yyvsp[(5) - (5)].list);
					(yyval.node) = (Node *)n;
				 }
    break;

  case 151:
/* Line 1787 of yacc.c  */
#line 1067 "gram.y"
    {
					AlterRoleSetStmt *n = makeNode(AlterRoleSetStmt);
					n->role = (yyvsp[(3) - (4)].str);
					n->database = NULL;
					n->setstmt = (yyvsp[(4) - (4)].vsetstmt);
					(yyval.node) = (Node *)n;
				}
    break;

  case 152:
/* Line 1787 of yacc.c  */
#line 1088 "gram.y"
    {
					DropRoleStmt *n = makeNode(DropRoleStmt);
					n->missing_ok = FALSE;
					n->roles = (yyvsp[(3) - (3)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 153:
/* Line 1787 of yacc.c  */
#line 1095 "gram.y"
    {
					DropRoleStmt *n = makeNode(DropRoleStmt);
					n->missing_ok = TRUE;
					n->roles = (yyvsp[(5) - (5)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 154:
/* Line 1787 of yacc.c  */
#line 1114 "gram.y"
    {
					DropRoleStmt *n = makeNode(DropRoleStmt);
					n->missing_ok = FALSE;
					n->roles = (yyvsp[(3) - (3)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 155:
/* Line 1787 of yacc.c  */
#line 1121 "gram.y"
    {
					DropRoleStmt *n = makeNode(DropRoleStmt);
					n->roles = (yyvsp[(5) - (5)].list);
					n->missing_ok = TRUE;
					(yyval.node) = (Node *)n;
				}
    break;

  case 156:
/* Line 1787 of yacc.c  */
#line 1138 "gram.y"
    {
					CreateRoleStmt *n = makeNode(CreateRoleStmt);
					n->stmt_type = ROLESTMT_GROUP;
					n->role = (yyvsp[(3) - (5)].str);
					n->options = (yyvsp[(5) - (5)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 157:
/* Line 1787 of yacc.c  */
#line 1156 "gram.y"
    {
					AlterRoleStmt *n = makeNode(AlterRoleStmt);
					n->role = (yyvsp[(3) - (6)].str);
					n->action = (yyvsp[(4) - (6)].ival);
					n->options = list_make1(makeDefElem("rolemembers",
														(Node *)(yyvsp[(6) - (6)].list)));
					(yyval.node) = (Node *)n;
				}
    break;

  case 158:
/* Line 1787 of yacc.c  */
#line 1166 "gram.y"
    { (yyval.ival) = +1; }
    break;

  case 159:
/* Line 1787 of yacc.c  */
#line 1167 "gram.y"
    { (yyval.ival) = -1; }
    break;

  case 160:
/* Line 1787 of yacc.c  */
#line 1180 "gram.y"
    {
					DropRoleStmt *n = makeNode(DropRoleStmt);
					n->missing_ok = FALSE;
					n->roles = (yyvsp[(3) - (3)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 161:
/* Line 1787 of yacc.c  */
#line 1187 "gram.y"
    {
					DropRoleStmt *n = makeNode(DropRoleStmt);
					n->missing_ok = TRUE;
					n->roles = (yyvsp[(5) - (5)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 162:
/* Line 1787 of yacc.c  */
#line 1204 "gram.y"
    {
					CreateSchemaStmt *n = makeNode(CreateSchemaStmt);
					/* One can omit the schema name or the authorization id. */
					if ((yyvsp[(3) - (6)].str) != NULL)
						n->schemaname = (yyvsp[(3) - (6)].str);
					else
						n->schemaname = (yyvsp[(5) - (6)].str);
					n->authid = (yyvsp[(5) - (6)].str);
					n->schemaElts = (yyvsp[(6) - (6)].list);
					n->if_not_exists = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 163:
/* Line 1787 of yacc.c  */
#line 1217 "gram.y"
    {
					CreateSchemaStmt *n = makeNode(CreateSchemaStmt);
					/* ...but not both */
					n->schemaname = (yyvsp[(3) - (4)].str);
					n->authid = NULL;
					n->schemaElts = (yyvsp[(4) - (4)].list);
					n->if_not_exists = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 164:
/* Line 1787 of yacc.c  */
#line 1227 "gram.y"
    {
					CreateSchemaStmt *n = makeNode(CreateSchemaStmt);
					/* One can omit the schema name or the authorization id. */
					if ((yyvsp[(6) - (9)].str) != NULL)
						n->schemaname = (yyvsp[(6) - (9)].str);
					else
						n->schemaname = (yyvsp[(8) - (9)].str);
					n->authid = (yyvsp[(8) - (9)].str);
					if ((yyvsp[(9) - (9)].list) != NIL)
						ereport(ERROR,
								(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
								 errmsg("CREATE SCHEMA IF NOT EXISTS cannot include schema elements"),
								 parser_errposition((yylsp[(9) - (9)]))));
					n->schemaElts = (yyvsp[(9) - (9)].list);
					n->if_not_exists = true;
					(yyval.node) = (Node *)n;
				}
    break;

  case 165:
/* Line 1787 of yacc.c  */
#line 1245 "gram.y"
    {
					CreateSchemaStmt *n = makeNode(CreateSchemaStmt);
					/* ...but not both */
					n->schemaname = (yyvsp[(6) - (7)].str);
					n->authid = NULL;
					if ((yyvsp[(7) - (7)].list) != NIL)
						ereport(ERROR,
								(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
								 errmsg("CREATE SCHEMA IF NOT EXISTS cannot include schema elements"),
								 parser_errposition((yylsp[(7) - (7)]))));
					n->schemaElts = (yyvsp[(7) - (7)].list);
					n->if_not_exists = true;
					(yyval.node) = (Node *)n;
				}
    break;

  case 166:
/* Line 1787 of yacc.c  */
#line 1262 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); }
    break;

  case 167:
/* Line 1787 of yacc.c  */
#line 1263 "gram.y"
    { (yyval.str) = NULL; }
    break;

  case 168:
/* Line 1787 of yacc.c  */
#line 1268 "gram.y"
    {
					if ((yyloc) < 0)			/* see comments for YYLLOC_DEFAULT */
						(yyloc) = (yylsp[(2) - (2)]);
					(yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].node));
				}
    break;

  case 169:
/* Line 1787 of yacc.c  */
#line 1274 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 176:
/* Line 1787 of yacc.c  */
#line 1302 "gram.y"
    {
					VariableSetStmt *n = (yyvsp[(2) - (2)].vsetstmt);
					n->is_local = false;
					(yyval.node) = (Node *) n;
				}
    break;

  case 177:
/* Line 1787 of yacc.c  */
#line 1308 "gram.y"
    {
					VariableSetStmt *n = (yyvsp[(3) - (3)].vsetstmt);
					n->is_local = true;
					(yyval.node) = (Node *) n;
				}
    break;

  case 178:
/* Line 1787 of yacc.c  */
#line 1314 "gram.y"
    {
					VariableSetStmt *n = (yyvsp[(3) - (3)].vsetstmt);
					n->is_local = false;
					(yyval.node) = (Node *) n;
				}
    break;

  case 179:
/* Line 1787 of yacc.c  */
#line 1323 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_MULTI;
					n->name = "TRANSACTION";
					n->args = (yyvsp[(2) - (2)].list);
					(yyval.vsetstmt) = n;
				}
    break;

  case 180:
/* Line 1787 of yacc.c  */
#line 1331 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_MULTI;
					n->name = "SESSION CHARACTERISTICS";
					n->args = (yyvsp[(5) - (5)].list);
					(yyval.vsetstmt) = n;
				}
    break;

  case 182:
/* Line 1787 of yacc.c  */
#line 1343 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_VALUE;
					n->name = (yyvsp[(1) - (3)].str);
					n->args = (yyvsp[(3) - (3)].list);
					(yyval.vsetstmt) = n;
				}
    break;

  case 183:
/* Line 1787 of yacc.c  */
#line 1351 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_VALUE;
					n->name = (yyvsp[(1) - (3)].str);
					n->args = (yyvsp[(3) - (3)].list);
					(yyval.vsetstmt) = n;
				}
    break;

  case 184:
/* Line 1787 of yacc.c  */
#line 1359 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_DEFAULT;
					n->name = (yyvsp[(1) - (3)].str);
					(yyval.vsetstmt) = n;
				}
    break;

  case 185:
/* Line 1787 of yacc.c  */
#line 1366 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_DEFAULT;
					n->name = (yyvsp[(1) - (3)].str);
					(yyval.vsetstmt) = n;
				}
    break;

  case 186:
/* Line 1787 of yacc.c  */
#line 1374 "gram.y"
    {(yyval.vsetstmt) = (yyvsp[(1) - (1)].vsetstmt);}
    break;

  case 187:
/* Line 1787 of yacc.c  */
#line 1376 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_CURRENT;
					n->name = (yyvsp[(1) - (3)].str);
					(yyval.vsetstmt) = n;
				}
    break;

  case 188:
/* Line 1787 of yacc.c  */
#line 1384 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_VALUE;
					n->name = "timezone";
					if ((yyvsp[(3) - (3)].node) != NULL)
						n->args = list_make1((yyvsp[(3) - (3)].node));
					else
						n->kind = VAR_SET_DEFAULT;
					(yyval.vsetstmt) = n;
				}
    break;

  case 189:
/* Line 1787 of yacc.c  */
#line 1395 "gram.y"
    {
					ereport(ERROR,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("current database cannot be changed"),
							 parser_errposition((yylsp[(2) - (2)]))));
					(yyval.vsetstmt) = NULL; /*not reached*/
				}
    break;

  case 190:
/* Line 1787 of yacc.c  */
#line 1403 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_VALUE;
					n->name = "search_path";
					n->args = list_make1(makeStringConst((yyvsp[(2) - (2)].str), (yylsp[(2) - (2)])));
					(yyval.vsetstmt) = n;
				}
    break;

  case 191:
/* Line 1787 of yacc.c  */
#line 1411 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_VALUE;
					n->name = "client_encoding";
					if ((yyvsp[(2) - (2)].str) != NULL)
						n->args = list_make1(makeStringConst((yyvsp[(2) - (2)].str), (yylsp[(2) - (2)])));
					else
						n->kind = VAR_SET_DEFAULT;
					(yyval.vsetstmt) = n;
				}
    break;

  case 192:
/* Line 1787 of yacc.c  */
#line 1422 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_VALUE;
					n->name = "role";
					n->args = list_make1(makeStringConst((yyvsp[(2) - (2)].str), (yylsp[(2) - (2)])));
					(yyval.vsetstmt) = n;
				}
    break;

  case 193:
/* Line 1787 of yacc.c  */
#line 1430 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_VALUE;
					n->name = "session_authorization";
					n->args = list_make1(makeStringConst((yyvsp[(3) - (3)].str), (yylsp[(3) - (3)])));
					(yyval.vsetstmt) = n;
				}
    break;

  case 194:
/* Line 1787 of yacc.c  */
#line 1438 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_DEFAULT;
					n->name = "session_authorization";
					(yyval.vsetstmt) = n;
				}
    break;

  case 195:
/* Line 1787 of yacc.c  */
#line 1445 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_VALUE;
					n->name = "xmloption";
					n->args = list_make1(makeStringConst((yyvsp[(3) - (3)].ival) == XMLOPTION_DOCUMENT ? "DOCUMENT" : "CONTENT", (yylsp[(3) - (3)])));
					(yyval.vsetstmt) = n;
				}
    break;

  case 196:
/* Line 1787 of yacc.c  */
#line 1454 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_MULTI;
					n->name = "TRANSACTION SNAPSHOT";
					n->args = list_make1(makeStringConst((yyvsp[(3) - (3)].str), (yylsp[(3) - (3)])));
					(yyval.vsetstmt) = n;
				}
    break;

  case 197:
/* Line 1787 of yacc.c  */
#line 1463 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); }
    break;

  case 198:
/* Line 1787 of yacc.c  */
#line 1465 "gram.y"
    { (yyval.str) = psprintf("%s.%s", (yyvsp[(1) - (3)].str), (yyvsp[(3) - (3)].str)); }
    break;

  case 199:
/* Line 1787 of yacc.c  */
#line 1468 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].node)); }
    break;

  case 200:
/* Line 1787 of yacc.c  */
#line 1469 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node)); }
    break;

  case 201:
/* Line 1787 of yacc.c  */
#line 1473 "gram.y"
    { (yyval.node) = makeStringConst((yyvsp[(1) - (1)].str), (yylsp[(1) - (1)])); }
    break;

  case 202:
/* Line 1787 of yacc.c  */
#line 1475 "gram.y"
    { (yyval.node) = makeAConst((yyvsp[(1) - (1)].value), (yylsp[(1) - (1)])); }
    break;

  case 203:
/* Line 1787 of yacc.c  */
#line 1478 "gram.y"
    { (yyval.str) = "read uncommitted"; }
    break;

  case 204:
/* Line 1787 of yacc.c  */
#line 1479 "gram.y"
    { (yyval.str) = "read committed"; }
    break;

  case 205:
/* Line 1787 of yacc.c  */
#line 1480 "gram.y"
    { (yyval.str) = "repeatable read"; }
    break;

  case 206:
/* Line 1787 of yacc.c  */
#line 1481 "gram.y"
    { (yyval.str) = "serializable"; }
    break;

  case 207:
/* Line 1787 of yacc.c  */
#line 1485 "gram.y"
    { (yyval.str) = "true"; }
    break;

  case 208:
/* Line 1787 of yacc.c  */
#line 1486 "gram.y"
    { (yyval.str) = "false"; }
    break;

  case 209:
/* Line 1787 of yacc.c  */
#line 1487 "gram.y"
    { (yyval.str) = "on"; }
    break;

  case 210:
/* Line 1787 of yacc.c  */
#line 1493 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); }
    break;

  case 211:
/* Line 1787 of yacc.c  */
#line 1506 "gram.y"
    {
					(yyval.node) = makeStringConst((yyvsp[(1) - (1)].str), (yylsp[(1) - (1)]));
				}
    break;

  case 212:
/* Line 1787 of yacc.c  */
#line 1510 "gram.y"
    {
					(yyval.node) = makeStringConst((yyvsp[(1) - (1)].str), (yylsp[(1) - (1)]));
				}
    break;

  case 213:
/* Line 1787 of yacc.c  */
#line 1514 "gram.y"
    {
					TypeName *t = (yyvsp[(1) - (3)].typnam);
					if ((yyvsp[(3) - (3)].list) != NIL)
					{
						A_Const *n = (A_Const *) linitial((yyvsp[(3) - (3)].list));
						if ((n->val.val.ival & ~(INTERVAL_MASK(HOUR) | INTERVAL_MASK(MINUTE))) != 0)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("time zone interval must be HOUR or HOUR TO MINUTE"),
									 parser_errposition((yylsp[(3) - (3)]))));
					}
					t->typmods = (yyvsp[(3) - (3)].list);
					(yyval.node) = makeStringConstCast((yyvsp[(2) - (3)].str), (yylsp[(2) - (3)]), t);
				}
    break;

  case 214:
/* Line 1787 of yacc.c  */
#line 1529 "gram.y"
    {
					TypeName *t = (yyvsp[(1) - (6)].typnam);
					if ((yyvsp[(6) - (6)].list) != NIL)
					{
						A_Const *n = (A_Const *) linitial((yyvsp[(6) - (6)].list));
						if ((n->val.val.ival & ~(INTERVAL_MASK(HOUR) | INTERVAL_MASK(MINUTE))) != 0)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("time zone interval must be HOUR or HOUR TO MINUTE"),
									 parser_errposition((yylsp[(6) - (6)]))));
						if (list_length((yyvsp[(6) - (6)].list)) != 1)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("interval precision specified twice"),
									 parser_errposition((yylsp[(1) - (6)]))));
						t->typmods = lappend((yyvsp[(6) - (6)].list), makeIntConst((yyvsp[(3) - (6)].ival), (yylsp[(3) - (6)])));
					}
					else
						t->typmods = list_make2(makeIntConst(INTERVAL_FULL_RANGE, -1),
												makeIntConst((yyvsp[(3) - (6)].ival), (yylsp[(3) - (6)])));
					(yyval.node) = makeStringConstCast((yyvsp[(5) - (6)].str), (yylsp[(5) - (6)]), t);
				}
    break;

  case 215:
/* Line 1787 of yacc.c  */
#line 1551 "gram.y"
    { (yyval.node) = makeAConst((yyvsp[(1) - (1)].value), (yylsp[(1) - (1)])); }
    break;

  case 216:
/* Line 1787 of yacc.c  */
#line 1552 "gram.y"
    { (yyval.node) = NULL; }
    break;

  case 217:
/* Line 1787 of yacc.c  */
#line 1553 "gram.y"
    { (yyval.node) = NULL; }
    break;

  case 218:
/* Line 1787 of yacc.c  */
#line 1557 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); }
    break;

  case 219:
/* Line 1787 of yacc.c  */
#line 1558 "gram.y"
    { (yyval.str) = NULL; }
    break;

  case 220:
/* Line 1787 of yacc.c  */
#line 1559 "gram.y"
    { (yyval.str) = NULL; }
    break;

  case 221:
/* Line 1787 of yacc.c  */
#line 1563 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); }
    break;

  case 222:
/* Line 1787 of yacc.c  */
#line 1564 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); }
    break;

  case 223:
/* Line 1787 of yacc.c  */
#line 1568 "gram.y"
    { (yyval.node) = (Node *) (yyvsp[(2) - (2)].vsetstmt); }
    break;

  case 224:
/* Line 1787 of yacc.c  */
#line 1572 "gram.y"
    { (yyval.vsetstmt) = (yyvsp[(1) - (1)].vsetstmt); }
    break;

  case 225:
/* Line 1787 of yacc.c  */
#line 1574 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_RESET;
					n->name = "timezone";
					(yyval.vsetstmt) = n;
				}
    break;

  case 226:
/* Line 1787 of yacc.c  */
#line 1581 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_RESET;
					n->name = "transaction_isolation";
					(yyval.vsetstmt) = n;
				}
    break;

  case 227:
/* Line 1787 of yacc.c  */
#line 1588 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_RESET;
					n->name = "session_authorization";
					(yyval.vsetstmt) = n;
				}
    break;

  case 228:
/* Line 1787 of yacc.c  */
#line 1598 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_RESET;
					n->name = (yyvsp[(1) - (1)].str);
					(yyval.vsetstmt) = n;
				}
    break;

  case 229:
/* Line 1787 of yacc.c  */
#line 1605 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_RESET_ALL;
					(yyval.vsetstmt) = n;
				}
    break;

  case 230:
/* Line 1787 of yacc.c  */
#line 1614 "gram.y"
    { (yyval.vsetstmt) = (yyvsp[(2) - (2)].vsetstmt); }
    break;

  case 231:
/* Line 1787 of yacc.c  */
#line 1615 "gram.y"
    { (yyval.vsetstmt) = (VariableSetStmt *) (yyvsp[(1) - (1)].node); }
    break;

  case 232:
/* Line 1787 of yacc.c  */
#line 1620 "gram.y"
    { (yyval.vsetstmt) = (yyvsp[(2) - (2)].vsetstmt); }
    break;

  case 233:
/* Line 1787 of yacc.c  */
#line 1621 "gram.y"
    { (yyval.vsetstmt) = (VariableSetStmt *) (yyvsp[(1) - (1)].node); }
    break;

  case 234:
/* Line 1787 of yacc.c  */
#line 1627 "gram.y"
    {
					VariableShowStmt *n = makeNode(VariableShowStmt);
					n->name = (yyvsp[(2) - (2)].str);
					(yyval.node) = (Node *) n;
				}
    break;

  case 235:
/* Line 1787 of yacc.c  */
#line 1633 "gram.y"
    {
					VariableShowStmt *n = makeNode(VariableShowStmt);
					n->name = "timezone";
					(yyval.node) = (Node *) n;
				}
    break;

  case 236:
/* Line 1787 of yacc.c  */
#line 1639 "gram.y"
    {
					VariableShowStmt *n = makeNode(VariableShowStmt);
					n->name = "transaction_isolation";
					(yyval.node) = (Node *) n;
				}
    break;

  case 237:
/* Line 1787 of yacc.c  */
#line 1645 "gram.y"
    {
					VariableShowStmt *n = makeNode(VariableShowStmt);
					n->name = "session_authorization";
					(yyval.node) = (Node *) n;
				}
    break;

  case 238:
/* Line 1787 of yacc.c  */
#line 1651 "gram.y"
    {
					VariableShowStmt *n = makeNode(VariableShowStmt);
					n->name = "all";
					(yyval.node) = (Node *) n;
				}
    break;

  case 239:
/* Line 1787 of yacc.c  */
#line 1661 "gram.y"
    {
					ConstraintsSetStmt *n = makeNode(ConstraintsSetStmt);
					n->constraints = (yyvsp[(3) - (4)].list);
					n->deferred = (yyvsp[(4) - (4)].boolean);
					(yyval.node) = (Node *) n;
				}
    break;

  case 240:
/* Line 1787 of yacc.c  */
#line 1670 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 241:
/* Line 1787 of yacc.c  */
#line 1671 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list); }
    break;

  case 242:
/* Line 1787 of yacc.c  */
#line 1675 "gram.y"
    { (yyval.boolean) = TRUE; }
    break;

  case 243:
/* Line 1787 of yacc.c  */
#line 1676 "gram.y"
    { (yyval.boolean) = FALSE; }
    break;

  case 244:
/* Line 1787 of yacc.c  */
#line 1685 "gram.y"
    {
					CheckPointStmt *n = makeNode(CheckPointStmt);
					(yyval.node) = (Node *)n;
				}
    break;

  case 245:
/* Line 1787 of yacc.c  */
#line 1700 "gram.y"
    {
					DiscardStmt *n = makeNode(DiscardStmt);
					n->target = DISCARD_ALL;
					(yyval.node) = (Node *) n;
				}
    break;

  case 246:
/* Line 1787 of yacc.c  */
#line 1706 "gram.y"
    {
					DiscardStmt *n = makeNode(DiscardStmt);
					n->target = DISCARD_TEMP;
					(yyval.node) = (Node *) n;
				}
    break;

  case 247:
/* Line 1787 of yacc.c  */
#line 1712 "gram.y"
    {
					DiscardStmt *n = makeNode(DiscardStmt);
					n->target = DISCARD_TEMP;
					(yyval.node) = (Node *) n;
				}
    break;

  case 248:
/* Line 1787 of yacc.c  */
#line 1718 "gram.y"
    {
					DiscardStmt *n = makeNode(DiscardStmt);
					n->target = DISCARD_PLANS;
					(yyval.node) = (Node *) n;
				}
    break;

  case 249:
/* Line 1787 of yacc.c  */
#line 1724 "gram.y"
    {
					DiscardStmt *n = makeNode(DiscardStmt);
					n->target = DISCARD_SEQUENCES;
					(yyval.node) = (Node *) n;
				}
    break;

  case 250:
/* Line 1787 of yacc.c  */
#line 1743 "gram.y"
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[(3) - (4)].range);
					n->cmds = (yyvsp[(4) - (4)].list);
					n->relkind = OBJECT_TABLE;
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 251:
/* Line 1787 of yacc.c  */
#line 1752 "gram.y"
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[(5) - (6)].range);
					n->cmds = (yyvsp[(6) - (6)].list);
					n->relkind = OBJECT_TABLE;
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
    break;

  case 252:
/* Line 1787 of yacc.c  */
#line 1761 "gram.y"
    {
					AlterTableMoveAllStmt *n =
						makeNode(AlterTableMoveAllStmt);
					n->orig_tablespacename = (yyvsp[(6) - (10)].str);
					n->objtype = OBJECT_TABLE;
					n->roles = NIL;
					n->new_tablespacename = (yyvsp[(9) - (10)].str);
					n->nowait = (yyvsp[(10) - (10)].boolean);
					(yyval.node) = (Node *)n;
				}
    break;

  case 253:
/* Line 1787 of yacc.c  */
#line 1772 "gram.y"
    {
					AlterTableMoveAllStmt *n =
						makeNode(AlterTableMoveAllStmt);
					n->orig_tablespacename = (yyvsp[(6) - (13)].str);
					n->objtype = OBJECT_TABLE;
					n->roles = (yyvsp[(9) - (13)].list);
					n->new_tablespacename = (yyvsp[(12) - (13)].str);
					n->nowait = (yyvsp[(13) - (13)].boolean);
					(yyval.node) = (Node *)n;
				}
    break;

  case 254:
/* Line 1787 of yacc.c  */
#line 1783 "gram.y"
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[(3) - (4)].range);
					n->cmds = (yyvsp[(4) - (4)].list);
					n->relkind = OBJECT_INDEX;
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 255:
/* Line 1787 of yacc.c  */
#line 1792 "gram.y"
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[(5) - (6)].range);
					n->cmds = (yyvsp[(6) - (6)].list);
					n->relkind = OBJECT_INDEX;
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
    break;

  case 256:
/* Line 1787 of yacc.c  */
#line 1801 "gram.y"
    {
					AlterTableMoveAllStmt *n =
						makeNode(AlterTableMoveAllStmt);
					n->orig_tablespacename = (yyvsp[(6) - (10)].str);
					n->objtype = OBJECT_INDEX;
					n->roles = NIL;
					n->new_tablespacename = (yyvsp[(9) - (10)].str);
					n->nowait = (yyvsp[(10) - (10)].boolean);
					(yyval.node) = (Node *)n;
				}
    break;

  case 257:
/* Line 1787 of yacc.c  */
#line 1812 "gram.y"
    {
					AlterTableMoveAllStmt *n =
						makeNode(AlterTableMoveAllStmt);
					n->orig_tablespacename = (yyvsp[(6) - (13)].str);
					n->objtype = OBJECT_INDEX;
					n->roles = (yyvsp[(9) - (13)].list);
					n->new_tablespacename = (yyvsp[(12) - (13)].str);
					n->nowait = (yyvsp[(13) - (13)].boolean);
					(yyval.node) = (Node *)n;
				}
    break;

  case 258:
/* Line 1787 of yacc.c  */
#line 1823 "gram.y"
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[(3) - (4)].range);
					n->cmds = (yyvsp[(4) - (4)].list);
					n->relkind = OBJECT_SEQUENCE;
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 259:
/* Line 1787 of yacc.c  */
#line 1832 "gram.y"
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[(5) - (6)].range);
					n->cmds = (yyvsp[(6) - (6)].list);
					n->relkind = OBJECT_SEQUENCE;
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
    break;

  case 260:
/* Line 1787 of yacc.c  */
#line 1841 "gram.y"
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[(3) - (4)].range);
					n->cmds = (yyvsp[(4) - (4)].list);
					n->relkind = OBJECT_VIEW;
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 261:
/* Line 1787 of yacc.c  */
#line 1850 "gram.y"
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[(5) - (6)].range);
					n->cmds = (yyvsp[(6) - (6)].list);
					n->relkind = OBJECT_VIEW;
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
    break;

  case 262:
/* Line 1787 of yacc.c  */
#line 1859 "gram.y"
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[(4) - (5)].range);
					n->cmds = (yyvsp[(5) - (5)].list);
					n->relkind = OBJECT_MATVIEW;
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 263:
/* Line 1787 of yacc.c  */
#line 1868 "gram.y"
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[(6) - (7)].range);
					n->cmds = (yyvsp[(7) - (7)].list);
					n->relkind = OBJECT_MATVIEW;
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
    break;

  case 264:
/* Line 1787 of yacc.c  */
#line 1877 "gram.y"
    {
					AlterTableMoveAllStmt *n =
						makeNode(AlterTableMoveAllStmt);
					n->orig_tablespacename = (yyvsp[(7) - (11)].str);
					n->objtype = OBJECT_MATVIEW;
					n->roles = NIL;
					n->new_tablespacename = (yyvsp[(10) - (11)].str);
					n->nowait = (yyvsp[(11) - (11)].boolean);
					(yyval.node) = (Node *)n;
				}
    break;

  case 265:
/* Line 1787 of yacc.c  */
#line 1888 "gram.y"
    {
					AlterTableMoveAllStmt *n =
						makeNode(AlterTableMoveAllStmt);
					n->orig_tablespacename = (yyvsp[(7) - (14)].str);
					n->objtype = OBJECT_MATVIEW;
					n->roles = (yyvsp[(10) - (14)].list);
					n->new_tablespacename = (yyvsp[(13) - (14)].str);
					n->nowait = (yyvsp[(14) - (14)].boolean);
					(yyval.node) = (Node *)n;
				}
    break;

  case 266:
/* Line 1787 of yacc.c  */
#line 1901 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].node)); }
    break;

  case 267:
/* Line 1787 of yacc.c  */
#line 1902 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node)); }
    break;

  case 268:
/* Line 1787 of yacc.c  */
#line 1908 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_AddColumn;
					n->def = (yyvsp[(2) - (2)].node);
					(yyval.node) = (Node *)n;
				}
    break;

  case 269:
/* Line 1787 of yacc.c  */
#line 1916 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_AddColumn;
					n->def = (yyvsp[(3) - (3)].node);
					(yyval.node) = (Node *)n;
				}
    break;

  case 270:
/* Line 1787 of yacc.c  */
#line 1924 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_ColumnDefault;
					n->name = (yyvsp[(3) - (4)].str);
					n->def = (yyvsp[(4) - (4)].node);
					(yyval.node) = (Node *)n;
				}
    break;

  case 271:
/* Line 1787 of yacc.c  */
#line 1933 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropNotNull;
					n->name = (yyvsp[(3) - (6)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 272:
/* Line 1787 of yacc.c  */
#line 1941 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_SetNotNull;
					n->name = (yyvsp[(3) - (6)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 273:
/* Line 1787 of yacc.c  */
#line 1949 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_SetStatistics;
					n->name = (yyvsp[(3) - (6)].str);
					n->def = (Node *) makeInteger((yyvsp[(6) - (6)].ival));
					(yyval.node) = (Node *)n;
				}
    break;

  case 274:
/* Line 1787 of yacc.c  */
#line 1958 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_SetOptions;
					n->name = (yyvsp[(3) - (5)].str);
					n->def = (Node *) (yyvsp[(5) - (5)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 275:
/* Line 1787 of yacc.c  */
#line 1967 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_ResetOptions;
					n->name = (yyvsp[(3) - (5)].str);
					n->def = (Node *) (yyvsp[(5) - (5)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 276:
/* Line 1787 of yacc.c  */
#line 1976 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_SetStorage;
					n->name = (yyvsp[(3) - (6)].str);
					n->def = (Node *) makeString((yyvsp[(6) - (6)].str));
					(yyval.node) = (Node *)n;
				}
    break;

  case 277:
/* Line 1787 of yacc.c  */
#line 1985 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropColumn;
					n->name = (yyvsp[(5) - (6)].str);
					n->behavior = (yyvsp[(6) - (6)].dbehavior);
					n->missing_ok = TRUE;
					(yyval.node) = (Node *)n;
				}
    break;

  case 278:
/* Line 1787 of yacc.c  */
#line 1995 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropColumn;
					n->name = (yyvsp[(3) - (4)].str);
					n->behavior = (yyvsp[(4) - (4)].dbehavior);
					n->missing_ok = FALSE;
					(yyval.node) = (Node *)n;
				}
    break;

  case 279:
/* Line 1787 of yacc.c  */
#line 2008 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					ColumnDef *def = makeNode(ColumnDef);
					n->subtype = AT_AlterColumnType;
					n->name = (yyvsp[(3) - (8)].str);
					n->def = (Node *) def;
					/* We only use these fields of the ColumnDef node */
					def->typeName = (yyvsp[(6) - (8)].typnam);
					def->collClause = (CollateClause *) (yyvsp[(7) - (8)].node);
					def->raw_default = (yyvsp[(8) - (8)].node);
					def->location = (yylsp[(3) - (8)]);
					(yyval.node) = (Node *)n;
				}
    break;

  case 280:
/* Line 1787 of yacc.c  */
#line 2023 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_AlterColumnGenericOptions;
					n->name = (yyvsp[(3) - (4)].str);
					n->def = (Node *) (yyvsp[(4) - (4)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 281:
/* Line 1787 of yacc.c  */
#line 2032 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_AddConstraint;
					n->def = (yyvsp[(2) - (2)].node);
					(yyval.node) = (Node *)n;
				}
    break;

  case 282:
/* Line 1787 of yacc.c  */
#line 2040 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					Constraint *c = makeNode(Constraint);
					n->subtype = AT_AlterConstraint;
					n->def = (Node *) c;
					c->contype = CONSTR_FOREIGN; /* others not supported, yet */
					c->conname = (yyvsp[(3) - (4)].str);
					processCASbits((yyvsp[(4) - (4)].ival), (yylsp[(4) - (4)]), "ALTER CONSTRAINT statement",
									&c->deferrable,
									&c->initdeferred,
									NULL, NULL, yyscanner);
					(yyval.node) = (Node *)n;
				}
    break;

  case 283:
/* Line 1787 of yacc.c  */
#line 2055 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_ValidateConstraint;
					n->name = (yyvsp[(3) - (3)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 284:
/* Line 1787 of yacc.c  */
#line 2063 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropConstraint;
					n->name = (yyvsp[(5) - (6)].str);
					n->behavior = (yyvsp[(6) - (6)].dbehavior);
					n->missing_ok = TRUE;
					(yyval.node) = (Node *)n;
				}
    break;

  case 285:
/* Line 1787 of yacc.c  */
#line 2073 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropConstraint;
					n->name = (yyvsp[(3) - (4)].str);
					n->behavior = (yyvsp[(4) - (4)].dbehavior);
					n->missing_ok = FALSE;
					(yyval.node) = (Node *)n;
				}
    break;

  case 286:
/* Line 1787 of yacc.c  */
#line 2083 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_AddOids;
					(yyval.node) = (Node *)n;
				}
    break;

  case 287:
/* Line 1787 of yacc.c  */
#line 2090 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropOids;
					(yyval.node) = (Node *)n;
				}
    break;

  case 288:
/* Line 1787 of yacc.c  */
#line 2097 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_ClusterOn;
					n->name = (yyvsp[(3) - (3)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 289:
/* Line 1787 of yacc.c  */
#line 2105 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropCluster;
					n->name = NULL;
					(yyval.node) = (Node *)n;
				}
    break;

  case 290:
/* Line 1787 of yacc.c  */
#line 2113 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_EnableTrig;
					n->name = (yyvsp[(3) - (3)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 291:
/* Line 1787 of yacc.c  */
#line 2121 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_EnableAlwaysTrig;
					n->name = (yyvsp[(4) - (4)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 292:
/* Line 1787 of yacc.c  */
#line 2129 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_EnableReplicaTrig;
					n->name = (yyvsp[(4) - (4)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 293:
/* Line 1787 of yacc.c  */
#line 2137 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_EnableTrigAll;
					(yyval.node) = (Node *)n;
				}
    break;

  case 294:
/* Line 1787 of yacc.c  */
#line 2144 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_EnableTrigUser;
					(yyval.node) = (Node *)n;
				}
    break;

  case 295:
/* Line 1787 of yacc.c  */
#line 2151 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DisableTrig;
					n->name = (yyvsp[(3) - (3)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 296:
/* Line 1787 of yacc.c  */
#line 2159 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DisableTrigAll;
					(yyval.node) = (Node *)n;
				}
    break;

  case 297:
/* Line 1787 of yacc.c  */
#line 2166 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DisableTrigUser;
					(yyval.node) = (Node *)n;
				}
    break;

  case 298:
/* Line 1787 of yacc.c  */
#line 2173 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_EnableRule;
					n->name = (yyvsp[(3) - (3)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 299:
/* Line 1787 of yacc.c  */
#line 2181 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_EnableAlwaysRule;
					n->name = (yyvsp[(4) - (4)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 300:
/* Line 1787 of yacc.c  */
#line 2189 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_EnableReplicaRule;
					n->name = (yyvsp[(4) - (4)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 301:
/* Line 1787 of yacc.c  */
#line 2197 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DisableRule;
					n->name = (yyvsp[(3) - (3)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 302:
/* Line 1787 of yacc.c  */
#line 2205 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_AddInherit;
					n->def = (Node *) (yyvsp[(2) - (2)].range);
					(yyval.node) = (Node *)n;
				}
    break;

  case 303:
/* Line 1787 of yacc.c  */
#line 2213 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropInherit;
					n->def = (Node *) (yyvsp[(3) - (3)].range);
					(yyval.node) = (Node *)n;
				}
    break;

  case 304:
/* Line 1787 of yacc.c  */
#line 2221 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					TypeName *def = makeTypeNameFromNameList((yyvsp[(2) - (2)].list));
					def->location = (yylsp[(2) - (2)]);
					n->subtype = AT_AddOf;
					n->def = (Node *) def;
					(yyval.node) = (Node *)n;
				}
    break;

  case 305:
/* Line 1787 of yacc.c  */
#line 2231 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropOf;
					(yyval.node) = (Node *)n;
				}
    break;

  case 306:
/* Line 1787 of yacc.c  */
#line 2238 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_ChangeOwner;
					n->name = (yyvsp[(3) - (3)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 307:
/* Line 1787 of yacc.c  */
#line 2246 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_SetTableSpace;
					n->name = (yyvsp[(3) - (3)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 308:
/* Line 1787 of yacc.c  */
#line 2254 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_SetRelOptions;
					n->def = (Node *)(yyvsp[(2) - (2)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 309:
/* Line 1787 of yacc.c  */
#line 2262 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_ResetRelOptions;
					n->def = (Node *)(yyvsp[(2) - (2)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 310:
/* Line 1787 of yacc.c  */
#line 2270 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_ReplicaIdentity;
					n->def = (yyvsp[(3) - (3)].node);
					(yyval.node) = (Node *)n;
				}
    break;

  case 311:
/* Line 1787 of yacc.c  */
#line 2277 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_GenericOptions;
					n->def = (Node *)(yyvsp[(1) - (1)].list);
					(yyval.node) = (Node *) n;
				}
    break;

  case 312:
/* Line 1787 of yacc.c  */
#line 2286 "gram.y"
    { (yyval.node) = (yyvsp[(3) - (3)].node); }
    break;

  case 313:
/* Line 1787 of yacc.c  */
#line 2287 "gram.y"
    { (yyval.node) = NULL; }
    break;

  case 314:
/* Line 1787 of yacc.c  */
#line 2291 "gram.y"
    { (yyval.dbehavior) = DROP_CASCADE; }
    break;

  case 315:
/* Line 1787 of yacc.c  */
#line 2292 "gram.y"
    { (yyval.dbehavior) = DROP_RESTRICT; }
    break;

  case 316:
/* Line 1787 of yacc.c  */
#line 2293 "gram.y"
    { (yyval.dbehavior) = DROP_RESTRICT; /* default */ }
    break;

  case 317:
/* Line 1787 of yacc.c  */
#line 2298 "gram.y"
    {
					CollateClause *n = makeNode(CollateClause);
					n->arg = NULL;
					n->collname = (yyvsp[(2) - (2)].list);
					n->location = (yylsp[(1) - (2)]);
					(yyval.node) = (Node *) n;
				}
    break;

  case 318:
/* Line 1787 of yacc.c  */
#line 2305 "gram.y"
    { (yyval.node) = NULL; }
    break;

  case 319:
/* Line 1787 of yacc.c  */
#line 2309 "gram.y"
    { (yyval.node) = (yyvsp[(2) - (2)].node); }
    break;

  case 320:
/* Line 1787 of yacc.c  */
#line 2310 "gram.y"
    { (yyval.node) = NULL; }
    break;

  case 321:
/* Line 1787 of yacc.c  */
#line 2315 "gram.y"
    {
					ReplicaIdentityStmt *n = makeNode(ReplicaIdentityStmt);
					n->identity_type = REPLICA_IDENTITY_NOTHING;
					n->name = NULL;
					(yyval.node) = (Node *) n;
				}
    break;

  case 322:
/* Line 1787 of yacc.c  */
#line 2322 "gram.y"
    {
					ReplicaIdentityStmt *n = makeNode(ReplicaIdentityStmt);
					n->identity_type = REPLICA_IDENTITY_FULL;
					n->name = NULL;
					(yyval.node) = (Node *) n;
				}
    break;

  case 323:
/* Line 1787 of yacc.c  */
#line 2329 "gram.y"
    {
					ReplicaIdentityStmt *n = makeNode(ReplicaIdentityStmt);
					n->identity_type = REPLICA_IDENTITY_DEFAULT;
					n->name = NULL;
					(yyval.node) = (Node *) n;
				}
    break;

  case 324:
/* Line 1787 of yacc.c  */
#line 2336 "gram.y"
    {
					ReplicaIdentityStmt *n = makeNode(ReplicaIdentityStmt);
					n->identity_type = REPLICA_IDENTITY_INDEX;
					n->name = (yyvsp[(3) - (3)].str);
					(yyval.node) = (Node *) n;
				}
    break;

  case 325:
/* Line 1787 of yacc.c  */
#line 2345 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (3)].list); }
    break;

  case 326:
/* Line 1787 of yacc.c  */
#line 2348 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (2)].list); }
    break;

  case 327:
/* Line 1787 of yacc.c  */
#line 2349 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 328:
/* Line 1787 of yacc.c  */
#line 2353 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].defelt)); }
    break;

  case 329:
/* Line 1787 of yacc.c  */
#line 2354 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].defelt)); }
    break;

  case 330:
/* Line 1787 of yacc.c  */
#line 2360 "gram.y"
    {
					(yyval.defelt) = makeDefElem((yyvsp[(1) - (3)].str), (Node *) (yyvsp[(3) - (3)].node));
				}
    break;

  case 331:
/* Line 1787 of yacc.c  */
#line 2364 "gram.y"
    {
					(yyval.defelt) = makeDefElem((yyvsp[(1) - (1)].str), NULL);
				}
    break;

  case 332:
/* Line 1787 of yacc.c  */
#line 2368 "gram.y"
    {
					(yyval.defelt) = makeDefElemExtended((yyvsp[(1) - (5)].str), (yyvsp[(3) - (5)].str), (Node *) (yyvsp[(5) - (5)].node),
											 DEFELEM_UNSPEC);
				}
    break;

  case 333:
/* Line 1787 of yacc.c  */
#line 2373 "gram.y"
    {
					(yyval.defelt) = makeDefElemExtended((yyvsp[(1) - (3)].str), (yyvsp[(3) - (3)].str), NULL, DEFELEM_UNSPEC);
				}
    break;

  case 334:
/* Line 1787 of yacc.c  */
#line 2388 "gram.y"
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);

					/* can't use qualified_name, sigh */
					n->relation = makeRangeVarFromAnyName((yyvsp[(3) - (4)].list), (yylsp[(3) - (4)]), yyscanner);
					n->cmds = (yyvsp[(4) - (4)].list);
					n->relkind = OBJECT_TYPE;
					(yyval.node) = (Node *)n;
				}
    break;

  case 335:
/* Line 1787 of yacc.c  */
#line 2400 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].node)); }
    break;

  case 336:
/* Line 1787 of yacc.c  */
#line 2401 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node)); }
    break;

  case 337:
/* Line 1787 of yacc.c  */
#line 2407 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_AddColumn;
					n->def = (yyvsp[(3) - (4)].node);
					n->behavior = (yyvsp[(4) - (4)].dbehavior);
					(yyval.node) = (Node *)n;
				}
    break;

  case 338:
/* Line 1787 of yacc.c  */
#line 2416 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropColumn;
					n->name = (yyvsp[(5) - (6)].str);
					n->behavior = (yyvsp[(6) - (6)].dbehavior);
					n->missing_ok = TRUE;
					(yyval.node) = (Node *)n;
				}
    break;

  case 339:
/* Line 1787 of yacc.c  */
#line 2426 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropColumn;
					n->name = (yyvsp[(3) - (4)].str);
					n->behavior = (yyvsp[(4) - (4)].dbehavior);
					n->missing_ok = FALSE;
					(yyval.node) = (Node *)n;
				}
    break;

  case 340:
/* Line 1787 of yacc.c  */
#line 2436 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					ColumnDef *def = makeNode(ColumnDef);
					n->subtype = AT_AlterColumnType;
					n->name = (yyvsp[(3) - (8)].str);
					n->def = (Node *) def;
					n->behavior = (yyvsp[(8) - (8)].dbehavior);
					/* We only use these fields of the ColumnDef node */
					def->typeName = (yyvsp[(6) - (8)].typnam);
					def->collClause = (CollateClause *) (yyvsp[(7) - (8)].node);
					def->raw_default = NULL;
					def->location = (yylsp[(3) - (8)]);
					(yyval.node) = (Node *)n;
				}
    break;

  case 341:
/* Line 1787 of yacc.c  */
#line 2462 "gram.y"
    {
					ClosePortalStmt *n = makeNode(ClosePortalStmt);
					n->portalname = (yyvsp[(2) - (2)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 342:
/* Line 1787 of yacc.c  */
#line 2468 "gram.y"
    {
					ClosePortalStmt *n = makeNode(ClosePortalStmt);
					n->portalname = NULL;
					(yyval.node) = (Node *)n;
				}
    break;

  case 343:
/* Line 1787 of yacc.c  */
#line 2499 "gram.y"
    {
					CopyStmt *n = makeNode(CopyStmt);
					n->relation = (yyvsp[(3) - (11)].range);
					n->query = NULL;
					n->attlist = (yyvsp[(4) - (11)].list);
					n->is_from = (yyvsp[(6) - (11)].boolean);
					n->is_program = (yyvsp[(7) - (11)].boolean);
					n->filename = (yyvsp[(8) - (11)].str);

					if (n->is_program && n->filename == NULL)
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("STDIN/STDOUT not allowed with PROGRAM"),
								 parser_errposition((yylsp[(8) - (11)]))));

					n->options = NIL;
					/* Concatenate user-supplied flags */
					if ((yyvsp[(2) - (11)].defelt))
						n->options = lappend(n->options, (yyvsp[(2) - (11)].defelt));
					if ((yyvsp[(5) - (11)].defelt))
						n->options = lappend(n->options, (yyvsp[(5) - (11)].defelt));
					if ((yyvsp[(9) - (11)].defelt))
						n->options = lappend(n->options, (yyvsp[(9) - (11)].defelt));
					if ((yyvsp[(11) - (11)].list))
						n->options = list_concat(n->options, (yyvsp[(11) - (11)].list));
					(yyval.node) = (Node *)n;
				}
    break;

  case 344:
/* Line 1787 of yacc.c  */
#line 2527 "gram.y"
    {
					CopyStmt *n = makeNode(CopyStmt);
					n->relation = NULL;
					n->query = (yyvsp[(2) - (7)].node);
					n->attlist = NIL;
					n->is_from = false;
					n->is_program = (yyvsp[(4) - (7)].boolean);
					n->filename = (yyvsp[(5) - (7)].str);
					n->options = (yyvsp[(7) - (7)].list);

					if (n->is_program && n->filename == NULL)
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("STDIN/STDOUT not allowed with PROGRAM"),
								 parser_errposition((yylsp[(5) - (7)]))));

					(yyval.node) = (Node *)n;
				}
    break;

  case 345:
/* Line 1787 of yacc.c  */
#line 2548 "gram.y"
    { (yyval.boolean) = TRUE; }
    break;

  case 346:
/* Line 1787 of yacc.c  */
#line 2549 "gram.y"
    { (yyval.boolean) = FALSE; }
    break;

  case 347:
/* Line 1787 of yacc.c  */
#line 2553 "gram.y"
    { (yyval.boolean) = TRUE; }
    break;

  case 348:
/* Line 1787 of yacc.c  */
#line 2554 "gram.y"
    { (yyval.boolean) = FALSE; }
    break;

  case 349:
/* Line 1787 of yacc.c  */
#line 2563 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); }
    break;

  case 350:
/* Line 1787 of yacc.c  */
#line 2564 "gram.y"
    { (yyval.str) = NULL; }
    break;

  case 351:
/* Line 1787 of yacc.c  */
#line 2565 "gram.y"
    { (yyval.str) = NULL; }
    break;

  case 352:
/* Line 1787 of yacc.c  */
#line 2568 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list); }
    break;

  case 353:
/* Line 1787 of yacc.c  */
#line 2569 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (3)].list); }
    break;

  case 354:
/* Line 1787 of yacc.c  */
#line 2574 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].defelt)); }
    break;

  case 355:
/* Line 1787 of yacc.c  */
#line 2575 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 356:
/* Line 1787 of yacc.c  */
#line 2580 "gram.y"
    {
					(yyval.defelt) = makeDefElem("format", (Node *)makeString("binary"));
				}
    break;

  case 357:
/* Line 1787 of yacc.c  */
#line 2584 "gram.y"
    {
					(yyval.defelt) = makeDefElem("oids", (Node *)makeInteger(TRUE));
				}
    break;

  case 358:
/* Line 1787 of yacc.c  */
#line 2588 "gram.y"
    {
					(yyval.defelt) = makeDefElem("freeze", (Node *)makeInteger(TRUE));
				}
    break;

  case 359:
/* Line 1787 of yacc.c  */
#line 2592 "gram.y"
    {
					(yyval.defelt) = makeDefElem("delimiter", (Node *)makeString((yyvsp[(3) - (3)].str)));
				}
    break;

  case 360:
/* Line 1787 of yacc.c  */
#line 2596 "gram.y"
    {
					(yyval.defelt) = makeDefElem("null", (Node *)makeString((yyvsp[(3) - (3)].str)));
				}
    break;

  case 361:
/* Line 1787 of yacc.c  */
#line 2600 "gram.y"
    {
					(yyval.defelt) = makeDefElem("format", (Node *)makeString("csv"));
				}
    break;

  case 362:
/* Line 1787 of yacc.c  */
#line 2604 "gram.y"
    {
					(yyval.defelt) = makeDefElem("header", (Node *)makeInteger(TRUE));
				}
    break;

  case 363:
/* Line 1787 of yacc.c  */
#line 2608 "gram.y"
    {
					(yyval.defelt) = makeDefElem("quote", (Node *)makeString((yyvsp[(3) - (3)].str)));
				}
    break;

  case 364:
/* Line 1787 of yacc.c  */
#line 2612 "gram.y"
    {
					(yyval.defelt) = makeDefElem("escape", (Node *)makeString((yyvsp[(3) - (3)].str)));
				}
    break;

  case 365:
/* Line 1787 of yacc.c  */
#line 2616 "gram.y"
    {
					(yyval.defelt) = makeDefElem("force_quote", (Node *)(yyvsp[(3) - (3)].list));
				}
    break;

  case 366:
/* Line 1787 of yacc.c  */
#line 2620 "gram.y"
    {
					(yyval.defelt) = makeDefElem("force_quote", (Node *)makeNode(A_Star));
				}
    break;

  case 367:
/* Line 1787 of yacc.c  */
#line 2624 "gram.y"
    {
					(yyval.defelt) = makeDefElem("force_not_null", (Node *)(yyvsp[(4) - (4)].list));
				}
    break;

  case 368:
/* Line 1787 of yacc.c  */
#line 2628 "gram.y"
    {
					(yyval.defelt) = makeDefElem("force_null", (Node *)(yyvsp[(3) - (3)].list));
				}
    break;

  case 369:
/* Line 1787 of yacc.c  */
#line 2632 "gram.y"
    {
					(yyval.defelt) = makeDefElem("encoding", (Node *)makeString((yyvsp[(2) - (2)].str)));
				}
    break;

  case 370:
/* Line 1787 of yacc.c  */
#line 2641 "gram.y"
    {
					(yyval.defelt) = makeDefElem("format", (Node *)makeString("binary"));
				}
    break;

  case 371:
/* Line 1787 of yacc.c  */
#line 2644 "gram.y"
    { (yyval.defelt) = NULL; }
    break;

  case 372:
/* Line 1787 of yacc.c  */
#line 2649 "gram.y"
    {
					(yyval.defelt) = makeDefElem("oids", (Node *)makeInteger(TRUE));
				}
    break;

  case 373:
/* Line 1787 of yacc.c  */
#line 2652 "gram.y"
    { (yyval.defelt) = NULL; }
    break;

  case 374:
/* Line 1787 of yacc.c  */
#line 2657 "gram.y"
    {
					(yyval.defelt) = makeDefElem("delimiter", (Node *)makeString((yyvsp[(3) - (3)].str)));
				}
    break;

  case 375:
/* Line 1787 of yacc.c  */
#line 2660 "gram.y"
    { (yyval.defelt) = NULL; }
    break;

  case 376:
/* Line 1787 of yacc.c  */
#line 2664 "gram.y"
    {}
    break;

  case 377:
/* Line 1787 of yacc.c  */
#line 2665 "gram.y"
    {}
    break;

  case 378:
/* Line 1787 of yacc.c  */
#line 2671 "gram.y"
    {
					(yyval.list) = list_make1((yyvsp[(1) - (1)].defelt));
				}
    break;

  case 379:
/* Line 1787 of yacc.c  */
#line 2675 "gram.y"
    {
					(yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].defelt));
				}
    break;

  case 380:
/* Line 1787 of yacc.c  */
#line 2682 "gram.y"
    {
					(yyval.defelt) = makeDefElem((yyvsp[(1) - (2)].str), (yyvsp[(2) - (2)].node));
				}
    break;

  case 381:
/* Line 1787 of yacc.c  */
#line 2688 "gram.y"
    { (yyval.node) = (Node *) makeString((yyvsp[(1) - (1)].str)); }
    break;

  case 382:
/* Line 1787 of yacc.c  */
#line 2689 "gram.y"
    { (yyval.node) = (Node *) (yyvsp[(1) - (1)].value); }
    break;

  case 383:
/* Line 1787 of yacc.c  */
#line 2690 "gram.y"
    { (yyval.node) = (Node *) makeNode(A_Star); }
    break;

  case 384:
/* Line 1787 of yacc.c  */
#line 2691 "gram.y"
    { (yyval.node) = (Node *) (yyvsp[(2) - (3)].list); }
    break;

  case 385:
/* Line 1787 of yacc.c  */
#line 2692 "gram.y"
    { (yyval.node) = NULL; }
    break;

  case 386:
/* Line 1787 of yacc.c  */
#line 2697 "gram.y"
    {
					(yyval.list) = list_make1((yyvsp[(1) - (1)].node));
				}
    break;

  case 387:
/* Line 1787 of yacc.c  */
#line 2701 "gram.y"
    {
					(yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node));
				}
    break;

  case 388:
/* Line 1787 of yacc.c  */
#line 2708 "gram.y"
    { (yyval.node) = (Node *) makeString((yyvsp[(1) - (1)].str)); }
    break;

  case 389:
/* Line 1787 of yacc.c  */
#line 2721 "gram.y"
    {
					CreateStmt *n = makeNode(CreateStmt);
					(yyvsp[(4) - (11)].range)->relpersistence = (yyvsp[(2) - (11)].ival);
					n->relation = (yyvsp[(4) - (11)].range);
					n->tableElts = (yyvsp[(6) - (11)].list);
					n->inhRelations = (yyvsp[(8) - (11)].list);
					n->constraints = NIL;
					n->options = (yyvsp[(9) - (11)].list);
					n->oncommit = (yyvsp[(10) - (11)].oncommit);
					n->tablespacename = (yyvsp[(11) - (11)].str);
					n->if_not_exists = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 390:
/* Line 1787 of yacc.c  */
#line 2737 "gram.y"
    {
					CreateStmt *n = makeNode(CreateStmt);
					(yyvsp[(7) - (14)].range)->relpersistence = (yyvsp[(2) - (14)].ival);
					n->relation = (yyvsp[(7) - (14)].range);
					n->tableElts = (yyvsp[(9) - (14)].list);
					n->inhRelations = (yyvsp[(11) - (14)].list);
					n->constraints = NIL;
					n->options = (yyvsp[(12) - (14)].list);
					n->oncommit = (yyvsp[(13) - (14)].oncommit);
					n->tablespacename = (yyvsp[(14) - (14)].str);
					n->if_not_exists = true;
					(yyval.node) = (Node *)n;
				}
    break;

  case 391:
/* Line 1787 of yacc.c  */
#line 2752 "gram.y"
    {
					CreateStmt *n = makeNode(CreateStmt);
					(yyvsp[(4) - (10)].range)->relpersistence = (yyvsp[(2) - (10)].ival);
					n->relation = (yyvsp[(4) - (10)].range);
					n->tableElts = (yyvsp[(7) - (10)].list);
					n->ofTypename = makeTypeNameFromNameList((yyvsp[(6) - (10)].list));
					n->ofTypename->location = (yylsp[(6) - (10)]);
					n->constraints = NIL;
					n->options = (yyvsp[(8) - (10)].list);
					n->oncommit = (yyvsp[(9) - (10)].oncommit);
					n->tablespacename = (yyvsp[(10) - (10)].str);
					n->if_not_exists = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 392:
/* Line 1787 of yacc.c  */
#line 2768 "gram.y"
    {
					CreateStmt *n = makeNode(CreateStmt);
					(yyvsp[(7) - (13)].range)->relpersistence = (yyvsp[(2) - (13)].ival);
					n->relation = (yyvsp[(7) - (13)].range);
					n->tableElts = (yyvsp[(10) - (13)].list);
					n->ofTypename = makeTypeNameFromNameList((yyvsp[(9) - (13)].list));
					n->ofTypename->location = (yylsp[(9) - (13)]);
					n->constraints = NIL;
					n->options = (yyvsp[(11) - (13)].list);
					n->oncommit = (yyvsp[(12) - (13)].oncommit);
					n->tablespacename = (yyvsp[(13) - (13)].str);
					n->if_not_exists = true;
					(yyval.node) = (Node *)n;
				}
    break;

  case 393:
/* Line 1787 of yacc.c  */
#line 2795 "gram.y"
    { (yyval.ival) = RELPERSISTENCE_TEMP; }
    break;

  case 394:
/* Line 1787 of yacc.c  */
#line 2796 "gram.y"
    { (yyval.ival) = RELPERSISTENCE_TEMP; }
    break;

  case 395:
/* Line 1787 of yacc.c  */
#line 2797 "gram.y"
    { (yyval.ival) = RELPERSISTENCE_TEMP; }
    break;

  case 396:
/* Line 1787 of yacc.c  */
#line 2798 "gram.y"
    { (yyval.ival) = RELPERSISTENCE_TEMP; }
    break;

  case 397:
/* Line 1787 of yacc.c  */
#line 2800 "gram.y"
    {
					ereport(WARNING,
							(errmsg("GLOBAL is deprecated in temporary table creation"),
							 parser_errposition((yylsp[(1) - (2)]))));
					(yyval.ival) = RELPERSISTENCE_TEMP;
				}
    break;

  case 398:
/* Line 1787 of yacc.c  */
#line 2807 "gram.y"
    {
					ereport(WARNING,
							(errmsg("GLOBAL is deprecated in temporary table creation"),
							 parser_errposition((yylsp[(1) - (2)]))));
					(yyval.ival) = RELPERSISTENCE_TEMP;
				}
    break;

  case 399:
/* Line 1787 of yacc.c  */
#line 2813 "gram.y"
    { (yyval.ival) = RELPERSISTENCE_UNLOGGED; }
    break;

  case 400:
/* Line 1787 of yacc.c  */
#line 2814 "gram.y"
    { (yyval.ival) = RELPERSISTENCE_PERMANENT; }
    break;

  case 401:
/* Line 1787 of yacc.c  */
#line 2818 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list); }
    break;

  case 402:
/* Line 1787 of yacc.c  */
#line 2819 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 403:
/* Line 1787 of yacc.c  */
#line 2823 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (3)].list); }
    break;

  case 404:
/* Line 1787 of yacc.c  */
#line 2824 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 405:
/* Line 1787 of yacc.c  */
#line 2829 "gram.y"
    {
					(yyval.list) = list_make1((yyvsp[(1) - (1)].node));
				}
    break;

  case 406:
/* Line 1787 of yacc.c  */
#line 2833 "gram.y"
    {
					(yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node));
				}
    break;

  case 407:
/* Line 1787 of yacc.c  */
#line 2840 "gram.y"
    {
					(yyval.list) = list_make1((yyvsp[(1) - (1)].node));
				}
    break;

  case 408:
/* Line 1787 of yacc.c  */
#line 2844 "gram.y"
    {
					(yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node));
				}
    break;

  case 409:
/* Line 1787 of yacc.c  */
#line 2850 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); }
    break;

  case 410:
/* Line 1787 of yacc.c  */
#line 2851 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); }
    break;

  case 411:
/* Line 1787 of yacc.c  */
#line 2852 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); }
    break;

  case 412:
/* Line 1787 of yacc.c  */
#line 2856 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); }
    break;

  case 413:
/* Line 1787 of yacc.c  */
#line 2857 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); }
    break;

  case 414:
/* Line 1787 of yacc.c  */
#line 2861 "gram.y"
    {
					ColumnDef *n = makeNode(ColumnDef);
					n->colname = (yyvsp[(1) - (4)].str);
					n->typeName = (yyvsp[(2) - (4)].typnam);
					n->inhcount = 0;
					n->is_local = true;
					n->is_not_null = false;
					n->is_from_type = false;
					n->storage = 0;
					n->raw_default = NULL;
					n->cooked_default = NULL;
					n->collOid = InvalidOid;
					n->fdwoptions = (yyvsp[(3) - (4)].list);
					SplitColQualList((yyvsp[(4) - (4)].list), &n->constraints, &n->collClause,
									 yyscanner);
					n->location = (yylsp[(1) - (4)]);
					(yyval.node) = (Node *)n;
				}
    break;

  case 415:
/* Line 1787 of yacc.c  */
#line 2882 "gram.y"
    {
					ColumnDef *n = makeNode(ColumnDef);
					n->colname = (yyvsp[(1) - (4)].str);
					n->typeName = NULL;
					n->inhcount = 0;
					n->is_local = true;
					n->is_not_null = false;
					n->is_from_type = false;
					n->storage = 0;
					n->raw_default = NULL;
					n->cooked_default = NULL;
					n->collOid = InvalidOid;
					SplitColQualList((yyvsp[(4) - (4)].list), &n->constraints, &n->collClause,
									 yyscanner);
					n->location = (yylsp[(1) - (4)]);
					(yyval.node) = (Node *)n;
				}
    break;

  case 416:
/* Line 1787 of yacc.c  */
#line 2902 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].node)); }
    break;

  case 417:
/* Line 1787 of yacc.c  */
#line 2903 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 418:
/* Line 1787 of yacc.c  */
#line 2908 "gram.y"
    {
					Constraint *n = (Constraint *) (yyvsp[(3) - (3)].node);
					Assert(IsA(n, Constraint));
					n->conname = (yyvsp[(2) - (3)].str);
					n->location = (yylsp[(1) - (3)]);
					(yyval.node) = (Node *) n;
				}
    break;

  case 419:
/* Line 1787 of yacc.c  */
#line 2915 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); }
    break;

  case 420:
/* Line 1787 of yacc.c  */
#line 2916 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); }
    break;

  case 421:
/* Line 1787 of yacc.c  */
#line 2918 "gram.y"
    {
					/*
					 * Note: the CollateClause is momentarily included in
					 * the list built by ColQualList, but we split it out
					 * again in SplitColQualList.
					 */
					CollateClause *n = makeNode(CollateClause);
					n->arg = NULL;
					n->collname = (yyvsp[(2) - (2)].list);
					n->location = (yylsp[(1) - (2)]);
					(yyval.node) = (Node *) n;
				}
    break;

  case 422:
/* Line 1787 of yacc.c  */
#line 2949 "gram.y"
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_NOTNULL;
					n->location = (yylsp[(1) - (2)]);
					(yyval.node) = (Node *)n;
				}
    break;

  case 423:
/* Line 1787 of yacc.c  */
#line 2956 "gram.y"
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_NULL;
					n->location = (yylsp[(1) - (1)]);
					(yyval.node) = (Node *)n;
				}
    break;

  case 424:
/* Line 1787 of yacc.c  */
#line 2963 "gram.y"
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_UNIQUE;
					n->location = (yylsp[(1) - (3)]);
					n->keys = NULL;
					n->options = (yyvsp[(2) - (3)].list);
					n->indexname = NULL;
					n->indexspace = (yyvsp[(3) - (3)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 425:
/* Line 1787 of yacc.c  */
#line 2974 "gram.y"
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_PRIMARY;
					n->location = (yylsp[(1) - (4)]);
					n->keys = NULL;
					n->options = (yyvsp[(3) - (4)].list);
					n->indexname = NULL;
					n->indexspace = (yyvsp[(4) - (4)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 426:
/* Line 1787 of yacc.c  */
#line 2985 "gram.y"
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_CHECK;
					n->location = (yylsp[(1) - (5)]);
					n->is_no_inherit = (yyvsp[(5) - (5)].boolean);
					n->raw_expr = (yyvsp[(3) - (5)].node);
					n->cooked_expr = NULL;
					(yyval.node) = (Node *)n;
				}
    break;

  case 427:
/* Line 1787 of yacc.c  */
#line 2995 "gram.y"
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_DEFAULT;
					n->location = (yylsp[(1) - (2)]);
					n->raw_expr = (yyvsp[(2) - (2)].node);
					n->cooked_expr = NULL;
					(yyval.node) = (Node *)n;
				}
    break;

  case 428:
/* Line 1787 of yacc.c  */
#line 3004 "gram.y"
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_FOREIGN;
					n->location = (yylsp[(1) - (5)]);
					n->pktable			= (yyvsp[(2) - (5)].range);
					n->fk_attrs			= NIL;
					n->pk_attrs			= (yyvsp[(3) - (5)].list);
					n->fk_matchtype		= (yyvsp[(4) - (5)].ival);
					n->fk_upd_action	= (char) ((yyvsp[(5) - (5)].ival) >> 8);
					n->fk_del_action	= (char) ((yyvsp[(5) - (5)].ival) & 0xFF);
					n->skip_validation  = false;
					n->initially_valid  = true;
					(yyval.node) = (Node *)n;
				}
    break;

  case 429:
/* Line 1787 of yacc.c  */
#line 3037 "gram.y"
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_ATTR_DEFERRABLE;
					n->location = (yylsp[(1) - (1)]);
					(yyval.node) = (Node *)n;
				}
    break;

  case 430:
/* Line 1787 of yacc.c  */
#line 3044 "gram.y"
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_ATTR_NOT_DEFERRABLE;
					n->location = (yylsp[(1) - (2)]);
					(yyval.node) = (Node *)n;
				}
    break;

  case 431:
/* Line 1787 of yacc.c  */
#line 3051 "gram.y"
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_ATTR_DEFERRED;
					n->location = (yylsp[(1) - (2)]);
					(yyval.node) = (Node *)n;
				}
    break;

  case 432:
/* Line 1787 of yacc.c  */
#line 3058 "gram.y"
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_ATTR_IMMEDIATE;
					n->location = (yylsp[(1) - (2)]);
					(yyval.node) = (Node *)n;
				}
    break;

  case 433:
/* Line 1787 of yacc.c  */
#line 3069 "gram.y"
    {
					TableLikeClause *n = makeNode(TableLikeClause);
					n->relation = (yyvsp[(2) - (3)].range);
					n->options = (yyvsp[(3) - (3)].ival);
					(yyval.node) = (Node *)n;
				}
    break;

  case 434:
/* Line 1787 of yacc.c  */
#line 3078 "gram.y"
    { (yyval.ival) = (yyvsp[(1) - (3)].ival) | (yyvsp[(3) - (3)].ival); }
    break;

  case 435:
/* Line 1787 of yacc.c  */
#line 3079 "gram.y"
    { (yyval.ival) = (yyvsp[(1) - (3)].ival) & ~(yyvsp[(3) - (3)].ival); }
    break;

  case 436:
/* Line 1787 of yacc.c  */
#line 3080 "gram.y"
    { (yyval.ival) = 0; }
    break;

  case 437:
/* Line 1787 of yacc.c  */
#line 3084 "gram.y"
    { (yyval.ival) = CREATE_TABLE_LIKE_DEFAULTS; }
    break;

  case 438:
/* Line 1787 of yacc.c  */
#line 3085 "gram.y"
    { (yyval.ival) = CREATE_TABLE_LIKE_CONSTRAINTS; }
    break;

  case 439:
/* Line 1787 of yacc.c  */
#line 3086 "gram.y"
    { (yyval.ival) = CREATE_TABLE_LIKE_INDEXES; }
    break;

  case 440:
/* Line 1787 of yacc.c  */
#line 3087 "gram.y"
    { (yyval.ival) = CREATE_TABLE_LIKE_STORAGE; }
    break;

  case 441:
/* Line 1787 of yacc.c  */
#line 3088 "gram.y"
    { (yyval.ival) = CREATE_TABLE_LIKE_COMMENTS; }
    break;

  case 442:
/* Line 1787 of yacc.c  */
#line 3089 "gram.y"
    { (yyval.ival) = CREATE_TABLE_LIKE_ALL; }
    break;

  case 443:
/* Line 1787 of yacc.c  */
#line 3099 "gram.y"
    {
					Constraint *n = (Constraint *) (yyvsp[(3) - (3)].node);
					Assert(IsA(n, Constraint));
					n->conname = (yyvsp[(2) - (3)].str);
					n->location = (yylsp[(1) - (3)]);
					(yyval.node) = (Node *) n;
				}
    break;

  case 444:
/* Line 1787 of yacc.c  */
#line 3106 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); }
    break;

  case 445:
/* Line 1787 of yacc.c  */
#line 3111 "gram.y"
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_CHECK;
					n->location = (yylsp[(1) - (5)]);
					n->raw_expr = (yyvsp[(3) - (5)].node);
					n->cooked_expr = NULL;
					processCASbits((yyvsp[(5) - (5)].ival), (yylsp[(5) - (5)]), "CHECK",
								   NULL, NULL, &n->skip_validation,
								   &n->is_no_inherit, yyscanner);
					n->initially_valid = !n->skip_validation;
					(yyval.node) = (Node *)n;
				}
    break;

  case 446:
/* Line 1787 of yacc.c  */
#line 3125 "gram.y"
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_UNIQUE;
					n->location = (yylsp[(1) - (7)]);
					n->keys = (yyvsp[(3) - (7)].list);
					n->options = (yyvsp[(5) - (7)].list);
					n->indexname = NULL;
					n->indexspace = (yyvsp[(6) - (7)].str);
					processCASbits((yyvsp[(7) - (7)].ival), (yylsp[(7) - (7)]), "UNIQUE",
								   &n->deferrable, &n->initdeferred, NULL,
								   NULL, yyscanner);
					(yyval.node) = (Node *)n;
				}
    break;

  case 447:
/* Line 1787 of yacc.c  */
#line 3139 "gram.y"
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_UNIQUE;
					n->location = (yylsp[(1) - (3)]);
					n->keys = NIL;
					n->options = NIL;
					n->indexname = (yyvsp[(2) - (3)].str);
					n->indexspace = NULL;
					processCASbits((yyvsp[(3) - (3)].ival), (yylsp[(3) - (3)]), "UNIQUE",
								   &n->deferrable, &n->initdeferred, NULL,
								   NULL, yyscanner);
					(yyval.node) = (Node *)n;
				}
    break;

  case 448:
/* Line 1787 of yacc.c  */
#line 3154 "gram.y"
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_PRIMARY;
					n->location = (yylsp[(1) - (8)]);
					n->keys = (yyvsp[(4) - (8)].list);
					n->options = (yyvsp[(6) - (8)].list);
					n->indexname = NULL;
					n->indexspace = (yyvsp[(7) - (8)].str);
					processCASbits((yyvsp[(8) - (8)].ival), (yylsp[(8) - (8)]), "PRIMARY KEY",
								   &n->deferrable, &n->initdeferred, NULL,
								   NULL, yyscanner);
					(yyval.node) = (Node *)n;
				}
    break;

  case 449:
/* Line 1787 of yacc.c  */
#line 3168 "gram.y"
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_PRIMARY;
					n->location = (yylsp[(1) - (4)]);
					n->keys = NIL;
					n->options = NIL;
					n->indexname = (yyvsp[(3) - (4)].str);
					n->indexspace = NULL;
					processCASbits((yyvsp[(4) - (4)].ival), (yylsp[(4) - (4)]), "PRIMARY KEY",
								   &n->deferrable, &n->initdeferred, NULL,
								   NULL, yyscanner);
					(yyval.node) = (Node *)n;
				}
    break;

  case 450:
/* Line 1787 of yacc.c  */
#line 3184 "gram.y"
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_EXCLUSION;
					n->location = (yylsp[(1) - (9)]);
					n->access_method	= (yyvsp[(2) - (9)].str);
					n->exclusions		= (yyvsp[(4) - (9)].list);
					n->options			= (yyvsp[(6) - (9)].list);
					n->indexname		= NULL;
					n->indexspace		= (yyvsp[(7) - (9)].str);
					n->where_clause		= (yyvsp[(8) - (9)].node);
					processCASbits((yyvsp[(9) - (9)].ival), (yylsp[(9) - (9)]), "EXCLUDE",
								   &n->deferrable, &n->initdeferred, NULL,
								   NULL, yyscanner);
					(yyval.node) = (Node *)n;
				}
    break;

  case 451:
/* Line 1787 of yacc.c  */
#line 3201 "gram.y"
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_FOREIGN;
					n->location = (yylsp[(1) - (11)]);
					n->pktable			= (yyvsp[(7) - (11)].range);
					n->fk_attrs			= (yyvsp[(4) - (11)].list);
					n->pk_attrs			= (yyvsp[(8) - (11)].list);
					n->fk_matchtype		= (yyvsp[(9) - (11)].ival);
					n->fk_upd_action	= (char) ((yyvsp[(10) - (11)].ival) >> 8);
					n->fk_del_action	= (char) ((yyvsp[(10) - (11)].ival) & 0xFF);
					processCASbits((yyvsp[(11) - (11)].ival), (yylsp[(11) - (11)]), "FOREIGN KEY",
								   &n->deferrable, &n->initdeferred,
								   &n->skip_validation, NULL,
								   yyscanner);
					n->initially_valid = !n->skip_validation;
					(yyval.node) = (Node *)n;
				}
    break;

  case 452:
/* Line 1787 of yacc.c  */
#line 3220 "gram.y"
    {  (yyval.boolean) = TRUE; }
    break;

  case 453:
/* Line 1787 of yacc.c  */
#line 3221 "gram.y"
    {  (yyval.boolean) = FALSE; }
    break;

  case 454:
/* Line 1787 of yacc.c  */
#line 3225 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (3)].list); }
    break;

  case 455:
/* Line 1787 of yacc.c  */
#line 3226 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 456:
/* Line 1787 of yacc.c  */
#line 3230 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].node)); }
    break;

  case 457:
/* Line 1787 of yacc.c  */
#line 3231 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node)); }
    break;

  case 458:
/* Line 1787 of yacc.c  */
#line 3235 "gram.y"
    {
					(yyval.node) = (Node *) makeString((yyvsp[(1) - (1)].str));
				}
    break;

  case 459:
/* Line 1787 of yacc.c  */
#line 3241 "gram.y"
    {
				(yyval.ival) = FKCONSTR_MATCH_FULL;
			}
    break;

  case 460:
/* Line 1787 of yacc.c  */
#line 3245 "gram.y"
    {
				ereport(ERROR,
						(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
						 errmsg("MATCH PARTIAL not yet implemented"),
						 parser_errposition((yylsp[(1) - (2)]))));
				(yyval.ival) = FKCONSTR_MATCH_PARTIAL;
			}
    break;

  case 461:
/* Line 1787 of yacc.c  */
#line 3253 "gram.y"
    {
				(yyval.ival) = FKCONSTR_MATCH_SIMPLE;
			}
    break;

  case 462:
/* Line 1787 of yacc.c  */
#line 3257 "gram.y"
    {
				(yyval.ival) = FKCONSTR_MATCH_SIMPLE;
			}
    break;

  case 463:
/* Line 1787 of yacc.c  */
#line 3263 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].list)); }
    break;

  case 464:
/* Line 1787 of yacc.c  */
#line 3265 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].list)); }
    break;

  case 465:
/* Line 1787 of yacc.c  */
#line 3269 "gram.y"
    {
				(yyval.list) = list_make2((yyvsp[(1) - (3)].ielem), (yyvsp[(3) - (3)].list));
			}
    break;

  case 466:
/* Line 1787 of yacc.c  */
#line 3274 "gram.y"
    {
				(yyval.list) = list_make2((yyvsp[(1) - (6)].ielem), (yyvsp[(5) - (6)].list));
			}
    break;

  case 467:
/* Line 1787 of yacc.c  */
#line 3280 "gram.y"
    { (yyval.node) = (yyvsp[(3) - (4)].node); }
    break;

  case 468:
/* Line 1787 of yacc.c  */
#line 3281 "gram.y"
    { (yyval.node) = NULL; }
    break;

  case 469:
/* Line 1787 of yacc.c  */
#line 3292 "gram.y"
    { (yyval.ival) = ((yyvsp[(1) - (1)].ival) << 8) | (FKCONSTR_ACTION_NOACTION & 0xFF); }
    break;

  case 470:
/* Line 1787 of yacc.c  */
#line 3294 "gram.y"
    { (yyval.ival) = (FKCONSTR_ACTION_NOACTION << 8) | ((yyvsp[(1) - (1)].ival) & 0xFF); }
    break;

  case 471:
/* Line 1787 of yacc.c  */
#line 3296 "gram.y"
    { (yyval.ival) = ((yyvsp[(1) - (2)].ival) << 8) | ((yyvsp[(2) - (2)].ival) & 0xFF); }
    break;

  case 472:
/* Line 1787 of yacc.c  */
#line 3298 "gram.y"
    { (yyval.ival) = ((yyvsp[(2) - (2)].ival) << 8) | ((yyvsp[(1) - (2)].ival) & 0xFF); }
    break;

  case 473:
/* Line 1787 of yacc.c  */
#line 3300 "gram.y"
    { (yyval.ival) = (FKCONSTR_ACTION_NOACTION << 8) | (FKCONSTR_ACTION_NOACTION & 0xFF); }
    break;

  case 474:
/* Line 1787 of yacc.c  */
#line 3303 "gram.y"
    { (yyval.ival) = (yyvsp[(3) - (3)].ival); }
    break;

  case 475:
/* Line 1787 of yacc.c  */
#line 3306 "gram.y"
    { (yyval.ival) = (yyvsp[(3) - (3)].ival); }
    break;

  case 476:
/* Line 1787 of yacc.c  */
#line 3310 "gram.y"
    { (yyval.ival) = FKCONSTR_ACTION_NOACTION; }
    break;

  case 477:
/* Line 1787 of yacc.c  */
#line 3311 "gram.y"
    { (yyval.ival) = FKCONSTR_ACTION_RESTRICT; }
    break;

  case 478:
/* Line 1787 of yacc.c  */
#line 3312 "gram.y"
    { (yyval.ival) = FKCONSTR_ACTION_CASCADE; }
    break;

  case 479:
/* Line 1787 of yacc.c  */
#line 3313 "gram.y"
    { (yyval.ival) = FKCONSTR_ACTION_SETNULL; }
    break;

  case 480:
/* Line 1787 of yacc.c  */
#line 3314 "gram.y"
    { (yyval.ival) = FKCONSTR_ACTION_SETDEFAULT; }
    break;

  case 481:
/* Line 1787 of yacc.c  */
#line 3317 "gram.y"
    { (yyval.list) = (yyvsp[(3) - (4)].list); }
    break;

  case 482:
/* Line 1787 of yacc.c  */
#line 3318 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 483:
/* Line 1787 of yacc.c  */
#line 3323 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (2)].list); }
    break;

  case 484:
/* Line 1787 of yacc.c  */
#line 3324 "gram.y"
    { (yyval.list) = list_make1(defWithOids(true)); }
    break;

  case 485:
/* Line 1787 of yacc.c  */
#line 3325 "gram.y"
    { (yyval.list) = list_make1(defWithOids(false)); }
    break;

  case 486:
/* Line 1787 of yacc.c  */
#line 3326 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 487:
/* Line 1787 of yacc.c  */
#line 3329 "gram.y"
    { (yyval.oncommit) = ONCOMMIT_DROP; }
    break;

  case 488:
/* Line 1787 of yacc.c  */
#line 3330 "gram.y"
    { (yyval.oncommit) = ONCOMMIT_DELETE_ROWS; }
    break;

  case 489:
/* Line 1787 of yacc.c  */
#line 3331 "gram.y"
    { (yyval.oncommit) = ONCOMMIT_PRESERVE_ROWS; }
    break;

  case 490:
/* Line 1787 of yacc.c  */
#line 3332 "gram.y"
    { (yyval.oncommit) = ONCOMMIT_NOOP; }
    break;

  case 491:
/* Line 1787 of yacc.c  */
#line 3335 "gram.y"
    { (yyval.str) = (yyvsp[(2) - (2)].str); }
    break;

  case 492:
/* Line 1787 of yacc.c  */
#line 3336 "gram.y"
    { (yyval.str) = NULL; }
    break;

  case 493:
/* Line 1787 of yacc.c  */
#line 3339 "gram.y"
    { (yyval.str) = (yyvsp[(4) - (4)].str); }
    break;

  case 494:
/* Line 1787 of yacc.c  */
#line 3340 "gram.y"
    { (yyval.str) = NULL; }
    break;

  case 495:
/* Line 1787 of yacc.c  */
#line 3343 "gram.y"
    { (yyval.str) = (yyvsp[(3) - (3)].str); }
    break;

  case 496:
/* Line 1787 of yacc.c  */
#line 3359 "gram.y"
    {
					CreateTableAsStmt *ctas = makeNode(CreateTableAsStmt);
					ctas->query = (yyvsp[(6) - (7)].node);
					ctas->into = (yyvsp[(4) - (7)].into);
					ctas->relkind = OBJECT_TABLE;
					ctas->is_select_into = false;
					/* cram additional flags into the IntoClause */
					(yyvsp[(4) - (7)].into)->rel->relpersistence = (yyvsp[(2) - (7)].ival);
					(yyvsp[(4) - (7)].into)->skipData = !((yyvsp[(7) - (7)].boolean));
					(yyval.node) = (Node *) ctas;
				}
    break;

  case 497:
/* Line 1787 of yacc.c  */
#line 3374 "gram.y"
    {
					(yyval.into) = makeNode(IntoClause);
					(yyval.into)->rel = (yyvsp[(1) - (5)].range);
					(yyval.into)->colNames = (yyvsp[(2) - (5)].list);
					(yyval.into)->options = (yyvsp[(3) - (5)].list);
					(yyval.into)->onCommit = (yyvsp[(4) - (5)].oncommit);
					(yyval.into)->tableSpaceName = (yyvsp[(5) - (5)].str);
					(yyval.into)->viewQuery = NULL;
					(yyval.into)->skipData = false;		/* might get changed later */
				}
    break;

  case 498:
/* Line 1787 of yacc.c  */
#line 3387 "gram.y"
    { (yyval.boolean) = TRUE; }
    break;

  case 499:
/* Line 1787 of yacc.c  */
#line 3388 "gram.y"
    { (yyval.boolean) = FALSE; }
    break;

  case 500:
/* Line 1787 of yacc.c  */
#line 3389 "gram.y"
    { (yyval.boolean) = TRUE; }
    break;

  case 501:
/* Line 1787 of yacc.c  */
#line 3402 "gram.y"
    {
					CreateTableAsStmt *ctas = makeNode(CreateTableAsStmt);
					ctas->query = (yyvsp[(7) - (8)].node);
					ctas->into = (yyvsp[(5) - (8)].into);
					ctas->relkind = OBJECT_MATVIEW;
					ctas->is_select_into = false;
					/* cram additional flags into the IntoClause */
					(yyvsp[(5) - (8)].into)->rel->relpersistence = (yyvsp[(2) - (8)].ival);
					(yyvsp[(5) - (8)].into)->skipData = !((yyvsp[(8) - (8)].boolean));
					(yyval.node) = (Node *) ctas;
				}
    break;

  case 502:
/* Line 1787 of yacc.c  */
#line 3417 "gram.y"
    {
					(yyval.into) = makeNode(IntoClause);
					(yyval.into)->rel = (yyvsp[(1) - (4)].range);
					(yyval.into)->colNames = (yyvsp[(2) - (4)].list);
					(yyval.into)->options = (yyvsp[(3) - (4)].list);
					(yyval.into)->onCommit = ONCOMMIT_NOOP;
					(yyval.into)->tableSpaceName = (yyvsp[(4) - (4)].str);
					(yyval.into)->viewQuery = NULL;		/* filled at analysis time */
					(yyval.into)->skipData = false;		/* might get changed later */
				}
    break;

  case 503:
/* Line 1787 of yacc.c  */
#line 3429 "gram.y"
    { (yyval.ival) = RELPERSISTENCE_UNLOGGED; }
    break;

  case 504:
/* Line 1787 of yacc.c  */
#line 3430 "gram.y"
    { (yyval.ival) = RELPERSISTENCE_PERMANENT; }
    break;

  case 505:
/* Line 1787 of yacc.c  */
#line 3443 "gram.y"
    {
					RefreshMatViewStmt *n = makeNode(RefreshMatViewStmt);
					n->concurrent = (yyvsp[(4) - (6)].boolean);
					n->relation = (yyvsp[(5) - (6)].range);
					n->skipData = !((yyvsp[(6) - (6)].boolean));
					(yyval.node) = (Node *) n;
				}
    break;

  case 506:
/* Line 1787 of yacc.c  */
#line 3463 "gram.y"
    {
					CreateSeqStmt *n = makeNode(CreateSeqStmt);
					(yyvsp[(4) - (5)].range)->relpersistence = (yyvsp[(2) - (5)].ival);
					n->sequence = (yyvsp[(4) - (5)].range);
					n->options = (yyvsp[(5) - (5)].list);
					n->ownerId = InvalidOid;
					(yyval.node) = (Node *)n;
				}
    break;

  case 507:
/* Line 1787 of yacc.c  */
#line 3475 "gram.y"
    {
					AlterSeqStmt *n = makeNode(AlterSeqStmt);
					n->sequence = (yyvsp[(3) - (4)].range);
					n->options = (yyvsp[(4) - (4)].list);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 508:
/* Line 1787 of yacc.c  */
#line 3483 "gram.y"
    {
					AlterSeqStmt *n = makeNode(AlterSeqStmt);
					n->sequence = (yyvsp[(5) - (6)].range);
					n->options = (yyvsp[(6) - (6)].list);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
    break;

  case 509:
/* Line 1787 of yacc.c  */
#line 3493 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list); }
    break;

  case 510:
/* Line 1787 of yacc.c  */
#line 3494 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 511:
/* Line 1787 of yacc.c  */
#line 3497 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].defelt)); }
    break;

  case 512:
/* Line 1787 of yacc.c  */
#line 3498 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].defelt)); }
    break;

  case 513:
/* Line 1787 of yacc.c  */
#line 3502 "gram.y"
    {
					(yyval.defelt) = makeDefElem("cache", (Node *)(yyvsp[(2) - (2)].value));
				}
    break;

  case 514:
/* Line 1787 of yacc.c  */
#line 3506 "gram.y"
    {
					(yyval.defelt) = makeDefElem("cycle", (Node *)makeInteger(TRUE));
				}
    break;

  case 515:
/* Line 1787 of yacc.c  */
#line 3510 "gram.y"
    {
					(yyval.defelt) = makeDefElem("cycle", (Node *)makeInteger(FALSE));
				}
    break;

  case 516:
/* Line 1787 of yacc.c  */
#line 3514 "gram.y"
    {
					(yyval.defelt) = makeDefElem("increment", (Node *)(yyvsp[(3) - (3)].value));
				}
    break;

  case 517:
/* Line 1787 of yacc.c  */
#line 3518 "gram.y"
    {
					(yyval.defelt) = makeDefElem("maxvalue", (Node *)(yyvsp[(2) - (2)].value));
				}
    break;

  case 518:
/* Line 1787 of yacc.c  */
#line 3522 "gram.y"
    {
					(yyval.defelt) = makeDefElem("minvalue", (Node *)(yyvsp[(2) - (2)].value));
				}
    break;

  case 519:
/* Line 1787 of yacc.c  */
#line 3526 "gram.y"
    {
					(yyval.defelt) = makeDefElem("maxvalue", NULL);
				}
    break;

  case 520:
/* Line 1787 of yacc.c  */
#line 3530 "gram.y"
    {
					(yyval.defelt) = makeDefElem("minvalue", NULL);
				}
    break;

  case 521:
/* Line 1787 of yacc.c  */
#line 3534 "gram.y"
    {
					(yyval.defelt) = makeDefElem("owned_by", (Node *)(yyvsp[(3) - (3)].list));
				}
    break;

  case 522:
/* Line 1787 of yacc.c  */
#line 3538 "gram.y"
    {
					(yyval.defelt) = makeDefElem("start", (Node *)(yyvsp[(3) - (3)].value));
				}
    break;

  case 523:
/* Line 1787 of yacc.c  */
#line 3542 "gram.y"
    {
					(yyval.defelt) = makeDefElem("restart", NULL);
				}
    break;

  case 524:
/* Line 1787 of yacc.c  */
#line 3546 "gram.y"
    {
					(yyval.defelt) = makeDefElem("restart", (Node *)(yyvsp[(3) - (3)].value));
				}
    break;

  case 525:
/* Line 1787 of yacc.c  */
#line 3551 "gram.y"
    {}
    break;

  case 526:
/* Line 1787 of yacc.c  */
#line 3552 "gram.y"
    {}
    break;

  case 527:
/* Line 1787 of yacc.c  */
#line 3556 "gram.y"
    { (yyval.value) = makeFloat((yyvsp[(1) - (1)].str)); }
    break;

  case 528:
/* Line 1787 of yacc.c  */
#line 3558 "gram.y"
    {
					(yyval.value) = makeFloat((yyvsp[(2) - (2)].str));
					doNegateFloat((yyval.value));
				}
    break;

  case 529:
/* Line 1787 of yacc.c  */
#line 3562 "gram.y"
    { (yyval.value) = makeInteger((yyvsp[(1) - (1)].ival)); }
    break;

  case 530:
/* Line 1787 of yacc.c  */
#line 3565 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].value)); }
    break;

  case 531:
/* Line 1787 of yacc.c  */
#line 3566 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].value)); }
    break;

  case 532:
/* Line 1787 of yacc.c  */
#line 3579 "gram.y"
    {
				CreatePLangStmt *n = makeNode(CreatePLangStmt);
				n->replace = (yyvsp[(2) - (6)].boolean);
				n->plname = (yyvsp[(6) - (6)].str);
				/* parameters are all to be supplied by system */
				n->plhandler = NIL;
				n->plinline = NIL;
				n->plvalidator = NIL;
				n->pltrusted = false;
				(yyval.node) = (Node *)n;
			}
    break;

  case 533:
/* Line 1787 of yacc.c  */
#line 3592 "gram.y"
    {
				CreatePLangStmt *n = makeNode(CreatePLangStmt);
				n->replace = (yyvsp[(2) - (10)].boolean);
				n->plname = (yyvsp[(6) - (10)].str);
				n->plhandler = (yyvsp[(8) - (10)].list);
				n->plinline = (yyvsp[(9) - (10)].list);
				n->plvalidator = (yyvsp[(10) - (10)].list);
				n->pltrusted = (yyvsp[(3) - (10)].boolean);
				(yyval.node) = (Node *)n;
			}
    break;

  case 534:
/* Line 1787 of yacc.c  */
#line 3605 "gram.y"
    { (yyval.boolean) = TRUE; }
    break;

  case 535:
/* Line 1787 of yacc.c  */
#line 3606 "gram.y"
    { (yyval.boolean) = FALSE; }
    break;

  case 536:
/* Line 1787 of yacc.c  */
#line 3614 "gram.y"
    { (yyval.list) = list_make1(makeString((yyvsp[(1) - (1)].str))); }
    break;

  case 537:
/* Line 1787 of yacc.c  */
#line 3615 "gram.y"
    { (yyval.list) = lcons(makeString((yyvsp[(1) - (2)].str)), (yyvsp[(2) - (2)].list)); }
    break;

  case 538:
/* Line 1787 of yacc.c  */
#line 3619 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (2)].list); }
    break;

  case 539:
/* Line 1787 of yacc.c  */
#line 3620 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 540:
/* Line 1787 of yacc.c  */
#line 3624 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (2)].list); }
    break;

  case 541:
/* Line 1787 of yacc.c  */
#line 3625 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 542:
/* Line 1787 of yacc.c  */
#line 3629 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list); }
    break;

  case 543:
/* Line 1787 of yacc.c  */
#line 3630 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 544:
/* Line 1787 of yacc.c  */
#line 3635 "gram.y"
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_LANGUAGE;
					n->objects = list_make1(list_make1(makeString((yyvsp[(4) - (5)].str))));
					n->arguments = NIL;
					n->behavior = (yyvsp[(5) - (5)].dbehavior);
					n->missing_ok = false;
					n->concurrent = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 545:
/* Line 1787 of yacc.c  */
#line 3646 "gram.y"
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_LANGUAGE;
					n->objects = list_make1(list_make1(makeString((yyvsp[(6) - (7)].str))));
					n->behavior = (yyvsp[(7) - (7)].dbehavior);
					n->missing_ok = true;
					n->concurrent = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 546:
/* Line 1787 of yacc.c  */
#line 3658 "gram.y"
    {}
    break;

  case 547:
/* Line 1787 of yacc.c  */
#line 3659 "gram.y"
    {}
    break;

  case 548:
/* Line 1787 of yacc.c  */
#line 3670 "gram.y"
    {
					CreateTableSpaceStmt *n = makeNode(CreateTableSpaceStmt);
					n->tablespacename = (yyvsp[(3) - (7)].str);
					n->owner = (yyvsp[(4) - (7)].str);
					n->location = (yyvsp[(6) - (7)].str);
					n->options = (yyvsp[(7) - (7)].list);
					(yyval.node) = (Node *) n;
				}
    break;

  case 549:
/* Line 1787 of yacc.c  */
#line 3680 "gram.y"
    { (yyval.str) = (yyvsp[(2) - (2)].str); }
    break;

  case 550:
/* Line 1787 of yacc.c  */
#line 3681 "gram.y"
    { (yyval.str) = NULL; }
    break;

  case 551:
/* Line 1787 of yacc.c  */
#line 3695 "gram.y"
    {
					DropTableSpaceStmt *n = makeNode(DropTableSpaceStmt);
					n->tablespacename = (yyvsp[(3) - (3)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
    break;

  case 552:
/* Line 1787 of yacc.c  */
#line 3702 "gram.y"
    {
					DropTableSpaceStmt *n = makeNode(DropTableSpaceStmt);
					n->tablespacename = (yyvsp[(5) - (5)].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
    break;

  case 553:
/* Line 1787 of yacc.c  */
#line 3719 "gram.y"
    {
					CreateExtensionStmt *n = makeNode(CreateExtensionStmt);
					n->extname = (yyvsp[(3) - (5)].str);
					n->if_not_exists = false;
					n->options = (yyvsp[(5) - (5)].list);
					(yyval.node) = (Node *) n;
				}
    break;

  case 554:
/* Line 1787 of yacc.c  */
#line 3727 "gram.y"
    {
					CreateExtensionStmt *n = makeNode(CreateExtensionStmt);
					n->extname = (yyvsp[(6) - (8)].str);
					n->if_not_exists = true;
					n->options = (yyvsp[(8) - (8)].list);
					(yyval.node) = (Node *) n;
				}
    break;

  case 555:
/* Line 1787 of yacc.c  */
#line 3738 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].defelt)); }
    break;

  case 556:
/* Line 1787 of yacc.c  */
#line 3740 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 557:
/* Line 1787 of yacc.c  */
#line 3745 "gram.y"
    {
					(yyval.defelt) = makeDefElem("schema", (Node *)makeString((yyvsp[(2) - (2)].str)));
				}
    break;

  case 558:
/* Line 1787 of yacc.c  */
#line 3749 "gram.y"
    {
					(yyval.defelt) = makeDefElem("new_version", (Node *)makeString((yyvsp[(2) - (2)].str)));
				}
    break;

  case 559:
/* Line 1787 of yacc.c  */
#line 3753 "gram.y"
    {
					(yyval.defelt) = makeDefElem("old_version", (Node *)makeString((yyvsp[(2) - (2)].str)));
				}
    break;

  case 560:
/* Line 1787 of yacc.c  */
#line 3765 "gram.y"
    {
					AlterExtensionStmt *n = makeNode(AlterExtensionStmt);
					n->extname = (yyvsp[(3) - (5)].str);
					n->options = (yyvsp[(5) - (5)].list);
					(yyval.node) = (Node *) n;
				}
    break;

  case 561:
/* Line 1787 of yacc.c  */
#line 3775 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].defelt)); }
    break;

  case 562:
/* Line 1787 of yacc.c  */
#line 3777 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 563:
/* Line 1787 of yacc.c  */
#line 3782 "gram.y"
    {
					(yyval.defelt) = makeDefElem("new_version", (Node *)makeString((yyvsp[(2) - (2)].str)));
				}
    break;

  case 564:
/* Line 1787 of yacc.c  */
#line 3795 "gram.y"
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[(3) - (7)].str);
					n->action = (yyvsp[(4) - (7)].ival);
					n->objtype = OBJECT_AGGREGATE;
					n->objname = (yyvsp[(6) - (7)].list);
					n->objargs = extractAggrArgTypes((yyvsp[(7) - (7)].list));
					(yyval.node) = (Node *)n;
				}
    break;

  case 565:
/* Line 1787 of yacc.c  */
#line 3805 "gram.y"
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[(3) - (10)].str);
					n->action = (yyvsp[(4) - (10)].ival);
					n->objtype = OBJECT_CAST;
					n->objname = list_make1((yyvsp[(7) - (10)].typnam));
					n->objargs = list_make1((yyvsp[(9) - (10)].typnam));
					(yyval.node) = (Node *) n;
				}
    break;

  case 566:
/* Line 1787 of yacc.c  */
#line 3815 "gram.y"
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[(3) - (6)].str);
					n->action = (yyvsp[(4) - (6)].ival);
					n->objtype = OBJECT_COLLATION;
					n->objname = (yyvsp[(6) - (6)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 567:
/* Line 1787 of yacc.c  */
#line 3824 "gram.y"
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[(3) - (6)].str);
					n->action = (yyvsp[(4) - (6)].ival);
					n->objtype = OBJECT_CONVERSION;
					n->objname = (yyvsp[(6) - (6)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 568:
/* Line 1787 of yacc.c  */
#line 3833 "gram.y"
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[(3) - (6)].str);
					n->action = (yyvsp[(4) - (6)].ival);
					n->objtype = OBJECT_DOMAIN;
					n->objname = (yyvsp[(6) - (6)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 569:
/* Line 1787 of yacc.c  */
#line 3842 "gram.y"
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[(3) - (6)].str);
					n->action = (yyvsp[(4) - (6)].ival);
					n->objtype = OBJECT_FUNCTION;
					n->objname = (yyvsp[(6) - (6)].funwithargs)->funcname;
					n->objargs = (yyvsp[(6) - (6)].funwithargs)->funcargs;
					(yyval.node) = (Node *)n;
				}
    break;

  case 570:
/* Line 1787 of yacc.c  */
#line 3852 "gram.y"
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[(3) - (7)].str);
					n->action = (yyvsp[(4) - (7)].ival);
					n->objtype = OBJECT_LANGUAGE;
					n->objname = list_make1(makeString((yyvsp[(7) - (7)].str)));
					(yyval.node) = (Node *)n;
				}
    break;

  case 571:
/* Line 1787 of yacc.c  */
#line 3861 "gram.y"
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[(3) - (7)].str);
					n->action = (yyvsp[(4) - (7)].ival);
					n->objtype = OBJECT_OPERATOR;
					n->objname = (yyvsp[(6) - (7)].list);
					n->objargs = (yyvsp[(7) - (7)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 572:
/* Line 1787 of yacc.c  */
#line 3871 "gram.y"
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[(3) - (9)].str);
					n->action = (yyvsp[(4) - (9)].ival);
					n->objtype = OBJECT_OPCLASS;
					n->objname = (yyvsp[(7) - (9)].list);
					n->objargs = list_make1(makeString((yyvsp[(9) - (9)].str)));
					(yyval.node) = (Node *)n;
				}
    break;

  case 573:
/* Line 1787 of yacc.c  */
#line 3881 "gram.y"
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[(3) - (9)].str);
					n->action = (yyvsp[(4) - (9)].ival);
					n->objtype = OBJECT_OPFAMILY;
					n->objname = (yyvsp[(7) - (9)].list);
					n->objargs = list_make1(makeString((yyvsp[(9) - (9)].str)));
					(yyval.node) = (Node *)n;
				}
    break;

  case 574:
/* Line 1787 of yacc.c  */
#line 3891 "gram.y"
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[(3) - (6)].str);
					n->action = (yyvsp[(4) - (6)].ival);
					n->objtype = OBJECT_SCHEMA;
					n->objname = list_make1(makeString((yyvsp[(6) - (6)].str)));
					(yyval.node) = (Node *)n;
				}
    break;

  case 575:
/* Line 1787 of yacc.c  */
#line 3900 "gram.y"
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[(3) - (7)].str);
					n->action = (yyvsp[(4) - (7)].ival);
					n->objtype = OBJECT_EVENT_TRIGGER;
					n->objname = list_make1(makeString((yyvsp[(7) - (7)].str)));
					(yyval.node) = (Node *)n;
				}
    break;

  case 576:
/* Line 1787 of yacc.c  */
#line 3909 "gram.y"
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[(3) - (6)].str);
					n->action = (yyvsp[(4) - (6)].ival);
					n->objtype = OBJECT_TABLE;
					n->objname = (yyvsp[(6) - (6)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 577:
/* Line 1787 of yacc.c  */
#line 3918 "gram.y"
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[(3) - (8)].str);
					n->action = (yyvsp[(4) - (8)].ival);
					n->objtype = OBJECT_TSPARSER;
					n->objname = (yyvsp[(8) - (8)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 578:
/* Line 1787 of yacc.c  */
#line 3927 "gram.y"
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[(3) - (8)].str);
					n->action = (yyvsp[(4) - (8)].ival);
					n->objtype = OBJECT_TSDICTIONARY;
					n->objname = (yyvsp[(8) - (8)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 579:
/* Line 1787 of yacc.c  */
#line 3936 "gram.y"
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[(3) - (8)].str);
					n->action = (yyvsp[(4) - (8)].ival);
					n->objtype = OBJECT_TSTEMPLATE;
					n->objname = (yyvsp[(8) - (8)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 580:
/* Line 1787 of yacc.c  */
#line 3945 "gram.y"
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[(3) - (8)].str);
					n->action = (yyvsp[(4) - (8)].ival);
					n->objtype = OBJECT_TSCONFIGURATION;
					n->objname = (yyvsp[(8) - (8)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 581:
/* Line 1787 of yacc.c  */
#line 3954 "gram.y"
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[(3) - (6)].str);
					n->action = (yyvsp[(4) - (6)].ival);
					n->objtype = OBJECT_SEQUENCE;
					n->objname = (yyvsp[(6) - (6)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 582:
/* Line 1787 of yacc.c  */
#line 3963 "gram.y"
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[(3) - (6)].str);
					n->action = (yyvsp[(4) - (6)].ival);
					n->objtype = OBJECT_VIEW;
					n->objname = (yyvsp[(6) - (6)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 583:
/* Line 1787 of yacc.c  */
#line 3972 "gram.y"
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[(3) - (7)].str);
					n->action = (yyvsp[(4) - (7)].ival);
					n->objtype = OBJECT_MATVIEW;
					n->objname = (yyvsp[(7) - (7)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 584:
/* Line 1787 of yacc.c  */
#line 3981 "gram.y"
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[(3) - (7)].str);
					n->action = (yyvsp[(4) - (7)].ival);
					n->objtype = OBJECT_FOREIGN_TABLE;
					n->objname = (yyvsp[(7) - (7)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 585:
/* Line 1787 of yacc.c  */
#line 3990 "gram.y"
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[(3) - (8)].str);
					n->action = (yyvsp[(4) - (8)].ival);
					n->objtype = OBJECT_FDW;
					n->objname = list_make1(makeString((yyvsp[(8) - (8)].str)));
					(yyval.node) = (Node *)n;
				}
    break;

  case 586:
/* Line 1787 of yacc.c  */
#line 3999 "gram.y"
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[(3) - (6)].str);
					n->action = (yyvsp[(4) - (6)].ival);
					n->objtype = OBJECT_FOREIGN_SERVER;
					n->objname = list_make1(makeString((yyvsp[(6) - (6)].str)));
					(yyval.node) = (Node *)n;
				}
    break;

  case 587:
/* Line 1787 of yacc.c  */
#line 4008 "gram.y"
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);
					n->extname = (yyvsp[(3) - (6)].str);
					n->action = (yyvsp[(4) - (6)].ival);
					n->objtype = OBJECT_TYPE;
					n->objname = (yyvsp[(6) - (6)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 588:
/* Line 1787 of yacc.c  */
#line 4026 "gram.y"
    {
					CreateFdwStmt *n = makeNode(CreateFdwStmt);
					n->fdwname = (yyvsp[(5) - (7)].str);
					n->func_options = (yyvsp[(6) - (7)].list);
					n->options = (yyvsp[(7) - (7)].list);
					(yyval.node) = (Node *) n;
				}
    break;

  case 589:
/* Line 1787 of yacc.c  */
#line 4036 "gram.y"
    { (yyval.defelt) = makeDefElem("handler", (Node *)(yyvsp[(2) - (2)].list)); }
    break;

  case 590:
/* Line 1787 of yacc.c  */
#line 4037 "gram.y"
    { (yyval.defelt) = makeDefElem("handler", NULL); }
    break;

  case 591:
/* Line 1787 of yacc.c  */
#line 4038 "gram.y"
    { (yyval.defelt) = makeDefElem("validator", (Node *)(yyvsp[(2) - (2)].list)); }
    break;

  case 592:
/* Line 1787 of yacc.c  */
#line 4039 "gram.y"
    { (yyval.defelt) = makeDefElem("validator", NULL); }
    break;

  case 593:
/* Line 1787 of yacc.c  */
#line 4043 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].defelt)); }
    break;

  case 594:
/* Line 1787 of yacc.c  */
#line 4044 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].defelt)); }
    break;

  case 595:
/* Line 1787 of yacc.c  */
#line 4048 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list); }
    break;

  case 596:
/* Line 1787 of yacc.c  */
#line 4049 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 597:
/* Line 1787 of yacc.c  */
#line 4060 "gram.y"
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_FDW;
					n->objects = list_make1(list_make1(makeString((yyvsp[(5) - (6)].str))));
					n->arguments = NIL;
					n->missing_ok = false;
					n->behavior = (yyvsp[(6) - (6)].dbehavior);
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
    break;

  case 598:
/* Line 1787 of yacc.c  */
#line 4071 "gram.y"
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_FDW;
					n->objects = list_make1(list_make1(makeString((yyvsp[(7) - (8)].str))));
					n->arguments = NIL;
					n->missing_ok = true;
					n->behavior = (yyvsp[(8) - (8)].dbehavior);
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
    break;

  case 599:
/* Line 1787 of yacc.c  */
#line 4091 "gram.y"
    {
					AlterFdwStmt *n = makeNode(AlterFdwStmt);
					n->fdwname = (yyvsp[(5) - (7)].str);
					n->func_options = (yyvsp[(6) - (7)].list);
					n->options = (yyvsp[(7) - (7)].list);
					(yyval.node) = (Node *) n;
				}
    break;

  case 600:
/* Line 1787 of yacc.c  */
#line 4099 "gram.y"
    {
					AlterFdwStmt *n = makeNode(AlterFdwStmt);
					n->fdwname = (yyvsp[(5) - (6)].str);
					n->func_options = (yyvsp[(6) - (6)].list);
					n->options = NIL;
					(yyval.node) = (Node *) n;
				}
    break;

  case 601:
/* Line 1787 of yacc.c  */
#line 4110 "gram.y"
    { (yyval.list) = (yyvsp[(3) - (4)].list); }
    break;

  case 602:
/* Line 1787 of yacc.c  */
#line 4111 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 603:
/* Line 1787 of yacc.c  */
#line 4116 "gram.y"
    {
					(yyval.list) = list_make1((yyvsp[(1) - (1)].defelt));
				}
    break;

  case 604:
/* Line 1787 of yacc.c  */
#line 4120 "gram.y"
    {
					(yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].defelt));
				}
    break;

  case 605:
/* Line 1787 of yacc.c  */
#line 4127 "gram.y"
    { (yyval.list) = (yyvsp[(3) - (4)].list); }
    break;

  case 606:
/* Line 1787 of yacc.c  */
#line 4132 "gram.y"
    {
					(yyval.list) = list_make1((yyvsp[(1) - (1)].defelt));
				}
    break;

  case 607:
/* Line 1787 of yacc.c  */
#line 4136 "gram.y"
    {
					(yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].defelt));
				}
    break;

  case 608:
/* Line 1787 of yacc.c  */
#line 4143 "gram.y"
    {
					(yyval.defelt) = (yyvsp[(1) - (1)].defelt);
				}
    break;

  case 609:
/* Line 1787 of yacc.c  */
#line 4147 "gram.y"
    {
					(yyval.defelt) = (yyvsp[(2) - (2)].defelt);
					(yyval.defelt)->defaction = DEFELEM_SET;
				}
    break;

  case 610:
/* Line 1787 of yacc.c  */
#line 4152 "gram.y"
    {
					(yyval.defelt) = (yyvsp[(2) - (2)].defelt);
					(yyval.defelt)->defaction = DEFELEM_ADD;
				}
    break;

  case 611:
/* Line 1787 of yacc.c  */
#line 4157 "gram.y"
    {
					(yyval.defelt) = makeDefElemExtended(NULL, (yyvsp[(2) - (2)].str), NULL, DEFELEM_DROP);
				}
    break;

  case 612:
/* Line 1787 of yacc.c  */
#line 4164 "gram.y"
    {
					(yyval.defelt) = makeDefElem((yyvsp[(1) - (2)].str), (yyvsp[(2) - (2)].node));
				}
    break;

  case 613:
/* Line 1787 of yacc.c  */
#line 4170 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); }
    break;

  case 614:
/* Line 1787 of yacc.c  */
#line 4175 "gram.y"
    { (yyval.node) = (Node *) makeString((yyvsp[(1) - (1)].str)); }
    break;

  case 615:
/* Line 1787 of yacc.c  */
#line 4187 "gram.y"
    {
					CreateForeignServerStmt *n = makeNode(CreateForeignServerStmt);
					n->servername = (yyvsp[(3) - (10)].str);
					n->servertype = (yyvsp[(4) - (10)].str);
					n->version = (yyvsp[(5) - (10)].str);
					n->fdwname = (yyvsp[(9) - (10)].str);
					n->options = (yyvsp[(10) - (10)].list);
					(yyval.node) = (Node *) n;
				}
    break;

  case 616:
/* Line 1787 of yacc.c  */
#line 4199 "gram.y"
    { (yyval.str) = (yyvsp[(2) - (2)].str); }
    break;

  case 617:
/* Line 1787 of yacc.c  */
#line 4200 "gram.y"
    { (yyval.str) = NULL; }
    break;

  case 618:
/* Line 1787 of yacc.c  */
#line 4205 "gram.y"
    { (yyval.str) = (yyvsp[(2) - (2)].str); }
    break;

  case 619:
/* Line 1787 of yacc.c  */
#line 4206 "gram.y"
    { (yyval.str) = NULL; }
    break;

  case 620:
/* Line 1787 of yacc.c  */
#line 4210 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); }
    break;

  case 621:
/* Line 1787 of yacc.c  */
#line 4211 "gram.y"
    { (yyval.str) = NULL; }
    break;

  case 622:
/* Line 1787 of yacc.c  */
#line 4222 "gram.y"
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_FOREIGN_SERVER;
					n->objects = list_make1(list_make1(makeString((yyvsp[(3) - (4)].str))));
					n->arguments = NIL;
					n->missing_ok = false;
					n->behavior = (yyvsp[(4) - (4)].dbehavior);
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
    break;

  case 623:
/* Line 1787 of yacc.c  */
#line 4233 "gram.y"
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_FOREIGN_SERVER;
					n->objects = list_make1(list_make1(makeString((yyvsp[(5) - (6)].str))));
					n->arguments = NIL;
					n->missing_ok = true;
					n->behavior = (yyvsp[(6) - (6)].dbehavior);
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
    break;

  case 624:
/* Line 1787 of yacc.c  */
#line 4253 "gram.y"
    {
					AlterForeignServerStmt *n = makeNode(AlterForeignServerStmt);
					n->servername = (yyvsp[(3) - (5)].str);
					n->version = (yyvsp[(4) - (5)].str);
					n->options = (yyvsp[(5) - (5)].list);
					n->has_version = true;
					(yyval.node) = (Node *) n;
				}
    break;

  case 625:
/* Line 1787 of yacc.c  */
#line 4262 "gram.y"
    {
					AlterForeignServerStmt *n = makeNode(AlterForeignServerStmt);
					n->servername = (yyvsp[(3) - (4)].str);
					n->version = (yyvsp[(4) - (4)].str);
					n->has_version = true;
					(yyval.node) = (Node *) n;
				}
    break;

  case 626:
/* Line 1787 of yacc.c  */
#line 4270 "gram.y"
    {
					AlterForeignServerStmt *n = makeNode(AlterForeignServerStmt);
					n->servername = (yyvsp[(3) - (4)].str);
					n->options = (yyvsp[(4) - (4)].list);
					(yyval.node) = (Node *) n;
				}
    break;

  case 627:
/* Line 1787 of yacc.c  */
#line 4289 "gram.y"
    {
					CreateForeignTableStmt *n = makeNode(CreateForeignTableStmt);
					(yyvsp[(4) - (10)].range)->relpersistence = RELPERSISTENCE_PERMANENT;
					n->base.relation = (yyvsp[(4) - (10)].range);
					n->base.tableElts = (yyvsp[(6) - (10)].list);
					n->base.inhRelations = NIL;
					n->base.if_not_exists = false;
					/* FDW-specific data */
					n->servername = (yyvsp[(9) - (10)].str);
					n->options = (yyvsp[(10) - (10)].list);
					(yyval.node) = (Node *) n;
				}
    break;

  case 628:
/* Line 1787 of yacc.c  */
#line 4304 "gram.y"
    {
					CreateForeignTableStmt *n = makeNode(CreateForeignTableStmt);
					(yyvsp[(7) - (13)].range)->relpersistence = RELPERSISTENCE_PERMANENT;
					n->base.relation = (yyvsp[(7) - (13)].range);
					n->base.tableElts = (yyvsp[(9) - (13)].list);
					n->base.inhRelations = NIL;
					n->base.if_not_exists = true;
					/* FDW-specific data */
					n->servername = (yyvsp[(12) - (13)].str);
					n->options = (yyvsp[(13) - (13)].list);
					(yyval.node) = (Node *) n;
				}
    break;

  case 629:
/* Line 1787 of yacc.c  */
#line 4327 "gram.y"
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[(4) - (5)].range);
					n->cmds = (yyvsp[(5) - (5)].list);
					n->relkind = OBJECT_FOREIGN_TABLE;
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 630:
/* Line 1787 of yacc.c  */
#line 4336 "gram.y"
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[(6) - (7)].range);
					n->cmds = (yyvsp[(7) - (7)].list);
					n->relkind = OBJECT_FOREIGN_TABLE;
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
    break;

  case 631:
/* Line 1787 of yacc.c  */
#line 4354 "gram.y"
    {
					CreateUserMappingStmt *n = makeNode(CreateUserMappingStmt);
					n->username = (yyvsp[(5) - (8)].str);
					n->servername = (yyvsp[(7) - (8)].str);
					n->options = (yyvsp[(8) - (8)].list);
					(yyval.node) = (Node *) n;
				}
    break;

  case 632:
/* Line 1787 of yacc.c  */
#line 4365 "gram.y"
    { (yyval.str) = "current_user"; }
    break;

  case 633:
/* Line 1787 of yacc.c  */
#line 4366 "gram.y"
    { (yyval.str) = "current_user"; }
    break;

  case 634:
/* Line 1787 of yacc.c  */
#line 4367 "gram.y"
    { (yyval.str) = (strcmp((yyvsp[(1) - (1)].str), "public") == 0) ? NULL : (yyvsp[(1) - (1)].str); }
    break;

  case 635:
/* Line 1787 of yacc.c  */
#line 4378 "gram.y"
    {
					DropUserMappingStmt *n = makeNode(DropUserMappingStmt);
					n->username = (yyvsp[(5) - (7)].str);
					n->servername = (yyvsp[(7) - (7)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
    break;

  case 636:
/* Line 1787 of yacc.c  */
#line 4386 "gram.y"
    {
					DropUserMappingStmt *n = makeNode(DropUserMappingStmt);
					n->username = (yyvsp[(7) - (9)].str);
					n->servername = (yyvsp[(9) - (9)].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
    break;

  case 637:
/* Line 1787 of yacc.c  */
#line 4403 "gram.y"
    {
					AlterUserMappingStmt *n = makeNode(AlterUserMappingStmt);
					n->username = (yyvsp[(5) - (8)].str);
					n->servername = (yyvsp[(7) - (8)].str);
					n->options = (yyvsp[(8) - (8)].list);
					(yyval.node) = (Node *) n;
				}
    break;

  case 638:
/* Line 1787 of yacc.c  */
#line 4424 "gram.y"
    {
					CreateTrigStmt *n = makeNode(CreateTrigStmt);
					n->trigname = (yyvsp[(3) - (15)].str);
					n->relation = (yyvsp[(7) - (15)].range);
					n->funcname = (yyvsp[(12) - (15)].list);
					n->args = (yyvsp[(14) - (15)].list);
					n->row = (yyvsp[(8) - (15)].boolean);
					n->timing = (yyvsp[(4) - (15)].ival);
					n->events = intVal(linitial((yyvsp[(5) - (15)].list)));
					n->columns = (List *) lsecond((yyvsp[(5) - (15)].list));
					n->whenClause = (yyvsp[(9) - (15)].node);
					n->isconstraint  = FALSE;
					n->deferrable	 = FALSE;
					n->initdeferred  = FALSE;
					n->constrrel = NULL;
					(yyval.node) = (Node *)n;
				}
    break;

  case 639:
/* Line 1787 of yacc.c  */
#line 4445 "gram.y"
    {
					CreateTrigStmt *n = makeNode(CreateTrigStmt);
					n->trigname = (yyvsp[(4) - (20)].str);
					n->relation = (yyvsp[(8) - (20)].range);
					n->funcname = (yyvsp[(17) - (20)].list);
					n->args = (yyvsp[(19) - (20)].list);
					n->row = TRUE;
					n->timing = TRIGGER_TYPE_AFTER;
					n->events = intVal(linitial((yyvsp[(6) - (20)].list)));
					n->columns = (List *) lsecond((yyvsp[(6) - (20)].list));
					n->whenClause = (yyvsp[(14) - (20)].node);
					n->isconstraint  = TRUE;
					processCASbits((yyvsp[(10) - (20)].ival), (yylsp[(10) - (20)]), "TRIGGER",
								   &n->deferrable, &n->initdeferred, NULL,
								   NULL, yyscanner);
					n->constrrel = (yyvsp[(9) - (20)].range);
					(yyval.node) = (Node *)n;
				}
    break;

  case 640:
/* Line 1787 of yacc.c  */
#line 4466 "gram.y"
    { (yyval.ival) = TRIGGER_TYPE_BEFORE; }
    break;

  case 641:
/* Line 1787 of yacc.c  */
#line 4467 "gram.y"
    { (yyval.ival) = TRIGGER_TYPE_AFTER; }
    break;

  case 642:
/* Line 1787 of yacc.c  */
#line 4468 "gram.y"
    { (yyval.ival) = TRIGGER_TYPE_INSTEAD; }
    break;

  case 643:
/* Line 1787 of yacc.c  */
#line 4473 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list); }
    break;

  case 644:
/* Line 1787 of yacc.c  */
#line 4475 "gram.y"
    {
					int		events1 = intVal(linitial((yyvsp[(1) - (3)].list)));
					int		events2 = intVal(linitial((yyvsp[(3) - (3)].list)));
					List   *columns1 = (List *) lsecond((yyvsp[(1) - (3)].list));
					List   *columns2 = (List *) lsecond((yyvsp[(3) - (3)].list));

					if (events1 & events2)
						parser_yyerror("duplicate trigger events specified");
					/*
					 * concat'ing the columns lists loses information about
					 * which columns went with which event, but so long as
					 * only UPDATE carries columns and we disallow multiple
					 * UPDATE items, it doesn't matter.  Command execution
					 * should just ignore the columns for non-UPDATE events.
					 */
					(yyval.list) = list_make2(makeInteger(events1 | events2),
									list_concat(columns1, columns2));
				}
    break;

  case 645:
/* Line 1787 of yacc.c  */
#line 4497 "gram.y"
    { (yyval.list) = list_make2(makeInteger(TRIGGER_TYPE_INSERT), NIL); }
    break;

  case 646:
/* Line 1787 of yacc.c  */
#line 4499 "gram.y"
    { (yyval.list) = list_make2(makeInteger(TRIGGER_TYPE_DELETE), NIL); }
    break;

  case 647:
/* Line 1787 of yacc.c  */
#line 4501 "gram.y"
    { (yyval.list) = list_make2(makeInteger(TRIGGER_TYPE_UPDATE), NIL); }
    break;

  case 648:
/* Line 1787 of yacc.c  */
#line 4503 "gram.y"
    { (yyval.list) = list_make2(makeInteger(TRIGGER_TYPE_UPDATE), (yyvsp[(3) - (3)].list)); }
    break;

  case 649:
/* Line 1787 of yacc.c  */
#line 4505 "gram.y"
    { (yyval.list) = list_make2(makeInteger(TRIGGER_TYPE_TRUNCATE), NIL); }
    break;

  case 650:
/* Line 1787 of yacc.c  */
#line 4510 "gram.y"
    {
					(yyval.boolean) = (yyvsp[(3) - (3)].boolean);
				}
    break;

  case 651:
/* Line 1787 of yacc.c  */
#line 4514 "gram.y"
    {
					/*
					 * If ROW/STATEMENT not specified, default to
					 * STATEMENT, per SQL
					 */
					(yyval.boolean) = FALSE;
				}
    break;

  case 652:
/* Line 1787 of yacc.c  */
#line 4524 "gram.y"
    {}
    break;

  case 653:
/* Line 1787 of yacc.c  */
#line 4525 "gram.y"
    {}
    break;

  case 654:
/* Line 1787 of yacc.c  */
#line 4529 "gram.y"
    { (yyval.boolean) = TRUE; }
    break;

  case 655:
/* Line 1787 of yacc.c  */
#line 4530 "gram.y"
    { (yyval.boolean) = FALSE; }
    break;

  case 656:
/* Line 1787 of yacc.c  */
#line 4534 "gram.y"
    { (yyval.node) = (yyvsp[(3) - (4)].node); }
    break;

  case 657:
/* Line 1787 of yacc.c  */
#line 4535 "gram.y"
    { (yyval.node) = NULL; }
    break;

  case 658:
/* Line 1787 of yacc.c  */
#line 4539 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].value)); }
    break;

  case 659:
/* Line 1787 of yacc.c  */
#line 4540 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].value)); }
    break;

  case 660:
/* Line 1787 of yacc.c  */
#line 4541 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 661:
/* Line 1787 of yacc.c  */
#line 4546 "gram.y"
    {
					char buf[64];
					snprintf(buf, sizeof(buf), "%d", (yyvsp[(1) - (1)].ival));
					(yyval.value) = makeString(pstrdup(buf));
				}
    break;

  case 662:
/* Line 1787 of yacc.c  */
#line 4551 "gram.y"
    { (yyval.value) = makeString((yyvsp[(1) - (1)].str)); }
    break;

  case 663:
/* Line 1787 of yacc.c  */
#line 4552 "gram.y"
    { (yyval.value) = makeString((yyvsp[(1) - (1)].str)); }
    break;

  case 664:
/* Line 1787 of yacc.c  */
#line 4553 "gram.y"
    { (yyval.value) = makeString((yyvsp[(1) - (1)].str)); }
    break;

  case 665:
/* Line 1787 of yacc.c  */
#line 4557 "gram.y"
    { (yyval.range) = (yyvsp[(2) - (2)].range); }
    break;

  case 666:
/* Line 1787 of yacc.c  */
#line 4558 "gram.y"
    { (yyval.range) = NULL; }
    break;

  case 667:
/* Line 1787 of yacc.c  */
#line 4563 "gram.y"
    { (yyval.ival) = 0; }
    break;

  case 668:
/* Line 1787 of yacc.c  */
#line 4565 "gram.y"
    {
					/*
					 * We must complain about conflicting options.
					 * We could, but choose not to, complain about redundant
					 * options (ie, where $2's bit is already set in $1).
					 */
					int		newspec = (yyvsp[(1) - (2)].ival) | (yyvsp[(2) - (2)].ival);

					/* special message for this case */
					if ((newspec & (CAS_NOT_DEFERRABLE | CAS_INITIALLY_DEFERRED)) == (CAS_NOT_DEFERRABLE | CAS_INITIALLY_DEFERRED))
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("constraint declared INITIALLY DEFERRED must be DEFERRABLE"),
								 parser_errposition((yylsp[(2) - (2)]))));
					/* generic message for other conflicts */
					if ((newspec & (CAS_NOT_DEFERRABLE | CAS_DEFERRABLE)) == (CAS_NOT_DEFERRABLE | CAS_DEFERRABLE) ||
						(newspec & (CAS_INITIALLY_IMMEDIATE | CAS_INITIALLY_DEFERRED)) == (CAS_INITIALLY_IMMEDIATE | CAS_INITIALLY_DEFERRED))
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("conflicting constraint properties"),
								 parser_errposition((yylsp[(2) - (2)]))));
					(yyval.ival) = newspec;
				}
    break;

  case 669:
/* Line 1787 of yacc.c  */
#line 4591 "gram.y"
    { (yyval.ival) = CAS_NOT_DEFERRABLE; }
    break;

  case 670:
/* Line 1787 of yacc.c  */
#line 4592 "gram.y"
    { (yyval.ival) = CAS_DEFERRABLE; }
    break;

  case 671:
/* Line 1787 of yacc.c  */
#line 4593 "gram.y"
    { (yyval.ival) = CAS_INITIALLY_IMMEDIATE; }
    break;

  case 672:
/* Line 1787 of yacc.c  */
#line 4594 "gram.y"
    { (yyval.ival) = CAS_INITIALLY_DEFERRED; }
    break;

  case 673:
/* Line 1787 of yacc.c  */
#line 4595 "gram.y"
    { (yyval.ival) = CAS_NOT_VALID; }
    break;

  case 674:
/* Line 1787 of yacc.c  */
#line 4596 "gram.y"
    { (yyval.ival) = CAS_NO_INHERIT; }
    break;

  case 675:
/* Line 1787 of yacc.c  */
#line 4602 "gram.y"
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_TRIGGER;
					n->objects = list_make1(lappend((yyvsp[(5) - (6)].list), makeString((yyvsp[(3) - (6)].str))));
					n->arguments = NIL;
					n->behavior = (yyvsp[(6) - (6)].dbehavior);
					n->missing_ok = false;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
    break;

  case 676:
/* Line 1787 of yacc.c  */
#line 4613 "gram.y"
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_TRIGGER;
					n->objects = list_make1(lappend((yyvsp[(7) - (8)].list), makeString((yyvsp[(5) - (8)].str))));
					n->arguments = NIL;
					n->behavior = (yyvsp[(8) - (8)].dbehavior);
					n->missing_ok = true;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
    break;

  case 677:
/* Line 1787 of yacc.c  */
#line 4637 "gram.y"
    {
					CreateEventTrigStmt *n = makeNode(CreateEventTrigStmt);
					n->trigname = (yyvsp[(4) - (11)].str);
					n->eventname = (yyvsp[(6) - (11)].str);
					n->whenclause = NULL;
					n->funcname = (yyvsp[(9) - (11)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 678:
/* Line 1787 of yacc.c  */
#line 4648 "gram.y"
    {
					CreateEventTrigStmt *n = makeNode(CreateEventTrigStmt);
					n->trigname = (yyvsp[(4) - (13)].str);
					n->eventname = (yyvsp[(6) - (13)].str);
					n->whenclause = (yyvsp[(8) - (13)].list);
					n->funcname = (yyvsp[(11) - (13)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 679:
/* Line 1787 of yacc.c  */
#line 4660 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].defelt)); }
    break;

  case 680:
/* Line 1787 of yacc.c  */
#line 4662 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].defelt)); }
    break;

  case 681:
/* Line 1787 of yacc.c  */
#line 4667 "gram.y"
    { (yyval.defelt) = makeDefElem((yyvsp[(1) - (5)].str), (Node *) (yyvsp[(4) - (5)].list)); }
    break;

  case 682:
/* Line 1787 of yacc.c  */
#line 4672 "gram.y"
    { (yyval.list) = list_make1(makeString((yyvsp[(1) - (1)].str))); }
    break;

  case 683:
/* Line 1787 of yacc.c  */
#line 4674 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), makeString((yyvsp[(3) - (3)].str))); }
    break;

  case 684:
/* Line 1787 of yacc.c  */
#line 4679 "gram.y"
    {
					AlterEventTrigStmt *n = makeNode(AlterEventTrigStmt);
					n->trigname = (yyvsp[(4) - (5)].str);
					n->tgenabled = (yyvsp[(5) - (5)].chr);
					(yyval.node) = (Node *) n;
				}
    break;

  case 685:
/* Line 1787 of yacc.c  */
#line 4688 "gram.y"
    { (yyval.chr) = TRIGGER_FIRES_ON_ORIGIN; }
    break;

  case 686:
/* Line 1787 of yacc.c  */
#line 4689 "gram.y"
    { (yyval.chr) = TRIGGER_FIRES_ON_REPLICA; }
    break;

  case 687:
/* Line 1787 of yacc.c  */
#line 4690 "gram.y"
    { (yyval.chr) = TRIGGER_FIRES_ALWAYS; }
    break;

  case 688:
/* Line 1787 of yacc.c  */
#line 4691 "gram.y"
    { (yyval.chr) = TRIGGER_DISABLED; }
    break;

  case 689:
/* Line 1787 of yacc.c  */
#line 4705 "gram.y"
    {
					CreateTrigStmt *n = makeNode(CreateTrigStmt);
					n->trigname = (yyvsp[(3) - (8)].str);
					n->args = list_make1((yyvsp[(6) - (8)].node));
					n->isconstraint  = TRUE;
					processCASbits((yyvsp[(8) - (8)].ival), (yylsp[(8) - (8)]), "ASSERTION",
								   &n->deferrable, &n->initdeferred, NULL,
								   NULL, yyscanner);

					ereport(ERROR,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("CREATE ASSERTION is not yet implemented")));

					(yyval.node) = (Node *)n;
				}
    break;

  case 690:
/* Line 1787 of yacc.c  */
#line 4724 "gram.y"
    {
					DropStmt *n = makeNode(DropStmt);
					n->objects = NIL;
					n->arguments = NIL;
					n->behavior = (yyvsp[(4) - (4)].dbehavior);
					n->removeType = OBJECT_TRIGGER; /* XXX */
					ereport(ERROR,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("DROP ASSERTION is not yet implemented")));
					(yyval.node) = (Node *) n;
				}
    break;

  case 691:
/* Line 1787 of yacc.c  */
#line 4747 "gram.y"
    {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_AGGREGATE;
					n->oldstyle = false;
					n->defnames = (yyvsp[(3) - (5)].list);
					n->args = (yyvsp[(4) - (5)].list);
					n->definition = (yyvsp[(5) - (5)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 692:
/* Line 1787 of yacc.c  */
#line 4757 "gram.y"
    {
					/* old-style (pre-8.2) syntax for CREATE AGGREGATE */
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_AGGREGATE;
					n->oldstyle = true;
					n->defnames = (yyvsp[(3) - (4)].list);
					n->args = NIL;
					n->definition = (yyvsp[(4) - (4)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 693:
/* Line 1787 of yacc.c  */
#line 4768 "gram.y"
    {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_OPERATOR;
					n->oldstyle = false;
					n->defnames = (yyvsp[(3) - (4)].list);
					n->args = NIL;
					n->definition = (yyvsp[(4) - (4)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 694:
/* Line 1787 of yacc.c  */
#line 4778 "gram.y"
    {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_TYPE;
					n->oldstyle = false;
					n->defnames = (yyvsp[(3) - (4)].list);
					n->args = NIL;
					n->definition = (yyvsp[(4) - (4)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 695:
/* Line 1787 of yacc.c  */
#line 4788 "gram.y"
    {
					/* Shell type (identified by lack of definition) */
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_TYPE;
					n->oldstyle = false;
					n->defnames = (yyvsp[(3) - (3)].list);
					n->args = NIL;
					n->definition = NIL;
					(yyval.node) = (Node *)n;
				}
    break;

  case 696:
/* Line 1787 of yacc.c  */
#line 4799 "gram.y"
    {
					CompositeTypeStmt *n = makeNode(CompositeTypeStmt);

					/* can't use qualified_name, sigh */
					n->typevar = makeRangeVarFromAnyName((yyvsp[(3) - (7)].list), (yylsp[(3) - (7)]), yyscanner);
					n->coldeflist = (yyvsp[(6) - (7)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 697:
/* Line 1787 of yacc.c  */
#line 4808 "gram.y"
    {
					CreateEnumStmt *n = makeNode(CreateEnumStmt);
					n->typeName = (yyvsp[(3) - (8)].list);
					n->vals = (yyvsp[(7) - (8)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 698:
/* Line 1787 of yacc.c  */
#line 4815 "gram.y"
    {
					CreateRangeStmt *n = makeNode(CreateRangeStmt);
					n->typeName = (yyvsp[(3) - (6)].list);
					n->params	= (yyvsp[(6) - (6)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 699:
/* Line 1787 of yacc.c  */
#line 4822 "gram.y"
    {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_TSPARSER;
					n->args = NIL;
					n->defnames = (yyvsp[(5) - (6)].list);
					n->definition = (yyvsp[(6) - (6)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 700:
/* Line 1787 of yacc.c  */
#line 4831 "gram.y"
    {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_TSDICTIONARY;
					n->args = NIL;
					n->defnames = (yyvsp[(5) - (6)].list);
					n->definition = (yyvsp[(6) - (6)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 701:
/* Line 1787 of yacc.c  */
#line 4840 "gram.y"
    {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_TSTEMPLATE;
					n->args = NIL;
					n->defnames = (yyvsp[(5) - (6)].list);
					n->definition = (yyvsp[(6) - (6)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 702:
/* Line 1787 of yacc.c  */
#line 4849 "gram.y"
    {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_TSCONFIGURATION;
					n->args = NIL;
					n->defnames = (yyvsp[(5) - (6)].list);
					n->definition = (yyvsp[(6) - (6)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 703:
/* Line 1787 of yacc.c  */
#line 4858 "gram.y"
    {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_COLLATION;
					n->args = NIL;
					n->defnames = (yyvsp[(3) - (4)].list);
					n->definition = (yyvsp[(4) - (4)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 704:
/* Line 1787 of yacc.c  */
#line 4867 "gram.y"
    {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_COLLATION;
					n->args = NIL;
					n->defnames = (yyvsp[(3) - (5)].list);
					n->definition = list_make1(makeDefElem("from", (Node *) (yyvsp[(5) - (5)].list)));
					(yyval.node) = (Node *)n;
				}
    break;

  case 705:
/* Line 1787 of yacc.c  */
#line 4877 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (3)].list); }
    break;

  case 706:
/* Line 1787 of yacc.c  */
#line 4880 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].defelt)); }
    break;

  case 707:
/* Line 1787 of yacc.c  */
#line 4881 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].defelt)); }
    break;

  case 708:
/* Line 1787 of yacc.c  */
#line 4885 "gram.y"
    {
					(yyval.defelt) = makeDefElem((yyvsp[(1) - (3)].str), (Node *) (yyvsp[(3) - (3)].node));
				}
    break;

  case 709:
/* Line 1787 of yacc.c  */
#line 4889 "gram.y"
    {
					(yyval.defelt) = makeDefElem((yyvsp[(1) - (1)].str), NULL);
				}
    break;

  case 710:
/* Line 1787 of yacc.c  */
#line 4895 "gram.y"
    { (yyval.node) = (Node *)(yyvsp[(1) - (1)].typnam); }
    break;

  case 711:
/* Line 1787 of yacc.c  */
#line 4896 "gram.y"
    { (yyval.node) = (Node *)makeString(pstrdup((yyvsp[(1) - (1)].keyword))); }
    break;

  case 712:
/* Line 1787 of yacc.c  */
#line 4897 "gram.y"
    { (yyval.node) = (Node *)(yyvsp[(1) - (1)].list); }
    break;

  case 713:
/* Line 1787 of yacc.c  */
#line 4898 "gram.y"
    { (yyval.node) = (Node *)(yyvsp[(1) - (1)].value); }
    break;

  case 714:
/* Line 1787 of yacc.c  */
#line 4899 "gram.y"
    { (yyval.node) = (Node *)makeString((yyvsp[(1) - (1)].str)); }
    break;

  case 715:
/* Line 1787 of yacc.c  */
#line 4902 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (3)].list); }
    break;

  case 716:
/* Line 1787 of yacc.c  */
#line 4905 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].defelt)); }
    break;

  case 717:
/* Line 1787 of yacc.c  */
#line 4906 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].defelt)); }
    break;

  case 718:
/* Line 1787 of yacc.c  */
#line 4915 "gram.y"
    {
					(yyval.defelt) = makeDefElem((yyvsp[(1) - (3)].str), (Node *)(yyvsp[(3) - (3)].node));
				}
    break;

  case 719:
/* Line 1787 of yacc.c  */
#line 4921 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list); }
    break;

  case 720:
/* Line 1787 of yacc.c  */
#line 4922 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 721:
/* Line 1787 of yacc.c  */
#line 4926 "gram.y"
    { (yyval.list) = list_make1(makeString((yyvsp[(1) - (1)].str))); }
    break;

  case 722:
/* Line 1787 of yacc.c  */
#line 4928 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), makeString((yyvsp[(3) - (3)].str))); }
    break;

  case 723:
/* Line 1787 of yacc.c  */
#line 4939 "gram.y"
    {
				AlterEnumStmt *n = makeNode(AlterEnumStmt);
				n->typeName = (yyvsp[(3) - (7)].list);
				n->newVal = (yyvsp[(7) - (7)].str);
				n->newValNeighbor = NULL;
				n->newValIsAfter = true;
				n->skipIfExists = (yyvsp[(6) - (7)].boolean);
				(yyval.node) = (Node *) n;
			}
    break;

  case 724:
/* Line 1787 of yacc.c  */
#line 4949 "gram.y"
    {
				AlterEnumStmt *n = makeNode(AlterEnumStmt);
				n->typeName = (yyvsp[(3) - (9)].list);
				n->newVal = (yyvsp[(7) - (9)].str);
				n->newValNeighbor = (yyvsp[(9) - (9)].str);
				n->newValIsAfter = false;
				n->skipIfExists = (yyvsp[(6) - (9)].boolean);
				(yyval.node) = (Node *) n;
			}
    break;

  case 725:
/* Line 1787 of yacc.c  */
#line 4959 "gram.y"
    {
				AlterEnumStmt *n = makeNode(AlterEnumStmt);
				n->typeName = (yyvsp[(3) - (9)].list);
				n->newVal = (yyvsp[(7) - (9)].str);
				n->newValNeighbor = (yyvsp[(9) - (9)].str);
				n->newValIsAfter = true;
				n->skipIfExists = (yyvsp[(6) - (9)].boolean);
				(yyval.node) = (Node *) n;
			}
    break;

  case 726:
/* Line 1787 of yacc.c  */
#line 4970 "gram.y"
    { (yyval.boolean) = true; }
    break;

  case 727:
/* Line 1787 of yacc.c  */
#line 4971 "gram.y"
    { (yyval.boolean) = false; }
    break;

  case 728:
/* Line 1787 of yacc.c  */
#line 4989 "gram.y"
    {
					CreateOpClassStmt *n = makeNode(CreateOpClassStmt);
					n->opclassname = (yyvsp[(4) - (13)].list);
					n->isDefault = (yyvsp[(5) - (13)].boolean);
					n->datatype = (yyvsp[(8) - (13)].typnam);
					n->amname = (yyvsp[(10) - (13)].str);
					n->opfamilyname = (yyvsp[(11) - (13)].list);
					n->items = (yyvsp[(13) - (13)].list);
					(yyval.node) = (Node *) n;
				}
    break;

  case 729:
/* Line 1787 of yacc.c  */
#line 5002 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].node)); }
    break;

  case 730:
/* Line 1787 of yacc.c  */
#line 5003 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node)); }
    break;

  case 731:
/* Line 1787 of yacc.c  */
#line 5008 "gram.y"
    {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);
					n->itemtype = OPCLASS_ITEM_OPERATOR;
					n->name = (yyvsp[(3) - (5)].list);
					n->args = NIL;
					n->number = (yyvsp[(2) - (5)].ival);
					n->order_family = (yyvsp[(4) - (5)].list);
					(yyval.node) = (Node *) n;
				}
    break;

  case 732:
/* Line 1787 of yacc.c  */
#line 5019 "gram.y"
    {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);
					n->itemtype = OPCLASS_ITEM_OPERATOR;
					n->name = (yyvsp[(3) - (6)].list);
					n->args = (yyvsp[(4) - (6)].list);
					n->number = (yyvsp[(2) - (6)].ival);
					n->order_family = (yyvsp[(5) - (6)].list);
					(yyval.node) = (Node *) n;
				}
    break;

  case 733:
/* Line 1787 of yacc.c  */
#line 5029 "gram.y"
    {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);
					n->itemtype = OPCLASS_ITEM_FUNCTION;
					n->name = (yyvsp[(3) - (4)].list);
					n->args = extractArgTypes((yyvsp[(4) - (4)].list));
					n->number = (yyvsp[(2) - (4)].ival);
					(yyval.node) = (Node *) n;
				}
    break;

  case 734:
/* Line 1787 of yacc.c  */
#line 5038 "gram.y"
    {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);
					n->itemtype = OPCLASS_ITEM_FUNCTION;
					n->name = (yyvsp[(6) - (7)].list);
					n->args = extractArgTypes((yyvsp[(7) - (7)].list));
					n->number = (yyvsp[(2) - (7)].ival);
					n->class_args = (yyvsp[(4) - (7)].list);
					(yyval.node) = (Node *) n;
				}
    break;

  case 735:
/* Line 1787 of yacc.c  */
#line 5048 "gram.y"
    {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);
					n->itemtype = OPCLASS_ITEM_STORAGETYPE;
					n->storedtype = (yyvsp[(2) - (2)].typnam);
					(yyval.node) = (Node *) n;
				}
    break;

  case 736:
/* Line 1787 of yacc.c  */
#line 5056 "gram.y"
    { (yyval.boolean) = TRUE; }
    break;

  case 737:
/* Line 1787 of yacc.c  */
#line 5057 "gram.y"
    { (yyval.boolean) = FALSE; }
    break;

  case 738:
/* Line 1787 of yacc.c  */
#line 5060 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (2)].list); }
    break;

  case 739:
/* Line 1787 of yacc.c  */
#line 5061 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 740:
/* Line 1787 of yacc.c  */
#line 5064 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 741:
/* Line 1787 of yacc.c  */
#line 5065 "gram.y"
    { (yyval.list) = (yyvsp[(4) - (4)].list); }
    break;

  case 742:
/* Line 1787 of yacc.c  */
#line 5066 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 743:
/* Line 1787 of yacc.c  */
#line 5070 "gram.y"
    {
					/*
					 * RECHECK no longer does anything in opclass definitions,
					 * but we still accept it to ease porting of old database
					 * dumps.
					 */
					ereport(NOTICE,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("RECHECK is no longer required"),
							 errhint("Update your data type."),
							 parser_errposition((yylsp[(1) - (1)]))));
					(yyval.boolean) = TRUE;
				}
    break;

  case 744:
/* Line 1787 of yacc.c  */
#line 5083 "gram.y"
    { (yyval.boolean) = FALSE; }
    break;

  case 745:
/* Line 1787 of yacc.c  */
#line 5089 "gram.y"
    {
					CreateOpFamilyStmt *n = makeNode(CreateOpFamilyStmt);
					n->opfamilyname = (yyvsp[(4) - (6)].list);
					n->amname = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *) n;
				}
    break;

  case 746:
/* Line 1787 of yacc.c  */
#line 5099 "gram.y"
    {
					AlterOpFamilyStmt *n = makeNode(AlterOpFamilyStmt);
					n->opfamilyname = (yyvsp[(4) - (8)].list);
					n->amname = (yyvsp[(6) - (8)].str);
					n->isDrop = false;
					n->items = (yyvsp[(8) - (8)].list);
					(yyval.node) = (Node *) n;
				}
    break;

  case 747:
/* Line 1787 of yacc.c  */
#line 5108 "gram.y"
    {
					AlterOpFamilyStmt *n = makeNode(AlterOpFamilyStmt);
					n->opfamilyname = (yyvsp[(4) - (8)].list);
					n->amname = (yyvsp[(6) - (8)].str);
					n->isDrop = true;
					n->items = (yyvsp[(8) - (8)].list);
					(yyval.node) = (Node *) n;
				}
    break;

  case 748:
/* Line 1787 of yacc.c  */
#line 5119 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].node)); }
    break;

  case 749:
/* Line 1787 of yacc.c  */
#line 5120 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node)); }
    break;

  case 750:
/* Line 1787 of yacc.c  */
#line 5125 "gram.y"
    {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);
					n->itemtype = OPCLASS_ITEM_OPERATOR;
					n->number = (yyvsp[(2) - (5)].ival);
					n->args = (yyvsp[(4) - (5)].list);
					(yyval.node) = (Node *) n;
				}
    break;

  case 751:
/* Line 1787 of yacc.c  */
#line 5133 "gram.y"
    {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);
					n->itemtype = OPCLASS_ITEM_FUNCTION;
					n->number = (yyvsp[(2) - (5)].ival);
					n->args = (yyvsp[(4) - (5)].list);
					(yyval.node) = (Node *) n;
				}
    break;

  case 752:
/* Line 1787 of yacc.c  */
#line 5145 "gram.y"
    {
					DropStmt *n = makeNode(DropStmt);
					n->objects = list_make1((yyvsp[(4) - (7)].list));
					n->arguments = list_make1(list_make1(makeString((yyvsp[(6) - (7)].str))));
					n->removeType = OBJECT_OPCLASS;
					n->behavior = (yyvsp[(7) - (7)].dbehavior);
					n->missing_ok = false;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
    break;

  case 753:
/* Line 1787 of yacc.c  */
#line 5156 "gram.y"
    {
					DropStmt *n = makeNode(DropStmt);
					n->objects = list_make1((yyvsp[(6) - (9)].list));
					n->arguments = list_make1(list_make1(makeString((yyvsp[(8) - (9)].str))));
					n->removeType = OBJECT_OPCLASS;
					n->behavior = (yyvsp[(9) - (9)].dbehavior);
					n->missing_ok = true;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
    break;

  case 754:
/* Line 1787 of yacc.c  */
#line 5170 "gram.y"
    {
					DropStmt *n = makeNode(DropStmt);
					n->objects = list_make1((yyvsp[(4) - (7)].list));
					n->arguments = list_make1(list_make1(makeString((yyvsp[(6) - (7)].str))));
					n->removeType = OBJECT_OPFAMILY;
					n->behavior = (yyvsp[(7) - (7)].dbehavior);
					n->missing_ok = false;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
    break;

  case 755:
/* Line 1787 of yacc.c  */
#line 5181 "gram.y"
    {
					DropStmt *n = makeNode(DropStmt);
					n->objects = list_make1((yyvsp[(6) - (9)].list));
					n->arguments = list_make1(list_make1(makeString((yyvsp[(8) - (9)].str))));
					n->removeType = OBJECT_OPFAMILY;
					n->behavior = (yyvsp[(9) - (9)].dbehavior);
					n->missing_ok = true;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
    break;

  case 756:
/* Line 1787 of yacc.c  */
#line 5204 "gram.y"
    {
					DropOwnedStmt *n = makeNode(DropOwnedStmt);
					n->roles = (yyvsp[(4) - (5)].list);
					n->behavior = (yyvsp[(5) - (5)].dbehavior);
					(yyval.node) = (Node *)n;
				}
    break;

  case 757:
/* Line 1787 of yacc.c  */
#line 5214 "gram.y"
    {
					ReassignOwnedStmt *n = makeNode(ReassignOwnedStmt);
					n->roles = (yyvsp[(4) - (6)].list);
					n->newrole = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 758:
/* Line 1787 of yacc.c  */
#line 5232 "gram.y"
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = (yyvsp[(2) - (6)].objtype);
					n->missing_ok = TRUE;
					n->objects = (yyvsp[(5) - (6)].list);
					n->arguments = NIL;
					n->behavior = (yyvsp[(6) - (6)].dbehavior);
					n->concurrent = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 759:
/* Line 1787 of yacc.c  */
#line 5243 "gram.y"
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = (yyvsp[(2) - (4)].objtype);
					n->missing_ok = FALSE;
					n->objects = (yyvsp[(3) - (4)].list);
					n->arguments = NIL;
					n->behavior = (yyvsp[(4) - (4)].dbehavior);
					n->concurrent = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 760:
/* Line 1787 of yacc.c  */
#line 5254 "gram.y"
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_INDEX;
					n->missing_ok = FALSE;
					n->objects = (yyvsp[(4) - (5)].list);
					n->arguments = NIL;
					n->behavior = (yyvsp[(5) - (5)].dbehavior);
					n->concurrent = true;
					(yyval.node) = (Node *)n;
				}
    break;

  case 761:
/* Line 1787 of yacc.c  */
#line 5265 "gram.y"
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_INDEX;
					n->missing_ok = TRUE;
					n->objects = (yyvsp[(6) - (7)].list);
					n->arguments = NIL;
					n->behavior = (yyvsp[(7) - (7)].dbehavior);
					n->concurrent = true;
					(yyval.node) = (Node *)n;
				}
    break;

  case 762:
/* Line 1787 of yacc.c  */
#line 5278 "gram.y"
    { (yyval.objtype) = OBJECT_TABLE; }
    break;

  case 763:
/* Line 1787 of yacc.c  */
#line 5279 "gram.y"
    { (yyval.objtype) = OBJECT_SEQUENCE; }
    break;

  case 764:
/* Line 1787 of yacc.c  */
#line 5280 "gram.y"
    { (yyval.objtype) = OBJECT_VIEW; }
    break;

  case 765:
/* Line 1787 of yacc.c  */
#line 5281 "gram.y"
    { (yyval.objtype) = OBJECT_MATVIEW; }
    break;

  case 766:
/* Line 1787 of yacc.c  */
#line 5282 "gram.y"
    { (yyval.objtype) = OBJECT_INDEX; }
    break;

  case 767:
/* Line 1787 of yacc.c  */
#line 5283 "gram.y"
    { (yyval.objtype) = OBJECT_FOREIGN_TABLE; }
    break;

  case 768:
/* Line 1787 of yacc.c  */
#line 5284 "gram.y"
    { (yyval.objtype) = OBJECT_EVENT_TRIGGER; }
    break;

  case 769:
/* Line 1787 of yacc.c  */
#line 5285 "gram.y"
    { (yyval.objtype) = OBJECT_TYPE; }
    break;

  case 770:
/* Line 1787 of yacc.c  */
#line 5286 "gram.y"
    { (yyval.objtype) = OBJECT_DOMAIN; }
    break;

  case 771:
/* Line 1787 of yacc.c  */
#line 5287 "gram.y"
    { (yyval.objtype) = OBJECT_COLLATION; }
    break;

  case 772:
/* Line 1787 of yacc.c  */
#line 5288 "gram.y"
    { (yyval.objtype) = OBJECT_CONVERSION; }
    break;

  case 773:
/* Line 1787 of yacc.c  */
#line 5289 "gram.y"
    { (yyval.objtype) = OBJECT_SCHEMA; }
    break;

  case 774:
/* Line 1787 of yacc.c  */
#line 5290 "gram.y"
    { (yyval.objtype) = OBJECT_EXTENSION; }
    break;

  case 775:
/* Line 1787 of yacc.c  */
#line 5291 "gram.y"
    { (yyval.objtype) = OBJECT_TSPARSER; }
    break;

  case 776:
/* Line 1787 of yacc.c  */
#line 5292 "gram.y"
    { (yyval.objtype) = OBJECT_TSDICTIONARY; }
    break;

  case 777:
/* Line 1787 of yacc.c  */
#line 5293 "gram.y"
    { (yyval.objtype) = OBJECT_TSTEMPLATE; }
    break;

  case 778:
/* Line 1787 of yacc.c  */
#line 5294 "gram.y"
    { (yyval.objtype) = OBJECT_TSCONFIGURATION; }
    break;

  case 779:
/* Line 1787 of yacc.c  */
#line 5298 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].list)); }
    break;

  case 780:
/* Line 1787 of yacc.c  */
#line 5299 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].list)); }
    break;

  case 781:
/* Line 1787 of yacc.c  */
#line 5302 "gram.y"
    { (yyval.list) = list_make1(makeString((yyvsp[(1) - (1)].str))); }
    break;

  case 782:
/* Line 1787 of yacc.c  */
#line 5303 "gram.y"
    { (yyval.list) = lcons(makeString((yyvsp[(1) - (2)].str)), (yyvsp[(2) - (2)].list)); }
    break;

  case 783:
/* Line 1787 of yacc.c  */
#line 5307 "gram.y"
    { (yyval.list) = list_make1(makeString((yyvsp[(2) - (2)].str))); }
    break;

  case 784:
/* Line 1787 of yacc.c  */
#line 5309 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), makeString((yyvsp[(3) - (3)].str))); }
    break;

  case 785:
/* Line 1787 of yacc.c  */
#line 5322 "gram.y"
    {
					TruncateStmt *n = makeNode(TruncateStmt);
					n->relations = (yyvsp[(3) - (5)].list);
					n->restart_seqs = (yyvsp[(4) - (5)].boolean);
					n->behavior = (yyvsp[(5) - (5)].dbehavior);
					(yyval.node) = (Node *)n;
				}
    break;

  case 786:
/* Line 1787 of yacc.c  */
#line 5332 "gram.y"
    { (yyval.boolean) = false; }
    break;

  case 787:
/* Line 1787 of yacc.c  */
#line 5333 "gram.y"
    { (yyval.boolean) = true; }
    break;

  case 788:
/* Line 1787 of yacc.c  */
#line 5334 "gram.y"
    { (yyval.boolean) = false; }
    break;

  case 789:
/* Line 1787 of yacc.c  */
#line 5367 "gram.y"
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = (yyvsp[(3) - (6)].objtype);
					n->objname = (yyvsp[(4) - (6)].list);
					n->objargs = NIL;
					n->comment = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *) n;
				}
    break;

  case 790:
/* Line 1787 of yacc.c  */
#line 5376 "gram.y"
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_AGGREGATE;
					n->objname = (yyvsp[(4) - (7)].list);
					n->objargs = extractAggrArgTypes((yyvsp[(5) - (7)].list));
					n->comment = (yyvsp[(7) - (7)].str);
					(yyval.node) = (Node *) n;
				}
    break;

  case 791:
/* Line 1787 of yacc.c  */
#line 5385 "gram.y"
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_FUNCTION;
					n->objname = (yyvsp[(4) - (7)].list);
					n->objargs = extractArgTypes((yyvsp[(5) - (7)].list));
					n->comment = (yyvsp[(7) - (7)].str);
					(yyval.node) = (Node *) n;
				}
    break;

  case 792:
/* Line 1787 of yacc.c  */
#line 5394 "gram.y"
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_OPERATOR;
					n->objname = (yyvsp[(4) - (7)].list);
					n->objargs = (yyvsp[(5) - (7)].list);
					n->comment = (yyvsp[(7) - (7)].str);
					(yyval.node) = (Node *) n;
				}
    break;

  case 793:
/* Line 1787 of yacc.c  */
#line 5403 "gram.y"
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_CONSTRAINT;
					n->objname = lappend((yyvsp[(6) - (8)].list), makeString((yyvsp[(4) - (8)].str)));
					n->objargs = NIL;
					n->comment = (yyvsp[(8) - (8)].str);
					(yyval.node) = (Node *) n;
				}
    break;

  case 794:
/* Line 1787 of yacc.c  */
#line 5412 "gram.y"
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_RULE;
					n->objname = lappend((yyvsp[(6) - (8)].list), makeString((yyvsp[(4) - (8)].str)));
					n->objargs = NIL;
					n->comment = (yyvsp[(8) - (8)].str);
					(yyval.node) = (Node *) n;
				}
    break;

  case 795:
/* Line 1787 of yacc.c  */
#line 5421 "gram.y"
    {
					/* Obsolete syntax supported for awhile for compatibility */
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_RULE;
					n->objname = list_make1(makeString((yyvsp[(4) - (6)].str)));
					n->objargs = NIL;
					n->comment = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *) n;
				}
    break;

  case 796:
/* Line 1787 of yacc.c  */
#line 5431 "gram.y"
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_TRIGGER;
					n->objname = lappend((yyvsp[(6) - (8)].list), makeString((yyvsp[(4) - (8)].str)));
					n->objargs = NIL;
					n->comment = (yyvsp[(8) - (8)].str);
					(yyval.node) = (Node *) n;
				}
    break;

  case 797:
/* Line 1787 of yacc.c  */
#line 5440 "gram.y"
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_OPCLASS;
					n->objname = (yyvsp[(5) - (9)].list);
					n->objargs = list_make1(makeString((yyvsp[(7) - (9)].str)));
					n->comment = (yyvsp[(9) - (9)].str);
					(yyval.node) = (Node *) n;
				}
    break;

  case 798:
/* Line 1787 of yacc.c  */
#line 5449 "gram.y"
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_OPFAMILY;
					n->objname = (yyvsp[(5) - (9)].list);
					n->objargs = list_make1(makeString((yyvsp[(7) - (9)].str)));
					n->comment = (yyvsp[(9) - (9)].str);
					(yyval.node) = (Node *) n;
				}
    break;

  case 799:
/* Line 1787 of yacc.c  */
#line 5458 "gram.y"
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_LARGEOBJECT;
					n->objname = list_make1((yyvsp[(5) - (7)].value));
					n->objargs = NIL;
					n->comment = (yyvsp[(7) - (7)].str);
					(yyval.node) = (Node *) n;
				}
    break;

  case 800:
/* Line 1787 of yacc.c  */
#line 5467 "gram.y"
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_CAST;
					n->objname = list_make1((yyvsp[(5) - (10)].typnam));
					n->objargs = list_make1((yyvsp[(7) - (10)].typnam));
					n->comment = (yyvsp[(10) - (10)].str);
					(yyval.node) = (Node *) n;
				}
    break;

  case 801:
/* Line 1787 of yacc.c  */
#line 5476 "gram.y"
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_LANGUAGE;
					n->objname = (yyvsp[(5) - (7)].list);
					n->objargs = NIL;
					n->comment = (yyvsp[(7) - (7)].str);
					(yyval.node) = (Node *) n;
				}
    break;

  case 802:
/* Line 1787 of yacc.c  */
#line 5487 "gram.y"
    { (yyval.objtype) = OBJECT_COLUMN; }
    break;

  case 803:
/* Line 1787 of yacc.c  */
#line 5488 "gram.y"
    { (yyval.objtype) = OBJECT_DATABASE; }
    break;

  case 804:
/* Line 1787 of yacc.c  */
#line 5489 "gram.y"
    { (yyval.objtype) = OBJECT_SCHEMA; }
    break;

  case 805:
/* Line 1787 of yacc.c  */
#line 5490 "gram.y"
    { (yyval.objtype) = OBJECT_INDEX; }
    break;

  case 806:
/* Line 1787 of yacc.c  */
#line 5491 "gram.y"
    { (yyval.objtype) = OBJECT_SEQUENCE; }
    break;

  case 807:
/* Line 1787 of yacc.c  */
#line 5492 "gram.y"
    { (yyval.objtype) = OBJECT_TABLE; }
    break;

  case 808:
/* Line 1787 of yacc.c  */
#line 5493 "gram.y"
    { (yyval.objtype) = OBJECT_DOMAIN; }
    break;

  case 809:
/* Line 1787 of yacc.c  */
#line 5494 "gram.y"
    { (yyval.objtype) = OBJECT_TYPE; }
    break;

  case 810:
/* Line 1787 of yacc.c  */
#line 5495 "gram.y"
    { (yyval.objtype) = OBJECT_VIEW; }
    break;

  case 811:
/* Line 1787 of yacc.c  */
#line 5496 "gram.y"
    { (yyval.objtype) = OBJECT_MATVIEW; }
    break;

  case 812:
/* Line 1787 of yacc.c  */
#line 5497 "gram.y"
    { (yyval.objtype) = OBJECT_COLLATION; }
    break;

  case 813:
/* Line 1787 of yacc.c  */
#line 5498 "gram.y"
    { (yyval.objtype) = OBJECT_CONVERSION; }
    break;

  case 814:
/* Line 1787 of yacc.c  */
#line 5499 "gram.y"
    { (yyval.objtype) = OBJECT_TABLESPACE; }
    break;

  case 815:
/* Line 1787 of yacc.c  */
#line 5500 "gram.y"
    { (yyval.objtype) = OBJECT_EXTENSION; }
    break;

  case 816:
/* Line 1787 of yacc.c  */
#line 5501 "gram.y"
    { (yyval.objtype) = OBJECT_ROLE; }
    break;

  case 817:
/* Line 1787 of yacc.c  */
#line 5502 "gram.y"
    { (yyval.objtype) = OBJECT_FOREIGN_TABLE; }
    break;

  case 818:
/* Line 1787 of yacc.c  */
#line 5503 "gram.y"
    { (yyval.objtype) = OBJECT_FOREIGN_SERVER; }
    break;

  case 819:
/* Line 1787 of yacc.c  */
#line 5504 "gram.y"
    { (yyval.objtype) = OBJECT_FDW; }
    break;

  case 820:
/* Line 1787 of yacc.c  */
#line 5505 "gram.y"
    { (yyval.objtype) = OBJECT_EVENT_TRIGGER; }
    break;

  case 821:
/* Line 1787 of yacc.c  */
#line 5506 "gram.y"
    { (yyval.objtype) = OBJECT_TSCONFIGURATION; }
    break;

  case 822:
/* Line 1787 of yacc.c  */
#line 5507 "gram.y"
    { (yyval.objtype) = OBJECT_TSDICTIONARY; }
    break;

  case 823:
/* Line 1787 of yacc.c  */
#line 5508 "gram.y"
    { (yyval.objtype) = OBJECT_TSPARSER; }
    break;

  case 824:
/* Line 1787 of yacc.c  */
#line 5509 "gram.y"
    { (yyval.objtype) = OBJECT_TSTEMPLATE; }
    break;

  case 825:
/* Line 1787 of yacc.c  */
#line 5513 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); }
    break;

  case 826:
/* Line 1787 of yacc.c  */
#line 5514 "gram.y"
    { (yyval.str) = NULL; }
    break;

  case 827:
/* Line 1787 of yacc.c  */
#line 5530 "gram.y"
    {
					SecLabelStmt *n = makeNode(SecLabelStmt);
					n->provider = (yyvsp[(3) - (8)].str);
					n->objtype = (yyvsp[(5) - (8)].objtype);
					n->objname = (yyvsp[(6) - (8)].list);
					n->objargs = NIL;
					n->label = (yyvsp[(8) - (8)].str);
					(yyval.node) = (Node *) n;
				}
    break;

  case 828:
/* Line 1787 of yacc.c  */
#line 5541 "gram.y"
    {
					SecLabelStmt *n = makeNode(SecLabelStmt);
					n->provider = (yyvsp[(3) - (9)].str);
					n->objtype = OBJECT_AGGREGATE;
					n->objname = (yyvsp[(6) - (9)].list);
					n->objargs = extractAggrArgTypes((yyvsp[(7) - (9)].list));
					n->label = (yyvsp[(9) - (9)].str);
					(yyval.node) = (Node *) n;
				}
    break;

  case 829:
/* Line 1787 of yacc.c  */
#line 5552 "gram.y"
    {
					SecLabelStmt *n = makeNode(SecLabelStmt);
					n->provider = (yyvsp[(3) - (9)].str);
					n->objtype = OBJECT_FUNCTION;
					n->objname = (yyvsp[(6) - (9)].list);
					n->objargs = extractArgTypes((yyvsp[(7) - (9)].list));
					n->label = (yyvsp[(9) - (9)].str);
					(yyval.node) = (Node *) n;
				}
    break;

  case 830:
/* Line 1787 of yacc.c  */
#line 5563 "gram.y"
    {
					SecLabelStmt *n = makeNode(SecLabelStmt);
					n->provider = (yyvsp[(3) - (9)].str);
					n->objtype = OBJECT_LARGEOBJECT;
					n->objname = list_make1((yyvsp[(7) - (9)].value));
					n->objargs = NIL;
					n->label = (yyvsp[(9) - (9)].str);
					(yyval.node) = (Node *) n;
				}
    break;

  case 831:
/* Line 1787 of yacc.c  */
#line 5574 "gram.y"
    {
					SecLabelStmt *n = makeNode(SecLabelStmt);
					n->provider = (yyvsp[(3) - (9)].str);
					n->objtype = OBJECT_LANGUAGE;
					n->objname = (yyvsp[(7) - (9)].list);
					n->objargs = NIL;
					n->label = (yyvsp[(9) - (9)].str);
					(yyval.node) = (Node *) n;
				}
    break;

  case 832:
/* Line 1787 of yacc.c  */
#line 5585 "gram.y"
    { (yyval.str) = (yyvsp[(2) - (2)].str); }
    break;

  case 833:
/* Line 1787 of yacc.c  */
#line 5586 "gram.y"
    { (yyval.str) = NULL; }
    break;

  case 834:
/* Line 1787 of yacc.c  */
#line 5590 "gram.y"
    { (yyval.objtype) = OBJECT_COLUMN; }
    break;

  case 835:
/* Line 1787 of yacc.c  */
#line 5591 "gram.y"
    { (yyval.objtype) = OBJECT_DATABASE; }
    break;

  case 836:
/* Line 1787 of yacc.c  */
#line 5592 "gram.y"
    { (yyval.objtype) = OBJECT_EVENT_TRIGGER; }
    break;

  case 837:
/* Line 1787 of yacc.c  */
#line 5593 "gram.y"
    { (yyval.objtype) = OBJECT_FOREIGN_TABLE; }
    break;

  case 838:
/* Line 1787 of yacc.c  */
#line 5594 "gram.y"
    { (yyval.objtype) = OBJECT_SCHEMA; }
    break;

  case 839:
/* Line 1787 of yacc.c  */
#line 5595 "gram.y"
    { (yyval.objtype) = OBJECT_SEQUENCE; }
    break;

  case 840:
/* Line 1787 of yacc.c  */
#line 5596 "gram.y"
    { (yyval.objtype) = OBJECT_TABLE; }
    break;

  case 841:
/* Line 1787 of yacc.c  */
#line 5597 "gram.y"
    { (yyval.objtype) = OBJECT_TYPE; }
    break;

  case 842:
/* Line 1787 of yacc.c  */
#line 5598 "gram.y"
    { (yyval.objtype) = OBJECT_ROLE; }
    break;

  case 843:
/* Line 1787 of yacc.c  */
#line 5599 "gram.y"
    { (yyval.objtype) = OBJECT_TABLESPACE; }
    break;

  case 844:
/* Line 1787 of yacc.c  */
#line 5600 "gram.y"
    { (yyval.objtype) = OBJECT_TYPE; }
    break;

  case 845:
/* Line 1787 of yacc.c  */
#line 5601 "gram.y"
    { (yyval.objtype) = OBJECT_VIEW; }
    break;

  case 846:
/* Line 1787 of yacc.c  */
#line 5602 "gram.y"
    { (yyval.objtype) = OBJECT_MATVIEW; }
    break;

  case 847:
/* Line 1787 of yacc.c  */
#line 5605 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); }
    break;

  case 848:
/* Line 1787 of yacc.c  */
#line 5606 "gram.y"
    { (yyval.str) = NULL; }
    break;

  case 849:
/* Line 1787 of yacc.c  */
#line 5617 "gram.y"
    {
					FetchStmt *n = (FetchStmt *) (yyvsp[(2) - (2)].node);
					n->ismove = FALSE;
					(yyval.node) = (Node *)n;
				}
    break;

  case 850:
/* Line 1787 of yacc.c  */
#line 5623 "gram.y"
    {
					FetchStmt *n = (FetchStmt *) (yyvsp[(2) - (2)].node);
					n->ismove = TRUE;
					(yyval.node) = (Node *)n;
				}
    break;

  case 851:
/* Line 1787 of yacc.c  */
#line 5631 "gram.y"
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[(1) - (1)].str);
					n->direction = FETCH_FORWARD;
					n->howMany = 1;
					(yyval.node) = (Node *)n;
				}
    break;

  case 852:
/* Line 1787 of yacc.c  */
#line 5639 "gram.y"
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[(2) - (2)].str);
					n->direction = FETCH_FORWARD;
					n->howMany = 1;
					(yyval.node) = (Node *)n;
				}
    break;

  case 853:
/* Line 1787 of yacc.c  */
#line 5647 "gram.y"
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[(3) - (3)].str);
					n->direction = FETCH_FORWARD;
					n->howMany = 1;
					(yyval.node) = (Node *)n;
				}
    break;

  case 854:
/* Line 1787 of yacc.c  */
#line 5655 "gram.y"
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[(3) - (3)].str);
					n->direction = FETCH_BACKWARD;
					n->howMany = 1;
					(yyval.node) = (Node *)n;
				}
    break;

  case 855:
/* Line 1787 of yacc.c  */
#line 5663 "gram.y"
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[(3) - (3)].str);
					n->direction = FETCH_ABSOLUTE;
					n->howMany = 1;
					(yyval.node) = (Node *)n;
				}
    break;

  case 856:
/* Line 1787 of yacc.c  */
#line 5671 "gram.y"
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[(3) - (3)].str);
					n->direction = FETCH_ABSOLUTE;
					n->howMany = -1;
					(yyval.node) = (Node *)n;
				}
    break;

  case 857:
/* Line 1787 of yacc.c  */
#line 5679 "gram.y"
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[(4) - (4)].str);
					n->direction = FETCH_ABSOLUTE;
					n->howMany = (yyvsp[(2) - (4)].ival);
					(yyval.node) = (Node *)n;
				}
    break;

  case 858:
/* Line 1787 of yacc.c  */
#line 5687 "gram.y"
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[(4) - (4)].str);
					n->direction = FETCH_RELATIVE;
					n->howMany = (yyvsp[(2) - (4)].ival);
					(yyval.node) = (Node *)n;
				}
    break;

  case 859:
/* Line 1787 of yacc.c  */
#line 5695 "gram.y"
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[(3) - (3)].str);
					n->direction = FETCH_FORWARD;
					n->howMany = (yyvsp[(1) - (3)].ival);
					(yyval.node) = (Node *)n;
				}
    break;

  case 860:
/* Line 1787 of yacc.c  */
#line 5703 "gram.y"
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[(3) - (3)].str);
					n->direction = FETCH_FORWARD;
					n->howMany = FETCH_ALL;
					(yyval.node) = (Node *)n;
				}
    break;

  case 861:
/* Line 1787 of yacc.c  */
#line 5711 "gram.y"
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[(3) - (3)].str);
					n->direction = FETCH_FORWARD;
					n->howMany = 1;
					(yyval.node) = (Node *)n;
				}
    break;

  case 862:
/* Line 1787 of yacc.c  */
#line 5719 "gram.y"
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[(4) - (4)].str);
					n->direction = FETCH_FORWARD;
					n->howMany = (yyvsp[(2) - (4)].ival);
					(yyval.node) = (Node *)n;
				}
    break;

  case 863:
/* Line 1787 of yacc.c  */
#line 5727 "gram.y"
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[(4) - (4)].str);
					n->direction = FETCH_FORWARD;
					n->howMany = FETCH_ALL;
					(yyval.node) = (Node *)n;
				}
    break;

  case 864:
/* Line 1787 of yacc.c  */
#line 5735 "gram.y"
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[(3) - (3)].str);
					n->direction = FETCH_BACKWARD;
					n->howMany = 1;
					(yyval.node) = (Node *)n;
				}
    break;

  case 865:
/* Line 1787 of yacc.c  */
#line 5743 "gram.y"
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[(4) - (4)].str);
					n->direction = FETCH_BACKWARD;
					n->howMany = (yyvsp[(2) - (4)].ival);
					(yyval.node) = (Node *)n;
				}
    break;

  case 866:
/* Line 1787 of yacc.c  */
#line 5751 "gram.y"
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[(4) - (4)].str);
					n->direction = FETCH_BACKWARD;
					n->howMany = FETCH_ALL;
					(yyval.node) = (Node *)n;
				}
    break;

  case 867:
/* Line 1787 of yacc.c  */
#line 5760 "gram.y"
    {}
    break;

  case 868:
/* Line 1787 of yacc.c  */
#line 5761 "gram.y"
    {}
    break;

  case 869:
/* Line 1787 of yacc.c  */
#line 5764 "gram.y"
    {}
    break;

  case 870:
/* Line 1787 of yacc.c  */
#line 5765 "gram.y"
    {}
    break;

  case 871:
/* Line 1787 of yacc.c  */
#line 5777 "gram.y"
    {
					GrantStmt *n = makeNode(GrantStmt);
					n->is_grant = true;
					n->privileges = (yyvsp[(2) - (7)].list);
					n->targtype = ((yyvsp[(4) - (7)].privtarget))->targtype;
					n->objtype = ((yyvsp[(4) - (7)].privtarget))->objtype;
					n->objects = ((yyvsp[(4) - (7)].privtarget))->objs;
					n->grantees = (yyvsp[(6) - (7)].list);
					n->grant_option = (yyvsp[(7) - (7)].boolean);
					(yyval.node) = (Node*)n;
				}
    break;

  case 872:
/* Line 1787 of yacc.c  */
#line 5793 "gram.y"
    {
					GrantStmt *n = makeNode(GrantStmt);
					n->is_grant = false;
					n->grant_option = false;
					n->privileges = (yyvsp[(2) - (7)].list);
					n->targtype = ((yyvsp[(4) - (7)].privtarget))->targtype;
					n->objtype = ((yyvsp[(4) - (7)].privtarget))->objtype;
					n->objects = ((yyvsp[(4) - (7)].privtarget))->objs;
					n->grantees = (yyvsp[(6) - (7)].list);
					n->behavior = (yyvsp[(7) - (7)].dbehavior);
					(yyval.node) = (Node *)n;
				}
    break;

  case 873:
/* Line 1787 of yacc.c  */
#line 5807 "gram.y"
    {
					GrantStmt *n = makeNode(GrantStmt);
					n->is_grant = false;
					n->grant_option = true;
					n->privileges = (yyvsp[(5) - (10)].list);
					n->targtype = ((yyvsp[(7) - (10)].privtarget))->targtype;
					n->objtype = ((yyvsp[(7) - (10)].privtarget))->objtype;
					n->objects = ((yyvsp[(7) - (10)].privtarget))->objs;
					n->grantees = (yyvsp[(9) - (10)].list);
					n->behavior = (yyvsp[(10) - (10)].dbehavior);
					(yyval.node) = (Node *)n;
				}
    break;

  case 874:
/* Line 1787 of yacc.c  */
#line 5832 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list); }
    break;

  case 875:
/* Line 1787 of yacc.c  */
#line 5834 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 876:
/* Line 1787 of yacc.c  */
#line 5836 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 877:
/* Line 1787 of yacc.c  */
#line 5838 "gram.y"
    {
					AccessPriv *n = makeNode(AccessPriv);
					n->priv_name = NULL;
					n->cols = (yyvsp[(3) - (4)].list);
					(yyval.list) = list_make1(n);
				}
    break;

  case 878:
/* Line 1787 of yacc.c  */
#line 5845 "gram.y"
    {
					AccessPriv *n = makeNode(AccessPriv);
					n->priv_name = NULL;
					n->cols = (yyvsp[(4) - (5)].list);
					(yyval.list) = list_make1(n);
				}
    break;

  case 879:
/* Line 1787 of yacc.c  */
#line 5853 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].accesspriv)); }
    break;

  case 880:
/* Line 1787 of yacc.c  */
#line 5854 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].accesspriv)); }
    break;

  case 881:
/* Line 1787 of yacc.c  */
#line 5858 "gram.y"
    {
				AccessPriv *n = makeNode(AccessPriv);
				n->priv_name = pstrdup((yyvsp[(1) - (2)].keyword));
				n->cols = (yyvsp[(2) - (2)].list);
				(yyval.accesspriv) = n;
			}
    break;

  case 882:
/* Line 1787 of yacc.c  */
#line 5865 "gram.y"
    {
				AccessPriv *n = makeNode(AccessPriv);
				n->priv_name = pstrdup((yyvsp[(1) - (2)].keyword));
				n->cols = (yyvsp[(2) - (2)].list);
				(yyval.accesspriv) = n;
			}
    break;

  case 883:
/* Line 1787 of yacc.c  */
#line 5872 "gram.y"
    {
				AccessPriv *n = makeNode(AccessPriv);
				n->priv_name = pstrdup((yyvsp[(1) - (2)].keyword));
				n->cols = (yyvsp[(2) - (2)].list);
				(yyval.accesspriv) = n;
			}
    break;

  case 884:
/* Line 1787 of yacc.c  */
#line 5879 "gram.y"
    {
				AccessPriv *n = makeNode(AccessPriv);
				n->priv_name = (yyvsp[(1) - (2)].str);
				n->cols = (yyvsp[(2) - (2)].list);
				(yyval.accesspriv) = n;
			}
    break;

  case 885:
/* Line 1787 of yacc.c  */
#line 5893 "gram.y"
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_RELATION;
					n->objs = (yyvsp[(1) - (1)].list);
					(yyval.privtarget) = n;
				}
    break;

  case 886:
/* Line 1787 of yacc.c  */
#line 5901 "gram.y"
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_RELATION;
					n->objs = (yyvsp[(2) - (2)].list);
					(yyval.privtarget) = n;
				}
    break;

  case 887:
/* Line 1787 of yacc.c  */
#line 5909 "gram.y"
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_SEQUENCE;
					n->objs = (yyvsp[(2) - (2)].list);
					(yyval.privtarget) = n;
				}
    break;

  case 888:
/* Line 1787 of yacc.c  */
#line 5917 "gram.y"
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_FDW;
					n->objs = (yyvsp[(4) - (4)].list);
					(yyval.privtarget) = n;
				}
    break;

  case 889:
/* Line 1787 of yacc.c  */
#line 5925 "gram.y"
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_FOREIGN_SERVER;
					n->objs = (yyvsp[(3) - (3)].list);
					(yyval.privtarget) = n;
				}
    break;

  case 890:
/* Line 1787 of yacc.c  */
#line 5933 "gram.y"
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_FUNCTION;
					n->objs = (yyvsp[(2) - (2)].list);
					(yyval.privtarget) = n;
				}
    break;

  case 891:
/* Line 1787 of yacc.c  */
#line 5941 "gram.y"
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_DATABASE;
					n->objs = (yyvsp[(2) - (2)].list);
					(yyval.privtarget) = n;
				}
    break;

  case 892:
/* Line 1787 of yacc.c  */
#line 5949 "gram.y"
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_DOMAIN;
					n->objs = (yyvsp[(2) - (2)].list);
					(yyval.privtarget) = n;
				}
    break;

  case 893:
/* Line 1787 of yacc.c  */
#line 5957 "gram.y"
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_LANGUAGE;
					n->objs = (yyvsp[(2) - (2)].list);
					(yyval.privtarget) = n;
				}
    break;

  case 894:
/* Line 1787 of yacc.c  */
#line 5965 "gram.y"
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_LARGEOBJECT;
					n->objs = (yyvsp[(3) - (3)].list);
					(yyval.privtarget) = n;
				}
    break;

  case 895:
/* Line 1787 of yacc.c  */
#line 5973 "gram.y"
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_NAMESPACE;
					n->objs = (yyvsp[(2) - (2)].list);
					(yyval.privtarget) = n;
				}
    break;

  case 896:
/* Line 1787 of yacc.c  */
#line 5981 "gram.y"
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_TABLESPACE;
					n->objs = (yyvsp[(2) - (2)].list);
					(yyval.privtarget) = n;
				}
    break;

  case 897:
/* Line 1787 of yacc.c  */
#line 5989 "gram.y"
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_TYPE;
					n->objs = (yyvsp[(2) - (2)].list);
					(yyval.privtarget) = n;
				}
    break;

  case 898:
/* Line 1787 of yacc.c  */
#line 5997 "gram.y"
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_ALL_IN_SCHEMA;
					n->objtype = ACL_OBJECT_RELATION;
					n->objs = (yyvsp[(5) - (5)].list);
					(yyval.privtarget) = n;
				}
    break;

  case 899:
/* Line 1787 of yacc.c  */
#line 6005 "gram.y"
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_ALL_IN_SCHEMA;
					n->objtype = ACL_OBJECT_SEQUENCE;
					n->objs = (yyvsp[(5) - (5)].list);
					(yyval.privtarget) = n;
				}
    break;

  case 900:
/* Line 1787 of yacc.c  */
#line 6013 "gram.y"
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_ALL_IN_SCHEMA;
					n->objtype = ACL_OBJECT_FUNCTION;
					n->objs = (yyvsp[(5) - (5)].list);
					(yyval.privtarget) = n;
				}
    break;

  case 901:
/* Line 1787 of yacc.c  */
#line 6024 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].node)); }
    break;

  case 902:
/* Line 1787 of yacc.c  */
#line 6025 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node)); }
    break;

  case 903:
/* Line 1787 of yacc.c  */
#line 6029 "gram.y"
    {
					PrivGrantee *n = makeNode(PrivGrantee);
					/* This hack lets us avoid reserving PUBLIC as a keyword*/
					if (strcmp((yyvsp[(1) - (1)].str), "public") == 0)
						n->rolname = NULL;
					else
						n->rolname = (yyvsp[(1) - (1)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 904:
/* Line 1787 of yacc.c  */
#line 6039 "gram.y"
    {
					PrivGrantee *n = makeNode(PrivGrantee);
					/* Treat GROUP PUBLIC as a synonym for PUBLIC */
					if (strcmp((yyvsp[(2) - (2)].str), "public") == 0)
						n->rolname = NULL;
					else
						n->rolname = (yyvsp[(2) - (2)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 905:
/* Line 1787 of yacc.c  */
#line 6052 "gram.y"
    { (yyval.boolean) = TRUE; }
    break;

  case 906:
/* Line 1787 of yacc.c  */
#line 6053 "gram.y"
    { (yyval.boolean) = FALSE; }
    break;

  case 907:
/* Line 1787 of yacc.c  */
#line 6057 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].funwithargs)); }
    break;

  case 908:
/* Line 1787 of yacc.c  */
#line 6059 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].funwithargs)); }
    break;

  case 909:
/* Line 1787 of yacc.c  */
#line 6064 "gram.y"
    {
					FuncWithArgs *n = makeNode(FuncWithArgs);
					n->funcname = (yyvsp[(1) - (2)].list);
					n->funcargs = extractArgTypes((yyvsp[(2) - (2)].list));
					(yyval.funwithargs) = n;
				}
    break;

  case 910:
/* Line 1787 of yacc.c  */
#line 6080 "gram.y"
    {
					GrantRoleStmt *n = makeNode(GrantRoleStmt);
					n->is_grant = true;
					n->granted_roles = (yyvsp[(2) - (6)].list);
					n->grantee_roles = (yyvsp[(4) - (6)].list);
					n->admin_opt = (yyvsp[(5) - (6)].boolean);
					n->grantor = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node*)n;
				}
    break;

  case 911:
/* Line 1787 of yacc.c  */
#line 6093 "gram.y"
    {
					GrantRoleStmt *n = makeNode(GrantRoleStmt);
					n->is_grant = false;
					n->admin_opt = false;
					n->granted_roles = (yyvsp[(2) - (6)].list);
					n->grantee_roles = (yyvsp[(4) - (6)].list);
					n->behavior = (yyvsp[(6) - (6)].dbehavior);
					(yyval.node) = (Node*)n;
				}
    break;

  case 912:
/* Line 1787 of yacc.c  */
#line 6103 "gram.y"
    {
					GrantRoleStmt *n = makeNode(GrantRoleStmt);
					n->is_grant = false;
					n->admin_opt = true;
					n->granted_roles = (yyvsp[(5) - (9)].list);
					n->grantee_roles = (yyvsp[(7) - (9)].list);
					n->behavior = (yyvsp[(9) - (9)].dbehavior);
					(yyval.node) = (Node*)n;
				}
    break;

  case 913:
/* Line 1787 of yacc.c  */
#line 6114 "gram.y"
    { (yyval.boolean) = TRUE; }
    break;

  case 914:
/* Line 1787 of yacc.c  */
#line 6115 "gram.y"
    { (yyval.boolean) = FALSE; }
    break;

  case 915:
/* Line 1787 of yacc.c  */
#line 6118 "gram.y"
    { (yyval.str) = (yyvsp[(3) - (3)].str); }
    break;

  case 916:
/* Line 1787 of yacc.c  */
#line 6119 "gram.y"
    { (yyval.str) = NULL; }
    break;

  case 917:
/* Line 1787 of yacc.c  */
#line 6130 "gram.y"
    {
					AlterDefaultPrivilegesStmt *n = makeNode(AlterDefaultPrivilegesStmt);
					n->options = (yyvsp[(4) - (5)].list);
					n->action = (GrantStmt *) (yyvsp[(5) - (5)].node);
					(yyval.node) = (Node*)n;
				}
    break;

  case 918:
/* Line 1787 of yacc.c  */
#line 6139 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].defelt)); }
    break;

  case 919:
/* Line 1787 of yacc.c  */
#line 6140 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 920:
/* Line 1787 of yacc.c  */
#line 6145 "gram.y"
    {
					(yyval.defelt) = makeDefElem("schemas", (Node *)(yyvsp[(3) - (3)].list));
				}
    break;

  case 921:
/* Line 1787 of yacc.c  */
#line 6149 "gram.y"
    {
					(yyval.defelt) = makeDefElem("roles", (Node *)(yyvsp[(3) - (3)].list));
				}
    break;

  case 922:
/* Line 1787 of yacc.c  */
#line 6153 "gram.y"
    {
					(yyval.defelt) = makeDefElem("roles", (Node *)(yyvsp[(3) - (3)].list));
				}
    break;

  case 923:
/* Line 1787 of yacc.c  */
#line 6165 "gram.y"
    {
					GrantStmt *n = makeNode(GrantStmt);
					n->is_grant = true;
					n->privileges = (yyvsp[(2) - (7)].list);
					n->targtype = ACL_TARGET_DEFAULTS;
					n->objtype = (yyvsp[(4) - (7)].ival);
					n->objects = NIL;
					n->grantees = (yyvsp[(6) - (7)].list);
					n->grant_option = (yyvsp[(7) - (7)].boolean);
					(yyval.node) = (Node*)n;
				}
    break;

  case 924:
/* Line 1787 of yacc.c  */
#line 6178 "gram.y"
    {
					GrantStmt *n = makeNode(GrantStmt);
					n->is_grant = false;
					n->grant_option = false;
					n->privileges = (yyvsp[(2) - (7)].list);
					n->targtype = ACL_TARGET_DEFAULTS;
					n->objtype = (yyvsp[(4) - (7)].ival);
					n->objects = NIL;
					n->grantees = (yyvsp[(6) - (7)].list);
					n->behavior = (yyvsp[(7) - (7)].dbehavior);
					(yyval.node) = (Node *)n;
				}
    break;

  case 925:
/* Line 1787 of yacc.c  */
#line 6192 "gram.y"
    {
					GrantStmt *n = makeNode(GrantStmt);
					n->is_grant = false;
					n->grant_option = true;
					n->privileges = (yyvsp[(5) - (10)].list);
					n->targtype = ACL_TARGET_DEFAULTS;
					n->objtype = (yyvsp[(7) - (10)].ival);
					n->objects = NIL;
					n->grantees = (yyvsp[(9) - (10)].list);
					n->behavior = (yyvsp[(10) - (10)].dbehavior);
					(yyval.node) = (Node *)n;
				}
    break;

  case 926:
/* Line 1787 of yacc.c  */
#line 6207 "gram.y"
    { (yyval.ival) = ACL_OBJECT_RELATION; }
    break;

  case 927:
/* Line 1787 of yacc.c  */
#line 6208 "gram.y"
    { (yyval.ival) = ACL_OBJECT_FUNCTION; }
    break;

  case 928:
/* Line 1787 of yacc.c  */
#line 6209 "gram.y"
    { (yyval.ival) = ACL_OBJECT_SEQUENCE; }
    break;

  case 929:
/* Line 1787 of yacc.c  */
#line 6210 "gram.y"
    { (yyval.ival) = ACL_OBJECT_TYPE; }
    break;

  case 930:
/* Line 1787 of yacc.c  */
#line 6225 "gram.y"
    {
					IndexStmt *n = makeNode(IndexStmt);
					n->unique = (yyvsp[(2) - (14)].boolean);
					n->concurrent = (yyvsp[(4) - (14)].boolean);
					n->idxname = (yyvsp[(5) - (14)].str);
					n->relation = (yyvsp[(7) - (14)].range);
					n->accessMethod = (yyvsp[(8) - (14)].str);
					n->indexParams = (yyvsp[(10) - (14)].list);
					n->options = (yyvsp[(12) - (14)].list);
					n->tableSpace = (yyvsp[(13) - (14)].str);
					n->whereClause = (yyvsp[(14) - (14)].node);
					n->excludeOpNames = NIL;
					n->idxcomment = NULL;
					n->indexOid = InvalidOid;
					n->oldNode = InvalidOid;
					n->primary = false;
					n->isconstraint = false;
					n->deferrable = false;
					n->initdeferred = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 931:
/* Line 1787 of yacc.c  */
#line 6249 "gram.y"
    { (yyval.boolean) = TRUE; }
    break;

  case 932:
/* Line 1787 of yacc.c  */
#line 6250 "gram.y"
    { (yyval.boolean) = FALSE; }
    break;

  case 933:
/* Line 1787 of yacc.c  */
#line 6254 "gram.y"
    { (yyval.boolean) = TRUE; }
    break;

  case 934:
/* Line 1787 of yacc.c  */
#line 6255 "gram.y"
    { (yyval.boolean) = FALSE; }
    break;

  case 935:
/* Line 1787 of yacc.c  */
#line 6259 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); }
    break;

  case 936:
/* Line 1787 of yacc.c  */
#line 6260 "gram.y"
    { (yyval.str) = NULL; }
    break;

  case 937:
/* Line 1787 of yacc.c  */
#line 6264 "gram.y"
    { (yyval.str) = (yyvsp[(2) - (2)].str); }
    break;

  case 938:
/* Line 1787 of yacc.c  */
#line 6265 "gram.y"
    { (yyval.str) = DEFAULT_INDEX_TYPE; }
    break;

  case 939:
/* Line 1787 of yacc.c  */
#line 6268 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].ielem)); }
    break;

  case 940:
/* Line 1787 of yacc.c  */
#line 6269 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].ielem)); }
    break;

  case 941:
/* Line 1787 of yacc.c  */
#line 6278 "gram.y"
    {
					(yyval.ielem) = makeNode(IndexElem);
					(yyval.ielem)->name = (yyvsp[(1) - (5)].str);
					(yyval.ielem)->expr = NULL;
					(yyval.ielem)->indexcolname = NULL;
					(yyval.ielem)->collation = (yyvsp[(2) - (5)].list);
					(yyval.ielem)->opclass = (yyvsp[(3) - (5)].list);
					(yyval.ielem)->ordering = (yyvsp[(4) - (5)].ival);
					(yyval.ielem)->nulls_ordering = (yyvsp[(5) - (5)].ival);
				}
    break;

  case 942:
/* Line 1787 of yacc.c  */
#line 6289 "gram.y"
    {
					(yyval.ielem) = makeNode(IndexElem);
					(yyval.ielem)->name = NULL;
					(yyval.ielem)->expr = (yyvsp[(1) - (5)].node);
					(yyval.ielem)->indexcolname = NULL;
					(yyval.ielem)->collation = (yyvsp[(2) - (5)].list);
					(yyval.ielem)->opclass = (yyvsp[(3) - (5)].list);
					(yyval.ielem)->ordering = (yyvsp[(4) - (5)].ival);
					(yyval.ielem)->nulls_ordering = (yyvsp[(5) - (5)].ival);
				}
    break;

  case 943:
/* Line 1787 of yacc.c  */
#line 6300 "gram.y"
    {
					(yyval.ielem) = makeNode(IndexElem);
					(yyval.ielem)->name = NULL;
					(yyval.ielem)->expr = (yyvsp[(2) - (7)].node);
					(yyval.ielem)->indexcolname = NULL;
					(yyval.ielem)->collation = (yyvsp[(4) - (7)].list);
					(yyval.ielem)->opclass = (yyvsp[(5) - (7)].list);
					(yyval.ielem)->ordering = (yyvsp[(6) - (7)].ival);
					(yyval.ielem)->nulls_ordering = (yyvsp[(7) - (7)].ival);
				}
    break;

  case 944:
/* Line 1787 of yacc.c  */
#line 6312 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (2)].list); }
    break;

  case 945:
/* Line 1787 of yacc.c  */
#line 6313 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 946:
/* Line 1787 of yacc.c  */
#line 6316 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list); }
    break;

  case 947:
/* Line 1787 of yacc.c  */
#line 6317 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (2)].list); }
    break;

  case 948:
/* Line 1787 of yacc.c  */
#line 6318 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 949:
/* Line 1787 of yacc.c  */
#line 6321 "gram.y"
    { (yyval.ival) = SORTBY_ASC; }
    break;

  case 950:
/* Line 1787 of yacc.c  */
#line 6322 "gram.y"
    { (yyval.ival) = SORTBY_DESC; }
    break;

  case 951:
/* Line 1787 of yacc.c  */
#line 6323 "gram.y"
    { (yyval.ival) = SORTBY_DEFAULT; }
    break;

  case 952:
/* Line 1787 of yacc.c  */
#line 6326 "gram.y"
    { (yyval.ival) = SORTBY_NULLS_FIRST; }
    break;

  case 953:
/* Line 1787 of yacc.c  */
#line 6327 "gram.y"
    { (yyval.ival) = SORTBY_NULLS_LAST; }
    break;

  case 954:
/* Line 1787 of yacc.c  */
#line 6328 "gram.y"
    { (yyval.ival) = SORTBY_NULLS_DEFAULT; }
    break;

  case 955:
/* Line 1787 of yacc.c  */
#line 6346 "gram.y"
    {
					CreateFunctionStmt *n = makeNode(CreateFunctionStmt);
					n->replace = (yyvsp[(2) - (9)].boolean);
					n->funcname = (yyvsp[(4) - (9)].list);
					n->parameters = (yyvsp[(5) - (9)].list);
					n->returnType = (yyvsp[(7) - (9)].typnam);
					n->options = (yyvsp[(8) - (9)].list);
					n->withClause = (yyvsp[(9) - (9)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 956:
/* Line 1787 of yacc.c  */
#line 6358 "gram.y"
    {
					CreateFunctionStmt *n = makeNode(CreateFunctionStmt);
					n->replace = (yyvsp[(2) - (12)].boolean);
					n->funcname = (yyvsp[(4) - (12)].list);
					n->parameters = mergeTableFuncParameters((yyvsp[(5) - (12)].list), (yyvsp[(9) - (12)].list));
					n->returnType = TableFuncTypeName((yyvsp[(9) - (12)].list));
					n->returnType->location = (yylsp[(7) - (12)]);
					n->options = (yyvsp[(11) - (12)].list);
					n->withClause = (yyvsp[(12) - (12)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 957:
/* Line 1787 of yacc.c  */
#line 6371 "gram.y"
    {
					CreateFunctionStmt *n = makeNode(CreateFunctionStmt);
					n->replace = (yyvsp[(2) - (7)].boolean);
					n->funcname = (yyvsp[(4) - (7)].list);
					n->parameters = (yyvsp[(5) - (7)].list);
					n->returnType = NULL;
					n->options = (yyvsp[(6) - (7)].list);
					n->withClause = (yyvsp[(7) - (7)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 958:
/* Line 1787 of yacc.c  */
#line 6384 "gram.y"
    { (yyval.boolean) = TRUE; }
    break;

  case 959:
/* Line 1787 of yacc.c  */
#line 6385 "gram.y"
    { (yyval.boolean) = FALSE; }
    break;

  case 960:
/* Line 1787 of yacc.c  */
#line 6388 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (3)].list); }
    break;

  case 961:
/* Line 1787 of yacc.c  */
#line 6389 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 962:
/* Line 1787 of yacc.c  */
#line 6393 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].fun_param)); }
    break;

  case 963:
/* Line 1787 of yacc.c  */
#line 6394 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].fun_param)); }
    break;

  case 964:
/* Line 1787 of yacc.c  */
#line 6402 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (3)].list); }
    break;

  case 965:
/* Line 1787 of yacc.c  */
#line 6403 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 966:
/* Line 1787 of yacc.c  */
#line 6407 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].fun_param)); }
    break;

  case 967:
/* Line 1787 of yacc.c  */
#line 6409 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].fun_param)); }
    break;

  case 968:
/* Line 1787 of yacc.c  */
#line 6424 "gram.y"
    {
					FunctionParameter *n = makeNode(FunctionParameter);
					n->name = (yyvsp[(2) - (3)].str);
					n->argType = (yyvsp[(3) - (3)].typnam);
					n->mode = (yyvsp[(1) - (3)].fun_param_mode);
					n->defexpr = NULL;
					(yyval.fun_param) = n;
				}
    break;

  case 969:
/* Line 1787 of yacc.c  */
#line 6433 "gram.y"
    {
					FunctionParameter *n = makeNode(FunctionParameter);
					n->name = (yyvsp[(1) - (3)].str);
					n->argType = (yyvsp[(3) - (3)].typnam);
					n->mode = (yyvsp[(2) - (3)].fun_param_mode);
					n->defexpr = NULL;
					(yyval.fun_param) = n;
				}
    break;

  case 970:
/* Line 1787 of yacc.c  */
#line 6442 "gram.y"
    {
					FunctionParameter *n = makeNode(FunctionParameter);
					n->name = (yyvsp[(1) - (2)].str);
					n->argType = (yyvsp[(2) - (2)].typnam);
					n->mode = FUNC_PARAM_IN;
					n->defexpr = NULL;
					(yyval.fun_param) = n;
				}
    break;

  case 971:
/* Line 1787 of yacc.c  */
#line 6451 "gram.y"
    {
					FunctionParameter *n = makeNode(FunctionParameter);
					n->name = NULL;
					n->argType = (yyvsp[(2) - (2)].typnam);
					n->mode = (yyvsp[(1) - (2)].fun_param_mode);
					n->defexpr = NULL;
					(yyval.fun_param) = n;
				}
    break;

  case 972:
/* Line 1787 of yacc.c  */
#line 6460 "gram.y"
    {
					FunctionParameter *n = makeNode(FunctionParameter);
					n->name = NULL;
					n->argType = (yyvsp[(1) - (1)].typnam);
					n->mode = FUNC_PARAM_IN;
					n->defexpr = NULL;
					(yyval.fun_param) = n;
				}
    break;

  case 973:
/* Line 1787 of yacc.c  */
#line 6471 "gram.y"
    { (yyval.fun_param_mode) = FUNC_PARAM_IN; }
    break;

  case 974:
/* Line 1787 of yacc.c  */
#line 6472 "gram.y"
    { (yyval.fun_param_mode) = FUNC_PARAM_OUT; }
    break;

  case 975:
/* Line 1787 of yacc.c  */
#line 6473 "gram.y"
    { (yyval.fun_param_mode) = FUNC_PARAM_INOUT; }
    break;

  case 976:
/* Line 1787 of yacc.c  */
#line 6474 "gram.y"
    { (yyval.fun_param_mode) = FUNC_PARAM_INOUT; }
    break;

  case 977:
/* Line 1787 of yacc.c  */
#line 6475 "gram.y"
    { (yyval.fun_param_mode) = FUNC_PARAM_VARIADIC; }
    break;

  case 979:
/* Line 1787 of yacc.c  */
#line 6486 "gram.y"
    {
					/* We can catch over-specified results here if we want to,
					 * but for now better to silently swallow typmod, etc.
					 * - thomas 2000-03-22
					 */
					(yyval.typnam) = (yyvsp[(1) - (1)].typnam);
				}
    break;

  case 980:
/* Line 1787 of yacc.c  */
#line 6500 "gram.y"
    { (yyval.typnam) = (yyvsp[(1) - (1)].typnam); }
    break;

  case 981:
/* Line 1787 of yacc.c  */
#line 6502 "gram.y"
    {
					(yyval.typnam) = makeTypeNameFromNameList(lcons(makeString((yyvsp[(1) - (4)].str)), (yyvsp[(2) - (4)].list)));
					(yyval.typnam)->pct_type = true;
					(yyval.typnam)->location = (yylsp[(1) - (4)]);
				}
    break;

  case 982:
/* Line 1787 of yacc.c  */
#line 6508 "gram.y"
    {
					(yyval.typnam) = makeTypeNameFromNameList(lcons(makeString((yyvsp[(2) - (5)].str)), (yyvsp[(3) - (5)].list)));
					(yyval.typnam)->pct_type = true;
					(yyval.typnam)->setof = TRUE;
					(yyval.typnam)->location = (yylsp[(2) - (5)]);
				}
    break;

  case 983:
/* Line 1787 of yacc.c  */
#line 6518 "gram.y"
    {
					(yyval.fun_param) = (yyvsp[(1) - (1)].fun_param);
				}
    break;

  case 984:
/* Line 1787 of yacc.c  */
#line 6522 "gram.y"
    {
					(yyval.fun_param) = (yyvsp[(1) - (3)].fun_param);
					(yyval.fun_param)->defexpr = (yyvsp[(3) - (3)].node);
				}
    break;

  case 985:
/* Line 1787 of yacc.c  */
#line 6527 "gram.y"
    {
					(yyval.fun_param) = (yyvsp[(1) - (3)].fun_param);
					(yyval.fun_param)->defexpr = (yyvsp[(3) - (3)].node);
				}
    break;

  case 986:
/* Line 1787 of yacc.c  */
#line 6535 "gram.y"
    {
					if (!((yyvsp[(1) - (1)].fun_param)->mode == FUNC_PARAM_IN ||
						  (yyvsp[(1) - (1)].fun_param)->mode == FUNC_PARAM_VARIADIC))
						ereport(ERROR,
								(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
								 errmsg("aggregates cannot have output arguments"),
								 parser_errposition((yylsp[(1) - (1)]))));
					(yyval.fun_param) = (yyvsp[(1) - (1)].fun_param);
				}
    break;

  case 987:
/* Line 1787 of yacc.c  */
#line 6576 "gram.y"
    {
					(yyval.list) = list_make2(NIL, makeInteger(-1));
				}
    break;

  case 988:
/* Line 1787 of yacc.c  */
#line 6580 "gram.y"
    {
					(yyval.list) = list_make2((yyvsp[(2) - (3)].list), makeInteger(-1));
				}
    break;

  case 989:
/* Line 1787 of yacc.c  */
#line 6584 "gram.y"
    {
					(yyval.list) = list_make2((yyvsp[(4) - (5)].list), makeInteger(0));
				}
    break;

  case 990:
/* Line 1787 of yacc.c  */
#line 6588 "gram.y"
    {
					/* this is the only case requiring consistency checking */
					(yyval.list) = makeOrderedSetArgs((yyvsp[(2) - (6)].list), (yyvsp[(5) - (6)].list), yyscanner);
				}
    break;

  case 991:
/* Line 1787 of yacc.c  */
#line 6595 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].fun_param)); }
    break;

  case 992:
/* Line 1787 of yacc.c  */
#line 6596 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].fun_param)); }
    break;

  case 993:
/* Line 1787 of yacc.c  */
#line 6601 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].defelt)); }
    break;

  case 994:
/* Line 1787 of yacc.c  */
#line 6602 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].defelt)); }
    break;

  case 995:
/* Line 1787 of yacc.c  */
#line 6610 "gram.y"
    {
					(yyval.defelt) = makeDefElem("strict", (Node *)makeInteger(FALSE));
				}
    break;

  case 996:
/* Line 1787 of yacc.c  */
#line 6614 "gram.y"
    {
					(yyval.defelt) = makeDefElem("strict", (Node *)makeInteger(TRUE));
				}
    break;

  case 997:
/* Line 1787 of yacc.c  */
#line 6618 "gram.y"
    {
					(yyval.defelt) = makeDefElem("strict", (Node *)makeInteger(TRUE));
				}
    break;

  case 998:
/* Line 1787 of yacc.c  */
#line 6622 "gram.y"
    {
					(yyval.defelt) = makeDefElem("volatility", (Node *)makeString("immutable"));
				}
    break;

  case 999:
/* Line 1787 of yacc.c  */
#line 6626 "gram.y"
    {
					(yyval.defelt) = makeDefElem("volatility", (Node *)makeString("stable"));
				}
    break;

  case 1000:
/* Line 1787 of yacc.c  */
#line 6630 "gram.y"
    {
					(yyval.defelt) = makeDefElem("volatility", (Node *)makeString("volatile"));
				}
    break;

  case 1001:
/* Line 1787 of yacc.c  */
#line 6634 "gram.y"
    {
					(yyval.defelt) = makeDefElem("security", (Node *)makeInteger(TRUE));
				}
    break;

  case 1002:
/* Line 1787 of yacc.c  */
#line 6638 "gram.y"
    {
					(yyval.defelt) = makeDefElem("security", (Node *)makeInteger(FALSE));
				}
    break;

  case 1003:
/* Line 1787 of yacc.c  */
#line 6642 "gram.y"
    {
					(yyval.defelt) = makeDefElem("security", (Node *)makeInteger(TRUE));
				}
    break;

  case 1004:
/* Line 1787 of yacc.c  */
#line 6646 "gram.y"
    {
					(yyval.defelt) = makeDefElem("security", (Node *)makeInteger(FALSE));
				}
    break;

  case 1005:
/* Line 1787 of yacc.c  */
#line 6650 "gram.y"
    {
					(yyval.defelt) = makeDefElem("leakproof", (Node *)makeInteger(TRUE));
				}
    break;

  case 1006:
/* Line 1787 of yacc.c  */
#line 6654 "gram.y"
    {
					(yyval.defelt) = makeDefElem("leakproof", (Node *)makeInteger(FALSE));
				}
    break;

  case 1007:
/* Line 1787 of yacc.c  */
#line 6658 "gram.y"
    {
					(yyval.defelt) = makeDefElem("cost", (Node *)(yyvsp[(2) - (2)].value));
				}
    break;

  case 1008:
/* Line 1787 of yacc.c  */
#line 6662 "gram.y"
    {
					(yyval.defelt) = makeDefElem("rows", (Node *)(yyvsp[(2) - (2)].value));
				}
    break;

  case 1009:
/* Line 1787 of yacc.c  */
#line 6666 "gram.y"
    {
					/* we abuse the normal content of a DefElem here */
					(yyval.defelt) = makeDefElem("set", (Node *)(yyvsp[(1) - (1)].vsetstmt));
				}
    break;

  case 1010:
/* Line 1787 of yacc.c  */
#line 6674 "gram.y"
    {
					(yyval.defelt) = makeDefElem("as", (Node *)(yyvsp[(2) - (2)].list));
				}
    break;

  case 1011:
/* Line 1787 of yacc.c  */
#line 6678 "gram.y"
    {
					(yyval.defelt) = makeDefElem("language", (Node *)makeString((yyvsp[(2) - (2)].str)));
				}
    break;

  case 1012:
/* Line 1787 of yacc.c  */
#line 6682 "gram.y"
    {
					(yyval.defelt) = makeDefElem("window", (Node *)makeInteger(TRUE));
				}
    break;

  case 1013:
/* Line 1787 of yacc.c  */
#line 6686 "gram.y"
    {
					(yyval.defelt) = (yyvsp[(1) - (1)].defelt);
				}
    break;

  case 1014:
/* Line 1787 of yacc.c  */
#line 6691 "gram.y"
    { (yyval.list) = list_make1(makeString((yyvsp[(1) - (1)].str))); }
    break;

  case 1015:
/* Line 1787 of yacc.c  */
#line 6693 "gram.y"
    {
					(yyval.list) = list_make2(makeString((yyvsp[(1) - (3)].str)), makeString((yyvsp[(3) - (3)].str)));
				}
    break;

  case 1016:
/* Line 1787 of yacc.c  */
#line 6699 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (2)].list); }
    break;

  case 1017:
/* Line 1787 of yacc.c  */
#line 6700 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 1018:
/* Line 1787 of yacc.c  */
#line 6704 "gram.y"
    {
					FunctionParameter *n = makeNode(FunctionParameter);
					n->name = (yyvsp[(1) - (2)].str);
					n->argType = (yyvsp[(2) - (2)].typnam);
					n->mode = FUNC_PARAM_TABLE;
					n->defexpr = NULL;
					(yyval.fun_param) = n;
				}
    break;

  case 1019:
/* Line 1787 of yacc.c  */
#line 6716 "gram.y"
    {
					(yyval.list) = list_make1((yyvsp[(1) - (1)].fun_param));
				}
    break;

  case 1020:
/* Line 1787 of yacc.c  */
#line 6720 "gram.y"
    {
					(yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].fun_param));
				}
    break;

  case 1021:
/* Line 1787 of yacc.c  */
#line 6735 "gram.y"
    {
					AlterFunctionStmt *n = makeNode(AlterFunctionStmt);
					n->func = (yyvsp[(3) - (5)].funwithargs);
					n->actions = (yyvsp[(4) - (5)].list);
					(yyval.node) = (Node *) n;
				}
    break;

  case 1022:
/* Line 1787 of yacc.c  */
#line 6745 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].defelt)); }
    break;

  case 1023:
/* Line 1787 of yacc.c  */
#line 6746 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].defelt)); }
    break;

  case 1026:
/* Line 1787 of yacc.c  */
#line 6768 "gram.y"
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_FUNCTION;
					n->objects = list_make1((yyvsp[(3) - (5)].list));
					n->arguments = list_make1(extractArgTypes((yyvsp[(4) - (5)].list)));
					n->behavior = (yyvsp[(5) - (5)].dbehavior);
					n->missing_ok = false;
					n->concurrent = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1027:
/* Line 1787 of yacc.c  */
#line 6779 "gram.y"
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_FUNCTION;
					n->objects = list_make1((yyvsp[(5) - (7)].list));
					n->arguments = list_make1(extractArgTypes((yyvsp[(6) - (7)].list)));
					n->behavior = (yyvsp[(7) - (7)].dbehavior);
					n->missing_ok = true;
					n->concurrent = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1028:
/* Line 1787 of yacc.c  */
#line 6793 "gram.y"
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_AGGREGATE;
					n->objects = list_make1((yyvsp[(3) - (5)].list));
					n->arguments = list_make1(extractAggrArgTypes((yyvsp[(4) - (5)].list)));
					n->behavior = (yyvsp[(5) - (5)].dbehavior);
					n->missing_ok = false;
					n->concurrent = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1029:
/* Line 1787 of yacc.c  */
#line 6804 "gram.y"
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_AGGREGATE;
					n->objects = list_make1((yyvsp[(5) - (7)].list));
					n->arguments = list_make1(extractAggrArgTypes((yyvsp[(6) - (7)].list)));
					n->behavior = (yyvsp[(7) - (7)].dbehavior);
					n->missing_ok = true;
					n->concurrent = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1030:
/* Line 1787 of yacc.c  */
#line 6818 "gram.y"
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_OPERATOR;
					n->objects = list_make1((yyvsp[(3) - (5)].list));
					n->arguments = list_make1((yyvsp[(4) - (5)].list));
					n->behavior = (yyvsp[(5) - (5)].dbehavior);
					n->missing_ok = false;
					n->concurrent = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1031:
/* Line 1787 of yacc.c  */
#line 6829 "gram.y"
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_OPERATOR;
					n->objects = list_make1((yyvsp[(5) - (7)].list));
					n->arguments = list_make1((yyvsp[(6) - (7)].list));
					n->behavior = (yyvsp[(7) - (7)].dbehavior);
					n->missing_ok = true;
					n->concurrent = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1032:
/* Line 1787 of yacc.c  */
#line 6843 "gram.y"
    {
				   ereport(ERROR,
						   (errcode(ERRCODE_SYNTAX_ERROR),
							errmsg("missing argument"),
							errhint("Use NONE to denote the missing argument of a unary operator."),
							parser_errposition((yylsp[(3) - (3)]))));
				}
    break;

  case 1033:
/* Line 1787 of yacc.c  */
#line 6851 "gram.y"
    { (yyval.list) = list_make2((yyvsp[(2) - (5)].typnam), (yyvsp[(4) - (5)].typnam)); }
    break;

  case 1034:
/* Line 1787 of yacc.c  */
#line 6853 "gram.y"
    { (yyval.list) = list_make2(NULL, (yyvsp[(4) - (5)].typnam)); }
    break;

  case 1035:
/* Line 1787 of yacc.c  */
#line 6855 "gram.y"
    { (yyval.list) = list_make2((yyvsp[(2) - (5)].typnam), NULL); }
    break;

  case 1036:
/* Line 1787 of yacc.c  */
#line 6860 "gram.y"
    { (yyval.list) = list_make1(makeString((yyvsp[(1) - (1)].str))); }
    break;

  case 1037:
/* Line 1787 of yacc.c  */
#line 6862 "gram.y"
    { (yyval.list) = lcons(makeString((yyvsp[(1) - (3)].str)), (yyvsp[(3) - (3)].list)); }
    break;

  case 1038:
/* Line 1787 of yacc.c  */
#line 6875 "gram.y"
    {
					DoStmt *n = makeNode(DoStmt);
					n->args = (yyvsp[(2) - (2)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1039:
/* Line 1787 of yacc.c  */
#line 6883 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].defelt)); }
    break;

  case 1040:
/* Line 1787 of yacc.c  */
#line 6884 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].defelt)); }
    break;

  case 1041:
/* Line 1787 of yacc.c  */
#line 6889 "gram.y"
    {
					(yyval.defelt) = makeDefElem("as", (Node *)makeString((yyvsp[(1) - (1)].str)));
				}
    break;

  case 1042:
/* Line 1787 of yacc.c  */
#line 6893 "gram.y"
    {
					(yyval.defelt) = makeDefElem("language", (Node *)makeString((yyvsp[(2) - (2)].str)));
				}
    break;

  case 1043:
/* Line 1787 of yacc.c  */
#line 6906 "gram.y"
    {
					CreateCastStmt *n = makeNode(CreateCastStmt);
					n->sourcetype = (yyvsp[(4) - (11)].typnam);
					n->targettype = (yyvsp[(6) - (11)].typnam);
					n->func = (yyvsp[(10) - (11)].funwithargs);
					n->context = (CoercionContext) (yyvsp[(11) - (11)].ival);
					n->inout = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1044:
/* Line 1787 of yacc.c  */
#line 6917 "gram.y"
    {
					CreateCastStmt *n = makeNode(CreateCastStmt);
					n->sourcetype = (yyvsp[(4) - (10)].typnam);
					n->targettype = (yyvsp[(6) - (10)].typnam);
					n->func = NULL;
					n->context = (CoercionContext) (yyvsp[(10) - (10)].ival);
					n->inout = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1045:
/* Line 1787 of yacc.c  */
#line 6928 "gram.y"
    {
					CreateCastStmt *n = makeNode(CreateCastStmt);
					n->sourcetype = (yyvsp[(4) - (10)].typnam);
					n->targettype = (yyvsp[(6) - (10)].typnam);
					n->func = NULL;
					n->context = (CoercionContext) (yyvsp[(10) - (10)].ival);
					n->inout = true;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1046:
/* Line 1787 of yacc.c  */
#line 6939 "gram.y"
    { (yyval.ival) = COERCION_IMPLICIT; }
    break;

  case 1047:
/* Line 1787 of yacc.c  */
#line 6940 "gram.y"
    { (yyval.ival) = COERCION_ASSIGNMENT; }
    break;

  case 1048:
/* Line 1787 of yacc.c  */
#line 6941 "gram.y"
    { (yyval.ival) = COERCION_EXPLICIT; }
    break;

  case 1049:
/* Line 1787 of yacc.c  */
#line 6946 "gram.y"
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_CAST;
					n->objects = list_make1(list_make1((yyvsp[(5) - (9)].typnam)));
					n->arguments = list_make1(list_make1((yyvsp[(7) - (9)].typnam)));
					n->behavior = (yyvsp[(9) - (9)].dbehavior);
					n->missing_ok = (yyvsp[(3) - (9)].boolean);
					n->concurrent = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1050:
/* Line 1787 of yacc.c  */
#line 6958 "gram.y"
    { (yyval.boolean) = TRUE; }
    break;

  case 1051:
/* Line 1787 of yacc.c  */
#line 6959 "gram.y"
    { (yyval.boolean) = FALSE; }
    break;

  case 1052:
/* Line 1787 of yacc.c  */
#line 6974 "gram.y"
    {
					ReindexStmt *n = makeNode(ReindexStmt);
					n->kind = (yyvsp[(2) - (4)].objtype);
					n->relation = (yyvsp[(3) - (4)].range);
					n->name = NULL;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1053:
/* Line 1787 of yacc.c  */
#line 6982 "gram.y"
    {
					ReindexStmt *n = makeNode(ReindexStmt);
					n->kind = OBJECT_DATABASE;
					n->name = (yyvsp[(3) - (4)].str);
					n->relation = NULL;
					n->do_system = true;
					n->do_user = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1054:
/* Line 1787 of yacc.c  */
#line 6992 "gram.y"
    {
					ReindexStmt *n = makeNode(ReindexStmt);
					n->kind = OBJECT_DATABASE;
					n->name = (yyvsp[(3) - (4)].str);
					n->relation = NULL;
					n->do_system = true;
					n->do_user = true;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1055:
/* Line 1787 of yacc.c  */
#line 7004 "gram.y"
    { (yyval.objtype) = OBJECT_INDEX; }
    break;

  case 1056:
/* Line 1787 of yacc.c  */
#line 7005 "gram.y"
    { (yyval.objtype) = OBJECT_TABLE; }
    break;

  case 1057:
/* Line 1787 of yacc.c  */
#line 7008 "gram.y"
    {  (yyval.boolean) = TRUE; }
    break;

  case 1058:
/* Line 1787 of yacc.c  */
#line 7009 "gram.y"
    {  (yyval.boolean) = FALSE; }
    break;

  case 1059:
/* Line 1787 of yacc.c  */
#line 7021 "gram.y"
    {
					AlterTableSpaceOptionsStmt *n =
						makeNode(AlterTableSpaceOptionsStmt);
					n->tablespacename = (yyvsp[(3) - (5)].str);
					n->options = (yyvsp[(5) - (5)].list);
					n->isReset = FALSE;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1060:
/* Line 1787 of yacc.c  */
#line 7030 "gram.y"
    {
					AlterTableSpaceOptionsStmt *n =
						makeNode(AlterTableSpaceOptionsStmt);
					n->tablespacename = (yyvsp[(3) - (5)].str);
					n->options = (yyvsp[(5) - (5)].list);
					n->isReset = TRUE;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1061:
/* Line 1787 of yacc.c  */
#line 7047 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_AGGREGATE;
					n->object = (yyvsp[(3) - (7)].list);
					n->objarg = extractAggrArgTypes((yyvsp[(4) - (7)].list));
					n->newname = (yyvsp[(7) - (7)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1062:
/* Line 1787 of yacc.c  */
#line 7057 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_COLLATION;
					n->object = (yyvsp[(3) - (6)].list);
					n->newname = (yyvsp[(6) - (6)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1063:
/* Line 1787 of yacc.c  */
#line 7066 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_CONVERSION;
					n->object = (yyvsp[(3) - (6)].list);
					n->newname = (yyvsp[(6) - (6)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1064:
/* Line 1787 of yacc.c  */
#line 7075 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_DATABASE;
					n->subname = (yyvsp[(3) - (6)].str);
					n->newname = (yyvsp[(6) - (6)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1065:
/* Line 1787 of yacc.c  */
#line 7084 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_DOMAIN;
					n->object = (yyvsp[(3) - (6)].list);
					n->newname = (yyvsp[(6) - (6)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1066:
/* Line 1787 of yacc.c  */
#line 7093 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_CONSTRAINT;
					n->relationType = OBJECT_DOMAIN;
					n->object = (yyvsp[(3) - (8)].list);
					n->subname = (yyvsp[(6) - (8)].str);
					n->newname = (yyvsp[(8) - (8)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1067:
/* Line 1787 of yacc.c  */
#line 7103 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_FDW;
					n->object = list_make1(makeString((yyvsp[(5) - (8)].str)));
					n->newname = (yyvsp[(8) - (8)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1068:
/* Line 1787 of yacc.c  */
#line 7112 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_FUNCTION;
					n->object = (yyvsp[(3) - (6)].funwithargs)->funcname;
					n->objarg = (yyvsp[(3) - (6)].funwithargs)->funcargs;
					n->newname = (yyvsp[(6) - (6)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1069:
/* Line 1787 of yacc.c  */
#line 7122 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_ROLE;
					n->subname = (yyvsp[(3) - (6)].str);
					n->newname = (yyvsp[(6) - (6)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1070:
/* Line 1787 of yacc.c  */
#line 7131 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_LANGUAGE;
					n->object = list_make1(makeString((yyvsp[(4) - (7)].str)));
					n->newname = (yyvsp[(7) - (7)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1071:
/* Line 1787 of yacc.c  */
#line 7140 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_OPCLASS;
					n->object = (yyvsp[(4) - (9)].list);
					n->objarg = list_make1(makeString((yyvsp[(6) - (9)].str)));
					n->newname = (yyvsp[(9) - (9)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1072:
/* Line 1787 of yacc.c  */
#line 7150 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_OPFAMILY;
					n->object = (yyvsp[(4) - (9)].list);
					n->objarg = list_make1(makeString((yyvsp[(6) - (9)].str)));
					n->newname = (yyvsp[(9) - (9)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1073:
/* Line 1787 of yacc.c  */
#line 7160 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_SCHEMA;
					n->subname = (yyvsp[(3) - (6)].str);
					n->newname = (yyvsp[(6) - (6)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1074:
/* Line 1787 of yacc.c  */
#line 7169 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_FOREIGN_SERVER;
					n->object = list_make1(makeString((yyvsp[(3) - (6)].str)));
					n->newname = (yyvsp[(6) - (6)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1075:
/* Line 1787 of yacc.c  */
#line 7178 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TABLE;
					n->relation = (yyvsp[(3) - (6)].range);
					n->subname = NULL;
					n->newname = (yyvsp[(6) - (6)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1076:
/* Line 1787 of yacc.c  */
#line 7188 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TABLE;
					n->relation = (yyvsp[(5) - (8)].range);
					n->subname = NULL;
					n->newname = (yyvsp[(8) - (8)].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1077:
/* Line 1787 of yacc.c  */
#line 7198 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_SEQUENCE;
					n->relation = (yyvsp[(3) - (6)].range);
					n->subname = NULL;
					n->newname = (yyvsp[(6) - (6)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1078:
/* Line 1787 of yacc.c  */
#line 7208 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_SEQUENCE;
					n->relation = (yyvsp[(5) - (8)].range);
					n->subname = NULL;
					n->newname = (yyvsp[(8) - (8)].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1079:
/* Line 1787 of yacc.c  */
#line 7218 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_VIEW;
					n->relation = (yyvsp[(3) - (6)].range);
					n->subname = NULL;
					n->newname = (yyvsp[(6) - (6)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1080:
/* Line 1787 of yacc.c  */
#line 7228 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_VIEW;
					n->relation = (yyvsp[(5) - (8)].range);
					n->subname = NULL;
					n->newname = (yyvsp[(8) - (8)].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1081:
/* Line 1787 of yacc.c  */
#line 7238 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_MATVIEW;
					n->relation = (yyvsp[(4) - (7)].range);
					n->subname = NULL;
					n->newname = (yyvsp[(7) - (7)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1082:
/* Line 1787 of yacc.c  */
#line 7248 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_MATVIEW;
					n->relation = (yyvsp[(6) - (9)].range);
					n->subname = NULL;
					n->newname = (yyvsp[(9) - (9)].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1083:
/* Line 1787 of yacc.c  */
#line 7258 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_INDEX;
					n->relation = (yyvsp[(3) - (6)].range);
					n->subname = NULL;
					n->newname = (yyvsp[(6) - (6)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1084:
/* Line 1787 of yacc.c  */
#line 7268 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_INDEX;
					n->relation = (yyvsp[(5) - (8)].range);
					n->subname = NULL;
					n->newname = (yyvsp[(8) - (8)].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1085:
/* Line 1787 of yacc.c  */
#line 7278 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_FOREIGN_TABLE;
					n->relation = (yyvsp[(4) - (7)].range);
					n->subname = NULL;
					n->newname = (yyvsp[(7) - (7)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1086:
/* Line 1787 of yacc.c  */
#line 7288 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_FOREIGN_TABLE;
					n->relation = (yyvsp[(6) - (9)].range);
					n->subname = NULL;
					n->newname = (yyvsp[(9) - (9)].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1087:
/* Line 1787 of yacc.c  */
#line 7298 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_COLUMN;
					n->relationType = OBJECT_TABLE;
					n->relation = (yyvsp[(3) - (8)].range);
					n->subname = (yyvsp[(6) - (8)].str);
					n->newname = (yyvsp[(8) - (8)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1088:
/* Line 1787 of yacc.c  */
#line 7309 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_COLUMN;
					n->relationType = OBJECT_TABLE;
					n->relation = (yyvsp[(5) - (10)].range);
					n->subname = (yyvsp[(8) - (10)].str);
					n->newname = (yyvsp[(10) - (10)].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1089:
/* Line 1787 of yacc.c  */
#line 7320 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_COLUMN;
					n->relationType = OBJECT_MATVIEW;
					n->relation = (yyvsp[(4) - (9)].range);
					n->subname = (yyvsp[(7) - (9)].str);
					n->newname = (yyvsp[(9) - (9)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1090:
/* Line 1787 of yacc.c  */
#line 7331 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_COLUMN;
					n->relationType = OBJECT_MATVIEW;
					n->relation = (yyvsp[(6) - (11)].range);
					n->subname = (yyvsp[(9) - (11)].str);
					n->newname = (yyvsp[(11) - (11)].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1091:
/* Line 1787 of yacc.c  */
#line 7342 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_CONSTRAINT;
					n->relationType = OBJECT_TABLE;
					n->relation = (yyvsp[(3) - (8)].range);
					n->subname = (yyvsp[(6) - (8)].str);
					n->newname = (yyvsp[(8) - (8)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1092:
/* Line 1787 of yacc.c  */
#line 7352 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_COLUMN;
					n->relationType = OBJECT_FOREIGN_TABLE;
					n->relation = (yyvsp[(4) - (9)].range);
					n->subname = (yyvsp[(7) - (9)].str);
					n->newname = (yyvsp[(9) - (9)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1093:
/* Line 1787 of yacc.c  */
#line 7363 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_COLUMN;
					n->relationType = OBJECT_FOREIGN_TABLE;
					n->relation = (yyvsp[(6) - (11)].range);
					n->subname = (yyvsp[(9) - (11)].str);
					n->newname = (yyvsp[(11) - (11)].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1094:
/* Line 1787 of yacc.c  */
#line 7374 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_RULE;
					n->relation = (yyvsp[(5) - (8)].range);
					n->subname = (yyvsp[(3) - (8)].str);
					n->newname = (yyvsp[(8) - (8)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1095:
/* Line 1787 of yacc.c  */
#line 7384 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TRIGGER;
					n->relation = (yyvsp[(5) - (8)].range);
					n->subname = (yyvsp[(3) - (8)].str);
					n->newname = (yyvsp[(8) - (8)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1096:
/* Line 1787 of yacc.c  */
#line 7394 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_EVENT_TRIGGER;
					n->object = list_make1(makeString((yyvsp[(4) - (7)].str)));
					n->newname = (yyvsp[(7) - (7)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1097:
/* Line 1787 of yacc.c  */
#line 7402 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_ROLE;
					n->subname = (yyvsp[(3) - (6)].str);
					n->newname = (yyvsp[(6) - (6)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1098:
/* Line 1787 of yacc.c  */
#line 7411 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_ROLE;
					n->subname = (yyvsp[(3) - (6)].str);
					n->newname = (yyvsp[(6) - (6)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1099:
/* Line 1787 of yacc.c  */
#line 7420 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TABLESPACE;
					n->subname = (yyvsp[(3) - (6)].str);
					n->newname = (yyvsp[(6) - (6)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1100:
/* Line 1787 of yacc.c  */
#line 7429 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TSPARSER;
					n->object = (yyvsp[(5) - (8)].list);
					n->newname = (yyvsp[(8) - (8)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1101:
/* Line 1787 of yacc.c  */
#line 7438 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TSDICTIONARY;
					n->object = (yyvsp[(5) - (8)].list);
					n->newname = (yyvsp[(8) - (8)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1102:
/* Line 1787 of yacc.c  */
#line 7447 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TSTEMPLATE;
					n->object = (yyvsp[(5) - (8)].list);
					n->newname = (yyvsp[(8) - (8)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1103:
/* Line 1787 of yacc.c  */
#line 7456 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TSCONFIGURATION;
					n->object = (yyvsp[(5) - (8)].list);
					n->newname = (yyvsp[(8) - (8)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1104:
/* Line 1787 of yacc.c  */
#line 7465 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TYPE;
					n->object = (yyvsp[(3) - (6)].list);
					n->newname = (yyvsp[(6) - (6)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1105:
/* Line 1787 of yacc.c  */
#line 7474 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_ATTRIBUTE;
					n->relationType = OBJECT_TYPE;
					n->relation = makeRangeVarFromAnyName((yyvsp[(3) - (9)].list), (yylsp[(3) - (9)]), yyscanner);
					n->subname = (yyvsp[(6) - (9)].str);
					n->newname = (yyvsp[(8) - (9)].str);
					n->behavior = (yyvsp[(9) - (9)].dbehavior);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1106:
/* Line 1787 of yacc.c  */
#line 7487 "gram.y"
    { (yyval.ival) = COLUMN; }
    break;

  case 1107:
/* Line 1787 of yacc.c  */
#line 7488 "gram.y"
    { (yyval.ival) = 0; }
    break;

  case 1108:
/* Line 1787 of yacc.c  */
#line 7491 "gram.y"
    { (yyval.ival) = 1; }
    break;

  case 1109:
/* Line 1787 of yacc.c  */
#line 7492 "gram.y"
    { (yyval.ival) = 0; }
    break;

  case 1110:
/* Line 1787 of yacc.c  */
#line 7503 "gram.y"
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_AGGREGATE;
					n->object = (yyvsp[(3) - (7)].list);
					n->objarg = extractAggrArgTypes((yyvsp[(4) - (7)].list));
					n->newschema = (yyvsp[(7) - (7)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1111:
/* Line 1787 of yacc.c  */
#line 7513 "gram.y"
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_COLLATION;
					n->object = (yyvsp[(3) - (6)].list);
					n->newschema = (yyvsp[(6) - (6)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1112:
/* Line 1787 of yacc.c  */
#line 7522 "gram.y"
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_CONVERSION;
					n->object = (yyvsp[(3) - (6)].list);
					n->newschema = (yyvsp[(6) - (6)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1113:
/* Line 1787 of yacc.c  */
#line 7531 "gram.y"
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_DOMAIN;
					n->object = (yyvsp[(3) - (6)].list);
					n->newschema = (yyvsp[(6) - (6)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1114:
/* Line 1787 of yacc.c  */
#line 7540 "gram.y"
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_EXTENSION;
					n->object = (yyvsp[(3) - (6)].list);
					n->newschema = (yyvsp[(6) - (6)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1115:
/* Line 1787 of yacc.c  */
#line 7549 "gram.y"
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_FUNCTION;
					n->object = (yyvsp[(3) - (6)].funwithargs)->funcname;
					n->objarg = (yyvsp[(3) - (6)].funwithargs)->funcargs;
					n->newschema = (yyvsp[(6) - (6)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1116:
/* Line 1787 of yacc.c  */
#line 7559 "gram.y"
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_OPERATOR;
					n->object = (yyvsp[(3) - (7)].list);
					n->objarg = (yyvsp[(4) - (7)].list);
					n->newschema = (yyvsp[(7) - (7)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1117:
/* Line 1787 of yacc.c  */
#line 7569 "gram.y"
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_OPCLASS;
					n->object = (yyvsp[(4) - (9)].list);
					n->objarg = list_make1(makeString((yyvsp[(6) - (9)].str)));
					n->newschema = (yyvsp[(9) - (9)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1118:
/* Line 1787 of yacc.c  */
#line 7579 "gram.y"
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_OPFAMILY;
					n->object = (yyvsp[(4) - (9)].list);
					n->objarg = list_make1(makeString((yyvsp[(6) - (9)].str)));
					n->newschema = (yyvsp[(9) - (9)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1119:
/* Line 1787 of yacc.c  */
#line 7589 "gram.y"
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_TABLE;
					n->relation = (yyvsp[(3) - (6)].range);
					n->newschema = (yyvsp[(6) - (6)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1120:
/* Line 1787 of yacc.c  */
#line 7598 "gram.y"
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_TABLE;
					n->relation = (yyvsp[(5) - (8)].range);
					n->newschema = (yyvsp[(8) - (8)].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1121:
/* Line 1787 of yacc.c  */
#line 7607 "gram.y"
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_TSPARSER;
					n->object = (yyvsp[(5) - (8)].list);
					n->newschema = (yyvsp[(8) - (8)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1122:
/* Line 1787 of yacc.c  */
#line 7616 "gram.y"
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_TSDICTIONARY;
					n->object = (yyvsp[(5) - (8)].list);
					n->newschema = (yyvsp[(8) - (8)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1123:
/* Line 1787 of yacc.c  */
#line 7625 "gram.y"
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_TSTEMPLATE;
					n->object = (yyvsp[(5) - (8)].list);
					n->newschema = (yyvsp[(8) - (8)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1124:
/* Line 1787 of yacc.c  */
#line 7634 "gram.y"
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_TSCONFIGURATION;
					n->object = (yyvsp[(5) - (8)].list);
					n->newschema = (yyvsp[(8) - (8)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1125:
/* Line 1787 of yacc.c  */
#line 7643 "gram.y"
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_SEQUENCE;
					n->relation = (yyvsp[(3) - (6)].range);
					n->newschema = (yyvsp[(6) - (6)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1126:
/* Line 1787 of yacc.c  */
#line 7652 "gram.y"
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_SEQUENCE;
					n->relation = (yyvsp[(5) - (8)].range);
					n->newschema = (yyvsp[(8) - (8)].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1127:
/* Line 1787 of yacc.c  */
#line 7661 "gram.y"
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_VIEW;
					n->relation = (yyvsp[(3) - (6)].range);
					n->newschema = (yyvsp[(6) - (6)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1128:
/* Line 1787 of yacc.c  */
#line 7670 "gram.y"
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_VIEW;
					n->relation = (yyvsp[(5) - (8)].range);
					n->newschema = (yyvsp[(8) - (8)].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1129:
/* Line 1787 of yacc.c  */
#line 7679 "gram.y"
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_MATVIEW;
					n->relation = (yyvsp[(4) - (7)].range);
					n->newschema = (yyvsp[(7) - (7)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1130:
/* Line 1787 of yacc.c  */
#line 7688 "gram.y"
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_MATVIEW;
					n->relation = (yyvsp[(6) - (9)].range);
					n->newschema = (yyvsp[(9) - (9)].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1131:
/* Line 1787 of yacc.c  */
#line 7697 "gram.y"
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_FOREIGN_TABLE;
					n->relation = (yyvsp[(4) - (7)].range);
					n->newschema = (yyvsp[(7) - (7)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1132:
/* Line 1787 of yacc.c  */
#line 7706 "gram.y"
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_FOREIGN_TABLE;
					n->relation = (yyvsp[(6) - (9)].range);
					n->newschema = (yyvsp[(9) - (9)].str);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1133:
/* Line 1787 of yacc.c  */
#line 7715 "gram.y"
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_TYPE;
					n->object = (yyvsp[(3) - (6)].list);
					n->newschema = (yyvsp[(6) - (6)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1134:
/* Line 1787 of yacc.c  */
#line 7732 "gram.y"
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_AGGREGATE;
					n->object = (yyvsp[(3) - (7)].list);
					n->objarg = extractAggrArgTypes((yyvsp[(4) - (7)].list));
					n->newowner = (yyvsp[(7) - (7)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1135:
/* Line 1787 of yacc.c  */
#line 7741 "gram.y"
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_COLLATION;
					n->object = (yyvsp[(3) - (6)].list);
					n->newowner = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1136:
/* Line 1787 of yacc.c  */
#line 7749 "gram.y"
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_CONVERSION;
					n->object = (yyvsp[(3) - (6)].list);
					n->newowner = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1137:
/* Line 1787 of yacc.c  */
#line 7757 "gram.y"
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_DATABASE;
					n->object = list_make1(makeString((yyvsp[(3) - (6)].str)));
					n->newowner = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1138:
/* Line 1787 of yacc.c  */
#line 7765 "gram.y"
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_DOMAIN;
					n->object = (yyvsp[(3) - (6)].list);
					n->newowner = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1139:
/* Line 1787 of yacc.c  */
#line 7773 "gram.y"
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_FUNCTION;
					n->object = (yyvsp[(3) - (6)].funwithargs)->funcname;
					n->objarg = (yyvsp[(3) - (6)].funwithargs)->funcargs;
					n->newowner = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1140:
/* Line 1787 of yacc.c  */
#line 7782 "gram.y"
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_LANGUAGE;
					n->object = list_make1(makeString((yyvsp[(4) - (7)].str)));
					n->newowner = (yyvsp[(7) - (7)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1141:
/* Line 1787 of yacc.c  */
#line 7790 "gram.y"
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_LARGEOBJECT;
					n->object = list_make1((yyvsp[(4) - (7)].value));
					n->newowner = (yyvsp[(7) - (7)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1142:
/* Line 1787 of yacc.c  */
#line 7798 "gram.y"
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_OPERATOR;
					n->object = (yyvsp[(3) - (7)].list);
					n->objarg = (yyvsp[(4) - (7)].list);
					n->newowner = (yyvsp[(7) - (7)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1143:
/* Line 1787 of yacc.c  */
#line 7807 "gram.y"
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_OPCLASS;
					n->object = (yyvsp[(4) - (9)].list);
					n->objarg = list_make1(makeString((yyvsp[(6) - (9)].str)));
					n->newowner = (yyvsp[(9) - (9)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1144:
/* Line 1787 of yacc.c  */
#line 7816 "gram.y"
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_OPFAMILY;
					n->object = (yyvsp[(4) - (9)].list);
					n->objarg = list_make1(makeString((yyvsp[(6) - (9)].str)));
					n->newowner = (yyvsp[(9) - (9)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1145:
/* Line 1787 of yacc.c  */
#line 7825 "gram.y"
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_SCHEMA;
					n->object = list_make1(makeString((yyvsp[(3) - (6)].str)));
					n->newowner = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1146:
/* Line 1787 of yacc.c  */
#line 7833 "gram.y"
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_TYPE;
					n->object = (yyvsp[(3) - (6)].list);
					n->newowner = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1147:
/* Line 1787 of yacc.c  */
#line 7841 "gram.y"
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_TABLESPACE;
					n->object = list_make1(makeString((yyvsp[(3) - (6)].str)));
					n->newowner = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1148:
/* Line 1787 of yacc.c  */
#line 7849 "gram.y"
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_TSDICTIONARY;
					n->object = (yyvsp[(5) - (8)].list);
					n->newowner = (yyvsp[(8) - (8)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1149:
/* Line 1787 of yacc.c  */
#line 7857 "gram.y"
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_TSCONFIGURATION;
					n->object = (yyvsp[(5) - (8)].list);
					n->newowner = (yyvsp[(8) - (8)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1150:
/* Line 1787 of yacc.c  */
#line 7865 "gram.y"
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_FDW;
					n->object = list_make1(makeString((yyvsp[(5) - (8)].str)));
					n->newowner = (yyvsp[(8) - (8)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1151:
/* Line 1787 of yacc.c  */
#line 7873 "gram.y"
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_FOREIGN_SERVER;
					n->object = list_make1(makeString((yyvsp[(3) - (6)].str)));
					n->newowner = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1152:
/* Line 1787 of yacc.c  */
#line 7881 "gram.y"
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_EVENT_TRIGGER;
					n->object = list_make1(makeString((yyvsp[(4) - (7)].str)));
					n->newowner = (yyvsp[(7) - (7)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1153:
/* Line 1787 of yacc.c  */
#line 7900 "gram.y"
    {
					RuleStmt *n = makeNode(RuleStmt);
					n->replace = (yyvsp[(2) - (13)].boolean);
					n->relation = (yyvsp[(9) - (13)].range);
					n->rulename = (yyvsp[(4) - (13)].str);
					n->whereClause = (yyvsp[(10) - (13)].node);
					n->event = (yyvsp[(7) - (13)].ival);
					n->instead = (yyvsp[(12) - (13)].boolean);
					n->actions = (yyvsp[(13) - (13)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1154:
/* Line 1787 of yacc.c  */
#line 7914 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 1155:
/* Line 1787 of yacc.c  */
#line 7915 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].node)); }
    break;

  case 1156:
/* Line 1787 of yacc.c  */
#line 7916 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (3)].list); }
    break;

  case 1157:
/* Line 1787 of yacc.c  */
#line 7922 "gram.y"
    { if ((yyvsp[(3) - (3)].node) != NULL)
					(yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node));
				  else
					(yyval.list) = (yyvsp[(1) - (3)].list);
				}
    break;

  case 1158:
/* Line 1787 of yacc.c  */
#line 7928 "gram.y"
    { if ((yyvsp[(1) - (1)].node) != NULL)
					(yyval.list) = list_make1((yyvsp[(1) - (1)].node));
				  else
					(yyval.list) = NIL;
				}
    break;

  case 1164:
/* Line 1787 of yacc.c  */
#line 7944 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); }
    break;

  case 1165:
/* Line 1787 of yacc.c  */
#line 7945 "gram.y"
    { (yyval.node) = NULL; }
    break;

  case 1166:
/* Line 1787 of yacc.c  */
#line 7948 "gram.y"
    { (yyval.ival) = CMD_SELECT; }
    break;

  case 1167:
/* Line 1787 of yacc.c  */
#line 7949 "gram.y"
    { (yyval.ival) = CMD_UPDATE; }
    break;

  case 1168:
/* Line 1787 of yacc.c  */
#line 7950 "gram.y"
    { (yyval.ival) = CMD_DELETE; }
    break;

  case 1169:
/* Line 1787 of yacc.c  */
#line 7951 "gram.y"
    { (yyval.ival) = CMD_INSERT; }
    break;

  case 1170:
/* Line 1787 of yacc.c  */
#line 7955 "gram.y"
    { (yyval.boolean) = TRUE; }
    break;

  case 1171:
/* Line 1787 of yacc.c  */
#line 7956 "gram.y"
    { (yyval.boolean) = FALSE; }
    break;

  case 1172:
/* Line 1787 of yacc.c  */
#line 7957 "gram.y"
    { (yyval.boolean) = FALSE; }
    break;

  case 1173:
/* Line 1787 of yacc.c  */
#line 7963 "gram.y"
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_RULE;
					n->objects = list_make1(lappend((yyvsp[(5) - (6)].list), makeString((yyvsp[(3) - (6)].str))));
					n->arguments = NIL;
					n->behavior = (yyvsp[(6) - (6)].dbehavior);
					n->missing_ok = false;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
    break;

  case 1174:
/* Line 1787 of yacc.c  */
#line 7974 "gram.y"
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = OBJECT_RULE;
					n->objects = list_make1(lappend((yyvsp[(7) - (8)].list), makeString((yyvsp[(5) - (8)].str))));
					n->arguments = NIL;
					n->behavior = (yyvsp[(8) - (8)].dbehavior);
					n->missing_ok = true;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
    break;

  case 1175:
/* Line 1787 of yacc.c  */
#line 7996 "gram.y"
    {
					NotifyStmt *n = makeNode(NotifyStmt);
					n->conditionname = (yyvsp[(2) - (3)].str);
					n->payload = (yyvsp[(3) - (3)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1176:
/* Line 1787 of yacc.c  */
#line 8005 "gram.y"
    { (yyval.str) = (yyvsp[(2) - (2)].str); }
    break;

  case 1177:
/* Line 1787 of yacc.c  */
#line 8006 "gram.y"
    { (yyval.str) = NULL; }
    break;

  case 1178:
/* Line 1787 of yacc.c  */
#line 8010 "gram.y"
    {
					ListenStmt *n = makeNode(ListenStmt);
					n->conditionname = (yyvsp[(2) - (2)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1179:
/* Line 1787 of yacc.c  */
#line 8019 "gram.y"
    {
					UnlistenStmt *n = makeNode(UnlistenStmt);
					n->conditionname = (yyvsp[(2) - (2)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1180:
/* Line 1787 of yacc.c  */
#line 8025 "gram.y"
    {
					UnlistenStmt *n = makeNode(UnlistenStmt);
					n->conditionname = NULL;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1181:
/* Line 1787 of yacc.c  */
#line 8044 "gram.y"
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_ROLLBACK;
					n->options = NIL;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1182:
/* Line 1787 of yacc.c  */
#line 8051 "gram.y"
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_BEGIN;
					n->options = (yyvsp[(3) - (3)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1183:
/* Line 1787 of yacc.c  */
#line 8058 "gram.y"
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_START;
					n->options = (yyvsp[(3) - (3)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1184:
/* Line 1787 of yacc.c  */
#line 8065 "gram.y"
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_COMMIT;
					n->options = NIL;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1185:
/* Line 1787 of yacc.c  */
#line 8072 "gram.y"
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_COMMIT;
					n->options = NIL;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1186:
/* Line 1787 of yacc.c  */
#line 8079 "gram.y"
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_ROLLBACK;
					n->options = NIL;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1187:
/* Line 1787 of yacc.c  */
#line 8086 "gram.y"
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_SAVEPOINT;
					n->options = list_make1(makeDefElem("savepoint_name",
														(Node *)makeString((yyvsp[(2) - (2)].str))));
					(yyval.node) = (Node *)n;
				}
    break;

  case 1188:
/* Line 1787 of yacc.c  */
#line 8094 "gram.y"
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_RELEASE;
					n->options = list_make1(makeDefElem("savepoint_name",
														(Node *)makeString((yyvsp[(3) - (3)].str))));
					(yyval.node) = (Node *)n;
				}
    break;

  case 1189:
/* Line 1787 of yacc.c  */
#line 8102 "gram.y"
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_RELEASE;
					n->options = list_make1(makeDefElem("savepoint_name",
														(Node *)makeString((yyvsp[(2) - (2)].str))));
					(yyval.node) = (Node *)n;
				}
    break;

  case 1190:
/* Line 1787 of yacc.c  */
#line 8110 "gram.y"
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_ROLLBACK_TO;
					n->options = list_make1(makeDefElem("savepoint_name",
														(Node *)makeString((yyvsp[(5) - (5)].str))));
					(yyval.node) = (Node *)n;
				}
    break;

  case 1191:
/* Line 1787 of yacc.c  */
#line 8118 "gram.y"
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_ROLLBACK_TO;
					n->options = list_make1(makeDefElem("savepoint_name",
														(Node *)makeString((yyvsp[(4) - (4)].str))));
					(yyval.node) = (Node *)n;
				}
    break;

  case 1192:
/* Line 1787 of yacc.c  */
#line 8126 "gram.y"
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_PREPARE;
					n->gid = (yyvsp[(3) - (3)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1193:
/* Line 1787 of yacc.c  */
#line 8133 "gram.y"
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_COMMIT_PREPARED;
					n->gid = (yyvsp[(3) - (3)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1194:
/* Line 1787 of yacc.c  */
#line 8140 "gram.y"
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_ROLLBACK_PREPARED;
					n->gid = (yyvsp[(3) - (3)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1195:
/* Line 1787 of yacc.c  */
#line 8148 "gram.y"
    {}
    break;

  case 1196:
/* Line 1787 of yacc.c  */
#line 8149 "gram.y"
    {}
    break;

  case 1197:
/* Line 1787 of yacc.c  */
#line 8150 "gram.y"
    {}
    break;

  case 1198:
/* Line 1787 of yacc.c  */
#line 8155 "gram.y"
    { (yyval.defelt) = makeDefElem("transaction_isolation",
									   makeStringConst((yyvsp[(3) - (3)].str), (yylsp[(3) - (3)]))); }
    break;

  case 1199:
/* Line 1787 of yacc.c  */
#line 8158 "gram.y"
    { (yyval.defelt) = makeDefElem("transaction_read_only",
									   makeIntConst(TRUE, (yylsp[(1) - (2)]))); }
    break;

  case 1200:
/* Line 1787 of yacc.c  */
#line 8161 "gram.y"
    { (yyval.defelt) = makeDefElem("transaction_read_only",
									   makeIntConst(FALSE, (yylsp[(1) - (2)]))); }
    break;

  case 1201:
/* Line 1787 of yacc.c  */
#line 8164 "gram.y"
    { (yyval.defelt) = makeDefElem("transaction_deferrable",
									   makeIntConst(TRUE, (yylsp[(1) - (1)]))); }
    break;

  case 1202:
/* Line 1787 of yacc.c  */
#line 8167 "gram.y"
    { (yyval.defelt) = makeDefElem("transaction_deferrable",
									   makeIntConst(FALSE, (yylsp[(1) - (2)]))); }
    break;

  case 1203:
/* Line 1787 of yacc.c  */
#line 8174 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].defelt)); }
    break;

  case 1204:
/* Line 1787 of yacc.c  */
#line 8176 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].defelt)); }
    break;

  case 1205:
/* Line 1787 of yacc.c  */
#line 8178 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].defelt)); }
    break;

  case 1207:
/* Line 1787 of yacc.c  */
#line 8184 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 1208:
/* Line 1787 of yacc.c  */
#line 8198 "gram.y"
    {
					ViewStmt *n = makeNode(ViewStmt);
					n->view = (yyvsp[(4) - (9)].range);
					n->view->relpersistence = (yyvsp[(2) - (9)].ival);
					n->aliases = (yyvsp[(5) - (9)].list);
					n->query = (yyvsp[(8) - (9)].node);
					n->replace = false;
					n->options = (yyvsp[(6) - (9)].list);
					n->withCheckOption = (yyvsp[(9) - (9)].ival);
					(yyval.node) = (Node *) n;
				}
    break;

  case 1209:
/* Line 1787 of yacc.c  */
#line 8211 "gram.y"
    {
					ViewStmt *n = makeNode(ViewStmt);
					n->view = (yyvsp[(6) - (11)].range);
					n->view->relpersistence = (yyvsp[(4) - (11)].ival);
					n->aliases = (yyvsp[(7) - (11)].list);
					n->query = (yyvsp[(10) - (11)].node);
					n->replace = true;
					n->options = (yyvsp[(8) - (11)].list);
					n->withCheckOption = (yyvsp[(11) - (11)].ival);
					(yyval.node) = (Node *) n;
				}
    break;

  case 1210:
/* Line 1787 of yacc.c  */
#line 8224 "gram.y"
    {
					ViewStmt *n = makeNode(ViewStmt);
					n->view = (yyvsp[(5) - (12)].range);
					n->view->relpersistence = (yyvsp[(2) - (12)].ival);
					n->aliases = (yyvsp[(7) - (12)].list);
					n->query = makeRecursiveViewSelect(n->view->relname, n->aliases, (yyvsp[(11) - (12)].node));
					n->replace = false;
					n->options = (yyvsp[(9) - (12)].list);
					n->withCheckOption = (yyvsp[(12) - (12)].ival);
					if (n->withCheckOption != NO_CHECK_OPTION)
						ereport(ERROR,
								(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
								 errmsg("WITH CHECK OPTION not supported on recursive views"),
								 parser_errposition((yylsp[(12) - (12)]))));
					(yyval.node) = (Node *) n;
				}
    break;

  case 1211:
/* Line 1787 of yacc.c  */
#line 8242 "gram.y"
    {
					ViewStmt *n = makeNode(ViewStmt);
					n->view = (yyvsp[(7) - (14)].range);
					n->view->relpersistence = (yyvsp[(4) - (14)].ival);
					n->aliases = (yyvsp[(9) - (14)].list);
					n->query = makeRecursiveViewSelect(n->view->relname, n->aliases, (yyvsp[(13) - (14)].node));
					n->replace = true;
					n->options = (yyvsp[(11) - (14)].list);
					n->withCheckOption = (yyvsp[(14) - (14)].ival);
					if (n->withCheckOption != NO_CHECK_OPTION)
						ereport(ERROR,
								(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
								 errmsg("WITH CHECK OPTION not supported on recursive views"),
								 parser_errposition((yylsp[(14) - (14)]))));
					(yyval.node) = (Node *) n;
				}
    break;

  case 1212:
/* Line 1787 of yacc.c  */
#line 8261 "gram.y"
    { (yyval.ival) = CASCADED_CHECK_OPTION; }
    break;

  case 1213:
/* Line 1787 of yacc.c  */
#line 8262 "gram.y"
    { (yyval.ival) = CASCADED_CHECK_OPTION; }
    break;

  case 1214:
/* Line 1787 of yacc.c  */
#line 8263 "gram.y"
    { (yyval.ival) = LOCAL_CHECK_OPTION; }
    break;

  case 1215:
/* Line 1787 of yacc.c  */
#line 8264 "gram.y"
    { (yyval.ival) = NO_CHECK_OPTION; }
    break;

  case 1216:
/* Line 1787 of yacc.c  */
#line 8275 "gram.y"
    {
					LoadStmt *n = makeNode(LoadStmt);
					n->filename = (yyvsp[(2) - (2)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1217:
/* Line 1787 of yacc.c  */
#line 8291 "gram.y"
    {
					CreatedbStmt *n = makeNode(CreatedbStmt);
					n->dbname = (yyvsp[(3) - (5)].str);
					n->options = (yyvsp[(5) - (5)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1218:
/* Line 1787 of yacc.c  */
#line 8300 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].defelt)); }
    break;

  case 1219:
/* Line 1787 of yacc.c  */
#line 8301 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 1220:
/* Line 1787 of yacc.c  */
#line 8306 "gram.y"
    {
					(yyval.defelt) = makeDefElem("tablespace", (Node *)makeString((yyvsp[(3) - (3)].str)));
				}
    break;

  case 1221:
/* Line 1787 of yacc.c  */
#line 8310 "gram.y"
    {
					(yyval.defelt) = makeDefElem("tablespace", NULL);
				}
    break;

  case 1222:
/* Line 1787 of yacc.c  */
#line 8314 "gram.y"
    {
					(yyval.defelt) = makeDefElem("location", (Node *)makeString((yyvsp[(3) - (3)].str)));
				}
    break;

  case 1223:
/* Line 1787 of yacc.c  */
#line 8318 "gram.y"
    {
					(yyval.defelt) = makeDefElem("location", NULL);
				}
    break;

  case 1224:
/* Line 1787 of yacc.c  */
#line 8322 "gram.y"
    {
					(yyval.defelt) = makeDefElem("template", (Node *)makeString((yyvsp[(3) - (3)].str)));
				}
    break;

  case 1225:
/* Line 1787 of yacc.c  */
#line 8326 "gram.y"
    {
					(yyval.defelt) = makeDefElem("template", NULL);
				}
    break;

  case 1226:
/* Line 1787 of yacc.c  */
#line 8330 "gram.y"
    {
					(yyval.defelt) = makeDefElem("encoding", (Node *)makeString((yyvsp[(3) - (3)].str)));
				}
    break;

  case 1227:
/* Line 1787 of yacc.c  */
#line 8334 "gram.y"
    {
					(yyval.defelt) = makeDefElem("encoding", (Node *)makeInteger((yyvsp[(3) - (3)].ival)));
				}
    break;

  case 1228:
/* Line 1787 of yacc.c  */
#line 8338 "gram.y"
    {
					(yyval.defelt) = makeDefElem("encoding", NULL);
				}
    break;

  case 1229:
/* Line 1787 of yacc.c  */
#line 8342 "gram.y"
    {
					(yyval.defelt) = makeDefElem("lc_collate", (Node *)makeString((yyvsp[(3) - (3)].str)));
				}
    break;

  case 1230:
/* Line 1787 of yacc.c  */
#line 8346 "gram.y"
    {
					(yyval.defelt) = makeDefElem("lc_collate", NULL);
				}
    break;

  case 1231:
/* Line 1787 of yacc.c  */
#line 8350 "gram.y"
    {
					(yyval.defelt) = makeDefElem("lc_ctype", (Node *)makeString((yyvsp[(3) - (3)].str)));
				}
    break;

  case 1232:
/* Line 1787 of yacc.c  */
#line 8354 "gram.y"
    {
					(yyval.defelt) = makeDefElem("lc_ctype", NULL);
				}
    break;

  case 1233:
/* Line 1787 of yacc.c  */
#line 8358 "gram.y"
    {
					(yyval.defelt) = makeDefElem("connectionlimit", (Node *)makeInteger((yyvsp[(4) - (4)].ival)));
				}
    break;

  case 1234:
/* Line 1787 of yacc.c  */
#line 8362 "gram.y"
    {
					(yyval.defelt) = makeDefElem("owner", (Node *)makeString((yyvsp[(3) - (3)].str)));
				}
    break;

  case 1235:
/* Line 1787 of yacc.c  */
#line 8366 "gram.y"
    {
					(yyval.defelt) = makeDefElem("owner", NULL);
				}
    break;

  case 1236:
/* Line 1787 of yacc.c  */
#line 8375 "gram.y"
    {}
    break;

  case 1237:
/* Line 1787 of yacc.c  */
#line 8376 "gram.y"
    {}
    break;

  case 1238:
/* Line 1787 of yacc.c  */
#line 8388 "gram.y"
    {
					AlterDatabaseStmt *n = makeNode(AlterDatabaseStmt);
					n->dbname = (yyvsp[(3) - (5)].str);
					n->options = (yyvsp[(5) - (5)].list);
					(yyval.node) = (Node *)n;
				 }
    break;

  case 1239:
/* Line 1787 of yacc.c  */
#line 8395 "gram.y"
    {
					AlterDatabaseStmt *n = makeNode(AlterDatabaseStmt);
					n->dbname = (yyvsp[(3) - (6)].str);
					n->options = list_make1(makeDefElem("tablespace",
													(Node *)makeString((yyvsp[(6) - (6)].str))));
					(yyval.node) = (Node *)n;
				 }
    break;

  case 1240:
/* Line 1787 of yacc.c  */
#line 8406 "gram.y"
    {
					AlterDatabaseSetStmt *n = makeNode(AlterDatabaseSetStmt);
					n->dbname = (yyvsp[(3) - (4)].str);
					n->setstmt = (yyvsp[(4) - (4)].vsetstmt);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1241:
/* Line 1787 of yacc.c  */
#line 8416 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].defelt)); }
    break;

  case 1242:
/* Line 1787 of yacc.c  */
#line 8417 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 1243:
/* Line 1787 of yacc.c  */
#line 8422 "gram.y"
    {
					(yyval.defelt) = makeDefElem("connectionlimit", (Node *)makeInteger((yyvsp[(4) - (4)].ival)));
				}
    break;

  case 1244:
/* Line 1787 of yacc.c  */
#line 8436 "gram.y"
    {
					DropdbStmt *n = makeNode(DropdbStmt);
					n->dbname = (yyvsp[(3) - (3)].str);
					n->missing_ok = FALSE;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1245:
/* Line 1787 of yacc.c  */
#line 8443 "gram.y"
    {
					DropdbStmt *n = makeNode(DropdbStmt);
					n->dbname = (yyvsp[(5) - (5)].str);
					n->missing_ok = TRUE;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1246:
/* Line 1787 of yacc.c  */
#line 8461 "gram.y"
    {
					AlterSystemStmt *n = makeNode(AlterSystemStmt);
					n->setstmt = (yyvsp[(4) - (4)].vsetstmt);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1247:
/* Line 1787 of yacc.c  */
#line 8467 "gram.y"
    {
					AlterSystemStmt *n = makeNode(AlterSystemStmt);
					n->setstmt = (yyvsp[(4) - (4)].vsetstmt);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1248:
/* Line 1787 of yacc.c  */
#line 8483 "gram.y"
    {
					CreateDomainStmt *n = makeNode(CreateDomainStmt);
					n->domainname = (yyvsp[(3) - (6)].list);
					n->typeName = (yyvsp[(5) - (6)].typnam);
					SplitColQualList((yyvsp[(6) - (6)].list), &n->constraints, &n->collClause,
									 yyscanner);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1249:
/* Line 1787 of yacc.c  */
#line 8496 "gram.y"
    {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);
					n->subtype = 'T';
					n->typeName = (yyvsp[(3) - (4)].list);
					n->def = (yyvsp[(4) - (4)].node);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1250:
/* Line 1787 of yacc.c  */
#line 8505 "gram.y"
    {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);
					n->subtype = 'N';
					n->typeName = (yyvsp[(3) - (6)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1251:
/* Line 1787 of yacc.c  */
#line 8513 "gram.y"
    {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);
					n->subtype = 'O';
					n->typeName = (yyvsp[(3) - (6)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1252:
/* Line 1787 of yacc.c  */
#line 8521 "gram.y"
    {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);
					n->subtype = 'C';
					n->typeName = (yyvsp[(3) - (5)].list);
					n->def = (yyvsp[(5) - (5)].node);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1253:
/* Line 1787 of yacc.c  */
#line 8530 "gram.y"
    {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);
					n->subtype = 'X';
					n->typeName = (yyvsp[(3) - (7)].list);
					n->name = (yyvsp[(6) - (7)].str);
					n->behavior = (yyvsp[(7) - (7)].dbehavior);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1254:
/* Line 1787 of yacc.c  */
#line 8541 "gram.y"
    {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);
					n->subtype = 'X';
					n->typeName = (yyvsp[(3) - (9)].list);
					n->name = (yyvsp[(8) - (9)].str);
					n->behavior = (yyvsp[(9) - (9)].dbehavior);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1255:
/* Line 1787 of yacc.c  */
#line 8552 "gram.y"
    {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);
					n->subtype = 'V';
					n->typeName = (yyvsp[(3) - (6)].list);
					n->name = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1256:
/* Line 1787 of yacc.c  */
#line 8561 "gram.y"
    {}
    break;

  case 1257:
/* Line 1787 of yacc.c  */
#line 8562 "gram.y"
    {}
    break;

  case 1258:
/* Line 1787 of yacc.c  */
#line 8574 "gram.y"
    {
					AlterTSDictionaryStmt *n = makeNode(AlterTSDictionaryStmt);
					n->dictname = (yyvsp[(5) - (6)].list);
					n->options = (yyvsp[(6) - (6)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1259:
/* Line 1787 of yacc.c  */
#line 8584 "gram.y"
    {
					AlterTSConfigurationStmt *n = makeNode(AlterTSConfigurationStmt);
					n->cfgname = (yyvsp[(5) - (11)].list);
					n->tokentype = (yyvsp[(9) - (11)].list);
					n->dicts = (yyvsp[(11) - (11)].list);
					n->override = false;
					n->replace = false;
					(yyval.node) = (Node*)n;
				}
    break;

  case 1260:
/* Line 1787 of yacc.c  */
#line 8594 "gram.y"
    {
					AlterTSConfigurationStmt *n = makeNode(AlterTSConfigurationStmt);
					n->cfgname = (yyvsp[(5) - (11)].list);
					n->tokentype = (yyvsp[(9) - (11)].list);
					n->dicts = (yyvsp[(11) - (11)].list);
					n->override = true;
					n->replace = false;
					(yyval.node) = (Node*)n;
				}
    break;

  case 1261:
/* Line 1787 of yacc.c  */
#line 8604 "gram.y"
    {
					AlterTSConfigurationStmt *n = makeNode(AlterTSConfigurationStmt);
					n->cfgname = (yyvsp[(5) - (11)].list);
					n->tokentype = NIL;
					n->dicts = list_make2((yyvsp[(9) - (11)].list),(yyvsp[(11) - (11)].list));
					n->override = false;
					n->replace = true;
					(yyval.node) = (Node*)n;
				}
    break;

  case 1262:
/* Line 1787 of yacc.c  */
#line 8614 "gram.y"
    {
					AlterTSConfigurationStmt *n = makeNode(AlterTSConfigurationStmt);
					n->cfgname = (yyvsp[(5) - (13)].list);
					n->tokentype = (yyvsp[(9) - (13)].list);
					n->dicts = list_make2((yyvsp[(11) - (13)].list),(yyvsp[(13) - (13)].list));
					n->override = false;
					n->replace = true;
					(yyval.node) = (Node*)n;
				}
    break;

  case 1263:
/* Line 1787 of yacc.c  */
#line 8624 "gram.y"
    {
					AlterTSConfigurationStmt *n = makeNode(AlterTSConfigurationStmt);
					n->cfgname = (yyvsp[(5) - (9)].list);
					n->tokentype = (yyvsp[(9) - (9)].list);
					n->missing_ok = false;
					(yyval.node) = (Node*)n;
				}
    break;

  case 1264:
/* Line 1787 of yacc.c  */
#line 8632 "gram.y"
    {
					AlterTSConfigurationStmt *n = makeNode(AlterTSConfigurationStmt);
					n->cfgname = (yyvsp[(5) - (11)].list);
					n->tokentype = (yyvsp[(11) - (11)].list);
					n->missing_ok = true;
					(yyval.node) = (Node*)n;
				}
    break;

  case 1265:
/* Line 1787 of yacc.c  */
#line 8654 "gram.y"
    {
				CreateConversionStmt *n = makeNode(CreateConversionStmt);
				n->conversion_name = (yyvsp[(4) - (10)].list);
				n->for_encoding_name = (yyvsp[(6) - (10)].str);
				n->to_encoding_name = (yyvsp[(8) - (10)].str);
				n->func_name = (yyvsp[(10) - (10)].list);
				n->def = (yyvsp[(2) - (10)].boolean);
				(yyval.node) = (Node *)n;
			}
    break;

  case 1266:
/* Line 1787 of yacc.c  */
#line 8676 "gram.y"
    {
					ClusterStmt *n = makeNode(ClusterStmt);
					n->relation = (yyvsp[(3) - (4)].range);
					n->indexname = (yyvsp[(4) - (4)].str);
					n->verbose = (yyvsp[(2) - (4)].boolean);
					(yyval.node) = (Node*)n;
				}
    break;

  case 1267:
/* Line 1787 of yacc.c  */
#line 8684 "gram.y"
    {
					ClusterStmt *n = makeNode(ClusterStmt);
					n->relation = NULL;
					n->indexname = NULL;
					n->verbose = (yyvsp[(2) - (2)].boolean);
					(yyval.node) = (Node*)n;
				}
    break;

  case 1268:
/* Line 1787 of yacc.c  */
#line 8693 "gram.y"
    {
					ClusterStmt *n = makeNode(ClusterStmt);
					n->relation = (yyvsp[(5) - (5)].range);
					n->indexname = (yyvsp[(3) - (5)].str);
					n->verbose = (yyvsp[(2) - (5)].boolean);
					(yyval.node) = (Node*)n;
				}
    break;

  case 1269:
/* Line 1787 of yacc.c  */
#line 8703 "gram.y"
    { (yyval.str) = (yyvsp[(2) - (2)].str); }
    break;

  case 1270:
/* Line 1787 of yacc.c  */
#line 8704 "gram.y"
    { (yyval.str) = NULL; }
    break;

  case 1271:
/* Line 1787 of yacc.c  */
#line 8717 "gram.y"
    {
					VacuumStmt *n = makeNode(VacuumStmt);
					n->options = VACOPT_VACUUM;
					if ((yyvsp[(2) - (4)].boolean))
						n->options |= VACOPT_FULL;
					if ((yyvsp[(4) - (4)].boolean))
						n->options |= VACOPT_VERBOSE;
					n->freeze_min_age = (yyvsp[(3) - (4)].boolean) ? 0 : -1;
					n->freeze_table_age = (yyvsp[(3) - (4)].boolean) ? 0 : -1;
					n->multixact_freeze_min_age = (yyvsp[(3) - (4)].boolean) ? 0 : -1;
					n->multixact_freeze_table_age = (yyvsp[(3) - (4)].boolean) ? 0 : -1;
					n->relation = NULL;
					n->va_cols = NIL;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1272:
/* Line 1787 of yacc.c  */
#line 8733 "gram.y"
    {
					VacuumStmt *n = makeNode(VacuumStmt);
					n->options = VACOPT_VACUUM;
					if ((yyvsp[(2) - (5)].boolean))
						n->options |= VACOPT_FULL;
					if ((yyvsp[(4) - (5)].boolean))
						n->options |= VACOPT_VERBOSE;
					n->freeze_min_age = (yyvsp[(3) - (5)].boolean) ? 0 : -1;
					n->freeze_table_age = (yyvsp[(3) - (5)].boolean) ? 0 : -1;
					n->multixact_freeze_min_age = (yyvsp[(3) - (5)].boolean) ? 0 : -1;
					n->multixact_freeze_table_age = (yyvsp[(3) - (5)].boolean) ? 0 : -1;
					n->relation = (yyvsp[(5) - (5)].range);
					n->va_cols = NIL;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1273:
/* Line 1787 of yacc.c  */
#line 8749 "gram.y"
    {
					VacuumStmt *n = (VacuumStmt *) (yyvsp[(5) - (5)].node);
					n->options |= VACOPT_VACUUM;
					if ((yyvsp[(2) - (5)].boolean))
						n->options |= VACOPT_FULL;
					if ((yyvsp[(4) - (5)].boolean))
						n->options |= VACOPT_VERBOSE;
					n->freeze_min_age = (yyvsp[(3) - (5)].boolean) ? 0 : -1;
					n->freeze_table_age = (yyvsp[(3) - (5)].boolean) ? 0 : -1;
					n->multixact_freeze_min_age = (yyvsp[(3) - (5)].boolean) ? 0 : -1;
					n->multixact_freeze_table_age = (yyvsp[(3) - (5)].boolean) ? 0 : -1;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1274:
/* Line 1787 of yacc.c  */
#line 8763 "gram.y"
    {
					VacuumStmt *n = makeNode(VacuumStmt);
					n->options = VACOPT_VACUUM | (yyvsp[(3) - (4)].ival);
					if (n->options & VACOPT_FREEZE)
					{
						n->freeze_min_age = n->freeze_table_age = 0;
						n->multixact_freeze_min_age = 0;
						n->multixact_freeze_table_age = 0;
					}
					else
					{
						n->freeze_min_age = n->freeze_table_age = -1;
						n->multixact_freeze_min_age = -1;
						n->multixact_freeze_table_age = -1;
					}
					n->relation = NULL;
					n->va_cols = NIL;
					(yyval.node) = (Node *) n;
				}
    break;

  case 1275:
/* Line 1787 of yacc.c  */
#line 8783 "gram.y"
    {
					VacuumStmt *n = makeNode(VacuumStmt);
					n->options = VACOPT_VACUUM | (yyvsp[(3) - (6)].ival);
					if (n->options & VACOPT_FREEZE)
					{
						n->freeze_min_age = n->freeze_table_age = 0;
						n->multixact_freeze_min_age = 0;
						n->multixact_freeze_table_age = 0;
					}
					else
					{
						n->freeze_min_age = n->freeze_table_age = -1;
						n->multixact_freeze_min_age = -1;
						n->multixact_freeze_table_age = -1;
					}
					n->relation = (yyvsp[(5) - (6)].range);
					n->va_cols = (yyvsp[(6) - (6)].list);
					if (n->va_cols != NIL)	/* implies analyze */
						n->options |= VACOPT_ANALYZE;
					(yyval.node) = (Node *) n;
				}
    break;

  case 1276:
/* Line 1787 of yacc.c  */
#line 8807 "gram.y"
    { (yyval.ival) = (yyvsp[(1) - (1)].ival); }
    break;

  case 1277:
/* Line 1787 of yacc.c  */
#line 8808 "gram.y"
    { (yyval.ival) = (yyvsp[(1) - (3)].ival) | (yyvsp[(3) - (3)].ival); }
    break;

  case 1278:
/* Line 1787 of yacc.c  */
#line 8812 "gram.y"
    { (yyval.ival) = VACOPT_ANALYZE; }
    break;

  case 1279:
/* Line 1787 of yacc.c  */
#line 8813 "gram.y"
    { (yyval.ival) = VACOPT_VERBOSE; }
    break;

  case 1280:
/* Line 1787 of yacc.c  */
#line 8814 "gram.y"
    { (yyval.ival) = VACOPT_FREEZE; }
    break;

  case 1281:
/* Line 1787 of yacc.c  */
#line 8815 "gram.y"
    { (yyval.ival) = VACOPT_FULL; }
    break;

  case 1282:
/* Line 1787 of yacc.c  */
#line 8820 "gram.y"
    {
					VacuumStmt *n = makeNode(VacuumStmt);
					n->options = VACOPT_ANALYZE;
					if ((yyvsp[(2) - (2)].boolean))
						n->options |= VACOPT_VERBOSE;
					n->freeze_min_age = -1;
					n->freeze_table_age = -1;
					n->multixact_freeze_min_age = -1;
					n->multixact_freeze_table_age = -1;
					n->relation = NULL;
					n->va_cols = NIL;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1283:
/* Line 1787 of yacc.c  */
#line 8834 "gram.y"
    {
					VacuumStmt *n = makeNode(VacuumStmt);
					n->options = VACOPT_ANALYZE;
					if ((yyvsp[(2) - (4)].boolean))
						n->options |= VACOPT_VERBOSE;
					n->freeze_min_age = -1;
					n->freeze_table_age = -1;
					n->multixact_freeze_min_age = -1;
					n->multixact_freeze_table_age = -1;
					n->relation = (yyvsp[(3) - (4)].range);
					n->va_cols = (yyvsp[(4) - (4)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1284:
/* Line 1787 of yacc.c  */
#line 8850 "gram.y"
    {}
    break;

  case 1285:
/* Line 1787 of yacc.c  */
#line 8851 "gram.y"
    {}
    break;

  case 1286:
/* Line 1787 of yacc.c  */
#line 8855 "gram.y"
    { (yyval.boolean) = TRUE; }
    break;

  case 1287:
/* Line 1787 of yacc.c  */
#line 8856 "gram.y"
    { (yyval.boolean) = FALSE; }
    break;

  case 1288:
/* Line 1787 of yacc.c  */
#line 8859 "gram.y"
    { (yyval.boolean) = TRUE; }
    break;

  case 1289:
/* Line 1787 of yacc.c  */
#line 8860 "gram.y"
    { (yyval.boolean) = FALSE; }
    break;

  case 1290:
/* Line 1787 of yacc.c  */
#line 8863 "gram.y"
    { (yyval.boolean) = TRUE; }
    break;

  case 1291:
/* Line 1787 of yacc.c  */
#line 8864 "gram.y"
    { (yyval.boolean) = FALSE; }
    break;

  case 1292:
/* Line 1787 of yacc.c  */
#line 8868 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (3)].list); }
    break;

  case 1293:
/* Line 1787 of yacc.c  */
#line 8869 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 1294:
/* Line 1787 of yacc.c  */
#line 8883 "gram.y"
    {
					ExplainStmt *n = makeNode(ExplainStmt);
					n->query = (yyvsp[(2) - (2)].node);
					n->options = NIL;
					(yyval.node) = (Node *) n;
				}
    break;

  case 1295:
/* Line 1787 of yacc.c  */
#line 8890 "gram.y"
    {
					ExplainStmt *n = makeNode(ExplainStmt);
					n->query = (yyvsp[(4) - (4)].node);
					n->options = list_make1(makeDefElem("analyze", NULL));
					if ((yyvsp[(3) - (4)].boolean))
						n->options = lappend(n->options,
											 makeDefElem("verbose", NULL));
					(yyval.node) = (Node *) n;
				}
    break;

  case 1296:
/* Line 1787 of yacc.c  */
#line 8900 "gram.y"
    {
					ExplainStmt *n = makeNode(ExplainStmt);
					n->query = (yyvsp[(3) - (3)].node);
					n->options = list_make1(makeDefElem("verbose", NULL));
					(yyval.node) = (Node *) n;
				}
    break;

  case 1297:
/* Line 1787 of yacc.c  */
#line 8907 "gram.y"
    {
					ExplainStmt *n = makeNode(ExplainStmt);
					n->query = (yyvsp[(5) - (5)].node);
					n->options = (yyvsp[(3) - (5)].list);
					(yyval.node) = (Node *) n;
				}
    break;

  case 1307:
/* Line 1787 of yacc.c  */
#line 8929 "gram.y"
    {
					(yyval.list) = list_make1((yyvsp[(1) - (1)].defelt));
				}
    break;

  case 1308:
/* Line 1787 of yacc.c  */
#line 8933 "gram.y"
    {
					(yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].defelt));
				}
    break;

  case 1309:
/* Line 1787 of yacc.c  */
#line 8940 "gram.y"
    {
					(yyval.defelt) = makeDefElem((yyvsp[(1) - (2)].str), (yyvsp[(2) - (2)].node));
				}
    break;

  case 1310:
/* Line 1787 of yacc.c  */
#line 8946 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); }
    break;

  case 1311:
/* Line 1787 of yacc.c  */
#line 8947 "gram.y"
    { (yyval.str) = "analyze"; }
    break;

  case 1312:
/* Line 1787 of yacc.c  */
#line 8951 "gram.y"
    { (yyval.node) = (Node *) makeString((yyvsp[(1) - (1)].str)); }
    break;

  case 1313:
/* Line 1787 of yacc.c  */
#line 8952 "gram.y"
    { (yyval.node) = (Node *) (yyvsp[(1) - (1)].value); }
    break;

  case 1314:
/* Line 1787 of yacc.c  */
#line 8953 "gram.y"
    { (yyval.node) = NULL; }
    break;

  case 1315:
/* Line 1787 of yacc.c  */
#line 8964 "gram.y"
    {
					PrepareStmt *n = makeNode(PrepareStmt);
					n->name = (yyvsp[(2) - (5)].str);
					n->argtypes = (yyvsp[(3) - (5)].list);
					n->query = (yyvsp[(5) - (5)].node);
					(yyval.node) = (Node *) n;
				}
    break;

  case 1316:
/* Line 1787 of yacc.c  */
#line 8973 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (3)].list); }
    break;

  case 1317:
/* Line 1787 of yacc.c  */
#line 8974 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 1322:
/* Line 1787 of yacc.c  */
#line 8992 "gram.y"
    {
					ExecuteStmt *n = makeNode(ExecuteStmt);
					n->name = (yyvsp[(2) - (3)].str);
					n->params = (yyvsp[(3) - (3)].list);
					(yyval.node) = (Node *) n;
				}
    break;

  case 1323:
/* Line 1787 of yacc.c  */
#line 9000 "gram.y"
    {
					CreateTableAsStmt *ctas = makeNode(CreateTableAsStmt);
					ExecuteStmt *n = makeNode(ExecuteStmt);
					n->name = (yyvsp[(7) - (9)].str);
					n->params = (yyvsp[(8) - (9)].list);
					ctas->query = (Node *) n;
					ctas->into = (yyvsp[(4) - (9)].into);
					ctas->relkind = OBJECT_TABLE;
					ctas->is_select_into = false;
					/* cram additional flags into the IntoClause */
					(yyvsp[(4) - (9)].into)->rel->relpersistence = (yyvsp[(2) - (9)].ival);
					(yyvsp[(4) - (9)].into)->skipData = !((yyvsp[(9) - (9)].boolean));
					(yyval.node) = (Node *) ctas;
				}
    break;

  case 1324:
/* Line 1787 of yacc.c  */
#line 9016 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (3)].list); }
    break;

  case 1325:
/* Line 1787 of yacc.c  */
#line 9017 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 1326:
/* Line 1787 of yacc.c  */
#line 9028 "gram.y"
    {
						DeallocateStmt *n = makeNode(DeallocateStmt);
						n->name = (yyvsp[(2) - (2)].str);
						(yyval.node) = (Node *) n;
					}
    break;

  case 1327:
/* Line 1787 of yacc.c  */
#line 9034 "gram.y"
    {
						DeallocateStmt *n = makeNode(DeallocateStmt);
						n->name = (yyvsp[(3) - (3)].str);
						(yyval.node) = (Node *) n;
					}
    break;

  case 1328:
/* Line 1787 of yacc.c  */
#line 9040 "gram.y"
    {
						DeallocateStmt *n = makeNode(DeallocateStmt);
						n->name = NULL;
						(yyval.node) = (Node *) n;
					}
    break;

  case 1329:
/* Line 1787 of yacc.c  */
#line 9046 "gram.y"
    {
						DeallocateStmt *n = makeNode(DeallocateStmt);
						n->name = NULL;
						(yyval.node) = (Node *) n;
					}
    break;

  case 1330:
/* Line 1787 of yacc.c  */
#line 9062 "gram.y"
    {
					(yyvsp[(5) - (6)].istmt)->relation = (yyvsp[(4) - (6)].range);
					(yyvsp[(5) - (6)].istmt)->returningList = (yyvsp[(6) - (6)].list);
					(yyvsp[(5) - (6)].istmt)->withClause = (yyvsp[(1) - (6)].with);
					(yyval.node) = (Node *) (yyvsp[(5) - (6)].istmt);
				}
    break;

  case 1331:
/* Line 1787 of yacc.c  */
#line 9072 "gram.y"
    {
					(yyval.istmt) = makeNode(InsertStmt);
					(yyval.istmt)->cols = NIL;
					(yyval.istmt)->selectStmt = (yyvsp[(1) - (1)].node);
				}
    break;

  case 1332:
/* Line 1787 of yacc.c  */
#line 9078 "gram.y"
    {
					(yyval.istmt) = makeNode(InsertStmt);
					(yyval.istmt)->cols = (yyvsp[(2) - (4)].list);
					(yyval.istmt)->selectStmt = (yyvsp[(4) - (4)].node);
				}
    break;

  case 1333:
/* Line 1787 of yacc.c  */
#line 9084 "gram.y"
    {
					(yyval.istmt) = makeNode(InsertStmt);
					(yyval.istmt)->cols = NIL;
					(yyval.istmt)->selectStmt = NULL;
				}
    break;

  case 1334:
/* Line 1787 of yacc.c  */
#line 9093 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].target)); }
    break;

  case 1335:
/* Line 1787 of yacc.c  */
#line 9095 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].target)); }
    break;

  case 1336:
/* Line 1787 of yacc.c  */
#line 9100 "gram.y"
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = (yyvsp[(1) - (2)].str);
					(yyval.target)->indirection = check_indirection((yyvsp[(2) - (2)].list), yyscanner);
					(yyval.target)->val = NULL;
					(yyval.target)->location = (yylsp[(1) - (2)]);
				}
    break;

  case 1337:
/* Line 1787 of yacc.c  */
#line 9110 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (2)].list); }
    break;

  case 1338:
/* Line 1787 of yacc.c  */
#line 9111 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 1339:
/* Line 1787 of yacc.c  */
#line 9124 "gram.y"
    {
					DeleteStmt *n = makeNode(DeleteStmt);
					n->relation = (yyvsp[(4) - (7)].range);
					n->usingClause = (yyvsp[(5) - (7)].list);
					n->whereClause = (yyvsp[(6) - (7)].node);
					n->returningList = (yyvsp[(7) - (7)].list);
					n->withClause = (yyvsp[(1) - (7)].with);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1340:
/* Line 1787 of yacc.c  */
#line 9136 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (2)].list); }
    break;

  case 1341:
/* Line 1787 of yacc.c  */
#line 9137 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 1342:
/* Line 1787 of yacc.c  */
#line 9149 "gram.y"
    {
					LockStmt *n = makeNode(LockStmt);

					n->relations = (yyvsp[(3) - (5)].list);
					n->mode = (yyvsp[(4) - (5)].ival);
					n->nowait = (yyvsp[(5) - (5)].boolean);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1343:
/* Line 1787 of yacc.c  */
#line 9159 "gram.y"
    { (yyval.ival) = (yyvsp[(2) - (3)].ival); }
    break;

  case 1344:
/* Line 1787 of yacc.c  */
#line 9160 "gram.y"
    { (yyval.ival) = AccessExclusiveLock; }
    break;

  case 1345:
/* Line 1787 of yacc.c  */
#line 9163 "gram.y"
    { (yyval.ival) = AccessShareLock; }
    break;

  case 1346:
/* Line 1787 of yacc.c  */
#line 9164 "gram.y"
    { (yyval.ival) = RowShareLock; }
    break;

  case 1347:
/* Line 1787 of yacc.c  */
#line 9165 "gram.y"
    { (yyval.ival) = RowExclusiveLock; }
    break;

  case 1348:
/* Line 1787 of yacc.c  */
#line 9166 "gram.y"
    { (yyval.ival) = ApplicationShareLock; }
    break;

  case 1349:
/* Line 1787 of yacc.c  */
#line 9167 "gram.y"
    { (yyval.ival) = ApplicationExclusiveLock; }
    break;

  case 1350:
/* Line 1787 of yacc.c  */
#line 9168 "gram.y"
    { (yyval.ival) = ShareUpdateExclusiveLock; }
    break;

  case 1351:
/* Line 1787 of yacc.c  */
#line 9169 "gram.y"
    { (yyval.ival) = ShareLock; }
    break;

  case 1352:
/* Line 1787 of yacc.c  */
#line 9170 "gram.y"
    { (yyval.ival) = ShareRowExclusiveLock; }
    break;

  case 1353:
/* Line 1787 of yacc.c  */
#line 9171 "gram.y"
    { (yyval.ival) = ExclusiveLock; }
    break;

  case 1354:
/* Line 1787 of yacc.c  */
#line 9172 "gram.y"
    { (yyval.ival) = AccessExclusiveLock; }
    break;

  case 1355:
/* Line 1787 of yacc.c  */
#line 9175 "gram.y"
    { (yyval.boolean) = TRUE; }
    break;

  case 1356:
/* Line 1787 of yacc.c  */
#line 9176 "gram.y"
    { (yyval.boolean) = FALSE; }
    break;

  case 1357:
/* Line 1787 of yacc.c  */
#line 9192 "gram.y"
    {
					UpdateStmt *n = makeNode(UpdateStmt);
					n->relation = (yyvsp[(3) - (8)].range);
					n->targetList = (yyvsp[(5) - (8)].list);
					n->fromClause = (yyvsp[(6) - (8)].list);
					n->whereClause = (yyvsp[(7) - (8)].node);
					n->returningList = (yyvsp[(8) - (8)].list);
					n->withClause = (yyvsp[(1) - (8)].with);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1358:
/* Line 1787 of yacc.c  */
#line 9205 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list); }
    break;

  case 1359:
/* Line 1787 of yacc.c  */
#line 9206 "gram.y"
    { (yyval.list) = list_concat((yyvsp[(1) - (3)].list),(yyvsp[(3) - (3)].list)); }
    break;

  case 1360:
/* Line 1787 of yacc.c  */
#line 9210 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].target)); }
    break;

  case 1361:
/* Line 1787 of yacc.c  */
#line 9211 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list); }
    break;

  case 1362:
/* Line 1787 of yacc.c  */
#line 9216 "gram.y"
    {
					(yyval.target) = (yyvsp[(1) - (3)].target);
					(yyval.target)->val = (Node *) (yyvsp[(3) - (3)].node);
				}
    break;

  case 1363:
/* Line 1787 of yacc.c  */
#line 9224 "gram.y"
    {
					ListCell *col_cell;
					ListCell *val_cell;

					/*
					 * Break the ctext_row apart, merge individual expressions
					 * into the destination ResTargets.  XXX this approach
					 * cannot work for general row expressions as sources.
					 */
					if (list_length((yyvsp[(2) - (5)].list)) != list_length((yyvsp[(5) - (5)].list)))
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("number of columns does not match number of values"),
								 parser_errposition((yylsp[(1) - (5)]))));
					forboth(col_cell, (yyvsp[(2) - (5)].list), val_cell, (yyvsp[(5) - (5)].list))
					{
						ResTarget *res_col = (ResTarget *) lfirst(col_cell);
						Node *res_val = (Node *) lfirst(val_cell);

						res_col->val = res_val;
					}

					(yyval.list) = (yyvsp[(2) - (5)].list);
				}
    break;

  case 1364:
/* Line 1787 of yacc.c  */
#line 9252 "gram.y"
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = (yyvsp[(1) - (2)].str);
					(yyval.target)->indirection = check_indirection((yyvsp[(2) - (2)].list), yyscanner);
					(yyval.target)->val = NULL;	/* upper production sets this */
					(yyval.target)->location = (yylsp[(1) - (2)]);
				}
    break;

  case 1365:
/* Line 1787 of yacc.c  */
#line 9262 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].target)); }
    break;

  case 1366:
/* Line 1787 of yacc.c  */
#line 9263 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list),(yyvsp[(3) - (3)].target)); }
    break;

  case 1367:
/* Line 1787 of yacc.c  */
#line 9274 "gram.y"
    {
					DeclareCursorStmt *n = makeNode(DeclareCursorStmt);
					n->portalname = (yyvsp[(2) - (7)].str);
					/* currently we always set FAST_PLAN option */
					n->options = (yyvsp[(3) - (7)].ival) | (yyvsp[(5) - (7)].ival) | CURSOR_OPT_FAST_PLAN;
					n->query = (yyvsp[(7) - (7)].node);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1368:
/* Line 1787 of yacc.c  */
#line 9284 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); }
    break;

  case 1369:
/* Line 1787 of yacc.c  */
#line 9287 "gram.y"
    { (yyval.ival) = 0; }
    break;

  case 1370:
/* Line 1787 of yacc.c  */
#line 9288 "gram.y"
    { (yyval.ival) = (yyvsp[(1) - (3)].ival) | CURSOR_OPT_NO_SCROLL; }
    break;

  case 1371:
/* Line 1787 of yacc.c  */
#line 9289 "gram.y"
    { (yyval.ival) = (yyvsp[(1) - (2)].ival) | CURSOR_OPT_SCROLL; }
    break;

  case 1372:
/* Line 1787 of yacc.c  */
#line 9290 "gram.y"
    { (yyval.ival) = (yyvsp[(1) - (2)].ival) | CURSOR_OPT_BINARY; }
    break;

  case 1373:
/* Line 1787 of yacc.c  */
#line 9291 "gram.y"
    { (yyval.ival) = (yyvsp[(1) - (2)].ival) | CURSOR_OPT_INSENSITIVE; }
    break;

  case 1374:
/* Line 1787 of yacc.c  */
#line 9294 "gram.y"
    { (yyval.ival) = 0; }
    break;

  case 1375:
/* Line 1787 of yacc.c  */
#line 9295 "gram.y"
    { (yyval.ival) = CURSOR_OPT_HOLD; }
    break;

  case 1376:
/* Line 1787 of yacc.c  */
#line 9296 "gram.y"
    { (yyval.ival) = 0; }
    break;

  case 1379:
/* Line 1787 of yacc.c  */
#line 9349 "gram.y"
    { (yyval.node) = (yyvsp[(2) - (3)].node); }
    break;

  case 1380:
/* Line 1787 of yacc.c  */
#line 9350 "gram.y"
    { (yyval.node) = (yyvsp[(2) - (3)].node); }
    break;

  case 1381:
/* Line 1787 of yacc.c  */
#line 9365 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); }
    break;

  case 1382:
/* Line 1787 of yacc.c  */
#line 9367 "gram.y"
    {
					insertSelectOptions((SelectStmt *) (yyvsp[(1) - (2)].node), (yyvsp[(2) - (2)].list), NIL,
										NULL, NULL, NULL,
										yyscanner);
					(yyval.node) = (yyvsp[(1) - (2)].node);
				}
    break;

  case 1383:
/* Line 1787 of yacc.c  */
#line 9374 "gram.y"
    {
					insertSelectOptions((SelectStmt *) (yyvsp[(1) - (4)].node), (yyvsp[(2) - (4)].list), (yyvsp[(3) - (4)].list),
										list_nth((yyvsp[(4) - (4)].list), 0), list_nth((yyvsp[(4) - (4)].list), 1),
										NULL,
										yyscanner);
					(yyval.node) = (yyvsp[(1) - (4)].node);
				}
    break;

  case 1384:
/* Line 1787 of yacc.c  */
#line 9382 "gram.y"
    {
					insertSelectOptions((SelectStmt *) (yyvsp[(1) - (4)].node), (yyvsp[(2) - (4)].list), (yyvsp[(4) - (4)].list),
										list_nth((yyvsp[(3) - (4)].list), 0), list_nth((yyvsp[(3) - (4)].list), 1),
										NULL,
										yyscanner);
					(yyval.node) = (yyvsp[(1) - (4)].node);
				}
    break;

  case 1385:
/* Line 1787 of yacc.c  */
#line 9390 "gram.y"
    {
					insertSelectOptions((SelectStmt *) (yyvsp[(2) - (2)].node), NULL, NIL,
										NULL, NULL,
										(yyvsp[(1) - (2)].with),
										yyscanner);
					(yyval.node) = (yyvsp[(2) - (2)].node);
				}
    break;

  case 1386:
/* Line 1787 of yacc.c  */
#line 9398 "gram.y"
    {
					insertSelectOptions((SelectStmt *) (yyvsp[(2) - (3)].node), (yyvsp[(3) - (3)].list), NIL,
										NULL, NULL,
										(yyvsp[(1) - (3)].with),
										yyscanner);
					(yyval.node) = (yyvsp[(2) - (3)].node);
				}
    break;

  case 1387:
/* Line 1787 of yacc.c  */
#line 9406 "gram.y"
    {
					insertSelectOptions((SelectStmt *) (yyvsp[(2) - (5)].node), (yyvsp[(3) - (5)].list), (yyvsp[(4) - (5)].list),
										list_nth((yyvsp[(5) - (5)].list), 0), list_nth((yyvsp[(5) - (5)].list), 1),
										(yyvsp[(1) - (5)].with),
										yyscanner);
					(yyval.node) = (yyvsp[(2) - (5)].node);
				}
    break;

  case 1388:
/* Line 1787 of yacc.c  */
#line 9414 "gram.y"
    {
					insertSelectOptions((SelectStmt *) (yyvsp[(2) - (5)].node), (yyvsp[(3) - (5)].list), (yyvsp[(5) - (5)].list),
										list_nth((yyvsp[(4) - (5)].list), 0), list_nth((yyvsp[(4) - (5)].list), 1),
										(yyvsp[(1) - (5)].with),
										yyscanner);
					(yyval.node) = (yyvsp[(2) - (5)].node);
				}
    break;

  case 1389:
/* Line 1787 of yacc.c  */
#line 9424 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); }
    break;

  case 1390:
/* Line 1787 of yacc.c  */
#line 9425 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); }
    break;

  case 1391:
/* Line 1787 of yacc.c  */
#line 9455 "gram.y"
    {
					SelectStmt *n = makeNode(SelectStmt);
					n->distinctClause = (yyvsp[(2) - (9)].list);
					n->targetList = (yyvsp[(3) - (9)].list);
					n->intoClause = (yyvsp[(4) - (9)].into);
					n->fromClause = (yyvsp[(5) - (9)].list);
					n->whereClause = (yyvsp[(6) - (9)].node);
					n->groupClause = (yyvsp[(7) - (9)].list);
					n->havingClause = (yyvsp[(8) - (9)].node);
					n->windowClause = (yyvsp[(9) - (9)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1392:
/* Line 1787 of yacc.c  */
#line 9467 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); }
    break;

  case 1393:
/* Line 1787 of yacc.c  */
#line 9469 "gram.y"
    {
					/* same as SELECT * FROM relation_expr */
					ColumnRef *cr = makeNode(ColumnRef);
					ResTarget *rt = makeNode(ResTarget);
					SelectStmt *n = makeNode(SelectStmt);

					cr->fields = list_make1(makeNode(A_Star));
					cr->location = -1;

					rt->name = NULL;
					rt->indirection = NIL;
					rt->val = (Node *)cr;
					rt->location = -1;

					n->targetList = list_make1(rt);
					n->fromClause = list_make1((yyvsp[(2) - (2)].range));
					(yyval.node) = (Node *)n;
				}
    break;

  case 1394:
/* Line 1787 of yacc.c  */
#line 9488 "gram.y"
    {
					(yyval.node) = makeSetOp(SETOP_UNION, (yyvsp[(3) - (4)].boolean), (yyvsp[(1) - (4)].node), (yyvsp[(4) - (4)].node));
				}
    break;

  case 1395:
/* Line 1787 of yacc.c  */
#line 9492 "gram.y"
    {
					(yyval.node) = makeSetOp(SETOP_INTERSECT, (yyvsp[(3) - (4)].boolean), (yyvsp[(1) - (4)].node), (yyvsp[(4) - (4)].node));
				}
    break;

  case 1396:
/* Line 1787 of yacc.c  */
#line 9496 "gram.y"
    {
					(yyval.node) = makeSetOp(SETOP_EXCEPT, (yyvsp[(3) - (4)].boolean), (yyvsp[(1) - (4)].node), (yyvsp[(4) - (4)].node));
				}
    break;

  case 1397:
/* Line 1787 of yacc.c  */
#line 9511 "gram.y"
    {
				(yyval.with) = makeNode(WithClause);
				(yyval.with)->ctes = (yyvsp[(2) - (2)].list);
				(yyval.with)->recursive = false;
				(yyval.with)->location = (yylsp[(1) - (2)]);
			}
    break;

  case 1398:
/* Line 1787 of yacc.c  */
#line 9518 "gram.y"
    {
				(yyval.with) = makeNode(WithClause);
				(yyval.with)->ctes = (yyvsp[(3) - (3)].list);
				(yyval.with)->recursive = true;
				(yyval.with)->location = (yylsp[(1) - (3)]);
			}
    break;

  case 1399:
/* Line 1787 of yacc.c  */
#line 9527 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].node)); }
    break;

  case 1400:
/* Line 1787 of yacc.c  */
#line 9528 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node)); }
    break;

  case 1401:
/* Line 1787 of yacc.c  */
#line 9532 "gram.y"
    {
				CommonTableExpr *n = makeNode(CommonTableExpr);
				n->ctename = (yyvsp[(1) - (6)].str);
				n->aliascolnames = (yyvsp[(2) - (6)].list);
				n->ctequery = (yyvsp[(5) - (6)].node);
				n->location = (yylsp[(1) - (6)]);
				(yyval.node) = (Node *) n;
			}
    break;

  case 1402:
/* Line 1787 of yacc.c  */
#line 9543 "gram.y"
    { (yyval.with) = (yyvsp[(1) - (1)].with); }
    break;

  case 1403:
/* Line 1787 of yacc.c  */
#line 9544 "gram.y"
    { (yyval.with) = NULL; }
    break;

  case 1404:
/* Line 1787 of yacc.c  */
#line 9549 "gram.y"
    {
					(yyval.into) = makeNode(IntoClause);
					(yyval.into)->rel = (yyvsp[(2) - (2)].range);
					(yyval.into)->colNames = NIL;
					(yyval.into)->options = NIL;
					(yyval.into)->onCommit = ONCOMMIT_NOOP;
					(yyval.into)->tableSpaceName = NULL;
					(yyval.into)->viewQuery = NULL;
					(yyval.into)->skipData = false;
				}
    break;

  case 1405:
/* Line 1787 of yacc.c  */
#line 9560 "gram.y"
    { (yyval.into) = NULL; }
    break;

  case 1406:
/* Line 1787 of yacc.c  */
#line 9569 "gram.y"
    {
					(yyval.range) = (yyvsp[(3) - (3)].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_TEMP;
				}
    break;

  case 1407:
/* Line 1787 of yacc.c  */
#line 9574 "gram.y"
    {
					(yyval.range) = (yyvsp[(3) - (3)].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_TEMP;
				}
    break;

  case 1408:
/* Line 1787 of yacc.c  */
#line 9579 "gram.y"
    {
					(yyval.range) = (yyvsp[(4) - (4)].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_TEMP;
				}
    break;

  case 1409:
/* Line 1787 of yacc.c  */
#line 9584 "gram.y"
    {
					(yyval.range) = (yyvsp[(4) - (4)].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_TEMP;
				}
    break;

  case 1410:
/* Line 1787 of yacc.c  */
#line 9589 "gram.y"
    {
					ereport(WARNING,
							(errmsg("GLOBAL is deprecated in temporary table creation"),
							 parser_errposition((yylsp[(1) - (4)]))));
					(yyval.range) = (yyvsp[(4) - (4)].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_TEMP;
				}
    break;

  case 1411:
/* Line 1787 of yacc.c  */
#line 9597 "gram.y"
    {
					ereport(WARNING,
							(errmsg("GLOBAL is deprecated in temporary table creation"),
							 parser_errposition((yylsp[(1) - (4)]))));
					(yyval.range) = (yyvsp[(4) - (4)].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_TEMP;
				}
    break;

  case 1412:
/* Line 1787 of yacc.c  */
#line 9605 "gram.y"
    {
					(yyval.range) = (yyvsp[(3) - (3)].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_UNLOGGED;
				}
    break;

  case 1413:
/* Line 1787 of yacc.c  */
#line 9610 "gram.y"
    {
					(yyval.range) = (yyvsp[(2) - (2)].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_PERMANENT;
				}
    break;

  case 1414:
/* Line 1787 of yacc.c  */
#line 9615 "gram.y"
    {
					(yyval.range) = (yyvsp[(1) - (1)].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_PERMANENT;
				}
    break;

  case 1415:
/* Line 1787 of yacc.c  */
#line 9621 "gram.y"
    {}
    break;

  case 1416:
/* Line 1787 of yacc.c  */
#line 9622 "gram.y"
    {}
    break;

  case 1417:
/* Line 1787 of yacc.c  */
#line 9625 "gram.y"
    { (yyval.boolean) = TRUE; }
    break;

  case 1418:
/* Line 1787 of yacc.c  */
#line 9626 "gram.y"
    { (yyval.boolean) = FALSE; }
    break;

  case 1419:
/* Line 1787 of yacc.c  */
#line 9627 "gram.y"
    { (yyval.boolean) = FALSE; }
    break;

  case 1420:
/* Line 1787 of yacc.c  */
#line 9634 "gram.y"
    { (yyval.list) = list_make1(NIL); }
    break;

  case 1421:
/* Line 1787 of yacc.c  */
#line 9635 "gram.y"
    { (yyval.list) = (yyvsp[(4) - (5)].list); }
    break;

  case 1422:
/* Line 1787 of yacc.c  */
#line 9636 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 1423:
/* Line 1787 of yacc.c  */
#line 9637 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 1424:
/* Line 1787 of yacc.c  */
#line 9641 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list);}
    break;

  case 1425:
/* Line 1787 of yacc.c  */
#line 9642 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 1426:
/* Line 1787 of yacc.c  */
#line 9646 "gram.y"
    { (yyval.list) = (yyvsp[(3) - (3)].list); }
    break;

  case 1427:
/* Line 1787 of yacc.c  */
#line 9650 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].sortby)); }
    break;

  case 1428:
/* Line 1787 of yacc.c  */
#line 9651 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].sortby)); }
    break;

  case 1429:
/* Line 1787 of yacc.c  */
#line 9655 "gram.y"
    {
					(yyval.sortby) = makeNode(SortBy);
					(yyval.sortby)->node = (yyvsp[(1) - (4)].node);
					(yyval.sortby)->sortby_dir = SORTBY_USING;
					(yyval.sortby)->sortby_nulls = (yyvsp[(4) - (4)].ival);
					(yyval.sortby)->useOp = (yyvsp[(3) - (4)].list);
					(yyval.sortby)->location = (yylsp[(3) - (4)]);
				}
    break;

  case 1430:
/* Line 1787 of yacc.c  */
#line 9664 "gram.y"
    {
					(yyval.sortby) = makeNode(SortBy);
					(yyval.sortby)->node = (yyvsp[(1) - (3)].node);
					(yyval.sortby)->sortby_dir = (yyvsp[(2) - (3)].ival);
					(yyval.sortby)->sortby_nulls = (yyvsp[(3) - (3)].ival);
					(yyval.sortby)->useOp = NIL;
					(yyval.sortby)->location = -1;		/* no operator */
				}
    break;

  case 1431:
/* Line 1787 of yacc.c  */
#line 9676 "gram.y"
    { (yyval.list) = list_make2((yyvsp[(2) - (2)].node), (yyvsp[(1) - (2)].node)); }
    break;

  case 1432:
/* Line 1787 of yacc.c  */
#line 9677 "gram.y"
    { (yyval.list) = list_make2((yyvsp[(1) - (2)].node), (yyvsp[(2) - (2)].node)); }
    break;

  case 1433:
/* Line 1787 of yacc.c  */
#line 9678 "gram.y"
    { (yyval.list) = list_make2(NULL, (yyvsp[(1) - (1)].node)); }
    break;

  case 1434:
/* Line 1787 of yacc.c  */
#line 9679 "gram.y"
    { (yyval.list) = list_make2((yyvsp[(1) - (1)].node), NULL); }
    break;

  case 1435:
/* Line 1787 of yacc.c  */
#line 9683 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list); }
    break;

  case 1436:
/* Line 1787 of yacc.c  */
#line 9684 "gram.y"
    { (yyval.list) = list_make2(NULL,NULL); }
    break;

  case 1437:
/* Line 1787 of yacc.c  */
#line 9689 "gram.y"
    { (yyval.node) = (yyvsp[(2) - (2)].node); }
    break;

  case 1438:
/* Line 1787 of yacc.c  */
#line 9691 "gram.y"
    {
					/* Disabled because it was too confusing, bjm 2002-02-18 */
					ereport(ERROR,
							(errcode(ERRCODE_SYNTAX_ERROR),
							 errmsg("LIMIT #,# syntax is not supported"),
							 errhint("Use separate LIMIT and OFFSET clauses."),
							 parser_errposition((yylsp[(1) - (4)]))));
				}
    break;

  case 1439:
/* Line 1787 of yacc.c  */
#line 9701 "gram.y"
    { (yyval.node) = (yyvsp[(3) - (5)].node); }
    break;

  case 1440:
/* Line 1787 of yacc.c  */
#line 9706 "gram.y"
    { (yyval.node) = (yyvsp[(2) - (2)].node); }
    break;

  case 1441:
/* Line 1787 of yacc.c  */
#line 9709 "gram.y"
    { (yyval.node) = (yyvsp[(2) - (3)].node); }
    break;

  case 1442:
/* Line 1787 of yacc.c  */
#line 9713 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); }
    break;

  case 1443:
/* Line 1787 of yacc.c  */
#line 9715 "gram.y"
    {
					/* LIMIT ALL is represented as a NULL constant */
					(yyval.node) = makeNullAConst((yylsp[(1) - (1)]));
				}
    break;

  case 1444:
/* Line 1787 of yacc.c  */
#line 9722 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); }
    break;

  case 1445:
/* Line 1787 of yacc.c  */
#line 9732 "gram.y"
    { (yyval.node) = makeIntConst((yyvsp[(1) - (1)].ival), (yylsp[(1) - (1)])); }
    break;

  case 1446:
/* Line 1787 of yacc.c  */
#line 9733 "gram.y"
    { (yyval.node) = (yyvsp[(2) - (3)].node); }
    break;

  case 1447:
/* Line 1787 of yacc.c  */
#line 9734 "gram.y"
    { (yyval.node) = makeIntConst(1, -1); }
    break;

  case 1448:
/* Line 1787 of yacc.c  */
#line 9742 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); }
    break;

  case 1449:
/* Line 1787 of yacc.c  */
#line 9746 "gram.y"
    { (yyval.ival) = 0; }
    break;

  case 1450:
/* Line 1787 of yacc.c  */
#line 9747 "gram.y"
    { (yyval.ival) = 0; }
    break;

  case 1451:
/* Line 1787 of yacc.c  */
#line 9750 "gram.y"
    { (yyval.ival) = 0; }
    break;

  case 1452:
/* Line 1787 of yacc.c  */
#line 9751 "gram.y"
    { (yyval.ival) = 0; }
    break;

  case 1453:
/* Line 1787 of yacc.c  */
#line 9756 "gram.y"
    { (yyval.list) = (yyvsp[(3) - (3)].list); }
    break;

  case 1454:
/* Line 1787 of yacc.c  */
#line 9757 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 1455:
/* Line 1787 of yacc.c  */
#line 9761 "gram.y"
    { (yyval.node) = (yyvsp[(2) - (2)].node); }
    break;

  case 1456:
/* Line 1787 of yacc.c  */
#line 9762 "gram.y"
    { (yyval.node) = NULL; }
    break;

  case 1457:
/* Line 1787 of yacc.c  */
#line 9766 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list); }
    break;

  case 1458:
/* Line 1787 of yacc.c  */
#line 9767 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 1459:
/* Line 1787 of yacc.c  */
#line 9771 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list); }
    break;

  case 1460:
/* Line 1787 of yacc.c  */
#line 9772 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 1461:
/* Line 1787 of yacc.c  */
#line 9776 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].node)); }
    break;

  case 1462:
/* Line 1787 of yacc.c  */
#line 9777 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].node)); }
    break;

  case 1463:
/* Line 1787 of yacc.c  */
#line 9782 "gram.y"
    {
					LockingClause *n = makeNode(LockingClause);
					n->lockedRels = (yyvsp[(2) - (3)].list);
					n->strength = (yyvsp[(1) - (3)].ival);
					n->noWait = (yyvsp[(3) - (3)].boolean);
					(yyval.node) = (Node *) n;
				}
    break;

  case 1464:
/* Line 1787 of yacc.c  */
#line 9792 "gram.y"
    { (yyval.ival) = LCS_FORUPDATE; }
    break;

  case 1465:
/* Line 1787 of yacc.c  */
#line 9793 "gram.y"
    { (yyval.ival) = LCS_FORNOKEYUPDATE; }
    break;

  case 1466:
/* Line 1787 of yacc.c  */
#line 9794 "gram.y"
    { (yyval.ival) = LCS_FORSHARE; }
    break;

  case 1467:
/* Line 1787 of yacc.c  */
#line 9795 "gram.y"
    { (yyval.ival) = LCS_FORKEYSHARE; }
    break;

  case 1468:
/* Line 1787 of yacc.c  */
#line 9799 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (2)].list); }
    break;

  case 1469:
/* Line 1787 of yacc.c  */
#line 9800 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 1470:
/* Line 1787 of yacc.c  */
#line 9806 "gram.y"
    {
					SelectStmt *n = makeNode(SelectStmt);
					n->valuesLists = list_make1((yyvsp[(2) - (2)].list));
					(yyval.node) = (Node *) n;
				}
    break;

  case 1471:
/* Line 1787 of yacc.c  */
#line 9812 "gram.y"
    {
					SelectStmt *n = (SelectStmt *) (yyvsp[(1) - (3)].node);
					n->valuesLists = lappend(n->valuesLists, (yyvsp[(3) - (3)].list));
					(yyval.node) = (Node *) n;
				}
    break;

  case 1472:
/* Line 1787 of yacc.c  */
#line 9829 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (2)].list); }
    break;

  case 1473:
/* Line 1787 of yacc.c  */
#line 9830 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 1474:
/* Line 1787 of yacc.c  */
#line 9834 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].node)); }
    break;

  case 1475:
/* Line 1787 of yacc.c  */
#line 9835 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node)); }
    break;

  case 1476:
/* Line 1787 of yacc.c  */
#line 9842 "gram.y"
    {
					(yyvsp[(1) - (2)].range)->alias = (yyvsp[(2) - (2)].alias);
					(yyval.node) = (Node *) (yyvsp[(1) - (2)].range);
				}
    break;

  case 1477:
/* Line 1787 of yacc.c  */
#line 9847 "gram.y"
    {
					RangeFunction *n = (RangeFunction *) (yyvsp[(1) - (2)].node);
					n->alias = linitial((yyvsp[(2) - (2)].list));
					n->coldeflist = lsecond((yyvsp[(2) - (2)].list));
					(yyval.node) = (Node *) n;
				}
    break;

  case 1478:
/* Line 1787 of yacc.c  */
#line 9854 "gram.y"
    {
					RangeFunction *n = (RangeFunction *) (yyvsp[(2) - (3)].node);
					n->lateral = true;
					n->alias = linitial((yyvsp[(3) - (3)].list));
					n->coldeflist = lsecond((yyvsp[(3) - (3)].list));
					(yyval.node) = (Node *) n;
				}
    break;

  case 1479:
/* Line 1787 of yacc.c  */
#line 9862 "gram.y"
    {
					RangeSubselect *n = makeNode(RangeSubselect);
					n->lateral = false;
					n->subquery = (yyvsp[(1) - (2)].node);
					n->alias = (yyvsp[(2) - (2)].alias);
					/*
					 * The SQL spec does not permit a subselect
					 * (<derived_table>) without an alias clause,
					 * so we don't either.  This avoids the problem
					 * of needing to invent a unique refname for it.
					 * That could be surmounted if there's sufficient
					 * popular demand, but for now let's just implement
					 * the spec and see if anyone complains.
					 * However, it does seem like a good idea to emit
					 * an error message that's better than "syntax error".
					 */
					if ((yyvsp[(2) - (2)].alias) == NULL)
					{
						if (IsA((yyvsp[(1) - (2)].node), SelectStmt) &&
							((SelectStmt *) (yyvsp[(1) - (2)].node))->valuesLists)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("VALUES in FROM must have an alias"),
									 errhint("For example, FROM (VALUES ...) [AS] foo."),
									 parser_errposition((yylsp[(1) - (2)]))));
						else
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("subquery in FROM must have an alias"),
									 errhint("For example, FROM (SELECT ...) [AS] foo."),
									 parser_errposition((yylsp[(1) - (2)]))));
					}
					(yyval.node) = (Node *) n;
				}
    break;

  case 1480:
/* Line 1787 of yacc.c  */
#line 9897 "gram.y"
    {
					RangeSubselect *n = makeNode(RangeSubselect);
					n->lateral = true;
					n->subquery = (yyvsp[(2) - (3)].node);
					n->alias = (yyvsp[(3) - (3)].alias);
					/* same comment as above */
					if ((yyvsp[(3) - (3)].alias) == NULL)
					{
						if (IsA((yyvsp[(2) - (3)].node), SelectStmt) &&
							((SelectStmt *) (yyvsp[(2) - (3)].node))->valuesLists)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("VALUES in FROM must have an alias"),
									 errhint("For example, FROM (VALUES ...) [AS] foo."),
									 parser_errposition((yylsp[(2) - (3)]))));
						else
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("subquery in FROM must have an alias"),
									 errhint("For example, FROM (SELECT ...) [AS] foo."),
									 parser_errposition((yylsp[(2) - (3)]))));
					}
					(yyval.node) = (Node *) n;
				}
    break;

  case 1481:
/* Line 1787 of yacc.c  */
#line 9922 "gram.y"
    {
					(yyval.node) = (Node *) (yyvsp[(1) - (1)].jexpr);
				}
    break;

  case 1482:
/* Line 1787 of yacc.c  */
#line 9926 "gram.y"
    {
					(yyvsp[(2) - (4)].jexpr)->alias = (yyvsp[(4) - (4)].alias);
					(yyval.node) = (Node *) (yyvsp[(2) - (4)].jexpr);
				}
    break;

  case 1483:
/* Line 1787 of yacc.c  */
#line 9952 "gram.y"
    {
					(yyval.jexpr) = (yyvsp[(2) - (3)].jexpr);
				}
    break;

  case 1484:
/* Line 1787 of yacc.c  */
#line 9956 "gram.y"
    {
					/* CROSS JOIN is same as unqualified inner join */
					JoinExpr *n = makeNode(JoinExpr);
					n->jointype = JOIN_INNER;
					n->isNatural = FALSE;
					n->larg = (yyvsp[(1) - (4)].node);
					n->rarg = (yyvsp[(4) - (4)].node);
					n->usingClause = NIL;
					n->quals = NULL;
					(yyval.jexpr) = n;
				}
    break;

  case 1485:
/* Line 1787 of yacc.c  */
#line 9968 "gram.y"
    {
					JoinExpr *n = makeNode(JoinExpr);
					n->jointype = (yyvsp[(2) - (5)].jtype);
					n->isNatural = FALSE;
					n->larg = (yyvsp[(1) - (5)].node);
					n->rarg = (yyvsp[(4) - (5)].node);
					if ((yyvsp[(5) - (5)].node) != NULL && IsA((yyvsp[(5) - (5)].node), List))
						n->usingClause = (List *) (yyvsp[(5) - (5)].node); /* USING clause */
					else
						n->quals = (yyvsp[(5) - (5)].node); /* ON clause */
					(yyval.jexpr) = n;
				}
    break;

  case 1486:
/* Line 1787 of yacc.c  */
#line 9981 "gram.y"
    {
					/* letting join_type reduce to empty doesn't work */
					JoinExpr *n = makeNode(JoinExpr);
					n->jointype = JOIN_INNER;
					n->isNatural = FALSE;
					n->larg = (yyvsp[(1) - (4)].node);
					n->rarg = (yyvsp[(3) - (4)].node);
					if ((yyvsp[(4) - (4)].node) != NULL && IsA((yyvsp[(4) - (4)].node), List))
						n->usingClause = (List *) (yyvsp[(4) - (4)].node); /* USING clause */
					else
						n->quals = (yyvsp[(4) - (4)].node); /* ON clause */
					(yyval.jexpr) = n;
				}
    break;

  case 1487:
/* Line 1787 of yacc.c  */
#line 9995 "gram.y"
    {
					JoinExpr *n = makeNode(JoinExpr);
					n->jointype = (yyvsp[(3) - (5)].jtype);
					n->isNatural = TRUE;
					n->larg = (yyvsp[(1) - (5)].node);
					n->rarg = (yyvsp[(5) - (5)].node);
					n->usingClause = NIL; /* figure out which columns later... */
					n->quals = NULL; /* fill later */
					(yyval.jexpr) = n;
				}
    break;

  case 1488:
/* Line 1787 of yacc.c  */
#line 10006 "gram.y"
    {
					/* letting join_type reduce to empty doesn't work */
					JoinExpr *n = makeNode(JoinExpr);
					n->jointype = JOIN_INNER;
					n->isNatural = TRUE;
					n->larg = (yyvsp[(1) - (4)].node);
					n->rarg = (yyvsp[(4) - (4)].node);
					n->usingClause = NIL; /* figure out which columns later... */
					n->quals = NULL; /* fill later */
					(yyval.jexpr) = n;
				}
    break;

  case 1489:
/* Line 1787 of yacc.c  */
#line 10021 "gram.y"
    {
					(yyval.alias) = makeNode(Alias);
					(yyval.alias)->aliasname = (yyvsp[(2) - (5)].str);
					(yyval.alias)->colnames = (yyvsp[(4) - (5)].list);
				}
    break;

  case 1490:
/* Line 1787 of yacc.c  */
#line 10027 "gram.y"
    {
					(yyval.alias) = makeNode(Alias);
					(yyval.alias)->aliasname = (yyvsp[(2) - (2)].str);
				}
    break;

  case 1491:
/* Line 1787 of yacc.c  */
#line 10032 "gram.y"
    {
					(yyval.alias) = makeNode(Alias);
					(yyval.alias)->aliasname = (yyvsp[(1) - (4)].str);
					(yyval.alias)->colnames = (yyvsp[(3) - (4)].list);
				}
    break;

  case 1492:
/* Line 1787 of yacc.c  */
#line 10038 "gram.y"
    {
					(yyval.alias) = makeNode(Alias);
					(yyval.alias)->aliasname = (yyvsp[(1) - (1)].str);
				}
    break;

  case 1493:
/* Line 1787 of yacc.c  */
#line 10044 "gram.y"
    { (yyval.alias) = (yyvsp[(1) - (1)].alias); }
    break;

  case 1494:
/* Line 1787 of yacc.c  */
#line 10045 "gram.y"
    { (yyval.alias) = NULL; }
    break;

  case 1495:
/* Line 1787 of yacc.c  */
#line 10054 "gram.y"
    {
					(yyval.list) = list_make2((yyvsp[(1) - (1)].alias), NIL);
				}
    break;

  case 1496:
/* Line 1787 of yacc.c  */
#line 10058 "gram.y"
    {
					(yyval.list) = list_make2(NULL, (yyvsp[(3) - (4)].list));
				}
    break;

  case 1497:
/* Line 1787 of yacc.c  */
#line 10062 "gram.y"
    {
					Alias *a = makeNode(Alias);
					a->aliasname = (yyvsp[(2) - (5)].str);
					(yyval.list) = list_make2(a, (yyvsp[(4) - (5)].list));
				}
    break;

  case 1498:
/* Line 1787 of yacc.c  */
#line 10068 "gram.y"
    {
					Alias *a = makeNode(Alias);
					a->aliasname = (yyvsp[(1) - (4)].str);
					(yyval.list) = list_make2(a, (yyvsp[(3) - (4)].list));
				}
    break;

  case 1499:
/* Line 1787 of yacc.c  */
#line 10074 "gram.y"
    {
					(yyval.list) = list_make2(NULL, NIL);
				}
    break;

  case 1500:
/* Line 1787 of yacc.c  */
#line 10079 "gram.y"
    { (yyval.jtype) = JOIN_FULL; }
    break;

  case 1501:
/* Line 1787 of yacc.c  */
#line 10080 "gram.y"
    { (yyval.jtype) = JOIN_LEFT; }
    break;

  case 1502:
/* Line 1787 of yacc.c  */
#line 10081 "gram.y"
    { (yyval.jtype) = JOIN_RIGHT; }
    break;

  case 1503:
/* Line 1787 of yacc.c  */
#line 10082 "gram.y"
    { (yyval.jtype) = JOIN_INNER; }
    break;

  case 1504:
/* Line 1787 of yacc.c  */
#line 10086 "gram.y"
    { (yyval.node) = NULL; }
    break;

  case 1505:
/* Line 1787 of yacc.c  */
#line 10087 "gram.y"
    { (yyval.node) = NULL; }
    break;

  case 1506:
/* Line 1787 of yacc.c  */
#line 10099 "gram.y"
    { (yyval.node) = (Node *) (yyvsp[(3) - (4)].list); }
    break;

  case 1507:
/* Line 1787 of yacc.c  */
#line 10100 "gram.y"
    { (yyval.node) = (yyvsp[(2) - (2)].node); }
    break;

  case 1508:
/* Line 1787 of yacc.c  */
#line 10106 "gram.y"
    {
					/* default inheritance */
					(yyval.range) = (yyvsp[(1) - (1)].range);
					(yyval.range)->inhOpt = INH_DEFAULT;
					(yyval.range)->alias = NULL;
				}
    break;

  case 1509:
/* Line 1787 of yacc.c  */
#line 10113 "gram.y"
    {
					/* inheritance query */
					(yyval.range) = (yyvsp[(1) - (2)].range);
					(yyval.range)->inhOpt = INH_YES;
					(yyval.range)->alias = NULL;
				}
    break;

  case 1510:
/* Line 1787 of yacc.c  */
#line 10120 "gram.y"
    {
					/* no inheritance */
					(yyval.range) = (yyvsp[(2) - (2)].range);
					(yyval.range)->inhOpt = INH_NO;
					(yyval.range)->alias = NULL;
				}
    break;

  case 1511:
/* Line 1787 of yacc.c  */
#line 10127 "gram.y"
    {
					/* no inheritance, SQL99-style syntax */
					(yyval.range) = (yyvsp[(3) - (4)].range);
					(yyval.range)->inhOpt = INH_NO;
					(yyval.range)->alias = NULL;
				}
    break;

  case 1512:
/* Line 1787 of yacc.c  */
#line 10137 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].range)); }
    break;

  case 1513:
/* Line 1787 of yacc.c  */
#line 10138 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].range)); }
    break;

  case 1514:
/* Line 1787 of yacc.c  */
#line 10152 "gram.y"
    {
					(yyval.range) = (yyvsp[(1) - (1)].range);
				}
    break;

  case 1515:
/* Line 1787 of yacc.c  */
#line 10156 "gram.y"
    {
					Alias *alias = makeNode(Alias);
					alias->aliasname = (yyvsp[(2) - (2)].str);
					(yyvsp[(1) - (2)].range)->alias = alias;
					(yyval.range) = (yyvsp[(1) - (2)].range);
				}
    break;

  case 1516:
/* Line 1787 of yacc.c  */
#line 10163 "gram.y"
    {
					Alias *alias = makeNode(Alias);
					alias->aliasname = (yyvsp[(3) - (3)].str);
					(yyvsp[(1) - (3)].range)->alias = alias;
					(yyval.range) = (yyvsp[(1) - (3)].range);
				}
    break;

  case 1517:
/* Line 1787 of yacc.c  */
#line 10184 "gram.y"
    {
					RangeFunction *n = makeNode(RangeFunction);
					n->lateral = false;
					n->ordinality = (yyvsp[(2) - (2)].boolean);
					n->is_rowsfrom = false;
					n->functions = list_make1(list_make2((yyvsp[(1) - (2)].node), NIL));
					/* alias and coldeflist are set by table_ref production */
					(yyval.node) = (Node *) n;
				}
    break;

  case 1518:
/* Line 1787 of yacc.c  */
#line 10194 "gram.y"
    {
					RangeFunction *n = makeNode(RangeFunction);
					n->lateral = false;
					n->ordinality = (yyvsp[(6) - (6)].boolean);
					n->is_rowsfrom = true;
					n->functions = (yyvsp[(4) - (6)].list);
					/* alias and coldeflist are set by table_ref production */
					(yyval.node) = (Node *) n;
				}
    break;

  case 1519:
/* Line 1787 of yacc.c  */
#line 10206 "gram.y"
    { (yyval.list) = list_make2((yyvsp[(1) - (2)].node), (yyvsp[(2) - (2)].list)); }
    break;

  case 1520:
/* Line 1787 of yacc.c  */
#line 10210 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].list)); }
    break;

  case 1521:
/* Line 1787 of yacc.c  */
#line 10211 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].list)); }
    break;

  case 1522:
/* Line 1787 of yacc.c  */
#line 10214 "gram.y"
    { (yyval.list) = (yyvsp[(3) - (4)].list); }
    break;

  case 1523:
/* Line 1787 of yacc.c  */
#line 10215 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 1524:
/* Line 1787 of yacc.c  */
#line 10218 "gram.y"
    { (yyval.boolean) = true; }
    break;

  case 1525:
/* Line 1787 of yacc.c  */
#line 10219 "gram.y"
    { (yyval.boolean) = false; }
    break;

  case 1526:
/* Line 1787 of yacc.c  */
#line 10224 "gram.y"
    { (yyval.node) = (yyvsp[(2) - (2)].node); }
    break;

  case 1527:
/* Line 1787 of yacc.c  */
#line 10225 "gram.y"
    { (yyval.node) = NULL; }
    break;

  case 1528:
/* Line 1787 of yacc.c  */
#line 10230 "gram.y"
    { (yyval.node) = (yyvsp[(2) - (2)].node); }
    break;

  case 1529:
/* Line 1787 of yacc.c  */
#line 10232 "gram.y"
    {
					CurrentOfExpr *n = makeNode(CurrentOfExpr);
					/* cvarno is filled in by parse analysis */
					n->cursor_name = (yyvsp[(4) - (4)].str);
					n->cursor_param = 0;
					(yyval.node) = (Node *) n;
				}
    break;

  case 1530:
/* Line 1787 of yacc.c  */
#line 10239 "gram.y"
    { (yyval.node) = NULL; }
    break;

  case 1531:
/* Line 1787 of yacc.c  */
#line 10244 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list); }
    break;

  case 1532:
/* Line 1787 of yacc.c  */
#line 10245 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 1533:
/* Line 1787 of yacc.c  */
#line 10250 "gram.y"
    {
					(yyval.list) = list_make1((yyvsp[(1) - (1)].node));
				}
    break;

  case 1534:
/* Line 1787 of yacc.c  */
#line 10254 "gram.y"
    {
					(yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node));
				}
    break;

  case 1535:
/* Line 1787 of yacc.c  */
#line 10260 "gram.y"
    {
					ColumnDef *n = makeNode(ColumnDef);
					n->colname = (yyvsp[(1) - (3)].str);
					n->typeName = (yyvsp[(2) - (3)].typnam);
					n->inhcount = 0;
					n->is_local = true;
					n->is_not_null = false;
					n->is_from_type = false;
					n->storage = 0;
					n->raw_default = NULL;
					n->cooked_default = NULL;
					n->collClause = (CollateClause *) (yyvsp[(3) - (3)].node);
					n->collOid = InvalidOid;
					n->constraints = NIL;
					n->location = (yylsp[(1) - (3)]);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1536:
/* Line 1787 of yacc.c  */
#line 10290 "gram.y"
    {
					(yyval.typnam) = (yyvsp[(1) - (2)].typnam);
					(yyval.typnam)->arrayBounds = (yyvsp[(2) - (2)].list);
				}
    break;

  case 1537:
/* Line 1787 of yacc.c  */
#line 10295 "gram.y"
    {
					(yyval.typnam) = (yyvsp[(2) - (3)].typnam);
					(yyval.typnam)->arrayBounds = (yyvsp[(3) - (3)].list);
					(yyval.typnam)->setof = TRUE;
				}
    break;

  case 1538:
/* Line 1787 of yacc.c  */
#line 10302 "gram.y"
    {
					(yyval.typnam) = (yyvsp[(1) - (5)].typnam);
					(yyval.typnam)->arrayBounds = list_make1(makeInteger((yyvsp[(4) - (5)].ival)));
				}
    break;

  case 1539:
/* Line 1787 of yacc.c  */
#line 10307 "gram.y"
    {
					(yyval.typnam) = (yyvsp[(2) - (6)].typnam);
					(yyval.typnam)->arrayBounds = list_make1(makeInteger((yyvsp[(5) - (6)].ival)));
					(yyval.typnam)->setof = TRUE;
				}
    break;

  case 1540:
/* Line 1787 of yacc.c  */
#line 10313 "gram.y"
    {
					(yyval.typnam) = (yyvsp[(1) - (2)].typnam);
					(yyval.typnam)->arrayBounds = list_make1(makeInteger(-1));
				}
    break;

  case 1541:
/* Line 1787 of yacc.c  */
#line 10318 "gram.y"
    {
					(yyval.typnam) = (yyvsp[(2) - (3)].typnam);
					(yyval.typnam)->arrayBounds = list_make1(makeInteger(-1));
					(yyval.typnam)->setof = TRUE;
				}
    break;

  case 1542:
/* Line 1787 of yacc.c  */
#line 10327 "gram.y"
    {  (yyval.list) = lappend((yyvsp[(1) - (3)].list), makeInteger(-1)); }
    break;

  case 1543:
/* Line 1787 of yacc.c  */
#line 10329 "gram.y"
    {  (yyval.list) = lappend((yyvsp[(1) - (4)].list), makeInteger((yyvsp[(3) - (4)].ival))); }
    break;

  case 1544:
/* Line 1787 of yacc.c  */
#line 10331 "gram.y"
    {  (yyval.list) = NIL; }
    break;

  case 1545:
/* Line 1787 of yacc.c  */
#line 10335 "gram.y"
    { (yyval.typnam) = (yyvsp[(1) - (1)].typnam); }
    break;

  case 1546:
/* Line 1787 of yacc.c  */
#line 10336 "gram.y"
    { (yyval.typnam) = (yyvsp[(1) - (1)].typnam); }
    break;

  case 1547:
/* Line 1787 of yacc.c  */
#line 10337 "gram.y"
    { (yyval.typnam) = (yyvsp[(1) - (1)].typnam); }
    break;

  case 1548:
/* Line 1787 of yacc.c  */
#line 10338 "gram.y"
    { (yyval.typnam) = (yyvsp[(1) - (1)].typnam); }
    break;

  case 1549:
/* Line 1787 of yacc.c  */
#line 10339 "gram.y"
    { (yyval.typnam) = (yyvsp[(1) - (1)].typnam); }
    break;

  case 1550:
/* Line 1787 of yacc.c  */
#line 10341 "gram.y"
    {
					(yyval.typnam) = (yyvsp[(1) - (2)].typnam);
					(yyval.typnam)->typmods = (yyvsp[(2) - (2)].list);
				}
    break;

  case 1551:
/* Line 1787 of yacc.c  */
#line 10346 "gram.y"
    {
					(yyval.typnam) = (yyvsp[(1) - (5)].typnam);
					if ((yyvsp[(5) - (5)].list) != NIL)
					{
						if (list_length((yyvsp[(5) - (5)].list)) != 1)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("interval precision specified twice"),
									 parser_errposition((yylsp[(1) - (5)]))));
						(yyval.typnam)->typmods = lappend((yyvsp[(5) - (5)].list), makeIntConst((yyvsp[(3) - (5)].ival), (yylsp[(3) - (5)])));
					}
					else
						(yyval.typnam)->typmods = list_make2(makeIntConst(INTERVAL_FULL_RANGE, -1),
												 makeIntConst((yyvsp[(3) - (5)].ival), (yylsp[(3) - (5)])));
				}
    break;

  case 1552:
/* Line 1787 of yacc.c  */
#line 10375 "gram.y"
    { (yyval.typnam) = (yyvsp[(1) - (1)].typnam); }
    break;

  case 1553:
/* Line 1787 of yacc.c  */
#line 10376 "gram.y"
    { (yyval.typnam) = (yyvsp[(1) - (1)].typnam); }
    break;

  case 1554:
/* Line 1787 of yacc.c  */
#line 10377 "gram.y"
    { (yyval.typnam) = (yyvsp[(1) - (1)].typnam); }
    break;

  case 1555:
/* Line 1787 of yacc.c  */
#line 10378 "gram.y"
    { (yyval.typnam) = (yyvsp[(1) - (1)].typnam); }
    break;

  case 1556:
/* Line 1787 of yacc.c  */
#line 10390 "gram.y"
    {
					(yyval.typnam) = makeTypeName((yyvsp[(1) - (2)].str));
					(yyval.typnam)->typmods = (yyvsp[(2) - (2)].list);
					(yyval.typnam)->location = (yylsp[(1) - (2)]);
				}
    break;

  case 1557:
/* Line 1787 of yacc.c  */
#line 10396 "gram.y"
    {
					(yyval.typnam) = makeTypeNameFromNameList(lcons(makeString((yyvsp[(1) - (3)].str)), (yyvsp[(2) - (3)].list)));
					(yyval.typnam)->typmods = (yyvsp[(3) - (3)].list);
					(yyval.typnam)->location = (yylsp[(1) - (3)]);
				}
    break;

  case 1558:
/* Line 1787 of yacc.c  */
#line 10403 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (3)].list); }
    break;

  case 1559:
/* Line 1787 of yacc.c  */
#line 10404 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 1560:
/* Line 1787 of yacc.c  */
#line 10411 "gram.y"
    {
					(yyval.typnam) = SystemTypeName("int4");
					(yyval.typnam)->location = (yylsp[(1) - (1)]);
				}
    break;

  case 1561:
/* Line 1787 of yacc.c  */
#line 10416 "gram.y"
    {
					(yyval.typnam) = SystemTypeName("int4");
					(yyval.typnam)->location = (yylsp[(1) - (1)]);
				}
    break;

  case 1562:
/* Line 1787 of yacc.c  */
#line 10421 "gram.y"
    {
					(yyval.typnam) = SystemTypeName("int2");
					(yyval.typnam)->location = (yylsp[(1) - (1)]);
				}
    break;

  case 1563:
/* Line 1787 of yacc.c  */
#line 10426 "gram.y"
    {
					(yyval.typnam) = SystemTypeName("int8");
					(yyval.typnam)->location = (yylsp[(1) - (1)]);
				}
    break;

  case 1564:
/* Line 1787 of yacc.c  */
#line 10431 "gram.y"
    {
					(yyval.typnam) = SystemTypeName("float4");
					(yyval.typnam)->location = (yylsp[(1) - (1)]);
				}
    break;

  case 1565:
/* Line 1787 of yacc.c  */
#line 10436 "gram.y"
    {
					(yyval.typnam) = (yyvsp[(2) - (2)].typnam);
					(yyval.typnam)->location = (yylsp[(1) - (2)]);
				}
    break;

  case 1566:
/* Line 1787 of yacc.c  */
#line 10441 "gram.y"
    {
					(yyval.typnam) = SystemTypeName("float8");
					(yyval.typnam)->location = (yylsp[(1) - (2)]);
				}
    break;

  case 1567:
/* Line 1787 of yacc.c  */
#line 10446 "gram.y"
    {
					(yyval.typnam) = SystemTypeName("numeric");
					(yyval.typnam)->typmods = (yyvsp[(2) - (2)].list);
					(yyval.typnam)->location = (yylsp[(1) - (2)]);
				}
    break;

  case 1568:
/* Line 1787 of yacc.c  */
#line 10452 "gram.y"
    {
					(yyval.typnam) = SystemTypeName("numeric");
					(yyval.typnam)->typmods = (yyvsp[(2) - (2)].list);
					(yyval.typnam)->location = (yylsp[(1) - (2)]);
				}
    break;

  case 1569:
/* Line 1787 of yacc.c  */
#line 10458 "gram.y"
    {
					(yyval.typnam) = SystemTypeName("numeric");
					(yyval.typnam)->typmods = (yyvsp[(2) - (2)].list);
					(yyval.typnam)->location = (yylsp[(1) - (2)]);
				}
    break;

  case 1570:
/* Line 1787 of yacc.c  */
#line 10464 "gram.y"
    {
					(yyval.typnam) = SystemTypeName("bool");
					(yyval.typnam)->location = (yylsp[(1) - (1)]);
				}
    break;

  case 1571:
/* Line 1787 of yacc.c  */
#line 10471 "gram.y"
    {
					/*
					 * Check FLOAT() precision limits assuming IEEE floating
					 * types - thomas 1997-09-18
					 */
					if ((yyvsp[(2) - (3)].ival) < 1)
						ereport(ERROR,
								(errcode(ERRCODE_INVALID_PARAMETER_VALUE),
								 errmsg("precision for type float must be at least 1 bit"),
								 parser_errposition((yylsp[(2) - (3)]))));
					else if ((yyvsp[(2) - (3)].ival) <= 24)
						(yyval.typnam) = SystemTypeName("float4");
					else if ((yyvsp[(2) - (3)].ival) <= 53)
						(yyval.typnam) = SystemTypeName("float8");
					else
						ereport(ERROR,
								(errcode(ERRCODE_INVALID_PARAMETER_VALUE),
								 errmsg("precision for type float must be less than 54 bits"),
								 parser_errposition((yylsp[(2) - (3)]))));
				}
    break;

  case 1572:
/* Line 1787 of yacc.c  */
#line 10492 "gram.y"
    {
					(yyval.typnam) = SystemTypeName("float8");
				}
    break;

  case 1573:
/* Line 1787 of yacc.c  */
#line 10502 "gram.y"
    {
					(yyval.typnam) = (yyvsp[(1) - (1)].typnam);
				}
    break;

  case 1574:
/* Line 1787 of yacc.c  */
#line 10506 "gram.y"
    {
					(yyval.typnam) = (yyvsp[(1) - (1)].typnam);
				}
    break;

  case 1575:
/* Line 1787 of yacc.c  */
#line 10514 "gram.y"
    {
					(yyval.typnam) = (yyvsp[(1) - (1)].typnam);
				}
    break;

  case 1576:
/* Line 1787 of yacc.c  */
#line 10518 "gram.y"
    {
					(yyval.typnam) = (yyvsp[(1) - (1)].typnam);
					(yyval.typnam)->typmods = NIL;
				}
    break;

  case 1577:
/* Line 1787 of yacc.c  */
#line 10526 "gram.y"
    {
					char *typname;

					typname = (yyvsp[(2) - (5)].boolean) ? "varbit" : "bit";
					(yyval.typnam) = SystemTypeName(typname);
					(yyval.typnam)->typmods = (yyvsp[(4) - (5)].list);
					(yyval.typnam)->location = (yylsp[(1) - (5)]);
				}
    break;

  case 1578:
/* Line 1787 of yacc.c  */
#line 10538 "gram.y"
    {
					/* bit defaults to bit(1), varbit to no limit */
					if ((yyvsp[(2) - (2)].boolean))
					{
						(yyval.typnam) = SystemTypeName("varbit");
					}
					else
					{
						(yyval.typnam) = SystemTypeName("bit");
						(yyval.typnam)->typmods = list_make1(makeIntConst(1, -1));
					}
					(yyval.typnam)->location = (yylsp[(1) - (2)]);
				}
    break;

  case 1579:
/* Line 1787 of yacc.c  */
#line 10559 "gram.y"
    {
					(yyval.typnam) = (yyvsp[(1) - (1)].typnam);
				}
    break;

  case 1580:
/* Line 1787 of yacc.c  */
#line 10563 "gram.y"
    {
					(yyval.typnam) = (yyvsp[(1) - (1)].typnam);
				}
    break;

  case 1581:
/* Line 1787 of yacc.c  */
#line 10569 "gram.y"
    {
					(yyval.typnam) = (yyvsp[(1) - (1)].typnam);
				}
    break;

  case 1582:
/* Line 1787 of yacc.c  */
#line 10573 "gram.y"
    {
					/* Length was not specified so allow to be unrestricted.
					 * This handles problems with fixed-length (bpchar) strings
					 * which in column definitions must default to a length
					 * of one, but should not be constrained if the length
					 * was not specified.
					 */
					(yyval.typnam) = (yyvsp[(1) - (1)].typnam);
					(yyval.typnam)->typmods = NIL;
				}
    break;

  case 1583:
/* Line 1787 of yacc.c  */
#line 10586 "gram.y"
    {
					if (((yyvsp[(5) - (5)].str) != NULL) && (strcmp((yyvsp[(5) - (5)].str), "sql_text") != 0))
						(yyvsp[(1) - (5)].str) = psprintf("%s_%s", (yyvsp[(1) - (5)].str), (yyvsp[(5) - (5)].str));

					(yyval.typnam) = SystemTypeName((yyvsp[(1) - (5)].str));
					(yyval.typnam)->typmods = list_make1(makeIntConst((yyvsp[(3) - (5)].ival), (yylsp[(3) - (5)])));
					(yyval.typnam)->location = (yylsp[(1) - (5)]);
				}
    break;

  case 1584:
/* Line 1787 of yacc.c  */
#line 10597 "gram.y"
    {
					if (((yyvsp[(2) - (2)].str) != NULL) && (strcmp((yyvsp[(2) - (2)].str), "sql_text") != 0))
						(yyvsp[(1) - (2)].str) = psprintf("%s_%s", (yyvsp[(1) - (2)].str), (yyvsp[(2) - (2)].str));

					(yyval.typnam) = SystemTypeName((yyvsp[(1) - (2)].str));

					/* char defaults to char(1), varchar to no limit */
					if (strcmp((yyvsp[(1) - (2)].str), "bpchar") == 0)
						(yyval.typnam)->typmods = list_make1(makeIntConst(1, -1));

					(yyval.typnam)->location = (yylsp[(1) - (2)]);
				}
    break;

  case 1585:
/* Line 1787 of yacc.c  */
#line 10612 "gram.y"
    { (yyval.str) = (yyvsp[(2) - (2)].boolean) ? "varchar": "bpchar"; }
    break;

  case 1586:
/* Line 1787 of yacc.c  */
#line 10614 "gram.y"
    { (yyval.str) = (yyvsp[(2) - (2)].boolean) ? "varchar": "bpchar"; }
    break;

  case 1587:
/* Line 1787 of yacc.c  */
#line 10616 "gram.y"
    { (yyval.str) = "varchar"; }
    break;

  case 1588:
/* Line 1787 of yacc.c  */
#line 10618 "gram.y"
    { (yyval.str) = (yyvsp[(3) - (3)].boolean) ? "varchar": "bpchar"; }
    break;

  case 1589:
/* Line 1787 of yacc.c  */
#line 10620 "gram.y"
    { (yyval.str) = (yyvsp[(3) - (3)].boolean) ? "varchar": "bpchar"; }
    break;

  case 1590:
/* Line 1787 of yacc.c  */
#line 10622 "gram.y"
    { (yyval.str) = (yyvsp[(2) - (2)].boolean) ? "varchar": "bpchar"; }
    break;

  case 1591:
/* Line 1787 of yacc.c  */
#line 10626 "gram.y"
    { (yyval.boolean) = TRUE; }
    break;

  case 1592:
/* Line 1787 of yacc.c  */
#line 10627 "gram.y"
    { (yyval.boolean) = FALSE; }
    break;

  case 1593:
/* Line 1787 of yacc.c  */
#line 10631 "gram.y"
    { (yyval.str) = (yyvsp[(3) - (3)].str); }
    break;

  case 1594:
/* Line 1787 of yacc.c  */
#line 10632 "gram.y"
    { (yyval.str) = NULL; }
    break;

  case 1595:
/* Line 1787 of yacc.c  */
#line 10640 "gram.y"
    {
					if ((yyvsp[(5) - (5)].boolean))
						(yyval.typnam) = SystemTypeName("timestamptz");
					else
						(yyval.typnam) = SystemTypeName("timestamp");
					(yyval.typnam)->typmods = list_make1(makeIntConst((yyvsp[(3) - (5)].ival), (yylsp[(3) - (5)])));
					(yyval.typnam)->location = (yylsp[(1) - (5)]);
				}
    break;

  case 1596:
/* Line 1787 of yacc.c  */
#line 10649 "gram.y"
    {
					if ((yyvsp[(2) - (2)].boolean))
						(yyval.typnam) = SystemTypeName("timestamptz");
					else
						(yyval.typnam) = SystemTypeName("timestamp");
					(yyval.typnam)->location = (yylsp[(1) - (2)]);
				}
    break;

  case 1597:
/* Line 1787 of yacc.c  */
#line 10657 "gram.y"
    {
					if ((yyvsp[(5) - (5)].boolean))
						(yyval.typnam) = SystemTypeName("timetz");
					else
						(yyval.typnam) = SystemTypeName("time");
					(yyval.typnam)->typmods = list_make1(makeIntConst((yyvsp[(3) - (5)].ival), (yylsp[(3) - (5)])));
					(yyval.typnam)->location = (yylsp[(1) - (5)]);
				}
    break;

  case 1598:
/* Line 1787 of yacc.c  */
#line 10666 "gram.y"
    {
					if ((yyvsp[(2) - (2)].boolean))
						(yyval.typnam) = SystemTypeName("timetz");
					else
						(yyval.typnam) = SystemTypeName("time");
					(yyval.typnam)->location = (yylsp[(1) - (2)]);
				}
    break;

  case 1599:
/* Line 1787 of yacc.c  */
#line 10677 "gram.y"
    {
					(yyval.typnam) = SystemTypeName("interval");
					(yyval.typnam)->location = (yylsp[(1) - (1)]);
				}
    break;

  case 1600:
/* Line 1787 of yacc.c  */
#line 10684 "gram.y"
    { (yyval.boolean) = TRUE; }
    break;

  case 1601:
/* Line 1787 of yacc.c  */
#line 10685 "gram.y"
    { (yyval.boolean) = FALSE; }
    break;

  case 1602:
/* Line 1787 of yacc.c  */
#line 10686 "gram.y"
    { (yyval.boolean) = FALSE; }
    break;

  case 1603:
/* Line 1787 of yacc.c  */
#line 10691 "gram.y"
    { (yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(YEAR), (yylsp[(1) - (1)]))); }
    break;

  case 1604:
/* Line 1787 of yacc.c  */
#line 10693 "gram.y"
    { (yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(MONTH), (yylsp[(1) - (1)]))); }
    break;

  case 1605:
/* Line 1787 of yacc.c  */
#line 10695 "gram.y"
    { (yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(DAY), (yylsp[(1) - (1)]))); }
    break;

  case 1606:
/* Line 1787 of yacc.c  */
#line 10697 "gram.y"
    { (yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(HOUR), (yylsp[(1) - (1)]))); }
    break;

  case 1607:
/* Line 1787 of yacc.c  */
#line 10699 "gram.y"
    { (yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(MINUTE), (yylsp[(1) - (1)]))); }
    break;

  case 1608:
/* Line 1787 of yacc.c  */
#line 10701 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list); }
    break;

  case 1609:
/* Line 1787 of yacc.c  */
#line 10703 "gram.y"
    {
					(yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(YEAR) |
												 INTERVAL_MASK(MONTH), (yylsp[(1) - (3)])));
				}
    break;

  case 1610:
/* Line 1787 of yacc.c  */
#line 10708 "gram.y"
    {
					(yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(DAY) |
												 INTERVAL_MASK(HOUR), (yylsp[(1) - (3)])));
				}
    break;

  case 1611:
/* Line 1787 of yacc.c  */
#line 10713 "gram.y"
    {
					(yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(DAY) |
												 INTERVAL_MASK(HOUR) |
												 INTERVAL_MASK(MINUTE), (yylsp[(1) - (3)])));
				}
    break;

  case 1612:
/* Line 1787 of yacc.c  */
#line 10719 "gram.y"
    {
					(yyval.list) = (yyvsp[(3) - (3)].list);
					linitial((yyval.list)) = makeIntConst(INTERVAL_MASK(DAY) |
												INTERVAL_MASK(HOUR) |
												INTERVAL_MASK(MINUTE) |
												INTERVAL_MASK(SECOND), (yylsp[(1) - (3)]));
				}
    break;

  case 1613:
/* Line 1787 of yacc.c  */
#line 10727 "gram.y"
    {
					(yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(HOUR) |
												 INTERVAL_MASK(MINUTE), (yylsp[(1) - (3)])));
				}
    break;

  case 1614:
/* Line 1787 of yacc.c  */
#line 10732 "gram.y"
    {
					(yyval.list) = (yyvsp[(3) - (3)].list);
					linitial((yyval.list)) = makeIntConst(INTERVAL_MASK(HOUR) |
												INTERVAL_MASK(MINUTE) |
												INTERVAL_MASK(SECOND), (yylsp[(1) - (3)]));
				}
    break;

  case 1615:
/* Line 1787 of yacc.c  */
#line 10739 "gram.y"
    {
					(yyval.list) = (yyvsp[(3) - (3)].list);
					linitial((yyval.list)) = makeIntConst(INTERVAL_MASK(MINUTE) |
												INTERVAL_MASK(SECOND), (yylsp[(1) - (3)]));
				}
    break;

  case 1616:
/* Line 1787 of yacc.c  */
#line 10745 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 1617:
/* Line 1787 of yacc.c  */
#line 10750 "gram.y"
    {
					(yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(SECOND), (yylsp[(1) - (1)])));
				}
    break;

  case 1618:
/* Line 1787 of yacc.c  */
#line 10754 "gram.y"
    {
					(yyval.list) = list_make2(makeIntConst(INTERVAL_MASK(SECOND), (yylsp[(1) - (4)])),
									makeIntConst((yyvsp[(3) - (4)].ival), (yylsp[(3) - (4)])));
				}
    break;

  case 1619:
/* Line 1787 of yacc.c  */
#line 10783 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); }
    break;

  case 1620:
/* Line 1787 of yacc.c  */
#line 10785 "gram.y"
    { (yyval.node) = makeTypeCast((yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].typnam), (yylsp[(2) - (3)])); }
    break;

  case 1621:
/* Line 1787 of yacc.c  */
#line 10787 "gram.y"
    {
					CollateClause *n = makeNode(CollateClause);
					n->arg = (yyvsp[(1) - (3)].node);
					n->collname = (yyvsp[(3) - (3)].list);
					n->location = (yylsp[(2) - (3)]);
					(yyval.node) = (Node *) n;
				}
    break;

  case 1622:
/* Line 1787 of yacc.c  */
#line 10795 "gram.y"
    {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("timezone"),
											   list_make2((yyvsp[(5) - (5)].node), (yyvsp[(1) - (5)].node)),
											   (yylsp[(2) - (5)]));
				}
    break;

  case 1623:
/* Line 1787 of yacc.c  */
#line 10810 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "+", NULL, (yyvsp[(2) - (2)].node), (yylsp[(1) - (2)])); }
    break;

  case 1624:
/* Line 1787 of yacc.c  */
#line 10812 "gram.y"
    { (yyval.node) = doNegate((yyvsp[(2) - (2)].node), (yylsp[(1) - (2)])); }
    break;

  case 1625:
/* Line 1787 of yacc.c  */
#line 10814 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "+", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); }
    break;

  case 1626:
/* Line 1787 of yacc.c  */
#line 10816 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "-", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); }
    break;

  case 1627:
/* Line 1787 of yacc.c  */
#line 10818 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "*", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); }
    break;

  case 1628:
/* Line 1787 of yacc.c  */
#line 10820 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "/", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); }
    break;

  case 1629:
/* Line 1787 of yacc.c  */
#line 10822 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "%", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); }
    break;

  case 1630:
/* Line 1787 of yacc.c  */
#line 10824 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "^", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); }
    break;

  case 1631:
/* Line 1787 of yacc.c  */
#line 10826 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "<", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); }
    break;

  case 1632:
/* Line 1787 of yacc.c  */
#line 10828 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, ">", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); }
    break;

  case 1633:
/* Line 1787 of yacc.c  */
#line 10830 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "=", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); }
    break;

  case 1634:
/* Line 1787 of yacc.c  */
#line 10833 "gram.y"
    { (yyval.node) = (Node *) makeA_Expr(AEXPR_OP, (yyvsp[(2) - (3)].list), (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); }
    break;

  case 1635:
/* Line 1787 of yacc.c  */
#line 10835 "gram.y"
    { (yyval.node) = (Node *) makeA_Expr(AEXPR_OP, (yyvsp[(1) - (2)].list), NULL, (yyvsp[(2) - (2)].node), (yylsp[(1) - (2)])); }
    break;

  case 1636:
/* Line 1787 of yacc.c  */
#line 10837 "gram.y"
    { (yyval.node) = (Node *) makeA_Expr(AEXPR_OP, (yyvsp[(2) - (2)].list), (yyvsp[(1) - (2)].node), NULL, (yylsp[(2) - (2)])); }
    break;

  case 1637:
/* Line 1787 of yacc.c  */
#line 10840 "gram.y"
    { (yyval.node) = (Node *) makeA_Expr(AEXPR_AND, NIL, (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); }
    break;

  case 1638:
/* Line 1787 of yacc.c  */
#line 10842 "gram.y"
    { (yyval.node) = (Node *) makeA_Expr(AEXPR_OR, NIL, (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); }
    break;

  case 1639:
/* Line 1787 of yacc.c  */
#line 10844 "gram.y"
    { (yyval.node) = (Node *) makeA_Expr(AEXPR_NOT, NIL, NULL, (yyvsp[(2) - (2)].node), (yylsp[(1) - (2)])); }
    break;

  case 1640:
/* Line 1787 of yacc.c  */
#line 10847 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "~~", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); }
    break;

  case 1641:
/* Line 1787 of yacc.c  */
#line 10849 "gram.y"
    {
					FuncCall *n = makeFuncCall(list_make1(makeString("like_escape")),
											   list_make2((yyvsp[(3) - (5)].node), (yyvsp[(5) - (5)].node)),
											   (yylsp[(2) - (5)]));
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "~~", (yyvsp[(1) - (5)].node), (Node *) n, (yylsp[(2) - (5)]));
				}
    break;

  case 1642:
/* Line 1787 of yacc.c  */
#line 10856 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "!~~", (yyvsp[(1) - (4)].node), (yyvsp[(4) - (4)].node), (yylsp[(2) - (4)])); }
    break;

  case 1643:
/* Line 1787 of yacc.c  */
#line 10858 "gram.y"
    {
					FuncCall *n = makeFuncCall(list_make1(makeString("like_escape")),
											   list_make2((yyvsp[(4) - (6)].node), (yyvsp[(6) - (6)].node)),
											   (yylsp[(2) - (6)]));
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "!~~", (yyvsp[(1) - (6)].node), (Node *) n, (yylsp[(2) - (6)]));
				}
    break;

  case 1644:
/* Line 1787 of yacc.c  */
#line 10865 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "~~*", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); }
    break;

  case 1645:
/* Line 1787 of yacc.c  */
#line 10867 "gram.y"
    {
					FuncCall *n = makeFuncCall(list_make1(makeString("like_escape")),
											   list_make2((yyvsp[(3) - (5)].node), (yyvsp[(5) - (5)].node)),
											   (yylsp[(2) - (5)]));
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "~~*", (yyvsp[(1) - (5)].node), (Node *) n, (yylsp[(2) - (5)]));
				}
    break;

  case 1646:
/* Line 1787 of yacc.c  */
#line 10874 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "!~~*", (yyvsp[(1) - (4)].node), (yyvsp[(4) - (4)].node), (yylsp[(2) - (4)])); }
    break;

  case 1647:
/* Line 1787 of yacc.c  */
#line 10876 "gram.y"
    {
					FuncCall *n = makeFuncCall(list_make1(makeString("like_escape")),
											   list_make2((yyvsp[(4) - (6)].node), (yyvsp[(6) - (6)].node)),
											   (yylsp[(2) - (6)]));
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "!~~*", (yyvsp[(1) - (6)].node), (Node *) n, (yylsp[(2) - (6)]));
				}
    break;

  case 1648:
/* Line 1787 of yacc.c  */
#line 10884 "gram.y"
    {
					FuncCall *n = makeFuncCall(list_make1(makeString("similar_escape")),
											   list_make2((yyvsp[(4) - (4)].node), makeNullAConst(-1)),
											   (yylsp[(2) - (4)]));
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "~", (yyvsp[(1) - (4)].node), (Node *) n, (yylsp[(2) - (4)]));
				}
    break;

  case 1649:
/* Line 1787 of yacc.c  */
#line 10891 "gram.y"
    {
					FuncCall *n = makeFuncCall(list_make1(makeString("similar_escape")),
											   list_make2((yyvsp[(4) - (6)].node), (yyvsp[(6) - (6)].node)),
											   (yylsp[(2) - (6)]));
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "~", (yyvsp[(1) - (6)].node), (Node *) n, (yylsp[(2) - (6)]));
				}
    break;

  case 1650:
/* Line 1787 of yacc.c  */
#line 10898 "gram.y"
    {
					FuncCall *n = makeFuncCall(list_make1(makeString("similar_escape")),
											   list_make2((yyvsp[(5) - (5)].node), makeNullAConst(-1)),
											   (yylsp[(2) - (5)]));
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "!~", (yyvsp[(1) - (5)].node), (Node *) n, (yylsp[(2) - (5)]));
				}
    break;

  case 1651:
/* Line 1787 of yacc.c  */
#line 10905 "gram.y"
    {
					FuncCall *n = makeFuncCall(list_make1(makeString("similar_escape")),
											   list_make2((yyvsp[(5) - (7)].node), (yyvsp[(7) - (7)].node)),
											   (yylsp[(2) - (7)]));
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "!~", (yyvsp[(1) - (7)].node), (Node *) n, (yylsp[(2) - (7)]));
				}
    break;

  case 1652:
/* Line 1787 of yacc.c  */
#line 10922 "gram.y"
    {
					NullTest *n = makeNode(NullTest);
					n->arg = (Expr *) (yyvsp[(1) - (3)].node);
					n->nulltesttype = IS_NULL;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1653:
/* Line 1787 of yacc.c  */
#line 10929 "gram.y"
    {
					NullTest *n = makeNode(NullTest);
					n->arg = (Expr *) (yyvsp[(1) - (2)].node);
					n->nulltesttype = IS_NULL;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1654:
/* Line 1787 of yacc.c  */
#line 10936 "gram.y"
    {
					NullTest *n = makeNode(NullTest);
					n->arg = (Expr *) (yyvsp[(1) - (4)].node);
					n->nulltesttype = IS_NOT_NULL;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1655:
/* Line 1787 of yacc.c  */
#line 10943 "gram.y"
    {
					NullTest *n = makeNode(NullTest);
					n->arg = (Expr *) (yyvsp[(1) - (2)].node);
					n->nulltesttype = IS_NOT_NULL;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1656:
/* Line 1787 of yacc.c  */
#line 10950 "gram.y"
    {
					if (list_length((yyvsp[(1) - (3)].list)) != 2)
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("wrong number of parameters on left side of OVERLAPS expression"),
								 parser_errposition((yylsp[(1) - (3)]))));
					if (list_length((yyvsp[(3) - (3)].list)) != 2)
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("wrong number of parameters on right side of OVERLAPS expression"),
								 parser_errposition((yylsp[(3) - (3)]))));
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("overlaps"),
											   list_concat((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].list)),
											   (yylsp[(2) - (3)]));
				}
    break;

  case 1657:
/* Line 1787 of yacc.c  */
#line 10966 "gram.y"
    {
					BooleanTest *b = makeNode(BooleanTest);
					b->arg = (Expr *) (yyvsp[(1) - (3)].node);
					b->booltesttype = IS_TRUE;
					(yyval.node) = (Node *)b;
				}
    break;

  case 1658:
/* Line 1787 of yacc.c  */
#line 10973 "gram.y"
    {
					BooleanTest *b = makeNode(BooleanTest);
					b->arg = (Expr *) (yyvsp[(1) - (4)].node);
					b->booltesttype = IS_NOT_TRUE;
					(yyval.node) = (Node *)b;
				}
    break;

  case 1659:
/* Line 1787 of yacc.c  */
#line 10980 "gram.y"
    {
					BooleanTest *b = makeNode(BooleanTest);
					b->arg = (Expr *) (yyvsp[(1) - (3)].node);
					b->booltesttype = IS_FALSE;
					(yyval.node) = (Node *)b;
				}
    break;

  case 1660:
/* Line 1787 of yacc.c  */
#line 10987 "gram.y"
    {
					BooleanTest *b = makeNode(BooleanTest);
					b->arg = (Expr *) (yyvsp[(1) - (4)].node);
					b->booltesttype = IS_NOT_FALSE;
					(yyval.node) = (Node *)b;
				}
    break;

  case 1661:
/* Line 1787 of yacc.c  */
#line 10994 "gram.y"
    {
					BooleanTest *b = makeNode(BooleanTest);
					b->arg = (Expr *) (yyvsp[(1) - (3)].node);
					b->booltesttype = IS_UNKNOWN;
					(yyval.node) = (Node *)b;
				}
    break;

  case 1662:
/* Line 1787 of yacc.c  */
#line 11001 "gram.y"
    {
					BooleanTest *b = makeNode(BooleanTest);
					b->arg = (Expr *) (yyvsp[(1) - (4)].node);
					b->booltesttype = IS_NOT_UNKNOWN;
					(yyval.node) = (Node *)b;
				}
    break;

  case 1663:
/* Line 1787 of yacc.c  */
#line 11008 "gram.y"
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_DISTINCT, "=", (yyvsp[(1) - (5)].node), (yyvsp[(5) - (5)].node), (yylsp[(2) - (5)]));
				}
    break;

  case 1664:
/* Line 1787 of yacc.c  */
#line 11012 "gram.y"
    {
					(yyval.node) = (Node *) makeA_Expr(AEXPR_NOT, NIL, NULL,
									(Node *) makeSimpleA_Expr(AEXPR_DISTINCT,
															  "=", (yyvsp[(1) - (6)].node), (yyvsp[(6) - (6)].node), (yylsp[(2) - (6)])),
											 (yylsp[(2) - (6)]));

				}
    break;

  case 1665:
/* Line 1787 of yacc.c  */
#line 11020 "gram.y"
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OF, "=", (yyvsp[(1) - (6)].node), (Node *) (yyvsp[(5) - (6)].list), (yylsp[(2) - (6)]));
				}
    break;

  case 1666:
/* Line 1787 of yacc.c  */
#line 11024 "gram.y"
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OF, "<>", (yyvsp[(1) - (7)].node), (Node *) (yyvsp[(6) - (7)].list), (yylsp[(2) - (7)]));
				}
    break;

  case 1667:
/* Line 1787 of yacc.c  */
#line 11034 "gram.y"
    {
					(yyval.node) = (Node *) makeA_Expr(AEXPR_AND, NIL,
						(Node *) makeSimpleA_Expr(AEXPR_OP, ">=", (yyvsp[(1) - (6)].node), (yyvsp[(4) - (6)].node), (yylsp[(2) - (6)])),
						(Node *) makeSimpleA_Expr(AEXPR_OP, "<=", (yyvsp[(1) - (6)].node), (yyvsp[(6) - (6)].node), (yylsp[(2) - (6)])),
											 (yylsp[(2) - (6)]));
				}
    break;

  case 1668:
/* Line 1787 of yacc.c  */
#line 11041 "gram.y"
    {
					(yyval.node) = (Node *) makeA_Expr(AEXPR_OR, NIL,
						(Node *) makeSimpleA_Expr(AEXPR_OP, "<", (yyvsp[(1) - (7)].node), (yyvsp[(5) - (7)].node), (yylsp[(2) - (7)])),
						(Node *) makeSimpleA_Expr(AEXPR_OP, ">", (yyvsp[(1) - (7)].node), (yyvsp[(7) - (7)].node), (yylsp[(2) - (7)])),
											 (yylsp[(2) - (7)]));
				}
    break;

  case 1669:
/* Line 1787 of yacc.c  */
#line 11048 "gram.y"
    {
					(yyval.node) = (Node *) makeA_Expr(AEXPR_OR, NIL,
						(Node *) makeA_Expr(AEXPR_AND, NIL,
							(Node *) makeSimpleA_Expr(AEXPR_OP, ">=", (yyvsp[(1) - (6)].node), (yyvsp[(4) - (6)].node), (yylsp[(2) - (6)])),
							(Node *) makeSimpleA_Expr(AEXPR_OP, "<=", (yyvsp[(1) - (6)].node), (yyvsp[(6) - (6)].node), (yylsp[(2) - (6)])),
											(yylsp[(2) - (6)])),
						(Node *) makeA_Expr(AEXPR_AND, NIL,
							(Node *) makeSimpleA_Expr(AEXPR_OP, ">=", (yyvsp[(1) - (6)].node), (yyvsp[(6) - (6)].node), (yylsp[(2) - (6)])),
							(Node *) makeSimpleA_Expr(AEXPR_OP, "<=", (yyvsp[(1) - (6)].node), (yyvsp[(4) - (6)].node), (yylsp[(2) - (6)])),
											(yylsp[(2) - (6)])),
											 (yylsp[(2) - (6)]));
				}
    break;

  case 1670:
/* Line 1787 of yacc.c  */
#line 11061 "gram.y"
    {
					(yyval.node) = (Node *) makeA_Expr(AEXPR_AND, NIL,
						(Node *) makeA_Expr(AEXPR_OR, NIL,
							(Node *) makeSimpleA_Expr(AEXPR_OP, "<", (yyvsp[(1) - (7)].node), (yyvsp[(5) - (7)].node), (yylsp[(2) - (7)])),
							(Node *) makeSimpleA_Expr(AEXPR_OP, ">", (yyvsp[(1) - (7)].node), (yyvsp[(7) - (7)].node), (yylsp[(2) - (7)])),
											(yylsp[(2) - (7)])),
						(Node *) makeA_Expr(AEXPR_OR, NIL,
							(Node *) makeSimpleA_Expr(AEXPR_OP, "<", (yyvsp[(1) - (7)].node), (yyvsp[(7) - (7)].node), (yylsp[(2) - (7)])),
							(Node *) makeSimpleA_Expr(AEXPR_OP, ">", (yyvsp[(1) - (7)].node), (yyvsp[(5) - (7)].node), (yylsp[(2) - (7)])),
											(yylsp[(2) - (7)])),
											 (yylsp[(2) - (7)]));
				}
    break;

  case 1671:
/* Line 1787 of yacc.c  */
#line 11074 "gram.y"
    {
					/* in_expr returns a SubLink or a list of a_exprs */
					if (IsA((yyvsp[(3) - (3)].node), SubLink))
					{
						/* generate foo = ANY (subquery) */
						SubLink *n = (SubLink *) (yyvsp[(3) - (3)].node);
						n->subLinkType = ANY_SUBLINK;
						n->testexpr = (yyvsp[(1) - (3)].node);
						n->operName = list_make1(makeString("="));
						n->location = (yylsp[(2) - (3)]);
						(yyval.node) = (Node *)n;
					}
					else
					{
						/* generate scalar IN expression */
						(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_IN, "=", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)]));
					}
				}
    break;

  case 1672:
/* Line 1787 of yacc.c  */
#line 11093 "gram.y"
    {
					/* in_expr returns a SubLink or a list of a_exprs */
					if (IsA((yyvsp[(4) - (4)].node), SubLink))
					{
						/* generate NOT (foo = ANY (subquery)) */
						/* Make an = ANY node */
						SubLink *n = (SubLink *) (yyvsp[(4) - (4)].node);
						n->subLinkType = ANY_SUBLINK;
						n->testexpr = (yyvsp[(1) - (4)].node);
						n->operName = list_make1(makeString("="));
						n->location = (yylsp[(3) - (4)]);
						/* Stick a NOT on top */
						(yyval.node) = (Node *) makeA_Expr(AEXPR_NOT, NIL, NULL, (Node *) n, (yylsp[(2) - (4)]));
					}
					else
					{
						/* generate scalar NOT IN expression */
						(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_IN, "<>", (yyvsp[(1) - (4)].node), (yyvsp[(4) - (4)].node), (yylsp[(2) - (4)]));
					}
				}
    break;

  case 1673:
/* Line 1787 of yacc.c  */
#line 11114 "gram.y"
    {
					SubLink *n = makeNode(SubLink);
					n->subLinkType = (yyvsp[(3) - (4)].ival);
					n->testexpr = (yyvsp[(1) - (4)].node);
					n->operName = (yyvsp[(2) - (4)].list);
					n->subselect = (yyvsp[(4) - (4)].node);
					n->location = (yylsp[(2) - (4)]);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1674:
/* Line 1787 of yacc.c  */
#line 11124 "gram.y"
    {
					if ((yyvsp[(3) - (6)].ival) == ANY_SUBLINK)
						(yyval.node) = (Node *) makeA_Expr(AEXPR_OP_ANY, (yyvsp[(2) - (6)].list), (yyvsp[(1) - (6)].node), (yyvsp[(5) - (6)].node), (yylsp[(2) - (6)]));
					else
						(yyval.node) = (Node *) makeA_Expr(AEXPR_OP_ALL, (yyvsp[(2) - (6)].list), (yyvsp[(1) - (6)].node), (yyvsp[(5) - (6)].node), (yylsp[(2) - (6)]));
				}
    break;

  case 1675:
/* Line 1787 of yacc.c  */
#line 11131 "gram.y"
    {
					/* Not sure how to get rid of the parentheses
					 * but there are lots of shift/reduce errors without them.
					 *
					 * Should be able to implement this by plopping the entire
					 * select into a node, then transforming the target expressions
					 * from whatever they are into count(*), and testing the
					 * entire result equal to one.
					 * But, will probably implement a separate node in the executor.
					 */
					ereport(ERROR,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("UNIQUE predicate is not yet implemented"),
							 parser_errposition((yylsp[(1) - (2)]))));
				}
    break;

  case 1676:
/* Line 1787 of yacc.c  */
#line 11147 "gram.y"
    {
					(yyval.node) = makeXmlExpr(IS_DOCUMENT, NULL, NIL,
									 list_make1((yyvsp[(1) - (3)].node)), (yylsp[(2) - (3)]));
				}
    break;

  case 1677:
/* Line 1787 of yacc.c  */
#line 11152 "gram.y"
    {
					(yyval.node) = (Node *) makeA_Expr(AEXPR_NOT, NIL, NULL,
											 makeXmlExpr(IS_DOCUMENT, NULL, NIL,
														 list_make1((yyvsp[(1) - (4)].node)), (yylsp[(2) - (4)])),
											 (yylsp[(2) - (4)]));
				}
    break;

  case 1678:
/* Line 1787 of yacc.c  */
#line 11170 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); }
    break;

  case 1679:
/* Line 1787 of yacc.c  */
#line 11172 "gram.y"
    { (yyval.node) = makeTypeCast((yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].typnam), (yylsp[(2) - (3)])); }
    break;

  case 1680:
/* Line 1787 of yacc.c  */
#line 11174 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "+", NULL, (yyvsp[(2) - (2)].node), (yylsp[(1) - (2)])); }
    break;

  case 1681:
/* Line 1787 of yacc.c  */
#line 11176 "gram.y"
    { (yyval.node) = doNegate((yyvsp[(2) - (2)].node), (yylsp[(1) - (2)])); }
    break;

  case 1682:
/* Line 1787 of yacc.c  */
#line 11178 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "+", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); }
    break;

  case 1683:
/* Line 1787 of yacc.c  */
#line 11180 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "-", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); }
    break;

  case 1684:
/* Line 1787 of yacc.c  */
#line 11182 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "*", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); }
    break;

  case 1685:
/* Line 1787 of yacc.c  */
#line 11184 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "/", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); }
    break;

  case 1686:
/* Line 1787 of yacc.c  */
#line 11186 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "%", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); }
    break;

  case 1687:
/* Line 1787 of yacc.c  */
#line 11188 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "^", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); }
    break;

  case 1688:
/* Line 1787 of yacc.c  */
#line 11190 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "<", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); }
    break;

  case 1689:
/* Line 1787 of yacc.c  */
#line 11192 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, ">", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); }
    break;

  case 1690:
/* Line 1787 of yacc.c  */
#line 11194 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "=", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); }
    break;

  case 1691:
/* Line 1787 of yacc.c  */
#line 11196 "gram.y"
    { (yyval.node) = (Node *) makeA_Expr(AEXPR_OP, (yyvsp[(2) - (3)].list), (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); }
    break;

  case 1692:
/* Line 1787 of yacc.c  */
#line 11198 "gram.y"
    { (yyval.node) = (Node *) makeA_Expr(AEXPR_OP, (yyvsp[(1) - (2)].list), NULL, (yyvsp[(2) - (2)].node), (yylsp[(1) - (2)])); }
    break;

  case 1693:
/* Line 1787 of yacc.c  */
#line 11200 "gram.y"
    { (yyval.node) = (Node *) makeA_Expr(AEXPR_OP, (yyvsp[(2) - (2)].list), (yyvsp[(1) - (2)].node), NULL, (yylsp[(2) - (2)])); }
    break;

  case 1694:
/* Line 1787 of yacc.c  */
#line 11202 "gram.y"
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_DISTINCT, "=", (yyvsp[(1) - (5)].node), (yyvsp[(5) - (5)].node), (yylsp[(2) - (5)]));
				}
    break;

  case 1695:
/* Line 1787 of yacc.c  */
#line 11206 "gram.y"
    {
					(yyval.node) = (Node *) makeA_Expr(AEXPR_NOT, NIL,
						NULL, (Node *) makeSimpleA_Expr(AEXPR_DISTINCT, "=", (yyvsp[(1) - (6)].node), (yyvsp[(6) - (6)].node), (yylsp[(2) - (6)])), (yylsp[(2) - (6)]));
				}
    break;

  case 1696:
/* Line 1787 of yacc.c  */
#line 11211 "gram.y"
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OF, "=", (yyvsp[(1) - (6)].node), (Node *) (yyvsp[(5) - (6)].list), (yylsp[(2) - (6)]));
				}
    break;

  case 1697:
/* Line 1787 of yacc.c  */
#line 11215 "gram.y"
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OF, "<>", (yyvsp[(1) - (7)].node), (Node *) (yyvsp[(6) - (7)].list), (yylsp[(2) - (7)]));
				}
    break;

  case 1698:
/* Line 1787 of yacc.c  */
#line 11219 "gram.y"
    {
					(yyval.node) = makeXmlExpr(IS_DOCUMENT, NULL, NIL,
									 list_make1((yyvsp[(1) - (3)].node)), (yylsp[(2) - (3)]));
				}
    break;

  case 1699:
/* Line 1787 of yacc.c  */
#line 11224 "gram.y"
    {
					(yyval.node) = (Node *) makeA_Expr(AEXPR_NOT, NIL, NULL,
											 makeXmlExpr(IS_DOCUMENT, NULL, NIL,
														 list_make1((yyvsp[(1) - (4)].node)), (yylsp[(2) - (4)])),
											 (yylsp[(2) - (4)]));
				}
    break;

  case 1700:
/* Line 1787 of yacc.c  */
#line 11240 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); }
    break;

  case 1701:
/* Line 1787 of yacc.c  */
#line 11241 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); }
    break;

  case 1702:
/* Line 1787 of yacc.c  */
#line 11243 "gram.y"
    {
					ParamRef *p = makeNode(ParamRef);
					p->number = (yyvsp[(1) - (2)].ival);
					p->location = (yylsp[(1) - (2)]);
					if ((yyvsp[(2) - (2)].list))
					{
						A_Indirection *n = makeNode(A_Indirection);
						n->arg = (Node *) p;
						n->indirection = check_indirection((yyvsp[(2) - (2)].list), yyscanner);
						(yyval.node) = (Node *) n;
					}
					else
						(yyval.node) = (Node *) p;
				}
    break;

  case 1703:
/* Line 1787 of yacc.c  */
#line 11258 "gram.y"
    {
					if ((yyvsp[(4) - (4)].list))
					{
						A_Indirection *n = makeNode(A_Indirection);
						n->arg = (yyvsp[(2) - (4)].node);
						n->indirection = check_indirection((yyvsp[(4) - (4)].list), yyscanner);
						(yyval.node) = (Node *)n;
					}
					else
						(yyval.node) = (yyvsp[(2) - (4)].node);
				}
    break;

  case 1704:
/* Line 1787 of yacc.c  */
#line 11270 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); }
    break;

  case 1705:
/* Line 1787 of yacc.c  */
#line 11272 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); }
    break;

  case 1706:
/* Line 1787 of yacc.c  */
#line 11274 "gram.y"
    {
					SubLink *n = makeNode(SubLink);
					n->subLinkType = EXPR_SUBLINK;
					n->testexpr = NULL;
					n->operName = NIL;
					n->subselect = (yyvsp[(1) - (1)].node);
					n->location = (yylsp[(1) - (1)]);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1707:
/* Line 1787 of yacc.c  */
#line 11284 "gram.y"
    {
					/*
					 * Because the select_with_parens nonterminal is designed
					 * to "eat" as many levels of parens as possible, the
					 * '(' a_expr ')' opt_indirection production above will
					 * fail to match a sub-SELECT with indirection decoration;
					 * the sub-SELECT won't be regarded as an a_expr as long
					 * as there are parens around it.  To support applying
					 * subscripting or field selection to a sub-SELECT result,
					 * we need this redundant-looking production.
					 */
					SubLink *n = makeNode(SubLink);
					A_Indirection *a = makeNode(A_Indirection);
					n->subLinkType = EXPR_SUBLINK;
					n->testexpr = NULL;
					n->operName = NIL;
					n->subselect = (yyvsp[(1) - (2)].node);
					n->location = (yylsp[(1) - (2)]);
					a->arg = (Node *)n;
					a->indirection = check_indirection((yyvsp[(2) - (2)].list), yyscanner);
					(yyval.node) = (Node *)a;
				}
    break;

  case 1708:
/* Line 1787 of yacc.c  */
#line 11307 "gram.y"
    {
					SubLink *n = makeNode(SubLink);
					n->subLinkType = EXISTS_SUBLINK;
					n->testexpr = NULL;
					n->operName = NIL;
					n->subselect = (yyvsp[(2) - (2)].node);
					n->location = (yylsp[(1) - (2)]);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1709:
/* Line 1787 of yacc.c  */
#line 11317 "gram.y"
    {
					SubLink *n = makeNode(SubLink);
					n->subLinkType = ARRAY_SUBLINK;
					n->testexpr = NULL;
					n->operName = NIL;
					n->subselect = (yyvsp[(2) - (2)].node);
					n->location = (yylsp[(1) - (2)]);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1710:
/* Line 1787 of yacc.c  */
#line 11327 "gram.y"
    {
					A_ArrayExpr *n = (A_ArrayExpr *) (yyvsp[(2) - (2)].node);
					Assert(IsA(n, A_ArrayExpr));
					/* point outermost A_ArrayExpr to the ARRAY keyword */
					n->location = (yylsp[(1) - (2)]);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1711:
/* Line 1787 of yacc.c  */
#line 11335 "gram.y"
    {
					RowExpr *r = makeNode(RowExpr);
					r->args = (yyvsp[(1) - (1)].list);
					r->row_typeid = InvalidOid;	/* not analyzed yet */
					r->colnames = NIL;	/* to be filled in during analysis */
					r->location = (yylsp[(1) - (1)]);
					(yyval.node) = (Node *)r;
				}
    break;

  case 1712:
/* Line 1787 of yacc.c  */
#line 11346 "gram.y"
    {
					(yyval.node) = (Node *) makeFuncCall((yyvsp[(1) - (3)].list), NIL, (yylsp[(1) - (3)]));
				}
    break;

  case 1713:
/* Line 1787 of yacc.c  */
#line 11350 "gram.y"
    {
					FuncCall *n = makeFuncCall((yyvsp[(1) - (5)].list), (yyvsp[(3) - (5)].list), (yylsp[(1) - (5)]));
					n->agg_order = (yyvsp[(4) - (5)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1714:
/* Line 1787 of yacc.c  */
#line 11356 "gram.y"
    {
					FuncCall *n = makeFuncCall((yyvsp[(1) - (6)].list), list_make1((yyvsp[(4) - (6)].node)), (yylsp[(1) - (6)]));
					n->func_variadic = TRUE;
					n->agg_order = (yyvsp[(5) - (6)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1715:
/* Line 1787 of yacc.c  */
#line 11363 "gram.y"
    {
					FuncCall *n = makeFuncCall((yyvsp[(1) - (8)].list), lappend((yyvsp[(3) - (8)].list), (yyvsp[(6) - (8)].node)), (yylsp[(1) - (8)]));
					n->func_variadic = TRUE;
					n->agg_order = (yyvsp[(7) - (8)].list);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1716:
/* Line 1787 of yacc.c  */
#line 11370 "gram.y"
    {
					FuncCall *n = makeFuncCall((yyvsp[(1) - (6)].list), (yyvsp[(4) - (6)].list), (yylsp[(1) - (6)]));
					n->agg_order = (yyvsp[(5) - (6)].list);
					/* Ideally we'd mark the FuncCall node to indicate
					 * "must be an aggregate", but there's no provision
					 * for that in FuncCall at the moment.
					 */
					(yyval.node) = (Node *)n;
				}
    break;

  case 1717:
/* Line 1787 of yacc.c  */
#line 11380 "gram.y"
    {
					FuncCall *n = makeFuncCall((yyvsp[(1) - (6)].list), (yyvsp[(4) - (6)].list), (yylsp[(1) - (6)]));
					n->agg_order = (yyvsp[(5) - (6)].list);
					n->agg_distinct = TRUE;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1718:
/* Line 1787 of yacc.c  */
#line 11387 "gram.y"
    {
					/*
					 * We consider AGGREGATE(*) to invoke a parameterless
					 * aggregate.  This does the right thing for COUNT(*),
					 * and there are no other aggregates in SQL that accept
					 * '*' as parameter.
					 *
					 * The FuncCall node is also marked agg_star = true,
					 * so that later processing can detect what the argument
					 * really was.
					 */
					FuncCall *n = makeFuncCall((yyvsp[(1) - (4)].list), NIL, (yylsp[(1) - (4)]));
					n->agg_star = TRUE;
					(yyval.node) = (Node *)n;
				}
    break;

  case 1719:
/* Line 1787 of yacc.c  */
#line 11415 "gram.y"
    {
					FuncCall *n = (FuncCall *) (yyvsp[(1) - (4)].node);
					/*
					 * The order clause for WITHIN GROUP and the one for
					 * plain-aggregate ORDER BY share a field, so we have to
					 * check here that at most one is present.  We also check
					 * for DISTINCT and VARIADIC here to give a better error
					 * location.  Other consistency checks are deferred to
					 * parse analysis.
					 */
					if ((yyvsp[(2) - (4)].list) != NIL)
					{
						if (n->agg_order != NIL)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("cannot use multiple ORDER BY clauses with WITHIN GROUP"),
									 parser_errposition((yylsp[(2) - (4)]))));
						if (n->agg_distinct)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("cannot use DISTINCT with WITHIN GROUP"),
									 parser_errposition((yylsp[(2) - (4)]))));
						if (n->func_variadic)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("cannot use VARIADIC with WITHIN GROUP"),
									 parser_errposition((yylsp[(2) - (4)]))));
						n->agg_order = (yyvsp[(2) - (4)].list);
						n->agg_within_group = TRUE;
					}
					n->agg_filter = (yyvsp[(3) - (4)].node);
					n->over = (yyvsp[(4) - (4)].windef);
					(yyval.node) = (Node *) n;
				}
    break;

  case 1720:
/* Line 1787 of yacc.c  */
#line 11450 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); }
    break;

  case 1721:
/* Line 1787 of yacc.c  */
#line 11460 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); }
    break;

  case 1722:
/* Line 1787 of yacc.c  */
#line 11461 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); }
    break;

  case 1723:
/* Line 1787 of yacc.c  */
#line 11469 "gram.y"
    {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("pg_collation_for"),
											   list_make1((yyvsp[(4) - (5)].node)),
											   (yylsp[(1) - (5)]));
				}
    break;

  case 1724:
/* Line 1787 of yacc.c  */
#line 11475 "gram.y"
    {
					/*
					 * Translate as "'now'::text::date".
					 *
					 * We cannot use "'now'::date" because coerce_type() will
					 * immediately reduce that to a constant representing
					 * today's date.  We need to delay the conversion until
					 * runtime, else the wrong things will happen when
					 * CURRENT_DATE is used in a column default value or rule.
					 *
					 * This could be simplified if we had a way to generate
					 * an expression tree representing runtime application
					 * of type-input conversion functions.  (As of PG 7.3
					 * that is actually possible, but not clear that we want
					 * to rely on it.)
					 *
					 * The token location is attached to the run-time
					 * typecast, not to the Const, for the convenience of
					 * pg_stat_statements (which doesn't want these constructs
					 * to appear to be replaceable constants).
					 */
					Node *n;
					n = makeStringConstCast("now", -1, SystemTypeName("text"));
					(yyval.node) = makeTypeCast(n, SystemTypeName("date"), (yylsp[(1) - (1)]));
				}
    break;

  case 1725:
/* Line 1787 of yacc.c  */
#line 11501 "gram.y"
    {
					/*
					 * Translate as "'now'::text::timetz".
					 * See comments for CURRENT_DATE.
					 */
					Node *n;
					n = makeStringConstCast("now", -1, SystemTypeName("text"));
					(yyval.node) = makeTypeCast(n, SystemTypeName("timetz"), (yylsp[(1) - (1)]));
				}
    break;

  case 1726:
/* Line 1787 of yacc.c  */
#line 11511 "gram.y"
    {
					/*
					 * Translate as "'now'::text::timetz(n)".
					 * See comments for CURRENT_DATE.
					 */
					Node *n;
					TypeName *d;
					n = makeStringConstCast("now", -1, SystemTypeName("text"));
					d = SystemTypeName("timetz");
					d->typmods = list_make1(makeIntConst((yyvsp[(3) - (4)].ival), (yylsp[(3) - (4)])));
					(yyval.node) = makeTypeCast(n, d, (yylsp[(1) - (4)]));
				}
    break;

  case 1727:
/* Line 1787 of yacc.c  */
#line 11524 "gram.y"
    {
					/*
					 * Translate as "now()", since we have a function that
					 * does exactly what is needed.
					 */
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("now"), NIL, (yylsp[(1) - (1)]));
				}
    break;

  case 1728:
/* Line 1787 of yacc.c  */
#line 11532 "gram.y"
    {
					/*
					 * Translate as "'now'::text::timestamptz(n)".
					 * See comments for CURRENT_DATE.
					 */
					Node *n;
					TypeName *d;
					n = makeStringConstCast("now", -1, SystemTypeName("text"));
					d = SystemTypeName("timestamptz");
					d->typmods = list_make1(makeIntConst((yyvsp[(3) - (4)].ival), (yylsp[(3) - (4)])));
					(yyval.node) = makeTypeCast(n, d, (yylsp[(1) - (4)]));
				}
    break;

  case 1729:
/* Line 1787 of yacc.c  */
#line 11545 "gram.y"
    {
					/*
					 * Translate as "'now'::text::time".
					 * See comments for CURRENT_DATE.
					 */
					Node *n;
					n = makeStringConstCast("now", -1, SystemTypeName("text"));
					(yyval.node) = makeTypeCast((Node *)n, SystemTypeName("time"), (yylsp[(1) - (1)]));
				}
    break;

  case 1730:
/* Line 1787 of yacc.c  */
#line 11555 "gram.y"
    {
					/*
					 * Translate as "'now'::text::time(n)".
					 * See comments for CURRENT_DATE.
					 */
					Node *n;
					TypeName *d;
					n = makeStringConstCast("now", -1, SystemTypeName("text"));
					d = SystemTypeName("time");
					d->typmods = list_make1(makeIntConst((yyvsp[(3) - (4)].ival), (yylsp[(3) - (4)])));
					(yyval.node) = makeTypeCast((Node *)n, d, (yylsp[(1) - (4)]));
				}
    break;

  case 1731:
/* Line 1787 of yacc.c  */
#line 11568 "gram.y"
    {
					/*
					 * Translate as "'now'::text::timestamp".
					 * See comments for CURRENT_DATE.
					 */
					Node *n;
					n = makeStringConstCast("now", -1, SystemTypeName("text"));
					(yyval.node) = makeTypeCast(n, SystemTypeName("timestamp"), (yylsp[(1) - (1)]));
				}
    break;

  case 1732:
/* Line 1787 of yacc.c  */
#line 11578 "gram.y"
    {
					/*
					 * Translate as "'now'::text::timestamp(n)".
					 * See comments for CURRENT_DATE.
					 */
					Node *n;
					TypeName *d;
					n = makeStringConstCast("now", -1, SystemTypeName("text"));
					d = SystemTypeName("timestamp");
					d->typmods = list_make1(makeIntConst((yyvsp[(3) - (4)].ival), (yylsp[(3) - (4)])));
					(yyval.node) = makeTypeCast(n, d, (yylsp[(1) - (4)]));
				}
    break;

  case 1733:
/* Line 1787 of yacc.c  */
#line 11591 "gram.y"
    {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("current_user"), NIL, (yylsp[(1) - (1)]));
				}
    break;

  case 1734:
/* Line 1787 of yacc.c  */
#line 11595 "gram.y"
    {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("current_user"), NIL, (yylsp[(1) - (1)]));
				}
    break;

  case 1735:
/* Line 1787 of yacc.c  */
#line 11599 "gram.y"
    {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("session_user"), NIL, (yylsp[(1) - (1)]));
				}
    break;

  case 1736:
/* Line 1787 of yacc.c  */
#line 11603 "gram.y"
    {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("current_user"), NIL, (yylsp[(1) - (1)]));
				}
    break;

  case 1737:
/* Line 1787 of yacc.c  */
#line 11607 "gram.y"
    {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("current_database"), NIL, (yylsp[(1) - (1)]));
				}
    break;

  case 1738:
/* Line 1787 of yacc.c  */
#line 11611 "gram.y"
    {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("current_schema"), NIL, (yylsp[(1) - (1)]));
				}
    break;

  case 1739:
/* Line 1787 of yacc.c  */
#line 11615 "gram.y"
    { (yyval.node) = makeTypeCast((yyvsp[(3) - (6)].node), (yyvsp[(5) - (6)].typnam), (yylsp[(1) - (6)])); }
    break;

  case 1740:
/* Line 1787 of yacc.c  */
#line 11617 "gram.y"
    {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("date_part"), (yyvsp[(3) - (4)].list), (yylsp[(1) - (4)]));
				}
    break;

  case 1741:
/* Line 1787 of yacc.c  */
#line 11621 "gram.y"
    {
					/* overlay(A PLACING B FROM C FOR D) is converted to
					 * overlay(A, B, C, D)
					 * overlay(A PLACING B FROM C) is converted to
					 * overlay(A, B, C)
					 */
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("overlay"), (yyvsp[(3) - (4)].list), (yylsp[(1) - (4)]));
				}
    break;

  case 1742:
/* Line 1787 of yacc.c  */
#line 11630 "gram.y"
    {
					/* position(A in B) is converted to position(B, A) */
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("position"), (yyvsp[(3) - (4)].list), (yylsp[(1) - (4)]));
				}
    break;

  case 1743:
/* Line 1787 of yacc.c  */
#line 11635 "gram.y"
    {
					/* substring(A from B for C) is converted to
					 * substring(A, B, C) - thomas 2000-11-28
					 */
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("substring"), (yyvsp[(3) - (4)].list), (yylsp[(1) - (4)]));
				}
    break;

  case 1744:
/* Line 1787 of yacc.c  */
#line 11642 "gram.y"
    {
					/* TREAT(expr AS target) converts expr of a particular type to target,
					 * which is defined to be a subtype of the original expression.
					 * In SQL99, this is intended for use with structured UDTs,
					 * but let's make this a generally useful form allowing stronger
					 * coercions than are handled by implicit casting.
					 *
					 * Convert SystemTypeName() to SystemFuncName() even though
					 * at the moment they result in the same thing.
					 */
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName(((Value *)llast((yyvsp[(5) - (6)].typnam)->names))->val.str),
												list_make1((yyvsp[(3) - (6)].node)),
												(yylsp[(1) - (6)]));
				}
    break;

  case 1745:
/* Line 1787 of yacc.c  */
#line 11657 "gram.y"
    {
					/* various trim expressions are defined in SQL
					 * - thomas 1997-07-19
					 */
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("btrim"), (yyvsp[(4) - (5)].list), (yylsp[(1) - (5)]));
				}
    break;

  case 1746:
/* Line 1787 of yacc.c  */
#line 11664 "gram.y"
    {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("ltrim"), (yyvsp[(4) - (5)].list), (yylsp[(1) - (5)]));
				}
    break;

  case 1747:
/* Line 1787 of yacc.c  */
#line 11668 "gram.y"
    {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("rtrim"), (yyvsp[(4) - (5)].list), (yylsp[(1) - (5)]));
				}
    break;

  case 1748:
/* Line 1787 of yacc.c  */
#line 11672 "gram.y"
    {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("btrim"), (yyvsp[(3) - (4)].list), (yylsp[(1) - (4)]));
				}
    break;

  case 1749:
/* Line 1787 of yacc.c  */
#line 11676 "gram.y"
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_NULLIF, "=", (yyvsp[(3) - (6)].node), (yyvsp[(5) - (6)].node), (yylsp[(1) - (6)]));
				}
    break;

  case 1750:
/* Line 1787 of yacc.c  */
#line 11680 "gram.y"
    {
					CoalesceExpr *c = makeNode(CoalesceExpr);
					c->args = (yyvsp[(3) - (4)].list);
					c->location = (yylsp[(1) - (4)]);
					(yyval.node) = (Node *)c;
				}
    break;

  case 1751:
/* Line 1787 of yacc.c  */
#line 11687 "gram.y"
    {
					MinMaxExpr *v = makeNode(MinMaxExpr);
					v->args = (yyvsp[(3) - (4)].list);
					v->op = IS_GREATEST;
					v->location = (yylsp[(1) - (4)]);
					(yyval.node) = (Node *)v;
				}
    break;

  case 1752:
/* Line 1787 of yacc.c  */
#line 11695 "gram.y"
    {
					MinMaxExpr *v = makeNode(MinMaxExpr);
					v->args = (yyvsp[(3) - (4)].list);
					v->op = IS_LEAST;
					v->location = (yylsp[(1) - (4)]);
					(yyval.node) = (Node *)v;
				}
    break;

  case 1753:
/* Line 1787 of yacc.c  */
#line 11703 "gram.y"
    {
					(yyval.node) = makeXmlExpr(IS_XMLCONCAT, NULL, NIL, (yyvsp[(3) - (4)].list), (yylsp[(1) - (4)]));
				}
    break;

  case 1754:
/* Line 1787 of yacc.c  */
#line 11707 "gram.y"
    {
					(yyval.node) = makeXmlExpr(IS_XMLELEMENT, (yyvsp[(4) - (5)].str), NIL, NIL, (yylsp[(1) - (5)]));
				}
    break;

  case 1755:
/* Line 1787 of yacc.c  */
#line 11711 "gram.y"
    {
					(yyval.node) = makeXmlExpr(IS_XMLELEMENT, (yyvsp[(4) - (7)].str), (yyvsp[(6) - (7)].list), NIL, (yylsp[(1) - (7)]));
				}
    break;

  case 1756:
/* Line 1787 of yacc.c  */
#line 11715 "gram.y"
    {
					(yyval.node) = makeXmlExpr(IS_XMLELEMENT, (yyvsp[(4) - (7)].str), NIL, (yyvsp[(6) - (7)].list), (yylsp[(1) - (7)]));
				}
    break;

  case 1757:
/* Line 1787 of yacc.c  */
#line 11719 "gram.y"
    {
					(yyval.node) = makeXmlExpr(IS_XMLELEMENT, (yyvsp[(4) - (9)].str), (yyvsp[(6) - (9)].list), (yyvsp[(8) - (9)].list), (yylsp[(1) - (9)]));
				}
    break;

  case 1758:
/* Line 1787 of yacc.c  */
#line 11723 "gram.y"
    {
					/* xmlexists(A PASSING [BY REF] B [BY REF]) is
					 * converted to xmlexists(A, B)*/
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("xmlexists"), list_make2((yyvsp[(3) - (5)].node), (yyvsp[(4) - (5)].node)), (yylsp[(1) - (5)]));
				}
    break;

  case 1759:
/* Line 1787 of yacc.c  */
#line 11729 "gram.y"
    {
					(yyval.node) = makeXmlExpr(IS_XMLFOREST, NULL, (yyvsp[(3) - (4)].list), NIL, (yylsp[(1) - (4)]));
				}
    break;

  case 1760:
/* Line 1787 of yacc.c  */
#line 11733 "gram.y"
    {
					XmlExpr *x = (XmlExpr *)
						makeXmlExpr(IS_XMLPARSE, NULL, NIL,
									list_make2((yyvsp[(4) - (6)].node), makeBoolAConst((yyvsp[(5) - (6)].boolean), -1)),
									(yylsp[(1) - (6)]));
					x->xmloption = (yyvsp[(3) - (6)].ival);
					(yyval.node) = (Node *)x;
				}
    break;

  case 1761:
/* Line 1787 of yacc.c  */
#line 11742 "gram.y"
    {
					(yyval.node) = makeXmlExpr(IS_XMLPI, (yyvsp[(4) - (5)].str), NULL, NIL, (yylsp[(1) - (5)]));
				}
    break;

  case 1762:
/* Line 1787 of yacc.c  */
#line 11746 "gram.y"
    {
					(yyval.node) = makeXmlExpr(IS_XMLPI, (yyvsp[(4) - (7)].str), NULL, list_make1((yyvsp[(6) - (7)].node)), (yylsp[(1) - (7)]));
				}
    break;

  case 1763:
/* Line 1787 of yacc.c  */
#line 11750 "gram.y"
    {
					(yyval.node) = makeXmlExpr(IS_XMLROOT, NULL, NIL,
									 list_make3((yyvsp[(3) - (7)].node), (yyvsp[(5) - (7)].node), (yyvsp[(6) - (7)].node)), (yylsp[(1) - (7)]));
				}
    break;

  case 1764:
/* Line 1787 of yacc.c  */
#line 11755 "gram.y"
    {
					XmlSerialize *n = makeNode(XmlSerialize);
					n->xmloption = (yyvsp[(3) - (7)].ival);
					n->expr = (yyvsp[(4) - (7)].node);
					n->typeName = (yyvsp[(6) - (7)].typnam);
					n->location = (yylsp[(1) - (7)]);
					(yyval.node) = (Node *)n;
				}
    break;

  case 1765:
/* Line 1787 of yacc.c  */
#line 11769 "gram.y"
    { (yyval.node) = (yyvsp[(2) - (2)].node); }
    break;

  case 1766:
/* Line 1787 of yacc.c  */
#line 11771 "gram.y"
    { (yyval.node) = makeNullAConst(-1); }
    break;

  case 1767:
/* Line 1787 of yacc.c  */
#line 11775 "gram.y"
    { (yyval.node) = makeIntConst(XML_STANDALONE_YES, -1); }
    break;

  case 1768:
/* Line 1787 of yacc.c  */
#line 11777 "gram.y"
    { (yyval.node) = makeIntConst(XML_STANDALONE_NO, -1); }
    break;

  case 1769:
/* Line 1787 of yacc.c  */
#line 11779 "gram.y"
    { (yyval.node) = makeIntConst(XML_STANDALONE_NO_VALUE, -1); }
    break;

  case 1770:
/* Line 1787 of yacc.c  */
#line 11781 "gram.y"
    { (yyval.node) = makeIntConst(XML_STANDALONE_OMITTED, -1); }
    break;

  case 1771:
/* Line 1787 of yacc.c  */
#line 11784 "gram.y"
    { (yyval.list) = (yyvsp[(3) - (4)].list); }
    break;

  case 1772:
/* Line 1787 of yacc.c  */
#line 11787 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].target)); }
    break;

  case 1773:
/* Line 1787 of yacc.c  */
#line 11788 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].target)); }
    break;

  case 1774:
/* Line 1787 of yacc.c  */
#line 11792 "gram.y"
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = (yyvsp[(3) - (3)].str);
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (Node *) (yyvsp[(1) - (3)].node);
					(yyval.target)->location = (yylsp[(1) - (3)]);
				}
    break;

  case 1775:
/* Line 1787 of yacc.c  */
#line 11800 "gram.y"
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = NULL;
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (Node *) (yyvsp[(1) - (1)].node);
					(yyval.target)->location = (yylsp[(1) - (1)]);
				}
    break;

  case 1776:
/* Line 1787 of yacc.c  */
#line 11809 "gram.y"
    { (yyval.ival) = XMLOPTION_DOCUMENT; }
    break;

  case 1777:
/* Line 1787 of yacc.c  */
#line 11810 "gram.y"
    { (yyval.ival) = XMLOPTION_CONTENT; }
    break;

  case 1778:
/* Line 1787 of yacc.c  */
#line 11813 "gram.y"
    { (yyval.boolean) = TRUE; }
    break;

  case 1779:
/* Line 1787 of yacc.c  */
#line 11814 "gram.y"
    { (yyval.boolean) = FALSE; }
    break;

  case 1780:
/* Line 1787 of yacc.c  */
#line 11815 "gram.y"
    { (yyval.boolean) = FALSE; }
    break;

  case 1781:
/* Line 1787 of yacc.c  */
#line 11821 "gram.y"
    {
					(yyval.node) = (yyvsp[(2) - (2)].node);
				}
    break;

  case 1782:
/* Line 1787 of yacc.c  */
#line 11825 "gram.y"
    {
					(yyval.node) = (yyvsp[(2) - (4)].node);
				}
    break;

  case 1783:
/* Line 1787 of yacc.c  */
#line 11829 "gram.y"
    {
					(yyval.node) = (yyvsp[(4) - (4)].node);
				}
    break;

  case 1784:
/* Line 1787 of yacc.c  */
#line 11833 "gram.y"
    {
					(yyval.node) = (yyvsp[(4) - (6)].node);
				}
    break;

  case 1785:
/* Line 1787 of yacc.c  */
#line 11843 "gram.y"
    { (yyval.list) = (yyvsp[(4) - (5)].list); }
    break;

  case 1786:
/* Line 1787 of yacc.c  */
#line 11844 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 1787:
/* Line 1787 of yacc.c  */
#line 11848 "gram.y"
    { (yyval.node) = (yyvsp[(4) - (5)].node); }
    break;

  case 1788:
/* Line 1787 of yacc.c  */
#line 11849 "gram.y"
    { (yyval.node) = NULL; }
    break;

  case 1789:
/* Line 1787 of yacc.c  */
#line 11857 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (2)].list); }
    break;

  case 1790:
/* Line 1787 of yacc.c  */
#line 11858 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 1791:
/* Line 1787 of yacc.c  */
#line 11862 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].windef)); }
    break;

  case 1792:
/* Line 1787 of yacc.c  */
#line 11864 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].windef)); }
    break;

  case 1793:
/* Line 1787 of yacc.c  */
#line 11869 "gram.y"
    {
					WindowDef *n = (yyvsp[(3) - (3)].windef);
					n->name = (yyvsp[(1) - (3)].str);
					(yyval.windef) = n;
				}
    break;

  case 1794:
/* Line 1787 of yacc.c  */
#line 11877 "gram.y"
    { (yyval.windef) = (yyvsp[(2) - (2)].windef); }
    break;

  case 1795:
/* Line 1787 of yacc.c  */
#line 11879 "gram.y"
    {
					WindowDef *n = makeNode(WindowDef);
					n->name = (yyvsp[(2) - (2)].str);
					n->refname = NULL;
					n->partitionClause = NIL;
					n->orderClause = NIL;
					n->frameOptions = FRAMEOPTION_DEFAULTS;
					n->startOffset = NULL;
					n->endOffset = NULL;
					n->location = (yylsp[(2) - (2)]);
					(yyval.windef) = n;
				}
    break;

  case 1796:
/* Line 1787 of yacc.c  */
#line 11892 "gram.y"
    { (yyval.windef) = NULL; }
    break;

  case 1797:
/* Line 1787 of yacc.c  */
#line 11897 "gram.y"
    {
					WindowDef *n = makeNode(WindowDef);
					n->name = NULL;
					n->refname = (yyvsp[(2) - (6)].str);
					n->partitionClause = (yyvsp[(3) - (6)].list);
					n->orderClause = (yyvsp[(4) - (6)].list);
					/* copy relevant fields of opt_frame_clause */
					n->frameOptions = (yyvsp[(5) - (6)].windef)->frameOptions;
					n->startOffset = (yyvsp[(5) - (6)].windef)->startOffset;
					n->endOffset = (yyvsp[(5) - (6)].windef)->endOffset;
					n->location = (yylsp[(1) - (6)]);
					(yyval.windef) = n;
				}
    break;

  case 1798:
/* Line 1787 of yacc.c  */
#line 11922 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); }
    break;

  case 1799:
/* Line 1787 of yacc.c  */
#line 11923 "gram.y"
    { (yyval.str) = NULL; }
    break;

  case 1800:
/* Line 1787 of yacc.c  */
#line 11926 "gram.y"
    { (yyval.list) = (yyvsp[(3) - (3)].list); }
    break;

  case 1801:
/* Line 1787 of yacc.c  */
#line 11927 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 1802:
/* Line 1787 of yacc.c  */
#line 11939 "gram.y"
    {
					WindowDef *n = (yyvsp[(2) - (2)].windef);
					n->frameOptions |= FRAMEOPTION_NONDEFAULT | FRAMEOPTION_RANGE;
					if (n->frameOptions & (FRAMEOPTION_START_VALUE_PRECEDING |
										   FRAMEOPTION_END_VALUE_PRECEDING))
						ereport(ERROR,
								(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
								 errmsg("RANGE PRECEDING is only supported with UNBOUNDED"),
								 parser_errposition((yylsp[(1) - (2)]))));
					if (n->frameOptions & (FRAMEOPTION_START_VALUE_FOLLOWING |
										   FRAMEOPTION_END_VALUE_FOLLOWING))
						ereport(ERROR,
								(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
								 errmsg("RANGE FOLLOWING is only supported with UNBOUNDED"),
								 parser_errposition((yylsp[(1) - (2)]))));
					(yyval.windef) = n;
				}
    break;

  case 1803:
/* Line 1787 of yacc.c  */
#line 11957 "gram.y"
    {
					WindowDef *n = (yyvsp[(2) - (2)].windef);
					n->frameOptions |= FRAMEOPTION_NONDEFAULT | FRAMEOPTION_ROWS;
					(yyval.windef) = n;
				}
    break;

  case 1804:
/* Line 1787 of yacc.c  */
#line 11963 "gram.y"
    {
					WindowDef *n = makeNode(WindowDef);
					n->frameOptions = FRAMEOPTION_DEFAULTS;
					n->startOffset = NULL;
					n->endOffset = NULL;
					(yyval.windef) = n;
				}
    break;

  case 1805:
/* Line 1787 of yacc.c  */
#line 11973 "gram.y"
    {
					WindowDef *n = (yyvsp[(1) - (1)].windef);
					/* reject invalid cases */
					if (n->frameOptions & FRAMEOPTION_START_UNBOUNDED_FOLLOWING)
						ereport(ERROR,
								(errcode(ERRCODE_WINDOWING_ERROR),
								 errmsg("frame start cannot be UNBOUNDED FOLLOWING"),
								 parser_errposition((yylsp[(1) - (1)]))));
					if (n->frameOptions & FRAMEOPTION_START_VALUE_FOLLOWING)
						ereport(ERROR,
								(errcode(ERRCODE_WINDOWING_ERROR),
								 errmsg("frame starting from following row cannot end with current row"),
								 parser_errposition((yylsp[(1) - (1)]))));
					n->frameOptions |= FRAMEOPTION_END_CURRENT_ROW;
					(yyval.windef) = n;
				}
    break;

  case 1806:
/* Line 1787 of yacc.c  */
#line 11990 "gram.y"
    {
					WindowDef *n1 = (yyvsp[(2) - (4)].windef);
					WindowDef *n2 = (yyvsp[(4) - (4)].windef);
					/* form merged options */
					int		frameOptions = n1->frameOptions;
					/* shift converts START_ options to END_ options */
					frameOptions |= n2->frameOptions << 1;
					frameOptions |= FRAMEOPTION_BETWEEN;
					/* reject invalid cases */
					if (frameOptions & FRAMEOPTION_START_UNBOUNDED_FOLLOWING)
						ereport(ERROR,
								(errcode(ERRCODE_WINDOWING_ERROR),
								 errmsg("frame start cannot be UNBOUNDED FOLLOWING"),
								 parser_errposition((yylsp[(2) - (4)]))));
					if (frameOptions & FRAMEOPTION_END_UNBOUNDED_PRECEDING)
						ereport(ERROR,
								(errcode(ERRCODE_WINDOWING_ERROR),
								 errmsg("frame end cannot be UNBOUNDED PRECEDING"),
								 parser_errposition((yylsp[(4) - (4)]))));
					if ((frameOptions & FRAMEOPTION_START_CURRENT_ROW) &&
						(frameOptions & FRAMEOPTION_END_VALUE_PRECEDING))
						ereport(ERROR,
								(errcode(ERRCODE_WINDOWING_ERROR),
								 errmsg("frame starting from current row cannot have preceding rows"),
								 parser_errposition((yylsp[(4) - (4)]))));
					if ((frameOptions & FRAMEOPTION_START_VALUE_FOLLOWING) &&
						(frameOptions & (FRAMEOPTION_END_VALUE_PRECEDING |
										 FRAMEOPTION_END_CURRENT_ROW)))
						ereport(ERROR,
								(errcode(ERRCODE_WINDOWING_ERROR),
								 errmsg("frame starting from following row cannot have preceding rows"),
								 parser_errposition((yylsp[(4) - (4)]))));
					n1->frameOptions = frameOptions;
					n1->endOffset = n2->startOffset;
					(yyval.windef) = n1;
				}
    break;

  case 1807:
/* Line 1787 of yacc.c  */
#line 12035 "gram.y"
    {
					WindowDef *n = makeNode(WindowDef);
					n->frameOptions = FRAMEOPTION_START_UNBOUNDED_PRECEDING;
					n->startOffset = NULL;
					n->endOffset = NULL;
					(yyval.windef) = n;
				}
    break;

  case 1808:
/* Line 1787 of yacc.c  */
#line 12043 "gram.y"
    {
					WindowDef *n = makeNode(WindowDef);
					n->frameOptions = FRAMEOPTION_START_UNBOUNDED_FOLLOWING;
					n->startOffset = NULL;
					n->endOffset = NULL;
					(yyval.windef) = n;
				}
    break;

  case 1809:
/* Line 1787 of yacc.c  */
#line 12051 "gram.y"
    {
					WindowDef *n = makeNode(WindowDef);
					n->frameOptions = FRAMEOPTION_START_CURRENT_ROW;
					n->startOffset = NULL;
					n->endOffset = NULL;
					(yyval.windef) = n;
				}
    break;

  case 1810:
/* Line 1787 of yacc.c  */
#line 12059 "gram.y"
    {
					WindowDef *n = makeNode(WindowDef);
					n->frameOptions = FRAMEOPTION_START_VALUE_PRECEDING;
					n->startOffset = (yyvsp[(1) - (2)].node);
					n->endOffset = NULL;
					(yyval.windef) = n;
				}
    break;

  case 1811:
/* Line 1787 of yacc.c  */
#line 12067 "gram.y"
    {
					WindowDef *n = makeNode(WindowDef);
					n->frameOptions = FRAMEOPTION_START_VALUE_FOLLOWING;
					n->startOffset = (yyvsp[(1) - (2)].node);
					n->endOffset = NULL;
					(yyval.windef) = n;
				}
    break;

  case 1812:
/* Line 1787 of yacc.c  */
#line 12087 "gram.y"
    { (yyval.list) = (yyvsp[(3) - (4)].list); }
    break;

  case 1813:
/* Line 1787 of yacc.c  */
#line 12088 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 1814:
/* Line 1787 of yacc.c  */
#line 12089 "gram.y"
    { (yyval.list) = lappend((yyvsp[(2) - (5)].list), (yyvsp[(4) - (5)].node)); }
    break;

  case 1815:
/* Line 1787 of yacc.c  */
#line 12092 "gram.y"
    { (yyval.ival) = ANY_SUBLINK; }
    break;

  case 1816:
/* Line 1787 of yacc.c  */
#line 12093 "gram.y"
    { (yyval.ival) = ANY_SUBLINK; }
    break;

  case 1817:
/* Line 1787 of yacc.c  */
#line 12094 "gram.y"
    { (yyval.ival) = ALL_SUBLINK; }
    break;

  case 1818:
/* Line 1787 of yacc.c  */
#line 12097 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); }
    break;

  case 1819:
/* Line 1787 of yacc.c  */
#line 12098 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); }
    break;

  case 1820:
/* Line 1787 of yacc.c  */
#line 12101 "gram.y"
    { (yyval.str) = "+"; }
    break;

  case 1821:
/* Line 1787 of yacc.c  */
#line 12102 "gram.y"
    { (yyval.str) = "-"; }
    break;

  case 1822:
/* Line 1787 of yacc.c  */
#line 12103 "gram.y"
    { (yyval.str) = "*"; }
    break;

  case 1823:
/* Line 1787 of yacc.c  */
#line 12104 "gram.y"
    { (yyval.str) = "/"; }
    break;

  case 1824:
/* Line 1787 of yacc.c  */
#line 12105 "gram.y"
    { (yyval.str) = "%"; }
    break;

  case 1825:
/* Line 1787 of yacc.c  */
#line 12106 "gram.y"
    { (yyval.str) = "^"; }
    break;

  case 1826:
/* Line 1787 of yacc.c  */
#line 12107 "gram.y"
    { (yyval.str) = "<"; }
    break;

  case 1827:
/* Line 1787 of yacc.c  */
#line 12108 "gram.y"
    { (yyval.str) = ">"; }
    break;

  case 1828:
/* Line 1787 of yacc.c  */
#line 12109 "gram.y"
    { (yyval.str) = "="; }
    break;

  case 1829:
/* Line 1787 of yacc.c  */
#line 12113 "gram.y"
    { (yyval.list) = list_make1(makeString((yyvsp[(1) - (1)].str))); }
    break;

  case 1830:
/* Line 1787 of yacc.c  */
#line 12115 "gram.y"
    { (yyval.list) = (yyvsp[(3) - (4)].list); }
    break;

  case 1831:
/* Line 1787 of yacc.c  */
#line 12120 "gram.y"
    { (yyval.list) = list_make1(makeString((yyvsp[(1) - (1)].str))); }
    break;

  case 1832:
/* Line 1787 of yacc.c  */
#line 12122 "gram.y"
    { (yyval.list) = (yyvsp[(3) - (4)].list); }
    break;

  case 1833:
/* Line 1787 of yacc.c  */
#line 12127 "gram.y"
    { (yyval.list) = list_make1(makeString((yyvsp[(1) - (1)].str))); }
    break;

  case 1834:
/* Line 1787 of yacc.c  */
#line 12129 "gram.y"
    { (yyval.list) = (yyvsp[(3) - (4)].list); }
    break;

  case 1835:
/* Line 1787 of yacc.c  */
#line 12131 "gram.y"
    { (yyval.list) = list_make1(makeString("~~")); }
    break;

  case 1836:
/* Line 1787 of yacc.c  */
#line 12133 "gram.y"
    { (yyval.list) = list_make1(makeString("!~~")); }
    break;

  case 1837:
/* Line 1787 of yacc.c  */
#line 12135 "gram.y"
    { (yyval.list) = list_make1(makeString("~~*")); }
    break;

  case 1838:
/* Line 1787 of yacc.c  */
#line 12137 "gram.y"
    { (yyval.list) = list_make1(makeString("!~~*")); }
    break;

  case 1839:
/* Line 1787 of yacc.c  */
#line 12149 "gram.y"
    {
					(yyval.list) = list_make1((yyvsp[(1) - (1)].node));
				}
    break;

  case 1840:
/* Line 1787 of yacc.c  */
#line 12153 "gram.y"
    {
					(yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node));
				}
    break;

  case 1841:
/* Line 1787 of yacc.c  */
#line 12160 "gram.y"
    {
					(yyval.list) = list_make1((yyvsp[(1) - (1)].node));
				}
    break;

  case 1842:
/* Line 1787 of yacc.c  */
#line 12164 "gram.y"
    {
					(yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node));
				}
    break;

  case 1843:
/* Line 1787 of yacc.c  */
#line 12170 "gram.y"
    {
					(yyval.node) = (yyvsp[(1) - (1)].node);
				}
    break;

  case 1844:
/* Line 1787 of yacc.c  */
#line 12174 "gram.y"
    {
					NamedArgExpr *na = makeNode(NamedArgExpr);
					na->name = (yyvsp[(1) - (3)].str);
					na->arg = (Expr *) (yyvsp[(3) - (3)].node);
					na->argnumber = -1;		/* until determined */
					na->location = (yylsp[(1) - (3)]);
					(yyval.node) = (Node *) na;
				}
    break;

  case 1845:
/* Line 1787 of yacc.c  */
#line 12184 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].typnam)); }
    break;

  case 1846:
/* Line 1787 of yacc.c  */
#line 12185 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].typnam)); }
    break;

  case 1847:
/* Line 1787 of yacc.c  */
#line 12189 "gram.y"
    {
					(yyval.node) = makeAArrayExpr((yyvsp[(2) - (3)].list), (yylsp[(1) - (3)]));
				}
    break;

  case 1848:
/* Line 1787 of yacc.c  */
#line 12193 "gram.y"
    {
					(yyval.node) = makeAArrayExpr((yyvsp[(2) - (3)].list), (yylsp[(1) - (3)]));
				}
    break;

  case 1849:
/* Line 1787 of yacc.c  */
#line 12197 "gram.y"
    {
					(yyval.node) = makeAArrayExpr(NIL, (yylsp[(1) - (2)]));
				}
    break;

  case 1850:
/* Line 1787 of yacc.c  */
#line 12202 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].node)); }
    break;

  case 1851:
/* Line 1787 of yacc.c  */
#line 12203 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node)); }
    break;

  case 1852:
/* Line 1787 of yacc.c  */
#line 12209 "gram.y"
    {
					(yyval.list) = list_make2(makeStringConst((yyvsp[(1) - (3)].str), (yylsp[(1) - (3)])), (yyvsp[(3) - (3)].node));
				}
    break;

  case 1853:
/* Line 1787 of yacc.c  */
#line 12212 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 1854:
/* Line 1787 of yacc.c  */
#line 12219 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); }
    break;

  case 1855:
/* Line 1787 of yacc.c  */
#line 12220 "gram.y"
    { (yyval.str) = "year"; }
    break;

  case 1856:
/* Line 1787 of yacc.c  */
#line 12221 "gram.y"
    { (yyval.str) = "month"; }
    break;

  case 1857:
/* Line 1787 of yacc.c  */
#line 12222 "gram.y"
    { (yyval.str) = "day"; }
    break;

  case 1858:
/* Line 1787 of yacc.c  */
#line 12223 "gram.y"
    { (yyval.str) = "hour"; }
    break;

  case 1859:
/* Line 1787 of yacc.c  */
#line 12224 "gram.y"
    { (yyval.str) = "minute"; }
    break;

  case 1860:
/* Line 1787 of yacc.c  */
#line 12225 "gram.y"
    { (yyval.str) = "second"; }
    break;

  case 1861:
/* Line 1787 of yacc.c  */
#line 12226 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); }
    break;

  case 1862:
/* Line 1787 of yacc.c  */
#line 12237 "gram.y"
    {
					(yyval.list) = list_make4((yyvsp[(1) - (4)].node), (yyvsp[(2) - (4)].node), (yyvsp[(3) - (4)].node), (yyvsp[(4) - (4)].node));
				}
    break;

  case 1863:
/* Line 1787 of yacc.c  */
#line 12241 "gram.y"
    {
					(yyval.list) = list_make3((yyvsp[(1) - (3)].node), (yyvsp[(2) - (3)].node), (yyvsp[(3) - (3)].node));
				}
    break;

  case 1864:
/* Line 1787 of yacc.c  */
#line 12248 "gram.y"
    { (yyval.node) = (yyvsp[(2) - (2)].node); }
    break;

  case 1865:
/* Line 1787 of yacc.c  */
#line 12254 "gram.y"
    { (yyval.list) = list_make2((yyvsp[(3) - (3)].node), (yyvsp[(1) - (3)].node)); }
    break;

  case 1866:
/* Line 1787 of yacc.c  */
#line 12255 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 1867:
/* Line 1787 of yacc.c  */
#line 12272 "gram.y"
    {
					(yyval.list) = list_make3((yyvsp[(1) - (3)].node), (yyvsp[(2) - (3)].node), (yyvsp[(3) - (3)].node));
				}
    break;

  case 1868:
/* Line 1787 of yacc.c  */
#line 12276 "gram.y"
    {
					/* not legal per SQL99, but might as well allow it */
					(yyval.list) = list_make3((yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yyvsp[(2) - (3)].node));
				}
    break;

  case 1869:
/* Line 1787 of yacc.c  */
#line 12281 "gram.y"
    {
					(yyval.list) = list_make2((yyvsp[(1) - (2)].node), (yyvsp[(2) - (2)].node));
				}
    break;

  case 1870:
/* Line 1787 of yacc.c  */
#line 12285 "gram.y"
    {
					/*
					 * Since there are no cases where this syntax allows
					 * a textual FOR value, we forcibly cast the argument
					 * to int4.  The possible matches in pg_proc are
					 * substring(text,int4) and substring(text,text),
					 * and we don't want the parser to choose the latter,
					 * which it is likely to do if the second argument
					 * is unknown or doesn't have an implicit cast to int4.
					 */
					(yyval.list) = list_make3((yyvsp[(1) - (2)].node), makeIntConst(1, -1),
									makeTypeCast((yyvsp[(2) - (2)].node),
												 SystemTypeName("int4"), -1));
				}
    break;

  case 1871:
/* Line 1787 of yacc.c  */
#line 12300 "gram.y"
    {
					(yyval.list) = (yyvsp[(1) - (1)].list);
				}
    break;

  case 1872:
/* Line 1787 of yacc.c  */
#line 12304 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 1873:
/* Line 1787 of yacc.c  */
#line 12308 "gram.y"
    { (yyval.node) = (yyvsp[(2) - (2)].node); }
    break;

  case 1874:
/* Line 1787 of yacc.c  */
#line 12311 "gram.y"
    { (yyval.node) = (yyvsp[(2) - (2)].node); }
    break;

  case 1875:
/* Line 1787 of yacc.c  */
#line 12314 "gram.y"
    { (yyval.list) = lappend((yyvsp[(3) - (3)].list), (yyvsp[(1) - (3)].node)); }
    break;

  case 1876:
/* Line 1787 of yacc.c  */
#line 12315 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (2)].list); }
    break;

  case 1877:
/* Line 1787 of yacc.c  */
#line 12316 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list); }
    break;

  case 1878:
/* Line 1787 of yacc.c  */
#line 12320 "gram.y"
    {
					SubLink *n = makeNode(SubLink);
					n->subselect = (yyvsp[(1) - (1)].node);
					/* other fields will be filled later */
					(yyval.node) = (Node *)n;
				}
    break;

  case 1879:
/* Line 1787 of yacc.c  */
#line 12326 "gram.y"
    { (yyval.node) = (Node *)(yyvsp[(2) - (3)].list); }
    break;

  case 1880:
/* Line 1787 of yacc.c  */
#line 12337 "gram.y"
    {
					CaseExpr *c = makeNode(CaseExpr);
					c->casetype = InvalidOid; /* not analyzed yet */
					c->arg = (Expr *) (yyvsp[(2) - (5)].node);
					c->args = (yyvsp[(3) - (5)].list);
					c->defresult = (Expr *) (yyvsp[(4) - (5)].node);
					c->location = (yylsp[(1) - (5)]);
					(yyval.node) = (Node *)c;
				}
    break;

  case 1881:
/* Line 1787 of yacc.c  */
#line 12350 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].node)); }
    break;

  case 1882:
/* Line 1787 of yacc.c  */
#line 12351 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].node)); }
    break;

  case 1883:
/* Line 1787 of yacc.c  */
#line 12356 "gram.y"
    {
					CaseWhen *w = makeNode(CaseWhen);
					w->expr = (Expr *) (yyvsp[(2) - (4)].node);
					w->result = (Expr *) (yyvsp[(4) - (4)].node);
					w->location = (yylsp[(1) - (4)]);
					(yyval.node) = (Node *)w;
				}
    break;

  case 1884:
/* Line 1787 of yacc.c  */
#line 12366 "gram.y"
    { (yyval.node) = (yyvsp[(2) - (2)].node); }
    break;

  case 1885:
/* Line 1787 of yacc.c  */
#line 12367 "gram.y"
    { (yyval.node) = NULL; }
    break;

  case 1886:
/* Line 1787 of yacc.c  */
#line 12370 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); }
    break;

  case 1887:
/* Line 1787 of yacc.c  */
#line 12371 "gram.y"
    { (yyval.node) = NULL; }
    break;

  case 1888:
/* Line 1787 of yacc.c  */
#line 12375 "gram.y"
    {
					(yyval.node) = makeColumnRef((yyvsp[(1) - (1)].str), NIL, (yylsp[(1) - (1)]), yyscanner);
				}
    break;

  case 1889:
/* Line 1787 of yacc.c  */
#line 12379 "gram.y"
    {
					(yyval.node) = makeColumnRef((yyvsp[(1) - (2)].str), (yyvsp[(2) - (2)].list), (yylsp[(1) - (2)]), yyscanner);
				}
    break;

  case 1890:
/* Line 1787 of yacc.c  */
#line 12386 "gram.y"
    {
					(yyval.node) = (Node *) makeString((yyvsp[(2) - (2)].str));
				}
    break;

  case 1891:
/* Line 1787 of yacc.c  */
#line 12390 "gram.y"
    {
					(yyval.node) = (Node *) makeNode(A_Star);
				}
    break;

  case 1892:
/* Line 1787 of yacc.c  */
#line 12394 "gram.y"
    {
					A_Indices *ai = makeNode(A_Indices);
					ai->lidx = NULL;
					ai->uidx = (yyvsp[(2) - (3)].node);
					(yyval.node) = (Node *) ai;
				}
    break;

  case 1893:
/* Line 1787 of yacc.c  */
#line 12401 "gram.y"
    {
					A_Indices *ai = makeNode(A_Indices);
					ai->lidx = (yyvsp[(2) - (5)].node);
					ai->uidx = (yyvsp[(4) - (5)].node);
					(yyval.node) = (Node *) ai;
				}
    break;

  case 1894:
/* Line 1787 of yacc.c  */
#line 12410 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].node)); }
    break;

  case 1895:
/* Line 1787 of yacc.c  */
#line 12411 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].node)); }
    break;

  case 1896:
/* Line 1787 of yacc.c  */
#line 12415 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 1897:
/* Line 1787 of yacc.c  */
#line 12416 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].node)); }
    break;

  case 1900:
/* Line 1787 of yacc.c  */
#line 12431 "gram.y"
    { (yyval.node) = (Node *) (yyvsp[(1) - (1)].node); }
    break;

  case 1901:
/* Line 1787 of yacc.c  */
#line 12433 "gram.y"
    {
					SetToDefault *n = makeNode(SetToDefault);
					n->location = (yylsp[(1) - (1)]);
					(yyval.node) = (Node *) n;
				}
    break;

  case 1902:
/* Line 1787 of yacc.c  */
#line 12441 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].node)); }
    break;

  case 1903:
/* Line 1787 of yacc.c  */
#line 12442 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node)); }
    break;

  case 1904:
/* Line 1787 of yacc.c  */
#line 12450 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (3)].list); }
    break;

  case 1905:
/* Line 1787 of yacc.c  */
#line 12460 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list); }
    break;

  case 1906:
/* Line 1787 of yacc.c  */
#line 12461 "gram.y"
    { (yyval.list) = NIL; }
    break;

  case 1907:
/* Line 1787 of yacc.c  */
#line 12465 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].target)); }
    break;

  case 1908:
/* Line 1787 of yacc.c  */
#line 12466 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].target)); }
    break;

  case 1909:
/* Line 1787 of yacc.c  */
#line 12470 "gram.y"
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = (yyvsp[(3) - (3)].str);
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (Node *)(yyvsp[(1) - (3)].node);
					(yyval.target)->location = (yylsp[(1) - (3)]);
				}
    break;

  case 1910:
/* Line 1787 of yacc.c  */
#line 12486 "gram.y"
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = (yyvsp[(2) - (2)].str);
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (Node *)(yyvsp[(1) - (2)].node);
					(yyval.target)->location = (yylsp[(1) - (2)]);
				}
    break;

  case 1911:
/* Line 1787 of yacc.c  */
#line 12494 "gram.y"
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = NULL;
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (Node *)(yyvsp[(1) - (1)].node);
					(yyval.target)->location = (yylsp[(1) - (1)]);
				}
    break;

  case 1912:
/* Line 1787 of yacc.c  */
#line 12502 "gram.y"
    {
					ColumnRef *n = makeNode(ColumnRef);
					n->fields = list_make1(makeNode(A_Star));
					n->location = (yylsp[(1) - (1)]);

					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = NULL;
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (Node *)n;
					(yyval.target)->location = (yylsp[(1) - (1)]);
				}
    break;

  case 1913:
/* Line 1787 of yacc.c  */
#line 12523 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].range)); }
    break;

  case 1914:
/* Line 1787 of yacc.c  */
#line 12524 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].range)); }
    break;

  case 1915:
/* Line 1787 of yacc.c  */
#line 12536 "gram.y"
    {
					(yyval.range) = makeRangeVar(NULL, (yyvsp[(1) - (1)].str), (yylsp[(1) - (1)]));
				}
    break;

  case 1916:
/* Line 1787 of yacc.c  */
#line 12540 "gram.y"
    {
					check_qualified_name((yyvsp[(2) - (2)].list), yyscanner);
					(yyval.range) = makeRangeVar(NULL, NULL, (yylsp[(1) - (2)]));
					switch (list_length((yyvsp[(2) - (2)].list)))
					{
						case 1:
							(yyval.range)->catalogname = NULL;
							(yyval.range)->schemaname = (yyvsp[(1) - (2)].str);
							(yyval.range)->relname = strVal(linitial((yyvsp[(2) - (2)].list)));
							break;
						case 2:
							(yyval.range)->catalogname = (yyvsp[(1) - (2)].str);
							(yyval.range)->schemaname = strVal(linitial((yyvsp[(2) - (2)].list)));
							(yyval.range)->relname = strVal(lsecond((yyvsp[(2) - (2)].list)));
							break;
						default:
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("improper qualified name (too many dotted names): %s",
											NameListToString(lcons(makeString((yyvsp[(1) - (2)].str)), (yyvsp[(2) - (2)].list)))),
									 parser_errposition((yylsp[(1) - (2)]))));
							break;
					}
				}
    break;

  case 1917:
/* Line 1787 of yacc.c  */
#line 12567 "gram.y"
    { (yyval.list) = list_make1(makeString((yyvsp[(1) - (1)].str))); }
    break;

  case 1918:
/* Line 1787 of yacc.c  */
#line 12569 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), makeString((yyvsp[(3) - (3)].str))); }
    break;

  case 1919:
/* Line 1787 of yacc.c  */
#line 12573 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); }
    break;

  case 1920:
/* Line 1787 of yacc.c  */
#line 12576 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); }
    break;

  case 1921:
/* Line 1787 of yacc.c  */
#line 12579 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); }
    break;

  case 1922:
/* Line 1787 of yacc.c  */
#line 12581 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); }
    break;

  case 1923:
/* Line 1787 of yacc.c  */
#line 12583 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); }
    break;

  case 1924:
/* Line 1787 of yacc.c  */
#line 12585 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); }
    break;

  case 1925:
/* Line 1787 of yacc.c  */
#line 12596 "gram.y"
    { (yyval.list) = list_make1(makeString((yyvsp[(1) - (1)].str))); }
    break;

  case 1926:
/* Line 1787 of yacc.c  */
#line 12598 "gram.y"
    {
						(yyval.list) = check_func_name(lcons(makeString((yyvsp[(1) - (2)].str)), (yyvsp[(2) - (2)].list)),
											 yyscanner);
					}
    break;

  case 1927:
/* Line 1787 of yacc.c  */
#line 12609 "gram.y"
    {
					(yyval.node) = makeIntConst((yyvsp[(1) - (1)].ival), (yylsp[(1) - (1)]));
				}
    break;

  case 1928:
/* Line 1787 of yacc.c  */
#line 12613 "gram.y"
    {
					(yyval.node) = makeFloatConst((yyvsp[(1) - (1)].str), (yylsp[(1) - (1)]));
				}
    break;

  case 1929:
/* Line 1787 of yacc.c  */
#line 12617 "gram.y"
    {
					(yyval.node) = makeStringConst((yyvsp[(1) - (1)].str), (yylsp[(1) - (1)]));
				}
    break;

  case 1930:
/* Line 1787 of yacc.c  */
#line 12621 "gram.y"
    {
					(yyval.node) = makeBitStringConst((yyvsp[(1) - (1)].str), (yylsp[(1) - (1)]));
				}
    break;

  case 1931:
/* Line 1787 of yacc.c  */
#line 12625 "gram.y"
    {
					/* This is a bit constant per SQL99:
					 * Without Feature F511, "BIT data type",
					 * a <general literal> shall not be a
					 * <bit string literal> or a <hex string literal>.
					 */
					(yyval.node) = makeBitStringConst((yyvsp[(1) - (1)].str), (yylsp[(1) - (1)]));
				}
    break;

  case 1932:
/* Line 1787 of yacc.c  */
#line 12634 "gram.y"
    {
					/* generic type 'literal' syntax */
					TypeName *t = makeTypeNameFromNameList((yyvsp[(1) - (2)].list));
					t->location = (yylsp[(1) - (2)]);
					(yyval.node) = makeStringConstCast((yyvsp[(2) - (2)].str), (yylsp[(2) - (2)]), t);
				}
    break;

  case 1933:
/* Line 1787 of yacc.c  */
#line 12641 "gram.y"
    {
					/* generic syntax with a type modifier */
					TypeName *t = makeTypeNameFromNameList((yyvsp[(1) - (6)].list));
					ListCell *lc;

					/*
					 * We must use func_arg_list and opt_sort_clause in the
					 * production to avoid reduce/reduce conflicts, but we
					 * don't actually wish to allow NamedArgExpr in this
					 * context, nor ORDER BY.
					 */
					foreach(lc, (yyvsp[(3) - (6)].list))
					{
						NamedArgExpr *arg = (NamedArgExpr *) lfirst(lc);

						if (IsA(arg, NamedArgExpr))
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("type modifier cannot have parameter name"),
									 parser_errposition(arg->location)));
					}
					if ((yyvsp[(4) - (6)].list) != NIL)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("type modifier cannot have ORDER BY"),
									 parser_errposition((yylsp[(4) - (6)]))));

					t->typmods = (yyvsp[(3) - (6)].list);
					t->location = (yylsp[(1) - (6)]);
					(yyval.node) = makeStringConstCast((yyvsp[(6) - (6)].str), (yylsp[(6) - (6)]), t);
				}
    break;

  case 1934:
/* Line 1787 of yacc.c  */
#line 12673 "gram.y"
    {
					(yyval.node) = makeStringConstCast((yyvsp[(2) - (2)].str), (yylsp[(2) - (2)]), (yyvsp[(1) - (2)].typnam));
				}
    break;

  case 1935:
/* Line 1787 of yacc.c  */
#line 12677 "gram.y"
    {
					TypeName *t = (yyvsp[(1) - (3)].typnam);
					t->typmods = (yyvsp[(3) - (3)].list);
					(yyval.node) = makeStringConstCast((yyvsp[(2) - (3)].str), (yylsp[(2) - (3)]), t);
				}
    break;

  case 1936:
/* Line 1787 of yacc.c  */
#line 12683 "gram.y"
    {
					TypeName *t = (yyvsp[(1) - (6)].typnam);
					if ((yyvsp[(6) - (6)].list) != NIL)
					{
						if (list_length((yyvsp[(6) - (6)].list)) != 1)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("interval precision specified twice"),
									 parser_errposition((yylsp[(1) - (6)]))));
						t->typmods = lappend((yyvsp[(6) - (6)].list), makeIntConst((yyvsp[(3) - (6)].ival), (yylsp[(3) - (6)])));
					}
					else
						t->typmods = list_make2(makeIntConst(INTERVAL_FULL_RANGE, -1),
												makeIntConst((yyvsp[(3) - (6)].ival), (yylsp[(3) - (6)])));
					(yyval.node) = makeStringConstCast((yyvsp[(5) - (6)].str), (yylsp[(5) - (6)]), t);
				}
    break;

  case 1937:
/* Line 1787 of yacc.c  */
#line 12700 "gram.y"
    {
					(yyval.node) = makeBoolAConst(TRUE, (yylsp[(1) - (1)]));
				}
    break;

  case 1938:
/* Line 1787 of yacc.c  */
#line 12704 "gram.y"
    {
					(yyval.node) = makeBoolAConst(FALSE, (yylsp[(1) - (1)]));
				}
    break;

  case 1939:
/* Line 1787 of yacc.c  */
#line 12708 "gram.y"
    {
					(yyval.node) = makeNullAConst((yylsp[(1) - (1)]));
				}
    break;

  case 1940:
/* Line 1787 of yacc.c  */
#line 12713 "gram.y"
    { (yyval.ival) = (yyvsp[(1) - (1)].ival); }
    break;

  case 1941:
/* Line 1787 of yacc.c  */
#line 12714 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); }
    break;

  case 1942:
/* Line 1787 of yacc.c  */
#line 12715 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); }
    break;

  case 1943:
/* Line 1787 of yacc.c  */
#line 12718 "gram.y"
    { (yyval.list) = list_make1(makeString((yyvsp[(1) - (1)].str))); }
    break;

  case 1944:
/* Line 1787 of yacc.c  */
#line 12720 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), makeString((yyvsp[(3) - (3)].str))); }
    break;

  case 1945:
/* Line 1787 of yacc.c  */
#line 12723 "gram.y"
    { (yyval.ival) = (yyvsp[(1) - (1)].ival); }
    break;

  case 1946:
/* Line 1787 of yacc.c  */
#line 12724 "gram.y"
    { (yyval.ival) = + (yyvsp[(2) - (2)].ival); }
    break;

  case 1947:
/* Line 1787 of yacc.c  */
#line 12725 "gram.y"
    { (yyval.ival) = - (yyvsp[(2) - (2)].ival); }
    break;

  case 1948:
/* Line 1787 of yacc.c  */
#line 12741 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); }
    break;

  case 1949:
/* Line 1787 of yacc.c  */
#line 12742 "gram.y"
    { (yyval.str) = pstrdup((yyvsp[(1) - (1)].keyword)); }
    break;

  case 1950:
/* Line 1787 of yacc.c  */
#line 12743 "gram.y"
    { (yyval.str) = pstrdup((yyvsp[(1) - (1)].keyword)); }
    break;

  case 1951:
/* Line 1787 of yacc.c  */
#line 12748 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); }
    break;

  case 1952:
/* Line 1787 of yacc.c  */
#line 12749 "gram.y"
    { (yyval.str) = pstrdup((yyvsp[(1) - (1)].keyword)); }
    break;

  case 1953:
/* Line 1787 of yacc.c  */
#line 12750 "gram.y"
    { (yyval.str) = pstrdup((yyvsp[(1) - (1)].keyword)); }
    break;

  case 1954:
/* Line 1787 of yacc.c  */
#line 12755 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); }
    break;

  case 1955:
/* Line 1787 of yacc.c  */
#line 12756 "gram.y"
    { (yyval.str) = pstrdup((yyvsp[(1) - (1)].keyword)); }
    break;

  case 1956:
/* Line 1787 of yacc.c  */
#line 12757 "gram.y"
    { (yyval.str) = pstrdup((yyvsp[(1) - (1)].keyword)); }
    break;

  case 1957:
/* Line 1787 of yacc.c  */
#line 12758 "gram.y"
    { (yyval.str) = pstrdup((yyvsp[(1) - (1)].keyword)); }
    break;

  case 1958:
/* Line 1787 of yacc.c  */
#line 12764 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); }
    break;

  case 1959:
/* Line 1787 of yacc.c  */
#line 12765 "gram.y"
    { (yyval.str) = pstrdup((yyvsp[(1) - (1)].keyword)); }
    break;

  case 1960:
/* Line 1787 of yacc.c  */
#line 12766 "gram.y"
    { (yyval.str) = pstrdup((yyvsp[(1) - (1)].keyword)); }
    break;

  case 1961:
/* Line 1787 of yacc.c  */
#line 12767 "gram.y"
    { (yyval.str) = pstrdup((yyvsp[(1) - (1)].keyword)); }
    break;

  case 1962:
/* Line 1787 of yacc.c  */
#line 12768 "gram.y"
    { (yyval.str) = pstrdup((yyvsp[(1) - (1)].keyword)); }
    break;


/* Line 1787 of yacc.c  */
#line 38422 "gram.c"
      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;
  *++yylsp = yyloc;

  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (&yylloc, yyscanner, YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (&yylloc, yyscanner, yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }

  yyerror_range[1] = yylloc;

  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
	{
	  /* Return failure if at end of input.  */
	  if (yychar == YYEOF)
	    YYABORT;
	}
      else
	{
	  yydestruct ("Error: discarding",
		      yytoken, &yylval, &yylloc, yyscanner);
	  yychar = YYEMPTY;
	}
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  yyerror_range[1] = yylsp[1-yylen];
  /* Do not reclaim the symbols of the rule which action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;

      yyerror_range[1] = *yylsp;
      yydestruct ("Error: popping",
		  yystos[yystate], yyvsp, yylsp, yyscanner);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  yyerror_range[2] = yylloc;
  /* Using YYLLOC is tempting, but would change the location of
     the lookahead.  YYLOC is available though.  */
  YYLLOC_DEFAULT (yyloc, yyerror_range, 2);
  *++yylsp = yyloc;

  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined yyoverflow || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (&yylloc, yyscanner, YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval, &yylloc, yyscanner);
    }
  /* Do not reclaim the symbols of the rule which action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
		  yystos[*yyssp], yyvsp, yylsp, yyscanner);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  /* Make sure YYID is used.  */
  return YYID (yyresult);
}


/* Line 2050 of yacc.c  */
#line 13231 "gram.y"


/*
 * The signature of this function is required by bison.  However, we
 * ignore the passed yylloc and instead use the last token position
 * available from the scanner.
 */
static void
base_yyerror(YYLTYPE *yylloc, core_yyscan_t yyscanner, const char *msg)
{
	parser_yyerror(msg);
}

static Node *
makeColumnRef(char *colname, List *indirection,
			  int location, core_yyscan_t yyscanner)
{
	/*
	 * Generate a ColumnRef node, with an A_Indirection node added if there
	 * is any subscripting in the specified indirection list.  However,
	 * any field selection at the start of the indirection list must be
	 * transposed into the "fields" part of the ColumnRef node.
	 */
	ColumnRef  *c = makeNode(ColumnRef);
	int		nfields = 0;
	ListCell *l;

	c->location = location;
	foreach(l, indirection)
	{
		if (IsA(lfirst(l), A_Indices))
		{
			A_Indirection *i = makeNode(A_Indirection);

			if (nfields == 0)
			{
				/* easy case - all indirection goes to A_Indirection */
				c->fields = list_make1(makeString(colname));
				i->indirection = check_indirection(indirection, yyscanner);
			}
			else
			{
				/* got to split the list in two */
				i->indirection = check_indirection(list_copy_tail(indirection,
																  nfields),
												   yyscanner);
				indirection = list_truncate(indirection, nfields);
				c->fields = lcons(makeString(colname), indirection);
			}
			i->arg = (Node *) c;
			return (Node *) i;
		}
		else if (IsA(lfirst(l), A_Star))
		{
			/* We only allow '*' at the end of a ColumnRef */
			if (lnext(l) != NULL)
				parser_yyerror("improper use of \"*\"");
		}
		nfields++;
	}
	/* No subscripting, so all indirection gets added to field list */
	c->fields = lcons(makeString(colname), indirection);
	return (Node *) c;
}

static Node *
makeTypeCast(Node *arg, TypeName *typename, int location)
{
	TypeCast *n = makeNode(TypeCast);
	n->arg = arg;
	n->typeName = typename;
	n->location = location;
	return (Node *) n;
}

static Node *
makeStringConst(char *str, int location)
{
	A_Const *n = makeNode(A_Const);

	n->val.type = T_String;
	n->val.val.str = str;
	n->location = location;

	return (Node *)n;
}

static Node *
makeStringConstCast(char *str, int location, TypeName *typename)
{
	Node *s = makeStringConst(str, location);

	return makeTypeCast(s, typename, -1);
}

static Node *
makeIntConst(int val, int location)
{
	A_Const *n = makeNode(A_Const);

	n->val.type = T_Integer;
	n->val.val.ival = val;
	n->location = location;

	return (Node *)n;
}

static Node *
makeFloatConst(char *str, int location)
{
	A_Const *n = makeNode(A_Const);

	n->val.type = T_Float;
	n->val.val.str = str;
	n->location = location;

	return (Node *)n;
}

static Node *
makeBitStringConst(char *str, int location)
{
	A_Const *n = makeNode(A_Const);

	n->val.type = T_BitString;
	n->val.val.str = str;
	n->location = location;

	return (Node *)n;
}

static Node *
makeNullAConst(int location)
{
	A_Const *n = makeNode(A_Const);

	n->val.type = T_Null;
	n->location = location;

	return (Node *)n;
}

static Node *
makeAConst(Value *v, int location)
{
	Node *n;

	switch (v->type)
	{
		case T_Float:
			n = makeFloatConst(v->val.str, location);
			break;

		case T_Integer:
			n = makeIntConst(v->val.ival, location);
			break;

		case T_String:
		default:
			n = makeStringConst(v->val.str, location);
			break;
	}

	return n;
}

/* makeBoolAConst()
 * Create an A_Const string node and put it inside a boolean cast.
 */
static Node *
makeBoolAConst(bool state, int location)
{
	A_Const *n = makeNode(A_Const);

	n->val.type = T_String;
	n->val.val.str = (state ? "t" : "f");
	n->location = location;

	return makeTypeCast((Node *)n, SystemTypeName("bool"), -1);
}

/* check_qualified_name --- check the result of qualified_name production
 *
 * It's easiest to let the grammar production for qualified_name allow
 * subscripts and '*', which we then must reject here.
 */
static void
check_qualified_name(List *names, core_yyscan_t yyscanner)
{
	ListCell   *i;

	foreach(i, names)
	{
		if (!IsA(lfirst(i), String))
			parser_yyerror("syntax error");
	}
}

/* check_func_name --- check the result of func_name production
 *
 * It's easiest to let the grammar production for func_name allow subscripts
 * and '*', which we then must reject here.
 */
static List *
check_func_name(List *names, core_yyscan_t yyscanner)
{
	ListCell   *i;

	foreach(i, names)
	{
		if (!IsA(lfirst(i), String))
			parser_yyerror("syntax error");
	}
	return names;
}

/* check_indirection --- check the result of indirection production
 *
 * We only allow '*' at the end of the list, but it's hard to enforce that
 * in the grammar, so do it here.
 */
static List *
check_indirection(List *indirection, core_yyscan_t yyscanner)
{
	ListCell *l;

	foreach(l, indirection)
	{
		if (IsA(lfirst(l), A_Star))
		{
			if (lnext(l) != NULL)
				parser_yyerror("improper use of \"*\"");
		}
	}
	return indirection;
}

/* extractArgTypes()
 * Given a list of FunctionParameter nodes, extract a list of just the
 * argument types (TypeNames) for input parameters only.  This is what
 * is needed to look up an existing function, which is what is wanted by
 * the productions that use this call.
 */
static List *
extractArgTypes(List *parameters)
{
	List	   *result = NIL;
	ListCell   *i;

	foreach(i, parameters)
	{
		FunctionParameter *p = (FunctionParameter *) lfirst(i);

		if (p->mode != FUNC_PARAM_OUT && p->mode != FUNC_PARAM_TABLE)
			result = lappend(result, p->argType);
	}
	return result;
}

/* extractAggrArgTypes()
 * As above, but work from the output of the aggr_args production.
 */
static List *
extractAggrArgTypes(List *aggrargs)
{
	Assert(list_length(aggrargs) == 2);
	return extractArgTypes((List *) linitial(aggrargs));
}

/* makeOrderedSetArgs()
 * Build the result of the aggr_args production (which see the comments for).
 * This handles only the case where both given lists are nonempty, so that
 * we have to deal with multiple VARIADIC arguments.
 */
static List *
makeOrderedSetArgs(List *directargs, List *orderedargs,
				   core_yyscan_t yyscanner)
{
	FunctionParameter *lastd = (FunctionParameter *) llast(directargs);
	int			ndirectargs;

	/* No restriction unless last direct arg is VARIADIC */
	if (lastd->mode == FUNC_PARAM_VARIADIC)
	{
		FunctionParameter *firsto = (FunctionParameter *) linitial(orderedargs);

		/*
		 * We ignore the names, though the aggr_arg production allows them;
		 * it doesn't allow default values, so those need not be checked.
		 */
		if (list_length(orderedargs) != 1 ||
			firsto->mode != FUNC_PARAM_VARIADIC ||
			!equal(lastd->argType, firsto->argType))
			ereport(ERROR,
					(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
					 errmsg("an ordered-set aggregate with a VARIADIC direct argument must have one VARIADIC aggregated argument of the same data type"),
					 parser_errposition(exprLocation((Node *) firsto))));

		/* OK, drop the duplicate VARIADIC argument from the internal form */
		orderedargs = NIL;
	}

	/* don't merge into the next line, as list_concat changes directargs */
	ndirectargs = list_length(directargs);

	return list_make2(list_concat(directargs, orderedargs),
					  makeInteger(ndirectargs));
}

/* insertSelectOptions()
 * Insert ORDER BY, etc into an already-constructed SelectStmt.
 *
 * This routine is just to avoid duplicating code in SelectStmt productions.
 */
static void
insertSelectOptions(SelectStmt *stmt,
					List *sortClause, List *lockingClause,
					Node *limitOffset, Node *limitCount,
					WithClause *withClause,
					core_yyscan_t yyscanner)
{
	Assert(IsA(stmt, SelectStmt));

	/*
	 * Tests here are to reject constructs like
	 *	(SELECT foo ORDER BY bar) ORDER BY baz
	 */
	if (sortClause)
	{
		if (stmt->sortClause)
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("multiple ORDER BY clauses not allowed"),
					 parser_errposition(exprLocation((Node *) sortClause))));
		stmt->sortClause = sortClause;
	}
	/* We can handle multiple locking clauses, though */
	stmt->lockingClause = list_concat(stmt->lockingClause, lockingClause);
	if (limitOffset)
	{
		if (stmt->limitOffset)
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("multiple OFFSET clauses not allowed"),
					 parser_errposition(exprLocation(limitOffset))));
		stmt->limitOffset = limitOffset;
	}
	if (limitCount)
	{
		if (stmt->limitCount)
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("multiple LIMIT clauses not allowed"),
					 parser_errposition(exprLocation(limitCount))));
		stmt->limitCount = limitCount;
	}
	if (withClause)
	{
		if (stmt->withClause)
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("multiple WITH clauses not allowed"),
					 parser_errposition(exprLocation((Node *) withClause))));
		stmt->withClause = withClause;
	}
}

static Node *
makeSetOp(SetOperation op, bool all, Node *larg, Node *rarg)
{
	SelectStmt *n = makeNode(SelectStmt);

	n->op = op;
	n->all = all;
	n->larg = (SelectStmt *) larg;
	n->rarg = (SelectStmt *) rarg;
	return (Node *) n;
}

/* SystemFuncName()
 * Build a properly-qualified reference to a built-in function.
 */
List *
SystemFuncName(char *name)
{
	return list_make2(makeString("pg_catalog"), makeString(name));
}

/* SystemTypeName()
 * Build a properly-qualified reference to a built-in type.
 *
 * typmod is defaulted, but may be changed afterwards by caller.
 * Likewise for the location.
 */
TypeName *
SystemTypeName(char *name)
{
	return makeTypeNameFromNameList(list_make2(makeString("pg_catalog"),
											   makeString(name)));
}

/* doNegate()
 * Handle negation of a numeric constant.
 *
 * Formerly, we did this here because the optimizer couldn't cope with
 * indexquals that looked like "var = -4" --- it wants "var = const"
 * and a unary minus operator applied to a constant didn't qualify.
 * As of Postgres 7.0, that problem doesn't exist anymore because there
 * is a constant-subexpression simplifier in the optimizer.  However,
 * there's still a good reason for doing this here, which is that we can
 * postpone committing to a particular internal representation for simple
 * negative constants.	It's better to leave "-123.456" in string form
 * until we know what the desired type is.
 */
static Node *
doNegate(Node *n, int location)
{
	if (IsA(n, A_Const))
	{
		A_Const *con = (A_Const *)n;

		/* report the constant's location as that of the '-' sign */
		con->location = location;

		if (con->val.type == T_Integer)
		{
			con->val.val.ival = -con->val.val.ival;
			return n;
		}
		if (con->val.type == T_Float)
		{
			doNegateFloat(&con->val);
			return n;
		}
	}

	return (Node *) makeSimpleA_Expr(AEXPR_OP, "-", NULL, n, location);
}

static void
doNegateFloat(Value *v)
{
	char   *oldval = v->val.str;

	Assert(IsA(v, Float));
	if (*oldval == '+')
		oldval++;
	if (*oldval == '-')
		v->val.str = oldval+1;	/* just strip the '-' */
	else
		v->val.str = psprintf("-%s", oldval);
}

static Node *
makeAArrayExpr(List *elements, int location)
{
	A_ArrayExpr *n = makeNode(A_ArrayExpr);

	n->elements = elements;
	n->location = location;
	return (Node *) n;
}

static Node *
makeXmlExpr(XmlExprOp op, char *name, List *named_args, List *args,
			int location)
{
	XmlExpr		*x = makeNode(XmlExpr);

	x->op = op;
	x->name = name;
	/*
	 * named_args is a list of ResTarget; it'll be split apart into separate
	 * expression and name lists in transformXmlExpr().
	 */
	x->named_args = named_args;
	x->arg_names = NIL;
	x->args = args;
	/* xmloption, if relevant, must be filled in by caller */
	/* type and typmod will be filled in during parse analysis */
	x->type = InvalidOid;			/* marks the node as not analyzed */
	x->location = location;
	return (Node *) x;
}

/*
 * Merge the input and output parameters of a table function.
 */
static List *
mergeTableFuncParameters(List *func_args, List *columns)
{
	ListCell   *lc;

	/* Explicit OUT and INOUT parameters shouldn't be used in this syntax */
	foreach(lc, func_args)
	{
		FunctionParameter *p = (FunctionParameter *) lfirst(lc);

		if (p->mode != FUNC_PARAM_IN && p->mode != FUNC_PARAM_VARIADIC)
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("OUT and INOUT arguments aren't allowed in TABLE functions")));
	}

	return list_concat(func_args, columns);
}

/*
 * Determine return type of a TABLE function.  A single result column
 * returns setof that column's type; otherwise return setof record.
 */
static TypeName *
TableFuncTypeName(List *columns)
{
	TypeName *result;

	if (list_length(columns) == 1)
	{
		FunctionParameter *p = (FunctionParameter *) linitial(columns);

		result = (TypeName *) copyObject(p->argType);
	}
	else
		result = SystemTypeName("record");

	result->setof = true;

	return result;
}

/*
 * Convert a list of (dotted) names to a RangeVar (like
 * makeRangeVarFromNameList, but with position support).  The
 * "AnyName" refers to the any_name production in the grammar.
 */
static RangeVar *
makeRangeVarFromAnyName(List *names, int position, core_yyscan_t yyscanner)
{
	RangeVar *r = makeNode(RangeVar);

	switch (list_length(names))
	{
		case 1:
			r->catalogname = NULL;
			r->schemaname = NULL;
			r->relname = strVal(linitial(names));
			break;
		case 2:
			r->catalogname = NULL;
			r->schemaname = strVal(linitial(names));
			r->relname = strVal(lsecond(names));
			break;
		case 3:
			r->catalogname = strVal(linitial(names));
			r->schemaname = strVal(lsecond(names));
			r->relname = strVal(lthird(names));
			break;
		default:
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("improper qualified name (too many dotted names): %s",
							NameListToString(names)),
					 parser_errposition(position)));
			break;
	}

	r->relpersistence = RELPERSISTENCE_PERMANENT;
	r->location = position;

	return r;
}

/* Separate Constraint nodes from COLLATE clauses in a ColQualList */
static void
SplitColQualList(List *qualList,
				 List **constraintList, CollateClause **collClause,
				 core_yyscan_t yyscanner)
{
	ListCell   *cell;
	ListCell   *prev;
	ListCell   *next;

	*collClause = NULL;
	prev = NULL;
	for (cell = list_head(qualList); cell; cell = next)
	{
		Node   *n = (Node *) lfirst(cell);

		next = lnext(cell);
		if (IsA(n, Constraint))
		{
			/* keep it in list */
			prev = cell;
			continue;
		}
		if (IsA(n, CollateClause))
		{
			CollateClause *c = (CollateClause *) n;

			if (*collClause)
				ereport(ERROR,
						(errcode(ERRCODE_SYNTAX_ERROR),
						 errmsg("multiple COLLATE clauses not allowed"),
						 parser_errposition(c->location)));
			*collClause = c;
		}
		else
			elog(ERROR, "unexpected node type %d", (int) n->type);
		/* remove non-Constraint nodes from qualList */
		qualList = list_delete_cell(qualList, cell, prev);
	}
	*constraintList = qualList;
}

/*
 * Process result of ConstraintAttributeSpec, and set appropriate bool flags
 * in the output command node.  Pass NULL for any flags the particular
 * command doesn't support.
 */
static void
processCASbits(int cas_bits, int location, const char *constrType,
			   bool *deferrable, bool *initdeferred, bool *not_valid,
			   bool *no_inherit, core_yyscan_t yyscanner)
{
	/* defaults */
	if (deferrable)
		*deferrable = false;
	if (initdeferred)
		*initdeferred = false;
	if (not_valid)
		*not_valid = false;

	if (cas_bits & (CAS_DEFERRABLE | CAS_INITIALLY_DEFERRED))
	{
		if (deferrable)
			*deferrable = true;
		else
			ereport(ERROR,
					(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
					 /* translator: %s is CHECK, UNIQUE, or similar */
					 errmsg("%s constraints cannot be marked DEFERRABLE",
							constrType),
					 parser_errposition(location)));
	}

	if (cas_bits & CAS_INITIALLY_DEFERRED)
	{
		if (initdeferred)
			*initdeferred = true;
		else
			ereport(ERROR,
					(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
					 /* translator: %s is CHECK, UNIQUE, or similar */
					 errmsg("%s constraints cannot be marked DEFERRABLE",
							constrType),
					 parser_errposition(location)));
	}

	if (cas_bits & CAS_NOT_VALID)
	{
		if (not_valid)
			*not_valid = true;
		else
			ereport(ERROR,
					(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
					 /* translator: %s is CHECK, UNIQUE, or similar */
					 errmsg("%s constraints cannot be marked NOT VALID",
							constrType),
					 parser_errposition(location)));
	}

	if (cas_bits & CAS_NO_INHERIT)
	{
		if (no_inherit)
			*no_inherit = true;
		else
			ereport(ERROR,
					(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
					 /* translator: %s is CHECK, UNIQUE, or similar */
					 errmsg("%s constraints cannot be marked NO INHERIT",
							constrType),
					 parser_errposition(location)));
	}
}

/*----------
 * Recursive view transformation
 *
 * Convert
 *
 *     CREATE RECURSIVE VIEW relname (aliases) AS query
 *
 * to
 *
 *     CREATE VIEW relname (aliases) AS
 *         WITH RECURSIVE relname (aliases) AS (query)
 *         SELECT aliases FROM relname
 *
 * Actually, just the WITH ... part, which is then inserted into the original
 * view definition as the query.
 * ----------
 */
static Node *
makeRecursiveViewSelect(char *relname, List *aliases, Node *query)
{
	SelectStmt *s = makeNode(SelectStmt);
	WithClause *w = makeNode(WithClause);
	CommonTableExpr *cte = makeNode(CommonTableExpr);
	List	   *tl = NIL;
	ListCell   *lc;

	/* create common table expression */
	cte->ctename = relname;
	cte->aliascolnames = aliases;
	cte->ctequery = query;
	cte->location = -1;

	/* create WITH clause and attach CTE */
	w->recursive = true;
	w->ctes = list_make1(cte);
	w->location = -1;

	/* create target list for the new SELECT from the alias list of the
	 * recursive view specification */
	foreach (lc, aliases)
	{
		ResTarget *rt = makeNode(ResTarget);

		rt->name = NULL;
		rt->indirection = NIL;
		rt->val = makeColumnRef(strVal(lfirst(lc)), NIL, -1, 0);
		rt->location = -1;

		tl = lappend(tl, rt);
	}

	/* create new SELECT combining WITH clause, target list, and fake FROM
	 * clause */
	s->withClause = w;
	s->targetList = tl;
	s->fromClause = list_make1(makeRangeVar(NULL, relname, -1));

	return (Node *) s;
}

/* parser_init()
 * Initialize to parse one query string
 */
void
parser_init(base_yy_extra_type *yyext)
{
	yyext->parsetree = NIL;		/* in case grammar forgets to set it */
}
